prompt --application/set_environment
set define off verify off feedback off
whenever sqlerror exit sql.sqlcode rollback
--------------------------------------------------------------------------------
--
-- Oracle APEX export file
--
-- You should run this script using a SQL client connected to the database as
-- the owner (parsing schema) of the application or as a database user with the
-- APEX_ADMINISTRATOR_ROLE role.
--
-- This export file has been automatically generated. Modifying this file is not
-- supported by Oracle and can lead to unexpected application and/or instance
-- behavior now or in the future.
--
-- NOTE: Calls to apex_application_install override the defaults below.
--
--------------------------------------------------------------------------------
begin
wwv_flow_imp.import_begin (
 p_version_yyyy_mm_dd=>'2023.04.28'
,p_release=>'23.1.2'
,p_default_workspace_id=>2970412737642397
,p_default_application_id=>300
,p_default_id_offset=>0
,p_default_owner=>'DEV'
);
end;
/
 
prompt APPLICATION 300 - PLUGINS
--
-- Application Export:
--   Application:     300
--   Name:            PLUGINS
--   Date and Time:   15:46 Saturday January 6, 2024
--   Exported By:     FERNANDO.RICHTER
--   Flashback:       0
--   Export Type:     Component Export
--   Manifest
--     PLUGIN: 739921988389392679
--   Manifest End
--   Version:         23.1.2
--   Instance ID:     300113354816910
--

begin
  -- replace components
  wwv_flow_imp.g_mode := 'REPLACE';
end;
/
prompt --application/shared_components/plugins/dynamic_action/uppy
begin
wwv_flow_imp_shared.create_plugin(
 p_id=>wwv_flow_imp.id(739921988389392679)
,p_plugin_type=>'DYNAMIC ACTION'
,p_name=>'UPPY'
,p_display_name=>'124BITS - Uppy File Uploader'
,p_category=>'INIT'
,p_javascript_file_urls=>wwv_flow_string.join(wwv_flow_t_varchar2(
'#PLUGIN_FILES#dist/uppy.min.js',
'#PLUGIN_FILES#dist/pt_BR.min.js',
'#PLUGIN_FILES#dist/en_US.min.js',
'#PLUGIN_FILES#js/main.min.js',
''))
,p_css_file_urls=>'#PLUGIN_FILES#dist/uppy.min.css'
,p_plsql_code=>wwv_flow_string.join(wwv_flow_t_varchar2(
'-- Plug-in RENDER Function',
'function func_render (',
'  p_dynamic_action in apex_plugin.t_dynamic_action,',
'  p_plugin         in apex_plugin.t_plugin',
') return apex_plugin.t_dynamic_action_render_result ',
'as',
'  l_result 		 apex_plugin.t_dynamic_action_render_result;',
'	l_init_js_fn varchar2(32767) := nvl(apex_plugin_util.replace_substitutions(p_dynamic_action.init_javascript_code), ''undefined'');',
'begin',
'',
'  if apex_application.g_debug then',
'    apex_plugin_util.debug_dynamic_action(',
'       p_plugin         => p_plugin,',
'       p_dynamic_action => p_dynamic_action ',
'    );',
'  end if;',
'',
'	l_result.javascript_function := ''function() { UPPY.plugin.init(this, ''||l_init_js_fn||''); }'';',
'	l_result.ajax_identifier := apex_plugin.get_ajax_identifier;',
'  l_result.attribute_01 := p_dynamic_action.attribute_01; -- Restrictions',
'  l_result.attribute_02 := p_dynamic_action.attribute_02; -- Dashboard Options',
'  -- l_result.attribute_03 := p_dynamic_action.attribute_03; -- EMPTY',
'  l_result.attribute_04 := p_dynamic_action.attribute_04; -- Target Element',
'  l_result.attribute_05 := p_dynamic_action.attribute_05; -- Additional Features',
'  l_result.attribute_06 := p_dynamic_action.attribute_06; -- Presign URL Ajax PL/SQL Function',
'  l_result.attribute_07 := p_dynamic_action.attribute_07; -- Use Presign URL Method',
'  l_result.attribute_08 := p_dynamic_action.attribute_08; -- Theme',
'  l_result.attribute_09 := p_dynamic_action.attribute_09; -- On Complete Callback Function',
'  l_result.attribute_10 := p_dynamic_action.attribute_10; -- Locale Packs',
'  l_result.attribute_11 := p_dynamic_action.attribute_11; -- Destinations',
'  l_result.attribute_12 := p_dynamic_action.attribute_12; -- Uppy Instance ID',
'  l_result.attribute_13 := p_dynamic_action.attribute_13; -- Upload Link Object Key',
'  l_result.attribute_14 := p_dynamic_action.attribute_14; -- On Upload Success',
'  l_result.attribute_15 := p_dynamic_action.attribute_15; -- Compressor Options',
'',
'  return l_result;',
'end func_render;',
'',
'-- Plug-in AJAX Function',
'function func_ajax (',
'  p_dynamic_action in apex_plugin.t_dynamic_action,',
'  p_plugin         in apex_plugin.t_plugin',
') return apex_plugin.t_dynamic_action_ajax_result ',
'as',
'  l_result apex_plugin.t_dynamic_action_ajax_result;',
'  l_plsql_function p_dynamic_action.attribute_06%type := p_dynamic_action.attribute_06;',
'begin',
'',
'  sys.htp.p(',
'    apex_plugin_util.get_plsql_function_result (p_plsql_function => l_plsql_function)',
'  );',
'',
'  return l_result;',
'end func_ajax;'))
,p_default_escape_mode=>'HTML'
,p_api_version=>2
,p_render_function=>'func_render'
,p_ajax_function=>'func_ajax'
,p_standard_attributes=>'INIT_JAVASCRIPT_CODE'
,p_substitute_attributes=>true
,p_subscribe_plugin_settings=>true
,p_help_text=>wwv_flow_string.join(wwv_flow_t_varchar2(
'Uppy Library Docs - https://uppy.io/docs/uppy<br>',
'Uppy Library Version - 3.21.0'))
,p_version_identifier=>'1.0.1'
,p_about_url=>'https://github.com/124bits/oracle-apex-plugin-uppy'
,p_files_version=>933
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(740003822190204280)
,p_plugin_id=>wwv_flow_imp.id(739921988389392679)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>1
,p_display_sequence=>3
,p_prompt=>'Restrictions'
,p_attribute_type=>'TEXTAREA'
,p_is_required=>false
,p_default_value=>wwv_flow_string.join(wwv_flow_t_varchar2(
'{',
'  "maxFileSize": 10240000,',
'  "maxNumberOfFiles": 1,',
'  "allowedFileTypes": ["image/*"]',
'}'))
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'{',
'  "maxFileSize": 10240000,',
'  "maxNumberOfFiles": 1,',
'  "allowedFileTypes": ["image/*"]',
'}',
'</pre>'))
,p_help_text=>'Optionally, provide rules and conditions to limit the type and/or number of files that can be selected (https://uppy.io/docs/uppy/#restrictions).'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(740032408284407356)
,p_plugin_id=>wwv_flow_imp.id(739921988389392679)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>2
,p_display_sequence=>4
,p_prompt=>'Dashboard Options'
,p_attribute_type=>'TEXTAREA'
,p_is_required=>false
,p_default_value=>wwv_flow_string.join(wwv_flow_t_varchar2(
'{',
'  "height": 200,',
'  "autoOpenFileEditor": true',
'}'))
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'{',
'  "height": 200,',
'  "autoOpenFileEditor": true',
'}',
'</pre>'))
,p_help_text=>'The Dashboard can be extensively customized by configuring the options (https://uppy.io/docs/dashboard/#Options).'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(740182005921860715)
,p_plugin_id=>wwv_flow_imp.id(739921988389392679)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>4
,p_display_sequence=>5
,p_prompt=>'Target Element'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_max_length=>50
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'.target',
'#target',
'</pre>'))
,p_help_text=>'Target to render Uppy Plugin (reference to a html element id or class).'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(740205600560061423)
,p_plugin_id=>wwv_flow_imp.id(739921988389392679)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>5
,p_display_sequence=>6
,p_prompt=>'Additional Features'
,p_attribute_type=>'CHECKBOXES'
,p_is_required=>false
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>'Enable Audio, Webcam, Screen Capture sources and more.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(740206277030069467)
,p_plugin_attribute_id=>wwv_flow_imp.id(740205600560061423)
,p_display_sequence=>10
,p_display_value=>'Audio Capture'
,p_return_value=>'AUDIO'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(740206630164070703)
,p_plugin_attribute_id=>wwv_flow_imp.id(740205600560061423)
,p_display_sequence=>20
,p_display_value=>'Screen Capture'
,p_return_value=>'SCREEN_CAPTURE'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(740207118343071977)
,p_plugin_attribute_id=>wwv_flow_imp.id(740205600560061423)
,p_display_sequence=>30
,p_display_value=>'Webcam'
,p_return_value=>'WEBCAM'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(180484683188756039)
,p_plugin_attribute_id=>wwv_flow_imp.id(740205600560061423)
,p_display_sequence=>40
,p_display_value=>'Enable Image Editor'
,p_return_value=>'IMAGE_EDITOR'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(180485011173758325)
,p_plugin_attribute_id=>wwv_flow_imp.id(740205600560061423)
,p_display_sequence=>50
,p_display_value=>'Compress Images'
,p_return_value=>'COMPRESS_IMAGES'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(180736377277325796)
,p_plugin_attribute_id=>wwv_flow_imp.id(740205600560061423)
,p_display_sequence=>60
,p_display_value=>'Include Header "Content-Disposition attachment;" on upload process'
,p_return_value=>'ATTACHMENT'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(181176703316663074)
,p_plugin_attribute_id=>wwv_flow_imp.id(740205600560061423)
,p_display_sequence=>70
,p_display_value=>'Golden Retriever'
,p_return_value=>'GOLDEN_RETRIEVER'
,p_help_text=>'The golden-retriever plugin saves selected files in your browser cache, so that if the browser crashes, or the user accidentally closes the tab, Uppy can restore everything and continue uploading as if nothing happened.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(740220456217269355)
,p_plugin_id=>wwv_flow_imp.id(739921988389392679)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>6
,p_display_sequence=>10
,p_prompt=>'Presigned URL Ajax PL/SQL Function'
,p_attribute_type=>'PLSQL FUNCTION BODY'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(740227476440389003)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'declare',
'  l_filename varchar2(1000)   := apex_application.g_x01;',
'  l_type varchar2(1000)       := apex_application.g_x02;',
'  l_extension varchar2(1000)  := apex_application.g_x03;',
'  l_size varchar2(1000)       := apex_application.g_x04;',
'  l_presignUrl varchar2(1024) := ''{"url":"https://presignedurl.com/example"}'';',
'begin',
'  return l_presignUrl;',
'end;',
'</pre>'))
,p_help_text=>'PL/SQL function that will return the presigned URL object key. It must return a JSON object.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(740227476440389003)
,p_plugin_id=>wwv_flow_imp.id(739921988389392679)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>7
,p_display_sequence=>9
,p_prompt=>'Use Presingned URL Method'
,p_attribute_type=>'CHECKBOX'
,p_is_required=>false
,p_default_value=>'Y'
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(740518476190802262)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'AwsS3'
,p_help_text=>'Enable Uppy to use a presigned generated URL.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(740237454738523664)
,p_plugin_id=>wwv_flow_imp.id(739921988389392679)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>8
,p_display_sequence=>1
,p_prompt=>'Theme'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'auto'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>'Uppy theme (Light, Dark and Auto).'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(740490643047492452)
,p_plugin_attribute_id=>wwv_flow_imp.id(740237454738523664)
,p_display_sequence=>5
,p_display_value=>'Auto'
,p_return_value=>'auto'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(740238122653524887)
,p_plugin_attribute_id=>wwv_flow_imp.id(740237454738523664)
,p_display_sequence=>10
,p_display_value=>'Light'
,p_return_value=>'light'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(740238556713525405)
,p_plugin_attribute_id=>wwv_flow_imp.id(740237454738523664)
,p_display_sequence=>20
,p_display_value=>'Dark'
,p_return_value=>'dark'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(740243866829583774)
,p_plugin_id=>wwv_flow_imp.id(739921988389392679)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>9
,p_display_sequence=>13
,p_prompt=>'On Complete Callback Function'
,p_attribute_type=>'JAVASCRIPT'
,p_is_required=>true
,p_default_value=>wwv_flow_string.join(wwv_flow_t_varchar2(
'(result) => {',
'  console.log(''successful files:'', result.successful)',
'  console.log(''failed files:'', result.failed)',
'}'))
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'(result) => {',
'  console.log(''successful files:'', result.successful)',
'  console.log(''failed files:'', result.failed)',
'}',
'</pre>'))
,p_help_text=>'Allow users to define the callback function fired when all uploads are completed.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(740498611560658504)
,p_plugin_id=>wwv_flow_imp.id(739921988389392679)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>10
,p_display_sequence=>2
,p_prompt=>'Locale Pack'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'en_US'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>'You can use a locale pack to translate Uppy into your language of choice (default English).'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(740499263532662787)
,p_plugin_attribute_id=>wwv_flow_imp.id(740498611560658504)
,p_display_sequence=>10
,p_display_value=>'English United States'
,p_return_value=>'en_US'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(740499712810664497)
,p_plugin_attribute_id=>wwv_flow_imp.id(740498611560658504)
,p_display_sequence=>20
,p_display_value=>'Portuguese Brazil'
,p_return_value=>'pt_BR'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(740518476190802262)
,p_plugin_id=>wwv_flow_imp.id(739921988389392679)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>11
,p_display_sequence=>8
,p_prompt=>'Destinations'
,p_attribute_type=>'SELECT LIST'
,p_is_required=>true
,p_default_value=>'AwsS3'
,p_is_translatable=>false
,p_lov_type=>'STATIC'
,p_help_text=>'You can choose different upload destinations. For now, only avaliable <strong>AWS S3 / Cloudflare R2</strong>.'
);
wwv_flow_imp_shared.create_plugin_attr_value(
 p_id=>wwv_flow_imp.id(740519129765805313)
,p_plugin_attribute_id=>wwv_flow_imp.id(740518476190802262)
,p_display_sequence=>10
,p_display_value=>'AWS S3 / Cloudflare R2'
,p_return_value=>'AwsS3'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(740549071917413487)
,p_plugin_id=>wwv_flow_imp.id(739921988389392679)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>12
,p_display_sequence=>14
,p_prompt=>'Uppy Instance ID'
,p_attribute_type=>'TEXT'
,p_is_required=>false
,p_max_length=>80
,p_is_translatable=>false
,p_help_text=>'Define a site-wide unique ID for the Uppy instance. If several Uppy instances are being used, for instance, on two different pages, an id should be specified. This allows Uppy to store information in localStorage without colliding with other Uppy ins'
||'tances.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(740638670311743368)
,p_plugin_id=>wwv_flow_imp.id(739921988389392679)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>13
,p_display_sequence=>11
,p_prompt=>'Upload Link Object Key'
,p_attribute_type=>'TEXT'
,p_is_required=>true
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(740227476440389003)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'EQUALS'
,p_depending_on_expression=>'Y'
,p_help_text=>'Define the upload object key returned from Presigned URL Ajax PL/SQL Function.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(180491156229964671)
,p_plugin_id=>wwv_flow_imp.id(739921988389392679)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>14
,p_display_sequence=>12
,p_prompt=>'On Upload Success'
,p_attribute_type=>'JAVASCRIPT'
,p_is_required=>false
,p_default_value=>wwv_flow_string.join(wwv_flow_t_varchar2(
'(file, response) => {',
'  console.log(file, response);',
'}'))
,p_is_translatable=>false
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'(file, response) => {',
'	console.log(file.name, response.uploadURL);',
'	const img = new Image();',
'	img.width = 300;',
'	img.alt = file.id;',
'	img.src = response.uploadURL;',
'	document.body.appendChild(img);',
'}',
'</pre>'))
,p_help_text=>'Fired each time a single upload is completed.'
);
wwv_flow_imp_shared.create_plugin_attribute(
 p_id=>wwv_flow_imp.id(740783898951652148)
,p_plugin_id=>wwv_flow_imp.id(739921988389392679)
,p_attribute_scope=>'COMPONENT'
,p_attribute_sequence=>15
,p_display_sequence=>7
,p_prompt=>'Compressor Options'
,p_attribute_type=>'TEXTAREA'
,p_is_required=>true
,p_default_value=>wwv_flow_string.join(wwv_flow_t_varchar2(
'{',
'  "quality": 0.6,',
'  "limit": 10,',
'  "convertTypes": ["image/png", "image/webp", "image/jpeg"],',
'  "convertSize": 10000',
'}'))
,p_is_translatable=>false
,p_depending_on_attribute_id=>wwv_flow_imp.id(740205600560061423)
,p_depending_on_has_to_exist=>true
,p_depending_on_condition_type=>'IN_LIST'
,p_depending_on_expression=>'COMPRESS_IMAGES'
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'{',
'  "quality": 0.6,',
'  "limit": 10,',
'  "convertTypes": ["image/png", "image/webp", "image/jpeg"],',
'  "convertSize": 10000',
'}',
'</pre>'))
,p_help_text=>'Check for Compressor options - https://github.com/fengyuanchen/compressorjs#options'
);
wwv_flow_imp_shared.create_plugin_std_attribute(
 p_id=>wwv_flow_imp.id(179591814840501151)
,p_plugin_id=>wwv_flow_imp.id(739921988389392679)
,p_name=>'INIT_JAVASCRIPT_CODE'
,p_is_required=>false
,p_default_value=>wwv_flow_string.join(wwv_flow_t_varchar2(
'( uppy ) => {',
'  // uppy.on(''progress'', (progress) => {',
'  // console.log(progress);',
'  // });',
'}'))
,p_depending_on_has_to_exist=>true
,p_examples=>wwv_flow_string.join(wwv_flow_t_varchar2(
'<pre>',
'( uppy ) => {',
'  uppy.on(''progress'', (progress) => {',
'    // progress: integer (total progress percentage)',
'    console.log(progress);',
'  });',
'}',
'</pre>',
'<p>Example service worker register with Golden Retriever enabled:</p>',
'<pre>',
'if (''serviceWorker'' in navigator) {',
'  navigator.serviceWorker',
'    .register(''#WORKSPACE_FILES#sw/golden-retriever-sw#MIN#.js'')',
'    .then((registration) => {',
'      console.log(',
'        ''ServiceWorker registration successful with scope: '',',
'        registration.scope,',
'      );',
'    })',
'    .catch((error) => {',
'      console.log(`Registration failed with ${error}`);',
'    });',
'}',
'</pre>'))
,p_help_text=>'Complete the component with additional code options.'
);
end;
/
begin
wwv_flow_imp.g_varchar2_table := wwv_flow_imp.empty_varchar2_table;
wwv_flow_imp.g_varchar2_table(1) := '636F6E737420555050593D77696E646F772E555050597C7C7B7D3B555050592E706C7567696E3D555050592E706C7567696E7C7C7B7D2C555050592E706C7567696E2E696E69743D28636F6E746578742C696E6974466E293D3E7B636F6E73747B616374';
wwv_flow_imp.g_varchar2_table(2) := '696F6E3A616374696F6E7D3D636F6E746578742C706C7567696E3D7B616A61784964656E7469666965723A616374696F6E2E616A61784964656E7469666965722C7265737472696374696F6E733A4A534F4E2E706172736528616374696F6E2E61747472';
wwv_flow_imp.g_varchar2_table(3) := '69627574653031292C64617368626F6172644F7074696F6E733A4A534F4E2E706172736528616374696F6E2E6174747269627574653032292C746172676574456C656D656E743A616374696F6E2E61747472696275746530342C6164646974696F6E616C';
wwv_flow_imp.g_varchar2_table(4) := '46656174757265733A616374696F6E2E61747472696275746530357C7C22656D707479222C7573655072657369676E55726C3A2259223D3D3D616374696F6E2E61747472696275746530372C7468656D653A616374696F6E2E6174747269627574653038';
wwv_flow_imp.g_varchar2_table(5) := '2C6F6E436F6D706C65746543616C6C6261636B3A616374696F6E2E61747472696275746530392C6C6F63616C655061636B3A616374696F6E2E61747472696275746531302C64657374696E6174696F6E3A616374696F6E2E61747472696275746531312C';
wwv_flow_imp.g_varchar2_table(6) := '7570707949643A616374696F6E2E61747472696275746531327C7C446174652E6E6F7728292C75706C6F61644C696E6B4F626A6563744B65793A616374696F6E2E61747472696275746531332C6F6E55706C6F6164537563636573733A616374696F6E2E';
wwv_flow_imp.g_varchar2_table(7) := '61747472696275746531342C636F6D70726573734F7074696F6E733A4A534F4E2E706172736528616374696F6E2E6174747269627574653135297D2C757070793D6E657720557070792E55707079287B6C6F63616C653A557070792E6C6F63616C65735B';
wwv_flow_imp.g_varchar2_table(8) := '706C7567696E2E6C6F63616C655061636B5D2C69643A706C7567696E2E7570707949642C7265737472696374696F6E733A706C7567696E2E7265737472696374696F6E737D293B757070792E75736528557070792E44617368626F6172642C7B70726F75';
wwv_flow_imp.g_varchar2_table(9) := '646C79446973706C6179506F77657265644279557070793A21312C7461726765743A706C7567696E2E746172676574456C656D656E742C696E6C696E653A21302C73686F7750726F677265737344657461696C733A21302C7468656D653A706C7567696E';
wwv_flow_imp.g_varchar2_table(10) := '2E7468656D652C6869646550726F6772657373416674657246696E6973683A21302C2E2E2E706C7567696E2E64617368626F6172644F7074696F6E737D293B636F6E737420616464466561747572653D28742C652C613D7B7D293D3E7B706C7567696E2E';
wwv_flow_imp.g_varchar2_table(11) := '6164646974696F6E616C46656174757265732E696E636C756465732874292626757070792E75736528652C61297D3B72657475726E20616464466561747572652822434F4D50524553535F494D41474553222C557070792E436F6D70726573736F722C7B';
wwv_flow_imp.g_varchar2_table(12) := '2E2E2E706C7567696E2E636F6D70726573734F7074696F6E737D292C616464466561747572652822494D4147455F454449544F52222C557070792E496D616765456469746F722C7B7461726765743A557070792E44617368626F6172647D292C61646446';
wwv_flow_imp.g_varchar2_table(13) := '6561747572652822415544494F222C557070792E417564696F2C7B7461726765743A557070792E44617368626F6172642C73686F77417564696F536F7572636544726F70646F776E3A21307D292C61646446656174757265282257454243414D222C5570';
wwv_flow_imp.g_varchar2_table(14) := '70792E57656263616D2C7B7461726765743A557070792E44617368626F6172642C73686F77566964656F536F7572636544726F70646F776E3A21307D292C61646446656174757265282253435245454E5F43415054555245222C557070792E5363726565';
wwv_flow_imp.g_varchar2_table(15) := '6E436170747572652C7B7461726765743A557070792E44617368626F6172647D292C616464466561747572652822474F4C44454E5F524554524945564552222C557070792E476F6C64656E5265747269657665722C7B73657276696365576F726B65723A';
wwv_flow_imp.g_varchar2_table(16) := '21307D292C224177735333223D3D3D706C7567696E2E64657374696E6174696F6E2626757070792E75736528557070795B706C7567696E2E64657374696E6174696F6E5D2C7B6173796E632067657455706C6F6164506172616D65746572732874297B6C';
wwv_flow_imp.g_varchar2_table(17) := '657420653B706C7567696E2E7573655072657369676E55726C2626617761697420617065782E7365727665722E706C7567696E28706C7567696E2E616A61784964656E7469666965722C7B7830313A742E6E616D652C7830323A742E747970652C783033';
wwv_flow_imp.g_varchar2_table(18) := '3A742E657874656E73696F6E2C7830343A742E73697A657D2C7B737563636573733A743D3E653D747D293B636F6E737420613D7B22436F6E74656E742D54797065223A60247B742E747970657D3B20636861727365743D7574662D38602C2E2E2E706C75';
wwv_flow_imp.g_varchar2_table(19) := '67696E2E6164646974696F6E616C46656174757265732E696E636C7564657328224154544143484D454E54222926267B22436F6E74656E742D446973706F736974696F6E223A606174746163686D656E743B2066696C656E616D653D22247B742E6E616D';
wwv_flow_imp.g_varchar2_table(20) := '657D22607D7D3B72657475726E7B6D6574686F643A22707574222C75726C3A655B706C7567696E2E75706C6F61644C696E6B4F626A6563744B65795D2C6669656C64733A652C686561646572733A617D7D7D292C757070792E6F6E282275706C6F61642D';
wwv_flow_imp.g_varchar2_table(21) := '73756363657373222C6576616C28706C7567696E2E6F6E55706C6F61645375636365737329292C757070792E6F6E2822636F6D706C657465222C6576616C28706C7567696E2E6F6E436F6D706C65746543616C6C6261636B29292C2266756E6374696F6E';
wwv_flow_imp.g_varchar2_table(22) := '223D3D747970656F6620696E6974466E2626696E6974466E2E63616C6C28636F6E746578742C75707079292C757070797D3B';
null;
end;
/
begin
wwv_flow_imp_shared.create_plugin_file(
 p_id=>wwv_flow_imp.id(181770138246230832)
,p_plugin_id=>wwv_flow_imp.id(739921988389392679)
,p_file_name=>'js/main.min.js'
,p_mime_type=>'text/javascript'
,p_file_charset=>'utf-8'
,p_file_content=>wwv_flow_imp.varchar2_to_blob(wwv_flow_imp.g_varchar2_table)
);
end;
/
begin
wwv_flow_imp.g_varchar2_table := wwv_flow_imp.empty_varchar2_table;
wwv_flow_imp.g_varchar2_table(1) := '2F2A0A202A204F7261636C65204150455820506C7567696E0A202A20617574686F723A204665726E616E646F20442E20526963687465720A202A2076657273696F6E3A2076312E302E310A202A20757070792076657273696F6E3A2076332E32312E300A';
wwv_flow_imp.g_varchar2_table(2) := '202A206C6963656E73653A204D49540A202A2F0A0A636F6E73742055505059203D2077696E646F772E55505059207C7C207B7D3B0A555050592E706C7567696E203D20555050592E706C7567696E207C7C207B7D3B0A0A555050592E706C7567696E2E69';
wwv_flow_imp.g_varchar2_table(3) := '6E6974203D2028636F6E746578742C20696E6974466E29203D3E207B0A2020636F6E7374207B20616374696F6E207D203D20636F6E746578743B0A2020636F6E737420706C7567696E203D207B0A20202020616A61784964656E7469666965723A206163';
wwv_flow_imp.g_varchar2_table(4) := '74696F6E2E616A61784964656E7469666965722C0A202020207265737472696374696F6E733A204A534F4E2E706172736528616374696F6E2E6174747269627574653031292C0A2020202064617368626F6172644F7074696F6E733A204A534F4E2E7061';
wwv_flow_imp.g_varchar2_table(5) := '72736528616374696F6E2E6174747269627574653032292C0A20202020746172676574456C656D656E743A20616374696F6E2E61747472696275746530342C0A202020206164646974696F6E616C46656174757265733A20616374696F6E2E6174747269';
wwv_flow_imp.g_varchar2_table(6) := '627574653035207C7C2027656D707479272C0A202020207573655072657369676E55726C3A2028616374696F6E2E6174747269627574653037203D3D3D20275927292C0A202020207468656D653A20616374696F6E2E61747472696275746530382C0A20';
wwv_flow_imp.g_varchar2_table(7) := '2020206F6E436F6D706C65746543616C6C6261636B3A20616374696F6E2E61747472696275746530392C0A202020206C6F63616C655061636B3A20616374696F6E2E61747472696275746531302C0A2020202064657374696E6174696F6E3A2061637469';
wwv_flow_imp.g_varchar2_table(8) := '6F6E2E61747472696275746531312C0A202020207570707949643A20616374696F6E2E6174747269627574653132207C7C20446174652E6E6F7728292C0A2020202075706C6F61644C696E6B4F626A6563744B65793A20616374696F6E2E617474726962';
wwv_flow_imp.g_varchar2_table(9) := '75746531332C0A202020206F6E55706C6F6164537563636573733A20616374696F6E2E61747472696275746531342C0A20202020636F6D70726573734F7074696F6E733A204A534F4E2E706172736528616374696F6E2E6174747269627574653135292C';
wwv_flow_imp.g_varchar2_table(10) := '0A20207D3B0A0A2020636F6E73742075707079203D206E657720557070792E55707079287B0A202020206C6F63616C653A20557070792E6C6F63616C65735B706C7567696E2E6C6F63616C655061636B5D2C0A2020202069643A20706C7567696E2E7570';
wwv_flow_imp.g_varchar2_table(11) := '707949642C0A202020207265737472696374696F6E733A20706C7567696E2E7265737472696374696F6E732C0A20207D293B0A0A2020757070792E75736528557070792E44617368626F6172642C207B0A2020202070726F75646C79446973706C617950';
wwv_flow_imp.g_varchar2_table(12) := '6F77657265644279557070793A2066616C73652C0A202020207461726765743A20706C7567696E2E746172676574456C656D656E742C0A20202020696E6C696E653A20747275652C0A2020202073686F7750726F677265737344657461696C733A207472';
wwv_flow_imp.g_varchar2_table(13) := '75652C0A202020207468656D653A20706C7567696E2E7468656D652C0A202020206869646550726F6772657373416674657246696E6973683A20747275652C0A202020202E2E2E706C7567696E2E64617368626F6172644F7074696F6E732C0A20207D29';
wwv_flow_imp.g_varchar2_table(14) := '3B0A0A2020636F6E73742061646446656174757265203D2028666561747572652C2055707079436F6D706F6E656E742C206F7074696F6E73203D207B7D29203D3E207B0A2020202069662028706C7567696E2E6164646974696F6E616C46656174757265';
wwv_flow_imp.g_varchar2_table(15) := '732E696E636C7564657328666561747572652929207B0A202020202020757070792E7573652855707079436F6D706F6E656E742C206F7074696F6E73293B0A202020207D0A20207D3B0A0A2020616464466561747572652827434F4D50524553535F494D';
wwv_flow_imp.g_varchar2_table(16) := '41474553272C20557070792E436F6D70726573736F722C207B202E2E2E706C7567696E2E636F6D70726573734F7074696F6E73207D293B0A2020616464466561747572652827494D4147455F454449544F52272C20557070792E496D616765456469746F';
wwv_flow_imp.g_varchar2_table(17) := '722C207B207461726765743A20557070792E44617368626F617264207D293B0A2020616464466561747572652827415544494F272C20557070792E417564696F2C207B207461726765743A20557070792E44617368626F6172642C2073686F7741756469';
wwv_flow_imp.g_varchar2_table(18) := '6F536F7572636544726F70646F776E3A2074727565207D293B0A202061646446656174757265282757454243414D272C20557070792E57656263616D2C207B207461726765743A20557070792E44617368626F6172642C2073686F77566964656F536F75';
wwv_flow_imp.g_varchar2_table(19) := '72636544726F70646F776E3A2074727565207D293B0A202061646446656174757265282753435245454E5F43415054555245272C20557070792E53637265656E436170747572652C207B207461726765743A20557070792E44617368626F617264207D29';
wwv_flow_imp.g_varchar2_table(20) := '3B0A2020616464466561747572652827474F4C44454E5F524554524945564552272C20557070792E476F6C64656E5265747269657665722C207B2073657276696365576F726B65723A2074727565207D293B0A0A202069662028706C7567696E2E646573';
wwv_flow_imp.g_varchar2_table(21) := '74696E6174696F6E203D3D3D202741777353332729207B0A20202020757070792E75736528557070795B706C7567696E2E64657374696E6174696F6E5D2C207B0A2020202020206173796E632067657455706C6F6164506172616D65746572732866696C';
wwv_flow_imp.g_varchar2_table(22) := '6529207B0A20202020202020206C65742075706C6F6164506172616D65746572733B0A202020202020202069662028706C7567696E2E7573655072657369676E55726C29207B0A20202020202020202020617761697420617065782E7365727665722E70';
wwv_flow_imp.g_varchar2_table(23) := '6C7567696E28706C7567696E2E616A61784964656E7469666965722C207B0A2020202020202020202020207830313A2066696C652E6E616D652C0A2020202020202020202020207830323A2066696C652E747970652C0A20202020202020202020202078';
wwv_flow_imp.g_varchar2_table(24) := '30333A2066696C652E657874656E73696F6E2C0A2020202020202020202020207830343A2066696C652E73697A652C0A202020202020202020207D2C207B20737563636573733A20286461746129203D3E2075706C6F6164506172616D6574657273203D';
wwv_flow_imp.g_varchar2_table(25) := '2064617461207D293B0A20202020202020207D0A0A2020202020202020636F6E73742068656164657273203D207B0A2020202020202020202022436F6E74656E742D54797065223A2060247B66696C652E747970657D3B20636861727365743D7574662D';
wwv_flow_imp.g_varchar2_table(26) := '38602C0A202020202020202020202E2E2E28706C7567696E2E6164646974696F6E616C46656174757265732E696E636C7564657328274154544143484D454E542729202626207B2022436F6E74656E742D446973706F736974696F6E223A206061747461';
wwv_flow_imp.g_varchar2_table(27) := '63686D656E743B2066696C656E616D653D22247B66696C652E6E616D657D2260207D292C0A20202020202020207D3B0A0A202020202020202072657475726E207B0A202020202020202020206D6574686F643A2027707574272C0A202020202020202020';
wwv_flow_imp.g_varchar2_table(28) := '2075726C3A2075706C6F6164506172616D65746572735B706C7567696E2E75706C6F61644C696E6B4F626A6563744B65795D2C0A202020202020202020206669656C64733A2075706C6F6164506172616D65746572732C0A202020202020202020206865';
wwv_flow_imp.g_varchar2_table(29) := '61646572732C0A20202020202020207D3B0A2020202020207D0A202020207D293B0A20207D0A0A2020757070792E6F6E282775706C6F61642D73756363657373272C206576616C28706C7567696E2E6F6E55706C6F61645375636365737329293B0A2020';
wwv_flow_imp.g_varchar2_table(30) := '757070792E6F6E2827636F6D706C657465272C206576616C28706C7567696E2E6F6E436F6D706C65746543616C6C6261636B29293B0A0A202069662028747970656F6620696E6974466E203D3D3D202766756E6374696F6E2729207B0A20202020696E69';
wwv_flow_imp.g_varchar2_table(31) := '74466E2E63616C6C28636F6E746578742C2075707079293B0A20207D0A0A202072657475726E20757070793B0A7D3B0A';
null;
end;
/
begin
wwv_flow_imp_shared.create_plugin_file(
 p_id=>wwv_flow_imp.id(740457284597130531)
,p_plugin_id=>wwv_flow_imp.id(739921988389392679)
,p_file_name=>'js/main.js'
,p_mime_type=>'text/javascript'
,p_file_charset=>'utf-8'
,p_file_content=>wwv_flow_imp.varchar2_to_blob(wwv_flow_imp.g_varchar2_table)
);
end;
/
begin
wwv_flow_imp.g_varchar2_table := wwv_flow_imp.empty_varchar2_table;
wwv_flow_imp.g_varchar2_table(1) := '2828293D3E7B766172206F3D7B706C7572616C697A652865297B72657475726E20653D3D3D313F303A317D7D3B6F2E737472696E67733D7B636F6D7072657373696E67496D616765733A27436F6D7072696D696E646F20696D6167656E732E2E2E272C63';
wwv_flow_imp.g_varchar2_table(2) := '6F6D70726573736564583A2753616C766F20257B73697A657D20616F20636F6D7072696D697220617320696D6167656E73272C6164644D6F72653A2241646963696F6E65206D616973222C6164644D6F726546696C65733A2241646963696F6E6172206D';
wwv_flow_imp.g_varchar2_table(3) := '616973206172717569766F73222C616464696E674D6F726546696C65733A2241646963696F6E616E646F206D616973206172717569766F73222C616C6C6F774163636573734465736372697074696F6E3A225061726120706F6465722074697261722066';
wwv_flow_imp.g_varchar2_table(4) := '6F746F7320652067726176617220765C78454464656F7320636F6D2073756120635C7845326D6572612C20706F72206661766F72207065726D697461206F2061636573736F206120635C7845326D6572612070617261206573736520736974652E222C61';
wwv_flow_imp.g_varchar2_table(5) := '6C6C6F774163636573735469746C653A22506F72206661766F72207065726D697461206F2061636573736F20612073756120635C7845326D657261222C61757468656E746963617465576974683A22436F6E656374617220636F6D20257B706C7567696E';
wwv_flow_imp.g_varchar2_table(6) := '4E616D657D222C61757468656E746963617465576974685469746C653A22506F72206661766F7220636F6E6563746520636F6D20257B706C7567696E4E616D657D20706172612073656C6563696F6E6172206172717569766F73222C6261636B3A22566F';
wwv_flow_imp.g_varchar2_table(7) := '6C746172222C62726F7773653A226E617665677565222C62726F77736546696C65733A226E617665677565222C63616E63656C3A2243616E63656C6172222C63616E63656C55706C6F61643A2243616E63656C617220656E76696F206465206172717569';
wwv_flow_imp.g_varchar2_table(8) := '766F73222C63686F6F736546696C65733A2253656C6563696F6E6172206172717569766F73222C636C6F73654D6F64616C3A22466563686172204D6F64616C222C636F6D70616E696F6E4572726F723A22436F6E65785C7845336F20636F6D2073657276';
wwv_flow_imp.g_varchar2_table(9) := '695C7845376F2066616C686F75222C636F6D706C6574653A22436F6E636C755C784544646F222C636F6E6E6563746564546F496E7465726E65743A22436F6E65637461646F205C78453120696E7465726E6574222C636F70794C696E6B3A22436F706961';
wwv_flow_imp.g_varchar2_table(10) := '72206C696E6B222C636F70794C696E6B546F436C6970626F61726446616C6C6261636B3A22436F706961722055524C2061626169786F222C636F70794C696E6B546F436C6970626F617264537563636573733A224C696E6B20636F706961646F20706172';
wwv_flow_imp.g_varchar2_table(11) := '612061205C784531726561206465207472616E736665725C7845416E636961222C6372656174696E67417373656D626C793A22507265706172616E646F20656E76696F206465206172717569766F732E2E2E222C6372656174696E67417373656D626C79';
wwv_flow_imp.g_varchar2_table(12) := '4661696C65643A225472616E736C6F616469743A204E5C7845336F20666F6920706F73735C78454476656C206372696172206F20417373656D626C79222C64617368626F6172645469746C653A22456E76696F206465206172717569766F73222C646173';
wwv_flow_imp.g_varchar2_table(13) := '68626F61726457696E646F775469746C653A224A616E656C61207061726120656E76696F206465206172717569766F7320285072657373696F6E652065736320706172612066656368617229222C6461746155706C6F616465644F66546F74616C3A2225';
wwv_flow_imp.g_varchar2_table(14) := '7B636F6D706C6574657D20646520257B746F74616C7D222C646F6E653A22436F6E636C756972222C64726F70486572654F723A2241727261737465206172717569766F732061717569206F7520257B62726F7773657D222C64726F7048696E743A22536F';
wwv_flow_imp.g_varchar2_table(15) := '6C74652073657573206172717569766F732061717569222C64726F705061737465426F74683A22536F6C7465206172717569766F7320617175692C20636F6C65206F7520257B62726F7773657D222C64726F70506173746546696C65733A22536F6C7465';
wwv_flow_imp.g_varchar2_table(16) := '206172717569766F7320617175692C20636F6C65206F7520257B62726F7773657D222C64726F705061737465466F6C646572733A22536F6C7465206172717569766F7320617175692C20636F6C65206F7520257B62726F7773657D222C64726F70506173';
wwv_flow_imp.g_varchar2_table(17) := '7465496D706F7274426F74683A22536F6C7465206172717569766F7320617175692C20636F6C652C20257B62726F7773657D206F7520696D706F727465206465222C64726F705061737465496D706F727446696C65733A22536F6C746520617271756976';
wwv_flow_imp.g_varchar2_table(18) := '6F7320617175692C20636F6C652C20257B62726F7773657D206F7520696D706F727465206465222C64726F705061737465496D706F7274466F6C646572733A22536F6C7465206172717569766F7320617175692C20636F6C652C20257B62726F7773657D';
wwv_flow_imp.g_varchar2_table(19) := '206F7520696D706F727465206465222C6564697446696C653A22456469746172206172717569766F222C65646974696E673A2245646974616E646F20257B66696C657D222C656D707479466F6C64657241646465643A224E656E68756D20617271756976';
wwv_flow_imp.g_varchar2_table(20) := '6F20666F692061646963696F6E61646F2064612070617374612076617A6961222C656E636F64696E673A22436F6469666963616E646F2E2E2E222C656E746572436F727265637455726C3A2255524C20696E636F72726574613A20506F72206661766F72';
wwv_flow_imp.g_varchar2_table(21) := '2074656E68612063657274657A612071756520696E736572697520756D206C696E6B2064697265746F207061726120756D206172717569766F222C656E74657255726C546F496D706F72743A22436F6C6F71756520612055524C207061726120696D706F';
wwv_flow_imp.g_varchar2_table(22) := '7274617220756D206172717569766F222C6578636565647353697A653A2245737365206172717569766F2065786365646575206F2074616D616E686F206D5C78453178696D6F207065726D697469646F20257B73697A657D222C6661696C6564546F4665';
wwv_flow_imp.g_varchar2_table(23) := '7463683A2253657276695C7845376F2066616C686F7520706172612062757363617220657373612055524C2C20706F72206661766F722074656E68612063657274657A612071756520612055524C206573745C78453120636F7272657461222C6661696C';
wwv_flow_imp.g_varchar2_table(24) := '6564546F55706C6F61643A2246616C6861207061726120656E7669617220257B66696C657D222C66696C65536F757263653A224F726967656D20646F206172717569766F3A20257B6E616D657D222C66696C657355706C6F616465644F66546F74616C3A';
wwv_flow_imp.g_varchar2_table(25) := '7B303A22257B636F6D706C6574657D20646520257B736D6172745F636F756E747D206172717569766F20656E766961646F222C313A22257B636F6D706C6574657D20646520257B736D6172745F636F756E747D206172717569766F7320656E766961646F';
wwv_flow_imp.g_varchar2_table(26) := '73227D2C66696C7465723A2246696C74726172222C66696E69736845646974696E6746696C653A2246696E616C697A6172206564695C7845375C7845336F206465206172717569766F222C666F6C64657241646465643A7B303A2241646963696F6E6164';
wwv_flow_imp.g_varchar2_table(27) := '6F20257B736D6172745F636F756E747D206172717569766F20646520257B666F6C6465727D222C313A2241646963696F6E61646F20257B736D6172745F636F756E747D206172717569766F7320646520257B666F6C6465727D227D2C696D706F72743A22';
wwv_flow_imp.g_varchar2_table(28) := '496D706F72746172222C696D706F727446726F6D3A22496D706F7274617220646520257B6E616D657D222C6C6F6164696E673A22436172726567616E646F2E2E2E222C6C6F674F75743A224465736C6F676172222C6D794465766963653A224D65752064';
wwv_flow_imp.g_varchar2_table(29) := '6973706F73697469766F222C6E6F46696C6573466F756E643A22566F635C784541206E5C7845336F20706F73737569206172717569766F73206F75207061737461732061717569222C6E6F496E7465726E6574436F6E6E656374696F6E3A2253656D2063';
wwv_flow_imp.g_varchar2_table(30) := '6F6E65785C7845336F20636F6D206120696E7465726E6574222C70617573653A22506175736172222C706175736555706C6F61643A2250617573617220656E76696F206465206172717569766F73222C7061757365643A225061757361646F222C706F77';
wwv_flow_imp.g_varchar2_table(31) := '6572656442793A22446573656E766F6C7669646F20706F7220257B757070797D222C70726F63657373696E675846696C65733A7B303A2250726F63657373616E646F20257B736D6172745F636F756E747D206172717569766F222C313A2250726F636573';
wwv_flow_imp.g_varchar2_table(32) := '73616E646F20257B736D6172745F636F756E747D206172717569766F73227D2C72656D6F766546696C653A2252656D6F766572206172717569766F222C726573657446696C7465723A22526573657461722066696C74726F222C726573756D653A225265';
wwv_flow_imp.g_varchar2_table(33) := '746F6D6172222C726573756D6555706C6F61643A225265746F6D617220656E76696F206465206172717569766F73222C72657472793A2254656E746172206E6F76616D656E7465222C726574727955706C6F61643A2254656E74617220656E7669617220';
wwv_flow_imp.g_varchar2_table(34) := '6E6F76616D656E7465222C736176654368616E6765733A2253616C76617220616C746572615C7845375C7846356573222C73656C656374583A7B303A2253656C6563696F6E617220257B736D6172745F636F756E747D222C313A2253656C6563696F6E61';
wwv_flow_imp.g_varchar2_table(35) := '7220257B736D6172745F636F756E747D227D2C736D696C653A22536F7272696121222C73746172745265636F7264696E673A22436F6D655C78453761722067726176615C7845375C7845336F20646520765C78454464656F222C73746F705265636F7264';
wwv_flow_imp.g_varchar2_table(36) := '696E673A2250617261722067726176615C7845375C7845336F20646520765C78454464656F222C74616B65506963747572653A22546972617220756D6120666F746F222C74696D65644F75743A22456E76696F206465206172717569766F732070617261';
wwv_flow_imp.g_varchar2_table(37) := '646F20706F7220257B7365636F6E64737D20736567756E646F732C2061626F7274616E646F2E222C75706C6F61643A22456E76696172206172717569766F73222C75706C6F6164436F6D706C6574653A22456E76696F206465206172717569766F732066';
wwv_flow_imp.g_varchar2_table(38) := '696E616C697A61646F222C75706C6F61644661696C65643A22456E76696F206465206172717569766F732066616C686F75222C75706C6F61645061757365643A22456E76696F206465206172717569766F73207061757361646F222C75706C6F61645846';
wwv_flow_imp.g_varchar2_table(39) := '696C65733A7B303A22456E7669617220257B736D6172745F636F756E747D206172717569766F222C313A22456E7669617220257B736D6172745F636F756E747D206172717569766F73227D2C75706C6F6164584E657746696C65733A7B303A22456E7669';
wwv_flow_imp.g_varchar2_table(40) := '6172202B257B736D6172745F636F756E747D206172717569766F222C313A22456E76696172202B257B736D6172745F636F756E747D206172717569766F73227D2C75706C6F6164696E673A22456E7669616E646F222C75706C6F6164696E675846696C65';
wwv_flow_imp.g_varchar2_table(41) := '733A7B303A22456E7669616E646F20257B736D6172745F636F756E747D206172717569766F222C313A22456E7669616E646F20257B736D6172745F636F756E747D206172717569766F73227D2C7846696C657353656C65637465643A7B303A22257B736D';
wwv_flow_imp.g_varchar2_table(42) := '6172745F636F756E747D206172717569766F2073656C6563696F6E61646F222C313A22257B736D6172745F636F756E747D206172717569766F732073656C6563696F6E61646F73227D2C784D6F726546696C657341646465643A7B303A22257B736D6172';
wwv_flow_imp.g_varchar2_table(43) := '745F636F756E747D206172717569766F2061646963696F6E61646F73222C313A22257B736D6172745F636F756E747D206172717569766F732061646963696F6E61646F73227D2C7854696D654C6566743A22257B74696D657D2072657374616E74657322';
wwv_flow_imp.g_varchar2_table(44) := '2C796F7543616E4F6E6C7955706C6F616446696C6554797065733A22566F635C78454120706F646520656E76696172206170656E6173206172717569766F733A20257B74797065737D222C796F7543616E4F6E6C7955706C6F6164583A7B303A22566F63';
wwv_flow_imp.g_varchar2_table(45) := '5C78454120706F646520656E76696172206170656E617320257B736D6172745F636F756E747D206172717569766F222C313A22566F635C78454120706F646520656E76696172206170656E617320257B736D6172745F636F756E747D206172717569766F';
wwv_flow_imp.g_varchar2_table(46) := '73227D2C796F7548617665546F41744C6561737453656C656374583A7B303A22566F635C78454120707265636973612073656C6563696F6E61722070656C6F206D656E6F7320257B736D6172745F636F756E747D206172717569766F222C313A22566F63';
wwv_flow_imp.g_varchar2_table(47) := '5C78454120707265636973612073656C6563696F6E61722070656C6F206D656E6F7320257B736D6172745F636F756E747D206172717569766F73227D2C73656C65637446696C654E616D65643A2253656C6563696F6E65206F206172717569766F20257B';
wwv_flow_imp.g_varchar2_table(48) := '6E616D657D222C756E73656C65637446696C654E616D65643A22446573656C6563696F6E6172206172717569766F20257B6E616D657D222C6F70656E466F6C6465724E616D65643A2250617374612061626572746120257B6E616D657D227D3B74797065';
wwv_flow_imp.g_varchar2_table(49) := '6F6620557070793C227522262628676C6F62616C546869732E557070792E6C6F63616C65732E70745F42523D6F293B76617220613D6F3B7D2928293B0A2F2F2320736F757263654D617070696E6755524C3D70745F42522E6D696E2E6A732E6D6170';
null;
end;
/
begin
wwv_flow_imp_shared.create_plugin_file(
 p_id=>wwv_flow_imp.id(740462737636162536)
,p_plugin_id=>wwv_flow_imp.id(739921988389392679)
,p_file_name=>'dist/pt_BR.min.js'
,p_mime_type=>'text/javascript'
,p_file_charset=>'utf-8'
,p_file_content=>wwv_flow_imp.varchar2_to_blob(wwv_flow_imp.g_varchar2_table)
);
end;
/
begin
wwv_flow_imp.g_varchar2_table := wwv_flow_imp.empty_varchar2_table;
wwv_flow_imp.g_varchar2_table(1) := '2275736520737472696374223B2828293D3E7B7661722048623D4F626A6563742E6372656174653B76617220436C3D4F626A6563742E646566696E6550726F70657274793B7661722024623D4F626A6563742E6765744F776E50726F7065727479446573';
wwv_flow_imp.g_varchar2_table(2) := '63726970746F723B7661722071623D4F626A6563742E6765744F776E50726F70657274794E616D65733B7661722056623D4F626A6563742E67657450726F746F747970654F662C57623D4F626A6563742E70726F746F747970652E6861734F776E50726F';
wwv_flow_imp.g_varchar2_table(3) := '70657274793B766172206E3D28692C65293D3E436C28692C226E616D65222C7B76616C75653A652C636F6E666967757261626C653A21307D293B7661722068653D28692C65293D3E28293D3E28657C7C692828653D7B6578706F7274733A7B7D7D292E65';
wwv_flow_imp.g_varchar2_table(4) := '78706F7274732C65292C652E6578706F727473292C4F6C3D28692C65293D3E7B666F7228766172207420696E206529436C28692C742C7B6765743A655B745D2C656E756D657261626C653A21307D297D2C47623D28692C652C742C72293D3E7B69662865';
wwv_flow_imp.g_varchar2_table(5) := '2626747970656F6620653D3D226F626A656374227C7C747970656F6620653D3D2266756E6374696F6E2229666F72286C65742073206F66207162286529292157622E63616C6C28692C7329262673213D3D742626436C28692C732C7B6765743A28293D3E';
wwv_flow_imp.g_varchar2_table(6) := '655B735D2C656E756D657261626C653A2128723D246228652C7329297C7C722E656E756D657261626C657D293B72657475726E20697D3B7661722064653D28692C652C74293D3E28743D69213D6E756C6C3F4862285662286929293A7B7D2C476228657C';
wwv_flow_imp.g_varchar2_table(7) := '7C21697C7C21692E5F5F65734D6F64756C653F436C28742C2264656661756C74222C7B76616C75653A692C656E756D657261626C653A21307D293A742C6929293B7661722076683D686528285A462C6E66293D3E7B6E662E6578706F7274733D6E286675';
wwv_flow_imp.g_varchar2_table(8) := '6E6374696F6E28297B76617220653D7B7D2C743D652E5F666E733D7B7D3B652E656D69743D6E2866756E6374696F6E28612C6C2C682C632C642C662C79297B76617220623D722861293B622E6C656E67746826267328612C622C5B6C2C682C632C642C66';
wwv_flow_imp.g_varchar2_table(9) := '2C795D297D2C22656D697422292C652E6F6E3D6E2866756E6374696F6E28612C6C297B745B615D7C7C28745B615D3D5B5D292C745B615D2E70757368286C297D2C226F6E22292C652E6F6E63653D6E2866756E6374696F6E28612C6C297B66756E637469';
wwv_flow_imp.g_varchar2_table(10) := '6F6E206828297B6C2E6170706C7928746869732C617267756D656E7473292C652E6F666628612C68297D6E28682C226F6E6522292C746869732E6F6E28612C68297D2C226F6E636522292C652E6F66663D6E2866756E6374696F6E28612C6C297B766172';
wwv_flow_imp.g_varchar2_table(11) := '20683D5B5D3B6966286126266C297B76617220633D746869732E5F666E735B615D2C643D302C663D633F632E6C656E6774683A303B666F7228643B643C663B642B2B29635B645D213D3D6C2626682E7075736828635B645D297D682E6C656E6774683F74';
wwv_flow_imp.g_varchar2_table(12) := '6869732E5F666E735B615D3D683A64656C65746520746869732E5F666E735B615D7D2C226F666622293B66756E6374696F6E2072286F297B76617220613D745B6F5D3F745B6F5D3A5B5D2C6C3D6F2E696E6465784F6628223A22292C683D6C3D3D3D2D31';
wwv_flow_imp.g_varchar2_table(13) := '3F5B6F5D3A5B6F2E737562737472696E6728302C6C292C6F2E737562737472696E67286C2B31295D2C633D4F626A6563742E6B6579732874292C643D302C663D632E6C656E6774683B666F7228643B643C663B642B2B297B76617220793D635B645D3B69';
wwv_flow_imp.g_varchar2_table(14) := '6628793D3D3D222A22262628613D612E636F6E63617428745B795D29292C682E6C656E6774683D3D3D322626685B305D3D3D3D79297B613D612E636F6E63617428745B795D293B627265616B7D7D72657475726E20617D6E28722C226765744C69737465';
wwv_flow_imp.g_varchar2_table(15) := '6E65727322293B66756E6374696F6E2073286F2C612C6C297B76617220683D302C633D612E6C656E6774683B666F7228683B683C632626615B685D3B682B2B29615B685D2E6576656E743D6F2C615B685D2E6170706C7928615B685D2C6C297D72657475';
wwv_flow_imp.g_varchar2_table(16) := '726E206E28732C22656D6974416C6C22292C657D2C226372656174654E616D657370616365456D697474657222297D293B76617220416C3D6865282872782C6166293D3E7B66756E6374696F6E205A622869297B76617220653D747970656F6620693B72';
wwv_flow_imp.g_varchar2_table(17) := '657475726E2069213D6E756C6C262628653D3D226F626A656374227C7C653D3D2266756E6374696F6E22297D6E285A622C2269734F626A65637422293B61662E6578706F7274733D5A627D293B7661722075663D686528286F782C6C66293D3E7B766172';
wwv_flow_imp.g_varchar2_table(18) := '2065313D747970656F6620676C6F62616C3D3D226F626A656374222626676C6F62616C2626676C6F62616C2E4F626A6563743D3D3D4F626A6563742626676C6F62616C3B6C662E6578706F7274733D65317D293B7661722062683D686528286E782C6866';
wwv_flow_imp.g_varchar2_table(19) := '293D3E7B7661722074313D756628292C69313D747970656F662073656C663D3D226F626A65637422262673656C66262673656C662E4F626A6563743D3D3D4F626A656374262673656C662C72313D74317C7C69317C7C46756E6374696F6E282272657475';
wwv_flow_imp.g_varchar2_table(20) := '726E2074686973222928293B68662E6578706F7274733D72317D293B7661722063663D6865282861782C6466293D3E7B7661722073313D626828292C6F313D6E2866756E6374696F6E28297B72657475726E2073312E446174652E6E6F7728297D2C226E';
wwv_flow_imp.g_varchar2_table(21) := '6F7722293B64662E6578706F7274733D6F317D293B7661722066663D6865282875782C7066293D3E7B766172206E313D2F5C732F3B66756E6374696F6E2061312869297B666F722876617220653D692E6C656E6774683B652D2D26266E312E7465737428';
wwv_flow_imp.g_varchar2_table(22) := '692E636861724174286529293B293B72657475726E20657D6E2861312C227472696D6D6564456E64496E64657822293B70662E6578706F7274733D61317D293B7661722067663D6865282864782C6D66293D3E7B766172206C313D666628292C75313D2F';
wwv_flow_imp.g_varchar2_table(23) := '5E5C732B2F3B66756E6374696F6E2068312869297B72657475726E20692626692E736C69636528302C6C312869292B31292E7265706C6163652875312C2222297D6E2868312C22626173655472696D22293B6D662E6578706F7274733D68317D293B7661';
wwv_flow_imp.g_varchar2_table(24) := '722077683D6865282870782C7966293D3E7B7661722064313D626828292C63313D64312E53796D626F6C3B79662E6578706F7274733D63317D293B7661722053663D6865282866782C7766293D3E7B7661722076663D776828292C62663D4F626A656374';
wwv_flow_imp.g_varchar2_table(25) := '2E70726F746F747970652C70313D62662E6861734F776E50726F70657274792C66313D62662E746F537472696E672C706E3D76663F76662E746F537472696E675461673A766F696420303B66756E6374696F6E206D312869297B76617220653D70312E63';
wwv_flow_imp.g_varchar2_table(26) := '616C6C28692C706E292C743D695B706E5D3B7472797B695B706E5D3D766F696420303B76617220723D21307D63617463687B7D76617220733D66312E63616C6C2869293B72657475726E2072262628653F695B706E5D3D743A64656C65746520695B706E';
wwv_flow_imp.g_varchar2_table(27) := '5D292C737D6E286D312C2267657452617754616722293B77662E6578706F7274733D6D317D293B766172205F663D6865282867782C5066293D3E7B7661722067313D4F626A6563742E70726F746F747970652C79313D67312E746F537472696E673B6675';
wwv_flow_imp.g_varchar2_table(28) := '6E6374696F6E2076312869297B72657475726E2079312E63616C6C2869297D6E2876312C226F626A656374546F537472696E6722293B50662E6578706F7274733D76317D293B7661722043663D6865282876782C4566293D3E7B7661722046663D776828';
wwv_flow_imp.g_varchar2_table(29) := '292C62313D536628292C77313D5F6628292C53313D225B6F626A656374204E756C6C5D222C50313D225B6F626A65637420556E646566696E65645D222C78663D46663F46662E746F537472696E675461673A766F696420303B66756E6374696F6E205F31';
wwv_flow_imp.g_varchar2_table(30) := '2869297B72657475726E20693D3D6E756C6C3F693D3D3D766F696420303F50313A53313A78662626786620696E204F626A6563742869293F62312869293A77312869297D6E285F312C226261736547657454616722293B45662E6578706F7274733D5F31';
wwv_flow_imp.g_varchar2_table(31) := '7D293B7661722054663D6865282877782C4F66293D3E7B66756E6374696F6E2046312869297B72657475726E2069213D6E756C6C2626747970656F6620693D3D226F626A656374227D6E2846312C2269734F626A6563744C696B6522293B4F662E657870';
wwv_flow_imp.g_varchar2_table(32) := '6F7274733D46317D293B7661722052663D6865282850782C4166293D3E7B7661722078313D436628292C45313D546628292C43313D225B6F626A6563742053796D626F6C5D223B66756E6374696F6E204F312869297B72657475726E20747970656F6620';
wwv_flow_imp.g_varchar2_table(33) := '693D3D2273796D626F6C227C7C4531286929262678312869293D3D43317D6E284F312C22697353796D626F6C22293B41662E6578706F7274733D4F317D293B7661722049663D6865282846782C4466293D3E7B7661722054313D676628292C55663D416C';
wwv_flow_imp.g_varchar2_table(34) := '28292C41313D526628292C6B663D302F302C52313D2F5E5B2D2B5D30785B302D39612D665D2B242F692C55313D2F5E30625B30315D2B242F692C6B313D2F5E306F5B302D375D2B242F692C44313D7061727365496E743B66756E6374696F6E2049312869';
wwv_flow_imp.g_varchar2_table(35) := '297B696628747970656F6620693D3D226E756D626572222972657475726E20693B69662841312869292972657475726E206B663B6966285566286929297B76617220653D747970656F6620692E76616C75654F663D3D2266756E6374696F6E223F692E76';
wwv_flow_imp.g_varchar2_table(36) := '616C75654F6628293A693B693D55662865293F652B22223A657D696628747970656F662069213D22737472696E67222972657475726E20693D3D3D303F693A2B693B693D54312869293B76617220743D55312E746573742869293B72657475726E20747C';
wwv_flow_imp.g_varchar2_table(37) := '7C6B312E746573742869293F443128692E736C6963652832292C743F323A38293A52312E746573742869293F6B663A2B697D6E2849312C22746F4E756D62657222293B44662E6578706F7274733D49317D293B7661722050683D6865282845782C4E6629';
wwv_flow_imp.g_varchar2_table(38) := '3D3E7B766172204D313D416C28292C53683D636628292C4D663D496628292C4E313D22457870656374656420612066756E6374696F6E222C4C313D4D6174682E6D61782C42313D4D6174682E6D696E3B66756E6374696F6E207A3128692C652C74297B76';
wwv_flow_imp.g_varchar2_table(39) := '617220722C732C6F2C612C6C2C682C633D302C643D21312C663D21312C793D21303B696628747970656F662069213D2266756E6374696F6E22297468726F77206E657720547970654572726F72284E31293B653D4D662865297C7C302C4D312874292626';
wwv_flow_imp.g_varchar2_table(40) := '28643D2121742E6C656164696E672C663D226D61785761697422696E20742C6F3D663F4C31284D6628742E6D617857616974297C7C302C65293A6F2C793D22747261696C696E6722696E20743F2121742E747261696C696E673A79293B66756E6374696F';
wwv_flow_imp.g_varchar2_table(41) := '6E20622842297B766172207A3D722C4B3D733B72657475726E20723D733D766F696420302C633D422C613D692E6170706C79284B2C7A292C617D6E28622C22696E766F6B6546756E6322293B66756E6374696F6E20532842297B72657475726E20633D42';
wwv_flow_imp.g_varchar2_table(42) := '2C6C3D73657454696D656F757428782C65292C643F622842293A617D6E28532C226C656164696E674564676522293B66756E6374696F6E20452842297B766172207A3D422D682C4B3D422D632C6F653D652D7A3B72657475726E20663F4231286F652C6F';
wwv_flow_imp.g_varchar2_table(43) := '2D4B293A6F657D6E28452C2272656D61696E696E675761697422293B66756E6374696F6E20462842297B766172207A3D422D682C4B3D422D633B72657475726E20683D3D3D766F696420307C7C7A3E3D657C7C7A3C307C7C6626264B3E3D6F7D6E28462C';
wwv_flow_imp.g_varchar2_table(44) := '2273686F756C64496E766F6B6522293B66756E6374696F6E207828297B76617220423D536828293B696628462842292972657475726E20552842293B6C3D73657454696D656F757428782C45284229297D6E28782C2274696D6572457870697265642229';
wwv_flow_imp.g_varchar2_table(45) := '3B66756E6374696F6E20552842297B72657475726E206C3D766F696420302C792626723F622842293A28723D733D766F696420302C61297D6E28552C22747261696C696E674564676522293B66756E6374696F6E206A28297B6C213D3D766F6964203026';
wwv_flow_imp.g_varchar2_table(46) := '26636C65617254696D656F7574286C292C633D302C723D683D733D6C3D766F696420307D6E286A2C2263616E63656C22293B66756E6374696F6E204728297B72657475726E206C3D3D3D766F696420303F613A552853682829297D6E28472C22666C7573';
wwv_flow_imp.g_varchar2_table(47) := '6822293B66756E6374696F6E204A28297B76617220423D536828292C7A3D462842293B696628723D617267756D656E74732C733D746869732C683D422C7A297B6966286C3D3D3D766F696420302972657475726E20532868293B69662866297265747572';
wwv_flow_imp.g_varchar2_table(48) := '6E20636C65617254696D656F7574286C292C6C3D73657454696D656F757428782C65292C622868297D72657475726E206C3D3D3D766F696420302626286C3D73657454696D656F757428782C6529292C617D72657475726E206E284A2C226465626F756E';
wwv_flow_imp.g_varchar2_table(49) := '63656422292C4A2E63616E63656C3D6A2C4A2E666C7573683D472C4A7D6E287A312C226465626F756E636522293B4E662E6578706F7274733D7A317D293B76617220526C3D686528284F782C4C66293D3E7B766172206A313D506828292C48313D416C28';
wwv_flow_imp.g_varchar2_table(50) := '292C24313D22457870656374656420612066756E6374696F6E223B66756E6374696F6E20713128692C652C74297B76617220723D21302C733D21303B696628747970656F662069213D2266756E6374696F6E22297468726F77206E657720547970654572';
wwv_flow_imp.g_varchar2_table(51) := '726F72282431293B72657475726E204831287429262628723D226C656164696E6722696E20743F2121742E6C656164696E673A722C733D22747261696C696E6722696E20743F2121742E747261696C696E673A73292C6A3128692C652C7B6C656164696E';
wwv_flow_imp.g_varchar2_table(52) := '673A722C6D6178576169743A652C747261696C696E673A737D297D6E2871312C227468726F74746C6522293B4C662E6578706F7274733D71317D293B76617220496C3D6865282859782C2466293D3E7B24662E6578706F7274733D6E2866756E6374696F';
wwv_flow_imp.g_varchar2_table(53) := '6E2865297B696628747970656F662065213D226E756D626572227C7C69734E614E286529297468726F77206E657720547970654572726F72286045787065637465642061206E756D6265722C20676F7420247B747970656F6620657D60293B6C65742074';
wwv_flow_imp.g_varchar2_table(54) := '3D653C302C723D5B2242222C224B42222C224D42222C224742222C225442222C225042222C224542222C225A42222C225942225D3B69662874262628653D2D65292C653C312972657475726E60247B28743F222D223A2222292B657D2042603B6C657420';
wwv_flow_imp.g_varchar2_table(55) := '733D4D6174682E6D696E284D6174682E666C6F6F72284D6174682E6C6F672865292F4D6174682E6C6F67283130323429292C722E6C656E6774682D31293B653D4E756D62657228652F4D6174682E706F7728313032342C7329293B6C6574206F3D725B73';
wwv_flow_imp.g_varchar2_table(56) := '5D3B72657475726E20653E3D31307C7C6525313D3D3D303F60247B28743F222D223A2222292B652E746F46697865642830297D20247B6F7D603A60247B28743F222D223A2222292B652E746F46697865642831297D20247B6F7D607D2C22707265747469';
wwv_flow_imp.g_varchar2_table(57) := '6572427974657322297D293B7661722057663D686528284A782C5666293D3E7B2275736520737472696374223B66756E6374696F6E20716628692C65297B746869732E746578743D693D697C7C22222C746869732E68617357696C643D7E692E696E6465';
wwv_flow_imp.g_varchar2_table(58) := '784F6628222A22292C746869732E736570617261746F723D652C746869732E70617274733D692E73706C69742865297D6E2871662C2257696C64636172644D61746368657222293B71662E70726F746F747970652E6D617463683D66756E6374696F6E28';
wwv_flow_imp.g_varchar2_table(59) := '69297B76617220653D21302C743D746869732E70617274732C722C733D742E6C656E6774682C6F3B696628747970656F6620693D3D22737472696E67227C7C6920696E7374616E63656F6620537472696E672969662821746869732E68617357696C6426';
wwv_flow_imp.g_varchar2_table(60) := '26746869732E74657874213D6929653D21313B656C73657B666F72286F3D28697C7C2222292E73706C697428746869732E736570617261746F72292C723D303B652626723C733B722B2B29745B725D213D3D222A22262628723C6F2E6C656E6774683F65';
wwv_flow_imp.g_varchar2_table(61) := '3D745B725D3D3D3D6F5B725D3A653D2131293B653D6526266F7D656C736520696628747970656F6620692E73706C6963653D3D2266756E6374696F6E2229666F7228653D5B5D2C723D692E6C656E6774683B722D2D3B29746869732E6D6174636828695B';
wwv_flow_imp.g_varchar2_table(62) := '725D29262628655B652E6C656E6774685D3D695B725D293B656C736520696628747970656F6620693D3D226F626A65637422297B653D7B7D3B666F7228766172206120696E206929746869732E6D61746368286129262628655B615D3D695B615D297D72';
wwv_flow_imp.g_varchar2_table(63) := '657475726E20657D3B56662E6578706F7274733D66756E6374696F6E28692C652C74297B76617220723D6E657720716628692C747C7C2F5B5C2F5C2E5D2F293B72657475726E20747970656F6620653C2275223F722E6D617463682865293A727D7D293B';
wwv_flow_imp.g_varchar2_table(64) := '766172204B663D6865282865332C4766293D3E7B7661722059313D576628292C51313D2F5B5C2F5C2B5C2E5D2F3B47662E6578706F7274733D66756E6374696F6E28692C65297B66756E6374696F6E20742872297B76617220733D593128722C692C5131';
wwv_flow_imp.g_varchar2_table(65) := '293B72657475726E20732626732E6C656E6774683E3D327D72657475726E206E28742C227465737422292C653F7428652E73706C697428223B22295B305D293A747D7D293B76617220536D3D6865282824332C776D293D3E7B66756E6374696F6E206669';
wwv_flow_imp.g_varchar2_table(66) := '28692C65297B747970656F6620653D3D22626F6F6C65616E22262628653D7B666F72657665723A657D292C746869732E5F6F726967696E616C54696D656F7574733D4A534F4E2E7061727365284A534F4E2E737472696E67696679286929292C74686973';
wwv_flow_imp.g_varchar2_table(67) := '2E5F74696D656F7574733D692C746869732E5F6F7074696F6E733D657C7C7B7D2C746869732E5F6D6178526574727954696D653D652626652E6D6178526574727954696D657C7C312F302C746869732E5F666E3D6E756C6C2C746869732E5F6572726F72';
wwv_flow_imp.g_varchar2_table(68) := '733D5B5D2C746869732E5F617474656D7074733D312C746869732E5F6F7065726174696F6E54696D656F75743D6E756C6C2C746869732E5F6F7065726174696F6E54696D656F757443623D6E756C6C2C746869732E5F74696D656F75743D6E756C6C2C74';
wwv_flow_imp.g_varchar2_table(69) := '6869732E5F6F7065726174696F6E53746172743D6E756C6C2C746869732E5F74696D65723D6E756C6C2C746869732E5F6F7074696F6E732E666F7265766572262628746869732E5F63616368656454696D656F7574733D746869732E5F74696D656F7574';
wwv_flow_imp.g_varchar2_table(70) := '732E736C696365283029297D6E2866692C2252657472794F7065726174696F6E22293B776D2E6578706F7274733D66693B66692E70726F746F747970652E72657365743D66756E6374696F6E28297B746869732E5F617474656D7074733D312C74686973';
wwv_flow_imp.g_varchar2_table(71) := '2E5F74696D656F7574733D746869732E5F6F726967696E616C54696D656F7574732E736C6963652830297D3B66692E70726F746F747970652E73746F703D66756E6374696F6E28297B746869732E5F74696D656F75742626636C65617254696D656F7574';
wwv_flow_imp.g_varchar2_table(72) := '28746869732E5F74696D656F7574292C746869732E5F74696D65722626636C65617254696D656F757428746869732E5F74696D6572292C746869732E5F74696D656F7574733D5B5D2C746869732E5F63616368656454696D656F7574733D6E756C6C7D3B';
wwv_flow_imp.g_varchar2_table(73) := '66692E70726F746F747970652E72657472793D66756E6374696F6E2869297B696628746869732E5F74696D656F75742626636C65617254696D656F757428746869732E5F74696D656F7574292C21692972657475726E21313B76617220653D6E65772044';
wwv_flow_imp.g_varchar2_table(74) := '61746528292E67657454696D6528293B696628692626652D746869732E5F6F7065726174696F6E53746172743E3D746869732E5F6D6178526574727954696D652972657475726E20746869732E5F6572726F72732E707573682869292C746869732E5F65';
wwv_flow_imp.g_varchar2_table(75) := '72726F72732E756E7368696674286E6577204572726F72282252657472794F7065726174696F6E2074696D656F7574206F636375727265642229292C21313B746869732E5F6572726F72732E707573682869293B76617220743D746869732E5F74696D65';
wwv_flow_imp.g_varchar2_table(76) := '6F7574732E736869667428293B696628743D3D3D766F6964203029696628746869732E5F63616368656454696D656F75747329746869732E5F6572726F72732E73706C69636528302C746869732E5F6572726F72732E6C656E6774682D31292C743D7468';
wwv_flow_imp.g_varchar2_table(77) := '69732E5F63616368656454696D656F7574732E736C696365282D31293B656C73652072657475726E21313B76617220723D746869733B72657475726E20746869732E5F74696D65723D73657454696D656F75742866756E6374696F6E28297B722E5F6174';
wwv_flow_imp.g_varchar2_table(78) := '74656D7074732B2B2C722E5F6F7065726174696F6E54696D656F75744362262628722E5F74696D656F75743D73657454696D656F75742866756E6374696F6E28297B722E5F6F7065726174696F6E54696D656F7574436228722E5F617474656D70747329';
wwv_flow_imp.g_varchar2_table(79) := '7D2C722E5F6F7065726174696F6E54696D656F7574292C722E5F6F7074696F6E732E756E7265662626722E5F74696D656F75742E756E7265662829292C722E5F666E28722E5F617474656D707473297D2C74292C746869732E5F6F7074696F6E732E756E';
wwv_flow_imp.g_varchar2_table(80) := '7265662626746869732E5F74696D65722E756E72656628292C21307D3B66692E70726F746F747970652E617474656D70743D66756E6374696F6E28692C65297B746869732E5F666E3D692C65262628652E74696D656F7574262628746869732E5F6F7065';
wwv_flow_imp.g_varchar2_table(81) := '726174696F6E54696D656F75743D652E74696D656F7574292C652E6362262628746869732E5F6F7065726174696F6E54696D656F757443623D652E636229293B76617220743D746869733B746869732E5F6F7065726174696F6E54696D656F7574436226';
wwv_flow_imp.g_varchar2_table(82) := '2628746869732E5F74696D656F75743D73657454696D656F75742866756E6374696F6E28297B742E5F6F7065726174696F6E54696D656F7574436228297D2C742E5F6F7065726174696F6E54696D656F757429292C746869732E5F6F7065726174696F6E';
wwv_flow_imp.g_varchar2_table(83) := '53746172743D6E6577204461746528292E67657454696D6528292C746869732E5F666E28746869732E5F617474656D707473297D3B66692E70726F746F747970652E7472793D66756E6374696F6E2869297B636F6E736F6C652E6C6F6728225573696E67';
wwv_flow_imp.g_varchar2_table(84) := '2052657472794F7065726174696F6E2E7472792829206973206465707265636174656422292C746869732E617474656D70742869297D3B66692E70726F746F747970652E73746172743D66756E6374696F6E2869297B636F6E736F6C652E6C6F67282255';
wwv_flow_imp.g_varchar2_table(85) := '73696E672052657472794F7065726174696F6E2E73746172742829206973206465707265636174656422292C746869732E617474656D70742869297D3B66692E70726F746F747970652E73746172743D66692E70726F746F747970652E7472793B66692E';
wwv_flow_imp.g_varchar2_table(86) := '70726F746F747970652E6572726F72733D66756E6374696F6E28297B72657475726E20746869732E5F6572726F72737D3B66692E70726F746F747970652E617474656D7074733D66756E6374696F6E28297B72657475726E20746869732E5F617474656D';
wwv_flow_imp.g_varchar2_table(87) := '7074737D3B66692E70726F746F747970652E6D61696E4572726F723D66756E6374696F6E28297B696628746869732E5F6572726F72732E6C656E6774683D3D3D302972657475726E206E756C6C3B666F722876617220693D7B7D2C653D6E756C6C2C743D';
wwv_flow_imp.g_varchar2_table(88) := '302C723D303B723C746869732E5F6572726F72732E6C656E6774683B722B2B297B76617220733D746869732E5F6572726F72735B725D2C6F3D732E6D6573736167652C613D28695B6F5D7C7C30292B313B695B6F5D3D612C613E3D74262628653D732C74';
wwv_flow_imp.g_varchar2_table(89) := '3D61297D72657475726E20657D7D293B76617220506D3D68652877733D3E7B7661722050773D536D28293B77732E6F7065726174696F6E3D66756E6374696F6E2869297B76617220653D77732E74696D656F7574732869293B72657475726E206E657720';
wwv_flow_imp.g_varchar2_table(90) := '507728652C7B666F72657665723A69262628692E666F72657665727C7C692E726574726965733D3D3D312F30292C756E7265663A692626692E756E7265662C6D6178526574727954696D653A692626692E6D6178526574727954696D657D297D3B77732E';
wwv_flow_imp.g_varchar2_table(91) := '74696D656F7574733D66756E6374696F6E2869297B6966286920696E7374616E63656F662041727261792972657475726E5B5D2E636F6E6361742869293B76617220653D7B726574726965733A31302C666163746F723A322C6D696E54696D656F75743A';
wwv_flow_imp.g_varchar2_table(92) := '312A3165332C6D617854696D656F75743A312F302C72616E646F6D697A653A21317D3B666F7228766172207420696E206929655B745D3D695B745D3B696628652E6D696E54696D656F75743E652E6D617854696D656F7574297468726F77206E65772045';
wwv_flow_imp.g_varchar2_table(93) := '72726F7228226D696E54696D656F75742069732067726561746572207468616E206D617854696D656F757422293B666F722876617220723D5B5D2C733D303B733C652E726574726965733B732B2B29722E7075736828746869732E63726561746554696D';
wwv_flow_imp.g_varchar2_table(94) := '656F757428732C6529293B72657475726E20692626692E666F7265766572262621722E6C656E6774682626722E7075736828746869732E63726561746554696D656F757428732C6529292C722E736F72742866756E6374696F6E286F2C61297B72657475';
wwv_flow_imp.g_varchar2_table(95) := '726E206F2D617D292C727D3B77732E63726561746554696D656F75743D66756E6374696F6E28692C65297B76617220743D652E72616E646F6D697A653F4D6174682E72616E646F6D28292B313A312C723D4D6174682E726F756E6428742A4D6174682E6D';
wwv_flow_imp.g_varchar2_table(96) := '617828652E6D696E54696D656F75742C31292A4D6174682E706F7728652E666163746F722C6929293B72657475726E20723D4D6174682E6D696E28722C652E6D617854696D656F7574292C727D3B77732E777261703D66756E6374696F6E28692C652C74';
wwv_flow_imp.g_varchar2_table(97) := '297B6966286520696E7374616E63656F66204172726179262628743D652C653D6E756C6C292C2174297B743D5B5D3B666F7228766172207220696E206929747970656F6620695B725D3D3D2266756E6374696F6E222626742E707573682872297D666F72';
wwv_flow_imp.g_varchar2_table(98) := '2876617220733D303B733C742E6C656E6774683B732B2B297B766172206F3D745B735D2C613D695B6F5D3B695B6F5D3D6E2866756E6374696F6E2868297B76617220633D77732E6F7065726174696F6E2865292C643D41727261792E70726F746F747970';
wwv_flow_imp.g_varchar2_table(99) := '652E736C6963652E63616C6C28617267756D656E74732C31292C663D642E706F7028293B642E707573682866756E6374696F6E2879297B632E72657472792879297C7C2879262628617267756D656E74735B305D3D632E6D61696E4572726F722829292C';
wwv_flow_imp.g_varchar2_table(100) := '662E6170706C7928746869732C617267756D656E747329297D292C632E617474656D70742866756E6374696F6E28297B682E6170706C7928692C64297D297D2C2272657472795772617070657222292E62696E6428692C61292C695B6F5D2E6F7074696F';
wwv_flow_imp.g_varchar2_table(101) := '6E733D657D7D7D293B76617220466D3D6865282847332C5F6D293D3E7B5F6D2E6578706F7274733D506D28297D293B766172204C6D3D686528284E452C6A68293D3E7B2275736520737472696374223B7661722071773D4F626A6563742E70726F746F74';
wwv_flow_imp.g_varchar2_table(102) := '7970652E6861734F776E50726F70657274792C41743D227E223B66756E6374696F6E20496E28297B7D6E28496E2C224576656E747322293B4F626A6563742E637265617465262628496E2E70726F746F747970653D4F626A6563742E637265617465286E';
wwv_flow_imp.g_varchar2_table(103) := '756C6C292C6E657720496E28292E5F5F70726F746F5F5F7C7C2841743D213129293B66756E6374696F6E20567728692C652C74297B746869732E666E3D692C746869732E636F6E746578743D652C746869732E6F6E63653D747C7C21317D6E2856772C22';
wwv_flow_imp.g_varchar2_table(104) := '454522293B66756E6374696F6E204E6D28692C652C742C722C73297B696628747970656F662074213D2266756E6374696F6E22297468726F77206E657720547970654572726F722822546865206C697374656E6572206D75737420626520612066756E63';
wwv_flow_imp.g_varchar2_table(105) := '74696F6E22293B766172206F3D6E657720567728742C727C7C692C73292C613D41743F41742B653A653B72657475726E20692E5F6576656E74735B615D3F692E5F6576656E74735B615D2E666E3F692E5F6576656E74735B615D3D5B692E5F6576656E74';
wwv_flow_imp.g_varchar2_table(106) := '735B615D2C6F5D3A692E5F6576656E74735B615D2E70757368286F293A28692E5F6576656E74735B615D3D6F2C692E5F6576656E7473436F756E742B2B292C697D6E284E6D2C226164644C697374656E657222293B66756E6374696F6E20596C28692C65';
wwv_flow_imp.g_varchar2_table(107) := '297B2D2D692E5F6576656E7473436F756E743D3D3D303F692E5F6576656E74733D6E657720496E3A64656C65746520692E5F6576656E74735B655D7D6E28596C2C22636C6561724576656E7422293B66756E6374696F6E205F7428297B746869732E5F65';
wwv_flow_imp.g_varchar2_table(108) := '76656E74733D6E657720496E2C746869732E5F6576656E7473436F756E743D307D6E285F742C224576656E74456D697474657222293B5F742E70726F746F747970652E6576656E744E616D65733D6E2866756E6374696F6E28297B76617220653D5B5D2C';
wwv_flow_imp.g_varchar2_table(109) := '742C723B696628746869732E5F6576656E7473436F756E743D3D3D302972657475726E20653B666F72287220696E20743D746869732E5F6576656E74732971772E63616C6C28742C72292626652E707573682841743F722E736C6963652831293A72293B';
wwv_flow_imp.g_varchar2_table(110) := '72657475726E204F626A6563742E6765744F776E50726F706572747953796D626F6C733F652E636F6E636174284F626A6563742E6765744F776E50726F706572747953796D626F6C73287429293A657D2C226576656E744E616D657322293B5F742E7072';
wwv_flow_imp.g_varchar2_table(111) := '6F746F747970652E6C697374656E6572733D6E2866756E6374696F6E2865297B76617220743D41743F41742B653A652C723D746869732E5F6576656E74735B745D3B69662821722972657475726E5B5D3B696628722E666E2972657475726E5B722E666E';
wwv_flow_imp.g_varchar2_table(112) := '5D3B666F722876617220733D302C6F3D722E6C656E6774682C613D6E6577204172726179286F293B733C6F3B732B2B29615B735D3D725B735D2E666E3B72657475726E20617D2C226C697374656E65727322293B5F742E70726F746F747970652E6C6973';
wwv_flow_imp.g_varchar2_table(113) := '74656E6572436F756E743D6E2866756E6374696F6E2865297B76617220743D41743F41742B653A652C723D746869732E5F6576656E74735B745D3B72657475726E20723F722E666E3F313A722E6C656E6774683A307D2C226C697374656E6572436F756E';
wwv_flow_imp.g_varchar2_table(114) := '7422293B5F742E70726F746F747970652E656D69743D6E2866756E6374696F6E28652C742C722C732C6F2C61297B766172206C3D41743F41742B653A653B69662821746869732E5F6576656E74735B6C5D2972657475726E21313B76617220683D746869';
wwv_flow_imp.g_varchar2_table(115) := '732E5F6576656E74735B6C5D2C633D617267756D656E74732E6C656E6774682C642C663B696628682E666E297B73776974636828682E6F6E63652626746869732E72656D6F76654C697374656E657228652C682E666E2C766F696420302C2130292C6329';
wwv_flow_imp.g_varchar2_table(116) := '7B6361736520313A72657475726E20682E666E2E63616C6C28682E636F6E74657874292C21303B6361736520323A72657475726E20682E666E2E63616C6C28682E636F6E746578742C74292C21303B6361736520333A72657475726E20682E666E2E6361';
wwv_flow_imp.g_varchar2_table(117) := '6C6C28682E636F6E746578742C742C72292C21303B6361736520343A72657475726E20682E666E2E63616C6C28682E636F6E746578742C742C722C73292C21303B6361736520353A72657475726E20682E666E2E63616C6C28682E636F6E746578742C74';
wwv_flow_imp.g_varchar2_table(118) := '2C722C732C6F292C21303B6361736520363A72657475726E20682E666E2E63616C6C28682E636F6E746578742C742C722C732C6F2C61292C21307D666F7228663D312C643D6E657720417272617928632D31293B663C633B662B2B29645B662D315D3D61';
wwv_flow_imp.g_varchar2_table(119) := '7267756D656E74735B665D3B682E666E2E6170706C7928682E636F6E746578742C64297D656C73657B76617220793D682E6C656E6774682C623B666F7228663D303B663C793B662B2B2973776974636828685B665D2E6F6E63652626746869732E72656D';
wwv_flow_imp.g_varchar2_table(120) := '6F76654C697374656E657228652C685B665D2E666E2C766F696420302C2130292C63297B6361736520313A685B665D2E666E2E63616C6C28685B665D2E636F6E74657874293B627265616B3B6361736520323A685B665D2E666E2E63616C6C28685B665D';
wwv_flow_imp.g_varchar2_table(121) := '2E636F6E746578742C74293B627265616B3B6361736520333A685B665D2E666E2E63616C6C28685B665D2E636F6E746578742C742C72293B627265616B3B6361736520343A685B665D2E666E2E63616C6C28685B665D2E636F6E746578742C742C722C73';
wwv_flow_imp.g_varchar2_table(122) := '293B627265616B3B64656661756C743A696628216429666F7228623D312C643D6E657720417272617928632D31293B623C633B622B2B29645B622D315D3D617267756D656E74735B625D3B685B665D2E666E2E6170706C7928685B665D2E636F6E746578';
wwv_flow_imp.g_varchar2_table(123) := '742C64297D7D72657475726E21307D2C22656D697422293B5F742E70726F746F747970652E6F6E3D6E2866756E6374696F6E28652C742C72297B72657475726E204E6D28746869732C652C742C722C2131297D2C226F6E22293B5F742E70726F746F7479';
wwv_flow_imp.g_varchar2_table(124) := '70652E6F6E63653D6E2866756E6374696F6E28652C742C72297B72657475726E204E6D28746869732C652C742C722C2130297D2C226F6E636522293B5F742E70726F746F747970652E72656D6F76654C697374656E65723D6E2866756E6374696F6E2865';
wwv_flow_imp.g_varchar2_table(125) := '2C742C722C73297B766172206F3D41743F41742B653A653B69662821746869732E5F6576656E74735B6F5D2972657475726E20746869733B69662821742972657475726E20596C28746869732C6F292C746869733B76617220613D746869732E5F657665';
wwv_flow_imp.g_varchar2_table(126) := '6E74735B6F5D3B696628612E666E29612E666E3D3D3D7426262821737C7C612E6F6E63652926262821727C7C612E636F6E746578743D3D3D72292626596C28746869732C6F293B656C73657B666F7228766172206C3D302C683D5B5D2C633D612E6C656E';
wwv_flow_imp.g_varchar2_table(127) := '6774683B6C3C633B6C2B2B2928615B6C5D2E666E213D3D747C7C73262621615B6C5D2E6F6E63657C7C722626615B6C5D2E636F6E74657874213D3D72292626682E7075736828615B6C5D293B682E6C656E6774683F746869732E5F6576656E74735B6F5D';
wwv_flow_imp.g_varchar2_table(128) := '3D682E6C656E6774683D3D3D313F685B305D3A683A596C28746869732C6F297D72657475726E20746869737D2C2272656D6F76654C697374656E657222293B5F742E70726F746F747970652E72656D6F7665416C6C4C697374656E6572733D6E2866756E';
wwv_flow_imp.g_varchar2_table(129) := '6374696F6E2865297B76617220743B72657475726E20653F28743D41743F41742B653A652C746869732E5F6576656E74735B745D2626596C28746869732C7429293A28746869732E5F6576656E74733D6E657720496E2C746869732E5F6576656E747343';
wwv_flow_imp.g_varchar2_table(130) := '6F756E743D30292C746869737D2C2272656D6F7665416C6C4C697374656E65727322293B5F742E70726F746F747970652E6F66663D5F742E70726F746F747970652E72656D6F76654C697374656E65723B5F742E70726F746F747970652E6164644C6973';
wwv_flow_imp.g_varchar2_table(131) := '74656E65723D5F742E70726F746F747970652E6F6E3B5F742E70726566697865643D41743B5F742E4576656E74456D69747465723D5F743B747970656F66206A683C2275222626286A682E6578706F7274733D5F74297D293B766172205A743D68652828';
wwv_flow_imp.g_varchar2_table(132) := '6D432C6875293D3E7B2866756E6374696F6E28297B2275736520737472696374223B76617220693D7B7D2E6861734F776E50726F70657274793B66756E6374696F6E206528297B666F722876617220743D5B5D2C723D303B723C617267756D656E74732E';
wwv_flow_imp.g_varchar2_table(133) := '6C656E6774683B722B2B297B76617220733D617267756D656E74735B725D3B69662873297B766172206F3D747970656F6620733B6966286F3D3D3D22737472696E67227C7C6F3D3D3D226E756D6265722229742E707573682873293B656C736520696628';
wwv_flow_imp.g_varchar2_table(134) := '41727261792E69734172726179287329297B696628732E6C656E677468297B76617220613D652E6170706C79286E756C6C2C73293B612626742E707573682861297D7D656C7365206966286F3D3D3D226F626A6563742229696628732E746F537472696E';
wwv_flow_imp.g_varchar2_table(135) := '673D3D3D4F626A6563742E70726F746F747970652E746F537472696E6729666F7228766172206C20696E207329692E63616C6C28732C6C292626735B6C5D2626742E70757368286C293B656C736520742E7075736828732E746F537472696E672829297D';
wwv_flow_imp.g_varchar2_table(136) := '7D72657475726E20742E6A6F696E28222022297D6E28652C22636C6173734E616D657322292C747970656F662068753C227522262668752E6578706F7274733F28652E64656661756C743D652C68752E6578706F7274733D65293A747970656F66206465';
wwv_flow_imp.g_varchar2_table(137) := '66696E653D3D2266756E6374696F6E222626747970656F6620646566696E652E616D643D3D226F626A656374222626646566696E652E616D643F646566696E652822636C6173736E616D6573222C5B5D2C66756E6374696F6E28297B72657475726E2065';
wwv_flow_imp.g_varchar2_table(138) := '7D293A77696E646F772E636C6173734E616D65733D657D2928297D293B766172206F793D6865282845342C7379293D3E7B73792E6578706F7274733D6E2866756E6374696F6E28652C74297B696628653D3D3D742972657475726E21303B666F72287661';
wwv_flow_imp.g_varchar2_table(139) := '72207220696E20652969662821287220696E2074292972657475726E21313B666F7228766172207220696E207429696628655B725D213D3D745B725D2972657475726E21313B72657475726E21307D2C2269735368616C6C6F77457175616C22297D293B';
wwv_flow_imp.g_varchar2_table(140) := '766172206C793D6865282847342C6179293D3E7B61792E6578706F7274733D6E2866756E6374696F6E2865297B696628747970656F662065213D226E756D626572227C7C69734E614E286529297468726F77206E657720547970654572726F7228224578';
wwv_flow_imp.g_varchar2_table(141) := '7065637465642061206E756D6265722C20676F7420222B747970656F662065293B76617220743D653C302C723D5B2242222C224B42222C224D42222C224742222C225442222C225042222C224542222C225A42222C225942225D3B69662874262628653D';
wwv_flow_imp.g_varchar2_table(142) := '2D65292C653C312972657475726E28743F222D223A2222292B652B222042223B76617220733D4D6174682E6D696E284D6174682E666C6F6F72284D6174682E6C6F672865292F4D6174682E6C6F67283130323429292C722E6C656E6774682D31293B653D';
wwv_flow_imp.g_varchar2_table(143) := '4E756D62657228652F4D6174682E706F7728313032342C7329293B766172206F3D725B735D3B72657475726E20653E3D31307C7C6525313D3D3D303F28743F222D223A2222292B652E746F46697865642830292B2220222B6F3A28743F222D223A222229';
wwv_flow_imp.g_varchar2_table(144) := '2B652E746F46697865642831292B2220222B6F7D2C227072657474696572427974657322297D293B766172206B793D6865282857642C4764293D3E7B2866756E6374696F6E28692C65297B747970656F662057643D3D226F626A65637422262674797065';
wwv_flow_imp.g_varchar2_table(145) := '6F662047643C2275223F47642E6578706F7274733D6528293A747970656F6620646566696E653D3D2266756E6374696F6E222626646566696E652E616D643F646566696E652865293A28693D697C7C73656C662C692E43726F707065723D652829297D29';
wwv_flow_imp.g_varchar2_table(146) := '2857642C66756E6374696F6E28297B2275736520737472696374223B66756E6374696F6E20692876297B2240626162656C2F68656C70657273202D20747970656F66223B72657475726E20747970656F662053796D626F6C3D3D2266756E6374696F6E22';
wwv_flow_imp.g_varchar2_table(147) := '2626747970656F662053796D626F6C2E6974657261746F723D3D2273796D626F6C223F693D6E2866756E6374696F6E2870297B72657475726E20747970656F6620707D2C225F747970656F6622293A693D6E2866756E6374696F6E2870297B7265747572';
wwv_flow_imp.g_varchar2_table(148) := '6E20702626747970656F662053796D626F6C3D3D2266756E6374696F6E222626702E636F6E7374727563746F723D3D3D53796D626F6C262670213D3D53796D626F6C2E70726F746F747970653F2273796D626F6C223A747970656F6620707D2C225F7479';
wwv_flow_imp.g_varchar2_table(149) := '70656F6622292C692876297D6E28692C225F747970656F6622293B66756E6374696F6E206528762C70297B69662821287620696E7374616E63656F66207029297468726F77206E657720547970654572726F72282243616E6E6F742063616C6C20612063';
wwv_flow_imp.g_varchar2_table(150) := '6C61737320617320612066756E6374696F6E22297D6E28652C225F636C61737343616C6C436865636B22293B66756E6374696F6E207428762C70297B666F722876617220673D303B673C702E6C656E6774683B672B2B297B766172206D3D705B675D3B6D';
wwv_flow_imp.g_varchar2_table(151) := '2E656E756D657261626C653D6D2E656E756D657261626C657C7C21312C6D2E636F6E666967757261626C653D21302C2276616C756522696E206D2626286D2E7772697461626C653D2130292C4F626A6563742E646566696E6550726F706572747928762C';
wwv_flow_imp.g_varchar2_table(152) := '6D2E6B65792C6D297D7D6E28742C225F646566696E6550726F7065727469657322293B66756E6374696F6E207228762C702C67297B72657475726E207026267428762E70726F746F747970652C70292C6726267428762C67292C767D6E28722C225F6372';
wwv_flow_imp.g_varchar2_table(153) := '65617465436C61737322293B66756E6374696F6E207328762C702C67297B72657475726E207020696E20763F4F626A6563742E646566696E6550726F706572747928762C702C7B76616C75653A672C656E756D657261626C653A21302C636F6E66696775';
wwv_flow_imp.g_varchar2_table(154) := '7261626C653A21302C7772697461626C653A21307D293A765B705D3D672C767D6E28732C225F646566696E6550726F706572747922293B66756E6374696F6E206F28762C70297B76617220673D4F626A6563742E6B6579732876293B6966284F626A6563';
wwv_flow_imp.g_varchar2_table(155) := '742E6765744F776E50726F706572747953796D626F6C73297B766172206D3D4F626A6563742E6765744F776E50726F706572747953796D626F6C732876293B702626286D3D6D2E66696C7465722866756E6374696F6E2850297B72657475726E204F626A';
wwv_flow_imp.g_varchar2_table(156) := '6563742E6765744F776E50726F706572747944657363726970746F7228762C50292E656E756D657261626C657D29292C672E707573682E6170706C7928672C6D297D72657475726E20677D6E286F2C226F776E4B65797322293B66756E6374696F6E2061';
wwv_flow_imp.g_varchar2_table(157) := '2876297B666F722876617220703D313B703C617267756D656E74732E6C656E6774683B702B2B297B76617220673D617267756D656E74735B705D213D6E756C6C3F617267756D656E74735B705D3A7B7D3B7025323F6F284F626A6563742867292C213029';
wwv_flow_imp.g_varchar2_table(158) := '2E666F72456163682866756E6374696F6E286D297B7328762C6D2C675B6D5D297D293A4F626A6563742E6765744F776E50726F706572747944657363726970746F72733F4F626A6563742E646566696E6550726F7065727469657328762C4F626A656374';
wwv_flow_imp.g_varchar2_table(159) := '2E6765744F776E50726F706572747944657363726970746F7273286729293A6F284F626A656374286729292E666F72456163682866756E6374696F6E286D297B4F626A6563742E646566696E6550726F706572747928762C6D2C4F626A6563742E676574';
wwv_flow_imp.g_varchar2_table(160) := '4F776E50726F706572747944657363726970746F7228672C6D29297D297D72657475726E20767D6E28612C225F6F626A6563745370726561643222293B66756E6374696F6E206C2876297B72657475726E20682876297C7C632876297C7C642876297C7C';
wwv_flow_imp.g_varchar2_table(161) := '7928297D6E286C2C225F746F436F6E73756D61626C65417272617922293B66756E6374696F6E20682876297B69662841727261792E697341727261792876292972657475726E20662876297D6E28682C225F6172726179576974686F7574486F6C657322';
wwv_flow_imp.g_varchar2_table(162) := '293B66756E6374696F6E20632876297B696628747970656F662053796D626F6C3C227522262653796D626F6C2E6974657261746F7220696E204F626A6563742876292972657475726E2041727261792E66726F6D2876297D6E28632C225F697465726162';
wwv_flow_imp.g_varchar2_table(163) := '6C65546F417272617922293B66756E6374696F6E206428762C70297B69662876297B696628747970656F6620763D3D22737472696E67222972657475726E206628762C70293B76617220673D4F626A6563742E70726F746F747970652E746F537472696E';
wwv_flow_imp.g_varchar2_table(164) := '672E63616C6C2876292E736C69636528382C2D31293B696628673D3D3D224F626A656374222626762E636F6E7374727563746F72262628673D762E636F6E7374727563746F722E6E616D65292C673D3D3D224D6170227C7C673D3D3D2253657422297265';
wwv_flow_imp.g_varchar2_table(165) := '7475726E2041727261792E66726F6D2876293B696628673D3D3D22417267756D656E7473227C7C2F5E283F3A55697C49296E74283F3A387C31367C333229283F3A436C616D706564293F4172726179242F2E746573742867292972657475726E20662876';
wwv_flow_imp.g_varchar2_table(166) := '2C70297D7D6E28642C225F756E737570706F727465644974657261626C65546F417272617922293B66756E6374696F6E206628762C70297B28703D3D6E756C6C7C7C703E762E6C656E67746829262628703D762E6C656E677468293B666F722876617220';
wwv_flow_imp.g_varchar2_table(167) := '673D302C6D3D6E65772041727261792870293B673C703B672B2B296D5B675D3D765B675D3B72657475726E206D7D6E28662C225F61727261794C696B65546F417272617922293B66756E6374696F6E207928297B7468726F77206E657720547970654572';
wwv_flow_imp.g_varchar2_table(168) := '726F722860496E76616C696420617474656D707420746F20737072656164206E6F6E2D6974657261626C6520696E7374616E63652E0A496E206F7264657220746F206265206974657261626C652C206E6F6E2D6172726179206F626A65637473206D7573';
wwv_flow_imp.g_varchar2_table(169) := '7420686176652061205B53796D626F6C2E6974657261746F725D2829206D6574686F642E60297D6E28792C225F6E6F6E4974657261626C6553707265616422293B76617220623D747970656F662077696E646F773C2275222626747970656F662077696E';
wwv_flow_imp.g_varchar2_table(170) := '646F772E646F63756D656E743C2275222C533D623F77696E646F773A7B7D2C453D622626532E646F63756D656E742E646F63756D656E74456C656D656E743F226F6E746F756368737461727422696E20532E646F63756D656E742E646F63756D656E7445';
wwv_flow_imp.g_varchar2_table(171) := '6C656D656E743A21312C463D623F22506F696E7465724576656E7422696E20533A21312C783D2263726F70706572222C553D22616C6C222C6A3D2263726F70222C473D226D6F7665222C4A3D227A6F6F6D222C423D2265222C7A3D2277222C4B3D227322';
wwv_flow_imp.g_varchar2_table(172) := '2C6F653D226E222C42653D226E65222C4A653D226E77222C77743D227365222C47653D227377222C5F653D22222E636F6E63617428782C222D63726F7022292C7A653D22222E636F6E63617428782C222D64697361626C656422292C46653D22222E636F';
wwv_flow_imp.g_varchar2_table(173) := '6E63617428782C222D68696464656E22292C68693D22222E636F6E63617428782C222D6869646522292C563D22222E636F6E63617428782C222D696E76697369626C6522292C523D22222E636F6E63617428782C222D6D6F64616C22292C493D22222E63';
wwv_flow_imp.g_varchar2_table(174) := '6F6E63617428782C222D6D6F766522292C4C3D22222E636F6E63617428782C22416374696F6E22292C513D22222E636F6E63617428782C225072657669657722292C583D2263726F70222C79653D226D6F7665222C70653D226E6F6E65222C6E653D2263';
wwv_flow_imp.g_varchar2_table(175) := '726F70222C72653D2263726F70656E64222C78653D2263726F706D6F7665222C45653D2263726F707374617274222C45743D2264626C636C69636B222C43743D453F22746F7563687374617274223A226D6F757365646F776E222C74653D453F22746F75';
wwv_flow_imp.g_varchar2_table(176) := '63686D6F7665223A226D6F7573656D6F7665222C4F743D453F22746F756368656E6420746F75636863616E63656C223A226D6F7573657570222C4B653D463F22706F696E746572646F776E223A43742C6C723D463F22706F696E7465726D6F7665223A74';
wwv_flow_imp.g_varchar2_table(177) := '652C536F3D463F22706F696E746572757020706F696E74657263616E63656C223A4F742C6A723D227265616479222C48723D22726573697A65222C24723D22776865656C222C75723D227A6F6F6D222C68723D22696D6167652F6A706567222C6F743D2F';
wwv_flow_imp.g_varchar2_table(178) := '5E657C777C737C6E7C73657C73777C6E657C6E777C616C6C7C63726F707C6D6F76657C7A6F6F6D242F2C6E743D2F5E646174613A2F2C626C3D2F5E646174613A696D6167655C2F6A7065673B6261736536342C2F2C776C3D2F5E696D677C63616E766173';
wwv_flow_imp.g_varchar2_table(179) := '242F692C6E6E3D7B766965774D6F64653A302C647261674D6F64653A582C696E697469616C417370656374526174696F3A4E614E2C617370656374526174696F3A4E614E2C646174613A6E756C6C2C707265766965773A22222C726573706F6E73697665';
wwv_flow_imp.g_varchar2_table(180) := '3A21302C726573746F72653A21302C636865636B43726F73734F726967696E3A21302C636865636B4F7269656E746174696F6E3A21302C6D6F64616C3A21302C6775696465733A21302C63656E7465723A21302C686967686C696768743A21302C626163';
wwv_flow_imp.g_varchar2_table(181) := '6B67726F756E643A21302C6175746F43726F703A21302C6175746F43726F70417265613A2E382C6D6F7661626C653A21302C726F74617461626C653A21302C7363616C61626C653A21302C7A6F6F6D61626C653A21302C7A6F6F6D4F6E546F7563683A21';
wwv_flow_imp.g_varchar2_table(182) := '302C7A6F6F6D4F6E576865656C3A21302C776865656C5A6F6F6D526174696F3A2E312C63726F70426F784D6F7661626C653A21302C63726F70426F78526573697A61626C653A21302C746F67676C65447261674D6F64654F6E44626C636C69636B3A2130';
wwv_flow_imp.g_varchar2_table(183) := '2C6D696E43616E76617357696474683A302C6D696E43616E7661734865696768743A302C6D696E43726F70426F7857696474683A302C6D696E43726F70426F784865696768743A302C6D696E436F6E7461696E657257696474683A3230302C6D696E436F';
wwv_flow_imp.g_varchar2_table(184) := '6E7461696E65724865696768743A3130302C72656164793A6E756C6C2C63726F7073746172743A6E756C6C2C63726F706D6F76653A6E756C6C2C63726F70656E643A6E756C6C2C63726F703A6E756C6C2C7A6F6F6D3A6E756C6C7D2C536C3D273C646976';
wwv_flow_imp.g_varchar2_table(185) := '20636C6173733D2263726F707065722D636F6E7461696E65722220746F7563682D616374696F6E3D226E6F6E65223E3C64697620636C6173733D2263726F707065722D777261702D626F78223E3C64697620636C6173733D2263726F707065722D63616E';
wwv_flow_imp.g_varchar2_table(186) := '766173223E3C2F6469763E3C2F6469763E3C64697620636C6173733D2263726F707065722D647261672D626F78223E3C2F6469763E3C64697620636C6173733D2263726F707065722D63726F702D626F78223E3C7370616E20636C6173733D2263726F70';
wwv_flow_imp.g_varchar2_table(187) := '7065722D766965772D626F78223E3C2F7370616E3E3C7370616E20636C6173733D2263726F707065722D646173686564206461736865642D68223E3C2F7370616E3E3C7370616E20636C6173733D2263726F707065722D64617368656420646173686564';
wwv_flow_imp.g_varchar2_table(188) := '2D76223E3C2F7370616E3E3C7370616E20636C6173733D2263726F707065722D63656E746572223E3C2F7370616E3E3C7370616E20636C6173733D2263726F707065722D66616365223E3C2F7370616E3E3C7370616E20636C6173733D2263726F707065';
wwv_flow_imp.g_varchar2_table(189) := '722D6C696E65206C696E652D652220646174612D63726F707065722D616374696F6E3D2265223E3C2F7370616E3E3C7370616E20636C6173733D2263726F707065722D6C696E65206C696E652D6E2220646174612D63726F707065722D616374696F6E3D';
wwv_flow_imp.g_varchar2_table(190) := '226E223E3C2F7370616E3E3C7370616E20636C6173733D2263726F707065722D6C696E65206C696E652D772220646174612D63726F707065722D616374696F6E3D2277223E3C2F7370616E3E3C7370616E20636C6173733D2263726F707065722D6C696E';
wwv_flow_imp.g_varchar2_table(191) := '65206C696E652D732220646174612D63726F707065722D616374696F6E3D2273223E3C2F7370616E3E3C7370616E20636C6173733D2263726F707065722D706F696E7420706F696E742D652220646174612D63726F707065722D616374696F6E3D226522';
wwv_flow_imp.g_varchar2_table(192) := '3E3C2F7370616E3E3C7370616E20636C6173733D2263726F707065722D706F696E7420706F696E742D6E2220646174612D63726F707065722D616374696F6E3D226E223E3C2F7370616E3E3C7370616E20636C6173733D2263726F707065722D706F696E';
wwv_flow_imp.g_varchar2_table(193) := '7420706F696E742D772220646174612D63726F707065722D616374696F6E3D2277223E3C2F7370616E3E3C7370616E20636C6173733D2263726F707065722D706F696E7420706F696E742D732220646174612D63726F707065722D616374696F6E3D2273';
wwv_flow_imp.g_varchar2_table(194) := '223E3C2F7370616E3E3C7370616E20636C6173733D2263726F707065722D706F696E7420706F696E742D6E652220646174612D63726F707065722D616374696F6E3D226E65223E3C2F7370616E3E3C7370616E20636C6173733D2263726F707065722D70';
wwv_flow_imp.g_varchar2_table(195) := '6F696E7420706F696E742D6E772220646174612D63726F707065722D616374696F6E3D226E77223E3C2F7370616E3E3C7370616E20636C6173733D2263726F707065722D706F696E7420706F696E742D73772220646174612D63726F707065722D616374';
wwv_flow_imp.g_varchar2_table(196) := '696F6E3D227377223E3C2F7370616E3E3C7370616E20636C6173733D2263726F707065722D706F696E7420706F696E742D73652220646174612D63726F707065722D616374696F6E3D227365223E3C2F7370616E3E3C2F6469763E3C2F6469763E272C50';
wwv_flow_imp.g_varchar2_table(197) := '6C3D4E756D6265722E69734E614E7C7C532E69734E614E3B66756E6374696F6E2069652876297B72657475726E20747970656F6620763D3D226E756D62657222262621506C2876297D6E2869652C2269734E756D62657222293B76617220616E3D6E2866';
wwv_flow_imp.g_varchar2_table(198) := '756E6374696F6E2870297B72657475726E20703E302626703C312F307D2C226973506F7369746976654E756D62657222293B66756E6374696F6E20506F2876297B72657475726E20747970656F6620763E2275227D6E28506F2C226973556E646566696E';
wwv_flow_imp.g_varchar2_table(199) := '656422293B66756E6374696F6E204D692876297B72657475726E20692876293D3D3D226F626A65637422262676213D3D6E756C6C7D6E284D692C2269734F626A65637422293B7661722064683D4F626A6563742E70726F746F747970652E6861734F776E';
wwv_flow_imp.g_varchar2_table(200) := '50726F70657274793B66756E6374696F6E2071722876297B696628214D692876292972657475726E21313B7472797B76617220703D762E636F6E7374727563746F722C673D702E70726F746F747970653B72657475726E2070262667262664682E63616C';
wwv_flow_imp.g_varchar2_table(201) := '6C28672C22697350726F746F747970654F6622297D63617463687B72657475726E21317D7D6E2871722C226973506C61696E4F626A65637422293B66756E6374696F6E2053742876297B72657475726E20747970656F6620763D3D2266756E6374696F6E';
wwv_flow_imp.g_varchar2_table(202) := '227D6E2853742C22697346756E6374696F6E22293B7661722063683D41727261792E70726F746F747970652E736C6963653B66756E6374696F6E205F6F2876297B72657475726E2041727261792E66726F6D3F41727261792E66726F6D2876293A63682E';
wwv_flow_imp.g_varchar2_table(203) := '63616C6C2876297D6E285F6F2C22746F417272617922293B66756E6374696F6E20416528762C70297B72657475726E20762626537428702926262841727261792E697341727261792876297C7C696528762E6C656E677468293F5F6F2876292E666F7245';
wwv_flow_imp.g_varchar2_table(204) := '6163682866756E6374696F6E28672C6D297B702E63616C6C28762C672C6D2C76297D293A4D6928762926264F626A6563742E6B6579732876292E666F72456163682866756E6374696F6E2867297B702E63616C6C28762C765B675D2C672C76297D29292C';
wwv_flow_imp.g_varchar2_table(205) := '767D6E2841652C22666F724561636822293B7661722053653D4F626A6563742E61737369676E7C7C6E2866756E6374696F6E2870297B666F722876617220673D617267756D656E74732E6C656E6774682C6D3D6E657720417272617928673E313F672D31';
wwv_flow_imp.g_varchar2_table(206) := '3A30292C503D313B503C673B502B2B296D5B502D315D3D617267756D656E74735B505D3B72657475726E204D6928702926266D2E6C656E6774683E3026266D2E666F72456163682866756E6374696F6E2877297B4D6928772926264F626A6563742E6B65';
wwv_flow_imp.g_varchar2_table(207) := '79732877292E666F72456163682866756E6374696F6E285F297B705B5F5D3D775B5F5D7D297D292C707D2C2261737369676E22292C6C6E3D2F5C2E5C642A283F3A307C39297B31327D5C642A242F3B66756E6374696F6E204E692876297B76617220703D';
wwv_flow_imp.g_varchar2_table(208) := '617267756D656E74732E6C656E6774683E312626617267756D656E74735B315D213D3D766F696420303F617267756D656E74735B315D3A316531313B72657475726E206C6E2E746573742876293F4D6174682E726F756E6428762A70292F703A767D6E28';
wwv_flow_imp.g_varchar2_table(209) := '4E692C226E6F726D616C697A65446563696D616C4E756D62657222293B766172205F6C3D2F5E77696474687C6865696768747C6C6566747C746F707C6D617267696E4C6566747C6D617267696E546F70242F3B66756E6374696F6E20626928762C70297B';
wwv_flow_imp.g_varchar2_table(210) := '76617220673D762E7374796C653B416528702C66756E6374696F6E286D2C50297B5F6C2E7465737428502926266965286D292626286D3D22222E636F6E636174286D2C2270782229292C675B505D3D6D7D297D6E2862692C227365745374796C6522293B';
wwv_flow_imp.g_varchar2_table(211) := '66756E6374696F6E20466C28762C70297B72657475726E20762E636C6173734C6973743F762E636C6173734C6973742E636F6E7461696E732870293A762E636C6173734E616D652E696E6465784F662870293E2D317D6E28466C2C22686173436C617373';
wwv_flow_imp.g_varchar2_table(212) := '22293B66756E6374696F6E206A6528762C70297B69662870297B696628696528762E6C656E67746829297B416528762C66756E6374696F6E286D297B6A65286D2C70297D293B72657475726E7D696628762E636C6173734C697374297B762E636C617373';
wwv_flow_imp.g_varchar2_table(213) := '4C6973742E6164642870293B72657475726E7D76617220673D762E636C6173734E616D652E7472696D28293B673F672E696E6465784F662870293C30262628762E636C6173734E616D653D22222E636F6E63617428672C222022292E636F6E6361742870';
wwv_flow_imp.g_varchar2_table(214) := '29293A762E636C6173734E616D653D707D7D6E286A652C22616464436C61737322293B66756E6374696F6E20776928762C70297B69662870297B696628696528762E6C656E67746829297B416528762C66756E6374696F6E2867297B776928672C70297D';
wwv_flow_imp.g_varchar2_table(215) := '293B72657475726E7D696628762E636C6173734C697374297B762E636C6173734C6973742E72656D6F76652870293B72657475726E7D762E636C6173734E616D652E696E6465784F662870293E3D30262628762E636C6173734E616D653D762E636C6173';
wwv_flow_imp.g_varchar2_table(216) := '734E616D652E7265706C61636528702C222229297D7D6E2877692C2272656D6F7665436C61737322293B66756E6374696F6E20567228762C702C67297B69662870297B696628696528762E6C656E67746829297B416528762C66756E6374696F6E286D29';
wwv_flow_imp.g_varchar2_table(217) := '7B5672286D2C702C67297D293B72657475726E7D673F6A6528762C70293A776928762C70297D7D6E2856722C22746F67676C65436C61737322293B7661722077623D2F285B612D7A5C645D29285B412D5A5D292F673B66756E6374696F6E207068287629';
wwv_flow_imp.g_varchar2_table(218) := '7B72657475726E20762E7265706C6163652877622C2224312D243222292E746F4C6F7765724361736528297D6E2870682C22746F506172616D4361736522293B66756E6374696F6E20666828762C70297B72657475726E204D6928765B705D293F765B70';
wwv_flow_imp.g_varchar2_table(219) := '5D3A762E646174617365743F762E646174617365745B705D3A762E6765744174747269627574652822646174612D222E636F6E63617428706828702929297D6E2866682C226765744461746122293B66756E6374696F6E20756E28762C702C67297B4D69';
wwv_flow_imp.g_varchar2_table(220) := '2867293F765B705D3D673A762E646174617365743F762E646174617365745B705D3D673A762E7365744174747269627574652822646174612D222E636F6E636174287068287029292C67297D6E28756E2C227365744461746122293B66756E6374696F6E';
wwv_flow_imp.g_varchar2_table(221) := '20536228762C70297B6966284D6928765B705D29297472797B64656C65746520765B705D7D63617463687B765B705D3D766F696420307D656C736520696628762E64617461736574297472797B64656C65746520762E646174617365745B705D7D636174';
wwv_flow_imp.g_varchar2_table(222) := '63687B762E646174617365745B705D3D766F696420307D656C736520762E72656D6F76654174747269627574652822646174612D222E636F6E63617428706828702929297D6E2853622C2272656D6F76654461746122293B7661722057703D2F5C735C73';
wwv_flow_imp.g_varchar2_table(223) := '2A2F2C47703D66756E6374696F6E28297B76617220763D21313B69662862297B76617220703D21312C673D6E2866756E6374696F6E28297B7D2C226C697374656E657222292C6D3D4F626A6563742E646566696E6550726F7065727479287B7D2C226F6E';
wwv_flow_imp.g_varchar2_table(224) := '6365222C7B6765743A6E2866756E6374696F6E28297B72657475726E20763D21302C707D2C2267657422292C7365743A6E2866756E6374696F6E2877297B703D777D2C2273657422297D293B532E6164644576656E744C697374656E6572282274657374';
wwv_flow_imp.g_varchar2_table(225) := '222C672C6D292C532E72656D6F76654576656E744C697374656E6572282274657374222C672C6D297D72657475726E20767D28293B66756E6374696F6E20536928762C702C67297B766172206D3D617267756D656E74732E6C656E6774683E3326266172';
wwv_flow_imp.g_varchar2_table(226) := '67756D656E74735B335D213D3D766F696420303F617267756D656E74735B335D3A7B7D2C503D673B702E7472696D28292E73706C6974285770292E666F72456163682866756E6374696F6E2877297B696628214770297B766172205F3D762E6C69737465';
wwv_flow_imp.g_varchar2_table(227) := '6E6572733B5F26265F5B775D26265F5B775D5B675D262628503D5F5B775D5B675D2C64656C657465205F5B775D5B675D2C4F626A6563742E6B657973285F5B775D292E6C656E6774683D3D3D30262664656C657465205F5B775D2C4F626A6563742E6B65';
wwv_flow_imp.g_varchar2_table(228) := '7973285F292E6C656E6774683D3D3D30262664656C65746520762E6C697374656E657273297D762E72656D6F76654576656E744C697374656E657228772C502C6D297D297D6E2853692C2272656D6F76654C697374656E657222293B66756E6374696F6E';
wwv_flow_imp.g_varchar2_table(229) := '20646928762C702C67297B766172206D3D617267756D656E74732E6C656E6774683E332626617267756D656E74735B335D213D3D766F696420303F617267756D656E74735B335D3A7B7D2C503D673B702E7472696D28292E73706C6974285770292E666F';
wwv_flow_imp.g_varchar2_table(230) := '72456163682866756E6374696F6E2877297B6966286D2E6F6E63652626214770297B766172205F3D762E6C697374656E6572732C433D5F3D3D3D766F696420303F7B7D3A5F3B503D6E2866756E6374696F6E28297B64656C65746520435B775D5B675D2C';
wwv_flow_imp.g_varchar2_table(231) := '762E72656D6F76654576656E744C697374656E657228772C502C6D293B666F722876617220413D617267756D656E74732E6C656E6774682C543D6E65772041727261792841292C4F3D303B4F3C413B4F2B2B29545B4F5D3D617267756D656E74735B4F5D';
wwv_flow_imp.g_varchar2_table(232) := '3B672E6170706C7928762C54297D2C2268616E646C657222292C435B775D7C7C28435B775D3D7B7D292C435B775D5B675D2626762E72656D6F76654576656E744C697374656E657228772C435B775D5B675D2C6D292C435B775D5B675D3D502C762E6C69';
wwv_flow_imp.g_varchar2_table(233) := '7374656E6572733D437D762E6164644576656E744C697374656E657228772C502C6D297D297D6E2864692C226164644C697374656E657222293B66756E6374696F6E20466F28762C702C67297B766172206D3B72657475726E205374284576656E742926';
wwv_flow_imp.g_varchar2_table(234) := '26537428437573746F6D4576656E74293F6D3D6E657720437573746F6D4576656E7428702C7B64657461696C3A672C627562626C65733A21302C63616E63656C61626C653A21307D293A286D3D646F63756D656E742E6372656174654576656E74282243';
wwv_flow_imp.g_varchar2_table(235) := '7573746F6D4576656E7422292C6D2E696E6974437573746F6D4576656E7428702C21302C21302C6729292C762E64697370617463684576656E74286D297D6E28466F2C2264697370617463684576656E7422293B66756E6374696F6E204B702876297B76';
wwv_flow_imp.g_varchar2_table(236) := '617220703D762E676574426F756E64696E67436C69656E745265637428293B72657475726E7B6C6566743A702E6C6566742B2877696E646F772E70616765584F66667365742D646F63756D656E742E646F63756D656E74456C656D656E742E636C69656E';
wwv_flow_imp.g_varchar2_table(237) := '744C656674292C746F703A702E746F702B2877696E646F772E70616765594F66667365742D646F63756D656E742E646F63756D656E74456C656D656E742E636C69656E74546F70297D7D6E284B702C226765744F666673657422293B766172206D683D53';
wwv_flow_imp.g_varchar2_table(238) := '2E6C6F636174696F6E2C50623D2F5E285C772B3A295C2F5C2F285B5E3A2F3F235D2A293A3F285C642A292F693B66756E6374696F6E2058702876297B76617220703D762E6D61746368285062293B72657475726E2070213D3D6E756C6C262628705B315D';
wwv_flow_imp.g_varchar2_table(239) := '213D3D6D682E70726F746F636F6C7C7C705B325D213D3D6D682E686F73746E616D657C7C705B335D213D3D6D682E706F7274297D6E2858702C22697343726F73734F726967696E55524C22293B66756E6374696F6E2059702876297B76617220703D2274';
wwv_flow_imp.g_varchar2_table(240) := '696D657374616D703D222E636F6E636174286E6577204461746528292E67657454696D652829293B72657475726E20762B28762E696E6465784F6628223F22293D3D3D2D313F223F223A222622292B707D6E2859702C2261646454696D657374616D7022';
wwv_flow_imp.g_varchar2_table(241) := '293B66756E6374696F6E20686E2876297B76617220703D762E726F746174652C673D762E7363616C65582C6D3D762E7363616C65592C503D762E7472616E736C617465582C773D762E7472616E736C617465592C5F3D5B5D3B6965285029262650213D3D';
wwv_flow_imp.g_varchar2_table(242) := '3026265F2E7075736828227472616E736C6174655828222E636F6E63617428502C227078292229292C6965287729262677213D3D3026265F2E7075736828227472616E736C6174655928222E636F6E63617428772C227078292229292C69652870292626';
wwv_flow_imp.g_varchar2_table(243) := '70213D3D3026265F2E707573682822726F7461746528222E636F6E63617428702C22646567292229292C6965286729262667213D3D3126265F2E7075736828227363616C655828222E636F6E63617428672C22292229292C6965286D2926266D213D3D31';
wwv_flow_imp.g_varchar2_table(244) := '26265F2E7075736828227363616C655928222E636F6E636174286D2C22292229293B76617220433D5F2E6C656E6774683F5F2E6A6F696E28222022293A226E6F6E65223B72657475726E7B5765626B69745472616E73666F726D3A432C6D735472616E73';
wwv_flow_imp.g_varchar2_table(245) := '666F726D3A432C7472616E73666F726D3A437D7D6E28686E2C226765745472616E73666F726D7322293B66756E6374696F6E205F622876297B76617220703D61287B7D2C76292C673D5B5D3B72657475726E20416528762C66756E6374696F6E286D2C50';
wwv_flow_imp.g_varchar2_table(246) := '297B64656C65746520705B505D2C416528702C66756E6374696F6E2877297B766172205F3D4D6174682E616273286D2E7374617274582D772E737461727458292C433D4D6174682E616273286D2E7374617274592D772E737461727459292C443D4D6174';
wwv_flow_imp.g_varchar2_table(247) := '682E616273286D2E656E64582D772E656E6458292C413D4D6174682E616273286D2E656E64592D772E656E6459292C543D4D6174682E73717274285F2A5F2B432A43292C4F3D4D6174682E7371727428442A442B412A41292C6B3D284F2D54292F543B67';
wwv_flow_imp.g_varchar2_table(248) := '2E70757368286B297D297D292C672E736F72742866756E6374696F6E286D2C50297B72657475726E204D6174682E616273286D293C4D6174682E6162732850297D292C675B305D7D6E285F622C226765744D61785A6F6F6D526174696F22293B66756E63';
wwv_flow_imp.g_varchar2_table(249) := '74696F6E20786C28762C70297B76617220673D762E70616765582C6D3D762E70616765592C503D7B656E64583A672C656E64593A6D7D3B72657475726E20703F503A61287B7374617274583A672C7374617274593A6D7D2C50297D6E28786C2C22676574';
wwv_flow_imp.g_varchar2_table(250) := '506F696E74657222293B66756E6374696F6E2046622876297B76617220703D302C673D302C6D3D303B72657475726E20416528762C66756E6374696F6E2850297B76617220773D502E7374617274582C5F3D502E7374617274593B702B3D772C672B3D5F';
wwv_flow_imp.g_varchar2_table(251) := '2C6D2B3D317D292C702F3D6D2C672F3D6D2C7B70616765583A702C70616765593A677D7D6E2846622C22676574506F696E7465727343656E74657222293B66756E6374696F6E2057722876297B76617220703D762E617370656374526174696F2C673D76';
wwv_flow_imp.g_varchar2_table(252) := '2E6865696768742C6D3D762E77696474682C503D617267756D656E74732E6C656E6774683E312626617267756D656E74735B315D213D3D766F696420303F617267756D656E74735B315D3A22636F6E7461696E222C773D616E286D292C5F3D616E286729';
wwv_flow_imp.g_varchar2_table(253) := '3B6966287726265F297B76617220433D672A703B503D3D3D22636F6E7461696E222626433E6D7C7C503D3D3D22636F766572222626433C6D3F673D6D2F703A6D3D672A707D656C736520773F673D6D2F703A5F2626286D3D672A70293B72657475726E7B';
wwv_flow_imp.g_varchar2_table(254) := '77696474683A6D2C6865696768743A677D7D6E2857722C2267657441646A757374656453697A657322293B66756E6374696F6E2078622876297B76617220703D762E77696474682C673D762E6865696768742C6D3D762E6465677265653B6966286D3D4D';
wwv_flow_imp.g_varchar2_table(255) := '6174682E616273286D29253138302C6D3D3D3D39302972657475726E7B77696474683A672C6865696768743A707D3B76617220503D6D2539302A4D6174682E50492F3138302C773D4D6174682E73696E2850292C5F3D4D6174682E636F732850292C433D';
wwv_flow_imp.g_varchar2_table(256) := '702A5F2B672A772C443D702A772B672A5F3B72657475726E206D3E39303F7B77696474683A442C6865696768743A437D3A7B77696474683A432C6865696768743A447D7D6E2878622C22676574526F746174656453697A657322293B66756E6374696F6E';
wwv_flow_imp.g_varchar2_table(257) := '20456228762C702C672C6D297B76617220503D702E617370656374526174696F2C773D702E6E61747572616C57696474682C5F3D702E6E61747572616C4865696768742C433D702E726F746174652C443D433D3D3D766F696420303F303A432C413D702E';
wwv_flow_imp.g_varchar2_table(258) := '7363616C65582C543D413D3D3D766F696420303F313A412C4F3D702E7363616C65592C6B3D4F3D3D3D766F696420303F313A4F2C75653D672E617370656374526174696F2C6C653D672E6E61747572616C57696474682C4F653D672E6E61747572616C48';
wwv_flow_imp.g_varchar2_table(259) := '65696768742C66653D6D2E66696C6C436F6C6F722C5A653D66653D3D3D766F696420303F227472616E73706172656E74223A66652C61743D6D2E696D616765536D6F6F7468696E67456E61626C65642C58653D61743D3D3D766F696420303F21303A6174';
wwv_flow_imp.g_varchar2_table(260) := '2C64723D6D2E696D616765536D6F6F7468696E675175616C6974792C47743D64723D3D3D766F696420303F226C6F77223A64722C4E3D6D2E6D617857696474682C6D653D4E3D3D3D766F696420303F312F303A4E2C65743D6D2E6D61784865696768742C';
wwv_flow_imp.g_varchar2_table(261) := '63693D65743D3D3D766F696420303F312F303A65742C63723D6D2E6D696E57696474682C63733D63723D3D3D766F696420303F303A63722C70733D6D2E6D696E4865696768742C47723D70733D3D3D766F696420303F303A70732C4C693D646F63756D65';
wwv_flow_imp.g_varchar2_table(262) := '6E742E637265617465456C656D656E74282263616E76617322292C6A743D4C692E676574436F6E746578742822326422292C66733D5772287B617370656374526174696F3A75652C77696474683A6D652C6865696768743A63697D292C456C3D5772287B';
wwv_flow_imp.g_varchar2_table(263) := '617370656374526174696F3A75652C77696474683A63732C6865696768743A47727D2C22636F76657222292C67683D4D6174682E6D696E2866732E77696474682C4D6174682E6D617828456C2E77696474682C6C6529292C79683D4D6174682E6D696E28';
wwv_flow_imp.g_varchar2_table(264) := '66732E6865696768742C4D6174682E6D617828456C2E6865696768742C4F6529292C5A703D5772287B617370656374526174696F3A502C77696474683A6D652C6865696768743A63697D292C65663D5772287B617370656374526174696F3A502C776964';
wwv_flow_imp.g_varchar2_table(265) := '74683A63732C6865696768743A47727D2C22636F76657222292C74663D4D6174682E6D696E285A702E77696474682C4D6174682E6D61782865662E77696474682C7729292C72663D4D6174682E6D696E285A702E6865696768742C4D6174682E6D617828';
wwv_flow_imp.g_varchar2_table(266) := '65662E6865696768742C5F29292C7A623D5B2D74662F322C2D72662F322C74662C72665D3B72657475726E204C692E77696474683D4E69286768292C4C692E6865696768743D4E69287968292C6A742E66696C6C5374796C653D5A652C6A742E66696C6C';
wwv_flow_imp.g_varchar2_table(267) := '5265637428302C302C67682C7968292C6A742E7361766528292C6A742E7472616E736C6174652867682F322C79682F32292C6A742E726F7461746528442A4D6174682E50492F313830292C6A742E7363616C6528542C6B292C6A742E696D616765536D6F';
wwv_flow_imp.g_varchar2_table(268) := '6F7468696E67456E61626C65643D58652C6A742E696D616765536D6F6F7468696E675175616C6974793D47742C6A742E64726177496D6167652E6170706C79286A742C5B765D2E636F6E636174286C287A622E6D61702866756E6374696F6E286A62297B';
wwv_flow_imp.g_varchar2_table(269) := '72657475726E204D6174682E666C6F6F72284E69286A6229297D292929292C6A742E726573746F726528292C4C697D6E2845622C22676574536F7572636543616E76617322293B7661722051703D537472696E672E66726F6D43686172436F64653B6675';
wwv_flow_imp.g_varchar2_table(270) := '6E6374696F6E20436228762C702C67297B766172206D3D22223B672B3D703B666F722876617220503D703B503C673B502B3D31296D2B3D517028762E67657455696E7438285029293B72657475726E206D7D6E2843622C22676574537472696E6746726F';
wwv_flow_imp.g_varchar2_table(271) := '6D43686172436F646522293B766172204F623D2F5E646174613A2E2A2C2F3B66756E6374696F6E2054622876297B76617220703D762E7265706C616365284F622C2222292C673D61746F622870292C6D3D6E657720417272617942756666657228672E6C';
wwv_flow_imp.g_varchar2_table(272) := '656E677468292C503D6E65772055696E74384172726179286D293B72657475726E20416528502C66756E6374696F6E28772C5F297B505B5F5D3D672E63686172436F64654174285F297D292C6D7D6E2854622C226461746155524C546F41727261794275';
wwv_flow_imp.g_varchar2_table(273) := '6666657222293B66756E6374696F6E20416228762C70297B666F722876617220673D5B5D2C6D3D383139322C503D6E65772055696E743841727261792876293B502E6C656E6774683E303B29672E707573682851702E6170706C79286E756C6C2C5F6F28';
wwv_flow_imp.g_varchar2_table(274) := '502E737562617272617928302C6D292929292C503D502E7375626172726179286D293B72657475726E22646174613A222E636F6E63617428702C223B6261736536342C22292E636F6E6361742862746F6128672E6A6F696E2822222929297D6E2841622C';
wwv_flow_imp.g_varchar2_table(275) := '226172726179427566666572546F4461746155524C22293B66756E6374696F6E2052622876297B76617220703D6E65772044617461566965772876292C673B7472797B766172206D2C502C773B696628702E67657455696E74382830293D3D3D32353526';
wwv_flow_imp.g_varchar2_table(276) := '26702E67657455696E74382831293D3D3D32313629666F7228766172205F3D702E627974654C656E6774682C433D323B432B313C5F3B297B696628702E67657455696E74382843293D3D3D3235352626702E67657455696E743828432B31293D3D3D3232';
wwv_flow_imp.g_varchar2_table(277) := '35297B503D433B627265616B7D432B3D317D69662850297B76617220443D502B342C413D502B31303B696628436228702C442C34293D3D3D224578696622297B76617220543D702E67657455696E7431362841293B6966286D3D543D3D3D31383736312C';
wwv_flow_imp.g_varchar2_table(278) := '286D7C7C543D3D3D3139373839292626702E67657455696E74313628412B322C6D293D3D3D3432297B766172204F3D702E67657455696E74333228412B342C6D293B4F3E3D38262628773D412B4F297D7D7D69662877297B766172206B3D702E67657455';
wwv_flow_imp.g_varchar2_table(279) := '696E74313628772C6D292C75652C6C653B666F72286C653D303B6C653C6B3B6C652B3D312969662875653D772B6C652A31322B322C702E67657455696E7431362875652C6D293D3D3D323734297B75652B3D382C673D702E67657455696E743136287565';
wwv_flow_imp.g_varchar2_table(280) := '2C6D292C702E73657455696E7431362875652C312C6D293B627265616B7D7D7D63617463687B673D317D72657475726E20677D6E2852622C227265736574416E644765744F7269656E746174696F6E22293B66756E6374696F6E2055622876297B766172';
wwv_flow_imp.g_varchar2_table(281) := '20703D302C673D312C6D3D313B7377697463682876297B6361736520323A673D2D313B627265616B3B6361736520333A703D2D3138303B627265616B3B6361736520343A6D3D2D313B627265616B3B6361736520353A703D39302C6D3D2D313B62726561';
wwv_flow_imp.g_varchar2_table(282) := '6B3B6361736520363A703D39303B627265616B3B6361736520373A703D39302C673D2D313B627265616B3B6361736520383A703D2D39303B627265616B7D72657475726E7B726F746174653A702C7363616C65583A672C7363616C65593A6D7D7D6E2855';
wwv_flow_imp.g_varchar2_table(283) := '622C2270617273654F7269656E746174696F6E22293B766172206B623D7B72656E6465723A6E2866756E6374696F6E28297B746869732E696E6974436F6E7461696E657228292C746869732E696E697443616E76617328292C746869732E696E69744372';
wwv_flow_imp.g_varchar2_table(284) := '6F70426F7828292C746869732E72656E64657243616E76617328292C746869732E63726F707065642626746869732E72656E64657243726F70426F7828297D2C2272656E64657222292C696E6974436F6E7461696E65723A6E2866756E6374696F6E2829';
wwv_flow_imp.g_varchar2_table(285) := '7B76617220703D746869732E656C656D656E742C673D746869732E6F7074696F6E732C6D3D746869732E636F6E7461696E65722C503D746869732E63726F707065723B6A6528502C4665292C776928702C4665293B76617220773D7B77696474683A4D61';
wwv_flow_imp.g_varchar2_table(286) := '74682E6D6178286D2E6F666673657457696474682C4E756D62657228672E6D696E436F6E7461696E65725769647468297C7C323030292C6865696768743A4D6174682E6D6178286D2E6F66667365744865696768742C4E756D62657228672E6D696E436F';
wwv_flow_imp.g_varchar2_table(287) := '6E7461696E6572486569676874297C7C313030297D3B746869732E636F6E7461696E6572446174613D772C626928502C7B77696474683A772E77696474682C6865696768743A772E6865696768747D292C6A6528702C4665292C776928502C4665297D2C';
wwv_flow_imp.g_varchar2_table(288) := '22696E6974436F6E7461696E657222292C696E697443616E7661733A6E2866756E6374696F6E28297B76617220703D746869732E636F6E7461696E6572446174612C673D746869732E696D616765446174612C6D3D746869732E6F7074696F6E732E7669';
wwv_flow_imp.g_varchar2_table(289) := '65774D6F64652C503D4D6174682E61627328672E726F7461746529253138303D3D3D39302C773D503F672E6E61747572616C4865696768743A672E6E61747572616C57696474682C5F3D503F672E6E61747572616C57696474683A672E6E61747572616C';
wwv_flow_imp.g_varchar2_table(290) := '4865696768742C433D772F5F2C443D702E77696474682C413D702E6865696768743B702E6865696768742A433E702E77696474683F6D3D3D3D333F443D702E6865696768742A433A413D702E77696474682F433A6D3D3D3D333F413D702E77696474682F';
wwv_flow_imp.g_varchar2_table(291) := '433A443D702E6865696768742A433B76617220543D7B617370656374526174696F3A432C6E61747572616C57696474683A772C6E61747572616C4865696768743A5F2C77696474683A442C6865696768743A417D3B542E6C6566743D28702E7769647468';
wwv_flow_imp.g_varchar2_table(292) := '2D44292F322C542E746F703D28702E6865696768742D41292F322C542E6F6C644C6566743D542E6C6566742C542E6F6C64546F703D542E746F702C746869732E63616E766173446174613D542C746869732E6C696D697465643D6D3D3D3D317C7C6D3D3D';
wwv_flow_imp.g_varchar2_table(293) := '3D322C746869732E6C696D697443616E7661732821302C2130292C746869732E696E697469616C496D616765446174613D5365287B7D2C67292C746869732E696E697469616C43616E766173446174613D5365287B7D2C54297D2C22696E697443616E76';
wwv_flow_imp.g_varchar2_table(294) := '617322292C6C696D697443616E7661733A6E2866756E6374696F6E28702C67297B766172206D3D746869732E6F7074696F6E732C503D746869732E636F6E7461696E6572446174612C773D746869732E63616E766173446174612C5F3D746869732E6372';
wwv_flow_imp.g_varchar2_table(295) := '6F70426F78446174612C433D6D2E766965774D6F64652C443D772E617370656374526174696F2C413D746869732E63726F7070656426265F3B69662870297B76617220543D4E756D626572286D2E6D696E43616E7661735769647468297C7C302C4F3D4E';
wwv_flow_imp.g_varchar2_table(296) := '756D626572286D2E6D696E43616E766173486569676874297C7C303B433E313F28543D4D6174682E6D617828542C502E7769647468292C4F3D4D6174682E6D6178284F2C502E686569676874292C433D3D3D332626284F2A443E543F543D4F2A443A4F3D';
wwv_flow_imp.g_varchar2_table(297) := '542F4429293A433E30262628543F543D4D6174682E6D617828542C413F5F2E77696474683A30293A4F3F4F3D4D6174682E6D6178284F2C413F5F2E6865696768743A30293A41262628543D5F2E77696474682C4F3D5F2E6865696768742C4F2A443E543F';
wwv_flow_imp.g_varchar2_table(298) := '543D4F2A443A4F3D542F4429293B766172206B3D5772287B617370656374526174696F3A442C77696474683A542C6865696768743A4F7D293B543D6B2E77696474682C4F3D6B2E6865696768742C772E6D696E57696474683D542C772E6D696E48656967';
wwv_flow_imp.g_varchar2_table(299) := '68743D4F2C772E6D617857696474683D312F302C772E6D61784865696768743D312F307D6966286729696628433E28413F303A3129297B7661722075653D502E77696474682D772E77696474682C6C653D502E6865696768742D772E6865696768743B77';
wwv_flow_imp.g_varchar2_table(300) := '2E6D696E4C6566743D4D6174682E6D696E28302C7565292C772E6D696E546F703D4D6174682E6D696E28302C6C65292C772E6D61784C6566743D4D6174682E6D617828302C7565292C772E6D6178546F703D4D6174682E6D617828302C6C65292C412626';
wwv_flow_imp.g_varchar2_table(301) := '746869732E6C696D69746564262628772E6D696E4C6566743D4D6174682E6D696E285F2E6C6566742C5F2E6C6566742B285F2E77696474682D772E776964746829292C772E6D696E546F703D4D6174682E6D696E285F2E746F702C5F2E746F702B285F2E';
wwv_flow_imp.g_varchar2_table(302) := '6865696768742D772E68656967687429292C772E6D61784C6566743D5F2E6C6566742C772E6D6178546F703D5F2E746F702C433D3D3D32262628772E77696474683E3D502E7769647468262628772E6D696E4C6566743D4D6174682E6D696E28302C7565';
wwv_flow_imp.g_varchar2_table(303) := '292C772E6D61784C6566743D4D6174682E6D617828302C756529292C772E6865696768743E3D502E686569676874262628772E6D696E546F703D4D6174682E6D696E28302C6C65292C772E6D6178546F703D4D6174682E6D617828302C6C65292929297D';
wwv_flow_imp.g_varchar2_table(304) := '656C736520772E6D696E4C6566743D2D772E77696474682C772E6D696E546F703D2D772E6865696768742C772E6D61784C6566743D502E77696474682C772E6D6178546F703D502E6865696768747D2C226C696D697443616E76617322292C72656E6465';
wwv_flow_imp.g_varchar2_table(305) := '7243616E7661733A6E2866756E6374696F6E28702C67297B766172206D3D746869732E63616E766173446174612C503D746869732E696D616765446174613B69662867297B76617220773D7862287B77696474683A502E6E61747572616C57696474682A';
wwv_flow_imp.g_varchar2_table(306) := '4D6174682E61627328502E7363616C65587C7C31292C6865696768743A502E6E61747572616C4865696768742A4D6174682E61627328502E7363616C65597C7C31292C6465677265653A502E726F746174657C7C307D292C5F3D772E77696474682C433D';
wwv_flow_imp.g_varchar2_table(307) := '772E6865696768742C443D6D2E77696474682A285F2F6D2E6E61747572616C5769647468292C413D6D2E6865696768742A28432F6D2E6E61747572616C486569676874293B6D2E6C6566742D3D28442D6D2E7769647468292F322C6D2E746F702D3D2841';
wwv_flow_imp.g_varchar2_table(308) := '2D6D2E686569676874292F322C6D2E77696474683D442C6D2E6865696768743D412C6D2E617370656374526174696F3D5F2F432C6D2E6E61747572616C57696474683D5F2C6D2E6E61747572616C4865696768743D432C746869732E6C696D697443616E';
wwv_flow_imp.g_varchar2_table(309) := '7661732821302C2131297D286D2E77696474683E6D2E6D617857696474687C7C6D2E77696474683C6D2E6D696E5769647468292626286D2E6C6566743D6D2E6F6C644C656674292C286D2E6865696768743E6D2E6D61784865696768747C7C6D2E686569';
wwv_flow_imp.g_varchar2_table(310) := '6768743C6D2E6D696E486569676874292626286D2E746F703D6D2E6F6C64546F70292C6D2E77696474683D4D6174682E6D696E284D6174682E6D6178286D2E77696474682C6D2E6D696E5769647468292C6D2E6D61785769647468292C6D2E6865696768';
wwv_flow_imp.g_varchar2_table(311) := '743D4D6174682E6D696E284D6174682E6D6178286D2E6865696768742C6D2E6D696E486569676874292C6D2E6D6178486569676874292C746869732E6C696D697443616E7661732821312C2130292C6D2E6C6566743D4D6174682E6D696E284D6174682E';
wwv_flow_imp.g_varchar2_table(312) := '6D6178286D2E6C6566742C6D2E6D696E4C656674292C6D2E6D61784C656674292C6D2E746F703D4D6174682E6D696E284D6174682E6D6178286D2E746F702C6D2E6D696E546F70292C6D2E6D6178546F70292C6D2E6F6C644C6566743D6D2E6C6566742C';
wwv_flow_imp.g_varchar2_table(313) := '6D2E6F6C64546F703D6D2E746F702C626928746869732E63616E7661732C5365287B77696474683A6D2E77696474682C6865696768743A6D2E6865696768747D2C686E287B7472616E736C617465583A6D2E6C6566742C7472616E736C617465593A6D2E';
wwv_flow_imp.g_varchar2_table(314) := '746F707D2929292C746869732E72656E646572496D6167652870292C746869732E63726F707065642626746869732E6C696D697465642626746869732E6C696D697443726F70426F782821302C2130297D2C2272656E64657243616E76617322292C7265';
wwv_flow_imp.g_varchar2_table(315) := '6E646572496D6167653A6E2866756E6374696F6E2870297B76617220673D746869732E63616E766173446174612C6D3D746869732E696D616765446174612C503D6D2E6E61747572616C57696474682A28672E77696474682F672E6E61747572616C5769';
wwv_flow_imp.g_varchar2_table(316) := '647468292C773D6D2E6E61747572616C4865696768742A28672E6865696768742F672E6E61747572616C486569676874293B5365286D2C7B77696474683A502C6865696768743A772C6C6566743A28672E77696474682D50292F322C746F703A28672E68';
wwv_flow_imp.g_varchar2_table(317) := '65696768742D77292F327D292C626928746869732E696D6167652C5365287B77696474683A6D2E77696474682C6865696768743A6D2E6865696768747D2C686E285365287B7472616E736C617465583A6D2E6C6566742C7472616E736C617465593A6D2E';
wwv_flow_imp.g_varchar2_table(318) := '746F707D2C6D292929292C702626746869732E6F757470757428297D2C2272656E646572496D61676522292C696E697443726F70426F783A6E2866756E6374696F6E28297B76617220703D746869732E6F7074696F6E732C673D746869732E63616E7661';
wwv_flow_imp.g_varchar2_table(319) := '73446174612C6D3D702E617370656374526174696F7C7C702E696E697469616C417370656374526174696F2C503D4E756D62657228702E6175746F43726F7041726561297C7C2E382C773D7B77696474683A672E77696474682C6865696768743A672E68';
wwv_flow_imp.g_varchar2_table(320) := '65696768747D3B6D262628672E6865696768742A6D3E672E77696474683F772E6865696768743D772E77696474682F6D3A772E77696474683D772E6865696768742A6D292C746869732E63726F70426F78446174613D772C746869732E6C696D69744372';
wwv_flow_imp.g_varchar2_table(321) := '6F70426F782821302C2130292C772E77696474683D4D6174682E6D696E284D6174682E6D617828772E77696474682C772E6D696E5769647468292C772E6D61785769647468292C772E6865696768743D4D6174682E6D696E284D6174682E6D617828772E';
wwv_flow_imp.g_varchar2_table(322) := '6865696768742C772E6D696E486569676874292C772E6D6178486569676874292C772E77696474683D4D6174682E6D617828772E6D696E57696474682C772E77696474682A50292C772E6865696768743D4D6174682E6D617828772E6D696E4865696768';
wwv_flow_imp.g_varchar2_table(323) := '742C772E6865696768742A50292C772E6C6566743D672E6C6566742B28672E77696474682D772E7769647468292F322C772E746F703D672E746F702B28672E6865696768742D772E686569676874292F322C772E6F6C644C6566743D772E6C6566742C77';
wwv_flow_imp.g_varchar2_table(324) := '2E6F6C64546F703D772E746F702C746869732E696E697469616C43726F70426F78446174613D5365287B7D2C77297D2C22696E697443726F70426F7822292C6C696D697443726F70426F783A6E2866756E6374696F6E28702C67297B766172206D3D7468';
wwv_flow_imp.g_varchar2_table(325) := '69732E6F7074696F6E732C503D746869732E636F6E7461696E6572446174612C773D746869732E63616E766173446174612C5F3D746869732E63726F70426F78446174612C433D746869732E6C696D697465642C443D6D2E617370656374526174696F3B';
wwv_flow_imp.g_varchar2_table(326) := '69662870297B76617220413D4E756D626572286D2E6D696E43726F70426F785769647468297C7C302C543D4E756D626572286D2E6D696E43726F70426F78486569676874297C7C302C4F3D433F4D6174682E6D696E28502E77696474682C772E77696474';
wwv_flow_imp.g_varchar2_table(327) := '682C772E77696474682B772E6C6566742C502E77696474682D772E6C656674293A502E77696474682C6B3D433F4D6174682E6D696E28502E6865696768742C772E6865696768742C772E6865696768742B772E746F702C502E6865696768742D772E746F';
wwv_flow_imp.g_varchar2_table(328) := '70293A502E6865696768743B413D4D6174682E6D696E28412C502E7769647468292C543D4D6174682E6D696E28542C502E686569676874292C44262628412626543F542A443E413F543D412F443A413D542A443A413F543D412F443A54262628413D542A';
wwv_flow_imp.g_varchar2_table(329) := '44292C6B2A443E4F3F6B3D4F2F443A4F3D6B2A44292C5F2E6D696E57696474683D4D6174682E6D696E28412C4F292C5F2E6D696E4865696768743D4D6174682E6D696E28542C6B292C5F2E6D617857696474683D4F2C5F2E6D61784865696768743D6B7D';
wwv_flow_imp.g_varchar2_table(330) := '67262628433F285F2E6D696E4C6566743D4D6174682E6D617828302C772E6C656674292C5F2E6D696E546F703D4D6174682E6D617828302C772E746F70292C5F2E6D61784C6566743D4D6174682E6D696E28502E77696474682C772E6C6566742B772E77';
wwv_flow_imp.g_varchar2_table(331) := '69647468292D5F2E77696474682C5F2E6D6178546F703D4D6174682E6D696E28502E6865696768742C772E746F702B772E686569676874292D5F2E686569676874293A285F2E6D696E4C6566743D302C5F2E6D696E546F703D302C5F2E6D61784C656674';
wwv_flow_imp.g_varchar2_table(332) := '3D502E77696474682D5F2E77696474682C5F2E6D6178546F703D502E6865696768742D5F2E68656967687429297D2C226C696D697443726F70426F7822292C72656E64657243726F70426F783A6E2866756E6374696F6E28297B76617220703D74686973';
wwv_flow_imp.g_varchar2_table(333) := '2E6F7074696F6E732C673D746869732E636F6E7461696E6572446174612C6D3D746869732E63726F70426F78446174613B286D2E77696474683E6D2E6D617857696474687C7C6D2E77696474683C6D2E6D696E5769647468292626286D2E6C6566743D6D';
wwv_flow_imp.g_varchar2_table(334) := '2E6F6C644C656674292C286D2E6865696768743E6D2E6D61784865696768747C7C6D2E6865696768743C6D2E6D696E486569676874292626286D2E746F703D6D2E6F6C64546F70292C6D2E77696474683D4D6174682E6D696E284D6174682E6D6178286D';
wwv_flow_imp.g_varchar2_table(335) := '2E77696474682C6D2E6D696E5769647468292C6D2E6D61785769647468292C6D2E6865696768743D4D6174682E6D696E284D6174682E6D6178286D2E6865696768742C6D2E6D696E486569676874292C6D2E6D6178486569676874292C746869732E6C69';
wwv_flow_imp.g_varchar2_table(336) := '6D697443726F70426F782821312C2130292C6D2E6C6566743D4D6174682E6D696E284D6174682E6D6178286D2E6C6566742C6D2E6D696E4C656674292C6D2E6D61784C656674292C6D2E746F703D4D6174682E6D696E284D6174682E6D6178286D2E746F';
wwv_flow_imp.g_varchar2_table(337) := '702C6D2E6D696E546F70292C6D2E6D6178546F70292C6D2E6F6C644C6566743D6D2E6C6566742C6D2E6F6C64546F703D6D2E746F702C702E6D6F7661626C652626702E63726F70426F784D6F7661626C652626756E28746869732E666163652C4C2C6D2E';
wwv_flow_imp.g_varchar2_table(338) := '77696474683E3D672E776964746826266D2E6865696768743E3D672E6865696768743F473A55292C626928746869732E63726F70426F782C5365287B77696474683A6D2E77696474682C6865696768743A6D2E6865696768747D2C686E287B7472616E73';
wwv_flow_imp.g_varchar2_table(339) := '6C617465583A6D2E6C6566742C7472616E736C617465593A6D2E746F707D2929292C746869732E63726F707065642626746869732E6C696D697465642626746869732E6C696D697443616E7661732821302C2130292C746869732E64697361626C65647C';
wwv_flow_imp.g_varchar2_table(340) := '7C746869732E6F757470757428297D2C2272656E64657243726F70426F7822292C6F75747075743A6E2866756E6374696F6E28297B746869732E7072657669657728292C466F28746869732E656C656D656E742C6E652C746869732E6765744461746128';
wwv_flow_imp.g_varchar2_table(341) := '29297D2C226F757470757422297D2C44623D7B696E6974507265766965773A6E2866756E6374696F6E28297B76617220703D746869732E656C656D656E742C673D746869732E63726F73734F726967696E2C6D3D746869732E6F7074696F6E732E707265';
wwv_flow_imp.g_varchar2_table(342) := '766965772C503D673F746869732E63726F73734F726967696E55726C3A746869732E75726C2C773D702E616C747C7C2254686520696D61676520746F2070726576696577222C5F3D646F63756D656E742E637265617465456C656D656E742822696D6722';
wwv_flow_imp.g_varchar2_table(343) := '293B696628672626285F2E63726F73734F726967696E3D67292C5F2E7372633D502C5F2E616C743D772C746869732E76696577426F782E617070656E644368696C64285F292C746869732E76696577426F78496D6167653D5F2C21216D297B7661722043';
wwv_flow_imp.g_varchar2_table(344) := '3D6D3B747970656F66206D3D3D22737472696E67223F433D702E6F776E6572446F63756D656E742E717565727953656C6563746F72416C6C286D293A6D2E717565727953656C6563746F72262628433D5B6D5D292C746869732E70726576696577733D43';
wwv_flow_imp.g_varchar2_table(345) := '2C416528432C66756E6374696F6E2844297B76617220413D646F63756D656E742E637265617465456C656D656E742822696D6722293B756E28442C512C7B77696474683A442E6F666673657457696474682C6865696768743A442E6F6666736574486569';
wwv_flow_imp.g_varchar2_table(346) := '6768742C68746D6C3A442E696E6E657248544D4C7D292C67262628412E63726F73734F726967696E3D67292C412E7372633D502C412E616C743D772C412E7374796C652E637373546578743D27646973706C61793A626C6F636B3B77696474683A313030';
wwv_flow_imp.g_varchar2_table(347) := '253B6865696768743A6175746F3B6D696E2D77696474683A3021696D706F7274616E743B6D696E2D6865696768743A3021696D706F7274616E743B6D61782D77696474683A6E6F6E6521696D706F7274616E743B6D61782D6865696768743A6E6F6E6521';
wwv_flow_imp.g_varchar2_table(348) := '696D706F7274616E743B696D6167652D6F7269656E746174696F6E3A3064656721696D706F7274616E743B22272C442E696E6E657248544D4C3D22222C442E617070656E644368696C642841297D297D7D2C22696E69745072657669657722292C726573';
wwv_flow_imp.g_varchar2_table(349) := '6574507265766965773A6E2866756E6374696F6E28297B416528746869732E70726576696577732C66756E6374696F6E2870297B76617220673D666828702C51293B626928702C7B77696474683A672E77696474682C6865696768743A672E6865696768';
wwv_flow_imp.g_varchar2_table(350) := '747D292C702E696E6E657248544D4C3D672E68746D6C2C536228702C51297D297D2C2272657365745072657669657722292C707265766965773A6E2866756E6374696F6E28297B76617220703D746869732E696D616765446174612C673D746869732E63';
wwv_flow_imp.g_varchar2_table(351) := '616E766173446174612C6D3D746869732E63726F70426F78446174612C503D6D2E77696474682C773D6D2E6865696768742C5F3D702E77696474682C433D702E6865696768742C443D6D2E6C6566742D672E6C6566742D702E6C6566742C413D6D2E746F';
wwv_flow_imp.g_varchar2_table(352) := '702D672E746F702D702E746F703B21746869732E63726F707065647C7C746869732E64697361626C65647C7C28626928746869732E76696577426F78496D6167652C5365287B77696474683A5F2C6865696768743A437D2C686E285365287B7472616E73';
wwv_flow_imp.g_varchar2_table(353) := '6C617465583A2D442C7472616E736C617465593A2D417D2C70292929292C416528746869732E70726576696577732C66756E6374696F6E2854297B766172204F3D666828542C51292C6B3D4F2E77696474682C75653D4F2E6865696768742C6C653D6B2C';
wwv_flow_imp.g_varchar2_table(354) := '4F653D75652C66653D313B5026262866653D6B2F502C4F653D772A6665292C7726264F653E756526262866653D75652F772C6C653D502A66652C4F653D7565292C626928542C7B77696474683A6C652C6865696768743A4F657D292C626928542E676574';
wwv_flow_imp.g_varchar2_table(355) := '456C656D656E747342795461674E616D652822696D6722295B305D2C5365287B77696474683A5F2A66652C6865696768743A432A66657D2C686E285365287B7472616E736C617465583A2D442A66652C7472616E736C617465593A2D412A66657D2C7029';
wwv_flow_imp.g_varchar2_table(356) := '2929297D29297D2C227072657669657722297D2C49623D7B62696E643A6E2866756E6374696F6E28297B76617220703D746869732E656C656D656E742C673D746869732E6F7074696F6E732C6D3D746869732E63726F707065723B537428672E63726F70';
wwv_flow_imp.g_varchar2_table(357) := '7374617274292626646928702C45652C672E63726F707374617274292C537428672E63726F706D6F7665292626646928702C78652C672E63726F706D6F7665292C537428672E63726F70656E64292626646928702C72652C672E63726F70656E64292C53';
wwv_flow_imp.g_varchar2_table(358) := '7428672E63726F70292626646928702C6E652C672E63726F70292C537428672E7A6F6F6D292626646928702C75722C672E7A6F6F6D292C6469286D2C4B652C746869732E6F6E43726F7053746172743D746869732E63726F7053746172742E62696E6428';
wwv_flow_imp.g_varchar2_table(359) := '7468697329292C672E7A6F6F6D61626C652626672E7A6F6F6D4F6E576865656C26266469286D2C24722C746869732E6F6E576865656C3D746869732E776865656C2E62696E642874686973292C7B706173736976653A21312C636170747572653A21307D';
wwv_flow_imp.g_varchar2_table(360) := '292C672E746F67676C65447261674D6F64654F6E44626C636C69636B26266469286D2C45742C746869732E6F6E44626C636C69636B3D746869732E64626C636C69636B2E62696E64287468697329292C646928702E6F776E6572446F63756D656E742C6C';
wwv_flow_imp.g_varchar2_table(361) := '722C746869732E6F6E43726F704D6F76653D746869732E63726F704D6F76652E62696E64287468697329292C646928702E6F776E6572446F63756D656E742C536F2C746869732E6F6E43726F70456E643D746869732E63726F70456E642E62696E642874';
wwv_flow_imp.g_varchar2_table(362) := '68697329292C672E726573706F6E73697665262664692877696E646F772C48722C746869732E6F6E526573697A653D746869732E726573697A652E62696E64287468697329297D2C2262696E6422292C756E62696E643A6E2866756E6374696F6E28297B';
wwv_flow_imp.g_varchar2_table(363) := '76617220703D746869732E656C656D656E742C673D746869732E6F7074696F6E732C6D3D746869732E63726F707065723B537428672E63726F707374617274292626536928702C45652C672E63726F707374617274292C537428672E63726F706D6F7665';
wwv_flow_imp.g_varchar2_table(364) := '292626536928702C78652C672E63726F706D6F7665292C537428672E63726F70656E64292626536928702C72652C672E63726F70656E64292C537428672E63726F70292626536928702C6E652C672E63726F70292C537428672E7A6F6F6D292626536928';
wwv_flow_imp.g_varchar2_table(365) := '702C75722C672E7A6F6F6D292C5369286D2C4B652C746869732E6F6E43726F705374617274292C672E7A6F6F6D61626C652626672E7A6F6F6D4F6E576865656C26265369286D2C24722C746869732E6F6E576865656C2C7B706173736976653A21312C63';
wwv_flow_imp.g_varchar2_table(366) := '6170747572653A21307D292C672E746F67676C65447261674D6F64654F6E44626C636C69636B26265369286D2C45742C746869732E6F6E44626C636C69636B292C536928702E6F776E6572446F63756D656E742C6C722C746869732E6F6E43726F704D6F';
wwv_flow_imp.g_varchar2_table(367) := '7665292C536928702E6F776E6572446F63756D656E742C536F2C746869732E6F6E43726F70456E64292C672E726573706F6E73697665262653692877696E646F772C48722C746869732E6F6E526573697A65297D2C22756E62696E6422297D2C4D623D7B';
wwv_flow_imp.g_varchar2_table(368) := '726573697A653A6E2866756E6374696F6E28297B69662821746869732E64697361626C6564297B76617220703D746869732E6F7074696F6E732C673D746869732E636F6E7461696E65722C6D3D746869732E636F6E7461696E6572446174612C503D672E';
wwv_flow_imp.g_varchar2_table(369) := '6F666673657457696474682F6D2E77696474683B69662850213D3D317C7C672E6F6666736574486569676874213D3D6D2E686569676874297B76617220772C5F3B702E726573746F7265262628773D746869732E67657443616E7661734461746128292C';
wwv_flow_imp.g_varchar2_table(370) := '5F3D746869732E67657443726F70426F78446174612829292C746869732E72656E64657228292C702E726573746F7265262628746869732E73657443616E7661734461746128416528772C66756E6374696F6E28432C44297B775B445D3D432A507D2929';
wwv_flow_imp.g_varchar2_table(371) := '2C746869732E73657443726F70426F7844617461284165285F2C66756E6374696F6E28432C44297B5F5B445D3D432A507D2929297D7D7D2C22726573697A6522292C64626C636C69636B3A6E2866756E6374696F6E28297B746869732E64697361626C65';
wwv_flow_imp.g_varchar2_table(372) := '647C7C746869732E6F7074696F6E732E647261674D6F64653D3D3D70657C7C746869732E736574447261674D6F646528466C28746869732E64726167426F782C5F65293F79653A58297D2C2264626C636C69636B22292C776865656C3A6E2866756E6374';
wwv_flow_imp.g_varchar2_table(373) := '696F6E2870297B76617220673D746869732C6D3D4E756D62657228746869732E6F7074696F6E732E776865656C5A6F6F6D526174696F297C7C2E312C503D313B746869732E64697361626C65647C7C28702E70726576656E7444656661756C7428292C21';
wwv_flow_imp.g_varchar2_table(374) := '746869732E776865656C696E67262628746869732E776865656C696E673D21302C73657454696D656F75742866756E6374696F6E28297B672E776865656C696E673D21317D2C3530292C702E64656C7461593F503D702E64656C7461593E303F313A2D31';
wwv_flow_imp.g_varchar2_table(375) := '3A702E776865656C44656C74613F503D2D702E776865656C44656C74612F3132303A702E64657461696C262628503D702E64657461696C3E303F313A2D31292C746869732E7A6F6F6D282D502A6D2C702929297D2C22776865656C22292C63726F705374';
wwv_flow_imp.g_varchar2_table(376) := '6172743A6E2866756E6374696F6E2870297B76617220673D702E627574746F6E732C6D3D702E627574746F6E3B6966282128746869732E64697361626C65647C7C28702E747970653D3D3D226D6F757365646F776E227C7C702E747970653D3D3D22706F';
wwv_flow_imp.g_varchar2_table(377) := '696E746572646F776E222626702E706F696E746572547970653D3D3D226D6F75736522292626286965286729262667213D3D317C7C6965286D2926266D213D3D307C7C702E6374726C4B65792929297B76617220503D746869732E6F7074696F6E732C77';
wwv_flow_imp.g_varchar2_table(378) := '3D746869732E706F696E746572732C5F3B702E6368616E676564546F75636865733F416528702E6368616E676564546F75636865732C66756E6374696F6E2843297B775B432E6964656E7469666965725D3D786C2843297D293A775B702E706F696E7465';
wwv_flow_imp.g_varchar2_table(379) := '7249647C7C305D3D786C2870292C4F626A6563742E6B6579732877292E6C656E6774683E312626502E7A6F6F6D61626C652626502E7A6F6F6D4F6E546F7563683F5F3D4A3A5F3D666828702E7461726765742C4C292C6F742E74657374285F292626466F';
wwv_flow_imp.g_varchar2_table(380) := '28746869732E656C656D656E742C45652C7B6F726967696E616C4576656E743A702C616374696F6E3A5F7D29213D3D2131262628702E70726576656E7444656661756C7428292C746869732E616374696F6E3D5F2C746869732E63726F7070696E673D21';
wwv_flow_imp.g_varchar2_table(381) := '312C5F3D3D3D6A262628746869732E63726F7070696E673D21302C6A6528746869732E64726167426F782C522929297D7D2C2263726F70537461727422292C63726F704D6F76653A6E2866756E6374696F6E2870297B76617220673D746869732E616374';
wwv_flow_imp.g_varchar2_table(382) := '696F6E3B6966282128746869732E64697361626C65647C7C216729297B766172206D3D746869732E706F696E746572733B702E70726576656E7444656661756C7428292C466F28746869732E656C656D656E742C78652C7B6F726967696E616C4576656E';
wwv_flow_imp.g_varchar2_table(383) := '743A702C616374696F6E3A677D29213D3D2131262628702E6368616E676564546F75636865733F416528702E6368616E676564546F75636865732C66756E6374696F6E2850297B5365286D5B502E6964656E7469666965725D7C7C7B7D2C786C28502C21';
wwv_flow_imp.g_varchar2_table(384) := '3029297D293A5365286D5B702E706F696E74657249647C7C305D7C7C7B7D2C786C28702C213029292C746869732E6368616E6765287029297D7D2C2263726F704D6F766522292C63726F70456E643A6E2866756E6374696F6E2870297B69662821746869';
wwv_flow_imp.g_varchar2_table(385) := '732E64697361626C6564297B76617220673D746869732E616374696F6E2C6D3D746869732E706F696E746572733B702E6368616E676564546F75636865733F416528702E6368616E676564546F75636865732C66756E6374696F6E2850297B64656C6574';
wwv_flow_imp.g_varchar2_table(386) := '65206D5B502E6964656E7469666965725D7D293A64656C657465206D5B702E706F696E74657249647C7C305D2C67262628702E70726576656E7444656661756C7428292C4F626A6563742E6B657973286D292E6C656E6774687C7C28746869732E616374';
wwv_flow_imp.g_varchar2_table(387) := '696F6E3D2222292C746869732E63726F7070696E67262628746869732E63726F7070696E673D21312C567228746869732E64726167426F782C522C746869732E63726F707065642626746869732E6F7074696F6E732E6D6F64616C29292C466F28746869';
wwv_flow_imp.g_varchar2_table(388) := '732E656C656D656E742C72652C7B6F726967696E616C4576656E743A702C616374696F6E3A677D29297D7D2C2263726F70456E6422297D2C4E623D7B6368616E67653A6E2866756E6374696F6E2870297B76617220673D746869732E6F7074696F6E732C';
wwv_flow_imp.g_varchar2_table(389) := '6D3D746869732E63616E766173446174612C503D746869732E636F6E7461696E6572446174612C773D746869732E63726F70426F78446174612C5F3D746869732E706F696E746572732C433D746869732E616374696F6E2C443D672E6173706563745261';
wwv_flow_imp.g_varchar2_table(390) := '74696F2C413D772E6C6566742C543D772E746F702C4F3D772E77696474682C6B3D772E6865696768742C75653D412B4F2C6C653D542B6B2C4F653D302C66653D302C5A653D502E77696474682C61743D502E6865696768742C58653D21302C64723B2144';
wwv_flow_imp.g_varchar2_table(391) := '2626702E73686966744B6579262628443D4F26266B3F4F2F6B3A31292C746869732E6C696D697465642626284F653D772E6D696E4C6566742C66653D772E6D696E546F702C5A653D4F652B4D6174682E6D696E28502E77696474682C6D2E77696474682C';
wwv_flow_imp.g_varchar2_table(392) := '6D2E6C6566742B6D2E7769647468292C61743D66652B4D6174682E6D696E28502E6865696768742C6D2E6865696768742C6D2E746F702B6D2E68656967687429293B7661722047743D5F5B4F626A6563742E6B657973285F295B305D5D2C4E3D7B783A47';
wwv_flow_imp.g_varchar2_table(393) := '742E656E64582D47742E7374617274582C793A47742E656E64592D47742E7374617274597D2C6D653D6E2866756E6374696F6E286369297B737769746368286369297B6361736520423A75652B4E2E783E5A652626284E2E783D5A652D7565293B627265';
wwv_flow_imp.g_varchar2_table(394) := '616B3B63617365207A3A412B4E2E783C4F652626284E2E783D4F652D41293B627265616B3B63617365206F653A542B4E2E793C66652626284E2E793D66652D54293B627265616B3B63617365204B3A6C652B4E2E793E61742626284E2E793D61742D6C65';
wwv_flow_imp.g_varchar2_table(395) := '293B627265616B7D7D2C22636865636B22293B7377697463682843297B6361736520553A412B3D4E2E782C542B3D4E2E793B627265616B3B6361736520423A6966284E2E783E3D3026262875653E3D5A657C7C44262628543C3D66657C7C6C653E3D6174';
wwv_flow_imp.g_varchar2_table(396) := '2929297B58653D21313B627265616B7D6D652842292C4F2B3D4E2E782C4F3C30262628433D7A2C4F3D2D4F2C412D3D4F292C442626286B3D4F2F442C542B3D28772E6865696768742D6B292F32293B627265616B3B63617365206F653A6966284E2E793C';
wwv_flow_imp.g_varchar2_table(397) := '3D30262628543C3D66657C7C44262628413C3D4F657C7C75653E3D5A652929297B58653D21313B627265616B7D6D65286F65292C6B2D3D4E2E792C542B3D4E2E792C6B3C30262628433D4B2C6B3D2D6B2C542D3D6B292C442626284F3D6B2A442C412B3D';
wwv_flow_imp.g_varchar2_table(398) := '28772E77696474682D4F292F32293B627265616B3B63617365207A3A6966284E2E783C3D30262628413C3D4F657C7C44262628543C3D66657C7C6C653E3D61742929297B58653D21313B627265616B7D6D65287A292C4F2D3D4E2E782C412B3D4E2E782C';
wwv_flow_imp.g_varchar2_table(399) := '4F3C30262628433D422C4F3D2D4F2C412D3D4F292C442626286B3D4F2F442C542B3D28772E6865696768742D6B292F32293B627265616B3B63617365204B3A6966284E2E793E3D302626286C653E3D61747C7C44262628413C3D4F657C7C75653E3D5A65';
wwv_flow_imp.g_varchar2_table(400) := '2929297B58653D21313B627265616B7D6D65284B292C6B2B3D4E2E792C6B3C30262628433D6F652C6B3D2D6B2C542D3D6B292C442626284F3D6B2A442C412B3D28772E77696474682D4F292F32293B627265616B3B636173652042653A69662844297B69';
wwv_flow_imp.g_varchar2_table(401) := '66284E2E793C3D30262628543C3D66657C7C75653E3D5A6529297B58653D21313B627265616B7D6D65286F65292C6B2D3D4E2E792C542B3D4E2E792C4F3D6B2A447D656C7365206D65286F65292C6D652842292C4E2E783E3D303F75653C5A653F4F2B3D';
wwv_flow_imp.g_varchar2_table(402) := '4E2E783A4E2E793C3D302626543C3D666526262858653D2131293A4F2B3D4E2E782C4E2E793C3D303F543E66652626286B2D3D4E2E792C542B3D4E2E79293A286B2D3D4E2E792C542B3D4E2E79293B4F3C3026266B3C303F28433D47652C6B3D2D6B2C4F';
wwv_flow_imp.g_varchar2_table(403) := '3D2D4F2C542D3D6B2C412D3D4F293A4F3C303F28433D4A652C4F3D2D4F2C412D3D4F293A6B3C30262628433D77742C6B3D2D6B2C542D3D6B293B627265616B3B63617365204A653A69662844297B6966284E2E793C3D30262628543C3D66657C7C413C3D';
wwv_flow_imp.g_varchar2_table(404) := '4F6529297B58653D21313B627265616B7D6D65286F65292C6B2D3D4E2E792C542B3D4E2E792C4F3D6B2A442C412B3D772E77696474682D4F7D656C7365206D65286F65292C6D65287A292C4E2E783C3D303F413E4F653F284F2D3D4E2E782C412B3D4E2E';
wwv_flow_imp.g_varchar2_table(405) := '78293A4E2E793C3D302626543C3D666526262858653D2131293A284F2D3D4E2E782C412B3D4E2E78292C4E2E793C3D303F543E66652626286B2D3D4E2E792C542B3D4E2E79293A286B2D3D4E2E792C542B3D4E2E79293B4F3C3026266B3C303F28433D77';
wwv_flow_imp.g_varchar2_table(406) := '742C6B3D2D6B2C4F3D2D4F2C542D3D6B2C412D3D4F293A4F3C303F28433D42652C4F3D2D4F2C412D3D4F293A6B3C30262628433D47652C6B3D2D6B2C542D3D6B293B627265616B3B636173652047653A69662844297B6966284E2E783C3D30262628413C';
wwv_flow_imp.g_varchar2_table(407) := '3D4F657C7C6C653E3D617429297B58653D21313B627265616B7D6D65287A292C4F2D3D4E2E782C412B3D4E2E782C6B3D4F2F447D656C7365206D65284B292C6D65287A292C4E2E783C3D303F413E4F653F284F2D3D4E2E782C412B3D4E2E78293A4E2E79';
wwv_flow_imp.g_varchar2_table(408) := '3E3D3026266C653E3D617426262858653D2131293A284F2D3D4E2E782C412B3D4E2E78292C4E2E793E3D303F6C653C61742626286B2B3D4E2E79293A6B2B3D4E2E793B4F3C3026266B3C303F28433D42652C6B3D2D6B2C4F3D2D4F2C542D3D6B2C412D3D';
wwv_flow_imp.g_varchar2_table(409) := '4F293A4F3C303F28433D77742C4F3D2D4F2C412D3D4F293A6B3C30262628433D4A652C6B3D2D6B2C542D3D6B293B627265616B3B636173652077743A69662844297B6966284E2E783E3D3026262875653E3D5A657C7C6C653E3D617429297B58653D2131';
wwv_flow_imp.g_varchar2_table(410) := '3B627265616B7D6D652842292C4F2B3D4E2E782C6B3D4F2F447D656C7365206D65284B292C6D652842292C4E2E783E3D303F75653C5A653F4F2B3D4E2E783A4E2E793E3D3026266C653E3D617426262858653D2131293A4F2B3D4E2E782C4E2E793E3D30';
wwv_flow_imp.g_varchar2_table(411) := '3F6C653C61742626286B2B3D4E2E79293A6B2B3D4E2E793B4F3C3026266B3C303F28433D4A652C6B3D2D6B2C4F3D2D4F2C542D3D6B2C412D3D4F293A4F3C303F28433D47652C4F3D2D4F2C412D3D4F293A6B3C30262628433D42652C6B3D2D6B2C542D3D';
wwv_flow_imp.g_varchar2_table(412) := '6B293B627265616B3B6361736520473A746869732E6D6F7665284E2E782C4E2E79292C58653D21313B627265616B3B63617365204A3A746869732E7A6F6F6D285F62285F292C70292C58653D21313B627265616B3B63617365206A3A696628214E2E787C';
wwv_flow_imp.g_varchar2_table(413) := '7C214E2E79297B58653D21313B627265616B7D64723D4B7028746869732E63726F70706572292C413D47742E7374617274582D64722E6C6566742C543D47742E7374617274592D64722E746F702C4F3D772E6D696E57696474682C6B3D772E6D696E4865';
wwv_flow_imp.g_varchar2_table(414) := '696768742C4E2E783E303F433D4E2E793E303F77743A42653A4E2E783C30262628412D3D4F2C433D4E2E793E303F47653A4A65292C4E2E793C30262628542D3D6B292C746869732E63726F707065647C7C28776928746869732E63726F70426F782C4665';
wwv_flow_imp.g_varchar2_table(415) := '292C746869732E63726F707065643D21302C746869732E6C696D697465642626746869732E6C696D697443726F70426F782821302C213029293B627265616B7D5865262628772E77696474683D4F2C772E6865696768743D6B2C772E6C6566743D412C77';
wwv_flow_imp.g_varchar2_table(416) := '2E746F703D542C746869732E616374696F6E3D432C746869732E72656E64657243726F70426F782829292C4165285F2C66756E6374696F6E286574297B65742E7374617274583D65742E656E64582C65742E7374617274593D65742E656E64597D297D2C';
wwv_flow_imp.g_varchar2_table(417) := '226368616E676522297D2C4C623D7B63726F703A6E2866756E6374696F6E28297B72657475726E20746869732E7265616479262621746869732E63726F70706564262621746869732E64697361626C6564262628746869732E63726F707065643D21302C';
wwv_flow_imp.g_varchar2_table(418) := '746869732E6C696D697443726F70426F782821302C2130292C746869732E6F7074696F6E732E6D6F64616C26266A6528746869732E64726167426F782C52292C776928746869732E63726F70426F782C4665292C746869732E73657443726F70426F7844';
wwv_flow_imp.g_varchar2_table(419) := '61746128746869732E696E697469616C43726F70426F784461746129292C746869737D2C2263726F7022292C72657365743A6E2866756E6374696F6E28297B72657475726E20746869732E7265616479262621746869732E64697361626C656426262874';
wwv_flow_imp.g_varchar2_table(420) := '6869732E696D616765446174613D5365287B7D2C746869732E696E697469616C496D61676544617461292C746869732E63616E766173446174613D5365287B7D2C746869732E696E697469616C43616E76617344617461292C746869732E63726F70426F';
wwv_flow_imp.g_varchar2_table(421) := '78446174613D5365287B7D2C746869732E696E697469616C43726F70426F7844617461292C746869732E72656E64657243616E76617328292C746869732E63726F707065642626746869732E72656E64657243726F70426F782829292C746869737D2C22';
wwv_flow_imp.g_varchar2_table(422) := '726573657422292C636C6561723A6E2866756E6374696F6E28297B72657475726E20746869732E63726F70706564262621746869732E64697361626C6564262628536528746869732E63726F70426F78446174612C7B6C6566743A302C746F703A302C77';
wwv_flow_imp.g_varchar2_table(423) := '696474683A302C6865696768743A307D292C746869732E63726F707065643D21312C746869732E72656E64657243726F70426F7828292C746869732E6C696D697443616E7661732821302C2130292C746869732E72656E64657243616E76617328292C77';
wwv_flow_imp.g_varchar2_table(424) := '6928746869732E64726167426F782C52292C6A6528746869732E63726F70426F782C466529292C746869737D2C22636C65617222292C7265706C6163653A6E2866756E6374696F6E2870297B76617220673D617267756D656E74732E6C656E6774683E31';
wwv_flow_imp.g_varchar2_table(425) := '2626617267756D656E74735B315D213D3D766F696420303F617267756D656E74735B315D3A21313B72657475726E21746869732E64697361626C6564262670262628746869732E6973496D67262628746869732E656C656D656E742E7372633D70292C67';
wwv_flow_imp.g_varchar2_table(426) := '3F28746869732E75726C3D702C746869732E696D6167652E7372633D702C746869732E7265616479262628746869732E76696577426F78496D6167652E7372633D702C416528746869732E70726576696577732C66756E6374696F6E286D297B6D2E6765';
wwv_flow_imp.g_varchar2_table(427) := '74456C656D656E747342795461674E616D652822696D6722295B305D2E7372633D707D2929293A28746869732E6973496D67262628746869732E7265706C616365643D2130292C746869732E6F7074696F6E732E646174613D6E756C6C2C746869732E75';
wwv_flow_imp.g_varchar2_table(428) := '6E63726561746528292C746869732E6C6F616428702929292C746869737D2C227265706C61636522292C656E61626C653A6E2866756E6374696F6E28297B72657475726E20746869732E72656164792626746869732E64697361626C6564262628746869';
wwv_flow_imp.g_varchar2_table(429) := '732E64697361626C65643D21312C776928746869732E63726F707065722C7A6529292C746869737D2C22656E61626C6522292C64697361626C653A6E2866756E6374696F6E28297B72657475726E20746869732E7265616479262621746869732E646973';
wwv_flow_imp.g_varchar2_table(430) := '61626C6564262628746869732E64697361626C65643D21302C6A6528746869732E63726F707065722C7A6529292C746869737D2C2264697361626C6522292C64657374726F793A6E2866756E6374696F6E28297B76617220703D746869732E656C656D65';
wwv_flow_imp.g_varchar2_table(431) := '6E743B72657475726E20705B785D3F28705B785D3D766F696420302C746869732E6973496D672626746869732E7265706C61636564262628702E7372633D746869732E6F726967696E616C55726C292C746869732E756E63726561746528292C74686973';
wwv_flow_imp.g_varchar2_table(432) := '293A746869737D2C2264657374726F7922292C6D6F76653A6E2866756E6374696F6E2870297B76617220673D617267756D656E74732E6C656E6774683E312626617267756D656E74735B315D213D3D766F696420303F617267756D656E74735B315D3A70';
wwv_flow_imp.g_varchar2_table(433) := '2C6D3D746869732E63616E766173446174612C503D6D2E6C6566742C773D6D2E746F703B72657475726E20746869732E6D6F7665546F28506F2870293F703A502B4E756D6265722870292C506F2867293F673A772B4E756D626572286729297D2C226D6F';
wwv_flow_imp.g_varchar2_table(434) := '766522292C6D6F7665546F3A6E2866756E6374696F6E2870297B76617220673D617267756D656E74732E6C656E6774683E312626617267756D656E74735B315D213D3D766F696420303F617267756D656E74735B315D3A702C6D3D746869732E63616E76';
wwv_flow_imp.g_varchar2_table(435) := '6173446174612C503D21313B72657475726E20703D4E756D6265722870292C673D4E756D6265722867292C746869732E7265616479262621746869732E64697361626C65642626746869732E6F7074696F6E732E6D6F7661626C65262628696528702926';
wwv_flow_imp.g_varchar2_table(436) := '26286D2E6C6566743D702C503D2130292C69652867292626286D2E746F703D672C503D2130292C502626746869732E72656E64657243616E76617328213029292C746869737D2C226D6F7665546F22292C7A6F6F6D3A6E2866756E6374696F6E28702C67';
wwv_flow_imp.g_varchar2_table(437) := '297B766172206D3D746869732E63616E766173446174613B72657475726E20703D4E756D6265722870292C703C303F703D312F28312D70293A703D312B702C746869732E7A6F6F6D546F286D2E77696474682A702F6D2E6E61747572616C57696474682C';
wwv_flow_imp.g_varchar2_table(438) := '6E756C6C2C67297D2C227A6F6F6D22292C7A6F6F6D546F3A6E2866756E6374696F6E28702C672C6D297B76617220503D746869732E6F7074696F6E732C773D746869732E63616E766173446174612C5F3D772E77696474682C433D772E6865696768742C';
wwv_flow_imp.g_varchar2_table(439) := '443D772E6E61747572616C57696474682C413D772E6E61747572616C4865696768743B696628703D4E756D6265722870292C703E3D302626746869732E7265616479262621746869732E64697361626C65642626502E7A6F6F6D61626C65297B76617220';
wwv_flow_imp.g_varchar2_table(440) := '543D442A702C4F3D412A703B696628466F28746869732E656C656D656E742C75722C7B726174696F3A702C6F6C64526174696F3A5F2F442C6F726967696E616C4576656E743A6D7D293D3D3D21312972657475726E20746869733B6966286D297B766172';
wwv_flow_imp.g_varchar2_table(441) := '206B3D746869732E706F696E746572732C75653D4B7028746869732E63726F70706572292C6C653D6B26264F626A6563742E6B657973286B292E6C656E6774683F4662286B293A7B70616765583A6D2E70616765582C70616765593A6D2E70616765597D';
wwv_flow_imp.g_varchar2_table(442) := '3B772E6C6566742D3D28542D5F292A28286C652E70616765582D75652E6C6566742D772E6C656674292F5F292C772E746F702D3D284F2D43292A28286C652E70616765592D75652E746F702D772E746F70292F43297D656C736520717228672926266965';
wwv_flow_imp.g_varchar2_table(443) := '28672E78292626696528672E79293F28772E6C6566742D3D28542D5F292A2828672E782D772E6C656674292F5F292C772E746F702D3D284F2D43292A2828672E792D772E746F70292F4329293A28772E6C6566742D3D28542D5F292F322C772E746F702D';
wwv_flow_imp.g_varchar2_table(444) := '3D284F2D43292F32293B772E77696474683D542C772E6865696768743D4F2C746869732E72656E64657243616E766173282130297D72657475726E20746869737D2C227A6F6F6D546F22292C726F746174653A6E2866756E6374696F6E2870297B726574';
wwv_flow_imp.g_varchar2_table(445) := '75726E20746869732E726F74617465546F2828746869732E696D616765446174612E726F746174657C7C30292B4E756D626572287029297D2C22726F7461746522292C726F74617465546F3A6E2866756E6374696F6E2870297B72657475726E20703D4E';
wwv_flow_imp.g_varchar2_table(446) := '756D6265722870292C69652870292626746869732E7265616479262621746869732E64697361626C65642626746869732E6F7074696F6E732E726F74617461626C65262628746869732E696D616765446174612E726F746174653D70253336302C746869';
wwv_flow_imp.g_varchar2_table(447) := '732E72656E64657243616E7661732821302C213029292C746869737D2C22726F74617465546F22292C7363616C65583A6E2866756E6374696F6E2870297B76617220673D746869732E696D616765446174612E7363616C65593B72657475726E20746869';
wwv_flow_imp.g_varchar2_table(448) := '732E7363616C6528702C69652867293F673A31297D2C227363616C655822292C7363616C65593A6E2866756E6374696F6E2870297B76617220673D746869732E696D616765446174612E7363616C65583B72657475726E20746869732E7363616C652869';
wwv_flow_imp.g_varchar2_table(449) := '652867293F673A312C70297D2C227363616C655922292C7363616C653A6E2866756E6374696F6E2870297B76617220673D617267756D656E74732E6C656E6774683E312626617267756D656E74735B315D213D3D766F696420303F617267756D656E7473';
wwv_flow_imp.g_varchar2_table(450) := '5B315D3A702C6D3D746869732E696D616765446174612C503D21313B72657475726E20703D4E756D6265722870292C673D4E756D6265722867292C746869732E7265616479262621746869732E64697361626C65642626746869732E6F7074696F6E732E';
wwv_flow_imp.g_varchar2_table(451) := '7363616C61626C6526262869652870292626286D2E7363616C65583D702C503D2130292C69652867292626286D2E7363616C65593D672C503D2130292C502626746869732E72656E64657243616E7661732821302C213029292C746869737D2C22736361';
wwv_flow_imp.g_varchar2_table(452) := '6C6522292C676574446174613A6E2866756E6374696F6E28297B76617220703D617267756D656E74732E6C656E6774683E302626617267756D656E74735B305D213D3D766F696420303F617267756D656E74735B305D3A21312C673D746869732E6F7074';
wwv_flow_imp.g_varchar2_table(453) := '696F6E732C6D3D746869732E696D616765446174612C503D746869732E63616E766173446174612C773D746869732E63726F70426F78446174612C5F3B696628746869732E72656164792626746869732E63726F70706564297B5F3D7B783A772E6C6566';
wwv_flow_imp.g_varchar2_table(454) := '742D502E6C6566742C793A772E746F702D502E746F702C77696474683A772E77696474682C6865696768743A772E6865696768747D3B76617220433D6D2E77696474682F6D2E6E61747572616C57696474683B6966284165285F2C66756E6374696F6E28';
wwv_flow_imp.g_varchar2_table(455) := '542C4F297B5F5B4F5D3D542F437D292C70297B76617220443D4D6174682E726F756E64285F2E792B5F2E686569676874292C413D4D6174682E726F756E64285F2E782B5F2E7769647468293B5F2E783D4D6174682E726F756E64285F2E78292C5F2E793D';
wwv_flow_imp.g_varchar2_table(456) := '4D6174682E726F756E64285F2E79292C5F2E77696474683D412D5F2E782C5F2E6865696768743D442D5F2E797D7D656C7365205F3D7B783A302C793A302C77696474683A302C6865696768743A307D3B72657475726E20672E726F74617461626C652626';
wwv_flow_imp.g_varchar2_table(457) := '285F2E726F746174653D6D2E726F746174657C7C30292C672E7363616C61626C652626285F2E7363616C65583D6D2E7363616C65587C7C312C5F2E7363616C65593D6D2E7363616C65597C7C31292C5F7D2C226765744461746122292C73657444617461';
wwv_flow_imp.g_varchar2_table(458) := '3A6E2866756E6374696F6E2870297B76617220673D746869732E6F7074696F6E732C6D3D746869732E696D616765446174612C503D746869732E63616E766173446174612C773D7B7D3B696628746869732E7265616479262621746869732E6469736162';
wwv_flow_imp.g_varchar2_table(459) := '6C656426267172287029297B766172205F3D21313B672E726F74617461626C652626696528702E726F74617465292626702E726F74617465213D3D6D2E726F746174652626286D2E726F746174653D702E726F746174652C5F3D2130292C672E7363616C';
wwv_flow_imp.g_varchar2_table(460) := '61626C65262628696528702E7363616C6558292626702E7363616C6558213D3D6D2E7363616C65582626286D2E7363616C65583D702E7363616C65582C5F3D2130292C696528702E7363616C6559292626702E7363616C6559213D3D6D2E7363616C6559';
wwv_flow_imp.g_varchar2_table(461) := '2626286D2E7363616C65593D702E7363616C65592C5F3D213029292C5F2626746869732E72656E64657243616E7661732821302C2130293B76617220433D6D2E77696474682F6D2E6E61747572616C57696474683B696528702E7829262628772E6C6566';
wwv_flow_imp.g_varchar2_table(462) := '743D702E782A432B502E6C656674292C696528702E7929262628772E746F703D702E792A432B502E746F70292C696528702E776964746829262628772E77696474683D702E77696474682A43292C696528702E68656967687429262628772E6865696768';
wwv_flow_imp.g_varchar2_table(463) := '743D702E6865696768742A43292C746869732E73657443726F70426F78446174612877297D72657475726E20746869737D2C227365744461746122292C676574436F6E7461696E6572446174613A6E2866756E6374696F6E28297B72657475726E207468';
wwv_flow_imp.g_varchar2_table(464) := '69732E72656164793F5365287B7D2C746869732E636F6E7461696E657244617461293A7B7D7D2C22676574436F6E7461696E65724461746122292C676574496D616765446174613A6E2866756E6374696F6E28297B72657475726E20746869732E73697A';
wwv_flow_imp.g_varchar2_table(465) := '65643F5365287B7D2C746869732E696D61676544617461293A7B7D7D2C22676574496D6167654461746122292C67657443616E766173446174613A6E2866756E6374696F6E28297B76617220703D746869732E63616E766173446174612C673D7B7D3B72';
wwv_flow_imp.g_varchar2_table(466) := '657475726E20746869732E726561647926264165285B226C656674222C22746F70222C227769647468222C22686569676874222C226E61747572616C5769647468222C226E61747572616C486569676874225D2C66756E6374696F6E286D297B675B6D5D';
wwv_flow_imp.g_varchar2_table(467) := '3D705B6D5D7D292C677D2C2267657443616E7661734461746122292C73657443616E766173446174613A6E2866756E6374696F6E2870297B76617220673D746869732E63616E766173446174612C6D3D672E617370656374526174696F3B72657475726E';
wwv_flow_imp.g_varchar2_table(468) := '20746869732E7265616479262621746869732E64697361626C656426267172287029262628696528702E6C65667429262628672E6C6566743D702E6C656674292C696528702E746F7029262628672E746F703D702E746F70292C696528702E7769647468';
wwv_flow_imp.g_varchar2_table(469) := '293F28672E77696474683D702E77696474682C672E6865696768743D702E77696474682F6D293A696528702E68656967687429262628672E6865696768743D702E6865696768742C672E77696474683D702E6865696768742A6D292C746869732E72656E';
wwv_flow_imp.g_varchar2_table(470) := '64657243616E76617328213029292C746869737D2C2273657443616E7661734461746122292C67657443726F70426F78446174613A6E2866756E6374696F6E28297B76617220703D746869732E63726F70426F78446174612C673B72657475726E207468';
wwv_flow_imp.g_varchar2_table(471) := '69732E72656164792626746869732E63726F70706564262628673D7B6C6566743A702E6C6566742C746F703A702E746F702C77696474683A702E77696474682C6865696768743A702E6865696768747D292C677C7C7B7D7D2C2267657443726F70426F78';
wwv_flow_imp.g_varchar2_table(472) := '4461746122292C73657443726F70426F78446174613A6E2866756E6374696F6E2870297B76617220673D746869732E63726F70426F78446174612C6D3D746869732E6F7074696F6E732E617370656374526174696F2C502C773B72657475726E20746869';
wwv_flow_imp.g_varchar2_table(473) := '732E72656164792626746869732E63726F70706564262621746869732E64697361626C656426267172287029262628696528702E6C65667429262628672E6C6566743D702E6C656674292C696528702E746F7029262628672E746F703D702E746F70292C';
wwv_flow_imp.g_varchar2_table(474) := '696528702E7769647468292626702E7769647468213D3D672E7769647468262628503D21302C672E77696474683D702E7769647468292C696528702E686569676874292626702E686569676874213D3D672E686569676874262628773D21302C672E6865';
wwv_flow_imp.g_varchar2_table(475) := '696768743D702E686569676874292C6D262628503F672E6865696768743D672E77696474682F6D3A77262628672E77696474683D672E6865696768742A6D29292C746869732E72656E64657243726F70426F782829292C746869737D2C2273657443726F';
wwv_flow_imp.g_varchar2_table(476) := '70426F784461746122292C67657443726F7070656443616E7661733A6E2866756E6374696F6E28297B76617220703D617267756D656E74732E6C656E6774683E302626617267756D656E74735B305D213D3D766F696420303F617267756D656E74735B30';
wwv_flow_imp.g_varchar2_table(477) := '5D3A7B7D3B69662821746869732E72656164797C7C2177696E646F772E48544D4C43616E766173456C656D656E742972657475726E206E756C6C3B76617220673D746869732E63616E766173446174612C6D3D456228746869732E696D6167652C746869';
wwv_flow_imp.g_varchar2_table(478) := '732E696D616765446174612C672C70293B69662821746869732E63726F707065642972657475726E206D3B76617220503D746869732E6765744461746128292C773D502E782C5F3D502E792C433D502E77696474682C443D502E6865696768742C413D6D';
wwv_flow_imp.g_varchar2_table(479) := '2E77696474682F4D6174682E666C6F6F7228672E6E61747572616C5769647468293B41213D3D31262628772A3D412C5F2A3D412C432A3D412C442A3D41293B76617220543D432F442C4F3D5772287B617370656374526174696F3A542C77696474683A70';
wwv_flow_imp.g_varchar2_table(480) := '2E6D617857696474687C7C312F302C6865696768743A702E6D61784865696768747C7C312F307D292C6B3D5772287B617370656374526174696F3A542C77696474683A702E6D696E57696474687C7C302C6865696768743A702E6D696E4865696768747C';
wwv_flow_imp.g_varchar2_table(481) := '7C307D2C22636F76657222292C75653D5772287B617370656374526174696F3A542C77696474683A702E77696474687C7C2841213D3D313F6D2E77696474683A43292C6865696768743A702E6865696768747C7C2841213D3D313F6D2E6865696768743A';
wwv_flow_imp.g_varchar2_table(482) := '44297D292C6C653D75652E77696474682C4F653D75652E6865696768743B6C653D4D6174682E6D696E284F2E77696474682C4D6174682E6D6178286B2E77696474682C6C6529292C4F653D4D6174682E6D696E284F2E6865696768742C4D6174682E6D61';
wwv_flow_imp.g_varchar2_table(483) := '78286B2E6865696768742C4F6529293B7661722066653D646F63756D656E742E637265617465456C656D656E74282263616E76617322292C5A653D66652E676574436F6E746578742822326422293B66652E77696474683D4E69286C65292C66652E6865';
wwv_flow_imp.g_varchar2_table(484) := '696768743D4E69284F65292C5A652E66696C6C5374796C653D702E66696C6C436F6C6F727C7C227472616E73706172656E74222C5A652E66696C6C5265637428302C302C6C652C4F65293B7661722061743D702E696D616765536D6F6F7468696E67456E';
wwv_flow_imp.g_varchar2_table(485) := '61626C65642C58653D61743D3D3D766F696420303F21303A61742C64723D702E696D616765536D6F6F7468696E675175616C6974793B5A652E696D616765536D6F6F7468696E67456E61626C65643D58652C64722626285A652E696D616765536D6F6F74';
wwv_flow_imp.g_varchar2_table(486) := '68696E675175616C6974793D6472293B7661722047743D6D2E77696474682C4E3D6D2E6865696768742C6D653D772C65743D5F2C63692C63722C63732C70732C47722C4C693B6D653C3D2D437C7C6D653E47743F286D653D302C63693D302C63733D302C';
wwv_flow_imp.g_varchar2_table(487) := '47723D30293A6D653C3D303F2863733D2D6D652C6D653D302C63693D4D6174682E6D696E2847742C432B6D65292C47723D6369293A6D653C3D477426262863733D302C63693D4D6174682E6D696E28432C47742D6D65292C47723D6369292C63693C3D30';
wwv_flow_imp.g_varchar2_table(488) := '7C7C65743C3D2D447C7C65743E4E3F2865743D302C63723D302C70733D302C4C693D30293A65743C3D303F2870733D2D65742C65743D302C63723D4D6174682E6D696E284E2C442B6574292C4C693D6372293A65743C3D4E26262870733D302C63723D4D';
wwv_flow_imp.g_varchar2_table(489) := '6174682E6D696E28442C4E2D6574292C4C693D6372293B766172206A743D5B6D652C65742C63692C63725D3B69662847723E3026264C693E30297B7661722066733D6C652F433B6A742E707573682863732A66732C70732A66732C47722A66732C4C692A';
wwv_flow_imp.g_varchar2_table(490) := '6673297D72657475726E205A652E64726177496D6167652E6170706C79285A652C5B6D5D2E636F6E636174286C286A742E6D61702866756E6374696F6E28456C297B72657475726E204D6174682E666C6F6F72284E6928456C29297D292929292C66657D';
wwv_flow_imp.g_varchar2_table(491) := '2C2267657443726F7070656443616E76617322292C736574417370656374526174696F3A6E2866756E6374696F6E2870297B76617220673D746869732E6F7074696F6E733B72657475726E21746869732E64697361626C6564262621506F287029262628';
wwv_flow_imp.g_varchar2_table(492) := '672E617370656374526174696F3D4D6174682E6D617828302C70297C7C4E614E2C746869732E7265616479262628746869732E696E697443726F70426F7828292C746869732E63726F707065642626746869732E72656E64657243726F70426F78282929';
wwv_flow_imp.g_varchar2_table(493) := '292C746869737D2C22736574417370656374526174696F22292C736574447261674D6F64653A6E2866756E6374696F6E2870297B76617220673D746869732E6F7074696F6E732C6D3D746869732E64726167426F782C503D746869732E666163653B6966';
wwv_flow_imp.g_varchar2_table(494) := '28746869732E7265616479262621746869732E64697361626C6564297B76617220773D703D3D3D582C5F3D672E6D6F7661626C652626703D3D3D79653B703D777C7C5F3F703A70652C672E647261674D6F64653D702C756E286D2C4C2C70292C5672286D';
wwv_flow_imp.g_varchar2_table(495) := '2C5F652C77292C5672286D2C492C5F292C672E63726F70426F784D6F7661626C657C7C28756E28502C4C2C70292C567228502C5F652C77292C567228502C492C5F29297D72657475726E20746869737D2C22736574447261674D6F646522297D2C42623D';
wwv_flow_imp.g_varchar2_table(496) := '532E43726F707065722C4A703D66756E6374696F6E28297B66756E6374696F6E20762870297B76617220673D617267756D656E74732E6C656E6774683E312626617267756D656E74735B315D213D3D766F696420303F617267756D656E74735B315D3A7B';
wwv_flow_imp.g_varchar2_table(497) := '7D3B6966286528746869732C76292C21707C7C21776C2E7465737428702E7461674E616D6529297468726F77206E6577204572726F72282254686520666972737420617267756D656E7420697320726571756972656420616E64206D7573742062652061';
wwv_flow_imp.g_varchar2_table(498) := '6E203C696D673E206F72203C63616E7661733E20656C656D656E742E22293B746869732E656C656D656E743D702C746869732E6F7074696F6E733D5365287B7D2C6E6E2C7172286729262667292C746869732E63726F707065643D21312C746869732E64';
wwv_flow_imp.g_varchar2_table(499) := '697361626C65643D21312C746869732E706F696E746572733D7B7D2C746869732E72656164793D21312C746869732E72656C6F6164696E673D21312C746869732E7265706C616365643D21312C746869732E73697A65643D21312C746869732E73697A69';
wwv_flow_imp.g_varchar2_table(500) := '6E673D21312C746869732E696E697428297D72657475726E206E28762C2243726F7070657222292C7228762C5B7B6B65793A22696E6974222C76616C75653A6E2866756E6374696F6E28297B76617220673D746869732E656C656D656E742C6D3D672E74';
wwv_flow_imp.g_varchar2_table(501) := '61674E616D652E746F4C6F7765724361736528292C503B69662821675B785D297B696628675B785D3D746869732C6D3D3D3D22696D6722297B696628746869732E6973496D673D21302C503D672E676574417474726962757465282273726322297C7C22';
wwv_flow_imp.g_varchar2_table(502) := '222C746869732E6F726967696E616C55726C3D502C21502972657475726E3B503D672E7372637D656C7365206D3D3D3D2263616E76617322262677696E646F772E48544D4C43616E766173456C656D656E74262628503D672E746F4461746155524C2829';
wwv_flow_imp.g_varchar2_table(503) := '293B746869732E6C6F61642850297D7D2C22696E697422297D2C7B6B65793A226C6F6164222C76616C75653A6E2866756E6374696F6E2867297B766172206D3D746869733B69662867297B746869732E75726C3D672C746869732E696D61676544617461';
wwv_flow_imp.g_varchar2_table(504) := '3D7B7D3B76617220503D746869732E656C656D656E742C773D746869732E6F7074696F6E733B69662821772E726F74617461626C65262621772E7363616C61626C65262628772E636865636B4F7269656E746174696F6E3D2131292C21772E636865636B';
wwv_flow_imp.g_varchar2_table(505) := '4F7269656E746174696F6E7C7C2177696E646F772E4172726179427566666572297B746869732E636C6F6E6528293B72657475726E7D6966286E742E74657374286729297B626C2E746573742867293F746869732E72656164285462286729293A746869';
wwv_flow_imp.g_varchar2_table(506) := '732E636C6F6E6528293B72657475726E7D766172205F3D6E657720584D4C48747470526571756573742C433D746869732E636C6F6E652E62696E642874686973293B746869732E72656C6F6164696E673D21302C746869732E7868723D5F2C5F2E6F6E61';
wwv_flow_imp.g_varchar2_table(507) := '626F72743D432C5F2E6F6E6572726F723D432C5F2E6F6E74696D656F75743D432C5F2E6F6E70726F67726573733D66756E6374696F6E28297B5F2E676574526573706F6E73654865616465722822636F6E74656E742D747970652229213D3D687226265F';
wwv_flow_imp.g_varchar2_table(508) := '2E61626F727428297D2C5F2E6F6E6C6F61643D66756E6374696F6E28297B6D2E72656164285F2E726573706F6E7365297D2C5F2E6F6E6C6F6164656E643D66756E6374696F6E28297B6D2E72656C6F6164696E673D21312C6D2E7868723D6E756C6C7D2C';
wwv_flow_imp.g_varchar2_table(509) := '772E636865636B43726F73734F726967696E262658702867292626502E63726F73734F726967696E262628673D5970286729292C5F2E6F70656E2822474554222C67292C5F2E726573706F6E7365547970653D226172726179627566666572222C5F2E77';
wwv_flow_imp.g_varchar2_table(510) := '69746843726564656E7469616C733D502E63726F73734F726967696E3D3D3D227573652D63726564656E7469616C73222C5F2E73656E6428297D7D2C226C6F616422297D2C7B6B65793A2272656164222C76616C75653A6E2866756E6374696F6E286729';
wwv_flow_imp.g_varchar2_table(511) := '7B766172206D3D746869732E6F7074696F6E732C503D746869732E696D616765446174612C773D52622867292C5F3D302C433D312C443D313B696628773E31297B746869732E75726C3D416228672C6872293B76617220413D55622877293B5F3D412E72';
wwv_flow_imp.g_varchar2_table(512) := '6F746174652C433D412E7363616C65582C443D412E7363616C65597D6D2E726F74617461626C65262628502E726F746174653D5F292C6D2E7363616C61626C65262628502E7363616C65583D432C502E7363616C65593D44292C746869732E636C6F6E65';
wwv_flow_imp.g_varchar2_table(513) := '28297D2C227265616422297D2C7B6B65793A22636C6F6E65222C76616C75653A6E2866756E6374696F6E28297B76617220673D746869732E656C656D656E742C6D3D746869732E75726C2C503D672E63726F73734F726967696E2C773D6D3B746869732E';
wwv_flow_imp.g_varchar2_table(514) := '6F7074696F6E732E636865636B43726F73734F726967696E26265870286D29262628507C7C28503D22616E6F6E796D6F757322292C773D5970286D29292C746869732E63726F73734F726967696E3D502C746869732E63726F73734F726967696E55726C';
wwv_flow_imp.g_varchar2_table(515) := '3D773B766172205F3D646F63756D656E742E637265617465456C656D656E742822696D6722293B502626285F2E63726F73734F726967696E3D50292C5F2E7372633D777C7C6D2C5F2E616C743D672E616C747C7C2254686520696D61676520746F206372';
wwv_flow_imp.g_varchar2_table(516) := '6F70222C746869732E696D6167653D5F2C5F2E6F6E6C6F61643D746869732E73746172742E62696E642874686973292C5F2E6F6E6572726F723D746869732E73746F702E62696E642874686973292C6A65285F2C6869292C672E706172656E744E6F6465';
wwv_flow_imp.g_varchar2_table(517) := '2E696E736572744265666F7265285F2C672E6E6578745369626C696E67297D2C22636C6F6E6522297D2C7B6B65793A227374617274222C76616C75653A6E2866756E6374696F6E28297B76617220673D746869732C6D3D746869732E696D6167653B6D2E';
wwv_flow_imp.g_varchar2_table(518) := '6F6E6C6F61643D6E756C6C2C6D2E6F6E6572726F723D6E756C6C2C746869732E73697A696E673D21303B76617220503D532E6E6176696761746F7226262F283F3A695061647C6950686F6E657C69506F64292E2A3F4170706C655765624B69742F692E74';
wwv_flow_imp.g_varchar2_table(519) := '65737428532E6E6176696761746F722E757365724167656E74292C773D6E2866756E6374696F6E28412C54297B536528672E696D616765446174612C7B6E61747572616C57696474683A412C6E61747572616C4865696768743A542C6173706563745261';
wwv_flow_imp.g_varchar2_table(520) := '74696F3A412F547D292C672E73697A696E673D21312C672E73697A65643D21302C672E6275696C6428297D2C22646F6E6522293B6966286D2E6E61747572616C576964746826262150297B77286D2E6E61747572616C57696474682C6D2E6E6174757261';
wwv_flow_imp.g_varchar2_table(521) := '6C486569676874293B72657475726E7D766172205F3D646F63756D656E742E637265617465456C656D656E742822696D6722292C433D646F63756D656E742E626F64797C7C646F63756D656E742E646F63756D656E74456C656D656E743B746869732E73';
wwv_flow_imp.g_varchar2_table(522) := '697A696E67496D6167653D5F2C5F2E6F6E6C6F61643D66756E6374696F6E28297B77285F2E77696474682C5F2E686569676874292C507C7C432E72656D6F76654368696C64285F297D2C5F2E7372633D6D2E7372632C507C7C285F2E7374796C652E6373';
wwv_flow_imp.g_varchar2_table(523) := '73546578743D226C6566743A303B6D61782D6865696768743A6E6F6E6521696D706F7274616E743B6D61782D77696474683A6E6F6E6521696D706F7274616E743B6D696E2D6865696768743A3021696D706F7274616E743B6D696E2D77696474683A3021';
wwv_flow_imp.g_varchar2_table(524) := '696D706F7274616E743B6F7061636974793A303B706F736974696F6E3A6162736F6C7574653B746F703A303B7A2D696E6465783A2D313B222C432E617070656E644368696C64285F29297D2C22737461727422297D2C7B6B65793A2273746F70222C7661';
wwv_flow_imp.g_varchar2_table(525) := '6C75653A6E2866756E6374696F6E28297B76617220673D746869732E696D6167653B672E6F6E6C6F61643D6E756C6C2C672E6F6E6572726F723D6E756C6C2C672E706172656E744E6F64652E72656D6F76654368696C642867292C746869732E696D6167';
wwv_flow_imp.g_varchar2_table(526) := '653D6E756C6C7D2C2273746F7022297D2C7B6B65793A226275696C64222C76616C75653A6E2866756E6374696F6E28297B696628212821746869732E73697A65647C7C746869732E726561647929297B76617220673D746869732E656C656D656E742C6D';
wwv_flow_imp.g_varchar2_table(527) := '3D746869732E6F7074696F6E732C503D746869732E696D6167652C773D672E706172656E744E6F64652C5F3D646F63756D656E742E637265617465456C656D656E74282264697622293B5F2E696E6E657248544D4C3D536C3B76617220433D5F2E717565';
wwv_flow_imp.g_varchar2_table(528) := '727953656C6563746F7228222E222E636F6E63617428782C222D636F6E7461696E65722229292C443D432E717565727953656C6563746F7228222E222E636F6E63617428782C222D63616E7661732229292C413D432E717565727953656C6563746F7228';
wwv_flow_imp.g_varchar2_table(529) := '222E222E636F6E63617428782C222D647261672D626F782229292C543D432E717565727953656C6563746F7228222E222E636F6E63617428782C222D63726F702D626F782229292C4F3D542E717565727953656C6563746F7228222E222E636F6E636174';
wwv_flow_imp.g_varchar2_table(530) := '28782C222D666163652229293B746869732E636F6E7461696E65723D772C746869732E63726F707065723D432C746869732E63616E7661733D442C746869732E64726167426F783D412C746869732E63726F70426F783D542C746869732E76696577426F';
wwv_flow_imp.g_varchar2_table(531) := '783D432E717565727953656C6563746F7228222E222E636F6E63617428782C222D766965772D626F782229292C746869732E666163653D4F2C442E617070656E644368696C642850292C6A6528672C4665292C772E696E736572744265666F726528432C';
wwv_flow_imp.g_varchar2_table(532) := '672E6E6578745369626C696E67292C746869732E6973496D677C7C776928502C6869292C746869732E696E69745072657669657728292C746869732E62696E6428292C6D2E696E697469616C417370656374526174696F3D4D6174682E6D617828302C6D';
wwv_flow_imp.g_varchar2_table(533) := '2E696E697469616C417370656374526174696F297C7C4E614E2C6D2E617370656374526174696F3D4D6174682E6D617828302C6D2E617370656374526174696F297C7C4E614E2C6D2E766965774D6F64653D4D6174682E6D617828302C4D6174682E6D69';
wwv_flow_imp.g_varchar2_table(534) := '6E28332C4D6174682E726F756E64286D2E766965774D6F64652929297C7C302C6A6528542C4665292C6D2E6775696465737C7C6A6528542E676574456C656D656E74734279436C6173734E616D652822222E636F6E63617428782C222D64617368656422';
wwv_flow_imp.g_varchar2_table(535) := '29292C4665292C6D2E63656E7465727C7C6A6528542E676574456C656D656E74734279436C6173734E616D652822222E636F6E63617428782C222D63656E7465722229292C4665292C6D2E6261636B67726F756E6426266A6528432C22222E636F6E6361';
wwv_flow_imp.g_varchar2_table(536) := '7428782C222D62672229292C6D2E686967686C696768747C7C6A65284F2C56292C6D2E63726F70426F784D6F7661626C652626286A65284F2C49292C756E284F2C4C2C5529292C6D2E63726F70426F78526573697A61626C657C7C286A6528542E676574';
wwv_flow_imp.g_varchar2_table(537) := '456C656D656E74734279436C6173734E616D652822222E636F6E63617428782C222D6C696E652229292C4665292C6A6528542E676574456C656D656E74734279436C6173734E616D652822222E636F6E63617428782C222D706F696E742229292C466529';
wwv_flow_imp.g_varchar2_table(538) := '292C746869732E72656E64657228292C746869732E72656164793D21302C746869732E736574447261674D6F6465286D2E647261674D6F6465292C6D2E6175746F43726F702626746869732E63726F7028292C746869732E73657444617461286D2E6461';
wwv_flow_imp.g_varchar2_table(539) := '7461292C5374286D2E7265616479292626646928672C6A722C6D2E72656164792C7B6F6E63653A21307D292C466F28672C6A72297D7D2C226275696C6422297D2C7B6B65793A22756E6275696C64222C76616C75653A6E2866756E6374696F6E28297B74';
wwv_flow_imp.g_varchar2_table(540) := '6869732E7265616479262628746869732E72656164793D21312C746869732E756E62696E6428292C746869732E72657365745072657669657728292C746869732E63726F707065722E706172656E744E6F64652E72656D6F76654368696C642874686973';
wwv_flow_imp.g_varchar2_table(541) := '2E63726F70706572292C776928746869732E656C656D656E742C466529297D2C22756E6275696C6422297D2C7B6B65793A22756E637265617465222C76616C75653A6E2866756E6374696F6E28297B746869732E72656164793F28746869732E756E6275';
wwv_flow_imp.g_varchar2_table(542) := '696C6428292C746869732E72656164793D21312C746869732E63726F707065643D2131293A746869732E73697A696E673F28746869732E73697A696E67496D6167652E6F6E6C6F61643D6E756C6C2C746869732E73697A696E673D21312C746869732E73';
wwv_flow_imp.g_varchar2_table(543) := '697A65643D2131293A746869732E72656C6F6164696E673F28746869732E7868722E6F6E61626F72743D6E756C6C2C746869732E7868722E61626F72742829293A746869732E696D6167652626746869732E73746F7028297D2C22756E63726561746522';
wwv_flow_imp.g_varchar2_table(544) := '297D5D2C5B7B6B65793A226E6F436F6E666C696374222C76616C75653A6E2866756E6374696F6E28297B72657475726E2077696E646F772E43726F707065723D42622C767D2C226E6F436F6E666C69637422297D2C7B6B65793A2273657444656661756C';
wwv_flow_imp.g_varchar2_table(545) := '7473222C76616C75653A6E2866756E6374696F6E2867297B5365286E6E2C7172286729262667297D2C2273657444656661756C747322297D5D292C767D28293B72657475726E205365284A702E70726F746F747970652C6B622C44622C49622C4D622C4E';
wwv_flow_imp.g_varchar2_table(546) := '622C4C62292C4A707D297D293B7661722061763D6865282864442C7A75293D3E7B2275736520737472696374223B7A752E6578706F7274733D70633B7A752E6578706F7274732E69734D6F62696C653D70633B7A752E6578706F7274732E64656661756C';
wwv_flow_imp.g_varchar2_table(547) := '743D70633B766172205F503D2F28616E64726F69647C62625C642B7C6D6565676F292E2B6D6F62696C657C61726D76376C7C6176616E74676F7C626164615C2F7C626C61636B62657272797C626C617A65727C636F6D70616C7C656C61696E657C66656E';
wwv_flow_imp.g_varchar2_table(548) := '6E65637C686970746F707C69656D6F62696C657C697028686F6E657C6F64297C697269737C6B696E646C657C6C6765207C6D61656D6F7C6D6964707C6D6D707C6D6F62696C652E2B66697265666F787C6E657466726F6E747C6F70657261206D286F627C';
wwv_flow_imp.g_varchar2_table(549) := '696E29697C70616C6D28206F73293F7C70686F6E657C70286978697C7265295C2F7C706C75636B65727C706F636B65747C7073707C7365726965735B34365D307C73616D73756E6762726F777365727C73796D6269616E7C7472656F7C75705C2E286272';
wwv_flow_imp.g_varchar2_table(550) := '6F777365727C6C696E6B297C766F6461666F6E657C7761707C77696E646F7773202863657C70686F6E65297C7864617C7869696E6F2F692C46503D2F43724F532F2C78503D2F616E64726F69647C697061647C706C6179626F6F6B7C73696C6B2F693B66';
wwv_flow_imp.g_varchar2_table(551) := '756E6374696F6E2070632869297B697C7C28693D7B7D293B6C657420653D692E75613B69662821652626747970656F66206E6176696761746F723C227522262628653D6E6176696761746F722E757365724167656E74292C652626652E68656164657273';
wwv_flow_imp.g_varchar2_table(552) := '2626747970656F6620652E686561646572735B22757365722D6167656E74225D3D3D22737472696E6722262628653D652E686561646572735B22757365722D6167656E74225D292C747970656F662065213D22737472696E67222972657475726E21313B';
wwv_flow_imp.g_varchar2_table(553) := '6C657420743D5F502E7465737428652926262146502E746573742865297C7C2121692E7461626C6574262678502E746573742865293B72657475726E21742626692E7461626C65742626692E6665617475726544657465637426266E6176696761746F72';
wwv_flow_imp.g_varchar2_table(554) := '26266E6176696761746F722E6D6178546F756368506F696E74733E312626652E696E6465784F6628224D6163696E746F73682229213D3D2D312626652E696E6465784F6628225361666172692229213D3D2D31262628743D2130292C747D6E2870632C22';
wwv_flow_imp.g_varchar2_table(555) := '69734D6F62696C6522297D293B7661722051763D6865282866392C5976293D3E7B2275736520737472696374223B59762E6578706F7274733D6E2866756E6374696F6E28652C74297B696628743D742E73706C697428223A22295B305D2C653D2B652C21';
wwv_flow_imp.g_varchar2_table(556) := '652972657475726E21313B7377697463682874297B636173652268747470223A63617365227773223A72657475726E2065213D3D38303B63617365226874747073223A6361736522777373223A72657475726E2065213D3D3434333B6361736522667470';
wwv_flow_imp.g_varchar2_table(557) := '223A72657475726E2065213D3D32313B6361736522676F70686572223A72657475726E2065213D3D37303B636173652266696C65223A72657475726E21317D72657475726E2065213D3D307D2C22726571756972656422297D293B7661722065303D6865';
wwv_flow_imp.g_varchar2_table(558) := '2857633D3E7B2275736520737472696374223B76617220495F3D4F626A6563742E70726F746F747970652E6861734F776E50726F70657274792C4D5F3B66756E6374696F6E204A762869297B7472797B72657475726E206465636F6465555249436F6D70';
wwv_flow_imp.g_varchar2_table(559) := '6F6E656E7428692E7265706C616365282F5C2B2F672C22202229297D63617463687B72657475726E206E756C6C7D7D6E284A762C226465636F646522293B66756E6374696F6E205A762869297B7472797B72657475726E20656E636F6465555249436F6D';
wwv_flow_imp.g_varchar2_table(560) := '706F6E656E742869297D63617463687B72657475726E206E756C6C7D7D6E285A762C22656E636F646522293B66756E6374696F6E204E5F2869297B666F722876617220653D2F285B5E3D3F23265D2B293D3F285B5E265D2A292F672C743D7B7D2C723B72';
wwv_flow_imp.g_varchar2_table(561) := '3D652E657865632869293B297B76617220733D4A7628725B315D292C6F3D4A7628725B325D293B733D3D3D6E756C6C7C7C6F3D3D3D6E756C6C7C7C7320696E20747C7C28745B735D3D6F297D72657475726E20747D6E284E5F2C22717565727973747269';
wwv_flow_imp.g_varchar2_table(562) := '6E6722293B66756E6374696F6E204C5F28692C65297B653D657C7C22223B76617220743D5B5D2C722C733B747970656F662065213D22737472696E6722262628653D223F22293B666F72287320696E206929696628495F2E63616C6C28692C7329297B69';
wwv_flow_imp.g_varchar2_table(563) := '6628723D695B735D2C2172262628723D3D3D6E756C6C7C7C723D3D3D4D5F7C7C69734E614E28722929262628723D2222292C733D5A762873292C723D5A762872292C733D3D3D6E756C6C7C7C723D3D3D6E756C6C29636F6E74696E75653B742E70757368';
wwv_flow_imp.g_varchar2_table(564) := '28732B223D222B72297D72657475726E20742E6C656E6774683F652B742E6A6F696E28222622293A22227D6E284C5F2C227175657279737472696E6769667922293B57632E737472696E676966793D4C5F3B57632E70617273653D4E5F7D293B76617220';
wwv_flow_imp.g_varchar2_table(565) := '6C303D6865282876392C6130293D3E7B2275736520737472696374223B7661722069303D517628292C51753D653028292C425F3D2F5E5B5C7830302D5C7832305C75303061305C75313638305C75323030302D5C75323030615C75323032385C75323032';
wwv_flow_imp.g_varchar2_table(566) := '395C75323032665C75323035665C75333030305C75666566665D2B2F2C72303D2F5B5C6E5C725C745D2F672C7A5F3D2F5E5B412D5A612D7A5D5B412D5A612D7A302D392B2D2E5D2A3A5C2F5C2F2F2C73303D2F3A5C642B242F2C6A5F3D2F5E285B612D7A';
wwv_flow_imp.g_varchar2_table(567) := '5D5B612D7A302D392E2B2D5D2A3A293F285C2F5C2F293F285B5C5C2F5D2B293F285B5C535C735D2A292F692C485F3D2F5E5B612D7A412D5A5D3A2F3B66756E6374696F6E204B632869297B72657475726E28697C7C2222292E746F537472696E6728292E';
wwv_flow_imp.g_varchar2_table(568) := '7265706C61636528425F2C2222297D6E284B632C227472696D4C65667422293B7661722047633D5B5B2223222C2268617368225D2C5B223F222C227175657279225D2C6E2866756E6374696F6E28652C74297B72657475726E20727228742E70726F746F';
wwv_flow_imp.g_varchar2_table(569) := '636F6C293F652E7265706C616365282F5C5C2F672C222F22293A657D2C2273616E6974697A6522292C5B222F222C22706174686E616D65225D2C5B2240222C2261757468222C315D2C5B4E614E2C22686F7374222C766F696420302C312C315D2C5B2F3A';
wwv_flow_imp.g_varchar2_table(570) := '285C642A29242F2C22706F7274222C766F696420302C315D2C5B4E614E2C22686F73746E616D65222C766F696420302C312C315D5D2C74303D7B686173683A312C71756572793A317D3B66756E6374696F6E206F302869297B76617220653B747970656F';
wwv_flow_imp.g_varchar2_table(571) := '662077696E646F773C2275223F653D77696E646F773A747970656F6620676C6F62616C3C2275223F653D676C6F62616C3A747970656F662073656C663C2275223F653D73656C663A653D7B7D3B76617220743D652E6C6F636174696F6E7C7C7B7D3B693D';
wwv_flow_imp.g_varchar2_table(572) := '697C7C743B76617220723D7B7D2C733D747970656F6620692C6F3B696628692E70726F746F636F6C3D3D3D22626C6F623A2229723D6E657720737228756E65736361706528692E706174686E616D65292C7B7D293B656C736520696628733D3D3D227374';
wwv_flow_imp.g_varchar2_table(573) := '72696E6722297B723D6E657720737228692C7B7D293B666F72286F20696E2074302964656C65746520725B6F5D7D656C736520696628733D3D3D226F626A65637422297B666F72286F20696E2069296F20696E2074307C7C28725B6F5D3D695B6F5D293B';
wwv_flow_imp.g_varchar2_table(574) := '722E736C61736865733D3D3D766F69642030262628722E736C61736865733D7A5F2E7465737428692E6872656629297D72657475726E20727D6E286F302C226C6F6C636174696F6E22293B66756E6374696F6E2072722869297B72657475726E20693D3D';
wwv_flow_imp.g_varchar2_table(575) := '3D2266696C653A227C7C693D3D3D226674703A227C7C693D3D3D22687474703A227C7C693D3D3D2268747470733A227C7C693D3D3D2277733A227C7C693D3D3D227773733A227D6E2872722C2269735370656369616C22293B66756E6374696F6E206E30';
wwv_flow_imp.g_varchar2_table(576) := '28692C65297B693D4B632869292C693D692E7265706C6163652872302C2222292C653D657C7C7B7D3B76617220743D6A5F2E657865632869292C723D745B315D3F745B315D2E746F4C6F7765724361736528293A22222C733D2121745B325D2C6F3D2121';
wwv_flow_imp.g_varchar2_table(577) := '745B335D2C613D302C6C3B72657475726E20733F6F3F286C3D745B325D2B745B335D2B745B345D2C613D745B325D2E6C656E6774682B745B335D2E6C656E677468293A286C3D745B325D2B745B345D2C613D745B325D2E6C656E677468293A6F3F286C3D';
wwv_flow_imp.g_varchar2_table(578) := '745B335D2B745B345D2C613D745B335D2E6C656E677468293A6C3D745B345D2C723D3D3D2266696C653A223F613E3D322626286C3D6C2E736C696365283229293A72722872293F6C3D745B345D3A723F732626286C3D6C2E736C696365283229293A613E';
wwv_flow_imp.g_varchar2_table(579) := '3D322626727228652E70726F746F636F6C292626286C3D745B345D292C7B70726F746F636F6C3A722C736C61736865733A737C7C72722872292C736C6173686573436F756E743A612C726573743A6C7D7D6E286E302C226578747261637450726F746F63';
wwv_flow_imp.g_varchar2_table(580) := '6F6C22293B66756E6374696F6E20245F28692C65297B696628693D3D3D22222972657475726E20653B666F722876617220743D28657C7C222F22292E73706C697428222F22292E736C69636528302C2D31292E636F6E63617428692E73706C697428222F';
wwv_flow_imp.g_varchar2_table(581) := '2229292C723D742E6C656E6774682C733D745B722D315D2C6F3D21312C613D303B722D2D3B29745B725D3D3D3D222E223F742E73706C69636528722C31293A745B725D3D3D3D222E2E223F28742E73706C69636528722C31292C612B2B293A6126262872';
wwv_flow_imp.g_varchar2_table(582) := '3D3D3D302626286F3D2130292C742E73706C69636528722C31292C612D2D293B72657475726E206F2626742E756E7368696674282222292C28733D3D3D222E227C7C733D3D3D222E2E22292626742E70757368282222292C742E6A6F696E28222F22297D';
wwv_flow_imp.g_varchar2_table(583) := '6E28245F2C227265736F6C766522293B66756E6374696F6E20737228692C652C74297B696628693D4B632869292C693D692E7265706C6163652872302C2222292C21287468697320696E7374616E63656F66207372292972657475726E206E6577207372';
wwv_flow_imp.g_varchar2_table(584) := '28692C652C74293B76617220722C732C6F2C612C6C2C682C633D47632E736C69636528292C643D747970656F6620652C663D746869732C793D303B666F722864213D3D226F626A65637422262664213D3D22737472696E6722262628743D652C653D6E75';
wwv_flow_imp.g_varchar2_table(585) := '6C6C292C742626747970656F662074213D2266756E6374696F6E22262628743D51752E7061727365292C653D6F302865292C733D6E3028697C7C22222C65292C723D21732E70726F746F636F6C262621732E736C61736865732C662E736C61736865733D';
wwv_flow_imp.g_varchar2_table(586) := '732E736C61736865737C7C722626652E736C61736865732C662E70726F746F636F6C3D732E70726F746F636F6C7C7C652E70726F746F636F6C7C7C22222C693D732E726573742C28732E70726F746F636F6C3D3D3D2266696C653A22262628732E736C61';
wwv_flow_imp.g_varchar2_table(587) := '73686573436F756E74213D3D327C7C485F2E74657374286929297C7C21732E736C6173686573262628732E70726F746F636F6C7C7C732E736C6173686573436F756E743C327C7C21727228662E70726F746F636F6C292929262628635B335D3D5B2F282E';
wwv_flow_imp.g_varchar2_table(588) := '2A292F2C22706174686E616D65225D293B793C632E6C656E6774683B792B2B297B696628613D635B795D2C747970656F6620613D3D2266756E6374696F6E22297B693D6128692C66293B636F6E74696E75657D6F3D615B305D2C683D615B315D2C6F213D';
wwv_flow_imp.g_varchar2_table(589) := '3D6F3F665B685D3D693A747970656F66206F3D3D22737472696E67223F286C3D6F3D3D3D2240223F692E6C617374496E6465784F66286F293A692E696E6465784F66286F292C7E6C262628747970656F6620615B325D3D3D226E756D626572223F28665B';
wwv_flow_imp.g_varchar2_table(590) := '685D3D692E736C69636528302C6C292C693D692E736C696365286C2B615B325D29293A28665B685D3D692E736C696365286C292C693D692E736C69636528302C6C292929293A286C3D6F2E6578656328692929262628665B685D3D6C5B315D2C693D692E';
wwv_flow_imp.g_varchar2_table(591) := '736C69636528302C6C2E696E64657829292C665B685D3D665B685D7C7C722626615B335D2626655B685D7C7C22222C615B345D262628665B685D3D665B685D2E746F4C6F776572436173652829297D74262628662E71756572793D7428662E7175657279';
wwv_flow_imp.g_varchar2_table(592) := '29292C722626652E736C61736865732626662E706174686E616D652E636861724174283029213D3D222F22262628662E706174686E616D65213D3D22227C7C652E706174686E616D65213D3D222229262628662E706174686E616D653D245F28662E7061';
wwv_flow_imp.g_varchar2_table(593) := '74686E616D652C652E706174686E616D6529292C662E706174686E616D652E636861724174283029213D3D222F222626727228662E70726F746F636F6C29262628662E706174686E616D653D222F222B662E706174686E616D65292C693028662E706F72';
wwv_flow_imp.g_varchar2_table(594) := '742C662E70726F746F636F6C297C7C28662E686F73743D662E686F73746E616D652C662E706F72743D2222292C662E757365726E616D653D662E70617373776F72643D22222C662E617574682626286C3D662E617574682E696E6465784F6628223A2229';
wwv_flow_imp.g_varchar2_table(595) := '2C7E6C3F28662E757365726E616D653D662E617574682E736C69636528302C6C292C662E757365726E616D653D656E636F6465555249436F6D706F6E656E74286465636F6465555249436F6D706F6E656E7428662E757365726E616D6529292C662E7061';
wwv_flow_imp.g_varchar2_table(596) := '7373776F72643D662E617574682E736C696365286C2B31292C662E70617373776F72643D656E636F6465555249436F6D706F6E656E74286465636F6465555249436F6D706F6E656E7428662E70617373776F72642929293A662E757365726E616D653D65';
wwv_flow_imp.g_varchar2_table(597) := '6E636F6465555249436F6D706F6E656E74286465636F6465555249436F6D706F6E656E7428662E6175746829292C662E617574683D662E70617373776F72643F662E757365726E616D652B223A222B662E70617373776F72643A662E757365726E616D65';
wwv_flow_imp.g_varchar2_table(598) := '292C662E6F726967696E3D662E70726F746F636F6C213D3D2266696C653A222626727228662E70726F746F636F6C292626662E686F73743F662E70726F746F636F6C2B222F2F222B662E686F73743A226E756C6C222C662E687265663D662E746F537472';
wwv_flow_imp.g_varchar2_table(599) := '696E6728297D6E2873722C2255726C22293B66756E6374696F6E20715F28692C652C74297B76617220723D746869733B7377697463682869297B63617365227175657279223A747970656F6620653D3D22737472696E67222626652E6C656E6774682626';
wwv_flow_imp.g_varchar2_table(600) := '28653D28747C7C51752E706172736529286529292C725B695D3D653B627265616B3B6361736522706F7274223A725B695D3D652C693028652C722E70726F746F636F6C293F65262628722E686F73743D722E686F73746E616D652B223A222B65293A2872';
wwv_flow_imp.g_varchar2_table(601) := '2E686F73743D722E686F73746E616D652C725B695D3D2222293B627265616B3B6361736522686F73746E616D65223A725B695D3D652C722E706F7274262628652B3D223A222B722E706F7274292C722E686F73743D653B627265616B3B6361736522686F';
wwv_flow_imp.g_varchar2_table(602) := '7374223A725B695D3D652C73302E746573742865293F28653D652E73706C697428223A22292C722E706F72743D652E706F7028292C722E686F73746E616D653D652E6A6F696E28223A2229293A28722E686F73746E616D653D652C722E706F72743D2222';
wwv_flow_imp.g_varchar2_table(603) := '293B627265616B3B636173652270726F746F636F6C223A722E70726F746F636F6C3D652E746F4C6F7765724361736528292C722E736C61736865733D21743B627265616B3B6361736522706174686E616D65223A636173652268617368223A6966286529';
wwv_flow_imp.g_varchar2_table(604) := '7B76617220733D693D3D3D22706174686E616D65223F222F223A2223223B725B695D3D652E636861724174283029213D3D733F732B653A657D656C736520725B695D3D653B627265616B3B6361736522757365726E616D65223A63617365227061737377';
wwv_flow_imp.g_varchar2_table(605) := '6F7264223A725B695D3D656E636F6465555249436F6D706F6E656E742865293B627265616B3B636173652261757468223A766172206F3D652E696E6465784F6628223A22293B7E6F3F28722E757365726E616D653D652E736C69636528302C6F292C722E';
wwv_flow_imp.g_varchar2_table(606) := '757365726E616D653D656E636F6465555249436F6D706F6E656E74286465636F6465555249436F6D706F6E656E7428722E757365726E616D6529292C722E70617373776F72643D652E736C696365286F2B31292C722E70617373776F72643D656E636F64';
wwv_flow_imp.g_varchar2_table(607) := '65555249436F6D706F6E656E74286465636F6465555249436F6D706F6E656E7428722E70617373776F72642929293A722E757365726E616D653D656E636F6465555249436F6D706F6E656E74286465636F6465555249436F6D706F6E656E74286529297D';
wwv_flow_imp.g_varchar2_table(608) := '666F722876617220613D303B613C47632E6C656E6774683B612B2B297B766172206C3D47635B615D3B6C5B345D262628725B6C5B315D5D3D725B6C5B315D5D2E746F4C6F776572436173652829297D72657475726E20722E617574683D722E7061737377';
wwv_flow_imp.g_varchar2_table(609) := '6F72643F722E757365726E616D652B223A222B722E70617373776F72643A722E757365726E616D652C722E6F726967696E3D722E70726F746F636F6C213D3D2266696C653A222626727228722E70726F746F636F6C292626722E686F73743F722E70726F';
wwv_flow_imp.g_varchar2_table(610) := '746F636F6C2B222F2F222B722E686F73743A226E756C6C222C722E687265663D722E746F537472696E6728292C727D6E28715F2C2273657422293B66756E6374696F6E20565F2869297B2821697C7C747970656F662069213D2266756E6374696F6E2229';
wwv_flow_imp.g_varchar2_table(611) := '262628693D51752E737472696E67696679293B76617220652C743D746869732C723D742E686F73742C733D742E70726F746F636F6C3B732626732E63686172417428732E6C656E6774682D3129213D3D223A22262628732B3D223A22293B766172206F3D';
wwv_flow_imp.g_varchar2_table(612) := '732B28742E70726F746F636F6C2626742E736C61736865737C7C727228742E70726F746F636F6C293F222F2F223A2222293B72657475726E20742E757365726E616D653F286F2B3D742E757365726E616D652C742E70617373776F72642626286F2B3D22';
wwv_flow_imp.g_varchar2_table(613) := '3A222B742E70617373776F7264292C6F2B3D224022293A742E70617373776F72643F286F2B3D223A222B742E70617373776F72642C6F2B3D224022293A742E70726F746F636F6C213D3D2266696C653A222626727228742E70726F746F636F6C29262621';
wwv_flow_imp.g_varchar2_table(614) := '722626742E706174686E616D65213D3D222F222626286F2B3D224022292C28725B722E6C656E6774682D315D3D3D3D223A227C7C73302E7465737428742E686F73746E616D6529262621742E706F727429262628722B3D223A22292C6F2B3D722B742E70';
wwv_flow_imp.g_varchar2_table(615) := '6174686E616D652C653D747970656F6620742E71756572793D3D226F626A656374223F6928742E7175657279293A742E71756572792C652626286F2B3D652E636861724174283029213D3D223F223F223F222B653A65292C742E686173682626286F2B3D';
wwv_flow_imp.g_varchar2_table(616) := '742E68617368292C6F7D6E28565F2C22746F537472696E6722293B73722E70726F746F747970653D7B7365743A715F2C746F537472696E673A565F7D3B73722E6578747261637450726F746F636F6C3D6E303B73722E6C6F636174696F6E3D6F303B7372';
wwv_flow_imp.g_varchar2_table(617) := '2E7472696D4C6566743D4B633B73722E71733D51753B61302E6578706F7274733D73727D293B7661722070703D6865282841492C6370293D3E7B747970656F662063703C22752226262863702E6578706F7274733D6169293B66756E6374696F6E206169';
wwv_flow_imp.g_varchar2_table(618) := '2869297B696628692972657475726E2071352869297D6E2861692C22456D697474657222293B66756E6374696F6E2071352869297B666F7228766172206520696E2061692E70726F746F7479706529695B655D3D61692E70726F746F747970655B655D3B';
wwv_flow_imp.g_varchar2_table(619) := '72657475726E20697D6E2871352C226D6978696E22293B61692E70726F746F747970652E6F6E3D61692E70726F746F747970652E6164644576656E744C697374656E65723D66756E6374696F6E28692C65297B72657475726E20746869732E5F63616C6C';
wwv_flow_imp.g_varchar2_table(620) := '6261636B733D746869732E5F63616C6C6261636B737C7C7B7D2C28746869732E5F63616C6C6261636B735B2224222B695D3D746869732E5F63616C6C6261636B735B2224222B695D7C7C5B5D292E707573682865292C746869737D3B61692E70726F746F';
wwv_flow_imp.g_varchar2_table(621) := '747970652E6F6E63653D66756E6374696F6E28692C65297B66756E6374696F6E207428297B746869732E6F666628692C74292C652E6170706C7928746869732C617267756D656E7473297D72657475726E206E28742C226F6E22292C742E666E3D652C74';
wwv_flow_imp.g_varchar2_table(622) := '6869732E6F6E28692C74292C746869737D3B61692E70726F746F747970652E6F66663D61692E70726F746F747970652E72656D6F76654C697374656E65723D61692E70726F746F747970652E72656D6F7665416C6C4C697374656E6572733D61692E7072';
wwv_flow_imp.g_varchar2_table(623) := '6F746F747970652E72656D6F76654576656E744C697374656E65723D66756E6374696F6E28692C65297B696628746869732E5F63616C6C6261636B733D746869732E5F63616C6C6261636B737C7C7B7D2C617267756D656E74732E6C656E6774683D3D30';
wwv_flow_imp.g_varchar2_table(624) := '2972657475726E20746869732E5F63616C6C6261636B733D7B7D2C746869733B76617220743D746869732E5F63616C6C6261636B735B2224222B695D3B69662821742972657475726E20746869733B696628617267756D656E74732E6C656E6774683D3D';
wwv_flow_imp.g_varchar2_table(625) := '312972657475726E2064656C65746520746869732E5F63616C6C6261636B735B2224222B695D2C746869733B666F722876617220722C733D303B733C742E6C656E6774683B732B2B29696628723D745B735D2C723D3D3D657C7C722E666E3D3D3D65297B';
wwv_flow_imp.g_varchar2_table(626) := '742E73706C69636528732C31293B627265616B7D72657475726E20742E6C656E6774683D3D3D30262664656C65746520746869732E5F63616C6C6261636B735B2224222B695D2C746869737D3B61692E70726F746F747970652E656D69743D66756E6374';
wwv_flow_imp.g_varchar2_table(627) := '696F6E2869297B746869732E5F63616C6C6261636B733D746869732E5F63616C6C6261636B737C7C7B7D3B666F722876617220653D6E657720417272617928617267756D656E74732E6C656E6774682D31292C743D746869732E5F63616C6C6261636B73';
wwv_flow_imp.g_varchar2_table(628) := '5B2224222B695D2C723D313B723C617267756D656E74732E6C656E6774683B722B2B29655B722D315D3D617267756D656E74735B725D3B69662874297B743D742E736C6963652830293B666F722876617220723D302C733D742E6C656E6774683B723C73';
wwv_flow_imp.g_varchar2_table(629) := '3B2B2B7229745B725D2E6170706C7928746869732C65297D72657475726E20746869737D3B61692E70726F746F747970652E6C697374656E6572733D66756E6374696F6E2869297B72657475726E20746869732E5F63616C6C6261636B733D746869732E';
wwv_flow_imp.g_varchar2_table(630) := '5F63616C6C6261636B737C7C7B7D2C746869732E5F63616C6C6261636B735B2224222B695D7C7C5B5D7D3B61692E70726F746F747970652E6861734C697374656E6572733D66756E6374696F6E2869297B72657475726E2121746869732E6C697374656E';
wwv_flow_imp.g_varchar2_table(631) := '6572732869292E6C656E6774687D7D293B7661722074623D6865282848702C2470293D3E7B2866756E6374696F6E28692C65297B747970656F662048703D3D226F626A656374222626747970656F662024703C2275223F24702E6578706F7274733D6528';
wwv_flow_imp.g_varchar2_table(632) := '293A747970656F6620646566696E653D3D2266756E6374696F6E222626646566696E652E616D643F646566696E652865293A28693D747970656F6620676C6F62616C546869733C2275223F676C6F62616C546869733A697C7C73656C662C692E436F6D70';
wwv_flow_imp.g_varchar2_table(633) := '726573736F723D652829297D292848702C66756E6374696F6E28297B2275736520737472696374223B66756E6374696F6E206928562C52297B76617220493D4F626A6563742E6B6579732856293B6966284F626A6563742E6765744F776E50726F706572';
wwv_flow_imp.g_varchar2_table(634) := '747953796D626F6C73297B766172204C3D4F626A6563742E6765744F776E50726F706572747953796D626F6C732856293B522626284C3D4C2E66696C7465722866756E6374696F6E2851297B72657475726E204F626A6563742E6765744F776E50726F70';
wwv_flow_imp.g_varchar2_table(635) := '6572747944657363726970746F7228562C51292E656E756D657261626C657D29292C492E707573682E6170706C7928492C4C297D72657475726E20497D6E28692C226F776E4B65797322293B66756E6374696F6E20652856297B666F722876617220523D';
wwv_flow_imp.g_varchar2_table(636) := '313B523C617267756D656E74732E6C656E6774683B522B2B297B76617220493D617267756D656E74735B525D213D6E756C6C3F617267756D656E74735B525D3A7B7D3B5225323F69284F626A6563742849292C2130292E666F72456163682866756E6374';
wwv_flow_imp.g_varchar2_table(637) := '696F6E284C297B6F28562C4C2C495B4C5D297D293A4F626A6563742E6765744F776E50726F706572747944657363726970746F72733F4F626A6563742E646566696E6550726F7065727469657328562C4F626A6563742E6765744F776E50726F70657274';
wwv_flow_imp.g_varchar2_table(638) := '7944657363726970746F7273284929293A69284F626A656374284929292E666F72456163682866756E6374696F6E284C297B4F626A6563742E646566696E6550726F706572747928562C4C2C4F626A6563742E6765744F776E50726F7065727479446573';
wwv_flow_imp.g_varchar2_table(639) := '63726970746F7228492C4C29297D297D72657475726E20567D6E28652C225F6F626A6563745370726561643222293B66756E6374696F6E207428562C52297B69662821285620696E7374616E63656F66205229297468726F77206E657720547970654572';
wwv_flow_imp.g_varchar2_table(640) := '726F72282243616E6E6F742063616C6C206120636C61737320617320612066756E6374696F6E22297D6E28742C225F636C61737343616C6C436865636B22293B66756E6374696F6E207228562C52297B666F722876617220493D303B493C522E6C656E67';
wwv_flow_imp.g_varchar2_table(641) := '74683B492B2B297B766172204C3D525B495D3B4C2E656E756D657261626C653D4C2E656E756D657261626C657C7C21312C4C2E636F6E666967757261626C653D21302C2276616C756522696E204C2626284C2E7772697461626C653D2130292C4F626A65';
wwv_flow_imp.g_varchar2_table(642) := '63742E646566696E6550726F706572747928562C4C2E6B65792C4C297D7D6E28722C225F646566696E6550726F7065727469657322293B66756E6374696F6E207328562C522C49297B72657475726E205226267228562E70726F746F747970652C52292C';
wwv_flow_imp.g_varchar2_table(643) := '4926267228562C49292C567D6E28732C225F637265617465436C61737322293B66756E6374696F6E206F28562C522C49297B72657475726E205220696E20563F4F626A6563742E646566696E6550726F706572747928562C522C7B76616C75653A492C65';
wwv_flow_imp.g_varchar2_table(644) := '6E756D657261626C653A21302C636F6E666967757261626C653A21302C7772697461626C653A21307D293A565B525D3D492C567D6E286F2C225F646566696E6550726F706572747922293B66756E6374696F6E206128297B72657475726E20613D4F626A';
wwv_flow_imp.g_varchar2_table(645) := '6563742E61737369676E7C7C66756E6374696F6E2856297B666F722876617220523D313B523C617267756D656E74732E6C656E6774683B522B2B297B76617220493D617267756D656E74735B525D3B666F7228766172204C20696E2049294F626A656374';
wwv_flow_imp.g_varchar2_table(646) := '2E70726F746F747970652E6861734F776E50726F70657274792E63616C6C28492C4C29262628565B4C5D3D495B4C5D297D72657475726E20567D2C612E6170706C7928746869732C617267756D656E7473297D6E28612C225F657874656E647322293B76';
wwv_flow_imp.g_varchar2_table(647) := '6172206C3D7B6578706F7274733A7B7D7D3B2866756E6374696F6E2856297B747970656F662077696E646F773E2275227C7C66756E6374696F6E2852297B76617220493D522E48544D4C43616E766173456C656D656E742626522E48544D4C43616E7661';
wwv_flow_imp.g_varchar2_table(648) := '73456C656D656E742E70726F746F747970652C4C3D522E426C6F62262666756E6374696F6E28297B7472797B72657475726E21216E657720426C6F627D63617463687B72657475726E21317D7D28292C513D4C2626522E55696E74384172726179262666';
wwv_flow_imp.g_varchar2_table(649) := '756E6374696F6E28297B7472797B72657475726E206E657720426C6F62285B6E65772055696E7438417272617928313030295D292E73697A653D3D3D3130307D63617463687B72657475726E21317D7D28292C583D522E426C6F624275696C6465727C7C';
wwv_flow_imp.g_varchar2_table(650) := '522E5765624B6974426C6F624275696C6465727C7C522E4D6F7A426C6F624275696C6465727C7C522E4D53426C6F624275696C6465722C79653D2F5E646174613A28282E2A3F29283B636861727365743D2E2A3F293F29283B626173653634293F2C2F2C';
wwv_flow_imp.g_varchar2_table(651) := '70653D284C7C7C58292626522E61746F622626522E41727261794275666665722626522E55696E74384172726179262666756E6374696F6E286E65297B7661722072652C78652C45652C45742C43742C74652C4F742C4B652C6C723B69662872653D6E65';
wwv_flow_imp.g_varchar2_table(652) := '2E6D61746368287965292C217265297468726F77206E6577204572726F722822696E76616C696420646174612055524922293B666F722878653D72655B325D3F72655B315D3A22746578742F706C61696E222B2872655B335D7C7C223B63686172736574';
wwv_flow_imp.g_varchar2_table(653) := '3D55532D415343494922292C45653D212172655B345D2C45743D6E652E736C6963652872655B305D2E6C656E677468292C45653F43743D61746F62284574293A43743D6465636F6465555249436F6D706F6E656E74284574292C74653D6E657720417272';
wwv_flow_imp.g_varchar2_table(654) := '61794275666665722843742E6C656E677468292C4F743D6E65772055696E74384172726179287465292C4B653D303B4B653C43742E6C656E6774683B4B652B3D31294F745B4B655D3D43742E63686172436F64654174284B65293B72657475726E204C3F';
wwv_flow_imp.g_varchar2_table(655) := '6E657720426C6F62285B513F4F743A74655D2C7B747970653A78657D293A286C723D6E657720582C6C722E617070656E64287465292C6C722E676574426C6F6228786529297D3B522E48544D4C43616E766173456C656D656E74262621492E746F426C6F';
wwv_flow_imp.g_varchar2_table(656) := '62262628492E6D6F7A476574417346696C653F492E746F426C6F623D66756E6374696F6E286E652C72652C7865297B7661722045653D746869733B73657454696D656F75742866756E6374696F6E28297B78652626492E746F4461746155524C26267065';
wwv_flow_imp.g_varchar2_table(657) := '3F6E652870652845652E746F4461746155524C2872652C78652929293A6E652845652E6D6F7A476574417346696C652822626C6F62222C726529297D297D3A492E746F4461746155524C26267065262628492E6D73546F426C6F623F492E746F426C6F62';
wwv_flow_imp.g_varchar2_table(658) := '3D66756E6374696F6E286E652C72652C7865297B7661722045653D746869733B73657454696D656F75742866756E6374696F6E28297B28726526267265213D3D22696D6167652F706E67227C7C7865292626492E746F4461746155524C262670653F6E65';
wwv_flow_imp.g_varchar2_table(659) := '2870652845652E746F4461746155524C2872652C78652929293A6E652845652E6D73546F426C6F6228726529297D297D3A492E746F426C6F623D66756E6374696F6E286E652C72652C7865297B7661722045653D746869733B73657454696D656F757428';
wwv_flow_imp.g_varchar2_table(660) := '66756E6374696F6E28297B6E652870652845652E746F4461746155524C2872652C78652929297D297D29292C562E6578706F7274733F562E6578706F7274733D70653A522E6461746155524C746F426C6F623D70657D2877696E646F77297D29286C293B';
wwv_flow_imp.g_varchar2_table(661) := '76617220683D6C2E6578706F7274732C633D6E2866756E6374696F6E2852297B72657475726E20747970656F6620426C6F623E2275223F21313A5220696E7374616E63656F6620426C6F627C7C4F626A6563742E70726F746F747970652E746F53747269';
wwv_flow_imp.g_varchar2_table(662) := '6E672E63616C6C2852293D3D3D225B6F626A65637420426C6F625D227D2C226973426C6F6222292C643D7B7374726963743A21302C636865636B4F7269656E746174696F6E3A21302C6D617857696474683A312F302C6D61784865696768743A312F302C';
wwv_flow_imp.g_varchar2_table(663) := '6D696E57696474683A302C6D696E4865696768743A302C77696474683A766F696420302C6865696768743A766F696420302C726573697A653A226E6F6E65222C7175616C6974793A2E382C6D696D65547970653A226175746F222C636F6E766572745479';
wwv_flow_imp.g_varchar2_table(664) := '7065733A5B22696D6167652F706E67225D2C636F6E7665727453697A653A3565362C6265666F7265447261773A6E756C6C2C647265773A6E756C6C2C737563636573733A6E756C6C2C6572726F723A6E756C6C7D2C663D747970656F662077696E646F77';
wwv_flow_imp.g_varchar2_table(665) := '3C2275222626747970656F662077696E646F772E646F63756D656E743C2275222C793D663F77696E646F773A7B7D2C623D6E2866756E6374696F6E2852297B72657475726E20523E302626523C312F307D2C226973506F7369746976654E756D62657222';
wwv_flow_imp.g_varchar2_table(666) := '292C533D41727261792E70726F746F747970652E736C6963653B66756E6374696F6E20452856297B72657475726E2041727261792E66726F6D3F41727261792E66726F6D2856293A532E63616C6C2856297D6E28452C22746F417272617922293B766172';
wwv_flow_imp.g_varchar2_table(667) := '20463D2F5E696D6167655C2F2E2B242F3B66756E6374696F6E20782856297B72657475726E20462E746573742856297D6E28782C226973496D6167655479706522293B66756E6374696F6E20552856297B76617220523D782856293F562E737562737472';
wwv_flow_imp.g_varchar2_table(668) := '2836293A22223B72657475726E20523D3D3D226A70656722262628523D226A706722292C222E222E636F6E6361742852297D6E28552C22696D61676554797065546F457874656E73696F6E22293B766172206A3D537472696E672E66726F6D4368617243';
wwv_flow_imp.g_varchar2_table(669) := '6F64653B66756E6374696F6E204728562C522C49297B766172204C3D22222C513B666F7228492B3D522C513D523B513C493B512B3D31294C2B3D6A28562E67657455696E7438285129293B72657475726E204C7D6E28472C22676574537472696E674672';
wwv_flow_imp.g_varchar2_table(670) := '6F6D43686172436F646522293B766172204A3D792E62746F613B66756E6374696F6E204228562C52297B666F722876617220493D5B5D2C4C3D383139322C513D6E65772055696E743841727261792856293B512E6C656E6774683E303B29492E70757368';
wwv_flow_imp.g_varchar2_table(671) := '286A2E6170706C79286E756C6C2C4528512E737562617272617928302C4C292929292C513D512E7375626172726179284C293B72657475726E22646174613A222E636F6E63617428522C223B6261736536342C22292E636F6E636174284A28492E6A6F69';
wwv_flow_imp.g_varchar2_table(672) := '6E2822222929297D6E28422C226172726179427566666572546F4461746155524C22293B66756E6374696F6E207A2856297B76617220523D6E65772044617461566965772856292C493B7472797B766172204C2C512C583B696628522E67657455696E74';
wwv_flow_imp.g_varchar2_table(673) := '382830293D3D3D3235352626522E67657455696E74382831293D3D3D32313629666F72287661722079653D522E627974654C656E6774682C70653D323B70652B313C79653B297B696628522E67657455696E7438287065293D3D3D3235352626522E6765';
wwv_flow_imp.g_varchar2_table(674) := '7455696E74382870652B31293D3D3D323235297B513D70653B627265616B7D70652B3D317D69662851297B766172206E653D512B342C72653D512B31303B6966284728522C6E652C34293D3D3D224578696622297B7661722078653D522E67657455696E';
wwv_flow_imp.g_varchar2_table(675) := '743136287265293B6966284C3D78653D3D3D31383736312C284C7C7C78653D3D3D3139373839292626522E67657455696E7431362872652B322C4C293D3D3D3432297B7661722045653D522E67657455696E7433322872652B342C4C293B45653E3D3826';
wwv_flow_imp.g_varchar2_table(676) := '2628583D72652B4565297D7D7D69662858297B7661722045743D522E67657455696E74313628582C4C292C43742C74653B666F722874653D303B74653C45743B74652B3D312969662843743D582B74652A31322B322C522E67657455696E743136284374';
wwv_flow_imp.g_varchar2_table(677) := '2C4C293D3D3D323734297B43742B3D382C493D522E67657455696E7431362843742C4C292C522E73657455696E7431362843742C312C4C293B627265616B7D7D7D63617463687B493D317D72657475726E20497D6E287A2C227265736574416E64476574';
wwv_flow_imp.g_varchar2_table(678) := '4F7269656E746174696F6E22293B66756E6374696F6E204B2856297B76617220523D302C493D312C4C3D313B7377697463682856297B6361736520323A493D2D313B627265616B3B6361736520333A523D2D3138303B627265616B3B6361736520343A4C';
wwv_flow_imp.g_varchar2_table(679) := '3D2D313B627265616B3B6361736520353A523D39302C4C3D2D313B627265616B3B6361736520363A523D39303B627265616B3B6361736520373A523D39302C493D2D313B627265616B3B6361736520383A523D2D39303B627265616B7D72657475726E7B';
wwv_flow_imp.g_varchar2_table(680) := '726F746174653A522C7363616C65583A492C7363616C65593A4C7D7D6E284B2C2270617273654F7269656E746174696F6E22293B766172206F653D2F5C2E5C642A283F3A307C39297B31327D5C642A242F3B66756E6374696F6E2042652856297B766172';
wwv_flow_imp.g_varchar2_table(681) := '20523D617267756D656E74732E6C656E6774683E312626617267756D656E74735B315D213D3D766F696420303F617267756D656E74735B315D3A316531313B72657475726E206F652E746573742856293F4D6174682E726F756E6428562A52292F523A56';
wwv_flow_imp.g_varchar2_table(682) := '7D6E2842652C226E6F726D616C697A65446563696D616C4E756D62657222293B66756E6374696F6E204A652856297B76617220523D562E617370656374526174696F2C493D562E6865696768742C4C3D562E77696474682C513D617267756D656E74732E';
wwv_flow_imp.g_varchar2_table(683) := '6C656E6774683E312626617267756D656E74735B315D213D3D766F696420303F617267756D656E74735B315D3A226E6F6E65222C583D62284C292C79653D622849293B6966285826267965297B7661722070653D492A523B28513D3D3D22636F6E746169';
wwv_flow_imp.g_varchar2_table(684) := '6E227C7C513D3D3D226E6F6E652229262670653E4C7C7C513D3D3D22636F76657222262670653C4C3F493D4C2F523A4C3D492A527D656C736520583F493D4C2F523A79652626284C3D492A52293B72657475726E7B77696474683A4C2C6865696768743A';
wwv_flow_imp.g_varchar2_table(685) := '497D7D6E284A652C2267657441646A757374656453697A657322293B7661722077743D792E41727261794275666665722C47653D792E46696C655265616465722C5F653D792E55524C7C7C792E7765626B697455524C2C7A653D2F5C2E5C772B242F2C46';
wwv_flow_imp.g_varchar2_table(686) := '653D792E436F6D70726573736F722C68693D66756E6374696F6E28297B66756E6374696F6E205628522C49297B7428746869732C56292C746869732E66696C653D522C746869732E696D6167653D6E657720496D6167652C746869732E6F7074696F6E73';
wwv_flow_imp.g_varchar2_table(687) := '3D652865287B7D2C64292C49292C746869732E61626F727465643D21312C746869732E726573756C743D6E756C6C2C746869732E696E697428297D72657475726E206E28562C22436F6D70726573736F7222292C7328562C5B7B6B65793A22696E697422';
wwv_flow_imp.g_varchar2_table(688) := '2C76616C75653A6E2866756E6374696F6E28297B76617220493D746869732C4C3D746869732E66696C652C513D746869732E6F7074696F6E733B6966282163284C29297B746869732E6661696C286E6577204572726F7228225468652066697273742061';
wwv_flow_imp.g_varchar2_table(689) := '7267756D656E74206D75737420626520612046696C65206F7220426C6F62206F626A6563742E2229293B72657475726E7D76617220583D4C2E747970653B6966282178285829297B746869732E6661696C286E6577204572726F72282254686520666972';
wwv_flow_imp.g_varchar2_table(690) := '737420617267756D656E74206D75737420626520616E20696D6167652046696C65206F7220426C6F62206F626A6563742E2229293B72657475726E7D696628215F657C7C214765297B746869732E6661696C286E6577204572726F722822546865206375';
wwv_flow_imp.g_varchar2_table(691) := '7272656E742062726F7773657220646F6573206E6F7420737570706F727420696D61676520636F6D7072657373696F6E2E2229293B72657475726E7D69662877747C7C28512E636865636B4F7269656E746174696F6E3D2131292C5F65262621512E6368';
wwv_flow_imp.g_varchar2_table(692) := '65636B4F7269656E746174696F6E29746869732E6C6F6164287B75726C3A5F652E6372656174654F626A65637455524C284C297D293B656C73657B7661722079653D6E65772047652C70653D512E636865636B4F7269656E746174696F6E2626583D3D3D';
wwv_flow_imp.g_varchar2_table(693) := '22696D6167652F6A706567223B746869732E7265616465723D79652C79652E6F6E6C6F61643D66756E6374696F6E286E65297B7661722072653D6E652E7461726765742C78653D72652E726573756C742C45653D7B7D3B6966287065297B766172204574';
wwv_flow_imp.g_varchar2_table(694) := '3D7A287865293B45743E317C7C215F653F2845652E75726C3D422878652C58292C45743E312626612845652C4B2845742929293A45652E75726C3D5F652E6372656174654F626A65637455524C284C297D656C73652045652E75726C3D78653B492E6C6F';
wwv_flow_imp.g_varchar2_table(695) := '6164284565297D2C79652E6F6E61626F72743D66756E6374696F6E28297B492E6661696C286E6577204572726F72282241626F7274656420746F20726561642074686520696D61676520776974682046696C655265616465722E2229297D2C79652E6F6E';
wwv_flow_imp.g_varchar2_table(696) := '6572726F723D66756E6374696F6E28297B492E6661696C286E6577204572726F7228224661696C656420746F20726561642074686520696D61676520776974682046696C655265616465722E2229297D2C79652E6F6E6C6F6164656E643D66756E637469';
wwv_flow_imp.g_varchar2_table(697) := '6F6E28297B492E7265616465723D6E756C6C7D2C70653F79652E7265616441734172726179427566666572284C293A79652E7265616441734461746155524C284C297D7D2C22696E697422297D2C7B6B65793A226C6F6164222C76616C75653A6E286675';
wwv_flow_imp.g_varchar2_table(698) := '6E6374696F6E2849297B766172204C3D746869732C513D746869732E66696C652C583D746869732E696D6167653B582E6F6E6C6F61643D66756E6374696F6E28297B4C2E6472617728652865287B7D2C49292C7B7D2C7B6E61747572616C57696474683A';
wwv_flow_imp.g_varchar2_table(699) := '582E6E61747572616C57696474682C6E61747572616C4865696768743A582E6E61747572616C4865696768747D29297D2C582E6F6E61626F72743D66756E6374696F6E28297B4C2E6661696C286E6577204572726F72282241626F7274656420746F206C';
wwv_flow_imp.g_varchar2_table(700) := '6F61642074686520696D6167652E2229297D2C582E6F6E6572726F723D66756E6374696F6E28297B4C2E6661696C286E6577204572726F7228224661696C656420746F206C6F61642074686520696D6167652E2229297D2C792E6E6176696761746F7226';
wwv_flow_imp.g_varchar2_table(701) := '262F283F3A695061647C6950686F6E657C69506F64292E2A3F4170706C655765624B69742F692E7465737428792E6E6176696761746F722E757365724167656E7429262628582E63726F73734F726967696E3D22616E6F6E796D6F757322292C582E616C';
wwv_flow_imp.g_varchar2_table(702) := '743D512E6E616D652C582E7372633D492E75726C7D2C226C6F616422297D2C7B6B65793A2264726177222C76616C75653A6E2866756E6374696F6E2849297B766172204C3D746869732C513D492E6E61747572616C57696474682C583D492E6E61747572';
wwv_flow_imp.g_varchar2_table(703) := '616C4865696768742C79653D492E726F746174652C70653D79653D3D3D766F696420303F303A79652C6E653D492E7363616C65582C72653D6E653D3D3D766F696420303F313A6E652C78653D492E7363616C65592C45653D78653D3D3D766F696420303F';
wwv_flow_imp.g_varchar2_table(704) := '313A78652C45743D746869732E66696C652C43743D746869732E696D6167652C74653D746869732E6F7074696F6E732C4F743D646F63756D656E742E637265617465456C656D656E74282263616E76617322292C4B653D4F742E676574436F6E74657874';
wwv_flow_imp.g_varchar2_table(705) := '2822326422292C6C723D4D6174682E61627328706529253138303D3D3D39302C536F3D2874652E726573697A653D3D3D22636F6E7461696E227C7C74652E726573697A653D3D3D22636F76657222292626622874652E7769647468292626622874652E68';
wwv_flow_imp.g_varchar2_table(706) := '6569676874292C6A723D4D6174682E6D61782874652E6D617857696474682C30297C7C312F302C48723D4D6174682E6D61782874652E6D61784865696768742C30297C7C312F302C24723D4D6174682E6D61782874652E6D696E57696474682C30297C7C';
wwv_flow_imp.g_varchar2_table(707) := '302C75723D4D6174682E6D61782874652E6D696E4865696768742C30297C7C302C68723D512F582C6F743D74652E77696474682C6E743D74652E6865696768743B6966286C72297B76617220626C3D5B48722C6A725D3B6A723D626C5B305D2C48723D62';
wwv_flow_imp.g_varchar2_table(708) := '6C5B315D3B76617220776C3D5B75722C24725D3B24723D776C5B305D2C75723D776C5B315D3B766172206E6E3D5B6E742C6F745D3B6F743D6E6E5B305D2C6E743D6E6E5B315D7D536F26262868723D6F742F6E74293B76617220536C3D4A65287B617370';
wwv_flow_imp.g_varchar2_table(709) := '656374526174696F3A68722C77696474683A6A722C6865696768743A48727D2C22636F6E7461696E22293B6A723D536C2E77696474682C48723D536C2E6865696768743B76617220506C3D4A65287B617370656374526174696F3A68722C77696474683A';
wwv_flow_imp.g_varchar2_table(710) := '24722C6865696768743A75727D2C22636F76657222293B69662824723D506C2E77696474682C75723D506C2E6865696768742C536F297B7661722069653D4A65287B617370656374526174696F3A68722C77696474683A6F742C6865696768743A6E747D';
wwv_flow_imp.g_varchar2_table(711) := '2C74652E726573697A65293B6F743D69652E77696474682C6E743D69652E6865696768747D656C73657B76617220616E3D4A65287B617370656374526174696F3A68722C77696474683A6F742C6865696768743A6E747D292C506F3D616E2E7769647468';
wwv_flow_imp.g_varchar2_table(712) := '3B6F743D506F3D3D3D766F696420303F513A506F3B766172204D693D616E2E6865696768743B6E743D4D693D3D3D766F696420303F583A4D697D6F743D4D6174682E666C6F6F72284265284D6174682E6D696E284D6174682E6D6178286F742C2472292C';
wwv_flow_imp.g_varchar2_table(713) := '6A722929292C6E743D4D6174682E666C6F6F72284265284D6174682E6D696E284D6174682E6D6178286E742C7572292C48722929293B7661722064683D2D6F742F322C71723D2D6E742F322C53743D6F742C63683D6E742C5F6F3D5B5D3B696628536F29';
wwv_flow_imp.g_varchar2_table(714) := '7B7661722041653D302C53653D302C6C6E3D512C4E693D582C5F6C3D4A65287B617370656374526174696F3A68722C77696474683A512C6865696768743A587D2C7B636F6E7461696E3A22636F766572222C636F7665723A22636F6E7461696E227D5B74';
wwv_flow_imp.g_varchar2_table(715) := '652E726573697A655D293B6C6E3D5F6C2E77696474682C4E693D5F6C2E6865696768742C41653D28512D6C6E292F322C53653D28582D4E69292F322C5F6F2E707573682841652C53652C6C6E2C4E69297D6966285F6F2E707573682864682C71722C5374';
wwv_flow_imp.g_varchar2_table(716) := '2C6368292C6C72297B7661722062693D5B6E742C6F745D3B6F743D62695B305D2C6E743D62695B315D7D4F742E77696474683D6F742C4F742E6865696768743D6E742C782874652E6D696D6554797065297C7C2874652E6D696D65547970653D45742E74';
wwv_flow_imp.g_varchar2_table(717) := '797065293B76617220466C3D227472616E73706172656E74223B69662845742E73697A653E74652E636F6E7665727453697A65262674652E636F6E7665727454797065732E696E6465784F662874652E6D696D6554797065293E3D3026262874652E6D69';
wwv_flow_imp.g_varchar2_table(718) := '6D65547970653D22696D6167652F6A70656722292C74652E6D696D65547970653D3D3D22696D6167652F6A70656722262628466C3D222366666622292C4B652E66696C6C5374796C653D466C2C4B652E66696C6C5265637428302C302C6F742C6E74292C';
wwv_flow_imp.g_varchar2_table(719) := '74652E6265666F726544726177262674652E6265666F7265447261772E63616C6C28746869732C4B652C4F74292C21746869732E61626F727465642626284B652E7361766528292C4B652E7472616E736C617465286F742F322C6E742F32292C4B652E72';
wwv_flow_imp.g_varchar2_table(720) := '6F746174652870652A4D6174682E50492F313830292C4B652E7363616C652872652C4565292C4B652E64726177496D6167652E6170706C79284B652C5B43745D2E636F6E636174285F6F29292C4B652E726573746F726528292C74652E64726577262674';
wwv_flow_imp.g_varchar2_table(721) := '652E647265772E63616C6C28746869732C4B652C4F74292C21746869732E61626F7274656429297B766172206A653D6E2866756E6374696F6E285672297B4C2E61626F727465647C7C4C2E646F6E65287B6E61747572616C57696474683A512C6E617475';
wwv_flow_imp.g_varchar2_table(722) := '72616C4865696768743A582C726573756C743A56727D297D2C22646F6E6522293B4F742E746F426C6F623F4F742E746F426C6F62286A652C74652E6D696D65547970652C74652E7175616C697479293A6A652868284F742E746F4461746155524C287465';
wwv_flow_imp.g_varchar2_table(723) := '2E6D696D65547970652C74652E7175616C6974792929297D7D2C226472617722297D2C7B6B65793A22646F6E65222C76616C75653A6E2866756E6374696F6E2849297B766172204C3D492E6E61747572616C57696474682C513D492E6E61747572616C48';
wwv_flow_imp.g_varchar2_table(724) := '65696768742C583D492E726573756C742C79653D746869732E66696C652C70653D746869732E696D6167652C6E653D746869732E6F7074696F6E733B6966285F652626216E652E636865636B4F7269656E746174696F6E26265F652E7265766F6B654F62';
wwv_flow_imp.g_varchar2_table(725) := '6A65637455524C2870652E737263292C58296966286E652E7374726963742626582E73697A653E79652E73697A6526266E652E6D696D65547970653D3D3D79652E74797065262621286E652E77696474683E4C7C7C6E652E6865696768743E517C7C6E65';
wwv_flow_imp.g_varchar2_table(726) := '2E6D696E57696474683E4C7C7C6E652E6D696E4865696768743E517C7C6E652E6D617857696474683C4C7C7C6E652E6D61784865696768743C512929583D79653B656C73657B7661722072653D6E657720446174653B582E6C6173744D6F646966696564';
wwv_flow_imp.g_varchar2_table(727) := '3D72652E67657454696D6528292C582E6C6173744D6F646966696564446174653D72652C582E6E616D653D79652E6E616D652C582E6E616D652626582E74797065213D3D79652E74797065262628582E6E616D653D582E6E616D652E7265706C61636528';
wwv_flow_imp.g_varchar2_table(728) := '7A652C5528582E747970652929297D656C736520583D79653B746869732E726573756C743D582C6E652E7375636365737326266E652E737563636573732E63616C6C28746869732C58297D2C22646F6E6522297D2C7B6B65793A226661696C222C76616C';
wwv_flow_imp.g_varchar2_table(729) := '75653A6E2866756E6374696F6E2849297B766172204C3D746869732E6F7074696F6E733B6966284C2E6572726F72294C2E6572726F722E63616C6C28746869732C49293B656C7365207468726F7720497D2C226661696C22297D2C7B6B65793A2261626F';
wwv_flow_imp.g_varchar2_table(730) := '7274222C76616C75653A6E2866756E6374696F6E28297B746869732E61626F727465647C7C28746869732E61626F727465643D21302C746869732E7265616465723F746869732E7265616465722E61626F727428293A746869732E696D6167652E636F6D';
wwv_flow_imp.g_varchar2_table(731) := '706C6574653F746869732E6661696C286E6577204572726F72282254686520636F6D7072657373696F6E2070726F6365737320686173206265656E2061626F727465642E2229293A28746869732E696D6167652E6F6E6C6F61643D6E756C6C2C74686973';
wwv_flow_imp.g_varchar2_table(732) := '2E696D6167652E6F6E61626F7274282929297D2C2261626F727422297D5D2C5B7B6B65793A226E6F436F6E666C696374222C76616C75653A6E2866756E6374696F6E28297B72657475726E2077696E646F772E436F6D70726573736F723D46652C567D2C';
wwv_flow_imp.g_varchar2_table(733) := '226E6F436F6E666C69637422297D2C7B6B65793A2273657444656661756C7473222C76616C75653A6E2866756E6374696F6E2849297B6128642C49297D2C2273657444656661756C747322297D5D292C567D28293B72657475726E2068697D297D293B76';
wwv_flow_imp.g_varchar2_table(734) := '61722056703D7B7D3B4F6C2856702C7B417564696F3A28293D3E6F732C41777353333A28293D3E6E6F2C41777353334D756C7469706172743A28293D3E52692C42617365506C7567696E3A28293D3E76652C426F783A28293D3E58692C436F6D70726573';
wwv_flow_imp.g_varchar2_table(735) := '736F723A28293D3E6F6E2C436F72653A28293D3E47462C44617368626F6172643A28293D3E74732C44656661756C7453746F72653A28293D3E6B6C2C4472616744726F703A28293D3E47692C44726F705461726765743A28293D3E4D732C44726F70626F';
wwv_flow_imp.g_varchar2_table(736) := '783A28293D3E59692C46616365626F6F6B3A28293D3E51692C46696C65496E7075743A28293D3E69732C466F726D3A28293D3E676F2C476F6C64656E5265747269657665723A28293D3E626F2C476F6F676C6544726976653A28293D3E4A692C496D6167';
wwv_flow_imp.g_varchar2_table(737) := '65456469746F723A28293D3E72732C496E666F726D65723A28293D3E71692C496E7374616772616D3A28293D3E5A692C4F6E6544726976653A28293D3E65722C50726F67726573734261723A28293D3E73732C5265647578446576546F6F6C733A28293D';
wwv_flow_imp.g_varchar2_table(738) := '3E776F2C526564757853746F72653A28293D3E79672C52656D6F7465536F75726365733A28293D3E7A732C53637265656E436170747572653A28293D3E6E732C5374617475734261723A28293D3E24692C5468756D626E61696C47656E657261746F723A';
wwv_flow_imp.g_varchar2_table(739) := '28293D3E43722C5472616E736C6F616469743A28293D3E76692C5475733A28293D3E6F722C5549506C7567696E3A28293D3E5A2C556E73706C6173683A28293D3E74722C557070793A28293D3E52682C55726C3A28293D3E46742C57656263616D3A2829';
wwv_flow_imp.g_varchar2_table(740) := '3D3E61732C58485255706C6F61643A28293D3E6D6F2C5A6F6F6D3A28293D3E69722C64656275674C6F676765723A28293D3E676E2C6C6F63616C65733A28293D3E58462C7365727665723A28293D3E7A682C76696577733A28293D3E4B467D293B66756E';
wwv_flow_imp.g_varchar2_table(741) := '6374696F6E20546C28692C65297B696628214F626A6563742E70726F746F747970652E6861734F776E50726F70657274792E63616C6C28692C6529297468726F77206E657720547970654572726F722822617474656D7074656420746F20757365207072';
wwv_flow_imp.g_varchar2_table(742) := '6976617465206669656C64206F6E206E6F6E2D696E7374616E636522293B72657475726E20697D6E28546C2C225F636C617373507269766174654669656C644C6F6F73654261736522293B766172204B623D303B66756E6374696F6E206F662869297B72';
wwv_flow_imp.g_varchar2_table(743) := '657475726E225F5F707269766174655F222B4B622B2B2B225F222B697D6E286F662C225F636C617373507269766174654669656C644C6F6F73654B657922293B66756E6374696F6E20586228692C652C74297B6C657420723D5B5D3B72657475726E2069';
wwv_flow_imp.g_varchar2_table(744) := '2E666F724561636828733D3E747970656F662073213D22737472696E67223F722E707573682873293A655B53796D626F6C2E73706C69745D2873292E666F724561636828286F2C612C6C293D3E7B6F213D3D22222626722E70757368286F292C613C6C2E';
wwv_flow_imp.g_varchar2_table(745) := '6C656E6774682D312626722E707573682874297D29292C727D6E2858622C22696E736572745265706C6163656D656E7422293B66756E6374696F6E20736628692C65297B6C657420743D2F5C242F672C723D2224242424222C733D5B695D3B696628653D';
wwv_flow_imp.g_varchar2_table(746) := '3D6E756C6C2972657475726E20733B666F72286C6574206F206F66204F626A6563742E6B657973286529296966286F213D3D225F22297B6C657420613D655B6F5D3B747970656F6620613D3D22737472696E6722262628613D745B53796D626F6C2E7265';
wwv_flow_imp.g_varchar2_table(747) := '706C6163655D28612C7229292C733D586228732C6E6577205265674578702860255C5C7B247B6F7D5C5C7D602C226722292C61297D72657475726E20737D6E2873662C22696E746572706F6C61746522293B7661722059623D6E28693D3E7B7468726F77';
wwv_flow_imp.g_varchar2_table(748) := '206E6577204572726F7228606D697373696E6720737472696E673A20247B697D60297D2C2264656661756C744F6E4D697373696E674B657922292C646E3D6F6628226F6E4D697373696E674B657922292C636E3D6F6628226170706C7922292C4B723D63';
wwv_flow_imp.g_varchar2_table(749) := '6C6173737B636F6E7374727563746F7228652C74297B6C65747B6F6E4D697373696E674B65793A723D59627D3D743D3D3D766F696420303F7B7D3A743B4F626A6563742E646566696E6550726F706572747928746869732C636E2C7B76616C75653A5162';
wwv_flow_imp.g_varchar2_table(750) := '7D292C4F626A6563742E646566696E6550726F706572747928746869732C646E2C7B7772697461626C653A21302C76616C75653A766F696420307D292C746869732E6C6F63616C653D7B737472696E67733A7B7D2C706C7572616C697A652873297B7265';
wwv_flow_imp.g_varchar2_table(751) := '7475726E20733D3D3D313F303A317D7D2C41727261792E697341727261792865293F652E666F724561636828546C28746869732C636E295B636E5D2C74686973293A546C28746869732C636E295B636E5D2865292C546C28746869732C646E295B646E5D';
wwv_flow_imp.g_varchar2_table(752) := '3D727D7472616E736C61746528652C74297B72657475726E20746869732E7472616E736C617465417272617928652C74292E6A6F696E282222297D7472616E736C617465417272617928652C74297B6C657420723D746869732E6C6F63616C652E737472';
wwv_flow_imp.g_varchar2_table(753) := '696E67735B655D3B696628723D3D6E756C6C262628546C28746869732C646E295B646E5D2865292C723D65292C747970656F6620723D3D226F626A65637422297B696628742626747970656F6620742E736D6172745F636F756E743C227522297B6C6574';
wwv_flow_imp.g_varchar2_table(754) := '206F3D746869732E6C6F63616C652E706C7572616C697A6528742E736D6172745F636F756E74293B72657475726E20736628725B6F5D2C74297D7468726F77206E6577204572726F722822417474656D7074656420746F20757365206120737472696E67';
wwv_flow_imp.g_varchar2_table(755) := '207769746820706C7572616C20666F726D732C20627574206E6F2076616C75652077617320676976656E20666F7220257B736D6172745F636F756E747D22297D696628747970656F662072213D22737472696E6722297468726F77206E6577204572726F';
wwv_flow_imp.g_varchar2_table(756) := '722822737472696E6720776173206E6F74206120737472696E6722293B72657475726E20736628722C74297D7D3B6E284B722C225472616E736C61746F7222293B66756E6374696F6E2051622869297B696628212869213D6E756C6C2626692E73747269';
wwv_flow_imp.g_varchar2_table(757) := '6E6773292972657475726E3B6C657420653D746869732E6C6F63616C653B746869732E6C6F63616C653D7B2E2E2E652C737472696E67733A7B2E2E2E652E737472696E67732C2E2E2E692E737472696E67737D7D2C746869732E6C6F63616C652E706C75';
wwv_flow_imp.g_varchar2_table(758) := '72616C697A653D692E706C7572616C697A657C7C652E706C7572616C697A657D6E2851622C225F6170706C793222293B76617220656D3D646528766828292C31293B766172204A623D22757365616E646F6D2D3236543139383334305058373570784A41';
wwv_flow_imp.g_varchar2_table(759) := '434B564552594D494E4442555348574F4C465F47515A626667686A6B6C717677797A72696374223B7661722050743D6E2828693D3231293D3E7B6C657420653D22222C743D693B666F72283B742D2D3B29652B3D4A625B4D6174682E72616E646F6D2829';
wwv_flow_imp.g_varchar2_table(760) := '2A36347C305D3B72657475726E20657D2C226E616E6F696422293B76617220746D3D646528526C28292C31293B66756E6374696F6E20556C28692C65297B696628214F626A6563742E70726F746F747970652E6861734F776E50726F70657274792E6361';
wwv_flow_imp.g_varchar2_table(761) := '6C6C28692C6529297468726F77206E657720547970654572726F722822617474656D7074656420746F207573652070726976617465206669656C64206F6E206E6F6E2D696E7374616E636522293B72657475726E20697D6E28556C2C225F636C61737350';
wwv_flow_imp.g_varchar2_table(762) := '7269766174654669656C644C6F6F73654261736522293B7661722056313D303B66756E6374696F6E2042662869297B72657475726E225F5F707269766174655F222B56312B2B2B225F222B697D6E2842662C225F636C617373507269766174654669656C';
wwv_flow_imp.g_varchar2_table(763) := '644C6F6F73654B657922293B7661722057313D7B76657273696F6E3A22332E322E30227D2C6D733D4266282263616C6C6261636B7322292C5F683D426628227075626C69736822292C666E3D636C6173737B636F6E7374727563746F7228297B4F626A65';
wwv_flow_imp.g_varchar2_table(764) := '63742E646566696E6550726F706572747928746869732C5F682C7B76616C75653A47317D292C746869732E73746174653D7B7D2C4F626A6563742E646566696E6550726F706572747928746869732C6D732C7B7772697461626C653A21302C76616C7565';
wwv_flow_imp.g_varchar2_table(765) := '3A6E6577205365747D297D676574537461746528297B72657475726E20746869732E73746174657D73657453746174652865297B6C657420743D7B2E2E2E746869732E73746174657D2C723D7B2E2E2E746869732E73746174652C2E2E2E657D3B746869';
wwv_flow_imp.g_varchar2_table(766) := '732E73746174653D722C556C28746869732C5F68295B5F685D28742C722C65297D7375627363726962652865297B72657475726E20556C28746869732C6D73295B6D735D2E6164642865292C28293D3E7B556C28746869732C6D73295B6D735D2E64656C';
wwv_flow_imp.g_varchar2_table(767) := '6574652865297D7D7D3B6E28666E2C2244656661756C7453746F726522293B66756E6374696F6E20473128297B666F722876617220693D617267756D656E74732E6C656E6774682C653D6E65772041727261792869292C743D303B743C693B742B2B2965';
wwv_flow_imp.g_varchar2_table(768) := '5B745D3D617267756D656E74735B745D3B556C28746869732C6D73295B6D735D2E666F724561636828723D3E7B72282E2E2E65297D297D6E2847312C225F7075626C6973683222293B666E2E56455253494F4E3D57312E76657273696F6E3B766172206B';
wwv_flow_imp.g_varchar2_table(769) := '6C3D666E3B66756E6374696F6E2042692869297B6C657420653D692E6C617374496E6465784F6628222E22293B72657475726E20653D3D3D2D317C7C653D3D3D692E6C656E6774682D313F7B6E616D653A692C657874656E73696F6E3A766F696420307D';
wwv_flow_imp.g_varchar2_table(770) := '3A7B6E616D653A692E736C69636528302C65292C657874656E73696F6E3A692E736C69636528652B31297D7D6E2842692C2267657446696C654E616D65416E64457874656E73696F6E22293B766172206D6E3D7B5F5F70726F746F5F5F3A6E756C6C2C6D';
wwv_flow_imp.g_varchar2_table(771) := '643A22746578742F6D61726B646F776E222C6D61726B646F776E3A22746578742F6D61726B646F776E222C6D70343A22766964656F2F6D7034222C6D70333A22617564696F2F6D7033222C7376673A22696D6167652F7376672B786D6C222C6A70673A22';
wwv_flow_imp.g_varchar2_table(772) := '696D6167652F6A706567222C706E673A22696D6167652F706E67222C776562703A22696D6167652F77656270222C6769663A22696D6167652F676966222C686569633A22696D6167652F68656963222C686569663A22696D6167652F68656966222C7961';
wwv_flow_imp.g_varchar2_table(773) := '6D6C3A22746578742F79616D6C222C796D6C3A22746578742F79616D6C222C6373763A22746578742F637376222C7473763A22746578742F7461622D7365706172617465642D76616C756573222C7461623A22746578742F7461622D7365706172617465';
wwv_flow_imp.g_varchar2_table(774) := '642D76616C756573222C6176693A22766964656F2F782D6D73766964656F222C6D6B733A22766964656F2F782D6D6174726F736B61222C6D6B763A22766964656F2F782D6D6174726F736B61222C6D6F763A22766964656F2F717569636B74696D65222C';
wwv_flow_imp.g_varchar2_table(775) := '6469636F6D3A226170706C69636174696F6E2F6469636F6D222C646F633A226170706C69636174696F6E2F6D73776F7264222C646F636D3A226170706C69636174696F6E2F766E642E6D732D776F72642E646F63756D656E742E6D6163726F656E61626C';
wwv_flow_imp.g_varchar2_table(776) := '65642E3132222C646F63783A226170706C69636174696F6E2F766E642E6F70656E786D6C666F726D6174732D6F6666696365646F63756D656E742E776F726470726F63657373696E676D6C2E646F63756D656E74222C646F743A226170706C6963617469';
wwv_flow_imp.g_varchar2_table(777) := '6F6E2F6D73776F7264222C646F746D3A226170706C69636174696F6E2F766E642E6D732D776F72642E74656D706C6174652E6D6163726F656E61626C65642E3132222C646F74783A226170706C69636174696F6E2F766E642E6F70656E786D6C666F726D';
wwv_flow_imp.g_varchar2_table(778) := '6174732D6F6666696365646F63756D656E742E776F726470726F63657373696E676D6C2E74656D706C617465222C786C613A226170706C69636174696F6E2F766E642E6D732D657863656C222C786C616D3A226170706C69636174696F6E2F766E642E6D';
wwv_flow_imp.g_varchar2_table(779) := '732D657863656C2E616464696E2E6D6163726F656E61626C65642E3132222C786C633A226170706C69636174696F6E2F766E642E6D732D657863656C222C786C663A226170706C69636174696F6E2F782D786C6966662B786D6C222C786C6D3A22617070';
wwv_flow_imp.g_varchar2_table(780) := '6C69636174696F6E2F766E642E6D732D657863656C222C786C733A226170706C69636174696F6E2F766E642E6D732D657863656C222C786C73623A226170706C69636174696F6E2F766E642E6D732D657863656C2E73686565742E62696E6172792E6D61';
wwv_flow_imp.g_varchar2_table(781) := '63726F656E61626C65642E3132222C786C736D3A226170706C69636174696F6E2F766E642E6D732D657863656C2E73686565742E6D6163726F656E61626C65642E3132222C786C73783A226170706C69636174696F6E2F766E642E6F70656E786D6C666F';
wwv_flow_imp.g_varchar2_table(782) := '726D6174732D6F6666696365646F63756D656E742E73707265616473686565746D6C2E7368656574222C786C743A226170706C69636174696F6E2F766E642E6D732D657863656C222C786C746D3A226170706C69636174696F6E2F766E642E6D732D6578';
wwv_flow_imp.g_varchar2_table(783) := '63656C2E74656D706C6174652E6D6163726F656E61626C65642E3132222C786C74783A226170706C69636174696F6E2F766E642E6F70656E786D6C666F726D6174732D6F6666696365646F63756D656E742E73707265616473686565746D6C2E74656D70';
wwv_flow_imp.g_varchar2_table(784) := '6C617465222C786C773A226170706C69636174696F6E2F766E642E6D732D657863656C222C7478743A22746578742F706C61696E222C746578743A22746578742F706C61696E222C636F6E663A22746578742F706C61696E222C6C6F673A22746578742F';
wwv_flow_imp.g_varchar2_table(785) := '706C61696E222C7064663A226170706C69636174696F6E2F706466222C7A69703A226170706C69636174696F6E2F7A6970222C22377A223A226170706C69636174696F6E2F782D377A2D636F6D70726573736564222C7261723A226170706C6963617469';
wwv_flow_imp.g_varchar2_table(786) := '6F6E2F782D7261722D636F6D70726573736564222C7461723A226170706C69636174696F6E2F782D746172222C677A3A226170706C69636174696F6E2F677A6970222C646D673A226170706C69636174696F6E2F782D6170706C652D6469736B696D6167';
wwv_flow_imp.g_varchar2_table(787) := '65227D3B66756E6374696F6E2067732869297B76617220653B696628692E747970652972657475726E20692E747970653B6C657420743D692E6E616D653F28653D426928692E6E616D65292E657874656E73696F6E293D3D6E756C6C3F766F696420303A';
wwv_flow_imp.g_varchar2_table(788) := '652E746F4C6F7765724361736528293A6E756C6C3B72657475726E207426267420696E206D6E3F6D6E5B745D3A226170706C69636174696F6E2F6F637465742D73747265616D227D6E2867732C2267657446696C655479706522293B66756E6374696F6E';
wwv_flow_imp.g_varchar2_table(789) := '204B312869297B72657475726E20692E63686172436F646541742830292E746F537472696E67283332297D6E284B312C22656E636F646543686172616374657222293B66756E6374696F6E207A662869297B6C657420653D22223B72657475726E20692E';
wwv_flow_imp.g_varchar2_table(790) := '7265706C616365282F5B5E412D5A302D395D2F67692C743D3E28652B3D602D247B4B312874297D602C222F2229292B657D6E287A662C22656E636F646546696C656E616D6522293B66756E6374696F6E206A662869297B6C657420653D2275707079223B';
wwv_flow_imp.g_varchar2_table(791) := '72657475726E20747970656F6620692E6E616D653D3D22737472696E6722262628652B3D602D247B7A6628692E6E616D652E746F4C6F776572436173652829297D60292C692E74797065213D3D766F69642030262628652B3D602D247B692E747970657D';
wwv_flow_imp.g_varchar2_table(792) := '60292C692E6D6574612626747970656F6620692E6D6574612E72656C6174697665506174683D3D22737472696E6722262628652B3D602D247B7A6628692E6D6574612E72656C6174697665506174682E746F4C6F776572436173652829297D60292C692E';
wwv_flow_imp.g_varchar2_table(793) := '646174612E73697A65213D3D766F69642030262628652B3D602D247B692E646174612E73697A657D60292C692E646174612E6C6173744D6F646966696564213D3D766F69642030262628652B3D602D247B692E646174612E6C6173744D6F646966696564';
wwv_flow_imp.g_varchar2_table(794) := '7D60292C657D6E286A662C2267656E657261746546696C65494422293B66756E6374696F6E2058312869297B72657475726E21692E697352656D6F74657C7C21692E72656D6F74653F21313A6E657720536574285B22626F78222C2264726F70626F7822';
wwv_flow_imp.g_varchar2_table(795) := '2C226472697665222C2266616365626F6F6B222C22756E73706C617368225D292E68617328692E72656D6F74652E70726F7669646572297D6E2858312C2268617346696C65537461626C65496422293B66756E6374696F6E20446C2869297B6966285831';
wwv_flow_imp.g_varchar2_table(796) := '2869292972657475726E20692E69643B6C657420653D67732869293B72657475726E206A66287B2E2E2E692C747970653A657D297D6E28446C2C226765745361666546696C65496422293B66756E6374696F6E2046682869297B696628693D3D6E756C6C';
wwv_flow_imp.g_varchar2_table(797) := '2626747970656F66206E6176696761746F723C227522262628693D6E6176696761746F722E757365724167656E74292C21692972657475726E21303B6C657420653D2F456467655C2F285C642B5C2E5C642B292F2E657865632869293B69662821652972';
wwv_flow_imp.g_varchar2_table(798) := '657475726E21303B6C657420743D655B315D2C5B722C735D3D742E73706C697428222E22293B72657475726E20723D7061727365496E7428722C3130292C733D7061727365496E7428732C3130292C723C31357C7C723D3D3D31352626733C3135303633';
wwv_flow_imp.g_varchar2_table(799) := '7C7C723E31387C7C723D3D3D31382626733E3D31383231387D6E2846682C22737570706F72747355706C6F616450726F677265737322293B66756E6374696F6E20786828692C65297B72657475726E20652E6E616D653F652E6E616D653A692E73706C69';
wwv_flow_imp.g_varchar2_table(800) := '7428222F22295B305D3D3D3D22696D616765223F60247B692E73706C697428222F22295B305D7D2E247B692E73706C697428222F22295B315D7D603A226E6F6E616D65227D6E2878682C2267657446696C654E616D6522293B66756E6374696F6E204568';
wwv_flow_imp.g_varchar2_table(801) := '2869297B72657475726E20693C31303F6030247B697D603A692E746F537472696E6728297D6E2845682C2270616422293B66756E6374696F6E20786F28297B6C657420693D6E657720446174652C653D456828692E676574486F7572732829292C743D45';
wwv_flow_imp.g_varchar2_table(802) := '6828692E6765744D696E757465732829292C723D456828692E6765745365636F6E64732829293B72657475726E60247B657D3A247B747D3A247B727D607D6E28786F2C2267657454696D655374616D7022293B7661722048663D7B64656275673A28293D';
wwv_flow_imp.g_varchar2_table(803) := '3E7B7D2C7761726E3A28293D3E7B7D2C6572726F723A66756E6374696F6E28297B666F722876617220693D617267756D656E74732E6C656E6774682C653D6E65772041727261792869292C743D303B743C693B742B2B29655B745D3D617267756D656E74';
wwv_flow_imp.g_varchar2_table(804) := '735B745D3B72657475726E20636F6E736F6C652E6572726F7228605B557070795D205B247B786F28297D5D602C2E2E2E65297D7D2C676E3D7B64656275673A66756E6374696F6E28297B666F722876617220693D617267756D656E74732E6C656E677468';
wwv_flow_imp.g_varchar2_table(805) := '2C653D6E65772041727261792869292C743D303B743C693B742B2B29655B745D3D617267756D656E74735B745D3B72657475726E20636F6E736F6C652E646562756728605B557070795D205B247B786F28297D5D602C2E2E2E65297D2C7761726E3A6675';
wwv_flow_imp.g_varchar2_table(806) := '6E6374696F6E28297B666F722876617220693D617267756D656E74732E6C656E6774682C653D6E65772041727261792869292C743D303B743C693B742B2B29655B745D3D617267756D656E74735B745D3B72657475726E20636F6E736F6C652E7761726E';
wwv_flow_imp.g_varchar2_table(807) := '28605B557070795D205B247B786F28297D5D602C2E2E2E65297D2C6572726F723A66756E6374696F6E28297B666F722876617220693D617267756D656E74732E6C656E6774682C653D6E65772041727261792869292C743D303B743C693B742B2B29655B';
wwv_flow_imp.g_varchar2_table(808) := '745D3D617267756D656E74735B745D3B72657475726E20636F6E736F6C652E6572726F7228605B557070795D205B247B786F28297D5D602C2E2E2E65297D7D3B766172204D6C3D646528496C28292C31292C58663D6465284B6628292C31293B76617220';
wwv_flow_imp.g_varchar2_table(809) := '59663D7B6D617846696C6553697A653A6E756C6C2C6D696E46696C6553697A653A6E756C6C2C6D6178546F74616C46696C6553697A653A6E756C6C2C6D61784E756D6265724F6646696C65733A6E756C6C2C6D696E4E756D6265724F6646696C65733A6E';
wwv_flow_imp.g_varchar2_table(810) := '756C6C2C616C6C6F77656446696C6554797065733A6E756C6C2C72657175697265644D6574614669656C64733A5B5D7D2C54743D636C61737320657874656E6473204572726F727B636F6E7374727563746F7228652C74297B6C65747B69735573657246';
wwv_flow_imp.g_varchar2_table(811) := '6163696E673A723D21302C66696C653A737D3D743D3D3D766F696420303F7B7D3A743B73757065722865292C746869732E69735265737472696374696F6E3D21302C746869732E697355736572466163696E673D722C73213D6E756C6C26262874686973';
wwv_flow_imp.g_varchar2_table(812) := '2E66696C653D73297D7D3B6E2854742C225265737472696374696F6E4572726F7222293B76617220796E3D636C6173737B636F6E7374727563746F7228652C74297B746869732E6931386E3D742C746869732E6765744F7074733D28293D3E7B6C657420';
wwv_flow_imp.g_varchar2_table(813) := '723D6528293B696628722E7265737472696374696F6E732E616C6C6F77656446696C655479706573213D6E756C6C26262141727261792E6973417272617928722E7265737472696374696F6E732E616C6C6F77656446696C65547970657329297468726F';
wwv_flow_imp.g_varchar2_table(814) := '77206E657720547970654572726F722822607265737472696374696F6E732E616C6C6F77656446696C65547970657360206D75737420626520616E20617272617922293B72657475726E20727D7D76616C69646174654167677265676174655265737472';
wwv_flow_imp.g_varchar2_table(815) := '696374696F6E7328652C74297B6C65747B6D6178546F74616C46696C6553697A653A722C6D61784E756D6265724F6646696C65733A737D3D746869732E6765744F70747328292E7265737472696374696F6E733B696628732626652E66696C7465722861';
wwv_flow_imp.g_varchar2_table(816) := '3D3E21612E697347686F7374292E6C656E6774682B742E6C656E6774683E73297468726F77206E65772054742860247B746869732E6931386E2822796F7543616E4F6E6C7955706C6F616458222C7B736D6172745F636F756E743A737D297D60293B6966';
wwv_flow_imp.g_varchar2_table(817) := '2872297B6C6574206F3D652E7265647563652828612C6C293D3E612B6C2E73697A652C30293B666F72286C65742061206F66207429696628612E73697A65213D6E756C6C2626286F2B3D612E73697A652C6F3E7229297468726F77206E65772054742874';
wwv_flow_imp.g_varchar2_table(818) := '6869732E6931386E28226578636565647353697A65222C7B73697A653A28302C4D6C2E64656661756C74292872292C66696C653A612E6E616D657D29297D7D76616C696461746553696E676C6546696C652865297B6C65747B6D617846696C6553697A65';
wwv_flow_imp.g_varchar2_table(819) := '3A742C6D696E46696C6553697A653A722C616C6C6F77656446696C6554797065733A737D3D746869732E6765744F70747328292E7265737472696374696F6E733B69662873262621732E736F6D6528613D3E612E696E636C7564657328222F22293F652E';
wwv_flow_imp.g_varchar2_table(820) := '747970653F28302C58662E64656661756C742928652E747970652E7265706C616365282F3B2E2A3F242F2C2222292C61293A21313A615B305D3D3D3D222E222626652E657874656E73696F6E3F652E657874656E73696F6E2E746F4C6F77657243617365';
wwv_flow_imp.g_varchar2_table(821) := '28293D3D3D612E736C6963652831292E746F4C6F7765724361736528293A213129297B6C657420613D732E6A6F696E28222C2022293B7468726F77206E657720547428746869732E6931386E2822796F7543616E4F6E6C7955706C6F616446696C655479';
wwv_flow_imp.g_varchar2_table(822) := '706573222C7B74797065733A617D292C7B66696C653A657D297D696628742626652E73697A65213D6E756C6C2626652E73697A653E74297468726F77206E657720547428746869732E6931386E28226578636565647353697A65222C7B73697A653A2830';
wwv_flow_imp.g_varchar2_table(823) := '2C4D6C2E64656661756C74292874292C66696C653A652E6E616D657D292C7B66696C653A657D293B696628722626652E73697A65213D6E756C6C2626652E73697A653C72297468726F77206E657720547428746869732E6931386E2822696E666572696F';
wwv_flow_imp.g_varchar2_table(824) := '7253697A65222C7B73697A653A28302C4D6C2E64656661756C74292872297D292C7B66696C653A657D297D76616C696461746528652C74297B742E666F724561636828723D3E7B746869732E76616C696461746553696E676C6546696C652872297D292C';
wwv_flow_imp.g_varchar2_table(825) := '746869732E76616C69646174654167677265676174655265737472696374696F6E7328652C74297D76616C69646174654D696E4E756D6265724F6646696C65732865297B6C65747B6D696E4E756D6265724F6646696C65733A747D3D746869732E676574';
wwv_flow_imp.g_varchar2_table(826) := '4F70747328292E7265737472696374696F6E733B6966284F626A6563742E6B6579732865292E6C656E6774683C74297468726F77206E657720547428746869732E6931386E2822796F7548617665546F41744C6561737453656C65637458222C7B736D61';
wwv_flow_imp.g_varchar2_table(827) := '72745F636F756E743A747D29297D6765744D697373696E6752657175697265644D6574614669656C64732865297B6C657420743D6E657720547428746869732E6931386E28226D697373696E6752657175697265644D6574614669656C644F6E46696C65';
wwv_flow_imp.g_varchar2_table(828) := '222C7B66696C654E616D653A652E6E616D657D29292C7B72657175697265644D6574614669656C64733A727D3D746869732E6765744F70747328292E7265737472696374696F6E732C733D5B5D3B666F72286C6574206F206F6620722928214F626A6563';
wwv_flow_imp.g_varchar2_table(829) := '742E6861734F776E28652E6D6574612C6F297C7C652E6D6574615B6F5D3D3D3D2222292626732E70757368286F293B72657475726E7B6D697373696E674669656C64733A732C6572726F723A747D7D7D3B6E28796E2C225265737472696374657222293B';
wwv_flow_imp.g_varchar2_table(830) := '7661722051663D7B737472696E67733A7B61646442756C6B46696C65734661696C65643A7B303A224661696C656420746F2061646420257B736D6172745F636F756E747D2066696C652064756520746F20616E20696E7465726E616C206572726F72222C';
wwv_flow_imp.g_varchar2_table(831) := '313A224661696C656420746F2061646420257B736D6172745F636F756E747D2066696C65732064756520746F20696E7465726E616C206572726F7273227D2C796F7543616E4F6E6C7955706C6F6164583A7B303A22596F752063616E206F6E6C79207570';
wwv_flow_imp.g_varchar2_table(832) := '6C6F616420257B736D6172745F636F756E747D2066696C65222C313A22596F752063616E206F6E6C792075706C6F616420257B736D6172745F636F756E747D2066696C6573227D2C796F7548617665546F41744C6561737453656C656374583A7B303A22';
wwv_flow_imp.g_varchar2_table(833) := '596F75206861766520746F2073656C656374206174206C6561737420257B736D6172745F636F756E747D2066696C65222C313A22596F75206861766520746F2073656C656374206174206C6561737420257B736D6172745F636F756E747D2066696C6573';
wwv_flow_imp.g_varchar2_table(834) := '227D2C6578636565647353697A653A22257B66696C657D2065786365656473206D6178696D756D20616C6C6F7765642073697A65206F6620257B73697A657D222C6D697373696E6752657175697265644D6574614669656C643A224D697373696E672072';
wwv_flow_imp.g_varchar2_table(835) := '65717569726564206D657461206669656C6473222C6D697373696E6752657175697265644D6574614669656C644F6E46696C653A224D697373696E67207265717569726564206D657461206669656C647320696E20257B66696C654E616D657D222C696E';
wwv_flow_imp.g_varchar2_table(836) := '666572696F7253697A653A22546869732066696C6520697320736D616C6C6572207468616E2074686520616C6C6F7765642073697A65206F6620257B73697A657D222C796F7543616E4F6E6C7955706C6F616446696C6554797065733A22596F75206361';
wwv_flow_imp.g_varchar2_table(837) := '6E206F6E6C792075706C6F61643A20257B74797065737D222C6E6F4D6F726546696C6573416C6C6F7765643A2243616E6E6F7420616464206D6F72652066696C6573222C6E6F4475706C6963617465733A2243616E6E6F74206164642074686520647570';
wwv_flow_imp.g_varchar2_table(838) := '6C69636174652066696C652027257B66696C654E616D657D272C20697420616C726561647920657869737473222C636F6D70616E696F6E4572726F723A22436F6E6E656374696F6E207769746820436F6D70616E696F6E206661696C6564222C61757468';
wwv_flow_imp.g_varchar2_table(839) := '41626F727465643A2241757468656E7469636174696F6E2061626F72746564222C636F6D70616E696F6E556E617574686F72697A6548696E743A22546F20756E617574686F72697A6520746F20796F757220257B70726F76696465727D206163636F756E';
wwv_flow_imp.g_varchar2_table(840) := '742C20706C6561736520676F20746F20257B75726C7D222C6661696C6564546F55706C6F61643A224661696C656420746F2075706C6F616420257B66696C657D222C6E6F496E7465726E6574436F6E6E656374696F6E3A224E6F20496E7465726E657420';
wwv_flow_imp.g_varchar2_table(841) := '636F6E6E656374696F6E222C636F6E6E6563746564546F496E7465726E65743A22436F6E6E656374656420746F2074686520496E7465726E6574222C6E6F46696C6573466F756E643A22596F752068617665206E6F2066696C6573206F7220666F6C6465';
wwv_flow_imp.g_varchar2_table(842) := '72732068657265222C6E6F536561726368526573756C74733A22556E666F7274756E6174656C792C20746865726520617265206E6F20726573756C747320666F72207468697320736561726368222C73656C656374583A7B303A2253656C65637420257B';
wwv_flow_imp.g_varchar2_table(843) := '736D6172745F636F756E747D222C313A2253656C65637420257B736D6172745F636F756E747D227D2C616C6C46696C657346726F6D466F6C6465724E616D65643A22416C6C2066696C65732066726F6D20666F6C64657220257B6E616D657D222C6F7065';
wwv_flow_imp.g_varchar2_table(844) := '6E466F6C6465724E616D65643A224F70656E20666F6C64657220257B6E616D657D222C63616E63656C3A2243616E63656C222C6C6F674F75743A224C6F67206F7574222C66696C7465723A2246696C746572222C726573657446696C7465723A22526573';
wwv_flow_imp.g_varchar2_table(845) := '65742066696C746572222C6C6F6164696E673A224C6F6164696E672E2E2E222C6C6F616465645846696C65733A224C6F6164656420257B6E756D46696C65737D2066696C6573222C61757468656E746963617465576974685469746C653A22506C656173';
wwv_flow_imp.g_varchar2_table(846) := '652061757468656E746963617465207769746820257B706C7567696E4E616D657D20746F2073656C6563742066696C6573222C61757468656E746963617465576974683A22436F6E6E65637420746F20257B706C7567696E4E616D657D222C7369676E49';
wwv_flow_imp.g_varchar2_table(847) := '6E57697468476F6F676C653A225369676E20696E207769746820476F6F676C65222C736561726368496D616765733A2253656172636820666F7220696D61676573222C656E74657254657874546F5365617263683A22456E746572207465787420746F20';
wwv_flow_imp.g_varchar2_table(848) := '73656172636820666F7220696D61676573222C7365617263683A22536561726368222C72657365745365617263683A22526573657420736561726368222C656D707479466F6C64657241646465643A224E6F2066696C6573207765726520616464656420';
wwv_flow_imp.g_varchar2_table(849) := '66726F6D20656D70747920666F6C646572222C61646465644E756D46696C65733A22416464656420257B6E756D46696C65737D2066696C65287329222C666F6C646572416C726561647941646465643A2754686520666F6C6465722022257B666F6C6465';
wwv_flow_imp.g_varchar2_table(850) := '727D222077617320616C7265616479206164646564272C666F6C64657241646465643A7B303A22416464656420257B736D6172745F636F756E747D2066696C652066726F6D20257B666F6C6465727D222C313A22416464656420257B736D6172745F636F';
wwv_flow_imp.g_varchar2_table(851) := '756E747D2066696C65732066726F6D20257B666F6C6465727D227D2C6164646974696F6E616C5265737472696374696F6E734661696C65643A22257B636F756E747D206164646974696F6E616C207265737472696374696F6E732077657265206E6F7420';
wwv_flow_imp.g_varchar2_table(852) := '66756C66696C6C6564227D7D3B766172204A662C5A663B66756E6374696F6E204828692C65297B696628214F626A6563742E70726F746F747970652E6861734F776E50726F70657274792E63616C6C28692C6529297468726F77206E6577205479706545';
wwv_flow_imp.g_varchar2_table(853) := '72726F722822617474656D7074656420746F207573652070726976617465206669656C64206F6E206E6F6E2D696E7374616E636522293B72657475726E20697D6E28482C225F636C617373507269766174654669656C644C6F6F73654261736522293B76';
wwv_flow_imp.g_varchar2_table(854) := '6172204A313D303B66756E6374696F6E2048652869297B72657475726E225F5F707269766174655F222B4A312B2B2B225F222B697D6E2848652C225F636C617373507269766174654669656C644C6F6F73654B657922293B766172205A313D7B76657273';
wwv_flow_imp.g_varchar2_table(855) := '696F6E3A22332E382E30227D2C4E6C3D6E2828293D3E287B746F74616C50726F67726573733A302C616C6C6F774E657755706C6F61643A21302C6572726F723A6E756C6C2C7265636F766572656453746174653A6E756C6C7D292C226765744465666175';
wwv_flow_imp.g_varchar2_table(856) := '6C7455706C6F6164537461746522292C75743D48652822706C7567696E7322292C4B743D486528227265737472696374657222292C766E3D4865282273746F7265556E73756273637269626522292C70723D48652822656D697474657222292C79733D48';
wwv_flow_imp.g_varchar2_table(857) := '65282270726550726F636573736F727322292C76733D4865282275706C6F616465727322292C67723D48652822706F737450726F636573736F727322292C58743D48652822696E666F726D416E64456D697422292C466E3D48652822636865636B526571';
wwv_flow_imp.g_varchar2_table(858) := '75697265644D6574614669656C64734F6E46696C6522292C43683D48652822636865636B52657175697265644D6574614669656C647322292C626E3D486528226173736572744E657755706C6F6164416C6C6F77656422292C41683D486528227472616E';
wwv_flow_imp.g_varchar2_table(859) := '73666F726D46696C6522292C776E3D48652822737461727449664175746F50726F6365656422292C536E3D48652822636865636B416E6455706461746546696C65537461746522292C4F683D486528226164644C697374656E65727322292C50693D4865';
wwv_flow_imp.g_varchar2_table(860) := '28227570646174654F6E6C696E6553746174757322292C506E3D4865282272657175657374436C69656E744279496422292C66723D4865282263726561746555706C6F616422292C54683D4865282267657455706C6F616422292C62733D486528227265';
wwv_flow_imp.g_varchar2_table(861) := '6D6F766555706C6F616422292C6D723D4865282272756E55706C6F616422293B4A663D53796D626F6C2E666F7228227570707920746573743A20676574506C7567696E7322293B5A663D53796D626F6C2E666F7228227570707920746573743A20637265';
wwv_flow_imp.g_varchar2_table(862) := '61746555706C6F616422293B766172205F6E3D636C6173737B636F6E7374727563746F722865297B4F626A6563742E646566696E6550726F706572747928746869732C6D722C7B76616C75653A64777D292C4F626A6563742E646566696E6550726F7065';
wwv_flow_imp.g_varchar2_table(863) := '72747928746869732C62732C7B76616C75653A68777D292C4F626A6563742E646566696E6550726F706572747928746869732C54682C7B76616C75653A75777D292C4F626A6563742E646566696E6550726F706572747928746869732C66722C7B76616C';
wwv_flow_imp.g_varchar2_table(864) := '75653A6C777D292C4F626A6563742E646566696E6550726F706572747928746869732C4F682C7B76616C75653A61777D292C4F626A6563742E646566696E6550726F706572747928746869732C536E2C7B76616C75653A6E777D292C4F626A6563742E64';
wwv_flow_imp.g_varchar2_table(865) := '6566696E6550726F706572747928746869732C776E2C7B76616C75653A6F777D292C4F626A6563742E646566696E6550726F706572747928746869732C41682C7B76616C75653A73777D292C4F626A6563742E646566696E6550726F7065727479287468';
wwv_flow_imp.g_varchar2_table(866) := '69732C626E2C7B76616C75653A72777D292C4F626A6563742E646566696E6550726F706572747928746869732C43682C7B76616C75653A69777D292C4F626A6563742E646566696E6550726F706572747928746869732C466E2C7B76616C75653A74777D';
wwv_flow_imp.g_varchar2_table(867) := '292C4F626A6563742E646566696E6550726F706572747928746869732C58742C7B76616C75653A65777D292C4F626A6563742E646566696E6550726F706572747928746869732C75742C7B7772697461626C653A21302C76616C75653A4F626A6563742E';
wwv_flow_imp.g_varchar2_table(868) := '637265617465286E756C6C297D292C4F626A6563742E646566696E6550726F706572747928746869732C4B742C7B7772697461626C653A21302C76616C75653A766F696420307D292C4F626A6563742E646566696E6550726F706572747928746869732C';
wwv_flow_imp.g_varchar2_table(869) := '766E2C7B7772697461626C653A21302C76616C75653A766F696420307D292C4F626A6563742E646566696E6550726F706572747928746869732C70722C7B7772697461626C653A21302C76616C75653A28302C656D2E64656661756C742928297D292C4F';
wwv_flow_imp.g_varchar2_table(870) := '626A6563742E646566696E6550726F706572747928746869732C79732C7B7772697461626C653A21302C76616C75653A6E6577205365747D292C4F626A6563742E646566696E6550726F706572747928746869732C76732C7B7772697461626C653A2130';
wwv_flow_imp.g_varchar2_table(871) := '2C76616C75653A6E6577205365747D292C4F626A6563742E646566696E6550726F706572747928746869732C67722C7B7772697461626C653A21302C76616C75653A6E6577205365747D292C746869732E63616C63756C61746550726F67726573733D28';
wwv_flow_imp.g_varchar2_table(872) := '302C746D2E64656661756C74292828722C73293D3E7B6C6574206F3D746869732E67657446696C6528723F2E6964293B696628723D3D6E756C6C7C7C216F297B746869732E6C6F6728604E6F742073657474696E672070726F677265737320666F722061';
wwv_flow_imp.g_varchar2_table(873) := '2066696C65207468617420686173206265656E2072656D6F7665643A20247B723F2E69647D60293B72657475726E7D6966286F2E70726F67726573732E70657263656E746167653D3D3D313030297B746869732E6C6F6728604E6F742073657474696E67';
wwv_flow_imp.g_varchar2_table(874) := '2070726F677265737320666F7220612066696C65207468617420686173206265656E20616C72656164792075706C6F616465643A20247B722E69647D60293B72657475726E7D6C657420613D4E756D6265722E697346696E69746528732E627974657354';
wwv_flow_imp.g_varchar2_table(875) := '6F74616C292626732E6279746573546F74616C3E303B746869732E73657446696C65537461746528722E69642C7B70726F67726573733A7B2E2E2E6F2E70726F67726573732C627974657355706C6F616465643A732E627974657355706C6F616465642C';
wwv_flow_imp.g_varchar2_table(876) := '6279746573546F74616C3A732E6279746573546F74616C2C70657263656E746167653A613F4D6174682E726F756E6428732E627974657355706C6F616465642F732E6279746573546F74616C2A313030293A307D7D292C746869732E63616C63756C6174';
wwv_flow_imp.g_varchar2_table(877) := '65546F74616C50726F677265737328297D2C3530302C7B6C656164696E673A21302C747261696C696E673A21307D292C4F626A6563742E646566696E6550726F706572747928746869732C50692C7B7772697461626C653A21302C76616C75653A746869';
wwv_flow_imp.g_varchar2_table(878) := '732E7570646174654F6E6C696E655374617475732E62696E642874686973297D292C4F626A6563742E646566696E6550726F706572747928746869732C506E2C7B7772697461626C653A21302C76616C75653A6E6577204D61707D292C746869732E6465';
wwv_flow_imp.g_varchar2_table(879) := '6661756C744C6F63616C653D51663B6C657420743D7B69643A2275707079222C6175746F50726F636565643A21312C616C6C6F774D756C7469706C6555706C6F6164426174636865733A21302C64656275673A21312C7265737472696374696F6E733A59';
wwv_flow_imp.g_varchar2_table(880) := '662C6D6574613A7B7D2C6F6E4265666F726546696C6541646465643A28722C73293D3E214F626A6563742E6861734F776E28732C722E6964292C6F6E4265666F726555706C6F61643A723D3E722C73746F72653A6E6577206B6C2C6C6F676765723A4866';
wwv_flow_imp.g_varchar2_table(881) := '2C696E666F54696D656F75743A3565337D3B746869732E6F7074733D7B2E2E2E742C2E2E2E652C7265737472696374696F6E733A7B2E2E2E742E7265737472696374696F6E732C2E2E2E652626652E7265737472696374696F6E737D7D2C652626652E6C';
wwv_flow_imp.g_varchar2_table(882) := '6F676765722626652E64656275673F746869732E6C6F672822596F7520617265207573696E67206120637573746F6D20606C6F67676572602C2062757420616C736F20736574206064656275673A2074727565602C207768696368207573657320627569';
wwv_flow_imp.g_varchar2_table(883) := '6C742D696E206C6F6767657220746F206F7574707574206C6F677320746F20636F6E736F6C652E2049676E6F72696E67206064656275673A20747275656020616E64207573696E6720796F757220637573746F6D20606C6F67676572602E222C22776172';
wwv_flow_imp.g_varchar2_table(884) := '6E696E6722293A652626652E6465627567262628746869732E6F7074732E6C6F676765723D676E292C746869732E6C6F6728605573696E6720436F72652076247B746869732E636F6E7374727563746F722E56455253494F4E7D60292C746869732E6931';
wwv_flow_imp.g_varchar2_table(885) := '386E496E697428292C746869732E73746F72653D746869732E6F7074732E73746F72652C746869732E7365745374617465287B2E2E2E4E6C28292C706C7567696E733A7B7D2C66696C65733A7B7D2C63757272656E7455706C6F6164733A7B7D2C636170';
wwv_flow_imp.g_varchar2_table(886) := '6162696C69746965733A7B75706C6F616450726F67726573733A466828292C696E646976696475616C43616E63656C6C6174696F6E3A21302C726573756D61626C6555706C6F6164733A21317D2C6D6574613A7B2E2E2E746869732E6F7074732E6D6574';
wwv_flow_imp.g_varchar2_table(887) := '617D2C696E666F3A5B5D7D292C4828746869732C4B74295B4B745D3D6E657720796E2828293D3E746869732E6F7074732C746869732E6931386E292C4828746869732C766E295B766E5D3D746869732E73746F72652E7375627363726962652828722C73';
wwv_flow_imp.g_varchar2_table(888) := '2C6F293D3E7B746869732E656D6974282273746174652D757064617465222C722C732C6F292C746869732E757064617465416C6C2873297D292C746869732E6F7074732E64656275672626747970656F662077696E646F773C22752226262877696E646F';
wwv_flow_imp.g_varchar2_table(889) := '775B746869732E6F7074732E69645D3D74686973292C4828746869732C4F68295B4F685D28297D656D69742865297B666F722876617220743D617267756D656E74732E6C656E6774682C723D6E657720417272617928743E313F742D313A30292C733D31';
wwv_flow_imp.g_varchar2_table(890) := '3B733C743B732B2B29725B732D315D3D617267756D656E74735B735D3B4828746869732C7072295B70725D2E656D697428652C2E2E2E72297D6F6E28652C74297B72657475726E204828746869732C7072295B70725D2E6F6E28652C74292C746869737D';
wwv_flow_imp.g_varchar2_table(891) := '6F6E636528652C74297B72657475726E204828746869732C7072295B70725D2E6F6E636528652C74292C746869737D6F666628652C74297B72657475726E204828746869732C7072295B70725D2E6F666628652C74292C746869737D757064617465416C';
wwv_flow_imp.g_varchar2_table(892) := '6C2865297B746869732E69746572617465506C7567696E7328743D3E7B742E7570646174652865297D297D73657453746174652865297B746869732E73746F72652E73657453746174652865297D676574537461746528297B72657475726E2074686973';
wwv_flow_imp.g_varchar2_table(893) := '2E73746F72652E676574537461746528297D706174636846696C657353746174652865297B6C657420743D746869732E676574537461746528292E66696C65733B746869732E7365745374617465287B66696C65733A7B2E2E2E742C2E2E2E4F626A6563';
wwv_flow_imp.g_varchar2_table(894) := '742E66726F6D456E7472696573284F626A6563742E656E74726965732865292E6D617028723D3E7B6C65745B732C6F5D3D723B72657475726E5B732C7B2E2E2E745B735D2C2E2E2E6F7D5D7D29297D7D297D73657446696C65537461746528652C74297B';
wwv_flow_imp.g_varchar2_table(895) := '69662821746869732E676574537461746528292E66696C65735B655D297468726F77206E6577204572726F72286043616E5C7532303139742073657420737461746520666F7220247B657D20287468652066696C6520636F756C64206861766520626565';
wwv_flow_imp.g_varchar2_table(896) := '6E2072656D6F7665642960293B746869732E706174636846696C65735374617465287B5B655D3A747D297D6931386E496E697428297B6C657420653D6E28723D3E746869732E6C6F6728604D697373696E67206931386E20737472696E673A20247B727D';
wwv_flow_imp.g_varchar2_table(897) := '602C226572726F7222292C226F6E4D697373696E674B657922292C743D6E6577204B72285B746869732E64656661756C744C6F63616C652C746869732E6F7074732E6C6F63616C655D2C7B6F6E4D697373696E674B65793A657D293B746869732E693138';
wwv_flow_imp.g_varchar2_table(898) := '6E3D742E7472616E736C6174652E62696E642874292C746869732E6931386E41727261793D742E7472616E736C61746541727261792E62696E642874292C746869732E6C6F63616C653D742E6C6F63616C657D7365744F7074696F6E732865297B746869';
wwv_flow_imp.g_varchar2_table(899) := '732E6F7074733D7B2E2E2E746869732E6F7074732C2E2E2E652C7265737472696374696F6E733A7B2E2E2E746869732E6F7074732E7265737472696374696F6E732C2E2E2E652626652E7265737472696374696F6E737D7D2C652E6D6574612626746869';
wwv_flow_imp.g_varchar2_table(900) := '732E7365744D65746128652E6D657461292C746869732E6931386E496E697428292C652E6C6F63616C652626746869732E69746572617465506C7567696E7328743D3E7B742E7365744F7074696F6E732865297D292C746869732E736574537461746528';
wwv_flow_imp.g_varchar2_table(901) := '297D726573657450726F677265737328297B6C657420653D7B70657263656E746167653A302C627974657355706C6F616465643A302C75706C6F6164436F6D706C6574653A21312C75706C6F6164537461727465643A6E756C6C7D2C743D7B2E2E2E7468';
wwv_flow_imp.g_varchar2_table(902) := '69732E676574537461746528292E66696C65737D2C723D7B7D3B4F626A6563742E6B6579732874292E666F724561636828733D3E7B725B735D3D7B2E2E2E745B735D2C70726F67726573733A7B2E2E2E745B735D2E70726F67726573732C2E2E2E657D7D';
wwv_flow_imp.g_varchar2_table(903) := '7D292C746869732E7365745374617465287B66696C65733A722C2E2E2E4E6C28297D292C746869732E656D6974282272657365742D70726F677265737322297D636C65617255706C6F6164656446696C657328297B746869732E7365745374617465287B';
wwv_flow_imp.g_varchar2_table(904) := '2E2E2E4E6C28292C66696C65733A7B7D7D297D61646450726550726F636573736F722865297B4828746869732C7973295B79735D2E6164642865297D72656D6F766550726550726F636573736F722865297B72657475726E204828746869732C7973295B';
wwv_flow_imp.g_varchar2_table(905) := '79735D2E64656C6574652865297D616464506F737450726F636573736F722865297B4828746869732C6772295B67725D2E6164642865297D72656D6F7665506F737450726F636573736F722865297B72657475726E204828746869732C6772295B67725D';
wwv_flow_imp.g_varchar2_table(906) := '2E64656C6574652865297D61646455706C6F616465722865297B4828746869732C7673295B76735D2E6164642865297D72656D6F766555706C6F616465722865297B72657475726E204828746869732C7673295B76735D2E64656C6574652865297D7365';
wwv_flow_imp.g_varchar2_table(907) := '744D6574612865297B6C657420743D7B2E2E2E746869732E676574537461746528292E6D6574612C2E2E2E657D2C723D7B2E2E2E746869732E676574537461746528292E66696C65737D3B4F626A6563742E6B6579732872292E666F724561636828733D';
wwv_flow_imp.g_varchar2_table(908) := '3E7B725B735D3D7B2E2E2E725B735D2C6D6574613A7B2E2E2E725B735D2E6D6574612C2E2E2E657D7D7D292C746869732E6C6F672822416464696E67206D657461646174613A22292C746869732E6C6F672865292C746869732E7365745374617465287B';
wwv_flow_imp.g_varchar2_table(909) := '6D6574613A742C66696C65733A727D297D73657446696C654D65746128652C74297B6C657420723D7B2E2E2E746869732E676574537461746528292E66696C65737D3B69662821725B655D297B746869732E6C6F67282257617320747279696E6720746F';
wwv_flow_imp.g_varchar2_table(910) := '20736574206D6574616461746120666F7220612066696C65207468617420686173206265656E2072656D6F7665643A20222C65293B72657475726E7D6C657420733D7B2E2E2E725B655D2E6D6574612C2E2E2E747D3B725B655D3D7B2E2E2E725B655D2C';
wwv_flow_imp.g_varchar2_table(911) := '6D6574613A737D2C746869732E7365745374617465287B66696C65733A727D297D67657446696C652865297B72657475726E20746869732E676574537461746528292E66696C65735B655D7D67657446696C657328297B6C65747B66696C65733A657D3D';
wwv_flow_imp.g_varchar2_table(912) := '746869732E676574537461746528293B72657475726E204F626A6563742E76616C7565732865297D67657446696C657342794964732865297B72657475726E20652E6D617028743D3E746869732E67657446696C65287429297D6765744F626A6563744F';
wwv_flow_imp.g_varchar2_table(913) := '6646696C6573506572537461746528297B6C65747B66696C65733A652C746F74616C50726F67726573733A742C6572726F723A727D3D746869732E676574537461746528292C733D4F626A6563742E76616C7565732865292C6F3D732E66696C74657228';
wwv_flow_imp.g_varchar2_table(914) := '533D3E7B6C65747B70726F67726573733A457D3D533B72657475726E21452E75706C6F6164436F6D706C6574652626452E75706C6F6164537461727465647D292C613D732E66696C74657228533D3E21532E70726F67726573732E75706C6F6164537461';
wwv_flow_imp.g_varchar2_table(915) := '72746564292C6C3D732E66696C74657228533D3E532E70726F67726573732E75706C6F6164537461727465647C7C532E70726F67726573732E70726570726F636573737C7C532E70726F67726573732E706F737470726F63657373292C683D732E66696C';
wwv_flow_imp.g_varchar2_table(916) := '74657228533D3E532E70726F67726573732E75706C6F616453746172746564292C633D732E66696C74657228533D3E532E6973506175736564292C643D732E66696C74657228533D3E532E70726F67726573732E75706C6F6164436F6D706C657465292C';
wwv_flow_imp.g_varchar2_table(917) := '663D732E66696C74657228533D3E532E6572726F72292C793D6F2E66696C74657228533D3E21532E6973506175736564292C623D732E66696C74657228533D3E532E70726F67726573732E70726570726F636573737C7C532E70726F67726573732E706F';
wwv_flow_imp.g_varchar2_table(918) := '737470726F63657373293B72657475726E7B6E657746696C65733A612C7374617274656446696C65733A6C2C75706C6F61645374617274656446696C65733A682C70617573656446696C65733A632C636F6D706C65746546696C65733A642C6572726F72';
wwv_flow_imp.g_varchar2_table(919) := '656446696C65733A662C696E50726F677265737346696C65733A6F2C696E50726F67726573734E6F7450617573656446696C65733A792C70726F63657373696E6746696C65733A622C697355706C6F6164537461727465643A682E6C656E6774683E302C';
wwv_flow_imp.g_varchar2_table(920) := '6973416C6C436F6D706C6574653A743D3D3D3130302626642E6C656E6774683D3D3D732E6C656E6774682626622E6C656E6774683D3D3D302C6973416C6C4572726F7265643A2121722626662E6C656E6774683D3D3D732E6C656E6774682C6973416C6C';
wwv_flow_imp.g_varchar2_table(921) := '5061757365643A6F2E6C656E677468213D3D302626632E6C656E6774683D3D3D6F2E6C656E6774682C697355706C6F6164496E50726F67726573733A6F2E6C656E6774683E302C6973536F6D6547686F73743A732E736F6D6528533D3E532E697347686F';
wwv_flow_imp.g_varchar2_table(922) := '7374297D7D76616C69646174655265737472696374696F6E7328652C74297B743D3D3D766F69642030262628743D746869732E67657446696C65732829293B7472797B4828746869732C4B74295B4B745D2E76616C696461746528742C5B655D297D6361';
wwv_flow_imp.g_varchar2_table(923) := '7463682872297B72657475726E20727D72657475726E206E756C6C7D636865636B496646696C65416C72656164794578697374732865297B6C65747B66696C65733A747D3D746869732E676574537461746528293B72657475726E212128745B655D2626';
wwv_flow_imp.g_varchar2_table(924) := '21745B655D2E697347686F7374297D61646446696C652865297B4828746869732C626E295B626E5D2865293B6C65747B6E65787446696C657353746174653A742C76616C696446696C6573546F4164643A722C6572726F72733A737D3D4828746869732C';
wwv_flow_imp.g_varchar2_table(925) := '536E295B536E5D285B655D292C6F3D732E66696C746572286C3D3E6C2E69735265737472696374696F6E293B6966284828746869732C5874295B58745D286F292C732E6C656E6774683E30297468726F7720735B305D3B746869732E7365745374617465';
wwv_flow_imp.g_varchar2_table(926) := '287B66696C65733A747D293B6C65745B615D3D723B72657475726E20746869732E656D6974282266696C652D6164646564222C61292C746869732E656D6974282266696C65732D6164646564222C72292C746869732E6C6F67286041646465642066696C';
wwv_flow_imp.g_varchar2_table(927) := '653A20247B612E6E616D657D2C20247B612E69647D2C206D696D6520747970653A20247B612E747970657D60292C4828746869732C776E295B776E5D28292C612E69647D61646446696C65732865297B4828746869732C626E295B626E5D28293B6C6574';
wwv_flow_imp.g_varchar2_table(928) := '7B6E65787446696C657353746174653A742C76616C696446696C6573546F4164643A722C6572726F72733A737D3D4828746869732C536E295B536E5D2865292C6F3D732E66696C746572286C3D3E6C2E69735265737472696374696F6E293B4828746869';
wwv_flow_imp.g_varchar2_table(929) := '732C5874295B58745D286F293B6C657420613D732E66696C746572286C3D3E216C2E69735265737472696374696F6E293B696628612E6C656E6774683E30297B6C6574206C3D604D756C7469706C65206572726F7273206F63637572726564207768696C';
wwv_flow_imp.g_varchar2_table(930) := '6520616464696E672066696C65733A0A603B696628612E666F724561636828683D3E7B6C2B3D600A202A20247B682E6D6573736167657D607D292C746869732E696E666F287B6D6573736167653A746869732E6931386E282261646442756C6B46696C65';
wwv_flow_imp.g_varchar2_table(931) := '734661696C6564222C7B736D6172745F636F756E743A612E6C656E6774687D292C64657461696C733A6C7D2C226572726F72222C746869732E6F7074732E696E666F54696D656F7574292C747970656F66204167677265676174654572726F723D3D2266';
wwv_flow_imp.g_varchar2_table(932) := '756E6374696F6E22297468726F77206E6577204167677265676174654572726F7228612C6C293B7B6C657420683D6E6577204572726F72286C293B7468726F7720682E6572726F72733D612C687D7D746869732E7365745374617465287B66696C65733A';
wwv_flow_imp.g_varchar2_table(933) := '747D292C722E666F7245616368286C3D3E7B746869732E656D6974282266696C652D6164646564222C6C297D292C746869732E656D6974282266696C65732D6164646564222C72292C722E6C656E6774683E353F746869732E6C6F672860416464656420';
wwv_flow_imp.g_varchar2_table(934) := '6261746368206F6620247B722E6C656E6774687D2066696C657360293A4F626A6563742E76616C7565732872292E666F7245616368286C3D3E7B746869732E6C6F67286041646465642066696C653A20247B6C2E6E616D657D0A2069643A20247B6C2E69';
wwv_flow_imp.g_varchar2_table(935) := '647D0A20747970653A20247B6C2E747970657D60297D292C722E6C656E6774683E3026264828746869732C776E295B776E5D28297D72656D6F766546696C657328652C74297B6C65747B66696C65733A722C63757272656E7455706C6F6164733A737D3D';
wwv_flow_imp.g_varchar2_table(936) := '746869732E676574537461746528292C6F3D7B2E2E2E727D2C613D7B2E2E2E737D2C6C3D4F626A6563742E637265617465286E756C6C293B652E666F724561636828663D3E7B725B665D2626286C5B665D3D725B665D2C64656C657465206F5B665D297D';
wwv_flow_imp.g_varchar2_table(937) := '293B66756E6374696F6E20682866297B72657475726E206C5B665D3D3D3D766F696420307D6E28682C2266696C6549734E6F7452656D6F76656422292C4F626A6563742E6B6579732861292E666F724561636828663D3E7B6C657420793D735B665D2E66';
wwv_flow_imp.g_varchar2_table(938) := '696C654944732E66696C7465722868293B696628792E6C656E6774683D3D3D30297B64656C65746520615B665D3B72657475726E7D6C65747B6361706162696C69746965733A627D3D746869732E676574537461746528293B696628792E6C656E677468';
wwv_flow_imp.g_varchar2_table(939) := '213D3D735B665D2E66696C654944732E6C656E677468262621622E696E646976696475616C43616E63656C6C6174696F6E297468726F77206E6577204572726F722822696E646976696475616C43616E63656C6C6174696F6E2069732064697361626C65';
wwv_flow_imp.g_varchar2_table(940) := '6422293B615B665D3D7B2E2E2E735B665D2C66696C654944733A797D7D293B6C657420633D7B63757272656E7455706C6F6164733A612C66696C65733A6F7D3B4F626A6563742E6B657973286F292E6C656E6774683D3D3D30262628632E616C6C6F774E';
wwv_flow_imp.g_varchar2_table(941) := '657755706C6F61643D21302C632E6572726F723D6E756C6C2C632E7265636F766572656453746174653D6E756C6C292C746869732E73657453746174652863292C746869732E63616C63756C617465546F74616C50726F677265737328293B6C65742064';
wwv_flow_imp.g_varchar2_table(942) := '3D4F626A6563742E6B657973286C293B642E666F724561636828663D3E7B746869732E656D6974282266696C652D72656D6F766564222C6C5B665D2C74297D292C642E6C656E6774683E353F746869732E6C6F67286052656D6F76656420247B642E6C65';
wwv_flow_imp.g_varchar2_table(943) := '6E6774687D2066696C657360293A746869732E6C6F67286052656D6F7665642066696C65733A20247B642E6A6F696E28222C2022297D60297D72656D6F766546696C6528652C74297B743D3D3D766F69642030262628743D6E756C6C292C746869732E72';
wwv_flow_imp.g_varchar2_table(944) := '656D6F766546696C6573285B655D2C74297D7061757365526573756D652865297B69662821746869732E676574537461746528292E6361706162696C69746965732E726573756D61626C6555706C6F6164737C7C746869732E67657446696C652865292E';
wwv_flow_imp.g_varchar2_table(945) := '75706C6F6164436F6D706C6574652972657475726E3B6C657420723D2128746869732E67657446696C652865292E69735061757365647C7C2131293B72657475726E20746869732E73657446696C65537461746528652C7B69735061757365643A727D29';
wwv_flow_imp.g_varchar2_table(946) := '2C746869732E656D6974282275706C6F61642D7061757365222C652C72292C727D7061757365416C6C28297B6C657420653D7B2E2E2E746869732E676574537461746528292E66696C65737D3B4F626A6563742E6B6579732865292E66696C7465722872';
wwv_flow_imp.g_varchar2_table(947) := '3D3E21655B725D2E70726F67726573732E75706C6F6164436F6D706C6574652626655B725D2E70726F67726573732E75706C6F616453746172746564292E666F724561636828723D3E7B6C657420733D7B2E2E2E655B725D2C69735061757365643A2130';
wwv_flow_imp.g_varchar2_table(948) := '7D3B655B725D3D737D292C746869732E7365745374617465287B66696C65733A657D292C746869732E656D6974282270617573652D616C6C22297D726573756D65416C6C28297B6C657420653D7B2E2E2E746869732E676574537461746528292E66696C';
wwv_flow_imp.g_varchar2_table(949) := '65737D3B4F626A6563742E6B6579732865292E66696C74657228723D3E21655B725D2E70726F67726573732E75706C6F6164436F6D706C6574652626655B725D2E70726F67726573732E75706C6F616453746172746564292E666F724561636828723D3E';
wwv_flow_imp.g_varchar2_table(950) := '7B6C657420733D7B2E2E2E655B725D2C69735061757365643A21312C6572726F723A6E756C6C7D3B655B725D3D737D292C746869732E7365745374617465287B66696C65733A657D292C746869732E656D69742822726573756D652D616C6C22297D7265';
wwv_flow_imp.g_varchar2_table(951) := '747279416C6C28297B6C657420653D7B2E2E2E746869732E676574537461746528292E66696C65737D2C743D4F626A6563742E6B6579732865292E66696C74657228733D3E655B735D2E6572726F72293B696628742E666F724561636828733D3E7B6C65';
wwv_flow_imp.g_varchar2_table(952) := '74206F3D7B2E2E2E655B735D2C69735061757365643A21312C6572726F723A6E756C6C7D3B655B735D3D6F7D292C746869732E7365745374617465287B66696C65733A652C6572726F723A6E756C6C7D292C746869732E656D6974282272657472792D61';
wwv_flow_imp.g_varchar2_table(953) := '6C6C222C74292C742E6C656E6774683D3D3D302972657475726E2050726F6D6973652E7265736F6C7665287B7375636365737366756C3A5B5D2C6661696C65643A5B5D7D293B6C657420723D4828746869732C6672295B66725D28742C7B666F72636541';
wwv_flow_imp.g_varchar2_table(954) := '6C6C6F774E657755706C6F61643A21307D293B72657475726E204828746869732C6D72295B6D725D2872297D63616E63656C416C6C2865297B6C65747B726561736F6E3A743D2275736572227D3D653D3D3D766F696420303F7B7D3A653B696628746869';
wwv_flow_imp.g_varchar2_table(955) := '732E656D6974282263616E63656C2D616C6C222C7B726561736F6E3A747D292C743D3D3D227573657222297B6C65747B66696C65733A727D3D746869732E676574537461746528292C733D4F626A6563742E6B6579732872293B732E6C656E6774682626';
wwv_flow_imp.g_varchar2_table(956) := '746869732E72656D6F766546696C657328732C2263616E63656C2D616C6C22292C746869732E7365745374617465284E6C2829297D7D726574727955706C6F61642865297B746869732E73657446696C65537461746528652C7B6572726F723A6E756C6C';
wwv_flow_imp.g_varchar2_table(957) := '2C69735061757365643A21317D292C746869732E656D6974282275706C6F61642D7265747279222C65293B6C657420743D4828746869732C6672295B66725D285B655D2C7B666F726365416C6C6F774E657755706C6F61643A21307D293B72657475726E';
wwv_flow_imp.g_varchar2_table(958) := '204828746869732C6D72295B6D725D2874297D6C6F676F757428297B746869732E69746572617465506C7567696E7328653D3E7B652E70726F76696465722626652E70726F76696465722E6C6F676F75742626652E70726F76696465722E6C6F676F7574';
wwv_flow_imp.g_varchar2_table(959) := '28297D297D63616C63756C617465546F74616C50726F677265737328297B6C657420743D746869732E67657446696C657328292E66696C74657228633D3E632E70726F67726573732E75706C6F6164537461727465647C7C632E70726F67726573732E70';
wwv_flow_imp.g_varchar2_table(960) := '726570726F636573737C7C632E70726F67726573732E706F737470726F63657373293B696628742E6C656E6774683D3D3D30297B746869732E656D6974282270726F6772657373222C30292C746869732E7365745374617465287B746F74616C50726F67';
wwv_flow_imp.g_varchar2_table(961) := '726573733A307D293B72657475726E7D6C657420723D742E66696C74657228633D3E632E70726F67726573732E6279746573546F74616C213D6E756C6C292C733D742E66696C74657228633D3E632E70726F67726573732E6279746573546F74616C3D3D';
wwv_flow_imp.g_varchar2_table(962) := '6E756C6C293B696628722E6C656E6774683D3D3D30297B6C657420633D742E6C656E6774682A3130302C643D732E7265647563652828792C62293D3E792B622E70726F67726573732E70657263656E746167652C30292C663D4D6174682E726F756E6428';
wwv_flow_imp.g_varchar2_table(963) := '642F632A313030293B746869732E7365745374617465287B746F74616C50726F67726573733A667D293B72657475726E7D6C6574206F3D722E7265647563652828632C64293D3E632B642E70726F67726573732E6279746573546F74616C2C30292C613D';
wwv_flow_imp.g_varchar2_table(964) := '6F2F722E6C656E6774683B6F2B3D612A732E6C656E6774683B6C6574206C3D303B722E666F724561636828633D3E7B6C2B3D632E70726F67726573732E627974657355706C6F616465647D292C732E666F724561636828633D3E7B6C2B3D612A28632E70';
wwv_flow_imp.g_varchar2_table(965) := '726F67726573732E70657263656E746167657C7C30292F3130307D293B6C657420683D6F3D3D3D303F303A4D6174682E726F756E64286C2F6F2A313030293B683E313030262628683D313030292C746869732E7365745374617465287B746F74616C5072';
wwv_flow_imp.g_varchar2_table(966) := '6F67726573733A687D292C746869732E656D6974282270726F6772657373222C68297D7570646174654F6E6C696E6553746174757328297B28747970656F662077696E646F772E6E6176696761746F722E6F6E4C696E653C2275223F77696E646F772E6E';
wwv_flow_imp.g_varchar2_table(967) := '6176696761746F722E6F6E4C696E653A2130293F28746869732E656D6974282269732D6F6E6C696E6522292C746869732E7761734F66666C696E65262628746869732E656D697428226261636B2D6F6E6C696E6522292C746869732E696E666F28746869';
wwv_flow_imp.g_varchar2_table(968) := '732E6931386E2822636F6E6E6563746564546F496E7465726E657422292C2273756363657373222C336533292C746869732E7761734F66666C696E653D213129293A28746869732E656D6974282269732D6F66666C696E6522292C746869732E696E666F';
wwv_flow_imp.g_varchar2_table(969) := '28746869732E6931386E28226E6F496E7465726E6574436F6E6E656374696F6E22292C226572726F72222C30292C746869732E7761734F66666C696E653D2130297D676574494428297B72657475726E20746869732E6F7074732E69647D75736528652C';
wwv_flow_imp.g_varchar2_table(970) := '74297B696628747970656F662065213D2266756E6374696F6E22297B6C657420613D604578706563746564206120706C7567696E20636C6173732C2062757420676F7420247B653D3D3D6E756C6C3F226E756C6C223A747970656F6620657D2E20506C65';
wwv_flow_imp.g_varchar2_table(971) := '6173652076657269667920746861742074686520706C7567696E2077617320696D706F7274656420616E64207370656C6C656420636F72726563746C792E603B7468726F77206E657720547970654572726F722861297D6C657420723D6E657720652874';
wwv_flow_imp.g_varchar2_table(972) := '6869732C74292C733D722E69643B6966282173297468726F77206E6577204572726F722822596F757220706C7567696E206D757374206861766520616E20696422293B69662821722E74797065297468726F77206E6577204572726F722822596F757220';
wwv_flow_imp.g_varchar2_table(973) := '706C7567696E206D75737420686176652061207479706522293B6C6574206F3D746869732E676574506C7567696E2873293B6966286F297B6C657420613D60416C726561647920666F756E64206120706C7567696E206E616D65642027247B6F2E69647D';
wwv_flow_imp.g_varchar2_table(974) := '272E20547269656420746F207573653A2027247B737D272E0A5570707920706C7567696E73206D757374206861766520756E69717565205C6069645C60206F7074696F6E732E205365652068747470733A2F2F757070792E696F2F646F63732F706C7567';
wwv_flow_imp.g_varchar2_table(975) := '696E732F2369642E603B7468726F77206E6577204572726F722861297D72657475726E20652E56455253494F4E2626746869732E6C6F6728605573696E6720247B737D2076247B652E56455253494F4E7D60292C722E7479706520696E20482874686973';
wwv_flow_imp.g_varchar2_table(976) := '2C7574295B75745D3F4828746869732C7574295B75745D5B722E747970655D2E707573682872293A4828746869732C7574295B75745D5B722E747970655D3D5B725D2C722E696E7374616C6C28292C746869732E656D69742822706C7567696E2D616464';
wwv_flow_imp.g_varchar2_table(977) := '6564222C72292C746869737D676574506C7567696E2865297B666F72286C65742074206F66204F626A6563742E76616C756573284828746869732C7574295B75745D29297B6C657420723D742E66696E6428733D3E732E69643D3D3D65293B6966287221';
wwv_flow_imp.g_varchar2_table(978) := '3D6E756C6C2972657475726E20727D7D5B4A665D2865297B72657475726E204828746869732C7574295B75745D5B655D7D69746572617465506C7567696E732865297B4F626A6563742E76616C756573284828746869732C7574295B75745D292E666C61';
wwv_flow_imp.g_varchar2_table(979) := '742831292E666F72456163682865297D72656D6F7665506C7567696E2865297B746869732E6C6F67286052656D6F76696E6720706C7567696E20247B652E69647D60292C746869732E656D69742822706C7567696E2D72656D6F7665222C65292C652E75';
wwv_flow_imp.g_varchar2_table(980) := '6E696E7374616C6C2626652E756E696E7374616C6C28293B6C657420743D4828746869732C7574295B75745D5B652E747970655D2C723D742E66696E64496E64657828613D3E612E69643D3D3D652E6964293B72213D3D2D312626742E73706C69636528';
wwv_flow_imp.g_varchar2_table(981) := '722C31293B6C6574206F3D7B706C7567696E733A7B2E2E2E746869732E676574537461746528292E706C7567696E732C5B652E69645D3A766F696420307D7D3B746869732E7365745374617465286F297D636C6F73652865297B6C65747B726561736F6E';
wwv_flow_imp.g_varchar2_table(982) := '3A747D3D653D3D3D766F696420303F7B7D3A653B746869732E6C6F672860436C6F73696E67205570707920696E7374616E636520247B746869732E6F7074732E69647D3A2072656D6F76696E6720616C6C2066696C657320616E6420756E696E7374616C';
wwv_flow_imp.g_varchar2_table(983) := '6C696E6720706C7567696E7360292C746869732E63616E63656C416C6C287B726561736F6E3A747D292C4828746869732C766E295B766E5D28292C746869732E69746572617465506C7567696E7328723D3E7B746869732E72656D6F7665506C7567696E';
wwv_flow_imp.g_varchar2_table(984) := '2872297D292C747970656F662077696E646F773C227522262677696E646F772E72656D6F76654576656E744C697374656E657226262877696E646F772E72656D6F76654576656E744C697374656E657228226F6E6C696E65222C4828746869732C506929';
wwv_flow_imp.g_varchar2_table(985) := '5B50695D292C77696E646F772E72656D6F76654576656E744C697374656E657228226F66666C696E65222C4828746869732C5069295B50695D29297D68696465496E666F28297B6C65747B696E666F3A657D3D746869732E676574537461746528293B74';
wwv_flow_imp.g_varchar2_table(986) := '6869732E7365745374617465287B696E666F3A652E736C6963652831297D292C746869732E656D69742822696E666F2D68696464656E22297D696E666F28652C742C72297B743D3D3D766F69642030262628743D22696E666F22292C723D3D3D766F6964';
wwv_flow_imp.g_varchar2_table(987) := '2030262628723D336533293B6C657420733D747970656F6620653D3D226F626A656374223B746869732E7365745374617465287B696E666F3A5B2E2E2E746869732E676574537461746528292E696E666F2C7B747970653A742C6D6573736167653A733F';
wwv_flow_imp.g_varchar2_table(988) := '652E6D6573736167653A652C64657461696C733A733F652E64657461696C733A6E756C6C7D5D7D292C73657454696D656F75742828293D3E746869732E68696465496E666F28292C72292C746869732E656D69742822696E666F2D76697369626C652229';
wwv_flow_imp.g_varchar2_table(989) := '7D6C6F6728652C74297B6C65747B6C6F676765723A727D3D746869732E6F7074733B7377697463682874297B63617365226572726F72223A722E6572726F722865293B627265616B3B63617365227761726E696E67223A722E7761726E2865293B627265';
wwv_flow_imp.g_varchar2_table(990) := '616B3B64656661756C743A722E64656275672865293B627265616B7D7D726567697374657252657175657374436C69656E7428652C74297B4828746869732C506E295B506E5D2E73657428652C74297D67657452657175657374436C69656E74466F7246';
wwv_flow_imp.g_varchar2_table(991) := '696C652865297B69662821652E72656D6F7465297468726F77206E6577204572726F722860547269656420746F206765742052657175657374436C69656E7420666F722061206E6F6E2D72656D6F74652066696C6520247B652E69647D60293B6C657420';
wwv_flow_imp.g_varchar2_table(992) := '743D4828746869732C506E295B506E5D2E67657428652E72656D6F74652E72657175657374436C69656E744964293B696628743D3D6E756C6C297468726F77206E6577204572726F72286072657175657374436C69656E7449642022247B652E72656D6F';
wwv_flow_imp.g_varchar2_table(993) := '74652E72657175657374436C69656E7449647D22206E6F74207265676973746572656420666F722066696C652022247B652E69647D2260293B72657475726E20747D726573746F72652865297B72657475726E20746869732E6C6F672860436F72653A20';
wwv_flow_imp.g_varchar2_table(994) := '617474656D7074696E6720746F20726573746F72652075706C6F61642022247B657D2260292C746869732E676574537461746528292E63757272656E7455706C6F6164735B655D3F4828746869732C6D72295B6D725D2865293A284828746869732C6273';
wwv_flow_imp.g_varchar2_table(995) := '295B62735D2865292C50726F6D6973652E72656A656374286E6577204572726F7228224E6F6E6578697374656E742075706C6F6164222929297D5B5A665D28297B72657475726E204828746869732C6672295B66725D282E2E2E617267756D656E747329';
wwv_flow_imp.g_varchar2_table(996) := '7D616464526573756C744461746128652C74297B696628214828746869732C5468295B54685D286529297B746869732E6C6F6728604E6F742073657474696E6720726573756C7420666F7220616E2075706C6F6164207468617420686173206265656E20';
wwv_flow_imp.g_varchar2_table(997) := '72656D6F7665643A20247B657D60293B72657475726E7D6C65747B63757272656E7455706C6F6164733A727D3D746869732E676574537461746528292C733D7B2E2E2E725B655D2C726573756C743A7B2E2E2E725B655D2E726573756C742C2E2E2E747D';
wwv_flow_imp.g_varchar2_table(998) := '7D3B746869732E7365745374617465287B63757272656E7455706C6F6164733A7B2E2E2E722C5B655D3A737D7D297D75706C6F616428297B76617220653B28653D4828746869732C7574295B75745D2E75706C6F6164657229213D6E756C6C2626652E6C';
wwv_flow_imp.g_varchar2_table(999) := '656E6774687C7C746869732E6C6F6728224E6F2075706C6F61646572207479706520706C7567696E73206172652075736564222C227761726E696E6722293B6C65747B66696C65733A747D3D746869732E676574537461746528292C723D746869732E6F';
wwv_flow_imp.g_varchar2_table(1000) := '7074732E6F6E4265666F726555706C6F61642874293B72657475726E20723D3D3D21313F50726F6D6973652E72656A656374286E6577204572726F7228224E6F74207374617274696E67207468652075706C6F61642062656361757365206F6E4265666F';
wwv_flow_imp.g_varchar2_table(1001) := '726555706C6F61642072657475726E65642066616C73652229293A28722626747970656F6620723D3D226F626A65637422262628743D722C746869732E7365745374617465287B66696C65733A747D29292C50726F6D6973652E7265736F6C766528292E';
wwv_flow_imp.g_varchar2_table(1002) := '7468656E2828293D3E4828746869732C4B74295B4B745D2E76616C69646174654D696E4E756D6265724F6646696C6573287429292E636174636828733D3E7B7468726F77204828746869732C5874295B58745D285B735D292C737D292E7468656E282829';
wwv_flow_imp.g_varchar2_table(1003) := '3D3E7B696628214828746869732C4368295B43685D287429297468726F77206E657720547428746869732E6931386E28226D697373696E6752657175697265644D6574614669656C642229297D292E636174636828733D3E7B7468726F7720737D292E74';
wwv_flow_imp.g_varchar2_table(1004) := '68656E2828293D3E7B6C65747B63757272656E7455706C6F6164733A737D3D746869732E676574537461746528292C6F3D4F626A6563742E76616C7565732873292E666C61744D617028683D3E682E66696C65494473292C613D5B5D3B4F626A6563742E';
wwv_flow_imp.g_varchar2_table(1005) := '6B6579732874292E666F724561636828683D3E7B6C657420633D746869732E67657446696C652868293B21632E70726F67726573732E75706C6F61645374617274656426266F2E696E6465784F662868293D3D3D2D312626612E7075736828632E696429';
wwv_flow_imp.g_varchar2_table(1006) := '7D293B6C6574206C3D4828746869732C6672295B66725D2861293B72657475726E204828746869732C6D72295B6D725D286C297D292E636174636828733D3E7B7468726F7720746869732E656D697428226572726F72222C73292C746869732E6C6F6728';
wwv_flow_imp.g_varchar2_table(1007) := '732C226572726F7222292C737D29297D7D3B6E285F6E2C225570707922293B66756E6374696F6E2065772869297B666F72286C6574206F206F662069297B6C65747B66696C653A612C69735265737472696374696F6E3A6C7D3D6F3B6C3F746869732E65';
wwv_flow_imp.g_varchar2_table(1008) := '6D697428227265737472696374696F6E2D6661696C6564222C612C6F293A746869732E656D697428226572726F72222C6F292C746869732E6C6F67286F2C227761726E696E6722297D6C657420653D692E66696C746572286F3D3E6F2E69735573657246';
wwv_flow_imp.g_varchar2_table(1009) := '6163696E67292C743D342C723D652E736C69636528302C74292C733D652E736C6963652874293B722E666F7245616368286F3D3E7B6C65747B6D6573736167653A612C64657461696C733A6C3D22227D3D6F3B746869732E696E666F287B6D6573736167';
wwv_flow_imp.g_varchar2_table(1010) := '653A612C64657461696C733A6C7D2C226572726F72222C746869732E6F7074732E696E666F54696D656F7574297D292C732E6C656E6774683E302626746869732E696E666F287B6D6573736167653A746869732E6931386E28226164646974696F6E616C';
wwv_flow_imp.g_varchar2_table(1011) := '5265737472696374696F6E734661696C6564222C7B636F756E743A732E6C656E6774687D297D297D6E2865772C225F696E666F726D416E64456D69743222293B66756E6374696F6E2074772869297B6C65747B6D697373696E674669656C64733A652C65';
wwv_flow_imp.g_varchar2_table(1012) := '72726F723A747D3D4828746869732C4B74295B4B745D2E6765744D697373696E6752657175697265644D6574614669656C64732869293B72657475726E20652E6C656E6774683E303F28746869732E73657446696C65537461746528692E69642C7B6D69';
wwv_flow_imp.g_varchar2_table(1013) := '7373696E6752657175697265644D6574614669656C64733A657D292C746869732E6C6F6728742E6D657373616765292C746869732E656D697428227265737472696374696F6E2D6661696C6564222C692C74292C2131293A21307D6E2874772C225F6368';
wwv_flow_imp.g_varchar2_table(1014) := '65636B52657175697265644D6574614669656C64734F6E46696C653222293B66756E6374696F6E2069772869297B6C657420653D21303B666F72286C65742074206F66204F626A6563742E76616C756573286929294828746869732C466E295B466E5D28';
wwv_flow_imp.g_varchar2_table(1015) := '74297C7C28653D2131293B72657475726E20657D6E2869772C225F636865636B52657175697265644D6574614669656C64733222293B66756E6374696F6E2072772869297B6C65747B616C6C6F774E657755706C6F61643A657D3D746869732E67657453';
wwv_flow_imp.g_varchar2_table(1016) := '7461746528293B696628653D3D3D2131297B6C657420743D6E657720547428746869732E6931386E28226E6F4D6F726546696C6573416C6C6F77656422292C7B66696C653A697D293B7468726F77204828746869732C5874295B58745D285B745D292C74';
wwv_flow_imp.g_varchar2_table(1017) := '7D7D6E2872772C225F6173736572744E657755706C6F6164416C6C6F7765643222293B66756E6374696F6E2073772869297B6C657420653D6920696E7374616E63656F662046696C653F7B6E616D653A692E6E616D652C747970653A692E747970652C73';
wwv_flow_imp.g_varchar2_table(1018) := '697A653A692E73697A652C646174613A697D3A692C743D67732865292C723D786828742C65292C733D42692872292E657874656E73696F6E2C6F3D2121652E697352656D6F74652C613D446C2865292C6C3D652E6D6574617C7C7B7D3B6C2E6E616D653D';
wwv_flow_imp.g_varchar2_table(1019) := '722C6C2E747970653D743B6C657420683D4E756D6265722E697346696E69746528652E646174612E73697A65293F652E646174612E73697A653A6E756C6C3B72657475726E7B736F757263653A652E736F757263657C7C22222C69643A612C6E616D653A';
wwv_flow_imp.g_varchar2_table(1020) := '722C657874656E73696F6E3A737C7C22222C6D6574613A7B2E2E2E746869732E676574537461746528292E6D6574612C2E2E2E6C7D2C747970653A742C646174613A652E646174612C70726F67726573733A7B70657263656E746167653A302C62797465';
wwv_flow_imp.g_varchar2_table(1021) := '7355706C6F616465643A302C6279746573546F74616C3A682C75706C6F6164436F6D706C6574653A21312C75706C6F6164537461727465643A6E756C6C7D2C73697A653A682C697352656D6F74653A6F2C72656D6F74653A652E72656D6F74657C7C2222';
wwv_flow_imp.g_varchar2_table(1022) := '2C707265766965773A652E707265766965777D7D6E2873772C225F7472616E73666F726D46696C653222293B66756E6374696F6E206F7728297B746869732E6F7074732E6175746F50726F63656564262621746869732E7363686564756C65644175746F';
wwv_flow_imp.g_varchar2_table(1023) := '50726F63656564262628746869732E7363686564756C65644175746F50726F636565643D73657454696D656F75742828293D3E7B746869732E7363686564756C65644175746F50726F636565643D6E756C6C2C746869732E75706C6F616428292E636174';
wwv_flow_imp.g_varchar2_table(1024) := '636828693D3E7B692E69735265737472696374696F6E7C7C746869732E6C6F6728692E737461636B7C7C692E6D6573736167657C7C69297D297D2C3429297D6E286F772C225F737461727449664175746F50726F636565643222293B66756E6374696F6E';
wwv_flow_imp.g_varchar2_table(1025) := '206E772869297B6C65747B66696C65733A657D3D746869732E676574537461746528292C743D7B2E2E2E657D2C723D5B5D2C733D5B5D3B666F72286C65742061206F662069297472797B766172206F3B6C6574206C3D4828746869732C4168295B41685D';
wwv_flow_imp.g_varchar2_table(1026) := '2861292C683D286F3D655B6C2E69645D293D3D6E756C6C3F766F696420303A6F2E697347686F73743B69662868297B6C65747B697347686F73743A642C2E2E2E667D3D655B6C2E69645D3B6C3D7B2E2E2E662C646174613A612E646174617D2C74686973';
wwv_flow_imp.g_varchar2_table(1027) := '2E6C6F6728605265706C616365642074686520626C6F6220696E2074686520726573746F7265642067686F73742066696C653A20247B6C2E6E616D657D2C20247B6C2E69647D60297D6C657420633D746869732E6F7074732E6F6E4265666F726546696C';
wwv_flow_imp.g_varchar2_table(1028) := '654164646564286C2C74293B69662821632626746869732E636865636B496646696C65416C7265616479457869737473286C2E696429297468726F77206E657720547428746869732E6931386E28226E6F4475706C696361746573222C7B66696C654E61';
wwv_flow_imp.g_varchar2_table(1029) := '6D653A6C2E6E616D657D292C7B66696C653A617D293B696628633D3D3D213126262168297468726F77206E6577205474282243616E6E6F7420616464207468652066696C652062656361757365206F6E4265666F726546696C6541646465642072657475';
wwv_flow_imp.g_varchar2_table(1030) := '726E65642066616C73652E222C7B697355736572466163696E673A21312C66696C653A617D293B747970656F6620633D3D226F626A65637422262663213D3D6E756C6C2626286C3D63292C4828746869732C4B74295B4B745D2E76616C69646174655369';
wwv_flow_imp.g_varchar2_table(1031) := '6E676C6546696C65286C292C745B6C2E69645D3D6C2C722E70757368286C297D6361746368286C297B732E70757368286C297D7472797B4828746869732C4B74295B4B745D2E76616C69646174654167677265676174655265737472696374696F6E7328';
wwv_flow_imp.g_varchar2_table(1032) := '4F626A6563742E76616C7565732865292C72297D63617463682861297B72657475726E20732E707573682861292C7B6E65787446696C657353746174653A652C76616C696446696C6573546F4164643A5B5D2C6572726F72733A737D7D72657475726E7B';
wwv_flow_imp.g_varchar2_table(1033) := '6E65787446696C657353746174653A742C76616C696446696C6573546F4164643A722C6572726F72733A737D7D6E286E772C225F636865636B416E6455706461746546696C6553746174653222293B66756E6374696F6E20617728297B6C657420693D6E';
wwv_flow_imp.g_varchar2_table(1034) := '2828722C732C6F293D3E7B6C657420613D722E6D6573736167657C7C22556E6B6E6F776E206572726F72223B722E64657461696C73262628612B3D6020247B722E64657461696C737D60292C746869732E7365745374617465287B6572726F723A617D29';
wwv_flow_imp.g_varchar2_table(1035) := '2C73213D6E756C6C2626732E696420696E20746869732E676574537461746528292E66696C65732626746869732E73657446696C65537461746528732E69642C7B6572726F723A612C726573706F6E73653A6F7D297D2C226572726F7248616E646C6572';
wwv_flow_imp.g_varchar2_table(1036) := '22293B746869732E6F6E28226572726F72222C69292C746869732E6F6E282275706C6F61642D6572726F72222C28722C732C6F293D3E7B6966286928732C722C6F292C747970656F6620733D3D226F626A656374222626732E6D657373616765297B7468';
wwv_flow_imp.g_varchar2_table(1037) := '69732E6C6F6728732E6D6573736167652C226572726F7222293B6C657420613D6E6577204572726F7228746869732E6931386E28226661696C6564546F55706C6F6164222C7B66696C653A723F2E6E616D657D29293B612E697355736572466163696E67';
wwv_flow_imp.g_varchar2_table(1038) := '3D21302C612E64657461696C733D732E6D6573736167652C732E64657461696C73262628612E64657461696C732B3D6020247B732E64657461696C737D60292C4828746869732C5874295B58745D285B615D297D656C7365204828746869732C5874295B';
wwv_flow_imp.g_varchar2_table(1039) := '58745D285B735D297D293B6C657420653B746869732E6F6E282275706C6F61642D7374616C6C6564222C28722C73293D3E7B6C65747B6D6573736167653A6F7D3D722C613D732E6D6170286C3D3E6C2E6D6574612E6E616D65292E6A6F696E28222C2022';
wwv_flow_imp.g_varchar2_table(1040) := '293B657C7C28746869732E696E666F287B6D6573736167653A6F2C64657461696C733A617D2C227761726E696E67222C746869732E6F7074732E696E666F54696D656F7574292C653D73657454696D656F75742828293D3E7B653D6E756C6C7D2C746869';
wwv_flow_imp.g_varchar2_table(1041) := '732E6F7074732E696E666F54696D656F757429292C746869732E6C6F672860247B6F7D20247B617D602E7472696D28292C227761726E696E6722297D292C746869732E6F6E282275706C6F6164222C28293D3E7B746869732E7365745374617465287B65';
wwv_flow_imp.g_varchar2_table(1042) := '72726F723A6E756C6C7D297D293B6C657420743D6E28723D3E7B6C657420733D722E66696C74657228613D3E7B6C6574206C3D61213D6E756C6C2626746869732E67657446696C6528612E6964293B72657475726E206C7C7C746869732E6C6F6728604E';
wwv_flow_imp.g_varchar2_table(1043) := '6F742073657474696E672070726F677265737320666F7220612066696C65207468617420686173206265656E2072656D6F7665643A20247B613F2E69647D60292C6C7D292C6F3D4F626A6563742E66726F6D456E747269657328732E6D617028613D3E5B';
wwv_flow_imp.g_varchar2_table(1044) := '612E69642C7B70726F67726573733A7B75706C6F6164537461727465643A446174652E6E6F7728292C75706C6F6164436F6D706C6574653A21312C70657263656E746167653A302C627974657355706C6F616465643A302C6279746573546F74616C3A61';
wwv_flow_imp.g_varchar2_table(1045) := '2E73697A657D7D5D29293B746869732E706174636846696C65735374617465286F297D2C226F6E55706C6F61645374617274656422293B746869732E6F6E282275706C6F61642D7374617274222C723D3E7B722E666F724561636828733D3E7B74686973';
wwv_flow_imp.g_varchar2_table(1046) := '2E656D6974282275706C6F61642D73746172746564222C73297D292C742872297D292C746869732E6F6E282275706C6F61642D70726F6772657373222C746869732E63616C63756C61746550726F6772657373292C746869732E6F6E282275706C6F6164';
wwv_flow_imp.g_varchar2_table(1047) := '2D73756363657373222C28722C73293D3E7B696628723D3D6E756C6C7C7C21746869732E67657446696C6528722E696429297B746869732E6C6F6728604E6F742073657474696E672070726F677265737320666F7220612066696C652074686174206861';
wwv_flow_imp.g_varchar2_table(1048) := '73206265656E2072656D6F7665643A20247B723F2E69647D60293B72657475726E7D6C6574206F3D746869732E67657446696C6528722E6964292E70726F67726573733B746869732E73657446696C65537461746528722E69642C7B70726F6772657373';
wwv_flow_imp.g_varchar2_table(1049) := '3A7B2E2E2E6F2C706F737470726F636573733A4828746869732C6772295B67725D2E73697A653E303F7B6D6F64653A22696E64657465726D696E617465227D3A6E756C6C2C75706C6F6164436F6D706C6574653A21302C70657263656E746167653A3130';
wwv_flow_imp.g_varchar2_table(1050) := '302C627974657355706C6F616465643A6F2E6279746573546F74616C7D2C726573706F6E73653A732C75706C6F616455524C3A732E75706C6F616455524C2C69735061757365643A21317D292C722E73697A653D3D6E756C6C2626746869732E73657446';
wwv_flow_imp.g_varchar2_table(1051) := '696C65537461746528722E69642C7B73697A653A732E627974657355706C6F616465647C7C6F2E6279746573546F74616C7D292C746869732E63616C63756C617465546F74616C50726F677265737328297D292C746869732E6F6E282270726570726F63';
wwv_flow_imp.g_varchar2_table(1052) := '6573732D70726F6772657373222C28722C73293D3E7B696628723D3D6E756C6C7C7C21746869732E67657446696C6528722E696429297B746869732E6C6F6728604E6F742073657474696E672070726F677265737320666F7220612066696C6520746861';
wwv_flow_imp.g_varchar2_table(1053) := '7420686173206265656E2072656D6F7665643A20247B723F2E69647D60293B72657475726E7D746869732E73657446696C65537461746528722E69642C7B70726F67726573733A7B2E2E2E746869732E67657446696C6528722E6964292E70726F677265';
wwv_flow_imp.g_varchar2_table(1054) := '73732C70726570726F636573733A737D7D297D292C746869732E6F6E282270726570726F636573732D636F6D706C657465222C723D3E7B696628723D3D6E756C6C7C7C21746869732E67657446696C6528722E696429297B746869732E6C6F6728604E6F';
wwv_flow_imp.g_varchar2_table(1055) := '742073657474696E672070726F677265737320666F7220612066696C65207468617420686173206265656E2072656D6F7665643A20247B723F2E69647D60293B72657475726E7D6C657420733D7B2E2E2E746869732E676574537461746528292E66696C';
wwv_flow_imp.g_varchar2_table(1056) := '65737D3B735B722E69645D3D7B2E2E2E735B722E69645D2C70726F67726573733A7B2E2E2E735B722E69645D2E70726F67726573737D7D2C64656C65746520735B722E69645D2E70726F67726573732E70726570726F636573732C746869732E73657453';
wwv_flow_imp.g_varchar2_table(1057) := '74617465287B66696C65733A737D297D292C746869732E6F6E2822706F737470726F636573732D70726F6772657373222C28722C73293D3E7B696628723D3D6E756C6C7C7C21746869732E67657446696C6528722E696429297B746869732E6C6F672860';
wwv_flow_imp.g_varchar2_table(1058) := '4E6F742073657474696E672070726F677265737320666F7220612066696C65207468617420686173206265656E2072656D6F7665643A20247B723F2E69647D60293B72657475726E7D746869732E73657446696C65537461746528722E69642C7B70726F';
wwv_flow_imp.g_varchar2_table(1059) := '67726573733A7B2E2E2E746869732E676574537461746528292E66696C65735B722E69645D2E70726F67726573732C706F737470726F636573733A737D7D297D292C746869732E6F6E2822706F737470726F636573732D636F6D706C657465222C723D3E';
wwv_flow_imp.g_varchar2_table(1060) := '7B696628723D3D6E756C6C7C7C21746869732E67657446696C6528722E696429297B746869732E6C6F6728604E6F742073657474696E672070726F677265737320666F7220612066696C65207468617420686173206265656E2072656D6F7665643A2024';
wwv_flow_imp.g_varchar2_table(1061) := '7B723F2E69647D60293B72657475726E7D6C657420733D7B2E2E2E746869732E676574537461746528292E66696C65737D3B735B722E69645D3D7B2E2E2E735B722E69645D2C70726F67726573733A7B2E2E2E735B722E69645D2E70726F67726573737D';
wwv_flow_imp.g_varchar2_table(1062) := '7D2C64656C65746520735B722E69645D2E70726F67726573732E706F737470726F636573732C746869732E7365745374617465287B66696C65733A737D297D292C746869732E6F6E2822726573746F726564222C28293D3E7B746869732E63616C63756C';
wwv_flow_imp.g_varchar2_table(1063) := '617465546F74616C50726F677265737328297D292C746869732E6F6E282264617368626F6172643A66696C652D656469742D636F6D706C657465222C723D3E7B7226264828746869732C466E295B466E5D2872297D292C747970656F662077696E646F77';
wwv_flow_imp.g_varchar2_table(1064) := '3C227522262677696E646F772E6164644576656E744C697374656E657226262877696E646F772E6164644576656E744C697374656E657228226F6E6C696E65222C4828746869732C5069295B50695D292C77696E646F772E6164644576656E744C697374';
wwv_flow_imp.g_varchar2_table(1065) := '656E657228226F66666C696E65222C4828746869732C5069295B50695D292C73657454696D656F7574284828746869732C5069295B50695D2C33653329297D6E2861772C225F6164644C697374656E6572733222293B66756E6374696F6E206C7728692C';
wwv_flow_imp.g_varchar2_table(1066) := '65297B653D3D3D766F69642030262628653D7B7D293B6C65747B666F726365416C6C6F774E657755706C6F61643A743D21317D3D652C7B616C6C6F774E657755706C6F61643A722C63757272656E7455706C6F6164733A737D3D746869732E6765745374';
wwv_flow_imp.g_varchar2_table(1067) := '61746528293B696628217226262174297468726F77206E6577204572726F72282243616E6E6F74206372656174652061206E65772075706C6F61643A20616C72656164792075706C6F6164696E672E22293B6C6574206F3D507428293B72657475726E20';
wwv_flow_imp.g_varchar2_table(1068) := '746869732E656D6974282275706C6F6164222C7B69643A6F2C66696C654944733A697D292C746869732E7365745374617465287B616C6C6F774E657755706C6F61643A746869732E6F7074732E616C6C6F774D756C7469706C6555706C6F616442617463';
wwv_flow_imp.g_varchar2_table(1069) := '686573213D3D21312626746869732E6F7074732E616C6C6F774D756C7469706C6555706C6F616473213D3D21312C63757272656E7455706C6F6164733A7B2E2E2E732C5B6F5D3A7B66696C654944733A692C737465703A302C726573756C743A7B7D7D7D';
wwv_flow_imp.g_varchar2_table(1070) := '7D292C6F7D6E286C772C225F63726561746555706C6F61643222293B66756E6374696F6E2075772869297B6C65747B63757272656E7455706C6F6164733A657D3D746869732E676574537461746528293B72657475726E20655B695D7D6E2875772C225F';
wwv_flow_imp.g_varchar2_table(1071) := '67657455706C6F61643222293B66756E6374696F6E2068772869297B6C657420653D7B2E2E2E746869732E676574537461746528292E63757272656E7455706C6F6164737D3B64656C65746520655B695D2C746869732E7365745374617465287B637572';
wwv_flow_imp.g_varchar2_table(1072) := '72656E7455706C6F6164733A657D297D6E2868772C225F72656D6F766555706C6F61643222293B6173796E632066756E6374696F6E2064772869297B6C657420653D6E2828293D3E7B6C65747B63757272656E7455706C6F6164733A6F7D3D746869732E';
wwv_flow_imp.g_varchar2_table(1073) := '676574537461746528293B72657475726E206F5B695D7D2C2267657443757272656E7455706C6F616422292C743D6528292C723D5B2E2E2E4828746869732C7973295B79735D2C2E2E2E4828746869732C7673295B76735D2C2E2E2E4828746869732C67';
wwv_flow_imp.g_varchar2_table(1074) := '72295B67725D5D3B7472797B666F72286C6574206F3D742E737465707C7C303B6F3C722E6C656E6774682626743B6F2B2B297B6C657420613D725B6F5D3B746869732E7365745374617465287B63757272656E7455706C6F6164733A7B2E2E2E74686973';
wwv_flow_imp.g_varchar2_table(1075) := '2E676574537461746528292E63757272656E7455706C6F6164732C5B695D3A7B2E2E2E742C737465703A6F7D7D7D293B6C65747B66696C654944733A6C7D3D743B61776169742061286C2C69292C743D6528297D7D6361746368286F297B7468726F7720';
wwv_flow_imp.g_varchar2_table(1076) := '4828746869732C6273295B62735D2869292C6F7D69662874297B742E66696C654944732E666F724561636828683D3E7B6C657420633D746869732E67657446696C652868293B632626632E70726F67726573732E706F737470726F636573732626746869';
wwv_flow_imp.g_varchar2_table(1077) := '732E656D69742822706F737470726F636573732D636F6D706C657465222C63297D293B6C6574206F3D742E66696C654944732E6D617028683D3E746869732E67657446696C65286829292C613D6F2E66696C74657228683D3E21682E6572726F72292C6C';
wwv_flow_imp.g_varchar2_table(1078) := '3D6F2E66696C74657228683D3E682E6572726F72293B617761697420746869732E616464526573756C744461746128692C7B7375636365737366756C3A612C6661696C65643A6C2C75706C6F616449443A697D292C743D6528297D6C657420733B726574';
wwv_flow_imp.g_varchar2_table(1079) := '75726E2074262628733D742E726573756C742C746869732E656D69742822636F6D706C657465222C73292C4828746869732C6273295B62735D286929292C733D3D6E756C6C2626746869732E6C6F6728604E6F742073657474696E6720726573756C7420';
wwv_flow_imp.g_varchar2_table(1080) := '666F7220616E2075706C6F6164207468617420686173206265656E2072656D6F7665643A20247B697D60292C737D6E2864772C225F72756E55706C6F61643222293B5F6E2E56455253494F4E3D5A312E76657273696F6E3B7661722052683D5F6E3B7661';
wwv_flow_imp.g_varchar2_table(1081) := '7220436E2C65652C616D2C63772C786E2C696D2C70772C4C6C3D7B7D2C6C6D3D5B5D2C66773D2F616369747C6578283F3A737C677C6E7C707C24297C7270687C677269647C6F77737C6D6E637C6E74777C696E655B63685D7C7A6F6F7C5E6F72647C6974';
wwv_flow_imp.g_varchar2_table(1082) := '6572612F693B66756E6374696F6E20797228692C65297B666F7228766172207420696E206529695B745D3D655B745D3B72657475726E20697D6E2879722C227322293B66756E6374696F6E20756D2869297B76617220653D692E706172656E744E6F6465';
wwv_flow_imp.g_varchar2_table(1083) := '3B652626652E72656D6F76654368696C642869297D6E28756D2C226122293B66756E6374696F6E207528692C652C74297B76617220722C732C6F2C613D7B7D3B666F72286F20696E2065296F3D3D226B6579223F723D655B6F5D3A6F3D3D22726566223F';
wwv_flow_imp.g_varchar2_table(1084) := '733D655B6F5D3A615B6F5D3D655B6F5D3B696628617267756D656E74732E6C656E6774683E32262628612E6368696C6472656E3D617267756D656E74732E6C656E6774683E333F436E2E63616C6C28617267756D656E74732C32293A74292C747970656F';
wwv_flow_imp.g_varchar2_table(1085) := '6620693D3D2266756E6374696F6E222626692E64656661756C7450726F7073213D6E756C6C29666F72286F20696E20692E64656661756C7450726F707329615B6F5D3D3D3D766F69642030262628615B6F5D3D692E64656661756C7450726F70735B6F5D';
wwv_flow_imp.g_varchar2_table(1086) := '293B72657475726E20456E28692C612C722C732C6E756C6C297D6E28752C226822293B66756E6374696F6E20456E28692C652C742C722C73297B766172206F3D7B747970653A692C70726F70733A652C6B65793A742C7265663A722C5F5F6B3A6E756C6C';
wwv_flow_imp.g_varchar2_table(1087) := '2C5F5F3A6E756C6C2C5F5F623A302C5F5F653A6E756C6C2C5F5F643A766F696420302C5F5F633A6E756C6C2C5F5F683A6E756C6C2C636F6E7374727563746F723A766F696420302C5F5F763A733F3F2B2B616D7D3B72657475726E20733D3D6E756C6C26';
wwv_flow_imp.g_varchar2_table(1088) := '2665652E766E6F6465213D6E756C6C262665652E766E6F6465286F292C6F7D6E28456E2C227622293B66756E6374696F6E20686D28297B72657475726E7B63757272656E743A6E756C6C7D7D6E28686D2C227922293B66756E6374696F6E204874286929';
wwv_flow_imp.g_varchar2_table(1089) := '7B72657475726E20692E6368696C6472656E7D6E2848742C227022293B66756E6374696F6E20776528692C65297B746869732E70726F70733D692C746869732E636F6E746578743D657D6E2877652C226422293B66756E6374696F6E20456F28692C6529';
wwv_flow_imp.g_varchar2_table(1090) := '7B696628653D3D6E756C6C2972657475726E20692E5F5F3F456F28692E5F5F2C692E5F5F2E5F5F6B2E696E6465784F662869292B31293A6E756C6C3B666F722876617220743B653C692E5F5F6B2E6C656E6774683B652B2B2969662828743D692E5F5F6B';
wwv_flow_imp.g_varchar2_table(1091) := '5B655D29213D6E756C6C2626742E5F5F65213D6E756C6C2972657475726E20742E5F5F653B72657475726E20747970656F6620692E747970653D3D2266756E6374696F6E223F456F2869293A6E756C6C7D6E28456F2C225F22293B66756E6374696F6E20';
wwv_flow_imp.g_varchar2_table(1092) := '646D2869297B76617220652C743B69662828693D692E5F5F29213D6E756C6C2626692E5F5F63213D6E756C6C297B666F7228692E5F5F653D692E5F5F632E626173653D6E756C6C2C653D303B653C692E5F5F6B2E6C656E6774683B652B2B296966282874';
wwv_flow_imp.g_varchar2_table(1093) := '3D692E5F5F6B5B655D29213D6E756C6C2626742E5F5F65213D6E756C6C297B692E5F5F653D692E5F5F632E626173653D742E5F5F653B627265616B7D72657475726E20646D2869297D7D6E28646D2C226B22293B66756E6374696F6E20726D2869297B28';
wwv_flow_imp.g_varchar2_table(1094) := '21692E5F5F64262628692E5F5F643D2130292626786E2E70757368286929262621426C2E5F5F722B2B7C7C696D213D3D65652E6465626F756E636552656E646572696E672926262828696D3D65652E6465626F756E636552656E646572696E67297C7C73';
wwv_flow_imp.g_varchar2_table(1095) := '657454696D656F75742928426C297D6E28726D2C226222293B66756E6374696F6E20426C28297B666F722876617220693B426C2E5F5F723D786E2E6C656E6774683B29693D786E2E736F72742866756E6374696F6E28652C74297B72657475726E20652E';
wwv_flow_imp.g_varchar2_table(1096) := '5F5F762E5F5F622D742E5F5F762E5F5F627D292C786E3D5B5D2C692E736F6D652866756E6374696F6E2865297B76617220742C722C732C6F2C612C6C3B652E5F5F64262628613D286F3D28743D65292E5F5F76292E5F5F652C286C3D742E5F5F50292626';
wwv_flow_imp.g_varchar2_table(1097) := '28723D5B5D2C28733D7972287B7D2C6F29292E5F5F763D6F2E5F5F762B312C5568286C2C6F2C732C742E5F5F6E2C6C2E6F776E6572535647456C656D656E74213D3D766F696420302C6F2E5F5F68213D6E756C6C3F5B615D3A6E756C6C2C722C613F3F45';
wwv_flow_imp.g_varchar2_table(1098) := '6F286F292C6F2E5F5F68292C6D6D28722C6F292C6F2E5F5F65213D612626646D286F2929297D297D6E28426C2C226722293B66756E6374696F6E20636D28692C652C742C722C732C6F2C612C6C2C682C63297B76617220642C662C792C622C532C452C46';
wwv_flow_imp.g_varchar2_table(1099) := '2C783D722626722E5F5F6B7C7C6C6D2C553D782E6C656E6774683B666F7228742E5F5F6B3D5B5D2C643D303B643C652E6C656E6774683B642B2B2969662828623D742E5F5F6B5B645D3D28623D655B645D293D3D6E756C6C7C7C747970656F6620623D3D';
wwv_flow_imp.g_varchar2_table(1100) := '22626F6F6C65616E223F6E756C6C3A747970656F6620623D3D22737472696E67227C7C747970656F6620623D3D226E756D626572227C7C747970656F6620623D3D22626967696E74223F456E286E756C6C2C622C6E756C6C2C6E756C6C2C62293A417272';
wwv_flow_imp.g_varchar2_table(1101) := '61792E697341727261792862293F456E2848742C7B6368696C6472656E3A627D2C6E756C6C2C6E756C6C2C6E756C6C293A622E5F5F623E303F456E28622E747970652C622E70726F70732C622E6B65792C6E756C6C2C622E5F5F76293A6229213D6E756C';
wwv_flow_imp.g_varchar2_table(1102) := '6C297B696628622E5F5F3D742C622E5F5F623D742E5F5F622B312C28793D785B645D293D3D3D6E756C6C7C7C792626622E6B65793D3D792E6B65792626622E747970653D3D3D792E7479706529785B645D3D766F696420303B656C736520666F7228663D';
wwv_flow_imp.g_varchar2_table(1103) := '303B663C553B662B2B297B69662828793D785B665D292626622E6B65793D3D792E6B65792626622E747970653D3D3D792E74797065297B785B665D3D766F696420303B627265616B7D793D6E756C6C7D556828692C622C793D797C7C4C6C2C732C6F2C61';
wwv_flow_imp.g_varchar2_table(1104) := '2C6C2C682C63292C533D622E5F5F652C28663D622E726566292626792E726566213D66262628467C7C28463D5B5D292C792E7265662626462E7075736828792E7265662C6E756C6C2C62292C462E7075736828662C622E5F5F637C7C532C6229292C5321';
wwv_flow_imp.g_varchar2_table(1105) := '3D6E756C6C3F28453D3D6E756C6C262628453D53292C747970656F6620622E747970653D3D2266756E6374696F6E222626622E5F5F6B3D3D3D792E5F5F6B3F622E5F5F643D683D706D28622C682C69293A683D666D28692C622C792C782C532C68292C74';
wwv_flow_imp.g_varchar2_table(1106) := '7970656F6620742E747970653D3D2266756E6374696F6E22262628742E5F5F643D6829293A682626792E5F5F653D3D682626682E706172656E744E6F6465213D69262628683D456F287929297D666F7228742E5F5F653D452C643D553B642D2D3B29785B';
wwv_flow_imp.g_varchar2_table(1107) := '645D213D6E756C6C262628747970656F6620742E747970653D3D2266756E6374696F6E222626785B645D2E5F5F65213D6E756C6C2626785B645D2E5F5F653D3D742E5F5F64262628742E5F5F643D456F28722C642B3129292C796D28785B645D2C785B64';
wwv_flow_imp.g_varchar2_table(1108) := '5D29293B6966284629666F7228643D303B643C462E6C656E6774683B642B2B29676D28465B645D2C465B2B2B645D2C465B2B2B645D297D6E28636D2C227722293B66756E6374696F6E20706D28692C652C74297B666F722876617220722C733D692E5F5F';
wwv_flow_imp.g_varchar2_table(1109) := '6B2C6F3D303B7326266F3C732E6C656E6774683B6F2B2B2928723D735B6F5D29262628722E5F5F3D692C653D747970656F6620722E747970653D3D2266756E6374696F6E223F706D28722C652C74293A666D28742C722C722C732C722E5F5F652C652929';
wwv_flow_imp.g_varchar2_table(1110) := '3B72657475726E20657D6E28706D2C226D22293B66756E6374696F6E20706928692C65297B72657475726E20653D657C7C5B5D2C693D3D6E756C6C7C7C747970656F6620693D3D22626F6F6C65616E227C7C2841727261792E697341727261792869293F';
wwv_flow_imp.g_varchar2_table(1111) := '692E736F6D652866756E6374696F6E2874297B706928742C65297D293A652E70757368286929292C657D6E2870692C227822293B66756E6374696F6E20666D28692C652C742C722C732C6F297B76617220612C6C2C683B696628652E5F5F64213D3D766F';
wwv_flow_imp.g_varchar2_table(1112) := '6964203029613D652E5F5F642C652E5F5F643D766F696420303B656C736520696628743D3D6E756C6C7C7C73213D6F7C7C732E706172656E744E6F64653D3D6E756C6C29653A6966286F3D3D6E756C6C7C7C6F2E706172656E744E6F6465213D3D692969';
wwv_flow_imp.g_varchar2_table(1113) := '2E617070656E644368696C642873292C613D6E756C6C3B656C73657B666F72286C3D6F2C683D303B286C3D6C2E6E6578745369626C696E67292626683C722E6C656E6774683B682B3D32296966286C3D3D7329627265616B20653B692E696E7365727442';
wwv_flow_imp.g_varchar2_table(1114) := '65666F726528732C6F292C613D6F7D72657475726E2061213D3D766F696420303F613A732E6E6578745369626C696E677D6E28666D2C224122293B66756E6374696F6E206D7728692C652C742C722C73297B766172206F3B666F72286F20696E2074296F';
wwv_flow_imp.g_varchar2_table(1115) := '3D3D3D226368696C6472656E227C7C6F3D3D3D226B6579227C7C6F20696E20657C7C7A6C28692C6F2C6E756C6C2C745B6F5D2C72293B666F72286F20696E206529732626747970656F6620655B6F5D213D2266756E6374696F6E227C7C6F3D3D3D226368';
wwv_flow_imp.g_varchar2_table(1116) := '696C6472656E227C7C6F3D3D3D226B6579227C7C6F3D3D3D2276616C7565227C7C6F3D3D3D22636865636B6564227C7C745B6F5D3D3D3D655B6F5D7C7C7A6C28692C6F2C655B6F5D2C745B6F5D2C72297D6E286D772C224322293B66756E6374696F6E20';
wwv_flow_imp.g_varchar2_table(1117) := '736D28692C652C74297B655B305D3D3D3D222D223F692E73657450726F706572747928652C74293A695B655D3D743D3D6E756C6C3F22223A747970656F662074213D226E756D626572227C7C66772E746573742865293F743A742B227078227D6E28736D';
wwv_flow_imp.g_varchar2_table(1118) := '2C222422293B66756E6374696F6E207A6C28692C652C742C722C73297B766172206F3B653A696628653D3D3D227374796C652229696628747970656F6620743D3D22737472696E672229692E7374796C652E637373546578743D743B656C73657B696628';
wwv_flow_imp.g_varchar2_table(1119) := '747970656F6620723D3D22737472696E6722262628692E7374796C652E637373546578743D723D2222292C7229666F72286520696E2072297426266520696E20747C7C736D28692E7374796C652C652C2222293B6966287429666F72286520696E207429';
wwv_flow_imp.g_varchar2_table(1120) := '722626745B655D3D3D3D725B655D7C7C736D28692E7374796C652C652C745B655D297D656C736520696628655B305D3D3D3D226F222626655B315D3D3D3D226E22296F3D65213D3D28653D652E7265706C616365282F43617074757265242F2C22222929';
wwv_flow_imp.g_varchar2_table(1121) := '2C653D652E746F4C6F776572436173652829696E20693F652E746F4C6F7765724361736528292E736C6963652832293A652E736C6963652832292C692E6C7C7C28692E6C3D7B7D292C692E6C5B652B6F5D3D742C743F727C7C692E6164644576656E744C';
wwv_flow_imp.g_varchar2_table(1122) := '697374656E657228652C6F3F6E6D3A6F6D2C6F293A692E72656D6F76654576656E744C697374656E657228652C6F3F6E6D3A6F6D2C6F293B656C73652069662865213D3D2264616E6765726F75736C79536574496E6E657248544D4C22297B6966287329';
wwv_flow_imp.g_varchar2_table(1123) := '653D652E7265706C616365282F786C696E6B28487C3A68292F2C226822292E7265706C616365282F734E616D65242F2C227322293B656C73652069662865213D3D226872656622262665213D3D226C69737422262665213D3D22666F726D22262665213D';
wwv_flow_imp.g_varchar2_table(1124) := '3D22746162496E64657822262665213D3D22646F776E6C6F61642226266520696E2069297472797B695B655D3D743F3F22223B627265616B20657D63617463687B7D747970656F6620743D3D2266756E6374696F6E227C7C2874213D6E756C6C26262874';
wwv_flow_imp.g_varchar2_table(1125) := '213D3D21317C7C655B305D3D3D3D2261222626655B315D3D3D3D227222293F692E73657441747472696275746528652C74293A692E72656D6F7665417474726962757465286529297D7D6E287A6C2C224822293B66756E6374696F6E206F6D2869297B74';
wwv_flow_imp.g_varchar2_table(1126) := '6869732E6C5B692E747970652B21315D2865652E6576656E743F65652E6576656E742869293A69297D6E286F6D2C224922293B66756E6374696F6E206E6D2869297B746869732E6C5B692E747970652B21305D2865652E6576656E743F65652E6576656E';
wwv_flow_imp.g_varchar2_table(1127) := '742869293A69297D6E286E6D2C225422293B66756E6374696F6E20556828692C652C742C722C732C6F2C612C6C2C68297B76617220632C642C662C792C622C532C452C462C782C552C6A2C472C4A2C423D652E747970653B696628652E636F6E73747275';
wwv_flow_imp.g_varchar2_table(1128) := '63746F72213D3D766F696420302972657475726E206E756C6C3B742E5F5F68213D6E756C6C262628683D742E5F5F682C6C3D652E5F5F653D742E5F5F652C652E5F5F683D6E756C6C2C6F3D5B6C5D292C28633D65652E5F5F62292626632865293B747279';
wwv_flow_imp.g_varchar2_table(1129) := '7B653A696628747970656F6620423D3D2266756E6374696F6E22297B696628463D652E70726F70732C783D28633D422E636F6E7465787454797065292626725B632E5F5F635D2C553D633F783F782E70726F70732E76616C75653A632E5F5F3A722C742E';
wwv_flow_imp.g_varchar2_table(1130) := '5F5F633F453D28643D652E5F5F633D742E5F5F63292E5F5F3D642E5F5F453A282270726F746F7479706522696E20422626422E70726F746F747970652E72656E6465723F652E5F5F633D643D6E6577204228462C55293A28652E5F5F633D643D6E657720';
wwv_flow_imp.g_varchar2_table(1131) := '776528462C55292C642E636F6E7374727563746F723D422C642E72656E6465723D7977292C782626782E7375622864292C642E70726F70733D462C642E73746174657C7C28642E73746174653D7B7D292C642E636F6E746578743D552C642E5F5F6E3D72';
wwv_flow_imp.g_varchar2_table(1132) := '2C663D642E5F5F643D21302C642E5F5F683D5B5D292C642E5F5F733D3D6E756C6C262628642E5F5F733D642E7374617465292C422E67657444657269766564537461746546726F6D50726F7073213D6E756C6C262628642E5F5F733D3D642E7374617465';
wwv_flow_imp.g_varchar2_table(1133) := '262628642E5F5F733D7972287B7D2C642E5F5F7329292C797228642E5F5F732C422E67657444657269766564537461746546726F6D50726F707328462C642E5F5F732929292C793D642E70726F70732C623D642E73746174652C6629422E676574446572';
wwv_flow_imp.g_varchar2_table(1134) := '69766564537461746546726F6D50726F70733D3D6E756C6C2626642E636F6D706F6E656E7457696C6C4D6F756E74213D6E756C6C2626642E636F6D706F6E656E7457696C6C4D6F756E7428292C642E636F6D706F6E656E744469644D6F756E74213D6E75';
wwv_flow_imp.g_varchar2_table(1135) := '6C6C2626642E5F5F682E7075736828642E636F6D706F6E656E744469644D6F756E74293B656C73657B696628422E67657444657269766564537461746546726F6D50726F70733D3D6E756C6C262646213D3D792626642E636F6D706F6E656E7457696C6C';
wwv_flow_imp.g_varchar2_table(1136) := '5265636569766550726F7073213D6E756C6C2626642E636F6D706F6E656E7457696C6C5265636569766550726F707328462C55292C21642E5F5F652626642E73686F756C64436F6D706F6E656E74557064617465213D6E756C6C2626642E73686F756C64';
wwv_flow_imp.g_varchar2_table(1137) := '436F6D706F6E656E7455706461746528462C642E5F5F732C55293D3D3D21317C7C652E5F5F763D3D3D742E5F5F76297B642E70726F70733D462C642E73746174653D642E5F5F732C652E5F5F76213D3D742E5F5F76262628642E5F5F643D2131292C642E';
wwv_flow_imp.g_varchar2_table(1138) := '5F5F763D652C652E5F5F653D742E5F5F652C652E5F5F6B3D742E5F5F6B2C652E5F5F6B2E666F72456163682866756E6374696F6E287A297B7A2626287A2E5F5F3D65297D292C642E5F5F682E6C656E6774682626612E707573682864293B627265616B20';
wwv_flow_imp.g_varchar2_table(1139) := '657D642E636F6D706F6E656E7457696C6C557064617465213D6E756C6C2626642E636F6D706F6E656E7457696C6C55706461746528462C642E5F5F732C55292C642E636F6D706F6E656E74446964557064617465213D6E756C6C2626642E5F5F682E7075';
wwv_flow_imp.g_varchar2_table(1140) := '73682866756E6374696F6E28297B642E636F6D706F6E656E7444696455706461746528792C622C53297D297D696628642E636F6E746578743D552C642E70726F70733D462C642E5F5F763D652C642E5F5F503D692C6A3D65652E5F5F722C473D302C2270';
wwv_flow_imp.g_varchar2_table(1141) := '726F746F7479706522696E20422626422E70726F746F747970652E72656E64657229642E73746174653D642E5F5F732C642E5F5F643D21312C6A26266A2865292C633D642E72656E64657228642E70726F70732C642E73746174652C642E636F6E746578';
wwv_flow_imp.g_varchar2_table(1142) := '74293B656C736520646F20642E5F5F643D21312C6A26266A2865292C633D642E72656E64657228642E70726F70732C642E73746174652C642E636F6E74657874292C642E73746174653D642E5F5F733B7768696C6528642E5F5F6426262B2B473C323529';
wwv_flow_imp.g_varchar2_table(1143) := '3B642E73746174653D642E5F5F732C642E6765744368696C64436F6E74657874213D6E756C6C262628723D7972287972287B7D2C72292C642E6765744368696C64436F6E74657874282929292C667C7C642E676574536E617073686F744265666F726555';
wwv_flow_imp.g_varchar2_table(1144) := '70646174653D3D6E756C6C7C7C28533D642E676574536E617073686F744265666F726555706461746528792C6229292C4A3D63213D6E756C6C2626632E747970653D3D3D48742626632E6B65793D3D6E756C6C3F632E70726F70732E6368696C6472656E';
wwv_flow_imp.g_varchar2_table(1145) := '3A632C636D28692C41727261792E69734172726179284A293F4A3A5B4A5D2C652C742C722C732C6F2C612C6C2C68292C642E626173653D652E5F5F652C652E5F5F683D6E756C6C2C642E5F5F682E6C656E6774682626612E707573682864292C45262628';
wwv_flow_imp.g_varchar2_table(1146) := '642E5F5F453D642E5F5F3D6E756C6C292C642E5F5F653D21317D656C7365206F3D3D6E756C6C2626652E5F5F763D3D3D742E5F5F763F28652E5F5F6B3D742E5F5F6B2C652E5F5F653D742E5F5F65293A652E5F5F653D677728742E5F5F652C652C742C72';
wwv_flow_imp.g_varchar2_table(1147) := '2C732C6F2C612C68293B28633D65652E646966666564292626632865297D6361746368287A297B652E5F5F763D6E756C6C2C28687C7C6F213D6E756C6C29262628652E5F5F653D6C2C652E5F5F683D2121682C6F5B6F2E696E6465784F66286C295D3D6E';
wwv_flow_imp.g_varchar2_table(1148) := '756C6C292C65652E5F5F65287A2C652C74297D7D6E2855682C226A22293B66756E6374696F6E206D6D28692C65297B65652E5F5F63262665652E5F5F6328652C69292C692E736F6D652866756E6374696F6E2874297B7472797B693D742E5F5F682C742E';
wwv_flow_imp.g_varchar2_table(1149) := '5F5F683D5B5D2C692E736F6D652866756E6374696F6E2872297B722E63616C6C2874297D297D63617463682872297B65652E5F5F6528722C742E5F5F76297D7D297D6E286D6D2C227A22293B66756E6374696F6E20677728692C652C742C722C732C6F2C';
wwv_flow_imp.g_varchar2_table(1150) := '612C6C297B76617220682C632C642C663D742E70726F70732C793D652E70726F70732C623D652E747970652C533D303B696628623D3D3D2273766722262628733D2130292C6F213D6E756C6C297B666F72283B533C6F2E6C656E6774683B532B2B296966';
wwv_flow_imp.g_varchar2_table(1151) := '2828683D6F5B535D2926262273657441747472696275746522696E20683D3D212162262628623F682E6C6F63616C4E616D653D3D3D623A682E6E6F6465547970653D3D3D3329297B693D682C6F5B535D3D6E756C6C3B627265616B7D7D696628693D3D6E';
wwv_flow_imp.g_varchar2_table(1152) := '756C6C297B696628623D3D3D6E756C6C2972657475726E20646F63756D656E742E637265617465546578744E6F64652879293B693D733F646F63756D656E742E637265617465456C656D656E744E532822687474703A2F2F7777772E77332E6F72672F32';
wwv_flow_imp.g_varchar2_table(1153) := '3030302F737667222C62293A646F63756D656E742E637265617465456C656D656E7428622C792E6973262679292C6F3D6E756C6C2C6C3D21317D696628623D3D3D6E756C6C29663D3D3D797C7C6C2626692E646174613D3D3D797C7C28692E646174613D';
wwv_flow_imp.g_varchar2_table(1154) := '79293B656C73657B6966286F3D6F2626436E2E63616C6C28692E6368696C644E6F646573292C633D28663D742E70726F70737C7C4C6C292E64616E6765726F75736C79536574496E6E657248544D4C2C643D792E64616E6765726F75736C79536574496E';
wwv_flow_imp.g_varchar2_table(1155) := '6E657248544D4C2C216C297B6966286F213D6E756C6C29666F7228663D7B7D2C533D303B533C692E617474726962757465732E6C656E6774683B532B2B29665B692E617474726962757465735B535D2E6E616D655D3D692E617474726962757465735B53';
wwv_flow_imp.g_varchar2_table(1156) := '5D2E76616C75653B28647C7C632926262864262628632626642E5F5F68746D6C3D3D632E5F5F68746D6C7C7C642E5F5F68746D6C3D3D3D692E696E6E657248544D4C297C7C28692E696E6E657248544D4C3D642626642E5F5F68746D6C7C7C222229297D';
wwv_flow_imp.g_varchar2_table(1157) := '6966286D7728692C792C662C732C6C292C6429652E5F5F6B3D5B5D3B656C736520696628533D652E70726F70732E6368696C6472656E2C636D28692C41727261792E697341727261792853293F533A5B535D2C652C742C722C73262662213D3D22666F72';
wwv_flow_imp.g_varchar2_table(1158) := '6569676E4F626A656374222C6F2C612C6F3F6F5B305D3A742E5F5F6B2626456F28742C30292C6C292C6F213D6E756C6C29666F7228533D6F2E6C656E6774683B532D2D3B296F5B535D213D6E756C6C2626756D286F5B535D293B6C7C7C282276616C7565';
wwv_flow_imp.g_varchar2_table(1159) := '22696E2079262628533D792E76616C756529213D3D766F6964203026262853213D3D692E76616C75657C7C623D3D3D2270726F677265737322262621537C7C623D3D3D226F7074696F6E22262653213D3D662E76616C75652926267A6C28692C2276616C';
wwv_flow_imp.g_varchar2_table(1160) := '7565222C532C662E76616C75652C2131292C22636865636B656422696E2079262628533D792E636865636B656429213D3D766F69642030262653213D3D692E636865636B656426267A6C28692C22636865636B6564222C532C662E636865636B65642C21';
wwv_flow_imp.g_varchar2_table(1161) := '3129297D72657475726E20697D6E2867772C224C22293B66756E6374696F6E20676D28692C652C74297B7472797B747970656F6620693D3D2266756E6374696F6E223F692865293A692E63757272656E743D657D63617463682872297B65652E5F5F6528';
wwv_flow_imp.g_varchar2_table(1162) := '722C74297D7D6E28676D2C224D22293B66756E6374696F6E20796D28692C652C74297B76617220722C733B69662865652E756E6D6F756E74262665652E756E6D6F756E742869292C28723D692E72656629262628722E63757272656E742626722E637572';
wwv_flow_imp.g_varchar2_table(1163) := '72656E74213D3D692E5F5F657C7C676D28722C6E756C6C2C6529292C28723D692E5F5F6329213D6E756C6C297B696628722E636F6D706F6E656E7457696C6C556E6D6F756E74297472797B722E636F6D706F6E656E7457696C6C556E6D6F756E7428297D';
wwv_flow_imp.g_varchar2_table(1164) := '6361746368286F297B65652E5F5F65286F2C65297D722E626173653D722E5F5F503D6E756C6C7D696628723D692E5F5F6B29666F7228733D303B733C722E6C656E6774683B732B2B29725B735D2626796D28725B735D2C652C747970656F6620692E7479';
wwv_flow_imp.g_varchar2_table(1165) := '7065213D2266756E6374696F6E22293B747C7C692E5F5F653D3D6E756C6C7C7C756D28692E5F5F65292C692E5F5F653D692E5F5F643D766F696420307D6E28796D2C224E22293B66756E6374696F6E20797728692C652C74297B72657475726E20746869';
wwv_flow_imp.g_varchar2_table(1166) := '732E636F6E7374727563746F7228692C74297D6E2879772C224F22293B66756E6374696F6E206B6828692C652C74297B76617220722C732C6F3B65652E5F5F262665652E5F5F28692C65292C733D28723D747970656F6620743D3D2266756E6374696F6E';
wwv_flow_imp.g_varchar2_table(1167) := '22293F6E756C6C3A742626742E5F5F6B7C7C652E5F5F6B2C6F3D5B5D2C556828652C693D2821722626747C7C65292E5F5F6B3D752848742C6E756C6C2C5B695D292C737C7C4C6C2C4C6C2C652E6F776E6572535647456C656D656E74213D3D766F696420';
wwv_flow_imp.g_varchar2_table(1168) := '302C21722626743F5B745D3A733F6E756C6C3A652E66697273744368696C643F436E2E63616C6C28652E6368696C644E6F646573293A6E756C6C2C6F2C21722626743F743A733F732E5F5F653A652E66697273744368696C642C72292C6D6D286F2C6929';
wwv_flow_imp.g_varchar2_table(1169) := '7D6E286B682C225022293B66756E6374696F6E206A6C28692C652C74297B76617220722C732C6F2C613D7972287B7D2C692E70726F7073293B666F72286F20696E2065296F3D3D226B6579223F723D655B6F5D3A6F3D3D22726566223F733D655B6F5D3A';
wwv_flow_imp.g_varchar2_table(1170) := '615B6F5D3D655B6F5D3B72657475726E20617267756D656E74732E6C656E6774683E32262628612E6368696C6472656E3D617267756D656E74732E6C656E6774683E333F436E2E63616C6C28617267756D656E74732C32293A74292C456E28692E747970';
wwv_flow_imp.g_varchar2_table(1171) := '652C612C727C7C692E6B65792C737C7C692E7265662C6E756C6C297D6E286A6C2C227122293B436E3D6C6D2E736C6963652C65653D7B5F5F653A66756E6374696F6E28692C652C742C72297B666F722876617220732C6F2C613B653D652E5F5F3B296966';
wwv_flow_imp.g_varchar2_table(1172) := '2828733D652E5F5F6329262621732E5F5F297472797B696628286F3D732E636F6E7374727563746F722926266F2E67657444657269766564537461746546726F6D4572726F72213D6E756C6C262628732E7365745374617465286F2E6765744465726976';
wwv_flow_imp.g_varchar2_table(1173) := '6564537461746546726F6D4572726F72286929292C613D732E5F5F64292C732E636F6D706F6E656E744469644361746368213D6E756C6C262628732E636F6D706F6E656E74446964436174636828692C727C7C7B7D292C613D732E5F5F64292C61297265';
wwv_flow_imp.g_varchar2_table(1174) := '7475726E20732E5F5F453D737D6361746368286C297B693D6C7D7468726F7720697D7D2C616D3D302C63773D6E2866756E6374696F6E2869297B72657475726E2069213D6E756C6C2626692E636F6E7374727563746F723D3D3D766F696420307D2C2269';
wwv_flow_imp.g_varchar2_table(1175) := '22292C77652E70726F746F747970652E73657453746174653D66756E6374696F6E28692C65297B76617220743B743D746869732E5F5F73213D6E756C6C2626746869732E5F5F73213D3D746869732E73746174653F746869732E5F5F733A746869732E5F';
wwv_flow_imp.g_varchar2_table(1176) := '5F733D7972287B7D2C746869732E7374617465292C747970656F6620693D3D2266756E6374696F6E22262628693D69287972287B7D2C74292C746869732E70726F707329292C692626797228742C69292C69213D6E756C6C2626746869732E5F5F762626';
wwv_flow_imp.g_varchar2_table(1177) := '28652626746869732E5F5F682E707573682865292C726D287468697329297D2C77652E70726F746F747970652E666F7263655570646174653D66756E6374696F6E2869297B746869732E5F5F76262628746869732E5F5F653D21302C692626746869732E';
wwv_flow_imp.g_varchar2_table(1178) := '5F5F682E707573682869292C726D287468697329297D2C77652E70726F746F747970652E72656E6465723D48742C786E3D5B5D2C426C2E5F5F723D302C70773D303B66756E6374696F6E204F6E2869297B72657475726E20747970656F662069213D226F';
wwv_flow_imp.g_varchar2_table(1179) := '626A656374227C7C693D3D3D6E756C6C7C7C2128226E6F64655479706522696E2069293F21313A692E6E6F6465547970653D3D3D4E6F64652E454C454D454E545F4E4F44457D6E284F6E2C226973444F4D456C656D656E7422293B66756E6374696F6E20';
wwv_flow_imp.g_varchar2_table(1180) := '546E28692C65297B72657475726E20653D3D3D766F69642030262628653D646F63756D656E74292C747970656F6620693D3D22737472696E67223F652E717565727953656C6563746F722869293A4F6E2869293F693A6E756C6C7D6E28546E2C2266696E';
wwv_flow_imp.g_varchar2_table(1181) := '64444F4D456C656D656E7422293B66756E6374696F6E2076772869297B666F722876617220653B69262621692E6469723B29693D692E706172656E744E6F64653B72657475726E28653D69293D3D6E756C6C3F766F696420303A652E6469727D6E287677';
wwv_flow_imp.g_varchar2_table(1182) := '2C2267657454657874446972656374696F6E22293B76617220486C3D76773B7661722076653D636C6173737B636F6E7374727563746F7228652C74297B743D3D3D766F69642030262628743D7B7D292C746869732E757070793D652C746869732E6F7074';
wwv_flow_imp.g_varchar2_table(1183) := '733D747D676574506C7567696E537461746528297B6C65747B706C7567696E733A657D3D746869732E757070792E676574537461746528293B72657475726E20655B746869732E69645D7C7C7B7D7D736574506C7567696E53746174652865297B6C6574';
wwv_flow_imp.g_varchar2_table(1184) := '7B706C7567696E733A747D3D746869732E757070792E676574537461746528293B746869732E757070792E7365745374617465287B706C7567696E733A7B2E2E2E742C5B746869732E69645D3A7B2E2E2E745B746869732E69645D2C2E2E2E657D7D7D29';
wwv_flow_imp.g_varchar2_table(1185) := '7D7365744F7074696F6E732865297B746869732E6F7074733D7B2E2E2E746869732E6F7074732C2E2E2E657D2C746869732E736574506C7567696E537461746528292C746869732E6931386E496E697428297D6931386E496E697428297B6C657420653D';
wwv_flow_imp.g_varchar2_table(1186) := '6E28723D3E746869732E757070792E6C6F6728604D697373696E67206931386E20737472696E673A20247B727D602C226572726F7222292C226F6E4D697373696E674B657922292C743D6E6577204B72285B746869732E64656661756C744C6F63616C65';
wwv_flow_imp.g_varchar2_table(1187) := '2C746869732E757070792E6C6F63616C652C746869732E6F7074732E6C6F63616C655D2C7B6F6E4D697373696E674B65793A657D293B746869732E6931386E3D742E7472616E736C6174652E62696E642874292C746869732E6931386E41727261793D74';
wwv_flow_imp.g_varchar2_table(1188) := '2E7472616E736C61746541727261792E62696E642874292C746869732E736574506C7567696E537461746528297D61646454617267657428297B7468726F77206E6577204572726F722822457874656E642074686520616464546172676574206D657468';
wwv_flow_imp.g_varchar2_table(1189) := '6F6420746F2061646420796F757220706C7567696E20746F20616E6F7468657220706C7567696E27732074617267657422297D696E7374616C6C28297B7D756E696E7374616C6C28297B7D72656E64657228297B7468726F77206E6577204572726F7228';
wwv_flow_imp.g_varchar2_table(1190) := '22457874656E64207468652072656E646572206D6574686F6420746F2061646420796F757220706C7567696E20746F206120444F4D20656C656D656E7422297D75706461746528297B7D616674657255706461746528297B7D7D3B6E2876652C22426173';
wwv_flow_imp.g_varchar2_table(1191) := '65506C7567696E22293B66756E6374696F6E20766D28692C65297B696628214F626A6563742E70726F746F747970652E6861734F776E50726F70657274792E63616C6C28692C6529297468726F77206E657720547970654572726F722822617474656D70';
wwv_flow_imp.g_varchar2_table(1192) := '74656420746F207573652070726976617465206669656C64206F6E206E6F6E2D696E7374616E636522293B72657475726E20697D6E28766D2C225F636C617373507269766174654669656C644C6F6F73654261736522293B7661722062773D303B66756E';
wwv_flow_imp.g_varchar2_table(1193) := '6374696F6E2077772869297B72657475726E225F5F707269766174655F222B62772B2B2B225F222B697D6E2877772C225F636C617373507269766174654669656C644C6F6F73654B657922293B66756E6374696F6E2053772869297B6C657420653D6E75';
wwv_flow_imp.g_varchar2_table(1194) := '6C6C2C743D6E756C6C3B72657475726E2066756E6374696F6E28297B666F722876617220723D617267756D656E74732E6C656E6774682C733D6E65772041727261792872292C6F3D303B6F3C723B6F2B2B29735B6F5D3D617267756D656E74735B6F5D3B';
wwv_flow_imp.g_varchar2_table(1195) := '72657475726E20743D732C657C7C28653D50726F6D6973652E7265736F6C766528292E7468656E2828293D3E28653D6E756C6C2C69282E2E2E74292929292C657D7D6E2853772C226465626F756E636522293B76617220416E3D77772822757064617465';
wwv_flow_imp.g_varchar2_table(1196) := '554922292C436F3D636C61737320657874656E64732076657B636F6E7374727563746F7228297B7375706572282E2E2E617267756D656E7473292C4F626A6563742E646566696E6550726F706572747928746869732C416E2C7B7772697461626C653A21';
wwv_flow_imp.g_varchar2_table(1197) := '302C76616C75653A766F696420307D297D676574546172676574506C7567696E2865297B6C657420743B696628747970656F6620653D3D226F626A6563742226266520696E7374616E63656F6620436F29743D653B656C736520696628747970656F6620';
wwv_flow_imp.g_varchar2_table(1198) := '653D3D2266756E6374696F6E22297B6C657420723D653B746869732E757070792E69746572617465506C7567696E7328733D3E7B7320696E7374616E63656F662072262628743D73297D297D72657475726E20747D6D6F756E7428652C74297B6C657420';
wwv_flow_imp.g_varchar2_table(1199) := '723D742E69642C733D546E2865293B69662873297B746869732E6973546172676574444F4D456C3D21303B6C6574206C3D646F63756D656E742E637265617465456C656D656E74282264697622293B72657475726E206C2E636C6173734C6973742E6164';
wwv_flow_imp.g_varchar2_table(1200) := '642822757070792D526F6F7422292C766D28746869732C416E295B416E5D3D537728683D3E7B746869732E757070792E676574506C7567696E28746869732E6964292626286B6828746869732E72656E6465722868292C6C292C746869732E6166746572';
wwv_flow_imp.g_varchar2_table(1201) := '5570646174652829297D292C746869732E757070792E6C6F672860496E7374616C6C696E6720247B727D20746F206120444F4D20656C656D656E742027247B657D2760292C746869732E6F7074732E7265706C616365546172676574436F6E74656E7426';
wwv_flow_imp.g_varchar2_table(1202) := '2628732E696E6E657248544D4C3D2222292C6B6828746869732E72656E64657228746869732E757070792E67657453746174652829292C6C292C746869732E656C3D6C2C732E617070656E644368696C64286C292C6C2E6469723D746869732E6F707473';
wwv_flow_imp.g_varchar2_table(1203) := '2E646972656374696F6E7C7C486C286C297C7C226C7472222C746869732E6F6E4D6F756E7428292C746869732E656C7D6C6574206F3D746869732E676574546172676574506C7567696E2865293B6966286F2972657475726E20746869732E757070792E';
wwv_flow_imp.g_varchar2_table(1204) := '6C6F672860496E7374616C6C696E6720247B727D20746F20247B6F2E69647D60292C746869732E706172656E743D6F2C746869732E656C3D6F2E6164645461726765742874292C746869732E6F6E4D6F756E7428292C746869732E656C3B746869732E75';
wwv_flow_imp.g_varchar2_table(1205) := '7070792E6C6F6728604E6F7420696E7374616C6C696E6720247B727D60293B6C657420613D60496E76616C696420746172676574206F7074696F6E20676976656E20746F20247B727D2E603B7468726F7720747970656F6620653D3D2266756E6374696F';
wwv_flow_imp.g_varchar2_table(1206) := '6E223F612B3D222054686520676976656E20746172676574206973206E6F74206120506C7567696E20636C6173732E20506C6561736520636865636B207468617420796F75277265206E6F742073706563696679696E67206120526561637420436F6D70';
wwv_flow_imp.g_varchar2_table(1207) := '6F6E656E7420696E7374656164206F66206120706C7567696E2E20496620796F7520617265207573696E672040757070792F2A207061636B61676573206469726563746C792C206D616B65207375726520796F752068617665206F6E6C79203120766572';
wwv_flow_imp.g_varchar2_table(1208) := '73696F6E206F662040757070792F636F726520696E7374616C6C65643A2072756E20606E706D206C732040757070792F636F726560206F6E2074686520636F6D6D616E64206C696E6520616E6420766572696679207468617420616C6C20746865207665';
wwv_flow_imp.g_varchar2_table(1209) := '7273696F6E73206D6174636820616E6420617265206465647570656420636F72726563746C792E223A612B3D22496620796F75206D65616E7420746F2074617267657420616E2048544D4C20656C656D656E742C20706C65617365206D616B6520737572';
wwv_flow_imp.g_varchar2_table(1210) := '6520746861742074686520656C656D656E74206578697374732E20436865636B207468617420746865203C7363726970743E2074616720696E697469616C697A696E672055707079206973207269676874206265666F72652074686520636C6F73696E67';
wwv_flow_imp.g_varchar2_table(1211) := '203C2F626F64793E207461672061742074686520656E64206F662074686520706167652E20287365652068747470733A2F2F6769746875622E636F6D2F7472616E736C6F616469742F757070792F6973737565732F31303432295C6E5C6E496620796F75';
wwv_flow_imp.g_varchar2_table(1212) := '206D65616E7420746F20746172676574206120706C7567696E2C20706C6561736520636F6E6669726D207468617420796F75722060696D706F7274602073746174656D656E7473206F72206072657175697265602063616C6C732061726520636F727265';
wwv_flow_imp.g_varchar2_table(1213) := '63742E222C6E6577204572726F722861297D7570646174652865297B696628746869732E656C213D6E756C6C297B76617220742C723B28743D28723D766D28746869732C416E29295B416E5D293D3D6E756C6C7C7C742E63616C6C28722C65297D7D756E';
wwv_flow_imp.g_varchar2_table(1214) := '6D6F756E7428297B696628746869732E6973546172676574444F4D456C297B76617220653B28653D746869732E656C293D3D6E756C6C7C7C652E72656D6F766528297D746869732E6F6E556E6D6F756E7428297D6F6E4D6F756E7428297B7D6F6E556E6D';
wwv_flow_imp.g_varchar2_table(1215) := '6F756E7428297B7D7D3B6E28436F2C225549506C7567696E22293B766172205A3D436F3B766172207A683D7B7D3B4F6C287A682C7B50726F76696465723A28293D3E62652C52657175657374436C69656E743A28293D3E68742C53656172636850726F76';
wwv_flow_imp.g_varchar2_table(1216) := '696465723A28293D3E58722C536F636B65743A28293D3E4F6F7D293B76617220246C3D636C61737320657874656E6473204572726F727B636F6E7374727563746F7228297B7375706572282E2E2E617267756D656E7473292C746869732E6E616D653D22';
wwv_flow_imp.g_varchar2_table(1217) := '55736572466163696E674170694572726F72227D7D3B6E28246C2C2255736572466163696E674170694572726F7222293B76617220626D3D246C3B76617220456D3D646528466D28292C31293B766172205F773D4F626A6563742E70726F746F74797065';
wwv_flow_imp.g_varchar2_table(1218) := '2E746F537472696E672C46773D6E28693D3E5F772E63616C6C2869293D3D3D225B6F626A656374204572726F725D222C2269734572726F7222292C78773D6E657720536574285B224661696C656420746F206665746368222C224E6574776F726B457272';
wwv_flow_imp.g_varchar2_table(1219) := '6F72207768656E20617474656D7074696E6720746F206665746368207265736F757263652E222C2254686520496E7465726E657420636F6E6E656374696F6E206170706561727320746F206265206F66666C696E652E222C224C6F6164206661696C6564';
wwv_flow_imp.g_varchar2_table(1220) := '222C224E6574776F726B2072657175657374206661696C6564222C226665746368206661696C6564225D293B66756E6374696F6E2044682869297B72657475726E2069262646772869292626692E6E616D653D3D3D22547970654572726F722226267479';
wwv_flow_imp.g_varchar2_table(1221) := '70656F6620692E6D6573736167653D3D22737472696E67223F692E6D6573736167653D3D3D224C6F6164206661696C6564223F692E737461636B3D3D3D766F696420303A78772E68617328692E6D657373616765293A21317D6E2844682C2269734E6574';
wwv_flow_imp.g_varchar2_table(1222) := '776F726B4572726F7222293B7661722053733D636C61737320657874656E6473204572726F727B636F6E7374727563746F722865297B737570657228292C6520696E7374616E63656F66204572726F723F28746869732E6F726967696E616C4572726F72';
wwv_flow_imp.g_varchar2_table(1223) := '3D652C7B6D6573736167653A657D3D65293A28746869732E6F726967696E616C4572726F723D6E6577204572726F722865292C746869732E6F726967696E616C4572726F722E737461636B3D746869732E737461636B292C746869732E6E616D653D2241';
wwv_flow_imp.g_varchar2_table(1224) := '626F72744572726F72222C746869732E6D6573736167653D657D7D3B6E2853732C2241626F72744572726F7222293B76617220786D3D6E2828692C652C74293D3E7B6C657420723D742E726574726965732D28652D31293B72657475726E20692E617474';
wwv_flow_imp.g_varchar2_table(1225) := '656D70744E756D6265723D652C692E726574726965734C6566743D722C697D2C226465636F726174654572726F7257697468436F756E747322293B6173796E632066756E6374696F6E20716C28692C65297B72657475726E206E65772050726F6D697365';
wwv_flow_imp.g_varchar2_table(1226) := '2828742C72293D3E7B653D7B6F6E4661696C6564417474656D707428297B7D2C726574726965733A31302C2E2E2E657D3B6C657420733D456D2E64656661756C742E6F7065726174696F6E2865292C6F3D6E2828293D3E7B732E73746F7028292C722865';
wwv_flow_imp.g_varchar2_table(1227) := '2E7369676E616C3F2E726561736F6E297D2C2261626F727448616E646C657222293B652E7369676E616C262621652E7369676E616C2E61626F727465642626652E7369676E616C2E6164644576656E744C697374656E6572282261626F7274222C6F2C7B';
wwv_flow_imp.g_varchar2_table(1228) := '6F6E63653A21307D293B6C657420613D6E2828293D3E7B652E7369676E616C3F2E72656D6F76654576656E744C697374656E6572282261626F7274222C6F292C732E73746F7028297D2C22636C65616E557022293B732E617474656D7074286173796E63';
wwv_flow_imp.g_varchar2_table(1229) := '206C3D3E7B7472797B6C657420683D61776169742069286C293B6128292C742868297D63617463682868297B7472797B69662821286820696E7374616E63656F66204572726F7229297468726F77206E657720547970654572726F7228604E6F6E2D6572';
wwv_flow_imp.g_varchar2_table(1230) := '726F7220776173207468726F776E3A2022247B687D222E20596F752073686F756C64206F6E6C79207468726F77206572726F72732E60293B6966286820696E7374616E63656F66205373297468726F7720682E6F726967696E616C4572726F723B696628';
wwv_flow_imp.g_varchar2_table(1231) := '6820696E7374616E63656F6620547970654572726F722626214468286829297468726F7720683B696628617761697420652E6F6E4661696C6564417474656D707428786D28682C6C2C6529292C21732E7265747279286829297468726F7720732E6D6169';
wwv_flow_imp.g_varchar2_table(1232) := '6E4572726F7228297D63617463682863297B786D28632C6C2C65292C6128292C722863297D7D7D297D297D6E28716C2C2270526574727922293B76617220566C3D636C61737320657874656E6473204572726F727B636F6E7374727563746F7228652C74';
wwv_flow_imp.g_varchar2_table(1233) := '297B743D3D3D766F69642030262628743D6E756C6C292C7375706572282254686973206C6F6F6B73206C696B652061206E6574776F726B206572726F722C2074686520656E64706F696E74206D6967687420626520626C6F636B656420627920616E2069';
wwv_flow_imp.g_varchar2_table(1234) := '6E7465726E65742070726F7669646572206F722061206669726577616C6C2E22292C746869732E63617573653D652C746869732E69734E6574776F726B4572726F723D21302C746869732E726571756573743D747D7D3B6E28566C2C224E6574776F726B';
wwv_flow_imp.g_varchar2_table(1235) := '4572726F7222293B766172205F693D566C3B66756E6374696F6E20507328297B72657475726E206665746368282E2E2E617267756D656E7473292E636174636828693D3E7B7468726F7720692E6E616D653D3D3D2241626F72744572726F72223F693A6E';
wwv_flow_imp.g_varchar2_table(1236) := '6577205F692869297D297D6E2850732C226665746368576974684E6574776F726B4572726F7222293B66756E6374696F6E20597428692C65297B72657475726E204F626A6563742E70726F746F747970652E6861734F776E50726F70657274792E63616C';
wwv_flow_imp.g_varchar2_table(1237) := '6C28692C65297D6E2859742C2268617322293B76617220576C3D636C61737320657874656E6473204572726F727B636F6E7374727563746F7228652C74297B73757065722865292C746869732E63617573653D743F2E63617573652C746869732E636175';
wwv_flow_imp.g_varchar2_table(1238) := '73652626597428746869732E63617573652C2269734E6574776F726B4572726F7222293F746869732E69734E6574776F726B4572726F723D746869732E63617573652E69734E6574776F726B4572726F723A746869732E69734E6574776F726B4572726F';
wwv_flow_imp.g_varchar2_table(1239) := '723D21317D7D3B6E28576C2C224572726F7257697468436175736522293B7661722076723D576C3B76617220436D3D646528526C28292C31293B66756E6374696F6E20457728692C652C74297B6C65747B70726F67726573733A722C627974657355706C';
wwv_flow_imp.g_varchar2_table(1240) := '6F616465643A732C6279746573546F74616C3A6F7D3D653B72262628692E757070792E6C6F67286055706C6F61642070726F67726573733A20247B727D60292C692E757070792E656D6974282275706C6F61642D70726F6772657373222C742C7B75706C';
wwv_flow_imp.g_varchar2_table(1241) := '6F616465723A692C627974657355706C6F616465643A732C6279746573546F74616C3A6F7D29297D6E2845772C22656D6974536F636B657450726F677265737322293B766172204F6D3D28302C436D2E64656661756C74292845772C3330302C7B6C6561';
wwv_flow_imp.g_varchar2_table(1242) := '64696E673A21302C747261696C696E673A21307D293B66756E6374696F6E2049682869297B76617220653B6C657420723D28653D2F5E283F3A68747470733F3A5C2F5C2F7C5C2F5C2F293F283F3A5B5E405C6E5D2B40293F283F3A7777775C2E293F285B';
wwv_flow_imp.g_varchar2_table(1243) := '5E5C6E5D2B292F692E65786563286929293D3D6E756C6C3F766F696420303A655B315D3B72657475726E60247B2F5E687474703A5C2F5C2F2F692E746573742869293F227773223A22777373227D3A2F2F247B727D607D6E2849682C22676574536F636B';
wwv_flow_imp.g_varchar2_table(1244) := '6574486F737422293B76617220476C3D636C61737320657874656E6473204572726F727B636F6E7374727563746F7228297B73757065722822417574686F72697A6174696F6E20726571756972656422292C746869732E6E616D653D2241757468457272';
wwv_flow_imp.g_varchar2_table(1245) := '6F72222C746869732E6973417574684572726F723D21307D7D3B6E28476C2C22417574684572726F7222293B76617220546D3D476C3B76617220416D3B66756E6374696F6E20627228692C65297B696628214F626A6563742E70726F746F747970652E68';
wwv_flow_imp.g_varchar2_table(1246) := '61734F776E50726F70657274792E63616C6C28692C6529297468726F77206E657720547970654572726F722822617474656D7074656420746F207573652070726976617465206669656C64206F6E206E6F6E2D696E7374616E636522293B72657475726E';
wwv_flow_imp.g_varchar2_table(1247) := '20697D6E2862722C225F636C617373507269766174654669656C644C6F6F73654261736522293B7661722043773D303B66756E6374696F6E20586C2869297B72657475726E225F5F707269766174655F222B43772B2B2B225F222B697D6E28586C2C225F';
wwv_flow_imp.g_varchar2_table(1248) := '636C617373507269766174654669656C644C6F6F73654B657922293B766172204F773D7B76657273696F6E3A22332E372E30227D3B66756E6374696F6E2054772869297B72657475726E20692E7265706C616365282F5C2F242F2C2222297D6E2854772C';
wwv_flow_imp.g_varchar2_table(1249) := '227374726970536C61736822293B76617220526D3D31302C41773D352A36302A3165332C4E683D3430312C4B6C3D636C61737320657874656E6473204572726F727B636F6E7374727563746F722865297B6C65747B737461747573436F64653A742C6D65';
wwv_flow_imp.g_varchar2_table(1250) := '73736167653A727D3D653B73757065722872292C746869732E737461747573436F64653D766F696420302C746869732E6E616D653D22487474704572726F72222C746869732E737461747573436F64653D747D7D3B6E284B6C2C22487474704572726F72';
wwv_flow_imp.g_varchar2_table(1251) := '22293B6173796E632066756E6374696F6E2052772869297B696628692E7374617475733D3D3D4E68297468726F77206E657720546D3B696628692E6F6B2972657475726E20692E6A736F6E28293B6C657420653D604661696C6564207265717565737420';
wwv_flow_imp.g_varchar2_table(1252) := '77697468207374617475733A20247B692E7374617475737D2E20247B692E737461747573546578747D602C743B7472797B743D617761697420692E6A736F6E28292C742E6D657373616765262628653D60247B657D206D6573736167653A20247B742E6D';
wwv_flow_imp.g_varchar2_table(1253) := '6573736167657D60292C742E726571756573744964262628653D60247B657D20726571756573742D49643A20247B742E7265717565737449647D60297D63617463682872297B7468726F77206E6577204572726F7228652C7B63617573653A727D297D74';
wwv_flow_imp.g_varchar2_table(1254) := '68726F7720692E7374617475733E3D3430302626692E7374617475733C3D3439392626742E6D6573736167653F6E657720626D28742E6D657373616765293A6E6577204B6C287B737461747573436F64653A692E7374617475732C6D6573736167653A65';
wwv_flow_imp.g_varchar2_table(1255) := '7D297D6E2852772C2268616E646C654A534F4E526573706F6E736522293B7661722077723D586C2822636F6D70616E696F6E4865616465727322292C526E3D586C282267657455726C22292C4D683D586C282272657175657374536F636B6574546F6B65';
wwv_flow_imp.g_varchar2_table(1256) := '6E22292C556E3D586C2822617761697452656D6F746546696C6555706C6F616422293B416D3D53796D626F6C2E666F7228227570707920746573743A20676574436F6D70616E696F6E4865616465727322293B7661722068743D636C6173737B636F6E73';
wwv_flow_imp.g_varchar2_table(1257) := '74727563746F7228652C74297B4F626A6563742E646566696E6550726F706572747928746869732C556E2C7B76616C75653A6B777D292C4F626A6563742E646566696E6550726F706572747928746869732C526E2C7B76616C75653A55777D292C4F626A';
wwv_flow_imp.g_varchar2_table(1258) := '6563742E646566696E6550726F706572747928746869732C77722C7B7772697461626C653A21302C76616C75653A766F696420307D292C4F626A6563742E646566696E6550726F706572747928746869732C4D682C7B7772697461626C653A21302C7661';
wwv_flow_imp.g_varchar2_table(1259) := '6C75653A6173796E6320723D3E7B6C65747B66696C653A732C706F7374426F64793A6F2C7369676E616C3A617D3D723B696628732E72656D6F74652E75726C3D3D6E756C6C297468726F77206E6577204572726F72282243616E6E6F7420636F6E6E6563';
wwv_flow_imp.g_varchar2_table(1260) := '7420746F20616E20756E646566696E65642055524C22293B72657475726E28617761697420746869732E706F737428732E72656D6F74652E75726C2C7B2E2E2E732E72656D6F74652E626F64792C2E2E2E6F7D2C6129292E746F6B656E7D7D292C746869';
wwv_flow_imp.g_varchar2_table(1261) := '732E757070793D652C746869732E6F7074733D742C746869732E6F6E52656365697665526573706F6E73653D746869732E6F6E52656365697665526573706F6E73652E62696E642874686973292C627228746869732C7772295B77725D3D743F2E636F6D';
wwv_flow_imp.g_varchar2_table(1262) := '70616E696F6E486561646572737D736574436F6D70616E696F6E486561646572732865297B627228746869732C7772295B77725D3D657D5B416D5D28297B72657475726E20627228746869732C7772295B77725D7D67657420686F73746E616D6528297B';
wwv_flow_imp.g_varchar2_table(1263) := '6C65747B636F6D70616E696F6E3A657D3D746869732E757070792E676574537461746528292C743D746869732E6F7074732E636F6D70616E696F6E55726C3B72657475726E20547728652626655B745D3F655B745D3A74297D6173796E63206865616465';
wwv_flow_imp.g_varchar2_table(1264) := '72732865297B72657475726E20653D3D3D766F69642030262628653D2131292C7B2E2E2E7B4163636570743A226170706C69636174696F6E2F6A736F6E222C2E2E2E653F766F696420303A7B22436F6E74656E742D54797065223A226170706C69636174';
wwv_flow_imp.g_varchar2_table(1265) := '696F6E2F6A736F6E227D7D2C2E2E2E627228746869732C7772295B77725D7D7D6F6E52656365697665526573706F6E73652865297B6C65747B686561646572733A747D3D652C733D746869732E757070792E676574537461746528292E636F6D70616E69';
wwv_flow_imp.g_varchar2_table(1266) := '6F6E7C7C7B7D2C6F3D746869732E6F7074732E636F6D70616E696F6E55726C3B742E6861732822692D616D22292626742E6765742822692D616D2229213D3D735B6F5D2626746869732E757070792E7365745374617465287B636F6D70616E696F6E3A7B';
wwv_flow_imp.g_varchar2_table(1267) := '2E2E2E732C5B6F5D3A742E6765742822692D616D22297D7D297D6173796E6320726571756573742865297B6C65747B706174683A742C6D6574686F643A723D22474554222C646174613A732C736B6970506F7374526573706F6E73653A6F2C7369676E61';
wwv_flow_imp.g_varchar2_table(1268) := '6C3A617D3D653B7472797B6C6574206C3D617761697420746869732E68656164657273282173292C683D617761697420507328627228746869732C526E295B526E5D2874292C7B6D6574686F643A722C7369676E616C3A612C686561646572733A6C2C63';
wwv_flow_imp.g_varchar2_table(1269) := '726564656E7469616C733A746869732E6F7074732E636F6D70616E696F6E436F6F6B69657352756C657C7C2273616D652D6F726967696E222C626F64793A733F4A534F4E2E737472696E676966792873293A6E756C6C7D293B72657475726E206F7C7C74';
wwv_flow_imp.g_varchar2_table(1270) := '6869732E6F6E52656365697665526573706F6E73652868292C61776169742052772868297D6361746368286C297B7468726F77206C2E6973417574684572726F727C7C6C2E6E616D653D3D3D2255736572466163696E674170694572726F72227C7C6C2E';
wwv_flow_imp.g_varchar2_table(1271) := '6E616D653D3D3D2241626F72744572726F72223F6C3A6E65772076722860436F756C64206E6F7420247B727D20247B627228746869732C526E295B526E5D2874297D602C7B63617573653A6C7D297D7D6173796E632067657428652C74297B7265747572';
wwv_flow_imp.g_varchar2_table(1272) := '6E20743D3D3D766F69642030262628743D766F69642030292C747970656F6620743D3D22626F6F6C65616E22262628743D7B736B6970506F7374526573706F6E73653A747D292C746869732E72657175657374287B2E2E2E742C706174683A657D297D61';
wwv_flow_imp.g_varchar2_table(1273) := '73796E6320706F737428652C742C72297B72657475726E20723D3D3D766F69642030262628723D766F69642030292C747970656F6620723D3D22626F6F6C65616E22262628723D7B736B6970506F7374526573706F6E73653A727D292C746869732E7265';
wwv_flow_imp.g_varchar2_table(1274) := '7175657374287B2E2E2E722C706174683A652C6D6574686F643A22504F5354222C646174613A747D297D6173796E632064656C65746528652C742C72297B72657475726E20743D3D3D766F69642030262628743D766F69642030292C747970656F662072';
wwv_flow_imp.g_varchar2_table(1275) := '3D3D22626F6F6C65616E22262628723D7B736B6970506F7374526573706F6E73653A727D292C746869732E72657175657374287B2E2E2E722C706174683A652C6D6574686F643A2244454C455445222C646174613A747D297D6173796E632075706C6F61';
wwv_flow_imp.g_varchar2_table(1276) := '6452656D6F746546696C6528652C742C72297B76617220733D746869733B723D3D3D766F69642030262628723D7B7D293B7472797B6C65747B7369676E616C3A6F2C67657451756575653A617D3D723B72657475726E20617761697420716C286173796E';
wwv_flow_imp.g_varchar2_table(1277) := '6328293D3E7B766172206C3B6C657420683D286C3D746869732E757070792E67657446696C6528652E696429293D3D6E756C6C3F766F696420303A6C2E736572766572546F6B656E3B69662868213D6E756C6C2972657475726E20746869732E75707079';
wwv_flow_imp.g_varchar2_table(1278) := '2E6C6F672860436F6E6E656374696E6720746F2065786974696E6720776562736F636B657420247B687D60292C627228746869732C556E295B556E5D287B66696C653A652C71756575653A6128292C7369676E616C3A6F7D293B6C657420643D61776169';
wwv_flow_imp.g_varchar2_table(1279) := '74206128292E7772617050726F6D69736546756E6374696F6E286173796E632066756E6374696F6E28297B7472797B72657475726E20617761697420627228732C4D68295B4D685D282E2E2E617267756D656E7473297D63617463682866297B69662866';
wwv_flow_imp.g_varchar2_table(1280) := '2E6973417574684572726F72297468726F77206E65772053732866293B696628662E63617573653D3D6E756C6C297468726F7720663B6C657420793D662E63617573652C623D6E2828293D3E5B3430382C3430392C3432392C3431382C3432335D2E696E';
wwv_flow_imp.g_varchar2_table(1281) := '636C7564657328792E737461747573436F6465297C7C792E737461747573436F64653E3D3530302626792E737461747573436F64653C3D3539392626215B3530312C3530355D2E696E636C7564657328792E737461747573436F6465292C226973526574';
wwv_flow_imp.g_varchar2_table(1282) := '727961626C65487474704572726F7222293B7468726F7720792E6E616D653D3D3D22487474704572726F72222626216228293F6E65772053732879293A797D7D2C7B7072696F726974793A2D317D29287B66696C653A652C706F7374426F64793A742C73';
wwv_flow_imp.g_varchar2_table(1283) := '69676E616C3A6F7D292E61626F72744F6E286F293B696628746869732E757070792E67657446696C6528652E6964292972657475726E20746869732E757070792E73657446696C65537461746528652E69642C7B736572766572546F6B656E3A647D292C';
wwv_flow_imp.g_varchar2_table(1284) := '627228746869732C556E295B556E5D287B66696C653A746869732E757070792E67657446696C6528652E6964292C71756575653A6128292C7369676E616C3A6F7D297D2C7B726574726965733A526D2C7369676E616C3A6F2C6F6E4661696C6564417474';
wwv_flow_imp.g_varchar2_table(1285) := '656D70743A6C3D3E746869732E757070792E6C6F6728605265747279696E672075706C6F61642064756520746F3A20247B6C2E6D6573736167657D602C227761726E696E6722297D297D6361746368286F297B6966286F2E6E616D653D3D3D2241626F72';
wwv_flow_imp.g_varchar2_table(1286) := '744572726F72222972657475726E3B7468726F7720746869732E757070792E656D6974282275706C6F61642D6572726F72222C652C6F292C6F7D7D7D3B6E2868742C2252657175657374436C69656E7422293B66756E6374696F6E2055772869297B7265';
wwv_flow_imp.g_varchar2_table(1287) := '7475726E2F5E2868747470733F3A7C295C2F5C2F2F2E746573742869293F693A60247B746869732E686F73746E616D657D2F247B697D607D6E2855772C225F67657455726C3222293B6173796E632066756E6374696F6E206B772869297B6C65747B6669';
wwv_flow_imp.g_varchar2_table(1288) := '6C653A652C71756575653A742C7369676E616C3A727D3D692C732C7B6361706162696C69746965733A6F7D3D746869732E757070792E676574537461746528293B7472797B72657475726E206177616974206E65772050726F6D6973652828612C6C293D';
wwv_flow_imp.g_varchar2_table(1289) := '3E7B6C657420683D652E736572766572546F6B656E2C633D496828652E72656D6F74652E636F6D70616E696F6E55726C292C642C662C792C7B69735061757365643A627D3D652C533D6E28287A2C4B293D3E7B696628643D3D6E756C6C7C7C642E726561';
wwv_flow_imp.g_varchar2_table(1290) := '64795374617465213D3D642E4F50454E297B766172206F653B746869732E757070792E6C6F67286043616E6E6F742073656E642022247B7A7D2220746F20736F636B657420247B652E69647D20626563617573652074686520736F636B65742073746174';
wwv_flow_imp.g_varchar2_table(1291) := '652077617320247B537472696E6728286F653D64293D3D6E756C6C3F766F696420303A6F652E72656164795374617465297D602C227761726E696E6722293B72657475726E7D642E73656E64284A534F4E2E737472696E67696679287B616374696F6E3A';
wwv_flow_imp.g_varchar2_table(1292) := '7A2C7061796C6F61643A4B3F3F7B7D7D29297D2C22736F636B657453656E6422293B66756E6374696F6E204528297B6F2E726573756D61626C6555706C6F61647326265328623F227061757365223A22726573756D6522297D6E28452C2273656E645374';
wwv_flow_imp.g_varchar2_table(1293) := '61746522293B6C657420463D6E286173796E6328293D3E7B662626662E61626F727428292C663D6E65772041626F7274436F6E74726F6C6C65723B6C6574207A3D6E286F653D3E7B7661722042653B746869732E757070792E73657446696C6553746174';
wwv_flow_imp.g_varchar2_table(1294) := '6528652E69642C7B736572766572546F6B656E3A6E756C6C7D292C2842653D66293D3D6E756C6C7C7C42652E61626F72743D3D6E756C6C7C7C42652E61626F727428292C6C286F65297D2C226F6E466174616C4572726F7222293B66756E6374696F6E20';
wwv_flow_imp.g_varchar2_table(1295) := '4B28297B636C65617254696D656F75742879292C2162262628793D73657454696D656F75742828293D3E7A286E6577204572726F72282254696D656F75742077616974696E6720666F72206D6573736167652066726F6D20436F6D70616E696F6E20736F';
wwv_flow_imp.g_varchar2_table(1296) := '636B65742229292C417729297D6E284B2C227265736574416374697669747954696D656F757422293B7472797B617761697420742E7772617050726F6D69736546756E6374696F6E286173796E6328293D3E7B617761697420716C286E286173796E6328';
wwv_flow_imp.g_varchar2_table(1297) := '293D3E6E65772050726F6D697365282842652C4A65293D3E7B643D6E657720576562536F636B65742860247B637D2F6170692F247B687D60292C4B28292C642E6164644576656E744C697374656E65722822636C6F7365222C28293D3E7B643D766F6964';
wwv_flow_imp.g_varchar2_table(1298) := '20302C4A65286E6577204572726F722822536F636B657420636C6F73656420756E65787065637465646C792229297D292C642E6164644576656E744C697374656E657228226572726F72222C47653D3E7B746869732E757070792E6C6F672860436F6D70';
wwv_flow_imp.g_varchar2_table(1299) := '616E696F6E20736F636B6574206572726F7220247B4A534F4E2E737472696E67696679284765297D2C20636C6F73696E6720736F636B6574602C227761726E696E6722292C642E636C6F736528297D292C642E6164644576656E744C697374656E657228';
wwv_flow_imp.g_varchar2_table(1300) := '226F70656E222C28293D3E7B4528297D292C642E6164644576656E744C697374656E657228226D657373616765222C47653D3E7B4B28293B7472797B6C65747B616374696F6E3A7A652C7061796C6F61643A46657D3D4A534F4E2E70617273652847652E';
wwv_flow_imp.g_varchar2_table(1301) := '64617461293B737769746368287A65297B636173652270726F6772657373223A7B4F6D28746869732C46652C65293B627265616B7D636173652273756363657373223A7B766172205F653B746869732E757070792E656D6974282275706C6F61642D7375';
wwv_flow_imp.g_varchar2_table(1302) := '6363657373222C652C7B75706C6F616455524C3A46652E75726C7D292C285F653D66293D3D6E756C6C7C7C5F652E61626F72743D3D6E756C6C7C7C5F652E61626F727428292C6128293B627265616B7D63617365226572726F72223A7B6C65747B6D6573';
wwv_flow_imp.g_varchar2_table(1303) := '736167653A68697D3D46652E6572726F723B7468726F77204F626A6563742E61737369676E286E6577204572726F72286869292C7B63617573653A46652E6572726F727D297D64656661756C743A746869732E757070792E6C6F672860436F6D70616E69';
wwv_flow_imp.g_varchar2_table(1304) := '6F6E20736F636B657420756E6B6E6F776E20616374696F6E20247B7A657D602C227761726E696E6722297D7D6361746368287A65297B7A287A65297D7D293B6C65742077743D6E2828293D3E7B746869732E757070792E6C6F672860436C6F73696E6720';
wwv_flow_imp.g_varchar2_table(1305) := '736F636B657420247B652E69647D602C22696E666F22292C636C65617254696D656F75742879292C642626642E636C6F736528292C643D766F696420307D2C22636C6F7365536F636B657422293B662E7369676E616C2E6164644576656E744C69737465';
wwv_flow_imp.g_varchar2_table(1306) := '6E6572282261626F7274222C28293D3E7B777428297D297D292C227265636F6E6E656374576562736F636B657422292C7B726574726965733A526D2C7369676E616C3A662E7369676E616C2C6F6E4661696C6564417474656D70743A28293D3E7B662E73';
wwv_flow_imp.g_varchar2_table(1307) := '69676E616C2E61626F727465647C7C746869732E757070792E6C6F6728605265747279696E6720776562736F636B657420247B652E69647D602C22696E666F22297D7D297D2928292E61626F72744F6E28662E7369676E616C297D6361746368286F6529';
wwv_flow_imp.g_varchar2_table(1308) := '7B696628662E7369676E616C2E61626F727465642972657475726E3B7A286F65297D7D2C22637265617465576562736F636B657422292C783D6E287A3D3E7B6966286F2E726573756D61626C6555706C6F61647329696628623D7A2C6426264528292C7A';
wwv_flow_imp.g_varchar2_table(1309) := '297B766172204B3B284B3D66293D3D6E756C6C7C7C4B2E61626F72743D3D6E756C6C7C7C4B2E61626F727428297D656C7365204628297D2C22706175736522292C553D6E287A3D3E7B766172204B3B6F2E696E646976696475616C43616E63656C6C6174';
wwv_flow_imp.g_varchar2_table(1310) := '696F6E26267A2E69643D3D3D652E696426262853282263616E63656C22292C284B3D66293D3D6E756C6C7C7C4B2E61626F72743D3D6E756C6C7C7C4B2E61626F727428292C746869732E757070792E6C6F67286075706C6F616420247B652E69647D2077';
wwv_flow_imp.g_varchar2_table(1311) := '61732072656D6F766564602C22696E666F22292C612829297D2C226F6E46696C6552656D6F766522292C6A3D6E287A3D3E7B766172204B3B6C65747B726561736F6E3A6F657D3D7A3B6F653D3D3D227573657222262653282263616E63656C22292C284B';
wwv_flow_imp.g_varchar2_table(1312) := '3D66293D3D6E756C6C7C7C4B2E61626F72743D3D6E756C6C7C7C4B2E61626F727428292C746869732E757070792E6C6F67286075706C6F616420247B652E69647D207761732063616E63656C6564602C22696E666F22292C6128297D2C226F6E43616E63';
wwv_flow_imp.g_varchar2_table(1313) := '656C416C6C22292C473D6E28287A2C4B293D3E7B7A3D3D3D652E6964262678284B297D2C226F6E46696C655061757365644368616E676522292C4A3D6E2828293D3E78282130292C226F6E5061757365416C6C22292C423D6E2828293D3E78282131292C';
wwv_flow_imp.g_varchar2_table(1314) := '226F6E526573756D65416C6C22293B746869732E757070792E6F6E282266696C652D72656D6F766564222C55292C746869732E757070792E6F6E282263616E63656C2D616C6C222C6A292C746869732E757070792E6F6E282275706C6F61642D70617573';
wwv_flow_imp.g_varchar2_table(1315) := '65222C47292C746869732E757070792E6F6E282270617573652D616C6C222C4A292C746869732E757070792E6F6E2822726573756D652D616C6C222C42292C733D6E2828293D3E7B746869732E757070792E6F6666282266696C652D72656D6F76656422';
wwv_flow_imp.g_varchar2_table(1316) := '2C55292C746869732E757070792E6F6666282263616E63656C2D616C6C222C6A292C746869732E757070792E6F6666282275706C6F61642D7061757365222C47292C746869732E757070792E6F6666282270617573652D616C6C222C4A292C746869732E';
wwv_flow_imp.g_varchar2_table(1317) := '757070792E6F66662822726573756D652D616C6C222C42297D2C2272656D6F76654576656E7448616E646C65727322292C722E6164644576656E744C697374656E6572282261626F7274222C28293D3E7B766172207A3B287A3D66293D3D6E756C6C7C7C';
wwv_flow_imp.g_varchar2_table(1318) := '7A2E61626F727428297D292C4628297D297D66696E616C6C797B733F2E28297D7D6E286B772C225F617761697452656D6F746546696C6555706C6F61643222293B68742E56455253494F4E3D4F772E76657273696F6E3B766172204C683D7B7D3B4F6C28';
wwv_flow_imp.g_varchar2_table(1319) := '4C682C7B6765744974656D3A28293D3E49772C72656D6F76654974656D3A28293D3E4D772C7365744974656D3A28293D3E44777D293B66756E6374696F6E20447728692C65297B72657475726E206E65772050726F6D69736528743D3E7B6C6F63616C53';
wwv_flow_imp.g_varchar2_table(1320) := '746F726167652E7365744974656D28692C65292C7428297D297D6E2844772C227365744974656D22293B66756E6374696F6E2049772869297B72657475726E2050726F6D6973652E7265736F6C7665286C6F63616C53746F726167652E6765744974656D';
wwv_flow_imp.g_varchar2_table(1321) := '286929297D6E2849772C226765744974656D22293B66756E6374696F6E204D772869297B72657475726E206E65772050726F6D69736528653D3E7B6C6F63616C53746F726167652E72656D6F76654974656D2869292C6528297D297D6E284D772C227265';
wwv_flow_imp.g_varchar2_table(1322) := '6D6F76654974656D22293B66756E6374696F6E205F7328692C65297B696628214F626A6563742E70726F746F747970652E6861734F776E50726F70657274792E63616C6C28692C6529297468726F77206E657720547970654572726F722822617474656D';
wwv_flow_imp.g_varchar2_table(1323) := '7074656420746F207573652070726976617465206669656C64206F6E206E6F6E2D696E7374616E636522293B72657475726E20697D6E285F732C225F636C617373507269766174654669656C644C6F6F73654261736522293B766172204E773D303B6675';
wwv_flow_imp.g_varchar2_table(1324) := '6E6374696F6E206B6D2869297B72657475726E225F5F707269766174655F222B4E772B2B2B225F222B697D6E286B6D2C225F636C617373507269766174654669656C644C6F6F73654B657922293B766172204C773D6E28693D3E692E73706C697428222D';
wwv_flow_imp.g_varchar2_table(1325) := '22292E6D617028653D3E652E6368617241742830292E746F55707065724361736528292B652E736C696365283129292E6A6F696E28222022292C226765744E616D6522293B66756E6374696F6E20427728297B72657475726E206C6F636174696F6E2E6F';
wwv_flow_imp.g_varchar2_table(1326) := '726967696E7D6E2842772C226765744F726967696E22293B66756E6374696F6E20556D2869297B696628747970656F6620693D3D22737472696E67222972657475726E206E65772052656745787028605E247B697D2460293B6966286920696E7374616E';
wwv_flow_imp.g_varchar2_table(1327) := '63656F66205265674578702972657475726E20697D6E28556D2C22676574526567657822293B66756E6374696F6E207A7728692C65297B72657475726E2841727261792E697341727261792865293F652E6D617028556D293A5B556D2865295D292E736F';
wwv_flow_imp.g_varchar2_table(1328) := '6D6528723D3E723F2E746573742869297C7C723F2E746573742860247B697D2F6029297D6E287A772C2269734F726967696E416C6C6F77656422293B7661722046693D6B6D282272656672657368696E67546F6B656E50726F6D69736522292C6B6E3D6B';
wwv_flow_imp.g_varchar2_table(1329) := '6D282267657441757468546F6B656E22292C62653D636C61737320657874656E64732068747B636F6E7374727563746F7228652C74297B76617220723B737570657228652C74292C4F626A6563742E646566696E6550726F706572747928746869732C6B';
wwv_flow_imp.g_varchar2_table(1330) := '6E2C7B76616C75653A6A777D292C4F626A6563742E646566696E6550726F706572747928746869732C46692C7B7772697461626C653A21302C76616C75653A766F696420307D292C746869732E70726F76696465723D742E70726F76696465722C746869';
wwv_flow_imp.g_varchar2_table(1331) := '732E69643D746869732E70726F76696465722C746869732E6E616D653D746869732E6F7074732E6E616D657C7C4C7728746869732E6964292C746869732E706C7567696E49643D746869732E6F7074732E706C7567696E49642C746869732E746F6B656E';
wwv_flow_imp.g_varchar2_table(1332) := '4B65793D60636F6D70616E696F6E2D247B746869732E706C7567696E49647D2D617574682D746F6B656E602C746869732E636F6D70616E696F6E4B657973506172616D733D746869732E6F7074732E636F6D70616E696F6E4B657973506172616D732C74';
wwv_flow_imp.g_varchar2_table(1333) := '6869732E70726541757468546F6B656E3D6E756C6C2C746869732E737570706F72747352656672657368546F6B656E3D28723D742E737570706F72747352656672657368546F6B656E29213D6E756C6C3F723A21307D6173796E63206865616465727328';
wwv_flow_imp.g_varchar2_table(1334) := '297B6C65745B652C745D3D61776169742050726F6D6973652E616C6C285B73757065722E6865616465727328292C5F7328746869732C6B6E295B6B6E5D28295D292C723D7B7D3B72657475726E2074262628725B22757070792D617574682D746F6B656E';
wwv_flow_imp.g_varchar2_table(1335) := '225D3D74292C746869732E636F6D70616E696F6E4B657973506172616D73262628725B22757070792D63726564656E7469616C732D706172616D73225D3D62746F61284A534F4E2E737472696E67696679287B706172616D733A746869732E636F6D7061';
wwv_flow_imp.g_varchar2_table(1336) := '6E696F6E4B657973506172616D737D2929292C7B2E2E2E652C2E2E2E727D7D6F6E52656365697665526573706F6E73652865297B73757065722E6F6E52656365697665526573706F6E73652865293B6C657420743D746869732E757070792E676574506C';
wwv_flow_imp.g_varchar2_table(1337) := '7567696E28746869732E706C7567696E4964292C733D742E676574506C7567696E537461746528292E61757468656E746963617465643F652E737461747573213D3D4E683A652E7374617475733C3430303B72657475726E20742E736574506C7567696E';
wwv_flow_imp.g_varchar2_table(1338) := '5374617465287B61757468656E746963617465643A737D292C657D6173796E632073657441757468546F6B656E2865297B72657475726E20746869732E757070792E676574506C7567696E28746869732E706C7567696E4964292E73746F726167652E73';
wwv_flow_imp.g_varchar2_table(1339) := '65744974656D28746869732E746F6B656E4B65792C65297D6173796E632072656D6F766541757468546F6B656E28297B72657475726E20746869732E757070792E676574506C7567696E28746869732E706C7567696E4964292E73746F726167652E7265';
wwv_flow_imp.g_varchar2_table(1340) := '6D6F76654974656D28746869732E746F6B656E4B6579297D6173796E6320656E737572655072654175746828297B696628746869732E636F6D70616E696F6E4B657973506172616D73262621746869732E70726541757468546F6B656E26262861776169';
wwv_flow_imp.g_varchar2_table(1341) := '7420746869732E666574636850726541757468546F6B656E28292C21746869732E70726541757468546F6B656E29297468726F77206E6577204572726F722822436F756C64206E6F74206C6F61642061757468656E7469636174696F6E20646174612072';
wwv_flow_imp.g_varchar2_table(1342) := '6571756972656420666F722074686972642D7061727479206C6F67696E2E20506C656173652074727920616761696E206C617465722E22297D61757468517565727928297B72657475726E7B7D7D6175746855726C2865297B6C65747B61757468466F72';
wwv_flow_imp.g_varchar2_table(1343) := '6D446174613A742C71756572793A727D3D653D3D3D766F696420303F7B7D3A652C733D6E65772055524C536561726368506172616D73287B2E2E2E722C73746174653A62746F61284A534F4E2E737472696E67696679287B6F726967696E3A427728297D';
wwv_flow_imp.g_varchar2_table(1344) := '29292C2E2E2E746869732E617574685175657279287B61757468466F726D446174613A747D297D293B72657475726E20746869732E70726541757468546F6B656E2626732E73657428227570707950726541757468546F6B656E222C746869732E707265';
wwv_flow_imp.g_varchar2_table(1345) := '41757468546F6B656E292C60247B746869732E686F73746E616D657D2F247B746869732E69647D2F636F6E6E6563743F247B737D607D6173796E63206C6F67696E53696D706C65417574682865297B6C65747B7570707956657273696F6E733A742C6175';
wwv_flow_imp.g_varchar2_table(1346) := '7468466F726D446174613A722C7369676E616C3A737D3D652C6F3D617761697420746869732E706F73742860247B746869732E69647D2F73696D706C652D61757468602C7B666F726D3A727D2C7B71733A7B7570707956657273696F6E733A747D2C7369';
wwv_flow_imp.g_varchar2_table(1347) := '676E616C3A737D293B746869732E73657441757468546F6B656E286F2E7570707941757468546F6B656E297D6173796E63206C6F67696E4F417574682865297B6C65747B7570707956657273696F6E733A742C61757468466F726D446174613A722C7369';
wwv_flow_imp.g_varchar2_table(1348) := '676E616C3A737D3D653B72657475726E20617761697420746869732E656E737572655072654175746828292C732E7468726F77496641626F7274656428292C6E65772050726F6D69736528286F2C61293D3E7B6C6574206C3D746869732E617574685572';
wwv_flow_imp.g_varchar2_table(1349) := '6C287B71756572793A7B7570707956657273696F6E733A747D2C61757468466F726D446174613A727D292C683D77696E646F772E6F70656E286C2C225F626C616E6B22292C632C643D6E28663D3E7B696628662E736F75726365213D3D68297B6C657420';
wwv_flow_imp.g_varchar2_table(1350) := '533D22223B7472797B533D4A534F4E2E737472696E6769667928662E64617461297D63617463687B7D746869732E757070792E6C6F67286069676E6F72696E67206576656E742066726F6D20756E6B6E6F776E20736F7572636520247B537D602C227761';
wwv_flow_imp.g_varchar2_table(1351) := '726E696E6722293B72657475726E7D6C65747B636F6D70616E696F6E416C6C6F776564486F7374733A797D3D746869732E757070792E676574506C7567696E28746869732E706C7567696E4964292E6F7074733B696628217A7728662E6F726967696E2C';
wwv_flow_imp.g_varchar2_table(1352) := '7929297B61286E6577204572726F72286072656A656374696E67206576656E742066726F6D20247B662E6F726967696E7D20767320616C6C6F776564207061747465726E20247B797D6029293B72657475726E7D6C657420623D747970656F6620662E64';
wwv_flow_imp.g_varchar2_table(1353) := '6174613D3D22737472696E67223F4A534F4E2E706172736528662E64617461293A662E646174613B696628622E6572726F72297B6C65747B757070793A537D3D746869732C453D532E6931386E28226175746841626F7274656422293B532E696E666F28';
wwv_flow_imp.g_varchar2_table(1354) := '7B6D6573736167653A457D2C227761726E696E67222C356533292C61286E6577204572726F722822617574682061626F727465642229293B72657475726E7D69662821622E746F6B656E297B61286E6577204572726F722822646964206E6F7420726563';
wwv_flow_imp.g_varchar2_table(1355) := '6569766520746F6B656E2066726F6D20617574682077696E646F772229293B72657475726E7D6328292C6F28746869732E73657441757468546F6B656E28622E746F6B656E29297D2C2268616E646C65546F6B656E22293B633D6E2828293D3E7B682E63';
wwv_flow_imp.g_varchar2_table(1356) := '6C6F736528292C77696E646F772E72656D6F76654576656E744C697374656E657228226D657373616765222C64292C732E72656D6F76654576656E744C697374656E6572282261626F7274222C63297D2C22636C65616E757022292C732E616464457665';
wwv_flow_imp.g_varchar2_table(1357) := '6E744C697374656E6572282261626F7274222C63292C77696E646F772E6164644576656E744C697374656E657228226D657373616765222C64297D297D6173796E63206C6F67696E2865297B6C65747B7570707956657273696F6E733A742C6175746846';
wwv_flow_imp.g_varchar2_table(1358) := '6F726D446174613A722C7369676E616C3A737D3D653B72657475726E20746869732E6C6F67696E4F41757468287B7570707956657273696F6E733A742C61757468466F726D446174613A722C7369676E616C3A737D297D72656672657368546F6B656E55';
wwv_flow_imp.g_varchar2_table(1359) := '726C28297B72657475726E60247B746869732E686F73746E616D657D2F247B746869732E69647D2F726566726573682D746F6B656E607D66696C6555726C2865297B72657475726E60247B746869732E686F73746E616D657D2F247B746869732E69647D';
wwv_flow_imp.g_varchar2_table(1360) := '2F6765742F247B657D607D6173796E63207265717565737428297B6177616974205F7328746869732C4669295B46695D3B7472797B72657475726E2061776169742073757065722E72657175657374282E2E2E617267756D656E7473297D636174636828';
wwv_flow_imp.g_varchar2_table(1361) := '65297B69662821746869732E737570706F72747352656672657368546F6B656E297468726F7720653B6C657420743D6177616974205F7328746869732C6B6E295B6B6E5D28293B69662821652E6973417574684572726F727C7C2174297468726F772065';
wwv_flow_imp.g_varchar2_table(1362) := '3B72657475726E205F7328746869732C4669295B46695D3D3D6E756C6C2626285F7328746869732C4669295B46695D3D286173796E6328293D3E7B7472797B746869732E757070792E6C6F6728225B436F6D70616E696F6E436C69656E745D2052656672';
wwv_flow_imp.g_varchar2_table(1363) := '657368696E672065787069726564206175746820746F6B656E222C22696E666F22293B6C657420723D61776169742073757065722E72657175657374287B706174683A746869732E72656672657368546F6B656E55726C28292C6D6574686F643A22504F';
wwv_flow_imp.g_varchar2_table(1364) := '5354227D293B617761697420746869732E73657441757468546F6B656E28722E7570707941757468546F6B656E297D63617463682872297B7468726F7720722E6973417574684572726F722626617761697420746869732E72656D6F766541757468546F';
wwv_flow_imp.g_varchar2_table(1365) := '6B656E28292C657D66696E616C6C797B5F7328746869732C4669295B46695D3D766F696420307D7D292829292C6177616974205F7328746869732C4669295B46695D2C73757065722E72657175657374282E2E2E617267756D656E7473297D7D6173796E';
wwv_flow_imp.g_varchar2_table(1366) := '6320666574636850726541757468546F6B656E28297B696628746869732E636F6D70616E696F6E4B657973506172616D73297472797B6C657420653D617761697420746869732E706F73742860247B746869732E69647D2F707265617574682F602C7B70';
wwv_flow_imp.g_varchar2_table(1367) := '6172616D733A746869732E636F6D70616E696F6E4B657973506172616D737D293B746869732E70726541757468546F6B656E3D652E746F6B656E7D63617463682865297B746869732E757070792E6C6F6728605B436F6D70616E696F6E436C69656E745D';
wwv_flow_imp.g_varchar2_table(1368) := '20756E61626C6520746F2066657463682070726541757468546F6B656E20247B657D602C227761726E696E6722297D7D6C69737428652C74297B72657475726E20746869732E6765742860247B746869732E69647D2F6C6973742F247B657C7C22227D60';
wwv_flow_imp.g_varchar2_table(1369) := '2C74297D6173796E63206C6F676F75742865297B6C657420743D617761697420746869732E6765742860247B746869732E69647D2F6C6F676F7574602C65293B72657475726E20617761697420746869732E72656D6F766541757468546F6B656E28292C';
wwv_flow_imp.g_varchar2_table(1370) := '747D73746174696320696E6974506C7567696E28652C742C72297B696628652E747970653D226163717569726572222C652E66696C65733D5B5D2C72262628652E6F7074733D7B2E2E2E722C2E2E2E747D292C742E73657276657255726C7C7C742E7365';
wwv_flow_imp.g_varchar2_table(1371) := '727665725061747465726E297468726F77206E6577204572726F7228226073657276657255726C6020616E6420607365727665725061747465726E602068617665206265656E2072656E616D656420746F2060636F6D70616E696F6E55726C6020616E64';
wwv_flow_imp.g_varchar2_table(1372) := '2060636F6D70616E696F6E416C6C6F776564486F7374736020726573706563746976656C7920696E2074686520302E33302E352072656C656173652E20506C6561736520636F6E73756C742074686520646F63732028666F72206578616D706C652C2068';
wwv_flow_imp.g_varchar2_table(1373) := '747470733A2F2F757070792E696F2F646F63732F696E7374616772616D2F20666F722074686520496E7374616772616D20706C7567696E2920616E6420757365207468652075706461746564206F7074696F6E732E6022293B696628742E636F6D70616E';
wwv_flow_imp.g_varchar2_table(1374) := '696F6E416C6C6F776564486F737473297B6C657420733D742E636F6D70616E696F6E416C6C6F776564486F7374733B696628747970656F662073213D22737472696E672226262141727261792E69734172726179287329262621287320696E7374616E63';
wwv_flow_imp.g_varchar2_table(1375) := '656F662052656745787029297468726F77206E657720547970654572726F722860247B652E69647D3A20746865206F7074696F6E2022636F6D70616E696F6E416C6C6F776564486F73747322206D757374206265206F6E65206F6620737472696E672C20';
wwv_flow_imp.g_varchar2_table(1376) := '41727261792C2052656745787060293B652E6F7074732E636F6D70616E696F6E416C6C6F776564486F7374733D737D656C73652F5E283F2168747470733F3A5C2F5C2F292E2A242F692E7465737428742E636F6D70616E696F6E55726C293F652E6F7074';
wwv_flow_imp.g_varchar2_table(1377) := '732E636F6D70616E696F6E416C6C6F776564486F7374733D6068747470733A2F2F247B742E636F6D70616E696F6E55726C2E7265706C616365282F5E5C2F5C2F2F2C2222297D603A652E6F7074732E636F6D70616E696F6E416C6C6F776564486F737473';
wwv_flow_imp.g_varchar2_table(1378) := '3D6E65772055524C28742E636F6D70616E696F6E55726C292E6F726967696E3B652E73746F726167653D652E6F7074732E73746F726167657C7C4C687D7D3B6E2862652C2250726F766964657222293B6173796E632066756E6374696F6E206A7728297B';
wwv_flow_imp.g_varchar2_table(1379) := '72657475726E20746869732E757070792E676574506C7567696E28746869732E706C7567696E4964292E73746F726167652E6765744974656D28746869732E746F6B656E4B6579297D6E286A772C225F67657441757468546F6B656E3222293B76617220';
wwv_flow_imp.g_varchar2_table(1380) := '48773D6E28693D3E692E73706C697428222D22292E6D617028653D3E652E6368617241742830292E746F55707065724361736528292B652E736C696365283129292E6A6F696E28222022292C226765744E616D6522292C58723D636C6173732065787465';
wwv_flow_imp.g_varchar2_table(1381) := '6E64732068747B636F6E7374727563746F7228652C74297B737570657228652C74292C746869732E70726F76696465723D742E70726F76696465722C746869732E69643D746869732E70726F76696465722C746869732E6E616D653D746869732E6F7074';
wwv_flow_imp.g_varchar2_table(1382) := '732E6E616D657C7C487728746869732E6964292C746869732E706C7567696E49643D746869732E6F7074732E706C7567696E49647D66696C6555726C2865297B72657475726E60247B746869732E686F73746E616D657D2F7365617263682F247B746869';
wwv_flow_imp.g_varchar2_table(1383) := '732E69647D2F6765742F247B657D607D73656172636828652C74297B72657475726E20746869732E67657428607365617263682F247B746869732E69647D2F6C6973743F713D247B656E636F6465555249436F6D706F6E656E742865297D247B743F6026';
wwv_flow_imp.g_varchar2_table(1384) := '247B747D603A22227D60297D7D3B6E2858722C2253656172636850726F766964657222293B766172204D6D3D646528766828292C31293B76617220446D2C496D3B66756E6374696F6E204D6528692C65297B696628214F626A6563742E70726F746F7479';
wwv_flow_imp.g_varchar2_table(1385) := '70652E6861734F776E50726F70657274792E63616C6C28692C6529297468726F77206E657720547970654572726F722822617474656D7074656420746F207573652070726976617465206669656C64206F6E206E6F6E2D696E7374616E636522293B7265';
wwv_flow_imp.g_varchar2_table(1386) := '7475726E20697D6E284D652C225F636C617373507269766174654669656C644C6F6F73654261736522293B7661722024773D303B66756E6374696F6E20446E2869297B72657475726E225F5F707269766174655F222B24772B2B2B225F222B697D6E2844';
wwv_flow_imp.g_varchar2_table(1387) := '6E2C225F636C617373507269766174654669656C644C6F6F73654B657922293B7661722053723D446E282271756575656422292C46733D446E2822656D697474657222292C78693D446E282269734F70656E22292C74743D446E2822736F636B65742229';
wwv_flow_imp.g_varchar2_table(1388) := '2C42683D446E282268616E646C654D65737361676522293B446D3D53796D626F6C2E666F7228227570707920746573743A20676574536F636B657422293B496D3D53796D626F6C2E666F7228227570707920746573743A2067657451756575656422293B';
wwv_flow_imp.g_varchar2_table(1389) := '766172204F6F3D636C6173737B636F6E7374727563746F722865297B4F626A6563742E646566696E6550726F706572747928746869732C53722C7B7772697461626C653A21302C76616C75653A5B5D7D292C4F626A6563742E646566696E6550726F7065';
wwv_flow_imp.g_varchar2_table(1390) := '72747928746869732C46732C7B7772697461626C653A21302C76616C75653A28302C4D6D2E64656661756C742928297D292C4F626A6563742E646566696E6550726F706572747928746869732C78692C7B7772697461626C653A21302C76616C75653A21';
wwv_flow_imp.g_varchar2_table(1391) := '317D292C4F626A6563742E646566696E6550726F706572747928746869732C74742C7B7772697461626C653A21302C76616C75653A766F696420307D292C4F626A6563742E646566696E6550726F706572747928746869732C42682C7B7772697461626C';
wwv_flow_imp.g_varchar2_table(1392) := '653A21302C76616C75653A743D3E7B7472797B6C657420723D4A534F4E2E706172736528742E64617461293B746869732E656D697428722E616374696F6E2C722E7061796C6F6164297D63617463682872297B636F6E736F6C652E6C6F672872297D7D7D';
wwv_flow_imp.g_varchar2_table(1393) := '292C746869732E6F7074733D652C2821657C7C652E6175746F4F70656E213D3D2131292626746869732E6F70656E28297D6765742069734F70656E28297B72657475726E204D6528746869732C7869295B78695D7D5B446D5D28297B72657475726E204D';
wwv_flow_imp.g_varchar2_table(1394) := '6528746869732C7474295B74745D7D5B496D5D28297B72657475726E204D6528746869732C5372295B53725D7D6F70656E28297B4D6528746869732C7474295B74745D3D3D6E756C6C2626284D6528746869732C7474295B74745D3D6E65772057656253';
wwv_flow_imp.g_varchar2_table(1395) := '6F636B657428746869732E6F7074732E746172676574292C4D6528746869732C7474295B74745D2E6F6E6F70656E3D28293D3E7B666F72284D6528746869732C7869295B78695D3D21303B4D6528746869732C5372295B53725D2E6C656E6774683E3026';
wwv_flow_imp.g_varchar2_table(1396) := '264D6528746869732C7869295B78695D3B297B6C657420653D4D6528746869732C5372295B53725D2E736869667428293B746869732E73656E6428652E616374696F6E2C652E7061796C6F6164297D7D2C4D6528746869732C7474295B74745D2E6F6E63';
wwv_flow_imp.g_varchar2_table(1397) := '6C6F73653D28293D3E7B4D6528746869732C7869295B78695D3D21312C4D6528746869732C7474295B74745D3D6E756C6C7D2C4D6528746869732C7474295B74745D2E6F6E6D6573736167653D4D6528746869732C4268295B42685D297D636C6F736528';
wwv_flow_imp.g_varchar2_table(1398) := '297B76617220653B28653D4D6528746869732C7474295B74745D293D3D6E756C6C7C7C652E636C6F736528297D73656E6428652C74297B696628214D6528746869732C7869295B78695D297B4D6528746869732C5372295B53725D2E70757368287B6163';
wwv_flow_imp.g_varchar2_table(1399) := '74696F6E3A652C7061796C6F61643A747D293B72657475726E7D4D6528746869732C7474295B74745D2E73656E64284A534F4E2E737472696E67696679287B616374696F6E3A652C7061796C6F61643A747D29297D6F6E28652C74297B4D652874686973';
wwv_flow_imp.g_varchar2_table(1400) := '2C4673295B46735D2E6F6E28652C74297D656D697428652C74297B4D6528746869732C4673295B46735D2E656D697428652C74297D6F6E636528652C74297B4D6528746869732C4673295B46735D2E6F6E636528652C74297D7D3B6E284F6F2C22557070';
wwv_flow_imp.g_varchar2_table(1401) := '79536F636B657422293B7661722069643D7B7D3B4F6C2869642C7B50726F766964657256696577733A28293D3E4E652C53656172636850726F766964657256696577733A28293D3E6A692C64656661756C745069636B657249636F6E3A28293D3E6B6F7D';
wwv_flow_imp.g_varchar2_table(1402) := '293B7661722048683D6465284C6D28292C31293B76617220546F3D636C61737320657874656E6473204572726F727B636F6E7374727563746F722865297B73757065722865292C746869732E6E616D653D2254696D656F75744572726F72227D7D3B6E28';
wwv_flow_imp.g_varchar2_table(1403) := '546F2C2254696D656F75744572726F7222293B76617220516C3D636C61737320657874656E6473204572726F727B636F6E7374727563746F722865297B737570657228292C746869732E6E616D653D2241626F72744572726F72222C746869732E6D6573';
wwv_flow_imp.g_varchar2_table(1404) := '736167653D657D7D3B6E28516C2C2241626F72744572726F7222293B76617220426D3D6E28693D3E676C6F62616C546869732E444F4D457863657074696F6E3D3D3D766F696420303F6E657720516C2869293A6E657720444F4D457863657074696F6E28';
wwv_flow_imp.g_varchar2_table(1405) := '69292C22676574444F4D457863657074696F6E22292C7A6D3D6E28693D3E7B6C657420653D692E726561736F6E3D3D3D766F696420303F426D282254686973206F7065726174696F6E207761732061626F727465642E22293A692E726561736F6E3B7265';
wwv_flow_imp.g_varchar2_table(1406) := '7475726E206520696E7374616E63656F66204572726F723F653A426D2865297D2C2267657441626F72746564526561736F6E22293B66756E6374696F6E20246828692C652C742C72297B6C657420732C6F3D6E65772050726F6D6973652828612C6C293D';
wwv_flow_imp.g_varchar2_table(1407) := '3E7B696628747970656F662065213D226E756D626572227C7C4D6174682E7369676E286529213D3D31297468726F77206E657720547970654572726F7228604578706563746564205C606D696C6C697365636F6E64735C6020746F206265206120706F73';
wwv_flow_imp.g_varchar2_table(1408) := '6974697665206E756D6265722C20676F74205C60247B657D5C6060293B696628653D3D3D4E756D6265722E504F5349544956455F494E46494E495459297B612869293B72657475726E7D696628723D7B637573746F6D54696D6572733A7B73657454696D';
wwv_flow_imp.g_varchar2_table(1409) := '656F75742C636C65617254696D656F75747D2C2E2E2E727D2C722E7369676E616C297B6C65747B7369676E616C3A687D3D723B682E61626F7274656426266C287A6D286829292C682E6164644576656E744C697374656E6572282261626F7274222C2829';
wwv_flow_imp.g_varchar2_table(1410) := '3D3E7B6C287A6D286829297D297D733D722E637573746F6D54696D6572732E73657454696D656F75742E63616C6C28766F696420302C28293D3E7B696628747970656F6620743D3D2266756E6374696F6E22297B7472797B6128742829297D6361746368';
wwv_flow_imp.g_varchar2_table(1411) := '2864297B6C2864297D72657475726E7D6C657420683D747970656F6620743D3D22737472696E67223F743A6050726F6D6973652074696D6564206F757420616674657220247B657D206D696C6C697365636F6E6473602C633D7420696E7374616E63656F';
wwv_flow_imp.g_varchar2_table(1412) := '66204572726F723F743A6E657720546F2868293B747970656F6620692E63616E63656C3D3D2266756E6374696F6E222626692E63616E63656C28292C6C2863297D2C65292C286173796E6328293D3E7B7472797B612861776169742069297D6361746368';
wwv_flow_imp.g_varchar2_table(1413) := '2868297B6C2868297D66696E616C6C797B722E637573746F6D54696D6572732E636C65617254696D656F75742E63616C6C28766F696420302C73297D7D2928297D293B72657475726E206F2E636C6561723D28293D3E7B636C65617254696D656F757428';
wwv_flow_imp.g_varchar2_table(1414) := '73292C733D766F696420307D2C6F7D6E2824682C227054696D656F757422293B66756E6374696F6E20716828692C652C74297B6C657420723D302C733D692E6C656E6774683B666F72283B733E303B297B6C6574206F3D4D6174682E7472756E6328732F';
wwv_flow_imp.g_varchar2_table(1415) := '32292C613D722B6F3B7428695B615D2C65293C3D303F28723D2B2B612C732D3D6F2B31293A733D6F7D72657475726E20727D6E2871682C226C6F776572426F756E6422293B7661722078733D66756E6374696F6E28692C652C742C72297B696628743D3D';
wwv_flow_imp.g_varchar2_table(1416) := '3D22612226262172297468726F77206E657720547970654572726F72282250726976617465206163636573736F722077617320646566696E656420776974686F757420612067657474657222293B696628747970656F6620653D3D2266756E6374696F6E';
wwv_flow_imp.g_varchar2_table(1417) := '223F69213D3D657C7C21723A21652E686173286929297468726F77206E657720547970654572726F72282243616E6E6F7420726561642070726976617465206D656D6265722066726F6D20616E206F626A6563742077686F736520636C61737320646964';
wwv_flow_imp.g_varchar2_table(1418) := '206E6F74206465636C61726520697422293B72657475726E20743D3D3D226D223F723A743D3D3D2261223F722E63616C6C2869293A723F722E76616C75653A652E6765742869297D2C50722C4A6C3D636C6173737B636F6E7374727563746F7228297B50';
wwv_flow_imp.g_varchar2_table(1419) := '722E73657428746869732C5B5D297D656E717565756528652C74297B743D7B7072696F726974793A302C2E2E2E747D3B6C657420723D7B7072696F726974793A742E7072696F726974792C72756E3A657D3B696628746869732E73697A65262678732874';
wwv_flow_imp.g_varchar2_table(1420) := '6869732C50722C226622295B746869732E73697A652D315D2E7072696F726974793E3D742E7072696F72697479297B787328746869732C50722C226622292E707573682872293B72657475726E7D6C657420733D716828787328746869732C50722C2266';
wwv_flow_imp.g_varchar2_table(1421) := '22292C722C286F2C61293D3E612E7072696F726974792D6F2E7072696F72697479293B787328746869732C50722C226622292E73706C69636528732C302C72297D6465717565756528297B6C657420653D787328746869732C50722C226622292E736869';
wwv_flow_imp.g_varchar2_table(1422) := '667428293B72657475726E20653F2E72756E7D66696C7465722865297B72657475726E20787328746869732C50722C226622292E66696C74657228743D3E742E7072696F726974793D3D3D652E7072696F72697479292E6D617028743D3E742E72756E29';
wwv_flow_imp.g_varchar2_table(1423) := '7D6765742073697A6528297B72657475726E20787328746869732C50722C226622292E6C656E6774687D7D3B6E284A6C2C225072696F72697479517565756522293B50723D6E6577205765616B4D61703B766172206A6D3D4A6C3B7661722052653D6675';
wwv_flow_imp.g_varchar2_table(1424) := '6E6374696F6E28692C652C742C722C73297B696628723D3D3D226D22297468726F77206E657720547970654572726F72282250726976617465206D6574686F64206973206E6F74207772697461626C6522293B696628723D3D3D22612226262173297468';
wwv_flow_imp.g_varchar2_table(1425) := '726F77206E657720547970654572726F72282250726976617465206163636573736F722077617320646566696E656420776974686F757420612073657474657222293B696628747970656F6620653D3D2266756E6374696F6E223F69213D3D657C7C2173';
wwv_flow_imp.g_varchar2_table(1426) := '3A21652E686173286929297468726F77206E657720547970654572726F72282243616E6E6F742077726974652070726976617465206D656D62657220746F20616E206F626A6563742077686F736520636C61737320646964206E6F74206465636C617265';
wwv_flow_imp.g_varchar2_table(1427) := '20697422293B72657475726E20723D3D3D2261223F732E63616C6C28692C74293A733F732E76616C75653D743A652E73657428692C74292C747D2C573D66756E6374696F6E28692C652C742C72297B696628743D3D3D22612226262172297468726F7720';
wwv_flow_imp.g_varchar2_table(1428) := '6E657720547970654572726F72282250726976617465206163636573736F722077617320646566696E656420776974686F757420612067657474657222293B696628747970656F6620653D3D2266756E6374696F6E223F69213D3D657C7C21723A21652E';
wwv_flow_imp.g_varchar2_table(1429) := '686173286929297468726F77206E657720547970654572726F72282243616E6E6F7420726561642070726976617465206D656D6265722066726F6D20616E206F626A6563742077686F736520636C61737320646964206E6F74206465636C617265206974';
wwv_flow_imp.g_varchar2_table(1430) := '22293B72657475726E20743D3D3D226D223F723A743D3D3D2261223F722E63616C6C2869293A723F722E76616C75653A652E6765742869297D2C24652C4E6E2C4C6E2C51722C6F752C426E2C5A6C2C45692C4D6E2C51742C65752C4A742C7A6E2C59722C';
wwv_flow_imp.g_varchar2_table(1431) := '74752C486D2C246D2C576D2C716D2C566D2C69752C56682C57682C6E752C476D2C72752C6A6E3D636C61737320657874656E6473204572726F727B7D3B6E286A6E2C2241626F72744572726F7222293B7661722073753D636C61737320657874656E6473';
wwv_flow_imp.g_varchar2_table(1432) := '2048682E64656661756C747B636F6E7374727563746F722865297B76617220742C722C732C6F3B696628737570657228292C24652E6164642874686973292C4E6E2E73657428746869732C766F69642030292C4C6E2E73657428746869732C766F696420';
wwv_flow_imp.g_varchar2_table(1433) := '30292C51722E73657428746869732C30292C6F752E73657428746869732C766F69642030292C426E2E73657428746869732C766F69642030292C5A6C2E73657428746869732C30292C45692E73657428746869732C766F69642030292C4D6E2E73657428';
wwv_flow_imp.g_varchar2_table(1434) := '746869732C766F69642030292C51742E73657428746869732C766F69642030292C65752E73657428746869732C766F69642030292C4A742E73657428746869732C30292C7A6E2E73657428746869732C766F69642030292C59722E73657428746869732C';
wwv_flow_imp.g_varchar2_table(1435) := '766F69642030292C74752E73657428746869732C766F69642030292C4F626A6563742E646566696E6550726F706572747928746869732C2274696D656F7574222C7B656E756D657261626C653A21302C636F6E666967757261626C653A21302C77726974';
wwv_flow_imp.g_varchar2_table(1436) := '61626C653A21302C76616C75653A766F696420307D292C653D7B63617272796F766572436F6E63757272656E6379436F756E743A21312C696E74657276616C4361703A4E756D6265722E504F5349544956455F494E46494E4954592C696E74657276616C';
wwv_flow_imp.g_varchar2_table(1437) := '3A302C636F6E63757272656E63793A4E756D6265722E504F5349544956455F494E46494E4954592C6175746F53746172743A21302C7175657565436C6173733A6A6D2C2E2E2E657D2C2128747970656F6620652E696E74657276616C4361703D3D226E75';
wwv_flow_imp.g_varchar2_table(1438) := '6D626572222626652E696E74657276616C4361703E3D3129297468726F77206E657720547970654572726F7228604578706563746564205C60696E74657276616C4361705C6020746F2062652061206E756D6265722066726F6D203120616E642075702C';
wwv_flow_imp.g_varchar2_table(1439) := '20676F74205C60247B28723D28743D652E696E74657276616C436170293D3D3D6E756C6C7C7C743D3D3D766F696420303F766F696420303A742E746F537472696E67282929213D3D6E756C6C262672213D3D766F696420303F723A22227D5C602028247B';
wwv_flow_imp.g_varchar2_table(1440) := '747970656F6620652E696E74657276616C4361707D2960293B696628652E696E74657276616C3D3D3D766F696420307C7C21284E756D6265722E697346696E69746528652E696E74657276616C292626652E696E74657276616C3E3D3029297468726F77';
wwv_flow_imp.g_varchar2_table(1441) := '206E657720547970654572726F7228604578706563746564205C60696E74657276616C5C6020746F20626520612066696E697465206E756D626572203E3D20302C20676F74205C60247B286F3D28733D652E696E74657276616C293D3D3D6E756C6C7C7C';
wwv_flow_imp.g_varchar2_table(1442) := '733D3D3D766F696420303F766F696420303A732E746F537472696E67282929213D3D6E756C6C26266F213D3D766F696420303F6F3A22227D5C602028247B747970656F6620652E696E74657276616C7D2960293B526528746869732C4E6E2C652E636172';
wwv_flow_imp.g_varchar2_table(1443) := '72796F766572436F6E63757272656E6379436F756E742C226622292C526528746869732C4C6E2C652E696E74657276616C4361703D3D3D4E756D6265722E504F5349544956455F494E46494E4954597C7C652E696E74657276616C3D3D3D302C22662229';
wwv_flow_imp.g_varchar2_table(1444) := '2C526528746869732C6F752C652E696E74657276616C4361702C226622292C526528746869732C426E2C652E696E74657276616C2C226622292C526528746869732C51742C6E657720652E7175657565436C6173732C226622292C526528746869732C65';
wwv_flow_imp.g_varchar2_table(1445) := '752C652E7175657565436C6173732C226622292C746869732E636F6E63757272656E63793D652E636F6E63757272656E63792C746869732E74696D656F75743D652E74696D656F75742C526528746869732C74752C652E7468726F774F6E54696D656F75';
wwv_flow_imp.g_varchar2_table(1446) := '743D3D3D21302C226622292C526528746869732C59722C652E6175746F53746172743D3D3D21312C226622297D67657420636F6E63757272656E637928297B72657475726E205728746869732C7A6E2C226622297D73657420636F6E63757272656E6379';
wwv_flow_imp.g_varchar2_table(1447) := '2865297B6966282128747970656F6620653D3D226E756D626572222626653E3D3129297468726F77206E657720547970654572726F7228604578706563746564205C60636F6E63757272656E63795C6020746F2062652061206E756D6265722066726F6D';
wwv_flow_imp.g_varchar2_table(1448) := '203120616E642075702C20676F74205C60247B657D5C602028247B747970656F6620657D2960293B526528746869732C7A6E2C652C226622292C5728746869732C24652C226D222C6E75292E63616C6C2874686973297D6173796E632061646428652C74';
wwv_flow_imp.g_varchar2_table(1449) := '3D7B7D297B72657475726E20743D7B74696D656F75743A746869732E74696D656F75742C7468726F774F6E54696D656F75743A5728746869732C74752C226622292C2E2E2E747D2C6E65772050726F6D6973652828722C73293D3E7B5728746869732C51';
wwv_flow_imp.g_varchar2_table(1450) := '742C226622292E656E7175657565286173796E6328293D3E7B766172206F2C612C6C3B526528746869732C4A742C28613D5728746869732C4A742C226622292C612B2B2C61292C226622292C526528746869732C51722C286C3D5728746869732C51722C';
wwv_flow_imp.g_varchar2_table(1451) := '226622292C6C2B2B2C6C292C226622293B7472797B6966282128286F3D742E7369676E616C293D3D3D6E756C6C7C7C6F3D3D3D766F696420302926266F2E61626F72746564297468726F77206E6577206A6E2822546865207461736B207761732061626F';
wwv_flow_imp.g_varchar2_table(1452) := '727465642E22293B6C657420683D65287B7369676E616C3A742E7369676E616C7D293B742E74696D656F7574262628683D24682850726F6D6973652E7265736F6C76652868292C742E74696D656F757429292C742E7369676E616C262628683D50726F6D';
wwv_flow_imp.g_varchar2_table(1453) := '6973652E72616365285B682C5728746869732C24652C226D222C476D292E63616C6C28746869732C742E7369676E616C295D29293B6C657420633D617761697420683B722863292C746869732E656D69742822636F6D706C65746564222C63297D636174';
wwv_flow_imp.g_varchar2_table(1454) := '63682868297B6966286820696E7374616E63656F6620546F262621742E7468726F774F6E54696D656F7574297B7228293B72657475726E7D732868292C746869732E656D697428226572726F72222C68297D66696E616C6C797B5728746869732C24652C';
wwv_flow_imp.g_varchar2_table(1455) := '226D222C576D292E63616C6C2874686973297D7D2C74292C746869732E656D6974282261646422292C5728746869732C24652C226D222C6975292E63616C6C2874686973297D297D6173796E6320616464416C6C28652C74297B72657475726E2050726F';
wwv_flow_imp.g_varchar2_table(1456) := '6D6973652E616C6C28652E6D6170286173796E6320723D3E746869732E61646428722C742929297D737461727428297B72657475726E205728746869732C59722C226622293F28526528746869732C59722C21312C226622292C5728746869732C24652C';
wwv_flow_imp.g_varchar2_table(1457) := '226D222C6E75292E63616C6C2874686973292C74686973293A746869737D706175736528297B526528746869732C59722C21302C226622297D636C65617228297B526528746869732C51742C6E6577285728746869732C65752C22662229292C22662229';
wwv_flow_imp.g_varchar2_table(1458) := '7D6173796E63206F6E456D70747928297B5728746869732C51742C226622292E73697A65213D3D3026266177616974205728746869732C24652C226D222C7275292E63616C6C28746869732C22656D70747922297D6173796E63206F6E53697A654C6573';
wwv_flow_imp.g_varchar2_table(1459) := '735468616E2865297B5728746869732C51742C226622292E73697A653C657C7C6177616974205728746869732C24652C226D222C7275292E63616C6C28746869732C226E657874222C28293D3E5728746869732C51742C226622292E73697A653C65297D';
wwv_flow_imp.g_varchar2_table(1460) := '6173796E63206F6E49646C6528297B5728746869732C4A742C226622293D3D3D3026265728746869732C51742C226622292E73697A653D3D3D307C7C6177616974205728746869732C24652C226D222C7275292E63616C6C28746869732C2269646C6522';
wwv_flow_imp.g_varchar2_table(1461) := '297D6765742073697A6528297B72657475726E205728746869732C51742C226622292E73697A657D73697A6542792865297B72657475726E205728746869732C51742C226622292E66696C7465722865292E6C656E6774687D6765742070656E64696E67';
wwv_flow_imp.g_varchar2_table(1462) := '28297B72657475726E205728746869732C4A742C226622297D67657420697350617573656428297B72657475726E205728746869732C59722C226622297D7D3B6E2873752C2250517565756522293B4E6E3D6E6577205765616B4D61702C4C6E3D6E6577';
wwv_flow_imp.g_varchar2_table(1463) := '205765616B4D61702C51723D6E6577205765616B4D61702C6F753D6E6577205765616B4D61702C426E3D6E6577205765616B4D61702C5A6C3D6E6577205765616B4D61702C45693D6E6577205765616B4D61702C4D6E3D6E6577205765616B4D61702C51';
wwv_flow_imp.g_varchar2_table(1464) := '743D6E6577205765616B4D61702C65753D6E6577205765616B4D61702C4A743D6E6577205765616B4D61702C7A6E3D6E6577205765616B4D61702C59723D6E6577205765616B4D61702C74753D6E6577205765616B4D61702C24653D6E6577205765616B';
wwv_flow_imp.g_varchar2_table(1465) := '5365742C486D3D6E2866756E6374696F6E28297B72657475726E205728746869732C4C6E2C226622297C7C5728746869732C51722C226622293C5728746869732C6F752C226622297D2C225F5051756575655F646F6573496E74657276616C416C6C6F77';
wwv_flow_imp.g_varchar2_table(1466) := '416E6F746865725F67657422292C246D3D6E2866756E6374696F6E28297B72657475726E205728746869732C4A742C226622293C5728746869732C7A6E2C226622297D2C225F5051756575655F646F6573436F6E63757272656E74416C6C6F77416E6F74';
wwv_flow_imp.g_varchar2_table(1467) := '6865725F67657422292C576D3D6E2866756E6374696F6E28297B76617220653B526528746869732C4A742C28653D5728746869732C4A742C226622292C652D2D2C65292C226622292C5728746869732C24652C226D222C6975292E63616C6C2874686973';
wwv_flow_imp.g_varchar2_table(1468) := '292C746869732E656D697428226E65787422297D2C225F5051756575655F6E65787422292C716D3D6E2866756E6374696F6E28297B5728746869732C24652C226D222C5768292E63616C6C2874686973292C5728746869732C24652C226D222C5668292E';
wwv_flow_imp.g_varchar2_table(1469) := '63616C6C2874686973292C526528746869732C4D6E2C766F696420302C226622297D2C225F5051756575655F6F6E526573756D65496E74657276616C22292C566D3D6E2866756E6374696F6E28297B6C657420653D446174652E6E6F7728293B69662857';
wwv_flow_imp.g_varchar2_table(1470) := '28746869732C45692C226622293D3D3D766F69642030297B6C657420743D5728746869732C5A6C2C226622292D653B696628743C3029526528746869732C51722C5728746869732C4E6E2C226622293F5728746869732C4A742C226622293A302C226622';
wwv_flow_imp.g_varchar2_table(1471) := '293B656C73652072657475726E205728746869732C4D6E2C226622293D3D3D766F696420302626526528746869732C4D6E2C73657454696D656F75742828293D3E7B5728746869732C24652C226D222C716D292E63616C6C2874686973297D2C74292C22';
wwv_flow_imp.g_varchar2_table(1472) := '6622292C21307D72657475726E21317D2C225F5051756575655F6973496E74657276616C5061757365645F67657422292C69753D6E2866756E6374696F6E28297B6966285728746869732C51742C226622292E73697A653D3D3D302972657475726E2057';
wwv_flow_imp.g_varchar2_table(1473) := '28746869732C45692C226622292626636C656172496E74657276616C285728746869732C45692C22662229292C526528746869732C45692C766F696420302C226622292C746869732E656D69742822656D70747922292C5728746869732C4A742C226622';
wwv_flow_imp.g_varchar2_table(1474) := '293D3D3D302626746869732E656D6974282269646C6522292C21313B696628215728746869732C59722C22662229297B6C657420653D215728746869732C24652C2261222C566D293B6966285728746869732C24652C2261222C486D2926265728746869';
wwv_flow_imp.g_varchar2_table(1475) := '732C24652C2261222C246D29297B6C657420743D5728746869732C51742C226622292E6465717565756528293B72657475726E20743F28746869732E656D6974282261637469766522292C7428292C6526265728746869732C24652C226D222C5668292E';
wwv_flow_imp.g_varchar2_table(1476) := '63616C6C2874686973292C2130293A21317D7D72657475726E21317D2C225F5051756575655F747279546F5374617274416E6F7468657222292C56683D6E2866756E6374696F6E28297B5728746869732C4C6E2C226622297C7C5728746869732C45692C';
wwv_flow_imp.g_varchar2_table(1477) := '22662229213D3D766F696420307C7C28526528746869732C45692C736574496E74657276616C2828293D3E7B5728746869732C24652C226D222C5768292E63616C6C2874686973297D2C5728746869732C426E2C22662229292C226622292C5265287468';
wwv_flow_imp.g_varchar2_table(1478) := '69732C5A6C2C446174652E6E6F7728292B5728746869732C426E2C226622292C22662229297D2C225F5051756575655F696E697469616C697A65496E74657276616C49664E656564656422292C57683D6E2866756E6374696F6E28297B5728746869732C';
wwv_flow_imp.g_varchar2_table(1479) := '51722C226622293D3D3D3026265728746869732C4A742C226622293D3D3D3026265728746869732C45692C22662229262628636C656172496E74657276616C285728746869732C45692C22662229292C526528746869732C45692C766F696420302C2266';
wwv_flow_imp.g_varchar2_table(1480) := '2229292C526528746869732C51722C5728746869732C4E6E2C226622293F5728746869732C4A742C226622293A302C226622292C5728746869732C24652C226D222C6E75292E63616C6C2874686973297D2C225F5051756575655F6F6E496E7465727661';
wwv_flow_imp.g_varchar2_table(1481) := '6C22292C6E753D6E2866756E6374696F6E28297B666F72283B5728746869732C24652C226D222C6975292E63616C6C2874686973293B293B7D2C225F5051756575655F70726F63657373517565756522292C476D3D6E286173796E632066756E6374696F';
wwv_flow_imp.g_varchar2_table(1482) := '6E2865297B72657475726E206E65772050726F6D6973652828742C72293D3E7B652E6164644576656E744C697374656E6572282261626F7274222C28293D3E7B72286E6577206A6E2822546865207461736B207761732061626F727465642E2229297D2C';
wwv_flow_imp.g_varchar2_table(1483) := '7B6F6E63653A21307D297D297D2C225F5051756575655F7468726F774F6E41626F727422292C72753D6E286173796E632066756E6374696F6E28652C74297B72657475726E206E65772050726F6D69736528723D3E7B6C657420733D6E2828293D3E7B74';
wwv_flow_imp.g_varchar2_table(1484) := '2626217428297C7C28746869732E6F666628652C73292C722829297D2C226C697374656E657222293B746869732E6F6E28652C73297D297D2C225F5051756575655F6F6E4576656E7422293B766172204B6D3D73753B7661722075752C52742C47682C58';
wwv_flow_imp.g_varchar2_table(1485) := '6D2C486E3D302C69673D5B5D2C61753D5B5D2C596D3D65652E5F5F622C516D3D65652E5F5F722C4A6D3D65652E6469666665642C5A6D3D65652E5F5F632C65673D65652E756E6D6F756E743B66756E6374696F6E20586828692C65297B65652E5F5F6826';
wwv_flow_imp.g_varchar2_table(1486) := '2665652E5F5F682852742C692C486E7C7C65292C486E3D303B76617220743D52742E5F5F487C7C2852742E5F5F483D7B5F5F3A5B5D2C5F5F683A5B5D7D293B72657475726E20693E3D742E5F5F2E6C656E6774682626742E5F5F2E70757368287B5F5F56';
wwv_flow_imp.g_varchar2_table(1487) := '3A61757D292C742E5F5F5B695D7D6E2858682C227022293B66756E6374696F6E20416F2869297B72657475726E20486E3D312C57772873672C69297D6E28416F2C227922293B66756E6374696F6E20577728692C652C74297B76617220723D5868287575';
wwv_flow_imp.g_varchar2_table(1488) := '2B2B2C32293B72657475726E20722E743D692C722E5F5F637C7C28722E5F5F3D5B743F742865293A736728766F696420302C65292C66756E6374696F6E2873297B766172206F3D722E7428722E5F5F5B305D2C73293B722E5F5F5B305D213D3D6F262628';
wwv_flow_imp.g_varchar2_table(1489) := '722E5F5F3D5B6F2C722E5F5F5B315D5D2C722E5F5F632E7365745374617465287B7D29297D5D2C722E5F5F633D5274292C722E5F5F7D6E2857772C226422293B66756E6374696F6E20457328692C65297B76617220743D58682875752B2B2C33293B2165';
wwv_flow_imp.g_varchar2_table(1490) := '652E5F5F732626726728742E5F5F482C6529262628742E5F5F3D692C742E753D652C52742E5F5F482E5F5F682E70757368287429297D6E2845732C225F22293B66756E6374696F6E2059682869297B72657475726E20486E3D352C526F2866756E637469';
wwv_flow_imp.g_varchar2_table(1491) := '6F6E28297B72657475726E7B63757272656E743A697D7D2C5B5D297D6E2859682C227322293B66756E6374696F6E20526F28692C65297B76617220743D58682875752B2B2C37293B72657475726E20726728742E5F5F482C65293F28742E5F5F563D6928';
wwv_flow_imp.g_varchar2_table(1492) := '292C742E753D652C742E5F5F683D692C742E5F5F56293A742E5F5F7D6E28526F2C224622293B66756E6374696F6E20437328692C65297B72657475726E20486E3D382C526F2866756E6374696F6E28297B72657475726E20697D2C65297D6E2843732C22';
wwv_flow_imp.g_varchar2_table(1493) := '5422293B66756E6374696F6E20477728297B666F722876617220693B693D69672E736869667428293B29696628692E5F5F50297472797B692E5F5F482E5F5F682E666F7245616368286C75292C692E5F5F482E5F5F682E666F7245616368284B68292C69';
wwv_flow_imp.g_varchar2_table(1494) := '2E5F5F482E5F5F683D5B5D7D63617463682865297B692E5F5F482E5F5F683D5B5D2C65652E5F5F6528652C692E5F5F76297D7D6E2847772C226222293B65652E5F5F623D66756E6374696F6E2869297B52743D6E756C6C2C596D2626596D2869297D2C65';
wwv_flow_imp.g_varchar2_table(1495) := '652E5F5F723D66756E6374696F6E2869297B516D2626516D2869292C75753D303B76617220653D2852743D692E5F5F63292E5F5F483B6526262847683D3D3D52743F28652E5F5F683D5B5D2C52742E5F5F683D5B5D2C652E5F5F2E666F72456163682866';
wwv_flow_imp.g_varchar2_table(1496) := '756E6374696F6E2874297B742E5F5F563D61752C742E753D766F696420307D29293A28652E5F5F682E666F7245616368286C75292C652E5F5F682E666F7245616368284B68292C652E5F5F683D5B5D29292C47683D52747D2C65652E6469666665643D66';
wwv_flow_imp.g_varchar2_table(1497) := '756E6374696F6E2869297B4A6D26264A6D2869293B76617220653D692E5F5F633B652626652E5F5F48262628652E5F5F482E5F5F682E6C656E67746826262869672E70757368286529213D3D312626586D3D3D3D65652E72657175657374416E696D6174';
wwv_flow_imp.g_varchar2_table(1498) := '696F6E4672616D657C7C2828586D3D65652E72657175657374416E696D6174696F6E4672616D65297C7C66756E6374696F6E2874297B76617220722C733D6E2866756E6374696F6E28297B636C65617254696D656F7574286F292C7467262663616E6365';
wwv_flow_imp.g_varchar2_table(1499) := '6C416E696D6174696F6E4672616D652872292C73657454696D656F75742874297D2C227522292C6F3D73657454696D656F757428732C313030293B7467262628723D72657175657374416E696D6174696F6E4672616D65287329297D2928477729292C65';
wwv_flow_imp.g_varchar2_table(1500) := '2E5F5F482E5F5F2E666F72456163682866756E6374696F6E2874297B742E75262628742E5F5F483D742E75292C742E5F5F56213D3D6175262628742E5F5F3D742E5F5F56292C742E753D766F696420302C742E5F5F563D61757D29292C47683D52743D6E';
null;
end;
/
begin
wwv_flow_imp.g_varchar2_table(1501) := '756C6C7D2C65652E5F5F633D66756E6374696F6E28692C65297B652E736F6D652866756E6374696F6E2874297B7472797B742E5F5F682E666F7245616368286C75292C742E5F5F683D742E5F5F682E66696C7465722866756E6374696F6E2872297B7265';
wwv_flow_imp.g_varchar2_table(1502) := '7475726E21722E5F5F7C7C4B682872297D297D63617463682872297B652E736F6D652866756E6374696F6E2873297B732E5F5F68262628732E5F5F683D5B5D297D292C653D5B5D2C65652E5F5F6528722C742E5F5F76297D7D292C5A6D26265A6D28692C';
wwv_flow_imp.g_varchar2_table(1503) := '65297D2C65652E756E6D6F756E743D66756E6374696F6E2869297B6567262665672869293B76617220652C743D692E5F5F633B742626742E5F5F48262628742E5F5F482E5F5F2E666F72456163682866756E6374696F6E2872297B7472797B6C75287229';
wwv_flow_imp.g_varchar2_table(1504) := '7D63617463682873297B653D737D7D292C65262665652E5F5F6528652C742E5F5F7629297D3B7661722074673D747970656F662072657175657374416E696D6174696F6E4672616D653D3D2266756E6374696F6E223B66756E6374696F6E206C75286929';
wwv_flow_imp.g_varchar2_table(1505) := '7B76617220653D52742C743D692E5F5F633B747970656F6620743D3D2266756E6374696F6E22262628692E5F5F633D766F696420302C742829292C52743D657D6E286C752C226A22293B66756E6374696F6E204B682869297B76617220653D52743B692E';
wwv_flow_imp.g_varchar2_table(1506) := '5F5F633D692E5F5F28292C52743D657D6E284B682C226B22293B66756E6374696F6E20726728692C65297B72657475726E21697C7C692E6C656E677468213D3D652E6C656E6774687C7C652E736F6D652866756E6374696F6E28742C72297B7265747572';
wwv_flow_imp.g_varchar2_table(1507) := '6E2074213D3D695B725D7D297D6E2872672C227722293B66756E6374696F6E20736728692C65297B72657475726E20747970656F6620653D3D2266756E6374696F6E223F652869293A657D6E2873672C227A22293B66756E6374696F6E204B7728297B72';
wwv_flow_imp.g_varchar2_table(1508) := '657475726E20752822737667222C7B77696474683A223236222C6865696768743A223236222C76696577426F783A22302030203236203236222C786D6C6E733A22687474703A2F2F7777772E77332E6F72672F323030302F737667227D2C75282267222C';
wwv_flow_imp.g_varchar2_table(1509) := '7B66696C6C3A226E6F6E65222C2266696C6C2D72756C65223A226576656E6F6464227D2C752822636972636C65222C7B66696C6C3A2223464646222C63783A223133222C63793A223133222C723A223133227D292C75282270617468222C7B643A224D32';
wwv_flow_imp.g_varchar2_table(1510) := '312E36342031332E32303563302D2E3633392D2E3035372D312E3235322D2E3136342D312E38343148313376332E34383168342E38343461342E313420342E313420302030312D312E37393620322E37313676322E32353968322E39303863312E373032';
wwv_flow_imp.g_varchar2_table(1511) := '2D312E35363720322E3638342D332E38373520322E3638342D362E3631357A222C66696C6C3A2223343238354634222C2266696C6C2D72756C65223A226E6F6E7A65726F227D292C75282270617468222C7B643A224D313320323263322E343320302034';
wwv_flow_imp.g_varchar2_table(1512) := '2E3436372D2E38303620352E3935362D322E31386C2D322E3930382D322E323539632D2E3830362E35342D312E3833372E38362D332E3034382E38362D322E33343420302D342E3332382D312E3538342D352E3033362D332E37313148342E3935377632';
wwv_flow_imp.g_varchar2_table(1513) := '2E33333241382E39393720382E393937203020303031332032327A222C66696C6C3A2223333441383533222C2266696C6C2D72756C65223A226E6F6E7A65726F227D292C75282270617468222C7B643A224D372E3936342031342E373141352E34312035';
wwv_flow_imp.g_varchar2_table(1514) := '2E34312030203031372E36383220313363302D2E3539332E3130322D312E31372E3238322D312E373156382E39353848342E39353741382E39393620382E393936203020303034203133633020312E3435322E33343820322E3832372E39353720342E30';
wwv_flow_imp.g_varchar2_table(1515) := '34326C332E3030372D322E3333327A222C66696C6C3A2223464242433035222C2266696C6C2D72756C65223A226E6F6E7A65726F227D292C75282270617468222C7B643A224D313320372E353863312E333231203020322E3530382E34353420332E3434';
wwv_flow_imp.g_varchar2_table(1516) := '20312E3334356C322E3538322D322E35384331372E34363320342E3839312031352E3432362034203133203461382E39393720382E39393720302030302D382E30343320342E3935386C332E30303720322E33333243382E36373220392E313633203130';
wwv_flow_imp.g_varchar2_table(1517) := '2E36353620372E353820313320372E35387A222C66696C6C3A2223454134333335222C2266696C6C2D72756C65223A226E6F6E7A65726F227D292C75282270617468222C7B643A224D34203468313876313848347A227D2929297D6E284B772C22476F6F';
wwv_flow_imp.g_varchar2_table(1518) := '676C6549636F6E22293B7661722058773D6E28693D3E7B6C65747B706C7567696E4E616D653A652C6931386E3A742C6F6E417574683A727D3D692C733D653D3D3D22476F6F676C65204472697665222C6F3D437328613D3E7B612E70726576656E744465';
wwv_flow_imp.g_varchar2_table(1519) := '6661756C7428292C7228297D2C5B725D293B72657475726E20752822666F726D222C7B6F6E5375626D69743A6F7D2C733F752822627574746F6E222C7B747970653A227375626D6974222C636C6173734E616D653A22757070792D752D72657365742075';
wwv_flow_imp.g_varchar2_table(1520) := '7070792D632D62746E20757070792D632D62746E2D7072696D61727920757070792D50726F76696465722D6175746842746E20757070792D50726F76696465722D62746E2D676F6F676C65222C22646174612D757070792D73757065722D666F63757361';
wwv_flow_imp.g_varchar2_table(1521) := '626C65223A21307D2C75284B772C6E756C6C292C7428227369676E496E57697468476F6F676C652229293A752822627574746F6E222C7B747970653A227375626D6974222C636C6173734E616D653A22757070792D752D726573657420757070792D632D';
wwv_flow_imp.g_varchar2_table(1522) := '62746E20757070792D632D62746E2D7072696D61727920757070792D50726F76696465722D6175746842746E222C22646174612D757070792D73757065722D666F63757361626C65223A21307D2C74282261757468656E74696361746557697468222C7B';
wwv_flow_imp.g_varchar2_table(1523) := '706C7567696E4E616D653A657D2929297D2C2244656661756C74466F726D22292C59773D6E28693D3E7B6C65747B706C7567696E4E616D653A652C6931386E3A742C6F6E417574683A727D3D693B72657475726E20752858772C7B706C7567696E4E616D';
wwv_flow_imp.g_varchar2_table(1524) := '653A652C6931386E3A742C6F6E417574683A727D297D2C2264656661756C7452656E646572466F726D22293B66756E6374696F6E2051772869297B6C65747B6C6F6164696E673A652C706C7567696E4E616D653A742C706C7567696E49636F6E3A722C69';
wwv_flow_imp.g_varchar2_table(1525) := '31386E3A732C68616E646C65417574683A6F2C72656E646572466F726D3A613D59777D3D692C6C3D7528227370616E222C7B636C6173734E616D653A22757070792D50726F76696465722D617574685469746C654E616D65227D2C742C7528226272222C';
wwv_flow_imp.g_varchar2_table(1526) := '6E756C6C29293B72657475726E20752822646976222C7B636C6173734E616D653A22757070792D50726F76696465722D61757468227D2C752822646976222C7B636C6173734E616D653A22757070792D50726F76696465722D6175746849636F6E227D2C';
wwv_flow_imp.g_varchar2_table(1527) := '722829292C752822646976222C7B636C6173734E616D653A22757070792D50726F76696465722D617574685469746C65227D2C73282261757468656E746963617465576974685469746C65222C7B706C7567696E4E616D653A6C7D29292C752822646976';
wwv_flow_imp.g_varchar2_table(1528) := '222C7B636C6173734E616D653A22757070792D50726F76696465722D61757468466F726D227D2C61287B706C7567696E4E616D653A742C6931386E3A732C6C6F6164696E673A652C6F6E417574683A6F7D2929297D6E2851772C22417574685669657722';
wwv_flow_imp.g_varchar2_table(1529) := '293B766172206F673D51773B766172206E673D6E28693D3E7B6C65747B6931386E3A652C6C6F676F75743A742C757365726E616D653A727D3D693B72657475726E5B7528227370616E222C7B636C6173734E616D653A22757070792D50726F7669646572';
wwv_flow_imp.g_varchar2_table(1530) := '42726F777365722D75736572222C6B65793A22757365726E616D65227D2C72292C752822627574746F6E222C7B747970653A22627574746F6E222C6F6E436C69636B3A742C636C6173734E616D653A22757070792D752D726573657420757070792D632D';
wwv_flow_imp.g_varchar2_table(1531) := '62746E20757070792D50726F766964657242726F777365722D757365724C6F676F7574222C6B65793A226C6F676F7574227D2C6528226C6F674F75742229295D7D2C2264656661756C7422293B766172204A773D6E28693D3E7B6C65747B676574466F6C';
wwv_flow_imp.g_varchar2_table(1532) := '6465723A652C7469746C653A742C69734C6173743A727D3D693B72657475726E20752848742C6E756C6C2C752822627574746F6E222C7B747970653A22627574746F6E222C636C6173734E616D653A22757070792D752D726573657420757070792D632D';
wwv_flow_imp.g_varchar2_table(1533) := '62746E222C6F6E436C69636B3A657D2C74292C723F22223A22202F2022297D2C2242726561646372756D6222292C61673D6E28693D3E7B6C65747B676574466F6C6465723A652C7469746C653A742C62726561646372756D627349636F6E3A722C627265';
wwv_flow_imp.g_varchar2_table(1534) := '61646372756D62733A737D3D693B72657475726E20752822646976222C7B636C6173734E616D653A22757070792D50726F76696465722D62726561646372756D6273227D2C752822646976222C7B636C6173734E616D653A22757070792D50726F766964';
wwv_flow_imp.g_varchar2_table(1535) := '65722D62726561646372756D627349636F6E227D2C72292C732E6D617028286F2C61293D3E75284A772C7B6B65793A6F2E69642C676574466F6C6465723A28293D3E65286F2E7265717565737450617468292C7469746C653A613D3D3D303F743A6F2E6E';
wwv_flow_imp.g_varchar2_table(1536) := '616D652C69734C6173743A612B313D3D3D732E6C656E6774687D2929297D2C2264656661756C7422293B766172206C673D6E28693D3E7B6C657420653D5B5D3B72657475726E20692E73686F7742726561646372756D62732626652E7075736828616728';
wwv_flow_imp.g_varchar2_table(1537) := '7B676574466F6C6465723A692E676574466F6C6465722C62726561646372756D62733A692E62726561646372756D62732C62726561646372756D627349636F6E3A692E706C7567696E49636F6E2626692E706C7567696E49636F6E28292C7469746C653A';
wwv_flow_imp.g_varchar2_table(1538) := '692E7469746C657D29292C652E70757368286E67287B6C6F676F75743A692E6C6F676F75742C757365726E616D653A692E757365726E616D652C6931386E3A692E6931386E7D29292C657D2C2264656661756C7422293B7661722065643D6465285A7428';
wwv_flow_imp.g_varchar2_table(1539) := '292C31293B66756E6374696F6E20246E2869297B72657475726E7B2E2E2E692C747970653A692E6D696D65547970652C657874656E73696F6E3A692E6E616D653F426928692E6E616D65292E657874656E73696F6E3A6E756C6C7D7D6E28246E2C227265';
wwv_flow_imp.g_varchar2_table(1540) := '6D6F746546696C654F626A546F4C6F63616C22293B66756E6374696F6E20516828297B72657475726E2051683D4F626A6563742E61737369676E3F4F626A6563742E61737369676E2E62696E6428293A66756E6374696F6E2869297B666F722876617220';
wwv_flow_imp.g_varchar2_table(1541) := '653D313B653C617267756D656E74732E6C656E6774683B652B2B297B76617220743D617267756D656E74735B655D3B666F7228766172207220696E2074294F626A6563742E70726F746F747970652E6861734F776E50726F70657274792E63616C6C2874';
wwv_flow_imp.g_varchar2_table(1542) := '2C7229262628695B725D3D745B725D297D72657475726E20697D2C51682E6170706C7928746869732C617267756D656E7473297D6E2851682C225F657874656E647322293B766172205A773D7B706F736974696F6E3A2272656C6174697665222C776964';
wwv_flow_imp.g_varchar2_table(1543) := '74683A2231303025222C6D696E4865696768743A2231303025227D2C65323D7B706F736974696F6E3A226162736F6C757465222C746F703A302C6C6566743A302C77696474683A2231303025222C6F766572666C6F773A2276697369626C65227D2C6475';
wwv_flow_imp.g_varchar2_table(1544) := '3D636C61737320657874656E64732077657B636F6E7374727563746F722865297B73757065722865292C746869732E68616E646C655363726F6C6C3D28293D3E7B746869732E7365745374617465287B6F66667365743A746869732E626173652E736372';
wwv_flow_imp.g_varchar2_table(1545) := '6F6C6C546F707D297D2C746869732E68616E646C65526573697A653D28293D3E7B746869732E726573697A6528297D2C746869732E666F637573456C656D656E743D6E756C6C2C746869732E73746174653D7B6F66667365743A302C6865696768743A30';
wwv_flow_imp.g_varchar2_table(1546) := '7D7D636F6D706F6E656E744469644D6F756E7428297B746869732E726573697A6528292C77696E646F772E6164644576656E744C697374656E65722822726573697A65222C746869732E68616E646C65526573697A65297D636F6D706F6E656E7457696C';
wwv_flow_imp.g_varchar2_table(1547) := '6C55706461746528297B746869732E626173652E636F6E7461696E7328646F63756D656E742E616374697665456C656D656E7429262628746869732E666F637573456C656D656E743D646F63756D656E742E616374697665456C656D656E74297D636F6D';
wwv_flow_imp.g_varchar2_table(1548) := '706F6E656E7444696455706461746528297B746869732E666F637573456C656D656E742626746869732E666F637573456C656D656E742E706172656E744E6F64652626646F63756D656E742E616374697665456C656D656E74213D3D746869732E666F63';
wwv_flow_imp.g_varchar2_table(1549) := '7573456C656D656E742626746869732E666F637573456C656D656E742E666F63757328292C746869732E666F637573456C656D656E743D6E756C6C2C746869732E726573697A6528297D636F6D706F6E656E7457696C6C556E6D6F756E7428297B77696E';
wwv_flow_imp.g_varchar2_table(1550) := '646F772E72656D6F76654576656E744C697374656E65722822726573697A65222C746869732E68616E646C65526573697A65297D726573697A6528297B6C65747B6865696768743A657D3D746869732E73746174653B65213D3D746869732E626173652E';
wwv_flow_imp.g_varchar2_table(1551) := '6F66667365744865696768742626746869732E7365745374617465287B6865696768743A746869732E626173652E6F66667365744865696768747D297D72656E6465722865297B6C65747B646174613A742C726F774865696768743A722C72656E646572';
wwv_flow_imp.g_varchar2_table(1552) := '526F773A732C6F7665727363616E436F756E743A6F3D31302C2E2E2E617D3D652C7B6F66667365743A6C2C6865696768743A687D3D746869732E73746174652C633D4D6174682E666C6F6F72286C2F72292C643D4D6174682E666C6F6F7228682F72293B';
wwv_flow_imp.g_varchar2_table(1553) := '6F262628633D4D6174682E6D617828302C632D63256F292C642B3D6F293B6C657420663D632B642B342C793D742E736C69636528632C66292C623D7B2E2E2E5A772C6865696768743A742E6C656E6774682A727D2C533D7B2E2E2E65322C746F703A632A';
wwv_flow_imp.g_varchar2_table(1554) := '727D3B72657475726E20752822646976222C5168287B6F6E5363726F6C6C3A746869732E68616E646C655363726F6C6C7D2C61292C752822646976222C7B726F6C653A2270726573656E746174696F6E222C7374796C653A627D2C752822646976222C7B';
wwv_flow_imp.g_varchar2_table(1555) := '726F6C653A2270726573656E746174696F6E222C7374796C653A537D2C792E6D61702873292929297D7D3B6E2864752C225669727475616C4C69737422293B7661722063753D64753B66756E6374696F6E20716E2869297B6C65747B7365617263683A65';
wwv_flow_imp.g_varchar2_table(1556) := '2C7365617263684F6E496E7075743A742C7365617263685465726D3A722C73686F77427574746F6E3A732C696E7075744C6162656C3A6F2C636C6561725365617263684C6162656C3A612C627574746F6E4C6162656C3A6C2C636C656172536561726368';
wwv_flow_imp.g_varchar2_table(1557) := '3A682C696E707574436C6173734E616D653A632C627574746F6E435353436C6173734E616D653A647D3D692C5B662C795D3D416F28723F3F2222292C623D437328783D3E7B782E70726576656E7444656661756C7428292C652866297D2C5B652C665D29';
wwv_flow_imp.g_varchar2_table(1558) := '2C533D437328783D3E7B6C657420553D782E7461726765742E76616C75653B792855292C742626652855297D2C5B792C742C655D292C453D6E2828293D3E7B79282222292C6826266828297D2C2268616E646C65526573657422292C5B465D3D416F2828';
wwv_flow_imp.g_varchar2_table(1559) := '293D3E7B6C657420783D646F63756D656E742E637265617465456C656D656E742822666F726D22293B72657475726E20782E7365744174747269627574652822746162696E646578222C222D3122292C782E69643D507428292C787D293B72657475726E';
wwv_flow_imp.g_varchar2_table(1560) := '2045732828293D3E28646F63756D656E742E626F64792E617070656E644368696C642846292C462E6164644576656E744C697374656E657228227375626D6974222C62292C28293D3E7B462E72656D6F76654576656E744C697374656E65722822737562';
wwv_flow_imp.g_varchar2_table(1561) := '6D6974222C62292C646F63756D656E742E626F64792E72656D6F76654368696C642846297D292C5B462C625D292C752848742C6E756C6C2C752822696E707574222C7B636C6173734E616D653A60757070792D752D726573657420247B637D602C747970';
wwv_flow_imp.g_varchar2_table(1562) := '653A22736561726368222C22617269612D6C6162656C223A6F2C706C616365686F6C6465723A6F2C76616C75653A662C6F6E496E7075743A532C666F726D3A462E69642C22646174612D757070792D73757065722D666F63757361626C65223A21307D29';
wwv_flow_imp.g_varchar2_table(1563) := '2C21732626752822737667222C7B22617269612D68696464656E223A2274727565222C666F63757361626C653A2266616C7365222C636C6173733A22757070792D632D69636F6E20757070792D50726F766964657242726F777365722D73656172636846';
wwv_flow_imp.g_varchar2_table(1564) := '696C74657249636F6E222C77696474683A223132222C6865696768743A223132222C76696577426F783A22302030203132203132227D2C75282270617468222C7B643A224D382E36333820372E39396C332E31373220332E313732612E3439322E343932';
wwv_flow_imp.g_varchar2_table(1565) := '2030203120312D2E3639372E3639374C372E393120382E36353661342E39373720342E3937372030203020312D322E3938332E39383343322E32303620392E363339203020372E343831203020342E383139203020322E31353820322E32303620302034';
wwv_flow_imp.g_varchar2_table(1566) := '2E393237203063322E373231203020342E39323720322E31353820342E39323720342E383261342E373420342E37342030203020312D312E32313620332E31377A6D2D332E37312E36383563322E313736203020332E39342D312E37323620332E39342D';
wwv_flow_imp.g_varchar2_table(1567) := '332E38353620302D322E3132392D312E3736342D332E3835352D332E39342D332E38353543322E37352E3936342E39383420322E36392E39383420342E383139633020322E313320312E37363520332E38353620332E39343220332E3835367A227D2929';
wwv_flow_imp.g_varchar2_table(1568) := '2C21732626662626752822627574746F6E222C7B636C6173734E616D653A22757070792D752D726573657420757070792D50726F766964657242726F777365722D73656172636846696C7465725265736574222C747970653A22627574746F6E222C2261';
wwv_flow_imp.g_varchar2_table(1569) := '7269612D6C6162656C223A612C7469746C653A612C6F6E436C69636B3A457D2C752822737667222C7B22617269612D68696464656E223A2274727565222C666F63757361626C653A2266616C7365222C636C6173734E616D653A22757070792D632D6963';
wwv_flow_imp.g_varchar2_table(1570) := '6F6E222C76696577426F783A22302030203139203139227D2C75282270617468222C7B643A224D31372E3331382031372E3233324C392E393420392E38353420392E35383620392E356C2D2E3335342E3335342D372E33373820372E333738682E373037';
wwv_flow_imp.g_varchar2_table(1571) := '6C2D2E36322D2E3632762E3730364C392E33313820392E39346C2E3335342D2E3335342D2E3335342D2E3335344C312E393420312E383534762E3730376C2E36322D2E3632682D2E3730366C372E33373820372E3337382E3335342E3335342E3335342D';
wwv_flow_imp.g_varchar2_table(1572) := '2E33353420372E3337382D372E333738682D2E3730376C2E3632322E3632762D2E3730364C392E38353420392E3233326C2D2E3335342E3335342E3335342E33353420372E33373820372E3337382E3730382D2E3730372D372E33382D372E333738762E';
wwv_flow_imp.g_varchar2_table(1573) := '3730386C372E33382D372E33382E3335332D2E3335332D2E3335332D2E3335332D2E3632322D2E3632322D2E3335332D2E3335332D2E3335342E3335322D372E33373820372E3338682E3730384C322E353620312E323320322E3230382E38386C2D2E33';
wwv_flow_imp.g_varchar2_table(1574) := '35332E3335332D2E3632322E36322D2E3335332E3335352E3335322E33353320372E333820372E3338762D2E3730386C2D372E333820372E33382D2E3335332E3335332E3335322E3335332E3632322E3632322E3335332E3335332E3335342D2E333533';
wwv_flow_imp.g_varchar2_table(1575) := '20372E33382D372E3338682D2E3730386C372E333820372E33387A227D2929292C732626752822627574746F6E222C7B636C6173734E616D653A60757070792D752D726573657420757070792D632D62746E20757070792D632D62746E2D7072696D6172';
wwv_flow_imp.g_varchar2_table(1576) := '7920247B647D602C747970653A227375626D6974222C666F726D3A462E69647D2C6C29297D6E28716E2C2253656172636846696C746572496E70757422293B7661722075673D6E28693D3E7B6C65747B63616E63656C3A652C646F6E653A742C6931386E';
wwv_flow_imp.g_varchar2_table(1577) := '3A722C73656C65637465643A737D3D693B72657475726E20752822646976222C7B636C6173734E616D653A22757070792D50726F766964657242726F777365722D666F6F746572227D2C752822627574746F6E222C7B636C6173734E616D653A22757070';
wwv_flow_imp.g_varchar2_table(1578) := '792D752D726573657420757070792D632D62746E20757070792D632D62746E2D7072696D617279222C6F6E436C69636B3A742C747970653A22627574746F6E227D2C72282273656C65637458222C7B736D6172745F636F756E743A737D29292C75282262';
wwv_flow_imp.g_varchar2_table(1579) := '7574746F6E222C7B636C6173734E616D653A22757070792D752D726573657420757070792D632D62746E20757070792D632D62746E2D6C696E6B222C6F6E436C69636B3A652C747970653A22627574746F6E227D2C72282263616E63656C222929297D2C';
wwv_flow_imp.g_varchar2_table(1580) := '2264656661756C7422293B7661722070673D6465285A7428292C31293B66756E6374696F6E20743228297B72657475726E20752822737667222C7B22617269612D68696464656E223A2274727565222C666F63757361626C653A2266616C7365222C636C';
wwv_flow_imp.g_varchar2_table(1581) := '6173734E616D653A22757070792D632D69636F6E222C77696474683A31312C6865696768743A31342E352C76696577426F783A22302030203434203538227D2C75282270617468222C7B643A224D32372E3433372E353137613120312030203020302D2E';
wwv_flow_imp.g_varchar2_table(1582) := '3039342E303348342E323543322E3033372E3534382E32313720322E3336382E32313720342E35387634382E343035633020322E32313220312E383220342E303320342E303320342E30334833392E303363322E3231203020342E30332D312E38313820';
wwv_flow_imp.g_varchar2_table(1583) := '342E30332D342E30335631352E3631613120312030203020302D2E30332D2E32382031203120302030203020302D2E303933203120312030203020302D2E30332D2E3033322031203120302030203020302D2E3033203120312030203020302D2E303332';
wwv_flow_imp.g_varchar2_table(1584) := '2D2E303633203120312030203020302D2E30332D2E303633203120312030203020302D2E3033322030203120312030203020302D2E30332D2E303633203120312030203020302D2E3033322D2E3033203120312030203020302D2E30332D2E3036332031';
wwv_flow_imp.g_varchar2_table(1585) := '20312030203020302D2E3036332D2E3036326C2D31342E3539332D3134613120312030203020302D2E3036322D2E30363241312031203020302030203238202E373038613120312030203020302D2E3337342D2E313537203120312030203020302D2E31';
wwv_flow_imp.g_varchar2_table(1586) := '35362030203120312030203020302D2E30332D2E30336C2D2E3030332D2E3030337A4D342E323520322E3534376832322E32313876392E3937633020322E323120312E383220342E303320342E303320342E30336831302E3536347633362E3433386132';
wwv_flow_imp.g_varchar2_table(1587) := '2E303220322E30322030203020312D322E30333220322E30333248342E3235632D312E313320302D322E3033322D2E392D322E3033322D322E30333256342E353863302D312E31332E3930322D322E30333220322E30332D322E3033327A6D32342E3231';
wwv_flow_imp.g_varchar2_table(1588) := '3820312E3334356C31302E33373520392E3933372E37352E3731384833302E35632D312E313320302D322E3033322D2E392D322E3033322D322E303356332E38397A227D29297D6E2874322C2246696C6549636F6E22293B66756E6374696F6E20693228';
wwv_flow_imp.g_varchar2_table(1589) := '297B72657475726E20752822737667222C7B22617269612D68696464656E223A2274727565222C666F63757361626C653A2266616C7365222C636C6173734E616D653A22757070792D632D69636F6E222C7374796C653A7B6D696E57696474683A31362C';
wwv_flow_imp.g_varchar2_table(1590) := '6D617267696E52696768743A337D2C76696577426F783A22302030203237362E313537203237362E313537227D2C75282270617468222C7B643A224D3237332E3038203130312E333738632D332E332D342E36352D382E38362D372E33322D31352E3235';
wwv_flow_imp.g_varchar2_table(1591) := '342D372E3332682D32342E33345636372E353963302D31302E322D382E332D31382E352D31382E352D31382E35682D38352E333232632D332E363320302D392E3239352D322E3837352D31312E3433362D352E3830356C2D362E3338362D382E37333563';
wwv_flow_imp.g_varchar2_table(1592) := '2D342E3938322D362E3831342D31352E3130342D31312E3935342D32332E3534362D31312E3935344835382E3733632D392E32393220302D31382E36333820362E3630382D32312E3733372031352E3337326C2D322E30333320352E373532632D2E3935';
wwv_flow_imp.g_varchar2_table(1593) := '3820322E37312D342E373220352E33372D372E35393620352E33374831382E3543382E332034392E303920302035372E333920302036372E3539763136372E30376330202E3838362E313620312E37332E34343320322E35322E31353220332E33303620';
wwv_flow_imp.g_varchar2_table(1594) := '312E313820362E34323420332E30353320392E30363420332E3320342E36353220382E383620372E33322031352E32353520372E3332683138382E3438376331312E33393520302032332E32372D382E3432352032372E3033352D31392E31386C34302E';
wwv_flow_imp.g_varchar2_table(1595) := '3637372D3131362E31383863322E31312D362E30333520312E34332D31322E3136342D312E38372D31362E3831367A4D31382E352036342E30383868382E38363463392E32393520302031382E36342D362E3630372032312E3733382D31352E33376C32';
wwv_flow_imp.g_varchar2_table(1596) := '2E3033322D352E3735632E39362D322E37313220342E3732322D352E33373320372E3539372D352E3337336832392E35363563332E3633203020392E32393520322E3837362031312E34333720352E3830366C362E33383620382E37333563342E393832';
wwv_flow_imp.g_varchar2_table(1597) := '20362E3831352031352E3130342031312E3935342032332E3534362031312E3935346838352E33323263312E383938203020332E3520312E36303220332E3520332E357632362E34374836392E3334632D31312E33393520302D32332E323720382E3432';
wwv_flow_imp.g_varchar2_table(1598) := '332D32372E3033352031392E3137384C3135203139312E32335636372E353963302D312E38393820312E3630332D332E3520332E352D332E357A6D3234322E32392034392E31356C2D34302E363736203131362E313838632D312E36373420342E37382D';
wwv_flow_imp.g_varchar2_table(1599) := '372E38313220392E3133352D31322E38373720392E3133354831382E3735632D312E34343720302D322E3537362D2E3337322D332E30322D2E3939372D2E3434322D2E3632352D2E3432322D312E3831342E3035372D332E31386C34302E3637372D3131';
wwv_flow_imp.g_varchar2_table(1600) := '362E313963312E3637342D342E373820372E3831322D392E3133342031322E3837372D392E313334683138382E34383763312E343438203020322E3537372E33373220332E30322E3939372E3434332E3632352E34323320312E3831342D2E3035362033';
wwv_flow_imp.g_varchar2_table(1601) := '2E31387A227D29297D6E2869322C22466F6C64657249636F6E22293B66756E6374696F6E20723228297B72657475726E20752822737667222C7B22617269612D68696464656E223A2274727565222C666F63757361626C653A2266616C7365222C737479';
wwv_flow_imp.g_varchar2_table(1602) := '6C653A7B77696474683A31362C6D617267696E52696768743A347D2C76696577426F783A22302030203538203538227D2C75282270617468222C7B643A224D33362E3533372032382E3135366C2D31312D3761312E30303520312E303035203020302030';
wwv_flow_imp.g_varchar2_table(1603) := '2D312E30322D2E3033334332342E322032312E332032342032312E3633352032342032327631346131203120302030203020312E3533372E3834346C31312D3761312E30303220312E30303220302030203020302D312E3638387A4D32362033342E3138';
wwv_flow_imp.g_varchar2_table(1604) := '5632332E38324C33342E3133372032392032362033342E31387A227D292C75282270617468222C7B643A224D353720364831613120312030203020302D31203176343461312031203020302030203120316835366131203120302030203020312D315637';
wwv_flow_imp.g_varchar2_table(1605) := '613120312030203020302D312D317A4D31302032384832762D39683876397A6D2D382032683876394832762D397A6D313020313056386833347634324831325634307A6D34342D3132682D38762D39683876397A6D2D38203268387639682D38762D397A';
wwv_flow_imp.g_varchar2_table(1606) := '6D382D32327639682D38563868387A4D32203868387639483256387A6D30203432762D396838763948327A6D35342030682D38762D39683876397A227D29297D6E2872322C22566964656F49636F6E22293B7661722068673D6E28693D3E7B6C65747B69';
wwv_flow_imp.g_varchar2_table(1607) := '74656D49636F6E537472696E673A657D3D693B69662865213D3D6E756C6C297377697463682865297B636173652266696C65223A72657475726E20752874322C6E756C6C293B6361736522666F6C646572223A72657475726E20752869322C6E756C6C29';
wwv_flow_imp.g_varchar2_table(1608) := '3B6361736522766964656F223A72657475726E20752872322C6E756C6C293B64656661756C743A7B6C65747B616C743A747D3D693B72657475726E20752822696D67222C7B7372633A652C616C743A742C6C6F6164696E673A226C617A79222C77696474';
wwv_flow_imp.g_varchar2_table(1609) := '683A31362C6865696768743A31367D297D7D7D2C2264656661756C7422293B7661722064673D6465285A7428292C31293B66756E6374696F6E2073322869297B6C65747B636C6173734E616D653A652C697344697361626C65643A742C72657374726963';
wwv_flow_imp.g_varchar2_table(1610) := '74696F6E4572726F723A722C6973436865636B65643A732C7469746C653A6F2C6974656D49636F6E456C3A612C73686F775469746C65733A6C2C746F67676C65436865636B626F783A682C7265636F726453686966744B657950726573733A632C69643A';
wwv_flow_imp.g_varchar2_table(1611) := '642C6368696C6472656E3A667D3D692C793D28302C64672E64656661756C74292822757070792D752D7265736574222C22757070792D50726F766964657242726F777365724974656D2D636865636B626F78222C22757070792D50726F76696465724272';
wwv_flow_imp.g_varchar2_table(1612) := '6F777365724974656D2D636865636B626F782D2D67726964222C7B22757070792D50726F766964657242726F777365724974656D2D636865636B626F782D2D69732D636865636B6564223A737D293B72657475726E207528226C69222C7B636C6173734E';
wwv_flow_imp.g_varchar2_table(1613) := '616D653A652C7469746C653A743F723F2E6D6573736167653A6E756C6C7D2C752822696E707574222C7B747970653A22636865636B626F78222C636C6173734E616D653A792C6F6E4368616E67653A682C6F6E4B6579446F776E3A632C6F6E4D6F757365';
wwv_flow_imp.g_varchar2_table(1614) := '446F776E3A632C6E616D653A226C6973746974656D222C69643A642C636865636B65643A732C64697361626C65643A742C22646174612D757070792D73757065722D666F63757361626C65223A21307D292C7528226C6162656C222C7B68746D6C466F72';
wwv_flow_imp.g_varchar2_table(1615) := '3A642C22617269612D6C6162656C223A6F2C636C6173734E616D653A22757070792D752D726573657420757070792D50726F766964657242726F777365724974656D2D696E6E6572227D2C612C6C26266F2C6629297D6E2873322C22477269644C697374';
wwv_flow_imp.g_varchar2_table(1616) := '4974656D22293B766172204A683D73323B66756E6374696F6E206F322869297B6C65747B636C6173734E616D653A652C697344697361626C65643A742C7265737472696374696F6E4572726F723A722C6973436865636B626F7844697361626C65643A73';
wwv_flow_imp.g_varchar2_table(1617) := '2C6973436865636B65643A6F2C746F67676C65436865636B626F783A612C7265636F726453686966744B657950726573733A6C2C747970653A682C69643A632C6974656D49636F6E456C3A642C7469746C653A662C68616E646C65466F6C646572436C69';
wwv_flow_imp.g_varchar2_table(1618) := '636B3A792C73686F775469746C65733A622C6931386E3A537D3D693B72657475726E207528226C69222C7B636C6173734E616D653A652C7469746C653A743F723F2E6D6573736167653A6E756C6C7D2C733F6E756C6C3A752822696E707574222C7B7479';
wwv_flow_imp.g_varchar2_table(1619) := '70653A22636865636B626F78222C636C6173734E616D653A60757070792D752D726573657420757070792D50726F766964657242726F777365724974656D2D636865636B626F7820247B6F3F22757070792D50726F766964657242726F77736572497465';
wwv_flow_imp.g_varchar2_table(1620) := '6D2D636865636B626F782D2D69732D636865636B6564223A22227D602C6F6E4368616E67653A612C6F6E4B6579446F776E3A6C2C6F6E4D6F757365446F776E3A6C2C6E616D653A226C6973746974656D222C69643A632C636865636B65643A6F2C226172';
wwv_flow_imp.g_varchar2_table(1621) := '69612D6C6162656C223A683D3D3D2266696C65223F6E756C6C3A532822616C6C46696C657346726F6D466F6C6465724E616D6564222C7B6E616D653A667D292C64697361626C65643A742C22646174612D757070792D73757065722D666F63757361626C';
wwv_flow_imp.g_varchar2_table(1622) := '65223A21307D292C683D3D3D2266696C65223F7528226C6162656C222C7B68746D6C466F723A632C636C6173734E616D653A22757070792D752D726573657420757070792D50726F766964657242726F777365724974656D2D696E6E6572227D2C752822';
wwv_flow_imp.g_varchar2_table(1623) := '646976222C7B636C6173734E616D653A22757070792D50726F766964657242726F777365724974656D2D69636F6E57726170227D2C64292C62262666293A752822627574746F6E222C7B747970653A22627574746F6E222C636C6173734E616D653A2275';
wwv_flow_imp.g_varchar2_table(1624) := '7070792D752D726573657420757070792D632D62746E20757070792D50726F766964657242726F777365724974656D2D696E6E6572222C6F6E436C69636B3A792C22617269612D6C6162656C223A5328226F70656E466F6C6465724E616D6564222C7B6E';
wwv_flow_imp.g_varchar2_table(1625) := '616D653A667D297D2C752822646976222C7B636C6173734E616D653A22757070792D50726F766964657242726F777365724974656D2D69636F6E57726170227D2C64292C6226267528227370616E222C6E756C6C2C662929297D6E286F322C224C697374';
wwv_flow_imp.g_varchar2_table(1626) := '4974656D22293B7661722063673D6F323B66756E6374696F6E20566E28297B72657475726E20566E3D4F626A6563742E61737369676E3F4F626A6563742E61737369676E2E62696E6428293A66756E6374696F6E2869297B666F722876617220653D313B';
wwv_flow_imp.g_varchar2_table(1627) := '653C617267756D656E74732E6C656E6774683B652B2B297B76617220743D617267756D656E74735B655D3B666F7228766172207220696E2074294F626A6563742E70726F746F747970652E6861734F776E50726F70657274792E63616C6C28742C722926';
wwv_flow_imp.g_varchar2_table(1628) := '2628695B725D3D745B725D297D72657475726E20697D2C566E2E6170706C7928746869732C617267756D656E7473297D6E28566E2C225F657874656E647322293B766172205A683D6E28693D3E7B6C65747B617574686F723A652C6765744974656D4963';
wwv_flow_imp.g_varchar2_table(1629) := '6F6E3A742C6973436865636B65643A722C697344697361626C65643A732C76696577547970653A6F7D3D692C613D7428292C6C3D28302C70672E64656661756C74292822757070792D50726F766964657242726F777365724974656D222C7B2275707079';
wwv_flow_imp.g_varchar2_table(1630) := '2D50726F766964657242726F777365724974656D2D2D73656C6563746564223A727D2C7B22757070792D50726F766964657242726F777365724974656D2D2D64697361626C6564223A737D2C7B22757070792D50726F766964657242726F777365724974';
wwv_flow_imp.g_varchar2_table(1631) := '656D2D2D6E6F50726576696577223A613D3D3D22766964656F227D292C683D752868672C7B6974656D49636F6E537472696E673A617D293B737769746368286F297B636173652267726964223A72657475726E2075284A682C566E287B7D2C692C7B636C';
wwv_flow_imp.g_varchar2_table(1632) := '6173734E616D653A6C2C6974656D49636F6E456C3A687D29293B63617365226C697374223A72657475726E20752863672C566E287B7D2C692C7B636C6173734E616D653A6C2C6974656D49636F6E456C3A687D29293B6361736522756E73706C61736822';
wwv_flow_imp.g_varchar2_table(1633) := '3A72657475726E2075284A682C566E287B7D2C692C7B636C6173734E616D653A6C2C6974656D49636F6E456C3A687D292C75282261222C7B687265663A60247B652E75726C7D3F75746D5F736F757263653D436F6D70616E696F6E2675746D5F6D656469';
wwv_flow_imp.g_varchar2_table(1634) := '756D3D726566657272616C602C7461726765743A225F626C616E6B222C72656C3A226E6F6F70656E6572206E6F7265666572726572222C636C6173734E616D653A22757070792D50726F766964657242726F777365724974656D2D617574686F72222C74';
wwv_flow_imp.g_varchar2_table(1635) := '6162496E6465783A222D31227D2C652E6E616D6529293B64656661756C743A7468726F77206E6577204572726F7228605468657265206973206E6F2073756368207479706520247B6F7D60297D7D2C2264656661756C7422293B766172206E323D227368';
wwv_flow_imp.g_varchar2_table(1636) := '617265642D776974682D6D65223B66756E6374696F6E2066672869297B6C65747B63757272656E7453656C656374696F6E3A652C7570707946696C65733A742C76696577547970653A722C6973436865636B65643A732C746F67676C65436865636B626F';
wwv_flow_imp.g_varchar2_table(1637) := '783A6F2C7265636F726453686966744B657950726573733A612C73686F775469746C65733A6C2C6931386E3A682C76616C69646174655265737472696374696F6E733A632C6765744E657874466F6C6465723A642C636F6C756D6E733A662C663A797D3D';
wwv_flow_imp.g_varchar2_table(1638) := '693B696628792E6973466F6C646572297B76617220623B72657475726E205A68287B636F6C756D6E733A662C73686F775469746C65733A6C2C76696577547970653A722C6931386E3A682C69643A792E69642C7469746C653A792E6E616D652C67657449';
wwv_flow_imp.g_varchar2_table(1639) := '74656D49636F6E3A28293D3E792E69636F6E2C6973436865636B65643A732879292C746F67676C65436865636B626F783A453D3E6F28452C79292C7265636F726453686966744B657950726573733A612C747970653A22666F6C646572222C6973446973';
wwv_flow_imp.g_varchar2_table(1640) := '61626C65643A28623D73287929293D3D6E756C6C3F766F696420303A622E6C6F6164696E672C6973436865636B626F7844697361626C65643A792E69643D3D3D6E322C68616E646C65466F6C646572436C69636B3A28293D3E642879297D297D6C657420';
wwv_flow_imp.g_varchar2_table(1641) := '533D6328246E2879292C5B2E2E2E742C2E2E2E655D293B72657475726E205A68287B69643A792E69642C7469746C653A792E6E616D652C617574686F723A792E617574686F722C6765744974656D49636F6E3A28293D3E792E69636F6E2C697343686563';
wwv_flow_imp.g_varchar2_table(1642) := '6B65643A732879292C746F67676C65436865636B626F783A453D3E6F28452C79292C7265636F726453686966744B657950726573733A612C636F6C756D6E733A662C73686F775469746C65733A6C2C76696577547970653A722C6931386E3A682C747970';
wwv_flow_imp.g_varchar2_table(1643) := '653A2266696C65222C697344697361626C65643A53262621732879292C7265737472696374696F6E4572726F723A537D297D6E2866672C224C6973744974656D22293B66756E6374696F6E2061322869297B6C65747B63757272656E7453656C65637469';
wwv_flow_imp.g_varchar2_table(1644) := '6F6E3A652C666F6C646572733A742C66696C65733A722C7570707946696C65733A732C76696577547970653A6F2C686561646572436F6D706F6E656E743A612C73686F7742726561646372756D62733A6C2C6973436865636B65643A682C746F67676C65';
wwv_flow_imp.g_varchar2_table(1645) := '436865636B626F783A632C7265636F726453686966744B657950726573733A642C68616E646C655363726F6C6C3A662C73686F775469746C65733A792C6931386E3A622C76616C69646174655265737472696374696F6E733A532C69734C6F6164696E67';
wwv_flow_imp.g_varchar2_table(1646) := '3A452C73686F7753656172636846696C7465723A462C7365617263683A782C7365617263685465726D3A552C636C6561725365617263683A6A2C7365617263684F6E496E7075743A472C736561726368496E7075744C6162656C3A4A2C636C6561725365';
wwv_flow_imp.g_varchar2_table(1647) := '617263684C6162656C3A422C6765744E657874466F6C6465723A7A2C63616E63656C3A4B2C646F6E653A6F652C636F6C756D6E733A42652C6E6F526573756C74734C6162656C3A4A652C6C6F6164416C6C46696C65733A77747D3D692C47653D652E6C65';
wwv_flow_imp.g_varchar2_table(1648) := '6E6774682C5F653D526F2828293D3E5B2E2E2E742C2E2E2E725D2C5B742C725D293B72657475726E20752822646976222C7B636C6173734E616D653A28302C65642E64656661756C74292822757070792D50726F766964657242726F77736572222C6075';
wwv_flow_imp.g_varchar2_table(1649) := '7070792D50726F766964657242726F777365722D76696577547970652D2D247B6F7D60297D2C612626752822646976222C7B636C6173734E616D653A22757070792D50726F766964657242726F777365722D686561646572227D2C752822646976222C7B';
wwv_flow_imp.g_varchar2_table(1650) := '636C6173734E616D653A28302C65642E64656661756C74292822757070792D50726F766964657242726F777365722D686561646572426172222C216C262622757070792D50726F766964657242726F777365722D6865616465724261722D2D73696D706C';
wwv_flow_imp.g_varchar2_table(1651) := '6522297D2C6129292C462626752822646976222C7B636C6173733A22757070792D50726F766964657242726F777365722D73656172636846696C746572227D2C7528716E2C7B7365617263683A782C7365617263685465726D3A552C636C656172536561';
wwv_flow_imp.g_varchar2_table(1652) := '7263683A6A2C696E7075744C6162656C3A4A2C636C6561725365617263684C6162656C3A422C696E707574436C6173734E616D653A22757070792D50726F766964657242726F777365722D73656172636846696C746572496E707574222C736561726368';
wwv_flow_imp.g_varchar2_table(1653) := '4F6E496E7075743A477D29292C2828293D3E453F752822646976222C7B636C6173734E616D653A22757070792D50726F76696465722D6C6F6164696E67227D2C7528227370616E222C6E756C6C2C6228226C6F6164696E67222929293A21742E6C656E67';
wwv_flow_imp.g_varchar2_table(1654) := '7468262621722E6C656E6774683F752822646976222C7B636C6173734E616D653A22757070792D50726F76696465722D656D707479227D2C4A65293A77743F752822646976222C7B636C6173734E616D653A22757070792D50726F766964657242726F77';
wwv_flow_imp.g_varchar2_table(1655) := '7365722D626F6479227D2C752822756C222C7B636C6173734E616D653A22757070792D50726F766964657242726F777365722D6C697374227D2C752863752C7B646174613A5F652C72656E646572526F773A7A653D3E752866672C7B63757272656E7453';
wwv_flow_imp.g_varchar2_table(1656) := '656C656374696F6E3A652C7570707946696C65733A732C76696577547970653A6F2C6973436865636B65643A682C746F67676C65436865636B626F783A632C7265636F726453686966744B657950726573733A642C73686F775469746C65733A792C6931';
wwv_flow_imp.g_varchar2_table(1657) := '386E3A622C76616C69646174655265737472696374696F6E733A532C6765744E657874466F6C6465723A7A2C636F6C756D6E733A42652C663A7A657D292C726F774865696768743A33317D2929293A752822646976222C7B636C6173734E616D653A2275';
wwv_flow_imp.g_varchar2_table(1658) := '7070792D50726F766964657242726F777365722D626F6479227D2C752822756C222C7B636C6173734E616D653A22757070792D50726F766964657242726F777365722D6C697374222C6F6E5363726F6C6C3A662C726F6C653A226C697374626F78222C74';
wwv_flow_imp.g_varchar2_table(1659) := '6162496E6465783A222D31227D2C5F652E6D6170287A653D3E752866672C7B63757272656E7453656C656374696F6E3A652C7570707946696C65733A732C76696577547970653A6F2C6973436865636B65643A682C746F67676C65436865636B626F783A';
wwv_flow_imp.g_varchar2_table(1660) := '632C7265636F726453686966744B657950726573733A642C73686F775469746C65733A792C6931386E3A622C76616C69646174655265737472696374696F6E733A532C6765744E657874466F6C6465723A7A2C636F6C756D6E733A42652C663A7A657D29';
wwv_flow_imp.g_varchar2_table(1661) := '2929292928292C47653E302626752875672C7B73656C65637465643A47652C646F6E653A6F652C63616E63656C3A4B2C6931386E3A627D29297D6E2861322C2242726F7773657222293B7661722070753D61323B766172207A693D636C61737320657874';
wwv_flow_imp.g_varchar2_table(1662) := '656E64732077657B636F6D706F6E656E7457696C6C556E6D6F756E7428297B6C65747B6F6E556E6D6F756E743A657D3D746869732E70726F70733B6528297D72656E64657228297B6C65747B6368696C6472656E3A657D3D746869732E70726F70733B72';
wwv_flow_imp.g_varchar2_table(1663) := '657475726E2070692865295B305D7D7D3B6E287A692C22436C6F73655772617070657222293B66756E6374696F6E20556F2869297B72657475726E20693F2F5E5B5E2F5D2B5C2F286A70653F677C6769667C706E677C7376677C7376675C2B786D6C7C62';
wwv_flow_imp.g_varchar2_table(1664) := '6D707C776562707C6176696629242F2E746573742869293A21317D6E28556F2C22697350726576696577537570706F7274656422293B766172204A723D636C6173737B636F6E7374727563746F7228652C74297B746869732E66696C7465724974656D73';
wwv_flow_imp.g_varchar2_table(1665) := '3D723D3E7B6C657420733D746869732E706C7567696E2E676574506C7567696E537461746528293B72657475726E21732E66696C746572496E7075747C7C732E66696C746572496E7075743D3D3D22223F723A722E66696C746572286F3D3E6F2E6E616D';
wwv_flow_imp.g_varchar2_table(1666) := '652E746F4C6F7765724361736528292E696E6465784F6628732E66696C746572496E7075742E746F4C6F77657243617365282929213D3D2D31297D2C746869732E7265636F726453686966744B657950726573733D723D3E7B746869732E697353686966';
wwv_flow_imp.g_varchar2_table(1667) := '744B6579507265737365643D722E73686966744B65797D2C746869732E746F67676C65436865636B626F783D28722C73293D3E7B722E73746F7050726F7061676174696F6E28292C722E70726576656E7444656661756C7428292C722E63757272656E74';
wwv_flow_imp.g_varchar2_table(1668) := '5461726765742E666F63757328293B6C65747B666F6C646572733A6F2C66696C65733A617D3D746869732E706C7567696E2E676574506C7567696E537461746528292C6C3D746869732E66696C7465724974656D73286F2E636F6E636174286129293B69';
wwv_flow_imp.g_varchar2_table(1669) := '6628746869732E6C617374436865636B626F782626746869732E697353686966744B657950726573736564297B6C65747B63757272656E7453656C656374696F6E3A637D3D746869732E706C7567696E2E676574506C7567696E537461746528292C643D';
wwv_flow_imp.g_varchar2_table(1670) := '6C2E696E6465784F6628746869732E6C617374436865636B626F78292C663D6C2E696E6465784F662873292C793D643C663F6C2E736C69636528642C662B31293A6C2E736C69636528662C642B31292C623D5B5D3B666F72286C65742053206F66207929';
wwv_flow_imp.g_varchar2_table(1671) := '7B6C65747B757070793A457D3D746869732E706C7567696E2C463D452E76616C69646174655265737472696374696F6E7328246E2853292C5B2E2E2E452E67657446696C657328292C2E2E2E625D293B463F452E696E666F287B6D6573736167653A462E';
wwv_flow_imp.g_varchar2_table(1672) := '6D6573736167657D2C226572726F72222C452E6F7074732E696E666F54696D656F7574293A622E707573682853297D746869732E706C7567696E2E736574506C7567696E5374617465287B63757272656E7453656C656374696F6E3A5B2E2E2E6E657720';
wwv_flow_imp.g_varchar2_table(1673) := '536574285B2E2E2E632C2E2E2E625D295D7D293B72657475726E7D746869732E6C617374436865636B626F783D733B6C65747B63757272656E7453656C656374696F6E3A687D3D746869732E706C7567696E2E676574506C7567696E537461746528293B';
wwv_flow_imp.g_varchar2_table(1674) := '746869732E6973436865636B65642873293F746869732E706C7567696E2E736574506C7567696E5374617465287B63757272656E7453656C656374696F6E3A682E66696C74657228633D3E632E6964213D3D732E6964297D293A746869732E706C756769';
wwv_flow_imp.g_varchar2_table(1675) := '6E2E736574506C7567696E5374617465287B63757272656E7453656C656374696F6E3A682E636F6E636174285B735D297D297D2C746869732E6973436865636B65643D723D3E7B6C65747B63757272656E7453656C656374696F6E3A737D3D746869732E';
wwv_flow_imp.g_varchar2_table(1676) := '706C7567696E2E676574506C7567696E537461746528293B72657475726E20732E736F6D65286F3D3E6F2E69643D3D3D722E6964297D2C746869732E706C7567696E3D652C746869732E70726F76696465723D742E70726F76696465722C746869732E69';
wwv_flow_imp.g_varchar2_table(1677) := '7348616E646C696E675363726F6C6C3D21312C746869732E707265466972737452656E6465723D746869732E707265466972737452656E6465722E62696E642874686973292C746869732E68616E646C654572726F723D746869732E68616E646C654572';
wwv_flow_imp.g_varchar2_table(1678) := '726F722E62696E642874686973292C746869732E636C65617253656C656374696F6E3D746869732E636C65617253656C656374696F6E2E62696E642874686973292C746869732E63616E63656C5069636B696E673D746869732E63616E63656C5069636B';
wwv_flow_imp.g_varchar2_table(1679) := '696E672E62696E642874686973297D707265466972737452656E64657228297B746869732E706C7567696E2E736574506C7567696E5374617465287B646964466972737452656E6465723A21307D292C746869732E706C7567696E2E6F6E466972737452';
wwv_flow_imp.g_varchar2_table(1680) := '656E64657228297D73686F756C6448616E646C655363726F6C6C2865297B6C65747B7363726F6C6C4865696768743A742C7363726F6C6C546F703A722C6F66667365744865696768743A737D3D652E7461726765743B72657475726E20742D28722B7329';
wwv_flow_imp.g_varchar2_table(1681) := '3C3530262621746869732E697348616E646C696E675363726F6C6C7D636C65617253656C656374696F6E28297B746869732E706C7567696E2E736574506C7567696E5374617465287B63757272656E7453656C656374696F6E3A5B5D2C66696C74657249';
wwv_flow_imp.g_varchar2_table(1682) := '6E7075743A22227D297D63616E63656C5069636B696E6728297B746869732E636C65617253656C656374696F6E28293B6C657420653D746869732E706C7567696E2E757070792E676574506C7567696E282244617368626F61726422293B652626652E68';
wwv_flow_imp.g_varchar2_table(1683) := '696465416C6C50616E656C7328297D68616E646C654572726F722865297B76617220743B6C65747B757070793A727D3D746869732E706C7567696E2C733D722E6931386E2822636F6D70616E696F6E4572726F7222293B722E6C6F6728652E746F537472';
wwv_flow_imp.g_varchar2_table(1684) := '696E672829292C2128652E6973417574684572726F727C7C2828743D652E6361757365293D3D6E756C6C3F766F696420303A742E6E616D65293D3D3D2241626F72744572726F7222292626722E696E666F287B6D6573736167653A732C64657461696C73';
wwv_flow_imp.g_varchar2_table(1685) := '3A652E746F537472696E6728297D2C226572726F72222C356533297D726567697374657252657175657374436C69656E7428297B746869732E72657175657374436C69656E7449643D746869732E70726F76696465722E70726F76696465722C74686973';
wwv_flow_imp.g_varchar2_table(1686) := '2E706C7567696E2E757070792E726567697374657252657175657374436C69656E7428746869732E72657175657374436C69656E7449642C746869732E70726F7669646572297D67657454616746696C652865297B6C657420743D7B69643A652E69642C';
wwv_flow_imp.g_varchar2_table(1687) := '736F757263653A746869732E706C7567696E2E69642C646174613A652C6E616D653A652E6E616D657C7C652E69642C747970653A652E6D696D65547970652C697352656D6F74653A21302C6D6574613A7B7D2C626F64793A7B66696C6549643A652E6964';
wwv_flow_imp.g_varchar2_table(1688) := '7D2C72656D6F74653A7B636F6D70616E696F6E55726C3A746869732E706C7567696E2E6F7074732E636F6D70616E696F6E55726C2C75726C3A60247B746869732E70726F76696465722E66696C6555726C28652E7265717565737450617468297D602C62';
wwv_flow_imp.g_varchar2_table(1689) := '6F64793A7B66696C6549643A652E69647D2C70726F76696465724E616D653A746869732E70726F76696465722E6E616D652C70726F76696465723A746869732E70726F76696465722E70726F76696465722C72657175657374436C69656E7449643A7468';
wwv_flow_imp.g_varchar2_table(1690) := '69732E72657175657374436C69656E7449647D7D2C723D67732874293B72657475726E20722626556F287229262628742E707265766965773D652E7468756D626E61696C292C652E617574686F72262628652E617574686F722E6E616D65213D6E756C6C';
wwv_flow_imp.g_varchar2_table(1691) := '262628742E6D6574612E617574686F724E616D653D537472696E6728652E617574686F722E6E616D6529292C652E617574686F722E75726C262628742E6D6574612E617574686F7255726C3D652E617574686F722E75726C29292C652E72656C44697250';
wwv_flow_imp.g_varchar2_table(1692) := '617468213D6E756C6C262628742E6D6574612E72656C6174697665506174683D652E72656C446972506174683F60247B652E72656C446972506174687D2F247B742E6E616D657D603A6E756C6C292C652E61627344697250617468213D6E756C6C262628';
wwv_flow_imp.g_varchar2_table(1693) := '742E6D6574612E6162736F6C757465506174683D652E616273446972506174683F602F247B652E616273446972506174687D2F247B742E6E616D657D603A602F247B742E6E616D657D60292C747D7365744C6F6164696E672865297B746869732E706C75';
wwv_flow_imp.g_varchar2_table(1694) := '67696E2E736574506C7567696E5374617465287B6C6F6164696E673A657D297D7D3B6E284A722C225669657722293B66756E6374696F6E20247428692C65297B696628214F626A6563742E70726F746F747970652E6861734F776E50726F70657274792E';
wwv_flow_imp.g_varchar2_table(1695) := '63616C6C28692C6529297468726F77206E657720547970654572726F722822617474656D7074656420746F207573652070726976617465206669656C64206F6E206E6F6E2D696E7374616E636522293B72657475726E20697D6E2824742C225F636C6173';
wwv_flow_imp.g_varchar2_table(1696) := '73507269766174654669656C644C6F6F73654261736522293B766172206C323D303B66756E6374696F6E20586E2869297B72657475726E225F5F707269766174655F222B6C322B2B2B225F222B697D6E28586E2C225F636C617373507269766174654669';
wwv_flow_imp.g_varchar2_table(1697) := '656C644C6F6F73654B657922293B7661722075323D7B76657273696F6E3A22332E382E30227D3B66756E6374696F6E2068322869297B72657475726E20692E736C6963652831292E6D617028653D3E652E6E616D65292E6A6F696E28222F22297D6E2868';
wwv_flow_imp.g_varchar2_table(1698) := '322C22666F726D617442726561646372756D627322293B66756E6374696F6E20746428692C65297B72657475726E20693F60247B697D2F247B657D603A657D6E2874642C2270726570656E645061746822293B66756E6374696F6E206B6F28297B726574';
wwv_flow_imp.g_varchar2_table(1699) := '75726E20752822737667222C7B22617269612D68696464656E223A2274727565222C666F63757361626C653A2266616C7365222C77696474683A223330222C6865696768743A223330222C76696577426F783A22302030203330203330227D2C75282270';
wwv_flow_imp.g_varchar2_table(1700) := '617468222C7B643A224D313520333063382E32383420302031352D362E3731362031352D313520302D382E3238342D362E3731362D31352D31352D313543362E3731362030203020362E3731362030203135633020382E32383420362E37313620313520';
wwv_flow_imp.g_varchar2_table(1701) := '31352031357A6D342E3235382D31322E36373676362E383436682D382E343236762D362E38343648352E3230346C392E38322D31322E33363420392E38322031322E3336344831392E32367A227D29297D6E286B6F2C2264656661756C745069636B6572';
wwv_flow_imp.g_varchar2_table(1702) := '49636F6E22293B766172204F733D586E282261626F7274436F6E74726F6C6C657222292C43693D586E28227769746841626F727422292C4B6E3D586E28226C69737422292C576E3D586E28226C69737446696C6573416E64466F6C6465727322292C476E';
wwv_flow_imp.g_varchar2_table(1703) := '3D586E28227265637572736976656C794C697374416C6C46696C657322292C4E653D636C61737320657874656E6473204A727B636F6E7374727563746F7228652C74297B737570657228652C74292C4F626A6563742E646566696E6550726F7065727479';
wwv_flow_imp.g_varchar2_table(1704) := '28746869732C476E2C7B76616C75653A66327D292C4F626A6563742E646566696E6550726F706572747928746869732C576E2C7B76616C75653A70327D292C4F626A6563742E646566696E6550726F706572747928746869732C4B6E2C7B76616C75653A';
wwv_flow_imp.g_varchar2_table(1705) := '63327D292C4F626A6563742E646566696E6550726F706572747928746869732C43692C7B76616C75653A64327D292C4F626A6563742E646566696E6550726F706572747928746869732C4F732C7B7772697461626C653A21302C76616C75653A766F6964';
wwv_flow_imp.g_varchar2_table(1706) := '20307D293B6C657420723D7B76696577547970653A226C697374222C73686F775469746C65733A21302C73686F7746696C7465723A21302C73686F7742726561646372756D62733A21302C6C6F6164416C6C46696C65733A21317D3B746869732E6F7074';
wwv_flow_imp.g_varchar2_table(1707) := '733D7B2E2E2E722C2E2E2E747D2C746869732E66696C74657251756572793D746869732E66696C74657251756572792E62696E642874686973292C746869732E636C65617246696C7465723D746869732E636C65617246696C7465722E62696E64287468';
wwv_flow_imp.g_varchar2_table(1708) := '6973292C746869732E676574466F6C6465723D746869732E676574466F6C6465722E62696E642874686973292C746869732E6765744E657874466F6C6465723D746869732E6765744E657874466F6C6465722E62696E642874686973292C746869732E6C';
wwv_flow_imp.g_varchar2_table(1709) := '6F676F75743D746869732E6C6F676F75742E62696E642874686973292C746869732E68616E646C65417574683D746869732E68616E646C65417574682E62696E642874686973292C746869732E68616E646C655363726F6C6C3D746869732E68616E646C';
wwv_flow_imp.g_varchar2_table(1710) := '655363726F6C6C2E62696E642874686973292C746869732E646F6E655069636B696E673D746869732E646F6E655069636B696E672E62696E642874686973292C746869732E72656E6465723D746869732E72656E6465722E62696E642874686973292C74';
wwv_flow_imp.g_varchar2_table(1711) := '6869732E706C7567696E2E736574506C7567696E5374617465287B61757468656E746963617465643A766F696420302C66696C65733A5B5D2C666F6C646572733A5B5D2C62726561646372756D62733A5B5D2C66696C746572496E7075743A22222C6973';
wwv_flow_imp.g_varchar2_table(1712) := '53656172636856697369626C653A21312C63757272656E7453656C656374696F6E3A5B5D7D292C746869732E726567697374657252657175657374436C69656E7428297D74656172446F776E28297B7D6173796E6320676574466F6C64657228652C7429';
wwv_flow_imp.g_varchar2_table(1713) := '7B746869732E7365744C6F6164696E67282130293B7472797B617761697420247428746869732C4369295B43695D286173796E6320723D3E7B746869732E6C617374436865636B626F783D766F696420303B6C65747B62726561646372756D62733A737D';
wwv_flow_imp.g_varchar2_table(1714) := '3D746869732E706C7567696E2E676574506C7567696E537461746528292C6F3D732E66696E64496E64657828683D3E653D3D3D682E7265717565737450617468293B6F213D3D2D313F733D732E736C69636528302C6F2B31293A733D5B2E2E2E732C7B72';
wwv_flow_imp.g_varchar2_table(1715) := '657175657374506174683A652C6E616D653A747D5D2C746869732E6E65787450616765506174683D653B6C657420613D5B5D2C6C3D5B5D3B646F7B6C65747B66696C65733A682C666F6C646572733A637D3D617761697420247428746869732C576E295B';
wwv_flow_imp.g_varchar2_table(1716) := '576E5D287B62726561646372756D62733A732C7369676E616C3A727D293B613D612E636F6E6361742868292C6C3D6C2E636F6E6361742863292C746869732E7365744C6F6164696E6728746869732E706C7567696E2E757070792E6931386E28226C6F61';
wwv_flow_imp.g_varchar2_table(1717) := '6465645846696C6573222C7B6E756D46696C65733A612E6C656E6774682B6C2E6C656E6774687D29297D7768696C6528746869732E6F7074732E6C6F6164416C6C46696C65732626746869732E6E6578745061676550617468293B746869732E706C7567';
wwv_flow_imp.g_varchar2_table(1718) := '696E2E736574506C7567696E5374617465287B666F6C646572733A6C2C66696C65733A612C62726561646372756D62733A732C66696C746572496E7075743A22227D297D297D63617463682872297B696628723F2E6E616D653D3D3D2255736572466163';
wwv_flow_imp.g_varchar2_table(1719) := '696E674170694572726F7222297B746869732E706C7567696E2E757070792E696E666F287B6D6573736167653A746869732E706C7567696E2E757070792E6931386E28722E6D657373616765297D2C227761726E696E67222C356533293B72657475726E';
wwv_flow_imp.g_varchar2_table(1720) := '7D746869732E68616E646C654572726F722872297D66696E616C6C797B746869732E7365744C6F6164696E67282131297D7D6765744E657874466F6C6465722865297B746869732E676574466F6C64657228652E72657175657374506174682C652E6E61';
wwv_flow_imp.g_varchar2_table(1721) := '6D65292C746869732E6C617374436865636B626F783D766F696420307D6173796E63206C6F676F757428297B7472797B617761697420247428746869732C4369295B43695D286173796E6320653D3E7B6C657420743D617761697420746869732E70726F';
wwv_flow_imp.g_varchar2_table(1722) := '76696465722E6C6F676F7574287B7369676E616C3A657D293B696628742E6F6B297B69662821742E7265766F6B6564297B6C657420733D746869732E706C7567696E2E757070792E6931386E2822636F6D70616E696F6E556E617574686F72697A654869';
wwv_flow_imp.g_varchar2_table(1723) := '6E74222C7B70726F76696465723A746869732E706C7567696E2E7469746C652C75726C3A742E6D616E75616C5F7265766F6B655F75726C7D293B746869732E706C7567696E2E757070792E696E666F28732C22696E666F222C376533297D6C657420723D';
wwv_flow_imp.g_varchar2_table(1724) := '7B61757468656E746963617465643A21312C66696C65733A5B5D2C666F6C646572733A5B5D2C62726561646372756D62733A5B5D2C66696C746572496E7075743A22227D3B746869732E706C7567696E2E736574506C7567696E53746174652872297D7D';
wwv_flow_imp.g_varchar2_table(1725) := '297D63617463682865297B746869732E68616E646C654572726F722865297D7D66696C74657251756572792865297B746869732E706C7567696E2E736574506C7567696E5374617465287B66696C746572496E7075743A657D297D636C65617246696C74';
wwv_flow_imp.g_varchar2_table(1726) := '657228297B746869732E706C7567696E2E736574506C7567696E5374617465287B66696C746572496E7075743A22227D297D6173796E632068616E646C65417574682865297B7472797B617761697420247428746869732C4369295B43695D286173796E';
wwv_flow_imp.g_varchar2_table(1727) := '6320743D3E7B746869732E7365744C6F6164696E67282130292C617761697420746869732E70726F76696465722E6C6F67696E287B61757468466F726D446174613A652C7369676E616C3A747D292C746869732E706C7567696E2E736574506C7567696E';
wwv_flow_imp.g_varchar2_table(1728) := '5374617465287B61757468656E746963617465643A21307D292C746869732E707265466972737452656E64657228297D297D63617463682874297B696628742E6E616D653D3D3D2255736572466163696E674170694572726F7222297B746869732E706C';
wwv_flow_imp.g_varchar2_table(1729) := '7567696E2E757070792E696E666F287B6D6573736167653A746869732E706C7567696E2E757070792E6931386E28742E6D657373616765297D2C227761726E696E67222C356533293B72657475726E7D746869732E706C7567696E2E757070792E6C6F67';
wwv_flow_imp.g_varchar2_table(1730) := '28606C6F67696E206661696C65643A20247B742E6D6573736167657D60297D66696E616C6C797B746869732E7365744C6F6164696E67282131297D7D6173796E632068616E646C655363726F6C6C2865297B696628746869732E73686F756C6448616E64';
wwv_flow_imp.g_varchar2_table(1731) := '6C655363726F6C6C2865292626746869732E6E6578745061676550617468297B746869732E697348616E646C696E675363726F6C6C3D21303B7472797B617761697420247428746869732C4369295B43695D286173796E6320743D3E7B6C65747B66696C';
wwv_flow_imp.g_varchar2_table(1732) := '65733A722C666F6C646572733A732C62726561646372756D62733A6F7D3D746869732E706C7567696E2E676574506C7567696E537461746528292C7B66696C65733A612C666F6C646572733A6C7D3D617761697420247428746869732C576E295B576E5D';
wwv_flow_imp.g_varchar2_table(1733) := '287B62726561646372756D62733A6F2C7369676E616C3A747D292C683D722E636F6E6361742861292C633D732E636F6E636174286C293B746869732E706C7567696E2E736574506C7567696E5374617465287B666F6C646572733A632C66696C65733A68';
wwv_flow_imp.g_varchar2_table(1734) := '7D297D297D63617463682874297B746869732E68616E646C654572726F722874297D66696E616C6C797B746869732E697348616E646C696E675363726F6C6C3D21317D7D7D6173796E6320646F6E655069636B696E6728297B746869732E7365744C6F61';
wwv_flow_imp.g_varchar2_table(1735) := '64696E67282130293B7472797B617761697420247428746869732C4369295B43695D286173796E6320653D3E7B6C65747B63757272656E7453656C656374696F6E3A747D3D746869732E706C7567696E2E676574506C7567696E537461746528292C723D';
wwv_flow_imp.g_varchar2_table(1736) := '5B5D2C733D5B5D3B666F72286C6574206F206F662074297B6C65747B72657175657374506174683A617D3D6F2C6C3D6E28683D3E287B2E2E2E682C72656C446972506174683A682E616273446972506174682E7265706C616365286F2E61627344697250';
wwv_flow_imp.g_varchar2_table(1737) := '6174682C2222292E7265706C616365282F5E5C2F2F2C2222297D292C227769746852656C4469725061746822293B6966286F2E6973466F6C646572297B6C657420683D21302C633D302C643D6E6577204B6D287B636F6E63757272656E63793A367D292C';
wwv_flow_imp.g_varchar2_table(1738) := '663D6E28623D3E7B666F72286C65742053206F662062297B6C657420453D746869732E67657454616746696C652853292C463D446C2845293B746869732E706C7567696E2E757070792E636865636B496646696C65416C72656164794578697374732846';
wwv_flow_imp.g_varchar2_table(1739) := '297C7C28732E70757368286C285329292C632B2B2C746869732E7365744C6F6164696E6728746869732E706C7567696E2E757070792E6931386E282261646465644E756D46696C6573222C7B6E756D46696C65733A637D2929292C683D21317D7D2C226F';
wwv_flow_imp.g_varchar2_table(1740) := '6E46696C657322293B617761697420247428746869732C476E295B476E5D287B72657175657374506174683A612C616273446972506174683A7464286F2E616273446972506174682C6F2E6E616D65292C72656C446972506174683A6F2E6E616D652C71';
wwv_flow_imp.g_varchar2_table(1741) := '756575653A642C6F6E46696C65733A662C7369676E616C3A657D292C617761697420642E6F6E49646C6528293B6C657420793B683F793D746869732E706C7567696E2E757070792E6931386E2822656D707479466F6C646572416464656422293A633D3D';
wwv_flow_imp.g_varchar2_table(1742) := '3D303F793D746869732E706C7567696E2E757070792E6931386E2822666F6C646572416C72656164794164646564222C7B666F6C6465723A6F2E6E616D657D293A793D746869732E706C7567696E2E757070792E6931386E2822666F6C64657241646465';
wwv_flow_imp.g_varchar2_table(1743) := '64222C7B736D6172745F636F756E743A632C666F6C6465723A6F2E6E616D657D292C722E707573682879297D656C736520732E70757368286C286F29297D746869732E706C7567696E2E757070792E6C6F672822416464696E672066696C65732066726F';
wwv_flow_imp.g_varchar2_table(1744) := '6D20612072656D6F74652070726F766964657222292C746869732E706C7567696E2E757070792E61646446696C657328732E6D6170286F3D3E746869732E67657454616746696C65286F2C746869732E72657175657374436C69656E7449642929292C74';
wwv_flow_imp.g_varchar2_table(1745) := '6869732E706C7567696E2E736574506C7567696E5374617465287B66696C746572496E7075743A22227D292C722E666F7245616368286F3D3E746869732E706C7567696E2E757070792E696E666F286F29292C746869732E636C65617253656C65637469';
wwv_flow_imp.g_varchar2_table(1746) := '6F6E28297D297D63617463682865297B746869732E68616E646C654572726F722865297D66696E616C6C797B746869732E7365744C6F6164696E67282131297D7D72656E64657228652C74297B76617220723D746869733B743D3D3D766F696420302626';
wwv_flow_imp.g_varchar2_table(1747) := '28743D7B7D293B6C65747B61757468656E746963617465643A732C646964466972737452656E6465723A6F7D3D746869732E706C7567696E2E676574506C7567696E537461746528292C7B6931386E3A617D3D746869732E706C7567696E2E757070793B';
wwv_flow_imp.g_varchar2_table(1748) := '6F7C7C746869732E707265466972737452656E64657228293B6C6574206C3D7B2E2E2E746869732E6F7074732C2E2E2E747D2C7B66696C65733A682C666F6C646572733A632C66696C746572496E7075743A642C6C6F6164696E673A662C63757272656E';
wwv_flow_imp.g_varchar2_table(1749) := '7453656C656374696F6E3A797D3D746869732E706C7567696E2E676574506C7567696E537461746528292C7B6973436865636B65643A622C746F67676C65436865636B626F783A532C7265636F726453686966744B657950726573733A452C66696C7465';
wwv_flow_imp.g_varchar2_table(1750) := '724974656D733A467D3D746869732C783D64213D3D22222C553D746869732E706C7567696E2E69636F6E7C7C6B6F2C6A3D7B73686F7742726561646372756D62733A6C2E73686F7742726561646372756D62732C676574466F6C6465723A746869732E67';
wwv_flow_imp.g_varchar2_table(1751) := '6574466F6C6465722C62726561646372756D62733A746869732E706C7567696E2E676574506C7567696E537461746528292E62726561646372756D62732C706C7567696E49636F6E3A552C7469746C653A746869732E706C7567696E2E7469746C652C6C';
wwv_flow_imp.g_varchar2_table(1752) := '6F676F75743A746869732E6C6F676F75742C757365726E616D653A746869732E757365726E616D652C6931386E3A617D2C473D7B6973436865636B65643A622C746F67676C65436865636B626F783A532C7265636F726453686966744B65795072657373';
wwv_flow_imp.g_varchar2_table(1753) := '3A452C63757272656E7453656C656374696F6E3A792C66696C65733A783F462868293A682C666F6C646572733A783F462863293A632C6765744E657874466F6C6465723A746869732E6765744E657874466F6C6465722C676574466F6C6465723A746869';
wwv_flow_imp.g_varchar2_table(1754) := '732E676574466F6C6465722C6C6F6164416C6C46696C65733A746869732E6F7074732E6C6F6164416C6C46696C65732C73686F7753656172636846696C7465723A6C2E73686F7746696C7465722C7365617263683A746869732E66696C74657251756572';
wwv_flow_imp.g_varchar2_table(1755) := '792C636C6561725365617263683A746869732E636C65617246696C7465722C7365617263685465726D3A642C7365617263684F6E496E7075743A21302C736561726368496E7075744C6162656C3A61282266696C74657222292C636C6561725365617263';
wwv_flow_imp.g_varchar2_table(1756) := '684C6162656C3A612822726573657446696C74657222292C6E6F526573756C74734C6162656C3A6128226E6F46696C6573466F756E6422292C6C6F676F75743A746869732E6C6F676F75742C68616E646C655363726F6C6C3A746869732E68616E646C65';
wwv_flow_imp.g_varchar2_table(1757) := '5363726F6C6C2C646F6E653A746869732E646F6E655069636B696E672C63616E63656C3A746869732E63616E63656C5069636B696E672C686561646572436F6D706F6E656E743A6C67286A292C7469746C653A746869732E706C7567696E2E7469746C65';
wwv_flow_imp.g_varchar2_table(1758) := '2C76696577547970653A6C2E76696577547970652C73686F775469746C65733A6C2E73686F775469746C65732C73686F7742726561646372756D62733A6C2E73686F7742726561646372756D62732C706C7567696E49636F6E3A552C6931386E3A746869';
wwv_flow_imp.g_varchar2_table(1759) := '732E706C7567696E2E757070792E6931386E2C7570707946696C65733A746869732E706C7567696E2E757070792E67657446696C657328292C76616C69646174655265737472696374696F6E733A66756E6374696F6E28297B72657475726E20722E706C';
wwv_flow_imp.g_varchar2_table(1760) := '7567696E2E757070792E76616C69646174655265737472696374696F6E73282E2E2E617267756D656E7473297D2C69734C6F6164696E673A667D3B72657475726E20733D3D3D21313F75287A692C7B6F6E556E6D6F756E743A746869732E636C65617253';
wwv_flow_imp.g_varchar2_table(1761) := '656C656374696F6E7D2C75286F672C7B706C7567696E4E616D653A746869732E706C7567696E2E7469746C652C706C7567696E49636F6E3A552C68616E646C65417574683A746869732E68616E646C65417574682C6931386E3A746869732E706C756769';
wwv_flow_imp.g_varchar2_table(1762) := '6E2E757070792E6931386E41727261792C72656E646572466F726D3A746869732E6F7074732E72656E64657241757468466F726D2C6C6F6164696E673A667D29293A75287A692C7B6F6E556E6D6F756E743A746869732E636C65617253656C656374696F';
wwv_flow_imp.g_varchar2_table(1763) := '6E7D2C752870752C4729297D7D3B6E284E652C2250726F76696465725669657722293B6173796E632066756E6374696F6E2064322869297B76617220653B28653D247428746869732C4F73295B4F735D293D3D6E756C6C7C7C652E61626F727428293B6C';
wwv_flow_imp.g_varchar2_table(1764) := '657420743D6E65772041626F7274436F6E74726F6C6C65723B247428746869732C4F73295B4F735D3D743B6C657420723D6E2828293D3E7B742E61626F727428292C746869732E636C65617253656C656374696F6E28297D2C2263616E63656C52657175';
wwv_flow_imp.g_varchar2_table(1765) := '65737422293B7472797B746869732E706C7567696E2E757070792E6F6E282264617368626F6172643A636C6F73652D70616E656C222C72292C746869732E706C7567696E2E757070792E6F6E282263616E63656C2D616C6C222C72292C61776169742069';
wwv_flow_imp.g_varchar2_table(1766) := '28742E7369676E616C297D66696E616C6C797B746869732E706C7567696E2E757070792E6F6666282264617368626F6172643A636C6F73652D70616E656C222C72292C746869732E706C7567696E2E757070792E6F6666282263616E63656C2D616C6C22';
wwv_flow_imp.g_varchar2_table(1767) := '2C72292C247428746869732C4F73295B4F735D3D766F696420307D7D6E2864322C225F7769746841626F72743222293B6173796E632066756E6374696F6E2063322869297B6C65747B72657175657374506174683A652C616273446972506174683A742C';
wwv_flow_imp.g_varchar2_table(1768) := '7369676E616C3A727D3D692C7B757365726E616D653A732C6E65787450616765506174683A6F2C6974656D733A617D3D617761697420746869732E70726F76696465722E6C69737428652C7B7369676E616C3A727D293B72657475726E20746869732E75';
wwv_flow_imp.g_varchar2_table(1769) := '7365726E616D653D737C7C746869732E757365726E616D652C7B6974656D733A612E6D6170286C3D3E287B2E2E2E6C2C616273446972506174683A747D29292C6E65787450616765506174683A6F7D7D6E2863322C225F6C6973743222293B6173796E63';
wwv_flow_imp.g_varchar2_table(1770) := '2066756E6374696F6E2070322869297B6C65747B62726561646372756D62733A652C7369676E616C3A747D3D692C723D68322865292C7B6974656D733A732C6E65787450616765506174683A6F7D3D617761697420247428746869732C4B6E295B4B6E5D';
wwv_flow_imp.g_varchar2_table(1771) := '287B72657175657374506174683A746869732E6E65787450616765506174682C616273446972506174683A722C7369676E616C3A747D293B746869732E6E65787450616765506174683D6F3B6C657420613D5B5D2C6C3D5B5D3B72657475726E20732E66';
wwv_flow_imp.g_varchar2_table(1772) := '6F724561636828683D3E7B682E6973466F6C6465723F6C2E707573682868293A612E707573682868297D292C7B66696C65733A612C666F6C646572733A6C7D7D6E2870322C225F6C69737446696C6573416E64466F6C646572733222293B6173796E6320';
wwv_flow_imp.g_varchar2_table(1773) := '66756E6374696F6E2066322869297B6C65747B72657175657374506174683A652C616273446972506174683A742C72656C446972506174683A722C71756575653A732C6F6E46696C65733A6F2C7369676E616C3A617D3D692C6C3D653B666F72283B6C3B';
wwv_flow_imp.g_varchar2_table(1774) := '297B6C657420683D617761697420247428746869732C4B6E295B4B6E5D287B72657175657374506174683A6C2C616273446972506174683A742C7369676E616C3A617D293B6C3D682E6E65787450616765506174683B6C657420633D682E6974656D732E';
wwv_flow_imp.g_varchar2_table(1775) := '66696C74657228793D3E21792E6973466F6C646572292C643D682E6974656D732E66696C74657228793D3E792E6973466F6C646572293B6F2863293B6C657420663D642E6D6170286173796E6320793D3E732E616464286173796E6328293D3E24742874';
wwv_flow_imp.g_varchar2_table(1776) := '6869732C476E295B476E5D287B72657175657374506174683A792E72657175657374506174682C616273446972506174683A746428742C792E6E616D65292C72656C446972506174683A746428722C792E6E616D65292C71756575653A732C6F6E46696C';
wwv_flow_imp.g_varchar2_table(1777) := '65733A6F2C7369676E616C3A617D2929293B61776169742050726F6D6973652E616C6C2866297D7D6E2866322C225F7265637572736976656C794C697374416C6C46696C65733222293B4E652E56455253494F4E3D75322E76657273696F6E3B66756E63';
wwv_flow_imp.g_varchar2_table(1778) := '74696F6E206D6728692C65297B696628214F626A6563742E70726F746F747970652E6861734F776E50726F70657274792E63616C6C28692C6529297468726F77206E657720547970654572726F722822617474656D7074656420746F2075736520707269';
wwv_flow_imp.g_varchar2_table(1779) := '76617465206669656C64206F6E206E6F6E2D696E7374616E636522293B72657475726E20697D6E286D672C225F636C617373507269766174654669656C644C6F6F73654261736522293B766172206D323D303B66756E6374696F6E2067322869297B7265';
wwv_flow_imp.g_varchar2_table(1780) := '7475726E225F5F707269766174655F222B6D322B2B2B225F222B697D6E2867322C225F636C617373507269766174654669656C644C6F6F73654B657922293B7661722079323D7B76657273696F6E3A22332E382E30227D2C596E3D673228227570646174';
wwv_flow_imp.g_varchar2_table(1781) := '6546696C6573416E64496E7075744D6F646522292C6A693D636C61737320657874656E6473204A727B636F6E7374727563746F7228652C74297B737570657228652C74292C4F626A6563742E646566696E6550726F706572747928746869732C596E2C7B';
wwv_flow_imp.g_varchar2_table(1782) := '76616C75653A76327D293B6C657420723D7B76696577547970653A2267726964222C73686F775469746C65733A21312C73686F7746696C7465723A21312C73686F7742726561646372756D62733A21317D3B746869732E6F7074733D7B2E2E2E722C2E2E';
wwv_flow_imp.g_varchar2_table(1783) := '2E747D2C746869732E7365617263683D746869732E7365617263682E62696E642874686973292C746869732E636C6561725365617263683D746869732E636C6561725365617263682E62696E642874686973292C746869732E7265736574506C7567696E';
wwv_flow_imp.g_varchar2_table(1784) := '53746174653D746869732E7265736574506C7567696E53746174652E62696E642874686973292C746869732E68616E646C655363726F6C6C3D746869732E68616E646C655363726F6C6C2E62696E642874686973292C746869732E646F6E655069636B69';
wwv_flow_imp.g_varchar2_table(1785) := '6E673D746869732E646F6E655069636B696E672E62696E642874686973292C746869732E72656E6465723D746869732E72656E6465722E62696E642874686973292C746869732E64656661756C7453746174653D7B6973496E7075744D6F64653A21302C';
wwv_flow_imp.g_varchar2_table(1786) := '66696C65733A5B5D2C666F6C646572733A5B5D2C62726561646372756D62733A5B5D2C66696C746572496E7075743A22222C63757272656E7453656C656374696F6E3A5B5D2C7365617263685465726D3A6E756C6C7D2C746869732E706C7567696E2E73';
wwv_flow_imp.g_varchar2_table(1787) := '6574506C7567696E537461746528746869732E64656661756C745374617465292C746869732E726567697374657252657175657374436C69656E7428297D74656172446F776E28297B7D7265736574506C7567696E537461746528297B746869732E706C';
wwv_flow_imp.g_varchar2_table(1788) := '7567696E2E736574506C7567696E537461746528746869732E64656661756C745374617465297D6173796E63207365617263682865297B6C65747B7365617263685465726D3A747D3D746869732E706C7567696E2E676574506C7567696E537461746528';
wwv_flow_imp.g_varchar2_table(1789) := '293B6966282128652626653D3D3D7429297B746869732E7365744C6F6164696E67282130293B7472797B6C657420723D617761697420746869732E70726F76696465722E7365617263682865293B6D6728746869732C596E295B596E5D28722C5B5D297D';
wwv_flow_imp.g_varchar2_table(1790) := '63617463682872297B746869732E68616E646C654572726F722872297D66696E616C6C797B746869732E7365744C6F6164696E67282131297D7D7D636C65617253656172636828297B746869732E706C7567696E2E736574506C7567696E537461746528';
wwv_flow_imp.g_varchar2_table(1791) := '7B63757272656E7453656C656374696F6E3A5B5D2C66696C65733A5B5D2C7365617263685465726D3A6E756C6C7D297D6173796E632068616E646C655363726F6C6C2865297B6C657420743D746869732E6E6578745061676551756572797C7C6E756C6C';
wwv_flow_imp.g_varchar2_table(1792) := '3B696628746869732E73686F756C6448616E646C655363726F6C6C286529262674297B746869732E697348616E646C696E675363726F6C6C3D21303B7472797B6C65747B66696C65733A722C7365617263685465726D3A737D3D746869732E706C756769';
wwv_flow_imp.g_varchar2_table(1793) := '6E2E676574506C7567696E537461746528292C6F3D617761697420746869732E70726F76696465722E73656172636828732C74293B6D6728746869732C596E295B596E5D286F2C72297D63617463682872297B746869732E68616E646C654572726F7228';
wwv_flow_imp.g_varchar2_table(1794) := '72297D66696E616C6C797B746869732E697348616E646C696E675363726F6C6C3D21317D7D7D646F6E655069636B696E6728297B6C65747B63757272656E7453656C656374696F6E3A657D3D746869732E706C7567696E2E676574506C7567696E537461';
wwv_flow_imp.g_varchar2_table(1795) := '746528293B746869732E706C7567696E2E757070792E6C6F672822416464696E672072656D6F7465207365617263682070726F76696465722066696C657322292C746869732E706C7567696E2E757070792E61646446696C657328652E6D617028743D3E';
wwv_flow_imp.g_varchar2_table(1796) := '746869732E67657454616746696C6528742929292C746869732E7265736574506C7567696E537461746528297D72656E64657228652C74297B76617220723D746869733B743D3D3D766F69642030262628743D7B7D293B6C65747B646964466972737452';
wwv_flow_imp.g_varchar2_table(1797) := '656E6465723A732C6973496E7075744D6F64653A6F2C7365617263685465726D3A617D3D746869732E706C7567696E2E676574506C7567696E537461746528292C7B6931386E3A6C7D3D746869732E706C7567696E2E757070793B737C7C746869732E70';
wwv_flow_imp.g_varchar2_table(1798) := '7265466972737452656E64657228293B6C657420683D7B2E2E2E746869732E6F7074732C2E2E2E747D2C7B66696C65733A632C666F6C646572733A642C66696C746572496E7075743A662C6C6F6164696E673A792C63757272656E7453656C656374696F';
wwv_flow_imp.g_varchar2_table(1799) := '6E3A627D3D746869732E706C7567696E2E676574506C7567696E537461746528292C7B6973436865636B65643A532C746F67676C65436865636B626F783A452C66696C7465724974656D733A462C7265636F726453686966744B657950726573733A787D';
wwv_flow_imp.g_varchar2_table(1800) := '3D746869732C553D66213D3D22222C6A3D7B6973436865636B65643A532C746F67676C65436865636B626F783A452C7265636F726453686966744B657950726573733A782C63757272656E7453656C656374696F6E3A622C66696C65733A553F46286329';
wwv_flow_imp.g_varchar2_table(1801) := '3A632C666F6C646572733A553F462864293A642C68616E646C655363726F6C6C3A746869732E68616E646C655363726F6C6C2C646F6E653A746869732E646F6E655069636B696E672C63616E63656C3A746869732E63616E63656C5069636B696E672C73';
wwv_flow_imp.g_varchar2_table(1802) := '686F7753656172636846696C7465723A682E73686F7746696C7465722C7365617263683A746869732E7365617263682C636C6561725365617263683A746869732E636C6561725365617263682C7365617263685465726D3A612C7365617263684F6E496E';
wwv_flow_imp.g_varchar2_table(1803) := '7075743A21312C736561726368496E7075744C6162656C3A6C282273656172636822292C636C6561725365617263684C6162656C3A6C2822726573657453656172636822292C6E6F526573756C74734C6162656C3A6C28226E6F53656172636852657375';
wwv_flow_imp.g_varchar2_table(1804) := '6C747322292C7469746C653A746869732E706C7567696E2E7469746C652C76696577547970653A682E76696577547970652C73686F775469746C65733A682E73686F775469746C65732C73686F7746696C7465723A682E73686F7746696C7465722C6973';
wwv_flow_imp.g_varchar2_table(1805) := '4C6F6164696E673A792C73686F7742726561646372756D62733A682E73686F7742726561646372756D62732C706C7567696E49636F6E3A746869732E706C7567696E2E69636F6E2C6931386E3A6C2C7570707946696C65733A746869732E706C7567696E';
wwv_flow_imp.g_varchar2_table(1806) := '2E757070792E67657446696C657328292C76616C69646174655265737472696374696F6E733A66756E6374696F6E28297B72657475726E20722E706C7567696E2E757070792E76616C69646174655265737472696374696F6E73282E2E2E617267756D65';
wwv_flow_imp.g_varchar2_table(1807) := '6E7473297D7D3B72657475726E206F3F75287A692C7B6F6E556E6D6F756E743A746869732E7265736574506C7567696E53746174657D2C752822646976222C7B636C6173734E616D653A22757070792D53656172636850726F7669646572227D2C752871';
wwv_flow_imp.g_varchar2_table(1808) := '6E2C7B7365617263683A746869732E7365617263682C636C65617253656C656374696F6E3A746869732E636C65617253656C656374696F6E2C696E7075744C6162656C3A6C2822656E74657254657874546F53656172636822292C627574746F6E4C6162';
wwv_flow_imp.g_varchar2_table(1809) := '656C3A6C2822736561726368496D6167657322292C696E707574436C6173734E616D653A22757070792D632D74657874496E70757420757070792D53656172636850726F76696465722D696E707574222C627574746F6E435353436C6173734E616D653A';
wwv_flow_imp.g_varchar2_table(1810) := '22757070792D53656172636850726F76696465722D736561726368427574746F6E222C73686F77427574746F6E3A21307D2929293A75287A692C7B6F6E556E6D6F756E743A746869732E7265736574506C7567696E53746174657D2C752870752C6A2929';
wwv_flow_imp.g_varchar2_table(1811) := '7D7D3B6E286A692C2253656172636850726F76696465725669657722293B66756E6374696F6E20763228692C65297B746869732E6E6578745061676551756572793D692E6E6578745061676551756572792C692E6974656D732E666F724561636828743D';
wwv_flow_imp.g_varchar2_table(1812) := '3E7B652E707573682874297D292C746869732E706C7567696E2E736574506C7567696E5374617465287B63757272656E7453656C656374696F6E3A5B5D2C6973496E7075744D6F64653A21312C66696C65733A652C7365617263685465726D3A692E7365';
wwv_flow_imp.g_varchar2_table(1813) := '617263686564466F727D297D6E2876322C225F75706461746546696C6573416E64496E7075744D6F64653222293B6A692E56455253494F4E3D79322E76657273696F6E3B7661722067673B66756E6374696F6E20486928692C65297B696628214F626A65';
wwv_flow_imp.g_varchar2_table(1814) := '63742E70726F746F747970652E6861734F776E50726F70657274792E63616C6C28692C6529297468726F77206E657720547970654572726F722822617474656D7074656420746F207573652070726976617465206669656C64206F6E206E6F6E2D696E73';
wwv_flow_imp.g_varchar2_table(1815) := '74616E636522293B72657475726E20697D6E2848692C225F636C617373507269766174654669656C644C6F6F73654261736522293B7661722062323D303B66756E6374696F6E2072642869297B72657475726E225F5F707269766174655F222B62322B2B';
wwv_flow_imp.g_varchar2_table(1816) := '2B225F222B697D6E2872642C225F636C617373507269766174654669656C644C6F6F73654B657922293B7661722077323D7B76657273696F6E3A22332E302E35227D2C53323D22757070792F53544154455F555044415445222C50323D6E28693D3E653D';
wwv_flow_imp.g_varchar2_table(1817) := '3E652E757070795B695D2C2264656661756C7453656C6563746F7222293B66756E6374696F6E205F3228692C65297B6C657420743D4F626A6563742E6B6579732865292C723D7B7D3B72657475726E20742E666F724561636828733D3E7B695B735D213D';
wwv_flow_imp.g_varchar2_table(1818) := '3D655B735D262628725B735D3D655B735D297D292C727D6E285F322C22676574506174636822293B766172205F723D72642822696422292C516E3D7264282273656C6563746F7222292C46723D7264282273746F726522293B67673D53796D626F6C2E66';
wwv_flow_imp.g_varchar2_table(1819) := '6F7228227570707920746573743A2067657420696422293B766172204A6E3D636C6173737B636F6E7374727563746F722865297B4F626A6563742E646566696E6550726F706572747928746869732C5F722C7B7772697461626C653A21302C76616C7565';
wwv_flow_imp.g_varchar2_table(1820) := '3A766F696420307D292C4F626A6563742E646566696E6550726F706572747928746869732C516E2C7B7772697461626C653A21302C76616C75653A766F696420307D292C4F626A6563742E646566696E6550726F706572747928746869732C46722C7B77';
wwv_flow_imp.g_varchar2_table(1821) := '72697461626C653A21302C76616C75653A766F696420307D292C486928746869732C4672295B46725D3D652E73746F72652C486928746869732C5F72295B5F725D3D652E69647C7C507428292C486928746869732C516E295B516E5D3D652E73656C6563';
wwv_flow_imp.g_varchar2_table(1822) := '746F727C7C503228486928746869732C5F72295B5F725D292C746869732E7365745374617465287B7D297D73657453746174652865297B486928746869732C4672295B46725D2E6469737061746368287B747970653A53322C69643A486928746869732C';
wwv_flow_imp.g_varchar2_table(1823) := '5F72295B5F725D2C7061796C6F61643A657D297D676574537461746528297B72657475726E20486928746869732C516E295B516E5D28486928746869732C4672295B46725D2E67657453746174652829297D7375627363726962652865297B6C65742074';
wwv_flow_imp.g_varchar2_table(1824) := '3D746869732E676574537461746528293B72657475726E20486928746869732C4672295B46725D2E7375627363726962652828293D3E7B6C657420723D746869732E676574537461746528293B69662874213D3D72297B6C657420733D5F3228742C7229';
wwv_flow_imp.g_varchar2_table(1825) := '3B6528742C722C73292C743D727D7D297D5B67675D28297B72657475726E20486928746869732C5F72295B5F725D7D7D3B6E284A6E2C22526564757853746F726522293B4A6E2E56455253494F4E3D77322E76657273696F6E3B7661722079673D4A6E3B';
wwv_flow_imp.g_varchar2_table(1826) := '66756E6374696F6E20667528692C652C742C72297B72657475726E20743D3D3D307C7C693D3D3D653F693A723D3D3D303F653A692B28652D69292A322A2A282D722F74297D6E2866752C22656D6146696C74657222293B7661722055743D7B5354415445';
wwv_flow_imp.g_varchar2_table(1827) := '5F4552524F523A226572726F72222C53544154455F57414954494E473A2277616974696E67222C53544154455F50524550524F43455353494E473A2270726570726F63657373696E67222C53544154455F55504C4F4144494E473A2275706C6F6164696E';
wwv_flow_imp.g_varchar2_table(1828) := '67222C53544154455F504F535450524F43455353494E473A22706F737470726F63657373696E67222C53544154455F434F4D504C4554453A22636F6D706C657465227D3B7661722068643D6465285A7428292C31293B66756E6374696F6E205A6E286929';
wwv_flow_imp.g_varchar2_table(1829) := '7B6C657420653D5B5D2C742C723B666F72286C65747B70726F67726573733A6F7D6F66204F626A6563742E76616C756573286929297B6C65747B70726570726F636573733A612C706F737470726F636573733A6C7D3D6F3B723D3D6E756C6C262628617C';
wwv_flow_imp.g_varchar2_table(1830) := '7C6C292626287B6D6F64653A742C6D6573736167653A727D3D617C7C6C292C613F2E6D6F64653D3D3D2264657465726D696E617465222626652E7075736828612E76616C7565292C6C3F2E6D6F64653D3D3D2264657465726D696E617465222626652E70';
wwv_flow_imp.g_varchar2_table(1831) := '757368286C2E76616C7565297D6C657420733D652E72656475636528286F2C61293D3E6F2B612F652E6C656E6774682C30293B72657475726E7B6D6F64653A742C6D6573736167653A722C76616C75653A737D7D6E285A6E2C2263616C63756C61746550';
wwv_flow_imp.g_varchar2_table(1832) := '726F63657373696E6750726F677265737322293B7661722061643D6465285A7428292C31292C6E643D646528496C28292C31293B66756E6374696F6E2073642869297B6C657420653D4D6174682E666C6F6F7228692F33363030292532342C743D4D6174';
wwv_flow_imp.g_varchar2_table(1833) := '682E666C6F6F7228692F3630292536302C723D4D6174682E666C6F6F722869253630293B72657475726E7B686F7572733A652C6D696E757465733A742C7365636F6E64733A727D7D6E2873642C227365636F6E6473546F54696D6522293B66756E637469';
wwv_flow_imp.g_varchar2_table(1834) := '6F6E206F642869297B6C657420653D73642869292C743D652E686F7572733D3D3D303F22223A60247B652E686F7572737D68602C723D652E6D696E757465733D3D3D303F22223A60247B652E686F7572733D3D3D303F652E6D696E757465733A6020247B';
wwv_flow_imp.g_varchar2_table(1835) := '652E6D696E757465732E746F537472696E67283130292E706164537461727428322C223022297D607D6D602C733D652E686F757273213D3D303F22223A60247B652E6D696E757465733D3D3D303F652E7365636F6E64733A6020247B652E7365636F6E64';
wwv_flow_imp.g_varchar2_table(1836) := '732E746F537472696E67283130292E706164537461727428322C223022297D607D73603B72657475726E60247B747D247B727D247B737D607D6E286F642C2270726574747945544122293B7661722046323D225C784237222C76673D6E2828293D3E6020';
wwv_flow_imp.g_varchar2_table(1837) := '247B46327D20602C2272656E646572446F7422293B66756E6374696F6E2062672869297B6C65747B6E657746696C65733A652C697355706C6F6164537461727465643A742C7265636F766572656453746174653A722C6931386E3A732C75706C6F616453';
wwv_flow_imp.g_varchar2_table(1838) := '746174653A6F2C6973536F6D6547686F73743A612C737461727455706C6F61643A6C7D3D692C683D28302C61642E64656661756C74292822757070792D752D7265736574222C22757070792D632D62746E222C22757070792D5374617475734261722D61';
wwv_flow_imp.g_varchar2_table(1839) := '6374696F6E42746E222C22757070792D5374617475734261722D616374696F6E42746E2D2D75706C6F6164222C7B22757070792D632D62746E2D7072696D617279223A6F3D3D3D55742E53544154455F57414954494E477D2C7B22757070792D53746174';
wwv_flow_imp.g_varchar2_table(1840) := '75734261722D616374696F6E42746E2D2D64697361626C6564223A617D292C633D65262674262621723F73282275706C6F6164584E657746696C6573222C7B736D6172745F636F756E743A657D293A73282275706C6F61645846696C6573222C7B736D61';
wwv_flow_imp.g_varchar2_table(1841) := '72745F636F756E743A657D293B72657475726E20752822627574746F6E222C7B747970653A22627574746F6E222C636C6173734E616D653A682C22617269612D6C6162656C223A73282275706C6F61645846696C6573222C7B736D6172745F636F756E74';
wwv_flow_imp.g_varchar2_table(1842) := '3A657D292C6F6E436C69636B3A6C2C64697361626C65643A612C22646174612D757070792D73757065722D666F63757361626C65223A21307D2C63297D6E2862672C2255706C6F616442746E22293B66756E6374696F6E2077672869297B6C65747B6931';
wwv_flow_imp.g_varchar2_table(1843) := '386E3A652C757070793A747D3D693B72657475726E20752822627574746F6E222C7B747970653A22627574746F6E222C636C6173734E616D653A22757070792D752D726573657420757070792D632D62746E20757070792D5374617475734261722D6163';
wwv_flow_imp.g_varchar2_table(1844) := '74696F6E42746E20757070792D5374617475734261722D616374696F6E42746E2D2D7265747279222C22617269612D6C6162656C223A652822726574727955706C6F616422292C6F6E436C69636B3A28293D3E742E7265747279416C6C28292E63617463';
wwv_flow_imp.g_varchar2_table(1845) := '682828293D3E7B7D292C22646174612D757070792D73757065722D666F63757361626C65223A21302C22646174612D6379223A227265747279227D2C752822737667222C7B22617269612D68696464656E223A2274727565222C666F63757361626C653A';
wwv_flow_imp.g_varchar2_table(1846) := '2266616C7365222C636C6173734E616D653A22757070792D632D69636F6E222C77696474683A2238222C6865696768743A223130222C76696577426F783A223020302038203130227D2C75282270617468222C7B643A224D3420322E34303861322E3735';
wwv_flow_imp.g_varchar2_table(1847) := '20322E373520302031203020322E373520322E37352E3632362E36323620302030203120312E32352E303138762E303233613420342030203120312D342D342E303431562E3235612E32352E3235203020302031202E3338392D2E3230386C322E323939';
wwv_flow_imp.g_varchar2_table(1848) := '20312E353333612E32352E32352030203020312030202E3431366C2D322E3320312E353333412E32352E3235203020302031203420332E333136762D2E3930387A227D29292C65282272657472792229297D6E2877672C22526574727942746E22293B66';
wwv_flow_imp.g_varchar2_table(1849) := '756E6374696F6E2053672869297B6C65747B6931386E3A652C757070793A747D3D693B72657475726E20752822627574746F6E222C7B747970653A22627574746F6E222C636C6173734E616D653A22757070792D752D726573657420757070792D537461';
wwv_flow_imp.g_varchar2_table(1850) := '7475734261722D616374696F6E436972636C6542746E222C7469746C653A65282263616E63656C22292C22617269612D6C6162656C223A65282263616E63656C22292C6F6E436C69636B3A28293D3E742E63616E63656C416C6C28292C22646174612D63';
wwv_flow_imp.g_varchar2_table(1851) := '79223A2263616E63656C222C22646174612D757070792D73757065722D666F63757361626C65223A21307D2C752822737667222C7B22617269612D68696464656E223A2274727565222C666F63757361626C653A2266616C7365222C636C6173734E616D';
wwv_flow_imp.g_varchar2_table(1852) := '653A22757070792D632D69636F6E222C77696474683A223136222C6865696768743A223136222C76696577426F783A22302030203136203136227D2C75282267222C7B66696C6C3A226E6F6E65222C66696C6C52756C653A226576656E6F6464227D2C75';
wwv_flow_imp.g_varchar2_table(1853) := '2822636972636C65222C7B66696C6C3A2223383838222C63783A2238222C63793A2238222C723A2238227D292C75282270617468222C7B66696C6C3A2223464646222C643A224D392E32383320386C322E35363720322E3536372D312E32383320312E32';
wwv_flow_imp.g_varchar2_table(1854) := '38334C3820392E32383320352E3433332031312E383520342E31352031302E35363720362E373137203820342E313520352E34333320352E34333320342E3135203820362E3731376C322E3536372D322E35363720312E32383320312E3238337A227D29';
wwv_flow_imp.g_varchar2_table(1855) := '2929297D6E2853672C2243616E63656C42746E22293B66756E6374696F6E2050672869297B6C65747B6973416C6C5061757365643A652C6931386E3A742C6973416C6C436F6D706C6574653A722C726573756D61626C6555706C6F6164733A732C757070';
wwv_flow_imp.g_varchar2_table(1856) := '793A6F7D3D692C613D7428653F22726573756D65223A22706175736522293B66756E6374696F6E206C28297B72657475726E20723F6E756C6C3A733F653F6F2E726573756D65416C6C28293A6F2E7061757365416C6C28293A6F2E63616E63656C416C6C';
wwv_flow_imp.g_varchar2_table(1857) := '28297D72657475726E206E286C2C22746F67676C655061757365526573756D6522292C752822627574746F6E222C7B7469746C653A612C22617269612D6C6162656C223A612C636C6173734E616D653A22757070792D752D726573657420757070792D53';
wwv_flow_imp.g_varchar2_table(1858) := '74617475734261722D616374696F6E436972636C6542746E222C747970653A22627574746F6E222C6F6E436C69636B3A6C2C22646174612D6379223A22746F67676C655061757365526573756D65222C22646174612D757070792D73757065722D666F63';
wwv_flow_imp.g_varchar2_table(1859) := '757361626C65223A21307D2C752822737667222C7B22617269612D68696464656E223A2274727565222C666F63757361626C653A2266616C7365222C636C6173734E616D653A22757070792D632D69636F6E222C77696474683A223136222C6865696768';
wwv_flow_imp.g_varchar2_table(1860) := '743A223136222C76696577426F783A22302030203136203136227D2C75282267222C7B66696C6C3A226E6F6E65222C66696C6C52756C653A226576656E6F6464227D2C752822636972636C65222C7B66696C6C3A2223383838222C63783A2238222C6379';
wwv_flow_imp.g_varchar2_table(1861) := '3A2238222C723A2238227D292C75282270617468222C7B66696C6C3A2223464646222C643A653F224D3620342E32354C31312E35203820362031312E37357A223A224D3520342E35683276374835762D377A6D342030683276374839762D377A227D2929';
wwv_flow_imp.g_varchar2_table(1862) := '29297D6E2850672C225061757365526573756D65427574746F6E22293B66756E6374696F6E205F672869297B6C65747B6931386E3A652C646F6E65427574746F6E48616E646C65723A747D3D693B72657475726E20752822627574746F6E222C7B747970';
wwv_flow_imp.g_varchar2_table(1863) := '653A22627574746F6E222C636C6173734E616D653A22757070792D752D726573657420757070792D632D62746E20757070792D5374617475734261722D616374696F6E42746E20757070792D5374617475734261722D616374696F6E42746E2D2D646F6E';
wwv_flow_imp.g_varchar2_table(1864) := '65222C6F6E436C69636B3A742C22646174612D757070792D73757065722D666F63757361626C65223A21307D2C652822646F6E652229297D6E285F672C22446F6E6542746E22293B66756E6374696F6E20466728297B72657475726E2075282273766722';
wwv_flow_imp.g_varchar2_table(1865) := '2C7B636C6173734E616D653A22757070792D5374617475734261722D7370696E6E6572222C22617269612D68696464656E223A2274727565222C666F63757361626C653A2266616C7365222C77696474683A223134222C6865696768743A223134227D2C';
wwv_flow_imp.g_varchar2_table(1866) := '75282270617468222C7B643A224D31332E39383320362E353437632D2E31322D322E3530392D312E36342D342E3839332D332E3933392D352E3933362D322E34382D312E3132372D352E3438382D2E3635362D372E35353620312E303934432E35323420';
wwv_flow_imp.g_varchar2_table(1867) := '332E3336372D2E33393820362E3034382E31363220382E353632632E35353620322E34393520322E343620342E353220342E393420352E31383320322E3933322E37383420352E36312D2E36303220372E3235362D332E3031352D312E34393320312E39';
wwv_flow_imp.g_varchar2_table(1868) := '39332D332E37343520332E3330392D362E32393820322E3836382D322E3531342D2E3433342D342E3537382D322E3334392D352E3135332D342E383461362E32323620362E32323620302030203120322E39382D362E37373843362E33342E3538362039';
wwv_flow_imp.g_varchar2_table(1869) := '2E373420312E312031312E33373320332E343933632E3430372E3539362E36393320312E3238322E38343220312E3938382E3132372E3539382E30373320312E3139372E31363120312E3739342E3037382E3532352E35343320312E32353720312E3135';
wwv_flow_imp.g_varchar2_table(1870) := '2E3836342E3532352D2E3334312E34392D312E30352E3435362D312E3539322D2E3030372D2E31352E30322E3320302030222C66696C6C52756C653A226576656E6F6464227D29297D6E2846672C224C6F6164696E675370696E6E657222293B66756E63';
wwv_flow_imp.g_varchar2_table(1871) := '74696F6E2078672869297B6C65747B70726F67726573733A657D3D692C7B76616C75653A742C6D6F64653A722C6D6573736167653A737D3D652C6F3D4D6174682E726F756E6428742A313030292C613D225C784237223B72657475726E20752822646976';
wwv_flow_imp.g_varchar2_table(1872) := '222C7B636C6173734E616D653A22757070792D5374617475734261722D636F6E74656E74227D2C752846672C6E756C6C292C723D3D3D2264657465726D696E617465223F60247B6F7D2520247B617D20603A22222C73297D6E2878672C2250726F677265';
wwv_flow_imp.g_varchar2_table(1873) := '737342617250726F63657373696E6722293B66756E6374696F6E2078322869297B6C65747B6E756D55706C6F6164733A652C636F6D706C6574653A742C746F74616C55706C6F6164656453697A653A722C746F74616C53697A653A732C746F74616C4554';
wwv_flow_imp.g_varchar2_table(1874) := '413A6F2C6931386E3A617D3D692C6C3D653E313B72657475726E20752822646976222C7B636C6173734E616D653A22757070792D5374617475734261722D7374617475735365636F6E64617279227D2C6C262661282266696C657355706C6F616465644F';
wwv_flow_imp.g_varchar2_table(1875) := '66546F74616C222C7B636F6D706C6574653A742C736D6172745F636F756E743A657D292C7528227370616E222C7B636C6173734E616D653A22757070792D5374617475734261722D6164646974696F6E616C496E666F227D2C6C2626766728292C612822';
wwv_flow_imp.g_varchar2_table(1876) := '6461746155706C6F616465644F66546F74616C222C7B636F6D706C6574653A28302C6E642E64656661756C74292872292C746F74616C3A28302C6E642E64656661756C74292873297D292C766728292C6128227854696D654C656674222C7B74696D653A';
wwv_flow_imp.g_varchar2_table(1877) := '6F64286F297D2929297D6E2878322C2250726F677265737344657461696C7322293B66756E6374696F6E2045672869297B6C65747B6931386E3A652C636F6D706C6574653A742C6E756D55706C6F6164733A727D3D693B72657475726E20752822646976';
wwv_flow_imp.g_varchar2_table(1878) := '222C7B636C6173734E616D653A22757070792D5374617475734261722D7374617475735365636F6E64617279227D2C65282266696C657355706C6F616465644F66546F74616C222C7B636F6D706C6574653A742C736D6172745F636F756E743A727D2929';
wwv_flow_imp.g_varchar2_table(1879) := '7D6E2845672C2246696C6555706C6F6164436F756E7422293B66756E6374696F6E2045322869297B6C65747B6931386E3A652C6E657746696C65733A742C737461727455706C6F61643A727D3D692C733D28302C61642E64656661756C74292822757070';
wwv_flow_imp.g_varchar2_table(1880) := '792D752D7265736574222C22757070792D632D62746E222C22757070792D5374617475734261722D616374696F6E42746E222C22757070792D5374617475734261722D616374696F6E42746E2D2D75706C6F61644E65776C79416464656422293B726574';
wwv_flow_imp.g_varchar2_table(1881) := '75726E20752822646976222C7B636C6173734E616D653A22757070792D5374617475734261722D7374617475735365636F6E64617279227D2C752822646976222C7B636C6173734E616D653A22757070792D5374617475734261722D7374617475735365';
wwv_flow_imp.g_varchar2_table(1882) := '636F6E6461727948696E74227D2C652822784D6F726546696C65734164646564222C7B736D6172745F636F756E743A747D29292C752822627574746F6E222C7B747970653A22627574746F6E222C636C6173734E616D653A732C22617269612D6C616265';
wwv_flow_imp.g_varchar2_table(1883) := '6C223A65282275706C6F61645846696C6573222C7B736D6172745F636F756E743A747D292C6F6E436C69636B3A727D2C65282275706C6F6164222929297D6E2845322C2255706C6F61644E65776C79416464656446696C657322293B66756E6374696F6E';
wwv_flow_imp.g_varchar2_table(1884) := '2043672869297B6C65747B6931386E3A652C737570706F72747355706C6F616450726F67726573733A742C746F74616C50726F67726573733A722C73686F7750726F677265737344657461696C733A732C697355706C6F6164537461727465643A6F2C69';
wwv_flow_imp.g_varchar2_table(1885) := '73416C6C436F6D706C6574653A612C6973416C6C5061757365643A6C2C6E657746696C65733A682C6E756D55706C6F6164733A632C636F6D706C6574653A642C746F74616C55706C6F6164656453697A653A662C746F74616C53697A653A792C746F7461';
wwv_flow_imp.g_varchar2_table(1886) := '6C4554413A622C737461727455706C6F61643A537D3D692C453D6826266F3B696628216F7C7C612972657475726E206E756C6C3B6C657420463D65286C3F22706175736564223A2275706C6F6164696E6722293B66756E6374696F6E207828297B726574';
wwv_flow_imp.g_varchar2_table(1887) := '75726E216C262621452626733F743F752878322C7B6E756D55706C6F6164733A632C636F6D706C6574653A642C746F74616C55706C6F6164656453697A653A662C746F74616C53697A653A792C746F74616C4554413A622C6931386E3A657D293A752845';
wwv_flow_imp.g_varchar2_table(1888) := '672C7B6931386E3A652C636F6D706C6574653A642C6E756D55706C6F6164733A637D293A6E756C6C7D72657475726E206E28782C2272656E64657250726F677265737344657461696C7322292C752822646976222C7B636C6173734E616D653A22757070';
wwv_flow_imp.g_varchar2_table(1889) := '792D5374617475734261722D636F6E74656E74222C22617269612D6C6162656C223A462C7469746C653A467D2C6C3F6E756C6C3A752846672C6E756C6C292C752822646976222C7B636C6173734E616D653A22757070792D5374617475734261722D7374';
wwv_flow_imp.g_varchar2_table(1890) := '61747573227D2C752822646976222C7B636C6173734E616D653A22757070792D5374617475734261722D7374617475735072696D617279227D2C743F60247B467D3A20247B727D25603A46292C7828292C453F752845322C7B6931386E3A652C6E657746';
wwv_flow_imp.g_varchar2_table(1891) := '696C65733A682C737461727455706C6F61643A537D293A6E756C6C29297D6E2843672C2250726F677265737342617255706C6F6164696E6722293B66756E6374696F6E204F672869297B6C65747B6931386E3A657D3D693B72657475726E207528226469';
wwv_flow_imp.g_varchar2_table(1892) := '76222C7B636C6173734E616D653A22757070792D5374617475734261722D636F6E74656E74222C726F6C653A22737461747573222C7469746C653A652822636F6D706C65746522297D2C752822646976222C7B636C6173734E616D653A22757070792D53';
wwv_flow_imp.g_varchar2_table(1893) := '74617475734261722D737461747573227D2C752822646976222C7B636C6173734E616D653A22757070792D5374617475734261722D7374617475735072696D617279227D2C752822737667222C7B22617269612D68696464656E223A2274727565222C66';
wwv_flow_imp.g_varchar2_table(1894) := '6F63757361626C653A2266616C7365222C636C6173734E616D653A22757070792D5374617475734261722D737461747573496E64696361746F7220757070792D632D69636F6E222C77696474683A223135222C6865696768743A223131222C7669657742';
wwv_flow_imp.g_varchar2_table(1895) := '6F783A22302030203135203131227D2C75282270617468222C7B643A224D2E34313420352E3834334C312E36323720342E36336C332E34373220332E3437324C31332E32303220306C312E32313220312E3231334C352E312031302E3532387A227D2929';
wwv_flow_imp.g_varchar2_table(1896) := '2C652822636F6D706C65746522292929297D6E284F672C2250726F6772657373426172436F6D706C65746522293B66756E6374696F6E2054672869297B6C65747B6572726F723A652C6931386E3A742C636F6D706C6574653A722C6E756D55706C6F6164';
wwv_flow_imp.g_varchar2_table(1897) := '733A737D3D693B66756E6374696F6E206F28297B6C657420613D60247B74282275706C6F61644661696C656422297D200A0A20247B657D603B616C6572742861297D72657475726E206E286F2C22646973706C61794572726F72416C65727422292C7528';
wwv_flow_imp.g_varchar2_table(1898) := '22646976222C7B636C6173734E616D653A22757070792D5374617475734261722D636F6E74656E74222C7469746C653A74282275706C6F61644661696C656422297D2C752822737667222C7B22617269612D68696464656E223A2274727565222C666F63';
wwv_flow_imp.g_varchar2_table(1899) := '757361626C653A2266616C7365222C636C6173734E616D653A22757070792D5374617475734261722D737461747573496E64696361746F7220757070792D632D69636F6E222C77696474683A223131222C6865696768743A223131222C76696577426F78';
wwv_flow_imp.g_varchar2_table(1900) := '3A22302030203131203131227D2C75282270617468222C7B643A224D342E32373820352E354C3020312E32323220312E323232203020352E3520342E32373820392E373738203020313120312E32323220362E37323220352E3520313120392E37373820';
wwv_flow_imp.g_varchar2_table(1901) := '392E37373820313120352E3520362E37323220312E323232203131203020392E3737387A227D29292C752822646976222C7B636C6173734E616D653A22757070792D5374617475734261722D737461747573227D2C752822646976222C7B636C6173734E';
wwv_flow_imp.g_varchar2_table(1902) := '616D653A22757070792D5374617475734261722D7374617475735072696D617279227D2C74282275706C6F61644661696C656422292C752822627574746F6E222C7B636C6173734E616D653A22757070792D752D726573657420757070792D5374617475';
wwv_flow_imp.g_varchar2_table(1903) := '734261722D64657461696C73222C22617269612D6C6162656C223A74282273686F774572726F7244657461696C7322292C22646174612D6D6963726F7469702D706F736974696F6E223A22746F702D7269676874222C22646174612D6D6963726F746970';
wwv_flow_imp.g_varchar2_table(1904) := '2D73697A65223A226D656469756D222C6F6E436C69636B3A6F2C747970653A22627574746F6E227D2C223F2229292C752845672C7B6931386E3A742C636F6D706C6574653A722C6E756D55706C6F6164733A737D2929297D6E2854672C2250726F677265';
wwv_flow_imp.g_varchar2_table(1905) := '73734261724572726F7222293B7661727B53544154455F4552524F523A41672C53544154455F57414954494E473A52672C53544154455F50524550524F43455353494E473A6C642C53544154455F55504C4F4144494E473A6D752C53544154455F504F53';
wwv_flow_imp.g_varchar2_table(1906) := '5450524F43455353494E473A75642C53544154455F434F4D504C4554453A67757D3D55743B66756E6374696F6E2064642869297B6C65747B6E657746696C65733A652C616C6C6F774E657755706C6F61643A742C697355706C6F6164496E50726F677265';
wwv_flow_imp.g_varchar2_table(1907) := '73733A722C6973416C6C5061757365643A732C726573756D61626C6555706C6F6164733A6F2C6572726F723A612C6869646555706C6F6164427574746F6E3A6C2C686964655061757365526573756D65427574746F6E3A682C6869646543616E63656C42';
wwv_flow_imp.g_varchar2_table(1908) := '7574746F6E3A632C686964655265747279427574746F6E3A642C7265636F766572656453746174653A662C75706C6F616453746174653A792C746F74616C50726F67726573733A622C66696C65733A532C737570706F72747355706C6F616450726F6772';
wwv_flow_imp.g_varchar2_table(1909) := '6573733A452C68696465416674657246696E6973683A462C6973536F6D6547686F73743A782C646F6E65427574746F6E48616E646C65723A552C697355706C6F6164537461727465643A6A2C6931386E3A472C737461727455706C6F61643A4A2C757070';
wwv_flow_imp.g_varchar2_table(1910) := '793A422C6973416C6C436F6D706C6574653A7A2C73686F7750726F677265737344657461696C733A4B2C6E756D55706C6F6164733A6F652C636F6D706C6574653A42652C746F74616C53697A653A4A652C746F74616C4554413A77742C746F74616C5570';
wwv_flow_imp.g_varchar2_table(1911) := '6C6F6164656453697A653A47657D3D693B66756E6374696F6E205F6528297B7377697463682879297B636173652075643A63617365206C643A7B6C65742072653D5A6E2853293B72657475726E2072652E6D6F64653D3D3D2264657465726D696E617465';
wwv_flow_imp.g_varchar2_table(1912) := '223F72652E76616C75652A3130303A627D636173652041673A72657475726E206E756C6C3B63617365206D753A72657475726E20453F623A6E756C6C3B64656661756C743A72657475726E20627D7D6E285F652C2267657450726F677265737356616C75';
wwv_flow_imp.g_varchar2_table(1913) := '6522293B66756E6374696F6E207A6528297B7377697463682879297B636173652075643A63617365206C643A7B6C65747B6D6F64653A72657D3D5A6E2853293B72657475726E2072653D3D3D22696E64657465726D696E617465227D63617365206D753A';
wwv_flow_imp.g_varchar2_table(1914) := '72657475726E21453B64656661756C743A72657475726E21317D7D6E287A652C226765744973496E64657465726D696E61746522293B66756E6374696F6E20466528297B696628662972657475726E21313B7377697463682879297B636173652052673A';
wwv_flow_imp.g_varchar2_table(1915) := '72657475726E206C7C7C653D3D3D303B636173652067753A72657475726E20463B64656661756C743A72657475726E21317D7D6E2846652C22676574497348696464656E22293B6C65742068693D5F6528292C563D466528292C523D68693F3F3130302C';
wwv_flow_imp.g_varchar2_table(1916) := '493D216126266526262172262621732626742626216C2C4C3D2163262679213D3D5267262679213D3D67752C513D6F262621682626793D3D3D6D752C583D612626217A262621642C79653D552626793D3D3D67752C70653D28302C68642E64656661756C';
wwv_flow_imp.g_varchar2_table(1917) := '74292822757070792D5374617475734261722D70726F6772657373222C7B2269732D696E64657465726D696E617465223A7A6528297D292C6E653D28302C68642E64656661756C74292822757070792D537461747573426172222C6069732D247B797D60';
wwv_flow_imp.g_varchar2_table(1918) := '2C7B226861732D67686F737473223A787D293B72657475726E20752822646976222C7B636C6173734E616D653A6E652C22617269612D68696464656E223A567D2C752822646976222C7B636C6173734E616D653A70652C7374796C653A7B77696474683A';
wwv_flow_imp.g_varchar2_table(1919) := '60247B527D25607D2C726F6C653A2270726F6772657373626172222C22617269612D6C6162656C223A60247B527D25602C22617269612D76616C756574657874223A60247B527D25602C22617269612D76616C75656D696E223A2230222C22617269612D';
wwv_flow_imp.g_varchar2_table(1920) := '76616C75656D6178223A22313030222C22617269612D76616C75656E6F77223A68697D292C2828293D3E7B7377697463682879297B63617365206C643A636173652075643A72657475726E20752878672C7B70726F67726573733A5A6E2853297D293B63';
wwv_flow_imp.g_varchar2_table(1921) := '6173652067753A72657475726E2075284F672C7B6931386E3A477D293B636173652041673A72657475726E20752854672C7B6572726F723A612C6931386E3A472C6E756D55706C6F6164733A6F652C636F6D706C6574653A42657D293B63617365206D75';
wwv_flow_imp.g_varchar2_table(1922) := '3A72657475726E20752843672C7B6931386E3A472C737570706F72747355706C6F616450726F67726573733A452C746F74616C50726F67726573733A622C73686F7750726F677265737344657461696C733A4B2C697355706C6F6164537461727465643A';
wwv_flow_imp.g_varchar2_table(1923) := '6A2C6973416C6C436F6D706C6574653A7A2C6973416C6C5061757365643A732C6E657746696C65733A652C6E756D55706C6F6164733A6F652C636F6D706C6574653A42652C746F74616C55706C6F6164656453697A653A47652C746F74616C53697A653A';
wwv_flow_imp.g_varchar2_table(1924) := '4A652C746F74616C4554413A77742C737461727455706C6F61643A4A7D293B64656661756C743A72657475726E206E756C6C7D7D2928292C752822646976222C7B636C6173734E616D653A22757070792D5374617475734261722D616374696F6E73227D';
wwv_flow_imp.g_varchar2_table(1925) := '2C667C7C493F752862672C7B6E657746696C65733A652C697355706C6F6164537461727465643A6A2C7265636F766572656453746174653A662C6931386E3A472C6973536F6D6547686F73743A782C737461727455706C6F61643A4A2C75706C6F616453';
wwv_flow_imp.g_varchar2_table(1926) := '746174653A797D293A6E756C6C2C583F752877672C7B6931386E3A472C757070793A427D293A6E756C6C2C513F752850672C7B6973416C6C5061757365643A732C6931386E3A472C6973416C6C436F6D706C6574653A7A2C726573756D61626C6555706C';
wwv_flow_imp.g_varchar2_table(1927) := '6F6164733A6F2C757070793A427D293A6E756C6C2C4C3F752853672C7B6931386E3A472C757070793A427D293A6E756C6C2C79653F75285F672C7B6931386E3A472C646F6E65427574746F6E48616E646C65723A557D293A6E756C6C29297D6E2864642C';
wwv_flow_imp.g_varchar2_table(1928) := '2253746174757342617222293B7661722055673D7B737472696E67733A7B75706C6F6164696E673A2255706C6F6164696E67222C636F6D706C6574653A22436F6D706C657465222C75706C6F61644661696C65643A2255706C6F6164206661696C656422';
wwv_flow_imp.g_varchar2_table(1929) := '2C7061757365643A22506175736564222C72657472793A225265747279222C63616E63656C3A2243616E63656C222C70617573653A225061757365222C726573756D653A22526573756D65222C646F6E653A22446F6E65222C66696C657355706C6F6164';
wwv_flow_imp.g_varchar2_table(1930) := '65644F66546F74616C3A7B303A22257B636F6D706C6574657D206F6620257B736D6172745F636F756E747D2066696C652075706C6F61646564222C313A22257B636F6D706C6574657D206F6620257B736D6172745F636F756E747D2066696C6573207570';
wwv_flow_imp.g_varchar2_table(1931) := '6C6F61646564227D2C6461746155706C6F616465644F66546F74616C3A22257B636F6D706C6574657D206F6620257B746F74616C7D222C7854696D654C6566743A22257B74696D657D206C656674222C75706C6F61645846696C65733A7B303A2255706C';
wwv_flow_imp.g_varchar2_table(1932) := '6F616420257B736D6172745F636F756E747D2066696C65222C313A2255706C6F616420257B736D6172745F636F756E747D2066696C6573227D2C75706C6F6164584E657746696C65733A7B303A2255706C6F6164202B257B736D6172745F636F756E747D';
wwv_flow_imp.g_varchar2_table(1933) := '2066696C65222C313A2255706C6F6164202B257B736D6172745F636F756E747D2066696C6573227D2C75706C6F61643A2255706C6F6164222C726574727955706C6F61643A2252657472792075706C6F6164222C784D6F726546696C657341646465643A';
wwv_flow_imp.g_varchar2_table(1934) := '7B303A22257B736D6172745F636F756E747D206D6F72652066696C65206164646564222C313A22257B736D6172745F636F756E747D206D6F72652066696C6573206164646564227D2C73686F774572726F7244657461696C733A2253686F77206572726F';
wwv_flow_imp.g_varchar2_table(1935) := '722064657461696C73227D7D3B66756E6374696F6E20556528692C65297B696628214F626A6563742E70726F746F747970652E6861734F776E50726F70657274792E63616C6C28692C6529297468726F77206E657720547970654572726F722822617474';
wwv_flow_imp.g_varchar2_table(1936) := '656D7074656420746F207573652070726976617465206669656C64206F6E206E6F6E2D696E7374616E636522293B72657475726E20697D6E2855652C225F636C617373507269766174654669656C644C6F6F73654261736522293B7661722043323D303B';
wwv_flow_imp.g_varchar2_table(1937) := '66756E6374696F6E20446F2869297B72657475726E225F5F707269766174655F222B43322B2B2B225F222B697D6E28446F2C225F636C617373507269766174654669656C644C6F6F73654B657922293B766172204F323D7B76657273696F6E3A22332E32';
wwv_flow_imp.g_varchar2_table(1938) := '2E35227D2C54323D3265332C41323D3265333B66756E6374696F6E20523228692C652C742C72297B696628692972657475726E2055742E53544154455F4552524F523B696628652972657475726E2055742E53544154455F434F4D504C4554453B696628';
wwv_flow_imp.g_varchar2_table(1939) := '742972657475726E2055742E53544154455F57414954494E473B6C657420733D55742E53544154455F57414954494E472C6F3D4F626A6563742E6B6579732872293B666F72286C657420613D303B613C6F2E6C656E6774683B612B2B297B6C65747B7072';
wwv_flow_imp.g_varchar2_table(1940) := '6F67726573733A6C7D3D725B6F5B615D5D3B6966286C2E75706C6F6164537461727465642626216C2E75706C6F6164436F6D706C6574652972657475726E2055742E53544154455F55504C4F4144494E473B6C2E70726570726F63657373262673213D3D';
wwv_flow_imp.g_varchar2_table(1941) := '55742E53544154455F55504C4F4144494E47262628733D55742E53544154455F50524550524F43455353494E47292C6C2E706F737470726F63657373262673213D3D55742E53544154455F55504C4F4144494E47262673213D3D55742E53544154455F50';
wwv_flow_imp.g_varchar2_table(1942) := '524550524F43455353494E47262628733D55742E53544154455F504F535450524F43455353494E47297D72657475726E20737D6E2852322C2267657455706C6F6164696E67537461746522293B766172206D693D446F28226C6173745570646174655469';
wwv_flow_imp.g_varchar2_table(1943) := '6D6522292C4F693D446F282270726576696F757355706C6F61646564427974657322292C78723D446F282270726576696F7573537065656422292C65693D446F282270726576696F757345544122292C63643D446F2822636F6D70757465536D6F6F7468';
wwv_flow_imp.g_varchar2_table(1944) := '45544122292C65613D446F28226F6E55706C6F6164537461727422292C24693D636C61737320657874656E6473205A7B636F6E7374727563746F7228652C74297B737570657228652C74292C4F626A6563742E646566696E6550726F7065727479287468';
wwv_flow_imp.g_varchar2_table(1945) := '69732C63642C7B76616C75653A55327D292C4F626A6563742E646566696E6550726F706572747928746869732C6D692C7B7772697461626C653A21302C76616C75653A766F696420307D292C4F626A6563742E646566696E6550726F7065727479287468';
wwv_flow_imp.g_varchar2_table(1946) := '69732C4F692C7B7772697461626C653A21302C76616C75653A766F696420307D292C4F626A6563742E646566696E6550726F706572747928746869732C78722C7B7772697461626C653A21302C76616C75653A766F696420307D292C4F626A6563742E64';
wwv_flow_imp.g_varchar2_table(1947) := '6566696E6550726F706572747928746869732C65692C7B7772697461626C653A21302C76616C75653A766F696420307D292C746869732E737461727455706C6F61643D28293D3E746869732E757070792E75706C6F616428292E63617463682828293D3E';
wwv_flow_imp.g_varchar2_table(1948) := '7B7D292C4F626A6563742E646566696E6550726F706572747928746869732C65612C7B7772697461626C653A21302C76616C75653A28293D3E7B6C65747B7265636F766572656453746174653A737D3D746869732E757070792E67657453746174652829';
wwv_flow_imp.g_varchar2_table(1949) := '3B696628556528746869732C7872295B78725D3D6E756C6C2C556528746869732C6569295B65695D3D6E756C6C2C73297B556528746869732C4F69295B4F695D3D4F626A6563742E76616C75657328732E66696C6573292E72656475636528286F2C6129';
wwv_flow_imp.g_varchar2_table(1950) := '3D3E7B6C65747B70726F67726573733A6C7D3D613B72657475726E206F2B6C2E627974657355706C6F616465647D2C30292C746869732E757070792E656D69742822726573746F72652D636F6E6669726D656422293B72657475726E7D55652874686973';
wwv_flow_imp.g_varchar2_table(1951) := '2C6D69295B6D695D3D706572666F726D616E63652E6E6F7728292C556528746869732C4F69295B4F695D3D307D7D292C746869732E69643D746869732E6F7074732E69647C7C22537461747573426172222C746869732E7469746C653D22537461747573';
wwv_flow_imp.g_varchar2_table(1952) := '426172222C746869732E747970653D2270726F6772657373696E64696361746F72222C746869732E64656661756C744C6F63616C653D55673B6C657420723D7B7461726765743A22626F6479222C6869646555706C6F6164427574746F6E3A21312C6869';
wwv_flow_imp.g_varchar2_table(1953) := '64655265747279427574746F6E3A21312C686964655061757365526573756D65427574746F6E3A21312C6869646543616E63656C427574746F6E3A21312C73686F7750726F677265737344657461696C733A21312C68696465416674657246696E697368';
wwv_flow_imp.g_varchar2_table(1954) := '3A21302C646F6E65427574746F6E48616E646C65723A6E756C6C7D3B746869732E6F7074733D7B2E2E2E722C2E2E2E747D2C746869732E6931386E496E697428292C746869732E72656E6465723D746869732E72656E6465722E62696E64287468697329';
wwv_flow_imp.g_varchar2_table(1955) := '2C746869732E696E7374616C6C3D746869732E696E7374616C6C2E62696E642874686973297D72656E6465722865297B6C65747B6361706162696C69746965733A742C66696C65733A722C616C6C6F774E657755706C6F61643A732C746F74616C50726F';
wwv_flow_imp.g_varchar2_table(1956) := '67726573733A6F2C6572726F723A612C7265636F766572656453746174653A6C7D3D652C7B6E657746696C65733A682C7374617274656446696C65733A632C636F6D706C65746546696C65733A642C697355706C6F6164537461727465643A662C697341';
wwv_flow_imp.g_varchar2_table(1957) := '6C6C436F6D706C6574653A792C6973416C6C4572726F7265643A622C6973416C6C5061757365643A532C697355706C6F6164496E50726F67726573733A452C6973536F6D6547686F73743A467D3D746869732E757070792E6765744F626A6563744F6646';
wwv_flow_imp.g_varchar2_table(1958) := '696C6573506572537461746528292C783D6C3F4F626A6563742E76616C7565732872293A682C553D2121742E726573756D61626C6555706C6F6164732C6A3D742E75706C6F616450726F6772657373213D3D21312C473D302C4A3D303B632E666F724561';
wwv_flow_imp.g_varchar2_table(1959) := '6368287A3D3E7B472B3D7A2E70726F67726573732E6279746573546F74616C7C7C302C4A2B3D7A2E70726F67726573732E627974657355706C6F616465647C7C307D293B6C657420423D556528746869732C6364295B63645D287B75706C6F616465643A';
wwv_flow_imp.g_varchar2_table(1960) := '4A2C746F74616C3A472C72656D61696E696E673A472D4A7D293B72657475726E206464287B6572726F723A612C75706C6F616453746174653A523228612C792C6C2C652E66696C65737C7C7B7D292C616C6C6F774E657755706C6F61643A732C746F7461';
wwv_flow_imp.g_varchar2_table(1961) := '6C50726F67726573733A6F2C746F74616C53697A653A472C746F74616C55706C6F6164656453697A653A4A2C6973416C6C436F6D706C6574653A21312C6973416C6C5061757365643A532C6973416C6C4572726F7265643A622C697355706C6F61645374';
wwv_flow_imp.g_varchar2_table(1962) := '61727465643A662C697355706C6F6164496E50726F67726573733A452C6973536F6D6547686F73743A462C7265636F766572656453746174653A6C2C636F6D706C6574653A642E6C656E6774682C6E657746696C65733A782E6C656E6774682C6E756D55';
wwv_flow_imp.g_varchar2_table(1963) := '706C6F6164733A632E6C656E6774682C746F74616C4554413A422C66696C65733A722C6931386E3A746869732E6931386E2C757070793A746869732E757070792C737461727455706C6F61643A746869732E737461727455706C6F61642C646F6E654275';
wwv_flow_imp.g_varchar2_table(1964) := '74746F6E48616E646C65723A746869732E6F7074732E646F6E65427574746F6E48616E646C65722C726573756D61626C6555706C6F6164733A552C737570706F72747355706C6F616450726F67726573733A6A2C73686F7750726F677265737344657461';
wwv_flow_imp.g_varchar2_table(1965) := '696C733A746869732E6F7074732E73686F7750726F677265737344657461696C732C6869646555706C6F6164427574746F6E3A746869732E6F7074732E6869646555706C6F6164427574746F6E2C686964655265747279427574746F6E3A746869732E6F';
wwv_flow_imp.g_varchar2_table(1966) := '7074732E686964655265747279427574746F6E2C686964655061757365526573756D65427574746F6E3A746869732E6F7074732E686964655061757365526573756D65427574746F6E2C6869646543616E63656C427574746F6E3A746869732E6F707473';
wwv_flow_imp.g_varchar2_table(1967) := '2E6869646543616E63656C427574746F6E2C68696465416674657246696E6973683A746869732E6F7074732E68696465416674657246696E6973682C6973546172676574444F4D456C3A746869732E6973546172676574444F4D456C7D297D6F6E4D6F75';
wwv_flow_imp.g_varchar2_table(1968) := '6E7428297B6C657420653D746869732E656C3B486C2865297C7C28652E6469723D226C747222297D696E7374616C6C28297B6C65747B7461726765743A657D3D746869732E6F7074733B652626746869732E6D6F756E7428652C74686973292C74686973';
wwv_flow_imp.g_varchar2_table(1969) := '2E757070792E6F6E282275706C6F6164222C556528746869732C6561295B65615D292C556528746869732C6D69295B6D695D3D706572666F726D616E63652E6E6F7728292C556528746869732C4F69295B4F695D3D746869732E757070792E6765744669';
wwv_flow_imp.g_varchar2_table(1970) := '6C657328292E7265647563652828742C72293D3E742B722E70726F67726573732E627974657355706C6F616465642C30297D756E696E7374616C6C28297B746869732E756E6D6F756E7428292C746869732E757070792E6F6666282275706C6F6164222C';
wwv_flow_imp.g_varchar2_table(1971) := '556528746869732C6561295B65615D297D7D3B6E2824692C2253746174757342617222293B66756E6374696F6E2055322869297B76617220652C743B696628692E746F74616C3D3D3D307C7C692E72656D61696E696E673D3D3D302972657475726E2030';
wwv_flow_imp.g_varchar2_table(1972) := '3B28743D28653D556528746869732C6D6929295B6D695D29213D6E756C6C7C7C28655B6D695D3D706572666F726D616E63652E6E6F772829293B6C657420723D706572666F726D616E63652E6E6F7728292D556528746869732C6D69295B6D695D3B6966';
wwv_flow_imp.g_varchar2_table(1973) := '28723D3D3D30297B76617220733B72657475726E204D6174682E726F756E64282828733D556528746869732C6569295B65695D29213D6E756C6C3F733A30292F313030292F31307D6C6574206F3D692E75706C6F616465642D556528746869732C4F6929';
wwv_flow_imp.g_varchar2_table(1974) := '5B4F695D3B696628556528746869732C4F69295B4F695D3D692E75706C6F616465642C6F3C3D30297B76617220613B72657475726E204D6174682E726F756E64282828613D556528746869732C6569295B65695D29213D6E756C6C3F613A30292F313030';
wwv_flow_imp.g_varchar2_table(1975) := '292F31307D6C6574206C3D6F2F722C683D556528746869732C7872295B78725D3D3D6E756C6C3F6C3A6675286C2C556528746869732C7872295B78725D2C54322C72293B556528746869732C7872295B78725D3D683B6C657420633D692E72656D61696E';
wwv_flow_imp.g_varchar2_table(1976) := '696E672F682C643D4D6174682E6D617828556528746869732C6569295B65695D2D722C30292C663D556528746869732C6569295B65695D3D3D6E756C6C3F633A667528632C642C41322C72293B72657475726E20556528746869732C6569295B65695D3D';
wwv_flow_imp.g_varchar2_table(1977) := '662C556528746869732C6D69295B6D695D3D706572666F726D616E63652E6E6F7728292C4D6174682E726F756E6428662F313030292F31307D6E2855322C225F636F6D70757465536D6F6F74684554413222293B24692E56455253494F4E3D4F322E7665';
wwv_flow_imp.g_varchar2_table(1978) := '7273696F6E3B766172206B673D3330302C496F3D636C61737320657874656E64732077657B636F6E7374727563746F7228297B7375706572282E2E2E617267756D656E7473292C746869732E7265663D686D28297D636F6D706F6E656E7457696C6C456E';
wwv_flow_imp.g_varchar2_table(1979) := '7465722865297B746869732E7265662E63757272656E742E7374796C652E6F7061636974793D2231222C746869732E7265662E63757272656E742E7374796C652E7472616E73666F726D3D226E6F6E65222C73657454696D656F757428652C6B67297D63';
wwv_flow_imp.g_varchar2_table(1980) := '6F6D706F6E656E7457696C6C4C656176652865297B746869732E7265662E63757272656E742E7374796C652E6F7061636974793D2230222C746869732E7265662E63757272656E742E7374796C652E7472616E73666F726D3D227472616E736C61746559';
wwv_flow_imp.g_varchar2_table(1981) := '283335302529222C73657454696D656F757428652C6B67297D72656E64657228297B6C65747B6368696C6472656E3A657D3D746869732E70726F70733B72657475726E20752822646976222C7B636C6173734E616D653A22757070792D496E666F726D65';
wwv_flow_imp.g_varchar2_table(1982) := '722D616E696D61746564222C7265663A746869732E7265667D2C65297D7D3B6E28496F2C2246616465496E22293B66756E6374696F6E206B3228692C65297B72657475726E204F626A6563742E61737369676E28692C65297D6E286B322C226173736967';
wwv_flow_imp.g_varchar2_table(1983) := '6E22293B66756E6374696F6E20443228692C65297B76617220743B72657475726E28743D693F2E6B657929213D6E756C6C3F743A657D6E2844322C226765744B657922293B66756E6374696F6E20493228692C65297B6C657420743D692E5F7074674C69';
wwv_flow_imp.g_varchar2_table(1984) := '6E6B6564526566737C7C28692E5F7074674C696E6B6564526566733D7B7D293B72657475726E20745B655D7C7C28745B655D3D723D3E7B692E726566735B655D3D727D297D6E2849322C226C696E6B52656622293B66756E6374696F6E2074612869297B';
wwv_flow_imp.g_varchar2_table(1985) := '6C657420653D7B7D3B666F72286C657420743D303B743C692E6C656E6774683B742B2B29696628695B745D213D6E756C6C297B6C657420723D443228695B745D2C742E746F537472696E6728333629293B655B725D3D695B745D7D72657475726E20657D';
wwv_flow_imp.g_varchar2_table(1986) := '6E2874612C226765744368696C644D617070696E6722293B66756E6374696F6E204D3228692C65297B693D697C7C7B7D2C653D657C7C7B7D3B6C657420743D6E28613D3E652E6861734F776E50726F70657274792861293F655B615D3A695B615D2C2267';
wwv_flow_imp.g_varchar2_table(1987) := '657456616C7565466F724B657922292C723D7B7D2C733D5B5D3B666F72286C6574206120696E206929652E6861734F776E50726F70657274792861293F732E6C656E677468262628725B615D3D732C733D5B5D293A732E707573682861293B6C6574206F';
wwv_flow_imp.g_varchar2_table(1988) := '3D7B7D3B666F72286C6574206120696E2065297B696628722E6861734F776E50726F706572747928612929666F72286C6574206C3D303B6C3C725B615D2E6C656E6774683B6C2B2B297B6C657420683D725B615D5B6C5D3B6F5B725B615D5B6C5D5D3D74';
wwv_flow_imp.g_varchar2_table(1989) := '2868297D6F5B615D3D742861297D666F72286C657420613D303B613C732E6C656E6774683B612B2B296F5B735B615D5D3D7428735B615D293B72657475726E206F7D6E284D322C226D657267654368696C644D617070696E677322293B766172204E323D';
wwv_flow_imp.g_varchar2_table(1990) := '6E28693D3E692C226964656E7469747922292C69613D636C61737320657874656E64732077657B636F6E7374727563746F7228652C74297B737570657228652C74292C746869732E726566733D7B7D2C746869732E73746174653D7B6368696C6472656E';
wwv_flow_imp.g_varchar2_table(1991) := '3A746128706928706928746869732E70726F70732E6368696C6472656E29297C7C5B5D297D2C746869732E706572666F726D4170706561723D746869732E706572666F726D4170706561722E62696E642874686973292C746869732E706572666F726D45';
wwv_flow_imp.g_varchar2_table(1992) := '6E7465723D746869732E706572666F726D456E7465722E62696E642874686973292C746869732E706572666F726D4C656176653D746869732E706572666F726D4C656176652E62696E642874686973297D636F6D706F6E656E7457696C6C4D6F756E7428';
wwv_flow_imp.g_varchar2_table(1993) := '297B746869732E63757272656E746C795472616E736974696F6E696E674B6579733D7B7D2C746869732E6B657973546F41626F72744C656176653D5B5D2C746869732E6B657973546F456E7465723D5B5D2C746869732E6B657973546F4C656176653D5B';
wwv_flow_imp.g_varchar2_table(1994) := '5D7D636F6D706F6E656E744469644D6F756E7428297B6C657420653D746869732E73746174652E6368696C6472656E3B666F72286C6574207420696E206529655B745D2626746869732E706572666F726D4170706561722874297D636F6D706F6E656E74';
wwv_flow_imp.g_varchar2_table(1995) := '57696C6C5265636569766550726F70732865297B6C657420743D746128706928652E6368696C6472656E297C7C5B5D292C723D746869732E73746174652E6368696C6472656E3B746869732E7365745374617465286F3D3E287B6368696C6472656E3A4D';
wwv_flow_imp.g_varchar2_table(1996) := '32286F2E6368696C6472656E2C74297D29293B6C657420733B666F72287320696E207429696628742E6861734F776E50726F7065727479287329297B6C6574206F3D722626722E6861734F776E50726F70657274792873293B745B735D26266F26267468';
wwv_flow_imp.g_varchar2_table(1997) := '69732E63757272656E746C795472616E736974696F6E696E674B6579735B735D3F28746869732E6B657973546F456E7465722E707573682873292C746869732E6B657973546F41626F72744C656176652E70757368287329293A745B735D2626216F2626';
wwv_flow_imp.g_varchar2_table(1998) := '21746869732E63757272656E746C795472616E736974696F6E696E674B6579735B735D2626746869732E6B657973546F456E7465722E707573682873297D666F72287320696E207229696628722E6861734F776E50726F7065727479287329297B6C6574';
wwv_flow_imp.g_varchar2_table(1999) := '206F3D742626742E6861734F776E50726F70657274792873293B725B735D2626216F262621746869732E63757272656E746C795472616E736974696F6E696E674B6579735B735D2626746869732E6B657973546F4C656176652E707573682873297D7D63';
wwv_flow_imp.g_varchar2_table(2000) := '6F6D706F6E656E7444696455706461746528297B6C65747B6B657973546F456E7465723A657D3D746869733B746869732E6B657973546F456E7465723D5B5D2C652E666F724561636828746869732E706572666F726D456E746572293B6C65747B6B6579';
wwv_flow_imp.g_varchar2_table(2001) := '73546F4C656176653A747D3D746869733B746869732E6B657973546F4C656176653D5B5D2C742E666F724561636828746869732E706572666F726D4C65617665297D5F66696E69736841626F72742865297B6C657420743D746869732E6B657973546F41';
wwv_flow_imp.g_varchar2_table(2002) := '626F72744C656176652E696E6465784F662865293B74213D3D2D312626746869732E6B657973546F41626F72744C656176652E73706C69636528742C31297D706572666F726D4170706561722865297B746869732E63757272656E746C795472616E7369';
wwv_flow_imp.g_varchar2_table(2003) := '74696F6E696E674B6579735B655D3D21303B6C657420743D746869732E726566735B655D3B74213D6E756C6C2626742E636F6D706F6E656E7457696C6C4170706561723F742E636F6D706F6E656E7457696C6C41707065617228746869732E5F68616E64';
wwv_flow_imp.g_varchar2_table(2004) := '6C65446F6E65417070656172696E672E62696E6428746869732C6529293A746869732E5F68616E646C65446F6E65417070656172696E672865297D5F68616E646C65446F6E65417070656172696E672865297B6C657420743D746869732E726566735B65';
wwv_flow_imp.g_varchar2_table(2005) := '5D3B74213D6E756C6C2626742E636F6D706F6E656E744469644170706561722626742E636F6D706F6E656E7444696441707065617228292C64656C65746520746869732E63757272656E746C795472616E736974696F6E696E674B6579735B655D2C7468';
wwv_flow_imp.g_varchar2_table(2006) := '69732E5F66696E69736841626F72742865293B6C657420723D746128706928746869732E70726F70732E6368696C6472656E297C7C5B5D293B2821727C7C21722E6861734F776E50726F7065727479286529292626746869732E706572666F726D4C6561';
wwv_flow_imp.g_varchar2_table(2007) := '76652865297D706572666F726D456E7465722865297B746869732E63757272656E746C795472616E736974696F6E696E674B6579735B655D3D21303B6C657420743D746869732E726566735B655D3B74213D6E756C6C2626742E636F6D706F6E656E7457';
wwv_flow_imp.g_varchar2_table(2008) := '696C6C456E7465723F742E636F6D706F6E656E7457696C6C456E74657228746869732E5F68616E646C65446F6E65456E746572696E672E62696E6428746869732C6529293A746869732E5F68616E646C65446F6E65456E746572696E672865297D5F6861';
wwv_flow_imp.g_varchar2_table(2009) := '6E646C65446F6E65456E746572696E672865297B6C657420743D746869732E726566735B655D3B74213D6E756C6C2626742E636F6D706F6E656E74446964456E7465722626742E636F6D706F6E656E74446964456E74657228292C64656C657465207468';
wwv_flow_imp.g_varchar2_table(2010) := '69732E63757272656E746C795472616E736974696F6E696E674B6579735B655D2C746869732E5F66696E69736841626F72742865293B6C657420723D746128706928746869732E70726F70732E6368696C6472656E297C7C5B5D293B2821727C7C21722E';
wwv_flow_imp.g_varchar2_table(2011) := '6861734F776E50726F7065727479286529292626746869732E706572666F726D4C656176652865297D706572666F726D4C656176652865297B696628746869732E6B657973546F41626F72744C656176652E696E6465784F66286529213D3D2D31297265';
wwv_flow_imp.g_varchar2_table(2012) := '7475726E3B746869732E63757272656E746C795472616E736974696F6E696E674B6579735B655D3D21303B6C657420723D746869732E726566735B655D3B72213D6E756C6C2626722E636F6D706F6E656E7457696C6C4C656176653F722E636F6D706F6E';
wwv_flow_imp.g_varchar2_table(2013) := '656E7457696C6C4C6561766528746869732E5F68616E646C65446F6E654C656176696E672E62696E6428746869732C6529293A746869732E5F68616E646C65446F6E654C656176696E672865297D5F68616E646C65446F6E654C656176696E672865297B';
wwv_flow_imp.g_varchar2_table(2014) := '696628746869732E6B657973546F41626F72744C656176652E696E6465784F66286529213D3D2D312972657475726E3B6C657420723D746869732E726566735B655D3B72213D6E756C6C2626722E636F6D706F6E656E744469644C656176652626722E63';
wwv_flow_imp.g_varchar2_table(2015) := '6F6D706F6E656E744469644C6561766528292C64656C65746520746869732E63757272656E746C795472616E736974696F6E696E674B6579735B655D3B6C657420733D746128706928746869732E70726F70732E6368696C6472656E297C7C5B5D293B69';
wwv_flow_imp.g_varchar2_table(2016) := '6628732626732E6861734F776E50726F706572747928652929746869732E706572666F726D456E7465722865293B656C73657B6C6574206F3D6B32287B7D2C746869732E73746174652E6368696C6472656E293B64656C657465206F5B655D2C74686973';
wwv_flow_imp.g_varchar2_table(2017) := '2E7365745374617465287B6368696C6472656E3A6F7D297D7D72656E64657228652C74297B6C65747B6368696C64466163746F72793A722C7472616E736974696F6E4C656176653A732C7472616E736974696F6E4E616D653A6F2C7472616E736974696F';
wwv_flow_imp.g_varchar2_table(2018) := '6E4170706561723A612C7472616E736974696F6E456E7465723A6C2C7472616E736974696F6E4C6561766554696D656F75743A682C7472616E736974696F6E456E74657254696D656F75743A632C7472616E736974696F6E41707065617254696D656F75';
wwv_flow_imp.g_varchar2_table(2019) := '743A642C636F6D706F6E656E743A662C2E2E2E797D3D652C7B6368696C6472656E3A627D3D742C533D4F626A6563742E656E74726965732862292E6D617028453D3E7B6C65745B462C785D3D453B69662821782972657475726E3B6C657420553D493228';
wwv_flow_imp.g_varchar2_table(2020) := '746869732C46293B72657475726E206A6C28722878292C7B7265663A552C6B65793A467D297D292E66696C74657228426F6F6C65616E293B72657475726E207528662C792C53297D7D3B6E2869612C225472616E736974696F6E47726F757022293B6961';
wwv_flow_imp.g_varchar2_table(2021) := '2E64656661756C7450726F70733D7B636F6D706F6E656E743A227370616E222C6368696C64466163746F72793A4E327D3B7661722044673D69613B766172204C323D7B76657273696F6E3A22332E302E34227D2C71693D636C61737320657874656E6473';
wwv_flow_imp.g_varchar2_table(2022) := '205A7B636F6E7374727563746F7228652C74297B737570657228652C74292C746869732E72656E6465723D733D3E752822646976222C7B636C6173734E616D653A227570707920757070792D496E666F726D6572227D2C752844672C6E756C6C2C732E69';
wwv_flow_imp.g_varchar2_table(2023) := '6E666F2E6D6170286F3D3E7528496F2C7B6B65793A6F2E6D6573736167657D2C75282270222C7B726F6C653A22616C657274227D2C6F2E6D6573736167652C2220222C6F2E64657461696C7326267528227370616E222C7B22617269612D6C6162656C22';
wwv_flow_imp.g_varchar2_table(2024) := '3A6F2E64657461696C732C22646174612D6D6963726F7469702D706F736974696F6E223A22746F702D6C656674222C22646174612D6D6963726F7469702D73697A65223A226D656469756D222C726F6C653A22746F6F6C746970222C6F6E436C69636B3A';
wwv_flow_imp.g_varchar2_table(2025) := '28293D3E616C6572742860247B6F2E6D6573736167657D200A0A20247B6F2E64657461696C737D60297D2C223F222929292929292C746869732E747970653D2270726F6772657373696E64696361746F72222C746869732E69643D746869732E6F707473';
wwv_flow_imp.g_varchar2_table(2026) := '2E69647C7C22496E666F726D6572222C746869732E7469746C653D22496E666F726D6572223B6C657420723D7B7D3B746869732E6F7074733D7B2E2E2E722C2E2E2E747D7D696E7374616C6C28297B6C65747B7461726765743A657D3D746869732E6F70';
wwv_flow_imp.g_varchar2_table(2027) := '74733B652626746869732E6D6F756E7428652C74686973297D7D3B6E2871692C22496E666F726D657222293B71692E56455253494F4E3D4C322E76657273696F6E3B7661722042323D2F5E646174613A285B5E2F5D2B5C2F5B5E2C3B5D2B283F3A5B5E2C';
wwv_flow_imp.g_varchar2_table(2028) := '5D2A3F2929283B626173653634293F2C285B5C735C535D2A29242F3B66756E6374696F6E20706428692C652C74297B76617220722C733B6C6574206F3D42322E657865632869292C613D28723D28733D652E6D696D655479706529213D6E756C6C3F733A';
wwv_flow_imp.g_varchar2_table(2029) := '6F3F2E5B315D29213D6E756C6C3F723A22706C61696E2F74657874222C6C3B6966286F3F2E5B325D213D6E756C6C297B6C657420683D61746F62286465636F6465555249436F6D706F6E656E74286F5B335D29292C633D6E65772055696E743841727261';
wwv_flow_imp.g_varchar2_table(2030) := '7928682E6C656E677468293B666F72286C657420643D303B643C682E6C656E6774683B642B2B29635B645D3D682E63686172436F646541742864293B6C3D5B635D7D656C7365206F3F2E5B335D213D6E756C6C2626286C3D5B6465636F6465555249436F';
wwv_flow_imp.g_varchar2_table(2031) := '6D706F6E656E74286F5B335D295D293B72657475726E20743F6E65772046696C65286C2C652E6E616D657C7C22222C7B747970653A617D293A6E657720426C6F62286C2C7B747970653A617D297D6E2870642C2264617461555249746F426C6F6222293B';
wwv_flow_imp.g_varchar2_table(2032) := '66756E6374696F6E2079752869297B72657475726E20692E737461727473576974682822626C6F623A22297D6E2879752C2269734F626A65637455524C22293B66756E6374696F6E20676528692C652C74297B72657475726E206520696E20693F4F626A';
wwv_flow_imp.g_varchar2_table(2033) := '6563742E646566696E6550726F706572747928692C652C7B76616C75653A742C656E756D657261626C653A21302C636F6E666967757261626C653A21302C7772697461626C653A21307D293A695B655D3D742C697D6E2867652C226522293B7661722024';
wwv_flow_imp.g_varchar2_table(2034) := '673D747970656F662073656C663C2275223F73656C663A676C6F62616C2C61613D747970656F66206E6176696761746F723C2275222C7A323D61612626747970656F662048544D4C496D616765456C656D656E743E2275222C49673D2128747970656F66';
wwv_flow_imp.g_varchar2_table(2035) := '20676C6F62616C3E2275227C7C747970656F662070726F636573733E2275227C7C2170726F636573732E76657273696F6E737C7C2170726F636573732E76657273696F6E732E6E6F6465292C71673D24672E4275666665722C56673D212171672C6A323D';
wwv_flow_imp.g_varchar2_table(2036) := '6E28693D3E69213D3D766F696420302C226822293B66756E6374696F6E2057672869297B72657475726E20693D3D3D766F696420307C7C286920696E7374616E63656F66204D61703F692E73697A653D3D3D303A4F626A6563742E76616C756573286929';
wwv_flow_imp.g_varchar2_table(2037) := '2E66696C746572286A32292E6C656E6774683D3D3D30297D6E2857672C226622293B66756E6374696F6E206C742869297B6C657420653D6E6577204572726F722869293B7468726F772064656C65746520652E737461636B2C657D6E286C742C226C2229';
wwv_flow_imp.g_varchar2_table(2038) := '3B66756E6374696F6E204D672869297B6C657420653D66756E6374696F6E2874297B6C657420723D303B72657475726E20742E696664302E656E61626C6564262628722B3D31303234292C742E657869662E656E61626C6564262628722B3D3230343829';
wwv_flow_imp.g_varchar2_table(2039) := '2C742E6D616B65724E6F7465262628722B3D32303438292C742E75736572436F6D6D656E74262628722B3D31303234292C742E6770732E656E61626C6564262628722B3D353132292C742E696E7465726F702E656E61626C6564262628722B3D31303029';
wwv_flow_imp.g_varchar2_table(2040) := '2C742E696664312E656E61626C6564262628722B3D31303234292C722B323034387D2869293B72657475726E20692E6A6669662E656E61626C6564262628652B3D3530292C692E786D702E656E61626C6564262628652B3D326534292C692E697074632E';
wwv_flow_imp.g_varchar2_table(2041) := '656E61626C6564262628652B3D31346533292C692E6963632E656E61626C6564262628652B3D366533292C657D6E284D672C226F22293B7661722066643D6E28693D3E537472696E672E66726F6D43686172436F64652E6170706C79286E756C6C2C6929';
wwv_flow_imp.g_varchar2_table(2042) := '2C227522292C4E673D747970656F6620546578744465636F6465723C2275223F6E657720546578744465636F64657228227574662D3822293A766F696420302C71743D636C6173737B7374617469632066726F6D28652C74297B72657475726E20652069';
wwv_flow_imp.g_varchar2_table(2043) := '6E7374616E63656F6620746869732626652E6C653D3D3D743F653A6E657720717428652C766F696420302C766F696420302C74297D636F6E7374727563746F7228652C743D302C722C73297B696628747970656F6620733D3D22626F6F6C65616E222626';
wwv_flow_imp.g_varchar2_table(2044) := '28746869732E6C653D73292C41727261792E69734172726179286529262628653D6E65772055696E74384172726179286529292C653D3D3D3029746869732E627974654F66667365743D302C746869732E627974654C656E6774683D303B656C73652069';
wwv_flow_imp.g_varchar2_table(2045) := '66286520696E7374616E63656F66204172726179427566666572297B723D3D3D766F69642030262628723D652E627974654C656E6774682D74293B6C6574206F3D6E657720446174615669657728652C742C72293B746869732E5F737761704461746156';
wwv_flow_imp.g_varchar2_table(2046) := '696577286F297D656C7365206966286520696E7374616E63656F662055696E743841727261797C7C6520696E7374616E63656F662044617461566965777C7C6520696E7374616E63656F66207174297B723D3D3D766F69642030262628723D652E627974';
wwv_flow_imp.g_varchar2_table(2047) := '654C656E6774682D74292C28742B3D652E627974654F6666736574292B723E652E627974654F66667365742B652E627974654C656E67746826266C7428224372656174696E672076696577206F757473696465206F6620617661696C61626C65206D656D';
wwv_flow_imp.g_varchar2_table(2048) := '6F727920696E20417272617942756666657222293B6C6574206F3D6E657720446174615669657728652E6275666665722C742C72293B746869732E5F737761704461746156696577286F297D656C736520696628747970656F6620653D3D226E756D6265';
wwv_flow_imp.g_varchar2_table(2049) := '7222297B6C6574206F3D6E6577204461746156696577286E6577204172726179427566666572286529293B746869732E5F737761704461746156696577286F297D656C7365206C742822496E76616C696420696E70757420617267756D656E7420666F72';
wwv_flow_imp.g_varchar2_table(2050) := '20427566666572566965773A20222B65297D5F7377617041727261794275666665722865297B746869732E5F737761704461746156696577286E6577204461746156696577286529297D5F737761704275666665722865297B746869732E5F7377617044';
wwv_flow_imp.g_varchar2_table(2051) := '61746156696577286E657720446174615669657728652E6275666665722C652E627974654F66667365742C652E627974654C656E67746829297D5F7377617044617461566965772865297B746869732E64617461566965773D652C746869732E62756666';
wwv_flow_imp.g_varchar2_table(2052) := '65723D652E6275666665722C746869732E627974654F66667365743D652E627974654F66667365742C746869732E627974654C656E6774683D652E627974654C656E6774687D5F6C656E677468546F456E642865297B72657475726E20746869732E6279';
wwv_flow_imp.g_varchar2_table(2053) := '74654C656E6774682D657D73657428652C742C723D7174297B72657475726E206520696E7374616E63656F662044617461566965777C7C6520696E7374616E63656F662071743F653D6E65772055696E7438417272617928652E6275666665722C652E62';
wwv_flow_imp.g_varchar2_table(2054) := '7974654F66667365742C652E627974654C656E677468293A6520696E7374616E63656F66204172726179427566666572262628653D6E65772055696E74384172726179286529292C6520696E7374616E63656F662055696E743841727261797C7C6C7428';
wwv_flow_imp.g_varchar2_table(2055) := '22427566666572566965772E73657428293A20496E76616C6964206461746120617267756D656E742E22292C746869732E746F55696E743828292E73657428652C74292C6E6577207228746869732C742C652E627974654C656E677468297D7375626172';
wwv_flow_imp.g_varchar2_table(2056) := '72617928652C74297B72657475726E20743D747C7C746869732E5F6C656E677468546F456E642865292C6E657720717428746869732C652C74297D746F55696E743828297B72657475726E206E65772055696E7438417272617928746869732E62756666';
wwv_flow_imp.g_varchar2_table(2057) := '65722C746869732E627974654F66667365742C746869732E627974654C656E677468297D67657455696E7438417272617928652C74297B72657475726E206E65772055696E7438417272617928746869732E6275666665722C746869732E627974654F66';
wwv_flow_imp.g_varchar2_table(2058) := '667365742B652C74297D676574537472696E6728653D302C743D746869732E627974654C656E677468297B72657475726E20733D746869732E67657455696E7438417272617928652C74292C4E673F4E672E6465636F64652873293A56673F4275666665';
wwv_flow_imp.g_varchar2_table(2059) := '722E66726F6D2873292E746F537472696E6728227574663822293A6465636F6465555249436F6D706F6E656E742865736361706528666428732929293B76617220737D6765744C6174696E31537472696E6728653D302C743D746869732E627974654C65';
wwv_flow_imp.g_varchar2_table(2060) := '6E677468297B6C657420723D746869732E67657455696E7438417272617928652C74293B72657475726E2066642872297D676574556E69636F6465537472696E6728653D302C743D746869732E627974654C656E677468297B6C657420723D5B5D3B666F';
wwv_flow_imp.g_varchar2_table(2061) := '72286C657420733D303B733C742626652B733C746869732E627974654C656E6774683B732B3D3229722E7075736828746869732E67657455696E74313628652B7329293B72657475726E2066642872297D676574496E74382865297B72657475726E2074';
wwv_flow_imp.g_varchar2_table(2062) := '6869732E64617461566965772E676574496E74382865297D67657455696E74382865297B72657475726E20746869732E64617461566965772E67657455696E74382865297D676574496E74313628652C743D746869732E6C65297B72657475726E207468';
wwv_flow_imp.g_varchar2_table(2063) := '69732E64617461566965772E676574496E74313628652C74297D676574496E74333228652C743D746869732E6C65297B72657475726E20746869732E64617461566965772E676574496E74333228652C74297D67657455696E74313628652C743D746869';
wwv_flow_imp.g_varchar2_table(2064) := '732E6C65297B72657475726E20746869732E64617461566965772E67657455696E74313628652C74297D67657455696E74333228652C743D746869732E6C65297B72657475726E20746869732E64617461566965772E67657455696E74333228652C7429';
wwv_flow_imp.g_varchar2_table(2065) := '7D676574466C6F6174333228652C743D746869732E6C65297B72657475726E20746869732E64617461566965772E676574466C6F6174333228652C74297D676574466C6F6174363428652C743D746869732E6C65297B72657475726E20746869732E6461';
wwv_flow_imp.g_varchar2_table(2066) := '7461566965772E676574466C6F6174363428652C74297D676574466C6F617428652C743D746869732E6C65297B72657475726E20746869732E64617461566965772E676574466C6F6174333228652C74297D676574446F75626C6528652C743D74686973';
wwv_flow_imp.g_varchar2_table(2067) := '2E6C65297B72657475726E20746869732E64617461566965772E676574466C6F6174363428652C74297D67657455696E74427974657328652C742C72297B7377697463682874297B6361736520313A72657475726E20746869732E67657455696E743828';
wwv_flow_imp.g_varchar2_table(2068) := '652C72293B6361736520323A72657475726E20746869732E67657455696E74313628652C72293B6361736520343A72657475726E20746869732E67657455696E74333228652C72293B6361736520383A72657475726E20746869732E67657455696E7436';
wwv_flow_imp.g_varchar2_table(2069) := '342626746869732E67657455696E74363428652C72297D7D67657455696E7428652C742C72297B7377697463682874297B6361736520383A72657475726E20746869732E67657455696E743828652C72293B636173652031363A72657475726E20746869';
wwv_flow_imp.g_varchar2_table(2070) := '732E67657455696E74313628652C72293B636173652033323A72657475726E20746869732E67657455696E74333228652C72293B636173652036343A72657475726E20746869732E67657455696E7436342626746869732E67657455696E74363428652C';
wwv_flow_imp.g_varchar2_table(2071) := '72297D7D746F537472696E672865297B72657475726E20746869732E64617461566965772E746F537472696E6728652C746869732E636F6E7374727563746F722E6E616D65297D656E737572654368756E6B28297B7D7D3B6E2871742C226322293B6675';
wwv_flow_imp.g_varchar2_table(2072) := '6E6374696F6E20676428692C65297B6C742860247B697D2027247B657D2720776173206E6F74206C6F616465642C20747279207573696E672066756C6C206275696C64206F662065786966722E60297D6E2867642C227022293B766172207A6F3D636C61';
wwv_flow_imp.g_varchar2_table(2073) := '737320657874656E6473204D61707B636F6E7374727563746F722865297B737570657228292C746869732E6B696E643D657D67657428652C74297B72657475726E20746869732E6861732865297C7C676428746869732E6B696E642C65292C7426262865';
wwv_flow_imp.g_varchar2_table(2074) := '20696E20747C7C66756E6374696F6E28722C73297B6C742860556E6B6E6F776E20247B727D2027247B737D272E60297D28746869732E6B696E642C65292C745B655D2E656E61626C65647C7C676428746869732E6B696E642C6529292C73757065722E67';
wwv_flow_imp.g_varchar2_table(2075) := '65742865297D6B65794C69737428297B72657475726E2041727261792E66726F6D28746869732E6B6579732829297D7D3B6E287A6F2C226722293B7661722078753D6E6577207A6F282266696C652070617273657222292C74693D6E6577207A6F282273';
wwv_flow_imp.g_varchar2_table(2076) := '65676D656E742070617273657222292C68613D6E6577207A6F282266696C652072656164657222292C48323D24672E66657463683B66756E6374696F6E204C6728692C65297B72657475726E28743D69292E737461727473576974682822646174613A22';
wwv_flow_imp.g_varchar2_table(2077) := '297C7C742E6C656E6774683E3165343F766428692C652C2262617365363422293A49672626692E696E636C7564657328223A2F2F22293F796428692C652C2275726C222C5F75293A49673F766428692C652C22667322293A61613F796428692C652C2275';
wwv_flow_imp.g_varchar2_table(2078) := '726C222C5F75293A766F6964206C742822496E76616C696420696E70757420617267756D656E7422293B76617220747D6E284C672C226B22293B6173796E632066756E6374696F6E20796428692C652C742C72297B72657475726E2068612E6861732874';
wwv_flow_imp.g_varchar2_table(2079) := '293F766428692C652C74293A723F6173796E632066756E6374696F6E28732C6F297B6C657420613D6177616974206F2873293B72657475726E206E65772071742861297D28692C72293A766F6964206C74286050617273657220247B747D206973206E6F';
wwv_flow_imp.g_varchar2_table(2080) := '74206C6F6164656460297D6E2879642C224F22293B6173796E632066756E6374696F6E20766428692C652C74297B6C657420723D6E65772868612E6765742874292928692C65293B72657475726E20617761697420722E7265616428292C727D6E287664';
wwv_flow_imp.g_varchar2_table(2081) := '2C227622293B766172205F753D6E28693D3E48322869292E7468656E28653D3E652E61727261794275666665722829292C225322292C6C613D6E28693D3E6E65772050726F6D6973652828652C74293D3E7B6C657420723D6E65772046696C6552656164';
wwv_flow_imp.g_varchar2_table(2082) := '65723B722E6F6E6C6F6164656E643D28293D3E6528722E726573756C747C7C6E6577204172726179427566666572292C722E6F6E6572726F723D742C722E72656164417341727261794275666665722869297D292C224122292C76753D636C6173732065';
wwv_flow_imp.g_varchar2_table(2083) := '7874656E6473204D61707B676574207461674B65797328297B72657475726E20746869732E616C6C4B6579737C7C28746869732E616C6C4B6579733D41727261792E66726F6D28746869732E6B657973282929292C746869732E616C6C4B6579737D6765';
wwv_flow_imp.g_varchar2_table(2084) := '742074616756616C75657328297B72657475726E20746869732E616C6C56616C7565737C7C28746869732E616C6C56616C7565733D41727261792E66726F6D28746869732E76616C756573282929292C746869732E616C6C56616C7565737D7D3B6E2876';
wwv_flow_imp.g_varchar2_table(2085) := '752C225522293B66756E6374696F6E20476728692C652C74297B6C657420723D6E65772076753B666F72286C65745B732C6F5D6F66207429722E73657428732C6F293B69662841727261792E6973417272617928652929666F72286C65742073206F6620';
wwv_flow_imp.g_varchar2_table(2086) := '6529692E73657428732C72293B656C736520692E73657428652C72293B72657475726E20727D6E2847672C227822293B66756E6374696F6E204B6728692C652C74297B6C657420722C733D692E6765742865293B666F722872206F66207429732E736574';
wwv_flow_imp.g_varchar2_table(2087) := '28725B305D2C725B315D297D6E284B672C224322293B7661722064613D6E6577204D61702C62643D6E6577204D61702C77643D6E6577204D61702C4D6F3D5B226368756E6B6564222C2266697273744368756E6B53697A65222C2266697273744368756E';
wwv_flow_imp.g_varchar2_table(2088) := '6B53697A654E6F6465222C2266697273744368756E6B53697A6542726F77736572222C226368756E6B53697A65222C226368756E6B4C696D6974225D2C45753D5B226A666966222C22786D70222C22696363222C2269707463222C2269686472225D2C75';
wwv_flow_imp.g_varchar2_table(2089) := '613D5B2274696666222C2E2E2E45755D2C59653D5B2269666430222C2269666431222C2265786966222C22677073222C22696E7465726F70225D2C4E6F3D5B2E2E2E75612C2E2E2E59655D2C4C6F3D5B226D616B65724E6F7465222C2275736572436F6D';
wwv_flow_imp.g_varchar2_table(2090) := '6D656E74225D2C43753D5B227472616E736C6174654B657973222C227472616E736C61746556616C756573222C2272657669766556616C756573222C226D756C74695365676D656E74225D2C426F3D5B2E2E2E43752C2273616E6974697A65222C226D65';
wwv_flow_imp.g_varchar2_table(2091) := '7267654F7574707574222C2273696C656E744572726F7273225D2C6F613D636C6173737B676574207472616E736C61746528297B72657475726E20746869732E7472616E736C6174654B6579737C7C746869732E7472616E736C61746556616C7565737C';
wwv_flow_imp.g_varchar2_table(2092) := '7C746869732E72657669766556616C7565737D7D3B6E286F612C225F22293B766172205A723D636C61737320657874656E6473206F617B676574206E656564656428297B72657475726E20746869732E656E61626C65647C7C746869732E646570732E73';
wwv_flow_imp.g_varchar2_table(2093) := '697A653E307D636F6E7374727563746F7228652C742C722C73297B696628737570657228292C676528746869732C22656E61626C6564222C2131292C676528746869732C22736B6970222C6E657720536574292C676528746869732C227069636B222C6E';
wwv_flow_imp.g_varchar2_table(2094) := '657720536574292C676528746869732C2264657073222C6E657720536574292C676528746869732C227472616E736C6174654B657973222C2131292C676528746869732C227472616E736C61746556616C756573222C2131292C676528746869732C2272';
wwv_flow_imp.g_varchar2_table(2095) := '657669766556616C756573222C2131292C746869732E6B65793D652C746869732E656E61626C65643D742C746869732E70617273653D746869732E656E61626C65642C746869732E6170706C79496E686572697461626C65732873292C746869732E6361';
wwv_flow_imp.g_varchar2_table(2096) := '6E426546696C74657265643D59652E696E636C756465732865292C746869732E63616E426546696C7465726564262628746869732E646963743D64612E676574286529292C72213D3D766F696420302969662841727261792E6973417272617928722929';
wwv_flow_imp.g_varchar2_table(2097) := '746869732E70617273653D746869732E656E61626C65643D21302C746869732E63616E426546696C74657265642626722E6C656E6774683E302626746869732E7472616E736C61746554616753657428722C746869732E7069636B293B656C7365206966';
wwv_flow_imp.g_varchar2_table(2098) := '28747970656F6620723D3D226F626A65637422297B696628746869732E656E61626C65643D21302C746869732E70617273653D722E7061727365213D3D21312C746869732E63616E426546696C7465726564297B6C65747B7069636B3A6F2C736B69703A';
wwv_flow_imp.g_varchar2_table(2099) := '617D3D723B6F26266F2E6C656E6774683E302626746869732E7472616E736C617465546167536574286F2C746869732E7069636B292C612626612E6C656E6774683E302626746869732E7472616E736C61746554616753657428612C746869732E736B69';
wwv_flow_imp.g_varchar2_table(2100) := '70297D746869732E6170706C79496E686572697461626C65732872297D656C736520723D3D3D21307C7C723D3D3D21313F746869732E70617273653D746869732E656E61626C65643D723A6C742860496E76616C6964206F7074696F6E7320617267756D';
wwv_flow_imp.g_varchar2_table(2101) := '656E743A20247B727D60297D6170706C79496E686572697461626C65732865297B6C657420742C723B666F722874206F6620437529723D655B745D2C72213D3D766F69642030262628746869735B745D3D72297D7472616E736C61746554616753657428';
wwv_flow_imp.g_varchar2_table(2102) := '652C74297B696628746869732E64696374297B6C657420722C732C7B7461674B6579733A6F2C74616756616C7565733A617D3D746869732E646963743B666F722872206F66206529747970656F6620723D3D22737472696E67223F28733D612E696E6465';
wwv_flow_imp.g_varchar2_table(2103) := '784F662872292C733D3D3D2D31262628733D6F2E696E6465784F66284E756D62657228722929292C73213D3D2D312626742E616464284E756D626572286F5B735D2929293A742E6164642872297D656C736520666F72286C65742072206F66206529742E';
wwv_flow_imp.g_varchar2_table(2104) := '6164642872297D66696E616C697A6546696C7465727328297B21746869732E656E61626C65642626746869732E646570732E73697A653E303F28746869732E656E61626C65643D21302C467528746869732E7069636B2C746869732E6465707329293A74';
wwv_flow_imp.g_varchar2_table(2105) := '6869732E656E61626C65642626746869732E7069636B2E73697A653E302626467528746869732E7069636B2C746869732E64657073297D7D3B6E285A722C224422293B766172206B743D7B6A6669663A21312C746966663A21302C786D703A21312C6963';
wwv_flow_imp.g_varchar2_table(2106) := '633A21312C697074633A21312C696664303A21302C696664313A21312C657869663A21302C6770733A21302C696E7465726F703A21312C696864723A766F696420302C6D616B65724E6F74653A21312C75736572436F6D6D656E743A21312C6D756C7469';
wwv_flow_imp.g_varchar2_table(2107) := '5365676D656E743A21312C736B69703A5B5D2C7069636B3A5B5D2C7472616E736C6174654B6579733A21302C7472616E736C61746556616C7565733A21302C72657669766556616C7565733A21302C73616E6974697A653A21302C6D657267654F757470';
wwv_flow_imp.g_varchar2_table(2108) := '75743A21302C73696C656E744572726F72733A21302C6368756E6B65643A21302C66697273744368756E6B53697A653A766F696420302C66697273744368756E6B53697A654E6F64653A3531322C66697273744368756E6B53697A6542726F777365723A';
wwv_flow_imp.g_varchar2_table(2109) := '36353533362C6368756E6B53697A653A36353533362C6368756E6B4C696D69743A357D2C42673D6E6577204D61702C65733D636C61737320657874656E6473206F617B737461746963207573654361636865642865297B6C657420743D42672E67657428';
wwv_flow_imp.g_varchar2_table(2110) := '65293B72657475726E2074213D3D766F696420307C7C28743D6E657720746869732865292C42672E73657428652C7429292C747D636F6E7374727563746F722865297B737570657228292C653D3D3D21303F746869732E736574757046726F6D54727565';
wwv_flow_imp.g_varchar2_table(2111) := '28293A653D3D3D766F696420303F746869732E736574757046726F6D556E646566696E656428293A41727261792E697341727261792865293F746869732E736574757046726F6D41727261792865293A747970656F6620653D3D226F626A656374223F74';
wwv_flow_imp.g_varchar2_table(2112) := '6869732E736574757046726F6D4F626A6563742865293A6C742860496E76616C6964206F7074696F6E7320617267756D656E7420247B657D60292C746869732E66697273744368756E6B53697A653D3D3D766F69642030262628746869732E6669727374';
wwv_flow_imp.g_varchar2_table(2113) := '4368756E6B53697A653D61613F746869732E66697273744368756E6B53697A6542726F777365723A746869732E66697273744368756E6B53697A654E6F6465292C746869732E6D657267654F7574707574262628746869732E696664312E656E61626C65';
wwv_flow_imp.g_varchar2_table(2114) := '643D2131292C746869732E66696C7465724E65737465645365676D656E745461677328292C746869732E747261766572736554696666446570656E64656E63795472656528292C746869732E636865636B4C6F61646564506C7567696E7328297D736574';
wwv_flow_imp.g_varchar2_table(2115) := '757046726F6D556E646566696E656428297B6C657420653B666F722865206F66204D6F29746869735B655D3D6B745B655D3B666F722865206F6620426F29746869735B655D3D6B745B655D3B666F722865206F66204C6F29746869735B655D3D6B745B65';
wwv_flow_imp.g_varchar2_table(2116) := '5D3B666F722865206F66204E6F29746869735B655D3D6E6577205A7228652C6B745B655D2C766F696420302C74686973297D736574757046726F6D5472756528297B6C657420653B666F722865206F66204D6F29746869735B655D3D6B745B655D3B666F';
wwv_flow_imp.g_varchar2_table(2117) := '722865206F6620426F29746869735B655D3D6B745B655D3B666F722865206F66204C6F29746869735B655D3D21303B666F722865206F66204E6F29746869735B655D3D6E6577205A7228652C21302C766F696420302C74686973297D736574757046726F';
wwv_flow_imp.g_varchar2_table(2118) := '6D41727261792865297B6C657420743B666F722874206F66204D6F29746869735B745D3D6B745B745D3B666F722874206F6620426F29746869735B745D3D6B745B745D3B666F722874206F66204C6F29746869735B745D3D6B745B745D3B666F72287420';
wwv_flow_imp.g_varchar2_table(2119) := '6F66204E6F29746869735B745D3D6E6577205A7228742C21312C766F696420302C74686973293B746869732E7365747570476C6F62616C46696C7465727328652C766F696420302C5965297D736574757046726F6D4F626A6563742865297B6C65742074';
wwv_flow_imp.g_varchar2_table(2120) := '3B666F722874206F662859652E696664303D59652E696664307C7C59652E696D6167652C59652E696664313D59652E696664317C7C59652E7468756D626E61696C2C4F626A6563742E61737369676E28746869732C65292C4D6F2929746869735B745D3D';
wwv_flow_imp.g_varchar2_table(2121) := '6D6428655B745D2C6B745B745D293B666F722874206F6620426F29746869735B745D3D6D6428655B745D2C6B745B745D293B666F722874206F66204C6F29746869735B745D3D6D6428655B745D2C6B745B745D293B666F722874206F6620756129746869';
wwv_flow_imp.g_varchar2_table(2122) := '735B745D3D6E6577205A7228742C6B745B745D2C655B745D2C74686973293B666F722874206F6620596529746869735B745D3D6E6577205A7228742C6B745B745D2C655B745D2C746869732E74696666293B746869732E7365747570476C6F62616C4669';
wwv_flow_imp.g_varchar2_table(2123) := '6C7465727328652E7069636B2C652E736B69702C59652C4E6F292C652E746966663D3D3D21303F746869732E6261746368456E61626C6557697468426F6F6C2859652C2130293A652E746966663D3D3D21313F746869732E6261746368456E61626C6557';
wwv_flow_imp.g_varchar2_table(2124) := '6974685573657256616C75652859652C65293A41727261792E6973417272617928652E74696666293F746869732E7365747570476C6F62616C46696C7465727328652E746966662C766F696420302C5965293A747970656F6620652E746966663D3D226F';
wwv_flow_imp.g_varchar2_table(2125) := '626A656374222626746869732E7365747570476C6F62616C46696C7465727328652E746966662E7069636B2C652E746966662E736B69702C5965297D6261746368456E61626C6557697468426F6F6C28652C74297B666F72286C65742072206F66206529';
wwv_flow_imp.g_varchar2_table(2126) := '746869735B725D2E656E61626C65643D747D6261746368456E61626C65576974685573657256616C756528652C74297B666F72286C65742072206F662065297B6C657420733D745B725D3B746869735B725D2E656E61626C65643D73213D3D2131262673';
wwv_flow_imp.g_varchar2_table(2127) := '213D3D766F696420307D7D7365747570476C6F62616C46696C7465727328652C742C722C733D72297B696628652626652E6C656E677468297B666F72286C65742061206F66207329746869735B615D2E656E61626C65643D21313B6C6574206F3D7A6728';
wwv_flow_imp.g_varchar2_table(2128) := '652C72293B666F72286C65745B612C6C5D6F66206F29467528746869735B615D2E7069636B2C6C292C746869735B615D2E656E61626C65643D21307D656C736520696628742626742E6C656E677468297B6C6574206F3D7A6728742C72293B666F72286C';
wwv_flow_imp.g_varchar2_table(2129) := '65745B612C6C5D6F66206F29467528746869735B615D2E736B69702C6C297D7D66696C7465724E65737465645365676D656E745461677328297B6C65747B696664303A652C657869663A742C786D703A722C697074633A732C6963633A6F7D3D74686973';
wwv_flow_imp.g_varchar2_table(2130) := '3B746869732E6D616B65724E6F74653F742E646570732E616464283337353030293A742E736B69702E616464283337353030292C746869732E75736572436F6D6D656E743F742E646570732E616464283337353130293A742E736B69702E616464283337';
wwv_flow_imp.g_varchar2_table(2131) := '353130292C722E656E61626C65647C7C652E736B69702E61646428373030292C732E656E61626C65647C7C652E736B69702E616464283333373233292C6F2E656E61626C65647C7C652E736B69702E616464283334363735297D74726176657273655469';
wwv_flow_imp.g_varchar2_table(2132) := '6666446570656E64656E63795472656528297B6C65747B696664303A652C657869663A742C6770733A722C696E7465726F703A737D3D746869733B732E6E6565646564262628742E646570732E616464283430393635292C652E646570732E6164642834';
wwv_flow_imp.g_varchar2_table(2133) := '3039363529292C742E6E65656465642626652E646570732E616464283334363635292C722E6E65656465642626652E646570732E616464283334383533292C746869732E746966662E656E61626C65643D59652E736F6D65286F3D3E746869735B6F5D2E';
wwv_flow_imp.g_varchar2_table(2134) := '656E61626C65643D3D3D2130297C7C746869732E6D616B65724E6F74657C7C746869732E75736572436F6D6D656E743B666F72286C6574206F206F6620596529746869735B6F5D2E66696E616C697A6546696C7465727328297D676574206F6E6C795469';
wwv_flow_imp.g_varchar2_table(2135) := '666628297B72657475726E2145752E6D617028653D3E746869735B655D2E656E61626C6564292E736F6D6528653D3E653D3D3D2130292626746869732E746966662E656E61626C65647D636865636B4C6F61646564506C7567696E7328297B666F72286C';
wwv_flow_imp.g_varchar2_table(2136) := '65742065206F6620756129746869735B655D2E656E61626C656426262174692E6861732865292626676428227365676D656E7420706172736572222C65297D7D3B6E2865732C225222293B66756E6374696F6E207A6728692C65297B6C657420742C722C';
wwv_flow_imp.g_varchar2_table(2137) := '732C6F2C613D5B5D3B666F722873206F662065297B666F72286F206F6628743D64612E6765742873292C723D5B5D2C74292928692E696E636C75646573286F5B305D297C7C692E696E636C75646573286F5B315D29292626722E70757368286F5B305D29';
wwv_flow_imp.g_varchar2_table(2138) := '3B722E6C656E6774682626612E70757368285B732C725D297D72657475726E20617D6E287A672C224B22293B66756E6374696F6E206D6428692C65297B72657475726E2069213D3D766F696420303F693A65213D3D766F696420303F653A766F69642030';
wwv_flow_imp.g_varchar2_table(2139) := '7D6E286D642C225722293B66756E6374696F6E20467528692C65297B666F72286C65742074206F66206529692E6164642874297D6E2846752C225822293B67652865732C2264656661756C74222C6B74293B7661722054733D636C6173737B636F6E7374';
wwv_flow_imp.g_varchar2_table(2140) := '727563746F722865297B676528746869732C2270617273657273222C7B7D292C676528746869732C226F7574707574222C7B7D292C676528746869732C226572726F7273222C5B5D292C676528746869732C2270757368546F4572726F7273222C743D3E';
wwv_flow_imp.g_varchar2_table(2141) := '746869732E6572726F72732E70757368287429292C746869732E6F7074696F6E733D65732E7573654361636865642865297D6173796E6320726561642865297B746869732E66696C653D61776169742066756E6374696F6E28742C72297B72657475726E';
wwv_flow_imp.g_varchar2_table(2142) := '20747970656F6620743D3D22737472696E67223F4C6728742C72293A61612626217A3226267420696E7374616E63656F662048544D4C496D616765456C656D656E743F4C6728742E7372632C72293A7420696E7374616E63656F662055696E7438417272';
wwv_flow_imp.g_varchar2_table(2143) := '61797C7C7420696E7374616E63656F662041727261794275666665727C7C7420696E7374616E63656F662044617461566965773F6E65772071742874293A616126267420696E7374616E63656F6620426C6F623F796428742C722C22626C6F62222C6C61';
wwv_flow_imp.g_varchar2_table(2144) := '293A766F6964206C742822496E76616C696420696E70757420617267756D656E7422297D28652C746869732E6F7074696F6E73297D736574757028297B696628746869732E66696C655061727365722972657475726E3B6C65747B66696C653A657D3D74';
wwv_flow_imp.g_varchar2_table(2145) := '6869732C743D652E67657455696E7431362830293B666F72286C65745B722C735D6F6620787529696628732E63616E48616E646C6528652C74292972657475726E20746869732E66696C655061727365723D6E6577207328746869732E6F7074696F6E73';
wwv_flow_imp.g_varchar2_table(2146) := '2C746869732E66696C652C746869732E70617273657273292C655B725D3D21303B746869732E66696C652E636C6F73652626746869732E66696C652E636C6F736528292C6C742822556E6B6E6F776E2066696C6520666F726D617422297D6173796E6320';
wwv_flow_imp.g_varchar2_table(2147) := '706172736528297B6C65747B6F75747075743A652C6572726F72733A747D3D746869733B72657475726E20746869732E736574757028292C746869732E6F7074696F6E732E73696C656E744572726F72733F28617761697420746869732E657865637574';
wwv_flow_imp.g_varchar2_table(2148) := '655061727365727328292E636174636828746869732E70757368546F4572726F7273292C742E70757368282E2E2E746869732E66696C655061727365722E6572726F727329293A617761697420746869732E657865637574655061727365727328292C74';
wwv_flow_imp.g_varchar2_table(2149) := '6869732E66696C652E636C6F73652626746869732E66696C652E636C6F736528292C746869732E6F7074696F6E732E73696C656E744572726F72732626742E6C656E6774683E30262628652E6572726F72733D74292C576728723D65293F766F69642030';
wwv_flow_imp.g_varchar2_table(2150) := '3A723B76617220727D6173796E6320657865637574655061727365727328297B6C65747B6F75747075743A657D3D746869733B617761697420746869732E66696C655061727365722E706172736528293B6C657420743D4F626A6563742E76616C756573';
wwv_flow_imp.g_varchar2_table(2151) := '28746869732E70617273657273292E6D6170286173796E6320723D3E7B6C657420733D617761697420722E706172736528293B722E61737369676E546F4F757470757428652C73297D293B746869732E6F7074696F6E732E73696C656E744572726F7273';
wwv_flow_imp.g_varchar2_table(2152) := '262628743D742E6D617028723D3E722E636174636828746869732E70757368546F4572726F72732929292C61776169742050726F6D6973652E616C6C2874297D6173796E6320657874726163745468756D626E61696C28297B746869732E736574757028';
wwv_flow_imp.g_varchar2_table(2153) := '293B6C65747B6F7074696F6E733A652C66696C653A747D3D746869732C723D74692E676574282274696666222C65293B76617220733B696628742E746966663F733D7B73746172743A302C747970653A2274696666227D3A742E6A706567262628733D61';
wwv_flow_imp.g_varchar2_table(2154) := '7761697420746869732E66696C655061727365722E6765744F7246696E645365676D656E742822746966662229292C733D3D3D766F696420302972657475726E3B6C6574206F3D617761697420746869732E66696C655061727365722E656E7375726553';
wwv_flow_imp.g_varchar2_table(2155) := '65676D656E744368756E6B2873292C613D746869732E706172736572732E746966663D6E65772072286F2C652C74292C6C3D617761697420612E657874726163745468756D626E61696C28293B72657475726E20742E636C6F73652626742E636C6F7365';
wwv_flow_imp.g_varchar2_table(2156) := '28292C6C7D7D3B6E2854732C224822293B6173796E632066756E6374696F6E20586728692C65297B6C657420743D6E65772054732865293B72657475726E20617761697420742E726561642869292C742E706172736528297D6E2858672C225922293B76';
wwv_flow_imp.g_varchar2_table(2157) := '61722024323D4F626A6563742E667265657A65287B5F5F70726F746F5F5F3A6E756C6C2C70617273653A58672C45786966723A54732C66696C65506172736572733A78752C7365676D656E74506172736572733A74692C66696C65526561646572733A68';
wwv_flow_imp.g_varchar2_table(2158) := '612C7461674B6579733A64612C74616756616C7565733A62642C74616752657669766572733A77642C63726561746544696374696F6E6172793A47672C657874656E6444696374696F6E6172793A4B672C666574636855726C4173417272617942756666';
wwv_flow_imp.g_varchar2_table(2159) := '65723A5F752C72656164426C6F62417341727261794275666665723A6C612C6368756E6B656450726F70733A4D6F2C6F746865725365676D656E74733A45752C7365676D656E74733A75612C74696666426C6F636B733A59652C7365676D656E7473416E';
wwv_flow_imp.g_varchar2_table(2160) := '64426C6F636B733A4E6F2C746966664578747261637461626C65733A4C6F2C696E686572697461626C65733A43752C616C6C466F726D6174746572733A426F2C4F7074696F6E733A65737D292C45723D636C6173737B7374617469632066696E64506F73';
wwv_flow_imp.g_varchar2_table(2161) := '6974696F6E28652C74297B6C657420723D652E67657455696E74313628742B32292B322C733D747970656F6620746869732E6865616465724C656E6774683D3D2266756E6374696F6E223F746869732E6865616465724C656E67746828652C742C72293A';
wwv_flow_imp.g_varchar2_table(2162) := '746869732E6865616465724C656E6774682C6F3D742B732C613D722D733B72657475726E7B6F66667365743A742C6C656E6774683A722C6865616465724C656E6774683A732C73746172743A6F2C73697A653A612C656E643A6F2B617D7D737461746963';
wwv_flow_imp.g_varchar2_table(2163) := '20706172736528652C743D7B7D297B72657475726E206E6577207468697328652C6E6577206573287B5B746869732E747970655D3A747D292C65292E706172736528297D6E6F726D616C697A65496E7075742865297B72657475726E206520696E737461';
wwv_flow_imp.g_varchar2_table(2164) := '6E63656F662071743F653A6E65772071742865297D636F6E7374727563746F7228652C743D7B7D2C72297B676528746869732C226572726F7273222C5B5D292C676528746869732C22726177222C6E6577204D6170292C676528746869732C2268616E64';
wwv_flow_imp.g_varchar2_table(2165) := '6C654572726F72222C733D3E7B69662821746869732E6F7074696F6E732E73696C656E744572726F7273297468726F7720733B746869732E6572726F72732E7075736828732E6D657373616765297D292C746869732E6368756E6B3D746869732E6E6F72';
wwv_flow_imp.g_varchar2_table(2166) := '6D616C697A65496E7075742865292C746869732E66696C653D722C746869732E747970653D746869732E636F6E7374727563746F722E747970652C746869732E676C6F62616C4F7074696F6E733D746869732E6F7074696F6E733D742C746869732E6C6F';
wwv_flow_imp.g_varchar2_table(2167) := '63616C4F7074696F6E733D745B746869732E747970655D2C746869732E63616E5472616E736C6174653D746869732E6C6F63616C4F7074696F6E732626746869732E6C6F63616C4F7074696F6E732E7472616E736C6174657D7472616E736C6174652829';
wwv_flow_imp.g_varchar2_table(2168) := '7B746869732E63616E5472616E736C617465262628746869732E7472616E736C617465643D746869732E7472616E736C617465426C6F636B28746869732E7261772C746869732E7479706529297D676574206F757470757428297B72657475726E207468';
wwv_flow_imp.g_varchar2_table(2169) := '69732E7472616E736C617465643F746869732E7472616E736C617465643A746869732E7261773F4F626A6563742E66726F6D456E747269657328746869732E726177293A766F696420307D7472616E736C617465426C6F636B28652C74297B6C65742072';
wwv_flow_imp.g_varchar2_table(2170) := '3D77642E6765742874292C733D62642E6765742874292C6F3D64612E6765742874292C613D746869732E6F7074696F6E735B745D2C6C3D612E72657669766556616C75657326262121722C683D612E7472616E736C61746556616C75657326262121732C';
wwv_flow_imp.g_varchar2_table(2171) := '633D612E7472616E736C6174654B657973262621216F2C643D7B7D3B666F72286C65745B662C795D6F662065296C2626722E6861732866293F793D722E6765742866292879293A682626732E686173286629262628793D746869732E7472616E736C6174';
wwv_flow_imp.g_varchar2_table(2172) := '6556616C756528792C732E67657428662929292C6326266F2E686173286629262628663D6F2E6765742866297C7C66292C645B665D3D793B72657475726E20647D7472616E736C61746556616C756528652C74297B72657475726E20745B655D7C7C742E';
wwv_flow_imp.g_varchar2_table(2173) := '44454641554C547C7C657D61737369676E546F4F757470757428652C74297B746869732E61737369676E4F626A656374546F4F757470757428652C746869732E636F6E7374727563746F722E747970652C74297D61737369676E4F626A656374546F4F75';
wwv_flow_imp.g_varchar2_table(2174) := '7470757428652C742C72297B696628746869732E676C6F62616C4F7074696F6E732E6D657267654F75747075742972657475726E204F626A6563742E61737369676E28652C72293B655B745D3F4F626A6563742E61737369676E28655B745D2C72293A65';
wwv_flow_imp.g_varchar2_table(2175) := '5B745D3D727D7D3B6E2845722C224A22293B67652845722C226865616465724C656E677468222C34292C67652845722C2274797065222C766F69642030292C67652845722C226D756C74695365676D656E74222C2131292C67652845722C2263616E4861';
wwv_flow_imp.g_varchar2_table(2176) := '6E646C65222C28293D3E2131293B66756E6374696F6E2071322869297B72657475726E20693D3D3D3139327C7C693D3D3D3139347C7C693D3D3D3139367C7C693D3D3D3231397C7C693D3D3D3232317C7C693D3D3D3231387C7C693D3D3D3235347D6E28';
wwv_flow_imp.g_varchar2_table(2177) := '71322C227122293B66756E6374696F6E2056322869297B72657475726E20693E3D3232342626693C3D3233397D6E2856322C225122293B66756E6374696F6E20573228692C652C74297B666F72286C65745B722C735D6F6620746929696628732E63616E';
wwv_flow_imp.g_varchar2_table(2178) := '48616E646C6528692C652C74292972657475726E20727D6E2857322C225A22293B766172206E613D636C61737320657874656E647320636C6173737B636F6E7374727563746F7228652C742C72297B676528746869732C226572726F7273222C5B5D292C';
wwv_flow_imp.g_varchar2_table(2179) := '676528746869732C22656E737572655365676D656E744368756E6B222C6173796E6320733D3E7B6C6574206F3D732E73746172742C613D732E73697A657C7C36353533363B696628746869732E66696C652E6368756E6B656429696628746869732E6669';
wwv_flow_imp.g_varchar2_table(2180) := '6C652E617661696C61626C65286F2C612929732E6368756E6B3D746869732E66696C652E7375626172726179286F2C61293B656C7365207472797B732E6368756E6B3D617761697420746869732E66696C652E726561644368756E6B286F2C61297D6361';
wwv_flow_imp.g_varchar2_table(2181) := '746368286C297B6C742860436F756C646E27742072656164207365676D656E743A20247B4A534F4E2E737472696E676966792873297D2E20247B6C2E6D6573736167657D60297D656C736520746869732E66696C652E627974654C656E6774683E6F2B61';
wwv_flow_imp.g_varchar2_table(2182) := '3F732E6368756E6B3D746869732E66696C652E7375626172726179286F2C61293A732E73697A653D3D3D766F696420303F732E6368756E6B3D746869732E66696C652E7375626172726179286F293A6C7428225365676D656E7420756E72656163686162';
wwv_flow_imp.g_varchar2_table(2183) := '6C653A20222B4A534F4E2E737472696E67696679287329293B72657475726E20732E6368756E6B7D292C746869732E657874656E644F7074696F6E732626746869732E657874656E644F7074696F6E732865292C746869732E6F7074696F6E733D652C74';
wwv_flow_imp.g_varchar2_table(2184) := '6869732E66696C653D742C746869732E706172736572733D727D696E6A6563745365676D656E7428652C74297B746869732E6F7074696F6E735B655D2E656E61626C65642626746869732E63726561746550617273657228652C74297D63726561746550';
wwv_flow_imp.g_varchar2_table(2185) := '617273657228652C74297B6C657420723D6E65772874692E6765742865292928742C746869732E6F7074696F6E732C746869732E66696C65293B72657475726E20746869732E706172736572735B655D3D727D637265617465506172736572732865297B';
wwv_flow_imp.g_varchar2_table(2186) := '666F72286C65742074206F662065297B6C65747B747970653A722C6368756E6B3A737D3D742C6F3D746869732E6F7074696F6E735B725D3B6966286F26266F2E656E61626C6564297B6C657420613D746869732E706172736572735B725D3B612626612E';
wwv_flow_imp.g_varchar2_table(2187) := '617070656E647C7C617C7C746869732E63726561746550617273657228722C73297D7D7D6173796E6320726561645365676D656E74732865297B6C657420743D652E6D617028746869732E656E737572655365676D656E744368756E6B293B6177616974';
wwv_flow_imp.g_varchar2_table(2188) := '2050726F6D6973652E616C6C2874297D7D7B636F6E7374727563746F72282E2E2E65297B7375706572282E2E2E65292C676528746869732C226170705365676D656E7473222C5B5D292C676528746869732C226A7065675365676D656E7473222C5B5D29';
wwv_flow_imp.g_varchar2_table(2189) := '2C676528746869732C22756E6B6E6F776E5365676D656E7473222C5B5D297D7374617469632063616E48616E646C6528652C74297B72657475726E20743D3D3D36353439367D6173796E6320706172736528297B617761697420746869732E66696E6441';
wwv_flow_imp.g_varchar2_table(2190) := '70705365676D656E747328292C617761697420746869732E726561645365676D656E747328746869732E6170705365676D656E7473292C746869732E6D657267654D756C74695365676D656E747328292C746869732E6372656174655061727365727328';
wwv_flow_imp.g_varchar2_table(2191) := '746869732E6D65726765644170705365676D656E74737C7C746869732E6170705365676D656E7473297D73657475705365676D656E7446696E646572417267732865297B653D3D3D21303F28746869732E66696E64416C6C3D21302C746869732E77616E';
wwv_flow_imp.g_varchar2_table(2192) := '7465643D6E6577205365742874692E6B65794C697374282929293A28653D653D3D3D766F696420303F74692E6B65794C69737428292E66696C74657228743D3E746869732E6F7074696F6E735B745D2E656E61626C6564293A652E66696C74657228743D';
wwv_flow_imp.g_varchar2_table(2193) := '3E746869732E6F7074696F6E735B745D2E656E61626C6564262674692E686173287429292C746869732E66696E64416C6C3D21312C746869732E72656D61696E696E673D6E6577205365742865292C746869732E77616E7465643D6E6577205365742865';
wwv_flow_imp.g_varchar2_table(2194) := '29292C746869732E756E66696E69736865644D756C74695365676D656E743D21317D6173796E632066696E644170705365676D656E747328653D302C74297B746869732E73657475705365676D656E7446696E646572417267732874293B6C65747B6669';
wwv_flow_imp.g_varchar2_table(2195) := '6C653A722C66696E64416C6C3A732C77616E7465643A6F2C72656D61696E696E673A617D3D746869733B69662821732626746869732E66696C652E6368756E6B6564262628733D41727261792E66726F6D286F292E736F6D65286C3D3E7B6C657420683D';
wwv_flow_imp.g_varchar2_table(2196) := '74692E676574286C292C633D746869732E6F7074696F6E735B6C5D3B72657475726E20682E6D756C74695365676D656E742626632E6D756C74695365676D656E747D292C732626617761697420746869732E66696C652E7265616457686F6C652829292C';
wwv_flow_imp.g_varchar2_table(2197) := '653D746869732E66696E644170705365676D656E7473496E52616E676528652C722E627974654C656E677468292C21746869732E6F7074696F6E732E6F6E6C79546966662626722E6368756E6B6564297B6C6574206C3D21313B666F72283B612E73697A';
wwv_flow_imp.g_varchar2_table(2198) := '653E302626216C262628722E63616E526561644E6578744368756E6B7C7C746869732E756E66696E69736865644D756C74695365676D656E74293B297B6C65747B6E6578744368756E6B4F66667365743A687D3D722C633D746869732E6170705365676D';
wwv_flow_imp.g_varchar2_table(2199) := '656E74732E736F6D6528643D3E21746869732E66696C652E617661696C61626C6528642E6F66667365747C7C642E73746172742C642E6C656E6774687C7C642E73697A6529293B6966286C3D653E68262621633F21617761697420722E726561644E6578';
wwv_flow_imp.g_varchar2_table(2200) := '744368756E6B2865293A21617761697420722E726561644E6578744368756E6B2868292C28653D746869732E66696E644170705365676D656E7473496E52616E676528652C722E627974654C656E67746829293D3D3D766F696420302972657475726E7D';
wwv_flow_imp.g_varchar2_table(2201) := '7D7D66696E644170705365676D656E7473496E52616E676528652C74297B742D3D323B6C657420722C732C6F2C612C6C2C682C7B66696C653A632C66696E64416C6C3A642C77616E7465643A662C72656D61696E696E673A792C6F7074696F6E733A627D';
wwv_flow_imp.g_varchar2_table(2202) := '3D746869733B666F72283B653C743B652B2B29696628632E67657455696E74382865293D3D3D323535297B696628723D632E67657455696E743828652B31292C5632287229297B696628733D632E67657455696E74313628652B32292C6F3D573228632C';
wwv_flow_imp.g_varchar2_table(2203) := '652C73292C6F2626662E686173286F29262628613D74692E676574286F292C6C3D612E66696E64506F736974696F6E28632C65292C683D625B6F5D2C6C2E747970653D6F2C746869732E6170705365676D656E74732E70757368286C292C216426262861';
wwv_flow_imp.g_varchar2_table(2204) := '2E6D756C74695365676D656E742626682E6D756C74695365676D656E743F28746869732E756E66696E69736865644D756C74695365676D656E743D6C2E6368756E6B4E756D6265723C6C2E6368756E6B436F756E742C746869732E756E66696E69736865';
wwv_flow_imp.g_varchar2_table(2205) := '644D756C74695365676D656E747C7C792E64656C657465286F29293A792E64656C657465286F292C792E73697A653D3D3D30292929627265616B3B622E7265636F7264556E6B6E6F776E5365676D656E74732626286C3D45722E66696E64506F73697469';
wwv_flow_imp.g_varchar2_table(2206) := '6F6E28632C65292C6C2E6D61726B65723D722C746869732E756E6B6E6F776E5365676D656E74732E70757368286C29292C652B3D732B317D656C7365206966287132287229297B696628733D632E67657455696E74313628652B32292C723D3D3D323138';
wwv_flow_imp.g_varchar2_table(2207) := '2626622E73746F704166746572536F73213D3D21312972657475726E3B622E7265636F72644A7065675365676D656E74732626746869732E6A7065675365676D656E74732E70757368287B6F66667365743A652C6C656E6774683A732C6D61726B65723A';
wwv_flow_imp.g_varchar2_table(2208) := '727D292C652B3D732B317D7D72657475726E20657D6D657267654D756C74695365676D656E747328297B69662821746869732E6170705365676D656E74732E736F6D6528743D3E742E6D756C74695365676D656E74292972657475726E3B6C657420653D';
wwv_flow_imp.g_varchar2_table(2209) := '66756E6374696F6E28742C72297B6C657420732C6F2C612C6C3D6E6577204D61703B666F72286C657420683D303B683C742E6C656E6774683B682B2B29733D745B685D2C6F3D735B725D2C6C2E686173286F293F613D6C2E676574286F293A6C2E736574';
wwv_flow_imp.g_varchar2_table(2210) := '286F2C613D5B5D292C612E707573682873293B72657475726E2041727261792E66726F6D286C297D28746869732E6170705365676D656E74732C227479706522293B746869732E6D65726765644170705365676D656E74733D652E6D617028285B742C72';
wwv_flow_imp.g_varchar2_table(2211) := '5D293D3E7B6C657420733D74692E67657428742C746869732E6F7074696F6E73293B72657475726E20732E68616E646C654D756C74695365676D656E74733F7B747970653A742C6368756E6B3A732E68616E646C654D756C74695365676D656E74732872';
wwv_flow_imp.g_varchar2_table(2212) := '297D3A725B305D7D297D6765745365676D656E742865297B72657475726E20746869732E6170705365676D656E74732E66696E6428743D3E742E747970653D3D3D65297D6173796E63206765744F7246696E645365676D656E742865297B6C657420743D';
wwv_flow_imp.g_varchar2_table(2213) := '746869732E6765745365676D656E742865293B72657475726E20743D3D3D766F69642030262628617761697420746869732E66696E644170705365676D656E747328302C5B655D292C743D746869732E6765745365676D656E74286529292C747D7D3B6E';
wwv_flow_imp.g_varchar2_table(2214) := '286E612C22656522293B6765286E612C2274797065222C226A70656722292C78752E73657428226A706567222C6E61293B7661722047323D5B766F696420302C312C312C322C342C382C312C312C322C342C382C342C382C345D2C62753D636C61737320';
wwv_flow_imp.g_varchar2_table(2215) := '657874656E64732045727B706172736548656164657228297B76617220653D746869732E6368756E6B2E67657455696E74313628293B653D3D3D31383736313F746869732E6C653D21303A653D3D3D3139373839262628746869732E6C653D2131292C74';
wwv_flow_imp.g_varchar2_table(2216) := '6869732E6368756E6B2E6C653D746869732E6C652C746869732E6865616465725061727365643D21307D70617273655461677328652C742C723D6E6577204D6170297B6C65747B7069636B3A732C736B69703A6F7D3D746869732E6F7074696F6E735B74';
wwv_flow_imp.g_varchar2_table(2217) := '5D3B733D6E6577205365742873293B6C657420613D732E73697A653E302C6C3D6F2E73697A653D3D3D302C683D746869732E6368756E6B2E67657455696E7431362865293B652B3D323B666F72286C657420633D303B633C683B632B2B297B6C65742064';
wwv_flow_imp.g_varchar2_table(2218) := '3D746869732E6368756E6B2E67657455696E7431362865293B69662861297B696628732E686173286429262628722E73657428642C746869732E706172736554616728652C642C7429292C732E64656C6574652864292C732E73697A653D3D3D30292962';
wwv_flow_imp.g_varchar2_table(2219) := '7265616B7D656C7365216C26266F2E6861732864297C7C722E73657428642C746869732E706172736554616728652C642C7429293B652B3D31327D72657475726E20727D706172736554616728652C742C72297B6C65747B6368756E6B3A737D3D746869';
wwv_flow_imp.g_varchar2_table(2220) := '732C6F3D732E67657455696E74313628652B32292C613D732E67657455696E74333228652B34292C6C3D47325B6F5D3B6966286C2A613C3D343F652B3D383A653D732E67657455696E74333228652B38292C286F3C317C7C6F3E31332926266C74286049';
wwv_flow_imp.g_varchar2_table(2221) := '6E76616C696420544946462076616C756520747970652E20626C6F636B3A20247B722E746F55707065724361736528297D2C207461673A20247B742E746F537472696E67283136297D2C20747970653A20247B6F7D2C206F666673657420247B657D6029';
wwv_flow_imp.g_varchar2_table(2222) := '2C653E732E627974654C656E67746826266C742860496E76616C696420544946462076616C7565206F66667365742E20626C6F636B3A20247B722E746F55707065724361736528297D2C207461673A20247B742E746F537472696E67283136297D2C2074';
wwv_flow_imp.g_varchar2_table(2223) := '7970653A20247B6F7D2C206F666673657420247B657D206973206F757473696465206F66206368756E6B2073697A6520247B732E627974654C656E6774687D60292C6F3D3D3D312972657475726E20732E67657455696E7438417272617928652C61293B';
wwv_flow_imp.g_varchar2_table(2224) := '6966286F3D3D3D322972657475726E28683D66756E6374696F6E2863297B666F72283B632E656E64735769746828225C3022293B29633D632E736C69636528302C2D31293B72657475726E20637D28683D732E676574537472696E6728652C6129292E74';
wwv_flow_imp.g_varchar2_table(2225) := '72696D2829293D3D3D22223F766F696420303A683B76617220683B6966286F3D3D3D372972657475726E20732E67657455696E7438417272617928652C61293B696628613D3D3D312972657475726E20746869732E706172736554616756616C7565286F';
wwv_flow_imp.g_varchar2_table(2226) := '2C65293B7B6C657420633D6E65772866756E6374696F6E2866297B7377697463682866297B6361736520313A72657475726E2055696E743841727261793B6361736520333A72657475726E2055696E74313641727261793B6361736520343A7265747572';
wwv_flow_imp.g_varchar2_table(2227) := '6E2055696E74333241727261793B6361736520353A72657475726E2041727261793B6361736520363A72657475726E20496E743841727261793B6361736520383A72657475726E20496E74313641727261793B6361736520393A72657475726E20496E74';
wwv_flow_imp.g_varchar2_table(2228) := '333241727261793B636173652031303A72657475726E2041727261793B636173652031313A72657475726E20466C6F6174333241727261793B636173652031323A72657475726E20466C6F6174363441727261793B64656661756C743A72657475726E20';
wwv_flow_imp.g_varchar2_table(2229) := '41727261797D7D286F29292861292C643D6C3B666F72286C657420663D303B663C613B662B2B29635B665D3D746869732E706172736554616756616C7565286F2C65292C652B3D643B72657475726E20637D7D706172736554616756616C756528652C74';
wwv_flow_imp.g_varchar2_table(2230) := '297B6C65747B6368756E6B3A727D3D746869733B7377697463682865297B6361736520313A72657475726E20722E67657455696E74382874293B6361736520333A72657475726E20722E67657455696E7431362874293B6361736520343A72657475726E';
wwv_flow_imp.g_varchar2_table(2231) := '20722E67657455696E7433322874293B6361736520353A72657475726E20722E67657455696E7433322874292F722E67657455696E74333228742B34293B6361736520363A72657475726E20722E676574496E74382874293B6361736520383A72657475';
wwv_flow_imp.g_varchar2_table(2232) := '726E20722E676574496E7431362874293B6361736520393A72657475726E20722E676574496E7433322874293B636173652031303A72657475726E20722E676574496E7433322874292F722E676574496E74333228742B34293B636173652031313A7265';
wwv_flow_imp.g_varchar2_table(2233) := '7475726E20722E676574466C6F61742874293B636173652031323A72657475726E20722E676574446F75626C652874293B636173652031333A72657475726E20722E67657455696E7433322874293B64656661756C743A6C742860496E76616C69642074';
wwv_flow_imp.g_varchar2_table(2234) := '696666207479706520247B657D60297D7D7D3B6E2862752C22736522293B766172206A6F3D636C61737320657874656E64732062757B7374617469632063616E48616E646C6528652C74297B72657475726E20652E67657455696E743828742B31293D3D';
wwv_flow_imp.g_varchar2_table(2235) := '3D3232352626652E67657455696E74333228742B34293D3D3D313136353531393230362626652E67657455696E74313628742B38293D3D3D307D6173796E6320706172736528297B746869732E706172736548656164657228293B6C65747B6F7074696F';
wwv_flow_imp.g_varchar2_table(2236) := '6E733A657D3D746869733B72657475726E20652E696664302E656E61626C65642626617761697420746869732E706172736549666430426C6F636B28292C652E657869662E656E61626C65642626617761697420746869732E7361666550617273652822';
wwv_flow_imp.g_varchar2_table(2237) := '706172736545786966426C6F636B22292C652E6770732E656E61626C65642626617761697420746869732E73616665506172736528227061727365477073426C6F636B22292C652E696E7465726F702E656E61626C65642626617761697420746869732E';
wwv_flow_imp.g_varchar2_table(2238) := '73616665506172736528227061727365496E7465726F70426C6F636B22292C652E696664312E656E61626C65642626617761697420746869732E736166655061727365282270617273655468756D626E61696C426C6F636B22292C746869732E63726561';
wwv_flow_imp.g_varchar2_table(2239) := '74654F757470757428297D7361666550617273652865297B6C657420743D746869735B655D28293B72657475726E20742E6361746368213D3D766F69642030262628743D742E636174636828746869732E68616E646C654572726F7229292C747D66696E';
wwv_flow_imp.g_varchar2_table(2240) := '64496664304F666673657428297B746869732E696664304F66667365743D3D3D766F69642030262628746869732E696664304F66667365743D746869732E6368756E6B2E67657455696E743332283429297D66696E64496664314F666673657428297B69';
wwv_flow_imp.g_varchar2_table(2241) := '6628746869732E696664314F66667365743D3D3D766F69642030297B746869732E66696E64496664304F666673657428293B6C657420653D746869732E6368756E6B2E67657455696E74313628746869732E696664304F6666736574292C743D74686973';
wwv_flow_imp.g_varchar2_table(2242) := '2E696664304F66667365742B322B31322A653B746869732E696664314F66667365743D746869732E6368756E6B2E67657455696E7433322874297D7D7061727365426C6F636B28652C74297B6C657420723D6E6577204D61703B72657475726E20746869';
wwv_flow_imp.g_varchar2_table(2243) := '735B745D3D722C746869732E70617273655461677328652C742C72292C727D6173796E6320706172736549666430426C6F636B28297B696628746869732E696664302972657475726E3B6C65747B66696C653A657D3D746869733B746869732E66696E64';
wwv_flow_imp.g_varchar2_table(2244) := '496664304F666673657428292C746869732E696664304F66667365743C3826266C7428224D616C666F726D65642045584946206461746122292C21652E6368756E6B65642626746869732E696664304F66667365743E652E627974654C656E6774682626';
wwv_flow_imp.g_varchar2_table(2245) := '6C74286049464430206F666673657420706F696E747320746F206F757473696465206F662066696C652E0A746869732E696664304F66667365743A20247B746869732E696664304F66667365747D2C2066696C652E627974654C656E6774683A20247B65';
wwv_flow_imp.g_varchar2_table(2246) := '2E627974654C656E6774687D60292C652E746966662626617761697420652E656E737572654368756E6B28746869732E696664304F66667365742C4D6728746869732E6F7074696F6E7329293B6C657420743D746869732E7061727365426C6F636B2874';
wwv_flow_imp.g_varchar2_table(2247) := '6869732E696664304F66667365742C226966643022293B72657475726E20742E73697A65213D3D303F28746869732E657869664F66667365743D742E676574283334363635292C746869732E696E7465726F704F66667365743D742E6765742834303936';
wwv_flow_imp.g_varchar2_table(2248) := '35292C746869732E6770734F66667365743D742E676574283334383533292C746869732E786D703D742E67657428373030292C746869732E697074633D742E676574283333373233292C746869732E6963633D742E676574283334363735292C74686973';
wwv_flow_imp.g_varchar2_table(2249) := '2E6F7074696F6E732E73616E6974697A65262628742E64656C657465283334363635292C742E64656C657465283430393635292C742E64656C657465283334383533292C742E64656C65746528373030292C742E64656C657465283333373233292C742E';
wwv_flow_imp.g_varchar2_table(2250) := '64656C65746528333436373529292C74293A766F696420307D6173796E6320706172736545786966426C6F636B28297B696628746869732E657869667C7C28746869732E696664307C7C617761697420746869732E706172736549666430426C6F636B28';
wwv_flow_imp.g_varchar2_table(2251) := '292C746869732E657869664F66667365743D3D3D766F69642030292972657475726E3B746869732E66696C652E746966662626617761697420746869732E66696C652E656E737572654368756E6B28746869732E657869664F66667365742C4D67287468';
wwv_flow_imp.g_varchar2_table(2252) := '69732E6F7074696F6E7329293B6C657420653D746869732E7061727365426C6F636B28746869732E657869664F66667365742C226578696622293B72657475726E20746869732E696E7465726F704F66667365747C7C28746869732E696E7465726F704F';
wwv_flow_imp.g_varchar2_table(2253) := '66667365743D652E67657428343039363529292C746869732E6D616B65724E6F74653D652E676574283337353030292C746869732E75736572436F6D6D656E743D652E676574283337353130292C746869732E6F7074696F6E732E73616E6974697A6526';
wwv_flow_imp.g_varchar2_table(2254) := '2628652E64656C657465283430393635292C652E64656C657465283337353030292C652E64656C65746528333735313029292C746869732E756E7061636B28652C3431373238292C746869732E756E7061636B28652C3431373239292C657D756E706163';
wwv_flow_imp.g_varchar2_table(2255) := '6B28652C74297B6C657420723D652E6765742874293B722626722E6C656E6774683D3D3D312626652E73657428742C725B305D297D6173796E63207061727365477073426C6F636B28297B696628746869732E6770737C7C28746869732E696664307C7C';
wwv_flow_imp.g_varchar2_table(2256) := '617761697420746869732E706172736549666430426C6F636B28292C746869732E6770734F66667365743D3D3D766F69642030292972657475726E3B6C657420653D746869732E7061727365426C6F636B28746869732E6770734F66667365742C226770';
wwv_flow_imp.g_varchar2_table(2257) := '7322293B72657475726E20652626652E6861732832292626652E686173283429262628652E73657428226C61746974756465222C6A67282E2E2E652E6765742832292C652E67657428312929292C652E73657428226C6F6E676974756465222C6A67282E';
wwv_flow_imp.g_varchar2_table(2258) := '2E2E652E6765742834292C652E6765742833292929292C657D6173796E63207061727365496E7465726F70426C6F636B28297B69662821746869732E696E7465726F70262628746869732E696664307C7C617761697420746869732E7061727365496664';
wwv_flow_imp.g_varchar2_table(2259) := '30426C6F636B28292C746869732E696E7465726F704F6666736574213D3D766F696420307C7C746869732E657869667C7C617761697420746869732E706172736545786966426C6F636B28292C746869732E696E7465726F704F6666736574213D3D766F';
wwv_flow_imp.g_varchar2_table(2260) := '69642030292972657475726E20746869732E7061727365426C6F636B28746869732E696E7465726F704F66667365742C22696E7465726F7022297D6173796E632070617273655468756D626E61696C426C6F636B28653D2131297B69662821746869732E';
wwv_flow_imp.g_varchar2_table(2261) := '69666431262621746869732E6966643150617273656426262821746869732E6F7074696F6E732E6D657267654F75747075747C7C65292972657475726E20746869732E66696E64496664314F666673657428292C746869732E696664314F66667365743E';
wwv_flow_imp.g_varchar2_table(2262) := '30262628746869732E7061727365426C6F636B28746869732E696664314F66667365742C226966643122292C746869732E696664315061727365643D2130292C746869732E696664317D6173796E6320657874726163745468756D626E61696C28297B69';
wwv_flow_imp.g_varchar2_table(2263) := '6628746869732E6865616465725061727365647C7C746869732E706172736548656164657228292C746869732E696664315061727365647C7C617761697420746869732E70617273655468756D626E61696C426C6F636B282130292C746869732E696664';
wwv_flow_imp.g_varchar2_table(2264) := '313D3D3D766F696420302972657475726E3B6C657420653D746869732E696664312E67657428353133292C743D746869732E696664312E67657428353134293B72657475726E20746869732E6368756E6B2E67657455696E7438417272617928652C7429';
wwv_flow_imp.g_varchar2_table(2265) := '7D67657420696D61676528297B72657475726E20746869732E696664307D676574207468756D626E61696C28297B72657475726E20746869732E696664317D6372656174654F757470757428297B6C657420652C742C722C733D7B7D3B666F722874206F';
wwv_flow_imp.g_varchar2_table(2266) := '6620596529696628653D746869735B745D2C21576728652929696628723D746869732E63616E5472616E736C6174653F746869732E7472616E736C617465426C6F636B28652C74293A4F626A6563742E66726F6D456E74726965732865292C746869732E';
wwv_flow_imp.g_varchar2_table(2267) := '6F7074696F6E732E6D657267654F7574707574297B696628743D3D3D22696664312229636F6E74696E75653B4F626A6563742E61737369676E28732C72297D656C736520735B745D3D723B72657475726E20746869732E6D616B65724E6F746526262873';
wwv_flow_imp.g_varchar2_table(2268) := '2E6D616B65724E6F74653D746869732E6D616B65724E6F7465292C746869732E75736572436F6D6D656E74262628732E75736572436F6D6D656E743D746869732E75736572436F6D6D656E74292C737D61737369676E546F4F757470757428652C74297B';
wwv_flow_imp.g_varchar2_table(2269) := '696628746869732E676C6F62616C4F7074696F6E732E6D657267654F7574707574294F626A6563742E61737369676E28652C74293B656C736520666F72286C65745B722C735D6F66204F626A6563742E656E747269657328742929746869732E61737369';
wwv_flow_imp.g_varchar2_table(2270) := '676E4F626A656374546F4F757470757428652C722C73297D7D3B6E286A6F2C22696522293B66756E6374696F6E206A6728692C652C742C72297B76617220733D692B652F36302B742F333630303B72657475726E2072213D3D225322262672213D3D2257';
wwv_flow_imp.g_varchar2_table(2271) := '227C7C28732A3D2D31292C737D6E286A672C226E6522293B6765286A6F2C2274797065222C227469666622292C6765286A6F2C226865616465724C656E677468222C3130292C74692E736574282274696666222C6A6F293B766172206B543D4F626A6563';
wwv_flow_imp.g_varchar2_table(2272) := '742E667265657A65287B5F5F70726F746F5F5F3A6E756C6C2C64656661756C743A24322C45786966723A54732C66696C65506172736572733A78752C7365676D656E74506172736572733A74692C66696C65526561646572733A68612C7461674B657973';
wwv_flow_imp.g_varchar2_table(2273) := '3A64612C74616756616C7565733A62642C74616752657669766572733A77642C63726561746544696374696F6E6172793A47672C657874656E6444696374696F6E6172793A4B672C666574636855726C417341727261794275666665723A5F752C726561';
wwv_flow_imp.g_varchar2_table(2274) := '64426C6F62417341727261794275666665723A6C612C6368756E6B656450726F70733A4D6F2C6F746865725365676D656E74733A45752C7365676D656E74733A75612C74696666426C6F636B733A59652C7365676D656E7473416E64426C6F636B733A4E';
wwv_flow_imp.g_varchar2_table(2275) := '6F2C746966664578747261637461626C65733A4C6F2C696E686572697461626C65733A43752C616C6C466F726D6174746572733A426F2C4F7074696F6E733A65732C70617273653A58677D292C53643D7B696664303A21312C696664313A21312C657869';
wwv_flow_imp.g_varchar2_table(2276) := '663A21312C6770733A21312C696E7465726F703A21312C73616E6974697A653A21312C72657669766556616C7565733A21302C7472616E736C6174654B6579733A21312C7472616E736C61746556616C7565733A21312C6D657267654F75747075743A21';
wwv_flow_imp.g_varchar2_table(2277) := '317D2C44543D4F626A6563742E61737369676E287B7D2C53642C7B66697273744368756E6B53697A653A3465342C6770733A5B312C322C332C345D7D293B7661722049543D4F626A6563742E61737369676E287B7D2C53642C7B746966663A21312C6966';
wwv_flow_imp.g_varchar2_table(2278) := '64313A21302C6D657267654F75747075743A21317D293B766172204B323D4F626A6563742E61737369676E287B7D2C53642C7B66697273744368756E6B53697A653A3465342C696664303A5B3237345D7D293B6173796E632066756E6374696F6E205832';
wwv_flow_imp.g_varchar2_table(2279) := '2869297B6C657420653D6E6577205473284B32293B617761697420652E726561642869293B6C657420743D617761697420652E706172736528293B696628742626742E696664302972657475726E20742E696664305B3237345D7D6E2858322C22636522';
wwv_flow_imp.g_varchar2_table(2280) := '293B7661722059323D4F626A6563742E667265657A65287B313A7B64696D656E73696F6E537761707065643A21312C7363616C65583A312C7363616C65593A312C6465673A302C7261643A307D2C323A7B64696D656E73696F6E537761707065643A2131';
wwv_flow_imp.g_varchar2_table(2281) := '2C7363616C65583A2D312C7363616C65593A312C6465673A302C7261643A307D2C333A7B64696D656E73696F6E537761707065643A21312C7363616C65583A312C7363616C65593A312C6465673A3138302C7261643A3138302A4D6174682E50492F3138';
wwv_flow_imp.g_varchar2_table(2282) := '307D2C343A7B64696D656E73696F6E537761707065643A21312C7363616C65583A2D312C7363616C65593A312C6465673A3138302C7261643A3138302A4D6174682E50492F3138307D2C353A7B64696D656E73696F6E537761707065643A21302C736361';
wwv_flow_imp.g_varchar2_table(2283) := '6C65583A312C7363616C65593A2D312C6465673A39302C7261643A39302A4D6174682E50492F3138307D2C363A7B64696D656E73696F6E537761707065643A21302C7363616C65583A312C7363616C65593A312C6465673A39302C7261643A39302A4D61';
wwv_flow_imp.g_varchar2_table(2284) := '74682E50492F3138307D2C373A7B64696D656E73696F6E537761707065643A21302C7363616C65583A312C7363616C65593A2D312C6465673A3237302C7261643A3237302A4D6174682E50492F3138307D2C383A7B64696D656E73696F6E537761707065';
wwv_flow_imp.g_varchar2_table(2285) := '643A21302C7363616C65583A312C7363616C65593A312C6465673A3237302C7261643A3237302A4D6174682E50492F3138307D7D292C72613D21302C73613D21303B696628747970656F66206E6176696761746F723D3D226F626A65637422297B6C6574';
wwv_flow_imp.g_varchar2_table(2286) := '20693D6E6176696761746F722E757365724167656E743B696628692E696E636C7564657328226950616422297C7C692E696E636C7564657328226950686F6E652229297B6C657420653D692E6D61746368282F4F5320285C642B295F285C642B292F293B';
wwv_flow_imp.g_varchar2_table(2287) := '69662865297B6C65745B2C742C725D3D653B72613D4E756D6265722874292B2E312A4E756D6265722872293C31332E342C73613D21317D7D656C736520696628692E696E636C7564657328224F5320582031302229297B6C65745B2C655D3D692E6D6174';
wwv_flow_imp.g_varchar2_table(2288) := '6368282F4F5320582031305B5F2E5D285C642B292F293B72613D73613D4E756D6265722865293C31357D696628692E696E636C7564657328224368726F6D652F2229297B6C65745B2C655D3D692E6D61746368282F4368726F6D655C2F285C642B292F29';
wwv_flow_imp.g_varchar2_table(2289) := '3B72613D73613D4E756D6265722865293C38317D656C736520696628692E696E636C75646573282246697265666F782F2229297B6C65745B2C655D3D692E6D61746368282F46697265666F785C2F285C642B292F293B72613D73613D4E756D6265722865';
wwv_flow_imp.g_varchar2_table(2290) := '293C37377D7D6173796E632066756E6374696F6E2059672869297B6C657420653D61776169742058322869293B72657475726E204F626A6563742E61737369676E287B63616E7661733A72612C6373733A73617D2C59325B655D297D6E2859672C227965';
wwv_flow_imp.g_varchar2_table(2291) := '22293B7661722077753D636C61737320657874656E64732071747B636F6E7374727563746F72282E2E2E65297B7375706572282E2E2E65292C676528746869732C2272616E676573222C6E6577205375292C746869732E627974654C656E677468213D3D';
wwv_flow_imp.g_varchar2_table(2292) := '302626746869732E72616E6765732E61646428302C746869732E627974654C656E677468297D5F747279457874656E6428652C742C72297B696628653D3D3D302626746869732E627974654C656E6774683D3D3D30262672297B6C657420733D6E657720';
wwv_flow_imp.g_varchar2_table(2293) := '446174615669657728722E6275666665727C7C722C722E627974654F66667365742C722E627974654C656E677468293B746869732E5F7377617044617461566965772873297D656C73657B6C657420733D652B743B696628733E746869732E627974654C';
wwv_flow_imp.g_varchar2_table(2294) := '656E677468297B6C65747B64617461566965773A6F7D3D746869732E5F657874656E642873293B746869732E5F737761704461746156696577286F297D7D7D5F657874656E642865297B6C657420743B743D56673F71672E616C6C6F63556E7361666528';
wwv_flow_imp.g_varchar2_table(2295) := '65293A6E65772055696E743841727261792865293B6C657420723D6E657720446174615669657728742E6275666665722C742E627974654F66667365742C742E627974654C656E677468293B72657475726E20742E736574286E65772055696E74384172';
wwv_flow_imp.g_varchar2_table(2296) := '72617928746869732E6275666665722C746869732E627974654F66667365742C746869732E627974654C656E677468292C30292C7B75696E74566965773A742C64617461566965773A727D7D737562617272617928652C742C723D2131297B7265747572';
wwv_flow_imp.g_varchar2_table(2297) := '6E20743D747C7C746869732E5F6C656E677468546F456E642865292C722626746869732E5F747279457874656E6428652C74292C746869732E72616E6765732E61646428652C74292C73757065722E737562617272617928652C74297D73657428652C74';
wwv_flow_imp.g_varchar2_table(2298) := '2C723D2131297B722626746869732E5F747279457874656E6428742C652E627974654C656E6774682C65293B6C657420733D73757065722E73657428652C74293B72657475726E20746869732E72616E6765732E61646428742C732E627974654C656E67';
wwv_flow_imp.g_varchar2_table(2299) := '7468292C737D6173796E6320656E737572654368756E6B28652C74297B746869732E6368756E6B6564262628746869732E72616E6765732E617661696C61626C6528652C74297C7C617761697420746869732E726561644368756E6B28652C7429297D61';
wwv_flow_imp.g_varchar2_table(2300) := '7661696C61626C6528652C74297B72657475726E20746869732E72616E6765732E617661696C61626C6528652C74297D7D3B6E2877752C22626522293B7661722053753D636C6173737B636F6E7374727563746F7228297B676528746869732C226C6973';
wwv_flow_imp.g_varchar2_table(2301) := '74222C5B5D297D676574206C656E67746828297B72657475726E20746869732E6C6973742E6C656E6774687D61646428652C742C723D30297B6C657420733D652B742C6F3D746869732E6C6973742E66696C74657228613D3E486728652C612E6F666673';
wwv_flow_imp.g_varchar2_table(2302) := '65742C73297C7C486728652C612E656E642C7329293B6966286F2E6C656E6774683E30297B653D4D6174682E6D696E28652C2E2E2E6F2E6D6170286C3D3E6C2E6F666673657429292C733D4D6174682E6D617828732C2E2E2E6F2E6D6170286C3D3E6C2E';
wwv_flow_imp.g_varchar2_table(2303) := '656E6429292C743D732D653B6C657420613D6F2E736869667428293B612E6F66667365743D652C612E6C656E6774683D742C612E656E643D732C746869732E6C6973743D746869732E6C6973742E66696C746572286C3D3E216F2E696E636C7564657328';
wwv_flow_imp.g_varchar2_table(2304) := '6C29297D656C736520746869732E6C6973742E70757368287B6F66667365743A652C6C656E6774683A742C656E643A737D297D617661696C61626C6528652C74297B6C657420723D652B743B72657475726E20746869732E6C6973742E736F6D6528733D';
wwv_flow_imp.g_varchar2_table(2305) := '3E732E6F66667365743C3D652626723C3D732E656E64297D7D3B6E2853752C22776522293B66756E6374696F6E20486728692C652C74297B72657475726E20693C3D652626653C3D747D6E2848672C226B6522293B7661722050753D636C617373206578';
wwv_flow_imp.g_varchar2_table(2306) := '74656E64732077757B636F6E7374727563746F7228652C74297B73757065722830292C676528746869732C226368756E6B7352656164222C30292C746869732E696E7075743D652C746869732E6F7074696F6E733D747D6173796E63207265616457686F';
wwv_flow_imp.g_varchar2_table(2307) := '6C6528297B746869732E6368756E6B65643D21312C617761697420746869732E726561644368756E6B28746869732E6E6578744368756E6B4F6666736574297D6173796E6320726561644368756E6B656428297B746869732E6368756E6B65643D21302C';
wwv_flow_imp.g_varchar2_table(2308) := '617761697420746869732E726561644368756E6B28302C746869732E6F7074696F6E732E66697273744368756E6B53697A65297D6173796E6320726561644E6578744368756E6B28653D746869732E6E6578744368756E6B4F6666736574297B69662874';
wwv_flow_imp.g_varchar2_table(2309) := '6869732E66756C6C79526561642972657475726E20746869732E6368756E6B73526561642B2B2C21313B6C657420743D746869732E6F7074696F6E732E6368756E6B53697A652C723D617761697420746869732E726561644368756E6B28652C74293B72';
wwv_flow_imp.g_varchar2_table(2310) := '657475726E2121722626722E627974654C656E6774683D3D3D747D6173796E6320726561644368756E6B28652C74297B696628746869732E6368756E6B73526561642B2B2C28743D746869732E73616665577261704164647265737328652C742929213D';
wwv_flow_imp.g_varchar2_table(2311) := '3D302972657475726E20746869732E5F726561644368756E6B28652C74297D73616665577261704164647265737328652C74297B72657475726E20746869732E73697A65213D3D766F696420302626652B743E746869732E73697A653F4D6174682E6D61';
wwv_flow_imp.g_varchar2_table(2312) := '7828302C746869732E73697A652D65293A747D676574206E6578744368756E6B4F666673657428297B696628746869732E72616E6765732E6C6973742E6C656E677468213D3D302972657475726E20746869732E72616E6765732E6C6973745B305D2E6C';
wwv_flow_imp.g_varchar2_table(2313) := '656E6774687D6765742063616E526561644E6578744368756E6B28297B72657475726E20746869732E6368756E6B73526561643C746869732E6F7074696F6E732E6368756E6B4C696D69747D6765742066756C6C795265616428297B72657475726E2074';
wwv_flow_imp.g_varchar2_table(2314) := '6869732E73697A65213D3D766F696420302626746869732E6E6578744368756E6B4F66667365743D3D3D746869732E73697A657D7265616428297B72657475726E20746869732E6F7074696F6E732E6368756E6B65643F746869732E726561644368756E';
wwv_flow_imp.g_varchar2_table(2315) := '6B656428293A746869732E7265616457686F6C6528297D636C6F736528297B7D7D3B6E2850752C224F6522293B68612E7365742822626C6F62222C636C61737320657874656E64732050757B6173796E63207265616457686F6C6528297B746869732E63';
wwv_flow_imp.g_varchar2_table(2316) := '68756E6B65643D21313B6C657420693D6177616974206C6128746869732E696E707574293B746869732E5F7377617041727261794275666665722869297D726561644368756E6B656428297B72657475726E20746869732E6368756E6B65643D21302C74';
wwv_flow_imp.g_varchar2_table(2317) := '6869732E73697A653D746869732E696E7075742E73697A652C73757065722E726561644368756E6B656428297D6173796E63205F726561644368756E6B28692C65297B6C657420743D653F692B653A766F696420302C723D746869732E696E7075742E73';
wwv_flow_imp.g_varchar2_table(2318) := '6C69636528692C74292C733D6177616974206C612872293B72657475726E20746869732E73657428732C692C2130297D7D293B7661722051673D7B737472696E67733A7B67656E65726174696E675468756D626E61696C733A2247656E65726174696E67';
wwv_flow_imp.g_varchar2_table(2319) := '207468756D626E61696C732E2E2E227D7D3B7661722051323D7B76657273696F6E3A22332E302E36227D3B66756E6374696F6E204A3228692C652C74297B7472797B692E676574436F6E746578742822326422292E676574496D6167654461746128302C';
wwv_flow_imp.g_varchar2_table(2320) := '302C312C31297D63617463682872297B696628722E636F64653D3D3D31382972657475726E2050726F6D6973652E72656A656374286E6577204572726F72282263616E6E6F74207265616420696D6167652C2070726F6261626C7920616E207376672077';
wwv_flow_imp.g_varchar2_table(2321) := '6974682065787465726E616C207265736F75726365732229297D72657475726E20692E746F426C6F623F6E65772050726F6D69736528723D3E7B692E746F426C6F6228722C652C74297D292E7468656E28723D3E7B696628723D3D3D6E756C6C29746872';
wwv_flow_imp.g_varchar2_table(2322) := '6F77206E6577204572726F72282263616E6E6F74207265616420696D6167652C2070726F6261626C7920616E2073766720776974682065787465726E616C207265736F757263657322293B72657475726E20727D293A50726F6D6973652E7265736F6C76';
wwv_flow_imp.g_varchar2_table(2323) := '6528292E7468656E2828293D3E706428692E746F4461746155524C28652C74292C7B7D29292E7468656E28723D3E7B696628723D3D3D6E756C6C297468726F77206E6577204572726F722822636F756C64206E6F74206578747261637420626C6F622C20';
wwv_flow_imp.g_varchar2_table(2324) := '70726F6261626C7920616E206F6C642062726F7773657222293B72657475726E20727D297D6E284A322C2263616E766173546F426C6F6222293B66756E6374696F6E205A3228692C65297B6C657420743D692E77696474682C723D692E6865696768743B';
wwv_flow_imp.g_varchar2_table(2325) := '28652E6465673D3D3D39307C7C652E6465673D3D3D32373029262628743D692E6865696768742C723D692E7769647468293B6C657420733D646F63756D656E742E637265617465456C656D656E74282263616E76617322293B732E77696474683D742C73';
wwv_flow_imp.g_varchar2_table(2326) := '2E6865696768743D723B6C6574206F3D732E676574436F6E746578742822326422293B72657475726E206F2E7472616E736C61746528742F322C722F32292C652E63616E7661732626286F2E726F7461746528652E726164292C6F2E7363616C6528652E';
wwv_flow_imp.g_varchar2_table(2327) := '7363616C65582C652E7363616C655929292C6F2E64726177496D61676528692C2D692E77696474682F322C2D692E6865696768742F322C692E77696474682C692E686569676874292C737D6E285A322C22726F74617465496D61676522293B66756E6374';
wwv_flow_imp.g_varchar2_table(2328) := '696F6E2065532869297B6C657420653D692E77696474682F692E6865696768742C743D3565362C723D343039362C733D4D6174682E666C6F6F72284D6174682E7371727428742A6529292C6F3D4D6174682E666C6F6F7228742F4D6174682E7371727428';
wwv_flow_imp.g_varchar2_table(2329) := '742A6529293B696628733E72262628733D722C6F3D4D6174682E726F756E6428732F6529292C6F3E722626286F3D722C733D4D6174682E726F756E6428652A6F29292C692E77696474683E73297B6C657420613D646F63756D656E742E63726561746545';
wwv_flow_imp.g_varchar2_table(2330) := '6C656D656E74282263616E76617322293B72657475726E20612E77696474683D732C612E6865696768743D6F2C612E676574436F6E746578742822326422292E64726177496D61676528692C302C302C732C6F292C617D72657475726E20697D6E286553';
wwv_flow_imp.g_varchar2_table(2331) := '2C2270726F7465637422293B7661722043723D636C61737320657874656E6473205A7B636F6E7374727563746F7228652C74297B737570657228652C74292C746869732E6F6E46696C6541646465643D733D3E7B21732E707265766965772626732E6461';
wwv_flow_imp.g_varchar2_table(2332) := '74612626556F28732E7479706529262621732E697352656D6F74652626746869732E616464546F517565756528732E6964297D2C746869732E6F6E43616E63656C526571756573743D733D3E7B6C6574206F3D746869732E71756575652E696E6465784F';
wwv_flow_imp.g_varchar2_table(2333) := '6628732E6964293B6F213D3D2D312626746869732E71756575652E73706C696365286F2C31297D2C746869732E6F6E46696C6552656D6F7665643D733D3E7B6C6574206F3D746869732E71756575652E696E6465784F6628732E6964293B6F213D3D2D31';
wwv_flow_imp.g_varchar2_table(2334) := '2626746869732E71756575652E73706C696365286F2C31292C732E707265766965772626797528732E7072657669657729262655524C2E7265766F6B654F626A65637455524C28732E70726576696577297D2C746869732E6F6E526573746F7265643D28';
wwv_flow_imp.g_varchar2_table(2335) := '293D3E7B746869732E757070792E67657446696C657328292E66696C746572286F3D3E6F2E6973526573746F726564292E666F7245616368286F3D3E7B28216F2E707265766965777C7C7975286F2E7072657669657729292626746869732E616464546F';
wwv_flow_imp.g_varchar2_table(2336) := '5175657565286F2E6964297D297D2C746869732E6F6E416C6C46696C657352656D6F7665643D28293D3E7B746869732E71756575653D5B5D7D2C746869732E77616974556E74696C416C6C50726F6365737365643D733D3E7B732E666F72456163682861';
wwv_flow_imp.g_varchar2_table(2337) := '3D3E7B6C6574206C3D746869732E757070792E67657446696C652861293B746869732E757070792E656D6974282270726570726F636573732D70726F6772657373222C6C2C7B6D6F64653A22696E64657465726D696E617465222C6D6573736167653A74';
wwv_flow_imp.g_varchar2_table(2338) := '6869732E6931386E282267656E65726174696E675468756D626E61696C7322297D297D293B6C6574206F3D6E2828293D3E7B732E666F724561636828613D3E7B6C6574206C3D746869732E757070792E67657446696C652861293B746869732E75707079';
wwv_flow_imp.g_varchar2_table(2339) := '2E656D6974282270726570726F636573732D636F6D706C657465222C6C297D297D2C22656D697450726570726F63657373436F6D706C657465466F72416C6C22293B72657475726E206E65772050726F6D69736528613D3E7B746869732E717565756550';
wwv_flow_imp.g_varchar2_table(2340) := '726F63657373696E673F746869732E757070792E6F6E636528227468756D626E61696C3A616C6C2D67656E657261746564222C28293D3E7B6F28292C6128297D293A286F28292C612829297D297D2C746869732E747970653D226D6F646966696572222C';
wwv_flow_imp.g_varchar2_table(2341) := '746869732E69643D746869732E6F7074732E69647C7C225468756D626E61696C47656E657261746F72222C746869732E7469746C653D225468756D626E61696C2047656E657261746F72222C746869732E71756575653D5B5D2C746869732E7175657565';
wwv_flow_imp.g_varchar2_table(2342) := '50726F63657373696E673D21312C746869732E64656661756C745468756D626E61696C44696D656E73696F6E3D3230302C746869732E7468756D626E61696C547970653D746869732E6F7074732E7468756D626E61696C547970657C7C22696D6167652F';
wwv_flow_imp.g_varchar2_table(2343) := '6A706567222C746869732E64656661756C744C6F63616C653D51673B6C657420723D7B7468756D626E61696C57696474683A6E756C6C2C7468756D626E61696C4865696768743A6E756C6C2C77616974466F725468756D626E61696C734265666F726555';
wwv_flow_imp.g_varchar2_table(2344) := '706C6F61643A21312C6C617A793A21317D3B696628746869732E6F7074733D7B2E2E2E722C2E2E2E747D2C746869732E6931386E496E697428292C746869732E6F7074732E6C617A792626746869732E6F7074732E77616974466F725468756D626E6169';
wwv_flow_imp.g_varchar2_table(2345) := '6C734265666F726555706C6F6164297468726F77206E6577204572726F7228225468756D626E61696C47656E657261746F723A2054686520606C617A796020616E64206077616974466F725468756D626E61696C734265666F726555706C6F616460206F';
wwv_flow_imp.g_varchar2_table(2346) := '7074696F6E7320617265206D757475616C6C79206578636C75736976652E20506C6561736520656E73757265206174206D6F7374206F6E65206F66207468656D2069732073657420746F206074727565602E22297D6372656174655468756D626E61696C';
wwv_flow_imp.g_varchar2_table(2347) := '28652C742C72297B6C657420733D55524C2E6372656174654F626A65637455524C28652E64617461292C6F3D6E65772050726F6D69736528286C2C68293D3E7B6C657420633D6E657720496D6167653B632E7372633D732C632E6164644576656E744C69';
wwv_flow_imp.g_varchar2_table(2348) := '7374656E657228226C6F6164222C28293D3E7B55524C2E7265766F6B654F626A65637455524C2873292C6C2863297D292C632E6164644576656E744C697374656E657228226572726F72222C643D3E7B55524C2E7265766F6B654F626A65637455524C28';
wwv_flow_imp.g_varchar2_table(2349) := '73292C6828642E6572726F727C7C6E6577204572726F722822436F756C64206E6F7420637265617465207468756D626E61696C2229297D297D292C613D596728652E64617461292E63617463682828293D3E31293B72657475726E2050726F6D6973652E';
wwv_flow_imp.g_varchar2_table(2350) := '616C6C285B6F2C615D292E7468656E286C3D3E7B6C65745B682C635D3D6C2C643D746869732E67657450726F706F7274696F6E616C44696D656E73696F6E7328682C742C722C632E646567292C663D5A3228682C63292C793D746869732E726573697A65';
wwv_flow_imp.g_varchar2_table(2351) := '496D61676528662C642E77696474682C642E686569676874293B72657475726E204A3228792C746869732E7468756D626E61696C547970652C3830297D292E7468656E286C3D3E55524C2E6372656174654F626A65637455524C286C29297D6765745072';
wwv_flow_imp.g_varchar2_table(2352) := '6F706F7274696F6E616C44696D656E73696F6E7328652C742C722C73297B6C6574206F3D652E77696474682F652E6865696768743B72657475726E28733D3D3D39307C7C733D3D3D323730292626286F3D652E6865696768742F652E7769647468292C74';
wwv_flow_imp.g_varchar2_table(2353) := '213D6E756C6C3F7B77696474683A742C6865696768743A4D6174682E726F756E6428742F6F297D3A72213D6E756C6C3F7B77696474683A4D6174682E726F756E6428722A6F292C6865696768743A727D3A7B77696474683A746869732E64656661756C74';
wwv_flow_imp.g_varchar2_table(2354) := '5468756D626E61696C44696D656E73696F6E2C6865696768743A4D6174682E726F756E6428746869732E64656661756C745468756D626E61696C44696D656E73696F6E2F6F297D7D726573697A65496D61676528652C742C72297B6C657420733D655328';
wwv_flow_imp.g_varchar2_table(2355) := '65292C6F3D4D6174682E6365696C284D6174682E6C6F673228732E77696474682F7429293B6F3C312626286F3D31293B6C657420613D742A322A2A286F2D31292C6C3D722A322A2A286F2D31292C683D323B666F72283B6F2D2D3B297B6C657420633D64';
wwv_flow_imp.g_varchar2_table(2356) := '6F63756D656E742E637265617465456C656D656E74282263616E76617322293B632E77696474683D612C632E6865696768743D6C2C632E676574436F6E746578742822326422292E64726177496D61676528732C302C302C612C6C292C733D632C613D4D';
wwv_flow_imp.g_varchar2_table(2357) := '6174682E726F756E6428612F68292C6C3D4D6174682E726F756E64286C2F68297D72657475726E20737D7365745072657669657755524C28652C74297B746869732E757070792E73657446696C65537461746528652C7B707265766965773A747D297D61';
wwv_flow_imp.g_varchar2_table(2358) := '6464546F51756575652865297B746869732E71756575652E707573682865292C746869732E717565756550726F63657373696E673D3D3D21312626746869732E70726F63657373517565756528297D70726F63657373517565756528297B696628746869';
wwv_flow_imp.g_varchar2_table(2359) := '732E717565756550726F63657373696E673D21302C746869732E71756575652E6C656E6774683E30297B6C657420653D746869732E757070792E67657446696C6528746869732E71756575652E73686966742829293B72657475726E20653F746869732E';
wwv_flow_imp.g_varchar2_table(2360) := '726571756573745468756D626E61696C2865292E63617463682828293D3E7B7D292E7468656E2828293D3E746869732E70726F6365737351756575652829293A28746869732E757070792E6C6F6728225B5468756D626E61696C47656E657261746F725D';
wwv_flow_imp.g_varchar2_table(2361) := '2066696C65207761732072656D6F766564206265666F72652061207468756D626E61696C20636F756C642062652067656E6572617465642C20627574206E6F742072656D6F7665642066726F6D207468652071756575652E20546869732069732070726F';
wwv_flow_imp.g_varchar2_table(2362) := '6261626C79206120627567222C226572726F7222292C50726F6D6973652E7265736F6C76652829297D72657475726E20746869732E717565756550726F63657373696E673D21312C746869732E757070792E6C6F6728225B5468756D626E61696C47656E';
wwv_flow_imp.g_varchar2_table(2363) := '657261746F725D20456D7074696564207468756D626E61696C20717565756522292C746869732E757070792E656D697428227468756D626E61696C3A616C6C2D67656E65726174656422292C50726F6D6973652E7265736F6C766528297D726571756573';
wwv_flow_imp.g_varchar2_table(2364) := '745468756D626E61696C2865297B72657475726E20556F28652E7479706529262621652E697352656D6F74653F746869732E6372656174655468756D626E61696C28652C746869732E6F7074732E7468756D626E61696C57696474682C746869732E6F70';
wwv_flow_imp.g_varchar2_table(2365) := '74732E7468756D626E61696C486569676874292E7468656E28743D3E7B746869732E7365745072657669657755524C28652E69642C74292C746869732E757070792E6C6F6728605B5468756D626E61696C47656E657261746F725D2047656E6572617465';
wwv_flow_imp.g_varchar2_table(2366) := '64207468756D626E61696C20666F7220247B652E69647D60292C746869732E757070792E656D697428227468756D626E61696C3A67656E657261746564222C746869732E757070792E67657446696C6528652E6964292C74297D292E636174636828743D';
wwv_flow_imp.g_varchar2_table(2367) := '3E7B746869732E757070792E6C6F6728605B5468756D626E61696C47656E657261746F725D204661696C6564207468756D626E61696C20666F7220247B652E69647D3A602C227761726E696E6722292C746869732E757070792E6C6F6728742C22776172';
wwv_flow_imp.g_varchar2_table(2368) := '6E696E6722292C746869732E757070792E656D697428227468756D626E61696C3A6572726F72222C746869732E757070792E67657446696C6528652E6964292C74297D293A50726F6D6973652E7265736F6C766528297D696E7374616C6C28297B746869';
wwv_flow_imp.g_varchar2_table(2369) := '732E757070792E6F6E282266696C652D72656D6F766564222C746869732E6F6E46696C6552656D6F766564292C746869732E757070792E6F6E282263616E63656C2D616C6C222C746869732E6F6E416C6C46696C657352656D6F766564292C746869732E';
wwv_flow_imp.g_varchar2_table(2370) := '6F7074732E6C617A793F28746869732E757070792E6F6E28227468756D626E61696C3A72657175657374222C746869732E6F6E46696C654164646564292C746869732E757070792E6F6E28227468756D626E61696C3A63616E63656C222C746869732E6F';
wwv_flow_imp.g_varchar2_table(2371) := '6E43616E63656C5265717565737429293A28746869732E757070792E6F6E282266696C652D6164646564222C746869732E6F6E46696C654164646564292C746869732E757070792E6F6E2822726573746F726564222C746869732E6F6E526573746F7265';
wwv_flow_imp.g_varchar2_table(2372) := '6429292C746869732E6F7074732E77616974466F725468756D626E61696C734265666F726555706C6F61642626746869732E757070792E61646450726550726F636573736F7228746869732E77616974556E74696C416C6C50726F636573736564297D75';
wwv_flow_imp.g_varchar2_table(2373) := '6E696E7374616C6C28297B746869732E757070792E6F6666282266696C652D72656D6F766564222C746869732E6F6E46696C6552656D6F766564292C746869732E757070792E6F6666282263616E63656C2D616C6C222C746869732E6F6E416C6C46696C';
wwv_flow_imp.g_varchar2_table(2374) := '657352656D6F766564292C746869732E6F7074732E6C617A793F28746869732E757070792E6F666628227468756D626E61696C3A72657175657374222C746869732E6F6E46696C654164646564292C746869732E757070792E6F666628227468756D626E';
wwv_flow_imp.g_varchar2_table(2375) := '61696C3A63616E63656C222C746869732E6F6E43616E63656C5265717565737429293A28746869732E757070792E6F6666282266696C652D6164646564222C746869732E6F6E46696C654164646564292C746869732E757070792E6F6666282272657374';
wwv_flow_imp.g_varchar2_table(2376) := '6F726564222C746869732E6F6E526573746F72656429292C746869732E6F7074732E77616974466F725468756D626E61696C734265666F726555706C6F61642626746869732E757070792E72656D6F766550726550726F636573736F7228746869732E77';
wwv_flow_imp.g_varchar2_table(2377) := '616974556E74696C416C6C50726F636573736564297D7D3B6E2843722C225468756D626E61696C47656E657261746F7222293B43722E56455253494F4E3D51322E76657273696F6E3B66756E6374696F6E204F752869297B696628747970656F6620693D';
wwv_flow_imp.g_varchar2_table(2378) := '3D22737472696E6722297B6C657420653D646F63756D656E742E717565727953656C6563746F72416C6C2869293B72657475726E20652E6C656E6774683D3D3D303F6E756C6C3A41727261792E66726F6D2865297D72657475726E20747970656F662069';
wwv_flow_imp.g_varchar2_table(2379) := '3D3D226F626A6563742226264F6E2869293F5B695D3A6E756C6C7D6E284F752C2266696E64416C6C444F4D456C656D656E747322293B7661722051653D41727261792E66726F6D3B66756E6374696F6E20547528692C652C742C72297B6C65747B6F6E53';
wwv_flow_imp.g_varchar2_table(2380) := '7563636573733A737D3D723B692E72656164456E7472696573286F3D3E7B6C657420613D5B2E2E2E652C2E2E2E6F5D3B6F2E6C656E6774683F71756575654D6963726F7461736B2828293D3E7B547528692C612C742C7B6F6E537563636573733A737D29';
wwv_flow_imp.g_varchar2_table(2381) := '7D293A732861297D2C6F3D3E7B74286F292C732865297D297D6E2854752C2267657446696C6573416E644469726563746F7269657346726F6D4469726563746F727922293B66756E6374696F6E204A6728692C65297B72657475726E20693D3D6E756C6C';
wwv_flow_imp.g_varchar2_table(2382) := '3F693A7B6B696E643A692E697346696C653F2266696C65223A692E69734469726563746F72793F226469726563746F7279223A766F696420302C6E616D653A692E6E616D652C67657446696C6528297B72657475726E206E65772050726F6D6973652828';
wwv_flow_imp.g_varchar2_table(2383) := '742C72293D3E692E66696C6528742C7229297D2C6173796E632A76616C75657328297B6C657420743D692E63726561746552656164657228293B7969656C642A6177616974206E65772050726F6D69736528733D3E7B547528742C5B5D2C652C7B6F6E53';
wwv_flow_imp.g_varchar2_table(2384) := '7563636573733A6F3D3E73286F2E6D617028613D3E4A6728612C652929297D297D297D2C697353616D65456E7472793A766F696420307D7D6E284A672C22676574417346696C6553797374656D48616E646C6546726F6D456E74727922293B66756E6374';
wwv_flow_imp.g_varchar2_table(2385) := '696F6E205A6728692C652C74297B7472797B72657475726E20743D3D3D766F69642030262628743D766F69642030292C6173796E632066756E6374696F6E2A28297B6C657420723D6E2828293D3E60247B657D2F247B692E6E616D657D602C226765744E';
wwv_flow_imp.g_varchar2_table(2386) := '65787452656C61746976655061746822293B696628692E6B696E643D3D3D2266696C6522297B6C657420733D617761697420692E67657446696C6528293B73213D6E756C6C3F28732E72656C6174697665506174683D653F7228293A6E756C6C2C796965';
wwv_flow_imp.g_varchar2_table(2387) := '6C642073293A74213D6E756C6C2626287969656C642074297D656C736520696628692E6B696E643D3D3D226469726563746F72792229666F72206177616974286C65742073206F6620692E76616C7565732829297969656C642A5A6728732C653F722829';
wwv_flow_imp.g_varchar2_table(2388) := '3A692E6E616D65293B656C73652074213D6E756C6C2626287969656C642074297D28297D63617463682872297B72657475726E2050726F6D6973652E72656A6563742872297D7D6E285A672C2263726561746550726F6D697365546F41646446696C654F';
wwv_flow_imp.g_varchar2_table(2389) := '7250617273654469726563746F727922293B6173796E632066756E6374696F6E2A506428692C65297B6C657420743D61776169742050726F6D6973652E616C6C2841727261792E66726F6D28692E6974656D732C6173796E6320723D3E7B76617220733B';
wwv_flow_imp.g_varchar2_table(2390) := '6C6574206F2C613D6E2828293D3E747970656F6620722E6765744173456E7472793D3D2266756E6374696F6E223F722E6765744173456E74727928293A722E7765626B69744765744173456E74727928292C226765744173456E74727922293B72657475';
wwv_flow_imp.g_varchar2_table(2391) := '726E28733D6F29213D6E756C6C7C7C286F3D4A67286128292C6529292C7B66696C6553797374656D48616E646C653A6F2C6C6173745265736F727446696C653A722E676574417346696C6528297D7D29293B666F72286C65747B6C6173745265736F7274';
wwv_flow_imp.g_varchar2_table(2392) := '46696C653A722C66696C6553797374656D48616E646C653A737D6F6620742969662873213D6E756C6C297472797B7969656C642A5A6728732C22222C72297D6361746368286F297B72213D6E756C6C3F7969656C6420723A65286F297D656C7365207221';
wwv_flow_imp.g_varchar2_table(2393) := '3D6E756C6C2626287969656C642072297D6E2850642C2267657446696C657346726F6D446174615472616E7366657222293B66756E6374696F6E205F642869297B6C657420653D516528692E66696C6573293B72657475726E2050726F6D6973652E7265';
wwv_flow_imp.g_varchar2_table(2394) := '736F6C76652865297D6E285F642C2266616C6C6261636B41706922293B6173796E632066756E6374696F6E20417328692C65297B76617220743B6C657420723D28743D653F2E6C6F6744726F704572726F7229213D6E756C6C3F743A46756E6374696F6E';
wwv_flow_imp.g_varchar2_table(2395) := '2E70726F746F747970653B7472797B6C657420733D5B5D3B666F72206177616974286C6574206F206F6620506428692C722929732E70757368286F293B72657475726E20737D63617463687B72657475726E205F642869297D7D6E2841732C2267657444';
wwv_flow_imp.g_varchar2_table(2396) := '726F7070656446696C657322293B7661722065793D4E756D6265722E69734E614E7C7C6E2866756E6374696F6E2865297B72657475726E20747970656F6620653D3D226E756D62657222262665213D3D657D2C22706F6E7966696C6C22293B66756E6374';
wwv_flow_imp.g_varchar2_table(2397) := '696F6E20745328692C65297B72657475726E212128693D3D3D657C7C657928692926266579286529297D6E2874532C226973457175616C22293B66756E6374696F6E20695328692C65297B696628692E6C656E677468213D3D652E6C656E677468297265';
wwv_flow_imp.g_varchar2_table(2398) := '7475726E21313B666F722876617220743D303B743C692E6C656E6774683B742B2B2969662821745328695B745D2C655B745D292972657475726E21313B72657475726E21307D6E2869532C22617265496E70757473457175616C22293B66756E6374696F';
wwv_flow_imp.g_varchar2_table(2399) := '6E20466428692C65297B653D3D3D766F69642030262628653D6953293B76617220743D6E756C6C3B66756E6374696F6E207228297B666F722876617220733D5B5D2C6F3D303B6F3C617267756D656E74732E6C656E6774683B6F2B2B29735B6F5D3D6172';
wwv_flow_imp.g_varchar2_table(2400) := '67756D656E74735B6F5D3B696628742626742E6C617374546869733D3D3D7468697326266528732C742E6C61737441726773292972657475726E20742E6C617374526573756C743B76617220613D692E6170706C7928746869732C73293B72657475726E';
wwv_flow_imp.g_varchar2_table(2401) := '20743D7B6C617374526573756C743A612C6C617374417267733A732C6C617374546869733A746869737D2C617D72657475726E206E28722C226D656D6F697A656422292C722E636C6561723D6E2866756E6374696F6E28297B743D6E756C6C7D2C22636C';
wwv_flow_imp.g_varchar2_table(2402) := '65617222292C727D6E2846642C226D656D6F697A654F6E6522293B7661722041753D5B27615B687265665D3A6E6F74285B746162696E6465785E3D222D225D293A6E6F74285B696E6572745D293A6E6F74285B617269612D68696464656E5D29272C2761';
wwv_flow_imp.g_varchar2_table(2403) := '7265615B687265665D3A6E6F74285B746162696E6465785E3D222D225D293A6E6F74285B696E6572745D293A6E6F74285B617269612D68696464656E5D29272C22696E7075743A6E6F74285B64697361626C65645D293A6E6F74285B696E6572745D293A';
wwv_flow_imp.g_varchar2_table(2404) := '6E6F74285B617269612D68696464656E5D29222C2273656C6563743A6E6F74285B64697361626C65645D293A6E6F74285B696E6572745D293A6E6F74285B617269612D68696464656E5D29222C2274657874617265613A6E6F74285B64697361626C6564';
wwv_flow_imp.g_varchar2_table(2405) := '5D293A6E6F74285B696E6572745D293A6E6F74285B617269612D68696464656E5D29222C22627574746F6E3A6E6F74285B64697361626C65645D293A6E6F74285B696E6572745D293A6E6F74285B617269612D68696464656E5D29222C27696672616D65';
wwv_flow_imp.g_varchar2_table(2406) := '3A6E6F74285B746162696E6465785E3D222D225D293A6E6F74285B696E6572745D293A6E6F74285B617269612D68696464656E5D29272C276F626A6563743A6E6F74285B746162696E6465785E3D222D225D293A6E6F74285B696E6572745D293A6E6F74';
wwv_flow_imp.g_varchar2_table(2407) := '285B617269612D68696464656E5D29272C27656D6265643A6E6F74285B746162696E6465785E3D222D225D293A6E6F74285B696E6572745D293A6E6F74285B617269612D68696464656E5D29272C275B636F6E74656E746564697461626C655D3A6E6F74';
wwv_flow_imp.g_varchar2_table(2408) := '285B746162696E6465785E3D222D225D293A6E6F74285B696E6572745D293A6E6F74285B617269612D68696464656E5D29272C275B746162696E6465785D3A6E6F74285B746162696E6465785E3D222D225D293A6E6F74285B696E6572745D293A6E6F74';
wwv_flow_imp.g_varchar2_table(2409) := '285B617269612D68696464656E5D29275D3B66756E6374696F6E20636128692C65297B69662865297B6C657420743D692E717565727953656C6563746F7228605B646174612D757070792D70616E656C747970653D22247B657D225D60293B6966287429';
wwv_flow_imp.g_varchar2_table(2410) := '72657475726E20747D72657475726E20697D6E2863612C226765744163746976654F7665726C6179456C22293B66756E6374696F6E20747928692C65297B6C657420743D655B305D3B74262628742E666F63757328292C692E70726576656E7444656661';
wwv_flow_imp.g_varchar2_table(2411) := '756C742829297D6E2874792C22666F6375734F6E46697273744E6F646522293B66756E6374696F6E20725328692C65297B6C657420743D655B652E6C656E6774682D315D3B74262628742E666F63757328292C692E70726576656E7444656661756C7428';
wwv_flow_imp.g_varchar2_table(2412) := '29297D6E2872532C22666F6375734F6E4C6173744E6F646522293B66756E6374696F6E2073532869297B72657475726E20692E636F6E7461696E7328646F63756D656E742E616374697665456C656D656E74297D6E2873532C226973466F637573496E4F';
wwv_flow_imp.g_varchar2_table(2413) := '7665726C617922293B66756E6374696F6E20786428692C652C74297B6C657420723D636128742C65292C733D516528722E717565727953656C6563746F72416C6C28417529292C6F3D732E696E6465784F6628646F63756D656E742E616374697665456C';
wwv_flow_imp.g_varchar2_table(2414) := '656D656E74293B73532872293F692E73686966744B657926266F3D3D3D303F725328692C73293A21692E73686966744B657926266F3D3D3D732E6C656E6774682D312626747928692C73293A747928692C73297D6E2878642C2274726170466F63757322';
wwv_flow_imp.g_varchar2_table(2415) := '293B66756E6374696F6E20697928692C652C74297B653D3D3D6E756C6C7C7C786428692C652C74297D6E2869792C22666F72496E6C696E6522293B7661722072793D646528506828292C31293B66756E6374696F6E20456428297B6C657420693D21313B';
wwv_flow_imp.g_varchar2_table(2416) := '72657475726E28302C72792E64656661756C7429286E2828742C72293D3E7B6C657420733D636128742C72292C6F3D732E636F6E7461696E7328646F63756D656E742E616374697665456C656D656E74293B6966286F2626692972657475726E3B6C6574';
wwv_flow_imp.g_varchar2_table(2417) := '20613D732E717565727953656C6563746F7228225B646174612D757070792D73757065722D666F63757361626C655D22293B69662821286F2626216129296966286129612E666F637573287B70726576656E745363726F6C6C3A21307D292C693D21303B';
wwv_flow_imp.g_varchar2_table(2418) := '656C73657B6C6574206C3D732E717565727953656C6563746F72284175293B6C3F2E666F637573287B70726576656E745363726F6C6C3A21307D292C693D21317D7D2C227375706572466F63757322292C323630297D6E2845642C226372656174655375';
wwv_flow_imp.g_varchar2_table(2419) := '706572466F63757322293B7661722043793D6465285A7428292C31293B66756E6374696F6E20706128297B6C657420693D646F63756D656E742E626F64793B72657475726E2128212822647261676761626C6522696E2069297C7C2128226F6E64726167';
wwv_flow_imp.g_varchar2_table(2420) := '737461727422696E20692626226F6E64726F7022696E2069297C7C212822466F726D4461746122696E2077696E646F77297C7C21282246696C6552656164657222696E2077696E646F7729297D6E2870612C2269734472616744726F70537570706F7274';
wwv_flow_imp.g_varchar2_table(2421) := '656422293B7661722068793D6465285A7428292C31292C64793D6465286F7928292C31293B66756E6374696F6E206E5328297B72657475726E20752822737667222C7B22617269612D68696464656E223A2274727565222C666F63757361626C653A2266';
wwv_flow_imp.g_varchar2_table(2422) := '616C7365222C77696474683A223235222C6865696768743A223235222C76696577426F783A22302030203235203235227D2C75282267222C7B66696C6C3A2223363836444530222C66696C6C52756C653A226576656E6F6464227D2C7528227061746822';
wwv_flow_imp.g_varchar2_table(2423) := '2C7B643A224D352037763130683135563748357A6D302D316831356131203120302030203120312031763130613120312030203020312D3120314835613120312030203020312D312D3156376131203120302030203120312D317A222C66696C6C52756C';
wwv_flow_imp.g_varchar2_table(2424) := '653A226E6F6E7A65726F227D292C75282270617468222C7B643A224D362E33352031372E3137326C342E3939342D352E303236612E352E35203020302031202E37303720306C322E313620322E313620332E3530352D332E353035612E352E3520302030';
wwv_flow_imp.g_varchar2_table(2425) := '2031202E37303720306C322E33333620322E33312D2E3730372E37322D312E3938332D312E39372D332E35303520332E353035612E352E352030203020312D2E37303720306C2D322E31362D322E3135392D332E39333820332E3933392D312E3430392E';
wwv_flow_imp.g_varchar2_table(2426) := '3032367A222C66696C6C52756C653A226E6F6E7A65726F227D292C752822636972636C65222C7B63783A22372E35222C63793A22392E35222C723A22312E35227D2929297D6E286E532C2269636F6E496D61676522293B66756E6374696F6E2061532829';
wwv_flow_imp.g_varchar2_table(2427) := '7B72657475726E20752822737667222C7B22617269612D68696464656E223A2274727565222C666F63757361626C653A2266616C7365222C636C6173734E616D653A22757070792D632D69636F6E222C77696474683A223235222C6865696768743A2232';
wwv_flow_imp.g_varchar2_table(2428) := '35222C76696577426F783A22302030203235203235227D2C75282270617468222C7B643A224D392E352031382E3634633020312E31342D312E31343520322D322E352032732D322E352D2E38362D322E352D3263302D312E313420312E3134352D322032';
wwv_flow_imp.g_varchar2_table(2429) := '2E352D32202E353537203020312E3037392E31343520312E352E33393656372E3235612E352E35203020302031202E3337392D2E3438356C392D322E3235412E352E352030203020312031382E3520357631312E3634633020312E31342D312E31343520';
wwv_flow_imp.g_varchar2_table(2430) := '322D322E352032732D322E352D2E38362D322E352D3263302D312E313420312E3134352D3220322E352D32202E353537203020312E3037392E31343520312E352E33393656382E36376C2D38203276372E39377A6D382D3131762D326C2D38203276326C';
wwv_flow_imp.g_varchar2_table(2431) := '382D327A4D372031392E3634632E383535203020312E352D2E34383420312E352D31732D2E3634352D312D312E352D312D312E352E3438342D312E352031202E363435203120312E3520317A6D392D32632E383535203020312E352D2E34383420312E35';
wwv_flow_imp.g_varchar2_table(2432) := '2D31732D2E3634352D312D312E352D312D312E352E3438342D312E352031202E363435203120312E3520317A222C66696C6C3A2223303439424346222C66696C6C52756C653A226E6F6E7A65726F227D29297D6E2861532C2269636F6E417564696F2229';
wwv_flow_imp.g_varchar2_table(2433) := '3B66756E6374696F6E206C5328297B72657475726E20752822737667222C7B22617269612D68696464656E223A2274727565222C666F63757361626C653A2266616C7365222C636C6173734E616D653A22757070792D632D69636F6E222C77696474683A';
wwv_flow_imp.g_varchar2_table(2434) := '223235222C6865696768743A223235222C76696577426F783A22302030203235203235227D2C75282270617468222C7B643A224D31362031312E3833346C342E3438362D322E363931413120312030203020312032322031307636613120312030203020';
wwv_flow_imp.g_varchar2_table(2435) := '312D312E3531342E3835374C31362031342E313637563137613120312030203020312D3120314835613120312030203020312D312D3156396131203120302030203120312D31683130613120312030203020312031203176322E3833347A4D3135203948';
wwv_flow_imp.g_varchar2_table(2436) := '35763868313056397A6D3120346C352033762D366C2D3520337A222C66696C6C3A2223313941463637222C66696C6C52756C653A226E6F6E7A65726F227D29297D6E286C532C2269636F6E566964656F22293B66756E6374696F6E20755328297B726574';
wwv_flow_imp.g_varchar2_table(2437) := '75726E20752822737667222C7B22617269612D68696464656E223A2274727565222C666F63757361626C653A2266616C7365222C636C6173734E616D653A22757070792D632D69636F6E222C77696474683A223235222C6865696768743A223235222C76';
wwv_flow_imp.g_varchar2_table(2438) := '696577426F783A22302030203235203235227D2C75282270617468222C7B643A224D392E37363620382E323935632D2E3639312D312E3834332D2E3533392D332E3430312E3734372D332E37323620312E3634332D2E34313420322E3530352E39333820';
wwv_flow_imp.g_varchar2_table(2439) := '322E333920332E3239392D2E3033392E37392D2E31393420312E3636322D2E35333720332E3134382E3332342E34392E36362E39363720312E30353520312E35312E31372E3233312E3338322E3438382E3632392E37353720312E3836362D2E31323820';
wwv_flow_imp.g_varchar2_table(2440) := '332E3635332E31313420342E3931382E36353520312E3438372E36333520322E31393220312E36383520312E36313420322E38342D2E35363620312E3133332D312E38333920312E3038342D332E3431362E3234392D312E3134312D2E3630342D322E34';
wwv_flow_imp.g_varchar2_table(2441) := '35372D312E3633342D332E35312D322E3730376131332E3436372031332E3436372030203020302D322E3233382E343236632D312E33393220342E3035312D342E35333420362E3435332D352E37303720342E3537322D2E3938362D312E353820312E33';
wwv_flow_imp.g_varchar2_table(2442) := '382D342E32303620342E3931342D352E3337352E3039372D2E3332322E3138352D2E3635362E3236342D312E3030312E30382D2E3335332E3330362D312E33312E3430372D312E3733372D2E3637382D312E3035392D312E322D322E3033312D312E3533';
wwv_flow_imp.g_varchar2_table(2443) := '2D322E39317A6D322E30393820342E3837632D2E3033332E3134342D2E3036382E3238372D2E3130342E3432376C2E3033332D2E30312D2E3031322E3033386131342E3036352031342E30363520302030203120312E30322D2E3139376C2D2E3033322D';
wwv_flow_imp.g_varchar2_table(2444) := '2E3033332E3035322D2E30303461372E39303220372E3930322030203020312D2E3230382D2E323731632D2E3139372D2E32372D2E33382D2E3532362D2E3535352D2E3737356C2D2E3030362E3032382D2E3030322D2E303033632D2E3037362E333233';
wwv_flow_imp.g_varchar2_table(2445) := '2D2E3134382E3633322D2E3138362E387A6D352E373720322E39373863312E3134332E36303520312E3833322E36333220322E3035342E3138372E32362D2E3531392D2E3038372D312E3033342D312E3131332D312E3437332D2E3931312D2E33392D32';
wwv_flow_imp.g_varchar2_table(2446) := '2E3137352D2E3630382D332E35352D2E3630382E3834352E37363620312E37383720312E34353920322E36303920312E3839347A4D362E3535392031382E373839632E31342E3232332E3639332E313620312E3432352D2E3431332E3832372D2E363438';
wwv_flow_imp.g_varchar2_table(2447) := '20312E36312D312E37343720322E3230382D332E3230362D322E35363320312E3036342D342E31303220322E3836372D332E36333320332E36327A6D352E3334352D31302E3937632E3038382D312E3739332D2E3335312D322E34382D312E3134362D32';
wwv_flow_imp.g_varchar2_table(2448) := '2E32382D2E3437332E3131392D2E35363420312E30352D2E30353620322E3430352E3231332E3536362E353220312E3138382E39303820312E3835392E31382D2E3835382E3236382D312E3435332E3239342D312E3938347A222C66696C6C3A22234532';
wwv_flow_imp.g_varchar2_table(2449) := '35313441222C66696C6C52756C653A226E6F6E7A65726F227D29297D6E2875532C2269636F6E50444622293B66756E6374696F6E20685328297B72657475726E20752822737667222C7B22617269612D68696464656E223A2274727565222C666F637573';
wwv_flow_imp.g_varchar2_table(2450) := '61626C653A2266616C7365222C77696474683A223235222C6865696768743A223235222C76696577426F783A22302030203235203235227D2C75282270617468222C7B643A224D31302E343520322E303568312E3035612E352E35203020302031202E35';
wwv_flow_imp.g_varchar2_table(2451) := '2E35762E303234612E352E352030203020312D2E352E35682D312E3035612E352E352030203020312D2E352D2E3556322E3535612E352E35203020302031202E352D2E357A6D322E303520312E30323468312E3035612E352E35203020302031202E352E';
wwv_flow_imp.g_varchar2_table(2452) := '3556332E36612E352E352030203020312D2E352E354831322E35612E352E352030203020312D2E352D2E35762D2E303235612E352E35203020302031202E352D2E35762D2E3030317A4D31302E3435203068312E3035612E352E35203020302031202E35';
wwv_flow_imp.g_varchar2_table(2453) := '2E35762E303235612E352E352030203020312D2E352E35682D312E3035612E352E352030203020312D2E352D2E35562E35612E352E35203020302031202E352D2E357A6D322E303520312E30323568312E3035612E352E35203020302031202E352E3576';
wwv_flow_imp.g_varchar2_table(2454) := '2E303234612E352E352030203020312D2E352E354831322E35612E352E352030203020312D2E352D2E35762D2E303234612E352E35203020302031202E352D2E357A6D2D322E303520332E30373468312E3035612E352E35203020302031202E352E3576';
wwv_flow_imp.g_varchar2_table(2455) := '2E303235612E352E352030203020312D2E352E35682D312E3035612E352E352030203020312D2E352D2E35762D2E303235612E352E35203020302031202E352D2E357A6D322E303520312E30323568312E3035612E352E35203020302031202E352E3576';
wwv_flow_imp.g_varchar2_table(2456) := '2E303234612E352E352030203020312D2E352E354831322E35612E352E352030203020312D2E352D2E35762D2E303234612E352E35203020302031202E352D2E357A6D2D322E303520312E30323468312E3035612E352E35203020302031202E352E3576';
wwv_flow_imp.g_varchar2_table(2457) := '2E303235612E352E352030203020312D2E352E35682D312E3035612E352E352030203020312D2E352D2E35762D2E303235612E352E35203020302031202E352D2E357A6D322E303520312E30323568312E3035612E352E35203020302031202E352E3576';
wwv_flow_imp.g_varchar2_table(2458) := '2E303235612E352E352030203020312D2E352E354831322E35612E352E352030203020312D2E352D2E35762D2E303235612E352E35203020302031202E352D2E357A6D2D322E303520312E30323568312E3035612E352E35203020302031202E352E3576';
wwv_flow_imp.g_varchar2_table(2459) := '2E303235612E352E352030203020312D2E352E35682D312E3035612E352E352030203020312D2E352D2E35762D2E303235612E352E35203020302031202E352D2E357A6D322E303520312E30323568312E3035612E352E35203020302031202E352E3576';
wwv_flow_imp.g_varchar2_table(2460) := '2E303234612E352E352030203020312D2E352E354831322E35612E352E352030203020312D2E352D2E35762D2E303234612E352E35203020302031202E352D2E357A6D2D312E36353620332E3037346C2D2E383220352E393436632E35322E3330322031';
wwv_flow_imp.g_varchar2_table(2461) := '2E3137342E34353820312E3937362E3435382E383033203020312E3435352D2E31353620312E3937352D2E3435386C2D2E38322D352E393436682D322E3331317A6D302D312E30323568322E333132632E3531322030202E3934362E33373820312E3031';
wwv_flow_imp.g_varchar2_table(2462) := '352E3838356C2E383220352E393436632E3035362E3431322D2E3134322E3831372D2E35303120312E3032362D2E3638362E3339382D312E3531352E3539372D322E34392E3539372D2E39373420302D312E3830342D2E3139392D322E34392D2E353937';
wwv_flow_imp.g_varchar2_table(2463) := '61312E30323520312E3032352030203020312D2E352D312E3032366C2E3831392D352E393436632E30372D2E3530372E3530332D2E38383520312E3031352D2E3838357A6D2E35343520362E36612E352E352030203020312D2E3339372D2E3536316C2E';
wwv_flow_imp.g_varchar2_table(2464) := '3134332D2E393939612E352E35203020302031202E3439352D2E343239682E3734612E352E35203020302031202E3439352E34336C2E3134332E393938612E352E352030203020312D2E3339372E353631632D2E3430342E30382D2E3831392E30382D31';
wwv_flow_imp.g_varchar2_table(2465) := '2E32323220307A222C66696C6C3A2223303043343639222C66696C6C52756C653A226E6F6E7A65726F227D29297D6E2868532C2269636F6E4172636869766522293B66756E6374696F6E20645328297B72657475726E20752822737667222C7B22617269';
wwv_flow_imp.g_varchar2_table(2466) := '612D68696464656E223A2274727565222C666F63757361626C653A2266616C7365222C636C6173734E616D653A22757070792D632D69636F6E222C77696474683A223235222C6865696768743A223235222C76696577426F783A22302030203235203235';
wwv_flow_imp.g_varchar2_table(2467) := '227D2C75282267222C7B66696C6C3A2223413741464237222C66696C6C52756C653A226E6F6E7A65726F227D2C75282270617468222C7B643A224D352E35203232612E352E352030203020312D2E352D2E35762D3138612E352E35203020302031202E35';
wwv_flow_imp.g_varchar2_table(2468) := '2D2E356831302E373139612E352E35203020302031202E3336372E31366C332E32383120332E353536612E352E35203020302031202E3133332E3333395632312E35612E352E352030203020312D2E352E35682D31347A6D2E352D3168313356372E3235';
wwv_flow_imp.g_varchar2_table(2469) := '4C3136203448367631377A227D292C75282270617468222C7B643A224D313520347633613120312030203020302031203168335637682D335634682D317A227D2929297D6E2864532C2269636F6E46696C6522293B66756E6374696F6E20635328297B72';
wwv_flow_imp.g_varchar2_table(2470) := '657475726E20752822737667222C7B22617269612D68696464656E223A2274727565222C666F63757361626C653A2266616C7365222C636C6173734E616D653A22757070792D632D69636F6E222C77696474683A223235222C6865696768743A22323522';
wwv_flow_imp.g_varchar2_table(2471) := '2C76696577426F783A22302030203235203235227D2C75282270617468222C7B643A224D342E352037683133612E352E3520302031203120302031682D3133612E352E3520302030203120302D317A6D302033683135612E352E35203020312031203020';
wwv_flow_imp.g_varchar2_table(2472) := '31682D3135612E352E3520302031203120302D317A6D302033683135612E352E3520302031203120302031682D3135612E352E3520302031203120302D317A6D302033683130612E352E3520302031203120302031682D3130612E352E35203020312031';
wwv_flow_imp.g_varchar2_table(2473) := '20302D317A222C66696C6C3A2223354135453639222C66696C6C52756C653A226E6F6E7A65726F227D29297D6E2863532C2269636F6E5465787422293B66756E6374696F6E2052732869297B6C657420653D7B636F6C6F723A2223383338393939222C69';
wwv_flow_imp.g_varchar2_table(2474) := '636F6E3A645328297D3B69662821692972657475726E20653B6C657420743D692E73706C697428222F22295B305D2C723D692E73706C697428222F22295B315D3B72657475726E20743D3D3D2274657874223F7B636F6C6F723A2223356135653639222C';
wwv_flow_imp.g_varchar2_table(2475) := '69636F6E3A635328297D3A743D3D3D22696D616765223F7B636F6C6F723A2223363836646530222C69636F6E3A6E5328297D3A743D3D3D22617564696F223F7B636F6C6F723A2223303638646262222C69636F6E3A615328297D3A743D3D3D2276696465';
wwv_flow_imp.g_varchar2_table(2476) := '6F223F7B636F6C6F723A2223313961663637222C69636F6E3A6C5328297D3A743D3D3D226170706C69636174696F6E222626723D3D3D22706466223F7B636F6C6F723A2223653235313439222C69636F6E3A755328297D3A743D3D3D226170706C696361';
wwv_flow_imp.g_varchar2_table(2477) := '74696F6E2226265B227A6970222C22782D377A2D636F6D70726573736564222C22782D7261722D636F6D70726573736564222C22782D746172222C22782D677A6970222C22782D6170706C652D6469736B696D616765225D2E696E6465784F6628722921';
wwv_flow_imp.g_varchar2_table(2478) := '3D3D2D313F7B636F6C6F723A2223303043343639222C69636F6E3A685328297D3A657D6E2852732C2267657449636F6E42794D696D6522293B66756E6374696F6E2066612869297B6C65747B66696C653A657D3D693B696628652E707265766965772972';
wwv_flow_imp.g_varchar2_table(2479) := '657475726E20752822696D67222C7B636C6173734E616D653A22757070792D44617368626F6172642D4974656D2D70726576696577496D67222C616C743A652E6E616D652C7372633A652E707265766965777D293B6C65747B636F6C6F723A742C69636F';
wwv_flow_imp.g_varchar2_table(2480) := '6E3A727D3D527328652E74797065293B72657475726E20752822646976222C7B636C6173734E616D653A22757070792D44617368626F6172642D4974656D2D7072657669657749636F6E57726170227D2C7528227370616E222C7B636C6173734E616D65';
wwv_flow_imp.g_varchar2_table(2481) := '3A22757070792D44617368626F6172642D4974656D2D7072657669657749636F6E222C7374796C653A7B636F6C6F723A747D7D2C72292C752822737667222C7B22617269612D68696464656E223A2274727565222C666F63757361626C653A2266616C73';
wwv_flow_imp.g_varchar2_table(2482) := '65222C636C6173734E616D653A22757070792D44617368626F6172642D4974656D2D7072657669657749636F6E4267222C77696474683A223538222C6865696768743A223736222C76696577426F783A22302030203538203736227D2C75282272656374';
wwv_flow_imp.g_varchar2_table(2483) := '222C7B66696C6C3A2223464646222C77696474683A223538222C6865696768743A223736222C72783A2233222C66696C6C52756C653A226576656E6F6464227D2929297D6E2866612C2246696C655072657669657722293B7661722070533D6E2828692C';
wwv_flow_imp.g_varchar2_table(2484) := '65293D3E28747970656F6620653D3D2266756E6374696F6E223F6528293A65292E66696C74657228733D3E732E69643D3D3D69295B305D2E6E616D652C226D6574614669656C644964546F4E616D6522293B66756E6374696F6E206D612869297B6C6574';
wwv_flow_imp.g_varchar2_table(2485) := '7B66696C653A652C746F67676C6546696C65436172643A742C6931386E3A722C6D6574614669656C64733A737D3D692C7B6D697373696E6752657175697265644D6574614669656C64733A6F7D3D653B69662821286F213D6E756C6C26266F2E6C656E67';
wwv_flow_imp.g_varchar2_table(2486) := '7468292972657475726E206E756C6C3B6C657420613D6F2E6D6170286C3D3E7053286C2C7329292E6A6F696E28222C2022293B72657475726E20752822646976222C7B636C6173734E616D653A22757070792D44617368626F6172642D4974656D2D6572';
wwv_flow_imp.g_varchar2_table(2487) := '726F724D657373616765227D2C7228226D697373696E6752657175697265644D6574614669656C6473222C7B736D6172745F636F756E743A6F2E6C656E6774682C6669656C64733A617D292C2220222C752822627574746F6E222C7B747970653A226275';
wwv_flow_imp.g_varchar2_table(2488) := '74746F6E222C636C6173733A22757070792D752D726573657420757070792D44617368626F6172642D4974656D2D6572726F724D65737361676542746E222C6F6E436C69636B3A28293D3E742821302C652E6964297D2C7228226564697446696C652229';
wwv_flow_imp.g_varchar2_table(2489) := '29297D6E286D612C2272656E6465724D697373696E674D6574614669656C64734572726F7222293B66756E6374696F6E2043642869297B6C65747B66696C653A652C6931386E3A742C746F67676C6546696C65436172643A722C6D6574614669656C6473';
wwv_flow_imp.g_varchar2_table(2490) := '3A732C73686F774C696E6B546F46696C6555706C6F6164526573756C743A6F7D3D692C613D2272676261283235352C203235352C203235352C20302E3529222C6C3D652E707265766965773F613A527328692E66696C652E74797065292E636F6C6F723B';
wwv_flow_imp.g_varchar2_table(2491) := '72657475726E20752822646976222C7B636C6173734E616D653A22757070792D44617368626F6172642D4974656D2D70726576696577496E6E657257726170222C7374796C653A7B6261636B67726F756E64436F6C6F723A6C7D7D2C6F2626652E75706C';
wwv_flow_imp.g_varchar2_table(2492) := '6F616455524C262675282261222C7B636C6173734E616D653A22757070792D44617368626F6172642D4974656D2D707265766965774C696E6B222C687265663A652E75706C6F616455524C2C72656C3A226E6F7265666572726572206E6F6F70656E6572';
wwv_flow_imp.g_varchar2_table(2493) := '222C7461726765743A225F626C616E6B222C22617269612D6C6162656C223A652E6D6574612E6E616D657D2C7528227370616E222C7B68696464656E3A21307D2C652E6D6574612E6E616D6529292C752866612C7B66696C653A657D292C75286D612C7B';
wwv_flow_imp.g_varchar2_table(2494) := '66696C653A652C6931386E3A742C746F67676C6546696C65436172643A722C6D6574614669656C64733A737D29297D6E2843642C2246696C6550726576696577416E644C696E6B22293B66756E6374696F6E2066532869297B69662821692E697355706C';
wwv_flow_imp.g_varchar2_table(2495) := '6F61646564297B696628692E6572726F72262621692E686964655265747279427574746F6E297B692E757070792E726574727955706C6F616428692E66696C652E6964293B72657475726E7D692E726573756D61626C6555706C6F616473262621692E68';
wwv_flow_imp.g_varchar2_table(2496) := '6964655061757365526573756D65427574746F6E3F692E757070792E7061757365526573756D6528692E66696C652E6964293A692E696E646976696475616C43616E63656C6C6174696F6E262621692E6869646543616E63656C427574746F6E2626692E';
wwv_flow_imp.g_varchar2_table(2497) := '757070792E72656D6F766546696C6528692E66696C652E6964297D7D6E2866532C226F6E5061757365526573756D6543616E63656C526574727922293B66756E6374696F6E206E792869297B72657475726E20692E697355706C6F616465643F692E6931';
wwv_flow_imp.g_varchar2_table(2498) := '386E282275706C6F6164436F6D706C65746522293A692E6572726F723F692E6931386E2822726574727955706C6F616422293A692E726573756D61626C6555706C6F6164733F692E66696C652E69735061757365643F692E6931386E2822726573756D65';
wwv_flow_imp.g_varchar2_table(2499) := '55706C6F616422293A692E6931386E2822706175736555706C6F616422293A692E696E646976696475616C43616E63656C6C6174696F6E3F692E6931386E282263616E63656C55706C6F616422293A22227D6E286E792C2270726F6772657373496E6469';
wwv_flow_imp.g_varchar2_table(2500) := '6361746F725469746C6522293B66756E6374696F6E204F642869297B72657475726E20752822646976222C7B636C6173734E616D653A22757070792D44617368626F6172642D4974656D2D70726F6772657373227D2C752822627574746F6E222C7B636C';
wwv_flow_imp.g_varchar2_table(2501) := '6173734E616D653A22757070792D752D726573657420757070792D632D62746E20757070792D44617368626F6172642D4974656D2D70726F6772657373496E64696361746F72222C747970653A22627574746F6E222C22617269612D6C6162656C223A6E';
wwv_flow_imp.g_varchar2_table(2502) := '792869292C7469746C653A6E792869292C6F6E436C69636B3A28293D3E66532869297D2C692E6368696C6472656E29297D6E284F642C2250726F6772657373496E64696361746F72427574746F6E22293B66756E6374696F6E2052752869297B6C65747B';
wwv_flow_imp.g_varchar2_table(2503) := '6368696C6472656E3A657D3D693B72657475726E20752822737667222C7B22617269612D68696464656E223A2274727565222C666F63757361626C653A2266616C7365222C77696474683A223730222C6865696768743A223730222C76696577426F783A';
wwv_flow_imp.g_varchar2_table(2504) := '22302030203336203336222C636C6173734E616D653A22757070792D632D69636F6E20757070792D44617368626F6172642D4974656D2D70726F677265737349636F6E2D2D636972636C65227D2C65297D6E2852752C2250726F6772657373436972636C';
wwv_flow_imp.g_varchar2_table(2505) := '65436F6E7461696E657222293B66756E6374696F6E2054642869297B6C65747B70726F67726573733A657D3D692C743D322A4D6174682E50492A31353B72657475726E2075282267222C6E756C6C2C752822636972636C65222C7B636C6173734E616D65';
wwv_flow_imp.g_varchar2_table(2506) := '3A22757070792D44617368626F6172642D4974656D2D70726F677265737349636F6E2D2D6267222C723A223135222C63783A223138222C63793A223138222C227374726F6B652D7769647468223A2232222C66696C6C3A226E6F6E65227D292C75282263';
wwv_flow_imp.g_varchar2_table(2507) := '6972636C65222C7B636C6173734E616D653A22757070792D44617368626F6172642D4974656D2D70726F677265737349636F6E2D2D70726F6772657373222C723A223135222C63783A223138222C63793A223138222C7472616E73666F726D3A22726F74';
wwv_flow_imp.g_varchar2_table(2508) := '617465282D39302C2031382C20313829222C66696C6C3A226E6F6E65222C227374726F6B652D7769647468223A2232222C227374726F6B652D646173686172726179223A742C227374726F6B652D646173686F6666736574223A742D742F3130302A657D';
wwv_flow_imp.g_varchar2_table(2509) := '29297D6E2854642C2250726F6772657373436972636C6522293B66756E6374696F6E2041642869297B69662821692E66696C652E70726F67726573732E75706C6F6164537461727465642972657475726E206E756C6C3B696628692E697355706C6F6164';
wwv_flow_imp.g_varchar2_table(2510) := '65642972657475726E20752822646976222C7B636C6173734E616D653A22757070792D44617368626F6172642D4974656D2D70726F6772657373227D2C752822646976222C7B636C6173734E616D653A22757070792D44617368626F6172642D4974656D';
wwv_flow_imp.g_varchar2_table(2511) := '2D70726F6772657373496E64696361746F72227D2C752852752C6E756C6C2C752822636972636C65222C7B723A223135222C63783A223138222C63793A223138222C66696C6C3A2223316262323430227D292C752822706F6C79676F6E222C7B636C6173';
wwv_flow_imp.g_varchar2_table(2512) := '734E616D653A22757070792D44617368626F6172642D4974656D2D70726F677265737349636F6E2D2D636865636B222C7472616E73666F726D3A227472616E736C61746528322C203329222C706F696E74733A2231342032322E3520372031352E323435';
wwv_flow_imp.g_varchar2_table(2513) := '3730363520382E39393938353835372031332E313733323831352031342031382E333534373130342032322E3937323938383320392032352031312E31303035363334227D292929293B69662821692E7265636F76657265645374617465297265747572';
wwv_flow_imp.g_varchar2_table(2514) := '6E20692E6572726F72262621692E686964655265747279427574746F6E3F75284F642C692C752822737667222C7B22617269612D68696464656E223A2274727565222C666F63757361626C653A2266616C7365222C636C6173734E616D653A2275707079';
wwv_flow_imp.g_varchar2_table(2515) := '2D632D69636F6E20757070792D44617368626F6172642D4974656D2D70726F677265737349636F6E2D2D7265747279222C77696474683A223238222C6865696768743A223331222C76696577426F783A22302030203136203139227D2C75282270617468';
wwv_flow_imp.g_varchar2_table(2516) := '222C7B643A224D3136203131613820382030203120312D382D387632613620362030203120302036203668327A227D292C75282270617468222C7B643A224D372E392033483130763248372E397A227D292C75282270617468222C7B643A224D382E3533';
wwv_flow_imp.g_varchar2_table(2517) := '362E356C332E35333520332E3533362D312E34313420312E3431344C372E313220312E3931347A227D292C75282270617468222C7B643A224D31302E36353720322E3632316C312E34313420312E3431354C382E35333620372E353720372E313220362E';
wwv_flow_imp.g_varchar2_table(2518) := '3135377A227D2929293A692E726573756D61626C6555706C6F616473262621692E686964655061757365526573756D65427574746F6E3F75284F642C692C752852752C6E756C6C2C752854642C7B70726F67726573733A692E66696C652E70726F677265';
wwv_flow_imp.g_varchar2_table(2519) := '73732E70657263656E746167657D292C692E66696C652E69735061757365643F752822706F6C79676F6E222C7B636C6173734E616D653A22757070792D44617368626F6172642D4974656D2D70726F677265737349636F6E2D2D706C6179222C7472616E';
wwv_flow_imp.g_varchar2_table(2520) := '73666F726D3A227472616E736C61746528332C203329222C706F696E74733A223132203230203132203130203230203135227D293A75282267222C7B636C6173734E616D653A22757070792D44617368626F6172642D4974656D2D70726F677265737349';
wwv_flow_imp.g_varchar2_table(2521) := '636F6E2D2D7061757365222C7472616E73666F726D3A227472616E736C6174652831342E352C20313329227D2C75282272656374222C7B783A2230222C793A2230222C77696474683A2232222C6865696768743A223130222C72783A2230227D292C7528';
wwv_flow_imp.g_varchar2_table(2522) := '2272656374222C7B783A2235222C793A2230222C77696474683A2232222C6865696768743A223130222C72783A2230227D292929293A21692E726573756D61626C6555706C6F6164732626692E696E646976696475616C43616E63656C6C6174696F6E26';
wwv_flow_imp.g_varchar2_table(2523) := '2621692E6869646543616E63656C427574746F6E3F75284F642C692C752852752C6E756C6C2C752854642C7B70726F67726573733A692E66696C652E70726F67726573732E70657263656E746167657D292C752822706F6C79676F6E222C7B636C617373';
wwv_flow_imp.g_varchar2_table(2524) := '4E616D653A2263616E63656C222C7472616E73666F726D3A227472616E736C61746528322C203229222C706F696E74733A2231392E383835363531362031312E303632352031362031342E393438313531362031322E313031393733372031312E303632';
wwv_flow_imp.g_varchar2_table(2525) := '352031312E303632352031322E313134333438342031342E393438313531362031362031312E303632352031392E383938303236332031322E313031393733372032302E393337352031362031372E303531383438342031392E38383536353136203230';
wwv_flow_imp.g_varchar2_table(2526) := '2E393337352032302E393337352031392E383938303236332031372E303531383438342031362032302E39333735203132227D2929293A752822646976222C7B636C6173734E616D653A22757070792D44617368626F6172642D4974656D2D70726F6772';
wwv_flow_imp.g_varchar2_table(2527) := '657373227D2C752822646976222C7B636C6173734E616D653A22757070792D44617368626F6172642D4974656D2D70726F6772657373496E64696361746F72227D2C752852752C6E756C6C2C752854642C7B70726F67726573733A692E66696C652E7072';
wwv_flow_imp.g_varchar2_table(2528) := '6F67726573732E70657263656E746167657D292929297D6E2841642C2246696C6550726F677265737322293B7661722075793D6465286C7928292C31293B7661722052643D222E2E2E223B66756E6374696F6E20557528692C65297B696628653D3D3D30';
wwv_flow_imp.g_varchar2_table(2529) := '2972657475726E22223B696628692E6C656E6774683C3D652972657475726E20693B696628653C3D52642E6C656E6774682B312972657475726E60247B692E736C69636528302C652D31297D5C7532303236603B6C657420743D652D52642E6C656E6774';
wwv_flow_imp.g_varchar2_table(2530) := '682C723D4D6174682E6365696C28742F32292C733D4D6174682E666C6F6F7228742F32293B72657475726E20692E736C69636528302C72292B52642B692E736C696365282D73297D6E2855752C227472756E63617465537472696E6722293B766172206D';
wwv_flow_imp.g_varchar2_table(2531) := '533D6E28693D3E7B6C65747B617574686F723A652C6E616D653A747D3D692E66696C652E6D6574613B66756E6374696F6E207228297B72657475726E20692E697353696E676C6546696C652626692E636F6E7461696E65724865696768743E3D3335303F';
wwv_flow_imp.g_varchar2_table(2532) := '39303A692E636F6E7461696E657257696474683C3D3335323F33353A692E636F6E7461696E657257696474683C3D3537363F36303A653F32303A33307D72657475726E206E28722C226765744D61784E616D654C656E67746822292C752822646976222C';
wwv_flow_imp.g_varchar2_table(2533) := '7B636C6173734E616D653A22757070792D44617368626F6172642D4974656D2D6E616D65222C7469746C653A747D2C557528742C72282929297D2C2272656E64657246696C654E616D6522292C67533D6E28693D3E7B6C65747B617574686F723A657D3D';
wwv_flow_imp.g_varchar2_table(2534) := '692E66696C652E6D6574612C7B70726F76696465724E616D653A747D3D692E66696C652E72656D6F74652C723D225C784237223B72657475726E20653F752822646976222C7B636C6173734E616D653A22757070792D44617368626F6172642D4974656D';
wwv_flow_imp.g_varchar2_table(2535) := '2D617574686F72227D2C75282261222C7B687265663A60247B652E75726C7D3F75746D5F736F757263653D436F6D70616E696F6E2675746D5F6D656469756D3D726566657272616C602C7461726765743A225F626C616E6B222C72656C3A226E6F6F7065';
wwv_flow_imp.g_varchar2_table(2536) := '6E6572206E6F7265666572726572227D2C557528652E6E616D652C313329292C743F752848742C6E756C6C2C6020247B727D20602C742C6020247B727D2060293A6E756C6C293A6E756C6C7D2C2272656E646572417574686F7222292C79533D6E28693D';
wwv_flow_imp.g_varchar2_table(2537) := '3E692E66696C652E73697A652626752822646976222C7B636C6173734E616D653A22757070792D44617368626F6172642D4974656D2D73746174757353697A65227D2C28302C75792E64656661756C742928692E66696C652E73697A6529292C2272656E';
wwv_flow_imp.g_varchar2_table(2538) := '64657246696C6553697A6522292C76533D6E28693D3E692E66696C652E697347686F737426267528227370616E222C6E756C6C2C22205C753230323220222C752822627574746F6E222C7B636C6173734E616D653A22757070792D752D72657365742075';
wwv_flow_imp.g_varchar2_table(2539) := '7070792D632D62746E20757070792D44617368626F6172642D4974656D2D726553656C656374222C747970653A22627574746F6E222C6F6E436C69636B3A692E746F67676C6541646446696C657350616E656C7D2C692E6931386E2822726553656C6563';
wwv_flow_imp.g_varchar2_table(2540) := '74222929292C22526553656C656374427574746F6E22292C62533D6E28693D3E7B6C65747B66696C653A652C6F6E436C69636B3A747D3D693B72657475726E20652E6572726F723F752822627574746F6E222C7B636C6173734E616D653A22757070792D';
wwv_flow_imp.g_varchar2_table(2541) := '752D726573657420757070792D632D62746E20757070792D44617368626F6172642D4974656D2D6572726F7244657461696C73222C22617269612D6C6162656C223A652E6572726F722C22646174612D6D6963726F7469702D706F736974696F6E223A22';
wwv_flow_imp.g_varchar2_table(2542) := '626F74746F6D222C22646174612D6D6963726F7469702D73697A65223A226D656469756D222C6F6E436C69636B3A742C747970653A22627574746F6E227D2C223F22293A6E756C6C7D2C224572726F72427574746F6E22293B66756E6374696F6E205564';
wwv_flow_imp.g_varchar2_table(2543) := '2869297B6C65747B66696C653A657D3D693B72657475726E20752822646976222C7B636C6173734E616D653A22757070792D44617368626F6172642D4974656D2D66696C65496E666F222C22646174612D757070792D66696C652D736F75726365223A65';
wwv_flow_imp.g_varchar2_table(2544) := '2E736F757263657D2C752822646976222C7B636C6173734E616D653A22757070792D44617368626F6172642D4974656D2D66696C654E616D65227D2C6D532869292C752862532C7B66696C653A692E66696C652C6F6E436C69636B3A28293D3E616C6572';
wwv_flow_imp.g_varchar2_table(2545) := '7428692E66696C652E6572726F72297D29292C752822646976222C7B636C6173734E616D653A22757070792D44617368626F6172642D4974656D2D737461747573227D2C67532869292C79532869292C7653286929292C75286D612C7B66696C653A692E';
wwv_flow_imp.g_varchar2_table(2546) := '66696C652C6931386E3A692E6931386E2C746F67676C6546696C65436172643A692E746F67676C6546696C65436172642C6D6574614669656C64733A692E6D6574614669656C64737D29297D6E2855642C2246696C65496E666F22293B66756E6374696F';
wwv_flow_imp.g_varchar2_table(2547) := '6E206B6428692C65297B72657475726E20653D3D3D766F69642030262628653D22436F7079207468652055524C2062656C6F7722292C6E65772050726F6D69736528743D3E7B6C657420723D646F63756D656E742E637265617465456C656D656E742822';
wwv_flow_imp.g_varchar2_table(2548) := '746578746172656122293B722E73657441747472696275746528227374796C65222C7B706F736974696F6E3A226669786564222C746F703A302C6C6566743A302C77696474683A2232656D222C6865696768743A2232656D222C70616464696E673A302C';
wwv_flow_imp.g_varchar2_table(2549) := '626F726465723A226E6F6E65222C6F75746C696E653A226E6F6E65222C626F78536861646F773A226E6F6E65222C6261636B67726F756E643A227472616E73706172656E74227D292C722E76616C75653D692C646F63756D656E742E626F64792E617070';
wwv_flow_imp.g_varchar2_table(2550) := '656E644368696C642872292C722E73656C65637428293B6C657420733D6E2828293D3E7B646F63756D656E742E626F64792E72656D6F76654368696C642872292C77696E646F772E70726F6D707428652C69292C7428297D2C226D61676963436F707946';
wwv_flow_imp.g_varchar2_table(2551) := '61696C656422293B7472797B72657475726E20646F63756D656E742E65786563436F6D6D616E642822636F707922293F28646F63756D656E742E626F64792E72656D6F76654368696C642872292C742829293A732822636F707920636F6D6D616E642075';
wwv_flow_imp.g_varchar2_table(2552) := '6E617661696C61626C6522297D6361746368286F297B72657475726E20646F63756D656E742E626F64792E72656D6F76654368696C642872292C73286F297D7D297D6E286B642C22636F7079546F436C6970626F61726422293B66756E6374696F6E2077';
wwv_flow_imp.g_varchar2_table(2553) := '532869297B6C65747B66696C653A652C75706C6F6164496E50726F67726573734F72436F6D706C6574653A742C6D6574614669656C64733A722C63616E4564697446696C653A732C6931386E3A6F2C6F6E436C69636B3A617D3D693B72657475726E2174';
wwv_flow_imp.g_varchar2_table(2554) := '2626722626722E6C656E6774683E307C7C21742626732865293F752822627574746F6E222C7B636C6173734E616D653A22757070792D752D726573657420757070792D632D62746E20757070792D44617368626F6172642D4974656D2D616374696F6E20';
wwv_flow_imp.g_varchar2_table(2555) := '757070792D44617368626F6172642D4974656D2D616374696F6E2D2D65646974222C747970653A22627574746F6E222C22617269612D6C6162656C223A6F28226564697446696C655769746846696C656E616D65222C7B66696C653A652E6D6574612E6E';
wwv_flow_imp.g_varchar2_table(2556) := '616D657D292C7469746C653A6F28226564697446696C655769746846696C656E616D65222C7B66696C653A652E6D6574612E6E616D657D292C6F6E436C69636B3A28293D3E6128297D2C752822737667222C7B22617269612D68696464656E223A227472';
wwv_flow_imp.g_varchar2_table(2557) := '7565222C666F63757361626C653A2266616C7365222C636C6173734E616D653A22757070792D632D69636F6E222C77696474683A223134222C6865696768743A223134222C76696577426F783A22302030203134203134227D2C75282267222C7B66696C';
wwv_flow_imp.g_varchar2_table(2558) := '6C52756C653A226576656E6F6464227D2C75282270617468222C7B643A224D312E352031302E37393368322E3739334131203120302030203020352031302E354C31312E3520346131203120302030203020302D312E3431344C392E3730372E37393361';
wwv_flow_imp.g_varchar2_table(2559) := '3120312030203020302D312E34313420306C2D362E3520362E354131203120302030203020312E35203876322E3739337A6D312D3156384C3920312E356C312E37393320312E3739332D362E3520362E3548322E357A222C66696C6C52756C653A226E6F';
wwv_flow_imp.g_varchar2_table(2560) := '6E7A65726F227D292C75282272656374222C7B783A2231222C793A2231322E323933222C77696474683A223131222C6865696768743A2231222C72783A222E35227D292C75282270617468222C7B66696C6C52756C653A226E6F6E7A65726F222C643A22';
wwv_flow_imp.g_varchar2_table(2561) := '4D362E37393320322E354C392E3520352E3230376C2E3730372D2E3730374C372E3520312E3739337A227D292929293A6E756C6C7D6E2877532C2245646974427574746F6E22293B66756E6374696F6E2053532869297B6C65747B6931386E3A652C6F6E';
wwv_flow_imp.g_varchar2_table(2562) := '436C69636B3A742C66696C653A727D3D693B72657475726E20752822627574746F6E222C7B636C6173734E616D653A22757070792D752D726573657420757070792D44617368626F6172642D4974656D2D616374696F6E20757070792D44617368626F61';
wwv_flow_imp.g_varchar2_table(2563) := '72642D4974656D2D616374696F6E2D2D72656D6F7665222C747970653A22627574746F6E222C22617269612D6C6162656C223A65282272656D6F766546696C65222C7B66696C653A722E6D6574612E6E616D657D292C7469746C653A65282272656D6F76';
wwv_flow_imp.g_varchar2_table(2564) := '6546696C65222C7B66696C653A722E6D6574612E6E616D657D292C6F6E436C69636B3A28293D3E7428297D2C752822737667222C7B22617269612D68696464656E223A2274727565222C666F63757361626C653A2266616C7365222C636C6173734E616D';
wwv_flow_imp.g_varchar2_table(2565) := '653A22757070792D632D69636F6E222C77696474683A223138222C6865696768743A223138222C76696577426F783A22302030203138203138227D2C75282270617468222C7B643A224D39203043342E3033342030203020342E3033342030203973342E';
wwv_flow_imp.g_varchar2_table(2566) := '30333420392039203920392D342E30333420392D392D342E3033342D392D392D397A227D292C75282270617468222C7B66696C6C3A2223464646222C643A224D31332031322E3232326C2D2E3737382E3737384C3920392E37373820352E373738203133';
wwv_flow_imp.g_varchar2_table(2567) := '20352031322E32323220382E3232322039203520352E37373820352E3737382035203920382E3232322031322E32323220356C2E3737382E3737384C392E37373820397A227D2929297D6E2853532C2252656D6F7665427574746F6E22293B7661722050';
wwv_flow_imp.g_varchar2_table(2568) := '533D6E2828692C65293D3E7B6B6428652E66696C652E75706C6F616455524C2C652E6931386E2822636F70794C696E6B546F436C6970626F61726446616C6C6261636B2229292E7468656E2828293D3E7B652E757070792E6C6F6728224C696E6B20636F';
wwv_flow_imp.g_varchar2_table(2569) := '7069656420746F20636C6970626F6172642E22292C652E757070792E696E666F28652E6931386E2822636F70794C696E6B546F436C6970626F6172645375636365737322292C22696E666F222C336533297D292E636174636828652E757070792E6C6F67';
wwv_flow_imp.g_varchar2_table(2570) := '292E7468656E2828293D3E692E7461726765742E666F637573287B70726576656E745363726F6C6C3A21307D29297D2C22636F70794C696E6B546F436C6970626F61726422293B66756E6374696F6E205F532869297B6C65747B6931386E3A657D3D693B';
wwv_flow_imp.g_varchar2_table(2571) := '72657475726E20752822627574746F6E222C7B636C6173734E616D653A22757070792D752D726573657420757070792D44617368626F6172642D4974656D2D616374696F6E20757070792D44617368626F6172642D4974656D2D616374696F6E2D2D636F';
wwv_flow_imp.g_varchar2_table(2572) := '70794C696E6B222C747970653A22627574746F6E222C22617269612D6C6162656C223A652822636F70794C696E6B22292C7469746C653A652822636F70794C696E6B22292C6F6E436C69636B3A743D3E505328742C69297D2C752822737667222C7B2261';
wwv_flow_imp.g_varchar2_table(2573) := '7269612D68696464656E223A2274727565222C666F63757361626C653A2266616C7365222C636C6173734E616D653A22757070792D632D69636F6E222C77696474683A223134222C6865696768743A223134222C76696577426F783A2230203020313420';
wwv_flow_imp.g_varchar2_table(2574) := '3132227D2C75282270617468222C7B643A224D372E393420372E37303361322E36313320322E3631332030203020312D2E36323620322E3638316C2D2E3835322E38353161322E35393720322E3539372030203020312D312E3834392E37363641322E36';
wwv_flow_imp.g_varchar2_table(2575) := '313620322E36313620302030203120322E37363420372E35346C2E3835322D2E38353261322E35393620322E35393620302030203120322E36392D2E3632354C352E32363720372E30393961312E343420312E34342030203020302D2E3833332E343037';
wwv_flow_imp.g_varchar2_table(2576) := '6C2D2E3835322E38353161312E34353820312E34353820302030203020312E303320322E343836632E33392030202E3735352D2E31353220312E30332D2E3432366C2E3835322D2E383532632E3233312D2E3233312E3336332D2E3532322E3430362D2E';
wwv_flow_imp.g_varchar2_table(2577) := '3832346C312E30342D312E3033387A6D342E3239352D352E39333741322E35393620322E3539362030203020302031302E3338372031632D2E36393820302D312E3335352E3237322D312E3834392E3736366C2D2E3835322E38353161322E3631342032';
wwv_flow_imp.g_varchar2_table(2578) := '2E3631342030203020302D2E36323420322E3638386C312E3033362D312E303336632E3034312D2E3330342E3137332D2E362E3430372D2E3833336C2E3835322D2E383532632E3237352D2E3237352E36342D2E34323620312E30332D2E34323661312E';
wwv_flow_imp.g_varchar2_table(2579) := '34353820312E34353820302030203120312E303320322E3438366C2D2E3835322E38353161312E34343220312E3434322030203020312D2E3832342E3430366C2D312E303420312E303461322E35393620322E35393620302030203020322E3638332D2E';
wwv_flow_imp.g_varchar2_table(2580) := '3632386C2E3835312D2E383561322E36313620322E36313620302030203020302D332E3639377A6D2D362E383820362E383833612E3537372E353737203020302030202E383220306C332E3437342D332E343734612E3537392E3537392030203120302D';
wwv_flow_imp.g_varchar2_table(2581) := '2E3831392D2E38324C352E33353520372E3833612E3537392E3537392030203020302030202E3831397A227D2929297D6E285F532C22436F70794C696E6B427574746F6E22293B66756E6374696F6E2044642869297B6C65747B757070793A652C66696C';
wwv_flow_imp.g_varchar2_table(2582) := '653A742C75706C6F6164496E50726F67726573734F72436F6D706C6574653A722C63616E4564697446696C653A732C6D6574614669656C64733A6F2C73686F774C696E6B546F46696C6555706C6F6164526573756C743A612C73686F7752656D6F766542';
wwv_flow_imp.g_varchar2_table(2583) := '7574746F6E3A6C2C6931386E3A682C746F67676C6546696C65436172643A632C6F70656E46696C65456469746F723A647D3D693B72657475726E20752822646976222C7B636C6173734E616D653A22757070792D44617368626F6172642D4974656D2D61';
wwv_flow_imp.g_varchar2_table(2584) := '6374696F6E57726170706572227D2C752877532C7B6931386E3A682C66696C653A742C75706C6F6164496E50726F67726573734F72436F6D706C6574653A722C63616E4564697446696C653A732C6D6574614669656C64733A6F2C6F6E436C69636B3A6E';
wwv_flow_imp.g_varchar2_table(2585) := '2828293D3E7B6F26266F2E6C656E6774683E303F632821302C742E6964293A642874297D2C2265646974416374696F6E22297D292C612626742E75706C6F616455524C3F75285F532C7B66696C653A742C757070793A652C6931386E3A687D293A6E756C';
wwv_flow_imp.g_varchar2_table(2586) := '6C2C6C3F752853532C7B6931386E3A682C66696C653A742C757070793A652C6F6E436C69636B3A28293D3E692E757070792E72656D6F766546696C6528742E69642C2272656D6F7665642D62792D7573657222297D293A6E756C6C297D6E2844642C2242';
wwv_flow_imp.g_varchar2_table(2587) := '7574746F6E7322293B76617220486F3D636C61737320657874656E64732077657B636F6D706F6E656E744469644D6F756E7428297B6C65747B66696C653A657D3D746869732E70726F70733B652E707265766965777C7C746869732E70726F70732E6861';
wwv_flow_imp.g_varchar2_table(2588) := '6E646C65526571756573745468756D626E61696C2865297D73686F756C64436F6D706F6E656E745570646174652865297B72657475726E2128302C64792E64656661756C742928746869732E70726F70732C65297D636F6D706F6E656E74446964557064';
wwv_flow_imp.g_varchar2_table(2589) := '61746528297B6C65747B66696C653A657D3D746869732E70726F70733B652E707265766965777C7C746869732E70726F70732E68616E646C65526571756573745468756D626E61696C2865297D636F6D706F6E656E7457696C6C556E6D6F756E7428297B';
wwv_flow_imp.g_varchar2_table(2590) := '6C65747B66696C653A657D3D746869732E70726F70733B652E707265766965777C7C746869732E70726F70732E68616E646C6543616E63656C5468756D626E61696C2865297D72656E64657228297B6C65747B66696C653A657D3D746869732E70726F70';
wwv_flow_imp.g_varchar2_table(2591) := '732C743D652E70726F67726573732E70726570726F636573737C7C652E70726F67726573732E706F737470726F636573732C723D652E70726F67726573732E75706C6F6164436F6D706C65746526262174262621652E6572726F722C733D652E70726F67';
wwv_flow_imp.g_varchar2_table(2592) := '726573732E75706C6F6164537461727465647C7C742C6F3D652E70726F67726573732E75706C6F616453746172746564262621652E70726F67726573732E75706C6F6164436F6D706C6574657C7C742C613D652E6572726F727C7C21312C7B697347686F';
wwv_flow_imp.g_varchar2_table(2593) := '73743A6C7D3D652C683D28746869732E70726F70732E696E646976696475616C43616E63656C6C6174696F6E7C7C216F29262621723B722626746869732E70726F70732E73686F7752656D6F7665427574746F6E4166746572436F6D706C657465262628';
wwv_flow_imp.g_varchar2_table(2594) := '683D2130293B6C657420633D28302C68792E64656661756C7429287B22757070792D44617368626F6172642D4974656D223A21302C2269732D696E70726F6772657373223A6F262621746869732E70726F70732E7265636F766572656453746174652C22';
wwv_flow_imp.g_varchar2_table(2595) := '69732D70726F63657373696E67223A742C2269732D636F6D706C657465223A722C2269732D6572726F72223A2121612C2269732D726573756D61626C65223A746869732E70726F70732E726573756D61626C6555706C6F6164732C2269732D6E6F496E64';
wwv_flow_imp.g_varchar2_table(2596) := '6976696475616C43616E63656C6C6174696F6E223A21746869732E70726F70732E696E646976696475616C43616E63656C6C6174696F6E2C2269732D67686F7374223A6C7D293B72657475726E20752822646976222C7B636C6173734E616D653A632C69';
wwv_flow_imp.g_varchar2_table(2597) := '643A60757070795F247B652E69647D602C726F6C653A746869732E70726F70732E726F6C657D2C752822646976222C7B636C6173734E616D653A22757070792D44617368626F6172642D4974656D2D70726576696577227D2C752843642C7B66696C653A';
wwv_flow_imp.g_varchar2_table(2598) := '652C73686F774C696E6B546F46696C6555706C6F6164526573756C743A746869732E70726F70732E73686F774C696E6B546F46696C6555706C6F6164526573756C742C6931386E3A746869732E70726F70732E6931386E2C746F67676C6546696C654361';
wwv_flow_imp.g_varchar2_table(2599) := '72643A746869732E70726F70732E746F67676C6546696C65436172642C6D6574614669656C64733A746869732E70726F70732E6D6574614669656C64737D292C752841642C7B757070793A746869732E70726F70732E757070792C66696C653A652C6572';
wwv_flow_imp.g_varchar2_table(2600) := '726F723A612C697355706C6F616465643A722C686964655265747279427574746F6E3A746869732E70726F70732E686964655265747279427574746F6E2C6869646543616E63656C427574746F6E3A746869732E70726F70732E6869646543616E63656C';
wwv_flow_imp.g_varchar2_table(2601) := '427574746F6E2C686964655061757365526573756D65427574746F6E3A746869732E70726F70732E686964655061757365526573756D65427574746F6E2C7265636F766572656453746174653A746869732E70726F70732E7265636F7665726564537461';
wwv_flow_imp.g_varchar2_table(2602) := '74652C73686F7752656D6F7665427574746F6E4166746572436F6D706C6574653A746869732E70726F70732E73686F7752656D6F7665427574746F6E4166746572436F6D706C6574652C726573756D61626C6555706C6F6164733A746869732E70726F70';
wwv_flow_imp.g_varchar2_table(2603) := '732E726573756D61626C6555706C6F6164732C696E646976696475616C43616E63656C6C6174696F6E3A746869732E70726F70732E696E646976696475616C43616E63656C6C6174696F6E2C6931386E3A746869732E70726F70732E6931386E7D29292C';
wwv_flow_imp.g_varchar2_table(2604) := '752822646976222C7B636C6173734E616D653A22757070792D44617368626F6172642D4974656D2D66696C65496E666F416E64427574746F6E73227D2C752855642C7B66696C653A652C69643A746869732E70726F70732E69642C616371756972657273';
wwv_flow_imp.g_varchar2_table(2605) := '3A746869732E70726F70732E6163717569726572732C636F6E7461696E657257696474683A746869732E70726F70732E636F6E7461696E657257696474682C636F6E7461696E65724865696768743A746869732E70726F70732E636F6E7461696E657248';
wwv_flow_imp.g_varchar2_table(2606) := '65696768742C6931386E3A746869732E70726F70732E6931386E2C746F67676C6541646446696C657350616E656C3A746869732E70726F70732E746F67676C6541646446696C657350616E656C2C746F67676C6546696C65436172643A746869732E7072';
wwv_flow_imp.g_varchar2_table(2607) := '6F70732E746F67676C6546696C65436172642C6D6574614669656C64733A746869732E70726F70732E6D6574614669656C64732C697353696E676C6546696C653A746869732E70726F70732E697353696E676C6546696C657D292C752844642C7B66696C';
wwv_flow_imp.g_varchar2_table(2608) := '653A652C6D6574614669656C64733A746869732E70726F70732E6D6574614669656C64732C73686F774C696E6B546F46696C6555706C6F6164526573756C743A746869732E70726F70732E73686F774C696E6B546F46696C6555706C6F6164526573756C';
wwv_flow_imp.g_varchar2_table(2609) := '742C73686F7752656D6F7665427574746F6E3A682C63616E4564697446696C653A746869732E70726F70732E63616E4564697446696C652C75706C6F6164496E50726F67726573734F72436F6D706C6574653A732C746F67676C6546696C65436172643A';
wwv_flow_imp.g_varchar2_table(2610) := '746869732E70726F70732E746F67676C6546696C65436172642C6F70656E46696C65456469746F723A746869732E70726F70732E6F70656E46696C65456469746F722C757070793A746869732E70726F70732E757070792C6931386E3A746869732E7072';
wwv_flow_imp.g_varchar2_table(2611) := '6F70732E6931386E7D2929297D7D3B6E28486F2C2246696C654974656D22293B66756E6374696F6E20465328692C65297B6C657420743D5B5D2C723D5B5D3B72657475726E20692E666F724561636828733D3E7B722E6C656E6774683C653F722E707573';
wwv_flow_imp.g_varchar2_table(2612) := '682873293A28742E707573682872292C723D5B735D297D292C722E6C656E6774682626742E707573682872292C747D6E2846532C226368756E6B7322293B7661722063793D6E28693D3E7B6C65747B69643A652C6572726F723A742C6931386E3A722C75';
wwv_flow_imp.g_varchar2_table(2613) := '7070793A732C66696C65733A6F2C6163717569726572733A612C726573756D61626C6555706C6F6164733A6C2C686964655265747279427574746F6E3A682C686964655061757365526573756D65427574746F6E3A632C6869646543616E63656C427574';
wwv_flow_imp.g_varchar2_table(2614) := '746F6E3A642C73686F774C696E6B546F46696C6555706C6F6164526573756C743A662C73686F7752656D6F7665427574746F6E4166746572436F6D706C6574653A792C6973576964653A622C6D6574614669656C64733A532C697353696E676C6546696C';
wwv_flow_imp.g_varchar2_table(2615) := '653A452C746F67676C6546696C65436172643A462C68616E646C65526571756573745468756D626E61696C3A782C68616E646C6543616E63656C5468756D626E61696C3A552C7265636F766572656453746174653A6A2C696E646976696475616C43616E';
wwv_flow_imp.g_varchar2_table(2616) := '63656C6C6174696F6E3A472C6974656D73506572526F773A4A2C6F70656E46696C65456469746F723A422C63616E4564697446696C653A7A2C746F67676C6541646446696C657350616E656C3A4B2C636F6E7461696E657257696474683A6F652C636F6E';
wwv_flow_imp.g_varchar2_table(2617) := '7461696E65724865696768743A42657D3D692C4A653D4A3D3D3D313F37313A3230302C77743D526F2828293D3E7B6C6574205F653D6E282846652C6869293D3E6F5B68695D2E697347686F73742D6F5B46655D2E697347686F73742C22736F7274427947';
wwv_flow_imp.g_varchar2_table(2618) := '686F7374436F6D6573466972737422292C7A653D4F626A6563742E6B657973286F293B72657475726E206A26267A652E736F7274285F65292C4653287A652C4A297D2C5B6F2C4A2C6A5D292C47653D6E285F653D3E752822646976222C7B636C6173733A';
wwv_flow_imp.g_varchar2_table(2619) := '22757070792D44617368626F6172642D66696C6573496E6E6572222C726F6C653A2270726573656E746174696F6E222C6B65793A5F655B305D7D2C5F652E6D6170287A653D3E7528486F2C7B6B65793A7A652C757070793A732C69643A652C6572726F72';
wwv_flow_imp.g_varchar2_table(2620) := '3A742C6931386E3A722C6163717569726572733A612C726573756D61626C6555706C6F6164733A6C2C696E646976696475616C43616E63656C6C6174696F6E3A472C686964655265747279427574746F6E3A682C686964655061757365526573756D6542';
wwv_flow_imp.g_varchar2_table(2621) := '7574746F6E3A632C6869646543616E63656C427574746F6E3A642C73686F774C696E6B546F46696C6555706C6F6164526573756C743A662C73686F7752656D6F7665427574746F6E4166746572436F6D706C6574653A792C6973576964653A622C6D6574';
wwv_flow_imp.g_varchar2_table(2622) := '614669656C64733A532C7265636F766572656453746174653A6A2C697353696E676C6546696C653A452C636F6E7461696E657257696474683A6F652C636F6E7461696E65724865696768743A42652C746F67676C6546696C65436172643A462C68616E64';
wwv_flow_imp.g_varchar2_table(2623) := '6C65526571756573745468756D626E61696C3A782C68616E646C6543616E63656C5468756D626E61696C3A552C726F6C653A226C6973746974656D222C6F70656E46696C65456469746F723A422C63616E4564697446696C653A7A2C746F67676C654164';
wwv_flow_imp.g_varchar2_table(2624) := '6446696C657350616E656C3A4B2C66696C653A6F5B7A655D7D2929292C2272656E646572526F7722293B72657475726E20453F752822646976222C7B636C6173733A22757070792D44617368626F6172642D66696C6573227D2C47652877745B305D2929';
wwv_flow_imp.g_varchar2_table(2625) := '3A752863752C7B636C6173733A22757070792D44617368626F6172642D66696C6573222C726F6C653A226C697374222C646174613A77742C72656E646572526F773A47652C726F774865696768743A4A657D297D2C2264656661756C7422293B76617220';
wwv_flow_imp.g_varchar2_table(2626) := '70793B70793D53796D626F6C2E666F7228227570707920746573743A2064697361626C6520756E75736564206C6F63616C65206B6579207761726E696E6722293B766172206B753D636C61737320657874656E64732077657B636F6E7374727563746F72';
wwv_flow_imp.g_varchar2_table(2627) := '28297B7375706572282E2E2E617267756D656E7473292C746869732E7472696767657246696C65496E707574436C69636B3D28293D3E7B746869732E66696C65496E7075742E636C69636B28297D2C746869732E74726967676572466F6C646572496E70';
wwv_flow_imp.g_varchar2_table(2628) := '7574436C69636B3D28293D3E7B746869732E666F6C646572496E7075742E636C69636B28297D2C746869732E74726967676572566964656F43616D657261496E707574436C69636B3D28293D3E7B746869732E6D6F62696C65566964656F46696C65496E';
wwv_flow_imp.g_varchar2_table(2629) := '7075742E636C69636B28297D2C746869732E7472696767657250686F746F43616D657261496E707574436C69636B3D28293D3E7B746869732E6D6F62696C6550686F746F46696C65496E7075742E636C69636B28297D2C746869732E6F6E46696C65496E';
wwv_flow_imp.g_varchar2_table(2630) := '7075744368616E67653D653D3E7B746869732E70726F70732E68616E646C65496E7075744368616E67652865292C652E7461726765742E76616C75653D6E756C6C7D2C746869732E72656E64657248696464656E496E7075743D28652C74293D3E752822';
wwv_flow_imp.g_varchar2_table(2631) := '696E707574222C7B636C6173734E616D653A22757070792D44617368626F6172642D696E707574222C68696464656E3A21302C22617269612D68696464656E223A2274727565222C746162496E6465783A2D312C7765626B69746469726563746F72793A';
wwv_flow_imp.g_varchar2_table(2632) := '652C747970653A2266696C65222C6E616D653A2266696C65735B5D222C6D756C7469706C653A746869732E70726F70732E6D61784E756D6265724F6646696C6573213D3D312C6F6E4368616E67653A746869732E6F6E46696C65496E7075744368616E67';
wwv_flow_imp.g_varchar2_table(2633) := '652C6163636570743A746869732E70726F70732E616C6C6F77656446696C6554797065732C7265663A747D292C746869732E72656E64657248696464656E43616D657261496E7075743D28652C742C72293D3E7B6C6574206F3D7B70686F746F3A22696D';
wwv_flow_imp.g_varchar2_table(2634) := '6167652F2A222C766964656F3A22766964656F2F2A227D5B655D3B72657475726E20752822696E707574222C7B636C6173734E616D653A22757070792D44617368626F6172642D696E707574222C68696464656E3A21302C22617269612D68696464656E';
wwv_flow_imp.g_varchar2_table(2635) := '223A2274727565222C746162496E6465783A2D312C747970653A2266696C65222C6E616D653A6063616D6572612D247B657D602C6F6E4368616E67653A746869732E6F6E46696C65496E7075744368616E67652C636170747572653A742C616363657074';
wwv_flow_imp.g_varchar2_table(2636) := '3A6F2C7265663A727D297D2C746869732E72656E6465724D7944657669636541637175697265723D28293D3E752822646976222C7B636C6173734E616D653A22757070792D44617368626F617264546162222C726F6C653A2270726573656E746174696F';
wwv_flow_imp.g_varchar2_table(2637) := '6E222C22646174612D757070792D61637175697265722D6964223A224D79446576696365227D2C752822627574746F6E222C7B747970653A22627574746F6E222C636C6173734E616D653A22757070792D752D726573657420757070792D632D62746E20';
wwv_flow_imp.g_varchar2_table(2638) := '757070792D44617368626F6172645461622D62746E222C726F6C653A22746162222C746162496E6465783A302C22646174612D757070792D73757065722D666F63757361626C65223A21302C6F6E436C69636B3A746869732E7472696767657246696C65';
wwv_flow_imp.g_varchar2_table(2639) := '496E707574436C69636B7D2C752822646976222C7B636C6173734E616D653A22757070792D44617368626F6172645461622D696E6E6572227D2C752822737667222C7B636C6173734E616D653A22757070792D44617368626F6172645461622D69636F6E';
wwv_flow_imp.g_varchar2_table(2640) := '4D79446576696365222C22617269612D68696464656E223A2274727565222C666F63757361626C653A2266616C7365222C77696474683A223332222C6865696768743A223332222C76696577426F783A22302030203332203332227D2C75282270617468';
wwv_flow_imp.g_varchar2_table(2641) := '222C7B643A224D382E34352032322E3038376C2D312E3330352D362E3637346831372E3637386C2D312E35373220362E36373448382E34357A6D342E3937352D31322E3431326C312E30383320312E373635612E3832332E38323320302030302E373135';
wwv_flow_imp.g_varchar2_table(2642) := '2E33383668372E3935315631332E3548382E35383756392E36373568342E3833387A4D32362E3034332031332E35682D312E313935762D322E35393863302D2E3436332D2E3333362D2E37352D2E3739382D2E3735682D382E3335366C2D312E3038322D';
wwv_flow_imp.g_varchar2_table(2643) := '312E373636412E3832332E383233203020303031332E383937203848372E373238632D2E34363220302D2E3831352E3235362D2E3831352E3731385631332E35682D2E393536612E39372E393720302030302D2E3734362E33372E3937322E3937322030';
wwv_flow_imp.g_varchar2_table(2644) := '2030302D2E31392E38316C312E37323420382E353635632E3039352E34342E3438342E3735352E3933332E373535483234632E34342030202E3832342D2E332E3932392D2E3732376C322E3034332D382E353638612E3937322E39373220302030302D2E';
wwv_flow_imp.g_varchar2_table(2645) := '3137362D2E3832352E3936372E39363720302030302D2E3735332D2E33387A222C66696C6C3A2263757272656E74636F6C6F72222C2266696C6C2D72756C65223A226576656E6F6464227D2929292C752822646976222C7B636C6173734E616D653A2275';
wwv_flow_imp.g_varchar2_table(2646) := '7070792D44617368626F6172645461622D6E616D65227D2C746869732E70726F70732E6931386E28226D7944657669636522292929292C746869732E72656E64657250686F746F43616D6572613D28293D3E752822646976222C7B636C6173734E616D65';
wwv_flow_imp.g_varchar2_table(2647) := '3A22757070792D44617368626F617264546162222C726F6C653A2270726573656E746174696F6E222C22646174612D757070792D61637175697265722D6964223A224D6F62696C6550686F746F43616D657261227D2C752822627574746F6E222C7B7479';
wwv_flow_imp.g_varchar2_table(2648) := '70653A22627574746F6E222C636C6173734E616D653A22757070792D752D726573657420757070792D632D62746E20757070792D44617368626F6172645461622D62746E222C726F6C653A22746162222C746162496E6465783A302C22646174612D7570';
wwv_flow_imp.g_varchar2_table(2649) := '70792D73757065722D666F63757361626C65223A21302C6F6E436C69636B3A746869732E7472696767657250686F746F43616D657261496E707574436C69636B7D2C752822646976222C7B636C6173734E616D653A22757070792D44617368626F617264';
wwv_flow_imp.g_varchar2_table(2650) := '5461622D696E6E6572227D2C752822737667222C7B22617269612D68696464656E223A2274727565222C666F63757361626C653A2266616C7365222C77696474683A223332222C6865696768743A223332222C76696577426F783A223020302033322033';
wwv_flow_imp.g_varchar2_table(2651) := '32227D2C75282270617468222C7B643A224D32332E3520392E3563312E343137203020322E3520312E30383320322E3520322E3576392E313637633020312E3431362D312E30383320322E352D322E3520322E35682D3135632D312E34313720302D322E';
wwv_flow_imp.g_varchar2_table(2652) := '352D312E3038342D322E352D322E3556313263302D312E34313720312E3038332D322E3520322E352D322E3568322E3931376C312E3431362D322E31363743313320372E3136372031332E323520372031332E3520376835632E32352030202E352E3136';
wwv_flow_imp.g_varchar2_table(2653) := '372E3636372E3333334C32302E35383320392E354832332E357A4D31362031312E34313761342E37303620342E37303620302030302D342E373520342E373520342E37303420342E3730342030203030342E373520342E373520342E37303320342E3730';
wwv_flow_imp.g_varchar2_table(2654) := '332030203030342E37352D342E373563302D322E3636332D322E30392D342E37352D342E37352D342E37357A6D3020372E383235632D312E37343420302D332E3037362D312E3333322D332E3037362D332E30373420302D312E37343520312E3333332D';
wwv_flow_imp.g_varchar2_table(2655) := '332E30373720332E3037362D332E30373720312E373434203020332E30373420312E33333320332E30373420332E303736732D312E333320332E3037352D332E30373420332E3037357A222C66696C6C3A2223303242333833222C2266696C6C2D72756C';
wwv_flow_imp.g_varchar2_table(2656) := '65223A226E6F6E7A65726F227D2929292C752822646976222C7B636C6173734E616D653A22757070792D44617368626F6172645461622D6E616D65227D2C746869732E70726F70732E6931386E282274616B655069637475726542746E22292929292C74';
wwv_flow_imp.g_varchar2_table(2657) := '6869732E72656E646572566964656F43616D6572613D28293D3E752822646976222C7B636C6173734E616D653A22757070792D44617368626F617264546162222C726F6C653A2270726573656E746174696F6E222C22646174612D757070792D61637175';
wwv_flow_imp.g_varchar2_table(2658) := '697265722D6964223A224D6F62696C65566964656F43616D657261227D2C752822627574746F6E222C7B747970653A22627574746F6E222C636C6173734E616D653A22757070792D752D726573657420757070792D632D62746E20757070792D44617368';
wwv_flow_imp.g_varchar2_table(2659) := '626F6172645461622D62746E222C726F6C653A22746162222C746162496E6465783A302C22646174612D757070792D73757065722D666F63757361626C65223A21302C6F6E436C69636B3A746869732E74726967676572566964656F43616D657261496E';
wwv_flow_imp.g_varchar2_table(2660) := '707574436C69636B7D2C752822646976222C7B636C6173734E616D653A22757070792D44617368626F6172645461622D696E6E6572227D2C752822737667222C7B22617269612D68696464656E223A2274727565222C77696474683A223332222C686569';
wwv_flow_imp.g_varchar2_table(2661) := '6768743A223332222C76696577426F783A22302030203332203332227D2C75282270617468222C7B66696C6C3A2223464636373545222C66696C6C52756C653A226E6F6E7A65726F222C643A226D32312E3235342031342E32373720322E3934312D322E';
wwv_flow_imp.g_varchar2_table(2662) := '353838632E3739372D2E33313320312E3234332E38313820312E303920312E3535342D2E303120322E3039342E303220342E3138392D2E30313720362E3238322D2E3132362E3931352D312E31343520312E30382D312E35382E33346C2D322E3433342D';
wwv_flow_imp.g_varchar2_table(2663) := '322E313432632D2E3139322E3238372D2E35303420312E3330352D2E3733382E3436382D2E3130342D312E3239332D2E3032382D322E3539362D2E30352D332E3839342E3034372D2E3331322E3338312E3832332E34323620312E3036392E3036332D2E';
wwv_flow_imp.g_varchar2_table(2664) := '3338342E3230362D2E3734342E3336322D312E30397A6D2D31322E3933392D332E373363332E3835382E30313320372E3731372D2E3032352031312E3537342E30322E3931322E31323920312E34393220312E32333720312E33353120322E3231372D2E';
wwv_flow_imp.g_varchar2_table(2665) := '30313920322E3431322E303420342E38332D2E303320372E3233392D2E313720312E3032352D312E31363620312E35392D322E30323920312E3432392D332E3730352D2E3031322D372E34312E3032352D31312E3131342D2E3031392D2E3931332D2E31';
wwv_flow_imp.g_varchar2_table(2666) := '32392D312E3439322D312E3233372D312E3335322D322E3231372E3031382D322E3430342D2E3033362D342E3831332E3032392D372E3231342E3133362D2E38322E38332D312E34373320312E3537312D312E3435347A20227D2929292C752822646976';
wwv_flow_imp.g_varchar2_table(2667) := '222C7B636C6173734E616D653A22757070792D44617368626F6172645461622D6E616D65227D2C746869732E70726F70732E6931386E28227265636F7264566964656F42746E22292929292C746869732E72656E64657242726F777365427574746F6E3D';
wwv_flow_imp.g_varchar2_table(2668) := '28652C74293D3E7B6C657420723D746869732E70726F70732E6163717569726572732E6C656E6774683B72657475726E20752822627574746F6E222C7B747970653A22627574746F6E222C636C6173734E616D653A22757070792D752D72657365742075';
wwv_flow_imp.g_varchar2_table(2669) := '7070792D632D62746E20757070792D44617368626F6172642D62726F777365222C6F6E436C69636B3A742C22646174612D757070792D73757065722D666F63757361626C65223A723D3D3D307D2C65297D2C746869732E72656E64657244726F70506173';
wwv_flow_imp.g_varchar2_table(2670) := '746542726F7773655461676C696E653D653D3E7B6C657420743D746869732E72656E64657242726F777365427574746F6E28746869732E70726F70732E6931386E282262726F77736546696C657322292C746869732E7472696767657246696C65496E70';
wwv_flow_imp.g_varchar2_table(2671) := '7574436C69636B292C723D746869732E72656E64657242726F777365427574746F6E28746869732E70726F70732E6931386E282262726F777365466F6C6465727322292C746869732E74726967676572466F6C646572496E707574436C69636B292C733D';
wwv_flow_imp.g_varchar2_table(2672) := '746869732E70726F70732E66696C654D616E6167657253656C656374696F6E547970652C6F3D732E6368617241742830292E746F55707065724361736528292B732E736C6963652831293B72657475726E20752822646976222C7B636C6173733A227570';
wwv_flow_imp.g_varchar2_table(2673) := '70792D44617368626F6172642D41646446696C65732D7469746C65227D2C746869732E70726F70732E64697361626C654C6F63616C46696C65733F746869732E70726F70732E6931386E2822696D706F727446696C657322293A653E303F746869732E70';
wwv_flow_imp.g_varchar2_table(2674) := '726F70732E6931386E4172726179286064726F705061737465496D706F7274247B6F7D602C7B62726F77736546696C65733A742C62726F777365466F6C646572733A722C62726F7773653A747D293A746869732E70726F70732E6931386E417272617928';
wwv_flow_imp.g_varchar2_table(2675) := '6064726F705061737465247B6F7D602C7B62726F77736546696C65733A742C62726F777365466F6C646572733A722C62726F7773653A747D29297D2C746869732E72656E64657241637175697265723D653D3E752822646976222C7B636C6173734E616D';
wwv_flow_imp.g_varchar2_table(2676) := '653A22757070792D44617368626F617264546162222C726F6C653A2270726573656E746174696F6E222C22646174612D757070792D61637175697265722D6964223A652E69647D2C752822627574746F6E222C7B747970653A22627574746F6E222C636C';
wwv_flow_imp.g_varchar2_table(2677) := '6173734E616D653A22757070792D752D726573657420757070792D632D62746E20757070792D44617368626F6172645461622D62746E222C726F6C653A22746162222C746162496E6465783A302C22646174612D6379223A652E69642C22617269612D63';
wwv_flow_imp.g_varchar2_table(2678) := '6F6E74726F6C73223A60757070792D44617368626F617264436F6E74656E742D70616E656C2D2D247B652E69647D602C22617269612D73656C6563746564223A746869732E70726F70732E6163746976655069636B657250616E656C2E69643D3D3D652E';
wwv_flow_imp.g_varchar2_table(2679) := '69642C22646174612D757070792D73757065722D666F63757361626C65223A21302C6F6E436C69636B3A28293D3E746869732E70726F70732E73686F7750616E656C28652E6964297D2C752822646976222C7B636C6173734E616D653A22757070792D44';
wwv_flow_imp.g_varchar2_table(2680) := '617368626F6172645461622D696E6E6572227D2C652E69636F6E2829292C752822646976222C7B636C6173734E616D653A22757070792D44617368626F6172645461622D6E616D65227D2C652E6E616D652929292C746869732E72656E64657241637175';
wwv_flow_imp.g_varchar2_table(2681) := '69726572733D653D3E7B6C657420743D5B2E2E2E655D2C723D742E73706C69636528652E6C656E6774682D322C652E6C656E677468293B72657475726E20752848742C6E756C6C2C742E6D617028733D3E746869732E72656E6465724163717569726572';
wwv_flow_imp.g_varchar2_table(2682) := '287329292C7528227370616E222C7B726F6C653A2270726573656E746174696F6E222C7374796C653A7B2277686974652D7370616365223A226E6F77726170227D7D2C722E6D617028733D3E746869732E72656E64657241637175697265722873292929';
wwv_flow_imp.g_varchar2_table(2683) := '297D2C746869732E72656E646572536F75726365734C6973743D28652C74293D3E7B6C65747B73686F774E617469766550686F746F43616D657261427574746F6E3A722C73686F774E6174697665566964656F43616D657261427574746F6E3A737D3D74';
wwv_flow_imp.g_varchar2_table(2684) := '6869732E70726F70732C6F3D5B5D2C613D226D79446576696365223B747C7C286F2E70757368287B6B65793A612C656C656D656E74733A746869732E72656E6465724D79446576696365416371756972657228297D292C7226266F2E70757368287B6B65';
wwv_flow_imp.g_varchar2_table(2685) := '793A226E617469766550686F746F43616D657261427574746F6E222C656C656D656E74733A746869732E72656E64657250686F746F43616D65726128297D292C7326266F2E70757368287B6B65793A226E617469766550686F746F43616D657261427574';
wwv_flow_imp.g_varchar2_table(2686) := '746F6E222C656C656D656E74733A746869732E72656E646572566964656F43616D65726128297D29292C6F2E70757368282E2E2E652E6D617028663D3E287B6B65793A662E69642C656C656D656E74733A746869732E72656E6465724163717569726572';
wwv_flow_imp.g_varchar2_table(2687) := '2866297D2929292C6F2E6C656E6774683D3D3D3126266F5B305D2E6B65793D3D3D612626286F3D5B5D293B6C657420683D5B2E2E2E6F5D2C633D682E73706C696365286F2E6C656E6774682D322C6F2E6C656E677468292C643D6E28663D3E662E6D6170';
wwv_flow_imp.g_varchar2_table(2688) := '28793D3E7B6C65747B6B65793A622C656C656D656E74733A537D3D793B72657475726E20752848742C7B6B65793A627D2C53297D292C2272656E6465724C69737422293B72657475726E20752848742C6E756C6C2C746869732E72656E64657244726F70';
wwv_flow_imp.g_varchar2_table(2689) := '506173746542726F7773655461676C696E65286F2E6C656E677468292C752822646976222C7B636C6173734E616D653A22757070792D44617368626F6172642D41646446696C65732D6C697374222C726F6C653A227461626C697374227D2C642868292C';
wwv_flow_imp.g_varchar2_table(2690) := '7528227370616E222C7B726F6C653A2270726573656E746174696F6E222C7374796C653A7B2277686974652D7370616365223A226E6F77726170227D7D2C642863292929297D7D5B70795D28297B746869732E70726F70732E6931386E41727261792822';
wwv_flow_imp.g_varchar2_table(2691) := '64726F705061737465426F746822292C746869732E70726F70732E6931386E4172726179282264726F70506173746546696C657322292C746869732E70726F70732E6931386E4172726179282264726F705061737465466F6C6465727322292C74686973';
wwv_flow_imp.g_varchar2_table(2692) := '2E70726F70732E6931386E4172726179282264726F705061737465496D706F7274426F746822292C746869732E70726F70732E6931386E4172726179282264726F705061737465496D706F727446696C657322292C746869732E70726F70732E6931386E';
wwv_flow_imp.g_varchar2_table(2693) := '4172726179282264726F705061737465496D706F7274466F6C6465727322297D72656E646572506F776572656442795570707928297B6C65747B6931386E41727261793A657D3D746869732E70726F70732C743D7528227370616E222C6E756C6C2C7528';
wwv_flow_imp.g_varchar2_table(2694) := '22737667222C7B22617269612D68696464656E223A2274727565222C666F63757361626C653A2266616C7365222C636C6173734E616D653A22757070792D632D69636F6E20757070792D44617368626F6172642D706F7765726564427949636F6E222C77';
wwv_flow_imp.g_varchar2_table(2695) := '696474683A223131222C6865696768743A223131222C76696577426F783A22302030203131203131227D2C75282270617468222C7B643A224D372E3336352031302E356C2D2E30312D342E30343568322E3631324C352E352E3830366C2D342E34363720';
wwv_flow_imp.g_varchar2_table(2696) := '352E363568322E3630346C2E303120342E30343468332E3731387A222C66696C6C52756C653A226576656E6F6464227D29292C7528227370616E222C7B636C6173734E616D653A22757070792D44617368626F6172642D706F7765726564427955707079';
wwv_flow_imp.g_varchar2_table(2697) := '227D2C22557070792229292C723D652822706F77657265644279222C7B757070793A747D293B72657475726E2075282261222C7B746162496E6465783A222D31222C687265663A2268747470733A2F2F757070792E696F222C72656C3A226E6F72656665';
wwv_flow_imp.g_varchar2_table(2698) := '72726572206E6F6F70656E6572222C7461726765743A225F626C616E6B222C636C6173734E616D653A22757070792D44617368626F6172642D706F77657265644279227D2C72297D72656E64657228297B6C65747B73686F774E617469766550686F746F';
wwv_flow_imp.g_varchar2_table(2699) := '43616D657261427574746F6E3A652C73686F774E6174697665566964656F43616D657261427574746F6E3A742C6E617469766543616D657261466163696E674D6F64653A727D3D746869732E70726F70733B72657475726E20752822646976222C7B636C';
wwv_flow_imp.g_varchar2_table(2700) := '6173734E616D653A22757070792D44617368626F6172642D41646446696C6573227D2C746869732E72656E64657248696464656E496E7075742821312C733D3E7B746869732E66696C65496E7075743D737D292C746869732E72656E6465724869646465';
wwv_flow_imp.g_varchar2_table(2701) := '6E496E7075742821302C733D3E7B746869732E666F6C646572496E7075743D737D292C652626746869732E72656E64657248696464656E43616D657261496E707574282270686F746F222C722C733D3E7B746869732E6D6F62696C6550686F746F46696C';
wwv_flow_imp.g_varchar2_table(2702) := '65496E7075743D737D292C742626746869732E72656E64657248696464656E43616D657261496E7075742822766964656F222C722C733D3E7B746869732E6D6F62696C65566964656F46696C65496E7075743D737D292C746869732E72656E646572536F';
wwv_flow_imp.g_varchar2_table(2703) := '75726365734C69737428746869732E70726F70732E6163717569726572732C746869732E70726F70732E64697361626C654C6F63616C46696C6573292C752822646976222C7B636C6173734E616D653A22757070792D44617368626F6172642D41646446';
wwv_flow_imp.g_varchar2_table(2704) := '696C65732D696E666F227D2C746869732E70726F70732E6E6F74652626752822646976222C7B636C6173734E616D653A22757070792D44617368626F6172642D6E6F7465227D2C746869732E70726F70732E6E6F7465292C746869732E70726F70732E70';
wwv_flow_imp.g_varchar2_table(2705) := '726F75646C79446973706C6179506F77657265644279557070792626746869732E72656E646572506F776572656442795570707928746869732E70726F70732929297D7D3B6E286B752C2241646446696C657322293B7661722044753D6B753B76617220';
wwv_flow_imp.g_varchar2_table(2706) := '66793D6465285A7428292C31293B7661722078533D6E28693D3E752822646976222C7B636C6173734E616D653A28302C66792E64656661756C74292822757070792D44617368626F6172642D41646446696C657350616E656C222C692E636C6173734E61';
wwv_flow_imp.g_varchar2_table(2707) := '6D65292C22646174612D757070792D70616E656C54797065223A2241646446696C6573222C22617269612D68696464656E223A21692E73686F7741646446696C657350616E656C7D2C752822646976222C7B636C6173734E616D653A22757070792D4461';
wwv_flow_imp.g_varchar2_table(2708) := '7368626F617264436F6E74656E742D626172227D2C752822646976222C7B636C6173734E616D653A22757070792D44617368626F617264436F6E74656E742D7469746C65222C726F6C653A2268656164696E67222C22617269612D6C6576656C223A2231';
wwv_flow_imp.g_varchar2_table(2709) := '227D2C692E6931386E2822616464696E674D6F726546696C65732229292C752822627574746F6E222C7B636C6173734E616D653A22757070792D44617368626F617264436F6E74656E742D6261636B222C747970653A22627574746F6E222C6F6E436C69';
wwv_flow_imp.g_varchar2_table(2710) := '636B3A28293D3E692E746F67676C6541646446696C657350616E656C282131297D2C692E6931386E28226261636B222929292C752844752C6929292C2241646446696C657350616E656C22292C6D793D78533B7661722067793D6465285A7428292C3129';
wwv_flow_imp.g_varchar2_table(2711) := '3B66756E6374696F6E2045532869297B6C65747B7461674E616D653A657D3D692E7461726765743B696628653D3D3D22494E505554227C7C653D3D3D22544558544152454122297B692E73746F7050726F7061676174696F6E28293B72657475726E7D69';
wwv_flow_imp.g_varchar2_table(2712) := '2E70726576656E7444656661756C7428292C692E73746F7050726F7061676174696F6E28297D6E2845532C2269676E6F72654576656E7422293B7661722056693D45533B66756E6374696F6E2043532869297B6C65747B6163746976655069636B657250';
wwv_flow_imp.g_varchar2_table(2713) := '616E656C3A652C636C6173734E616D653A742C68696465416C6C50616E656C733A722C6931386E3A732C73746174653A6F2C757070793A617D3D693B72657475726E20752822646976222C7B636C6173734E616D653A28302C67792E64656661756C7429';
wwv_flow_imp.g_varchar2_table(2714) := '2822757070792D44617368626F617264436F6E74656E742D70616E656C222C74292C726F6C653A2274616270616E656C222C22646174612D757070792D70616E656C54797065223A225069636B657250616E656C222C69643A60757070792D4461736862';
wwv_flow_imp.g_varchar2_table(2715) := '6F617264436F6E74656E742D70616E656C2D2D247B652E69647D602C6F6E447261674F7665723A56692C6F6E447261674C656176653A56692C6F6E44726F703A56692C6F6E50617374653A56697D2C752822646976222C7B636C6173734E616D653A2275';
wwv_flow_imp.g_varchar2_table(2716) := '7070792D44617368626F617264436F6E74656E742D626172227D2C752822646976222C7B636C6173734E616D653A22757070792D44617368626F617264436F6E74656E742D7469746C65222C726F6C653A2268656164696E67222C22617269612D6C6576';
wwv_flow_imp.g_varchar2_table(2717) := '656C223A2231227D2C732822696D706F727446726F6D222C7B6E616D653A652E6E616D657D29292C752822627574746F6E222C7B636C6173734E616D653A22757070792D44617368626F617264436F6E74656E742D6261636B222C747970653A22627574';
wwv_flow_imp.g_varchar2_table(2718) := '746F6E222C6F6E436C69636B3A727D2C73282263616E63656C222929292C752822646976222C7B636C6173734E616D653A22757070792D44617368626F617264436F6E74656E742D70616E656C426F6479227D2C612E676574506C7567696E28652E6964';
wwv_flow_imp.g_varchar2_table(2719) := '292E72656E646572286F2929297D6E2843532C225069636B657250616E656C436F6E74656E7422293B7661722079793D43533B7661722076793D6465285A7428292C31293B66756E6374696F6E204F532869297B6C657420653D692E66696C65735B692E';
wwv_flow_imp.g_varchar2_table(2720) := '66696C6543617264466F725D2C743D6E2828293D3E7B692E757070792E656D6974282266696C652D656469746F723A63616E63656C222C65292C692E68696465416C6C50616E656C7328297D2C2268616E646C6543616E63656C22293B72657475726E20';
wwv_flow_imp.g_varchar2_table(2721) := '752822646976222C7B636C6173734E616D653A28302C76792E64656661756C74292822757070792D44617368626F617264436F6E74656E742D70616E656C222C692E636C6173734E616D65292C726F6C653A2274616270616E656C222C22646174612D75';
wwv_flow_imp.g_varchar2_table(2722) := '7070792D70616E656C54797065223A2246696C65456469746F72222C69643A22757070792D44617368626F617264436F6E74656E742D70616E656C2D2D656469746F72227D2C752822646976222C7B636C6173734E616D653A22757070792D4461736862';
wwv_flow_imp.g_varchar2_table(2723) := '6F617264436F6E74656E742D626172227D2C752822646976222C7B636C6173734E616D653A22757070792D44617368626F617264436F6E74656E742D7469746C65222C726F6C653A2268656164696E67222C22617269612D6C6576656C223A2231227D2C';
wwv_flow_imp.g_varchar2_table(2724) := '692E6931386E4172726179282265646974696E67222C7B66696C653A7528227370616E222C7B636C6173734E616D653A22757070792D44617368626F617264436F6E74656E742D7469746C6546696C65227D2C652E6D6574613F652E6D6574612E6E616D';
wwv_flow_imp.g_varchar2_table(2725) := '653A652E6E616D65297D29292C752822627574746F6E222C7B636C6173734E616D653A22757070792D44617368626F617264436F6E74656E742D6261636B222C747970653A22627574746F6E222C6F6E436C69636B3A747D2C692E6931386E282263616E';
wwv_flow_imp.g_varchar2_table(2726) := '63656C2229292C752822627574746F6E222C7B636C6173734E616D653A22757070792D44617368626F617264436F6E74656E742D73617665222C747970653A22627574746F6E222C6F6E436C69636B3A692E7361766546696C65456469746F727D2C692E';
wwv_flow_imp.g_varchar2_table(2727) := '6931386E282273617665222929292C752822646976222C7B636C6173734E616D653A22757070792D44617368626F617264436F6E74656E742D70616E656C426F6479227D2C692E656469746F72732E6D617028723D3E692E757070792E676574506C7567';
wwv_flow_imp.g_varchar2_table(2728) := '696E28722E6964292E72656E64657228692E7374617465292929297D6E284F532C22456469746F7250616E656C22293B7661722062793D4F533B7661722057693D7B53544154455F4552524F523A226572726F72222C53544154455F57414954494E473A';
wwv_flow_imp.g_varchar2_table(2729) := '2277616974696E67222C53544154455F50524550524F43455353494E473A2270726570726F63657373696E67222C53544154455F55504C4F4144494E473A2275706C6F6164696E67222C53544154455F504F535450524F43455353494E473A22706F7374';
wwv_flow_imp.g_varchar2_table(2730) := '70726F63657373696E67222C53544154455F434F4D504C4554453A22636F6D706C657465222C53544154455F5041555345443A22706175736564227D3B66756E6374696F6E20545328692C652C742C72297B696628723D3D3D766F69642030262628723D';
wwv_flow_imp.g_varchar2_table(2731) := '7B7D292C692972657475726E2057692E53544154455F4552524F523B696628652972657475726E2057692E53544154455F434F4D504C4554453B696628742972657475726E2057692E53544154455F5041555345443B6C657420733D57692E5354415445';
wwv_flow_imp.g_varchar2_table(2732) := '5F57414954494E472C6F3D4F626A6563742E6B6579732872293B666F72286C657420613D303B613C6F2E6C656E6774683B612B2B297B6C65747B70726F67726573733A6C7D3D725B6F5B615D5D3B6966286C2E75706C6F6164537461727465642626216C';
wwv_flow_imp.g_varchar2_table(2733) := '2E75706C6F6164436F6D706C6574652972657475726E2057692E53544154455F55504C4F4144494E473B6C2E70726570726F63657373262673213D3D57692E53544154455F55504C4F4144494E47262628733D57692E53544154455F50524550524F4345';
wwv_flow_imp.g_varchar2_table(2734) := '5353494E47292C6C2E706F737470726F63657373262673213D3D57692E53544154455F55504C4F4144494E47262673213D3D57692E53544154455F50524550524F43455353494E47262628733D57692E53544154455F504F535450524F43455353494E47';
wwv_flow_imp.g_varchar2_table(2735) := '297D72657475726E20737D6E2854532C2267657455706C6F6164696E67537461746522293B66756E6374696F6E2041532869297B6C65747B66696C65733A652C6931386E3A742C6973416C6C436F6D706C6574653A722C6973416C6C4572726F7265643A';
wwv_flow_imp.g_varchar2_table(2736) := '732C6973416C6C5061757365643A6F2C696E50726F67726573734E6F7450617573656446696C65733A612C6E657746696C65733A6C2C70726F63657373696E6746696C65733A687D3D693B73776974636828545328732C722C6F2C6529297B6361736522';
wwv_flow_imp.g_varchar2_table(2737) := '75706C6F6164696E67223A72657475726E2074282275706C6F6164696E675846696C6573222C7B736D6172745F636F756E743A612E6C656E6774687D293B636173652270726570726F63657373696E67223A6361736522706F737470726F63657373696E';
wwv_flow_imp.g_varchar2_table(2738) := '67223A72657475726E2074282270726F63657373696E675846696C6573222C7B736D6172745F636F756E743A682E6C656E6774687D293B6361736522706175736564223A72657475726E2074282275706C6F616450617573656422293B63617365227761';
wwv_flow_imp.g_varchar2_table(2739) := '6974696E67223A72657475726E207428227846696C657353656C6563746564222C7B736D6172745F636F756E743A6C2E6C656E6774687D293B6361736522636F6D706C657465223A72657475726E2074282275706C6F6164436F6D706C65746522293B63';
wwv_flow_imp.g_varchar2_table(2740) := '617365226572726F72223A72657475726E207428226572726F7222293B64656661756C743A7D7D6E2841532C2255706C6F616453746174757322293B66756E6374696F6E2052532869297B6C65747B6931386E3A652C6973416C6C436F6D706C6574653A';
wwv_flow_imp.g_varchar2_table(2741) := '742C6869646543616E63656C427574746F6E3A722C6D61784E756D6265724F6646696C65733A732C746F67676C6541646446696C657350616E656C3A6F2C757070793A617D3D692C7B616C6C6F774E657755706C6F61643A6C7D3D693B72657475726E20';
wwv_flow_imp.g_varchar2_table(2742) := '6C2626732626286C3D692E746F74616C46696C65436F756E743C692E6D61784E756D6265724F6646696C6573292C752822646976222C7B636C6173734E616D653A22757070792D44617368626F617264436F6E74656E742D626172227D2C217426262172';
wwv_flow_imp.g_varchar2_table(2743) := '3F752822627574746F6E222C7B636C6173734E616D653A22757070792D44617368626F617264436F6E74656E742D6261636B222C747970653A22627574746F6E222C6F6E436C69636B3A28293D3E612E63616E63656C416C6C28297D2C65282263616E63';
wwv_flow_imp.g_varchar2_table(2744) := '656C2229293A752822646976222C6E756C6C292C752822646976222C7B636C6173734E616D653A22757070792D44617368626F617264436F6E74656E742D7469746C65222C726F6C653A2268656164696E67222C22617269612D6C6576656C223A223122';
wwv_flow_imp.g_varchar2_table(2745) := '7D2C752841532C6929292C6C3F752822627574746F6E222C7B636C6173734E616D653A22757070792D44617368626F617264436F6E74656E742D6164644D6F7265222C747970653A22627574746F6E222C22617269612D6C6162656C223A652822616464';
wwv_flow_imp.g_varchar2_table(2746) := '4D6F726546696C657322292C7469746C653A6528226164644D6F726546696C657322292C6F6E436C69636B3A28293D3E6F282130297D2C752822737667222C7B22617269612D68696464656E223A2274727565222C666F63757361626C653A2266616C73';
wwv_flow_imp.g_varchar2_table(2747) := '65222C636C6173734E616D653A22757070792D632D69636F6E222C77696474683A223135222C6865696768743A223135222C76696577426F783A22302030203135203135227D2C75282270617468222C7B643A224D3820362E356836612E352E35203020';
wwv_flow_imp.g_varchar2_table(2748) := '302031202E352E35762E35612E352E352030203020312D2E352E3548387636612E352E352030203020312D2E352E354837612E352E352030203020312D2E352D2E355638682D36612E352E352030203020312D2E352D2E355637612E352E352030203020';
wwv_flow_imp.g_varchar2_table(2749) := '31202E352D2E356836762D36412E352E3520302030203120372030682E35612E352E35203020302031202E352E3576367A227D29292C7528227370616E222C7B636C6173734E616D653A22757070792D44617368626F617264436F6E74656E742D616464';
wwv_flow_imp.g_varchar2_table(2750) := '4D6F726543617074696F6E227D2C6528226164644D6F7265222929293A752822646976222C6E756C6C29297D6E2852532C2250616E656C546F7042617222293B7661722077793D52533B7661722053793D6465285A7428292C31293B66756E6374696F6E';
wwv_flow_imp.g_varchar2_table(2751) := '2049642869297B6C65747B636F6D70757465644D6574614669656C64733A652C72657175697265644D6574614669656C64733A742C7570646174654D6574613A722C666F726D3A732C666F726D53746174653A6F7D3D692C613D7B746578743A22757070';
wwv_flow_imp.g_varchar2_table(2752) := '792D752D726573657420757070792D632D74657874496E70757420757070792D44617368626F6172642D46696C65436172642D696E707574227D3B72657475726E20652E6D6170286C3D3E7B6C657420683D60757070792D44617368626F6172642D4669';
wwv_flow_imp.g_varchar2_table(2753) := '6C65436172642D696E7075742D247B6C2E69647D602C633D742E696E636C75646573286C2E6964293B72657475726E207528226669656C64736574222C7B6B65793A6C2E69642C636C6173734E616D653A22757070792D44617368626F6172642D46696C';
wwv_flow_imp.g_varchar2_table(2754) := '65436172642D6669656C64736574227D2C7528226C6162656C222C7B636C6173734E616D653A22757070792D44617368626F6172642D46696C65436172642D6C6162656C222C68746D6C466F723A687D2C6C2E6E616D65292C6C2E72656E646572213D3D';
wwv_flow_imp.g_varchar2_table(2755) := '766F696420303F6C2E72656E646572287B76616C75653A6F5B6C2E69645D2C6F6E4368616E67653A643D3E7228642C6C2E6964292C6669656C64435353436C61737365733A612C72657175697265643A632C666F726D3A732E69647D2C75293A75282269';
wwv_flow_imp.g_varchar2_table(2756) := '6E707574222C7B636C6173734E616D653A612E746578742C69643A682C666F726D3A732E69642C747970653A6C2E747970657C7C2274657874222C72657175697265643A632C76616C75653A6F5B6C2E69645D2C706C616365686F6C6465723A6C2E706C';
wwv_flow_imp.g_varchar2_table(2757) := '616365686F6C6465722C6F6E496E7075743A643D3E7228642E7461726765742E76616C75652C6C2E6964292C22646174612D757070792D73757065722D666F63757361626C65223A21307D29297D297D6E2849642C2252656E6465724D6574614669656C';
wwv_flow_imp.g_varchar2_table(2758) := '647322293B66756E6374696F6E204D642869297B76617220653B6C65747B66696C65733A742C66696C6543617264466F723A722C746F67676C6546696C65436172643A732C7361766546696C65436172643A6F2C6D6574614669656C64733A612C726571';
wwv_flow_imp.g_varchar2_table(2759) := '75697265644D6574614669656C64733A6C2C6F70656E46696C65456469746F723A682C6931386E3A632C6931386E41727261793A642C636C6173734E616D653A662C63616E4564697446696C653A797D3D692C623D6E2828293D3E747970656F6620613D';
wwv_flow_imp.g_varchar2_table(2760) := '3D2266756E6374696F6E223F6128745B725D293A612C226765744D6574614669656C647322292C533D745B725D2C453D28653D62282929213D6E756C6C3F653A5B5D2C463D792853292C783D7B7D3B452E666F7245616368284B3D3E7B766172206F653B';
wwv_flow_imp.g_varchar2_table(2761) := '785B4B2E69645D3D286F653D532E6D6574615B4B2E69645D29213D6E756C6C3F6F653A22227D293B6C65745B552C6A5D3D416F2878292C473D4373284B3D3E7B4B2E70726576656E7444656661756C7428292C6F28552C72297D2C5B6F2C552C725D292C';
wwv_flow_imp.g_varchar2_table(2762) := '4A3D6E28284B2C6F65293D3E7B6A287B2E2E2E552C5B6F655D3A4B7D297D2C227570646174654D65746122292C423D6E2828293D3E7B73282131297D2C2268616E646C6543616E63656C22292C5B7A5D3D416F2828293D3E7B6C6574204B3D646F63756D';
wwv_flow_imp.g_varchar2_table(2763) := '656E742E637265617465456C656D656E742822666F726D22293B72657475726E204B2E7365744174747269627574652822746162696E646578222C222D3122292C4B2E69643D507428292C4B7D293B72657475726E2045732828293D3E28646F63756D65';
wwv_flow_imp.g_varchar2_table(2764) := '6E742E626F64792E617070656E644368696C64287A292C7A2E6164644576656E744C697374656E657228227375626D6974222C47292C28293D3E7B7A2E72656D6F76654576656E744C697374656E657228227375626D6974222C47292C646F63756D656E';
wwv_flow_imp.g_varchar2_table(2765) := '742E626F64792E72656D6F76654368696C64287A297D292C5B7A2C475D292C752822646976222C7B636C6173734E616D653A28302C53792E64656661756C74292822757070792D44617368626F6172642D46696C6543617264222C66292C22646174612D';
wwv_flow_imp.g_varchar2_table(2766) := '757070792D70616E656C54797065223A2246696C6543617264222C6F6E447261674F7665723A56692C6F6E447261674C656176653A56692C6F6E44726F703A56692C6F6E50617374653A56697D2C752822646976222C7B636C6173734E616D653A227570';
wwv_flow_imp.g_varchar2_table(2767) := '70792D44617368626F617264436F6E74656E742D626172227D2C752822646976222C7B636C6173734E616D653A22757070792D44617368626F617264436F6E74656E742D7469746C65222C726F6C653A2268656164696E67222C22617269612D6C657665';
wwv_flow_imp.g_varchar2_table(2768) := '6C223A2231227D2C64282265646974696E67222C7B66696C653A7528227370616E222C7B636C6173734E616D653A22757070792D44617368626F617264436F6E74656E742D7469746C6546696C65227D2C532E6D6574613F532E6D6574612E6E616D653A';
wwv_flow_imp.g_varchar2_table(2769) := '532E6E616D65297D29292C752822627574746F6E222C7B636C6173734E616D653A22757070792D44617368626F617264436F6E74656E742D6261636B222C747970653A22627574746F6E222C666F726D3A7A2E69642C7469746C653A63282266696E6973';
wwv_flow_imp.g_varchar2_table(2770) := '6845646974696E6746696C6522292C6F6E436C69636B3A427D2C63282263616E63656C222929292C752822646976222C7B636C6173734E616D653A22757070792D44617368626F6172642D46696C65436172642D696E6E6572227D2C752822646976222C';
wwv_flow_imp.g_varchar2_table(2771) := '7B636C6173734E616D653A22757070792D44617368626F6172642D46696C65436172642D70726576696577222C7374796C653A7B6261636B67726F756E64436F6C6F723A527328532E74797065292E636F6C6F727D7D2C752866612C7B66696C653A537D';
wwv_flow_imp.g_varchar2_table(2772) := '292C462626752822627574746F6E222C7B747970653A22627574746F6E222C636C6173734E616D653A22757070792D752D726573657420757070792D632D62746E20757070792D44617368626F6172642D46696C65436172642D65646974222C6F6E436C';
wwv_flow_imp.g_varchar2_table(2773) := '69636B3A4B3D3E7B47284B292C682853297D7D2C6328226564697446696C65222929292C752822646976222C7B636C6173734E616D653A22757070792D44617368626F6172642D46696C65436172642D696E666F227D2C752849642C7B636F6D70757465';
wwv_flow_imp.g_varchar2_table(2774) := '644D6574614669656C64733A452C72657175697265644D6574614669656C64733A6C2C7570646174654D6574613A4A2C666F726D3A7A2C666F726D53746174653A557D29292C752822646976222C7B636C6173734E616D653A22757070792D4461736862';
wwv_flow_imp.g_varchar2_table(2775) := '6F6172642D46696C65436172642D616374696F6E73227D2C752822627574746F6E222C7B636C6173734E616D653A22757070792D752D726573657420757070792D632D62746E20757070792D632D62746E2D7072696D61727920757070792D4461736862';
wwv_flow_imp.g_varchar2_table(2776) := '6F6172642D46696C65436172642D616374696F6E7342746E222C747970653A227375626D6974222C666F726D3A7A2E69647D2C632822736176654368616E6765732229292C752822627574746F6E222C7B636C6173734E616D653A22757070792D752D72';
wwv_flow_imp.g_varchar2_table(2777) := '6573657420757070792D632D62746E20757070792D632D62746E2D6C696E6B20757070792D44617368626F6172642D46696C65436172642D616374696F6E7342746E222C747970653A22627574746F6E222C6F6E436C69636B3A422C666F726D3A7A2E69';
wwv_flow_imp.g_varchar2_table(2778) := '647D2C63282263616E63656C2229292929297D6E284D642C2246696C654361726422293B766172205F793D6465285A7428292C31293B76617220246F3D22757070792D7472616E736974696F6E2D736C696465446F776E5570222C50793D3235302C4975';
wwv_flow_imp.g_varchar2_table(2779) := '3D636C61737320657874656E64732077657B636F6E7374727563746F722865297B73757065722865292C746869732E73746174653D7B6361636865644368696C6472656E3A6E756C6C2C636C6173734E616D653A22227D7D636F6D706F6E656E7457696C';
wwv_flow_imp.g_varchar2_table(2780) := '6C5570646174652865297B6C65747B6361636865644368696C6472656E3A747D3D746869732E73746174652C723D706928652E6368696C6472656E295B305D3B696628743D3D3D722972657475726E206E756C6C3B6C657420733D7B6361636865644368';
wwv_flow_imp.g_varchar2_table(2781) := '696C6472656E3A727D3B7226262174262628732E636C6173734E616D653D60247B246F7D2D656E746572602C63616E63656C416E696D6174696F6E4672616D6528746869732E616E696D6174696F6E4672616D65292C636C65617254696D656F75742874';
wwv_flow_imp.g_varchar2_table(2782) := '6869732E6C6561766554696D656F7574292C746869732E6C6561766554696D656F75743D766F696420302C746869732E616E696D6174696F6E4672616D653D72657175657374416E696D6174696F6E4672616D652828293D3E7B746869732E7365745374';
wwv_flow_imp.g_varchar2_table(2783) := '617465287B636C6173734E616D653A60247B246F7D2D656E74657220247B246F7D2D656E7465722D616374697665607D292C746869732E656E74657254696D656F75743D73657454696D656F75742828293D3E7B746869732E7365745374617465287B63';
wwv_flow_imp.g_varchar2_table(2784) := '6C6173734E616D653A22227D297D2C5079297D29292C74262621722626746869732E6C6561766554696D656F75743D3D3D766F69642030262628732E6361636865644368696C6472656E3D742C732E636C6173734E616D653D60247B246F7D2D6C656176';
wwv_flow_imp.g_varchar2_table(2785) := '65602C63616E63656C416E696D6174696F6E4672616D6528746869732E616E696D6174696F6E4672616D65292C636C65617254696D656F757428746869732E656E74657254696D656F7574292C746869732E656E74657254696D656F75743D766F696420';
wwv_flow_imp.g_varchar2_table(2786) := '302C746869732E616E696D6174696F6E4672616D653D72657175657374416E696D6174696F6E4672616D652828293D3E7B746869732E7365745374617465287B636C6173734E616D653A60247B246F7D2D6C6561766520247B246F7D2D6C656176652D61';
wwv_flow_imp.g_varchar2_table(2787) := '6374697665607D292C746869732E6C6561766554696D656F75743D73657454696D656F75742828293D3E7B746869732E7365745374617465287B6361636865644368696C6472656E3A6E756C6C2C636C6173734E616D653A22227D297D2C5079297D2929';
wwv_flow_imp.g_varchar2_table(2788) := '2C746869732E73657453746174652873297D72656E64657228297B6C65747B6361636865644368696C6472656E3A652C636C6173734E616D653A747D3D746869732E73746174653B72657475726E20653F6A6C28652C7B636C6173734E616D653A28302C';
wwv_flow_imp.g_varchar2_table(2789) := '5F792E64656661756C742928742C652E70726F70732E636C6173734E616D65297D293A6E756C6C7D7D3B6E2849752C22536C69646522293B7661722067613D49753B66756E6374696F6E20557328297B72657475726E2055733D4F626A6563742E617373';
wwv_flow_imp.g_varchar2_table(2790) := '69676E3F4F626A6563742E61737369676E2E62696E6428293A66756E6374696F6E2869297B666F722876617220653D313B653C617267756D656E74732E6C656E6774683B652B2B297B76617220743D617267756D656E74735B655D3B666F722876617220';
wwv_flow_imp.g_varchar2_table(2791) := '7220696E2074294F626A6563742E70726F746F747970652E6861734F776E50726F70657274792E63616C6C28742C7229262628695B725D3D745B725D297D72657475726E20697D2C55732E6170706C7928746869732C617267756D656E7473297D6E2855';
wwv_flow_imp.g_varchar2_table(2792) := '732C225F657874656E647322293B7661722046793D3930302C78793D3730302C4E643D3537362C45793D3333303B66756E6374696F6E204C642869297B6C657420653D692E746F74616C46696C65436F756E743D3D3D302C743D692E746F74616C46696C';
wwv_flow_imp.g_varchar2_table(2793) := '65436F756E743D3D3D312C723D692E636F6E7461696E657257696474683E4E642C733D692E636F6E7461696E65724865696768743E45792C6F3D28302C43792E64656661756C7429287B22757070792D44617368626F617264223A21302C22757070792D';
wwv_flow_imp.g_varchar2_table(2794) := '44617368626F6172642D2D697344697361626C6564223A692E64697361626C65642C22757070792D44617368626F6172642D2D616E696D6174654F70656E436C6F7365223A692E616E696D6174654F70656E436C6F73652C22757070792D44617368626F';
wwv_flow_imp.g_varchar2_table(2795) := '6172642D2D6973436C6F73696E67223A692E6973436C6F73696E672C22757070792D44617368626F6172642D2D69734472616767696E674F766572223A692E69734472616767696E674F7665722C22757070792D44617368626F6172642D2D6D6F64616C';
wwv_flow_imp.g_varchar2_table(2796) := '223A21692E696E6C696E652C22757070792D73697A652D2D6D64223A692E636F6E7461696E657257696474683E4E642C22757070792D73697A652D2D6C67223A692E636F6E7461696E657257696474683E78792C22757070792D73697A652D2D786C223A';
wwv_flow_imp.g_varchar2_table(2797) := '692E636F6E7461696E657257696474683E46792C22757070792D73697A652D2D6865696768742D6D64223A692E636F6E7461696E65724865696768743E45792C22757070792D44617368626F6172642D2D697341646446696C657350616E656C56697369';
wwv_flow_imp.g_varchar2_table(2798) := '626C65223A692E73686F7741646446696C657350616E656C2C22757070792D44617368626F6172642D2D6973496E6E65725772617056697369626C65223A692E617265496E73696465735265616479546F426556697369626C652C22757070792D446173';
wwv_flow_imp.g_varchar2_table(2799) := '68626F6172642D2D73696E676C6546696C65223A692E73696E676C6546696C6546756C6C53637265656E2626742626737D292C613D313B692E636F6E7461696E657257696474683E46793F613D353A692E636F6E7461696E657257696474683E78793F61';
wwv_flow_imp.g_varchar2_table(2800) := '3D343A692E636F6E7461696E657257696474683E4E64262628613D33293B6C6574206C3D692E73686F7753656C656374656446696C6573262621652C683D692E7265636F766572656453746174653F4F626A6563742E6B65797328692E7265636F766572';
wwv_flow_imp.g_varchar2_table(2801) := '656453746174652E66696C6573292E6C656E6774683A6E756C6C2C633D692E66696C65733F4F626A6563742E6B65797328692E66696C6573292E66696C74657228793D3E692E66696C65735B795D2E697347686F7374292E6C656E6774683A6E756C6C2C';
wwv_flow_imp.g_varchar2_table(2802) := '643D6E2828293D3E633E303F692E6931386E28227265636F76657265645846696C6573222C7B736D6172745F636F756E743A637D293A692E6931386E28227265636F7665726564416C6C46696C657322292C2272656E646572526573746F726564546578';
wwv_flow_imp.g_varchar2_table(2803) := '7422293B72657475726E20752822646976222C7B636C6173734E616D653A6F2C22646174612D757070792D7468656D65223A692E7468656D652C22646174612D757070792D6E756D2D616371756972657273223A692E6163717569726572732E6C656E67';
wwv_flow_imp.g_varchar2_table(2804) := '74682C22646174612D757070792D647261672D64726F702D737570706F72746564223A21692E64697361626C654C6F63616C46696C65732626706128292C22617269612D68696464656E223A692E696E6C696E653F2266616C7365223A692E6973486964';
wwv_flow_imp.g_varchar2_table(2805) := '64656E2C22617269612D64697361626C6564223A692E64697361626C65642C22617269612D6C6162656C223A692E696E6C696E653F692E6931386E282264617368626F6172645469746C6522293A692E6931386E282264617368626F61726457696E646F';
wwv_flow_imp.g_varchar2_table(2806) := '775469746C6522292C6F6E50617374653A692E68616E646C6550617374652C6F6E447261674F7665723A692E68616E646C65447261674F7665722C6F6E447261674C656176653A692E68616E646C65447261674C656176652C6F6E44726F703A692E6861';
wwv_flow_imp.g_varchar2_table(2807) := '6E646C6544726F707D2C752822646976222C7B22617269612D68696464656E223A2274727565222C636C6173734E616D653A22757070792D44617368626F6172642D6F7665726C6179222C746162496E6465783A2D312C6F6E436C69636B3A692E68616E';
wwv_flow_imp.g_varchar2_table(2808) := '646C65436C69636B4F7574736964657D292C752822646976222C7B636C6173734E616D653A22757070792D44617368626F6172642D696E6E6572222C22617269612D6D6F64616C223A21692E696E6C696E6526262274727565222C726F6C653A21692E69';
wwv_flow_imp.g_varchar2_table(2809) := '6E6C696E652626226469616C6F67222C7374796C653A7B77696474683A692E696E6C696E652626692E77696474683F692E77696474683A22222C6865696768743A692E696E6C696E652626692E6865696768743F692E6865696768743A22227D7D2C692E';
wwv_flow_imp.g_varchar2_table(2810) := '696E6C696E653F6E756C6C3A752822627574746F6E222C7B636C6173734E616D653A22757070792D752D726573657420757070792D44617368626F6172642D636C6F7365222C747970653A22627574746F6E222C22617269612D6C6162656C223A692E69';
wwv_flow_imp.g_varchar2_table(2811) := '31386E2822636C6F73654D6F64616C22292C7469746C653A692E6931386E2822636C6F73654D6F64616C22292C6F6E436C69636B3A692E636C6F73654D6F64616C7D2C7528227370616E222C7B22617269612D68696464656E223A2274727565227D2C22';
wwv_flow_imp.g_varchar2_table(2812) := '5C7844372229292C752822646976222C7B636C6173734E616D653A22757070792D44617368626F6172642D696E6E657257726170227D2C752822646976222C7B636C6173734E616D653A22757070792D44617368626F6172642D64726F7046696C657348';
wwv_flow_imp.g_varchar2_table(2813) := '65726548696E74227D2C692E6931386E282264726F7048696E742229292C6C2626752877792C69292C682626752822646976222C7B636C6173734E616D653A22757070792D44617368626F6172642D736572766963654D7367227D2C752822737667222C';
wwv_flow_imp.g_varchar2_table(2814) := '7B636C6173734E616D653A22757070792D44617368626F6172642D736572766963654D73672D69636F6E222C22617269612D68696464656E223A2274727565222C666F63757361626C653A2266616C7365222C77696474683A223231222C686569676874';
wwv_flow_imp.g_varchar2_table(2815) := '3A223136222C76696577426F783A22302030203234203139227D2C75282267222C7B7472616E73666F726D3A227472616E736C6174652830202D3129222C66696C6C3A226E6F6E65222C66696C6C52756C653A226576656E6F6464227D2C752822706174';
wwv_flow_imp.g_varchar2_table(2816) := '68222C7B643A224D31322E38353720312E34336C31302E3233342031372E30353641312031203020303132322E32333420323048312E3736366131203120302030312D2E3835372D312E3531344C31312E31343320312E34323961312031203020303131';
wwv_flow_imp.g_varchar2_table(2817) := '2E37313420307A222C66696C6C3A2223464644333030227D292C75282270617468222C7B66696C6C3A2223303030222C643A224D3131203668326C2D2E332038682D312E347A227D292C752822636972636C65222C7B66696C6C3A2223303030222C6378';
wwv_flow_imp.g_varchar2_table(2818) := '3A223132222C63793A223137222C723A2231227D2929292C7528227374726F6E67222C7B636C6173734E616D653A22757070792D44617368626F6172642D736572766963654D73672D7469746C65227D2C692E6931386E282273657373696F6E52657374';
wwv_flow_imp.g_varchar2_table(2819) := '6F7265642229292C752822646976222C7B636C6173734E616D653A22757070792D44617368626F6172642D736572766963654D73672D74657874227D2C64282929292C6C3F752863792C7B69643A692E69642C6572726F723A692E6572726F722C693138';
wwv_flow_imp.g_varchar2_table(2820) := '6E3A692E6931386E2C757070793A692E757070792C66696C65733A692E66696C65732C6163717569726572733A692E6163717569726572732C726573756D61626C6555706C6F6164733A692E726573756D61626C6555706C6F6164732C68696465526574';
wwv_flow_imp.g_varchar2_table(2821) := '7279427574746F6E3A692E686964655265747279427574746F6E2C686964655061757365526573756D65427574746F6E3A692E686964655061757365526573756D65427574746F6E2C6869646543616E63656C427574746F6E3A692E6869646543616E63';
wwv_flow_imp.g_varchar2_table(2822) := '656C427574746F6E2C73686F774C696E6B546F46696C6555706C6F6164526573756C743A692E73686F774C696E6B546F46696C6555706C6F6164526573756C742C73686F7752656D6F7665427574746F6E4166746572436F6D706C6574653A692E73686F';
wwv_flow_imp.g_varchar2_table(2823) := '7752656D6F7665427574746F6E4166746572436F6D706C6574652C6973576964653A692E6973576964652C6D6574614669656C64733A692E6D6574614669656C64732C746F67676C6546696C65436172643A692E746F67676C6546696C65436172642C68';
wwv_flow_imp.g_varchar2_table(2824) := '616E646C65526571756573745468756D626E61696C3A692E68616E646C65526571756573745468756D626E61696C2C68616E646C6543616E63656C5468756D626E61696C3A692E68616E646C6543616E63656C5468756D626E61696C2C7265636F766572';
wwv_flow_imp.g_varchar2_table(2825) := '656453746174653A692E7265636F766572656453746174652C696E646976696475616C43616E63656C6C6174696F6E3A692E696E646976696475616C43616E63656C6C6174696F6E2C6F70656E46696C65456469746F723A692E6F70656E46696C654564';
wwv_flow_imp.g_varchar2_table(2826) := '69746F722C63616E4564697446696C653A692E63616E4564697446696C652C746F67676C6541646446696C657350616E656C3A692E746F67676C6541646446696C657350616E656C2C697353696E676C6546696C653A742C6974656D73506572526F773A';
wwv_flow_imp.g_varchar2_table(2827) := '617D293A752844752C5573287B7D2C692C7B697353697A654D443A727D29292C752867612C6E756C6C2C692E73686F7741646446696C657350616E656C3F75286D792C5573287B6B65793A2241646446696C6573227D2C692C7B697353697A654D443A72';
wwv_flow_imp.g_varchar2_table(2828) := '7D29293A6E756C6C292C752867612C6E756C6C2C692E66696C6543617264466F723F75284D642C5573287B6B65793A2246696C6543617264227D2C6929293A6E756C6C292C752867612C6E756C6C2C692E6163746976655069636B657250616E656C3F75';
wwv_flow_imp.g_varchar2_table(2829) := '2879792C5573287B6B65793A225069636B6572227D2C6929293A6E756C6C292C752867612C6E756C6C2C692E73686F7746696C65456469746F723F752862792C5573287B6B65793A22456469746F72227D2C6929293A6E756C6C292C752822646976222C';
wwv_flow_imp.g_varchar2_table(2830) := '7B636C6173734E616D653A22757070792D44617368626F6172642D70726F6772657373696E64696361746F7273227D2C692E70726F6772657373696E64696361746F72732E6D617028793D3E692E757070792E676574506C7567696E28792E6964292E72';
wwv_flow_imp.g_varchar2_table(2831) := '656E64657228692E73746174652929292929297D6E284C642C2244617368626F61726422293B766172204F793D7B737472696E67733A7B636C6F73654D6F64616C3A22436C6F7365204D6F64616C222C6164644D6F726546696C65733A22416464206D6F';
wwv_flow_imp.g_varchar2_table(2832) := '72652066696C6573222C616464696E674D6F726546696C65733A22416464696E67206D6F72652066696C6573222C696D706F727446726F6D3A22496D706F72742066726F6D20257B6E616D657D222C64617368626F61726457696E646F775469746C653A';
wwv_flow_imp.g_varchar2_table(2833) := '22557070792044617368626F6172642057696E646F77202850726573732065736361706520746F20636C6F736529222C64617368626F6172645469746C653A22557070792044617368626F617264222C636F70794C696E6B546F436C6970626F61726453';
wwv_flow_imp.g_varchar2_table(2834) := '7563636573733A224C696E6B20636F7069656420746F20636C6970626F6172642E222C636F70794C696E6B546F436C6970626F61726446616C6C6261636B3A22436F7079207468652055524C2062656C6F77222C636F70794C696E6B3A22436F7079206C';
wwv_flow_imp.g_varchar2_table(2835) := '696E6B222C6261636B3A224261636B222C72656D6F766546696C653A2252656D6F76652066696C65222C6564697446696C653A22456469742066696C65222C65646974696E673A2245646974696E6720257B66696C657D222C6572726F723A224572726F';
wwv_flow_imp.g_varchar2_table(2836) := '72222C66696E69736845646974696E6746696C653A2246696E6973682065646974696E672066696C65222C736176654368616E6765733A2253617665206368616E676573222C6D794465766963653A224D7920446576696365222C64726F7048696E743A';
wwv_flow_imp.g_varchar2_table(2837) := '2244726F7020796F75722066696C65732068657265222C75706C6F6164436F6D706C6574653A2255706C6F616420636F6D706C657465222C75706C6F61645061757365643A2255706C6F616420706175736564222C726573756D6555706C6F61643A2252';
wwv_flow_imp.g_varchar2_table(2838) := '6573756D652075706C6F6164222C706175736555706C6F61643A2250617573652075706C6F6164222C726574727955706C6F61643A2252657472792075706C6F6164222C63616E63656C55706C6F61643A2243616E63656C2075706C6F6164222C784669';
wwv_flow_imp.g_varchar2_table(2839) := '6C657353656C65637465643A7B303A22257B736D6172745F636F756E747D2066696C652073656C6563746564222C313A22257B736D6172745F636F756E747D2066696C65732073656C6563746564227D2C75706C6F6164696E675846696C65733A7B303A';
wwv_flow_imp.g_varchar2_table(2840) := '2255706C6F6164696E6720257B736D6172745F636F756E747D2066696C65222C313A2255706C6F6164696E6720257B736D6172745F636F756E747D2066696C6573227D2C70726F63657373696E675846696C65733A7B303A2250726F63657373696E6720';
wwv_flow_imp.g_varchar2_table(2841) := '257B736D6172745F636F756E747D2066696C65222C313A2250726F63657373696E6720257B736D6172745F636F756E747D2066696C6573227D2C706F776572656442793A22506F776572656420627920257B757070797D222C6164644D6F72653A224164';
wwv_flow_imp.g_varchar2_table(2842) := '64206D6F7265222C6564697446696C655769746846696C656E616D653A22456469742066696C6520257B66696C657D222C736176653A2253617665222C63616E63656C3A2243616E63656C222C64726F70506173746546696C65733A2244726F70206669';
wwv_flow_imp.g_varchar2_table(2843) := '6C65732068657265206F7220257B62726F77736546696C65737D222C64726F705061737465466F6C646572733A2244726F702066696C65732068657265206F7220257B62726F777365466F6C646572737D222C64726F705061737465426F74683A224472';
wwv_flow_imp.g_varchar2_table(2844) := '6F702066696C657320686572652C20257B62726F77736546696C65737D206F7220257B62726F777365466F6C646572737D222C64726F705061737465496D706F727446696C65733A2244726F702066696C657320686572652C20257B62726F7773654669';
wwv_flow_imp.g_varchar2_table(2845) := '6C65737D206F7220696D706F72742066726F6D3A222C64726F705061737465496D706F7274466F6C646572733A2244726F702066696C657320686572652C20257B62726F777365466F6C646572737D206F7220696D706F72742066726F6D3A222C64726F';
wwv_flow_imp.g_varchar2_table(2846) := '705061737465496D706F7274426F74683A2244726F702066696C657320686572652C20257B62726F77736546696C65737D2C20257B62726F777365466F6C646572737D206F7220696D706F72742066726F6D3A222C696D706F727446696C65733A22496D';
wwv_flow_imp.g_varchar2_table(2847) := '706F72742066696C65732066726F6D3A222C62726F77736546696C65733A2262726F7773652066696C6573222C62726F777365466F6C646572733A2262726F77736520666F6C64657273222C7265636F76657265645846696C65733A7B303A2257652063';
wwv_flow_imp.g_varchar2_table(2848) := '6F756C64206E6F742066756C6C79207265636F76657220312066696C652E20506C656173652072652D73656C65637420697420616E6420726573756D65207468652075706C6F61642E222C313A22576520636F756C64206E6F742066756C6C7920726563';
wwv_flow_imp.g_varchar2_table(2849) := '6F76657220257B736D6172745F636F756E747D2066696C65732E20506C656173652072652D73656C656374207468656D20616E6420726573756D65207468652075706C6F61642E227D2C7265636F7665726564416C6C46696C65733A2257652072657374';
wwv_flow_imp.g_varchar2_table(2850) := '6F72656420616C6C2066696C65732E20596F752063616E206E6F7720726573756D65207468652075706C6F61642E222C73657373696F6E526573746F7265643A2253657373696F6E20726573746F726564222C726553656C6563743A2252652D73656C65';
wwv_flow_imp.g_varchar2_table(2851) := '6374222C6D697373696E6752657175697265644D6574614669656C64733A7B303A224D697373696E67207265717569726564206D657461206669656C643A20257B6669656C64737D2E222C313A224D697373696E67207265717569726564206D65746120';
wwv_flow_imp.g_varchar2_table(2852) := '6669656C64733A20257B6669656C64737D2E227D2C74616B655069637475726542746E3A2254616B652050696374757265222C7265636F7264566964656F42746E3A225265636F726420566964656F227D7D3B66756E6374696F6E20546528692C65297B';
wwv_flow_imp.g_varchar2_table(2853) := '696628214F626A6563742E70726F746F747970652E6861734F776E50726F70657274792E63616C6C28692C6529297468726F77206E657720547970654572726F722822617474656D7074656420746F207573652070726976617465206669656C64206F6E';
wwv_flow_imp.g_varchar2_table(2854) := '206E6F6E2D696E7374616E636522293B72657475726E20697D6E2854652C225F636C617373507269766174654669656C644C6F6F73654261736522293B7661722055533D303B66756E6374696F6E2054692869297B72657475726E225F5F707269766174';
wwv_flow_imp.g_varchar2_table(2855) := '655F222B55532B2B2B225F222B697D6E2854692C225F636C617373507269766174654669656C644C6F6F73654B657922293B766172206B533D7B76657273696F6E3A22332E372E31227D2C42643D46642E64656661756C747C7C46642C54793D392C4453';
wwv_flow_imp.g_varchar2_table(2856) := '3D32373B66756E6374696F6E20417928297B6C657420693D7B7D3B72657475726E20692E70726F6D6973653D6E65772050726F6D6973652828652C74293D3E7B692E7265736F6C76653D652C692E72656A6563743D747D292C697D6E2841792C22637265';
wwv_flow_imp.g_varchar2_table(2857) := '61746550726F6D69736522293B766172206B733D5469282264697361626C65644E6F64657322292C4F723D5469282267656E65726174654C617267655468756D626E61696C496653696E676C6546696C6522292C79613D546928226F70656E46696C6545';
wwv_flow_imp.g_varchar2_table(2858) := '6469746F725768656E46696C6573416464656422292C44733D5469282261747461636852656E64657246756E6374696F6E546F54617267657422292C7A643D546928226973546172676574537570706F7274656422292C6A643D54692822676574416371';
wwv_flow_imp.g_varchar2_table(2859) := '75697265727322292C48643D5469282267657450726F6772657373496E64696361746F727322292C54723D54692822676574456469746F727322292C24643D54692822616464537065636966696564506C7567696E7346726F6D4F7074696F6E7322292C';
wwv_flow_imp.g_varchar2_table(2860) := '71643D546928226175746F446973636F766572506C7567696E7322292C49733D54692822616464537570706F72746564506C7567696E49664E6F54617267657422292C74733D636C61737320657874656E6473205A7B636F6E7374727563746F7228652C';
wwv_flow_imp.g_varchar2_table(2861) := '74297B76617220723B737570657228652C74292C723D746869732C4F626A6563742E646566696E6550726F706572747928746869732C6B732C7B7772697461626C653A21302C76616C75653A6E756C6C7D292C746869732E72656D6F7665546172676574';
wwv_flow_imp.g_varchar2_table(2862) := '3D6F3D3E7B6C6574206C3D746869732E676574506C7567696E537461746528292E746172676574732E66696C74657228683D3E682E6964213D3D6F2E6964293B746869732E736574506C7567696E5374617465287B746172676574733A6C7D297D2C7468';
wwv_flow_imp.g_varchar2_table(2863) := '69732E6164645461726765743D6F3D3E7B6C657420613D6F2E69647C7C6F2E636F6E7374727563746F722E6E616D652C6C3D6F2E7469746C657C7C612C683D6F2E747970653B69662868213D3D22616371756972657222262668213D3D2270726F677265';
wwv_flow_imp.g_varchar2_table(2864) := '7373696E64696361746F7222262668213D3D22656469746F7222297B6C657420793D2244617368626F6172643A2063616E206F6E6C7920626520746172676574656420627920706C7567696E73206F662074797065733A2061637175697265722C207072';
wwv_flow_imp.g_varchar2_table(2865) := '6F6772657373696E64696361746F722C20656469746F72223B746869732E757070792E6C6F6728792C226572726F7222293B72657475726E7D6C657420633D7B69643A612C6E616D653A6C2C747970653A687D2C663D746869732E676574506C7567696E';
wwv_flow_imp.g_varchar2_table(2866) := '537461746528292E746172676574732E736C69636528293B72657475726E20662E707573682863292C746869732E736574506C7567696E5374617465287B746172676574733A667D292C746869732E656C7D2C746869732E68696465416C6C50616E656C';
wwv_flow_imp.g_varchar2_table(2867) := '733D28293D3E7B6C6574206F3D746869732E676574506C7567696E537461746528292C613D7B6163746976655069636B657250616E656C3A21312C73686F7741646446696C657350616E656C3A21312C6163746976654F7665726C6179547970653A6E75';
wwv_flow_imp.g_varchar2_table(2868) := '6C6C2C66696C6543617264466F723A6E756C6C2C73686F7746696C65456469746F723A21317D3B6F2E6163746976655069636B657250616E656C3D3D3D612E6163746976655069636B657250616E656C26266F2E73686F7741646446696C657350616E65';
wwv_flow_imp.g_varchar2_table(2869) := '6C3D3D3D612E73686F7741646446696C657350616E656C26266F2E73686F7746696C65456469746F723D3D3D612E73686F7746696C65456469746F7226266F2E6163746976654F7665726C6179547970653D3D3D612E6163746976654F7665726C617954';
wwv_flow_imp.g_varchar2_table(2870) := '7970657C7C28746869732E736574506C7567696E53746174652861292C746869732E757070792E656D6974282264617368626F6172643A636C6F73652D70616E656C222C6F2E6163746976655069636B657250616E656C2E696429297D2C746869732E73';
wwv_flow_imp.g_varchar2_table(2871) := '686F7750616E656C3D6F3D3E7B6C65747B746172676574733A617D3D746869732E676574506C7567696E537461746528292C6C3D612E66696C74657228683D3E682E747970653D3D3D226163717569726572222626682E69643D3D3D6F295B305D3B7468';
wwv_flow_imp.g_varchar2_table(2872) := '69732E736574506C7567696E5374617465287B6163746976655069636B657250616E656C3A6C2C6163746976654F7665726C6179547970653A225069636B657250616E656C227D292C746869732E757070792E656D6974282264617368626F6172643A73';
wwv_flow_imp.g_varchar2_table(2873) := '686F772D70616E656C222C6F297D2C746869732E63616E4564697446696C653D6F3D3E7B6C65747B746172676574733A617D3D746869732E676574506C7567696E537461746528293B72657475726E20546528746869732C5472295B54725D2861292E73';
wwv_flow_imp.g_varchar2_table(2874) := '6F6D6528683D3E746869732E757070792E676574506C7567696E28682E6964292E63616E4564697446696C65286F29297D2C746869732E6F70656E46696C65456469746F723D6F3D3E7B6C65747B746172676574733A617D3D746869732E676574506C75';
wwv_flow_imp.g_varchar2_table(2875) := '67696E537461746528292C6C3D546528746869732C5472295B54725D2861293B746869732E736574506C7567696E5374617465287B73686F7746696C65456469746F723A21302C66696C6543617264466F723A6F2E69647C7C6E756C6C2C616374697665';
wwv_flow_imp.g_varchar2_table(2876) := '4F7665726C6179547970653A2246696C65456469746F72227D292C6C2E666F724561636828683D3E7B746869732E757070792E676574506C7567696E28682E6964292E73656C65637446696C65286F297D297D2C746869732E7361766546696C65456469';
wwv_flow_imp.g_varchar2_table(2877) := '746F723D28293D3E7B6C65747B746172676574733A6F7D3D746869732E676574506C7567696E537461746528293B546528746869732C5472295B54725D286F292E666F7245616368286C3D3E7B746869732E757070792E676574506C7567696E286C2E69';
wwv_flow_imp.g_varchar2_table(2878) := '64292E7361766528297D292C746869732E68696465416C6C50616E656C7328297D2C746869732E6F70656E4D6F64616C3D28293D3E7B6C65747B70726F6D6973653A6F2C7265736F6C76653A617D3D417928293B696628746869732E7361766564536372';
wwv_flow_imp.g_varchar2_table(2879) := '6F6C6C506F736974696F6E3D77696E646F772E70616765594F66667365742C746869732E7361766564416374697665456C656D656E743D646F63756D656E742E616374697665456C656D656E742C746869732E6F7074732E64697361626C655061676553';
wwv_flow_imp.g_varchar2_table(2880) := '63726F6C6C5768656E4D6F64616C4F70656E2626646F63756D656E742E626F64792E636C6173734C6973742E6164642822757070792D44617368626F6172642D6973466978656422292C746869732E6F7074732E616E696D6174654F70656E436C6F7365';
wwv_flow_imp.g_varchar2_table(2881) := '2626746869732E676574506C7567696E537461746528292E6973436C6F73696E67297B6C6574206C3D6E2828293D3E7B746869732E736574506C7567696E5374617465287B697348696464656E3A21317D292C746869732E656C2E72656D6F7665457665';
wwv_flow_imp.g_varchar2_table(2882) := '6E744C697374656E65722822616E696D6174696F6E656E64222C6C2C2131292C6128297D2C2268616E646C657222293B746869732E656C2E6164644576656E744C697374656E65722822616E696D6174696F6E656E64222C6C2C2131297D656C73652074';
wwv_flow_imp.g_varchar2_table(2883) := '6869732E736574506C7567696E5374617465287B697348696464656E3A21317D292C6128293B72657475726E20746869732E6F7074732E62726F777365724261636B427574746F6E436C6F73652626746869732E75706461746542726F77736572486973';
wwv_flow_imp.g_varchar2_table(2884) := '746F727928292C646F63756D656E742E6164644576656E744C697374656E657228226B6579646F776E222C746869732E68616E646C654B6579446F776E496E4D6F64616C292C746869732E757070792E656D6974282264617368626F6172643A6D6F6461';
wwv_flow_imp.g_varchar2_table(2885) := '6C2D6F70656E22292C6F7D2C746869732E636C6F73654D6F64616C3D66756E6374696F6E286F297B6F3D3D3D766F696420302626286F3D7B7D293B6C65747B6D616E75616C436C6F73653A613D21307D3D6F2C7B697348696464656E3A6C2C6973436C6F';
wwv_flow_imp.g_varchar2_table(2886) := '73696E673A687D3D722E676574506C7567696E537461746528293B6966286C7C7C682972657475726E3B6C65747B70726F6D6973653A632C7265736F6C76653A647D3D417928293B696628722E6F7074732E64697361626C65506167655363726F6C6C57';
wwv_flow_imp.g_varchar2_table(2887) := '68656E4D6F64616C4F70656E2626646F63756D656E742E626F64792E636C6173734C6973742E72656D6F76652822757070792D44617368626F6172642D6973466978656422292C722E6F7074732E616E696D6174654F70656E436C6F7365297B722E7365';
wwv_flow_imp.g_varchar2_table(2888) := '74506C7567696E5374617465287B6973436C6F73696E673A21307D293B6C657420793D6E2828293D3E7B722E736574506C7567696E5374617465287B697348696464656E3A21302C6973436C6F73696E673A21317D292C722E7375706572466F6375732E';
wwv_flow_imp.g_varchar2_table(2889) := '63616E63656C28292C722E7361766564416374697665456C656D656E742E666F63757328292C722E656C2E72656D6F76654576656E744C697374656E65722822616E696D6174696F6E656E64222C792C2131292C6428297D2C2268616E646C657222293B';
wwv_flow_imp.g_varchar2_table(2890) := '722E656C2E6164644576656E744C697374656E65722822616E696D6174696F6E656E64222C792C2131297D656C736520722E736574506C7567696E5374617465287B697348696464656E3A21307D292C722E7375706572466F6375732E63616E63656C28';
wwv_flow_imp.g_varchar2_table(2891) := '292C722E7361766564416374697665456C656D656E742E666F63757328292C6428293B696628646F63756D656E742E72656D6F76654576656E744C697374656E657228226B6579646F776E222C722E68616E646C654B6579446F776E496E4D6F64616C29';
wwv_flow_imp.g_varchar2_table(2892) := '2C612626722E6F7074732E62726F777365724261636B427574746F6E436C6F7365297B76617220663B28663D686973746F72792E737461746529213D6E756C6C2626665B722E6D6F64616C4E616D655D2626686973746F72792E6261636B28297D726574';
wwv_flow_imp.g_varchar2_table(2893) := '75726E20722E757070792E656D6974282264617368626F6172643A6D6F64616C2D636C6F73656422292C637D2C746869732E69734D6F64616C4F70656E3D28293D3E21746869732E676574506C7567696E537461746528292E697348696464656E7C7C21';
wwv_flow_imp.g_varchar2_table(2894) := '312C746869732E72657175657374436C6F73654D6F64616C3D28293D3E746869732E6F7074732E6F6E52657175657374436C6F73654D6F64616C3F746869732E6F7074732E6F6E52657175657374436C6F73654D6F64616C28293A746869732E636C6F73';
wwv_flow_imp.g_varchar2_table(2895) := '654D6F64616C28292C746869732E7365744461726B4D6F64654361706162696C6974793D6F3D3E7B6C65747B6361706162696C69746965733A617D3D746869732E757070792E676574537461746528293B746869732E757070792E736574537461746528';
wwv_flow_imp.g_varchar2_table(2896) := '7B6361706162696C69746965733A7B2E2E2E612C6461726B4D6F64653A6F7D7D297D2C746869732E68616E646C6553797374656D4461726B4D6F64654368616E67653D6F3D3E7B6C657420613D6F2E6D6174636865733B746869732E757070792E6C6F67';
wwv_flow_imp.g_varchar2_table(2897) := '28605B44617368626F6172645D204461726B206D6F646520697320247B613F226F6E223A226F6666227D60292C746869732E7365744461726B4D6F64654361706162696C6974792861297D2C746869732E746F67676C6546696C65436172643D286F2C61';
wwv_flow_imp.g_varchar2_table(2898) := '293D3E7B6C6574206C3D746869732E757070792E67657446696C652861293B6F3F746869732E757070792E656D6974282264617368626F6172643A66696C652D656469742D7374617274222C6C293A746869732E757070792E656D697428226461736862';
wwv_flow_imp.g_varchar2_table(2899) := '6F6172643A66696C652D656469742D636F6D706C657465222C6C292C746869732E736574506C7567696E5374617465287B66696C6543617264466F723A6F3F613A6E756C6C2C6163746976654F7665726C6179547970653A6F3F2246696C654361726422';
wwv_flow_imp.g_varchar2_table(2900) := '3A6E756C6C7D297D2C746869732E746F67676C6541646446696C657350616E656C3D6F3D3E7B746869732E736574506C7567696E5374617465287B73686F7741646446696C657350616E656C3A6F2C6163746976654F7665726C6179547970653A6F3F22';
wwv_flow_imp.g_varchar2_table(2901) := '41646446696C6573223A6E756C6C7D297D2C746869732E61646446696C65733D6F3D3E7B6C657420613D6F2E6D6170286C3D3E287B736F757263653A746869732E69642C6E616D653A6C2E6E616D652C747970653A6C2E747970652C646174613A6C2C6D';
wwv_flow_imp.g_varchar2_table(2902) := '6574613A7B72656C6174697665506174683A6C2E72656C6174697665506174687C7C6C2E7765626B697452656C6174697665506174687C7C6E756C6C7D7D29293B7472797B746869732E757070792E61646446696C65732861297D6361746368286C297B';
wwv_flow_imp.g_varchar2_table(2903) := '746869732E757070792E6C6F67286C297D7D2C746869732E73746172744C697374656E696E67546F526573697A653D28293D3E7B746869732E726573697A654F627365727665723D6E657720526573697A654F62736572766572286F3D3E7B6C65742061';
wwv_flow_imp.g_varchar2_table(2904) := '3D6F5B305D2C7B77696474683A6C2C6865696768743A687D3D612E636F6E74656E74526563743B746869732E736574506C7567696E5374617465287B636F6E7461696E657257696474683A6C2C636F6E7461696E65724865696768743A682C617265496E';
wwv_flow_imp.g_varchar2_table(2905) := '73696465735265616479546F426556697369626C653A21307D297D292C746869732E726573697A654F627365727665722E6F62736572766528746869732E656C2E717565727953656C6563746F7228222E757070792D44617368626F6172642D696E6E65';
wwv_flow_imp.g_varchar2_table(2906) := '722229292C746869732E6D616B6544617368626F617264496E736964657356697369626C65416E7977617954696D656F75743D73657454696D656F75742828293D3E7B6C6574206F3D746869732E676574506C7567696E537461746528292C613D217468';
wwv_flow_imp.g_varchar2_table(2907) := '69732E6F7074732E696E6C696E6526266F2E697348696464656E3B216F2E617265496E73696465735265616479546F426556697369626C6526262161262628746869732E757070792E6C6F6728225B44617368626F6172645D20726573697A6520657665';
wwv_flow_imp.g_varchar2_table(2908) := '6E74206469646E5C7532303139742066697265206F6E2074696D653A2064656661756C74656420746F206D6F62696C65206C61796F7574222C227761726E696E6722292C746869732E736574506C7567696E5374617465287B617265496E736964657352';
wwv_flow_imp.g_varchar2_table(2909) := '65616479546F426556697369626C653A21307D29297D2C316533297D2C746869732E73746F704C697374656E696E67546F526573697A653D28293D3E7B746869732E726573697A654F627365727665722E646973636F6E6E65637428292C636C65617254';
wwv_flow_imp.g_varchar2_table(2910) := '696D656F757428746869732E6D616B6544617368626F617264496E736964657356697369626C65416E7977617954696D656F7574297D2C746869732E7265636F72644966466F63757365644F6E55707079526563656E746C793D6F3D3E7B746869732E65';
wwv_flow_imp.g_varchar2_table(2911) := '6C2E636F6E7461696E73286F2E746172676574293F746869732E6966466F63757365644F6E55707079526563656E746C793D21303A28746869732E6966466F63757365644F6E55707079526563656E746C793D21312C746869732E7375706572466F6375';
wwv_flow_imp.g_varchar2_table(2912) := '732E63616E63656C2829297D2C746869732E64697361626C65496E746572616374697665456C656D656E74733D6F3D3E7B76617220613B6C6574206C3D5B22615B687265665D222C22696E7075743A6E6F74285B64697361626C65645D29222C2273656C';
wwv_flow_imp.g_varchar2_table(2913) := '6563743A6E6F74285B64697361626C65645D29222C2274657874617265613A6E6F74285B64697361626C65645D29222C22627574746F6E3A6E6F74285B64697361626C65645D29222C275B726F6C653D22627574746F6E225D3A6E6F74285B6469736162';
wwv_flow_imp.g_varchar2_table(2914) := '6C65645D29275D2C683D28613D546528746869732C6B73295B6B735D29213D6E756C6C3F613A516528746869732E656C2E717565727953656C6563746F72416C6C286C29292E66696C74657228633D3E21632E636C6173734C6973742E636F6E7461696E';
wwv_flow_imp.g_varchar2_table(2915) := '732822757070792D44617368626F6172642D636C6F73652229293B666F72286C65742063206F66206829632E7461674E616D653D3D3D2241223F632E7365744174747269627574652822617269612D64697361626C6564222C6F293A632E64697361626C';
wwv_flow_imp.g_varchar2_table(2916) := '65643D6F3B6F3F546528746869732C6B73295B6B735D3D683A546528746869732C6B73295B6B735D3D6E756C6C2C746869732E64617368626F617264497344697361626C65643D6F7D2C746869732E75706461746542726F77736572486973746F72793D';
wwv_flow_imp.g_varchar2_table(2917) := '28293D3E7B766172206F3B286F3D686973746F72792E737461746529213D6E756C6C26266F5B746869732E6D6F64616C4E616D655D7C7C686973746F72792E707573685374617465287B2E2E2E686973746F72792E73746174652C5B746869732E6D6F64';
wwv_flow_imp.g_varchar2_table(2918) := '616C4E616D655D3A21307D2C2222292C77696E646F772E6164644576656E744C697374656E65722822706F707374617465222C746869732E68616E646C65506F7053746174652C2131297D2C746869732E68616E646C65506F7053746174653D6F3D3E7B';
wwv_flow_imp.g_varchar2_table(2919) := '76617220613B746869732E69734D6F64616C4F70656E2829262628216F2E73746174657C7C216F2E73746174655B746869732E6D6F64616C4E616D655D292626746869732E636C6F73654D6F64616C287B6D616E75616C436C6F73653A21317D292C2174';
wwv_flow_imp.g_varchar2_table(2920) := '6869732E69734D6F64616C4F70656E2829262628613D6F2E737461746529213D6E756C6C2626615B746869732E6D6F64616C4E616D655D2626686973746F72792E6261636B28297D2C746869732E68616E646C654B6579446F776E496E4D6F64616C3D6F';
wwv_flow_imp.g_varchar2_table(2921) := '3D3E7B6F2E6B6579436F64653D3D3D44532626746869732E72657175657374436C6F73654D6F64616C286F292C6F2E6B6579436F64653D3D3D547926267864286F2C746869732E676574506C7567696E537461746528292E6163746976654F7665726C61';
wwv_flow_imp.g_varchar2_table(2922) := '79547970652C746869732E656C297D2C746869732E68616E646C65436C69636B4F7574736964653D28293D3E7B746869732E6F7074732E636C6F73654D6F64616C4F6E436C69636B4F7574736964652626746869732E72657175657374436C6F73654D6F';
wwv_flow_imp.g_varchar2_table(2923) := '64616C28297D2C746869732E68616E646C6550617374653D6F3D3E7B746869732E757070792E69746572617465506C7567696E73286C3D3E7B6C2E747970653D3D3D226163717569726572222626286C2E68616E646C65526F6F7450617374653D3D6E75';
wwv_flow_imp.g_varchar2_table(2924) := '6C6C7C7C6C2E68616E646C65526F6F745061737465286F29297D293B6C657420613D5165286F2E636C6970626F617264446174612E66696C6573293B612E6C656E6774683E30262628746869732E757070792E6C6F6728225B44617368626F6172645D20';
wwv_flow_imp.g_varchar2_table(2925) := '46696C65732070617374656422292C746869732E61646446696C6573286129297D2C746869732E68616E646C65496E7075744368616E67653D6F3D3E7B6F2E70726576656E7444656661756C7428293B6C657420613D5165286F2E7461726765742E6669';
wwv_flow_imp.g_varchar2_table(2926) := '6C6573293B612E6C656E6774683E30262628746869732E757070792E6C6F6728225B44617368626F6172645D2046696C65732073656C6563746564207468726F75676820696E70757422292C746869732E61646446696C6573286129297D2C746869732E';
wwv_flow_imp.g_varchar2_table(2927) := '68616E646C65447261674F7665723D6F3D3E7B76617220612C6C3B6F2E70726576656E7444656661756C7428292C6F2E73746F7050726F7061676174696F6E28293B6C657420683D6E2828293D3E7B6C657420793D21303B72657475726E20746869732E';
wwv_flow_imp.g_varchar2_table(2928) := '757070792E69746572617465506C7567696E7328623D3E7B622E63616E48616E646C65526F6F7444726F70213D6E756C6C2626622E63616E48616E646C65526F6F7444726F70286F29262628793D2130297D292C797D2C2263616E536F6D65506C756769';
wwv_flow_imp.g_varchar2_table(2929) := '6E48616E646C65526F6F7444726F7022292C633D6E2828293D3E7B6C65747B74797065733A797D3D6F2E646174615472616E736665723B72657475726E20792E736F6D6528623D3E623D3D3D2246696C657322297D2C22646F65734576656E7448617665';
wwv_flow_imp.g_varchar2_table(2930) := '46696C657322292C643D68286F292C663D63286F293B6966282164262621667C7C746869732E6F7074732E64697361626C65647C7C746869732E6F7074732E64697361626C654C6F63616C46696C6573262628667C7C2164297C7C21746869732E757070';
wwv_flow_imp.g_varchar2_table(2931) := '792E676574537461746528292E616C6C6F774E657755706C6F6164297B6F2E646174615472616E736665722E64726F704566666563743D226E6F6E65222C636C65617254696D656F757428746869732E72656D6F7665447261674F766572436C61737354';
wwv_flow_imp.g_varchar2_table(2932) := '696D656F7574293B72657475726E7D6F2E646174615472616E736665722E64726F704566666563743D22636F7079222C636C65617254696D656F757428746869732E72656D6F7665447261674F766572436C61737354696D656F7574292C746869732E73';
wwv_flow_imp.g_varchar2_table(2933) := '6574506C7567696E5374617465287B69734472616767696E674F7665723A21307D292C28613D286C3D746869732E6F707473292E6F6E447261674F766572293D3D6E756C6C7C7C612E63616C6C286C2C6F297D2C746869732E68616E646C65447261674C';
wwv_flow_imp.g_varchar2_table(2934) := '656176653D6F3D3E7B76617220612C6C3B6F2E70726576656E7444656661756C7428292C6F2E73746F7050726F7061676174696F6E28292C636C65617254696D656F757428746869732E72656D6F7665447261674F766572436C61737354696D656F7574';
wwv_flow_imp.g_varchar2_table(2935) := '292C746869732E72656D6F7665447261674F766572436C61737354696D656F75743D73657454696D656F75742828293D3E7B746869732E736574506C7567696E5374617465287B69734472616767696E674F7665723A21317D297D2C3530292C28613D28';
wwv_flow_imp.g_varchar2_table(2936) := '6C3D746869732E6F707473292E6F6E447261674C65617665293D3D6E756C6C7C7C612E63616C6C286C2C6F297D2C746869732E68616E646C6544726F703D6173796E63206F3D3E7B76617220612C6C3B6F2E70726576656E7444656661756C7428292C6F';
wwv_flow_imp.g_varchar2_table(2937) := '2E73746F7050726F7061676174696F6E28292C636C65617254696D656F757428746869732E72656D6F7665447261674F766572436C61737354696D656F7574292C746869732E736574506C7567696E5374617465287B69734472616767696E674F766572';
wwv_flow_imp.g_varchar2_table(2938) := '3A21317D292C746869732E757070792E69746572617465506C7567696E7328663D3E7B662E747970653D3D3D22616371756972657222262628662E68616E646C65526F6F7444726F703D3D6E756C6C7C7C662E68616E646C65526F6F7444726F70286F29';
wwv_flow_imp.g_varchar2_table(2939) := '297D293B6C657420683D21312C633D6E28663D3E7B746869732E757070792E6C6F6728662C226572726F7222292C687C7C28746869732E757070792E696E666F28662E6D6573736167652C226572726F7222292C683D2130297D2C226C6F6744726F7045';
wwv_flow_imp.g_varchar2_table(2940) := '72726F7222293B746869732E757070792E6C6F6728225B44617368626F6172645D2050726F63657373696E672064726F707065642066696C657322293B6C657420643D6177616974204173286F2E646174615472616E736665722C7B6C6F6744726F7045';
wwv_flow_imp.g_varchar2_table(2941) := '72726F723A637D293B642E6C656E6774683E30262628746869732E757070792E6C6F6728225B44617368626F6172645D2046696C65732064726F7070656422292C746869732E61646446696C6573286429292C28613D286C3D746869732E6F707473292E';
wwv_flow_imp.g_varchar2_table(2942) := '6F6E44726F70293D3D6E756C6C7C7C612E63616C6C286C2C6F297D2C746869732E68616E646C65526571756573745468756D626E61696C3D6F3D3E7B746869732E6F7074732E77616974466F725468756D626E61696C734265666F726555706C6F61647C';
wwv_flow_imp.g_varchar2_table(2943) := '7C746869732E757070792E656D697428227468756D626E61696C3A72657175657374222C6F297D2C746869732E68616E646C6543616E63656C5468756D626E61696C3D6F3D3E7B746869732E6F7074732E77616974466F725468756D626E61696C734265';
wwv_flow_imp.g_varchar2_table(2944) := '666F726555706C6F61647C7C746869732E757070792E656D697428227468756D626E61696C3A63616E63656C222C6F297D2C746869732E68616E646C654B6579446F776E496E496E6C696E653D6F3D3E7B6F2E6B6579436F64653D3D3D54792626697928';
wwv_flow_imp.g_varchar2_table(2945) := '6F2C746869732E676574506C7567696E537461746528292E6163746976654F7665726C6179547970652C746869732E656C297D2C746869732E68616E646C6550617374654F6E426F64793D6F3D3E7B746869732E656C2E636F6E7461696E7328646F6375';
wwv_flow_imp.g_varchar2_table(2946) := '6D656E742E616374697665456C656D656E74292626746869732E68616E646C655061737465286F297D2C746869732E68616E646C65436F6D706C6574653D6F3D3E7B6C65747B6661696C65643A617D3D6F3B746869732E6F7074732E636C6F7365416674';
wwv_flow_imp.g_varchar2_table(2947) := '657246696E6973682626612E6C656E6774683D3D3D302626746869732E72657175657374436C6F73654D6F64616C28297D2C746869732E68616E646C6543616E63656C526573746F72653D28293D3E7B746869732E757070792E656D6974282272657374';
wwv_flow_imp.g_varchar2_table(2948) := '6F72652D63616E63656C656422297D2C4F626A6563742E646566696E6550726F706572747928746869732C4F722C7B7772697461626C653A21302C76616C75653A28293D3E7B696628746869732E6F7074732E64697361626C655468756D626E61696C47';
wwv_flow_imp.g_varchar2_table(2949) := '656E657261746F722972657475726E3B6C6574206F3D3630302C613D746869732E757070792E67657446696C657328293B696628612E6C656E6774683D3D3D31297B6C6574206C3D746869732E757070792E676574506C7567696E2860247B746869732E';
wwv_flow_imp.g_varchar2_table(2950) := '69647D3A5468756D626E61696C47656E657261746F7260293B6C3F2E7365744F7074696F6E73287B7468756D626E61696C57696474683A6F7D293B6C657420683D7B2E2E2E615B305D2C707265766965773A766F696420307D3B6C2E7265717565737454';
wwv_flow_imp.g_varchar2_table(2951) := '68756D626E61696C2868292E7468656E2828293D3E7B6C3F2E7365744F7074696F6E73287B7468756D626E61696C57696474683A746869732E6F7074732E7468756D626E61696C57696474687D297D297D7D7D292C4F626A6563742E646566696E655072';
wwv_flow_imp.g_varchar2_table(2952) := '6F706572747928746869732C79612C7B7772697461626C653A21302C76616C75653A6F3D3E7B6C657420613D6F5B305D3B746869732E63616E4564697446696C652861292626746869732E6F70656E46696C65456469746F722861297D7D292C74686973';
wwv_flow_imp.g_varchar2_table(2953) := '2E696E69744576656E74733D28293D3E7B696628746869732E6F7074732E74726967676572262621746869732E6F7074732E696E6C696E65297B6C6574206F3D4F7528746869732E6F7074732E74726967676572293B6F3F6F2E666F724561636828613D';
wwv_flow_imp.g_varchar2_table(2954) := '3E612E6164644576656E744C697374656E65722822636C69636B222C746869732E6F70656E4D6F64616C29293A746869732E757070792E6C6F67282244617368626F617264206D6F64616C2074726967676572206E6F7420666F756E642E204D616B6520';
wwv_flow_imp.g_varchar2_table(2955) := '73757265206074726967676572602069732073657420696E2044617368626F617264206F7074696F6E732C20756E6C65737320796F752061726520706C616E6E696E6720746F2063616C6C206064617368626F6172642E6F70656E4D6F64616C28296020';
wwv_flow_imp.g_varchar2_table(2956) := '6D6574686F6420796F757273656C66222C227761726E696E6722297D746869732E73746172744C697374656E696E67546F526573697A6528292C646F63756D656E742E6164644576656E744C697374656E657228227061737465222C746869732E68616E';
wwv_flow_imp.g_varchar2_table(2957) := '646C6550617374654F6E426F6479292C746869732E757070792E6F6E2822706C7567696E2D6164646564222C546528746869732C4973295B49735D292C746869732E757070792E6F6E2822706C7567696E2D72656D6F7665222C746869732E72656D6F76';
wwv_flow_imp.g_varchar2_table(2958) := '65546172676574292C746869732E757070792E6F6E282266696C652D6164646564222C746869732E68696465416C6C50616E656C73292C746869732E757070792E6F6E282264617368626F6172643A6D6F64616C2D636C6F736564222C746869732E6869';
wwv_flow_imp.g_varchar2_table(2959) := '6465416C6C50616E656C73292C746869732E757070792E6F6E282266696C652D656469746F723A636F6D706C657465222C746869732E68696465416C6C50616E656C73292C746869732E757070792E6F6E2822636F6D706C657465222C746869732E6861';
wwv_flow_imp.g_varchar2_table(2960) := '6E646C65436F6D706C657465292C746869732E757070792E6F6E282266696C65732D6164646564222C546528746869732C4F72295B4F725D292C746869732E757070792E6F6E282266696C652D72656D6F766564222C546528746869732C4F72295B4F72';
wwv_flow_imp.g_varchar2_table(2961) := '5D292C646F63756D656E742E6164644576656E744C697374656E65722822666F637573222C746869732E7265636F72644966466F63757365644F6E55707079526563656E746C792C2130292C646F63756D656E742E6164644576656E744C697374656E65';
wwv_flow_imp.g_varchar2_table(2962) := '722822636C69636B222C746869732E7265636F72644966466F63757365644F6E55707079526563656E746C792C2130292C746869732E6F7074732E696E6C696E652626746869732E656C2E6164644576656E744C697374656E657228226B6579646F776E';
wwv_flow_imp.g_varchar2_table(2963) := '222C746869732E68616E646C654B6579446F776E496E496E6C696E65292C746869732E6F7074732E6175746F4F70656E46696C65456469746F722626746869732E757070792E6F6E282266696C65732D6164646564222C546528746869732C7961295B79';
wwv_flow_imp.g_varchar2_table(2964) := '615D297D2C746869732E72656D6F76654576656E74733D28293D3E7B6C6574206F3D4F7528746869732E6F7074732E74726967676572293B21746869732E6F7074732E696E6C696E6526266F26266F2E666F724561636828613D3E612E72656D6F766545';
wwv_flow_imp.g_varchar2_table(2965) := '76656E744C697374656E65722822636C69636B222C746869732E6F70656E4D6F64616C29292C746869732E73746F704C697374656E696E67546F526573697A6528292C646F63756D656E742E72656D6F76654576656E744C697374656E65722822706173';
wwv_flow_imp.g_varchar2_table(2966) := '7465222C746869732E68616E646C6550617374654F6E426F6479292C77696E646F772E72656D6F76654576656E744C697374656E65722822706F707374617465222C746869732E68616E646C65506F7053746174652C2131292C746869732E757070792E';
wwv_flow_imp.g_varchar2_table(2967) := '6F66662822706C7567696E2D6164646564222C546528746869732C4973295B49735D292C746869732E757070792E6F66662822706C7567696E2D72656D6F7665222C746869732E72656D6F7665546172676574292C746869732E757070792E6F66662822';
wwv_flow_imp.g_varchar2_table(2968) := '66696C652D6164646564222C746869732E68696465416C6C50616E656C73292C746869732E757070792E6F6666282264617368626F6172643A6D6F64616C2D636C6F736564222C746869732E68696465416C6C50616E656C73292C746869732E75707079';
wwv_flow_imp.g_varchar2_table(2969) := '2E6F6666282266696C652D656469746F723A636F6D706C657465222C746869732E68696465416C6C50616E656C73292C746869732E757070792E6F66662822636F6D706C657465222C746869732E68616E646C65436F6D706C657465292C746869732E75';
wwv_flow_imp.g_varchar2_table(2970) := '7070792E6F6666282266696C65732D6164646564222C546528746869732C4F72295B4F725D292C746869732E757070792E6F6666282266696C652D72656D6F766564222C546528746869732C4F72295B4F725D292C646F63756D656E742E72656D6F7665';
wwv_flow_imp.g_varchar2_table(2971) := '4576656E744C697374656E65722822666F637573222C746869732E7265636F72644966466F63757365644F6E55707079526563656E746C79292C646F63756D656E742E72656D6F76654576656E744C697374656E65722822636C69636B222C746869732E';
wwv_flow_imp.g_varchar2_table(2972) := '7265636F72644966466F63757365644F6E55707079526563656E746C79292C746869732E6F7074732E696E6C696E652626746869732E656C2E72656D6F76654576656E744C697374656E657228226B6579646F776E222C746869732E68616E646C654B65';
wwv_flow_imp.g_varchar2_table(2973) := '79446F776E496E496E6C696E65292C746869732E6F7074732E6175746F4F70656E46696C65456469746F722626746869732E757070792E6F6666282266696C65732D6164646564222C546528746869732C7961295B79615D297D2C746869732E73757065';
wwv_flow_imp.g_varchar2_table(2974) := '72466F6375734F6E456163685570646174653D28293D3E7B6C6574206F3D746869732E656C2E636F6E7461696E7328646F63756D656E742E616374697665456C656D656E74292C613D646F63756D656E742E616374697665456C656D656E743D3D3D646F';
wwv_flow_imp.g_varchar2_table(2975) := '63756D656E742E626F64797C7C646F63756D656E742E616374697665456C656D656E743D3D3D6E756C6C2C6C3D746869732E757070792E676574537461746528292E696E666F2E6C656E6774683D3D3D302C683D21746869732E6F7074732E696E6C696E';
wwv_flow_imp.g_varchar2_table(2976) := '653B6C262628687C7C6F7C7C612626746869732E6966466F63757365644F6E55707079526563656E746C79293F746869732E7375706572466F63757328746869732E656C2C746869732E676574506C7567696E537461746528292E6163746976654F7665';
wwv_flow_imp.g_varchar2_table(2977) := '726C617954797065293A746869732E7375706572466F6375732E63616E63656C28297D2C746869732E61667465725570646174653D28293D3E7B696628746869732E6F7074732E64697361626C6564262621746869732E64617368626F61726449734469';
wwv_flow_imp.g_varchar2_table(2978) := '7361626C6564297B746869732E64697361626C65496E746572616374697665456C656D656E7473282130293B72657475726E7D21746869732E6F7074732E64697361626C65642626746869732E64617368626F617264497344697361626C656426267468';
wwv_flow_imp.g_varchar2_table(2979) := '69732E64697361626C65496E746572616374697665456C656D656E7473282131292C746869732E7375706572466F6375734F6E4561636855706461746528297D2C746869732E7361766546696C65436172643D286F2C61293D3E7B746869732E75707079';
wwv_flow_imp.g_varchar2_table(2980) := '2E73657446696C654D65746128612C6F292C746869732E746F67676C6546696C65436172642821312C61297D2C4F626A6563742E646566696E6550726F706572747928746869732C44732C7B7772697461626C653A21302C76616C75653A6F3D3E7B6C65';
wwv_flow_imp.g_varchar2_table(2981) := '7420613D746869732E757070792E676574506C7567696E286F2E6964293B72657475726E7B2E2E2E6F2C69636F6E3A612E69636F6E7C7C746869732E6F7074732E64656661756C745069636B657249636F6E2C72656E6465723A612E72656E6465727D7D';
wwv_flow_imp.g_varchar2_table(2982) := '7D292C4F626A6563742E646566696E6550726F706572747928746869732C7A642C7B7772697461626C653A21302C76616C75653A6F3D3E7B6C657420613D746869732E757070792E676574506C7567696E286F2E6964293B72657475726E20747970656F';
wwv_flow_imp.g_varchar2_table(2983) := '6620612E6973537570706F72746564213D2266756E6374696F6E223F21303A612E6973537570706F7274656428297D7D292C4F626A6563742E646566696E6550726F706572747928746869732C6A642C7B7772697461626C653A21302C76616C75653A42';
wwv_flow_imp.g_varchar2_table(2984) := '64286F3D3E6F2E66696C74657228613D3E612E747970653D3D3D226163717569726572222626546528746869732C7A64295B7A645D286129292E6D617028546528746869732C4473295B44735D29297D292C4F626A6563742E646566696E6550726F7065';
wwv_flow_imp.g_varchar2_table(2985) := '72747928746869732C48642C7B7772697461626C653A21302C76616C75653A4264286F3D3E6F2E66696C74657228613D3E612E747970653D3D3D2270726F6772657373696E64696361746F7222292E6D617028546528746869732C4473295B44735D2929';
wwv_flow_imp.g_varchar2_table(2986) := '7D292C4F626A6563742E646566696E6550726F706572747928746869732C54722C7B7772697461626C653A21302C76616C75653A4264286F3D3E6F2E66696C74657228613D3E612E747970653D3D3D22656469746F7222292E6D61702854652874686973';
wwv_flow_imp.g_varchar2_table(2987) := '2C4473295B44735D29297D292C746869732E72656E6465723D6F3D3E7B6C657420613D746869732E676574506C7567696E537461746528292C7B66696C65733A6C2C6361706162696C69746965733A682C616C6C6F774E657755706C6F61643A637D3D6F';
wwv_flow_imp.g_varchar2_table(2988) := '2C7B6E657746696C65733A642C75706C6F61645374617274656446696C65733A662C636F6D706C65746546696C65733A792C6572726F72656446696C65733A622C696E50726F677265737346696C65733A532C696E50726F67726573734E6F7450617573';
wwv_flow_imp.g_varchar2_table(2989) := '656446696C65733A452C70726F63657373696E6746696C65733A462C697355706C6F6164537461727465643A782C6973416C6C436F6D706C6574653A552C6973416C6C4572726F7265643A6A2C6973416C6C5061757365643A477D3D746869732E757070';
wwv_flow_imp.g_varchar2_table(2990) := '792E6765744F626A6563744F6646696C6573506572537461746528292C4A3D546528746869732C6A64295B6A645D28612E74617267657473292C423D546528746869732C4864295B48645D28612E74617267657473292C7A3D546528746869732C547229';
wwv_flow_imp.g_varchar2_table(2991) := '5B54725D28612E74617267657473292C4B3B72657475726E20746869732E6F7074732E7468656D653D3D3D226175746F223F4B3D682E6461726B4D6F64653F226461726B223A226C69676874223A4B3D746869732E6F7074732E7468656D652C5B226669';
wwv_flow_imp.g_varchar2_table(2992) := '6C6573222C22666F6C64657273222C22626F7468225D2E696E6465784F6628746869732E6F7074732E66696C654D616E6167657253656C656374696F6E54797065293C30262628746869732E6F7074732E66696C654D616E6167657253656C656374696F';
wwv_flow_imp.g_varchar2_table(2993) := '6E547970653D2266696C6573222C636F6E736F6C652E7761726E2860556E737570706F72746564206F7074696F6E20666F72202266696C654D616E6167657253656C656374696F6E54797065222E205573696E672064656661756C74206F662022247B74';
wwv_flow_imp.g_varchar2_table(2994) := '6869732E6F7074732E66696C654D616E6167657253656C656374696F6E547970657D222E6029292C4C64287B73746174653A6F2C697348696464656E3A612E697348696464656E2C66696C65733A6C2C6E657746696C65733A642C75706C6F6164537461';
wwv_flow_imp.g_varchar2_table(2995) := '7274656446696C65733A662C636F6D706C65746546696C65733A792C6572726F72656446696C65733A622C696E50726F677265737346696C65733A532C696E50726F67726573734E6F7450617573656446696C65733A452C70726F63657373696E674669';
wwv_flow_imp.g_varchar2_table(2996) := '6C65733A462C697355706C6F6164537461727465643A782C6973416C6C436F6D706C6574653A552C6973416C6C4572726F7265643A6A2C6973416C6C5061757365643A472C746F74616C46696C65436F756E743A4F626A6563742E6B657973286C292E6C';
wwv_flow_imp.g_varchar2_table(2997) := '656E6774682C746F74616C50726F67726573733A6F2E746F74616C50726F67726573732C616C6C6F774E657755706C6F61643A632C6163717569726572733A4A2C7468656D653A4B2C64697361626C65643A746869732E6F7074732E64697361626C6564';
wwv_flow_imp.g_varchar2_table(2998) := '2C64697361626C654C6F63616C46696C65733A746869732E6F7074732E64697361626C654C6F63616C46696C65732C646972656374696F6E3A746869732E6F7074732E646972656374696F6E2C6163746976655069636B657250616E656C3A612E616374';
wwv_flow_imp.g_varchar2_table(2999) := '6976655069636B657250616E656C2C73686F7746696C65456469746F723A612E73686F7746696C65456469746F722C7361766546696C65456469746F723A746869732E7361766546696C65456469746F722C64697361626C65496E746572616374697665';
wwv_flow_imp.g_varchar2_table(3000) := '456C656D656E74733A746869732E64697361626C65496E746572616374697665456C656D656E74732C616E696D6174654F70656E436C6F73653A746869732E6F7074732E616E696D6174654F70656E436C6F73652C6973436C6F73696E673A612E697343';
null;
end;
/
begin
wwv_flow_imp.g_varchar2_table(3001) := '6C6F73696E672C70726F6772657373696E64696361746F72733A422C656469746F72733A7A2C6175746F50726F636565643A746869732E757070792E6F7074732E6175746F50726F636565642C69643A746869732E69642C636C6F73654D6F64616C3A74';
wwv_flow_imp.g_varchar2_table(3002) := '6869732E72657175657374436C6F73654D6F64616C2C68616E646C65436C69636B4F7574736964653A746869732E68616E646C65436C69636B4F7574736964652C68616E646C65496E7075744368616E67653A746869732E68616E646C65496E70757443';
wwv_flow_imp.g_varchar2_table(3003) := '68616E67652C68616E646C6550617374653A746869732E68616E646C6550617374652C696E6C696E653A746869732E6F7074732E696E6C696E652C73686F7750616E656C3A746869732E73686F7750616E656C2C68696465416C6C50616E656C733A7468';
wwv_flow_imp.g_varchar2_table(3004) := '69732E68696465416C6C50616E656C732C6931386E3A746869732E6931386E2C6931386E41727261793A746869732E6931386E41727261792C757070793A746869732E757070792C6E6F74653A746869732E6F7074732E6E6F74652C7265636F76657265';
wwv_flow_imp.g_varchar2_table(3005) := '6453746174653A6F2E7265636F766572656453746174652C6D6574614669656C64733A612E6D6574614669656C64732C726573756D61626C6555706C6F6164733A682E726573756D61626C6555706C6F6164737C7C21312C696E646976696475616C4361';
wwv_flow_imp.g_varchar2_table(3006) := '6E63656C6C6174696F6E3A682E696E646976696475616C43616E63656C6C6174696F6E2C69734D6F62696C654465766963653A682E69734D6F62696C654465766963652C66696C6543617264466F723A612E66696C6543617264466F722C746F67676C65';
wwv_flow_imp.g_varchar2_table(3007) := '46696C65436172643A746869732E746F67676C6546696C65436172642C746F67676C6541646446696C657350616E656C3A746869732E746F67676C6541646446696C657350616E656C2C73686F7741646446696C657350616E656C3A612E73686F774164';
wwv_flow_imp.g_varchar2_table(3008) := '6446696C657350616E656C2C7361766546696C65436172643A746869732E7361766546696C65436172642C6F70656E46696C65456469746F723A746869732E6F70656E46696C65456469746F722C63616E4564697446696C653A746869732E63616E4564';
wwv_flow_imp.g_varchar2_table(3009) := '697446696C652C77696474683A746869732E6F7074732E77696474682C6865696768743A746869732E6F7074732E6865696768742C73686F774C696E6B546F46696C6555706C6F6164526573756C743A746869732E6F7074732E73686F774C696E6B546F';
wwv_flow_imp.g_varchar2_table(3010) := '46696C6555706C6F6164526573756C742C66696C654D616E6167657253656C656374696F6E547970653A746869732E6F7074732E66696C654D616E6167657253656C656374696F6E547970652C70726F75646C79446973706C6179506F77657265644279';
wwv_flow_imp.g_varchar2_table(3011) := '557070793A746869732E6F7074732E70726F75646C79446973706C6179506F77657265644279557070792C6869646543616E63656C427574746F6E3A746869732E6F7074732E6869646543616E63656C427574746F6E2C68696465526574727942757474';
wwv_flow_imp.g_varchar2_table(3012) := '6F6E3A746869732E6F7074732E686964655265747279427574746F6E2C686964655061757365526573756D65427574746F6E3A746869732E6F7074732E686964655061757365526573756D65427574746F6E2C73686F7752656D6F7665427574746F6E41';
wwv_flow_imp.g_varchar2_table(3013) := '66746572436F6D706C6574653A746869732E6F7074732E73686F7752656D6F7665427574746F6E4166746572436F6D706C6574652C636F6E7461696E657257696474683A612E636F6E7461696E657257696474682C636F6E7461696E6572486569676874';
wwv_flow_imp.g_varchar2_table(3014) := '3A612E636F6E7461696E65724865696768742C617265496E73696465735265616479546F426556697369626C653A612E617265496E73696465735265616479546F426556697369626C652C6973546172676574444F4D456C3A746869732E697354617267';
wwv_flow_imp.g_varchar2_table(3015) := '6574444F4D456C2C706172656E74456C656D656E743A746869732E656C2C616C6C6F77656446696C6554797065733A746869732E757070792E6F7074732E7265737472696374696F6E732E616C6C6F77656446696C6554797065732C6D61784E756D6265';
wwv_flow_imp.g_varchar2_table(3016) := '724F6646696C65733A746869732E757070792E6F7074732E7265737472696374696F6E732E6D61784E756D6265724F6646696C65732C72657175697265644D6574614669656C64733A746869732E757070792E6F7074732E7265737472696374696F6E73';
wwv_flow_imp.g_varchar2_table(3017) := '2E72657175697265644D6574614669656C64732C73686F7753656C656374656446696C65733A746869732E6F7074732E73686F7753656C656374656446696C65732C73686F774E617469766550686F746F43616D657261427574746F6E3A746869732E6F';
wwv_flow_imp.g_varchar2_table(3018) := '7074732E73686F774E617469766550686F746F43616D657261427574746F6E2C73686F774E6174697665566964656F43616D657261427574746F6E3A746869732E6F7074732E73686F774E6174697665566964656F43616D657261427574746F6E2C6E61';
wwv_flow_imp.g_varchar2_table(3019) := '7469766543616D657261466163696E674D6F64653A746869732E6F7074732E6E617469766543616D657261466163696E674D6F64652C73696E676C6546696C6546756C6C53637265656E3A746869732E6F7074732E73696E676C6546696C6546756C6C53';
wwv_flow_imp.g_varchar2_table(3020) := '637265656E2C68616E646C6543616E63656C526573746F72653A746869732E68616E646C6543616E63656C526573746F72652C68616E646C65526571756573745468756D626E61696C3A746869732E68616E646C65526571756573745468756D626E6169';
wwv_flow_imp.g_varchar2_table(3021) := '6C2C68616E646C6543616E63656C5468756D626E61696C3A746869732E68616E646C6543616E63656C5468756D626E61696C2C69734472616767696E674F7665723A612E69734472616767696E674F7665722C68616E646C65447261674F7665723A7468';
wwv_flow_imp.g_varchar2_table(3022) := '69732E68616E646C65447261674F7665722C68616E646C65447261674C656176653A746869732E68616E646C65447261674C656176652C68616E646C6544726F703A746869732E68616E646C6544726F707D297D2C4F626A6563742E646566696E655072';
wwv_flow_imp.g_varchar2_table(3023) := '6F706572747928746869732C24642C7B7772697461626C653A21302C76616C75653A28293D3E7B28746869732E6F7074732E706C7567696E737C7C5B5D292E666F724561636828613D3E7B6C6574206C3D746869732E757070792E676574506C7567696E';
wwv_flow_imp.g_varchar2_table(3024) := '2861293B6C3F6C2E6D6F756E7428746869732C6C293A746869732E757070792E6C6F6728605B557070795D2044617368626F61726420636F756C64206E6F742066696E6420706C7567696E2027247B617D272C206D616B65207375726520746F20757070';
wwv_flow_imp.g_varchar2_table(3025) := '792E75736528292074686520706C7567696E7320796F75206172652073706563696679696E67602C227761726E696E6722297D297D7D292C4F626A6563742E646566696E6550726F706572747928746869732C71642C7B7772697461626C653A21302C76';
wwv_flow_imp.g_varchar2_table(3026) := '616C75653A28293D3E7B746869732E757070792E69746572617465506C7567696E7328546528746869732C4973295B49735D297D7D292C4F626A6563742E646566696E6550726F706572747928746869732C49732C7B7772697461626C653A21302C7661';
wwv_flow_imp.g_varchar2_table(3027) := '6C75653A6F3D3E7B76617220613B6C6574206C3D5B226163717569726572222C22656469746F72225D3B6F2626212828613D6F2E6F70747329213D6E756C6C2626612E7461726765742926266C2E696E636C75646573286F2E7479706529262628746869';
wwv_flow_imp.g_varchar2_table(3028) := '732E676574506C7567696E537461746528292E746172676574732E736F6D6528633D3E6F2E69643D3D3D632E6964297C7C6F2E6D6F756E7428746869732C6F29297D7D292C746869732E696E7374616C6C3D28293D3E7B746869732E736574506C756769';
wwv_flow_imp.g_varchar2_table(3029) := '6E5374617465287B697348696464656E3A21302C66696C6543617264466F723A6E756C6C2C6163746976654F7665726C6179547970653A6E756C6C2C73686F7741646446696C657350616E656C3A21312C6163746976655069636B657250616E656C3A21';
wwv_flow_imp.g_varchar2_table(3030) := '312C73686F7746696C65456469746F723A21312C6D6574614669656C64733A746869732E6F7074732E6D6574614669656C64732C746172676574733A5B5D2C617265496E73696465735265616479546F426556697369626C653A21312C69734472616767';
wwv_flow_imp.g_varchar2_table(3031) := '696E674F7665723A21317D293B6C65747B696E6C696E653A6F2C636C6F7365416674657246696E6973683A617D3D746869732E6F7074733B6966286F262661297468726F77206E6577204572726F7228225B44617368626F6172645D2060636C6F736541';
wwv_flow_imp.g_varchar2_table(3032) := '6674657246696E6973683A2074727565602063616E6E6F742062652075736564206F6E20616E20696E6C696E652044617368626F6172642C206265636175736520616E20696E6C696E652044617368626F6172642063616E6E6F7420626520636C6F7365';
wwv_flow_imp.g_varchar2_table(3033) := '6420617420616C6C2E20456974686572207365742060696E6C696E653A2066616C7365602C206F722064697361626C65207468652060636C6F7365416674657246696E69736860206F7074696F6E2E22293B6C65747B616C6C6F774D756C7469706C6555';
wwv_flow_imp.g_varchar2_table(3034) := '706C6F6164733A6C2C616C6C6F774D756C7469706C6555706C6F6164426174636865733A687D3D746869732E757070792E6F7074733B286C7C7C68292626612626746869732E757070792E6C6F6728225B44617368626F6172645D205768656E20757369';
wwv_flow_imp.g_varchar2_table(3035) := '6E672060636C6F7365416674657246696E697368602C207765207265636F6D6D656E6465642073657474696E67207468652060616C6C6F774D756C7469706C6555706C6F61644261746368657360206F7074696F6E20746F206066616C73656020696E20';
wwv_flow_imp.g_varchar2_table(3036) := '746865205570707920636F6E7374727563746F722E205365652068747470733A2F2F757070792E696F2F646F63732F757070792F23616C6C6F774D756C7469706C6555706C6F6164732D74727565222C227761726E696E6722293B6C65747B7461726765';
wwv_flow_imp.g_varchar2_table(3037) := '743A637D3D746869732E6F7074733B632626746869732E6D6F756E7428632C74686973292C746869732E6F7074732E64697361626C655374617475734261727C7C746869732E757070792E7573652824692C7B69643A60247B746869732E69647D3A5374';
wwv_flow_imp.g_varchar2_table(3038) := '61747573426172602C7461726765743A746869732C6869646555706C6F6164427574746F6E3A746869732E6F7074732E6869646555706C6F6164427574746F6E2C686964655265747279427574746F6E3A746869732E6F7074732E686964655265747279';
wwv_flow_imp.g_varchar2_table(3039) := '427574746F6E2C686964655061757365526573756D65427574746F6E3A746869732E6F7074732E686964655061757365526573756D65427574746F6E2C6869646543616E63656C427574746F6E3A746869732E6F7074732E6869646543616E63656C4275';
wwv_flow_imp.g_varchar2_table(3040) := '74746F6E2C73686F7750726F677265737344657461696C733A746869732E6F7074732E73686F7750726F677265737344657461696C732C68696465416674657246696E6973683A746869732E6F7074732E6869646550726F677265737341667465724669';
wwv_flow_imp.g_varchar2_table(3041) := '6E6973682C6C6F63616C653A746869732E6F7074732E6C6F63616C652C646F6E65427574746F6E48616E646C65723A746869732E6F7074732E646F6E65427574746F6E48616E646C65727D292C746869732E6F7074732E64697361626C65496E666F726D';
wwv_flow_imp.g_varchar2_table(3042) := '65727C7C746869732E757070792E7573652871692C7B69643A60247B746869732E69647D3A496E666F726D6572602C7461726765743A746869737D292C746869732E6F7074732E64697361626C655468756D626E61696C47656E657261746F727C7C7468';
wwv_flow_imp.g_varchar2_table(3043) := '69732E757070792E7573652843722C7B69643A60247B746869732E69647D3A5468756D626E61696C47656E657261746F72602C7468756D626E61696C57696474683A746869732E6F7074732E7468756D626E61696C57696474682C7468756D626E61696C';
wwv_flow_imp.g_varchar2_table(3044) := '4865696768743A746869732E6F7074732E7468756D626E61696C4865696768742C7468756D626E61696C547970653A746869732E6F7074732E7468756D626E61696C547970652C77616974466F725468756D626E61696C734265666F726555706C6F6164';
wwv_flow_imp.g_varchar2_table(3045) := '3A746869732E6F7074732E77616974466F725468756D626E61696C734265666F726555706C6F61642C6C617A793A21746869732E6F7074732E77616974466F725468756D626E61696C734265666F726555706C6F61647D292C746869732E6461726B4D6F';
wwv_flow_imp.g_varchar2_table(3046) := '64654D6564696151756572793D747970656F662077696E646F773C227522262677696E646F772E6D617463684D656469613F77696E646F772E6D617463684D65646961282228707265666572732D636F6C6F722D736368656D653A206461726B2922293A';
wwv_flow_imp.g_varchar2_table(3047) := '6E756C6C3B6C657420643D746869732E6461726B4D6F64654D6564696151756572793F746869732E6461726B4D6F64654D6564696151756572792E6D6174636865733A21313B746869732E757070792E6C6F6728605B44617368626F6172645D20446172';
wwv_flow_imp.g_varchar2_table(3048) := '6B206D6F646520697320247B643F226F6E223A226F6666227D60292C746869732E7365744461726B4D6F64654361706162696C6974792864292C746869732E6F7074732E7468656D653D3D3D226175746F222626746869732E6461726B4D6F64654D6564';
wwv_flow_imp.g_varchar2_table(3049) := '696151756572792E6164644C697374656E657228746869732E68616E646C6553797374656D4461726B4D6F64654368616E6765292C546528746869732C2464295B24645D28292C546528746869732C7164295B71645D28292C746869732E696E69744576';
wwv_flow_imp.g_varchar2_table(3050) := '656E747328297D2C746869732E756E696E7374616C6C3D28293D3E7B69662821746869732E6F7074732E64697361626C65496E666F726D6572297B6C657420613D746869732E757070792E676574506C7567696E2860247B746869732E69647D3A496E66';
wwv_flow_imp.g_varchar2_table(3051) := '6F726D657260293B612626746869732E757070792E72656D6F7665506C7567696E2861297D69662821746869732E6F7074732E64697361626C65537461747573426172297B6C657420613D746869732E757070792E676574506C7567696E2860247B7468';
wwv_flow_imp.g_varchar2_table(3052) := '69732E69647D3A53746174757342617260293B612626746869732E757070792E72656D6F7665506C7567696E2861297D69662821746869732E6F7074732E64697361626C655468756D626E61696C47656E657261746F72297B6C657420613D746869732E';
wwv_flow_imp.g_varchar2_table(3053) := '757070792E676574506C7567696E2860247B746869732E69647D3A5468756D626E61696C47656E657261746F7260293B612626746869732E757070792E72656D6F7665506C7567696E2861297D28746869732E6F7074732E706C7567696E737C7C5B5D29';
wwv_flow_imp.g_varchar2_table(3054) := '2E666F724561636828613D3E7B6C6574206C3D746869732E757070792E676574506C7567696E2861293B6C26266C2E756E6D6F756E7428297D292C746869732E6F7074732E7468656D653D3D3D226175746F222626746869732E6461726B4D6F64654D65';
wwv_flow_imp.g_varchar2_table(3055) := '64696151756572792E72656D6F76654C697374656E657228746869732E68616E646C6553797374656D4461726B4D6F64654368616E6765292C746869732E6F7074732E64697361626C65506167655363726F6C6C5768656E4D6F64616C4F70656E262664';
wwv_flow_imp.g_varchar2_table(3056) := '6F63756D656E742E626F64792E636C6173734C6973742E72656D6F76652822757070792D44617368626F6172642D6973466978656422292C746869732E756E6D6F756E7428292C746869732E72656D6F76654576656E747328297D2C746869732E69643D';
wwv_flow_imp.g_varchar2_table(3057) := '746869732E6F7074732E69647C7C2244617368626F617264222C746869732E7469746C653D2244617368626F617264222C746869732E747970653D226F7263686573747261746F72222C746869732E6D6F64616C4E616D653D60757070792D4461736862';
wwv_flow_imp.g_varchar2_table(3058) := '6F6172642D247B507428297D602C746869732E64656661756C744C6F63616C653D4F793B6C657420733D7B7461726765743A22626F6479222C6D6574614669656C64733A5B5D2C747269676765723A6E756C6C2C696E6C696E653A21312C77696474683A';
wwv_flow_imp.g_varchar2_table(3059) := '3735302C6865696768743A3535302C7468756D626E61696C57696474683A3238302C7468756D626E61696C547970653A22696D6167652F6A706567222C77616974466F725468756D626E61696C734265666F726555706C6F61643A21312C64656661756C';
wwv_flow_imp.g_varchar2_table(3060) := '745069636B657249636F6E3A6B6F2C73686F774C696E6B546F46696C6555706C6F6164526573756C743A21312C73686F7750726F677265737344657461696C733A21312C6869646555706C6F6164427574746F6E3A21312C6869646543616E63656C4275';
wwv_flow_imp.g_varchar2_table(3061) := '74746F6E3A21312C686964655265747279427574746F6E3A21312C686964655061757365526573756D65427574746F6E3A21312C6869646550726F6772657373416674657246696E6973683A21312C646F6E65427574746F6E48616E646C65723A28293D';
wwv_flow_imp.g_varchar2_table(3062) := '3E7B746869732E757070792E636C65617255706C6F6164656446696C657328292C746869732E72657175657374436C6F73654D6F64616C28297D2C6E6F74653A6E756C6C2C636C6F73654D6F64616C4F6E436C69636B4F7574736964653A21312C636C6F';
wwv_flow_imp.g_varchar2_table(3063) := '7365416674657246696E6973683A21312C73696E676C6546696C6546756C6C53637265656E3A21302C64697361626C655374617475734261723A21312C64697361626C65496E666F726D65723A21312C64697361626C655468756D626E61696C47656E65';
wwv_flow_imp.g_varchar2_table(3064) := '7261746F723A21312C64697361626C65506167655363726F6C6C5768656E4D6F64616C4F70656E3A21302C616E696D6174654F70656E436C6F73653A21302C66696C654D616E6167657253656C656374696F6E547970653A2266696C6573222C70726F75';
wwv_flow_imp.g_varchar2_table(3065) := '646C79446973706C6179506F77657265644279557070793A21302C6F6E52657175657374436C6F73654D6F64616C3A28293D3E746869732E636C6F73654D6F64616C28292C73686F7753656C656374656446696C65733A21302C73686F7752656D6F7665';
wwv_flow_imp.g_varchar2_table(3066) := '427574746F6E4166746572436F6D706C6574653A21312C62726F777365724261636B427574746F6E436C6F73653A21312C73686F774E617469766550686F746F43616D657261427574746F6E3A21312C73686F774E6174697665566964656F43616D6572';
wwv_flow_imp.g_varchar2_table(3067) := '61427574746F6E3A21312C7468656D653A226C69676874222C6175746F4F70656E46696C65456469746F723A21312C64697361626C65643A21312C64697361626C654C6F63616C46696C65733A21317D3B746869732E6F7074733D7B2E2E2E732C2E2E2E';
wwv_flow_imp.g_varchar2_table(3068) := '747D2C746869732E6931386E496E697428292C746869732E7375706572466F6375733D456428292C746869732E6966466F63757365644F6E55707079526563656E746C793D21312C746869732E6D616B6544617368626F617264496E7369646573566973';
wwv_flow_imp.g_varchar2_table(3069) := '69626C65416E7977617954696D656F75743D6E756C6C2C746869732E72656D6F7665447261674F766572436C61737354696D656F75743D6E756C6C7D7D3B6E2874732C2244617368626F61726422293B74732E56455253494F4E3D6B532E76657273696F';
wwv_flow_imp.g_varchar2_table(3070) := '6E3B7661722052793D7B737472696E67733A7B64726F70486572654F723A2244726F702068657265206F7220257B62726F7773657D222C62726F7773653A2262726F777365227D7D3B7661722049533D7B76657273696F6E3A22332E302E33227D2C4769';
wwv_flow_imp.g_varchar2_table(3071) := '3D636C61737320657874656E6473205A7B636F6E7374727563746F7228652C74297B737570657228652C74292C746869732E68616E646C6544726F703D6173796E6320733D3E7B766172206F2C613B732E70726576656E7444656661756C7428292C732E';
wwv_flow_imp.g_varchar2_table(3072) := '73746F7050726F7061676174696F6E28292C636C65617254696D656F757428746869732E72656D6F7665447261674F766572436C61737354696D656F7574292C746869732E736574506C7567696E5374617465287B69734472616767696E674F7665723A';
wwv_flow_imp.g_varchar2_table(3073) := '21317D293B6C6574206C3D6E28633D3E7B746869732E757070792E6C6F6728632C226572726F7222297D2C226C6F6744726F704572726F7222292C683D617761697420417328732E646174615472616E736665722C7B6C6F6744726F704572726F723A6C';
wwv_flow_imp.g_varchar2_table(3074) := '7D293B682E6C656E6774683E30262628746869732E757070792E6C6F6728225B4472616744726F705D2046696C65732064726F7070656422292C746869732E61646446696C6573286829292C286F3D28613D746869732E6F707473292E6F6E44726F7029';
wwv_flow_imp.g_varchar2_table(3075) := '3D3D6E756C6C7C7C6F2E63616C6C28612C73297D2C746869732E747970653D226163717569726572222C746869732E69643D746869732E6F7074732E69647C7C224472616744726F70222C746869732E7469746C653D224472616720262044726F70222C';
wwv_flow_imp.g_varchar2_table(3076) := '746869732E64656661756C744C6F63616C653D52793B6C657420723D7B7461726765743A6E756C6C2C696E7075744E616D653A2266696C65735B5D222C77696474683A2231303025222C6865696768743A2231303025222C6E6F74653A6E756C6C7D3B74';
wwv_flow_imp.g_varchar2_table(3077) := '6869732E6F7074733D7B2E2E2E722C2E2E2E747D2C746869732E6931386E496E697428292C746869732E69734472616744726F70537570706F727465643D706128292C746869732E72656D6F7665447261674F766572436C61737354696D656F75743D6E';
wwv_flow_imp.g_varchar2_table(3078) := '756C6C2C746869732E6F6E496E7075744368616E67653D746869732E6F6E496E7075744368616E67652E62696E642874686973292C746869732E68616E646C65447261674F7665723D746869732E68616E646C65447261674F7665722E62696E64287468';
wwv_flow_imp.g_varchar2_table(3079) := '6973292C746869732E68616E646C65447261674C656176653D746869732E68616E646C65447261674C656176652E62696E642874686973292C746869732E68616E646C6544726F703D746869732E68616E646C6544726F702E62696E642874686973292C';
wwv_flow_imp.g_varchar2_table(3080) := '746869732E61646446696C65733D746869732E61646446696C65732E62696E642874686973292C746869732E72656E6465723D746869732E72656E6465722E62696E642874686973297D61646446696C65732865297B6C657420743D652E6D617028723D';
wwv_flow_imp.g_varchar2_table(3081) := '3E287B736F757263653A746869732E69642C6E616D653A722E6E616D652C747970653A722E747970652C646174613A722C6D6574613A7B72656C6174697665506174683A722E72656C6174697665506174687C7C6E756C6C7D7D29293B7472797B746869';
wwv_flow_imp.g_varchar2_table(3082) := '732E757070792E61646446696C65732874297D63617463682872297B746869732E757070792E6C6F672872297D7D6F6E496E7075744368616E67652865297B6C657420743D516528652E7461726765742E66696C6573293B742E6C656E6774683E302626';
wwv_flow_imp.g_varchar2_table(3083) := '28746869732E757070792E6C6F6728225B4472616744726F705D2046696C65732073656C6563746564207468726F75676820696E70757422292C746869732E61646446696C6573287429292C652E7461726765742E76616C75653D6E756C6C7D68616E64';
wwv_flow_imp.g_varchar2_table(3084) := '6C65447261674F7665722865297B76617220742C723B652E70726576656E7444656661756C7428292C652E73746F7050726F7061676174696F6E28293B6C65747B74797065733A737D3D652E646174615472616E736665722C6F3D732E736F6D65286C3D';
wwv_flow_imp.g_varchar2_table(3085) := '3E6C3D3D3D2246696C657322292C7B616C6C6F774E657755706C6F61643A617D3D746869732E757070792E676574537461746528293B696628216F7C7C2161297B652E646174615472616E736665722E64726F704566666563743D226E6F6E65222C636C';
wwv_flow_imp.g_varchar2_table(3086) := '65617254696D656F757428746869732E72656D6F7665447261674F766572436C61737354696D656F7574293B72657475726E7D652E646174615472616E736665722E64726F704566666563743D22636F7079222C636C65617254696D656F757428746869';
wwv_flow_imp.g_varchar2_table(3087) := '732E72656D6F7665447261674F766572436C61737354696D656F7574292C746869732E736574506C7567696E5374617465287B69734472616767696E674F7665723A21307D292C28743D28723D746869732E6F707473292E6F6E447261674F766572293D';
wwv_flow_imp.g_varchar2_table(3088) := '3D6E756C6C7C7C742E63616C6C28722C65297D68616E646C65447261674C656176652865297B76617220742C723B652E70726576656E7444656661756C7428292C652E73746F7050726F7061676174696F6E28292C636C65617254696D656F7574287468';
wwv_flow_imp.g_varchar2_table(3089) := '69732E72656D6F7665447261674F766572436C61737354696D656F7574292C746869732E72656D6F7665447261674F766572436C61737354696D656F75743D73657454696D656F75742828293D3E7B746869732E736574506C7567696E5374617465287B';
wwv_flow_imp.g_varchar2_table(3090) := '69734472616767696E674F7665723A21317D297D2C3530292C28743D28723D746869732E6F707473292E6F6E447261674C65617665293D3D6E756C6C7C7C742E63616C6C28722C65297D72656E64657248696464656E46696C65496E70757428297B6C65';
wwv_flow_imp.g_varchar2_table(3091) := '747B7265737472696374696F6E733A657D3D746869732E757070792E6F7074733B72657475726E20752822696E707574222C7B636C6173734E616D653A22757070792D4472616744726F702D696E707574222C747970653A2266696C65222C6869646465';
wwv_flow_imp.g_varchar2_table(3092) := '6E3A21302C7265663A743D3E7B746869732E66696C65496E7075745265663D747D2C6E616D653A746869732E6F7074732E696E7075744E616D652C6D756C7469706C653A652E6D61784E756D6265724F6646696C6573213D3D312C6163636570743A652E';
wwv_flow_imp.g_varchar2_table(3093) := '616C6C6F77656446696C6554797065732C6F6E4368616E67653A746869732E6F6E496E7075744368616E67657D297D7374617469632072656E6465724172726F7753766728297B72657475726E20752822737667222C7B22617269612D68696464656E22';
wwv_flow_imp.g_varchar2_table(3094) := '3A2274727565222C666F63757361626C653A2266616C7365222C636C6173734E616D653A22757070792D632D69636F6E20757070792D4472616744726F702D6172726F77222C77696474683A223136222C6865696768743A223136222C76696577426F78';
wwv_flow_imp.g_varchar2_table(3095) := '3A22302030203136203136227D2C75282270617468222C7B643A224D31312031305630483576313048326C36203620362D36682D337A6D302030222C66696C6C52756C653A226576656E6F6464227D29297D72656E6465724C6162656C28297B72657475';
wwv_flow_imp.g_varchar2_table(3096) := '726E20752822646976222C7B636C6173734E616D653A22757070792D4472616744726F702D6C6162656C227D2C746869732E6931386E4172726179282264726F70486572654F72222C7B62726F7773653A7528227370616E222C7B636C6173734E616D65';
wwv_flow_imp.g_varchar2_table(3097) := '3A22757070792D4472616744726F702D62726F777365227D2C746869732E6931386E282262726F7773652229297D29297D72656E6465724E6F746528297B72657475726E207528227370616E222C7B636C6173734E616D653A22757070792D4472616744';
wwv_flow_imp.g_varchar2_table(3098) := '726F702D6E6F7465227D2C746869732E6F7074732E6E6F7465297D72656E64657228297B6C657420653D60757070792D752D72657365740A202020202020757070792D4472616744726F702D636F6E7461696E65720A202020202020247B746869732E69';
wwv_flow_imp.g_varchar2_table(3099) := '734472616744726F70537570706F727465643F22757070792D4472616744726F702D2D69734472616744726F70537570706F72746564223A22227D0A202020202020247B746869732E676574506C7567696E537461746528292E69734472616767696E67';
wwv_flow_imp.g_varchar2_table(3100) := '4F7665723F22757070792D4472616744726F702D2D69734472616767696E674F766572223A22227D0A20202020602C743D7B77696474683A746869732E6F7074732E77696474682C6865696768743A746869732E6F7074732E6865696768747D3B726574';
wwv_flow_imp.g_varchar2_table(3101) := '75726E20752822627574746F6E222C7B747970653A22627574746F6E222C636C6173734E616D653A652C7374796C653A742C6F6E436C69636B3A28293D3E746869732E66696C65496E7075745265662E636C69636B28292C6F6E447261674F7665723A74';
wwv_flow_imp.g_varchar2_table(3102) := '6869732E68616E646C65447261674F7665722C6F6E447261674C656176653A746869732E68616E646C65447261674C656176652C6F6E44726F703A746869732E68616E646C6544726F707D2C746869732E72656E64657248696464656E46696C65496E70';
wwv_flow_imp.g_varchar2_table(3103) := '757428292C752822646976222C7B636C6173734E616D653A22757070792D4472616744726F702D696E6E6572227D2C47692E72656E6465724172726F7753766728292C746869732E72656E6465724C6162656C28292C746869732E72656E6465724E6F74';
wwv_flow_imp.g_varchar2_table(3104) := '65282929297D696E7374616C6C28297B6C65747B7461726765743A657D3D746869732E6F7074733B746869732E736574506C7567696E5374617465287B69734472616767696E674F7665723A21317D292C652626746869732E6D6F756E7428652C746869';
wwv_flow_imp.g_varchar2_table(3105) := '73297D756E696E7374616C6C28297B746869732E756E6D6F756E7428297D7D3B6E2847692C224472616744726F7022293B47692E56455253494F4E3D49532E76657273696F6E3B766172204D533D7B76657273696F6E3A22322E302E32227D3B66756E63';
wwv_flow_imp.g_varchar2_table(3106) := '74696F6E2056642869297B76617220652C743B72657475726E28653D28743D692E646174615472616E736665722E7479706573293D3D6E756C6C3F766F696420303A742E736F6D6528723D3E723D3D3D2246696C6573222929213D6E756C6C3F653A2131';
wwv_flow_imp.g_varchar2_table(3107) := '7D6E2856642C22697346696C655472616E7366657222293B766172204D733D636C61737320657874656E64732076657B636F6E7374727563746F7228652C74297B737570657228652C74292C746869732E61646446696C65733D733D3E7B6C6574206F3D';
wwv_flow_imp.g_varchar2_table(3108) := '732E6D617028613D3E287B736F757263653A746869732E69642C6E616D653A612E6E616D652C747970653A612E747970652C646174613A612C6D6574613A7B72656C6174697665506174683A612E72656C6174697665506174687C7C6E756C6C7D7D2929';
wwv_flow_imp.g_varchar2_table(3109) := '3B7472797B746869732E757070792E61646446696C6573286F297D63617463682861297B746869732E757070792E6C6F672861297D7D2C746869732E68616E646C6544726F703D6173796E6320733D3E7B766172206F2C613B6966282156642873292972';
wwv_flow_imp.g_varchar2_table(3110) := '657475726E3B732E70726576656E7444656661756C7428292C732E73746F7050726F7061676174696F6E28292C636C65617254696D656F757428746869732E72656D6F7665447261674F766572436C61737354696D656F7574292C732E63757272656E74';
wwv_flow_imp.g_varchar2_table(3111) := '5461726765742E636C6173734C6973742E72656D6F76652822757070792D69732D647261672D6F76657222292C746869732E736574506C7567696E5374617465287B69734472616767696E674F7665723A21317D292C746869732E757070792E69746572';
wwv_flow_imp.g_varchar2_table(3112) := '617465506C7567696E7328643D3E7B642E747970653D3D3D22616371756972657222262628642E68616E646C65526F6F7444726F703D3D6E756C6C7C7C642E68616E646C65526F6F7444726F70287329297D293B6C6574206C3D21312C683D6E28643D3E';
wwv_flow_imp.g_varchar2_table(3113) := '7B746869732E757070792E6C6F6728642C226572726F7222292C6C7C7C28746869732E757070792E696E666F28642E6D6573736167652C226572726F7222292C6C3D2130297D2C226C6F6744726F704572726F7222292C633D617761697420417328732E';
wwv_flow_imp.g_varchar2_table(3114) := '646174615472616E736665722C7B6C6F6744726F704572726F723A687D293B632E6C656E6774683E30262628746869732E757070792E6C6F6728225B44726F705461726765745D2046696C657320776572652064726F7070656422292C746869732E6164';
wwv_flow_imp.g_varchar2_table(3115) := '6446696C6573286329292C286F3D28613D746869732E6F707473292E6F6E44726F70293D3D6E756C6C7C7C6F2E63616C6C28612C73297D2C746869732E68616E646C65447261674F7665723D733D3E7B766172206F2C613B5664287329262628732E7072';
wwv_flow_imp.g_varchar2_table(3116) := '6576656E7444656661756C7428292C732E73746F7050726F7061676174696F6E28292C732E646174615472616E736665722E64726F704566666563743D22636F7079222C636C65617254696D656F757428746869732E72656D6F7665447261674F766572';
wwv_flow_imp.g_varchar2_table(3117) := '436C61737354696D656F7574292C732E63757272656E745461726765742E636C6173734C6973742E6164642822757070792D69732D647261672D6F76657222292C746869732E736574506C7567696E5374617465287B69734472616767696E674F766572';
wwv_flow_imp.g_varchar2_table(3118) := '3A21307D292C286F3D28613D746869732E6F707473292E6F6E447261674F766572293D3D6E756C6C7C7C6F2E63616C6C28612C7329297D2C746869732E68616E646C65447261674C656176653D733D3E7B766172206F2C613B6966282156642873292972';
wwv_flow_imp.g_varchar2_table(3119) := '657475726E3B732E70726576656E7444656661756C7428292C732E73746F7050726F7061676174696F6E28293B6C65747B63757272656E745461726765743A6C7D3D733B636C65617254696D656F757428746869732E72656D6F7665447261674F766572';
wwv_flow_imp.g_varchar2_table(3120) := '436C61737354696D656F7574292C746869732E72656D6F7665447261674F766572436C61737354696D656F75743D73657454696D656F75742828293D3E7B6C2E636C6173734C6973742E72656D6F76652822757070792D69732D647261672D6F76657222';
wwv_flow_imp.g_varchar2_table(3121) := '292C746869732E736574506C7567696E5374617465287B69734472616767696E674F7665723A21317D297D2C3530292C286F3D28613D746869732E6F707473292E6F6E447261674C65617665293D3D6E756C6C7C7C6F2E63616C6C28612C73297D2C7468';
wwv_flow_imp.g_varchar2_table(3122) := '69732E6164644C697374656E6572733D28293D3E7B6C65747B7461726765743A737D3D746869732E6F7074733B6966287320696E7374616E63656F6620456C656D656E743F746869732E6E6F6465733D5B735D3A747970656F6620733D3D22737472696E';
wwv_flow_imp.g_varchar2_table(3123) := '6722262628746869732E6E6F6465733D516528646F63756D656E742E717565727953656C6563746F72416C6C28732929292C21746869732E6E6F646573262621746869732E6E6F6465732E6C656E6774683E30297468726F77206E6577204572726F7228';
wwv_flow_imp.g_varchar2_table(3124) := '6022247B737D2220646F6573206E6F74206D6174636820616E792048544D4C20656C656D656E747360293B746869732E6E6F6465732E666F7245616368286F3D3E7B6F2E6164644576656E744C697374656E65722822647261676F766572222C74686973';
wwv_flow_imp.g_varchar2_table(3125) := '2E68616E646C65447261674F7665722C2131292C6F2E6164644576656E744C697374656E65722822647261676C65617665222C746869732E68616E646C65447261674C656176652C2131292C6F2E6164644576656E744C697374656E6572282264726F70';
wwv_flow_imp.g_varchar2_table(3126) := '222C746869732E68616E646C6544726F702C2131297D297D2C746869732E72656D6F76654C697374656E6572733D28293D3E7B746869732E6E6F6465732626746869732E6E6F6465732E666F724561636828733D3E7B732E72656D6F76654576656E744C';
wwv_flow_imp.g_varchar2_table(3127) := '697374656E65722822647261676F766572222C746869732E68616E646C65447261674F7665722C2131292C732E72656D6F76654576656E744C697374656E65722822647261676C65617665222C746869732E68616E646C65447261674C656176652C2131';
wwv_flow_imp.g_varchar2_table(3128) := '292C732E72656D6F76654576656E744C697374656E6572282264726F70222C746869732E68616E646C6544726F702C2131297D297D2C746869732E747970653D226163717569726572222C746869732E69643D746869732E6F7074732E69647C7C224472';
wwv_flow_imp.g_varchar2_table(3129) := '6F70546172676574222C746869732E7469746C653D2244726F7020546172676574223B6C657420723D7B7461726765743A6E756C6C7D3B746869732E6F7074733D7B2E2E2E722C2E2E2E747D2C746869732E72656D6F7665447261674F766572436C6173';
wwv_flow_imp.g_varchar2_table(3130) := '7354696D656F75743D6E756C6C7D696E7374616C6C28297B746869732E736574506C7567696E5374617465287B69734472616767696E674F7665723A21317D292C746869732E6164644C697374656E65727328297D756E696E7374616C6C28297B746869';
wwv_flow_imp.g_varchar2_table(3131) := '732E72656D6F76654C697374656E65727328297D7D3B6E284D732C2244726F7054617267657422293B4D732E56455253494F4E3D4D532E76657273696F6E3B7661722055793D7B737472696E67733A7B63686F6F736546696C65733A2243686F6F736520';
wwv_flow_imp.g_varchar2_table(3132) := '66696C6573227D7D3B766172204E533D7B76657273696F6E3A22332E302E34227D2C69733D636C61737320657874656E6473205A7B636F6E7374727563746F7228652C74297B737570657228652C74292C746869732E69643D746869732E6F7074732E69';
wwv_flow_imp.g_varchar2_table(3133) := '647C7C2246696C65496E707574222C746869732E7469746C653D2246696C6520496E707574222C746869732E747970653D226163717569726572222C746869732E64656661756C744C6F63616C653D55793B6C657420723D7B7461726765743A6E756C6C';
wwv_flow_imp.g_varchar2_table(3134) := '2C7072657474793A21302C696E7075744E616D653A2266696C65735B5D227D3B746869732E6F7074733D7B2E2E2E722C2E2E2E747D2C746869732E6931386E496E697428292C746869732E72656E6465723D746869732E72656E6465722E62696E642874';
wwv_flow_imp.g_varchar2_table(3135) := '686973292C746869732E68616E646C65496E7075744368616E67653D746869732E68616E646C65496E7075744368616E67652E62696E642874686973292C746869732E68616E646C65436C69636B3D746869732E68616E646C65436C69636B2E62696E64';
wwv_flow_imp.g_varchar2_table(3136) := '2874686973297D61646446696C65732865297B6C657420743D652E6D617028723D3E287B736F757263653A746869732E69642C6E616D653A722E6E616D652C747970653A722E747970652C646174613A727D29293B7472797B746869732E757070792E61';
wwv_flow_imp.g_varchar2_table(3137) := '646446696C65732874297D63617463682872297B746869732E757070792E6C6F672872297D7D68616E646C65496E7075744368616E67652865297B746869732E757070792E6C6F6728225B46696C65496E7075745D20536F6D657468696E672073656C65';
wwv_flow_imp.g_varchar2_table(3138) := '63746564207468726F75676820696E7075742E2E2E22293B6C657420743D516528652E7461726765742E66696C6573293B746869732E61646446696C65732874292C652E7461726765742E76616C75653D6E756C6C7D68616E646C65436C69636B28297B';
wwv_flow_imp.g_varchar2_table(3139) := '746869732E696E7075742E636C69636B28297D72656E64657228297B6C657420653D7B77696474683A22302E317078222C6865696768743A22302E317078222C6F7061636974793A302C6F766572666C6F773A2268696464656E222C706F736974696F6E';
wwv_flow_imp.g_varchar2_table(3140) := '3A226162736F6C757465222C7A496E6465783A2D317D2C7B7265737472696374696F6E733A747D3D746869732E757070792E6F7074732C723D742E616C6C6F77656446696C6554797065733F742E616C6C6F77656446696C6554797065732E6A6F696E28';
wwv_flow_imp.g_varchar2_table(3141) := '222C22293A6E756C6C3B72657475726E20752822646976222C7B636C6173734E616D653A22757070792D46696C65496E7075742D636F6E7461696E6572227D2C752822696E707574222C7B636C6173734E616D653A22757070792D46696C65496E707574';
wwv_flow_imp.g_varchar2_table(3142) := '2D696E707574222C7374796C653A746869732E6F7074732E7072657474792626652C747970653A2266696C65222C6E616D653A746869732E6F7074732E696E7075744E616D652C6F6E4368616E67653A746869732E68616E646C65496E7075744368616E';
wwv_flow_imp.g_varchar2_table(3143) := '67652C6D756C7469706C653A742E6D61784E756D6265724F6646696C6573213D3D312C6163636570743A722C7265663A733D3E7B746869732E696E7075743D737D7D292C746869732E6F7074732E7072657474792626752822627574746F6E222C7B636C';
wwv_flow_imp.g_varchar2_table(3144) := '6173734E616D653A22757070792D46696C65496E7075742D62746E222C747970653A22627574746F6E222C6F6E436C69636B3A746869732E68616E646C65436C69636B7D2C746869732E6931386E282263686F6F736546696C6573222929297D696E7374';
wwv_flow_imp.g_varchar2_table(3145) := '616C6C28297B6C65747B7461726765743A657D3D746869732E6F7074733B652626746869732E6D6F756E7428652C74686973297D756E696E7374616C6C28297B746869732E756E6D6F756E7428297D7D3B6E2869732C2246696C65496E70757422293B69';
wwv_flow_imp.g_varchar2_table(3146) := '732E56455253494F4E3D4E532E76657273696F6E3B766172204C793D6465286B7928292C31293B66756E6374696F6E204C5328692C65297B6C657420743D692E77696474682F652E77696474682C723D692E6865696768742F652E6865696768742C733D';
wwv_flow_imp.g_varchar2_table(3147) := '4D6174682E6D696E28742C72292C6F3D652E77696474682A732C613D652E6865696768742A732C6C3D28692E77696474682D6F292F322C683D28692E6865696768742D61292F323B72657475726E7B77696474683A6F2C6865696768743A612C6C656674';
wwv_flow_imp.g_varchar2_table(3148) := '3A6C2C746F703A687D7D6E284C532C2267657443616E766173446174615468617446697473506572666563746C79496E746F436F6E7461696E657222293B7661722044793D4C533B66756E6374696F6E2042532869297B72657475726E20692A284D6174';
wwv_flow_imp.g_varchar2_table(3149) := '682E50492F313830297D6E2842532C22746F52616469616E7322293B66756E6374696F6E207A5328692C652C74297B6C657420723D4D6174682E616273284253287429293B72657475726E204D6174682E6D617828284D6174682E73696E2872292A692B';
wwv_flow_imp.g_varchar2_table(3150) := '4D6174682E636F732872292A65292F652C284D6174682E73696E2872292A652B4D6174682E636F732872292A69292F69297D6E287A532C226765745363616C65466163746F725468617452656D6F7665734461726B436F726E65727322293B7661722049';
wwv_flow_imp.g_varchar2_table(3151) := '793D7A533B66756E6374696F6E206A5328692C652C74297B72657475726E20652E6C6566743C692E6C6566743F7B6C6566743A692E6C6566742C77696474683A742E77696474687D3A652E746F703C692E746F703F7B746F703A692E746F702C68656967';
wwv_flow_imp.g_varchar2_table(3152) := '68743A742E6865696768747D3A652E6C6566742B652E77696474683E692E6C6566742B692E77696474683F7B6C6566743A692E6C6566742B692E77696474682D742E77696474682C77696474683A742E77696474687D3A652E746F702B652E6865696768';
wwv_flow_imp.g_varchar2_table(3153) := '743E692E746F702B692E6865696768743F7B746F703A692E746F702B692E6865696768742D742E6865696768742C6865696768743A742E6865696768747D3A6E756C6C7D6E286A532C226C696D697443726F70626F784D6F76656D656E744F6E4D6F7665';
wwv_flow_imp.g_varchar2_table(3154) := '22293B766172204D793D6A533B66756E6374696F6E20485328692C652C74297B72657475726E20652E6C6566743C692E6C6566743F7B6C6566743A692E6C6566742C77696474683A742E6C6566742B742E77696474682D692E6C6566747D3A652E746F70';
wwv_flow_imp.g_varchar2_table(3155) := '3C692E746F703F7B746F703A692E746F702C6865696768743A742E746F702B742E6865696768742D692E746F707D3A652E6C6566742B652E77696474683E692E6C6566742B692E77696474683F7B6C6566743A742E6C6566742C77696474683A692E6C65';
wwv_flow_imp.g_varchar2_table(3156) := '66742B692E77696474682D742E6C6566747D3A652E746F702B652E6865696768743E692E746F702B692E6865696768743F7B746F703A742E746F702C6865696768743A692E746F702B692E6865696768742D742E746F707D3A6E756C6C7D6E2848532C22';
wwv_flow_imp.g_varchar2_table(3157) := '6C696D697443726F70626F784D6F76656D656E744F6E526573697A6522293B766172204E793D48533B76617220716F3D636C61737320657874656E64732077657B636F6E7374727563746F722865297B73757065722865292C746869732E6F6E526F7461';
wwv_flow_imp.g_varchar2_table(3158) := '746539304465673D28293D3E7B6C65747B616E676C6539304465673A747D3D746869732E73746174652C723D742D39303B746869732E7365745374617465287B616E676C6539304465673A722C616E676C654772616E756C61723A307D292C746869732E';
wwv_flow_imp.g_varchar2_table(3159) := '63726F707065722E7363616C652831292C746869732E63726F707065722E726F74617465546F2872293B6C657420733D746869732E63726F707065722E67657443616E7661734461746128292C6F3D746869732E63726F707065722E676574436F6E7461';
wwv_flow_imp.g_varchar2_table(3160) := '696E65724461746128292C613D4479286F2C73293B746869732E63726F707065722E73657443616E766173446174612861292C746869732E63726F707065722E73657443726F70426F78446174612861297D2C746869732E6F6E526F746174654772616E';
wwv_flow_imp.g_varchar2_table(3161) := '756C61723D743D3E7B6C657420723D4E756D62657228742E7461726765742E76616C7565293B746869732E7365745374617465287B616E676C654772616E756C61723A727D293B6C65747B616E676C6539304465673A737D3D746869732E73746174652C';
wwv_flow_imp.g_varchar2_table(3162) := '6F3D732B723B746869732E63726F707065722E726F74617465546F286F293B6C657420613D746869732E63726F707065722E676574496D6167654461746128292C6C3D497928612E6E61747572616C57696474682C612E6E61747572616C486569676874';
wwv_flow_imp.g_varchar2_table(3163) := '2C72292C683D746869732E63726F707065722E676574496D6167654461746128292E7363616C65583C303F2D6C3A6C3B746869732E63726F707065722E7363616C6528682C6C297D2C746869732E73746174653D7B616E676C6539304465673A302C616E';
wwv_flow_imp.g_varchar2_table(3164) := '676C654772616E756C61723A302C7072657643726F70626F78446174613A6E756C6C7D2C746869732E73746F72655072657643726F70626F78446174613D746869732E73746F72655072657643726F70626F78446174612E62696E642874686973292C74';
wwv_flow_imp.g_varchar2_table(3165) := '6869732E6C696D697443726F70626F784D6F76656D656E743D746869732E6C696D697443726F70626F784D6F76656D656E742E62696E642874686973297D636F6D706F6E656E744469644D6F756E7428297B6C65747B6F7074733A652C73746F72654372';
wwv_flow_imp.g_varchar2_table(3166) := '6F70706572496E7374616E63653A747D3D746869732E70726F70733B746869732E63726F707065723D6E6577204C792E64656661756C7428746869732E696D67456C656D656E742C652E63726F707065724F7074696F6E73292C746869732E696D67456C';
wwv_flow_imp.g_varchar2_table(3167) := '656D656E742E6164644576656E744C697374656E6572282263726F707374617274222C746869732E73746F72655072657643726F70626F7844617461292C746869732E696D67456C656D656E742E6164644576656E744C697374656E6572282263726F70';
wwv_flow_imp.g_varchar2_table(3168) := '656E64222C746869732E6C696D697443726F70626F784D6F76656D656E74292C7428746869732E63726F70706572297D636F6D706F6E656E7457696C6C556E6D6F756E7428297B746869732E63726F707065722E64657374726F7928292C746869732E69';
wwv_flow_imp.g_varchar2_table(3169) := '6D67456C656D656E742E72656D6F76654576656E744C697374656E6572282263726F707374617274222C746869732E73746F72655072657643726F70626F7844617461292C746869732E696D67456C656D656E742E72656D6F76654576656E744C697374';
wwv_flow_imp.g_varchar2_table(3170) := '656E6572282263726F70656E64222C746869732E6C696D697443726F70626F784D6F76656D656E74297D73746F72655072657643726F70626F784461746128297B746869732E7365745374617465287B7072657643726F70626F78446174613A74686973';
wwv_flow_imp.g_varchar2_table(3171) := '2E63726F707065722E67657443726F70426F784461746128297D297D6C696D697443726F70626F784D6F76656D656E742865297B6C657420743D746869732E63726F707065722E67657443616E7661734461746128292C723D746869732E63726F707065';
wwv_flow_imp.g_varchar2_table(3172) := '722E67657443726F70426F784461746128292C7B7072657643726F70626F78446174613A737D3D746869732E73746174653B696628652E64657461696C2E616374696F6E3D3D3D22616C6C22297B6C6574206F3D4D7928742C722C73293B6F2626746869';
wwv_flow_imp.g_varchar2_table(3173) := '732E63726F707065722E73657443726F70426F7844617461286F297D656C73657B6C6574206F3D4E7928742C722C73293B6F2626746869732E63726F707065722E73657443726F70426F7844617461286F297D7D72656E6465724772616E756C6172526F';
wwv_flow_imp.g_varchar2_table(3174) := '7461746528297B6C65747B6931386E3A657D3D746869732E70726F70732C7B616E676C654772616E756C61723A747D3D746869732E73746174653B72657475726E207528226C6162656C222C7B726F6C653A22746F6F6C746970222C22617269612D6C61';
wwv_flow_imp.g_varchar2_table(3175) := '62656C223A60247B747D5C784241602C22646174612D6D6963726F7469702D706F736974696F6E223A22746F70222C636C6173734E616D653A22757070792D496D61676543726F707065722D72616E676557726170706572227D2C752822696E70757422';
wwv_flow_imp.g_varchar2_table(3176) := '2C7B636C6173734E616D653A22757070792D496D61676543726F707065722D72616E676520757070792D752D7265736574222C747970653A2272616E6765222C6F6E496E7075743A746869732E6F6E526F746174654772616E756C61722C6F6E4368616E';
wwv_flow_imp.g_varchar2_table(3177) := '67653A746869732E6F6E526F746174654772616E756C61722C76616C75653A742C6D696E3A222D3435222C6D61783A223435222C22617269612D6C6162656C223A652822726F7461746522297D29297D72656E64657252657665727428297B6C65747B69';
wwv_flow_imp.g_varchar2_table(3178) := '31386E3A652C6F7074733A747D3D746869732E70726F70733B72657475726E207528226C6162656C222C7B726F6C653A22746F6F6C746970222C22617269612D6C6162656C223A65282272657665727422292C22646174612D6D6963726F7469702D706F';
wwv_flow_imp.g_varchar2_table(3179) := '736974696F6E223A22746F70227D2C752822627574746F6E222C7B747970653A22627574746F6E222C636C6173734E616D653A22757070792D752D726573657420757070792D632D62746E222C6F6E436C69636B3A28293D3E7B746869732E63726F7070';
wwv_flow_imp.g_varchar2_table(3180) := '65722E726573657428292C746869732E63726F707065722E736574417370656374526174696F28742E63726F707065724F7074696F6E732E696E697469616C417370656374526174696F292C746869732E7365745374617465287B616E676C6539304465';
wwv_flow_imp.g_varchar2_table(3181) := '673A302C616E676C654772616E756C61723A307D297D7D2C752822737667222C7B22617269612D68696464656E223A2274727565222C636C6173734E616D653A22757070792D632D69636F6E222C77696474683A223234222C6865696768743A22323422';
wwv_flow_imp.g_varchar2_table(3182) := '2C76696577426F783A22302030203234203234227D2C75282270617468222C7B643A224D30203068323476323448307A222C66696C6C3A226E6F6E65227D292C75282270617468222C7B643A224D31332033632D342E393720302D3920342E30332D3920';
wwv_flow_imp.g_varchar2_table(3183) := '3948316C332E383920332E38392E30372E31344C39203132483663302D332E383720332E31332D3720372D37733720332E3133203720372D332E313320372D372037632D312E393320302D332E36382D2E37392D342E39342D322E30366C2D312E343220';
wwv_flow_imp.g_varchar2_table(3184) := '312E343243382E32372031392E39392031302E353120323120313320323163342E3937203020392D342E303320392D39732D342E30332D392D392D397A6D2D31203576356C342E323820322E35342E37322D312E32312D332E352D322E30385638483132';
wwv_flow_imp.g_varchar2_table(3185) := '7A227D292929297D72656E646572526F7461746528297B6C65747B6931386E3A657D3D746869732E70726F70733B72657475726E207528226C6162656C222C7B726F6C653A22746F6F6C746970222C22617269612D6C6162656C223A652822726F746174';
wwv_flow_imp.g_varchar2_table(3186) := '6522292C22646174612D6D6963726F7469702D706F736974696F6E223A22746F70227D2C752822627574746F6E222C7B747970653A22627574746F6E222C636C6173734E616D653A22757070792D752D726573657420757070792D632D62746E222C6F6E';
wwv_flow_imp.g_varchar2_table(3187) := '436C69636B3A746869732E6F6E526F7461746539304465677D2C752822737667222C7B22617269612D68696464656E223A2274727565222C636C6173734E616D653A22757070792D632D69636F6E222C77696474683A223234222C6865696768743A2232';
wwv_flow_imp.g_varchar2_table(3188) := '34222C76696577426F783A22302030203234203234227D2C75282270617468222C7B643A224D302030683234763234483056307A6D302030683234763234483056307A222C66696C6C3A226E6F6E65227D292C75282270617468222C7B643A224D313420';
wwv_flow_imp.g_varchar2_table(3189) := '313061322032203020303132203276376132203220302030312D32203248366132203220302030312D322D32762D37613220322030203031322D3268387A6D3020312E37354836612E32352E323520302030302D2E3234332E3139334C352E3735203132';
wwv_flow_imp.g_varchar2_table(3190) := '7637612E32352E323520302030302E3139332E3234334C362031392E32356838612E32352E323520302030302E3234332D2E3139334C31342E3235203139762D37612E32352E323520302030302D2E3139332D2E3234334C31342031312E37357A4D3132';
wwv_flow_imp.g_varchar2_table(3191) := '202E3736563463322E33203020342E36312E383820362E333620322E363461382E393520382E39352030203031322E36333420362E3032354C32312031336131203120302030312D312E3939332E3131374C3139203133682D2E30303361362E39373920';
wwv_flow_imp.g_varchar2_table(3192) := '362E39373920302030302D322E3034372D342E393520362E393720362E393720302030302D342E3635322D322E3034344C3132203676332E32344C372E37362035203132202E37367A227D292929297D72656E646572466C697028297B6C65747B693138';
wwv_flow_imp.g_varchar2_table(3193) := '6E3A657D3D746869732E70726F70733B72657475726E207528226C6162656C222C7B726F6C653A22746F6F6C746970222C22617269612D6C6162656C223A652822666C6970486F72697A6F6E74616C22292C22646174612D6D6963726F7469702D706F73';
wwv_flow_imp.g_varchar2_table(3194) := '6974696F6E223A22746F70227D2C752822627574746F6E222C7B747970653A22627574746F6E222C636C6173734E616D653A22757070792D752D726573657420757070792D632D62746E222C6F6E436C69636B3A28293D3E746869732E63726F70706572';
wwv_flow_imp.g_varchar2_table(3195) := '2E7363616C6558282D746869732E63726F707065722E6765744461746128292E7363616C65587C7C2D31297D2C752822737667222C7B22617269612D68696464656E223A2274727565222C636C6173734E616D653A22757070792D632D69636F6E222C77';
wwv_flow_imp.g_varchar2_table(3196) := '696474683A223234222C6865696768743A223234222C76696577426F783A22302030203234203234227D2C75282270617468222C7B643A224D30203068323476323448307A222C66696C6C3A226E6F6E65227D292C75282270617468222C7B643A224D31';
wwv_flow_imp.g_varchar2_table(3197) := '352032316832762D32682D3276327A6D342D313268325637682D3276327A4D332035763134633020312E312E392032203220326834762D3248355635683456334835632D312E3120302D32202E392D3220327A6D31362D327632683263302D312E312D2E';
wwv_flow_imp.g_varchar2_table(3198) := '392D322D322D327A6D2D3820323068325631682D327632327A6D382D366832762D32682D3276327A4D3135203568325633682D3276327A6D3420386832762D32682D3276327A6D30203863312E31203020322D2E3920322D32682D3276327A227D292929';
wwv_flow_imp.g_varchar2_table(3199) := '297D72656E6465725A6F6F6D496E28297B6C65747B6931386E3A657D3D746869732E70726F70733B72657475726E207528226C6162656C222C7B726F6C653A22746F6F6C746970222C22617269612D6C6162656C223A6528227A6F6F6D496E22292C2264';
wwv_flow_imp.g_varchar2_table(3200) := '6174612D6D6963726F7469702D706F736974696F6E223A22746F70227D2C752822627574746F6E222C7B747970653A22627574746F6E222C636C6173734E616D653A22757070792D752D726573657420757070792D632D62746E222C6F6E436C69636B3A';
wwv_flow_imp.g_varchar2_table(3201) := '28293D3E746869732E63726F707065722E7A6F6F6D282E31297D2C752822737667222C7B22617269612D68696464656E223A2274727565222C636C6173734E616D653A22757070792D632D69636F6E222C6865696768743A223234222C76696577426F78';
wwv_flow_imp.g_varchar2_table(3202) := '3A22302030203234203234222C77696474683A223234227D2C75282270617468222C7B643A224D302030683234763234483056307A222C66696C6C3A226E6F6E65227D292C75282270617468222C7B643A224D31352E35203134682D2E37396C2D2E3238';
wwv_flow_imp.g_varchar2_table(3203) := '2D2E32374331352E34312031322E35392031362031312E313120313620392E3520313620352E39312031332E3039203320392E352033533320352E3931203320392E3520352E393120313620392E3520313663312E3631203020332E30392D2E35392034';
wwv_flow_imp.g_varchar2_table(3204) := '2E32332D312E35376C2E32372E3238762E37396C3520342E39394C32302E34392031396C2D342E39392D357A6D2D36203043372E303120313420352031312E3939203520392E3553372E3031203520392E35203520313420372E303120313420392E3520';
wwv_flow_imp.g_varchar2_table(3205) := '31312E393920313420392E352031347A227D292C75282270617468222C7B643A224D3132203130682D3276324839762D32483756396832563768317632683276317A227D292929297D72656E6465725A6F6F6D4F757428297B6C65747B6931386E3A657D';
wwv_flow_imp.g_varchar2_table(3206) := '3D746869732E70726F70733B72657475726E207528226C6162656C222C7B726F6C653A22746F6F6C746970222C22617269612D6C6162656C223A6528227A6F6F6D4F757422292C22646174612D6D6963726F7469702D706F736974696F6E223A22746F70';
wwv_flow_imp.g_varchar2_table(3207) := '227D2C752822627574746F6E222C7B747970653A22627574746F6E222C636C6173734E616D653A22757070792D752D726573657420757070792D632D62746E222C6F6E436C69636B3A28293D3E746869732E63726F707065722E7A6F6F6D282D2E31297D';
wwv_flow_imp.g_varchar2_table(3208) := '2C752822737667222C7B22617269612D68696464656E223A2274727565222C636C6173734E616D653A22757070792D632D69636F6E222C77696474683A223234222C6865696768743A223234222C76696577426F783A22302030203234203234227D2C75';
wwv_flow_imp.g_varchar2_table(3209) := '282270617468222C7B643A224D302030683234763234483056307A222C66696C6C3A226E6F6E65227D292C75282270617468222C7B643A224D31352E35203134682D2E37396C2D2E32382D2E32374331352E34312031322E35392031362031312E313120';
wwv_flow_imp.g_varchar2_table(3210) := '313620392E3520313620352E39312031332E3039203320392E352033533320352E3931203320392E3520352E393120313620392E3520313663312E3631203020332E30392D2E353920342E32332D312E35376C2E32372E3238762E37396C3520342E3939';
wwv_flow_imp.g_varchar2_table(3211) := '4C32302E34392031396C2D342E39392D357A6D2D36203043372E303120313420352031312E3939203520392E3553372E3031203520392E35203520313420372E303120313420392E352031312E393920313420392E352031347A4D372039683576314837';
wwv_flow_imp.g_varchar2_table(3212) := '7A227D292929297D72656E64657243726F7053717561726528297B6C65747B6931386E3A657D3D746869732E70726F70733B72657475726E207528226C6162656C222C7B726F6C653A22746F6F6C746970222C22617269612D6C6162656C223A65282261';
wwv_flow_imp.g_varchar2_table(3213) := '7370656374526174696F53717561726522292C22646174612D6D6963726F7469702D706F736974696F6E223A22746F70227D2C752822627574746F6E222C7B747970653A22627574746F6E222C636C6173734E616D653A22757070792D752D7265736574';
wwv_flow_imp.g_varchar2_table(3214) := '20757070792D632D62746E222C6F6E436C69636B3A28293D3E746869732E63726F707065722E736574417370656374526174696F2831297D2C752822737667222C7B22617269612D68696464656E223A2274727565222C636C6173734E616D653A227570';
wwv_flow_imp.g_varchar2_table(3215) := '70792D632D69636F6E222C77696474683A223234222C6865696768743A223234222C76696577426F783A22302030203234203234227D2C75282270617468222C7B643A224D30203068323476323448307A222C66696C6C3A226E6F6E65227D292C752822';
wwv_flow_imp.g_varchar2_table(3216) := '70617468222C7B643A224D31392035763134483556356831346D302D324835632D312E3120302D32202E392D322032763134633020312E312E3920322032203268313463312E31203020322D2E3920322D32563563302D312E312D2E392D322D322D327A';
wwv_flow_imp.g_varchar2_table(3217) := '227D292929297D72656E64657243726F705769646573637265656E28297B6C65747B6931386E3A657D3D746869732E70726F70733B72657475726E207528226C6162656C222C7B726F6C653A22746F6F6C746970222C22617269612D6C6162656C223A65';
wwv_flow_imp.g_varchar2_table(3218) := '2822617370656374526174696F4C616E64736361706522292C22646174612D6D6963726F7469702D706F736974696F6E223A22746F70227D2C752822627574746F6E222C7B747970653A22627574746F6E222C636C6173734E616D653A22757070792D75';
wwv_flow_imp.g_varchar2_table(3219) := '2D726573657420757070792D632D62746E222C6F6E436C69636B3A28293D3E746869732E63726F707065722E736574417370656374526174696F2831362F39297D2C752822737667222C7B22617269612D68696464656E223A2274727565222C636C6173';
wwv_flow_imp.g_varchar2_table(3220) := '734E616D653A22757070792D632D69636F6E222C77696474683A223234222C6865696768743A223234222C76696577426F783A22302030203234203234227D2C75282270617468222C7B643A224D2031392C342E3939393939393220562031372E303030';
wwv_flow_imp.g_varchar2_table(3221) := '303031204820342E39393939393938205620362E393939393939322048203139206D20302C2D32204820342E393939393939382063202D312E303939393939392C30202D312E393939393939392C302E39303030303031202D312E393939393939392C32';
wwv_flow_imp.g_varchar2_table(3222) := '20562031372E303030303031206320302C312E3120302E392C3220312E393939393939392C322048203139206320312E312C3020322C2D302E3920322C2D32205620362E39393939393932206320302C2D312E30393939393939202D302E392C2D32202D';
wwv_flow_imp.g_varchar2_table(3223) := '322C2D32207A227D292C75282270617468222C7B66696C6C3A226E6F6E65222C643A224D30203068323476323448307A227D292929297D72656E64657243726F705769646573637265656E566572746963616C28297B6C65747B6931386E3A657D3D7468';
wwv_flow_imp.g_varchar2_table(3224) := '69732E70726F70733B72657475726E207528226C6162656C222C7B726F6C653A22746F6F6C746970222C22617269612D6C6162656C223A652822617370656374526174696F506F72747261697422292C22646174612D6D6963726F7469702D706F736974';
wwv_flow_imp.g_varchar2_table(3225) := '696F6E223A22746F70227D2C752822627574746F6E222C7B747970653A22627574746F6E222C636C6173734E616D653A22757070792D752D726573657420757070792D632D62746E222C6F6E436C69636B3A28293D3E746869732E63726F707065722E73';
wwv_flow_imp.g_varchar2_table(3226) := '6574417370656374526174696F28392F3136297D2C752822737667222C7B22617269612D68696464656E223A2274727565222C636C6173734E616D653A22757070792D632D69636F6E222C77696474683A223234222C6865696768743A223234222C7669';
wwv_flow_imp.g_varchar2_table(3227) := '6577426F783A22302030203234203234227D2C75282270617468222C7B643A224D2031392E3030303030312C3139204820362E3939393939392056203520682031302E3030303030322076203134206D20322C3020562035206320302C2D312E30393939';
wwv_flow_imp.g_varchar2_table(3228) := '393939202D302E392C2D312E39393939393939202D322C2D312E39393939393939204820362E3939393939392063202D312E312C30202D322C302E39202D322C312E393939393939392076203134206320302C312E3120302E392C3220322C3220682031';
wwv_flow_imp.g_varchar2_table(3229) := '302E303030303032206320312E312C3020322C2D302E3920322C2D32207A227D292C75282270617468222C7B643A224D30203068323476323448307A222C66696C6C3A226E6F6E65227D292929297D72656E64657228297B6C65747B63757272656E7449';
wwv_flow_imp.g_varchar2_table(3230) := '6D6167653A652C6F7074733A747D3D746869732E70726F70732C7B616374696F6E733A727D3D742C733D55524C2E6372656174654F626A65637455524C28652E64617461293B72657475726E20752822646976222C7B636C6173734E616D653A22757070';
wwv_flow_imp.g_varchar2_table(3231) := '792D496D61676543726F70706572227D2C752822646976222C7B636C6173734E616D653A22757070792D496D61676543726F707065722D636F6E7461696E6572227D2C752822696D67222C7B636C6173734E616D653A22757070792D496D61676543726F';
wwv_flow_imp.g_varchar2_table(3232) := '707065722D696D616765222C616C743A652E6E616D652C7372633A732C7265663A6F3D3E7B746869732E696D67456C656D656E743D6F7D7D29292C752822646976222C7B636C6173734E616D653A22757070792D496D61676543726F707065722D636F6E';
wwv_flow_imp.g_varchar2_table(3233) := '74726F6C73227D2C722E7265766572742626746869732E72656E64657252657665727428292C722E726F746174652626746869732E72656E646572526F7461746528292C722E6772616E756C6172526F746174652626746869732E72656E646572477261';
wwv_flow_imp.g_varchar2_table(3234) := '6E756C6172526F7461746528292C722E666C69702626746869732E72656E646572466C697028292C722E7A6F6F6D496E2626746869732E72656E6465725A6F6F6D496E28292C722E7A6F6F6D4F75742626746869732E72656E6465725A6F6F6D4F757428';
wwv_flow_imp.g_varchar2_table(3235) := '292C722E63726F705371756172652626746869732E72656E64657243726F7053717561726528292C722E63726F705769646573637265656E2626746869732E72656E64657243726F705769646573637265656E28292C722E63726F705769646573637265';
wwv_flow_imp.g_varchar2_table(3236) := '656E566572746963616C2626746869732E72656E64657243726F705769646573637265656E566572746963616C282929297D7D3B6E28716F2C22456469746F7222293B7661722042793D7B737472696E67733A7B7265766572743A225265736574222C72';
wwv_flow_imp.g_varchar2_table(3237) := '6F746174653A22526F746174652039305C784230222C7A6F6F6D496E3A225A6F6F6D20696E222C7A6F6F6D4F75743A225A6F6F6D206F7574222C666C6970486F72697A6F6E74616C3A22466C697020686F72697A6F6E74616C6C79222C61737065637452';
wwv_flow_imp.g_varchar2_table(3238) := '6174696F5371756172653A2243726F7020737175617265222C617370656374526174696F4C616E6473636170653A2243726F70206C616E647363617065202831363A3929222C617370656374526174696F506F7274726169743A2243726F7020706F7274';
wwv_flow_imp.g_varchar2_table(3239) := '726169742028393A313629227D7D3B7661722024533D7B76657273696F6E3A22322E342E30227D2C72733D636C61737320657874656E6473205A7B636F6E7374727563746F7228652C74297B737570657228652C74292C746869732E736176653D28293D';
wwv_flow_imp.g_varchar2_table(3240) := '3E7B6C657420613D6E28633D3E7B6C65747B63757272656E74496D6167653A647D3D746869732E676574506C7567696E537461746528293B746869732E757070792E73657446696C65537461746528642E69642C7B646174613A632C73697A653A632E73';
wwv_flow_imp.g_varchar2_table(3241) := '697A652C707265766965773A6E756C6C7D293B6C657420663D746869732E757070792E67657446696C6528642E6964293B746869732E757070792E656D697428227468756D626E61696C3A72657175657374222C66292C746869732E736574506C756769';
wwv_flow_imp.g_varchar2_table(3242) := '6E5374617465287B63757272656E74496D6167653A667D292C746869732E757070792E656D6974282266696C652D656469746F723A636F6D706C657465222C66297D2C2273617665426C6F6243616C6C6261636B22292C7B63757272656E74496D616765';
wwv_flow_imp.g_varchar2_table(3243) := '3A6C7D3D746869732E676574506C7567696E537461746528292C683D746869732E63726F707065722E67657443726F7070656443616E766173287B7D293B682E77696474682532213D3D302626746869732E63726F707065722E73657444617461287B77';
wwv_flow_imp.g_varchar2_table(3244) := '696474683A682E77696474682D317D292C682E6865696768742532213D3D302626746869732E63726F707065722E73657444617461287B6865696768743A682E6865696768742D317D292C746869732E63726F707065722E67657443726F707065644361';
wwv_flow_imp.g_varchar2_table(3245) := '6E76617328746869732E6F7074732E63726F707065724F7074696F6E732E63726F7070656443616E7661734F7074696F6E73292E746F426C6F6228612C6C2E747970652C746869732E6F7074732E7175616C697479297D2C746869732E73746F72654372';
wwv_flow_imp.g_varchar2_table(3246) := '6F70706572496E7374616E63653D613D3E7B746869732E63726F707065723D617D2C746869732E73656C65637446696C653D613D3E7B746869732E757070792E656D6974282266696C652D656469746F723A7374617274222C61292C746869732E736574';
wwv_flow_imp.g_varchar2_table(3247) := '506C7567696E5374617465287B63757272656E74496D6167653A617D297D2C746869732E69643D746869732E6F7074732E69647C7C22496D616765456469746F72222C746869732E7469746C653D22496D61676520456469746F72222C746869732E7479';
wwv_flow_imp.g_varchar2_table(3248) := '70653D22656469746F72222C746869732E64656661756C744C6F63616C653D42793B6C657420723D7B766965774D6F64653A302C6261636B67726F756E643A21312C6175746F43726F70417265613A312C726573706F6E736976653A21302C6D696E4372';
wwv_flow_imp.g_varchar2_table(3249) := '6F70426F7857696474683A37302C6D696E43726F70426F784865696768743A37302C63726F7070656443616E7661734F7074696F6E733A7B7D2C696E697469616C417370656374526174696F3A307D2C733D7B7265766572743A21302C726F746174653A';
wwv_flow_imp.g_varchar2_table(3250) := '21302C6772616E756C6172526F746174653A21302C666C69703A21302C7A6F6F6D496E3A21302C7A6F6F6D4F75743A21302C63726F705371756172653A21302C63726F705769646573637265656E3A21302C63726F705769646573637265656E56657274';
wwv_flow_imp.g_varchar2_table(3251) := '6963616C3A21307D2C6F3D7B7175616C6974793A2E387D3B746869732E6F7074733D7B2E2E2E6F2C2E2E2E742C616374696F6E733A7B2E2E2E732C2E2E2E743F2E616374696F6E737D2C63726F707065724F7074696F6E733A7B2E2E2E722C2E2E2E743F';
wwv_flow_imp.g_varchar2_table(3252) := '2E63726F707065724F7074696F6E737D7D2C746869732E6931386E496E697428297D63616E4564697446696C652865297B69662821652E747970657C7C652E697352656D6F74652972657475726E21313B6C657420743D652E747970652E73706C697428';
wwv_flow_imp.g_varchar2_table(3253) := '222F22295B315D3B72657475726E21212F5E286A70653F677C6769667C706E677C626D707C7765627029242F2E746573742874297D696E7374616C6C28297B746869732E736574506C7567696E5374617465287B63757272656E74496D6167653A6E756C';
wwv_flow_imp.g_varchar2_table(3254) := '6C7D293B6C65747B7461726765743A657D3D746869732E6F7074733B652626746869732E6D6F756E7428652C74686973297D756E696E7374616C6C28297B6C65747B63757272656E74496D6167653A657D3D746869732E676574506C7567696E53746174';
wwv_flow_imp.g_varchar2_table(3255) := '6528293B69662865297B6C657420743D746869732E757070792E67657446696C6528652E6964293B746869732E757070792E656D6974282266696C652D656469746F723A63616E63656C222C74297D746869732E756E6D6F756E7428297D72656E646572';
wwv_flow_imp.g_varchar2_table(3256) := '28297B6C65747B63757272656E74496D6167653A657D3D746869732E676574506C7567696E537461746528293B72657475726E20653D3D3D6E756C6C7C7C652E697352656D6F74653F6E756C6C3A7528716F2C7B63757272656E74496D6167653A652C73';
wwv_flow_imp.g_varchar2_table(3257) := '746F726543726F70706572496E7374616E63653A746869732E73746F726543726F70706572496E7374616E63652C736176653A746869732E736176652C6F7074733A746869732E6F7074732C6931386E3A746869732E6931386E7D297D7D3B6E2872732C';
wwv_flow_imp.g_varchar2_table(3258) := '22496D616765456469746F7222293B72732E56455253494F4E3D24532E76657273696F6E3B7661722071533D7B76657273696F6E3A22332E302E34227D2C73733D636C61737320657874656E6473205A7B636F6E7374727563746F7228652C74297B7375';
wwv_flow_imp.g_varchar2_table(3259) := '70657228652C74292C746869732E69643D746869732E6F7074732E69647C7C2250726F6772657373426172222C746869732E7469746C653D2250726F677265737320426172222C746869732E747970653D2270726F6772657373696E64696361746F7222';
wwv_flow_imp.g_varchar2_table(3260) := '3B6C657420723D7B7461726765743A22626F6479222C66697865643A21312C68696465416674657246696E6973683A21307D3B746869732E6F7074733D7B2E2E2E722C2E2E2E747D2C746869732E72656E6465723D746869732E72656E6465722E62696E';
wwv_flow_imp.g_varchar2_table(3261) := '642874686973297D72656E6465722865297B6C657420743D652E746F74616C50726F67726573737C7C302C723D28743D3D3D307C7C743D3D3D313030292626746869732E6F7074732E68696465416674657246696E6973683B72657475726E2075282264';
wwv_flow_imp.g_varchar2_table(3262) := '6976222C7B636C6173734E616D653A227570707920757070792D50726F6772657373426172222C7374796C653A7B706F736974696F6E3A746869732E6F7074732E66697865643F226669786564223A22696E697469616C227D2C22617269612D68696464';
wwv_flow_imp.g_varchar2_table(3263) := '656E223A727D2C752822646976222C7B636C6173734E616D653A22757070792D50726F67726573734261722D696E6E6572222C7374796C653A7B77696474683A60247B747D25607D7D292C752822646976222C7B636C6173734E616D653A22757070792D';
wwv_flow_imp.g_varchar2_table(3264) := '50726F67726573734261722D70657263656E74616765227D2C7429297D696E7374616C6C28297B6C65747B7461726765743A657D3D746869732E6F7074733B652626746869732E6D6F756E7428652C74686973297D756E696E7374616C6C28297B746869';
wwv_flow_imp.g_varchar2_table(3265) := '732E756E6D6F756E7428297D7D3B6E2873732C2250726F677265737342617222293B73732E56455253494F4E3D71532E76657273696F6E3B7661722056533D7B5F5F70726F746F5F5F3A6E756C6C2C22617564696F2F6D7033223A226D7033222C226175';
wwv_flow_imp.g_varchar2_table(3266) := '64696F2F6D7034223A226D7034222C22617564696F2F6F6767223A226F6767222C22617564696F2F7765626D223A227765626D222C22696D6167652F676966223A22676966222C22696D6167652F68656963223A2268656963222C22696D6167652F6865';
wwv_flow_imp.g_varchar2_table(3267) := '6966223A2268656966222C22696D6167652F6A706567223A226A7067222C22696D6167652F706E67223A22706E67222C22696D6167652F7376672B786D6C223A22737667222C22766964656F2F6D7034223A226D7034222C22766964656F2F6F6767223A';
wwv_flow_imp.g_varchar2_table(3268) := '226F6776222C22766964656F2F717569636B74696D65223A226D6F76222C22766964656F2F7765626D223A227765626D222C22766964656F2F782D6D6174726F736B61223A226D6B76222C22766964656F2F782D6D73766964656F223A22617669227D3B';
wwv_flow_imp.g_varchar2_table(3269) := '66756E6374696F6E204B692869297B72657475726E5B695D3D692E73706C697428223B222C31292C56535B695D7C7C6E756C6C7D6E284B692C2267657446696C6554797065457874656E73696F6E22293B66756E6374696F6E204B6428297B7661722069';
wwv_flow_imp.g_varchar2_table(3270) := '3B72657475726E20747970656F66204D656469615265636F726465723D3D2266756E6374696F6E222626747970656F662828693D4D656469615265636F726465722E70726F746F74797065293D3D6E756C6C3F766F696420303A692E7374617274293D3D';
wwv_flow_imp.g_varchar2_table(3271) := '2266756E6374696F6E227D6E284B642C22737570706F7274734D656469615265636F7264657222293B66756E6374696F6E2058642869297B6C65747B7265636F7264696E673A652C6F6E53746172745265636F7264696E673A742C6F6E53746F70526563';
wwv_flow_imp.g_varchar2_table(3272) := '6F7264696E673A722C6931386E3A737D3D693B72657475726E20653F752822627574746F6E222C7B636C6173734E616D653A22757070792D752D726573657420757070792D632D62746E20757070792D417564696F2D627574746F6E222C747970653A22';
wwv_flow_imp.g_varchar2_table(3273) := '627574746F6E222C7469746C653A73282273746F70417564696F5265636F7264696E6722292C22617269612D6C6162656C223A73282273746F70417564696F5265636F7264696E6722292C6F6E436C69636B3A722C22646174612D757070792D73757065';
wwv_flow_imp.g_varchar2_table(3274) := '722D666F63757361626C65223A21307D2C752822737667222C7B22617269612D68696464656E223A2274727565222C666F63757361626C653A2266616C7365222C636C6173734E616D653A22757070792D632D69636F6E222C77696474683A2231303022';
wwv_flow_imp.g_varchar2_table(3275) := '2C6865696768743A22313030222C76696577426F783A223020302031303020313030227D2C75282272656374222C7B783A223135222C793A223135222C77696474683A223730222C6865696768743A223730227D2929293A752822627574746F6E222C7B';
wwv_flow_imp.g_varchar2_table(3276) := '636C6173734E616D653A22757070792D752D726573657420757070792D632D62746E20757070792D417564696F2D627574746F6E222C747970653A22627574746F6E222C7469746C653A7328227374617274417564696F5265636F7264696E6722292C22';
wwv_flow_imp.g_varchar2_table(3277) := '617269612D6C6162656C223A7328227374617274417564696F5265636F7264696E6722292C6F6E436C69636B3A742C22646174612D757070792D73757065722D666F63757361626C65223A21307D2C752822737667222C7B22617269612D68696464656E';
wwv_flow_imp.g_varchar2_table(3278) := '223A2274727565222C666F63757361626C653A2266616C7365222C636C6173734E616D653A22757070792D632D69636F6E222C77696474683A2231347078222C6865696768743A2232307078222C76696577426F783A22302030203134203230227D2C75';
wwv_flow_imp.g_varchar2_table(3279) := '282270617468222C7B643A224D3720313463322E3231203020342D312E373120342D332E38313856332E38313843313120312E373120392E3231203020372030533320312E3731203320332E38313876362E33363443332031322E323920342E37392031';
wwv_flow_imp.g_varchar2_table(3280) := '3420372031347A6D362E3336342D37682D2E363337612E3634332E3634332030203020302D2E3633362E363556392E36633020332E3033392D322E35363520352E3437372D352E3620352E3137352D322E3634352D2E3236342D342E3538322D322E3639';
wwv_flow_imp.g_varchar2_table(3281) := '322D342E3538322D352E34303756372E363563302D2E33362D2E3238352D2E36352D2E3633362D2E3635482E363336412E3634332E363433203020302030203020372E363576312E363331633020332E36343220322E35343420362E38383820362E3034';
wwv_flow_imp.g_varchar2_table(3282) := '3520372E33383276312E33383748332E383138612E3634332E3634332030203020302D2E3633362E3635762E36356330202E33362E3238352E36352E3633362E363568362E333634632E3335312030202E3633362D2E32392E3633362D2E3635762D2E36';
wwv_flow_imp.g_varchar2_table(3283) := '3563302D2E33362D2E3238352D2E36352D2E3633362D2E363548372E393535762D312E3337324331312E3336332031362E322031342031332E32313220313420392E3656372E363563302D2E33362D2E3238352D2E36352D2E3633362D2E36357A222C66';
wwv_flow_imp.g_varchar2_table(3284) := '696C6C3A2223464646222C2266696C6C2D72756C65223A226E6F6E7A65726F227D2929297D6E2858642C225265636F7264427574746F6E22293B66756E6374696F6E2059642869297B72657475726E60247B4D6174682E666C6F6F7228692F3630297D3A';
wwv_flow_imp.g_varchar2_table(3285) := '247B537472696E672869253630292E706164537461727428322C30297D607D6E2859642C22666F726D61745365636F6E647322293B66756E6374696F6E2051642869297B6C65747B7265636F7264696E674C656E6774685365636F6E64733A652C693138';
wwv_flow_imp.g_varchar2_table(3286) := '6E3A747D3D692C723D59642865293B72657475726E207528227370616E222C7B22617269612D6C6162656C223A7428227265636F7264696E674C656E677468222C7B7265636F7264696E675F6C656E6774683A727D297D2C72297D6E2851642C22526563';
wwv_flow_imp.g_varchar2_table(3287) := '6F7264696E674C656E67746822293B766172207A793D6E28693D3E7B6C65747B63757272656E7444657669636549643A652C617564696F536F75726365733A742C6F6E4368616E6765536F757263653A727D3D693B72657475726E20752822646976222C';
wwv_flow_imp.g_varchar2_table(3288) := '7B636C6173734E616D653A22757070792D417564696F2D766964656F536F75726365227D2C75282273656C656374222C7B636C6173734E616D653A22757070792D752D726573657420757070792D417564696F2D617564696F536F757263652D73656C65';
wwv_flow_imp.g_varchar2_table(3289) := '6374222C6F6E4368616E67653A733D3E7B7228732E7461726765742E76616C7565297D7D2C742E6D617028733D3E7528226F7074696F6E222C7B6B65793A732E64657669636549642C76616C75653A732E64657669636549642C73656C65637465643A73';
wwv_flow_imp.g_varchar2_table(3290) := '2E64657669636549643D3D3D657D2C732E6C6162656C292929297D2C2264656661756C7422293B66756E6374696F6E20575328692C65297B696628214F626A6563742E70726F746F747970652E6861734F776E50726F70657274792E63616C6C28692C65';
wwv_flow_imp.g_varchar2_table(3291) := '29297468726F77206E657720547970654572726F722822617474656D7074656420746F207573652070726976617465206669656C64206F6E206E6F6E2D696E7374616E636522293B72657475726E20697D6E2857532C225F636C61737350726976617465';
wwv_flow_imp.g_varchar2_table(3292) := '4669656C644C6F6F73654261736522293B7661722047533D303B66756E6374696F6E204B532869297B72657475726E225F5F707269766174655F222B47532B2B2B225F222B697D6E284B532C225F636C617373507269766174654669656C644C6F6F7365';
wwv_flow_imp.g_varchar2_table(3293) := '4B657922293B66756E6374696F6E206A792869297B72657475726E20747970656F6620693D3D2266756E6374696F6E227D6E286A792C22697346756E6374696F6E22293B66756E6374696F6E2076612869297B72657475726E206A792869293F6928293A';
wwv_flow_imp.g_varchar2_table(3294) := '697D6E2876612C22726573756C7422293B766172204A643D4B5328226472617722292C566F3D636C6173737B636F6E7374727563746F7228652C74297B743D3D3D766F69642030262628743D7B7D292C4F626A6563742E646566696E6550726F70657274';
wwv_flow_imp.g_varchar2_table(3295) := '7928746869732C4A642C7B7772697461626C653A21302C76616C75653A28293D3E746869732E6472617728297D293B6C657420723D742E63616E7661737C7C7B7D2C733D742E63616E766173436F6E746578747C7C7B7D3B746869732E616E616C797365';
wwv_flow_imp.g_varchar2_table(3296) := '723D6E756C6C2C746869732E6275666665724C656E6774683D302C746869732E6461746141727261793D5B5D2C746869732E63616E7661733D652C746869732E77696474683D766128722E7769647468297C7C746869732E63616E7661732E7769647468';
wwv_flow_imp.g_varchar2_table(3297) := '2C746869732E6865696768743D766128722E686569676874297C7C746869732E63616E7661732E6865696768742C746869732E63616E7661732E77696474683D746869732E77696474682C746869732E63616E7661732E6865696768743D746869732E68';
wwv_flow_imp.g_varchar2_table(3298) := '65696768742C746869732E63616E766173436F6E746578743D746869732E63616E7661732E676574436F6E746578742822326422292C746869732E63616E766173436F6E746578742E66696C6C5374796C653D766128732E66696C6C5374796C65297C7C';
wwv_flow_imp.g_varchar2_table(3299) := '22726762283235352C203235352C2032353529222C746869732E63616E766173436F6E746578742E7374726F6B655374796C653D766128732E7374726F6B655374796C65297C7C2272676228302C20302C203029222C746869732E63616E766173436F6E';
wwv_flow_imp.g_varchar2_table(3300) := '746578742E6C696E6557696474683D766128732E6C696E655769647468297C7C312C746869732E6F6E447261774672616D653D6A7928742E6F6E447261774672616D65293F742E6F6E447261774672616D653A28293D3E7B7D7D616464536F7572636528';
wwv_flow_imp.g_varchar2_table(3301) := '65297B746869732E73747265616D536F757263653D652C746869732E617564696F436F6E746578743D746869732E73747265616D536F757263652E636F6E746578742C746869732E616E616C797365723D746869732E617564696F436F6E746578742E63';
wwv_flow_imp.g_varchar2_table(3302) := '7265617465416E616C7973657228292C746869732E616E616C797365722E66667453697A653D323034382C746869732E6275666665724C656E6774683D746869732E616E616C797365722E6672657175656E637942696E436F756E742C746869732E736F';
wwv_flow_imp.g_varchar2_table(3303) := '757263653D746869732E617564696F436F6E746578742E637265617465427566666572536F7572636528292C746869732E6461746141727261793D6E65772055696E7438417272617928746869732E6275666665724C656E677468292C746869732E616E';
wwv_flow_imp.g_varchar2_table(3304) := '616C797365722E6765744279746554696D65446F6D61696E4461746128746869732E646174614172726179292C746869732E73747265616D536F757263652E636F6E6E65637428746869732E616E616C79736572297D6472617728297B6C65747B616E61';
wwv_flow_imp.g_varchar2_table(3305) := '6C797365723A652C6461746141727261793A742C6275666665724C656E6774683A727D3D746869732C733D746869732E63616E766173436F6E746578742C6F3D746869732E77696474682C613D746869732E6865696768743B652626652E676574427974';
wwv_flow_imp.g_varchar2_table(3306) := '6554696D65446F6D61696E446174612874292C732E66696C6C5265637428302C302C6F2C61292C732E626567696E5061746828293B6C6574206C3D6F2A312F722C683D303B727C7C732E6D6F7665546F28302C746869732E6865696768742F32293B666F';
wwv_flow_imp.g_varchar2_table(3307) := '72286C657420633D303B633C723B632B2B297B6C657420663D745B635D2F3132382A28612F32293B633D3D3D303F732E6D6F7665546F28682C66293A732E6C696E65546F28682C66292C682B3D6C7D732E6C696E65546F286F2C612F32292C732E737472';
wwv_flow_imp.g_varchar2_table(3308) := '6F6B6528292C746869732E6F6E447261774672616D652874686973292C72657175657374416E696D6174696F6E4672616D6528575328746869732C4A64295B4A645D297D7D3B6E28566F2C22417564696F4F7363696C6C6F73636F706522293B66756E63';
wwv_flow_imp.g_varchar2_table(3309) := '74696F6E2058532869297B6C65747B6F6E5375626D69743A652C6931386E3A747D3D693B72657475726E20752822627574746F6E222C7B636C6173734E616D653A22757070792D752D726573657420757070792D632D62746E20757070792D417564696F';
wwv_flow_imp.g_varchar2_table(3310) := '2D627574746F6E20757070792D417564696F2D627574746F6E2D2D7375626D6974222C747970653A22627574746F6E222C7469746C653A7428227375626D69745265636F7264656446696C6522292C22617269612D6C6162656C223A7428227375626D69';
wwv_flow_imp.g_varchar2_table(3311) := '745265636F7264656446696C6522292C6F6E436C69636B3A652C22646174612D757070792D73757065722D666F63757361626C65223A21307D2C752822737667222C7B77696474683A223132222C6865696768743A2239222C76696577426F783A223020';
wwv_flow_imp.g_varchar2_table(3312) := '302031322039222C786D6C6E733A22687474703A2F2F7777772E77332E6F72672F323030302F737667222C22617269612D68696464656E223A2274727565222C666F63757361626C653A2266616C7365222C636C6173734E616D653A22757070792D632D';
wwv_flow_imp.g_varchar2_table(3313) := '69636F6E227D2C75282270617468222C7B66696C6C3A2223666666222C66696C6C52756C653A226E6F6E7A65726F222C643A224D31302E363620304C313220312E333120342E3133362039203020342E3935366C312E33342D312E33314C342E31333620';
wwv_flow_imp.g_varchar2_table(3314) := '362E33387A227D2929297D6E2858532C225375626D6974427574746F6E22293B7661722048793D58533B66756E6374696F6E2059532869297B6C65747B6F6E446973636172643A652C6931386E3A747D3D693B72657475726E20752822627574746F6E22';
wwv_flow_imp.g_varchar2_table(3315) := '2C7B636C6173734E616D653A22757070792D752D726573657420757070792D632D62746E20757070792D417564696F2D627574746F6E222C747970653A22627574746F6E222C7469746C653A742822646973636172645265636F7264656446696C652229';
wwv_flow_imp.g_varchar2_table(3316) := '2C22617269612D6C6162656C223A742822646973636172645265636F7264656446696C6522292C6F6E436C69636B3A652C22646174612D757070792D73757065722D666F63757361626C65223A21307D2C752822737667222C7B77696474683A22313322';
wwv_flow_imp.g_varchar2_table(3317) := '2C6865696768743A223133222C76696577426F783A22302030203133203133222C786D6C6E733A22687474703A2F2F7777772E77332E6F72672F323030302F737667222C22617269612D68696464656E223A2274727565222C636C6173734E616D653A22';
wwv_flow_imp.g_varchar2_table(3318) := '757070792D632D69636F6E227D2C75282267222C7B66696C6C3A2223464646222C66696C6C52756C653A226576656E6F6464227D2C75282270617468222C7B643A224D2E3439362031312E3336374C31312E3130332E37366C312E34313420312E343134';
wwv_flow_imp.g_varchar2_table(3319) := '4C312E3931312031322E3738317A227D292C75282270617468222C7B643A224D31312E3130342031322E3738324C2E34393720322E31373520312E3931312E37366C31302E3630372031302E3630367A227D292929297D6E2859532C2244697363617264';
wwv_flow_imp.g_varchar2_table(3320) := '427574746F6E22293B7661722024793D59533B66756E6374696F6E205A642869297B6C65747B73747265616D3A652C7265636F72646564417564696F3A742C6F6E53746F703A722C7265636F7264696E673A732C737570706F7274735265636F7264696E';
wwv_flow_imp.g_varchar2_table(3321) := '673A6F2C617564696F536F75726365733A612C73686F77417564696F536F7572636544726F70646F776E3A6C2C6F6E5375626D69743A682C6931386E3A632C6F6E53746172745265636F7264696E673A642C6F6E53746F705265636F7264696E673A662C';
wwv_flow_imp.g_varchar2_table(3322) := '6F6E446973636172645265636F72646564417564696F3A792C7265636F7264696E674C656E6774685365636F6E64733A627D3D692C533D5968286E756C6C292C453D5968286E756C6C293B45732828293D3E28293D3E7B452E63757272656E743D6E756C';
wwv_flow_imp.g_varchar2_table(3323) := '6C2C7228297D2C5B725D292C45732828293D3E7B6966282174262628452E63757272656E743D6E657720566F28532E63757272656E742C7B63616E7661733A7B77696474683A3630302C6865696768743A3630307D2C63616E766173436F6E746578743A';
wwv_flow_imp.g_varchar2_table(3324) := '7B6C696E6557696474683A322C66696C6C5374796C653A2272676228302C302C3029222C7374726F6B655374796C653A22677265656E227D7D292C452E63757272656E742E6472617728292C6529297B6C657420473D6E657720417564696F436F6E7465';
wwv_flow_imp.g_varchar2_table(3325) := '787428292E6372656174654D6564696153747265616D536F757263652865293B452E63757272656E742E616464536F757263652847297D7D2C5B742C655D293B6C657420463D74213D6E756C6C2C783D214626266F2C553D6C262621462626612626612E';
wwv_flow_imp.g_varchar2_table(3326) := '6C656E6774683E313B72657475726E20752822646976222C7B636C6173734E616D653A22757070792D417564696F2D636F6E7461696E6572227D2C752822646976222C7B636C6173734E616D653A22757070792D417564696F2D617564696F436F6E7461';
wwv_flow_imp.g_varchar2_table(3327) := '696E6572227D2C463F752822617564696F222C7B636C6173734E616D653A22757070792D417564696F2D706C61796572222C636F6E74726F6C733A21302C7372633A747D293A75282263616E766173222C7B7265663A532C636C6173734E616D653A2275';
wwv_flow_imp.g_varchar2_table(3328) := '7070792D417564696F2D63616E766173227D29292C752822646976222C7B636C6173734E616D653A22757070792D417564696F2D666F6F746572227D2C752822646976222C7B636C6173734E616D653A22757070792D417564696F2D617564696F536F75';
wwv_flow_imp.g_varchar2_table(3329) := '726365436F6E7461696E6572227D2C553F7A792869293A6E756C6C292C752822646976222C7B636C6173734E616D653A22757070792D417564696F2D627574746F6E436F6E7461696E6572227D2C782626752858642C7B7265636F7264696E673A732C6F';
wwv_flow_imp.g_varchar2_table(3330) := '6E53746172745265636F7264696E673A642C6F6E53746F705265636F7264696E673A662C6931386E3A637D292C462626752848792C7B6F6E5375626D69743A682C6931386E3A637D292C462626752824792C7B6F6E446973636172643A792C6931386E3A';
wwv_flow_imp.g_varchar2_table(3331) := '637D29292C752822646976222C7B636C6173734E616D653A22757070792D417564696F2D7265636F7264696E674C656E677468227D2C21462626752851642C7B7265636F7264696E674C656E6774685365636F6E64733A622C6931386E3A637D29292929';
wwv_flow_imp.g_varchar2_table(3332) := '7D6E285A642C225265636F7264696E6753637265656E22293B7661722071793D6E28693D3E7B6C65747B69636F6E3A652C686173417564696F3A742C6931386E3A727D3D693B72657475726E20752822646976222C7B636C6173734E616D653A22757070';
wwv_flow_imp.g_varchar2_table(3333) := '792D417564696F2D7065726D6973736F6E73227D2C752822646976222C7B636C6173734E616D653A22757070792D417564696F2D7065726D6973736F6E7349636F6E227D2C652829292C7528226831222C7B636C6173734E616D653A22757070792D4175';
wwv_flow_imp.g_varchar2_table(3334) := '64696F2D7469746C65227D2C7228743F22616C6C6F77417564696F4163636573735469746C65223A226E6F417564696F5469746C652229292C75282270222C6E756C6C2C7228743F22616C6C6F77417564696F4163636573734465736372697074696F6E';
wwv_flow_imp.g_varchar2_table(3335) := '223A226E6F417564696F4465736372697074696F6E222929297D2C2264656661756C7422293B7661722056793D7B737472696E67733A7B706C7567696E4E616D65417564696F3A22417564696F222C7374617274417564696F5265636F7264696E673A22';
wwv_flow_imp.g_varchar2_table(3336) := '426567696E20617564696F207265636F7264696E67222C73746F70417564696F5265636F7264696E673A2253746F7020617564696F207265636F7264696E67222C616C6C6F77417564696F4163636573735469746C653A22506C6561736520616C6C6F77';
wwv_flow_imp.g_varchar2_table(3337) := '2061636365737320746F20796F7572206D6963726F70686F6E65222C616C6C6F77417564696F4163636573734465736372697074696F6E3A22496E206F7264657220746F207265636F726420617564696F2C20706C6561736520616C6C6F77206D696372';
wwv_flow_imp.g_varchar2_table(3338) := '6F70686F6E652061636365737320666F72207468697320736974652E222C6E6F417564696F5469746C653A224D6963726F70686F6E65204E6F7420417661696C61626C65222C6E6F417564696F4465736372697074696F6E3A22496E206F726465722074';
wwv_flow_imp.g_varchar2_table(3339) := '6F207265636F726420617564696F2C20706C6561736520636F6E6E6563742061206D6963726F70686F6E65206F7220616E6F7468657220617564696F20696E70757420646576696365222C7265636F7264696E6753746F707065644D617853697A653A22';
wwv_flow_imp.g_varchar2_table(3340) := '5265636F7264696E672073746F707065642062656361757365207468652066696C652073697A652069732061626F757420746F2065786365656420746865206C696D6974222C7265636F7264696E674C656E6774683A225265636F7264696E67206C656E';
wwv_flow_imp.g_varchar2_table(3341) := '67746820257B7265636F7264696E675F6C656E6774687D222C7375626D69745265636F7264656446696C653A225375626D6974207265636F726465642066696C65222C646973636172645265636F7264656446696C653A2244697363617264207265636F';
wwv_flow_imp.g_varchar2_table(3342) := '726465642066696C65227D7D3B66756E6374696F6E206E6328297B72657475726E206E633D4F626A6563742E61737369676E3F4F626A6563742E61737369676E2E62696E6428293A66756E6374696F6E2869297B666F722876617220653D313B653C6172';
wwv_flow_imp.g_varchar2_table(3343) := '67756D656E74732E6C656E6774683B652B2B297B76617220743D617267756D656E74735B655D3B666F7228766172207220696E2074294F626A6563742E70726F746F747970652E6861734F776E50726F70657274792E63616C6C28742C7229262628695B';
wwv_flow_imp.g_varchar2_table(3344) := '725D3D745B725D297D72657475726E20697D2C6E632E6170706C7928746869732C617267756D656E7473297D6E286E632C225F657874656E647322293B66756E6374696F6E202428692C65297B696628214F626A6563742E70726F746F747970652E6861';
wwv_flow_imp.g_varchar2_table(3345) := '734F776E50726F70657274792E63616C6C28692C6529297468726F77206E657720547970654572726F722822617474656D7074656420746F207573652070726976617465206669656C64206F6E206E6F6E2D696E7374616E636522293B72657475726E20';
wwv_flow_imp.g_varchar2_table(3346) := '697D6E28242C225F636C617373507269766174654669656C644C6F6F73654261736522293B7661722051533D303B66756E6374696F6E2070742869297B72657475726E225F5F707269766174655F222B51532B2B2B225F222B697D6E2870742C225F636C';
wwv_flow_imp.g_varchar2_table(3347) := '617373507269766174654669656C644C6F6F73654B657922293B766172204A533D7B76657273696F6E3A22312E312E34227D2C64743D7074282273747265616D22292C41723D70742822617564696F41637469766522292C44653D707428227265636F72';
wwv_flow_imp.g_varchar2_table(3348) := '64696E674368756E6B7322292C6B653D707428227265636F7264657222292C52723D7074282263617074757265644D6564696146696C6522292C63743D707428226D656469614465766963657322292C62613D70742822737570706F727473557365724D';
wwv_flow_imp.g_varchar2_table(3349) := '6564696122292C65633D70742822686173417564696F436865636B22292C4E733D70742822737461727422292C74633D7074282273746172745265636F7264696E6722292C77613D7074282273746F705265636F7264696E6722292C69633D7074282264';
wwv_flow_imp.g_varchar2_table(3350) := '6973636172645265636F72646564417564696F22292C72633D707428227375626D697422292C55723D7074282273746F7022292C73633D70742822676574417564696F22292C6F633D707428226368616E6765536F7572636522292C4C733D7074282275';
wwv_flow_imp.g_varchar2_table(3351) := '7064617465536F757263657322292C6F733D636C61737320657874656E6473205A7B636F6E7374727563746F7228652C74297B76617220723B737570657228652C74292C723D746869732C4F626A6563742E646566696E6550726F706572747928746869';
wwv_flow_imp.g_varchar2_table(3352) := '732C73632C7B76616C75653A65507D292C4F626A6563742E646566696E6550726F706572747928746869732C65632C7B76616C75653A5A537D292C4F626A6563742E646566696E6550726F706572747928746869732C64742C7B7772697461626C653A21';
wwv_flow_imp.g_varchar2_table(3353) := '302C76616C75653A6E756C6C7D292C4F626A6563742E646566696E6550726F706572747928746869732C41722C7B7772697461626C653A21302C76616C75653A21317D292C4F626A6563742E646566696E6550726F706572747928746869732C44652C7B';
wwv_flow_imp.g_varchar2_table(3354) := '7772697461626C653A21302C76616C75653A6E756C6C7D292C4F626A6563742E646566696E6550726F706572747928746869732C6B652C7B7772697461626C653A21302C76616C75653A6E756C6C7D292C4F626A6563742E646566696E6550726F706572';
wwv_flow_imp.g_varchar2_table(3355) := '747928746869732C52722C7B7772697461626C653A21302C76616C75653A6E756C6C7D292C4F626A6563742E646566696E6550726F706572747928746869732C63742C7B7772697461626C653A21302C76616C75653A6E756C6C7D292C4F626A6563742E';
wwv_flow_imp.g_varchar2_table(3356) := '646566696E6550726F706572747928746869732C62612C7B7772697461626C653A21302C76616C75653A6E756C6C7D292C4F626A6563742E646566696E6550726F706572747928746869732C4E732C7B7772697461626C653A21302C76616C75653A6675';
wwv_flow_imp.g_varchar2_table(3357) := '6E6374696F6E2873297B696628733D3D3D766F69642030262628733D6E756C6C292C212428722C6261295B62615D2972657475726E2050726F6D6973652E72656A656374286E6577204572726F7228224D6963726F70686F6E6520616363657373206E6F';
wwv_flow_imp.g_varchar2_table(3358) := '7420737570706F727465642229293B2428722C4172295B41725D3D21302C2428722C6563295B65635D28292E7468656E286F3D3E28722E736574506C7567696E5374617465287B686173417564696F3A6F7D292C2428722C6374295B63745D2E67657455';
wwv_flow_imp.g_varchar2_table(3359) := '7365724D65646961287B617564696F3A21307D292E7468656E28613D3E7B2428722C6474295B64745D3D613B6C6574206C3D6E756C6C2C683D612E676574417564696F547261636B7328293B21737C7C21732E64657669636549643F6C3D685B305D2E67';
wwv_flow_imp.g_varchar2_table(3360) := '657453657474696E677328292E64657669636549643A682E666F724561636828633D3E7B632E67657453657474696E677328292E64657669636549643D3D3D732E64657669636549642626286C3D632E67657453657474696E677328292E646576696365';
wwv_flow_imp.g_varchar2_table(3361) := '4964297D292C2428722C4C73295B4C735D28292C722E736574506C7567696E5374617465287B63757272656E7444657669636549643A6C2C617564696F52656164793A21307D297D292E636174636828613D3E7B722E736574506C7567696E5374617465';
wwv_flow_imp.g_varchar2_table(3362) := '287B617564696F52656164793A21312C63616D6572614572726F723A617D292C722E757070792E696E666F28612E6D6573736167652C226572726F7222297D2929297D7D292C4F626A6563742E646566696E6550726F706572747928746869732C74632C';
wwv_flow_imp.g_varchar2_table(3363) := '7B7772697461626C653A21302C76616C75653A28293D3E7B2428746869732C6B65295B6B655D3D6E6577204D656469615265636F72646572282428746869732C6474295B64745D292C2428746869732C4465295B44655D3D5B5D3B6C657420733D21313B';
wwv_flow_imp.g_varchar2_table(3364) := '2428746869732C6B65295B6B655D2E6164644576656E744C697374656E6572282264617461617661696C61626C65222C6F3D3E7B2428746869732C4465295B44655D2E70757368286F2E64617461293B6C65747B7265737472696374696F6E733A617D3D';
wwv_flow_imp.g_varchar2_table(3365) := '746869732E757070792E6F7074733B6966282428746869732C4465295B44655D2E6C656E6774683E312626612E6D617846696C6553697A65213D6E756C6C26262173297B6C6574206C3D2428746869732C4465295B44655D2E7265647563652828662C79';
wwv_flow_imp.g_varchar2_table(3366) := '293D3E662B792E73697A652C30292C633D286C2D2428746869732C4465295B44655D5B305D2E73697A65292F282428746869732C4465295B44655D2E6C656E6774682D31292A332C643D4D6174682E6D617828302C612E6D617846696C6553697A652D63';
wwv_flow_imp.g_varchar2_table(3367) := '293B6C3E64262628733D21302C746869732E757070792E696E666F28746869732E6931386E28227265636F7264696E6753746F707065644D617853697A6522292C227761726E696E67222C346533292C2428746869732C7761295B77615D2829297D7D29';
wwv_flow_imp.g_varchar2_table(3368) := '2C2428746869732C6B65295B6B655D2E737461727428353030292C746869732E7265636F7264696E674C656E67746854696D65723D736574496E74657276616C2828293D3E7B6C6574206F3D746869732E676574506C7567696E537461746528292E7265';
wwv_flow_imp.g_varchar2_table(3369) := '636F7264696E674C656E6774685365636F6E64733B746869732E736574506C7567696E5374617465287B7265636F7264696E674C656E6774685365636F6E64733A6F2B317D297D2C316533292C746869732E736574506C7567696E5374617465287B6973';
wwv_flow_imp.g_varchar2_table(3370) := '5265636F7264696E673A21307D297D7D292C4F626A6563742E646566696E6550726F706572747928746869732C77612C7B7772697461626C653A21302C76616C75653A28293D3E6E65772050726F6D697365286F3D3E7B2428746869732C6B65295B6B65';
wwv_flow_imp.g_varchar2_table(3371) := '5D2E6164644576656E744C697374656E6572282273746F70222C28293D3E7B6F28297D292C2428746869732C6B65295B6B655D2E73746F7028292C636C656172496E74657276616C28746869732E7265636F7264696E674C656E67746854696D6572292C';
wwv_flow_imp.g_varchar2_table(3372) := '746869732E736574506C7567696E5374617465287B7265636F7264696E674C656E6774685365636F6E64733A307D297D292E7468656E2828293D3E28746869732E736574506C7567696E5374617465287B69735265636F7264696E673A21317D292C2428';
wwv_flow_imp.g_varchar2_table(3373) := '746869732C7363295B73635D282929292E7468656E286F3D3E7B7472797B2428746869732C5272295B52725D3D6F2C746869732E736574506C7567696E5374617465287B7265636F72646564417564696F3A55524C2E6372656174654F626A6563745552';
wwv_flow_imp.g_varchar2_table(3374) := '4C286F2E64617461297D297D63617463682861297B612E69735265737472696374696F6E7C7C746869732E757070792E6C6F672861297D7D292E7468656E2828293D3E7B2428746869732C4465295B44655D3D6E756C6C2C2428746869732C6B65295B6B';
wwv_flow_imp.g_varchar2_table(3375) := '655D3D6E756C6C7D2C6F3D3E7B7468726F77202428746869732C4465295B44655D3D6E756C6C2C2428746869732C6B65295B6B655D3D6E756C6C2C6F7D297D292C4F626A6563742E646566696E6550726F706572747928746869732C69632C7B77726974';
wwv_flow_imp.g_varchar2_table(3376) := '61626C653A21302C76616C75653A28293D3E7B746869732E736574506C7567696E5374617465287B7265636F72646564417564696F3A6E756C6C7D292C2428746869732C5272295B52725D3D6E756C6C7D7D292C4F626A6563742E646566696E6550726F';
wwv_flow_imp.g_varchar2_table(3377) := '706572747928746869732C72632C7B7772697461626C653A21302C76616C75653A28293D3E7B7472797B2428746869732C5272295B52725D2626746869732E757070792E61646446696C65282428746869732C5272295B52725D297D6361746368287329';
wwv_flow_imp.g_varchar2_table(3378) := '7B732E69735265737472696374696F6E7C7C746869732E757070792E6C6F6728732C227761726E696E6722297D7D7D292C4F626A6563742E646566696E6550726F706572747928746869732C55722C7B7772697461626C653A21302C76616C75653A6173';
wwv_flow_imp.g_varchar2_table(3379) := '796E6328293D3E7B2428746869732C6474295B64745D26262428746869732C6474295B64745D2E676574417564696F547261636B7328292E666F7245616368286F3D3E6F2E73746F702829292C2428746869732C6B65295B6B655D26266177616974206E';
wwv_flow_imp.g_varchar2_table(3380) := '65772050726F6D69736528733D3E7B2428746869732C6B65295B6B655D2E6164644576656E744C697374656E6572282273746F70222C732C7B6F6E63653A21307D292C2428746869732C6B65295B6B655D2E73746F7028292C636C656172496E74657276';
wwv_flow_imp.g_varchar2_table(3381) := '616C28746869732E7265636F7264696E674C656E67746854696D6572297D292C2428746869732C4465295B44655D3D6E756C6C2C2428746869732C6B65295B6B655D3D6E756C6C2C2428746869732C4172295B41725D3D21312C2428746869732C647429';
wwv_flow_imp.g_varchar2_table(3382) := '5B64745D3D6E756C6C2C746869732E736574506C7567696E5374617465287B7265636F72646564417564696F3A6E756C6C2C69735265636F7264696E673A21312C7265636F7264696E674C656E6774685365636F6E64733A307D297D7D292C4F626A6563';
wwv_flow_imp.g_varchar2_table(3383) := '742E646566696E6550726F706572747928746869732C6F632C7B7772697461626C653A21302C76616C75653A733D3E7B2428746869732C5572295B55725D28292C2428746869732C4E73295B4E735D287B64657669636549643A737D297D7D292C4F626A';
wwv_flow_imp.g_varchar2_table(3384) := '6563742E646566696E6550726F706572747928746869732C4C732C7B7772697461626C653A21302C76616C75653A28293D3E7B2428746869732C6374295B63745D2E656E756D65726174654465766963657328292E7468656E28733D3E7B746869732E73';
wwv_flow_imp.g_varchar2_table(3385) := '6574506C7567696E5374617465287B617564696F536F75726365733A732E66696C746572286F3D3E6F2E6B696E643D3D3D22617564696F696E70757422297D297D297D7D292C2428746869732C6374295B63745D3D6E6176696761746F722E6D65646961';
wwv_flow_imp.g_varchar2_table(3386) := '446576696365732C2428746869732C6261295B62615D3D2428746869732C6374295B63745D213D6E756C6C2C746869732E69643D746869732E6F7074732E69647C7C22417564696F222C746869732E747970653D226163717569726572222C746869732E';
wwv_flow_imp.g_varchar2_table(3387) := '69636F6E3D28293D3E752822737667222C7B636C6173734E616D653A22757070792D44617368626F6172645461622D69636F6E417564696F222C22617269612D68696464656E223A2274727565222C666F63757361626C653A2266616C7365222C776964';
wwv_flow_imp.g_varchar2_table(3388) := '74683A2233327078222C6865696768743A2233327078222C76696577426F783A22302030203332203332227D2C75282270617468222C7B643A224D32312E3134332031322E323937632E3437332030202E3835372E3338332E3835372E38353776322E35';
wwv_flow_imp.g_varchar2_table(3389) := '3732633020332E3031362D322E323420352E3531332D352E31343320352E39333176322E363468322E353732612E3835372E38353720302031313020312E3731344831322E3537612E3835372E3835372030203131302D312E37313468322E353732762D';
wwv_flow_imp.g_varchar2_table(3390) := '322E36344331322E32342032312E32342031302031382E3734322031302031352E373236762D322E353732612E3835372E3835372030203131312E373134203076322E35373241342E323920342E3239203020303031362032302E303161342E32392034';
wwv_flow_imp.g_varchar2_table(3391) := '2E32392030203030342E3238362D342E323835762D322E35373263302D2E3437342E3338342D2E3835372E3835372D2E3835377A4D313620362E3561332033203020303133203376366133203320302030312D362030762D36613320332030203031332D';
wwv_flow_imp.g_varchar2_table(3392) := '337A222C66696C6C3A2263757272656E74636F6C6F72222C2266696C6C2D72756C65223A226E6F6E7A65726F227D29292C746869732E64656661756C744C6F63616C653D56792C746869732E6F7074733D7B2E2E2E747D2C746869732E6931386E496E69';
wwv_flow_imp.g_varchar2_table(3393) := '7428292C746869732E7469746C653D746869732E6931386E2822706C7567696E4E616D65417564696F22292C746869732E736574506C7567696E5374617465287B686173417564696F3A21312C617564696F52656164793A21312C63616D657261457272';
wwv_flow_imp.g_varchar2_table(3394) := '6F723A6E756C6C2C7265636F7264696E674C656E6774685365636F6E64733A302C617564696F536F75726365733A5B5D2C63757272656E7444657669636549643A6E756C6C7D297D72656E64657228297B2428746869732C4172295B41725D7C7C242874';
wwv_flow_imp.g_varchar2_table(3395) := '6869732C4E73295B4E735D28293B6C657420653D746869732E676574506C7567696E537461746528293B72657475726E21652E617564696F52656164797C7C21652E686173417564696F3F752871792C7B69636F6E3A746869732E69636F6E2C6931386E';
wwv_flow_imp.g_varchar2_table(3396) := '3A746869732E6931386E2C686173417564696F3A652E686173417564696F7D293A75285A642C6E63287B7D2C652C7B617564696F4163746976653A2428746869732C4172295B41725D2C6F6E4368616E6765536F757263653A2428746869732C6F63295B';
wwv_flow_imp.g_varchar2_table(3397) := '6F635D2C6F6E53746172745265636F7264696E673A2428746869732C7463295B74635D2C6F6E53746F705265636F7264696E673A2428746869732C7761295B77615D2C6F6E446973636172645265636F72646564417564696F3A2428746869732C696329';
wwv_flow_imp.g_varchar2_table(3398) := '5B69635D2C6F6E5375626D69743A2428746869732C7263295B72635D2C6F6E53746F703A2428746869732C5572295B55725D2C6931386E3A746869732E6931386E2C73686F77417564696F536F7572636544726F70646F776E3A746869732E6F7074732E';
wwv_flow_imp.g_varchar2_table(3399) := '73686F77417564696F536F7572636544726F70646F776E2C737570706F7274735265636F7264696E673A4B6428292C7265636F7264696E673A652E69735265636F7264696E672C73747265616D3A2428746869732C6474295B64745D7D29297D696E7374';
wwv_flow_imp.g_varchar2_table(3400) := '616C6C28297B746869732E736574506C7567696E5374617465287B617564696F52656164793A21312C7265636F7264696E674C656E6774685365636F6E64733A307D293B6C65747B7461726765743A657D3D746869732E6F7074733B652626746869732E';
wwv_flow_imp.g_varchar2_table(3401) := '6D6F756E7428652C74686973292C2428746869732C6374295B63745D2626282428746869732C4C73295B4C735D28292C2428746869732C6374295B63745D2E6F6E6465766963656368616E67653D28293D3E7B6966282428746869732C4C73295B4C735D';
wwv_flow_imp.g_varchar2_table(3402) := '28292C2428746869732C6474295B64745D297B6C657420743D21302C7B617564696F536F75726365733A722C63757272656E7444657669636549643A737D3D746869732E676574506C7567696E537461746528293B722E666F7245616368286F3D3E7B73';
wwv_flow_imp.g_varchar2_table(3403) := '3D3D3D6F2E6465766963654964262628743D2131297D292C742626282428746869732C5572295B55725D28292C2428746869732C4E73295B4E735D2829297D7D297D756E696E7374616C6C28297B2428746869732C6474295B64745D2626242874686973';
wwv_flow_imp.g_varchar2_table(3404) := '2C5572295B55725D28292C746869732E756E6D6F756E7428297D7D3B6E286F732C22417564696F22293B66756E6374696F6E205A5328297B72657475726E202428746869732C6374295B63745D3F2428746869732C6374295B63745D2E656E756D657261';
wwv_flow_imp.g_varchar2_table(3405) := '74654465766963657328292E7468656E28693D3E692E736F6D6528653D3E652E6B696E643D3D3D22617564696F696E7075742229293A50726F6D6973652E7265736F6C7665282131297D6E285A532C225F686173417564696F436865636B3222293B6675';
wwv_flow_imp.g_varchar2_table(3406) := '6E6374696F6E20655028297B6C657420693D2428746869732C4465295B44655D2E66696E64286F3D3E7B76617220613B72657475726E2828613D6F2E74797065293D3D6E756C6C3F766F696420303A612E6C656E677468293E307D292E747970652C653D';
wwv_flow_imp.g_varchar2_table(3407) := '4B692869293B69662821652972657475726E2050726F6D6973652E72656A656374286E6577204572726F722860436F756C64206E6F74207265747269657665207265636F7264696E673A20556E737570706F72746564206D656469612074797065202224';
wwv_flow_imp.g_varchar2_table(3408) := '7B697D226029293B6C657420743D60617564696F2D247B446174652E6E6F7728297D2E247B657D602C723D6E657720426C6F62282428746869732C4465295B44655D2C7B747970653A697D292C733D7B736F757263653A746869732E69642C6E616D653A';
wwv_flow_imp.g_varchar2_table(3409) := '742C646174613A6E657720426C6F62285B725D2C7B747970653A697D292C747970653A697D3B72657475726E2050726F6D6973652E7265736F6C76652873297D6E2865502C225F676574417564696F3222293B6F732E56455253494F4E3D4A532E766572';
wwv_flow_imp.g_varchar2_table(3410) := '73696F6E3B7661722057793D7B737472696E67733A7B706C7567696E4E616D65426F783A22426F78227D7D3B7661722074503D7B76657273696F6E3A22322E322E30227D2C58693D636C61737320657874656E6473205A7B636F6E7374727563746F7228';
wwv_flow_imp.g_varchar2_table(3411) := '652C74297B737570657228652C74292C746869732E69643D746869732E6F7074732E69647C7C22426F78222C62652E696E6974506C7567696E28746869732C74292C746869732E7469746C653D746869732E6F7074732E7469746C657C7C22426F78222C';
wwv_flow_imp.g_varchar2_table(3412) := '746869732E69636F6E3D28293D3E752822737667222C7B636C6173734E616D653A22757070792D44617368626F6172645461622D69636F6E426F78222C22617269612D68696464656E223A2274727565222C666F63757361626C653A2266616C7365222C';
wwv_flow_imp.g_varchar2_table(3413) := '77696474683A223332222C6865696768743A223332222C76696577426F783A22302030203332203332227D2C75282267222C7B66696C6C3A2263757272656E74636F6C6F72222C66696C6C52756C653A226E6F6E7A65726F227D2C75282270617468222C';
wwv_flow_imp.g_varchar2_table(3414) := '7B643A226D31362E342031332E35632D312E3620302D3320302E392D332E3720322E322D302E372D312E332D322E312D322E322D332E372D322E322D3120302D312E3820302E332D322E3520302E38762D332E36632D302E312D302E332D302E352D302E';
wwv_flow_imp.g_varchar2_table(3415) := '372D312D302E37732D302E3820302E342D302E3820302E387637633020322E3320312E3920342E3220342E3220342E3220312E36203020332D302E3920332E372D322E3220302E3720312E3320322E3120322E3220332E3720322E3220322E3320302034';
wwv_flow_imp.g_varchar2_table(3416) := '2E322D312E3920342E322D342E3220302E312D322E342D312E382D342E332D342E312D342E336D2D372E3520362E38632D312E3420302D322E352D312E312D322E352D322E3573312E312D322E3520322E352D322E3520322E3520312E3120322E352032';
wwv_flow_imp.g_varchar2_table(3417) := '2E352D312E3120322E352D322E3520322E356D372E352030632D312E3420302D322E352D312E312D322E352D322E3573312E312D322E3520322E352D322E3520322E3520312E3120322E3520322E352D312E3120322E352D322E3520322E35227D292C75';
wwv_flow_imp.g_varchar2_table(3418) := '282270617468222C7B643A226D32372E322032302E366C2D322E332D322E3820322E332D322E3863302E332D302E3420302E322D302E392D302E322D312E32732D312D302E322D312E3320302E326C2D3220322E342D322D322E34632D302E332D302E34';
wwv_flow_imp.g_varchar2_table(3419) := '2D302E392D302E342D312E332D302E322D302E3420302E332D302E3520302E382D302E3220312E326C322E3320322E382D322E3320322E38632D302E3320302E342D302E3220302E3920302E3220312E32733120302E3220312E332D302E326C322D322E';
wwv_flow_imp.g_varchar2_table(3420) := '34203220322E3463302E3320302E3420302E3920302E3420312E3320302E3220302E342D302E3320302E342D302E3820302E322D312E32227D2929292C746869732E70726F76696465723D6E657720626528652C7B636F6D70616E696F6E55726C3A7468';
wwv_flow_imp.g_varchar2_table(3421) := '69732E6F7074732E636F6D70616E696F6E55726C2C636F6D70616E696F6E486561646572733A746869732E6F7074732E636F6D70616E696F6E486561646572732C636F6D70616E696F6E4B657973506172616D733A746869732E6F7074732E636F6D7061';
wwv_flow_imp.g_varchar2_table(3422) := '6E696F6E4B657973506172616D732C636F6D70616E696F6E436F6F6B69657352756C653A746869732E6F7074732E636F6D70616E696F6E436F6F6B69657352756C652C70726F76696465723A22626F78222C706C7567696E49643A746869732E69642C73';
wwv_flow_imp.g_varchar2_table(3423) := '7570706F72747352656672657368546F6B656E3A21317D292C746869732E64656661756C744C6F63616C653D57792C746869732E6931386E496E697428292C746869732E7469746C653D746869732E6931386E2822706C7567696E4E616D65426F782229';
wwv_flow_imp.g_varchar2_table(3424) := '2C746869732E6F6E466972737452656E6465723D746869732E6F6E466972737452656E6465722E62696E642874686973292C746869732E72656E6465723D746869732E72656E6465722E62696E642874686973297D696E7374616C6C28297B746869732E';
wwv_flow_imp.g_varchar2_table(3425) := '766965773D6E6577204E6528746869732C7B70726F76696465723A746869732E70726F76696465722C6C6F6164416C6C46696C65733A21307D293B6C65747B7461726765743A657D3D746869732E6F7074733B652626746869732E6D6F756E7428652C74';
wwv_flow_imp.g_varchar2_table(3426) := '686973297D756E696E7374616C6C28297B746869732E766965772E74656172446F776E28292C746869732E756E6D6F756E7428297D6F6E466972737452656E64657228297B72657475726E20746869732E766965772E676574466F6C64657228297D7265';
wwv_flow_imp.g_varchar2_table(3427) := '6E6465722865297B72657475726E20746869732E766965772E72656E6465722865297D7D3B6E2858692C22426F7822293B58692E56455253494F4E3D74502E76657273696F6E3B7661722047793D7B737472696E67733A7B706C7567696E4E616D654472';
wwv_flow_imp.g_varchar2_table(3428) := '6F70626F783A2244726F70626F78227D7D3B7661722069503D7B76657273696F6E3A22332E322E30227D2C59693D636C61737320657874656E6473205A7B636F6E7374727563746F7228652C74297B737570657228652C74292C746869732E69643D7468';
wwv_flow_imp.g_varchar2_table(3429) := '69732E6F7074732E69647C7C2244726F70626F78222C62652E696E6974506C7567696E28746869732C74292C746869732E7469746C653D746869732E6F7074732E7469746C657C7C2244726F70626F78222C746869732E69636F6E3D28293D3E75282273';
wwv_flow_imp.g_varchar2_table(3430) := '7667222C7B636C6173734E616D653A22757070792D44617368626F6172645461622D69636F6E44726F70626F78222C22617269612D68696464656E223A2274727565222C666F63757361626C653A2266616C7365222C77696474683A223332222C686569';
wwv_flow_imp.g_varchar2_table(3431) := '6768743A223332222C76696577426F783A22302030203332203332227D2C75282270617468222C7B643A224D31302E3520372E354C352031302E3935356C352E3520332E34353420352E352D332E34353420352E3520332E34353420352E352D332E3435';
wwv_flow_imp.g_varchar2_table(3432) := '344C32312E3520372E352031362031302E3935357A4D31302E352032312E3331394C352031372E3836346C352E352D332E34353520352E3520332E3435357A4D31362031372E3836346C352E352D332E34353520352E3520332E3435352D352E3520332E';
wwv_flow_imp.g_varchar2_table(3433) := '3435357A4D31362032352E3932356C2D352E352D332E34353520352E352D332E34353420352E3520332E3435347A222C66696C6C3A2263757272656E74636F6C6F72222C66696C6C52756C653A226E6F6E7A65726F227D29292C746869732E70726F7669';
wwv_flow_imp.g_varchar2_table(3434) := '6465723D6E657720626528652C7B636F6D70616E696F6E55726C3A746869732E6F7074732E636F6D70616E696F6E55726C2C636F6D70616E696F6E486561646572733A746869732E6F7074732E636F6D70616E696F6E486561646572732C636F6D70616E';
wwv_flow_imp.g_varchar2_table(3435) := '696F6E4B657973506172616D733A746869732E6F7074732E636F6D70616E696F6E4B657973506172616D732C636F6D70616E696F6E436F6F6B69657352756C653A746869732E6F7074732E636F6D70616E696F6E436F6F6B69657352756C652C70726F76';
wwv_flow_imp.g_varchar2_table(3436) := '696465723A2264726F70626F78222C706C7567696E49643A746869732E69642C737570706F72747352656672657368546F6B656E3A21307D292C746869732E64656661756C744C6F63616C653D47792C746869732E6931386E496E697428292C74686973';
wwv_flow_imp.g_varchar2_table(3437) := '2E7469746C653D746869732E6931386E2822706C7567696E4E616D6544726F70626F7822292C746869732E6F6E466972737452656E6465723D746869732E6F6E466972737452656E6465722E62696E642874686973292C746869732E72656E6465723D74';
wwv_flow_imp.g_varchar2_table(3438) := '6869732E72656E6465722E62696E642874686973297D696E7374616C6C28297B746869732E766965773D6E6577204E6528746869732C7B70726F76696465723A746869732E70726F76696465722C6C6F6164416C6C46696C65733A21307D293B6C65747B';
wwv_flow_imp.g_varchar2_table(3439) := '7461726765743A657D3D746869732E6F7074733B652626746869732E6D6F756E7428652C74686973297D756E696E7374616C6C28297B746869732E766965772E74656172446F776E28292C746869732E756E6D6F756E7428297D6F6E466972737452656E';
wwv_flow_imp.g_varchar2_table(3440) := '64657228297B72657475726E2050726F6D6973652E616C6C285B746869732E70726F76696465722E666574636850726541757468546F6B656E28292C746869732E766965772E676574466F6C64657228295D297D72656E6465722865297B72657475726E';
wwv_flow_imp.g_varchar2_table(3441) := '20746869732E766965772E72656E6465722865297D7D3B6E2859692C2244726F70626F7822293B59692E56455253494F4E3D69502E76657273696F6E3B766172204B793D7B737472696E67733A7B706C7567696E4E616D6546616365626F6F6B3A224661';
wwv_flow_imp.g_varchar2_table(3442) := '6365626F6F6B227D7D3B7661722072503D7B76657273696F6E3A22332E322E30227D2C51693D636C61737320657874656E6473205A7B636F6E7374727563746F7228652C74297B737570657228652C74292C746869732E69643D746869732E6F7074732E';
wwv_flow_imp.g_varchar2_table(3443) := '69647C7C2246616365626F6F6B222C62652E696E6974506C7567696E28746869732C74292C746869732E7469746C653D746869732E6F7074732E7469746C657C7C2246616365626F6F6B222C746869732E69636F6E3D28293D3E752822737667222C7B22';
wwv_flow_imp.g_varchar2_table(3444) := '617269612D68696464656E223A2274727565222C666F63757361626C653A2266616C7365222C77696474683A223332222C6865696768743A223332222C76696577426F783A22302030203332203332227D2C75282267222C7B66696C6C3A226E6F6E6522';
wwv_flow_imp.g_varchar2_table(3445) := '2C66696C6C52756C653A226576656E6F6464227D2C75282270617468222C7B643A224D323720313663302D362E3037352D342E3932352D31312D31312D3131533520392E3932352035203136633020352E343920342E3032332031302E30343120392E32';
wwv_flow_imp.g_varchar2_table(3446) := '38312031302E3836365631392E3138682D322E37393356313668322E373933762D322E34323363302D322E37353720312E3634322D342E323820342E3135352D342E323820312E323034203020322E3436322E32313520322E3436322E32313576322E37';
wwv_flow_imp.g_varchar2_table(3447) := '3037682D312E333837632D312E33363620302D312E3739322E3834382D312E37393220312E37313856313668332E30356C2D2E34383720332E3138682D322E35363376372E3638364332322E3937372032362E3034312032372032312E34392032372031';
wwv_flow_imp.g_varchar2_table(3448) := '36222C66696C6C3A2223313737374632227D292C75282270617468222C7B643A224D32302E3238322031392E31384C32302E3737203136682D332E303531762D322E30363363302D2E38372E3432362D312E37313820312E3739322D312E37313868312E';
wwv_flow_imp.g_varchar2_table(3449) := '33383756392E353132732D312E3235382D2E3231352D322E3436322D2E323135632D322E35313320302D342E31353520312E3532332D342E31353520342E3238563136682D322E37393376332E313868322E37393376372E3638366131312E3038322031';
wwv_flow_imp.g_varchar2_table(3450) := '312E3038322030203030332E34333820305631392E313868322E353633222C66696C6C3A2223464646464645227D2929292C746869732E70726F76696465723D6E657720626528652C7B636F6D70616E696F6E55726C3A746869732E6F7074732E636F6D';
wwv_flow_imp.g_varchar2_table(3451) := '70616E696F6E55726C2C636F6D70616E696F6E486561646572733A746869732E6F7074732E636F6D70616E696F6E486561646572732C636F6D70616E696F6E4B657973506172616D733A746869732E6F7074732E636F6D70616E696F6E4B657973506172';
wwv_flow_imp.g_varchar2_table(3452) := '616D732C636F6D70616E696F6E436F6F6B69657352756C653A746869732E6F7074732E636F6D70616E696F6E436F6F6B69657352756C652C70726F76696465723A2266616365626F6F6B222C706C7567696E49643A746869732E69642C737570706F7274';
wwv_flow_imp.g_varchar2_table(3453) := '7352656672657368546F6B656E3A21317D292C746869732E64656661756C744C6F63616C653D4B792C746869732E6931386E496E697428292C746869732E7469746C653D746869732E6931386E2822706C7567696E4E616D6546616365626F6F6B22292C';
wwv_flow_imp.g_varchar2_table(3454) := '746869732E6F6E466972737452656E6465723D746869732E6F6E466972737452656E6465722E62696E642874686973292C746869732E72656E6465723D746869732E72656E6465722E62696E642874686973297D696E7374616C6C28297B746869732E76';
wwv_flow_imp.g_varchar2_table(3455) := '6965773D6E6577204E6528746869732C7B70726F76696465723A746869732E70726F76696465727D293B6C65747B7461726765743A657D3D746869732E6F7074733B652626746869732E6D6F756E7428652C74686973297D756E696E7374616C6C28297B';
wwv_flow_imp.g_varchar2_table(3456) := '746869732E766965772E74656172446F776E28292C746869732E756E6D6F756E7428297D6F6E466972737452656E64657228297B72657475726E2050726F6D6973652E616C6C285B746869732E70726F76696465722E666574636850726541757468546F';
wwv_flow_imp.g_varchar2_table(3457) := '6B656E28292C746869732E766965772E676574466F6C64657228295D297D72656E6465722865297B6C657420743D7B7D3B72657475726E20746869732E676574506C7567696E537461746528292E66696C65732E6C656E677468262621746869732E6765';
wwv_flow_imp.g_varchar2_table(3458) := '74506C7567696E537461746528292E666F6C646572732E6C656E677468262628742E76696577547970653D2267726964222C742E73686F7746696C7465723D21312C742E73686F775469746C65733D2131292C746869732E766965772E72656E64657228';
wwv_flow_imp.g_varchar2_table(3459) := '652C74297D7D3B6E2851692C2246616365626F6F6B22293B51692E56455253494F4E3D72502E76657273696F6E3B76617220576F3D636C61737320657874656E6473204E657B746F67676C65436865636B626F7828652C74297B652E73746F7050726F70';
wwv_flow_imp.g_varchar2_table(3460) := '61676174696F6E28292C652E70726576656E7444656661756C7428292C742E637573746F6D2E697353686172656444726976657C7C73757065722E746F67676C65436865636B626F7828652C74297D7D3B6E28576F2C22447269766550726F7669646572';
wwv_flow_imp.g_varchar2_table(3461) := '566965777322293B7661722058793D7B737472696E67733A7B706C7567696E4E616D65476F6F676C6544726976653A22476F6F676C65204472697665227D7D3B7661722073503D7B76657273696F6E3A22332E342E30227D2C4A693D636C617373206578';
wwv_flow_imp.g_varchar2_table(3462) := '74656E6473205A7B636F6E7374727563746F7228652C74297B737570657228652C74292C746869732E69643D746869732E6F7074732E69647C7C22476F6F676C654472697665222C746869732E7469746C653D746869732E6F7074732E7469746C657C7C';
wwv_flow_imp.g_varchar2_table(3463) := '22476F6F676C65204472697665222C62652E696E6974506C7567696E28746869732C74292C746869732E7469746C653D746869732E6F7074732E7469746C657C7C22476F6F676C65204472697665222C746869732E69636F6E3D28293D3E752822737667';
wwv_flow_imp.g_varchar2_table(3464) := '222C7B22617269612D68696464656E223A2274727565222C666F63757361626C653A2266616C7365222C77696474683A223332222C6865696768743A223332222C76696577426F783A22302030203332203332227D2C75282267222C7B66696C6C52756C';
wwv_flow_imp.g_varchar2_table(3465) := '653A226E6F6E7A65726F222C66696C6C3A226E6F6E65227D2C75282270617468222C7B643A224D362E3636332032322E3238346C2E393720312E3632632E3230322E33342E3439322E3630392E3833322E3830346C332E3436352D352E37393848356330';
wwv_flow_imp.g_varchar2_table(3466) := '202E3337382E312E3735352E33303220312E3039366C312E33363120322E3237387A222C66696C6C3A2223303036364441227D292C75282270617468222C7B643A224D31362031322E30396C2D332E3436352D352E373938632D2E33342E3139352D2E36';
wwv_flow_imp.g_varchar2_table(3467) := '332E3436332D2E3833322E3830346C2D362E342031302E37313841322E313520322E31352030203030352031382E393168362E39334C31362031322E30397A222C66696C6C3A2223303041433437227D292C75282270617468222C7B643A224D32332E35';
wwv_flow_imp.g_varchar2_table(3468) := '33352032342E373038632E33342D2E3139352E36332D2E3436332E3833322D2E3830346C2E3430332D2E363720312E3932382D332E323238632E3230312D2E33342E3330322D2E3731382E3330322D312E303936682D362E39336C312E34373420322E38';
wwv_flow_imp.g_varchar2_table(3469) := '303220312E39393120322E3939367A222C66696C6C3A2223454134333335227D292C75282270617468222C7B643A224D31362031322E30396C332E3436352D352E37393841322E32373420322E323734203020303031382E3333312036682D342E363632';
wwv_flow_imp.g_varchar2_table(3470) := '632D2E34303320302D2E3739342E31312D312E3133342E3239324C31362031322E30397A222C66696C6C3A2223303038333244227D292C75282270617468222C7B643A224D32302E30372031382E3931682D382E31346C2D332E34363520352E37393863';
wwv_flow_imp.g_varchar2_table(3471) := '2E33342E3139352E37332E32393220312E3133342E3239326831322E383032632E3430332030202E3739342D2E313120312E3133342D2E3239324C32302E30372031382E39317A222C66696C6C3A2223323638344643227D292C75282270617468222C7B';
wwv_flow_imp.g_varchar2_table(3472) := '643A224D32332E3439372031322E3435356C2D332E322D352E33353961322E32353220322E32353220302030302D2E3833322D2E3830344C31362031322E30396C342E303720362E383268362E39313763302D2E3337372D2E312D2E3735352D2E333032';
wwv_flow_imp.g_varchar2_table(3473) := '2D312E3039366C2D332E3138382D352E3335397A222C66696C6C3A2223464642413030227D2929292C746869732E70726F76696465723D6E657720626528652C7B636F6D70616E696F6E55726C3A746869732E6F7074732E636F6D70616E696F6E55726C';
wwv_flow_imp.g_varchar2_table(3474) := '2C636F6D70616E696F6E486561646572733A746869732E6F7074732E636F6D70616E696F6E486561646572732C636F6D70616E696F6E4B657973506172616D733A746869732E6F7074732E636F6D70616E696F6E4B657973506172616D732C636F6D7061';
wwv_flow_imp.g_varchar2_table(3475) := '6E696F6E436F6F6B69657352756C653A746869732E6F7074732E636F6D70616E696F6E436F6F6B69657352756C652C70726F76696465723A226472697665222C706C7567696E49643A746869732E69642C737570706F72747352656672657368546F6B65';
wwv_flow_imp.g_varchar2_table(3476) := '6E3A21307D292C746869732E64656661756C744C6F63616C653D58792C746869732E6931386E496E697428292C746869732E7469746C653D746869732E6931386E2822706C7567696E4E616D65476F6F676C65447269766522292C746869732E6F6E4669';
wwv_flow_imp.g_varchar2_table(3477) := '72737452656E6465723D746869732E6F6E466972737452656E6465722E62696E642874686973292C746869732E72656E6465723D746869732E72656E6465722E62696E642874686973297D696E7374616C6C28297B746869732E766965773D6E65772057';
wwv_flow_imp.g_varchar2_table(3478) := '6F28746869732C7B70726F76696465723A746869732E70726F76696465722C6C6F6164416C6C46696C65733A21307D293B6C65747B7461726765743A657D3D746869732E6F7074733B652626746869732E6D6F756E7428652C74686973297D756E696E73';
wwv_flow_imp.g_varchar2_table(3479) := '74616C6C28297B746869732E766965772E74656172446F776E28292C746869732E756E6D6F756E7428297D6F6E466972737452656E64657228297B72657475726E2050726F6D6973652E616C6C285B746869732E70726F76696465722E66657463685072';
wwv_flow_imp.g_varchar2_table(3480) := '6541757468546F6B656E28292C746869732E766965772E676574466F6C6465722822726F6F7422295D297D72656E6465722865297B72657475726E20746869732E766965772E72656E6465722865297D7D3B6E284A692C22476F6F676C65447269766522';
wwv_flow_imp.g_varchar2_table(3481) := '293B4A692E56455253494F4E3D73502E76657273696F6E3B7661722059793D7B737472696E67733A7B706C7567696E4E616D65496E7374616772616D3A22496E7374616772616D227D7D3B766172206F503D7B76657273696F6E3A22332E322E30227D2C';
wwv_flow_imp.g_varchar2_table(3482) := '5A693D636C61737320657874656E6473205A7B636F6E7374727563746F7228652C74297B737570657228652C74292C746869732E69643D746869732E6F7074732E69647C7C22496E7374616772616D222C62652E696E6974506C7567696E28746869732C';
wwv_flow_imp.g_varchar2_table(3483) := '74292C746869732E69636F6E3D28293D3E752822737667222C7B22617269612D68696464656E223A2274727565222C666F63757361626C653A2266616C7365222C77696474683A223332222C6865696768743A223332222C76696577426F783A22302030';
wwv_flow_imp.g_varchar2_table(3484) := '203332203332227D2C75282264656673222C6E756C6C2C75282270617468222C7B643A224D31362E38323520356C2E3438332D2E3030312E3739392E30303263312E3136382E30303520312E3539382E30323120322E3430372E30353720312E31372E30';
wwv_flow_imp.g_varchar2_table(3485) := '3520312E39372E32333520322E36372E3530362E3732352E323820312E33342E36353520312E39353120312E3236352E3631332E36312E393920312E32323320312E32373320312E3934362E3237332E372E343620312E3439382E35313620322E36376C';
wwv_flow_imp.g_varchar2_table(3486) := '2E3032352E3535322E3030382E323035632E3032392E3734382E30333720312E35312E30343220332E3737376C2E3030312E383436762E3730336C2D2E3030312E3339386135302E38322035302E383220302030312D2E30353820322E353838632D2E30';
wwv_flow_imp.g_varchar2_table(3487) := '3520312E31372D2E32333520312E39372D2E35303620322E363761352E33393420352E33393420302030312D312E32363520312E393531632D2E36312E3631332D312E3232322E39392D312E39343620312E3237332D2E3639392E3237332D312E343938';
wwv_flow_imp.g_varchar2_table(3488) := '2E34362D322E3636382E3531362D2E3234332E3031322D2E3435312E3032322D2E3635362E30336C2D2E3230342E303037632D2E3731392E3032362D312E3531322E3033342D332E3637362E3033386C2D2E3834372E303031682D312E316135302E3237';
wwv_flow_imp.g_varchar2_table(3489) := '392035302E32373920302030312D322E3538372D2E303539632D312E3137312D2E30352D312E3937312D2E3233352D322E3637312D2E35303661352E33393420352E33393420302030312D312E3935312D312E32363520352E33383520352E3338352030';
wwv_flow_imp.g_varchar2_table(3490) := '2030312D312E3237322D312E393436632D2E3237342D2E3639392D2E34362D312E3439382D2E3531372D322E3636386138382E31352038382E313520302030312D2E30332D2E3635366C2D2E3030372D2E323035632D2E3032362D2E3731382D2E303334';
wwv_flow_imp.g_varchar2_table(3491) := '2D312E3531322D2E3033382D332E363734762D322E313239632E3030362D312E3136382E3032322D312E3539372E3035382D322E3430362E3035312D312E3137312E3233352D312E3937312E3530362D322E36373261352E333920352E33392030203031';
wwv_flow_imp.g_varchar2_table(3492) := '312E3236352D312E393520352E33383120352E3338312030203031312E3934362D312E323732632E3639392D2E32373420312E3439382D2E34363220322E3636392D2E3531376C2E3635362D2E30332E3230342D2E303037632E3731382D2E3032362031';
wwv_flow_imp.g_varchar2_table(3493) := '2E3531312D2E30333420332E3637342D2E3033387A6D2E36373820312E393831682D312E3232366C2D2E3239352E303031632D322E3330372E3030352D332E3031362E3031332D332E3737372E3034336C2D2E32312E3030392D2E3435372E3032632D31';
wwv_flow_imp.g_varchar2_table(3494) := '2E3037322E3035322D312E3635342E3233322D322E3034322E3338332D2E3531332E322D2E3837392E34342D312E3236332E38323561332E34313320332E34313320302030302D2E383220312E323637632D2E31352E3338382D2E33332E39372D2E3337';
wwv_flow_imp.g_varchar2_table(3495) := '3520322E3034336134382E38392034382E383920302030302D2E30353620322E343832762E33393820312E353635632E30303620322E3933372E30313820332E3238352E30373320342E3434342E303520312E3037332E32333120312E3635342E333832';
wwv_flow_imp.g_varchar2_table(3496) := '20322E3034332E322E3531322E34342E3837382E38323520312E3236332E3338362E3338332E3735332E36323120312E3236372E38322E3338382E31352E39372E33323820322E3034332E3337342E3230372E30312E3338382E3031372E3536332E3032';
wwv_flow_imp.g_varchar2_table(3497) := '346C2E3230382E3030376136332E32382036332E32382030203030322E3130392E30323668312E35363463322E3933382D2E30303620332E3238362D2E30313920342E3434362D2E30373320312E3037312D2E30353120312E3635342D2E32333220322E';
wwv_flow_imp.g_varchar2_table(3498) := '30342D2E3338332E3531342D2E322E38382D2E343420312E3236342D2E3832352E3338342D2E3338362E3632322D2E3735332E38322D312E3236362E31352D2E3338392E3332382D2E3937312E3337352D322E3034342E3033392D2E38382E3035342D31';
wwv_flow_imp.g_varchar2_table(3499) := '2E3239322E3035372D322E373233762D312E31352D2E353732632D2E3030362D322E3933362D2E3031392D332E3238342D2E3037342D342E3434352D2E30352D312E3037312D2E32332D312E3635342D2E3338322D322E30342D2E322D2E3531352D2E34';
wwv_flow_imp.g_varchar2_table(3500) := '342D2E38382D2E3832352D312E32363461332E34303520332E34303520302030302D312E3236372D2E3832632D2E3338382D2E31352D2E39372D2E3332382D322E3034322D2E3337356134382E3938372034382E39383720302030302D322E3533352D2E';
wwv_flow_imp.g_varchar2_table(3501) := '3035367A6D2D312E35313520332E333761352E363520352E363520302031312E3032312031312E32393920352E363520352E363520302030312D2E30322D31312E337A6D2E30303420312E39383261332E36363720332E36363720302031302E30313520';
wwv_flow_imp.g_varchar2_table(3502) := '372E33333420332E36363720332E36363720302030302D2E3031352D372E3333347A6D352E3836352D332E35333661312E333220312E333220302031312E30303520322E363420312E333220312E333220302030312D2E3030352D322E36347A222C6964';
wwv_flow_imp.g_varchar2_table(3503) := '3A2261227D29292C75282267222C7B66696C6C3A226E6F6E65222C2266696C6C2D72756C65223A226576656E6F6464227D2C7528226D61736B222C7B69643A2262222C66696C6C3A2223666666227D2C752822757365222C7B786C696E6B487265663A22';
wwv_flow_imp.g_varchar2_table(3504) := '2361227D29292C752822696D616765222C7B6D61736B3A2275726C28236229222C783A2234222C793A2234222C77696474683A223234222C6865696768743A223234222C786C696E6B487265663A22646174613A696D6167652F706E673B626173653634';
wwv_flow_imp.g_varchar2_table(3505) := '2C6956424F5277304B47676F414141414E53556845556741414143774141414173434159414141416568466F424141414141584E535230494172733463365141414145526C57456C6D545530414B67414141416741415964704141514141414142414141';
wwv_flow_imp.g_varchar2_table(3506) := '4147674141414141414136414241414D414141414241414541414B41434141514141414142414141414C4B41444141514141414142414141414C414141414144386275656A4141414C5A6B6C45515652594356575A43324C624E68414643524B796B7650';
wwv_flow_imp.g_varchar2_table(3507) := '306244313530365378524B497A6277484A6F55336A76356839574943553350372B367A6C47327A5A767238732F725731744E375530724D6C6C386144597566647A624C6663314A486D7076336A7050793874734F2B334F32732F4F36594D536A546C2F71';
wwv_flow_imp.g_varchar2_table(3508) := '64436473346D49494736306D38766471325A2B70686D325634764162392B6F3742625A65756F4D304E7959617A76547662766C4E314D476A48554165735A2F4957574F7343654630424F77414B34495452305759642F514B48455076324445796D6D6F72';
wwv_flow_imp.g_varchar2_table(3509) := '5A746975626A4F48454D59457A586D4339474D78752B39354B7A2B6B7577786A44424B623869556F434164715A6F416579414C726557365A4E783959344A7A38634C776A545A4F456F522B485530356B32527A6750326961664767665A6945645A624572';
wwv_flow_imp.g_varchar2_table(3510) := '39347A70582F786B50744474474178462B4C5263675473703943415A6730726E456E586D50714673685935764C6E5657784C584F2F62616832735A5167425A7070475365384E626A4E504E356B632F57624959456E38552B6A58434F657A54347A666753';
wwv_flow_imp.g_varchar2_table(3511) := '31656F564568636556654B37344665344E36436F59456F4C57796B7A4873642B474D41557164545456767671543175577142336C56434C6231322F4F524165382F355A75396D70376C716F454655434146444978717A37693162713241593155396A7171';
wwv_flow_imp.g_varchar2_table(3512) := '32514B2F3744596C2B3141655A6C41466345632B552F6A6B52557173764348512F6E7947766A724F6C3645755A5752575647434B554D436B6E7451356F2B7532415A334F78616B6254636F425A6E59307868674743554D344B7031787442546E426E584D';
wwv_flow_imp.g_varchar2_table(3513) := '354153526D732F46733764394F70583862584E343570696251592F4D4C314D6D4135473943494E4275437064667465787236693263357164394A3434314C4E4A6D337A6B31475675734A3776366D504A374850784A52304C692F7667394F315848544567';
wwv_flow_imp.g_varchar2_table(3514) := '7673516F5367457855304E6E6C4C463070614B2B36643036614F4D4B45326E434B56306F664E77345773576D4C73577276366C504C6E684770723945313337516B484F4D422F6A682F54384D4F714F61645861725234347A504257354E764463636E4278';
wwv_flow_imp.g_varchar2_table(3515) := '566D644B38312B375251357036716E516F52445A5068392B78576A304E32587071785831487A4D747939556C466E4B79612F683367756C7A6941737978776B536D7054495042387661674B4C796B74526444754245484E475A4D6D346F434657676A7133';
wwv_flow_imp.g_varchar2_table(3516) := '31575048706143393367474E71704F705034457A347370612B6E4D4E766854576375504B414A373966714978566F5576646A45473971537932576870516C7A363179472F676E4B454132354972494F594B364449735173324545394C522F73544B713338';
wwv_flow_imp.g_varchar2_table(3517) := '4E6431792F582F2F465847305144486B4571537A334559565632646862303072674C50534463716D7253637335354E4E4F44327A56714B6D596E5954466E6B414370353230646B57357642784B393942567A723739322F695A2B56566F3932556B4B5532';
wwv_flow_imp.g_varchar2_table(3518) := '6F473557465462366D4E694131483243384B43304534347161516C655233455176514E774C7245434F56416953774D35677046376E76444E44306C5A76597551394A625A6671645472714367774D6356725253307A39516B4C75394E576D6B6745486238';
wwv_flow_imp.g_varchar2_table(3519) := '70327A4452796C6A39565741336C584432764F6245645770543377354D6946715131572F6C74654734656970617374787632772B54655442503079704B383448694F573966557A4C636A524477435732623256786D6E47534B545836755253774D6E4339';
wwv_flow_imp.g_varchar2_table(3520) := '5958346C30354D68327577492B5156576457554F5354576435586A6A66372F7450596B32737453683035335854474E35524A4D434D53616A4D63533854726E336A2F4531616A74686C78436B6D4A5856693437505355737979712B6A796578736179514E';
wwv_flow_imp.g_varchar2_table(3521) := '7576354756594A61737A70724E73514433526B6759697934396B466C324A6C4A4A786C663855752F6C706B71372B6157717A457A6A72356354567046614A7653567238414B527469546C5650466B3574316E4F3330572B6F366A7262416B37366B784661';
wwv_flow_imp.g_varchar2_table(3522) := '2F74582B646F6D3443317744506B303367714377384854425378783446487849412B6D6832704D33724B7535534E714241754F535A6E487A7342394A77573744562F676538646C56734F6833373550764838594F3845414C553148756563494336715167';
wwv_flow_imp.g_varchar2_table(3523) := '5869664E7553783958416F4C616F474959446A6B57467261775831553158726B6E754D4677375142535074673739586F766D427677716E4449437268436C454F3677674B466A397650714A576C7468557664674831444F41382B77464D65787A51633542';
wwv_flow_imp.g_varchar2_table(3524) := '555331643149736442536A4576344665314C67424F3143704650547056314A755053464E7434792F74727A6274615566774257774D332F364A73724C364D535159774C4B58416D39594A4278734D383939324D626C5A363347616D69302B726E774F4D79';
wwv_flow_imp.g_varchar2_table(3525) := '50796B56705173796C3965594E4F665643366B52426B77616F702F2F4C6763414B5769766B484637393167304A4B356B4D6D43674B5061733251526B554651737554766D365231393436576739356B3736345A524C573539794F3555564773617777454C';
wwv_flow_imp.g_varchar2_table(3526) := '757043664162644375417776637A35586B313872495645646753524252674F37375232303651645848754132676F614769435130476D55664E314A6C6D4661796A763049634B476B6659743448416A30797551425247446A7A75532F72546D4166323947';
wwv_flow_imp.g_varchar2_table(3527) := '6F7631532B464637514261794E63706F424F45734D74337646634955433756784F6E452B70786D6B6771457A64757A777350796B726A42737A43757367646172735249414C36434D2F4B71737163416631766A385031545846794E3665354738616F3438';
wwv_flow_imp.g_varchar2_table(3528) := '666A4B6644514A59697A49644966622B587770365A3266453243376D556655457A4D4B715342703456555631413439537A314D324C7A567A616845667948554163514E6C7452306E4144596B42764858445A516F38483964517648463771686A5074536F';
wwv_flow_imp.g_varchar2_table(3529) := '6C424A30412F76614C7764527A35594646476F57427938452F34614B636A71696D61554258586E6A42707A4F5A6E4D6C49565873545645424255612B64443042523078566F706741443730707359304B6A4D48706D4842326B41706561396F32334E5338';
wwv_flow_imp.g_varchar2_table(3530) := '336D7073726566354F5A657434552F30434D6853454470776E7842396C564B53666B35646A6C6C58524650697A516D4B63714D706E795A337963506E74663936596D3943687A55387643516E6867575A32557579534172772B635642473467714E435336';
wwv_flow_imp.g_varchar2_table(3531) := '596F5345457A6952575653744B55706534466643643931563058412F71674F4A7546374670476A6A79516773466F4E447469627038636D2B637958786242367A6834704D554F34483036797A737634452F413672672F75524A526E4D526D72684D444968';
wwv_flow_imp.g_varchar2_table(3532) := '794F6A41425839434D4446684246787831394B756A6A715765696D35507756465536494269657766796B3749504554636735326B6A584E376E7362616F45796B4B662F636A5567567870545A5A56746E71464D677634464861386F534F69736177696E4D';
wwv_flow_imp.g_varchar2_table(3533) := '4C486655427A4A634B316A38426571717565644B44746763676E413462796D34503667425759564D33572F706E34316B75354C3452456C4657746C6B35535848455468684F574469497956524F6C514E4D2B777948696D6C674154492F5050496D344242';
wwv_flow_imp.g_varchar2_table(3534) := '3871667177486E68674C3839677A732B57773178516234383231535A2F3449774F4A695271482F58397537486A30384A4C535A6661774F516370527A77676B316F424E7A7A63674C6E3146424E4873704D454E696B394F47346177494461556A7739724B';
wwv_flow_imp.g_varchar2_table(3535) := '4E54314B58506C396E657561367353626B677166732F434E6642644E6644446851754C34414B584558654F675A49443931654F6952556E45464F494135726E546B4255302F495430356742796F71354B424A463448796D34507868335563785A37486A64';
wwv_flow_imp.g_varchar2_table(3536) := '6845684B575552626861764E5239726A4C42776B337279446372477A66766B39493639623179684D4757513462714D77762F524D53706C516B6A6A564B587A5A583877455356637542375147305955434D6A6B2F614F6D5767632F7643346F4D43565966';
wwv_flow_imp.g_varchar2_table(3537) := '6768494750364D54317A706555684D3172517A4F6E47786D464B77544369723158616A35764E3754376E445A766E6244474862434B6E776A69327A6F664E734F76626F6C64337A6C55744B476F7342756E3350624A537272526548456143515643494445';
wwv_flow_imp.g_varchar2_table(3538) := '4D61434342732B502B416279626B6249686D624E65634777462B45352F4C32454375504B435773554553516B4B6E79794A3933544741436B374F72415939503858472F2F6647436F4D3744414555476E6A354D7737615166656C7953574F6D3969507546';
wwv_flow_imp.g_varchar2_table(3539) := '7976724C38724B5152366D4D3671644355445173664E5056753479762F4861504F5431652F79446176694D4B6D546B672F492F46374D5547394F6C726D4472424C5256643363384B424A6C50454B6F565263494A75686F51416D5A44556B504330305735';
wwv_flow_imp.g_varchar2_table(3540) := '4F4931644F7051314636316B464E717239536D46636148644268654F6144484636515A4D4F50365179695A3830346F6A3938774C69414D4967635777345544596B44415766522B34643573307A50324767555A583034692B4E65536759476F6B76624468';
wwv_flow_imp.g_varchar2_table(3541) := '495A595557486764394B387A5A7A69723236344E785A55466273664D316A64717056326E61413438747836687376425361624534494D746C634F476771385071436A6F6C7932727732736F717934524A575174505A6C365055435531345A5557454E755A';
wwv_flow_imp.g_varchar2_table(3542) := '5632486F6E6E33662B6B36523677726B71675453747951306246592B58416161664D524667556C5665587858465563704C4559665A7A33467256557A5A724F4F4A4B2B34422F776E495A385447527662394F423845554D307738754E596A2F6F6139694B';
wwv_flow_imp.g_varchar2_table(3543) := '39414D6F7936674137326F303273724D7870415055442B45446E564546375035787738393656794162466B384D676E705670523367664C6E742F774543713372594676594C634B4370717663492B2F68566C3841756D58446541706B6C4452524B4A5353';
wwv_flow_imp.g_varchar2_table(3544) := '2B4B4F6171315267673469674F597469514B31684A793436544274446A7A6E44703369714A6666356A302F4C66535A625956646175715863634A39572B637A75707030735539674D6C716B5135326C553145367455776F4455756B414436595270417771';
wwv_flow_imp.g_varchar2_table(3545) := '44724145727A413851435276586D39384B456570307849645931434E317965323749503049487676594957313871477A3853375657555A754D6B554F623350384448546C363775722F69315541414141415355564F524B35435949493D227D2929292C74';
wwv_flow_imp.g_varchar2_table(3546) := '6869732E64656661756C744C6F63616C653D59792C746869732E6931386E496E697428292C746869732E7469746C653D746869732E6931386E2822706C7567696E4E616D65496E7374616772616D22292C746869732E70726F76696465723D6E65772062';
wwv_flow_imp.g_varchar2_table(3547) := '6528652C7B636F6D70616E696F6E55726C3A746869732E6F7074732E636F6D70616E696F6E55726C2C636F6D70616E696F6E486561646572733A746869732E6F7074732E636F6D70616E696F6E486561646572732C636F6D70616E696F6E4B6579735061';
wwv_flow_imp.g_varchar2_table(3548) := '72616D733A746869732E6F7074732E636F6D70616E696F6E4B657973506172616D732C636F6D70616E696F6E436F6F6B69657352756C653A746869732E6F7074732E636F6D70616E696F6E436F6F6B69657352756C652C70726F76696465723A22696E73';
wwv_flow_imp.g_varchar2_table(3549) := '74616772616D222C706C7567696E49643A746869732E69642C737570706F72747352656672657368546F6B656E3A21317D292C746869732E6F6E466972737452656E6465723D746869732E6F6E466972737452656E6465722E62696E642874686973292C';
wwv_flow_imp.g_varchar2_table(3550) := '746869732E72656E6465723D746869732E72656E6465722E62696E642874686973297D696E7374616C6C28297B746869732E766965773D6E6577204E6528746869732C7B70726F76696465723A746869732E70726F76696465722C76696577547970653A';
wwv_flow_imp.g_varchar2_table(3551) := '2267726964222C73686F775469746C65733A21312C73686F7746696C7465723A21312C73686F7742726561646372756D62733A21317D293B6C65747B7461726765743A657D3D746869732E6F7074733B652626746869732E6D6F756E7428652C74686973';
wwv_flow_imp.g_varchar2_table(3552) := '297D756E696E7374616C6C28297B746869732E766965772E74656172446F776E28292C746869732E756E6D6F756E7428297D6F6E466972737452656E64657228297B72657475726E2050726F6D6973652E616C6C285B746869732E70726F76696465722E';
wwv_flow_imp.g_varchar2_table(3553) := '666574636850726541757468546F6B656E28292C746869732E766965772E676574466F6C6465722822726563656E7422295D297D72656E6465722865297B72657475726E20746869732E766965772E72656E6465722865297D7D3B6E285A692C22496E73';
wwv_flow_imp.g_varchar2_table(3554) := '74616772616D22293B5A692E56455253494F4E3D6F502E76657273696F6E3B7661722051793D7B737472696E67733A7B706C7567696E4E616D654F6E6544726976653A224F6E654472697665227D7D3B766172206E503D7B76657273696F6E3A22332E32';
wwv_flow_imp.g_varchar2_table(3555) := '2E30227D2C65723D636C61737320657874656E6473205A7B636F6E7374727563746F7228652C74297B737570657228652C74292C746869732E69643D746869732E6F7074732E69647C7C224F6E654472697665222C62652E696E6974506C7567696E2874';
wwv_flow_imp.g_varchar2_table(3556) := '6869732C74292C746869732E7469746C653D746869732E6F7074732E7469746C657C7C224F6E654472697665222C746869732E69636F6E3D28293D3E752822737667222C7B22617269612D68696464656E223A2274727565222C666F63757361626C653A';
wwv_flow_imp.g_varchar2_table(3557) := '2266616C7365222C77696474683A223332222C6865696768743A223332222C76696577426F783A22302030203332203332227D2C75282267222C7B66696C6C3A226E6F6E65222C66696C6C52756C653A226E6F6E7A65726F227D2C75282270617468222C';
wwv_flow_imp.g_varchar2_table(3558) := '7B643A224D31332E33392031322E3838386C342E36313820322E37343720322E3735322D312E313561342E34373820342E3437382030203031322E3037332D2E33353220362E38353820362E38353820302030302D352E3532372D352E303420362E3839';
wwv_flow_imp.g_varchar2_table(3559) := '3520362E38393520302030302D362E38373620322E3938326C2E30372D2E30303261352E3520352E352030203031322E38392E3831357A222C66696C6C3A2223303336344238227D292C75282270617468222C7B643A224D31332E33392031322E383837';
wwv_flow_imp.g_varchar2_table(3560) := '762E30303161352E3520352E3520302030302D322E38392D2E3831356C2D2E30372E30303261352E35303220352E35303220302030302D342E38323220322E39363420352E343320352E343320302030302E333820352E36326C342E3037332D312E3730';
wwv_flow_imp.g_varchar2_table(3561) := '3220312E38312D2E37353720342E3033322D312E36383520322E3130352D2E38382D342E3631392D322E3734387A222C66696C6C3A2223303037384434227D292C75282270617468222C7B643A224D32322E3833332031342E31333361342E3437392034';
wwv_flow_imp.g_varchar2_table(3562) := '2E34373920302030302D322E3037332E3335326C2D322E37353220312E31352E3739382E34373520322E36313620312E35353620312E3134312E363820332E39303220322E33323161342E34313320342E34313320302030302D2E3032322D342E323520';
wwv_flow_imp.g_varchar2_table(3563) := '342E34373120342E34373120302030302D332E36312D322E3238347A222C66696C6C3A2223313439304446227D292C75282270617468222C7B643A224D32322E3536332031382E3334366C2D312E3134312D2E36382D322E3631362D312E3535362D2E37';
wwv_flow_imp.g_varchar2_table(3564) := '39382D2E3437352D322E3130352E38384C31312E38372031382E326C2D312E38312E3735372D342E30373320312E37303241352E35303320352E353033203020303031302E352032336831322E30333161342E34373220342E3437322030203030332E39';
wwv_flow_imp.g_varchar2_table(3565) := '33342D322E3333336C2D332E3930322D322E3332317A222C66696C6C3A2223323841384541227D2929292C746869732E70726F76696465723D6E657720626528652C7B636F6D70616E696F6E55726C3A746869732E6F7074732E636F6D70616E696F6E55';
wwv_flow_imp.g_varchar2_table(3566) := '726C2C636F6D70616E696F6E486561646572733A746869732E6F7074732E636F6D70616E696F6E486561646572732C636F6D70616E696F6E436F6F6B69657352756C653A746869732E6F7074732E636F6D70616E696F6E436F6F6B69657352756C652C70';
wwv_flow_imp.g_varchar2_table(3567) := '726F76696465723A226F6E656472697665222C706C7567696E49643A746869732E69642C737570706F72747352656672657368546F6B656E3A21317D292C746869732E64656661756C744C6F63616C653D51792C746869732E6931386E496E697428292C';
wwv_flow_imp.g_varchar2_table(3568) := '746869732E7469746C653D746869732E6931386E2822706C7567696E4E616D654F6E65447269766522292C746869732E6F6E466972737452656E6465723D746869732E6F6E466972737452656E6465722E62696E642874686973292C746869732E72656E';
wwv_flow_imp.g_varchar2_table(3569) := '6465723D746869732E72656E6465722E62696E642874686973297D696E7374616C6C28297B746869732E766965773D6E6577204E6528746869732C7B70726F76696465723A746869732E70726F76696465722C6C6F6164416C6C46696C65733A21307D29';
wwv_flow_imp.g_varchar2_table(3570) := '3B6C65747B7461726765743A657D3D746869732E6F7074733B652626746869732E6D6F756E7428652C74686973297D756E696E7374616C6C28297B746869732E766965772E74656172446F776E28292C746869732E756E6D6F756E7428297D6F6E466972';
wwv_flow_imp.g_varchar2_table(3571) := '737452656E64657228297B72657475726E2050726F6D6973652E616C6C285B746869732E70726F76696465722E666574636850726541757468546F6B656E28292C746869732E766965772E676574466F6C64657228295D297D72656E6465722865297B72';
wwv_flow_imp.g_varchar2_table(3572) := '657475726E20746869732E766965772E72656E6465722865297D7D3B6E2865722C224F6E65447269766522293B65722E56455253494F4E3D6E502E76657273696F6E3B7661722061503D7B76657273696F6E3A22332E322E33227D2C74723D636C617373';
wwv_flow_imp.g_varchar2_table(3573) := '20657874656E6473205A7B636F6E7374727563746F7228652C74297B696628737570657228652C74292C746869732E69643D746869732E6F7074732E69647C7C22556E73706C617368222C746869732E7469746C653D746869732E6F7074732E7469746C';
wwv_flow_imp.g_varchar2_table(3574) := '657C7C22556E73706C617368222C62652E696E6974506C7567696E28746869732C742C7B7D292C746869732E69636F6E3D28293D3E752822737667222C7B636C6173734E616D653A22757070792D44617368626F6172645461622D69636F6E556E73706C';
wwv_flow_imp.g_varchar2_table(3575) := '617368222C76696577426F783A22302030203332203332222C6865696768743A223332222C77696474683A223332222C22617269612D68696464656E223A2274727565227D2C75282267222C7B66696C6C3A2263757272656E74636F6C6F72227D2C7528';
wwv_flow_imp.g_varchar2_table(3576) := '2270617468222C7B643A224D34362E3537352031302E383833762D3968313276397A6D31322035683130763138682D3332762D313868313076396831327A227D292C75282270617468222C7B643A224D31332031322E355638683676342E357A6D362032';
wwv_flow_imp.g_varchar2_table(3577) := '2E35683576394838762D39683576342E3568367A227D2929292C21746869732E6F7074732E636F6D70616E696F6E55726C297468726F77206E6577204572726F722822436F6D70616E696F6E20686F73746E616D652069732072657175697265642C2070';
wwv_flow_imp.g_varchar2_table(3578) := '6C6561736520636F6E73756C742068747470733A2F2F757070792E696F2F646F63732F636F6D70616E696F6E22293B746869732E686F73746E616D653D746869732E6F7074732E636F6D70616E696F6E55726C2C746869732E70726F76696465723D6E65';
wwv_flow_imp.g_varchar2_table(3579) := '7720587228652C7B636F6D70616E696F6E55726C3A746869732E6F7074732E636F6D70616E696F6E55726C2C636F6D70616E696F6E486561646572733A746869732E6F7074732E636F6D70616E696F6E486561646572732C636F6D70616E696F6E436F6F';
wwv_flow_imp.g_varchar2_table(3580) := '6B69657352756C653A746869732E6F7074732E636F6D70616E696F6E436F6F6B69657352756C652C70726F76696465723A22756E73706C617368222C706C7567696E49643A746869732E69647D297D696E7374616C6C28297B746869732E766965773D6E';
wwv_flow_imp.g_varchar2_table(3581) := '6577206A6928746869732C7B70726F76696465723A746869732E70726F76696465722C76696577547970653A22756E73706C617368222C73686F7746696C7465723A21307D293B6C65747B7461726765743A657D3D746869732E6F7074733B6526267468';
wwv_flow_imp.g_varchar2_table(3582) := '69732E6D6F756E7428652C74686973297D6F6E466972737452656E64657228297B7D72656E6465722865297B72657475726E20746869732E766965772E72656E6465722865297D756E696E7374616C6C28297B746869732E756E6D6F756E7428297D7D3B';
wwv_flow_imp.g_varchar2_table(3583) := '6E2874722C22556E73706C61736822293B74722E56455253494F4E3D61502E76657273696F6E3B66756E6374696F6E204A7928692C65297B696628214F626A6563742E70726F746F747970652E6861734F776E50726F70657274792E63616C6C28692C65';
wwv_flow_imp.g_varchar2_table(3584) := '29297468726F77206E657720547970654572726F722822617474656D7074656420746F207573652070726976617465206669656C64206F6E206E6F6E2D696E7374616E636522293B72657475726E20697D6E284A792C225F636C61737350726976617465';
wwv_flow_imp.g_varchar2_table(3585) := '4669656C644C6F6F73654261736522293B766172206C503D303B66756E6374696F6E2075502869297B72657475726E225F5F707269766174655F222B6C502B2B2B225F222B697D6E2875502C225F636C617373507269766174654669656C644C6F6F7365';
wwv_flow_imp.g_varchar2_table(3586) := '4B657922293B7661722053613D7550282268616E646C655375626D697422292C4D753D636C61737320657874656E64732077657B636F6E7374727563746F722865297B73757065722865292C746869732E666F726D3D646F63756D656E742E6372656174';
wwv_flow_imp.g_varchar2_table(3587) := '65456C656D656E742822666F726D22292C4F626A6563742E646566696E6550726F706572747928746869732C53612C7B7772697461626C653A21302C76616C75653A743D3E7B742E70726576656E7444656661756C7428293B6C65747B61646446696C65';
wwv_flow_imp.g_varchar2_table(3588) := '3A727D3D746869732E70726F70732C733D746869732E696E7075742E76616C75652E7472696D28293B722873297D7D292C746869732E666F726D2E69643D507428297D636F6D706F6E656E744469644D6F756E7428297B746869732E696E7075742E7661';
wwv_flow_imp.g_varchar2_table(3589) := '6C75653D22222C746869732E666F726D2E6164644576656E744C697374656E657228227375626D6974222C4A7928746869732C5361295B53615D292C646F63756D656E742E626F64792E617070656E644368696C6428746869732E666F726D297D636F6D';
wwv_flow_imp.g_varchar2_table(3590) := '706F6E656E7457696C6C556E6D6F756E7428297B746869732E666F726D2E72656D6F76654576656E744C697374656E657228227375626D6974222C4A7928746869732C5361295B53615D292C646F63756D656E742E626F64792E72656D6F76654368696C';
wwv_flow_imp.g_varchar2_table(3591) := '6428746869732E666F726D297D72656E64657228297B6C65747B6931386E3A657D3D746869732E70726F70733B72657475726E20752822646976222C7B636C6173734E616D653A22757070792D55726C227D2C752822696E707574222C7B636C6173734E';
wwv_flow_imp.g_varchar2_table(3592) := '616D653A22757070792D752D726573657420757070792D632D74657874496E70757420757070792D55726C2D696E707574222C747970653A2274657874222C22617269612D6C6162656C223A652822656E74657255726C546F496D706F727422292C706C';
wwv_flow_imp.g_varchar2_table(3593) := '616365686F6C6465723A652822656E74657255726C546F496D706F727422292C7265663A743D3E7B746869732E696E7075743D747D2C22646174612D757070792D73757065722D666F63757361626C65223A21302C666F726D3A746869732E666F726D2E';
wwv_flow_imp.g_varchar2_table(3594) := '69647D292C752822627574746F6E222C7B636C6173734E616D653A22757070792D752D726573657420757070792D632D62746E20757070792D632D62746E2D7072696D61727920757070792D55726C2D696D706F7274427574746F6E222C747970653A22';
wwv_flow_imp.g_varchar2_table(3595) := '7375626D6974222C666F726D3A746869732E666F726D2E69647D2C652822696D706F7274222929297D7D3B6E284D752C2255726C554922293B766172205A793D4D753B66756E6374696F6E204E7528692C652C74297B6C657420723D516528692E697465';
wwv_flow_imp.g_varchar2_table(3596) := '6D73292C733B7377697463682865297B63617365227061737465223A7B696628722E736F6D6528613D3E612E6B696E643D3D3D2266696C6522292972657475726E3B733D722E66696C74657228613D3E612E6B696E643D3D3D22737472696E6722262661';
wwv_flow_imp.g_varchar2_table(3597) := '2E747970653D3D3D22746578742F706C61696E22293B627265616B7D636173652264726F70223A7B733D722E66696C746572286F3D3E6F2E6B696E643D3D3D22737472696E672226266F2E747970653D3D3D22746578742F7572692D6C69737422293B62';
wwv_flow_imp.g_varchar2_table(3598) := '7265616B7D64656661756C743A7468726F77206E6577204572726F722860697344726F704F725061737465206D75737420626520656974686572202764726F7027206F7220277061737465272C20627574206974277320247B657D60297D732E666F7245';
wwv_flow_imp.g_varchar2_table(3599) := '616368286F3D3E7B6F2E6765744173537472696E6728613D3E74286129297D297D6E284E752C22666F724561636844726F707065644F7250617374656455726C22293B7661722065763D7B737472696E67733A7B696D706F72743A22496D706F7274222C';
wwv_flow_imp.g_varchar2_table(3600) := '656E74657255726C546F496D706F72743A22456E7465722055524C20746F20696D706F727420612066696C65222C6661696C6564546F46657463683A22436F6D70616E696F6E206661696C656420746F20666574636820746869732055524C2C20706C65';
wwv_flow_imp.g_varchar2_table(3601) := '617365206D616B6520737572652069745C75323031397320636F7272656374222C656E746572436F727265637455726C3A22496E636F72726563742055524C3A20506C65617365206D616B65207375726520796F752061726520656E746572696E672061';
wwv_flow_imp.g_varchar2_table(3602) := '20646972656374206C696E6B20746F20612066696C65227D7D3B7661722068503D7B76657273696F6E3A22332E352E30227D3B66756E6374696F6E20645028297B72657475726E20752822737667222C7B22617269612D68696464656E223A2274727565';
wwv_flow_imp.g_varchar2_table(3603) := '222C666F63757361626C653A2266616C7365222C77696474683A223332222C6865696768743A223332222C76696577426F783A22302030203332203332227D2C75282270617468222C7B643A224D32332E3633372031352E3331326C2D322E3437342032';
wwv_flow_imp.g_varchar2_table(3604) := '2E34363461332E35383220332E35383220302030312D2E3537372E343931632D2E3930372E3635372D312E3839372E3938362D322E3936382E39383661342E39323520342E39323520302030312D332E3935392D312E393731632D2E3234382D2E333239';
wwv_flow_imp.g_varchar2_table(3605) := '2D2E3136342D2E3930322E3136352D312E3134392E33332D2E3234372E3930372D2E31363420312E3135352E31363420312E30373220312E34373820332E31333320312E37323420342E3631382E363536612E3634322E36343220302030302E33332D2E';
wwv_flow_imp.g_varchar2_table(3606) := '3332386C322E3437332D322E34363363312E3233382D312E33313320312E3233382D332E3336362D2E3038322D342E35393761332E33343820332E33343820302030302D342E36313820306C2D312E34303220312E333935612E3739392E373939203020';
wwv_flow_imp.g_varchar2_table(3607) := '30312D312E3135342030202E37392E37392030203031302D312E31356C312E3430322D312E33393461342E38343320342E3834332030203031362E383433203063322E30363220312E38303520322E31343420352E3030372E32343820362E3839367A6D';
wwv_flow_imp.g_varchar2_table(3608) := '2D382E30383120352E3636346C2D312E34303220312E33393561332E33343820332E33343820302030312D342E3631382030632D312E3331392D312E32332D312E3331392D332E3336352D2E3038322D342E3539366C322E3437352D322E3436342E3332';
wwv_flow_imp.g_varchar2_table(3609) := '382D2E333238632E3734332D2E34393220312E3536372D2E37333920322E3437352D2E3635372E3930362E31363520312E3634382E35373420322E31343320312E3331342E3234382E3332392E3832352E34313120312E3135352E3136352E33332D2E32';
wwv_flow_imp.g_varchar2_table(3610) := '34382E3431322D2E3832322E3136352D312E31352D2E3832352D312E3036382D312E39382D312E3732342D332E3231362D312E3838382D312E3233382D2E3234372D322E3535362E3038322D332E3632382E3930326C2D2E3439352E3439332D322E3437';
wwv_flow_imp.g_varchar2_table(3611) := '3420322E343634632D312E38393720312E3936392D312E38313420352E30392E30383320362E3937372E39392E39303420322E32323620312E33393620332E34363320312E33393673322E3437332D2E34393220332E3436332D312E3339356C312E3430';
wwv_flow_imp.g_varchar2_table(3612) := '322D312E333936612E37392E37392030203030302D312E3135632D2E33332D2E3332382D2E3930382D2E34312D312E3233372D2E3038327A222C66696C6C3A2223464637353345222C2266696C6C2D72756C65223A226E6F6E7A65726F227D29297D6E28';
wwv_flow_imp.g_varchar2_table(3613) := '64502C2255726C49636F6E22293B66756E6374696F6E2063502869297B6C657420653D2F5E5B612D7A302D395D2B3A5C2F5C2F2F2C743D22687474703A2F2F223B72657475726E20652E746573742869293F693A742B697D6E2863502C2261646450726F';
wwv_flow_imp.g_varchar2_table(3614) := '746F636F6C546F55524C22293B66756E6374696F6E2070502869297B72657475726E20516528692E646174615472616E736665722E6974656D73292E66696C74657228723D3E722E6B696E643D3D3D22737472696E67222626722E747970653D3D3D2274';
wwv_flow_imp.g_varchar2_table(3615) := '6578742F7572692D6C69737422292E6C656E6774683E307D6E2870502C2263616E48616E646C65526F6F7444726F7022293B66756E6374696F6E2066502869297B69662821692972657475726E21313B6C657420653D692E6D61746368282F5E285B612D';
wwv_flow_imp.g_varchar2_table(3616) := '7A302D395D2B293A5C2F5C2F2F295B315D3B72657475726E212865213D3D226874747022262665213D3D22687474707322297D6E2866502C22636865636B4966436F727265637455524C22293B66756E6374696F6E206D502869297B6C65747B70617468';
wwv_flow_imp.g_varchar2_table(3617) := '6E616D653A657D3D6E65772055524C2869293B72657475726E20652E737562737472696E6728652E6C617374496E6465784F6628222F22292B31297D6E286D502C2267657446696C654E616D6546726F6D55726C22293B7661722046743D636C61737320';
wwv_flow_imp.g_varchar2_table(3618) := '657874656E6473205A7B636F6E7374727563746F7228652C74297B737570657228652C74292C746869732E69643D746869732E6F7074732E69647C7C2255726C222C746869732E7469746C653D746869732E6F7074732E7469746C657C7C224C696E6B22';
wwv_flow_imp.g_varchar2_table(3619) := '2C746869732E747970653D226163717569726572222C746869732E69636F6E3D28293D3E752864502C6E756C6C292C746869732E64656661756C744C6F63616C653D65763B6C657420723D7B7D3B696628746869732E6F7074733D7B2E2E2E722C2E2E2E';
wwv_flow_imp.g_varchar2_table(3620) := '747D2C746869732E6931386E496E697428292C746869732E686F73746E616D653D746869732E6F7074732E636F6D70616E696F6E55726C2C21746869732E686F73746E616D65297468726F77206E6577204572726F722822436F6D70616E696F6E20686F';
wwv_flow_imp.g_varchar2_table(3621) := '73746E616D652069732072657175697265642C20706C6561736520636F6E73756C742068747470733A2F2F757070792E696F2F646F63732F636F6D70616E696F6E22293B746869732E6765744D6574613D746869732E6765744D6574612E62696E642874';
wwv_flow_imp.g_varchar2_table(3622) := '686973292C746869732E61646446696C653D746869732E61646446696C652E62696E642874686973292C746869732E68616E646C65526F6F7444726F703D746869732E68616E646C65526F6F7444726F702E62696E642874686973292C746869732E6861';
wwv_flow_imp.g_varchar2_table(3623) := '6E646C65526F6F7450617374653D746869732E68616E646C65526F6F7450617374652E62696E642874686973292C746869732E636C69656E743D6E657720687428652C7B636F6D70616E696F6E55726C3A746869732E6F7074732E636F6D70616E696F6E';
wwv_flow_imp.g_varchar2_table(3624) := '55726C2C636F6D70616E696F6E486561646572733A746869732E6F7074732E636F6D70616E696F6E486561646572732C636F6D70616E696F6E436F6F6B69657352756C653A746869732E6F7074732E636F6D70616E696F6E436F6F6B69657352756C657D';
wwv_flow_imp.g_varchar2_table(3625) := '292C746869732E757070792E726567697374657252657175657374436C69656E742846742E72657175657374436C69656E7449642C746869732E636C69656E74297D6765744D6574612865297B72657475726E20746869732E636C69656E742E706F7374';
wwv_flow_imp.g_varchar2_table(3626) := '282275726C2F6D657461222C7B75726C3A657D292E7468656E28743D3E7B696628742E6572726F72297468726F7720746869732E757070792E6C6F6728225B55524C5D204572726F723A22292C746869732E757070792E6C6F6728742E6572726F72292C';
wwv_flow_imp.g_varchar2_table(3627) := '6E6577204572726F7228224661696C656420746F206665746368207468652066696C6522293B72657475726E20747D297D6173796E632061646446696C6528652C74297B743D3D3D766F69642030262628743D766F69642030293B6C657420723D635028';
wwv_flow_imp.g_varchar2_table(3628) := '65293B696628216650287229297B746869732E757070792E6C6F6728605B55524C5D20496E636F72726563742055524C20656E74657265643A20247B727D60292C746869732E757070792E696E666F28746869732E6931386E2822656E746572436F7272';
wwv_flow_imp.g_varchar2_table(3629) := '65637455726C22292C226572726F72222C346533293B72657475726E7D7472797B6C657420733D617761697420746869732E6765744D6574612872292C6F3D7B6D6574613A742C736F757263653A746869732E69642C6E616D653A732E6E616D657C7C6D';
wwv_flow_imp.g_varchar2_table(3630) := '502872292C747970653A732E747970652C646174613A7B73697A653A732E73697A657D2C697352656D6F74653A21302C626F64793A7B75726C3A727D2C72656D6F74653A7B636F6D70616E696F6E55726C3A746869732E6F7074732E636F6D70616E696F';
wwv_flow_imp.g_varchar2_table(3631) := '6E55726C2C75726C3A60247B746869732E686F73746E616D657D2F75726C2F676574602C626F64793A7B66696C6549643A722C75726C3A727D2C72657175657374436C69656E7449643A46742E72657175657374436C69656E7449647D7D3B746869732E';
wwv_flow_imp.g_varchar2_table(3632) := '757070792E6C6F6728225B55726C5D20416464696E672072656D6F74652066696C6522293B7472797B72657475726E20746869732E757070792E61646446696C65286F297D63617463682861297B72657475726E20612E69735265737472696374696F6E';
wwv_flow_imp.g_varchar2_table(3633) := '7C7C746869732E757070792E6C6F672861292C617D7D63617463682873297B72657475726E20746869732E757070792E6C6F672873292C746869732E757070792E696E666F287B6D6573736167653A746869732E6931386E28226661696C6564546F4665';
wwv_flow_imp.g_varchar2_table(3634) := '74636822292C64657461696C733A737D2C226572726F72222C346533292C737D7D68616E646C65526F6F7444726F702865297B4E7528652E646174615472616E736665722C2264726F70222C743D3E7B746869732E757070792E6C6F6728605B55524C5D';
wwv_flow_imp.g_varchar2_table(3635) := '20416464696E672066696C652066726F6D2064726F707065642075726C3A20247B747D60292C746869732E61646446696C652874297D297D68616E646C65526F6F7450617374652865297B4E7528652E636C6970626F617264446174612C227061737465';
wwv_flow_imp.g_varchar2_table(3636) := '222C743D3E7B746869732E757070792E6C6F6728605B55524C5D20416464696E672066696C652066726F6D207061737465642075726C3A20247B747D60292C746869732E61646446696C652874297D297D72656E64657228297B72657475726E2075285A';
wwv_flow_imp.g_varchar2_table(3637) := '792C7B6931386E3A746869732E6931386E2C61646446696C653A746869732E61646446696C657D297D696E7374616C6C28297B6C65747B7461726765743A657D3D746869732E6F7074733B652626746869732E6D6F756E7428652C74686973297D756E69';
wwv_flow_imp.g_varchar2_table(3638) := '6E7374616C6C28297B746869732E756E6D6F756E7428297D7D3B6E2846742C2255726C22293B46742E56455253494F4E3D68502E76657273696F6E3B46742E72657175657374436C69656E7449643D46742E6E616D653B46742E70726F746F747970652E';
wwv_flow_imp.g_varchar2_table(3639) := '63616E48616E646C65526F6F7444726F703D70503B7661722074763D7B737472696E67733A7B706C7567696E4E616D655A6F6F6D3A225A6F6F6D227D7D3B7661722067503D7B76657273696F6E3A22322E322E30227D2C69723D636C6173732065787465';
wwv_flow_imp.g_varchar2_table(3640) := '6E6473205A7B636F6E7374727563746F7228652C74297B737570657228652C74292C746869732E69643D746869732E6F7074732E69647C7C225A6F6F6D222C62652E696E6974506C7567696E28746869732C74292C746869732E7469746C653D74686973';
wwv_flow_imp.g_varchar2_table(3641) := '2E6F7074732E7469746C657C7C225A6F6F6D222C746869732E69636F6E3D28293D3E752822737667222C7B22617269612D68696464656E223A2274727565222C666F63757361626C653A2266616C7365222C77696474683A223332222C6865696768743A';
wwv_flow_imp.g_varchar2_table(3642) := '223332222C76696577426F783A22302030203332203332227D2C75282270617468222C7B643A224D32342E352031312E3132356C2D322E373520322E303633632D2E3437332E3335332D2E37352E39312D2E373520312E3576332E3132346330202E3539';
wwv_flow_imp.g_varchar2_table(3643) := '2E32373720312E3134372E373520312E356C322E373520322E303633612E3933382E3933382030203030312E352D2E3735762D382E3735612E3933382E39333820302030302D312E352D2E37357A6D2D342E373520392E35633020312E3033352D2E3834';
wwv_flow_imp.g_varchar2_table(3644) := '20312E3837352D312E38373520312E38373548392E373541332E373520332E37352030203031362031382E3735762D362E38373543362031302E383420362E383420313020372E38373520313048313661332E373520332E37352030203031332E373520';
wwv_flow_imp.g_varchar2_table(3645) := '332E373576362E3837357A222C66696C6C3A2223324538434646222C2266696C6C2D72756C65223A226576656E6F6464227D29292C746869732E70726F76696465723D6E657720626528652C7B636F6D70616E696F6E55726C3A746869732E6F7074732E';
wwv_flow_imp.g_varchar2_table(3646) := '636F6D70616E696F6E55726C2C636F6D70616E696F6E486561646572733A746869732E6F7074732E636F6D70616E696F6E486561646572732C636F6D70616E696F6E4B657973506172616D733A746869732E6F7074732E636F6D70616E696F6E4B657973';
wwv_flow_imp.g_varchar2_table(3647) := '506172616D732C636F6D70616E696F6E436F6F6B69657352756C653A746869732E6F7074732E636F6D70616E696F6E436F6F6B69657352756C652C70726F76696465723A227A6F6F6D222C706C7567696E49643A746869732E69642C737570706F727473';
wwv_flow_imp.g_varchar2_table(3648) := '52656672657368546F6B656E3A21317D292C746869732E64656661756C744C6F63616C653D74762C746869732E6931386E496E697428292C746869732E7469746C653D746869732E6931386E2822706C7567696E4E616D655A6F6F6D22292C746869732E';
wwv_flow_imp.g_varchar2_table(3649) := '6F6E466972737452656E6465723D746869732E6F6E466972737452656E6465722E62696E642874686973292C746869732E72656E6465723D746869732E72656E6465722E62696E642874686973297D696E7374616C6C28297B746869732E766965773D6E';
wwv_flow_imp.g_varchar2_table(3650) := '6577204E6528746869732C7B70726F76696465723A746869732E70726F76696465727D293B6C65747B7461726765743A657D3D746869732E6F7074733B652626746869732E6D6F756E7428652C74686973297D756E696E7374616C6C28297B746869732E';
wwv_flow_imp.g_varchar2_table(3651) := '766965772E74656172446F776E28292C746869732E756E6D6F756E7428297D6F6E466972737452656E64657228297B72657475726E2050726F6D6973652E616C6C285B746869732E70726F76696465722E666574636850726541757468546F6B656E2829';
wwv_flow_imp.g_varchar2_table(3652) := '2C746869732E766965772E676574466F6C64657228295D297D72656E6465722865297B72657475726E20746869732E766965772E72656E6465722865297D7D3B6E2869722C225A6F6F6D22293B69722E56455253494F4E3D67502E76657273696F6E3B66';
wwv_flow_imp.g_varchar2_table(3653) := '756E6374696F6E20616328692C65297B696628214F626A6563742E70726F746F747970652E6861734F776E50726F70657274792E63616C6C28692C6529297468726F77206E657720547970654572726F722822617474656D7074656420746F2075736520';
wwv_flow_imp.g_varchar2_table(3654) := '70726976617465206669656C64206F6E206E6F6E2D696E7374616E636522293B72657475726E20697D6E2861632C225F636C617373507269766174654669656C644C6F6F73654261736522293B7661722079503D303B66756E6374696F6E207650286929';
wwv_flow_imp.g_varchar2_table(3655) := '7B72657475726E225F5F707269766174655F222B79502B2B2B225F222B697D6E2876502C225F636C617373507269766174654669656C644C6F6F73654B657922293B7661722062503D7B76657273696F6E3A22312E312E30227D2C6C633D7B5F5F70726F';
wwv_flow_imp.g_varchar2_table(3656) := '746F5F5F3A6E756C6C2C426F783A58692C44726F70626F783A59692C46616365626F6F6B3A51692C476F6F676C6544726976653A4A692C496E7374616772616D3A5A692C4F6E6544726976653A65722C556E73706C6173683A74722C55726C3A46742C5A';
wwv_flow_imp.g_varchar2_table(3657) := '6F6F6D3A69727D2C42733D76502822696E7374616C6C6564506C7567696E7322292C7A733D636C61737320657874656E64732076657B636F6E7374727563746F7228652C74297B737570657228652C74292C4F626A6563742E646566696E6550726F7065';
wwv_flow_imp.g_varchar2_table(3658) := '72747928746869732C42732C7B7772697461626C653A21302C76616C75653A6E6577205365747D292C746869732E69643D746869732E6F7074732E69647C7C2252656D6F7465536F7572636573222C746869732E747970653D22707265736574223B6C65';
wwv_flow_imp.g_varchar2_table(3659) := '7420723D7B736F75726365733A4F626A6563742E6B657973286C63297D3B696628746869732E6F7074733D7B2E2E2E722C2E2E2E747D2C746869732E6F7074732E636F6D70616E696F6E55726C3D3D6E756C6C297468726F77206E6577204572726F7228';
wwv_flow_imp.g_varchar2_table(3660) := '22506C65617365207370656369667920636F6D70616E696F6E55726C20666F722052656D6F7465536F757263657320746F20776F726B2C207365652068747470733A2F2F757070792E696F2F646F63732F72656D6F74652D736F757263657323636F6D70';
wwv_flow_imp.g_varchar2_table(3661) := '616E696F6E55726C22297D7365744F7074696F6E732865297B746869732E756E696E7374616C6C28292C73757065722E7365744F7074696F6E732865292C746869732E696E7374616C6C28297D696E7374616C6C28297B746869732E6F7074732E736F75';
wwv_flow_imp.g_varchar2_table(3662) := '726365732E666F724561636828653D3E7B6C657420743D7B2E2E2E746869732E6F7074732C736F75726365733A766F696420307D2C723D6C635B655D3B696628723D3D6E756C6C297B6C657420733D4F626A6563742E6B657973286C63292C6F3D6E6577';
wwv_flow_imp.g_varchar2_table(3663) := '20496E746C2E4C697374466F726D61742822656E222C7B7374796C653A226C6F6E67222C747970653A226469736A756E6374696F6E227D293B7468726F77206E6577204572726F722860496E76616C696420706C7567696E3A2022247B657D2220697320';
wwv_flow_imp.g_varchar2_table(3664) := '6E6F74206F6E65206F663A20247B6F2E666F726D61742873297D2E60297D746869732E757070792E75736528722C74292C616328746869732C4273295B42735D2E61646428746869732E757070792E676574506C7567696E286529297D297D756E696E73';
wwv_flow_imp.g_varchar2_table(3665) := '74616C6C28297B666F72286C65742065206F6620616328746869732C4273295B42735D29746869732E757070792E72656D6F7665506C7567696E2865293B616328746869732C4273295B42735D2E636C65617228297D7D3B6E287A732C2252656D6F7465';
wwv_flow_imp.g_varchar2_table(3666) := '536F757263657322293B7A732E56455253494F4E3D62502E76657273696F6E3B7661722069763D6E2828293D3E752822737667222C7B636C6173734E616D653A22757070792D44617368626F6172645461622D69636F6E53637265656E526563222C2261';
wwv_flow_imp.g_varchar2_table(3667) := '7269612D68696464656E223A2274727565222C666F63757361626C653A2266616C7365222C77696474683A223332222C6865696768743A223332222C76696577426F783A22302030203332203332227D2C75282267222C7B66696C6C3A2263757272656E';
wwv_flow_imp.g_varchar2_table(3668) := '74636F6C6F72222C66696C6C52756C653A226576656E6F6464227D2C75282270617468222C7B643A224D32342E313832203948372E38313843362E38312039203620392E37343220362031302E3636377631306330202E3931362E383120312E36363620';
wwv_flow_imp.g_varchar2_table(3669) := '312E38313820312E36363668342E35343656323468372E323732762D312E36363768342E3534366331203020312E3830392D2E373520312E3830392D312E3636366C2E3030392D313043323620392E3734322032352E31383220392032342E3138322039';
wwv_flow_imp.g_varchar2_table(3670) := '7A4D323420323148385631316831367631307A227D292C752822636972636C65222C7B63783A223136222C63793A223136222C723A2232227D2929292C2264656661756C7422293B66756E6374696F6E2075632869297B6C65747B7265636F7264696E67';
wwv_flow_imp.g_varchar2_table(3671) := '3A652C6F6E53746172745265636F7264696E673A742C6F6E53746F705265636F7264696E673A722C6931386E3A737D3D693B72657475726E20653F752822627574746F6E222C7B636C6173734E616D653A22757070792D752D726573657420757070792D';
wwv_flow_imp.g_varchar2_table(3672) := '632D62746E20757070792D53637265656E436170747572652D627574746F6E20757070792D53637265656E436170747572652D627574746F6E2D2D766964656F20757070792D53637265656E436170747572652D627574746F6E2D2D73746F702D726563';
wwv_flow_imp.g_varchar2_table(3673) := '222C747970653A22627574746F6E222C7469746C653A73282273746F70436170747572696E6722292C22617269612D6C6162656C223A73282273746F70436170747572696E6722292C6F6E436C69636B3A722C22646174612D757070792D73757065722D';
wwv_flow_imp.g_varchar2_table(3674) := '666F63757361626C65223A21307D2C752822737667222C7B22617269612D68696464656E223A2274727565222C666F63757361626C653A2266616C7365222C636C6173734E616D653A22757070792D632D69636F6E222C77696474683A22313030222C68';
wwv_flow_imp.g_varchar2_table(3675) := '65696768743A22313030222C76696577426F783A223020302031303020313030227D2C75282272656374222C7B783A223135222C793A223135222C77696474683A223730222C6865696768743A223730227D2929293A752822627574746F6E222C7B636C';
wwv_flow_imp.g_varchar2_table(3676) := '6173734E616D653A22757070792D752D726573657420757070792D632D62746E20757070792D53637265656E436170747572652D627574746F6E20757070792D53637265656E436170747572652D627574746F6E2D2D766964656F222C747970653A2262';
wwv_flow_imp.g_varchar2_table(3677) := '7574746F6E222C7469746C653A7328227374617274436170747572696E6722292C22617269612D6C6162656C223A7328227374617274436170747572696E6722292C6F6E436C69636B3A742C22646174612D757070792D73757065722D666F6375736162';
wwv_flow_imp.g_varchar2_table(3678) := '6C65223A21307D2C752822737667222C7B22617269612D68696464656E223A2274727565222C666F63757361626C653A2266616C7365222C636C6173734E616D653A22757070792D632D69636F6E222C77696474683A22313030222C6865696768743A22';
wwv_flow_imp.g_varchar2_table(3679) := '313030222C76696577426F783A223020302031303020313030227D2C752822636972636C65222C7B63783A223530222C63793A223530222C723A223430227D2929297D6E2875632C225265636F7264427574746F6E22293B66756E6374696F6E20686328';
wwv_flow_imp.g_varchar2_table(3680) := '69297B6C65747B7265636F7264696E673A652C7265636F72646564566964656F3A742C6F6E5375626D69743A722C6931386E3A737D3D693B72657475726E2074262621653F752822627574746F6E222C7B636C6173734E616D653A22757070792D752D72';
wwv_flow_imp.g_varchar2_table(3681) := '6573657420757070792D632D62746E20757070792D53637265656E436170747572652D627574746F6E20757070792D53637265656E436170747572652D627574746F6E2D2D7375626D6974222C747970653A22627574746F6E222C7469746C653A732822';
wwv_flow_imp.g_varchar2_table(3682) := '7375626D69745265636F7264656446696C6522292C22617269612D6C6162656C223A7328227375626D69745265636F7264656446696C6522292C6F6E436C69636B3A722C22646174612D757070792D73757065722D666F63757361626C65223A21307D2C';
wwv_flow_imp.g_varchar2_table(3683) := '752822737667222C7B77696474683A223132222C6865696768743A2239222C76696577426F783A223020302031322039222C786D6C6E733A22687474703A2F2F7777772E77332E6F72672F323030302F737667222C22617269612D68696464656E223A22';
wwv_flow_imp.g_varchar2_table(3684) := '74727565222C666F63757361626C653A2266616C7365222C636C6173734E616D653A22757070792D632D69636F6E227D2C75282270617468222C7B66696C6C3A2223666666222C66696C6C52756C653A226E6F6E7A65726F222C643A224D31302E363620';
wwv_flow_imp.g_varchar2_table(3685) := '304C313220312E333120342E3133362039203020342E3935366C312E33342D312E33314C342E31333620362E33387A227D2929293A6E756C6C7D6E2868632C225375626D6974427574746F6E22293B766172204C753D636C61737320657874656E647320';
wwv_flow_imp.g_varchar2_table(3686) := '77657B636F6E7374727563746F722865297B73757065722865292C746869732E73746174653D7B656C617073656454696D653A307D2C746869732E777261707065725374796C653D7B77696474683A2231303025222C6865696768743A2231303025222C';
wwv_flow_imp.g_varchar2_table(3687) := '646973706C61793A22666C6578227D2C746869732E6F7665726C61795374796C653D7B706F736974696F6E3A226162736F6C757465222C77696474683A2231303025222C6865696768743A2231303025222C6261636B67726F756E643A22626C61636B22';
wwv_flow_imp.g_varchar2_table(3688) := '2C6F7061636974793A2E377D2C746869732E696E666F436F6E7461696E65725374796C653D7B6D617267696E4C6566743A226175746F222C6D617267696E52696768743A226175746F222C6D617267696E546F703A226175746F222C6D617267696E426F';
wwv_flow_imp.g_varchar2_table(3689) := '74746F6D3A226175746F222C7A496E6465783A312C636F6C6F723A227768697465227D2C746869732E696E666F746578745374796C653D7B6D617267696E4C6566743A226175746F222C6D617267696E52696768743A226175746F222C6D617267696E42';
wwv_flow_imp.g_varchar2_table(3690) := '6F74746F6D3A223172656D222C666F6E7453697A653A22312E3572656D227D2C746869732E74696D655374796C653D7B646973706C61793A22626C6F636B222C666F6E745765696768743A22626F6C64222C6D617267696E4C6566743A226175746F222C';
wwv_flow_imp.g_varchar2_table(3691) := '6D617267696E52696768743A226175746F222C666F6E7453697A653A223372656D222C666F6E7446616D696C793A22436F7572696572204E6577227D7D737461727454696D657228297B746869732E74696D65725469636B28292C746869732E74696D65';
wwv_flow_imp.g_varchar2_table(3692) := '7252756E6E696E673D21307D726573657454696D657228297B636C65617254696D656F757428746869732E74696D6572292C746869732E7365745374617465287B656C617073656454696D653A307D292C746869732E74696D657252756E6E696E673D21';
wwv_flow_imp.g_varchar2_table(3693) := '317D74696D65725469636B28297B746869732E74696D65723D73657454696D656F75742828293D3E7B746869732E736574537461746528653D3E287B656C617073656454696D653A652E656C617073656454696D652B317D29292C746869732E74696D65';
wwv_flow_imp.g_varchar2_table(3694) := '725469636B28297D2C316533297D666D744D53532865297B72657475726E28652D2865253D363029292F36302B28653E393F223A223A223A3022292B657D72656E64657228297B6C65747B7265636F7264696E673A652C6931386E3A747D3D7B2E2E2E74';
wwv_flow_imp.g_varchar2_table(3695) := '6869732E70726F70737D2C7B656C617073656454696D653A727D3D746869732E73746174652C733D746869732E666D744D53532872293B72657475726E2065262621746869732E74696D657252756E6E696E672626746869732E737461727454696D6572';
wwv_flow_imp.g_varchar2_table(3696) := '28292C21652626746869732E74696D657252756E6E696E672626746869732E726573657454696D657228292C653F752822646976222C7B7374796C653A746869732E777261707065725374796C657D2C752822646976222C7B7374796C653A746869732E';
wwv_flow_imp.g_varchar2_table(3697) := '6F7665726C61795374796C657D292C752822646976222C7B7374796C653A746869732E696E666F436F6E7461696E65725374796C657D2C752822646976222C7B7374796C653A746869732E696E666F746578745374796C657D2C7428227265636F726469';
wwv_flow_imp.g_varchar2_table(3698) := '6E672229292C752822646976222C7B7374796C653A746869732E74696D655374796C657D2C732929293A6E756C6C7D7D3B6E284C752C2253746F70576174636822293B7661722072763D4C753B7661722073763D6E28693D3E7B6C65747B73747265616D';
wwv_flow_imp.g_varchar2_table(3699) := '4163746976653A652C6931386E3A747D3D693B72657475726E20653F752822646976222C7B7469746C653A74282273747265616D41637469766522292C22617269612D6C6162656C223A74282273747265616D41637469766522292C636C6173734E616D';
wwv_flow_imp.g_varchar2_table(3700) := '653A22757070792D53637265656E436170747572652D69636F6E2D2D73747265616D20757070792D53637265656E436170747572652D69636F6E2D2D73747265616D416374697665227D2C752822737667222C7B22617269612D68696464656E223A2274';
wwv_flow_imp.g_varchar2_table(3701) := '727565222C666F63757361626C653A2266616C7365222C77696474683A223234222C6865696768743A223234222C76696577426F783A22302030203234203234227D2C75282270617468222C7B643A224D30203068323476323448307A222C6F70616369';
wwv_flow_imp.g_varchar2_table(3702) := '74793A222E31222C66696C6C3A226E6F6E65227D292C75282270617468222C7B643A224D30203068323476323448307A222C66696C6C3A226E6F6E65227D292C75282270617468222C7B643A224D312031387633683363302D312E36362D312E33342D33';
wwv_flow_imp.g_varchar2_table(3703) := '2D332D337A6D302D34763263322E37362030203520322E323420352035683263302D332E38372D332E31332D372D372D377A6D31382D37483576312E363363332E393620312E323820372E303920342E343120382E333720382E333748313956377A4D31';
wwv_flow_imp.g_varchar2_table(3704) := '203130763263342E39372030203920342E303320392039683263302D362E30382D342E39332D31312D31312D31317A6D32302D374833632D312E3120302D32202E392D322032763368325635683138763134682D377632683763312E31203020322D2E39';
wwv_flow_imp.g_varchar2_table(3705) := '20322D32563563302D312E312D2E392D322D322D327A227D2929293A752822646976222C7B7469746C653A74282273747265616D5061737369766522292C22617269612D6C6162656C223A74282273747265616D5061737369766522292C636C6173734E';
wwv_flow_imp.g_varchar2_table(3706) := '616D653A22757070792D53637265656E436170747572652D69636F6E2D2D73747265616D227D2C752822737667222C7B22617269612D68696464656E223A2274727565222C666F63757361626C653A2266616C7365222C77696474683A223234222C6865';
wwv_flow_imp.g_varchar2_table(3707) := '696768743A223234222C76696577426F783A22302030203234203234227D2C75282270617468222C7B643A224D30203068323476323448307A222C6F7061636974793A222E31222C66696C6C3A226E6F6E65227D292C75282270617468222C7B643A224D';
wwv_flow_imp.g_varchar2_table(3708) := '30203068323476323448307A222C66696C6C3A226E6F6E65227D292C75282270617468222C7B643A224D323120334833632D312E3120302D32202E392D322032763368325635683138763134682D377632683763312E31203020322D2E3920322D325635';
wwv_flow_imp.g_varchar2_table(3709) := '63302D312E312D2E392D322D322D327A4D312031387633683363302D312E36362D312E33342D332D332D337A6D302D34763263322E37362030203520322E323420352035683263302D332E38372D332E31332D372D372D377A6D302D34763263342E3937';
wwv_flow_imp.g_varchar2_table(3710) := '2030203920342E303320392039683263302D362E30382D342E39332D31312D31312D31317A227D2929297D2C2264656661756C7422293B66756E6374696F6E20646328297B72657475726E2064633D4F626A6563742E61737369676E3F4F626A6563742E';
wwv_flow_imp.g_varchar2_table(3711) := '61737369676E2E62696E6428293A66756E6374696F6E2869297B666F722876617220653D313B653C617267756D656E74732E6C656E6774683B652B2B297B76617220743D617267756D656E74735B655D3B666F7228766172207220696E2074294F626A65';
wwv_flow_imp.g_varchar2_table(3712) := '63742E70726F746F747970652E6861734F776E50726F70657274792E63616C6C28742C7229262628695B725D3D745B725D297D72657475726E20697D2C64632E6170706C7928746869732C617267756D656E7473297D6E2864632C225F657874656E6473';
wwv_flow_imp.g_varchar2_table(3713) := '22293B7661722042753D636C61737320657874656E64732077657B636F6D706F6E656E7457696C6C556E6D6F756E7428297B6C65747B6F6E53746F703A657D3D746869732E70726F70733B6528297D72656E64657228297B6C65747B7265636F7264696E';
wwv_flow_imp.g_varchar2_table(3714) := '673A652C73747265616D3A742C7265636F72646564566964656F3A727D3D746869732E70726F70732C733D7B706C617973696E6C696E653A21307D3B72657475726E28657C7C21722626216529262628732E6D757465643D21302C732E6175746F706C61';
wwv_flow_imp.g_varchar2_table(3715) := '793D21302C732E7372634F626A6563743D74292C7226262165262628732E6D757465643D21312C732E636F6E74726F6C733D21302C732E7372633D722C746869732E766964656F456C656D656E74262628746869732E766964656F456C656D656E742E73';
wwv_flow_imp.g_varchar2_table(3716) := '72634F626A6563743D766F6964203029292C752822646976222C7B636C6173734E616D653A227570707920757070792D53637265656E436170747572652D636F6E7461696E6572227D2C752822646976222C7B636C6173734E616D653A22757070792D53';
wwv_flow_imp.g_varchar2_table(3717) := '637265656E436170747572652D766964656F436F6E7461696E6572227D2C752873762C746869732E70726F7073292C752822766964656F222C6463287B7265663A6F3D3E7B746869732E766964656F456C656D656E743D6F7D2C636C6173734E616D653A';
wwv_flow_imp.g_varchar2_table(3718) := '22757070792D53637265656E436170747572652D766964656F227D2C7329292C752872762C746869732E70726F707329292C752822646976222C7B636C6173734E616D653A22757070792D53637265656E436170747572652D627574746F6E436F6E7461';
wwv_flow_imp.g_varchar2_table(3719) := '696E6572227D2C752875632C746869732E70726F7073292C752868632C746869732E70726F70732929297D7D3B6E2842752C225265636F7264657253637265656E22293B766172206F763D42753B766172206E763D7B737472696E67733A7B7374617274';
wwv_flow_imp.g_varchar2_table(3720) := '436170747572696E673A22426567696E2073637265656E20636170747572696E67222C73746F70436170747572696E673A2253746F702073637265656E20636170747572696E67222C7375626D69745265636F7264656446696C653A225375626D697420';
wwv_flow_imp.g_varchar2_table(3721) := '7265636F726465642066696C65222C73747265616D4163746976653A2253747265616D20616374697665222C73747265616D506173736976653A2253747265616D2070617373697665222C6D696344697361626C65643A224D6963726F70686F6E652061';
wwv_flow_imp.g_varchar2_table(3722) := '63636573732064656E6965642062792075736572222C7265636F7264696E673A225265636F7264696E67227D7D3B66756E6374696F6E20636328297B72657475726E2063633D4F626A6563742E61737369676E3F4F626A6563742E61737369676E2E6269';
wwv_flow_imp.g_varchar2_table(3723) := '6E6428293A66756E6374696F6E2869297B666F722876617220653D313B653C617267756D656E74732E6C656E6774683B652B2B297B76617220743D617267756D656E74735B655D3B666F7228766172207220696E2074294F626A6563742E70726F746F74';
wwv_flow_imp.g_varchar2_table(3724) := '7970652E6861734F776E50726F70657274792E63616C6C28742C7229262628695B725D3D745B725D297D72657475726E20697D2C63632E6170706C7928746869732C617267756D656E7473297D6E2863632C225F657874656E647322293B766172207750';
wwv_flow_imp.g_varchar2_table(3725) := '3D7B76657273696F6E3A22332E312E33227D3B66756E6374696F6E20535028297B76617220693B72657475726E2077696E646F772E4D656469615265636F7264657226262828693D6E6176696761746F722E6D6564696144657669636573293D3D6E756C';
wwv_flow_imp.g_varchar2_table(3726) := '6C3F766F696420303A692E676574446973706C61794D65646961297D6E2853502C22697353637265656E5265636F7264696E67537570706F7274656422293B66756E6374696F6E20505028297B72657475726E2077696E646F772E4D656469615265636F';
wwv_flow_imp.g_varchar2_table(3727) := '7264657226266E6176696761746F722E6D65646961446576696365737D6E2850502C226765744D656469614465766963657322293B766172206E733D636C61737320657874656E6473205A7B636F6E7374727563746F7228652C74297B73757065722865';
wwv_flow_imp.g_varchar2_table(3728) := '2C74292C746869732E6D65646961446576696365733D505028292C746869732E70726F746F636F6C3D6C6F636174696F6E2E70726F746F636F6C3D3D3D2268747470733A223F226874747073223A2268747470222C746869732E69643D746869732E6F70';
wwv_flow_imp.g_varchar2_table(3729) := '74732E69647C7C2253637265656E43617074757265222C746869732E7469746C653D746869732E6F7074732E7469746C657C7C2253637265656E63617374222C746869732E747970653D226163717569726572222C746869732E69636F6E3D69762C7468';
wwv_flow_imp.g_varchar2_table(3730) := '69732E64656661756C744C6F63616C653D6E763B6C657420723D7B646973706C61794D65646961436F6E73747261696E74733A7B766964656F3A7B77696474683A313238302C6865696768743A3732302C6672616D65526174653A7B696465616C3A332C';
wwv_flow_imp.g_varchar2_table(3731) := '6D61783A357D2C637572736F723A226D6F74696F6E222C646973706C6179537572666163653A226D6F6E69746F72227D7D2C757365724D65646961436F6E73747261696E74733A7B617564696F3A21307D2C707265666572726564566964656F4D696D65';
wwv_flow_imp.g_varchar2_table(3732) := '547970653A22766964656F2F7765626D227D3B746869732E6F7074733D7B2E2E2E722C2E2E2E747D2C746869732E6931386E496E697428292C746869732E696E7374616C6C3D746869732E696E7374616C6C2E62696E642874686973292C746869732E73';
wwv_flow_imp.g_varchar2_table(3733) := '6574506C7567696E53746174653D746869732E736574506C7567696E53746174652E62696E642874686973292C746869732E72656E6465723D746869732E72656E6465722E62696E642874686973292C746869732E73746172743D746869732E73746172';
wwv_flow_imp.g_varchar2_table(3734) := '742E62696E642874686973292C746869732E73746F703D746869732E73746F702E62696E642874686973292C746869732E73746172745265636F7264696E673D746869732E73746172745265636F7264696E672E62696E642874686973292C746869732E';
wwv_flow_imp.g_varchar2_table(3735) := '73746F705265636F7264696E673D746869732E73746F705265636F7264696E672E62696E642874686973292C746869732E7375626D69743D746869732E7375626D69742E62696E642874686973292C746869732E73747265616D496E7465727275707465';
wwv_flow_imp.g_varchar2_table(3736) := '643D746869732E73747265616D496E6163746976617465642E62696E642874686973292C746869732E636170747572654163746976653D21312C746869732E63617074757265644D6564696146696C653D6E756C6C7D696E7374616C6C28297B69662821';
wwv_flow_imp.g_varchar2_table(3737) := '535028292972657475726E20746869732E757070792E6C6F67282253637265656E207265636F7264657220616363657373206973206E6F7420737570706F72746564222C227761726E696E6722292C6E756C6C3B746869732E736574506C7567696E5374';
wwv_flow_imp.g_varchar2_table(3738) := '617465287B73747265616D4163746976653A21312C617564696F53747265616D4163746976653A21317D293B6C65747B7461726765743A657D3D746869732E6F7074733B652626746869732E6D6F756E7428652C74686973297D756E696E7374616C6C28';
wwv_flow_imp.g_varchar2_table(3739) := '297B746869732E766964656F53747265616D2626746869732E73746F7028292C746869732E756E6D6F756E7428297D737461727428297B72657475726E20746869732E6D65646961446576696365733F28746869732E636170747572654163746976653D';
wwv_flow_imp.g_varchar2_table(3740) := '21302C746869732E73656C656374417564696F53747265616D536F7572636528292C746869732E73656C656374566964656F53747265616D536F7572636528292E7468656E28653D3E7B653D3D3D21312626746869732E706172656E742626746869732E';
wwv_flow_imp.g_varchar2_table(3741) := '706172656E742E68696465416C6C50616E656C73262628746869732E706172656E742E68696465416C6C50616E656C7328292C746869732E636170747572654163746976653D2131297D29293A50726F6D6973652E72656A656374286E6577204572726F';
wwv_flow_imp.g_varchar2_table(3742) := '72282253637265656E207265636F7264657220616363657373206E6F7420737570706F727465642229297D73656C656374566964656F53747265616D536F7572636528297B72657475726E20746869732E766964656F53747265616D3F6E65772050726F';
wwv_flow_imp.g_varchar2_table(3743) := '6D69736528653D3E6528746869732E766964656F53747265616D29293A746869732E6D65646961446576696365732E676574446973706C61794D6564696128746869732E6F7074732E646973706C61794D65646961436F6E73747261696E7473292E7468';
wwv_flow_imp.g_varchar2_table(3744) := '656E28653D3E28746869732E766964656F53747265616D3D652C746869732E766964656F53747265616D2E6164644576656E744C697374656E65722822696E616374697665222C28293D3E7B746869732E73747265616D496E6163746976617465642829';
wwv_flow_imp.g_varchar2_table(3745) := '7D292C746869732E736574506C7567696E5374617465287B73747265616D4163746976653A21307D292C6529292E636174636828653D3E28746869732E736574506C7567696E5374617465287B73637265656E5265634572726F723A657D292C74686973';
wwv_flow_imp.g_varchar2_table(3746) := '2E7573657244656E6965643D21302C73657454696D656F75742828293D3E7B746869732E7573657244656E6965643D21317D2C316533292C213129297D73656C656374417564696F53747265616D536F7572636528297B72657475726E20746869732E61';
wwv_flow_imp.g_varchar2_table(3747) := '7564696F53747265616D3F6E65772050726F6D69736528653D3E6528746869732E617564696F53747265616D29293A746869732E6D65646961446576696365732E676574557365724D6564696128746869732E6F7074732E757365724D65646961436F6E';
wwv_flow_imp.g_varchar2_table(3748) := '73747261696E7473292E7468656E28653D3E28746869732E617564696F53747265616D3D652C746869732E736574506C7567696E5374617465287B617564696F53747265616D4163746976653A21307D292C6529292E636174636828653D3E28652E6E61';
wwv_flow_imp.g_varchar2_table(3749) := '6D653D3D3D224E6F74416C6C6F7765644572726F7222262628746869732E757070792E696E666F28746869732E6931386E28226D696344697361626C656422292C226572726F72222C356533292C746869732E757070792E6C6F6728746869732E693138';
wwv_flow_imp.g_varchar2_table(3750) := '6E28226D696344697361626C656422292C227761726E696E672229292C213129297D73746172745265636F7264696E6728297B6C657420653D7B7D3B746869732E63617074757265644D6564696146696C653D6E756C6C2C746869732E7265636F726469';
wwv_flow_imp.g_varchar2_table(3751) := '6E674368756E6B733D5B5D3B6C65747B707265666572726564566964656F4D696D65547970653A747D3D746869732E6F7074733B746869732E73656C656374566964656F53747265616D536F7572636528292E7468656E28723D3E7B7426264D65646961';
wwv_flow_imp.g_varchar2_table(3752) := '5265636F726465722E697354797065537570706F7274656428742926264B69287429262628652E6D696D65547970653D74293B6C657420733D5B722E676574566964656F547261636B7328295B305D5D3B746869732E617564696F53747265616D262673';
wwv_flow_imp.g_varchar2_table(3753) := '2E7075736828746869732E617564696F53747265616D2E676574417564696F547261636B7328295B305D292C746869732E6F757470757453747265616D3D6E6577204D6564696153747265616D2873292C746869732E7265636F726465723D6E6577204D';
wwv_flow_imp.g_varchar2_table(3754) := '656469615265636F7264657228746869732E6F757470757453747265616D2C65292C746869732E7265636F726465722E6164644576656E744C697374656E6572282264617461617661696C61626C65222C6F3D3E7B746869732E7265636F7264696E6743';
wwv_flow_imp.g_varchar2_table(3755) := '68756E6B732E70757368286F2E64617461297D292C746869732E7265636F726465722E737461727428292C746869732E736574506C7567696E5374617465287B7265636F7264696E673A21307D297D292E636174636828723D3E7B746869732E75707079';
wwv_flow_imp.g_varchar2_table(3756) := '2E6C6F6728722C226572726F7222297D297D73747265616D496E61637469766174656428297B6C65747B7265636F72646564566964656F3A652C7265636F7264696E673A747D3D7B2E2E2E746869732E676574506C7567696E537461746528297D3B2165';
wwv_flow_imp.g_varchar2_table(3757) := '262621743F746869732E706172656E742626746869732E706172656E742E68696465416C6C50616E656C732626746869732E706172656E742E68696465416C6C50616E656C7328293A74262628746869732E757070792E6C6F6728224361707475726520';
wwv_flow_imp.g_varchar2_table(3758) := '73747265616D20696E616374697665205C75323031342073746F70207265636F7264696E6722292C746869732E73746F705265636F7264696E672829292C746869732E766964656F53747265616D3D6E756C6C2C746869732E617564696F53747265616D';
wwv_flow_imp.g_varchar2_table(3759) := '3D6E756C6C2C746869732E736574506C7567696E5374617465287B73747265616D4163746976653A21312C617564696F53747265616D4163746976653A21317D297D73746F705265636F7264696E6728297B72657475726E206E65772050726F6D697365';
wwv_flow_imp.g_varchar2_table(3760) := '28743D3E7B746869732E7265636F726465722E6164644576656E744C697374656E6572282273746F70222C28293D3E7B7428297D292C746869732E7265636F726465722E73746F7028297D292E7468656E2828293D3E28746869732E736574506C756769';
wwv_flow_imp.g_varchar2_table(3761) := '6E5374617465287B7265636F7264696E673A21317D292C746869732E676574566964656F282929292E7468656E28743D3E7B746869732E63617074757265644D6564696146696C653D742C746869732E736574506C7567696E5374617465287B7265636F';
wwv_flow_imp.g_varchar2_table(3762) := '72646564566964656F3A55524C2E6372656174654F626A65637455524C28742E64617461297D297D292E7468656E2828293D3E7B746869732E7265636F7264696E674368756E6B733D6E756C6C2C746869732E7265636F726465723D6E756C6C7D2C743D';
wwv_flow_imp.g_varchar2_table(3763) := '3E7B7468726F7720746869732E7265636F7264696E674368756E6B733D6E756C6C2C746869732E7265636F726465723D6E756C6C2C747D297D7375626D697428297B7472797B746869732E63617074757265644D6564696146696C652626746869732E75';
wwv_flow_imp.g_varchar2_table(3764) := '7070792E61646446696C6528746869732E63617074757265644D6564696146696C65297D63617463682865297B652E69735265737472696374696F6E7C7C746869732E757070792E6C6F6728652C227761726E696E6722297D7D73746F7028297B746869';
wwv_flow_imp.g_varchar2_table(3765) := '732E766964656F53747265616D262628746869732E766964656F53747265616D2E676574566964656F547261636B7328292E666F724561636828653D3E7B652E73746F7028297D292C746869732E766964656F53747265616D2E676574417564696F5472';
wwv_flow_imp.g_varchar2_table(3766) := '61636B7328292E666F724561636828653D3E7B652E73746F7028297D292C746869732E766964656F53747265616D3D6E756C6C292C746869732E617564696F53747265616D262628746869732E617564696F53747265616D2E676574417564696F547261';
wwv_flow_imp.g_varchar2_table(3767) := '636B7328292E666F724561636828653D3E7B652E73746F7028297D292C746869732E617564696F53747265616D2E676574566964656F547261636B7328292E666F724561636828653D3E7B652E73746F7028297D292C746869732E617564696F53747265';
wwv_flow_imp.g_varchar2_table(3768) := '616D3D6E756C6C292C746869732E6F757470757453747265616D262628746869732E6F757470757453747265616D2E676574417564696F547261636B7328292E666F724561636828653D3E7B652E73746F7028297D292C746869732E6F75747075745374';
wwv_flow_imp.g_varchar2_table(3769) := '7265616D2E676574566964656F547261636B7328292E666F724561636828653D3E7B652E73746F7028297D292C746869732E6F757470757453747265616D3D6E756C6C292C746869732E736574506C7567696E5374617465287B7265636F726465645669';
wwv_flow_imp.g_varchar2_table(3770) := '64656F3A6E756C6C7D292C746869732E636170747572654163746976653D21317D676574566964656F28297B6C657420653D746869732E7265636F7264696E674368756E6B735B305D2E747970652C743D4B692865293B69662821742972657475726E20';
wwv_flow_imp.g_varchar2_table(3771) := '50726F6D6973652E72656A656374286E6577204572726F722860436F756C64206E6F74207265747269657665207265636F7264696E673A20556E737570706F72746564206D6564696120747970652022247B657D226029293B6C657420723D6073637265';
wwv_flow_imp.g_varchar2_table(3772) := '656E6361702D247B446174652E6E6F7728297D2E247B747D602C733D6E657720426C6F6228746869732E7265636F7264696E674368756E6B732C7B747970653A657D292C6F3D7B736F757263653A746869732E69642C6E616D653A722C646174613A6E65';
wwv_flow_imp.g_varchar2_table(3773) := '7720426C6F62285B735D2C7B747970653A657D292C747970653A657D3B72657475726E2050726F6D6973652E7265736F6C7665286F297D72656E64657228297B6C657420653D746869732E676574506C7567696E537461746528293B72657475726E2165';
wwv_flow_imp.g_varchar2_table(3774) := '2E73747265616D416374697665262621746869732E63617074757265416374697665262621746869732E7573657244656E6965642626746869732E737461727428292C75286F762C6363287B7D2C652C7B6F6E53746172745265636F7264696E673A7468';
wwv_flow_imp.g_varchar2_table(3775) := '69732E73746172745265636F7264696E672C6F6E53746F705265636F7264696E673A746869732E73746F705265636F7264696E672C6F6E53746F703A746869732E73746F702C6F6E5375626D69743A746869732E7375626D69742C6931386E3A74686973';
wwv_flow_imp.g_varchar2_table(3776) := '2E6931386E2C73747265616D3A746869732E766964656F53747265616D7D29297D7D3B6E286E732C2253637265656E4361707475726522293B6E732E56455253494F4E3D77502E76657273696F6E3B7661722067763D646528617628292C31293B66756E';
wwv_flow_imp.g_varchar2_table(3777) := '6374696F6E20666328692C652C74297B72657475726E206E65772050726F6D69736528723D3E7B692E746F426C6F6228722C652C74297D297D6E2866632C2263616E766173546F426C6F6222293B66756E6374696F6E206D6328297B72657475726E2074';
wwv_flow_imp.g_varchar2_table(3778) := '7970656F66204D656469615265636F726465723D3D2266756E6374696F6E22262621214D656469615265636F726465722E70726F746F747970652626747970656F66204D656469615265636F726465722E70726F746F747970652E73746172743D3D2266';
wwv_flow_imp.g_varchar2_table(3779) := '756E6374696F6E227D6E286D632C22737570706F7274734D656469615265636F7264657222293B766172206A753D6E2828293D3E752822737667222C7B22617269612D68696464656E223A2274727565222C666F63757361626C653A2266616C7365222C';
wwv_flow_imp.g_varchar2_table(3780) := '66696C6C3A2223303039374443222C77696474683A223636222C6865696768743A223535222C76696577426F783A22302030203636203535227D2C75282270617468222C7B643A224D35372E3320382E34333363342E3539203020382E3120332E353120';
wwv_flow_imp.g_varchar2_table(3781) := '382E3120382E317632392E37633020342E35392D332E353120382E312D382E3120382E3148382E37632D342E353920302D382E312D332E35312D382E312D382E31762D32392E3763302D342E353920332E35312D382E3120382E312D382E3168392E3435';
wwv_flow_imp.g_varchar2_table(3782) := '6C342E35392D372E3032632E35342D2E353420312E33352D312E303820322E31362D312E30386831362E32632E3831203020312E36322E353420322E313620312E30386C342E353920372E303268392E34357A4D33332031342E3634632D382E36322030';
wwv_flow_imp.g_varchar2_table(3783) := '2D31352E33393320362E3737332D31352E3339332031352E333933203020382E363220362E3737332031352E3339332031352E3339332031352E33393320382E363220302031352E3339332D362E3737332031352E3339332D31352E33393320302D382E';
wwv_flow_imp.g_varchar2_table(3784) := '36322D362E3737332D31352E3339332D31352E3339332D31352E3339337A4D3333203430632D352E36343820302D392E3936362D342E3331392D392E3936362D392E39363720302D352E36343720342E3331382D392E39363620392E3936362D392E3936';
wwv_flow_imp.g_varchar2_table(3785) := '3673392E39363620342E33313920392E39363620392E3936364334322E3936362033352E3638312033382E3634382034302033332034307A222C66696C6C52756C653A226576656E6F6464227D29292C2264656661756C7422293B766172206C763D6E28';
wwv_flow_imp.g_varchar2_table(3786) := '693D3E7B6C65747B6F6E536E617073686F743A652C6931386E3A747D3D693B72657475726E20752822627574746F6E222C7B636C6173734E616D653A22757070792D752D726573657420757070792D632D62746E20757070792D57656263616D2D627574';
wwv_flow_imp.g_varchar2_table(3787) := '746F6E20757070792D57656263616D2D627574746F6E2D2D70696374757265222C747970653A22627574746F6E222C7469746C653A74282274616B655069637475726522292C22617269612D6C6162656C223A74282274616B655069637475726522292C';
wwv_flow_imp.g_varchar2_table(3788) := '6F6E436C69636B3A652C22646174612D757070792D73757065722D666F63757361626C65223A21307D2C6A752829297D2C2264656661756C7422293B66756E6374696F6E2067632869297B6C65747B7265636F7264696E673A652C6F6E53746172745265';
wwv_flow_imp.g_varchar2_table(3789) := '636F7264696E673A742C6F6E53746F705265636F7264696E673A722C6931386E3A737D3D693B72657475726E20653F752822627574746F6E222C7B636C6173734E616D653A22757070792D752D726573657420757070792D632D62746E20757070792D57';
wwv_flow_imp.g_varchar2_table(3790) := '656263616D2D627574746F6E222C747970653A22627574746F6E222C7469746C653A73282273746F705265636F7264696E6722292C22617269612D6C6162656C223A73282273746F705265636F7264696E6722292C6F6E436C69636B3A722C2264617461';
wwv_flow_imp.g_varchar2_table(3791) := '2D757070792D73757065722D666F63757361626C65223A21307D2C752822737667222C7B22617269612D68696464656E223A2274727565222C666F63757361626C653A2266616C7365222C636C6173734E616D653A22757070792D632D69636F6E222C77';
wwv_flow_imp.g_varchar2_table(3792) := '696474683A22313030222C6865696768743A22313030222C76696577426F783A223020302031303020313030227D2C75282272656374222C7B783A223135222C793A223135222C77696474683A223730222C6865696768743A223730227D2929293A7528';
wwv_flow_imp.g_varchar2_table(3793) := '22627574746F6E222C7B636C6173734E616D653A22757070792D752D726573657420757070792D632D62746E20757070792D57656263616D2D627574746F6E222C747970653A22627574746F6E222C7469746C653A73282273746172745265636F726469';
wwv_flow_imp.g_varchar2_table(3794) := '6E6722292C22617269612D6C6162656C223A73282273746172745265636F7264696E6722292C6F6E436C69636B3A742C22646174612D757070792D73757065722D666F63757361626C65223A21307D2C752822737667222C7B22617269612D6869646465';
wwv_flow_imp.g_varchar2_table(3795) := '6E223A2274727565222C666F63757361626C653A2266616C7365222C636C6173734E616D653A22757070792D632D69636F6E222C77696474683A22313030222C6865696768743A22313030222C76696577426F783A223020302031303020313030227D2C';
wwv_flow_imp.g_varchar2_table(3796) := '752822636972636C65222C7B63783A223530222C63793A223530222C723A223430227D2929297D6E2867632C225265636F7264427574746F6E22293B66756E6374696F6E2079632869297B72657475726E60247B4D6174682E666C6F6F7228692F363029';
wwv_flow_imp.g_varchar2_table(3797) := '7D3A247B537472696E672869253630292E706164537461727428322C30297D607D6E2879632C22666F726D61745365636F6E647322293B66756E6374696F6E2076632869297B6C65747B7265636F7264696E674C656E6774685365636F6E64733A652C69';
wwv_flow_imp.g_varchar2_table(3798) := '31386E3A747D3D692C723D79632865293B72657475726E207528227370616E222C7B22617269612D6C6162656C223A7428227265636F7264696E674C656E677468222C7B7265636F7264696E675F6C656E6774683A727D297D2C72297D6E2876632C2252';
wwv_flow_imp.g_varchar2_table(3799) := '65636F7264696E674C656E67746822293B7661722075763D6E28693D3E7B6C65747B63757272656E7444657669636549643A652C766964656F536F75726365733A742C6F6E4368616E6765566964656F536F757263653A727D3D693B72657475726E2075';
wwv_flow_imp.g_varchar2_table(3800) := '2822646976222C7B636C6173734E616D653A22757070792D57656263616D2D766964656F536F75726365227D2C75282273656C656374222C7B636C6173734E616D653A22757070792D752D726573657420757070792D57656263616D2D766964656F536F';
wwv_flow_imp.g_varchar2_table(3801) := '757263652D73656C656374222C6F6E4368616E67653A733D3E7B7228732E7461726765742E76616C7565297D7D2C742E6D617028733D3E7528226F7074696F6E222C7B6B65793A732E64657669636549642C76616C75653A732E64657669636549642C73';
wwv_flow_imp.g_varchar2_table(3802) := '656C65637465643A732E64657669636549643D3D3D657D2C732E6C6162656C292929297D2C2264656661756C7422293B66756E6374696F6E2045502869297B6C65747B6F6E5375626D69743A652C6931386E3A747D3D693B72657475726E207528226275';
wwv_flow_imp.g_varchar2_table(3803) := '74746F6E222C7B636C6173734E616D653A22757070792D752D726573657420757070792D632D62746E20757070792D57656263616D2D627574746F6E20757070792D57656263616D2D627574746F6E2D2D7375626D6974222C747970653A22627574746F';
wwv_flow_imp.g_varchar2_table(3804) := '6E222C7469746C653A7428227375626D69745265636F7264656446696C6522292C22617269612D6C6162656C223A7428227375626D69745265636F7264656446696C6522292C6F6E436C69636B3A652C22646174612D757070792D73757065722D666F63';
wwv_flow_imp.g_varchar2_table(3805) := '757361626C65223A21307D2C752822737667222C7B77696474683A223132222C6865696768743A2239222C76696577426F783A223020302031322039222C786D6C6E733A22687474703A2F2F7777772E77332E6F72672F323030302F737667222C226172';
wwv_flow_imp.g_varchar2_table(3806) := '69612D68696464656E223A2274727565222C666F63757361626C653A2266616C7365222C636C6173734E616D653A22757070792D632D69636F6E227D2C75282270617468222C7B66696C6C3A2223666666222C66696C6C52756C653A226E6F6E7A65726F';
wwv_flow_imp.g_varchar2_table(3807) := '222C643A224D31302E363620304C313220312E333120342E3133362039203020342E3935366C312E33342D312E33314C342E31333620362E33387A227D2929297D6E2845502C225375626D6974427574746F6E22293B7661722068763D45503B66756E63';
wwv_flow_imp.g_varchar2_table(3808) := '74696F6E2043502869297B6C65747B6F6E446973636172643A652C6931386E3A747D3D693B72657475726E20752822627574746F6E222C7B636C6173734E616D653A22757070792D752D726573657420757070792D632D62746E20757070792D57656263';
wwv_flow_imp.g_varchar2_table(3809) := '616D2D627574746F6E20757070792D57656263616D2D627574746F6E2D2D64697363617264222C747970653A22627574746F6E222C7469746C653A742822646973636172645265636F7264656446696C6522292C22617269612D6C6162656C223A742822';
wwv_flow_imp.g_varchar2_table(3810) := '646973636172645265636F7264656446696C6522292C6F6E436C69636B3A652C22646174612D757070792D73757065722D666F63757361626C65223A21307D2C752822737667222C7B77696474683A223133222C6865696768743A223133222C76696577';
wwv_flow_imp.g_varchar2_table(3811) := '426F783A22302030203133203133222C786D6C6E733A22687474703A2F2F7777772E77332E6F72672F323030302F737667222C22617269612D68696464656E223A2274727565222C666F63757361626C653A2266616C7365222C636C6173734E616D653A';
wwv_flow_imp.g_varchar2_table(3812) := '22757070792D632D69636F6E227D2C75282267222C7B66696C6C3A2223464646222C66696C6C52756C653A226576656E6F6464227D2C75282270617468222C7B643A224D2E3439362031312E3336374C31312E3130332E37366C312E34313420312E3431';
wwv_flow_imp.g_varchar2_table(3813) := '344C312E3931312031322E3738317A227D292C75282270617468222C7B643A224D31312E3130342031322E3738324C2E34393720322E31373520312E3931312E37366C31302E3630372031302E3630367A227D292929297D6E2843502C22446973636172';
wwv_flow_imp.g_varchar2_table(3814) := '64427574746F6E22293B7661722064763D43503B66756E6374696F6E20626328297B72657475726E2062633D4F626A6563742E61737369676E3F4F626A6563742E61737369676E2E62696E6428293A66756E6374696F6E2869297B666F72287661722065';
wwv_flow_imp.g_varchar2_table(3815) := '3D313B653C617267756D656E74732E6C656E6774683B652B2B297B76617220743D617267756D656E74735B655D3B666F7228766172207220696E2074294F626A6563742E70726F746F747970652E6861734F776E50726F70657274792E63616C6C28742C';
wwv_flow_imp.g_varchar2_table(3816) := '7229262628695B725D3D745B725D297D72657475726E20697D2C62632E6170706C7928746869732C617267756D656E7473297D6E2862632C225F657874656E647322293B66756E6374696F6E20487528692C65297B72657475726E20692E696E636C7564';
wwv_flow_imp.g_varchar2_table(3817) := '65732865297D6E2848752C2269734D6F6465417661696C61626C6522293B7661722024753D636C61737320657874656E64732077657B636F6D706F6E656E744469644D6F756E7428297B6C65747B6F6E466F6375733A657D3D746869732E70726F70733B';
wwv_flow_imp.g_varchar2_table(3818) := '6528297D636F6D706F6E656E7457696C6C556E6D6F756E7428297B6C65747B6F6E53746F703A657D3D746869732E70726F70733B6528297D72656E64657228297B6C65747B7372633A652C7265636F72646564566964656F3A742C7265636F7264696E67';
wwv_flow_imp.g_varchar2_table(3819) := '3A722C6D6F6465733A732C737570706F7274735265636F7264696E673A6F2C766964656F536F75726365733A612C73686F77566964656F536F7572636544726F70646F776E3A6C2C73686F775265636F7264696E674C656E6774683A682C6F6E5375626D';
wwv_flow_imp.g_varchar2_table(3820) := '69743A632C6931386E3A642C6D6972726F723A662C6F6E536E617073686F743A792C6F6E53746172745265636F7264696E673A622C6F6E53746F705265636F7264696E673A532C6F6E446973636172645265636F72646564566964656F3A452C7265636F';
wwv_flow_imp.g_varchar2_table(3821) := '7264696E674C656E6774685365636F6E64733A467D3D746869732E70726F70732C783D2121742C553D217826266F262628487528732C22766964656F2D6F6E6C7922297C7C487528732C22617564696F2D6F6E6C7922297C7C487528732C22766964656F';
wwv_flow_imp.g_varchar2_table(3822) := '2D617564696F2229292C6A3D21782626487528732C227069637475726522292C473D6F262668262621782C4A3D6C2626612626612E6C656E6774683E312C423D7B706C617973696E6C696E653A21307D3B72657475726E20743F28422E6D757465643D21';
wwv_flow_imp.g_varchar2_table(3823) := '312C422E636F6E74726F6C733D21302C422E7372633D742C746869732E766964656F456C656D656E74262628746869732E766964656F456C656D656E742E7372634F626A6563743D766F6964203029293A28422E6D757465643D21302C422E6175746F70';
wwv_flow_imp.g_varchar2_table(3824) := '6C61793D21302C422E7372634F626A6563743D65292C752822646976222C7B636C6173734E616D653A227570707920757070792D57656263616D2D636F6E7461696E6572227D2C752822646976222C7B636C6173734E616D653A22757070792D57656263';
wwv_flow_imp.g_varchar2_table(3825) := '616D2D766964656F436F6E7461696E6572227D2C752822766964656F222C6263287B7265663A7A3D3E746869732E766964656F456C656D656E743D7A2C636C6173734E616D653A60757070792D57656263616D2D766964656F2020247B663F2275707079';
wwv_flow_imp.g_varchar2_table(3826) := '2D57656263616D2D766964656F2D2D6D6972726F726564223A22227D607D2C422929292C752822646976222C7B636C6173734E616D653A22757070792D57656263616D2D666F6F746572227D2C752822646976222C7B636C6173734E616D653A22757070';
wwv_flow_imp.g_varchar2_table(3827) := '792D57656263616D2D766964656F536F75726365436F6E7461696E6572227D2C4A3F757628746869732E70726F7073293A6E756C6C292C752822646976222C7B636C6173734E616D653A22757070792D57656263616D2D627574746F6E436F6E7461696E';
wwv_flow_imp.g_varchar2_table(3828) := '6572227D2C6A262675286C762C7B6F6E536E617073686F743A792C6931386E3A647D292C552626752867632C7B7265636F7264696E673A722C6F6E53746172745265636F7264696E673A622C6F6E53746F705265636F7264696E673A532C6931386E3A64';
wwv_flow_imp.g_varchar2_table(3829) := '7D292C782626752868762C7B6F6E5375626D69743A632C6931386E3A647D292C782626752864762C7B6F6E446973636172643A452C6931386E3A647D29292C752822646976222C7B636C6173734E616D653A22757070792D57656263616D2D7265636F72';
wwv_flow_imp.g_varchar2_table(3830) := '64696E674C656E677468227D2C472626752876632C7B7265636F7264696E674C656E6774685365636F6E64733A462C6931386E3A647D292929297D7D3B6E2824752C2243616D65726153637265656E22293B7661722063763D24753B7661722070763D6E';
wwv_flow_imp.g_varchar2_table(3831) := '28693D3E7B6C65747B69636F6E3A652C6931386E3A742C68617343616D6572613A727D3D693B72657475726E20752822646976222C7B636C6173734E616D653A22757070792D57656263616D2D7065726D6973736F6E73227D2C752822646976222C7B63';
wwv_flow_imp.g_varchar2_table(3832) := '6C6173734E616D653A22757070792D57656263616D2D7065726D6973736F6E7349636F6E227D2C652829292C7528226831222C7B636C6173734E616D653A22757070792D57656263616D2D7469746C65227D2C7428723F22616C6C6F7741636365737354';
wwv_flow_imp.g_varchar2_table(3833) := '69746C65223A226E6F43616D6572615469746C652229292C75282270222C6E756C6C2C7428723F22616C6C6F774163636573734465736372697074696F6E223A226E6F43616D6572614465736372697074696F6E222929297D2C2264656661756C742229';
wwv_flow_imp.g_varchar2_table(3834) := '3B7661722066763D7B737472696E67733A7B706C7567696E4E616D6543616D6572613A2243616D657261222C6E6F43616D6572615469746C653A2243616D657261204E6F7420417661696C61626C65222C6E6F43616D6572614465736372697074696F6E';
wwv_flow_imp.g_varchar2_table(3835) := '3A22496E206F7264657220746F2074616B65207069637475726573206F72207265636F726420766964656F2C20706C6561736520636F6E6E65637420612063616D65726120646576696365222C7265636F7264696E6753746F707065644D617853697A65';
wwv_flow_imp.g_varchar2_table(3836) := '3A225265636F7264696E672073746F707065642062656361757365207468652066696C652073697A652069732061626F757420746F2065786365656420746865206C696D6974222C7375626D69745265636F7264656446696C653A225375626D69742072';
wwv_flow_imp.g_varchar2_table(3837) := '65636F726465642066696C65222C646973636172645265636F7264656446696C653A2244697363617264207265636F726465642066696C65222C736D696C653A22536D696C6521222C74616B65506963747572653A2254616B6520612070696374757265';
wwv_flow_imp.g_varchar2_table(3838) := '222C73746172745265636F7264696E673A22426567696E20766964656F207265636F7264696E67222C73746F705265636F7264696E673A2253746F7020766964656F207265636F7264696E67222C7265636F7264696E674C656E6774683A225265636F72';
wwv_flow_imp.g_varchar2_table(3839) := '64696E67206C656E67746820257B7265636F7264696E675F6C656E6774687D222C616C6C6F774163636573735469746C653A22506C6561736520616C6C6F772061636365737320746F20796F75722063616D657261222C616C6C6F774163636573734465';
wwv_flow_imp.g_varchar2_table(3840) := '736372697074696F6E3A22496E206F7264657220746F2074616B65207069637475726573206F72207265636F726420766964656F207769746820796F75722063616D6572612C20706C6561736520616C6C6F772063616D6572612061636365737320666F';
wwv_flow_imp.g_varchar2_table(3841) := '72207468697320736974652E227D7D3B66756E6374696F6E20536328297B72657475726E2053633D4F626A6563742E61737369676E3F4F626A6563742E61737369676E2E62696E6428293A66756E6374696F6E2869297B666F722876617220653D313B65';
wwv_flow_imp.g_varchar2_table(3842) := '3C617267756D656E74732E6C656E6774683B652B2B297B76617220743D617267756D656E74735B655D3B666F7228766172207220696E2074294F626A6563742E70726F746F747970652E6861734F776E50726F70657274792E63616C6C28742C72292626';
wwv_flow_imp.g_varchar2_table(3843) := '28695B725D3D745B725D297D72657475726E20697D2C53632E6170706C7928746869732C617267756D656E7473297D6E2853632C225F657874656E647322293B66756E6374696F6E20506128692C65297B696628214F626A6563742E70726F746F747970';
wwv_flow_imp.g_varchar2_table(3844) := '652E6861734F776E50726F70657274792E63616C6C28692C6529297468726F77206E657720547970654572726F722822617474656D7074656420746F207573652070726976617465206669656C64206F6E206E6F6E2D696E7374616E636522293B726574';
wwv_flow_imp.g_varchar2_table(3845) := '75726E20697D6E2850612C225F636C617373507269766174654669656C644C6F6F73654261736522293B766172204F503D303B66756E6374696F6E2054502869297B72657475726E225F5F707269766174655F222B4F502B2B2B225F222B697D6E285450';
wwv_flow_imp.g_varchar2_table(3846) := '2C225F636C617373507269766174654669656C644C6F6F73654B657922293B7661722041503D7B76657273696F6E3A22332E332E34227D3B66756E6374696F6E206D762869297B72657475726E20695B305D3D3D3D222E223F6D6E5B692E736C69636528';
wwv_flow_imp.g_varchar2_table(3847) := '31295D3A697D6E286D762C22746F4D696D655479706522293B66756E6374696F6E2052502869297B72657475726E2F5E766964656F5C2F5B5E2A5D2B242F2E746573742869297D6E2852502C226973566964656F4D696D655479706522293B66756E6374';
wwv_flow_imp.g_varchar2_table(3848) := '696F6E2055502869297B72657475726E2F5E696D6167655C2F5B5E2A5D2B242F2E746573742869297D6E2855502C226973496D6167654D696D655479706522293B66756E6374696F6E206B5028297B72657475726E206E6176696761746F722E6D656469';
wwv_flow_imp.g_varchar2_table(3849) := '61446576696365737D6E286B502C226765744D656469614465766963657322293B66756E6374696F6E20776328692C65297B72657475726E20692E696E636C756465732865297D6E2877632C2269734D6F6465417661696C61626C6522293B7661722041';
wwv_flow_imp.g_varchar2_table(3850) := '693D54502822656E61626C654D6972726F7222292C61733D636C61737320657874656E6473205A7B636F6E7374727563746F7228652C74297B737570657228652C74292C4F626A6563742E646566696E6550726F706572747928746869732C41692C7B77';
wwv_flow_imp.g_varchar2_table(3851) := '72697461626C653A21302C76616C75653A766F696420307D292C746869732E6D65646961446576696365733D6B5028292C746869732E737570706F727473557365724D656469613D2121746869732E6D65646961446576696365732C746869732E70726F';
wwv_flow_imp.g_varchar2_table(3852) := '746F636F6C3D6C6F636174696F6E2E70726F746F636F6C2E6D61746368282F68747470732F69293F226874747073223A2268747470222C746869732E69643D746869732E6F7074732E69647C7C2257656263616D222C746869732E747970653D22616371';
wwv_flow_imp.g_varchar2_table(3853) := '7569726572222C746869732E63617074757265644D6564696146696C653D6E756C6C2C746869732E69636F6E3D28293D3E752822737667222C7B22617269612D68696464656E223A2274727565222C666F63757361626C653A2266616C7365222C776964';
wwv_flow_imp.g_varchar2_table(3854) := '74683A223332222C6865696768743A223332222C76696577426F783A22302030203332203332227D2C75282270617468222C7B643A224D32332E3520392E3563312E343137203020322E3520312E30383320322E3520322E3576392E313637633020312E';
wwv_flow_imp.g_varchar2_table(3855) := '3431362D312E30383320322E352D322E3520322E35682D3135632D312E34313720302D322E352D312E3038342D322E352D322E3556313263302D312E34313720312E3038332D322E3520322E352D322E3568322E3931376C312E3431362D322E31363743';
wwv_flow_imp.g_varchar2_table(3856) := '313320372E3136372031332E323520372031332E3520376835632E32352030202E352E3136372E3636372E3333334C32302E35383320392E354832332E357A4D31362031312E34313761342E37303620342E37303620302030302D342E373520342E3735';
wwv_flow_imp.g_varchar2_table(3857) := '20342E37303420342E3730342030203030342E373520342E373520342E37303320342E3730332030203030342E37352D342E373563302D322E3636332D322E30392D342E37352D342E37352D342E37357A6D3020372E383235632D312E37343420302D33';
wwv_flow_imp.g_varchar2_table(3858) := '2E3037362D312E3333322D332E3037362D332E30373420302D312E37343520312E3333332D332E30373720332E3037362D332E30373720312E373434203020332E30373420312E33333320332E30373420332E303736732D312E333320332E3037352D33';
wwv_flow_imp.g_varchar2_table(3859) := '2E30373420332E3037357A222C66696C6C3A2223303242333833222C66696C6C52756C653A226E6F6E7A65726F227D29292C746869732E64656661756C744C6F63616C653D66763B6C657420723D7B6F6E4265666F7265536E617073686F743A28293D3E';
wwv_flow_imp.g_varchar2_table(3860) := '50726F6D6973652E7265736F6C766528292C636F756E74646F776E3A21312C6D6F6465733A5B22766964656F2D617564696F222C22766964656F2D6F6E6C79222C22617564696F2D6F6E6C79222C2270696374757265225D2C6D6972726F723A21302C73';
wwv_flow_imp.g_varchar2_table(3861) := '686F77566964656F536F7572636544726F70646F776E3A21312C666163696E674D6F64653A2275736572222C766964656F436F6E73747261696E74733A766F696420302C707265666572726564496D6167654D696D65547970653A6E756C6C2C70726566';
wwv_flow_imp.g_varchar2_table(3862) := '6572726564566964656F4D696D65547970653A6E756C6C2C73686F775265636F7264696E674C656E6774683A21312C6D6F62696C654E617469766543616D6572613A28302C67762E64656661756C7429287B7461626C65743A21307D297D3B746869732E';
wwv_flow_imp.g_varchar2_table(3863) := '6F7074733D7B2E2E2E722C2E2E2E747D2C746869732E6931386E496E697428292C746869732E7469746C653D746869732E6931386E2822706C7567696E4E616D6543616D65726122292C506128746869732C4169295B41695D3D746869732E6F7074732E';
wwv_flow_imp.g_varchar2_table(3864) := '6D6972726F722C746869732E696E7374616C6C3D746869732E696E7374616C6C2E62696E642874686973292C746869732E736574506C7567696E53746174653D746869732E736574506C7567696E53746174652E62696E642874686973292C746869732E';
wwv_flow_imp.g_varchar2_table(3865) := '72656E6465723D746869732E72656E6465722E62696E642874686973292C746869732E73746172743D746869732E73746172742E62696E642874686973292C746869732E73746F703D746869732E73746F702E62696E642874686973292C746869732E74';
wwv_flow_imp.g_varchar2_table(3866) := '616B65536E617073686F743D746869732E74616B65536E617073686F742E62696E642874686973292C746869732E73746172745265636F7264696E673D746869732E73746172745265636F7264696E672E62696E642874686973292C746869732E73746F';
wwv_flow_imp.g_varchar2_table(3867) := '705265636F7264696E673D746869732E73746F705265636F7264696E672E62696E642874686973292C746869732E646973636172645265636F72646564566964656F3D746869732E646973636172645265636F72646564566964656F2E62696E64287468';
wwv_flow_imp.g_varchar2_table(3868) := '6973292C746869732E7375626D69743D746869732E7375626D69742E62696E642874686973292C746869732E6F6E6554776F5468726565536D696C653D746869732E6F6E6554776F5468726565536D696C652E62696E642874686973292C746869732E66';
wwv_flow_imp.g_varchar2_table(3869) := '6F6375733D746869732E666F6375732E62696E642874686973292C746869732E6368616E6765566964656F536F757263653D746869732E6368616E6765566964656F536F757263652E62696E642874686973292C746869732E77656263616D4163746976';
wwv_flow_imp.g_varchar2_table(3870) := '653D21312C746869732E6F7074732E636F756E74646F776E262628746869732E6F7074732E6F6E4265666F7265536E617073686F743D746869732E6F6E6554776F5468726565536D696C65292C746869732E736574506C7567696E5374617465287B6861';
wwv_flow_imp.g_varchar2_table(3871) := '7343616D6572613A21312C63616D65726152656164793A21312C63616D6572614572726F723A6E756C6C2C7265636F7264696E674C656E6774685365636F6E64733A302C766964656F536F75726365733A5B5D2C63757272656E7444657669636549643A';
wwv_flow_imp.g_varchar2_table(3872) := '6E756C6C7D297D7365744F7074696F6E732865297B73757065722E7365744F7074696F6E73287B2E2E2E652C766964656F436F6E73747261696E74733A7B2E2E2E746869732E6F7074732E766964656F436F6E73747261696E74732C2E2E2E653F2E7669';
wwv_flow_imp.g_varchar2_table(3873) := '64656F436F6E73747261696E74737D7D297D68617343616D657261436865636B28297B72657475726E20746869732E6D65646961446576696365733F746869732E6D65646961446576696365732E656E756D65726174654465766963657328292E746865';
wwv_flow_imp.g_varchar2_table(3874) := '6E28653D3E652E736F6D6528743D3E742E6B696E643D3D3D22766964656F696E7075742229293A50726F6D6973652E7265736F6C7665282131297D6973417564696F4F6E6C7928297B72657475726E20746869732E6F7074732E6D6F6465732E6C656E67';
wwv_flow_imp.g_varchar2_table(3875) := '74683D3D3D312626746869732E6F7074732E6D6F6465735B305D3D3D3D22617564696F2D6F6E6C79227D676574436F6E73747261696E74732865297B653D3D3D766F69642030262628653D6E756C6C293B6C657420743D746869732E6F7074732E6D6F64';
wwv_flow_imp.g_varchar2_table(3876) := '65732E696E6465784F662822766964656F2D617564696F2229213D3D2D317C7C746869732E6F7074732E6D6F6465732E696E6465784F662822617564696F2D6F6E6C792229213D3D2D312C723D21746869732E6973417564696F4F6E6C79282926262874';
wwv_flow_imp.g_varchar2_table(3877) := '6869732E6F7074732E6D6F6465732E696E6465784F662822766964656F2D617564696F2229213D3D2D317C7C746869732E6F7074732E6D6F6465732E696E6465784F662822766964656F2D6F6E6C792229213D3D2D317C7C746869732E6F7074732E6D6F';
wwv_flow_imp.g_varchar2_table(3878) := '6465732E696E6465784F662822706963747572652229213D3D2D31292C733D7B2E2E2E746869732E6F7074732E766964656F436F6E73747261696E74737C7C7B666163696E674D6F64653A746869732E6F7074732E666163696E674D6F64657D2C2E2E2E';
wwv_flow_imp.g_varchar2_table(3879) := '653F7B64657669636549643A652C666163696E674D6F64653A6E756C6C7D3A7B7D7D3B72657475726E7B617564696F3A742C766964656F3A723F733A21317D7D73746172742865297B696628653D3D3D766F69642030262628653D6E756C6C292C217468';
wwv_flow_imp.g_varchar2_table(3880) := '69732E737570706F727473557365724D656469612972657475726E2050726F6D6973652E72656A656374286E6577204572726F72282257656263616D20616363657373206E6F7420737570706F727465642229293B746869732E77656263616D41637469';
wwv_flow_imp.g_varchar2_table(3881) := '76653D21302C746869732E6F7074732E6D6972726F72262628506128746869732C4169295B41695D3D2130293B6C657420743D746869732E676574436F6E73747261696E747328652626652E64657669636549643F652E64657669636549643A6E756C6C';
wwv_flow_imp.g_varchar2_table(3882) := '293B746869732E68617343616D657261436865636B28292E7468656E28723D3E28746869732E736574506C7567696E5374617465287B68617343616D6572613A727D292C746869732E6D65646961446576696365732E676574557365724D656469612874';
wwv_flow_imp.g_varchar2_table(3883) := '292E7468656E28733D3E7B746869732E73747265616D3D733B6C6574206F3D6E756C6C2C613D746869732E6973417564696F4F6E6C7928293F732E676574417564696F547261636B7328293A732E676574566964656F547261636B7328293B21657C7C21';
wwv_flow_imp.g_varchar2_table(3884) := '652E64657669636549643F6F3D615B305D2E67657453657474696E677328292E64657669636549643A612E666F7245616368286C3D3E7B6C2E67657453657474696E677328292E64657669636549643D3D3D652E64657669636549642626286F3D6C2E67';
wwv_flow_imp.g_varchar2_table(3885) := '657453657474696E677328292E6465766963654964297D292C746869732E757064617465566964656F536F757263657328292C746869732E736574506C7567696E5374617465287B63757272656E7444657669636549643A6F2C63616D65726152656164';
wwv_flow_imp.g_varchar2_table(3886) := '793A21307D297D292E636174636828733D3E7B746869732E736574506C7567696E5374617465287B63616D65726152656164793A21312C63616D6572614572726F723A737D292C746869732E757070792E696E666F28732E6D6573736167652C22657272';
wwv_flow_imp.g_varchar2_table(3887) := '6F7222297D2929297D6765744D656469615265636F726465724F7074696F6E7328297B6C657420653D7B7D3B6966284D656469615265636F726465722E697354797065537570706F72746564297B6C65747B7265737472696374696F6E733A747D3D7468';
wwv_flow_imp.g_varchar2_table(3888) := '69732E757070792E6F7074732C723D5B5D3B746869732E6F7074732E707265666572726564566964656F4D696D65547970653F723D5B746869732E6F7074732E707265666572726564566964656F4D696D65547970655D3A742E616C6C6F77656446696C';
wwv_flow_imp.g_varchar2_table(3889) := '655479706573262628723D742E616C6C6F77656446696C6554797065732E6D6170286D76292E66696C74657228525029293B6C657420733D6E28613D3E4D656469615265636F726465722E697354797065537570706F7274656428612926264B69286129';
wwv_flow_imp.g_varchar2_table(3890) := '2C2266696C746572537570706F72746564547970657322292C6F3D722E66696C7465722873293B6F2E6C656E6774683E30262628652E6D696D65547970653D6F5B305D297D72657475726E20657D73746172745265636F7264696E6728297B746869732E';
wwv_flow_imp.g_varchar2_table(3891) := '7265636F726465723D6E6577204D656469615265636F7264657228746869732E73747265616D2C746869732E6765744D656469615265636F726465724F7074696F6E732829292C746869732E7265636F7264696E674368756E6B733D5B5D3B6C65742065';
wwv_flow_imp.g_varchar2_table(3892) := '3D21313B746869732E7265636F726465722E6164644576656E744C697374656E6572282264617461617661696C61626C65222C743D3E7B746869732E7265636F7264696E674368756E6B732E7075736828742E64617461293B6C65747B72657374726963';
wwv_flow_imp.g_varchar2_table(3893) := '74696F6E733A727D3D746869732E757070792E6F7074733B696628746869732E7265636F7264696E674368756E6B732E6C656E6774683E312626722E6D617846696C6553697A65213D6E756C6C26262165297B6C657420733D746869732E7265636F7264';
wwv_flow_imp.g_varchar2_table(3894) := '696E674368756E6B732E7265647563652828682C63293D3E682B632E73697A652C30292C613D28732D746869732E7265636F7264696E674368756E6B735B305D2E73697A65292F28746869732E7265636F7264696E674368756E6B732E6C656E6774682D';
wwv_flow_imp.g_varchar2_table(3895) := '31292A332C6C3D4D6174682E6D617828302C722E6D617846696C6553697A652D61293B733E6C262628653D21302C746869732E757070792E696E666F28746869732E6931386E28227265636F7264696E6753746F707065644D617853697A6522292C2277';
wwv_flow_imp.g_varchar2_table(3896) := '61726E696E67222C346533292C746869732E73746F705265636F7264696E672829297D7D292C746869732E7265636F726465722E737461727428353030292C746869732E6F7074732E73686F775265636F7264696E674C656E677468262628746869732E';
wwv_flow_imp.g_varchar2_table(3897) := '7265636F7264696E674C656E67746854696D65723D736574496E74657276616C2828293D3E7B6C657420743D746869732E676574506C7567696E537461746528292E7265636F7264696E674C656E6774685365636F6E64733B746869732E736574506C75';
wwv_flow_imp.g_varchar2_table(3898) := '67696E5374617465287B7265636F7264696E674C656E6774685365636F6E64733A742B317D297D2C31653329292C746869732E736574506C7567696E5374617465287B69735265636F7264696E673A21307D297D73746F705265636F7264696E6728297B';
wwv_flow_imp.g_varchar2_table(3899) := '72657475726E206E65772050726F6D69736528743D3E7B746869732E7265636F726465722E6164644576656E744C697374656E6572282273746F70222C28293D3E7B7428297D292C746869732E7265636F726465722E73746F7028292C746869732E6F70';
wwv_flow_imp.g_varchar2_table(3900) := '74732E73686F775265636F7264696E674C656E677468262628636C656172496E74657276616C28746869732E7265636F7264696E674C656E67746854696D6572292C746869732E736574506C7567696E5374617465287B7265636F7264696E674C656E67';
wwv_flow_imp.g_varchar2_table(3901) := '74685365636F6E64733A307D29297D292E7468656E2828293D3E28746869732E736574506C7567696E5374617465287B69735265636F7264696E673A21317D292C746869732E676574566964656F282929292E7468656E28743D3E7B7472797B74686973';
wwv_flow_imp.g_varchar2_table(3902) := '2E63617074757265644D6564696146696C653D742C746869732E736574506C7567696E5374617465287B7265636F72646564566964656F3A55524C2E6372656174654F626A65637455524C28742E64617461297D292C506128746869732C4169295B4169';
wwv_flow_imp.g_varchar2_table(3903) := '5D3D21317D63617463682872297B722E69735265737472696374696F6E7C7C746869732E757070792E6C6F672872297D7D292E7468656E2828293D3E7B746869732E7265636F7264696E674368756E6B733D6E756C6C2C746869732E7265636F72646572';
wwv_flow_imp.g_varchar2_table(3904) := '3D6E756C6C7D2C743D3E7B7468726F7720746869732E7265636F7264696E674368756E6B733D6E756C6C2C746869732E7265636F726465723D6E756C6C2C747D297D646973636172645265636F72646564566964656F28297B746869732E736574506C75';
wwv_flow_imp.g_varchar2_table(3905) := '67696E5374617465287B7265636F72646564566964656F3A6E756C6C7D292C746869732E6F7074732E6D6972726F72262628506128746869732C4169295B41695D3D2130292C746869732E63617074757265644D6564696146696C653D6E756C6C7D7375';
wwv_flow_imp.g_varchar2_table(3906) := '626D697428297B7472797B746869732E63617074757265644D6564696146696C652626746869732E757070792E61646446696C6528746869732E63617074757265644D6564696146696C65297D63617463682865297B652E69735265737472696374696F';
wwv_flow_imp.g_varchar2_table(3907) := '6E7C7C746869732E757070792E6C6F6728652C226572726F7222297D7D6173796E632073746F7028297B696628746869732E73747265616D297B6C657420653D746869732E73747265616D2E676574417564696F547261636B7328292C743D746869732E';
wwv_flow_imp.g_varchar2_table(3908) := '73747265616D2E676574566964656F547261636B7328293B652E636F6E6361742874292E666F724561636828723D3E722E73746F702829297D746869732E7265636F7264657226266177616974206E65772050726F6D69736528653D3E7B746869732E72';
wwv_flow_imp.g_varchar2_table(3909) := '65636F726465722E6164644576656E744C697374656E6572282273746F70222C652C7B6F6E63653A21307D292C746869732E7265636F726465722E73746F7028292C746869732E6F7074732E73686F775265636F7264696E674C656E6774682626636C65';
wwv_flow_imp.g_varchar2_table(3910) := '6172496E74657276616C28746869732E7265636F7264696E674C656E67746854696D6572297D292C746869732E7265636F7264696E674368756E6B733D6E756C6C2C746869732E7265636F726465723D6E756C6C2C746869732E77656263616D41637469';
wwv_flow_imp.g_varchar2_table(3911) := '76653D21312C746869732E73747265616D3D6E756C6C2C746869732E736574506C7567696E5374617465287B7265636F72646564566964656F3A6E756C6C2C69735265636F7264696E673A21312C7265636F7264696E674C656E6774685365636F6E6473';
wwv_flow_imp.g_varchar2_table(3912) := '3A307D297D676574566964656F456C656D656E7428297B72657475726E20746869732E656C2E717565727953656C6563746F7228222E757070792D57656263616D2D766964656F22297D6F6E6554776F5468726565536D696C6528297B72657475726E20';
wwv_flow_imp.g_varchar2_table(3913) := '6E65772050726F6D6973652828652C74293D3E7B6C657420723D746869732E6F7074732E636F756E74646F776E2C733D736574496E74657276616C2828293D3E7B69662821746869732E77656263616D4163746976652972657475726E20636C65617249';
wwv_flow_imp.g_varchar2_table(3914) := '6E74657276616C2873292C746869732E63617074757265496E50726F67726573733D21312C74286E6577204572726F72282257656263616D206973206E6F74206163746976652229293B723E303F28746869732E757070792E696E666F2860247B727D2E';
wwv_flow_imp.g_varchar2_table(3915) := '2E2E602C227761726E696E67222C383030292C722D2D293A28636C656172496E74657276616C2873292C746869732E757070792E696E666F28746869732E6931386E2822736D696C6522292C2273756363657373222C31353030292C73657454696D656F';
wwv_flow_imp.g_varchar2_table(3916) := '75742828293D3E6528292C3135303029297D2C316533297D297D74616B65536E617073686F7428297B746869732E63617074757265496E50726F67726573737C7C28746869732E63617074757265496E50726F67726573733D21302C746869732E6F7074';
wwv_flow_imp.g_varchar2_table(3917) := '732E6F6E4265666F7265536E617073686F7428292E636174636828653D3E7B6C657420743D747970656F6620653D3D226F626A656374223F652E6D6573736167653A653B72657475726E20746869732E757070792E696E666F28742C226572726F72222C';
wwv_flow_imp.g_varchar2_table(3918) := '356533292C50726F6D6973652E72656A656374286E6577204572726F7228606F6E4265666F7265536E617073686F743A20247B747D6029297D292E7468656E2828293D3E746869732E676574496D6167652829292E7468656E28653D3E7B746869732E63';
wwv_flow_imp.g_varchar2_table(3919) := '617074757265496E50726F67726573733D21313B7472797B746869732E757070792E61646446696C652865297D63617463682874297B742E69735265737472696374696F6E7C7C746869732E757070792E6C6F672874297D7D2C653D3E7B7468726F7720';
wwv_flow_imp.g_varchar2_table(3920) := '746869732E63617074757265496E50726F67726573733D21312C657D29297D676574496D61676528297B6C657420653D746869732E676574566964656F456C656D656E7428293B69662821652972657475726E2050726F6D6973652E72656A656374286E';
wwv_flow_imp.g_varchar2_table(3921) := '6577204572726F7228224E6F20766964656F20656C656D656E7420666F756E642C206C696B656C792064756520746F207468652057656263616D20746162206265696E6720636C6F7365642E2229293B6C657420743D652E766964656F57696474682C72';
wwv_flow_imp.g_varchar2_table(3922) := '3D652E766964656F4865696768742C733D646F63756D656E742E637265617465456C656D656E74282263616E76617322293B732E77696474683D742C732E6865696768743D722C732E676574436F6E746578742822326422292E64726177496D61676528';
wwv_flow_imp.g_varchar2_table(3923) := '652C302C30293B6C65747B7265737472696374696F6E733A617D3D746869732E757070792E6F7074732C6C3D5B5D3B746869732E6F7074732E707265666572726564496D6167654D696D65547970653F6C3D5B746869732E6F7074732E70726566657272';
wwv_flow_imp.g_varchar2_table(3924) := '6564496D6167654D696D65547970655D3A612E616C6C6F77656446696C6554797065732626286C3D612E616C6C6F77656446696C6554797065732E6D6170286D76292E66696C74657228555029293B6C657420683D6C5B305D7C7C22696D6167652F6A70';
wwv_flow_imp.g_varchar2_table(3925) := '6567222C633D4B692868297C7C226A7067222C643D6063616D2D247B446174652E6E6F7728297D2E247B637D603B72657475726E20666328732C68292E7468656E28663D3E287B736F757263653A746869732E69642C6E616D653A642C646174613A6E65';
wwv_flow_imp.g_varchar2_table(3926) := '7720426C6F62285B665D2C7B747970653A687D292C747970653A687D29297D676574566964656F28297B6C657420653D746869732E7265636F7264696E674368756E6B732E66696E6428613D3E7B766172206C3B72657475726E28286C3D612E74797065';
wwv_flow_imp.g_varchar2_table(3927) := '293D3D6E756C6C3F766F696420303A6C2E6C656E677468293E307D292E747970652C743D4B692865293B69662821742972657475726E2050726F6D6973652E72656A656374286E6577204572726F722860436F756C64206E6F7420726574726965766520';
wwv_flow_imp.g_varchar2_table(3928) := '7265636F7264696E673A20556E737570706F72746564206D6564696120747970652022247B657D226029293B6C657420723D6077656263616D2D247B446174652E6E6F7728297D2E247B747D602C733D6E657720426C6F6228746869732E7265636F7264';
wwv_flow_imp.g_varchar2_table(3929) := '696E674368756E6B732C7B747970653A657D292C6F3D7B736F757263653A746869732E69642C6E616D653A722C646174613A6E657720426C6F62285B735D2C7B747970653A657D292C747970653A657D3B72657475726E2050726F6D6973652E7265736F';
wwv_flow_imp.g_varchar2_table(3930) := '6C7665286F297D666F63757328297B746869732E6F7074732E636F756E74646F776E262673657454696D656F75742828293D3E7B746869732E757070792E696E666F28746869732E6931386E2822736D696C6522292C2273756363657373222C31353030';
wwv_flow_imp.g_varchar2_table(3931) := '297D2C316533297D6368616E6765566964656F536F757263652865297B746869732E73746F7028292C746869732E7374617274287B64657669636549643A657D297D757064617465566964656F536F757263657328297B746869732E6D65646961446576';
wwv_flow_imp.g_varchar2_table(3932) := '696365732E656E756D65726174654465766963657328292E7468656E28653D3E7B746869732E736574506C7567696E5374617465287B766964656F536F75726365733A652E66696C74657228743D3E742E6B696E643D3D3D22766964656F696E70757422';
wwv_flow_imp.g_varchar2_table(3933) := '297D297D297D72656E64657228297B746869732E77656263616D4163746976657C7C746869732E737461727428293B6C657420653D746869732E676574506C7567696E537461746528293B72657475726E21652E63616D65726152656164797C7C21652E';
wwv_flow_imp.g_varchar2_table(3934) := '68617343616D6572613F752870762C7B69636F6E3A6A752C6931386E3A746869732E6931386E2C68617343616D6572613A652E68617343616D6572617D293A752863762C5363287B7D2C652C7B6F6E4368616E6765566964656F536F757263653A746869';
wwv_flow_imp.g_varchar2_table(3935) := '732E6368616E6765566964656F536F757263652C6F6E536E617073686F743A746869732E74616B65536E617073686F742C6F6E53746172745265636F7264696E673A746869732E73746172745265636F7264696E672C6F6E53746F705265636F7264696E';
wwv_flow_imp.g_varchar2_table(3936) := '673A746869732E73746F705265636F7264696E672C6F6E446973636172645265636F72646564566964656F3A746869732E646973636172645265636F72646564566964656F2C6F6E5375626D69743A746869732E7375626D69742C6F6E466F6375733A74';
wwv_flow_imp.g_varchar2_table(3937) := '6869732E666F6375732C6F6E53746F703A746869732E73746F702C6931386E3A746869732E6931386E2C6D6F6465733A746869732E6F7074732E6D6F6465732C73686F775265636F7264696E674C656E6774683A746869732E6F7074732E73686F775265';
wwv_flow_imp.g_varchar2_table(3938) := '636F7264696E674C656E6774682C73686F77566964656F536F7572636544726F70646F776E3A746869732E6F7074732E73686F77566964656F536F7572636544726F70646F776E2C737570706F7274735265636F7264696E673A6D6328292C7265636F72';
wwv_flow_imp.g_varchar2_table(3939) := '64696E673A652E69735265636F7264696E672C6D6972726F723A506128746869732C4169295B41695D2C7372633A746869732E73747265616D7D29297D696E7374616C6C28297B6C65747B6D6F62696C654E617469766543616D6572613A652C6D6F6465';
wwv_flow_imp.g_varchar2_table(3940) := '733A742C666163696E674D6F64653A722C766964656F436F6E73747261696E74733A737D3D746869732E6F7074732C7B7461726765743A6F7D3D746869732E6F7074733B6966286526266F297B76617220613B28613D746869732E676574546172676574';
wwv_flow_imp.g_varchar2_table(3941) := '506C7567696E286F29293D3D6E756C6C7C7C612E7365744F7074696F6E73287B73686F774E6174697665566964656F43616D657261427574746F6E3A776328742C22766964656F2D6F6E6C7922297C7C776328742C22766964656F2D617564696F22292C';
wwv_flow_imp.g_varchar2_table(3942) := '73686F774E617469766550686F746F43616D657261427574746F6E3A776328742C227069637475726522292C6E617469766543616D657261466163696E674D6F64653A733F2E666163696E674D6F64657C7C727D293B72657475726E7D746869732E7365';
wwv_flow_imp.g_varchar2_table(3943) := '74506C7567696E5374617465287B63616D65726152656164793A21312C7265636F7264696E674C656E6774685365636F6E64733A307D292C6F2626746869732E6D6F756E74286F2C74686973292C746869732E6D65646961446576696365732626287468';
wwv_flow_imp.g_varchar2_table(3944) := '69732E757064617465566964656F536F757263657328292C746869732E6D65646961446576696365732E6F6E6465766963656368616E67653D28293D3E7B696628746869732E757064617465566964656F536F757263657328292C746869732E73747265';
wwv_flow_imp.g_varchar2_table(3945) := '616D297B6C6574206C3D21302C7B766964656F536F75726365733A682C63757272656E7444657669636549643A637D3D746869732E676574506C7567696E537461746528293B682E666F724561636828643D3E7B633D3D3D642E64657669636549642626';
wwv_flow_imp.g_varchar2_table(3946) := '286C3D2131297D292C6C262628746869732E73746F7028292C746869732E73746172742829297D7D297D756E696E7374616C6C28297B746869732E73746F7028292C746869732E756E6D6F756E7428297D6F6E556E6D6F756E7428297B746869732E7374';
wwv_flow_imp.g_varchar2_table(3947) := '6F7028297D7D3B6E2861732C2257656263616D22293B61732E56455253494F4E3D41502E76657273696F6E3B66756E6374696F6E206B7228692C65297B696628214F626A6563742E70726F746F747970652E6861734F776E50726F70657274792E63616C';
wwv_flow_imp.g_varchar2_table(3948) := '6C28692C6529297468726F77206E657720547970654572726F722822617474656D7074656420746F207573652070726976617465206669656C64206F6E206E6F6E2D696E7374616E636522293B72657475726E20697D6E286B722C225F636C6173735072';
wwv_flow_imp.g_varchar2_table(3949) := '69766174654669656C644C6F6F73654261736522293B7661722044503D303B66756E6374696F6E2079762869297B72657475726E225F5F707269766174655F222B44502B2B2B225F222B697D6E2879762C225F636C617373507269766174654669656C64';
wwv_flow_imp.g_varchar2_table(3950) := '4C6F6F73654B657922293B7661722044743D797628227570707922292C5F613D797628226576656E747322292C67693D636C6173737B636F6E7374727563746F722865297B4F626A6563742E646566696E6550726F706572747928746869732C44742C7B';
wwv_flow_imp.g_varchar2_table(3951) := '7772697461626C653A21302C76616C75653A766F696420307D292C4F626A6563742E646566696E6550726F706572747928746869732C5F612C7B7772697461626C653A21302C76616C75653A5B5D7D292C6B7228746869732C4474295B44745D3D657D6F';
wwv_flow_imp.g_varchar2_table(3952) := '6E28652C74297B72657475726E206B7228746869732C5F61295B5F615D2E70757368285B652C745D292C6B7228746869732C4474295B44745D2E6F6E28652C74297D72656D6F766528297B666F72286C65745B652C745D6F66206B7228746869732C5F61';
wwv_flow_imp.g_varchar2_table(3953) := '295B5F615D2E73706C696365283029296B7228746869732C4474295B44745D2E6F666628652C74297D6F6E46696C65506175736528652C74297B746869732E6F6E282275706C6F61642D7061757365222C28722C73293D3E7B653D3D3D72262674287329';
wwv_flow_imp.g_varchar2_table(3954) := '7D297D6F6E46696C6552656D6F766528652C74297B746869732E6F6E282266696C652D72656D6F766564222C723D3E7B653D3D3D722E696426267428722E6964297D297D6F6E506175736528652C74297B746869732E6F6E282275706C6F61642D706175';
wwv_flow_imp.g_varchar2_table(3955) := '7365222C28722C73293D3E7B653D3D3D722626742873297D297D6F6E526574727928652C74297B746869732E6F6E282275706C6F61642D7265747279222C723D3E7B653D3D3D7226267428297D297D6F6E5265747279416C6C28652C74297B746869732E';
wwv_flow_imp.g_varchar2_table(3956) := '6F6E282272657472792D616C6C222C28293D3E7B6B7228746869732C4474295B44745D2E67657446696C6528652926267428297D297D6F6E5061757365416C6C28652C74297B746869732E6F6E282270617573652D616C6C222C28293D3E7B6B72287468';
wwv_flow_imp.g_varchar2_table(3957) := '69732C4474295B44745D2E67657446696C6528652926267428297D297D6F6E43616E63656C416C6C28652C74297B76617220723D746869733B746869732E6F6E282263616E63656C2D616C6C222C66756E6374696F6E28297B6B7228722C4474295B4474';
wwv_flow_imp.g_varchar2_table(3958) := '5D2E67657446696C65286529262674282E2E2E617267756D656E7473297D297D6F6E526573756D65416C6C28652C74297B746869732E6F6E2822726573756D652D616C6C222C28293D3E7B6B7228746869732C4474295B44745D2E67657446696C652865';
wwv_flow_imp.g_varchar2_table(3959) := '2926267428297D297D7D3B6E2867692C224576656E744D616E6167657222293B66756E6374696F6E205928692C65297B696628214F626A6563742E70726F746F747970652E6861734F776E50726F70657274792E63616C6C28692C6529297468726F7720';
wwv_flow_imp.g_varchar2_table(3960) := '6E657720547970654572726F722822617474656D7074656420746F207573652070726976617465206669656C64206F6E206E6F6E2D696E7374616E636522293B72657475726E20697D6E28592C225F636C617373507269766174654669656C644C6F6F73';
wwv_flow_imp.g_varchar2_table(3961) := '654261736522293B7661722049503D303B66756E6374696F6E2056742869297B72657475726E225F5F707269766174655F222B49502B2B2B225F222B697D6E2856742C225F636C617373507269766174654669656C644C6F6F73654B657922293B66756E';
wwv_flow_imp.g_varchar2_table(3962) := '6374696F6E204D502869297B72657475726E206E6577204572726F72282243616E63656C6C6564222C7B63617573653A697D297D6E284D502C2263726561746543616E63656C4572726F7222293B66756E6374696F6E2076762869297B69662869213D6E';
wwv_flow_imp.g_varchar2_table(3963) := '756C6C297B76617220653B6C657420743D6E2828293D3E746869732E61626F727428692E726561736F6E292C2261626F727450726F6D69736522293B692E6164644576656E744C697374656E6572282261626F7274222C742C7B6F6E63653A21307D293B';
wwv_flow_imp.g_varchar2_table(3964) := '6C657420723D6E2828293D3E7B692E72656D6F76654576656E744C697374656E6572282261626F7274222C74297D2C2272656D6F766541626F72744C697374656E657222293B28653D746869732E7468656E293D3D6E756C6C7C7C652E63616C6C287468';
wwv_flow_imp.g_varchar2_table(3965) := '69732C722C72297D72657475726E20746869737D6E2876762C2261626F72744F6E22293B7661722072693D56742822616374697665526571756573747322292C4D743D5674282271756575656448616E646C65727322292C69693D567428227061757365';
wwv_flow_imp.g_varchar2_table(3966) := '6422292C6A733D56742822706175736554696D657222292C49743D56742822646F776E4C696D697422292C48733D5674282275707065724C696D697422292C44723D56742822726174654C696D6974696E6754696D657222292C46613D5674282263616C';
wwv_flow_imp.g_varchar2_table(3967) := '6C22292C49723D5674282271756575654E65787422292C46633D567428226E65787422292C50633D56742822717565756522292C78633D567428226465717565756522292C5F633D56742822726573756D6522292C24733D56742822696E637265617365';
wwv_flow_imp.g_varchar2_table(3968) := '4C696D697422292C4E743D636C6173737B636F6E7374727563746F722865297B4F626A6563742E646566696E6550726F706572747928746869732C78632C7B76616C75653A6A507D292C4F626A6563742E646566696E6550726F70657274792874686973';
wwv_flow_imp.g_varchar2_table(3969) := '2C50632C7B76616C75653A7A507D292C4F626A6563742E646566696E6550726F706572747928746869732C46632C7B76616C75653A42507D292C4F626A6563742E646566696E6550726F706572747928746869732C49722C7B76616C75653A4C507D292C';
wwv_flow_imp.g_varchar2_table(3970) := '4F626A6563742E646566696E6550726F706572747928746869732C46612C7B76616C75653A4E507D292C4F626A6563742E646566696E6550726F706572747928746869732C72692C7B7772697461626C653A21302C76616C75653A307D292C4F626A6563';
wwv_flow_imp.g_varchar2_table(3971) := '742E646566696E6550726F706572747928746869732C4D742C7B7772697461626C653A21302C76616C75653A5B5D7D292C4F626A6563742E646566696E6550726F706572747928746869732C69692C7B7772697461626C653A21302C76616C75653A2131';
wwv_flow_imp.g_varchar2_table(3972) := '7D292C4F626A6563742E646566696E6550726F706572747928746869732C6A732C7B7772697461626C653A21302C76616C75653A766F696420307D292C4F626A6563742E646566696E6550726F706572747928746869732C49742C7B7772697461626C65';
wwv_flow_imp.g_varchar2_table(3973) := '3A21302C76616C75653A317D292C4F626A6563742E646566696E6550726F706572747928746869732C48732C7B7772697461626C653A21302C76616C75653A766F696420307D292C4F626A6563742E646566696E6550726F706572747928746869732C44';
wwv_flow_imp.g_varchar2_table(3974) := '722C7B7772697461626C653A21302C76616C75653A766F696420307D292C4F626A6563742E646566696E6550726F706572747928746869732C5F632C7B7772697461626C653A21302C76616C75653A28293D3E746869732E726573756D6528297D292C4F';
wwv_flow_imp.g_varchar2_table(3975) := '626A6563742E646566696E6550726F706572747928746869732C24732C7B7772697461626C653A21302C76616C75653A28293D3E7B6966285928746869732C6969295B69695D297B5928746869732C4472295B44725D3D73657454696D656F7574285928';
wwv_flow_imp.g_varchar2_table(3976) := '746869732C2473295B24735D2C30293B72657475726E7D5928746869732C4974295B49745D3D746869732E6C696D69742C746869732E6C696D69743D4D6174682E6365696C28285928746869732C4873295B48735D2B5928746869732C4974295B49745D';
wwv_flow_imp.g_varchar2_table(3977) := '292F32293B666F72286C657420743D5928746869732C4974295B49745D3B743C3D746869732E6C696D69743B742B2B295928746869732C4972295B49725D28293B5928746869732C4873295B48735D2D5928746869732C4974295B49745D3E333F592874';
wwv_flow_imp.g_varchar2_table(3978) := '6869732C4472295B44725D3D73657454696D656F7574285928746869732C2473295B24735D2C326533293A5928746869732C4974295B49745D3D4D6174682E666C6F6F72285928746869732C4974295B49745D2F32297D7D292C747970656F662065213D';
wwv_flow_imp.g_varchar2_table(3979) := '226E756D626572227C7C653D3D3D303F746869732E6C696D69743D312F303A746869732E6C696D69743D657D72756E28652C74297B72657475726E215928746869732C6969295B69695D26265928746869732C7269295B72695D3C746869732E6C696D69';
wwv_flow_imp.g_varchar2_table(3980) := '743F5928746869732C4661295B46615D2865293A5928746869732C5063295B50635D28652C74297D7772617053796E6346756E6374696F6E28652C74297B76617220723D746869733B72657475726E2066756E6374696F6E28297B666F72287661722073';
wwv_flow_imp.g_varchar2_table(3981) := '3D617267756D656E74732E6C656E6774682C6F3D6E65772041727261792873292C613D303B613C733B612B2B296F5B615D3D617267756D656E74735B615D3B6C6574206C3D722E72756E2828293D3E2865282E2E2E6F292C71756575654D6963726F7461';
wwv_flow_imp.g_varchar2_table(3982) := '736B2828293D3E6C2E646F6E652829292C28293D3E7B7D292C74293B72657475726E7B61626F72744F6E3A76762C61626F727428297B6C2E61626F727428297D7D7D7D7772617050726F6D69736546756E6374696F6E28652C74297B76617220723D7468';
wwv_flow_imp.g_varchar2_table(3983) := '69733B72657475726E2066756E6374696F6E28297B666F722876617220733D617267756D656E74732E6C656E6774682C6F3D6E65772041727261792873292C613D303B613C733B612B2B296F5B615D3D617267756D656E74735B615D3B6C6574206C2C68';
wwv_flow_imp.g_varchar2_table(3984) := '3D6E65772050726F6D6973652828632C64293D3E7B6C3D722E72756E2828293D3E7B6C657420662C793B7472797B793D50726F6D6973652E7265736F6C76652865282E2E2E6F29297D63617463682862297B793D50726F6D6973652E72656A6563742862';
wwv_flow_imp.g_varchar2_table(3985) := '297D72657475726E20792E7468656E28623D3E7B663F642866293A286C2E646F6E6528292C63286229297D2C623D3E7B663F642866293A286C2E646F6E6528292C64286229297D292C623D3E7B663D4D502862297D7D2C74297D293B72657475726E2068';
wwv_flow_imp.g_varchar2_table(3986) := '2E61626F72743D633D3E7B6C2E61626F72742863297D2C682E61626F72744F6E3D76762C687D7D726573756D6528297B5928746869732C6969295B69695D3D21312C636C65617254696D656F7574285928746869732C6A73295B6A735D293B666F72286C';
wwv_flow_imp.g_varchar2_table(3987) := '657420653D303B653C746869732E6C696D69743B652B2B295928746869732C4972295B49725D28297D70617573652865297B653D3D3D766F69642030262628653D6E756C6C292C5928746869732C6969295B69695D3D21302C636C65617254696D656F75';
wwv_flow_imp.g_varchar2_table(3988) := '74285928746869732C6A73295B6A735D292C65213D6E756C6C2626285928746869732C6A73295B6A735D3D73657454696D656F7574285928746869732C5F63295B5F635D2C6529297D726174654C696D69742865297B636C65617254696D656F75742859';
wwv_flow_imp.g_varchar2_table(3989) := '28746869732C4472295B44725D292C746869732E70617573652865292C746869732E6C696D69743E3126264E756D6265722E697346696E69746528746869732E6C696D6974292626285928746869732C4873295B48735D3D746869732E6C696D69742D31';
wwv_flow_imp.g_varchar2_table(3990) := '2C746869732E6C696D69743D5928746869732C4974295B49745D2C5928746869732C4472295B44725D3D73657454696D656F7574285928746869732C2473295B24735D2C6529297D67657420697350617573656428297B72657475726E20592874686973';
wwv_flow_imp.g_varchar2_table(3991) := '2C6969295B69695D7D7D3B6E284E742C22526174654C696D69746564517565756522293B66756E6374696F6E204E502869297B5928746869732C7269295B72695D2B3D313B6C657420653D21312C743B7472797B743D6928297D63617463682872297B74';
wwv_flow_imp.g_varchar2_table(3992) := '68726F77205928746869732C7269295B72695D2D3D312C727D72657475726E7B61626F72743A723D3E7B657C7C28653D21302C5928746869732C7269295B72695D2D3D312C743F2E2872292C5928746869732C4972295B49725D2829297D2C646F6E653A';
wwv_flow_imp.g_varchar2_table(3993) := '28293D3E7B657C7C28653D21302C5928746869732C7269295B72695D2D3D312C5928746869732C4972295B49725D2829297D7D7D6E284E502C225F63616C6C3222293B66756E6374696F6E204C5028297B71756575654D6963726F7461736B2828293D3E';
wwv_flow_imp.g_varchar2_table(3994) := '5928746869732C4663295B46635D2829297D6E284C502C225F71756575654E6578743222293B66756E6374696F6E20425028297B6966285928746869732C6969295B69695D7C7C5928746869732C7269295B72695D3E3D746869732E6C696D69747C7C59';
wwv_flow_imp.g_varchar2_table(3995) := '28746869732C4D74295B4D745D2E6C656E6774683D3D3D302972657475726E3B6C657420693D5928746869732C4D74295B4D745D2E736869667428292C653D5928746869732C4661295B46615D28692E666E293B692E61626F72743D652E61626F72742C';
wwv_flow_imp.g_varchar2_table(3996) := '692E646F6E653D652E646F6E657D6E2842502C225F6E6578743222293B66756E6374696F6E207A5028692C65297B653D3D3D766F69642030262628653D7B7D293B6C657420743D7B666E3A692C7072696F726974793A652E7072696F726974797C7C302C';
wwv_flow_imp.g_varchar2_table(3997) := '61626F72743A28293D3E7B5928746869732C7863295B78635D2874297D2C646F6E653A28293D3E7B7468726F77206E6577204572726F72282243616E6E6F74206D61726B206120717565756564207265717565737420617320646F6E653A207468697320';
wwv_flow_imp.g_varchar2_table(3998) := '696E6469636174657320612062756722297D7D2C723D5928746869732C4D74295B4D745D2E66696E64496E64657828733D3E742E7072696F726974793E732E7072696F72697479293B72657475726E20723D3D3D2D313F5928746869732C4D74295B4D74';
wwv_flow_imp.g_varchar2_table(3999) := '5D2E707573682874293A5928746869732C4D74295B4D745D2E73706C69636528722C302C74292C747D6E287A502C225F71756575653222293B66756E6374696F6E206A502869297B6C657420653D5928746869732C4D74295B4D745D2E696E6465784F66';
wwv_flow_imp.g_varchar2_table(4000) := '2869293B65213D3D2D3126265928746869732C4D74295B4D745D2E73706C69636528652C31297D6E286A502C225F646571756575653222293B766172206C733D53796D626F6C28225F5F717565756522293B66756E6374696F6E2075732869297B6C6574';
wwv_flow_imp.g_varchar2_table(4001) := '20653D6E28743D3E226572726F7222696E207426262121742E6572726F722C226861734572726F7222293B72657475726E20692E66696C74657228743D3E2165287429297D6E2875732C2266696C7465724E6F6E4661696C656446696C657322293B6675';
wwv_flow_imp.g_varchar2_table(4002) := '6E6374696F6E2068732869297B72657475726E20692E66696C74657228653D3E7B76617220743B72657475726E212828743D652E70726F677265737329213D6E756C6C2626742E75706C6F616453746172746564297C7C21652E6973526573746F726564';
wwv_flow_imp.g_varchar2_table(4003) := '7D297D6E2868732C2266696C74657246696C6573546F456D697455706C6F61645374617274656422293B7661727B41626F7274436F6E74726F6C6C65723A71757D3D676C6F62616C546869732C7B41626F72745369676E616C3A50377D3D676C6F62616C';
wwv_flow_imp.g_varchar2_table(4004) := '546869732C45633D6E2866756E6374696F6E28692C65297B693D3D3D766F69642030262628693D2241626F7274656422293B6C657420743D6E657720444F4D457863657074696F6E28692C2241626F72744572726F7222293B72657475726E2065213D6E';
wwv_flow_imp.g_varchar2_table(4005) := '756C6C2626597428652C226361757365222926264F626A6563742E646566696E6550726F706572747928742C226361757365222C7B5F5F70726F746F5F5F3A6E756C6C2C636F6E666967757261626C653A21302C7772697461626C653A21302C76616C75';
wwv_flow_imp.g_varchar2_table(4006) := '653A652E63617573657D292C747D2C2263726561746541626F72744572726F7222293B66756E6374696F6E207128692C65297B696628214F626A6563742E70726F746F747970652E6861734F776E50726F70657274792E63616C6C28692C652929746872';
wwv_flow_imp.g_varchar2_table(4007) := '6F77206E657720547970654572726F722822617474656D7074656420746F207573652070726976617465206669656C64206F6E206E6F6E2D696E7374616E636522293B72657475726E20697D6E28712C225F636C617373507269766174654669656C644C';
wwv_flow_imp.g_varchar2_table(4008) := '6F6F73654261736522293B7661722048503D303B66756E6374696F6E2072742869297B72657475726E225F5F707269766174655F222B48502B2B2B225F222B697D6E2872742C225F636C617373507269766174654669656C644C6F6F73654B657922293B';
wwv_flow_imp.g_varchar2_table(4009) := '7661722024503D313032342A313032342C62763D7B6765744368756E6B53697A652869297B72657475726E204D6174682E6365696C28692E73697A652F316534297D2C6F6E50726F677265737328297B7D2C6F6E50617274436F6D706C65746528297B7D';
wwv_flow_imp.g_varchar2_table(4010) := '2C6F6E5375636365737328297B7D2C6F6E4572726F722869297B7468726F7720697D7D3B66756E6374696F6E2071502869297B696628747970656F6620693D3D22737472696E67222972657475726E207061727365496E7428692C3130293B6966287479';
wwv_flow_imp.g_varchar2_table(4011) := '70656F6620693D3D226E756D626572222972657475726E20693B7468726F77206E657720547970654572726F72282245787065637465642061206E756D62657222297D6E2871502C22656E73757265496E7422293B7661722041613D53796D626F6C2822';
wwv_flow_imp.g_varchar2_table(4012) := '70617573696E672075706C6F61642C206E6F7420616E2061637475616C206572726F7222292C66743D7274282261626F7274436F6E74726F6C6C657222292C69743D727428226368756E6B7322292C4C743D727428226368756E6B537461746522292C73';
wwv_flow_imp.g_varchar2_table(4013) := '693D727428226461746122292C6F693D7274282266696C6522292C52613D7274282275706C6F61644861735374617274656422292C78613D727428226F6E4572726F7222292C57733D727428226F6E5375636365737322292C4D723D7274282273686F75';
wwv_flow_imp.g_varchar2_table(4014) := '6C645573654D756C74697061727422292C56733D727428226973526573746F72696E6722292C55613D727428226F6E52656A65637422292C71733D727428226D61784D756C746970617274506172747322292C43613D727428226D696E5061727453697A';
wwv_flow_imp.g_varchar2_table(4015) := '6522292C43633D72742822696E69744368756E6B7322292C4F633D7274282263726561746555706C6F616422292C45613D72742822726573756D6555706C6F616422292C4F613D727428226F6E5061727450726F677265737322292C54613D727428226F';
wwv_flow_imp.g_varchar2_table(4016) := '6E50617274436F6D706C65746522292C54633D7274282261626F727455706C6F616422292C56753D636C6173737B636F6E7374727563746F7228652C74297B76617220722C733B4F626A6563742E646566696E6550726F706572747928746869732C5463';
wwv_flow_imp.g_varchar2_table(4017) := '2C7B76616C75653A4B507D292C4F626A6563742E646566696E6550726F706572747928746869732C45612C7B76616C75653A47507D292C4F626A6563742E646566696E6550726F706572747928746869732C4F632C7B76616C75653A57507D292C4F626A';
wwv_flow_imp.g_varchar2_table(4018) := '6563742E646566696E6550726F706572747928746869732C43632C7B76616C75653A56507D292C4F626A6563742E646566696E6550726F706572747928746869732C66742C7B7772697461626C653A21302C76616C75653A6E65772071757D292C4F626A';
wwv_flow_imp.g_varchar2_table(4019) := '6563742E646566696E6550726F706572747928746869732C69742C7B7772697461626C653A21302C76616C75653A766F696420307D292C4F626A6563742E646566696E6550726F706572747928746869732C4C742C7B7772697461626C653A21302C7661';
wwv_flow_imp.g_varchar2_table(4020) := '6C75653A766F696420307D292C4F626A6563742E646566696E6550726F706572747928746869732C73692C7B7772697461626C653A21302C76616C75653A766F696420307D292C4F626A6563742E646566696E6550726F706572747928746869732C6F69';
wwv_flow_imp.g_varchar2_table(4021) := '2C7B7772697461626C653A21302C76616C75653A766F696420307D292C4F626A6563742E646566696E6550726F706572747928746869732C52612C7B7772697461626C653A21302C76616C75653A21317D292C4F626A6563742E646566696E6550726F70';
wwv_flow_imp.g_varchar2_table(4022) := '6572747928746869732C78612C7B7772697461626C653A21302C76616C75653A766F696420307D292C4F626A6563742E646566696E6550726F706572747928746869732C57732C7B7772697461626C653A21302C76616C75653A766F696420307D292C4F';
wwv_flow_imp.g_varchar2_table(4023) := '626A6563742E646566696E6550726F706572747928746869732C4D722C7B7772697461626C653A21302C76616C75653A766F696420307D292C4F626A6563742E646566696E6550726F706572747928746869732C56732C7B7772697461626C653A21302C';
wwv_flow_imp.g_varchar2_table(4024) := '76616C75653A766F696420307D292C4F626A6563742E646566696E6550726F706572747928746869732C55612C7B7772697461626C653A21302C76616C75653A6F3D3E6F3F2E63617573653D3D3D41613F6E756C6C3A7128746869732C7861295B78615D';
wwv_flow_imp.g_varchar2_table(4025) := '286F297D292C4F626A6563742E646566696E6550726F706572747928746869732C71732C7B7772697461626C653A21302C76616C75653A3165347D292C4F626A6563742E646566696E6550726F706572747928746869732C43612C7B7772697461626C65';
wwv_flow_imp.g_varchar2_table(4026) := '3A21302C76616C75653A352A24507D292C4F626A6563742E646566696E6550726F706572747928746869732C4F612C7B7772697461626C653A21302C76616C75653A6F3D3E613D3E7B69662821612E6C656E677468436F6D70757461626C652972657475';
wwv_flow_imp.g_varchar2_table(4027) := '726E3B7128746869732C4C74295B4C745D5B6F5D2E75706C6F616465643D715028612E6C6F61646564293B6C6574206C3D7128746869732C4C74295B4C745D2E7265647563652828682C63293D3E682B632E75706C6F616465642C30293B746869732E6F';
wwv_flow_imp.g_varchar2_table(4028) := '7074696F6E732E6F6E50726F6772657373286C2C7128746869732C7369295B73695D2E73697A65297D7D292C4F626A6563742E646566696E6550726F706572747928746869732C54612C7B7772697461626C653A21302C76616C75653A6F3D3E613D3E7B';
wwv_flow_imp.g_varchar2_table(4029) := '7128746869732C6974295B69745D5B6F5D3D6E756C6C2C7128746869732C4C74295B4C745D5B6F5D2E657461673D612C7128746869732C4C74295B4C745D5B6F5D2E646F6E653D21303B6C6574206C3D7B506172744E756D6265723A6F2B312C45546167';
wwv_flow_imp.g_varchar2_table(4030) := '3A617D3B746869732E6F7074696F6E732E6F6E50617274436F6D706C657465286C297D7D292C746869732E6F7074696F6E733D7B2E2E2E62762C2E2E2E747D2C28733D28723D746869732E6F7074696F6E73292E6765744368756E6B53697A6529213D6E';
wwv_flow_imp.g_varchar2_table(4031) := '756C6C7C7C28722E6765744368756E6B53697A653D62762E6765744368756E6B53697A65292C7128746869732C7369295B73695D3D652C7128746869732C6F69295B6F695D3D742E66696C652C7128746869732C5773295B57735D3D746869732E6F7074';
wwv_flow_imp.g_varchar2_table(4032) := '696F6E732E6F6E537563636573732C7128746869732C7861295B78615D3D746869732E6F7074696F6E732E6F6E4572726F722C7128746869732C4D72295B4D725D3D746869732E6F7074696F6E732E73686F756C645573654D756C7469706172742C7128';
wwv_flow_imp.g_varchar2_table(4033) := '746869732C5673295B56735D3D742E75706C6F616449642626742E6B65792C7128746869732C4363295B43635D28297D737461727428297B7128746869732C5261295B52615D3F287128746869732C6674295B66745D2E7369676E616C2E61626F727465';
wwv_flow_imp.g_varchar2_table(4034) := '647C7C7128746869732C6674295B66745D2E61626F7274284161292C7128746869732C6674295B66745D3D6E65772071752C7128746869732C4561295B45615D2829293A7128746869732C5673295B56735D3F28746869732E6F7074696F6E732E636F6D';
wwv_flow_imp.g_varchar2_table(4035) := '70616E696F6E436F6D6D2E726573746F726555706C6F616446696C65287128746869732C6F69295B6F695D2C7B75706C6F616449643A746869732E6F7074696F6E732E75706C6F616449642C6B65793A746869732E6F7074696F6E732E6B65797D292C71';
wwv_flow_imp.g_varchar2_table(4036) := '28746869732C4561295B45615D2829293A7128746869732C4F63295B4F635D28297D706175736528297B7128746869732C6674295B66745D2E61626F7274284161292C7128746869732C6674295B66745D3D6E65772071757D61626F72742865297B7661';
wwv_flow_imp.g_varchar2_table(4037) := '7220743B653D3D3D766F69642030262628653D766F69642030292C28743D6529213D6E756C6C2626742E7265616C6C793F7128746869732C5463295B54635D28293A746869732E706175736528297D676574206368756E6B537461746528297B72657475';
wwv_flow_imp.g_varchar2_table(4038) := '726E207128746869732C4C74295B4C745D7D7D3B6E2856752C224D756C74697061727455706C6F6164657222293B66756E6374696F6E20565028297B6C657420693D7128746869732C7369295B73695D2E73697A652C653D747970656F66207128746869';
wwv_flow_imp.g_varchar2_table(4039) := '732C4D72295B4D725D3D3D2266756E6374696F6E223F7128746869732C4D72295B4D725D287128746869732C6F69295B6F695D293A21217128746869732C4D72295B4D725D3B696628652626693E7128746869732C4361295B43615D297B6C657420743D';
wwv_flow_imp.g_varchar2_table(4040) := '4D6174682E6D617828746869732E6F7074696F6E732E6765744368756E6B53697A65287128746869732C7369295B73695D292C7128746869732C4361295B43615D292C723D4D6174682E666C6F6F7228692F74293B723E7128746869732C7173295B7173';
wwv_flow_imp.g_varchar2_table(4041) := '5D262628723D7128746869732C7173295B71735D2C743D692F7128746869732C7173295B71735D292C7128746869732C6974295B69745D3D41727261792872293B666F72286C657420733D302C6F3D303B733C693B732B3D742C6F2B2B297B6C65742061';
wwv_flow_imp.g_varchar2_table(4042) := '3D4D6174682E6D696E28692C732B74292C6C3D6E2828293D3E7B6C657420683D733B72657475726E207128746869732C7369295B73695D2E736C69636528682C61297D2C226765744461746122293B6966287128746869732C6974295B69745D5B6F5D3D';
wwv_flow_imp.g_varchar2_table(4043) := '7B676574446174613A6C2C6F6E50726F67726573733A7128746869732C4F61295B4F615D286F292C6F6E436F6D706C6574653A7128746869732C5461295B54615D286F292C73686F756C645573654D756C7469706172743A657D2C7128746869732C5673';
wwv_flow_imp.g_varchar2_table(4044) := '295B56735D297B6C657420683D732B743E693F692D733A743B7128746869732C6974295B69745D5B6F5D2E736574417355706C6F616465643D28293D3E7B7128746869732C6974295B69745D5B6F5D3D6E756C6C2C7128746869732C4C74295B4C745D5B';
wwv_flow_imp.g_varchar2_table(4045) := '6F5D2E75706C6F616465643D687D7D7D7D656C7365207128746869732C6974295B69745D3D5B7B676574446174613A28293D3E7128746869732C7369295B73695D2C6F6E50726F67726573733A7128746869732C4F61295B4F615D2830292C6F6E436F6D';
wwv_flow_imp.g_varchar2_table(4046) := '706C6574653A7128746869732C5461295B54615D2830292C73686F756C645573654D756C7469706172743A657D5D3B7128746869732C4C74295B4C745D3D7128746869732C6974295B69745D2E6D61702828293D3E287B75706C6F616465643A307D2929';
wwv_flow_imp.g_varchar2_table(4047) := '7D6E2856502C225F696E69744368756E6B733222293B66756E6374696F6E20575028297B746869732E6F7074696F6E732E636F6D70616E696F6E436F6D6D2E75706C6F616446696C65287128746869732C6F69295B6F695D2C7128746869732C6974295B';
wwv_flow_imp.g_varchar2_table(4048) := '69745D2C7128746869732C6674295B66745D2E7369676E616C292E7468656E287128746869732C5773295B57735D2C7128746869732C5561295B55615D292C7128746869732C5261295B52615D3D21307D6E2857502C225F63726561746555706C6F6164';
wwv_flow_imp.g_varchar2_table(4049) := '3222293B66756E6374696F6E20475028297B746869732E6F7074696F6E732E636F6D70616E696F6E436F6D6D2E726573756D6555706C6F616446696C65287128746869732C6F69295B6F695D2C7128746869732C6974295B69745D2C7128746869732C66';
wwv_flow_imp.g_varchar2_table(4050) := '74295B66745D2E7369676E616C292E7468656E287128746869732C5773295B57735D2C7128746869732C5561295B55615D297D6E2847502C225F726573756D6555706C6F61643222293B66756E6374696F6E204B5028297B7128746869732C6674295B66';
wwv_flow_imp.g_varchar2_table(4051) := '745D2E61626F727428292C746869732E6F7074696F6E732E636F6D70616E696F6E436F6D6D2E61626F727446696C6555706C6F6164287128746869732C6F69295B6F695D292E636174636828693D3E746869732E6F7074696F6E732E6C6F67286929297D';
wwv_flow_imp.g_varchar2_table(4052) := '6E284B502C225F61626F727455706C6F61643222293B7661722077763D56753B66756E6374696F6E2058502869297B6C65747B6D6574686F643A653D22505554222C43616E6F6E6963616C5572693A743D222F222C43616E6F6E6963616C517565727953';
wwv_flow_imp.g_varchar2_table(4053) := '7472696E673A723D22222C5369676E6564486561646572733A732C4861736865645061796C6F61643A6F7D3D692C613D4F626A6563742E6B6579732873292E6D6170286C3D3E6C2E746F4C6F776572436173652829292E736F727428293B72657475726E';
wwv_flow_imp.g_varchar2_table(4054) := '5B652C742C722C2E2E2E612E6D6170286C3D3E60247B6C7D3A247B735B6C5D7D60292C22222C612E6A6F696E28223B22292C6F5D2E6A6F696E28600A60297D6E2858502C2263726561746543616E6F6E6963616C5265717565737422293B766172204163';
wwv_flow_imp.g_varchar2_table(4055) := '3D6E65772054657874456E636F6465722C52633D7B6E616D653A22484D4143222C686173683A225348412D323536227D3B6173796E632066756E6374696F6E2059502869297B6C65747B737562746C653A657D3D676C6F62616C546869732E6372797074';
wwv_flow_imp.g_varchar2_table(4056) := '6F3B72657475726E20652E6469676573742852632E686173682C41632E656E636F6465286929297D6E2859502C2264696765737422293B6173796E632066756E6374696F6E2051502869297B6C65747B737562746C653A657D3D676C6F62616C54686973';
wwv_flow_imp.g_varchar2_table(4057) := '2E63727970746F3B72657475726E20652E696D706F72744B65792822726177222C747970656F6620693D3D22737472696E67223F41632E656E636F64652869293A692C52632C21312C5B227369676E225D297D6E2851502C2267656E6572617465486D61';
wwv_flow_imp.g_varchar2_table(4058) := '634B657922293B66756E6374696F6E2053762869297B6C657420653D6E65772055696E743841727261792869292C743D22223B666F72286C657420723D303B723C652E6C656E6774683B722B2B29742B3D655B725D2E746F537472696E67283136292E70';
wwv_flow_imp.g_varchar2_table(4059) := '6164537461727428322C223022293B72657475726E20747D6E2853762C226172726179427566666572546F486578537472696E6722293B6173796E632066756E6374696F6E206B6128692C65297B6C65747B737562746C653A747D3D676C6F62616C5468';
wwv_flow_imp.g_varchar2_table(4060) := '69732E63727970746F3B72657475726E20742E7369676E2852632C61776169742051502869292C41632E656E636F6465286529297D6E286B612C226861736822293B6173796E632066756E6374696F6E2055632869297B6C65747B6163636F756E744B65';
wwv_flow_imp.g_varchar2_table(4061) := '793A652C6163636F756E745365637265743A742C73657373696F6E546F6B656E3A722C6275636B65744E616D653A732C4B65793A6F2C526567696F6E3A612C657870697265733A6C2C75706C6F616449643A682C706172744E756D6265723A637D3D692C';
wwv_flow_imp.g_varchar2_table(4062) := '643D227333222C663D60247B737D2E247B647D2E247B617D2E616D617A6F6E6177732E636F6D602C793D602F247B656E636F6465555249286F297D602C623D22554E5349474E45442D5041594C4F4144222C533D6E6577204461746528292E746F49534F';
wwv_flow_imp.g_varchar2_table(4063) := '537472696E6728292E7265706C616365282F5B2D3A5D7C5C2E5C642B2F672C2222292C453D532E736C69636528302C38292C463D60247B457D2F247B617D2F247B647D2F617773345F72657175657374602C783D6E65772055524C286068747470733A2F';
wwv_flow_imp.g_varchar2_table(4064) := '2F247B667D247B797D60293B782E736561726368506172616D732E7365742822582D416D7A2D416C676F726974686D222C22415753342D484D41432D53484132353622292C782E736561726368506172616D732E7365742822582D416D7A2D436F6E7465';
wwv_flow_imp.g_varchar2_table(4065) := '6E742D536861323536222C62292C782E736561726368506172616D732E7365742822582D416D7A2D43726564656E7469616C222C60247B657D2F247B467D60292C782E736561726368506172616D732E7365742822582D416D7A2D44617465222C53292C';
wwv_flow_imp.g_varchar2_table(4066) := '782E736561726368506172616D732E7365742822582D416D7A2D45787069726573222C6C292C782E736561726368506172616D732E7365742822582D416D7A2D53656375726974792D546F6B656E222C72292C782E736561726368506172616D732E7365';
wwv_flow_imp.g_varchar2_table(4067) := '742822582D416D7A2D5369676E656448656164657273222C22686F737422292C632626782E736561726368506172616D732E7365742822706172744E756D626572222C63292C682626782E736561726368506172616D732E736574282275706C6F616449';
wwv_flow_imp.g_varchar2_table(4068) := '64222C68292C782E736561726368506172616D732E7365742822782D6964222C632626683F2255706C6F616450617274223A225075744F626A65637422293B6C657420553D5850287B43616E6F6E6963616C5572693A792C43616E6F6E6963616C517565';
wwv_flow_imp.g_varchar2_table(4069) := '7279537472696E673A782E7365617263682E736C6963652831292C5369676E6564486561646572733A7B686F73743A667D2C4861736865645061796C6F61643A627D292C6A3D5376286177616974205950285529292C473D5B22415753342D484D41432D';
wwv_flow_imp.g_varchar2_table(4070) := '534841323536222C532C462C6A5D2E6A6F696E28600A60292C4A3D6177616974206B61286041575334247B747D602C45292C423D6177616974206B61284A2C61292C7A3D6177616974206B6128422C64292C4B3D6177616974206B61287A2C2261777334';
wwv_flow_imp.g_varchar2_table(4071) := '5F7265717565737422292C6F653D5376286177616974206B61284B2C4729293B72657475726E20782E736561726368506172616D732E7365742822582D416D7A2D5369676E6174757265222C6F65292C787D6E2855632C226372656174655369676E6564';
wwv_flow_imp.g_varchar2_table(4072) := '55524C22293B766172205F763B66756E6374696F6E204D28692C65297B696628214F626A6563742E70726F746F747970652E6861734F776E50726F70657274792E63616C6C28692C6529297468726F77206E657720547970654572726F72282261747465';
wwv_flow_imp.g_varchar2_table(4073) := '6D7074656420746F207573652070726976617465206669656C64206F6E206E6F6E2D696E7374616E636522293B72657475726E20697D6E284D2C225F636C617373507269766174654669656C644C6F6F73654261736522293B766172204A503D303B6675';
wwv_flow_imp.g_varchar2_table(4074) := '6E6374696F6E2050652869297B72657475726E225F5F707269766174655F222B4A502B2B2B225F222B697D6E2850652C225F636C617373507269766174654669656C644C6F6F73654B657922293B766172205A503D7B76657273696F6E3A22332E31302E';
wwv_flow_imp.g_varchar2_table(4075) := '30227D3B66756E6374696F6E20476F2869297B696628692626692E6572726F72297B6C657420653D6E6577204572726F7228692E6D657373616765293B7468726F77204F626A6563742E61737369676E28652C692E6572726F72292C657D72657475726E';
wwv_flow_imp.g_varchar2_table(4076) := '20697D6E28476F2C226173736572745365727665724572726F7222293B66756E6374696F6E20655F2869297B6C657420653D6E65772055524C2869293B72657475726E20652E7365617263683D22222C652E686173683D22222C652E687265667D6E2865';
wwv_flow_imp.g_varchar2_table(4077) := '5F2C2272656D6F76654D6574616461746146726F6D55524C22293B66756E6374696F6E2046762869297B6C657420653D692E45787069726174696F6E3B69662865297B6C657420743D4D6174682E666C6F6F7228286E657720446174652865292D446174';
wwv_flow_imp.g_varchar2_table(4078) := '652E6E6F772829292F316533293B696628743E392972657475726E20747D7D6E2846762C2267657445787069727922293B66756E6374696F6E2050762869297B6C65747B6D6574613A652C616C6C6F7765644D6574614669656C64733A742C7175657269';
wwv_flow_imp.g_varchar2_table(4079) := '66793A723D21317D3D692C733D743F3F4F626A6563742E6B6579732865293B72657475726E20653F4F626A6563742E66726F6D456E747269657328732E66696C746572286F3D3E655B6F5D213D6E756C6C292E6D6170286F3D3E7B6C657420613D723F60';
wwv_flow_imp.g_varchar2_table(4080) := '6D657461646174615B247B6F7D5D603A6F2C6C3D537472696E6728655B6F5D293B72657475726E5B612C6C5D7D29293A7B7D7D6E2850762C22676574416C6C6F7765644D6574616461746122293B66756E6374696F6E2078742869297B69662869213D6E';
wwv_flow_imp.g_varchar2_table(4081) := '756C6C2626692E61626F72746564297468726F772045632822546865206F7065726174696F6E207761732061626F72746564222C7B63617573653A692E726561736F6E7D297D6E2878742C227468726F77496641626F7274656422293B7661722044613D';
wwv_flow_imp.g_varchar2_table(4082) := '5065282261626F72744D756C74697061727455706C6F616422292C6D743D50652822636163686522292C49613D506528226372656174654D756C74697061727455706C6F616422292C4D613D5065282266657463685369676E617475726522292C6A613D';
wwv_flow_imp.g_varchar2_table(4083) := '5065282267657455706C6F6164506172616D657465727322292C4E613D506528226C697374506172747322292C51733D5065282270726576696F7573526574727944656C617922292C4A733D50652822726571756573747322292C47733D506528227265';
wwv_flow_imp.g_varchar2_table(4084) := '74727944656C61797322292C4B733D5065282273656E64436F6D706C6574696F6E5265717565737422292C58733D5065282273657453334D756C746970617274537461746522292C5A733D5065282275706C6F616450617274427974657322292C79743D';
wwv_flow_imp.g_varchar2_table(4085) := '5065282267657446696C6522292C6B633D5065282273686F756C64526574727922292C4C613D506528226E6F6E4D756C74697061727455706C6F616422292C57753D636C6173737B636F6E7374727563746F7228652C742C722C73297B4F626A6563742E';
wwv_flow_imp.g_varchar2_table(4086) := '646566696E6550726F706572747928746869732C4C612C7B76616C75653A695F7D292C4F626A6563742E646566696E6550726F706572747928746869732C6B632C7B76616C75653A745F7D292C4F626A6563742E646566696E6550726F70657274792874';
wwv_flow_imp.g_varchar2_table(4087) := '6869732C44612C7B7772697461626C653A21302C76616C75653A766F696420307D292C4F626A6563742E646566696E6550726F706572747928746869732C6D742C7B7772697461626C653A21302C76616C75653A6E6577205765616B4D61707D292C4F62';
wwv_flow_imp.g_varchar2_table(4088) := '6A6563742E646566696E6550726F706572747928746869732C49612C7B7772697461626C653A21302C76616C75653A766F696420307D292C4F626A6563742E646566696E6550726F706572747928746869732C4D612C7B7772697461626C653A21302C76';
wwv_flow_imp.g_varchar2_table(4089) := '616C75653A766F696420307D292C4F626A6563742E646566696E6550726F706572747928746869732C6A612C7B7772697461626C653A21302C76616C75653A766F696420307D292C4F626A6563742E646566696E6550726F706572747928746869732C4E';
wwv_flow_imp.g_varchar2_table(4090) := '612C7B7772697461626C653A21302C76616C75653A766F696420307D292C4F626A6563742E646566696E6550726F706572747928746869732C51732C7B7772697461626C653A21302C76616C75653A766F696420307D292C4F626A6563742E646566696E';
wwv_flow_imp.g_varchar2_table(4091) := '6550726F706572747928746869732C4A732C7B7772697461626C653A21302C76616C75653A766F696420307D292C4F626A6563742E646566696E6550726F706572747928746869732C47732C7B7772697461626C653A21302C76616C75653A766F696420';
wwv_flow_imp.g_varchar2_table(4092) := '307D292C4F626A6563742E646566696E6550726F706572747928746869732C4B732C7B7772697461626C653A21302C76616C75653A766F696420307D292C4F626A6563742E646566696E6550726F706572747928746869732C58732C7B7772697461626C';
wwv_flow_imp.g_varchar2_table(4093) := '653A21302C76616C75653A766F696420307D292C4F626A6563742E646566696E6550726F706572747928746869732C5A732C7B7772697461626C653A21302C76616C75653A766F696420307D292C4F626A6563742E646566696E6550726F706572747928';
wwv_flow_imp.g_varchar2_table(4094) := '746869732C79742C7B7772697461626C653A21302C76616C75653A766F696420307D292C4D28746869732C4A73295B4A735D3D652C4D28746869732C5873295B58735D3D722C4D28746869732C7974295B79745D3D732C746869732E7365744F7074696F';
wwv_flow_imp.g_varchar2_table(4095) := '6E732874297D7365744F7074696F6E732865297B6C657420743D4D28746869732C4A73295B4A735D3B6966282261626F72744D756C74697061727455706C6F616422696E20652626284D28746869732C4461295B44615D3D742E7772617050726F6D6973';
wwv_flow_imp.g_varchar2_table(4096) := '6546756E6374696F6E28652E61626F72744D756C74697061727455706C6F61642C7B7072696F726974793A317D29292C226372656174654D756C74697061727455706C6F616422696E20652626284D28746869732C4961295B49615D3D742E7772617050';
wwv_flow_imp.g_varchar2_table(4097) := '726F6D69736546756E6374696F6E28652E6372656174654D756C74697061727455706C6F61642C7B7072696F726974793A2D317D29292C227369676E5061727422696E20652626284D28746869732C4D61295B4D615D3D742E7772617050726F6D697365';
wwv_flow_imp.g_varchar2_table(4098) := '46756E6374696F6E28652E7369676E5061727429292C226C697374506172747322696E20652626284D28746869732C4E61295B4E615D3D742E7772617050726F6D69736546756E6374696F6E28652E6C697374506172747329292C22636F6D706C657465';
wwv_flow_imp.g_varchar2_table(4099) := '4D756C74697061727455706C6F616422696E20652626284D28746869732C4B73295B4B735D3D742E7772617050726F6D69736546756E6374696F6E28652E636F6D706C6574654D756C74697061727455706C6F61642C7B7072696F726974793A317D2929';
wwv_flow_imp.g_varchar2_table(4100) := '2C22726574727944656C61797322696E2065297B76617220723B4D28746869732C4773295B47735D3D28723D652E726574727944656C61797329213D6E756C6C3F723A5B5D7D2275706C6F616450617274427974657322696E20652626284D2874686973';
wwv_flow_imp.g_varchar2_table(4101) := '2C5A73295B5A735D3D742E7772617050726F6D69736546756E6374696F6E28652E75706C6F61645061727442797465732C7B7072696F726974793A312F307D29292C2267657455706C6F6164506172616D657465727322696E20652626284D2874686973';
wwv_flow_imp.g_varchar2_table(4102) := '2C6A61295B6A615D3D742E7772617050726F6D69736546756E6374696F6E28652E67657455706C6F6164506172616D657465727329297D6173796E632067657455706C6F6164496428652C74297B6C657420723B666F72283B28723D4D28746869732C6D';
wwv_flow_imp.g_varchar2_table(4103) := '74295B6D745D2E67657428652E646174612929213D6E756C6C3B297472797B72657475726E20617761697420727D63617463687B7D6C657420733D4D28746869732C4961295B49615D284D28746869732C7974295B79745D2865292C74292C6F3D6E2828';
wwv_flow_imp.g_varchar2_table(4104) := '293D3E7B732E61626F727428742E726561736F6E292C4D28746869732C6D74295B6D745D2E64656C65746528652E64617461297D2C2261626F727450726F6D69736522293B72657475726E20742E6164644576656E744C697374656E6572282261626F72';
wwv_flow_imp.g_varchar2_table(4105) := '74222C6F2C7B6F6E63653A21307D292C4D28746869732C6D74295B6D745D2E73657428652E646174612C73292C732E7468656E286173796E6320613D3E7B742E72656D6F76654576656E744C697374656E6572282261626F7274222C6F292C4D28746869';
wwv_flow_imp.g_varchar2_table(4106) := '732C5873295B58735D28652C61292C4D28746869732C6D74295B6D745D2E73657428652E646174612C61297D2C28293D3E7B742E72656D6F76654576656E744C697374656E6572282261626F7274222C6F292C4D28746869732C6D74295B6D745D2E6465';
wwv_flow_imp.g_varchar2_table(4107) := '6C65746528652E64617461297D292C737D6173796E632061626F727446696C6555706C6F61642865297B6C657420743D4D28746869732C6D74295B6D745D2E67657428652E64617461293B696628743D3D6E756C6C2972657475726E3B4D28746869732C';
wwv_flow_imp.g_varchar2_table(4108) := '6D74295B6D745D2E64656C65746528652E64617461292C4D28746869732C5873295B58735D28652C4F626A6563742E637265617465286E756C6C29293B6C657420723B7472797B723D617761697420747D63617463687B72657475726E7D617761697420';
wwv_flow_imp.g_varchar2_table(4109) := '4D28746869732C4461295B44615D284D28746869732C7974295B79745D2865292C72297D6173796E632075706C6F616446696C6528652C742C72297B69662878742872292C742E6C656E6774683D3D3D31262621745B305D2E73686F756C645573654D75';
wwv_flow_imp.g_varchar2_table(4110) := '6C7469706172742972657475726E204D28746869732C4C61295B4C615D28652C745B305D2C72293B6C65747B75706C6F616449643A732C6B65793A6F7D3D617761697420746869732E67657455706C6F6164496428652C72293B78742872293B7472797B';
wwv_flow_imp.g_varchar2_table(4111) := '6C657420613D61776169742050726F6D6973652E616C6C28742E6D617028286C2C68293D3E746869732E75706C6F61644368756E6B28652C682B312C6C2C722929293B72657475726E2078742872292C6177616974204D28746869732C4B73295B4B735D';
wwv_flow_imp.g_varchar2_table(4112) := '284D28746869732C7974295B79745D2865292C7B6B65793A6F2C75706C6F616449643A732C70617274733A612C7369676E616C3A727D2C72292E61626F72744F6E2872297D63617463682861297B7468726F7720613F2E6361757365213D3D4161262661';
wwv_flow_imp.g_varchar2_table(4113) := '3F2E6E616D65213D3D2241626F72744572726F72222626746869732E61626F727446696C6555706C6F61642865292C617D7D726573746F726555706C6F616446696C6528652C74297B4D28746869732C6D74295B6D745D2E73657428652E646174612C74';
wwv_flow_imp.g_varchar2_table(4114) := '297D6173796E6320726573756D6555706C6F616446696C6528652C742C72297B69662878742872292C742E6C656E6774683D3D3D312626745B305D213D6E756C6C262621745B305D2E73686F756C645573654D756C7469706172742972657475726E204D';
wwv_flow_imp.g_varchar2_table(4115) := '28746869732C4C61295B4C615D28652C745B305D2C72293B6C65747B75706C6F616449643A732C6B65793A6F7D3D617761697420746869732E67657455706C6F6164496428652C72293B78742872293B6C657420613D6177616974204D28746869732C4E';
wwv_flow_imp.g_varchar2_table(4116) := '61295B4E615D284D28746869732C7974295B79745D2865292C7B75706C6F616449643A732C6B65793A6F2C7369676E616C3A727D2C72292E61626F72744F6E2872293B78742872293B6C6574206C3D61776169742050726F6D6973652E616C6C28742E6D';
wwv_flow_imp.g_varchar2_table(4117) := '61702828682C63293D3E7B6C657420643D632B312C663D612E66696E6428793D3E7B6C65747B506172744E756D6265723A627D3D793B72657475726E20623D3D3D647D293B72657475726E20663D3D6E756C6C3F746869732E75706C6F61644368756E6B';
wwv_flow_imp.g_varchar2_table(4118) := '28652C642C682C72293A28683D3D6E756C6C7C7C682E736574417355706C6F616465643D3D6E756C6C7C7C682E736574417355706C6F6164656428292C7B506172744E756D6265723A642C455461673A662E455461677D297D29293B72657475726E2078';
wwv_flow_imp.g_varchar2_table(4119) := '742872292C4D28746869732C4B73295B4B735D284D28746869732C7974295B79745D2865292C7B6B65793A6F2C75706C6F616449643A732C70617274733A6C2C7369676E616C3A727D2C72292E61626F72744F6E2872297D6173796E632075706C6F6164';
wwv_flow_imp.g_varchar2_table(4120) := '4368756E6B28652C742C722C73297B78742873293B6C65747B75706C6F616449643A6F2C6B65793A617D3D617761697420746869732E67657455706C6F6164496428652C73292C6C3D4D28746869732C4773295B47735D2E76616C75657328292C683D4D';
wwv_flow_imp.g_varchar2_table(4121) := '28746869732C4773295B47735D2E76616C75657328292C633D6E2828293D3E7B6C657420643D6C2E6E65787428293B72657475726E20643D3D6E756C6C7C7C642E646F6E653F6E756C6C3A642E76616C75657D2C2273686F756C6452657472795369676E';
wwv_flow_imp.g_varchar2_table(4122) := '617475726522293B666F72283B3B297B78742873293B6C657420643D722E6765744461746128292C7B6F6E50726F67726573733A662C6F6E436F6D706C6574653A797D3D722C623B7472797B623D6177616974204D28746869732C4D61295B4D615D284D';
wwv_flow_imp.g_varchar2_table(4123) := '28746869732C7974295B79745D2865292C7B75706C6F616449643A6F2C6B65793A612C706172744E756D6265723A742C626F64793A642C7369676E616C3A737D292E61626F72744F6E2873297D63617463682853297B6C657420453D6328293B69662845';
wwv_flow_imp.g_varchar2_table(4124) := '3D3D6E756C6C7C7C732E61626F72746564297468726F7720533B6177616974206E65772050726F6D69736528463D3E73657454696D656F757428462C4529293B636F6E74696E75657D78742873293B7472797B72657475726E7B506172744E756D626572';
wwv_flow_imp.g_varchar2_table(4125) := '3A742C2E2E2E6177616974204D28746869732C5A73295B5A735D287B7369676E61747572653A622C626F64793A642C73697A653A642E73697A652C6F6E50726F67726573733A662C6F6E436F6D706C6574653A792C7369676E616C3A737D292E61626F72';
wwv_flow_imp.g_varchar2_table(4126) := '744F6E2873297D7D63617463682853297B696628216177616974204D28746869732C6B63295B6B635D28532C6829297468726F7720537D7D7D7D3B6E2857752C2248545450436F6D6D756E69636174696F6E517565756522293B6173796E632066756E63';
wwv_flow_imp.g_varchar2_table(4127) := '74696F6E20745F28692C65297B76617220743B6C657420723D4D28746869732C4A73295B4A735D2C733D693D3D6E756C6C7C7C28743D692E736F75726365293D3D6E756C6C3F766F696420303A742E7374617475733B696628733D3D6E756C6C29726574';
wwv_flow_imp.g_varchar2_table(4128) := '75726E21313B696628733D3D3D3430332626692E6D6573736167653D3D3D225265717565737420686173206578706972656422297B69662821722E6973506175736564297B696628722E6C696D69743D3D3D317C7C4D28746869732C5173295B51735D3D';
wwv_flow_imp.g_varchar2_table(4129) := '3D6E756C6C297B6C6574206F3D652E6E65787428293B6966286F3D3D6E756C6C7C7C6F2E646F6E652972657475726E21313B4D28746869732C5173295B51735D3D6F2E76616C75657D722E726174654C696D69742830292C6177616974206E6577205072';
wwv_flow_imp.g_varchar2_table(4130) := '6F6D697365286F3D3E73657454696D656F7574286F2C4D28746869732C5173295B51735D29297D7D656C736520696628733D3D3D343239297B69662821722E6973506175736564297B6C6574206F3D652E6E65787428293B6966286F3D3D6E756C6C7C7C';
wwv_flow_imp.g_varchar2_table(4131) := '6F2E646F6E652972657475726E21313B722E726174654C696D6974286F2E76616C7565297D7D656C73657B696628733E3430302626733C353030262673213D3D3430392972657475726E21313B696628747970656F66206E6176696761746F723C227522';
wwv_flow_imp.g_varchar2_table(4132) := '26266E6176696761746F722E6F6E4C696E653D3D3D213129722E69735061757365647C7C28722E706175736528292C77696E646F772E6164644576656E744C697374656E657228226F6E6C696E65222C28293D3E7B722E726573756D6528297D2C7B6F6E';
wwv_flow_imp.g_varchar2_table(4133) := '63653A21307D29293B656C73657B6C6574206F3D652E6E65787428293B6966286F3D3D6E756C6C7C7C6F2E646F6E652972657475726E21313B6177616974206E65772050726F6D69736528613D3E73657454696D656F757428612C6F2E76616C75652929';
wwv_flow_imp.g_varchar2_table(4134) := '7D7D72657475726E21307D6E28745F2C225F73686F756C6452657472793222293B6173796E632066756E6374696F6E20695F28692C652C74297B6C65747B6D6574686F643A723D22504F5354222C75726C3A732C6669656C64733A6F2C68656164657273';
wwv_flow_imp.g_varchar2_table(4135) := '3A617D3D6177616974204D28746869732C6A61295B6A615D284D28746869732C7974295B79745D2869292C7B7369676E616C3A747D292E61626F72744F6E2874292C6C2C683D652E6765744461746128293B696628722E746F5570706572436173652829';
wwv_flow_imp.g_varchar2_table(4136) := '3D3D3D22504F535422297B6C657420793D6E657720466F726D446174613B4F626A6563742E656E7472696573286F292E666F724561636828623D3E7B6C65745B532C455D3D623B72657475726E20792E73657428532C45297D292C792E73657428226669';
wwv_flow_imp.g_varchar2_table(4137) := '6C65222C68292C6C3D797D656C7365206C3D683B6C65747B6F6E50726F67726573733A632C6F6E436F6D706C6574653A647D3D652C663D6177616974204D28746869732C5A73295B5A735D287B7369676E61747572653A7B75726C3A732C686561646572';
wwv_flow_imp.g_varchar2_table(4138) := '733A612C6D6574686F643A727D2C626F64793A6C2C73697A653A682E73697A652C6F6E50726F67726573733A632C6F6E436F6D706C6574653A642C7369676E616C3A747D292E61626F72744F6E2874293B72657475726E226C6F636174696F6E22696E20';
wwv_flow_imp.g_varchar2_table(4139) := '663F663A7B6C6F636174696F6E3A655F2873292C2E2E2E667D7D6E28695F2C225F6E6F6E4D756C74697061727455706C6F61643222293B76617220656F3D50652822636F6D70616E696F6E436F6D6D756E69636174696F6E517565756522292C71653D50';
wwv_flow_imp.g_varchar2_table(4140) := '652822636C69656E7422292C67743D5065282263616368656454656D706F7261727943726564656E7469616C7322292C44633D5065282267657454656D706F72617279536563757269747943726564656E7469616C7322292C49633D5065282273657453';
wwv_flow_imp.g_varchar2_table(4141) := '334D756C746970617274537461746522292C746F3D5065282267657446696C6522292C4D633D5065282275706C6F61644C6F63616C46696C6522292C4E633D50652822676574436F6D70616E696F6E436C69656E744172677322292C42613D5065282275';
wwv_flow_imp.g_varchar2_table(4142) := '706C6F616422292C59733D50652822736574436F6D70616E696F6E4865616465727322292C4E723D50652822736574526573756D61626C6555706C6F6164734361706162696C69747922292C7A613D506528227265736574526573756D61626C65436170';
wwv_flow_imp.g_varchar2_table(4143) := '6162696C69747922293B5F763D53796D626F6C2E666F7228227570707920746573743A20676574436C69656E7422293B7661722052693D636C61737320657874656E64732076657B636F6E7374727563746F7228652C74297B76617220723B7375706572';
wwv_flow_imp.g_varchar2_table(4144) := '28652C74292C4F626A6563742E646566696E6550726F706572747928746869732C4E632C7B76616C75653A6F5F7D292C4F626A6563742E646566696E6550726F706572747928746869732C4D632C7B76616C75653A735F7D292C4F626A6563742E646566';
wwv_flow_imp.g_varchar2_table(4145) := '696E6550726F706572747928746869732C44632C7B76616C75653A725F7D292C4F626A6563742E646566696E6550726F706572747928746869732C656F2C7B7772697461626C653A21302C76616C75653A766F696420307D292C4F626A6563742E646566';
wwv_flow_imp.g_varchar2_table(4146) := '696E6550726F706572747928746869732C71652C7B7772697461626C653A21302C76616C75653A766F696420307D292C4F626A6563742E646566696E6550726F706572747928746869732C67742C7B7772697461626C653A21302C76616C75653A766F69';
wwv_flow_imp.g_varchar2_table(4147) := '6420307D292C4F626A6563742E646566696E6550726F706572747928746869732C49632C7B7772697461626C653A21302C76616C75653A286F2C61293D3E7B6C65747B6B65793A6C2C75706C6F616449643A687D3D612C633D746869732E757070792E67';
wwv_flow_imp.g_varchar2_table(4148) := '657446696C65286F2E6964293B63213D6E756C6C2626746869732E757070792E73657446696C655374617465286F2E69642C7B73334D756C7469706172743A7B2E2E2E632E73334D756C7469706172742C6B65793A6C2C75706C6F616449643A687D7D29';
wwv_flow_imp.g_varchar2_table(4149) := '7D7D292C4F626A6563742E646566696E6550726F706572747928746869732C746F2C7B7772697461626C653A21302C76616C75653A6F3D3E746869732E757070792E67657446696C65286F2E6964297C7C6F7D292C4F626A6563742E646566696E655072';
wwv_flow_imp.g_varchar2_table(4150) := '6F706572747928746869732C42612C7B7772697461626C653A21302C76616C75653A6173796E63206F3D3E7B6966286F2E6C656E6774683D3D3D302972657475726E3B6C657420613D746869732E757070792E67657446696C65734279496473286F292C';
wwv_flow_imp.g_varchar2_table(4151) := '6C3D75732861292C683D6873286C293B746869732E757070792E656D6974282275706C6F61642D7374617274222C68293B6C657420633D6C2E6D617028663D3E7B696628662E697352656D6F7465297B6C657420793D6E2828293D3E746869732E726571';
wwv_flow_imp.g_varchar2_table(4152) := '75657374732C22676574517565756522293B4D28746869732C4E72295B4E725D282131293B6C657420623D6E65772041626F7274436F6E74726F6C6C65722C533D6E28463D3E7B462E69643D3D3D662E69642626622E61626F727428297D2C2272656D6F';
wwv_flow_imp.g_varchar2_table(4153) := '76656448616E646C657222293B746869732E757070792E6F6E282266696C652D72656D6F766564222C53293B6C657420453D746869732E757070792E67657452657175657374436C69656E74466F7246696C652866292E75706C6F616452656D6F746546';
wwv_flow_imp.g_varchar2_table(4154) := '696C6528662C4D28746869732C4E63295B4E635D2866292C7B7369676E616C3A622E7369676E616C2C67657451756575653A797D293B72657475726E20746869732E72657175657374732E7772617053796E6346756E6374696F6E2828293D3E7B746869';
wwv_flow_imp.g_varchar2_table(4155) := '732E757070792E6F6666282266696C652D72656D6F766564222C53297D2C7B7072696F726974793A2D317D2928292C457D72657475726E204D28746869732C4D63295B4D635D2866297D292C643D61776169742050726F6D6973652E616C6C2863293B72';
wwv_flow_imp.g_varchar2_table(4156) := '657475726E204D28746869732C4E72295B4E725D282130292C647D7D292C4F626A6563742E646566696E6550726F706572747928746869732C59732C7B7772697461626C653A21302C76616C75653A28293D3E7B4D28746869732C7165295B71655D2E73';
wwv_flow_imp.g_varchar2_table(4157) := '6574436F6D70616E696F6E4865616465727328746869732E6F7074732E636F6D70616E696F6E48656164657273297D7D292C4F626A6563742E646566696E6550726F706572747928746869732C4E722C7B7772697461626C653A21302C76616C75653A6F';
wwv_flow_imp.g_varchar2_table(4158) := '3D3E7B6C65747B6361706162696C69746965733A617D3D746869732E757070792E676574537461746528293B746869732E757070792E7365745374617465287B6361706162696C69746965733A7B2E2E2E612C726573756D61626C6555706C6F6164733A';
wwv_flow_imp.g_varchar2_table(4159) := '6F7D7D297D7D292C4F626A6563742E646566696E6550726F706572747928746869732C7A612C7B7772697461626C653A21302C76616C75653A28293D3E7B4D28746869732C4E72295B4E725D282130297D7D292C746869732E747970653D2275706C6F61';
wwv_flow_imp.g_varchar2_table(4160) := '646572222C746869732E69643D746869732E6F7074732E69647C7C2241777353334D756C746970617274222C746869732E7469746C653D22415753205333204D756C746970617274222C4D28746869732C7165295B71655D3D6E657720687428652C7429';
wwv_flow_imp.g_varchar2_table(4161) := '3B6C657420733D7B616C6C6F7765644D6574614669656C64733A6E756C6C2C6C696D69743A362C73686F756C645573654D756C7469706172743A6F3D3E6F2E73697A65213D3D302C726574727944656C6179733A5B302C3165332C3365332C3565335D2C';
wwv_flow_imp.g_varchar2_table(4162) := '6372656174654D756C74697061727455706C6F61643A746869732E6372656174654D756C74697061727455706C6F61642E62696E642874686973292C6C69737450617274733A746869732E6C69737450617274732E62696E642874686973292C61626F72';
wwv_flow_imp.g_varchar2_table(4163) := '744D756C74697061727455706C6F61643A746869732E61626F72744D756C74697061727455706C6F61642E62696E642874686973292C636F6D706C6574654D756C74697061727455706C6F61643A746869732E636F6D706C6574654D756C746970617274';
wwv_flow_imp.g_varchar2_table(4164) := '55706C6F61642E62696E642874686973292C67657454656D706F72617279536563757269747943726564656E7469616C733A21312C7369676E506172743A74213D6E756C6C2626742E67657454656D706F72617279536563757269747943726564656E74';
wwv_flow_imp.g_varchar2_table(4165) := '69616C733F746869732E6372656174655369676E656455524C2E62696E642874686973293A746869732E7369676E506172742E62696E642874686973292C75706C6F61645061727442797465733A52692E75706C6F61645061727442797465732C676574';
wwv_flow_imp.g_varchar2_table(4166) := '55706C6F6164506172616D65746572733A74213D6E756C6C2626742E67657454656D706F72617279536563757269747943726564656E7469616C733F746869732E6372656174655369676E656455524C2E62696E642874686973293A746869732E676574';
wwv_flow_imp.g_varchar2_table(4167) := '55706C6F6164506172616D65746572732E62696E642874686973292C636F6D70616E696F6E486561646572733A7B7D7D3B746869732E6F7074733D7B2E2E2E732C2E2E2E747D2C743F2E7072657061726555706C6F61645061727473213D6E756C6C2626';
wwv_flow_imp.g_varchar2_table(4168) := '742E7369676E506172743D3D6E756C6C262628746869732E6F7074732E7369676E506172743D6173796E63286F2C61293D3E7B6C65747B75706C6F616449643A6C2C6B65793A682C706172744E756D6265723A632C626F64793A642C7369676E616C3A66';
wwv_flow_imp.g_varchar2_table(4169) := '7D3D612C7B7072657369676E656455726C733A792C686561646572733A627D3D617761697420742E7072657061726555706C6F61645061727473286F2C7B75706C6F616449643A6C2C6B65793A682C70617274733A5B7B6E756D6265723A632C6368756E';
wwv_flow_imp.g_varchar2_table(4170) := '6B3A647D5D2C7369676E616C3A667D293B72657475726E7B75726C3A793F2E5B635D2C686561646572733A623F2E5B635D7D7D292C746869732E72657175657374733D28723D746869732E6F7074732E726174654C696D69746564517565756529213D6E';
wwv_flow_imp.g_varchar2_table(4171) := '756C6C3F723A6E6577204E7428746869732E6F7074732E6C696D6974292C4D28746869732C656F295B656F5D3D6E657720577528746869732E72657175657374732C746869732E6F7074732C4D28746869732C4963295B49635D2C4D28746869732C746F';
wwv_flow_imp.g_varchar2_table(4172) := '295B746F5D292C746869732E75706C6F61646572733D4F626A6563742E637265617465286E756C6C292C746869732E75706C6F616465724576656E74733D4F626A6563742E637265617465286E756C6C292C746869732E75706C6F61646572536F636B65';
wwv_flow_imp.g_varchar2_table(4173) := '74733D4F626A6563742E637265617465286E756C6C297D5B5F765D28297B72657475726E204D28746869732C7165295B71655D7D7365744F7074696F6E732865297B4D28746869732C656F295B656F5D2E7365744F7074696F6E732865292C7375706572';
wwv_flow_imp.g_varchar2_table(4174) := '2E7365744F7074696F6E732865292C4D28746869732C5973295B59735D28297D726573657455706C6F616465725265666572656E63657328652C74297B743D3D3D766F69642030262628743D7B7D292C746869732E75706C6F61646572735B655D262628';
wwv_flow_imp.g_varchar2_table(4175) := '746869732E75706C6F61646572735B655D2E61626F7274287B7265616C6C793A742E61626F72747C7C21317D292C746869732E75706C6F61646572735B655D3D6E756C6C292C746869732E75706C6F616465724576656E74735B655D262628746869732E';
wwv_flow_imp.g_varchar2_table(4176) := '75706C6F616465724576656E74735B655D2E72656D6F766528292C746869732E75706C6F616465724576656E74735B655D3D6E756C6C292C746869732E75706C6F61646572536F636B6574735B655D262628746869732E75706C6F61646572536F636B65';
wwv_flow_imp.g_varchar2_table(4177) := '74735B655D2E636C6F736528292C746869732E75706C6F61646572536F636B6574735B655D3D6E756C6C297D617373657274486F73742865297B69662821746869732E6F7074732E636F6D70616E696F6E55726C297468726F77206E6577204572726F72';
wwv_flow_imp.g_varchar2_table(4178) := '286045787065637465642061205C60636F6D70616E696F6E55726C5C60206F7074696F6E20636F6E7461696E696E67206120436F6D70616E696F6E20616464726573732C206F7220696620796F7520617265206E6F74207573696E6720436F6D70616E69';
wwv_flow_imp.g_varchar2_table(4179) := '6F6E2C206120637573746F6D205C60247B657D5C6020696D706C656D656E746174696F6E2E60297D6372656174654D756C74697061727455706C6F616428652C74297B746869732E617373657274486F737428226372656174654D756C74697061727455';
wwv_flow_imp.g_varchar2_table(4180) := '706C6F616422292C78742874293B6C657420723D5076287B6D6574613A652E6D6574612C616C6C6F7765644D6574614669656C64733A746869732E6F7074732E616C6C6F7765644D6574614669656C64737D293B72657475726E204D28746869732C7165';
wwv_flow_imp.g_varchar2_table(4181) := '295B71655D2E706F7374282273332F6D756C746970617274222C7B66696C656E616D653A652E6E616D652C747970653A652E747970652C6D657461646174613A727D2C7B7369676E616C3A747D292E7468656E28476F297D6C697374506172747328652C';
wwv_flow_imp.g_varchar2_table(4182) := '742C72297B6C65747B6B65793A732C75706C6F616449643A6F7D3D743B746869732E617373657274486F737428226C697374506172747322292C78742872293B6C657420613D656E636F6465555249436F6D706F6E656E742873293B72657475726E204D';
wwv_flow_imp.g_varchar2_table(4183) := '28746869732C7165295B71655D2E676574286073332F6D756C7469706172742F247B6F7D3F6B65793D247B617D602C7B7369676E616C3A727D292E7468656E28476F297D636F6D706C6574654D756C74697061727455706C6F616428652C742C72297B6C';
wwv_flow_imp.g_varchar2_table(4184) := '65747B6B65793A732C75706C6F616449643A6F2C70617274733A617D3D743B746869732E617373657274486F73742822636F6D706C6574654D756C74697061727455706C6F616422292C78742872293B6C6574206C3D656E636F6465555249436F6D706F';
wwv_flow_imp.g_varchar2_table(4185) := '6E656E742873292C683D656E636F6465555249436F6D706F6E656E74286F293B72657475726E204D28746869732C7165295B71655D2E706F7374286073332F6D756C7469706172742F247B687D2F636F6D706C6574653F6B65793D247B6C7D602C7B7061';
wwv_flow_imp.g_varchar2_table(4186) := '7274733A617D2C7B7369676E616C3A727D292E7468656E28476F297D6173796E63206372656174655369676E656455524C28652C74297B6C657420723D6177616974204D28746869732C4463295B44635D2874292C733D467628722E63726564656E7469';
wwv_flow_imp.g_varchar2_table(4187) := '616C73297C7C3630343830302C7B75706C6F616449643A6F2C6B65793A612C706172744E756D6265723A6C2C7369676E616C3A687D3D743B72657475726E7B6D6574686F643A22505554222C657870697265733A732C6669656C64733A7B7D2C75726C3A';
wwv_flow_imp.g_varchar2_table(4188) := '60247B6177616974205563287B6163636F756E744B65793A722E63726564656E7469616C732E4163636573734B657949642C6163636F756E745365637265743A722E63726564656E7469616C732E5365637265744163636573734B65792C73657373696F';
wwv_flow_imp.g_varchar2_table(4189) := '6E546F6B656E3A722E63726564656E7469616C732E53657373696F6E546F6B656E2C657870697265733A732C6275636B65744E616D653A722E6275636B65742C526567696F6E3A722E726567696F6E2C4B65793A613F3F60247B63727970746F2E72616E';
wwv_flow_imp.g_varchar2_table(4190) := '646F6D5555494428297D2D247B652E6E616D657D602C75706C6F616449643A6F2C706172744E756D6265723A6C2C7369676E616C3A687D297D602C686561646572733A7B22436F6E74656E742D54797065223A652E747970657D7D7D7369676E50617274';
wwv_flow_imp.g_varchar2_table(4191) := '28652C74297B6C65747B75706C6F616449643A722C6B65793A732C706172744E756D6265723A6F2C7369676E616C3A617D3D743B696628746869732E617373657274486F737428227369676E5061727422292C78742861292C723D3D6E756C6C7C7C733D';
wwv_flow_imp.g_varchar2_table(4192) := '3D6E756C6C7C7C6F3D3D6E756C6C297468726F77206E6577204572726F72282243616E6E6F74207369676E20776974686F75742061206B65792C20616E2075706C6F616449642C20616E64206120706172744E756D62657222293B6C6574206C3D656E63';
wwv_flow_imp.g_varchar2_table(4193) := '6F6465555249436F6D706F6E656E742873293B72657475726E204D28746869732C7165295B71655D2E676574286073332F6D756C7469706172742F247B727D2F247B6F7D3F6B65793D247B6C7D602C7B7369676E616C3A617D292E7468656E28476F297D';
wwv_flow_imp.g_varchar2_table(4194) := '61626F72744D756C74697061727455706C6F616428652C742C72297B6C65747B6B65793A732C75706C6F616449643A6F7D3D743B746869732E617373657274486F7374282261626F72744D756C74697061727455706C6F616422293B6C657420613D656E';
wwv_flow_imp.g_varchar2_table(4195) := '636F6465555249436F6D706F6E656E742873292C6C3D656E636F6465555249436F6D706F6E656E74286F293B72657475726E204D28746869732C7165295B71655D2E64656C657465286073332F6D756C7469706172742F247B6C7D3F6B65793D247B617D';
wwv_flow_imp.g_varchar2_table(4196) := '602C766F696420302C7B7369676E616C3A727D292E7468656E28476F297D67657455706C6F6164506172616D657465727328652C74297B6C65747B6D6574613A727D3D652C7B747970653A732C6E616D653A6F7D3D722C613D5076287B6D6574613A722C';
wwv_flow_imp.g_varchar2_table(4197) := '616C6C6F7765644D6574614669656C64733A746869732E6F7074732E616C6C6F7765644D6574614669656C64732C717565726966793A21307D292C6C3D6E65772055524C536561726368506172616D73287B66696C656E616D653A6F2C747970653A732C';
wwv_flow_imp.g_varchar2_table(4198) := '2E2E2E617D293B72657475726E204D28746869732C7165295B71655D2E676574286073332F706172616D733F247B6C7D602C74297D737461746963206173796E632075706C6F61645061727442797465732865297B6C65747B7369676E61747572653A7B';
wwv_flow_imp.g_varchar2_table(4199) := '75726C3A742C657870697265733A722C686561646572733A732C6D6574686F643A6F3D22505554227D2C626F64793A612C73697A653A6C3D612E73697A652C6F6E50726F67726573733A682C6F6E436F6D706C6574653A632C7369676E616C3A647D3D65';
wwv_flow_imp.g_varchar2_table(4200) := '3B69662878742864292C743D3D6E756C6C297468726F77206E6577204572726F72282243616E6E6F742075706C6F616420746F20616E20756E646566696E65642055524C22293B72657475726E206E65772050726F6D6973652828662C79293D3E7B6C65';
wwv_flow_imp.g_varchar2_table(4201) := '7420623D6E657720584D4C48747470526571756573743B622E6F70656E286F2C742C2130292C7326264F626A6563742E6B6579732873292E666F724561636828463D3E7B622E7365745265717565737448656164657228462C735B465D297D292C622E72';
wwv_flow_imp.g_varchar2_table(4202) := '6573706F6E7365547970653D2274657874222C747970656F6620723D3D226E756D62657222262628622E74696D656F75743D722A316533293B66756E6374696F6E205328297B622E61626F727428297D6E28532C226F6E61626F727422293B66756E6374';
wwv_flow_imp.g_varchar2_table(4203) := '696F6E204528297B642E72656D6F76654576656E744C697374656E6572282261626F7274222C53297D6E28452C22636C65616E757022292C642E6164644576656E744C697374656E6572282261626F7274222C53292C622E75706C6F61642E6164644576';
wwv_flow_imp.g_varchar2_table(4204) := '656E744C697374656E6572282270726F6772657373222C463D3E7B682846297D292C622E6164644576656E744C697374656E6572282261626F7274222C28293D3E7B4528292C792845632829297D292C622E6164644576656E744C697374656E65722822';
wwv_flow_imp.g_varchar2_table(4205) := '74696D656F7574222C28293D3E7B4528293B6C657420463D6E6577204572726F7228225265717565737420686173206578706972656422293B462E736F757263653D7B7374617475733A3430337D2C792846297D292C622E6164644576656E744C697374';
wwv_flow_imp.g_varchar2_table(4206) := '656E657228226C6F6164222C463D3E7B6966284528292C462E7461726765742E7374617475733D3D3D3430332626462E7461726765742E726573706F6E7365546578742E696E636C7564657328223C4D6573736167653E52657175657374206861732065';
wwv_flow_imp.g_varchar2_table(4207) := '7870697265643C2F4D6573736167653E2229297B6C6574206A3D6E6577204572726F7228225265717565737420686173206578706972656422293B6A2E736F757263653D462E7461726765742C79286A293B72657475726E7D696628462E746172676574';
wwv_flow_imp.g_varchar2_table(4208) := '2E7374617475733C3230307C7C462E7461726765742E7374617475733E3D333030297B6C6574206A3D6E6577204572726F7228224E6F6E2032787822293B6A2E736F757263653D462E7461726765742C79286A293B72657475726E7D683F2E287B6C6F61';
wwv_flow_imp.g_varchar2_table(4209) := '6465643A6C2C6C656E677468436F6D70757461626C653A21307D293B6C657420783D462E7461726765742E676574526573706F6E736548656164657228224554616722292C553D462E7461726765742E676574526573706F6E736548656164657228224C';
wwv_flow_imp.g_varchar2_table(4210) := '6F636174696F6E22293B6966286F2E746F55707065724361736528293D3D3D22504F5354222626553D3D3D6E756C6C2626636F6E736F6C652E7761726E282241777353332F4D756C7469706172743A20436F756C64206E6F74207265616420746865204C';
wwv_flow_imp.g_varchar2_table(4211) := '6F636174696F6E206865616465722E2054686973206C696B656C79206D65616E7320434F5253206973206E6F7420636F6E6669677572656420636F72726563746C79206F6E20746865205333204275636B65742E205365652068747470733A2F2F757070';
wwv_flow_imp.g_varchar2_table(4212) := '792E696F2F646F63732F6177732D73332D6D756C7469706172742353332D4275636B65742D436F6E66696775726174696F6E20666F7220696E737472756374696F6E732E22292C783D3D3D6E756C6C297B79286E6577204572726F72282241777353332F';
wwv_flow_imp.g_varchar2_table(4213) := '4D756C7469706172743A20436F756C64206E6F742072656164207468652045546167206865616465722E2054686973206C696B656C79206D65616E7320434F5253206973206E6F7420636F6E6669677572656420636F72726563746C79206F6E20746865';
wwv_flow_imp.g_varchar2_table(4214) := '205333204275636B65742E205365652068747470733A2F2F757070792E696F2F646F63732F6177732D73332D6D756C7469706172742353332D4275636B65742D436F6E66696775726174696F6E20666F7220696E737472756374696F6E732E2229293B72';
wwv_flow_imp.g_varchar2_table(4215) := '657475726E7D633F2E2878292C66287B455461673A782C2E2E2E553F7B6C6F636174696F6E3A557D3A766F696420307D297D292C622E6164644576656E744C697374656E657228226572726F72222C463D3E7B4528293B6C657420783D6E657720457272';
wwv_flow_imp.g_varchar2_table(4216) := '6F722822556E6B6E6F776E206572726F7222293B782E736F757263653D462E7461726765742C792878297D292C622E73656E642861297D297D696E7374616C6C28297B4D28746869732C4E72295B4E725D282130292C746869732E757070792E61646450';
wwv_flow_imp.g_varchar2_table(4217) := '726550726F636573736F72284D28746869732C5973295B59735D292C746869732E757070792E61646455706C6F61646572284D28746869732C4261295B42615D292C746869732E757070792E6F6E282263616E63656C2D616C6C222C4D28746869732C7A';
wwv_flow_imp.g_varchar2_table(4218) := '61295B7A615D297D756E696E7374616C6C28297B746869732E757070792E72656D6F766550726550726F636573736F72284D28746869732C5973295B59735D292C746869732E757070792E72656D6F766555706C6F61646572284D28746869732C426129';
wwv_flow_imp.g_varchar2_table(4219) := '5B42615D292C746869732E757070792E6F6666282263616E63656C2D616C6C222C4D28746869732C7A61295B7A615D297D7D3B6E2852692C2241777353334D756C74697061727422293B6173796E632066756E6374696F6E20725F2869297B7265747572';
wwv_flow_imp.g_varchar2_table(4220) := '6E20787428693F2E7369676E616C292C4D28746869732C6774295B67745D3D3D6E756C6C262628746869732E6F7074732E67657454656D706F72617279536563757269747943726564656E7469616C733D3D3D21303F28746869732E617373657274486F';
wwv_flow_imp.g_varchar2_table(4221) := '7374282267657454656D706F72617279536563757269747943726564656E7469616C7322292C4D28746869732C6774295B67745D3D4D28746869732C7165295B71655D2E676574282273332F737473222C6E756C6C2C69292E7468656E28476F29293A4D';
wwv_flow_imp.g_varchar2_table(4222) := '28746869732C6774295B67745D3D746869732E6F7074732E67657454656D706F72617279536563757269747943726564656E7469616C732869292C4D28746869732C6774295B67745D3D6177616974204D28746869732C6774295B67745D2C7365745469';
wwv_flow_imp.g_varchar2_table(4223) := '6D656F75742828293D3E7B4D28746869732C6774295B67745D3D6E756C6C7D2C284676284D28746869732C6774295B67745D2E63726564656E7469616C73297C7C30292A35303029292C4D28746869732C6774295B67745D7D6E28725F2C225F67657454';
wwv_flow_imp.g_varchar2_table(4224) := '656D706F72617279536563757269747943726564656E7469616C733222293B66756E6374696F6E20735F2869297B76617220653D746869733B72657475726E206E65772050726F6D6973652828742C72293D3E7B6C657420733D6E2828642C66293D3E7B';
wwv_flow_imp.g_varchar2_table(4225) := '746869732E757070792E656D6974282275706C6F61642D70726F6772657373222C692C7B75706C6F616465723A746869732C627974657355706C6F616465643A642C6279746573546F74616C3A667D297D2C226F6E50726F677265737322292C6F3D6E28';
wwv_flow_imp.g_varchar2_table(4226) := '643D3E7B746869732E757070792E6C6F672864292C746869732E757070792E656D6974282275706C6F61642D6572726F72222C692C64292C746869732E726573657455706C6F616465725265666572656E63657328692E6964292C722864297D2C226F6E';
wwv_flow_imp.g_varchar2_table(4227) := '4572726F7222292C613D6E28643D3E7B6C657420663D7B626F64793A7B2E2E2E647D2C75706C6F616455524C3A642E6C6F636174696F6E7D3B746869732E726573657455706C6F616465725265666572656E63657328692E6964292C746869732E757070';
wwv_flow_imp.g_varchar2_table(4228) := '792E656D6974282275706C6F61642D73756363657373222C4D28746869732C746F295B746F5D2869292C66292C642E6C6F636174696F6E2626746869732E757070792E6C6F672860446F776E6C6F616420247B692E6E616D657D2066726F6D20247B642E';
wwv_flow_imp.g_varchar2_table(4229) := '6C6F636174696F6E7D60292C7428297D2C226F6E5375636365737322292C6C3D6E28643D3E7B746869732E757070792E656D6974282273332D6D756C7469706172743A706172742D75706C6F61646564222C4D28746869732C746F295B746F5D2869292C';
wwv_flow_imp.g_varchar2_table(4230) := '64297D2C226F6E50617274436F6D706C65746522292C683D6E657720777628692E646174612C7B636F6D70616E696F6E436F6D6D3A4D28746869732C656F295B656F5D2C6C6F673A66756E6374696F6E28297B72657475726E20652E757070792E6C6F67';
wwv_flow_imp.g_varchar2_table(4231) := '282E2E2E617267756D656E7473297D2C6765744368756E6B53697A653A746869732E6F7074732E6765744368756E6B53697A653F746869732E6F7074732E6765744368756E6B53697A652E62696E642874686973293A6E756C6C2C6F6E50726F67726573';
wwv_flow_imp.g_varchar2_table(4232) := '733A732C6F6E4572726F723A6F2C6F6E537563636573733A612C6F6E50617274436F6D706C6574653A6C2C66696C653A692C73686F756C645573654D756C7469706172743A746869732E6F7074732E73686F756C645573654D756C7469706172742C2E2E';
wwv_flow_imp.g_varchar2_table(4233) := '2E692E73334D756C7469706172747D293B746869732E75706C6F61646572735B692E69645D3D683B6C657420633D6E657720676928746869732E75707079293B746869732E75706C6F616465724576656E74735B692E69645D3D632C632E6F6E46696C65';
wwv_flow_imp.g_varchar2_table(4234) := '52656D6F766528692E69642C643D3E7B682E61626F727428292C746869732E726573657455706C6F616465725265666572656E63657328692E69642C7B61626F72743A21307D292C74286075706C6F616420247B642E69647D207761732072656D6F7665';
wwv_flow_imp.g_varchar2_table(4235) := '6460297D292C632E6F6E43616E63656C416C6C28692E69642C66756E6374696F6E2864297B6C65747B726561736F6E3A667D3D643D3D3D766F696420303F7B7D3A643B663D3D3D227573657222262628682E61626F727428292C652E726573657455706C';
wwv_flow_imp.g_varchar2_table(4236) := '6F616465725265666572656E63657328692E69642C7B61626F72743A21307D29292C74286075706C6F616420247B692E69647D207761732063616E63656C656460297D292C632E6F6E46696C65506175736528692E69642C643D3E7B643F682E70617573';
wwv_flow_imp.g_varchar2_table(4237) := '6528293A682E737461727428297D292C632E6F6E5061757365416C6C28692E69642C28293D3E7B682E706175736528297D292C632E6F6E526573756D65416C6C28692E69642C28293D3E7B682E737461727428297D292C682E737461727428297D297D6E';
wwv_flow_imp.g_varchar2_table(4238) := '28735F2C225F75706C6F61644C6F63616C46696C653222293B66756E6374696F6E206F5F2869297B72657475726E7B2E2E2E692E72656D6F74652E626F64792C70726F746F636F6C3A2273332D6D756C746970617274222C73697A653A692E646174612E';
wwv_flow_imp.g_varchar2_table(4239) := '73697A652C6D657461646174613A692E6D6574617D7D6E286F5F2C225F676574436F6D70616E696F6E436C69656E74417267733222293B52692E56455253494F4E3D5A502E76657273696F6E3B66756E6374696F6E20796928692C65297B696628214F62';
wwv_flow_imp.g_varchar2_table(4240) := '6A6563742E70726F746F747970652E6861734F776E50726F70657274792E63616C6C28692C6529297468726F77206E657720547970654572726F722822617474656D7074656420746F207573652070726976617465206669656C64206F6E206E6F6E2D69';
wwv_flow_imp.g_varchar2_table(4241) := '6E7374616E636522293B72657475726E20697D6E2879692C225F636C617373507269766174654669656C644C6F6F73654261736522293B766172206E5F3D303B66756E6374696F6E204B752869297B72657475726E225F5F707269766174655F222B6E5F';
wwv_flow_imp.g_varchar2_table(4242) := '2B2B2B225F222B697D6E284B752C225F636C617373507269766174654669656C644C6F6F73654B657922293B766172204C723D4B752822616C69766554696D657222292C696F3D4B7528226973446F6E6522292C48613D4B7528226F6E54696D65644F75';
wwv_flow_imp.g_varchar2_table(4243) := '7422292C726F3D4B75282274696D656F757422292C47753D636C6173737B636F6E7374727563746F7228652C74297B4F626A6563742E646566696E6550726F706572747928746869732C4C722C7B7772697461626C653A21302C76616C75653A766F6964';
wwv_flow_imp.g_varchar2_table(4244) := '20307D292C4F626A6563742E646566696E6550726F706572747928746869732C696F2C7B7772697461626C653A21302C76616C75653A21317D292C4F626A6563742E646566696E6550726F706572747928746869732C48612C7B7772697461626C653A21';
wwv_flow_imp.g_varchar2_table(4245) := '302C76616C75653A766F696420307D292C4F626A6563742E646566696E6550726F706572747928746869732C726F2C7B7772697461626C653A21302C76616C75653A766F696420307D292C796928746869732C726F295B726F5D3D652C79692874686973';
wwv_flow_imp.g_varchar2_table(4246) := '2C4861295B48615D3D747D70726F677265737328297B796928746869732C696F295B696F5D7C7C796928746869732C726F295B726F5D3E30262628636C65617254696D656F757428796928746869732C4C72295B4C725D292C796928746869732C4C7229';
wwv_flow_imp.g_varchar2_table(4247) := '5B4C725D3D73657454696D656F757428796928746869732C4861295B48615D2C796928746869732C726F295B726F5D29297D646F6E6528297B796928746869732C696F295B696F5D7C7C28636C65617254696D656F757428796928746869732C4C72295B';
wwv_flow_imp.g_varchar2_table(4248) := '4C725D292C796928746869732C4C72295B4C725D3D766F696420302C796928746869732C696F295B696F5D3D2130297D7D3B6E2847752C2250726F677265737354696D656F757422293B7661722024613D47753B66756E6374696F6E20615F2869297B72';
wwv_flow_imp.g_varchar2_table(4249) := '657475726E20693F692E72656164795374617465213D3D302626692E72656164795374617465213D3D347C7C692E7374617475733D3D3D303A21317D6E28615F2C2269734E6574776F726B4572726F7222293B76617220736F3D615F3B66756E6374696F';
wwv_flow_imp.g_varchar2_table(4250) := '6E20787628692C65297B696628214F626A6563742E70726F746F747970652E6861734F776E50726F70657274792E63616C6C28692C6529297468726F77206E657720547970654572726F722822617474656D7074656420746F2075736520707269766174';
wwv_flow_imp.g_varchar2_table(4251) := '65206669656C64206F6E206E6F6E2D696E7374616E636522293B72657475726E20697D6E2878762C225F636C617373507269766174654669656C644C6F6F73654261736522293B766172206C5F3D303B66756E6374696F6E2043762869297B7265747572';
wwv_flow_imp.g_varchar2_table(4252) := '6E225F5F707269766174655F222B6C5F2B2B2B225F222B697D6E2843762C225F636C617373507269766174654669656C644C6F6F73654B657922293B66756E6374696F6E20457628692C65297B696628736F2869292972657475726E206E6577205F6928';
wwv_flow_imp.g_varchar2_table(4253) := '652C69293B6C657420743D6E6577207672282255706C6F6164206572726F72222C7B63617573653A657D293B72657475726E20742E726571756573743D692C747D6E2845762C226275696C64526573706F6E73654572726F7222293B66756E6374696F6E';
wwv_flow_imp.g_varchar2_table(4254) := '20755F2869297B72657475726E20692E646174612E736C69636528302C692E646174612E73697A652C692E6D6574612E74797065297D6E28755F2C2273657454797065496E426C6F6222293B66756E6374696F6E20685F28692C652C74297B2841727261';
wwv_flow_imp.g_varchar2_table(4255) := '792E6973417272617928742E616C6C6F7765644D6574614669656C6473293F742E616C6C6F7765644D6574614669656C64733A4F626A6563742E6B657973286529292E666F724561636828733D3E7B692E617070656E6428732C655B735D297D297D6E28';
wwv_flow_imp.g_varchar2_table(4256) := '685F2C226164644D6574616461746122293B66756E6374696F6E20645F28692C65297B6C657420743D6E657720466F726D446174613B685F28742C692E6D6574612C65293B6C657420723D755F2869293B72657475726E20692E6E616D653F742E617070';
wwv_flow_imp.g_varchar2_table(4257) := '656E6428652E6669656C644E616D652C722C692E6D6574612E6E616D65293A742E617070656E6428652E6669656C644E616D652C72292C747D6E28645F2C22637265617465466F726D4461746155706C6F616422293B76617220635F3D6E28693D3E692E';
wwv_flow_imp.g_varchar2_table(4258) := '646174612C226372656174654261726555706C6F616422292C4C633D437628226164644576656E7448616E646C6572466F7246696C6522292C42633D437628226164644576656E7448616E646C6572496646696C655374696C6C45786973747322292C4B';
wwv_flow_imp.g_varchar2_table(4259) := '6F3D636C6173737B636F6E7374727563746F7228652C74297B4F626A6563742E646566696E6550726F706572747928746869732C42632C7B76616C75653A665F7D292C4F626A6563742E646566696E6550726F706572747928746869732C4C632C7B7661';
wwv_flow_imp.g_varchar2_table(4260) := '6C75653A705F7D292C746869732E757070793D652C746869732E6F7074733D7B76616C69646174655374617475732872297B72657475726E20723E3D3230302626723C3330307D2C2E2E2E747D2C746869732E72657175657374733D745B6C735D2C7468';
wwv_flow_imp.g_varchar2_table(4261) := '69732E75706C6F616465724576656E74733D4F626A6563742E637265617465286E756C6C292C746869732E6931386E3D742E6931386E7D6765744F7074696F6E732865297B76617220743B6C65747B757070793A727D3D746869732C733D722E67657453';
wwv_flow_imp.g_varchar2_table(4262) := '7461746528292E78687255706C6F61643B72657475726E7B2E2E2E746869732E6F7074732C2E2E2E737C7C7B7D2C2E2E2E652E78687255706C6F61647C7C7B7D2C686561646572733A7B2E2E2E746869732E6F7074732E686561646572732C2E2E2E733F';
wwv_flow_imp.g_varchar2_table(4263) := '2E686561646572732C2E2E2E28743D652E78687255706C6F6164293D3D6E756C6C3F766F696420303A742E686561646572737D7D7D75706C6F61644C6F63616C46696C652865297B6C657420743D746869732E6765744F7074696F6E732865293B726574';
wwv_flow_imp.g_varchar2_table(4264) := '75726E206E65772050726F6D6973652828722C73293D3E7B6C6574206F3D742E666F726D446174613F645F28652C74293A635F28652C74292C613D6E657720584D4C48747470526571756573743B746869732E75706C6F616465724576656E74735B652E';
wwv_flow_imp.g_varchar2_table(4265) := '69645D3D6E657720676928746869732E75707079293B6C6574206C3D6E657720246128742E74696D656F75742C28293D3E7B612E61626F727428292C632E646F6E6528293B6C657420643D6E6577204572726F7228746869732E6931386E282274696D65';
wwv_flow_imp.g_varchar2_table(4266) := '644F7574222C7B7365636F6E64733A4D6174682E6365696C28742E74696D656F75742F316533297D29293B746869732E757070792E656D6974282275706C6F61642D6572726F72222C652C64292C732864297D292C683D507428293B612E75706C6F6164';
wwv_flow_imp.g_varchar2_table(4267) := '2E6164644576656E744C697374656E657228226C6F61647374617274222C28293D3E7B746869732E757070792E6C6F6728605B41777353332F58485255706C6F61645D20247B687D207374617274656460297D292C612E75706C6F61642E616464457665';
wwv_flow_imp.g_varchar2_table(4268) := '6E744C697374656E6572282270726F6772657373222C643D3E7B746869732E757070792E6C6F6728605B41777353332F58485255706C6F61645D20247B687D2070726F67726573733A20247B642E6C6F616465647D202F20247B642E746F74616C7D6029';
wwv_flow_imp.g_varchar2_table(4269) := '2C6C2E70726F677265737328292C642E6C656E677468436F6D70757461626C652626746869732E757070792E656D6974282275706C6F61642D70726F6772657373222C652C7B75706C6F616465723A746869732C627974657355706C6F616465643A642E';
wwv_flow_imp.g_varchar2_table(4270) := '6C6F616465642C6279746573546F74616C3A642E746F74616C7D297D292C612E6164644576656E744C697374656E657228226C6F6164222C643D3E7B696628746869732E757070792E6C6F6728605B41777353332F58485255706C6F61645D20247B687D';
wwv_flow_imp.g_varchar2_table(4271) := '2066696E697368656460292C6C2E646F6E6528292C632E646F6E6528292C746869732E75706C6F616465724576656E74735B652E69645D262628746869732E75706C6F616465724576656E74735B652E69645D2E72656D6F766528292C746869732E7570';
wwv_flow_imp.g_varchar2_table(4272) := '6C6F616465724576656E74735B652E69645D3D6E756C6C292C742E76616C696461746553746174757328642E7461726765742E7374617475732C612E726573706F6E7365546578742C6129297B6C657420533D742E676574526573706F6E736544617461';
wwv_flow_imp.g_varchar2_table(4273) := '28612E726573706F6E7365546578742C61292C453D535B742E726573706F6E736555726C4669656C644E616D655D2C463D7B7374617475733A642E7461726765742E7374617475732C626F64793A532C75706C6F616455524C3A457D3B72657475726E20';
wwv_flow_imp.g_varchar2_table(4274) := '746869732E757070792E656D6974282275706C6F61642D73756363657373222C652C46292C452626746869732E757070792E6C6F672860446F776E6C6F616420247B652E6E616D657D2066726F6D20247B457D60292C722865297D6C657420663D742E67';
wwv_flow_imp.g_varchar2_table(4275) := '6574526573706F6E73654461746128612E726573706F6E7365546578742C61292C793D457628612C742E676574526573706F6E73654572726F7228612E726573706F6E7365546578742C6129292C623D7B7374617475733A642E7461726765742E737461';
wwv_flow_imp.g_varchar2_table(4276) := '7475732C626F64793A667D3B72657475726E20746869732E757070792E656D6974282275706C6F61642D6572726F72222C652C792C62292C732879297D292C612E6164644576656E744C697374656E657228226572726F72222C28293D3E7B746869732E';
wwv_flow_imp.g_varchar2_table(4277) := '757070792E6C6F6728605B41777353332F58485255706C6F61645D20247B687D206572726F72656460292C6C2E646F6E6528292C632E646F6E6528292C746869732E75706C6F616465724576656E74735B652E69645D262628746869732E75706C6F6164';
wwv_flow_imp.g_varchar2_table(4278) := '65724576656E74735B652E69645D2E72656D6F766528292C746869732E75706C6F616465724576656E74735B652E69645D3D6E756C6C293B6C657420643D457628612C742E676574526573706F6E73654572726F7228612E726573706F6E736554657874';
wwv_flow_imp.g_varchar2_table(4279) := '2C6129293B72657475726E20746869732E757070792E656D6974282275706C6F61642D6572726F72222C652C64292C732864297D292C612E6F70656E28742E6D6574686F642E746F55707065724361736528292C742E656E64706F696E742C2130292C61';
wwv_flow_imp.g_varchar2_table(4280) := '2E7769746843726564656E7469616C733D2121742E7769746843726564656E7469616C732C742E726573706F6E736554797065213D3D2222262628612E726573706F6E7365547970653D742E726573706F6E736554797065292C4F626A6563742E6B6579';
wwv_flow_imp.g_varchar2_table(4281) := '7328742E68656164657273292E666F724561636828643D3E7B612E7365745265717565737448656164657228642C742E686561646572735B645D297D293B6C657420633D746869732E72657175657374732E72756E2828293D3E28612E73656E64286F29';
wwv_flow_imp.g_varchar2_table(4282) := '2C28293D3E7B6C2E646F6E6528292C612E61626F727428297D292C7B7072696F726974793A317D293B787628746869732C4C63295B4C635D282266696C652D72656D6F766564222C652E69642C28293D3E7B632E61626F727428292C73286E6577204572';
wwv_flow_imp.g_varchar2_table(4283) := '726F72282246696C652072656D6F7665642229297D292C787628746869732C4263295B42635D282263616E63656C2D616C6C222C652E69642C66756E6374696F6E2864297B6C65747B726561736F6E3A667D3D643D3D3D766F696420303F7B7D3A643B66';
wwv_flow_imp.g_varchar2_table(4284) := '3D3D3D2275736572222626632E61626F727428292C73286E6577204572726F72282255706C6F61642063616E63656C6C65642229297D297D297D7D3B6E284B6F2C224D696E6958485255706C6F616422293B66756E6374696F6E20705F28692C652C7429';
wwv_flow_imp.g_varchar2_table(4285) := '7B746869732E75706C6F616465724576656E74735B655D2E6F6E28692C723D3E7B76617220733B6C6574206F3D28733D723F2E696429213D6E756C6C3F733A723B653D3D3D6F26267428297D297D6E28705F2C225F6164644576656E7448616E646C6572';
wwv_flow_imp.g_varchar2_table(4286) := '466F7246696C653222293B66756E6374696F6E20665F28692C652C74297B76617220723D746869733B746869732E75706C6F616465724576656E74735B655D2E6F6E28692C66756E6374696F6E28297B722E757070792E67657446696C65286529262674';
wwv_flow_imp.g_varchar2_table(4287) := '282E2E2E617267756D656E7473297D297D6E28665F2C225F6164644576656E7448616E646C6572496646696C655374696C6C4578697374733222293B66756E6374696F6E206D5F2869297B72657475726E20692E7265706C616365282F3B2E2A242F2C22';
wwv_flow_imp.g_varchar2_table(4288) := '22297D6E286D5F2C2272656D6F76654D696D65506172616D657465727322293B66756E6374696F6E20675F28692C65297B6C657420743D652E686561646572733F652E686561646572735B22636F6E74656E742D74797065225D3A652E67657452657370';
wwv_flow_imp.g_varchar2_table(4289) := '6F6E73654865616465722822436F6E74656E742D5479706522293B696628747970656F6620743D3D22737472696E6722297B6C657420723D6D5F2874292E746F4C6F7765724361736528293B696628723D3D3D226170706C69636174696F6E2F786D6C22';
wwv_flow_imp.g_varchar2_table(4290) := '7C7C723D3D3D22746578742F786D6C227C7C723D3D3D22746578742F68746D6C2226262F5E3C5C3F786D6C202F2E746573742869292972657475726E21307D72657475726E21317D6E28675F2C226973586D6C22293B766172207A633D675F3B76617220';
wwv_flow_imp.g_varchar2_table(4291) := '4F763D7B737472696E67733A7B74696D65644F75743A2255706C6F6164207374616C6C656420666F7220257B7365636F6E64737D207365636F6E64732C2061626F7274696E672E227D7D3B7661722041763B66756E6374696F6E20737428692C65297B69';
wwv_flow_imp.g_varchar2_table(4292) := '6628214F626A6563742E70726F746F747970652E6861734F776E50726F70657274792E63616C6C28692C6529297468726F77206E657720547970654572726F722822617474656D7074656420746F207573652070726976617465206669656C64206F6E20';
wwv_flow_imp.g_varchar2_table(4293) := '6E6F6E2D696E7374616E636522293B72657475726E20697D6E2873742C225F636C617373507269766174654669656C644C6F6F73654261736522293B76617220795F3D303B66756E6374696F6E20586F2869297B72657475726E225F5F70726976617465';
wwv_flow_imp.g_varchar2_table(4294) := '5F222B795F2B2B2B225F222B697D6E28586F2C225F636C617373507269766174654669656C644C6F6F73654B657922293B76617220765F3D7B76657273696F6E3A22332E362E30227D3B66756E6374696F6E20625F28692C65297B72657475726E216926';
wwv_flow_imp.g_varchar2_table(4295) := '2621652E73746172747357697468282268747470733A2F2F2229262621652E737461727473576974682822687474703A2F2F2229262628653D6068747470733A2F2F247B657D60292C6E65772055524C28652C697C7C766F69642030292E746F53747269';
wwv_flow_imp.g_varchar2_table(4296) := '6E6728297D6E28625F2C227265736F6C766555726C22293B66756E6374696F6E20576128692C65297B6C657420743D692E696E6465784F6628603C247B657D3E60292C723D692E696E6465784F6628603C2F247B657D3E602C74293B72657475726E2074';
wwv_flow_imp.g_varchar2_table(4297) := '213D3D2D31262672213D3D2D313F692E736C69636528742B652E6C656E6774682B322C72293A22227D6E2857612C22676574586D6C56616C756522293B66756E6374696F6E20775F2869297B696628692626692E6572726F72297B6C657420653D6E6577';
wwv_flow_imp.g_varchar2_table(4298) := '204572726F7228692E6D657373616765293B7468726F77204F626A6563742E61737369676E28652C692E6572726F72292C657D72657475726E20697D6E28775F2C226173736572745365727665724572726F7222293B66756E6374696F6E20535F28692C';
wwv_flow_imp.g_varchar2_table(4299) := '65297B696628212865213D6E756C6C2626747970656F6620652E75726C3D3D22737472696E6722262628747970656F6620652E6669656C64733D3D226F626A656374227C7C652E6669656C64733D3D6E756C6C2929297468726F77206E65772054797065';
wwv_flow_imp.g_varchar2_table(4300) := '4572726F72286041777353333A20676F7420696E636F727265637420726573756C742066726F6D202767657455706C6F6164506172616D657465727328292720666F722066696C652027247B692E6E616D657D272C20657870656374656420616E206F62';
wwv_flow_imp.g_varchar2_table(4301) := '6A65637420277B2075726C2C206D6574686F642C206669656C64732C2068656164657273207D272062757420676F742027247B4A534F4E2E737472696E676966792865297D2720696E73746561642E0A5365652068747470733A2F2F757070792E696F2F';
wwv_flow_imp.g_varchar2_table(4302) := '646F63732F6177732D73332F2367657455706C6F6164506172616D65746572732D66696C6520666F72206D6F7265206F6E2074686520657870656374656420666F726D61742E60293B6966282128652E6D6574686F643D3D6E756C6C7C7C2F5E7028757C';
wwv_flow_imp.g_varchar2_table(4303) := '6F732974242F692E7465737428652E6D6574686F642929297468726F77206E657720547970654572726F72286041777353333A20676F7420696E636F7272656374206D6574686F642066726F6D202767657455706C6F6164506172616D65746572732829';
wwv_flow_imp.g_varchar2_table(4304) := '2720666F722066696C652027247B692E6E616D657D272C20657870656374656420202750555427206F722027504F5354272062757420676F742027247B652E6D6574686F647D2720696E73746561642E0A5365652068747470733A2F2F757070792E696F';
wwv_flow_imp.g_varchar2_table(4305) := '2F646F63732F6177732D73332F2367657455706C6F6164506172616D65746572732D66696C6520666F72206D6F7265206F6E2074686520657870656374656420666F726D61742E60297D6E28535F2C2276616C6964617465506172616D65746572732229';
wwv_flow_imp.g_varchar2_table(4306) := '3B66756E6374696F6E20505F28692C65297B696628217A6328692C65292972657475726E3B6C657420743D576128692C224D65737361676522293B72657475726E206E6577204572726F722874297D6E28505F2C2264656661756C74476574526573706F';
wwv_flow_imp.g_varchar2_table(4307) := '6E73654572726F7222293B7661722054763D21312C6E693D586F2822636C69656E7422292C55693D586F2822726571756573747322292C6F6F3D586F282275706C6F6164657222292C71613D586F282268616E646C6555706C6F616422292C56613D586F';
wwv_flow_imp.g_varchar2_table(4308) := '2822736574436F6D70616E696F6E4865616465727322292C6A633D586F2822676574436F6D70616E696F6E436C69656E744172677322293B41763D53796D626F6C2E666F7228227570707920746573743A20676574436C69656E7422293B766172206E6F';
wwv_flow_imp.g_varchar2_table(4309) := '3D636C61737320657874656E64732076657B636F6E7374727563746F7228652C74297B696628743F2E73686F756C645573654D756C746970617274213D6E756C6C2972657475726E206E657720526928652C74293B737570657228652C74292C4F626A65';
wwv_flow_imp.g_varchar2_table(4310) := '63742E646566696E6550726F706572747928746869732C6E692C7B7772697461626C653A21302C76616C75653A766F696420307D292C4F626A6563742E646566696E6550726F706572747928746869732C55692C7B7772697461626C653A21302C76616C';
wwv_flow_imp.g_varchar2_table(4311) := '75653A766F696420307D292C4F626A6563742E646566696E6550726F706572747928746869732C6F6F2C7B7772697461626C653A21302C76616C75653A766F696420307D292C4F626A6563742E646566696E6550726F706572747928746869732C71612C';
wwv_flow_imp.g_varchar2_table(4312) := '7B7772697461626C653A21302C76616C75653A6173796E6320733D3E7B6C6574206F3D4F626A6563742E637265617465286E756C6C293B66756E6374696F6E20612879297B76617220623B6C65747B69643A537D3D793B28623D6F5B535D293D3D6E756C';
wwv_flow_imp.g_varchar2_table(4313) := '6C7C7C622E61626F727428297D6E28612C226F6E72656D6F766522292C746869732E757070792E6F6E282266696C652D72656D6F766564222C61293B6C6574206C3D746869732E757070792E67657446696C657342794964732873292C683D7573286C29';
wwv_flow_imp.g_varchar2_table(4314) := '2C633D68732868293B746869732E757070792E656D6974282275706C6F61642D7374617274222C63293B6C657420643D737428746869732C5569295B55695D2E7772617050726F6D69736546756E6374696F6E28793D3E746869732E6F7074732E676574';
wwv_flow_imp.g_varchar2_table(4315) := '55706C6F6164506172616D6574657273287929292C663D732E6C656E6774683B72657475726E2050726F6D6973652E616C6C536574746C656428732E6D61702828792C62293D3E286F5B795D3D6428746869732E757070792E67657446696C6528792929';
wwv_flow_imp.g_varchar2_table(4316) := '2C6F5B795D2E7468656E28533D3E7B64656C657465206F5B795D3B6C657420453D746869732E757070792E67657446696C652879293B535F28452C53293B6C65747B6D6574686F643A463D22504F5354222C75726C3A782C6669656C64733A552C686561';
wwv_flow_imp.g_varchar2_table(4317) := '646572733A6A7D3D532C473D7B6D6574686F643A462C666F726D446174613A462E746F55707065724361736528293D3D3D22504F5354222C656E64706F696E743A782C616C6C6F7765644D6574614669656C64733A553F4F626A6563742E6B6579732855';
wwv_flow_imp.g_varchar2_table(4318) := '293A5B5D7D3B72657475726E206A262628472E686561646572733D6A292C746869732E757070792E73657446696C65537461746528452E69642C7B6D6574613A7B2E2E2E452E6D6574612C2E2E2E557D2C78687255706C6F61643A477D292C746869732E';
wwv_flow_imp.g_varchar2_table(4319) := '75706C6F616446696C6528452E69642C622C66297D292E636174636828533D3E7B64656C657465206F5B795D3B6C657420453D746869732E757070792E67657446696C652879293B72657475726E20746869732E757070792E656D6974282275706C6F61';
wwv_flow_imp.g_varchar2_table(4320) := '642D6572726F72222C452C53292C50726F6D6973652E72656A6563742853297D292929292E66696E616C6C792828293D3E7B746869732E757070792E6F6666282266696C652D72656D6F766564222C61297D297D7D292C4F626A6563742E646566696E65';
wwv_flow_imp.g_varchar2_table(4321) := '50726F706572747928746869732C56612C7B7772697461626C653A21302C76616C75653A28293D3E28737428746869732C6E69295B6E695D2E736574436F6D70616E696F6E4865616465727328746869732E6F7074732E636F6D70616E696F6E48656164';
wwv_flow_imp.g_varchar2_table(4322) := '657273292C50726F6D6973652E7265736F6C76652829297D292C4F626A6563742E646566696E6550726F706572747928746869732C6A632C7B7772697461626C653A21302C76616C75653A733D3E7B6C6574206F3D737428746869732C6F6F295B6F6F5D';
wwv_flow_imp.g_varchar2_table(4323) := '2E6765744F7074696F6E732873292C613D41727261792E69734172726179286F2E616C6C6F7765644D6574614669656C6473293F6F2E616C6C6F7765644D6574614669656C64733A4F626A6563742E6B65797328732E6D657461293B72657475726E7B2E';
wwv_flow_imp.g_varchar2_table(4324) := '2E2E732E72656D6F74652E626F64792C70726F746F636F6C3A226D756C746970617274222C656E64706F696E743A6F2E656E64706F696E742C73697A653A732E646174612E73697A652C6669656C646E616D653A6F2E6669656C644E616D652C6D657461';
wwv_flow_imp.g_varchar2_table(4325) := '646174613A4F626A6563742E66726F6D456E747269657328612E6D6170286C3D3E5B6C2C732E6D6574615B6C5D5D29292C687474704D6574686F643A6F2E6D6574686F642C757365466F726D446174613A6F2E666F726D446174612C686561646572733A';
wwv_flow_imp.g_varchar2_table(4326) := '747970656F66206F2E686561646572733D3D2266756E6374696F6E223F6F2E686561646572732873293A6F2E686561646572737D7D7D292C746869732E747970653D2275706C6F61646572222C746869732E69643D746869732E6F7074732E69647C7C22';
wwv_flow_imp.g_varchar2_table(4327) := '4177735333222C746869732E7469746C653D22415753205333222C746869732E64656661756C744C6F63616C653D4F763B6C657420723D7B74696D656F75743A33302A3165332C6C696D69743A302C616C6C6F7765644D6574614669656C64733A5B5D2C';
wwv_flow_imp.g_varchar2_table(4328) := '67657455706C6F6164506172616D65746572733A746869732E67657455706C6F6164506172616D65746572732E62696E642874686973292C73686F756C645573654D756C7469706172743A21312C636F6D70616E696F6E486561646572733A7B7D7D3B69';
wwv_flow_imp.g_varchar2_table(4329) := '6628746869732E6F7074733D7B2E2E2E722C2E2E2E747D2C743F2E616C6C6F7765644D6574614669656C64733D3D3D766F696420302626226D6574614669656C647322696E20746869732E6F707473297468726F77206E6577204572726F722822546865';
wwv_flow_imp.g_varchar2_table(4330) := '20606D6574614669656C647360206F7074696F6E20686173206265656E2072656E616D656420746F2060616C6C6F7765644D6574614669656C6473602E22293B746869732E6931386E496E697428292C737428746869732C6E69295B6E695D3D6E657720';
wwv_flow_imp.g_varchar2_table(4331) := '687428652C74292C737428746869732C5569295B55695D3D6E6577204E7428746869732E6F7074732E6C696D6974297D5B41765D28297B72657475726E20737428746869732C6E69295B6E695D7D67657420636C69656E7428297B72657475726E207374';
wwv_flow_imp.g_varchar2_table(4332) := '28746869732C6E69295B6E695D7D73657420636C69656E742865297B737428746869732C6E69295B6E695D3D657D67657455706C6F6164506172616D65746572732865297B69662821746869732E6F7074732E636F6D70616E696F6E55726C297468726F';
wwv_flow_imp.g_varchar2_table(4333) := '77206E6577204572726F722822457870656374656420612060636F6D70616E696F6E55726C60206F7074696F6E20636F6E7461696E696E67206120436F6D70616E696F6E20616464726573732E22293B6C657420743D652E6D6574612E6E616D652C7B74';
wwv_flow_imp.g_varchar2_table(4334) := '7970653A727D3D652E6D6574612C733D4F626A6563742E66726F6D456E747269657328746869732E6F7074732E616C6C6F7765644D6574614669656C64732E66696C74657228613D3E652E6D6574615B615D213D6E756C6C292E6D617028613D3E5B606D';
wwv_flow_imp.g_varchar2_table(4335) := '657461646174615B247B617D5D602C652E6D6574615B615D2E746F537472696E6728295D29292C6F3D6E65772055524C536561726368506172616D73287B66696C656E616D653A742C747970653A722C2E2E2E737D293B72657475726E20737428746869';
wwv_flow_imp.g_varchar2_table(4336) := '732C6E69295B6E695D2E676574286073332F706172616D733F247B6F7D60292E7468656E28775F297D75706C6F616446696C6528652C742C72297B6C657420733D746869732E757070792E67657446696C652865293B696628746869732E757070792E6C';
wwv_flow_imp.g_varchar2_table(4337) := '6F67286075706C6F6164696E6720247B747D206F6620247B727D60292C732E6572726F72297468726F77206E6577204572726F7228732E6572726F72293B696628732E697352656D6F7465297B6C6574206F3D6E2828293D3E737428746869732C556929';
wwv_flow_imp.g_varchar2_table(4338) := '5B55695D2C22676574517565756522292C613D6E65772041626F7274436F6E74726F6C6C65722C6C3D6E28633D3E7B632E69643D3D3D732E69642626612E61626F727428297D2C2272656D6F76656448616E646C657222293B746869732E757070792E6F';
wwv_flow_imp.g_varchar2_table(4339) := '6E282266696C652D72656D6F766564222C6C293B6C657420683D746869732E757070792E67657452657175657374436C69656E74466F7246696C652873292E75706C6F616452656D6F746546696C6528732C737428746869732C6A63295B6A635D287329';
wwv_flow_imp.g_varchar2_table(4340) := '2C7B7369676E616C3A612E7369676E616C2C67657451756575653A6F7D293B72657475726E20737428746869732C5569295B55695D2E7772617053796E6346756E6374696F6E2828293D3E7B746869732E757070792E6F6666282266696C652D72656D6F';
wwv_flow_imp.g_varchar2_table(4341) := '766564222C6C297D2C7B7072696F726974793A2D317D2928292C687D72657475726E20737428746869732C6F6F295B6F6F5D2E75706C6F61644C6F63616C46696C6528732C742C72297D696E7374616C6C28297B6C65747B757070793A657D3D74686973';
wwv_flow_imp.g_varchar2_table(4342) := '3B652E61646450726550726F636573736F7228737428746869732C5661295B56615D292C652E61646455706C6F6164657228737428746869732C7161295B71615D293B66756E6374696F6E207428732C6F297B6C657420613D746869733B72657475726E';
wwv_flow_imp.g_varchar2_table(4343) := '207A6328732C6F293F7B6C6F636174696F6E3A625F286F2E726573706F6E736555524C2C576128732C224C6F636174696F6E2229292C6275636B65743A576128732C224275636B657422292C6B65793A576128732C224B657922292C657461673A576128';
wwv_flow_imp.g_varchar2_table(4344) := '732C224554616722297D3A612E6D6574686F642E746F55707065724361736528293D3D3D22504F5354223F2854767C7C28652E6C6F6728225B41777353335D204E6F20726573706F6E7365206461746120666F756E642C206D616B65207375726520746F';
wwv_flow_imp.g_varchar2_table(4345) := '207365742074686520737563636573735F616374696F6E5F737461747573204157532053444B206F7074696F6E20746F203230312E205365652068747470733A2F2F757070792E696F2F646F63732F6177732D73332F23504F53542D55706C6F61647322';
wwv_flow_imp.g_varchar2_table(4346) := '2C227761726E696E6722292C54763D2130292C7B6C6F636174696F6E3A6E756C6C7D293A6F2E726573706F6E736555524C3F7B6C6F636174696F6E3A6F2E726573706F6E736555524C2E7265706C616365282F5C3F2E2A242F2C2222297D3A7B6C6F6361';
wwv_flow_imp.g_varchar2_table(4347) := '74696F6E3A6E756C6C7D7D6E28742C2264656661756C74476574526573706F6E73654461746122293B6C657420723D7B6669656C644E616D653A2266696C65222C726573706F6E736555726C4669656C644E616D653A226C6F636174696F6E222C74696D';
wwv_flow_imp.g_varchar2_table(4348) := '656F75743A746869732E6F7074732E74696D656F75742C5B6C735D3A737428746869732C5569295B55695D2C726573706F6E7365547970653A2274657874222C676574526573706F6E7365446174613A746869732E6F7074732E676574526573706F6E73';
wwv_flow_imp.g_varchar2_table(4349) := '65446174617C7C742C676574526573706F6E73654572726F723A505F7D3B722E6931386E3D746869732E6931386E2C737428746869732C6F6F295B6F6F5D3D6E6577204B6F28652C72297D756E696E7374616C6C28297B746869732E757070792E72656D';
wwv_flow_imp.g_varchar2_table(4350) := '6F766550726550726F636573736F7228737428746869732C5661295B56615D292C746869732E757070792E72656D6F766555706C6F6164657228737428746869732C7161295B71615D297D7D3B6E286E6F2C22417773533322293B6E6F2E56455253494F';
wwv_flow_imp.g_varchar2_table(4351) := '4E3D765F2E76657273696F6E3B766172204D763D22332E372E32222C5F5F3D4D762C465F3D747970656F662061746F623D3D2266756E6374696F6E222C785F3D747970656F662062746F613D3D2266756E6374696F6E222C516F3D747970656F66204275';
wwv_flow_imp.g_varchar2_table(4352) := '666665723D3D2266756E6374696F6E222C52763D747970656F6620546578744465636F6465723D3D2266756E6374696F6E223F6E657720546578744465636F6465723A766F696420302C55763D747970656F662054657874456E636F6465723D3D226675';
wwv_flow_imp.g_varchar2_table(4353) := '6E6374696F6E223F6E65772054657874456E636F6465723A766F696420302C455F3D224142434445464748494A4B4C4D4E4F505152535455565758595A6162636465666768696A6B6C6D6E6F707172737475767778797A303132333435363738392B2F3D';
wwv_flow_imp.g_varchar2_table(4354) := '222C47613D41727261792E70726F746F747970652E736C6963652E63616C6C28455F292C58753D28693D3E7B6C657420653D7B7D3B72657475726E20692E666F72456163682828742C72293D3E655B745D3D72292C657D29284761292C435F3D2F5E283F';
wwv_flow_imp.g_varchar2_table(4355) := '3A5B412D5A612D7A5C642B5C2F5D7B347D292A3F283F3A5B412D5A612D7A5C642B5C2F5D7B327D283F3A3D3D293F7C5B412D5A612D7A5C642B5C2F5D7B337D3D3F293F242F2C76743D537472696E672E66726F6D43686172436F64652E62696E64285374';
wwv_flow_imp.g_varchar2_table(4356) := '72696E67292C6B763D747970656F662055696E743841727261792E66726F6D3D3D2266756E6374696F6E223F55696E743841727261792E66726F6D2E62696E642855696E74384172726179293A28692C653D743D3E74293D3E6E65772055696E74384172';
wwv_flow_imp.g_varchar2_table(4357) := '7261792841727261792E70726F746F747970652E736C6963652E63616C6C28692C30292E6D6170286529292C4E763D6E28693D3E692E7265706C616365282F3D2F672C2222292E7265706C616365282F5B2B5C2F5D2F672C653D3E653D3D222B223F222D';
wwv_flow_imp.g_varchar2_table(4358) := '223A225F22292C225F6D6B5572695361666522292C4C763D6E28693D3E692E7265706C616365282F5B5E412D5A612D7A302D395C2B5C2F5D2F672C2222292C225F7469647942363422292C42763D6E28693D3E7B6C657420652C742C722C732C6F3D2222';
wwv_flow_imp.g_varchar2_table(4359) := '2C613D692E6C656E67746825333B666F72286C6574206C3D303B6C3C692E6C656E6774683B297B69662828743D692E63686172436F64654174286C2B2B29293E3235357C7C28723D692E63686172436F64654174286C2B2B29293E3235357C7C28733D69';
wwv_flow_imp.g_varchar2_table(4360) := '2E63686172436F64654174286C2B2B29293E323535297468726F77206E657720547970654572726F722822696E76616C69642063686172616374657220666F756E6422293B653D743C3C31367C723C3C387C732C6F2B3D47615B653E3E31382636335D2B';
wwv_flow_imp.g_varchar2_table(4361) := '47615B653E3E31322636335D2B47615B653E3E362636335D2B47615B652636335D7D72657475726E20613F6F2E736C69636528302C612D33292B223D3D3D222E737562737472696E672861293A6F7D2C2262746F61506F6C7966696C6C22292C71633D78';
wwv_flow_imp.g_varchar2_table(4362) := '5F3F693D3E62746F612869293A516F3F693D3E4275666665722E66726F6D28692C2262696E61727922292E746F537472696E67282262617365363422293A42762C48633D516F3F693D3E4275666665722E66726F6D2869292E746F537472696E67282262';
wwv_flow_imp.g_varchar2_table(4363) := '617365363422293A693D3E7B6C657420743D5B5D3B666F72286C657420723D302C733D692E6C656E6774683B723C733B722B3D3430393629742E707573682876742E6170706C79286E756C6C2C692E737562617272617928722C722B343039362929293B';
wwv_flow_imp.g_varchar2_table(4364) := '72657475726E20716328742E6A6F696E28222229297D2C59753D6E2828692C653D2131293D3E653F4E76284863286929293A48632869292C2266726F6D55696E7438417272617922292C4F5F3D6E28693D3E7B696628692E6C656E6774683C32297B7661';
wwv_flow_imp.g_varchar2_table(4365) := '7220653D692E63686172436F646541742830293B72657475726E20653C3132383F693A653C323034383F7674283139327C653E3E3E36292B7674283132387C65263633293A7674283232347C653E3E3E3132263135292B7674283132387C653E3E3E3626';
wwv_flow_imp.g_varchar2_table(4366) := '3633292B7674283132387C65263633297D656C73657B76617220653D36353533362B28692E63686172436F646541742830292D3535323936292A313032342B28692E63686172436F646541742831292D3536333230293B72657475726E20767428323430';
wwv_flow_imp.g_varchar2_table(4367) := '7C653E3E3E31382637292B7674283132387C653E3E3E3132263633292B7674283132387C653E3E3E36263633292B7674283132387C65263633297D7D2C2263625F75746F6222292C545F3D2F5B5C75443830302D5C75444246465D5B5C75444330302D5C';
wwv_flow_imp.g_varchar2_table(4368) := '7544464646465D7C5B5E5C7830302D5C7837465D2F672C7A763D6E28693D3E692E7265706C61636528545F2C4F5F292C2275746F6222292C44763D516F3F693D3E4275666665722E66726F6D28692C227574663822292E746F537472696E672822626173';
wwv_flow_imp.g_varchar2_table(4369) := '65363422293A55763F693D3E48632855762E656E636F6465286929293A693D3E7163287A76286929292C596F3D6E2828692C653D2131293D3E653F4E76284476286929293A44762869292C22656E636F646522292C49763D6E28693D3E596F28692C2130';
wwv_flow_imp.g_varchar2_table(4370) := '292C22656E636F646555524922292C415F3D2F5B5C7843302D5C7844465D5B5C7838302D5C7842465D7C5B5C7845302D5C7845465D5B5C7838302D5C7842465D7B327D7C5B5C7846302D5C7846375D5B5C7838302D5C7842465D7B337D2F672C525F3D6E';
wwv_flow_imp.g_varchar2_table(4371) := '28693D3E7B73776974636828692E6C656E677468297B6361736520343A76617220653D283726692E63686172436F64654174283029293C3C31387C28363326692E63686172436F64654174283129293C3C31327C28363326692E63686172436F64654174';
wwv_flow_imp.g_varchar2_table(4372) := '283229293C3C367C363326692E63686172436F646541742833292C743D652D36353533363B72657475726E2076742828743E3E3E3130292B3535323936292B76742828742631303233292B3536333230293B6361736520333A72657475726E2076742828';
wwv_flow_imp.g_varchar2_table(4373) := '313526692E63686172436F64654174283029293C3C31327C28363326692E63686172436F64654174283129293C3C367C363326692E63686172436F64654174283229293B64656661756C743A72657475726E2076742828333126692E63686172436F6465';
wwv_flow_imp.g_varchar2_table(4374) := '4174283029293C3C367C363326692E63686172436F64654174283129297D7D2C2263625F62746F7522292C6A763D6E28693D3E692E7265706C61636528415F2C525F292C2262746F7522292C48763D6E28693D3E7B696628693D692E7265706C61636528';
wwv_flow_imp.g_varchar2_table(4375) := '2F5C732B2F672C2222292C21435F2E74657374286929297468726F77206E657720547970654572726F7228226D616C666F726D6564206261736536342E22293B692B3D223D3D222E736C69636528322D28692E6C656E677468263329293B6C657420652C';
wwv_flow_imp.g_varchar2_table(4376) := '743D22222C722C733B666F72286C6574206F3D303B6F3C692E6C656E6774683B29653D58755B692E636861724174286F2B2B295D3C3C31387C58755B692E636861724174286F2B2B295D3C3C31327C28723D58755B692E636861724174286F2B2B295D29';
wwv_flow_imp.g_varchar2_table(4377) := '3C3C367C28733D58755B692E636861724174286F2B2B295D292C742B3D723D3D3D36343F767428653E3E313626323535293A733D3D3D36343F767428653E3E3136263235352C653E3E3826323535293A767428653E3E3136263235352C653E3E38263235';
wwv_flow_imp.g_varchar2_table(4378) := '352C6526323535293B72657475726E20747D2C2261746F62506F6C7966696C6C22292C56633D465F3F693D3E61746F62284C76286929293A516F3F693D3E4275666665722E66726F6D28692C2262617365363422292E746F537472696E67282262696E61';
wwv_flow_imp.g_varchar2_table(4379) := '727922293A48762C24763D516F3F693D3E6B76284275666665722E66726F6D28692C226261736536342229293A693D3E6B762856632869292C653D3E652E63686172436F64654174283029292C71763D6E28693D3E2476285676286929292C22746F5569';
wwv_flow_imp.g_varchar2_table(4380) := '6E7438417272617922292C555F3D516F3F693D3E4275666665722E66726F6D28692C2262617365363422292E746F537472696E6728227574663822293A52763F693D3E52762E6465636F6465282476286929293A693D3E6A76285663286929292C56763D';
wwv_flow_imp.g_varchar2_table(4381) := '6E28693D3E4C7628692E7265706C616365282F5B2D5F5D2F672C653D3E653D3D222D223F222B223A222F2229292C225F756E55524922292C24633D6E28693D3E555F285676286929292C226465636F646522292C6B5F3D6E28693D3E7B69662874797065';
wwv_flow_imp.g_varchar2_table(4382) := '6F662069213D22737472696E67222972657475726E21313B6C657420653D692E7265706C616365282F5C732B2F672C2222292E7265706C616365282F3D7B302C327D242F2C2222293B72657475726E212F5B5E5C73302D39612D7A412D5A5C2B2F5D2F2E';
wwv_flow_imp.g_varchar2_table(4383) := '746573742865297C7C212F5B5E5C73302D39612D7A412D5A5C2D5F5D2F2E746573742865297D2C22697356616C696422292C57763D6E28693D3E287B76616C75653A692C656E756D657261626C653A21312C7772697461626C653A21302C636F6E666967';
wwv_flow_imp.g_varchar2_table(4384) := '757261626C653A21307D292C225F6E6F456E756D22292C47763D6E2866756E6374696F6E28297B6C657420693D6E2828652C74293D3E4F626A6563742E646566696E6550726F706572747928537472696E672E70726F746F747970652C652C5776287429';
wwv_flow_imp.g_varchar2_table(4385) := '292C225F61646422293B69282266726F6D426173653634222C66756E6374696F6E28297B72657475726E2024632874686973297D292C692822746F426173653634222C66756E6374696F6E2865297B72657475726E20596F28746869732C65297D292C69';
wwv_flow_imp.g_varchar2_table(4386) := '2822746F426173653634555249222C66756E6374696F6E28297B72657475726E20596F28746869732C2130297D292C692822746F42617365363455524C222C66756E6374696F6E28297B72657475726E20596F28746869732C2130297D292C692822746F';
wwv_flow_imp.g_varchar2_table(4387) := '55696E74384172726179222C66756E6374696F6E28297B72657475726E2071762874686973297D297D2C22657874656E64537472696E6722292C4B763D6E2866756E6374696F6E28297B6C657420693D6E2828652C74293D3E4F626A6563742E64656669';
wwv_flow_imp.g_varchar2_table(4388) := '6E6550726F70657274792855696E743841727261792E70726F746F747970652C652C5776287429292C225F61646422293B692822746F426173653634222C66756E6374696F6E2865297B72657475726E20597528746869732C65297D292C692822746F42';
wwv_flow_imp.g_varchar2_table(4389) := '6173653634555249222C66756E6374696F6E28297B72657475726E20597528746869732C2130297D292C692822746F42617365363455524C222C66756E6374696F6E28297B72657475726E20597528746869732C2130297D297D2C22657874656E645569';
wwv_flow_imp.g_varchar2_table(4390) := '6E7438417272617922292C445F3D6E2828293D3E7B477628292C4B7628297D2C22657874656E644275696C74696E7322292C58763D7B76657273696F6E3A4D762C56455253494F4E3A5F5F2C61746F623A56632C61746F62506F6C7966696C6C3A48762C';
wwv_flow_imp.g_varchar2_table(4391) := '62746F613A71632C62746F61506F6C7966696C6C3A42762C66726F6D4261736536343A24632C746F4261736536343A596F2C656E636F64653A596F2C656E636F64655552493A49762C656E636F646555524C3A49762C75746F623A7A762C62746F753A6A';
wwv_flow_imp.g_varchar2_table(4392) := '762C6465636F64653A24632C697356616C69643A6B5F2C66726F6D55696E743841727261793A59752C746F55696E743841727261793A71762C657874656E64537472696E673A47762C657874656E6455696E743841727261793A4B762C657874656E6442';
wwv_flow_imp.g_varchar2_table(4393) := '75696C74696E733A445F7D3B7661722077303D6465286C302829293B66756E6374696F6E2058632869297B2240626162656C2F68656C70657273202D20747970656F66223B72657475726E2058633D747970656F662053796D626F6C3D3D2266756E6374';
wwv_flow_imp.g_varchar2_table(4394) := '696F6E222626747970656F662053796D626F6C2E6974657261746F723D3D2273796D626F6C223F66756E6374696F6E2865297B72657475726E20747970656F6620657D3A66756E6374696F6E2865297B72657475726E20652626747970656F662053796D';
wwv_flow_imp.g_varchar2_table(4395) := '626F6C3D3D2266756E6374696F6E222626652E636F6E7374727563746F723D3D3D53796D626F6C262665213D3D53796D626F6C2E70726F746F747970653F2273796D626F6C223A747970656F6620657D2C58632869297D6E2858632C225F747970656F66';
wwv_flow_imp.g_varchar2_table(4396) := '22293B66756E6374696F6E20753028692C65297B666F722876617220743D303B743C652E6C656E6774683B742B2B297B76617220723D655B745D3B722E656E756D657261626C653D722E656E756D657261626C657C7C21312C722E636F6E666967757261';
wwv_flow_imp.g_varchar2_table(4397) := '626C653D21302C2276616C756522696E2072262628722E7772697461626C653D2130292C4F626A6563742E646566696E6550726F706572747928692C722E6B65792C72297D7D6E2875302C225F646566696E6550726F7065727469657322293B66756E63';
wwv_flow_imp.g_varchar2_table(4398) := '74696F6E20575F28692C652C74297B72657475726E20652626753028692E70726F746F747970652C65292C742626753028692C74292C4F626A6563742E646566696E6550726F706572747928692C2270726F746F74797065222C7B7772697461626C653A';
wwv_flow_imp.g_varchar2_table(4399) := '21317D292C697D6E28575F2C225F637265617465436C61737322293B66756E6374696F6E20475F28692C65297B69662821286920696E7374616E63656F66206529297468726F77206E657720547970654572726F72282243616E6E6F742063616C6C2061';
wwv_flow_imp.g_varchar2_table(4400) := '20636C61737320617320612066756E6374696F6E22297D6E28475F2C225F636C61737343616C6C436865636B22293B66756E6374696F6E204B5F28692C65297B696628747970656F662065213D2266756E6374696F6E22262665213D3D6E756C6C297468';
wwv_flow_imp.g_varchar2_table(4401) := '726F77206E657720547970654572726F72282253757065722065787072657373696F6E206D75737420656974686572206265206E756C6C206F7220612066756E6374696F6E22293B692E70726F746F747970653D4F626A6563742E637265617465286526';
wwv_flow_imp.g_varchar2_table(4402) := '26652E70726F746F747970652C7B636F6E7374727563746F723A7B76616C75653A692C7772697461626C653A21302C636F6E666967757261626C653A21307D7D292C4F626A6563742E646566696E6550726F706572747928692C2270726F746F74797065';
wwv_flow_imp.g_varchar2_table(4403) := '222C7B7772697461626C653A21317D292C6526264B6128692C65297D6E284B5F2C225F696E68657269747322293B66756E6374696F6E20585F2869297B76617220653D683028293B72657475726E206E2866756E6374696F6E28297B76617220723D5861';
wwv_flow_imp.g_varchar2_table(4404) := '2869292C733B69662865297B766172206F3D58612874686973292E636F6E7374727563746F723B733D5265666C6563742E636F6E73747275637428722C617267756D656E74732C6F297D656C736520733D722E6170706C7928746869732C617267756D65';
wwv_flow_imp.g_varchar2_table(4405) := '6E7473293B72657475726E20595F28746869732C73297D2C225F6372656174655375706572496E7465726E616C22297D6E28585F2C225F637265617465537570657222293B66756E6374696F6E20595F28692C65297B6966286526262858632865293D3D';
wwv_flow_imp.g_varchar2_table(4406) := '3D226F626A656374227C7C747970656F6620653D3D2266756E6374696F6E22292972657475726E20653B69662865213D3D766F69642030297468726F77206E657720547970654572726F7228224465726976656420636F6E7374727563746F7273206D61';
wwv_flow_imp.g_varchar2_table(4407) := '79206F6E6C792072657475726E206F626A656374206F7220756E646566696E656422293B72657475726E20515F2869297D6E28595F2C225F706F737369626C65436F6E7374727563746F7252657475726E22293B66756E6374696F6E20515F2869297B69';
wwv_flow_imp.g_varchar2_table(4408) := '6628693D3D3D766F69642030297468726F77206E6577205265666572656E63654572726F72282274686973206861736E2774206265656E20696E697469616C69736564202D2073757065722829206861736E2774206265656E2063616C6C656422293B72';
wwv_flow_imp.g_varchar2_table(4409) := '657475726E20697D6E28515F2C225F61737365727454686973496E697469616C697A656422293B66756E6374696F6E2059632869297B76617220653D747970656F66204D61703D3D2266756E6374696F6E223F6E6577204D61703A766F696420303B7265';
wwv_flow_imp.g_varchar2_table(4410) := '7475726E2059633D6E2866756E6374696F6E2872297B696628723D3D3D6E756C6C7C7C214A5F2872292972657475726E20723B696628747970656F662072213D2266756E6374696F6E22297468726F77206E657720547970654572726F72282253757065';
wwv_flow_imp.g_varchar2_table(4411) := '722065787072657373696F6E206D75737420656974686572206265206E756C6C206F7220612066756E6374696F6E22293B696628747970656F6620653C227522297B696628652E6861732872292972657475726E20652E6765742872293B652E73657428';
wwv_flow_imp.g_varchar2_table(4412) := '722C73297D66756E6374696F6E207328297B72657475726E204A7528722C617267756D656E74732C58612874686973292E636F6E7374727563746F72297D72657475726E206E28732C225772617070657222292C732E70726F746F747970653D4F626A65';
wwv_flow_imp.g_varchar2_table(4413) := '63742E63726561746528722E70726F746F747970652C7B636F6E7374727563746F723A7B76616C75653A732C656E756D657261626C653A21312C7772697461626C653A21302C636F6E666967757261626C653A21307D7D292C4B6128732C72297D2C225F';
wwv_flow_imp.g_varchar2_table(4414) := '777261704E6174697665537570657222292C59632869297D6E2859632C225F777261704E6174697665537570657222293B66756E6374696F6E204A7528692C652C74297B72657475726E20683028293F4A753D5265666C6563742E636F6E737472756374';
wwv_flow_imp.g_varchar2_table(4415) := '2E62696E6428293A4A753D6E2866756E6374696F6E28732C6F2C61297B766172206C3D5B6E756C6C5D3B6C2E707573682E6170706C79286C2C6F293B76617220683D46756E6374696F6E2E62696E642E6170706C7928732C6C292C633D6E657720683B72';
wwv_flow_imp.g_varchar2_table(4416) := '657475726E206126264B6128632C612E70726F746F74797065292C637D2C225F636F6E73747275637422292C4A752E6170706C79286E756C6C2C617267756D656E7473297D6E284A752C225F636F6E73747275637422293B66756E6374696F6E20683028';
wwv_flow_imp.g_varchar2_table(4417) := '297B696628747970656F66205265666C6563743E2275227C7C215265666C6563742E636F6E7374727563747C7C5265666C6563742E636F6E7374727563742E7368616D2972657475726E21313B696628747970656F662050726F78793D3D2266756E6374';
wwv_flow_imp.g_varchar2_table(4418) := '696F6E222972657475726E21303B7472797B72657475726E20426F6F6C65616E2E70726F746F747970652E76616C75654F662E63616C6C285265666C6563742E636F6E73747275637428426F6F6C65616E2C5B5D2C66756E6374696F6E28297B7D29292C';
wwv_flow_imp.g_varchar2_table(4419) := '21307D63617463687B72657475726E21317D7D6E2868302C225F69734E61746976655265666C656374436F6E73747275637422293B66756E6374696F6E204A5F2869297B72657475726E2046756E6374696F6E2E746F537472696E672E63616C6C286929';
wwv_flow_imp.g_varchar2_table(4420) := '2E696E6465784F6628225B6E617469766520636F64655D2229213D3D2D317D6E284A5F2C225F69734E617469766546756E6374696F6E22293B66756E6374696F6E204B6128692C65297B72657475726E204B613D4F626A6563742E73657450726F746F74';
wwv_flow_imp.g_varchar2_table(4421) := '7970654F663F4F626A6563742E73657450726F746F747970654F662E62696E6428293A6E2866756E6374696F6E28722C73297B72657475726E20722E5F5F70726F746F5F5F3D732C727D2C225F73657450726F746F747970654F6622292C4B6128692C65';
wwv_flow_imp.g_varchar2_table(4422) := '297D6E284B612C225F73657450726F746F747970654F6622293B66756E6374696F6E2058612869297B72657475726E2058613D4F626A6563742E73657450726F746F747970654F663F4F626A6563742E67657450726F746F747970654F662E62696E6428';
wwv_flow_imp.g_varchar2_table(4423) := '293A6E2866756E6374696F6E2874297B72657475726E20742E5F5F70726F746F5F5F7C7C4F626A6563742E67657450726F746F747970654F662874297D2C225F67657450726F746F747970654F6622292C58612869297D6E2858612C225F67657450726F';
wwv_flow_imp.g_varchar2_table(4424) := '746F747970654F6622293B766172205A5F3D66756E6374696F6E2869297B4B5F28742C69293B76617220653D585F2874293B66756E6374696F6E20742872297B76617220732C6F3D617267756D656E74732E6C656E6774683E312626617267756D656E74';
wwv_flow_imp.g_varchar2_table(4425) := '735B315D213D3D766F696420303F617267756D656E74735B315D3A6E756C6C2C613D617267756D656E74732E6C656E6774683E322626617267756D656E74735B325D213D3D766F696420303F617267756D656E74735B325D3A6E756C6C2C6C3D61726775';
wwv_flow_imp.g_varchar2_table(4426) := '6D656E74732E6C656E6774683E332626617267756D656E74735B335D213D3D766F696420303F617267756D656E74735B335D3A6E756C6C3B696628475F28746869732C74292C733D652E63616C6C28746869732C72292C732E6F726967696E616C526571';
wwv_flow_imp.g_varchar2_table(4427) := '756573743D612C732E6F726967696E616C526573706F6E73653D6C2C732E63617573696E674572726F723D6F2C6F213D6E756C6C262628722B3D222C2063617573656420627920222E636F6E636174286F2E746F537472696E67282929292C61213D6E75';
wwv_flow_imp.g_varchar2_table(4428) := '6C6C297B76617220683D612E6765744865616465722822582D526571756573742D494422297C7C226E2F61222C633D612E6765744D6574686F6428292C643D612E67657455524C28292C663D6C3F6C2E67657453746174757328293A226E2F61222C793D';
wwv_flow_imp.g_varchar2_table(4429) := '6C3F6C2E676574426F647928297C7C22223A226E2F61223B722B3D222C206F726967696E617465642066726F6D207265717565737420286D6574686F643A20222E636F6E63617428632C222C2075726C3A2022292E636F6E63617428642C222C20726573';
wwv_flow_imp.g_varchar2_table(4430) := '706F6E736520636F64653A2022292E636F6E63617428662C222C20726573706F6E736520746578743A2022292E636F6E63617428792C222C20726571756573742069643A2022292E636F6E63617428682C222922297D72657475726E20732E6D65737361';
wwv_flow_imp.g_varchar2_table(4431) := '67653D722C737D72657475726E206E28742C2244657461696C65644572726F7222292C575F2874297D285963284572726F7229292C4A6F3D5A5F3B7661722065353D21313B66756E6374696F6E2064732869297B65352626636F6E736F6C652E6C6F6728';
wwv_flow_imp.g_varchar2_table(4432) := '69297D6E2864732C226C6F6722293B66756E6374696F6E20516328297B72657475726E2278787878787878782D787878782D347878782D797878782D787878787878787878787878222E7265706C616365282F5B78795D2F672C66756E6374696F6E2869';
wwv_flow_imp.g_varchar2_table(4433) := '297B76617220653D4D6174682E72616E646F6D28292A31367C302C743D693D3D3D2278223F653A6526337C383B72657475726E20742E746F537472696E67283136297D297D6E2851632C227575696422293B66756E6374696F6E20623028692C65297B72';
wwv_flow_imp.g_varchar2_table(4434) := '657475726E2073352869297C7C723528692C65297C7C693528692C65297C7C743528297D6E2862302C225F736C69636564546F417272617922293B66756E6374696F6E20743528297B7468726F77206E657720547970654572726F722860496E76616C69';
wwv_flow_imp.g_varchar2_table(4435) := '6420617474656D707420746F206465737472756374757265206E6F6E2D6974657261626C6520696E7374616E63652E0A496E206F7264657220746F206265206974657261626C652C206E6F6E2D6172726179206F626A65637473206D7573742068617665';
wwv_flow_imp.g_varchar2_table(4436) := '2061205B53796D626F6C2E6974657261746F725D2829206D6574686F642E60297D6E2874352C225F6E6F6E4974657261626C655265737422293B66756E6374696F6E20693528692C65297B69662869297B696628747970656F6620693D3D22737472696E';
wwv_flow_imp.g_varchar2_table(4437) := '67222972657475726E20643028692C65293B76617220743D4F626A6563742E70726F746F747970652E746F537472696E672E63616C6C2869292E736C69636528382C2D31293B696628743D3D3D224F626A656374222626692E636F6E7374727563746F72';
wwv_flow_imp.g_varchar2_table(4438) := '262628743D692E636F6E7374727563746F722E6E616D65292C743D3D3D224D6170227C7C743D3D3D22536574222972657475726E2041727261792E66726F6D2869293B696628743D3D3D22417267756D656E7473227C7C2F5E283F3A55697C49296E7428';
wwv_flow_imp.g_varchar2_table(4439) := '3F3A387C31367C333229283F3A436C616D706564293F4172726179242F2E746573742874292972657475726E20643028692C65297D7D6E2869352C225F756E737570706F727465644974657261626C65546F417272617922293B66756E6374696F6E2064';
wwv_flow_imp.g_varchar2_table(4440) := '3028692C65297B28653D3D6E756C6C7C7C653E692E6C656E67746829262628653D692E6C656E677468293B666F722876617220743D302C723D6E65772041727261792865293B743C653B742B2B29725B745D3D695B745D3B72657475726E20727D6E2864';
wwv_flow_imp.g_varchar2_table(4441) := '302C225F61727261794C696B65546F417272617922293B66756E6374696F6E20723528692C65297B76617220743D693D3D6E756C6C3F6E756C6C3A747970656F662053796D626F6C3C2275222626695B53796D626F6C2E6974657261746F725D7C7C695B';
wwv_flow_imp.g_varchar2_table(4442) := '2240406974657261746F72225D3B69662874213D6E756C6C297B76617220723D5B5D2C733D21302C6F3D21312C612C6C3B7472797B666F7228743D742E63616C6C2869293B2128733D28613D742E6E6578742829292E646F6E6529262628722E70757368';
wwv_flow_imp.g_varchar2_table(4443) := '28612E76616C7565292C2128652626722E6C656E6774683D3D3D6529293B733D2130293B7D63617463682868297B6F3D21302C6C3D687D66696E616C6C797B7472797B21732626742E72657475726E213D6E756C6C2626742E72657475726E28297D6669';
wwv_flow_imp.g_varchar2_table(4444) := '6E616C6C797B6966286F297468726F77206C7D7D72657475726E20727D7D6E2872352C225F6974657261626C65546F41727261794C696D697422293B66756E6374696F6E2073352869297B69662841727261792E69734172726179286929297265747572';
wwv_flow_imp.g_varchar2_table(4445) := '6E20697D6E2873352C225F617272617957697468486F6C657322293B66756E6374696F6E20633028692C65297B76617220743D4F626A6563742E6B6579732869293B6966284F626A6563742E6765744F776E50726F706572747953796D626F6C73297B76';
wwv_flow_imp.g_varchar2_table(4446) := '617220723D4F626A6563742E6765744F776E50726F706572747953796D626F6C732869293B65262628723D722E66696C7465722866756E6374696F6E2873297B72657475726E204F626A6563742E6765744F776E50726F70657274794465736372697074';
wwv_flow_imp.g_varchar2_table(4447) := '6F7228692C73292E656E756D657261626C657D29292C742E707573682E6170706C7928742C72297D72657475726E20747D6E2863302C226F776E4B65797322293B66756E6374696F6E205A6F2869297B666F722876617220653D313B653C617267756D65';
wwv_flow_imp.g_varchar2_table(4448) := '6E74732E6C656E6774683B652B2B297B76617220743D617267756D656E74735B655D213D6E756C6C3F617267756D656E74735B655D3A7B7D3B6525323F6330284F626A6563742874292C2130292E666F72456163682866756E6374696F6E2872297B6F35';
wwv_flow_imp.g_varchar2_table(4449) := '28692C722C745B725D297D293A4F626A6563742E6765744F776E50726F706572747944657363726970746F72733F4F626A6563742E646566696E6550726F7065727469657328692C4F626A6563742E6765744F776E50726F706572747944657363726970';
wwv_flow_imp.g_varchar2_table(4450) := '746F7273287429293A6330284F626A656374287429292E666F72456163682866756E6374696F6E2872297B4F626A6563742E646566696E6550726F706572747928692C722C4F626A6563742E6765744F776E50726F706572747944657363726970746F72';
wwv_flow_imp.g_varchar2_table(4451) := '28742C7229297D297D72657475726E20697D6E285A6F2C225F6F626A65637453707265616422293B66756E6374696F6E206F3528692C652C74297B72657475726E206520696E20693F4F626A6563742E646566696E6550726F706572747928692C652C7B';
wwv_flow_imp.g_varchar2_table(4452) := '76616C75653A742C656E756D657261626C653A21302C636F6E666967757261626C653A21302C7772697461626C653A21307D293A695B655D3D742C697D6E286F352C225F646566696E6550726F706572747922293B66756E6374696F6E206E3528692C65';
wwv_flow_imp.g_varchar2_table(4453) := '297B69662821286920696E7374616E63656F66206529297468726F77206E657720547970654572726F72282243616E6E6F742063616C6C206120636C61737320617320612066756E6374696F6E22297D6E286E352C225F636C61737343616C6C43686563';
wwv_flow_imp.g_varchar2_table(4454) := '6B22293B66756E6374696F6E20703028692C65297B666F722876617220743D303B743C652E6C656E6774683B742B2B297B76617220723D655B745D3B722E656E756D657261626C653D722E656E756D657261626C657C7C21312C722E636F6E6669677572';
wwv_flow_imp.g_varchar2_table(4455) := '61626C653D21302C2276616C756522696E2072262628722E7772697461626C653D2130292C4F626A6563742E646566696E6550726F706572747928692C722E6B65792C72297D7D6E2870302C225F646566696E6550726F7065727469657322293B66756E';
wwv_flow_imp.g_varchar2_table(4456) := '6374696F6E20613528692C652C74297B72657475726E20652626703028692E70726F746F747970652C65292C742626703028692C74292C4F626A6563742E646566696E6550726F706572747928692C2270726F746F74797065222C7B7772697461626C65';
wwv_flow_imp.g_varchar2_table(4457) := '3A21317D292C697D6E2861352C225F637265617465436C61737322293B766172206C353D7B656E64706F696E743A6E756C6C2C75706C6F616455726C3A6E756C6C2C6D657461646174613A7B7D2C66696E6765727072696E743A6E756C6C2C75706C6F61';
wwv_flow_imp.g_varchar2_table(4458) := '6453697A653A6E756C6C2C6F6E50726F67726573733A6E756C6C2C6F6E4368756E6B436F6D706C6574653A6E756C6C2C6F6E537563636573733A6E756C6C2C6F6E4572726F723A6E756C6C2C5F6F6E55706C6F616455726C417661696C61626C653A6E75';
wwv_flow_imp.g_varchar2_table(4459) := '6C6C2C6F7665727269646550617463684D6574686F643A21312C686561646572733A7B7D2C6164645265717565737449643A21312C6F6E4265666F7265526571756573743A6E756C6C2C6F6E4166746572526573706F6E73653A6E756C6C2C6F6E53686F';
wwv_flow_imp.g_varchar2_table(4460) := '756C6452657472793A6E756C6C2C6368756E6B53697A653A312F302C726574727944656C6179733A5B302C3165332C3365332C3565335D2C706172616C6C656C55706C6F6164733A312C706172616C6C656C55706C6F6164426F756E6461726965733A6E';
wwv_flow_imp.g_varchar2_table(4461) := '756C6C2C73746F726546696E6765727072696E74466F72526573756D696E673A21302C72656D6F766546696E6765727072696E744F6E537563636573733A21312C75706C6F61644C656E67746844656665727265643A21312C75706C6F61644461746144';
wwv_flow_imp.g_varchar2_table(4462) := '7572696E674372656174696F6E3A21312C75726C53746F726167653A6E756C6C2C66696C655265616465723A6E756C6C2C68747470537461636B3A6E756C6C7D2C53303D66756E6374696F6E28297B66756E6374696F6E206928652C74297B6E35287468';
wwv_flow_imp.g_varchar2_table(4463) := '69732C69292C22726573756D6522696E20742626636F6E736F6C652E6C6F6728227475733A205468652060726573756D6560206F7074696F6E20686173206265656E2072656D6F76656420696E207475732D6A732D636C69656E742076322E20506C6561';
wwv_flow_imp.g_varchar2_table(4464) := '736520757365207468652055524C2073746F726167652041504920696E73746561642E22292C746869732E6F7074696F6E733D742C746869732E6F7074696F6E732E6368756E6B53697A653D4E756D62657228746869732E6F7074696F6E732E6368756E';
wwv_flow_imp.g_varchar2_table(4465) := '6B53697A65292C746869732E5F75726C53746F726167653D746869732E6F7074696F6E732E75726C53746F726167652C746869732E66696C653D652C746869732E75726C3D6E756C6C2C746869732E5F7265713D6E756C6C2C746869732E5F66696E6765';
wwv_flow_imp.g_varchar2_table(4466) := '727072696E743D6E756C6C2C746869732E5F75726C53746F726167654B65793D6E756C6C2C746869732E5F6F66667365743D6E756C6C2C746869732E5F61626F727465643D21312C746869732E5F73697A653D6E756C6C2C746869732E5F736F75726365';
wwv_flow_imp.g_varchar2_table(4467) := '3D6E756C6C2C746869732E5F7265747279417474656D70743D302C746869732E5F726574727954696D656F75743D6E756C6C2C746869732E5F6F66667365744265666F726552657472793D302C746869732E5F706172616C6C656C55706C6F6164733D6E';
wwv_flow_imp.g_varchar2_table(4468) := '756C6C2C746869732E5F706172616C6C656C55706C6F616455726C733D6E756C6C7D72657475726E206E28692C224261736555706C6F616422292C613528692C5B7B6B65793A2266696E6450726576696F757355706C6F616473222C76616C75653A6E28';
wwv_flow_imp.g_varchar2_table(4469) := '66756E6374696F6E28297B76617220743D746869733B72657475726E20746869732E6F7074696F6E732E66696E6765727072696E7428746869732E66696C652C746869732E6F7074696F6E73292E7468656E2866756E6374696F6E2872297B7265747572';
wwv_flow_imp.g_varchar2_table(4470) := '6E20742E5F75726C53746F726167652E66696E6455706C6F616473427946696E6765727072696E742872297D297D2C2266696E6450726576696F757355706C6F61647322297D2C7B6B65793A22726573756D6546726F6D50726576696F757355706C6F61';
wwv_flow_imp.g_varchar2_table(4471) := '64222C76616C75653A6E2866756E6374696F6E2874297B746869732E75726C3D742E75706C6F616455726C7C7C6E756C6C2C746869732E5F706172616C6C656C55706C6F616455726C733D742E706172616C6C656C55706C6F616455726C737C7C6E756C';
wwv_flow_imp.g_varchar2_table(4472) := '6C2C746869732E5F75726C53746F726167654B65793D742E75726C53746F726167654B65797D2C22726573756D6546726F6D50726576696F757355706C6F616422297D2C7B6B65793A227374617274222C76616C75653A6E2866756E6374696F6E28297B';
wwv_flow_imp.g_varchar2_table(4473) := '76617220743D746869732C723D746869732E66696C653B6966282172297B746869732E5F656D69744572726F72286E6577204572726F7228227475733A206E6F2066696C65206F722073747265616D20746F2075706C6F61642070726F76696465642229';
wwv_flow_imp.g_varchar2_table(4474) := '293B72657475726E7D69662821746869732E6F7074696F6E732E656E64706F696E74262621746869732E6F7074696F6E732E75706C6F616455726C262621746869732E75726C297B746869732E5F656D69744572726F72286E6577204572726F72282274';
wwv_flow_imp.g_varchar2_table(4475) := '75733A206E65697468657220616E20656E64706F696E74206F7220616E2075706C6F61642055524C2069732070726F76696465642229293B72657475726E7D76617220733D746869732E6F7074696F6E732E726574727944656C6179733B69662873213D';
wwv_flow_imp.g_varchar2_table(4476) := '6E756C6C26264F626A6563742E70726F746F747970652E746F537472696E672E63616C6C287329213D3D225B6F626A6563742041727261795D22297B746869732E5F656D69744572726F72286E6577204572726F7228227475733A207468652060726574';
wwv_flow_imp.g_varchar2_table(4477) := '727944656C61797360206F7074696F6E206D7573742065697468657220626520616E206172726179206F72206E756C6C2229293B72657475726E7D696628746869732E6F7074696F6E732E706172616C6C656C55706C6F6164733E3129666F7228766172';
wwv_flow_imp.g_varchar2_table(4478) := '206F3D302C613D5B2275706C6F616455726C222C2275706C6F616453697A65222C2275706C6F61644C656E6774684465666572726564225D3B6F3C612E6C656E6774683B6F2B2B297B766172206C3D615B6F5D3B696628746869732E6F7074696F6E735B';
wwv_flow_imp.g_varchar2_table(4479) := '6C5D297B746869732E5F656D69744572726F72286E6577204572726F7228227475733A2063616E6E6F74207573652074686520222E636F6E636174286C2C22206F7074696F6E207768656E20706172616C6C656C55706C6F61647320697320656E61626C';
wwv_flow_imp.g_varchar2_table(4480) := '6564222929293B72657475726E7D7D696628746869732E6F7074696F6E732E706172616C6C656C55706C6F6164426F756E646172696573297B696628746869732E6F7074696F6E732E706172616C6C656C55706C6F6164733C3D31297B746869732E5F65';
wwv_flow_imp.g_varchar2_table(4481) := '6D69744572726F72286E6577204572726F7228227475733A2063616E6E6F7420757365207468652060706172616C6C656C55706C6F6164426F756E64617269657360206F7074696F6E207768656E2060706172616C6C656C55706C6F6164736020697320';
wwv_flow_imp.g_varchar2_table(4482) := '64697361626C65642229293B72657475726E7D696628746869732E6F7074696F6E732E706172616C6C656C55706C6F616473213D3D746869732E6F7074696F6E732E706172616C6C656C55706C6F6164426F756E6461726965732E6C656E677468297B74';
wwv_flow_imp.g_varchar2_table(4483) := '6869732E5F656D69744572726F72286E6577204572726F7228227475733A207468652060706172616C6C656C55706C6F6164426F756E64617269657360206D7573742068617665207468652073616D65206C656E677468206173207468652076616C7565';
wwv_flow_imp.g_varchar2_table(4484) := '206F662060706172616C6C656C55706C6F616473602229293B72657475726E7D7D746869732E6F7074696F6E732E66696E6765727072696E7428722C746869732E6F7074696F6E73292E7468656E2866756E6374696F6E2868297B72657475726E20683D';
wwv_flow_imp.g_varchar2_table(4485) := '3D6E756C6C3F647328224E6F2066696E6765727072696E74207761732063616C63756C61746564206D65616E696E672074686174207468652075706C6F61642063616E6E6F742062652073746F72656420696E207468652055524C2073746F726167652E';
wwv_flow_imp.g_varchar2_table(4486) := '22293A6473282243616C63756C617465642066696E6765727072696E743A20222E636F6E636174286829292C742E5F66696E6765727072696E743D682C742E5F736F757263653F742E5F736F757263653A742E6F7074696F6E732E66696C655265616465';
wwv_flow_imp.g_varchar2_table(4487) := '722E6F70656E46696C6528722C742E6F7074696F6E732E6368756E6B53697A65297D292E7468656E2866756E6374696F6E2868297B696628742E5F736F757263653D682C742E6F7074696F6E732E75706C6F61644C656E67746844656665727265642974';
wwv_flow_imp.g_varchar2_table(4488) := '2E5F73697A653D6E756C6C3B656C736520696628742E6F7074696F6E732E75706C6F616453697A65213D6E756C6C297B696628742E5F73697A653D4E756D62657228742E6F7074696F6E732E75706C6F616453697A65292C4E756D6265722E69734E614E';
wwv_flow_imp.g_varchar2_table(4489) := '28742E5F73697A6529297B742E5F656D69744572726F72286E6577204572726F7228227475733A2063616E6E6F7420636F6E76657274206075706C6F616453697A6560206F7074696F6E20696E746F2061206E756D6265722229293B72657475726E7D7D';
wwv_flow_imp.g_varchar2_table(4490) := '656C736520696628742E5F73697A653D742E5F736F757263652E73697A652C742E5F73697A653D3D6E756C6C297B742E5F656D69744572726F72286E6577204572726F7228227475733A2063616E6E6F74206175746F6D61746963616C6C792064657269';
wwv_flow_imp.g_varchar2_table(4491) := '76652075706C6F616427732073697A652066726F6D20696E7075742E2053706563696679206974206D616E75616C6C79207573696E6720746865206075706C6F616453697A6560206F7074696F6E206F722075736520746865206075706C6F61644C656E';
wwv_flow_imp.g_varchar2_table(4492) := '677468446566657272656460206F7074696F6E2229293B72657475726E7D742E6F7074696F6E732E706172616C6C656C55706C6F6164733E317C7C742E5F706172616C6C656C55706C6F616455726C73213D6E756C6C3F742E5F7374617274506172616C';
wwv_flow_imp.g_varchar2_table(4493) := '6C656C55706C6F616428293A742E5F737461727453696E676C6555706C6F616428297D292E63617463682866756E6374696F6E2868297B742E5F656D69744572726F722868297D297D2C22737461727422297D2C7B6B65793A225F737461727450617261';
wwv_flow_imp.g_varchar2_table(4494) := '6C6C656C55706C6F6164222C76616C75653A6E2866756E6374696F6E28297B76617220742C723D746869732C733D746869732E5F73697A652C6F3D303B746869732E5F706172616C6C656C55706C6F6164733D5B5D3B76617220613D746869732E5F7061';
wwv_flow_imp.g_varchar2_table(4495) := '72616C6C656C55706C6F616455726C73213D6E756C6C3F746869732E5F706172616C6C656C55706C6F616455726C732E6C656E6774683A746869732E6F7074696F6E732E706172616C6C656C55706C6F6164732C6C3D28743D746869732E6F7074696F6E';
wwv_flow_imp.g_varchar2_table(4496) := '732E706172616C6C656C55706C6F6164426F756E64617269657329213D3D6E756C6C262674213D3D766F696420303F743A683528746869732E5F736F757263652E73697A652C61293B746869732E5F706172616C6C656C55706C6F616455726C7326266C';
wwv_flow_imp.g_varchar2_table(4497) := '2E666F72456163682866756E6374696F6E28642C66297B642E75706C6F616455726C3D722E5F706172616C6C656C55706C6F616455726C735B665D7C7C6E756C6C7D292C746869732E5F706172616C6C656C55706C6F616455726C733D6E657720417272';
wwv_flow_imp.g_varchar2_table(4498) := '6179286C2E6C656E677468293B76617220683D6C2E6D61702866756E6374696F6E28642C66297B76617220793D303B72657475726E20722E5F736F757263652E736C69636528642E73746172742C642E656E64292E7468656E2866756E6374696F6E2862';
wwv_flow_imp.g_varchar2_table(4499) := '297B76617220533D622E76616C75653B72657475726E206E65772050726F6D6973652866756E6374696F6E28452C46297B76617220783D5A6F285A6F287B7D2C722E6F7074696F6E73292C7B7D2C7B75706C6F616455726C3A642E75706C6F616455726C';
wwv_flow_imp.g_varchar2_table(4500) := '7C7C6E756C6C2C73746F726546696E6765727072696E74466F72526573756D696E673A21312C72656D6F766546696E6765727072696E744F6E537563636573733A21312C706172616C6C656C55706C6F6164733A312C706172616C6C656C55706C6F6164';
null;
end;
/
begin
wwv_flow_imp.g_varchar2_table(4501) := '426F756E6461726965733A6E756C6C2C6D657461646174613A7B7D2C686561646572733A5A6F285A6F287B7D2C722E6F7074696F6E732E68656164657273292C7B7D2C7B2255706C6F61642D436F6E636174223A227061727469616C227D292C6F6E5375';
wwv_flow_imp.g_varchar2_table(4502) := '63636573733A452C6F6E4572726F723A462C6F6E50726F67726573733A6E2866756E6374696F6E2847297B6F3D6F2D792B472C793D472C722E5F656D697450726F6772657373286F2C73297D2C226F6E50726F677265737322292C5F6F6E55706C6F6164';
wwv_flow_imp.g_varchar2_table(4503) := '55726C417661696C61626C653A6E2866756E6374696F6E28297B722E5F706172616C6C656C55706C6F616455726C735B665D3D552E75726C2C722E5F706172616C6C656C55706C6F616455726C732E66696C7465722866756E6374696F6E2847297B7265';
wwv_flow_imp.g_varchar2_table(4504) := '7475726E2121477D292E6C656E6774683D3D3D6C2E6C656E6774682626722E5F7361766555706C6F6164496E55726C53746F7261676528297D2C225F6F6E55706C6F616455726C417661696C61626C6522297D292C553D6E6577206928532C78293B552E';
wwv_flow_imp.g_varchar2_table(4505) := '737461727428292C722E5F706172616C6C656C55706C6F6164732E707573682855297D297D297D292C633B50726F6D6973652E616C6C2868292E7468656E2866756E6374696F6E28297B633D722E5F6F70656E526571756573742822504F5354222C722E';
wwv_flow_imp.g_varchar2_table(4506) := '6F7074696F6E732E656E64706F696E74292C632E736574486561646572282255706C6F61642D436F6E636174222C2266696E616C3B222E636F6E63617428722E5F706172616C6C656C55706C6F616455726C732E6A6F696E282220222929293B76617220';
wwv_flow_imp.g_varchar2_table(4507) := '643D663028722E6F7074696F6E732E6D65746164617461293B72657475726E2064213D3D22222626632E736574486561646572282255706C6F61642D4D65746164617461222C64292C722E5F73656E645265717565737428632C6E756C6C297D292E7468';
wwv_flow_imp.g_varchar2_table(4508) := '656E2866756E6374696F6E2864297B69662821656E28642E67657453746174757328292C32303029297B722E5F656D6974487474704572726F7228632C642C227475733A20756E657870656374656420726573706F6E7365207768696C65206372656174';
wwv_flow_imp.g_varchar2_table(4509) := '696E672075706C6F616422293B72657475726E7D76617220663D642E67657448656164657228224C6F636174696F6E22293B696628663D3D6E756C6C297B722E5F656D6974487474704572726F7228632C642C227475733A20696E76616C6964206F7220';
wwv_flow_imp.g_varchar2_table(4510) := '6D697373696E67204C6F636174696F6E2068656164657222293B72657475726E7D722E75726C3D763028722E6F7074696F6E732E656E64706F696E742C66292C64732822437265617465642075706C6F616420617420222E636F6E63617428722E75726C';
wwv_flow_imp.g_varchar2_table(4511) := '29292C722E5F656D69745375636365737328297D292E63617463682866756E6374696F6E2864297B722E5F656D69744572726F722864297D297D2C225F7374617274506172616C6C656C55706C6F616422297D2C7B6B65793A225F737461727453696E67';
wwv_flow_imp.g_varchar2_table(4512) := '6C6555706C6F6164222C76616C75653A6E2866756E6374696F6E28297B696628746869732E5F61626F727465643D21312C746869732E75726C213D6E756C6C297B64732822526573756D696E672075706C6F61642066726F6D2070726576696F75732055';
wwv_flow_imp.g_varchar2_table(4513) := '524C3A20222E636F6E63617428746869732E75726C29292C746869732E5F726573756D6555706C6F616428293B72657475726E7D696628746869732E6F7074696F6E732E75706C6F616455726C213D6E756C6C297B64732822526573756D696E67207570';
wwv_flow_imp.g_varchar2_table(4514) := '6C6F61642066726F6D2070726F76696465642055524C3A20222E636F6E63617428746869732E6F7074696F6E732E75706C6F616455726C29292C746869732E75726C3D746869732E6F7074696F6E732E75706C6F616455726C2C746869732E5F72657375';
wwv_flow_imp.g_varchar2_table(4515) := '6D6555706C6F616428293B72657475726E7D647328224372656174696E672061206E65772075706C6F616422292C746869732E5F63726561746555706C6F616428297D2C225F737461727453696E676C6555706C6F616422297D2C7B6B65793A2261626F';
wwv_flow_imp.g_varchar2_table(4516) := '7274222C76616C75653A6E2866756E6374696F6E2874297B76617220723D746869733B72657475726E20746869732E5F706172616C6C656C55706C6F616473213D6E756C6C2626746869732E5F706172616C6C656C55706C6F6164732E666F7245616368';
wwv_flow_imp.g_varchar2_table(4517) := '2866756E6374696F6E2873297B732E61626F72742874297D292C746869732E5F726571213D3D6E756C6C2626746869732E5F7265712E61626F727428292C746869732E5F61626F727465643D21302C746869732E5F726574727954696D656F7574213D6E';
wwv_flow_imp.g_varchar2_table(4518) := '756C6C262628636C65617254696D656F757428746869732E5F726574727954696D656F7574292C746869732E5F726574727954696D656F75743D6E756C6C292C21747C7C746869732E75726C3D3D6E756C6C3F50726F6D6973652E7265736F6C76652829';
wwv_flow_imp.g_varchar2_table(4519) := '3A692E7465726D696E61746528746869732E75726C2C746869732E6F7074696F6E73292E7468656E2866756E6374696F6E28297B72657475726E20722E5F72656D6F766546726F6D55726C53746F7261676528297D297D2C2261626F727422297D2C7B6B';
wwv_flow_imp.g_varchar2_table(4520) := '65793A225F656D6974487474704572726F72222C76616C75653A6E2866756E6374696F6E28742C722C732C6F297B746869732E5F656D69744572726F72286E6577204A6F28732C6F2C742C7229297D2C225F656D6974487474704572726F7222297D2C7B';
wwv_flow_imp.g_varchar2_table(4521) := '6B65793A225F656D69744572726F72222C76616C75653A6E2866756E6374696F6E2874297B76617220723D746869733B69662821746869732E5F61626F72746564297B696628746869732E6F7074696F6E732E726574727944656C617973213D6E756C6C';
wwv_flow_imp.g_varchar2_table(4522) := '297B76617220733D746869732E5F6F6666736574213D6E756C6C2626746869732E5F6F66667365743E746869732E5F6F66667365744265666F726552657472793B69662873262628746869732E5F7265747279417474656D70743D30292C793028742C74';
wwv_flow_imp.g_varchar2_table(4523) := '6869732E5F7265747279417474656D70742C746869732E6F7074696F6E7329297B766172206F3D746869732E6F7074696F6E732E726574727944656C6179735B746869732E5F7265747279417474656D70742B2B5D3B746869732E5F6F66667365744265';
wwv_flow_imp.g_varchar2_table(4524) := '666F726552657472793D746869732E5F6F66667365742C746869732E5F726574727954696D656F75743D73657454696D656F75742866756E6374696F6E28297B722E737461727428297D2C6F293B72657475726E7D7D696628747970656F662074686973';
wwv_flow_imp.g_varchar2_table(4525) := '2E6F7074696F6E732E6F6E4572726F723D3D2266756E6374696F6E2229746869732E6F7074696F6E732E6F6E4572726F722874293B656C7365207468726F7720747D7D2C225F656D69744572726F7222297D2C7B6B65793A225F656D6974537563636573';
wwv_flow_imp.g_varchar2_table(4526) := '73222C76616C75653A6E2866756E6374696F6E28297B746869732E6F7074696F6E732E72656D6F766546696E6765727072696E744F6E537563636573732626746869732E5F72656D6F766546726F6D55726C53746F7261676528292C747970656F662074';
wwv_flow_imp.g_varchar2_table(4527) := '6869732E6F7074696F6E732E6F6E537563636573733D3D2266756E6374696F6E222626746869732E6F7074696F6E732E6F6E5375636365737328297D2C225F656D69745375636365737322297D2C7B6B65793A225F656D697450726F6772657373222C76';
wwv_flow_imp.g_varchar2_table(4528) := '616C75653A6E2866756E6374696F6E28742C72297B747970656F6620746869732E6F7074696F6E732E6F6E50726F67726573733D3D2266756E6374696F6E222626746869732E6F7074696F6E732E6F6E50726F677265737328742C72297D2C225F656D69';
wwv_flow_imp.g_varchar2_table(4529) := '7450726F677265737322297D2C7B6B65793A225F656D69744368756E6B436F6D706C657465222C76616C75653A6E2866756E6374696F6E28742C722C73297B747970656F6620746869732E6F7074696F6E732E6F6E4368756E6B436F6D706C6574653D3D';
wwv_flow_imp.g_varchar2_table(4530) := '2266756E6374696F6E222626746869732E6F7074696F6E732E6F6E4368756E6B436F6D706C65746528742C722C73297D2C225F656D69744368756E6B436F6D706C65746522297D2C7B6B65793A225F63726561746555706C6F6164222C76616C75653A6E';
wwv_flow_imp.g_varchar2_table(4531) := '2866756E6374696F6E28297B76617220743D746869733B69662821746869732E6F7074696F6E732E656E64706F696E74297B746869732E5F656D69744572726F72286E6577204572726F7228227475733A20756E61626C6520746F206372656174652075';
wwv_flow_imp.g_varchar2_table(4532) := '706C6F61642062656361757365206E6F20656E64706F696E742069732070726F76696465642229293B72657475726E7D76617220723D746869732E5F6F70656E526571756573742822504F5354222C746869732E6F7074696F6E732E656E64706F696E74';
wwv_flow_imp.g_varchar2_table(4533) := '293B746869732E6F7074696F6E732E75706C6F61644C656E67746844656665727265643F722E736574486561646572282255706C6F61642D44656665722D4C656E677468222C31293A722E736574486561646572282255706C6F61642D4C656E67746822';
wwv_flow_imp.g_varchar2_table(4534) := '2C746869732E5F73697A65293B76617220733D663028746869732E6F7074696F6E732E6D65746164617461293B73213D3D22222626722E736574486561646572282255706C6F61642D4D65746164617461222C73293B766172206F3B746869732E6F7074';
wwv_flow_imp.g_varchar2_table(4535) := '696F6E732E75706C6F616444617461447572696E674372656174696F6E262621746869732E6F7074696F6E732E75706C6F61644C656E67746844656665727265643F28746869732E5F6F66667365743D302C6F3D746869732E5F6164644368756E6B546F';
wwv_flow_imp.g_varchar2_table(4536) := '52657175657374287229293A6F3D746869732E5F73656E645265717565737428722C6E756C6C292C6F2E7468656E2866756E6374696F6E2861297B69662821656E28612E67657453746174757328292C32303029297B742E5F656D697448747470457272';
wwv_flow_imp.g_varchar2_table(4537) := '6F7228722C612C227475733A20756E657870656374656420726573706F6E7365207768696C65206372656174696E672075706C6F616422293B72657475726E7D766172206C3D612E67657448656164657228224C6F636174696F6E22293B6966286C3D3D';
wwv_flow_imp.g_varchar2_table(4538) := '6E756C6C297B742E5F656D6974487474704572726F7228722C612C227475733A20696E76616C6964206F72206D697373696E67204C6F636174696F6E2068656164657222293B72657475726E7D696628742E75726C3D763028742E6F7074696F6E732E65';
wwv_flow_imp.g_varchar2_table(4539) := '6E64706F696E742C6C292C64732822437265617465642075706C6F616420617420222E636F6E63617428742E75726C29292C747970656F6620742E6F7074696F6E732E5F6F6E55706C6F616455726C417661696C61626C653D3D2266756E6374696F6E22';
wwv_flow_imp.g_varchar2_table(4540) := '2626742E6F7074696F6E732E5F6F6E55706C6F616455726C417661696C61626C6528292C742E5F73697A653D3D3D30297B742E5F656D69745375636365737328292C742E5F736F757263652E636C6F736528293B72657475726E7D742E5F736176655570';
wwv_flow_imp.g_varchar2_table(4541) := '6C6F6164496E55726C53746F7261676528292E7468656E2866756E6374696F6E28297B742E6F7074696F6E732E75706C6F616444617461447572696E674372656174696F6E3F742E5F68616E646C6555706C6F6164526573706F6E736528722C61293A28';
wwv_flow_imp.g_varchar2_table(4542) := '742E5F6F66667365743D302C742E5F706572666F726D55706C6F61642829297D297D292E63617463682866756E6374696F6E2861297B742E5F656D6974487474704572726F7228722C6E756C6C2C227475733A206661696C656420746F20637265617465';
wwv_flow_imp.g_varchar2_table(4543) := '2075706C6F6164222C61297D297D2C225F63726561746555706C6F616422297D2C7B6B65793A225F726573756D6555706C6F6164222C76616C75653A6E2866756E6374696F6E28297B76617220743D746869732C723D746869732E5F6F70656E52657175';
wwv_flow_imp.g_varchar2_table(4544) := '657374282248454144222C746869732E75726C292C733D746869732E5F73656E645265717565737428722C6E756C6C293B732E7468656E2866756E6374696F6E286F297B76617220613D6F2E67657453746174757328293B69662821656E28612C323030';
wwv_flow_imp.g_varchar2_table(4545) := '29297B696628613D3D3D343233297B742E5F656D6974487474704572726F7228722C6F2C227475733A2075706C6F61642069732063757272656E746C79206C6F636B65643B207265747279206C6174657222293B72657475726E7D696628656E28612C34';
wwv_flow_imp.g_varchar2_table(4546) := '3030292626742E5F72656D6F766546726F6D55726C53746F7261676528292C21742E6F7074696F6E732E656E64706F696E74297B742E5F656D6974487474704572726F7228722C6F2C227475733A20756E61626C6520746F20726573756D652075706C6F';
wwv_flow_imp.g_varchar2_table(4547) := '616420286E65772075706C6F61642063616E6E6F74206265206372656174656420776974686F757420616E20656E64706F696E742922293B72657475726E7D742E75726C3D6E756C6C2C742E5F63726561746555706C6F616428293B72657475726E7D76';
wwv_flow_imp.g_varchar2_table(4548) := '6172206C3D7061727365496E74286F2E676574486561646572282255706C6F61642D4F666673657422292C3130293B6966284E756D6265722E69734E614E286C29297B742E5F656D6974487474704572726F7228722C6F2C227475733A20696E76616C69';
wwv_flow_imp.g_varchar2_table(4549) := '64206F72206D697373696E67206F66667365742076616C756522293B72657475726E7D76617220683D7061727365496E74286F2E676574486561646572282255706C6F61642D4C656E67746822292C3130293B6966284E756D6265722E69734E614E2868';
wwv_flow_imp.g_varchar2_table(4550) := '29262621742E6F7074696F6E732E75706C6F61644C656E6774684465666572726564297B742E5F656D6974487474704572726F7228722C6F2C227475733A20696E76616C6964206F72206D697373696E67206C656E6774682076616C756522293B726574';
wwv_flow_imp.g_varchar2_table(4551) := '75726E7D747970656F6620742E6F7074696F6E732E5F6F6E55706C6F616455726C417661696C61626C653D3D2266756E6374696F6E222626742E6F7074696F6E732E5F6F6E55706C6F616455726C417661696C61626C6528292C742E5F7361766555706C';
wwv_flow_imp.g_varchar2_table(4552) := '6F6164496E55726C53746F7261676528292E7468656E2866756E6374696F6E28297B6966286C3D3D3D68297B742E5F656D697450726F677265737328682C68292C742E5F656D69745375636365737328293B72657475726E7D742E5F6F66667365743D6C';
wwv_flow_imp.g_varchar2_table(4553) := '2C742E5F706572666F726D55706C6F616428297D297D292E63617463682866756E6374696F6E286F297B742E5F656D6974487474704572726F7228722C6E756C6C2C227475733A206661696C656420746F20726573756D652075706C6F6164222C6F297D';
wwv_flow_imp.g_varchar2_table(4554) := '297D2C225F726573756D6555706C6F616422297D2C7B6B65793A225F706572666F726D55706C6F6164222C76616C75653A6E2866756E6374696F6E28297B76617220743D746869733B69662821746869732E5F61626F72746564297B76617220723B7468';
wwv_flow_imp.g_varchar2_table(4555) := '69732E6F7074696F6E732E6F7665727269646550617463684D6574686F643F28723D746869732E5F6F70656E526571756573742822504F5354222C746869732E75726C292C722E7365744865616465722822582D485454502D4D6574686F642D4F766572';
wwv_flow_imp.g_varchar2_table(4556) := '72696465222C2250415443482229293A723D746869732E5F6F70656E5265717565737428225041544348222C746869732E75726C292C722E736574486561646572282255706C6F61642D4F6666736574222C746869732E5F6F6666736574293B76617220';
wwv_flow_imp.g_varchar2_table(4557) := '733D746869732E5F6164644368756E6B546F526571756573742872293B732E7468656E2866756E6374696F6E286F297B69662821656E286F2E67657453746174757328292C32303029297B742E5F656D6974487474704572726F7228722C6F2C22747573';
wwv_flow_imp.g_varchar2_table(4558) := '3A20756E657870656374656420726573706F6E7365207768696C652075706C6F6164696E67206368756E6B22293B72657475726E7D742E5F68616E646C6555706C6F6164526573706F6E736528722C6F297D292E63617463682866756E6374696F6E286F';
wwv_flow_imp.g_varchar2_table(4559) := '297B742E5F61626F727465647C7C742E5F656D6974487474704572726F7228722C6E756C6C2C227475733A206661696C656420746F2075706C6F6164206368756E6B206174206F666673657420222E636F6E63617428742E5F6F6666736574292C6F297D';
wwv_flow_imp.g_varchar2_table(4560) := '297D7D2C225F706572666F726D55706C6F616422297D2C7B6B65793A225F6164644368756E6B546F52657175657374222C76616C75653A6E2866756E6374696F6E2874297B76617220723D746869732C733D746869732E5F6F66667365742C6F3D746869';
wwv_flow_imp.g_varchar2_table(4561) := '732E5F6F66667365742B746869732E6F7074696F6E732E6368756E6B53697A653B72657475726E20742E73657450726F677265737348616E646C65722866756E6374696F6E2861297B722E5F656D697450726F677265737328732B612C722E5F73697A65';
wwv_flow_imp.g_varchar2_table(4562) := '297D292C742E7365744865616465722822436F6E74656E742D54797065222C226170706C69636174696F6E2F6F66667365742B6F637465742D73747265616D22292C286F3D3D3D312F307C7C6F3E746869732E5F73697A6529262621746869732E6F7074';
wwv_flow_imp.g_varchar2_table(4563) := '696F6E732E75706C6F61644C656E67746844656665727265642626286F3D746869732E5F73697A65292C746869732E5F736F757263652E736C69636528732C6F292E7468656E2866756E6374696F6E2861297B766172206C3D612E76616C75652C683D61';
wwv_flow_imp.g_varchar2_table(4564) := '2E646F6E653B72657475726E20722E6F7074696F6E732E75706C6F61644C656E6774684465666572726564262668262628722E5F73697A653D722E5F6F66667365742B286C26266C2E73697A653F6C2E73697A653A30292C742E73657448656164657228';
wwv_flow_imp.g_varchar2_table(4565) := '2255706C6F61642D4C656E677468222C722E5F73697A6529292C6C3D3D3D6E756C6C3F722E5F73656E64526571756573742874293A28722E5F656D697450726F677265737328722E5F6F66667365742C722E5F73697A65292C722E5F73656E6452657175';
wwv_flow_imp.g_varchar2_table(4566) := '65737428742C6C29297D297D2C225F6164644368756E6B546F5265717565737422297D2C7B6B65793A225F68616E646C6555706C6F6164526573706F6E7365222C76616C75653A6E2866756E6374696F6E28742C72297B76617220733D7061727365496E';
wwv_flow_imp.g_varchar2_table(4567) := '7428722E676574486561646572282255706C6F61642D4F666673657422292C3130293B6966284E756D6265722E69734E614E287329297B746869732E5F656D6974487474704572726F7228742C722C227475733A20696E76616C6964206F72206D697373';
wwv_flow_imp.g_varchar2_table(4568) := '696E67206F66667365742076616C756522293B72657475726E7D696628746869732E5F656D697450726F677265737328732C746869732E5F73697A65292C746869732E5F656D69744368756E6B436F6D706C65746528732D746869732E5F6F6666736574';
wwv_flow_imp.g_varchar2_table(4569) := '2C732C746869732E5F73697A65292C746869732E5F6F66667365743D732C733D3D3D746869732E5F73697A65297B746869732E5F656D69745375636365737328292C746869732E5F736F757263652E636C6F736528293B72657475726E7D746869732E5F';
wwv_flow_imp.g_varchar2_table(4570) := '706572666F726D55706C6F616428297D2C225F68616E646C6555706C6F6164526573706F6E736522297D2C7B6B65793A225F6F70656E52657175657374222C76616C75653A6E2866756E6374696F6E28742C72297B76617220733D6D3028742C722C7468';
wwv_flow_imp.g_varchar2_table(4571) := '69732E6F7074696F6E73293B72657475726E20746869732E5F7265713D732C737D2C225F6F70656E5265717565737422297D2C7B6B65793A225F72656D6F766546726F6D55726C53746F72616765222C76616C75653A6E2866756E6374696F6E28297B76';
wwv_flow_imp.g_varchar2_table(4572) := '617220743D746869733B746869732E5F75726C53746F726167654B6579262628746869732E5F75726C53746F726167652E72656D6F766555706C6F616428746869732E5F75726C53746F726167654B6579292E63617463682866756E6374696F6E287229';
wwv_flow_imp.g_varchar2_table(4573) := '7B742E5F656D69744572726F722872297D292C746869732E5F75726C53746F726167654B65793D6E756C6C297D2C225F72656D6F766546726F6D55726C53746F7261676522297D2C7B6B65793A225F7361766555706C6F6164496E55726C53746F726167';
wwv_flow_imp.g_varchar2_table(4574) := '65222C76616C75653A6E2866756E6374696F6E28297B76617220743D746869733B69662821746869732E6F7074696F6E732E73746F726546696E6765727072696E74466F72526573756D696E677C7C21746869732E5F66696E6765727072696E747C7C74';
wwv_flow_imp.g_varchar2_table(4575) := '6869732E5F75726C53746F726167654B6579213D3D6E756C6C2972657475726E2050726F6D6973652E7265736F6C766528293B76617220723D7B73697A653A746869732E5F73697A652C6D657461646174613A746869732E6F7074696F6E732E6D657461';
wwv_flow_imp.g_varchar2_table(4576) := '646174612C6372656174696F6E54696D653A6E6577204461746528292E746F537472696E6728297D3B72657475726E20746869732E5F706172616C6C656C55706C6F6164733F722E706172616C6C656C55706C6F616455726C733D746869732E5F706172';
wwv_flow_imp.g_varchar2_table(4577) := '616C6C656C55706C6F616455726C733A722E75706C6F616455726C3D746869732E75726C2C746869732E5F75726C53746F726167652E61646455706C6F616428746869732E5F66696E6765727072696E742C72292E7468656E2866756E6374696F6E2873';
wwv_flow_imp.g_varchar2_table(4578) := '297B742E5F75726C53746F726167654B65793D737D297D2C225F7361766555706C6F6164496E55726C53746F7261676522297D2C7B6B65793A225F73656E6452657175657374222C76616C75653A6E2866756E6374696F6E2874297B76617220723D6172';
wwv_flow_imp.g_varchar2_table(4579) := '67756D656E74732E6C656E6774683E312626617267756D656E74735B315D213D3D766F696420303F617267756D656E74735B315D3A6E756C6C3B72657475726E20673028742C722C746869732E6F7074696F6E73297D2C225F73656E6452657175657374';
wwv_flow_imp.g_varchar2_table(4580) := '22297D5D2C5B7B6B65793A227465726D696E617465222C76616C75653A6E2866756E6374696F6E2874297B76617220723D617267756D656E74732E6C656E6774683E312626617267756D656E74735B315D213D3D766F696420303F617267756D656E7473';
wwv_flow_imp.g_varchar2_table(4581) := '5B315D3A7B7D2C733D6D30282244454C455445222C742C72293B72657475726E20673028732C6E756C6C2C72292E7468656E2866756E6374696F6E286F297B6966286F2E6765745374617475732829213D3D323034297468726F77206E6577204A6F2822';
wwv_flow_imp.g_varchar2_table(4582) := '7475733A20756E657870656374656420726573706F6E7365207768696C65207465726D696E6174696E672075706C6F6164222C6E756C6C2C732C6F297D292E63617463682866756E6374696F6E286F297B6966286F20696E7374616E63656F66204A6F7C';
wwv_flow_imp.g_varchar2_table(4583) := '7C286F3D6E6577204A6F28227475733A206661696C656420746F207465726D696E6174652075706C6F6164222C6F2C732C6E756C6C29292C217930286F2C302C7229297468726F77206F3B76617220613D722E726574727944656C6179735B305D2C6C3D';
wwv_flow_imp.g_varchar2_table(4584) := '722E726574727944656C6179732E736C6963652831292C683D5A6F285A6F287B7D2C72292C7B7D2C7B726574727944656C6179733A6C7D293B72657475726E206E65772050726F6D6973652866756E6374696F6E2863297B72657475726E207365745469';
wwv_flow_imp.g_varchar2_table(4585) := '6D656F757428632C61297D292E7468656E2866756E6374696F6E28297B72657475726E20692E7465726D696E61746528742C68297D297D297D2C227465726D696E61746522297D5D292C697D28293B66756E6374696F6E2066302869297B72657475726E';
wwv_flow_imp.g_varchar2_table(4586) := '204F626A6563742E656E74726965732869292E6D61702866756E6374696F6E2865297B76617220743D623028652C32292C723D745B305D2C733D745B315D3B72657475726E22222E636F6E63617428722C222022292E636F6E6361742858762E656E636F';
wwv_flow_imp.g_varchar2_table(4587) := '646528537472696E6728732929297D292E6A6F696E28222C22297D6E2866302C22656E636F64654D6574616461746122293B66756E6374696F6E20656E28692C65297B72657475726E20693E3D652626693C652B3130307D6E28656E2C22696E53746174';
wwv_flow_imp.g_varchar2_table(4588) := '757343617465676F727922293B66756E6374696F6E206D3028692C652C74297B76617220723D742E68747470537461636B2E6372656174655265717565737428692C65293B722E73657448656164657228225475732D526573756D61626C65222C22312E';
wwv_flow_imp.g_varchar2_table(4589) := '302E3022293B76617220733D742E686561646572737C7C7B7D3B6966284F626A6563742E656E74726965732873292E666F72456163682866756E6374696F6E2861297B766172206C3D623028612C32292C683D6C5B305D2C633D6C5B315D3B722E736574';
wwv_flow_imp.g_varchar2_table(4590) := '48656164657228682C63297D292C742E616464526571756573744964297B766172206F3D516328293B722E7365744865616465722822582D526571756573742D4944222C6F297D72657475726E20727D6E286D302C226F70656E5265717565737422293B';
wwv_flow_imp.g_varchar2_table(4591) := '66756E6374696F6E20673028692C652C74297B76617220723D747970656F6620742E6F6E4265666F7265526571756573743D3D2266756E6374696F6E223F50726F6D6973652E7265736F6C766528742E6F6E4265666F726552657175657374286929293A';
wwv_flow_imp.g_varchar2_table(4592) := '50726F6D6973652E7265736F6C766528293B72657475726E20722E7468656E2866756E6374696F6E28297B72657475726E20692E73656E642865292E7468656E2866756E6374696F6E2873297B766172206F3D747970656F6620742E6F6E416674657252';
wwv_flow_imp.g_varchar2_table(4593) := '6573706F6E73653D3D2266756E6374696F6E223F50726F6D6973652E7265736F6C766528742E6F6E4166746572526573706F6E736528692C7329293A50726F6D6973652E7265736F6C766528293B72657475726E206F2E7468656E2866756E6374696F6E';
wwv_flow_imp.g_varchar2_table(4594) := '28297B72657475726E20737D297D297D297D6E2867302C2273656E645265717565737422293B66756E6374696F6E20753528297B76617220693D21303B72657475726E20747970656F662077696E646F773C2275222626226E6176696761746F7222696E';
wwv_flow_imp.g_varchar2_table(4595) := '2077696E646F77262677696E646F772E6E6176696761746F722E6F6E4C696E653D3D3D2131262628693D2131292C697D6E2875352C2269734F6E6C696E6522293B66756E6374696F6E20793028692C652C74297B696628742E726574727944656C617973';
wwv_flow_imp.g_varchar2_table(4596) := '3D3D6E756C6C7C7C653E3D742E726574727944656C6179732E6C656E6774687C7C692E6F726967696E616C526571756573743D3D6E756C6C2972657475726E21313B696628742626747970656F6620742E6F6E53686F756C6452657472793D3D2266756E';
wwv_flow_imp.g_varchar2_table(4597) := '6374696F6E222972657475726E20742E6F6E53686F756C64526574727928692C652C74293B76617220723D692E6F726967696E616C526573706F6E73653F692E6F726967696E616C526573706F6E73652E67657453746174757328293A303B7265747572';
wwv_flow_imp.g_varchar2_table(4598) := '6E2821656E28722C343030297C7C723D3D3D3430397C7C723D3D3D343233292626753528297D6E2879302C2273686F756C64526574727922293B66756E6374696F6E20763028692C65297B72657475726E206E65772077302E64656661756C7428652C69';
wwv_flow_imp.g_varchar2_table(4599) := '292E746F537472696E6728297D6E2876302C227265736F6C766555726C22293B66756E6374696F6E20683528692C65297B666F722876617220743D4D6174682E666C6F6F7228692F65292C723D5B5D2C733D303B733C653B732B2B29722E70757368287B';
wwv_flow_imp.g_varchar2_table(4600) := '73746172743A742A732C656E643A742A28732B31297D293B72657475726E20725B652D315D2E656E643D692C727D6E2868352C2273706C697453697A65496E746F506172747322293B53302E64656661756C744F7074696F6E733D6C353B766172205A75';
wwv_flow_imp.g_varchar2_table(4601) := '3D53303B66756E6374696F6E20643528692C65297B69662821286920696E7374616E63656F66206529297468726F77206E657720547970654572726F72282243616E6E6F742063616C6C206120636C61737320617320612066756E6374696F6E22297D6E';
wwv_flow_imp.g_varchar2_table(4602) := '2864352C225F636C61737343616C6C436865636B22293B66756E6374696F6E20503028692C65297B666F722876617220743D303B743C652E6C656E6774683B742B2B297B76617220723D655B745D3B722E656E756D657261626C653D722E656E756D6572';
wwv_flow_imp.g_varchar2_table(4603) := '61626C657C7C21312C722E636F6E666967757261626C653D21302C2276616C756522696E2072262628722E7772697461626C653D2130292C4F626A6563742E646566696E6550726F706572747928692C722E6B65792C72297D7D6E2850302C225F646566';
wwv_flow_imp.g_varchar2_table(4604) := '696E6550726F7065727469657322293B66756E6374696F6E20633528692C652C74297B72657475726E20652626503028692E70726F746F747970652C65292C742626503028692C74292C4F626A6563742E646566696E6550726F706572747928692C2270';
wwv_flow_imp.g_varchar2_table(4605) := '726F746F74797065222C7B7772697461626C653A21317D292C697D6E2863352C225F637265617465436C61737322293B766172205F303D66756E6374696F6E28297B66756E6374696F6E206928297B643528746869732C69297D72657475726E206E2869';
wwv_flow_imp.g_varchar2_table(4606) := '2C224E6F6F7055726C53746F7261676522292C633528692C5B7B6B65793A226C697374416C6C55706C6F616473222C76616C75653A6E2866756E6374696F6E28297B72657475726E2050726F6D6973652E7265736F6C7665285B5D297D2C226C69737441';
wwv_flow_imp.g_varchar2_table(4607) := '6C6C55706C6F61647322297D2C7B6B65793A2266696E6455706C6F616473427946696E6765727072696E74222C76616C75653A6E2866756E6374696F6E2874297B72657475726E2050726F6D6973652E7265736F6C7665285B5D297D2C2266696E645570';
wwv_flow_imp.g_varchar2_table(4608) := '6C6F616473427946696E6765727072696E7422297D2C7B6B65793A2272656D6F766555706C6F6164222C76616C75653A6E2866756E6374696F6E2874297B72657475726E2050726F6D6973652E7265736F6C766528297D2C2272656D6F766555706C6F61';
wwv_flow_imp.g_varchar2_table(4609) := '6422297D2C7B6B65793A2261646455706C6F6164222C76616C75653A6E2866756E6374696F6E28742C72297B72657475726E2050726F6D6973652E7265736F6C7665286E756C6C297D2C2261646455706C6F616422297D5D292C697D28293B66756E6374';
wwv_flow_imp.g_varchar2_table(4610) := '696F6E20703528692C65297B69662821286920696E7374616E63656F66206529297468726F77206E657720547970654572726F72282243616E6E6F742063616C6C206120636C61737320617320612066756E6374696F6E22297D6E2870352C225F636C61';
wwv_flow_imp.g_varchar2_table(4611) := '737343616C6C436865636B22293B66756E6374696F6E20463028692C65297B666F722876617220743D303B743C652E6C656E6774683B742B2B297B76617220723D655B745D3B722E656E756D657261626C653D722E656E756D657261626C657C7C21312C';
wwv_flow_imp.g_varchar2_table(4612) := '722E636F6E666967757261626C653D21302C2276616C756522696E2072262628722E7772697461626C653D2130292C4F626A6563742E646566696E6550726F706572747928692C722E6B65792C72297D7D6E2846302C225F646566696E6550726F706572';
wwv_flow_imp.g_varchar2_table(4613) := '7469657322293B66756E6374696F6E20663528692C652C74297B72657475726E20652626463028692E70726F746F747970652C65292C742626463028692C74292C4F626A6563742E646566696E6550726F706572747928692C2270726F746F7479706522';
wwv_flow_imp.g_varchar2_table(4614) := '2C7B7772697461626C653A21317D292C697D6E2866352C225F637265617465436C61737322293B766172205A633D21313B7472797B5A633D226C6F63616C53746F7261676522696E2077696E646F772C4A633D22747573537570706F7274222C6C6F6361';
wwv_flow_imp.g_varchar2_table(4615) := '6C53746F726167652E7365744974656D284A632C6C6F63616C53746F726167652E6765744974656D284A6329297D63617463682869297B696628692E636F64653D3D3D692E53454355524954595F4552527C7C692E636F64653D3D3D692E51554F54415F';
wwv_flow_imp.g_varchar2_table(4616) := '45584345454445445F455252295A633D21313B656C7365207468726F7720697D766172204A632C78303D5A632C45303D66756E6374696F6E28297B66756E6374696F6E206928297B703528746869732C69297D72657475726E206E28692C225765625374';
wwv_flow_imp.g_varchar2_table(4617) := '6F7261676555726C53746F7261676522292C663528692C5B7B6B65793A2266696E64416C6C55706C6F616473222C76616C75653A6E2866756E6374696F6E28297B76617220743D746869732E5F66696E64456E747269657328227475733A3A22293B7265';
wwv_flow_imp.g_varchar2_table(4618) := '7475726E2050726F6D6973652E7265736F6C76652874297D2C2266696E64416C6C55706C6F61647322297D2C7B6B65793A2266696E6455706C6F616473427946696E6765727072696E74222C76616C75653A6E2866756E6374696F6E2874297B76617220';
wwv_flow_imp.g_varchar2_table(4619) := '723D746869732E5F66696E64456E747269657328227475733A3A222E636F6E63617428742C223A3A2229293B72657475726E2050726F6D6973652E7265736F6C76652872297D2C2266696E6455706C6F616473427946696E6765727072696E7422297D2C';
wwv_flow_imp.g_varchar2_table(4620) := '7B6B65793A2272656D6F766555706C6F6164222C76616C75653A6E2866756E6374696F6E2874297B72657475726E206C6F63616C53746F726167652E72656D6F76654974656D2874292C50726F6D6973652E7265736F6C766528297D2C2272656D6F7665';
wwv_flow_imp.g_varchar2_table(4621) := '55706C6F616422297D2C7B6B65793A2261646455706C6F6164222C76616C75653A6E2866756E6374696F6E28742C72297B76617220733D4D6174682E726F756E64284D6174682E72616E646F6D28292A31653132292C6F3D227475733A3A222E636F6E63';
wwv_flow_imp.g_varchar2_table(4622) := '617428742C223A3A22292E636F6E6361742873293B72657475726E206C6F63616C53746F726167652E7365744974656D286F2C4A534F4E2E737472696E67696679287229292C50726F6D6973652E7265736F6C7665286F297D2C2261646455706C6F6164';
wwv_flow_imp.g_varchar2_table(4623) := '22297D2C7B6B65793A225F66696E64456E7472696573222C76616C75653A6E2866756E6374696F6E2874297B666F722876617220723D5B5D2C733D303B733C6C6F63616C53746F726167652E6C656E6774683B732B2B297B766172206F3D6C6F63616C53';
wwv_flow_imp.g_varchar2_table(4624) := '746F726167652E6B65792873293B6966286F2E696E6465784F662874293D3D3D30297472797B76617220613D4A534F4E2E7061727365286C6F63616C53746F726167652E6765744974656D286F29293B612E75726C53746F726167654B65793D6F2C722E';
wwv_flow_imp.g_varchar2_table(4625) := '707573682861297D63617463687B7D7D72657475726E20727D2C225F66696E64456E747269657322297D5D292C697D28293B66756E6374696F6E20657028692C65297B69662821286920696E7374616E63656F66206529297468726F77206E6577205479';
wwv_flow_imp.g_varchar2_table(4626) := '70654572726F72282243616E6E6F742063616C6C206120636C61737320617320612066756E6374696F6E22297D6E2865702C225F636C61737343616C6C436865636B22293B66756E6374696F6E20433028692C65297B666F722876617220743D303B743C';
wwv_flow_imp.g_varchar2_table(4627) := '652E6C656E6774683B742B2B297B76617220723D655B745D3B722E656E756D657261626C653D722E656E756D657261626C657C7C21312C722E636F6E666967757261626C653D21302C2276616C756522696E2072262628722E7772697461626C653D2130';
wwv_flow_imp.g_varchar2_table(4628) := '292C4F626A6563742E646566696E6550726F706572747928692C722E6B65792C72297D7D6E2843302C225F646566696E6550726F7065727469657322293B66756E6374696F6E20747028692C652C74297B72657475726E20652626433028692E70726F74';
wwv_flow_imp.g_varchar2_table(4629) := '6F747970652C65292C742626433028692C74292C4F626A6563742E646566696E6550726F706572747928692C2270726F746F74797065222C7B7772697461626C653A21317D292C697D6E2874702C225F637265617465436C61737322293B766172204F30';
wwv_flow_imp.g_varchar2_table(4630) := '3D66756E6374696F6E28297B66756E6374696F6E206928297B657028746869732C69297D72657475726E206E28692C2258485248747470537461636B22292C747028692C5B7B6B65793A2263726561746552657175657374222C76616C75653A6E286675';
wwv_flow_imp.g_varchar2_table(4631) := '6E6374696F6E28742C72297B72657475726E206E6577206D3528742C72297D2C226372656174655265717565737422297D2C7B6B65793A226765744E616D65222C76616C75653A6E2866756E6374696F6E28297B72657475726E22584852487474705374';
wwv_flow_imp.g_varchar2_table(4632) := '61636B227D2C226765744E616D6522297D5D292C697D28293B766172206D353D66756E6374696F6E28297B66756E6374696F6E206928652C74297B657028746869732C69292C746869732E5F7868723D6E657720584D4C48747470526571756573742C74';
wwv_flow_imp.g_varchar2_table(4633) := '6869732E5F7868722E6F70656E28652C742C2130292C746869732E5F6D6574686F643D652C746869732E5F75726C3D742C746869732E5F686561646572733D7B7D7D72657475726E206E28692C225265717565737422292C747028692C5B7B6B65793A22';
wwv_flow_imp.g_varchar2_table(4634) := '6765744D6574686F64222C76616C75653A6E2866756E6374696F6E28297B72657475726E20746869732E5F6D6574686F647D2C226765744D6574686F6422297D2C7B6B65793A2267657455524C222C76616C75653A6E2866756E6374696F6E28297B7265';
wwv_flow_imp.g_varchar2_table(4635) := '7475726E20746869732E5F75726C7D2C2267657455524C22297D2C7B6B65793A22736574486561646572222C76616C75653A6E2866756E6374696F6E28742C72297B746869732E5F7868722E7365745265717565737448656164657228742C72292C7468';
wwv_flow_imp.g_varchar2_table(4636) := '69732E5F686561646572735B745D3D727D2C2273657448656164657222297D2C7B6B65793A22676574486561646572222C76616C75653A6E2866756E6374696F6E2874297B72657475726E20746869732E5F686561646572735B745D7D2C226765744865';
wwv_flow_imp.g_varchar2_table(4637) := '6164657222297D2C7B6B65793A2273657450726F677265737348616E646C6572222C76616C75653A6E2866756E6374696F6E2874297B2275706C6F616422696E20746869732E5F786872262628746869732E5F7868722E75706C6F61642E6F6E70726F67';
wwv_flow_imp.g_varchar2_table(4638) := '726573733D66756E6374696F6E2872297B722E6C656E677468436F6D70757461626C6526267428722E6C6F61646564297D297D2C2273657450726F677265737348616E646C657222297D2C7B6B65793A2273656E64222C76616C75653A6E2866756E6374';
wwv_flow_imp.g_varchar2_table(4639) := '696F6E28297B76617220743D746869732C723D617267756D656E74732E6C656E6774683E302626617267756D656E74735B305D213D3D766F696420303F617267756D656E74735B305D3A6E756C6C3B72657475726E206E65772050726F6D697365286675';
wwv_flow_imp.g_varchar2_table(4640) := '6E6374696F6E28732C6F297B742E5F7868722E6F6E6C6F61643D66756E6374696F6E28297B73286E657720673528742E5F78687229297D2C742E5F7868722E6F6E6572726F723D66756E6374696F6E2861297B6F2861297D2C742E5F7868722E73656E64';
wwv_flow_imp.g_varchar2_table(4641) := '2872297D297D2C2273656E6422297D2C7B6B65793A2261626F7274222C76616C75653A6E2866756E6374696F6E28297B72657475726E20746869732E5F7868722E61626F727428292C50726F6D6973652E7265736F6C766528297D2C2261626F72742229';
wwv_flow_imp.g_varchar2_table(4642) := '7D2C7B6B65793A22676574556E6465726C79696E674F626A656374222C76616C75653A6E2866756E6374696F6E28297B72657475726E20746869732E5F7868727D2C22676574556E6465726C79696E674F626A65637422297D5D292C697D28292C67353D';
wwv_flow_imp.g_varchar2_table(4643) := '66756E6374696F6E28297B66756E6374696F6E20692865297B657028746869732C69292C746869732E5F7868723D657D72657475726E206E28692C22526573706F6E736522292C747028692C5B7B6B65793A22676574537461747573222C76616C75653A';
wwv_flow_imp.g_varchar2_table(4644) := '6E2866756E6374696F6E28297B72657475726E20746869732E5F7868722E7374617475737D2C2267657453746174757322297D2C7B6B65793A22676574486561646572222C76616C75653A6E2866756E6374696F6E2874297B72657475726E2074686973';
wwv_flow_imp.g_varchar2_table(4645) := '2E5F7868722E676574526573706F6E73654865616465722874297D2C2267657448656164657222297D2C7B6B65793A22676574426F6479222C76616C75653A6E2866756E6374696F6E28297B72657475726E20746869732E5F7868722E726573706F6E73';
wwv_flow_imp.g_varchar2_table(4646) := '65546578747D2C22676574426F647922297D2C7B6B65793A22676574556E6465726C79696E674F626A656374222C76616C75653A6E2866756E6374696F6E28297B72657475726E20746869732E5F7868727D2C22676574556E6465726C79696E674F626A';
wwv_flow_imp.g_varchar2_table(4647) := '65637422297D5D292C697D28293B7661722079353D6E2866756E6374696F6E28297B72657475726E20747970656F66206E6176696761746F723C2275222626747970656F66206E6176696761746F722E70726F647563743D3D22737472696E672226266E';
wwv_flow_imp.g_varchar2_table(4648) := '6176696761746F722E70726F647563742E746F4C6F7765724361736528293D3D3D2272656163746E6174697665227D2C22697352656163744E617469766522292C65683D79353B66756E6374696F6E2069702869297B72657475726E206E65772050726F';
wwv_flow_imp.g_varchar2_table(4649) := '6D6973652866756E6374696F6E28652C74297B76617220723D6E657720584D4C48747470526571756573743B722E726573706F6E7365547970653D22626C6F62222C722E6F6E6C6F61643D66756E6374696F6E28297B76617220733D722E726573706F6E';
wwv_flow_imp.g_varchar2_table(4650) := '73653B652873297D2C722E6F6E6572726F723D66756E6374696F6E2873297B742873297D2C722E6F70656E2822474554222C69292C722E73656E6428297D297D6E2869702C22757269546F426C6F6222293B7661722076353D6E2866756E6374696F6E28';
wwv_flow_imp.g_varchar2_table(4651) := '297B72657475726E20747970656F662077696E646F773C227522262628747970656F662077696E646F772E50686F6E654761703C2275227C7C747970656F662077696E646F772E436F72646F76613C2275227C7C747970656F662077696E646F772E636F';
wwv_flow_imp.g_varchar2_table(4652) := '72646F76613C227522297D2C226973436F72646F766122292C54303D76353B66756E6374696F6E2072702869297B72657475726E206E65772050726F6D6973652866756E6374696F6E28652C74297B76617220723D6E65772046696C655265616465723B';
wwv_flow_imp.g_varchar2_table(4653) := '722E6F6E6C6F61643D66756E6374696F6E28297B76617220733D6E65772055696E7438417272617928722E726573756C74293B65287B76616C75653A737D297D2C722E6F6E6572726F723D66756E6374696F6E2873297B742873297D2C722E7265616441';
wwv_flow_imp.g_varchar2_table(4654) := '7341727261794275666665722869297D297D6E2872702C2272656164417342797465417272617922293B66756E6374696F6E20623528692C65297B69662821286920696E7374616E63656F66206529297468726F77206E657720547970654572726F7228';
wwv_flow_imp.g_varchar2_table(4655) := '2243616E6E6F742063616C6C206120636C61737320617320612066756E6374696F6E22297D6E2862352C225F636C61737343616C6C436865636B22293B66756E6374696F6E20413028692C65297B666F722876617220743D303B743C652E6C656E677468';
wwv_flow_imp.g_varchar2_table(4656) := '3B742B2B297B76617220723D655B745D3B722E656E756D657261626C653D722E656E756D657261626C657C7C21312C722E636F6E666967757261626C653D21302C2276616C756522696E2072262628722E7772697461626C653D2130292C4F626A656374';
wwv_flow_imp.g_varchar2_table(4657) := '2E646566696E6550726F706572747928692C722E6B65792C72297D7D6E2841302C225F646566696E6550726F7065727469657322293B66756E6374696F6E20773528692C652C74297B72657475726E20652626413028692E70726F746F747970652C6529';
wwv_flow_imp.g_varchar2_table(4658) := '2C742626413028692C74292C4F626A6563742E646566696E6550726F706572747928692C2270726F746F74797065222C7B7772697461626C653A21317D292C697D6E2877352C225F637265617465436C61737322293B7661722073703D66756E6374696F';
wwv_flow_imp.g_varchar2_table(4659) := '6E28297B66756E6374696F6E20692865297B623528746869732C69292C746869732E5F66696C653D652C746869732E73697A653D652E73697A657D72657475726E206E28692C2246696C65536F7572636522292C773528692C5B7B6B65793A22736C6963';
wwv_flow_imp.g_varchar2_table(4660) := '65222C76616C75653A6E2866756E6374696F6E28742C72297B696628543028292972657475726E20727028746869732E5F66696C652E736C69636528742C7229293B76617220733D746869732E5F66696C652E736C69636528742C72293B72657475726E';
wwv_flow_imp.g_varchar2_table(4661) := '2050726F6D6973652E7265736F6C7665287B76616C75653A737D297D2C22736C69636522297D2C7B6B65793A22636C6F7365222C76616C75653A6E2866756E6374696F6E28297B7D2C22636C6F736522297D5D292C697D28293B66756E6374696F6E2053';
wwv_flow_imp.g_varchar2_table(4662) := '3528692C65297B69662821286920696E7374616E63656F66206529297468726F77206E657720547970654572726F72282243616E6E6F742063616C6C206120636C61737320617320612066756E6374696F6E22297D6E2853352C225F636C61737343616C';
wwv_flow_imp.g_varchar2_table(4663) := '6C436865636B22293B66756E6374696F6E20523028692C65297B666F722876617220743D303B743C652E6C656E6774683B742B2B297B76617220723D655B745D3B722E656E756D657261626C653D722E656E756D657261626C657C7C21312C722E636F6E';
wwv_flow_imp.g_varchar2_table(4664) := '666967757261626C653D21302C2276616C756522696E2072262628722E7772697461626C653D2130292C4F626A6563742E646566696E6550726F706572747928692C722E6B65792C72297D7D6E2852302C225F646566696E6550726F7065727469657322';
wwv_flow_imp.g_varchar2_table(4665) := '293B66756E6374696F6E20503528692C652C74297B72657475726E20652626523028692E70726F746F747970652C65292C742626523028692C74292C4F626A6563742E646566696E6550726F706572747928692C2270726F746F74797065222C7B777269';
wwv_flow_imp.g_varchar2_table(4666) := '7461626C653A21317D292C697D6E2850352C225F637265617465436C61737322293B66756E6374696F6E2055302869297B72657475726E20693D3D3D766F696420303F303A692E73697A65213D3D766F696420303F692E73697A653A692E6C656E677468';
wwv_flow_imp.g_varchar2_table(4667) := '7D6E2855302C226C656E22293B66756E6374696F6E205F3528692C65297B696628692E636F6E6361742972657475726E20692E636F6E6361742865293B6966286920696E7374616E63656F6620426C6F622972657475726E206E657720426C6F62285B69';
wwv_flow_imp.g_varchar2_table(4668) := '2C655D2C7B747970653A692E747970657D293B696628692E736574297B76617220743D6E657720692E636F6E7374727563746F7228692E6C656E6774682B652E6C656E677468293B72657475726E20742E7365742869292C742E73657428652C692E6C65';
wwv_flow_imp.g_varchar2_table(4669) := '6E677468292C747D7468726F77206E6577204572726F722822556E6B6E6F776E2064617461207479706522297D6E285F352C22636F6E63617422293B766172206B303D66756E6374696F6E28297B66756E6374696F6E20692865297B533528746869732C';
wwv_flow_imp.g_varchar2_table(4670) := '69292C746869732E5F6275666665723D766F696420302C746869732E5F6275666665724F66667365743D302C746869732E5F7265616465723D652C746869732E5F646F6E653D21317D72657475726E206E28692C2253747265616D536F7572636522292C';
wwv_flow_imp.g_varchar2_table(4671) := '503528692C5B7B6B65793A22736C696365222C76616C75653A6E2866756E6374696F6E28742C72297B72657475726E20743C746869732E5F6275666665724F66667365743F50726F6D6973652E72656A656374286E6577204572726F7228225265717565';
wwv_flow_imp.g_varchar2_table(4672) := '737465642064617461206973206265666F7265207468652072656164657227732063757272656E74206F66667365742229293A746869732E5F72656164556E74696C456E6F756768446174614F72446F6E6528742C72297D2C22736C69636522297D2C7B';
wwv_flow_imp.g_varchar2_table(4673) := '6B65793A225F72656164556E74696C456E6F756768446174614F72446F6E65222C76616C75653A6E2866756E6374696F6E28742C72297B76617220733D746869732C6F3D723C3D746869732E5F6275666665724F66667365742B553028746869732E5F62';
wwv_flow_imp.g_varchar2_table(4674) := '7566666572293B696628746869732E5F646F6E657C7C6F297B76617220613D746869732E5F6765744461746146726F6D42756666657228742C72292C6C3D613D3D6E756C6C3F746869732E5F646F6E653A21313B72657475726E2050726F6D6973652E72';
wwv_flow_imp.g_varchar2_table(4675) := '65736F6C7665287B76616C75653A612C646F6E653A6C7D297D72657475726E20746869732E5F7265616465722E7265616428292E7468656E2866756E6374696F6E2868297B76617220633D682E76616C75652C643D682E646F6E653B72657475726E2064';
wwv_flow_imp.g_varchar2_table(4676) := '3F732E5F646F6E653D21303A732E5F6275666665723D3D3D766F696420303F732E5F6275666665723D633A732E5F6275666665723D5F3528732E5F6275666665722C63292C732E5F72656164556E74696C456E6F756768446174614F72446F6E6528742C';
wwv_flow_imp.g_varchar2_table(4677) := '72297D297D2C225F72656164556E74696C456E6F756768446174614F72446F6E6522297D2C7B6B65793A225F6765744461746146726F6D427566666572222C76616C75653A6E2866756E6374696F6E28742C72297B743E746869732E5F6275666665724F';
wwv_flow_imp.g_varchar2_table(4678) := '6666736574262628746869732E5F6275666665723D746869732E5F6275666665722E736C69636528742D746869732E5F6275666665724F6666736574292C746869732E5F6275666665724F66667365743D74293B76617220733D553028746869732E5F62';
wwv_flow_imp.g_varchar2_table(4679) := '7566666572293D3D3D303B72657475726E20746869732E5F646F6E652626733F6E756C6C3A746869732E5F6275666665722E736C69636528302C722D74297D2C225F6765744461746146726F6D42756666657222297D2C7B6B65793A22636C6F7365222C';
wwv_flow_imp.g_varchar2_table(4680) := '76616C75653A6E2866756E6374696F6E28297B746869732E5F7265616465722E63616E63656C2626746869732E5F7265616465722E63616E63656C28297D2C22636C6F736522297D5D292C697D28293B66756E6374696F6E20463528692C65297B696628';
wwv_flow_imp.g_varchar2_table(4681) := '21286920696E7374616E63656F66206529297468726F77206E657720547970654572726F72282243616E6E6F742063616C6C206120636C61737320617320612066756E6374696F6E22297D6E2846352C225F636C61737343616C6C436865636B22293B66';
wwv_flow_imp.g_varchar2_table(4682) := '756E6374696F6E20443028692C65297B666F722876617220743D303B743C652E6C656E6774683B742B2B297B76617220723D655B745D3B722E656E756D657261626C653D722E656E756D657261626C657C7C21312C722E636F6E666967757261626C653D';
wwv_flow_imp.g_varchar2_table(4683) := '21302C2276616C756522696E2072262628722E7772697461626C653D2130292C4F626A6563742E646566696E6550726F706572747928692C722E6B65792C72297D7D6E2844302C225F646566696E6550726F7065727469657322293B66756E6374696F6E';
wwv_flow_imp.g_varchar2_table(4684) := '20783528692C652C74297B72657475726E20652626443028692E70726F746F747970652C65292C742626443028692C74292C4F626A6563742E646566696E6550726F706572747928692C2270726F746F74797065222C7B7772697461626C653A21317D29';
wwv_flow_imp.g_varchar2_table(4685) := '2C697D6E2878352C225F637265617465436C61737322293B7661722049303D66756E6374696F6E28297B66756E6374696F6E206928297B463528746869732C69297D72657475726E206E28692C2246696C6552656164657222292C783528692C5B7B6B65';
wwv_flow_imp.g_varchar2_table(4686) := '793A226F70656E46696C65222C76616C75653A6E2866756E6374696F6E28742C72297B72657475726E20656828292626742626747970656F6620742E7572693C2275223F697028742E757269292E7468656E2866756E6374696F6E2873297B7265747572';
wwv_flow_imp.g_varchar2_table(4687) := '6E206E65772073702873297D292E63617463682866756E6374696F6E2873297B7468726F77206E6577204572726F7228227475733A2063616E6E6F74206665746368206066696C652E7572696020617320426C6F622C206D616B65207375726520746865';
wwv_flow_imp.g_varchar2_table(4688) := '2075726920697320636F727265637420616E642061636365737369626C652E20222E636F6E636174287329297D293A747970656F6620742E736C6963653D3D2266756E6374696F6E222626747970656F6620742E73697A653C2275223F50726F6D697365';
wwv_flow_imp.g_varchar2_table(4689) := '2E7265736F6C7665286E6577207370287429293A747970656F6620742E726561643D3D2266756E6374696F6E223F28723D4E756D6265722872292C4E756D6265722E697346696E6974652872293F50726F6D6973652E7265736F6C7665286E6577206B30';
wwv_flow_imp.g_varchar2_table(4690) := '28742C7229293A50726F6D6973652E72656A656374286E6577204572726F72282263616E6E6F742063726561746520736F7572636520666F722073747265616D20776974686F757420612066696E6974652076616C756520666F72207468652060636875';
wwv_flow_imp.g_varchar2_table(4691) := '6E6B53697A6560206F7074696F6E222929293A50726F6D6973652E72656A656374286E6577204572726F722822736F75726365206F626A656374206D6179206F6E6C7920626520616E20696E7374616E6365206F662046696C652C20426C6F622C206F72';
wwv_flow_imp.g_varchar2_table(4692) := '2052656164657220696E207468697320656E7669726F6E6D656E742229297D2C226F70656E46696C6522297D5D292C697D28293B66756E6374696F6E206F7028692C65297B72657475726E20656828293F50726F6D6973652E7265736F6C766528453528';
wwv_flow_imp.g_varchar2_table(4693) := '692C6529293A50726F6D6973652E7265736F6C7665285B227475732D6272222C692E6E616D652C692E747970652C692E73697A652C692E6C6173744D6F6469666965642C652E656E64706F696E745D2E6A6F696E28222D2229297D6E286F702C2266696E';
wwv_flow_imp.g_varchar2_table(4694) := '6765727072696E7422293B66756E6374696F6E20453528692C65297B76617220743D692E657869663F4335284A534F4E2E737472696E6769667928692E6578696629293A226E6F65786966223B72657475726E5B227475732D726E222C692E6E616D657C';
wwv_flow_imp.g_varchar2_table(4695) := '7C226E6F6E616D65222C692E73697A657C7C226E6F73697A65222C742C652E656E64706F696E745D2E6A6F696E28222F22297D6E2845352C2272656163744E617469766546696E6765727072696E7422293B66756E6374696F6E2043352869297B766172';
wwv_flow_imp.g_varchar2_table(4696) := '20653D303B696628692E6C656E6774683D3D3D302972657475726E20653B666F722876617220743D303B743C692E6C656E6774683B742B2B297B76617220723D692E63686172436F646541742874293B653D28653C3C35292D652B722C65263D657D7265';
wwv_flow_imp.g_varchar2_table(4697) := '7475726E20657D6E2843352C2268617368436F646522293B66756E6374696F6E206E702869297B2240626162656C2F68656C70657273202D20747970656F66223B72657475726E206E703D747970656F662053796D626F6C3D3D2266756E6374696F6E22';
wwv_flow_imp.g_varchar2_table(4698) := '2626747970656F662053796D626F6C2E6974657261746F723D3D2273796D626F6C223F66756E6374696F6E2865297B72657475726E20747970656F6620657D3A66756E6374696F6E2865297B72657475726E20652626747970656F662053796D626F6C3D';
wwv_flow_imp.g_varchar2_table(4699) := '3D2266756E6374696F6E222626652E636F6E7374727563746F723D3D3D53796D626F6C262665213D3D53796D626F6C2E70726F746F747970653F2273796D626F6C223A747970656F6620657D2C6E702869297D6E286E702C225F747970656F6622293B66';
wwv_flow_imp.g_varchar2_table(4700) := '756E6374696F6E204F3528692C65297B69662821286920696E7374616E63656F66206529297468726F77206E657720547970654572726F72282243616E6E6F742063616C6C206120636C61737320617320612066756E6374696F6E22297D6E284F352C22';
wwv_flow_imp.g_varchar2_table(4701) := '5F636C61737343616C6C436865636B22293B66756E6374696F6E204D3028692C65297B666F722876617220743D303B743C652E6C656E6774683B742B2B297B76617220723D655B745D3B722E656E756D657261626C653D722E656E756D657261626C657C';
wwv_flow_imp.g_varchar2_table(4702) := '7C21312C722E636F6E666967757261626C653D21302C2276616C756522696E2072262628722E7772697461626C653D2130292C4F626A6563742E646566696E6550726F706572747928692C722E6B65792C72297D7D6E284D302C225F646566696E655072';
wwv_flow_imp.g_varchar2_table(4703) := '6F7065727469657322293B66756E6374696F6E20543528692C652C74297B72657475726E206526264D3028692E70726F746F747970652C65292C7426264D3028692C74292C4F626A6563742E646566696E6550726F706572747928692C2270726F746F74';
wwv_flow_imp.g_varchar2_table(4704) := '797065222C7B7772697461626C653A21317D292C697D6E2854352C225F637265617465436C61737322293B66756E6374696F6E20413528692C65297B696628747970656F662065213D2266756E6374696F6E22262665213D3D6E756C6C297468726F7720';
wwv_flow_imp.g_varchar2_table(4705) := '6E657720547970654572726F72282253757065722065787072657373696F6E206D75737420656974686572206265206E756C6C206F7220612066756E6374696F6E22293B692E70726F746F747970653D4F626A6563742E63726561746528652626652E70';
wwv_flow_imp.g_varchar2_table(4706) := '726F746F747970652C7B636F6E7374727563746F723A7B76616C75653A692C7772697461626C653A21302C636F6E666967757261626C653A21307D7D292C4F626A6563742E646566696E6550726F706572747928692C2270726F746F74797065222C7B77';
wwv_flow_imp.g_varchar2_table(4707) := '72697461626C653A21317D292C652626617028692C65297D6E2841352C225F696E68657269747322293B66756E6374696F6E20617028692C65297B72657475726E2061703D4F626A6563742E73657450726F746F747970654F663F4F626A6563742E7365';
wwv_flow_imp.g_varchar2_table(4708) := '7450726F746F747970654F662E62696E6428293A6E2866756E6374696F6E28722C73297B72657475726E20722E5F5F70726F746F5F5F3D732C727D2C225F73657450726F746F747970654F6622292C617028692C65297D6E2861702C225F73657450726F';
wwv_flow_imp.g_varchar2_table(4709) := '746F747970654F6622293B66756E6374696F6E2052352869297B76617220653D443528293B72657475726E206E2866756E6374696F6E28297B76617220723D74682869292C733B69662865297B766172206F3D74682874686973292E636F6E7374727563';
wwv_flow_imp.g_varchar2_table(4710) := '746F723B733D5265666C6563742E636F6E73747275637428722C617267756D656E74732C6F297D656C736520733D722E6170706C7928746869732C617267756D656E7473293B72657475726E20553528746869732C73297D2C225F637265617465537570';
wwv_flow_imp.g_varchar2_table(4711) := '6572496E7465726E616C22297D6E2852352C225F637265617465537570657222293B66756E6374696F6E20553528692C65297B696628652626286E702865293D3D3D226F626A656374227C7C747970656F6620653D3D2266756E6374696F6E2229297265';
wwv_flow_imp.g_varchar2_table(4712) := '7475726E20653B69662865213D3D766F69642030297468726F77206E657720547970654572726F7228224465726976656420636F6E7374727563746F7273206D6179206F6E6C792072657475726E206F626A656374206F7220756E646566696E65642229';
wwv_flow_imp.g_varchar2_table(4713) := '3B72657475726E206B352869297D6E2855352C225F706F737369626C65436F6E7374727563746F7252657475726E22293B66756E6374696F6E206B352869297B696628693D3D3D766F69642030297468726F77206E6577205265666572656E6365457272';
wwv_flow_imp.g_varchar2_table(4714) := '6F72282274686973206861736E2774206265656E20696E697469616C69736564202D2073757065722829206861736E2774206265656E2063616C6C656422293B72657475726E20697D6E286B352C225F61737365727454686973496E697469616C697A65';
wwv_flow_imp.g_varchar2_table(4715) := '6422293B66756E6374696F6E20443528297B696628747970656F66205265666C6563743E2275227C7C215265666C6563742E636F6E7374727563747C7C5265666C6563742E636F6E7374727563742E7368616D2972657475726E21313B69662874797065';
wwv_flow_imp.g_varchar2_table(4716) := '6F662050726F78793D3D2266756E6374696F6E222972657475726E21303B7472797B72657475726E20426F6F6C65616E2E70726F746F747970652E76616C75654F662E63616C6C285265666C6563742E636F6E73747275637428426F6F6C65616E2C5B5D';
wwv_flow_imp.g_varchar2_table(4717) := '2C66756E6374696F6E28297B7D29292C21307D63617463687B72657475726E21317D7D6E2844352C225F69734E61746976655265666C656374436F6E73747275637422293B66756E6374696F6E2074682869297B72657475726E2074683D4F626A656374';
wwv_flow_imp.g_varchar2_table(4718) := '2E73657450726F746F747970654F663F4F626A6563742E67657450726F746F747970654F662E62696E6428293A6E2866756E6374696F6E2874297B72657475726E20742E5F5F70726F746F5F5F7C7C4F626A6563742E67657450726F746F747970654F66';
wwv_flow_imp.g_varchar2_table(4719) := '2874297D2C225F67657450726F746F747970654F6622292C74682869297D6E2874682C225F67657450726F746F747970654F6622293B66756E6374696F6E204E3028692C65297B76617220743D4F626A6563742E6B6579732869293B6966284F626A6563';
wwv_flow_imp.g_varchar2_table(4720) := '742E6765744F776E50726F706572747953796D626F6C73297B76617220723D4F626A6563742E6765744F776E50726F706572747953796D626F6C732869293B65262628723D722E66696C7465722866756E6374696F6E2873297B72657475726E204F626A';
wwv_flow_imp.g_varchar2_table(4721) := '6563742E6765744F776E50726F706572747944657363726970746F7228692C73292E656E756D657261626C657D29292C742E707573682E6170706C7928742C72297D72657475726E20747D6E284E302C226F776E4B65797322293B66756E6374696F6E20';
wwv_flow_imp.g_varchar2_table(4722) := '746E2869297B666F722876617220653D313B653C617267756D656E74732E6C656E6774683B652B2B297B76617220743D617267756D656E74735B655D213D6E756C6C3F617267756D656E74735B655D3A7B7D3B6525323F4E30284F626A6563742874292C';
wwv_flow_imp.g_varchar2_table(4723) := '2130292E666F72456163682866756E6374696F6E2872297B493528692C722C745B725D297D293A4F626A6563742E6765744F776E50726F706572747944657363726970746F72733F4F626A6563742E646566696E6550726F7065727469657328692C4F62';
wwv_flow_imp.g_varchar2_table(4724) := '6A6563742E6765744F776E50726F706572747944657363726970746F7273287429293A4E30284F626A656374287429292E666F72456163682866756E6374696F6E2872297B4F626A6563742E646566696E6550726F706572747928692C722C4F626A6563';
wwv_flow_imp.g_varchar2_table(4725) := '742E6765744F776E50726F706572747944657363726970746F7228742C7229297D297D72657475726E20697D6E28746E2C225F6F626A65637453707265616422293B66756E6374696F6E20493528692C652C74297B72657475726E206520696E20693F4F';
wwv_flow_imp.g_varchar2_table(4726) := '626A6563742E646566696E6550726F706572747928692C652C7B76616C75653A742C656E756D657261626C653A21302C636F6E666967757261626C653A21302C7772697461626C653A21307D293A695B655D3D742C697D6E2849352C225F646566696E65';
wwv_flow_imp.g_varchar2_table(4727) := '50726F706572747922293B7661722069683D746E28746E287B7D2C5A752E64656661756C744F7074696F6E73292C7B7D2C7B68747470537461636B3A6E6577204F302C66696C655265616465723A6E65772049302C75726C53746F726167653A78303F6E';
wwv_flow_imp.g_varchar2_table(4728) := '65772045303A6E6577205F302C66696E6765727072696E743A6F707D292C42303D66756E6374696F6E2869297B413528742C69293B76617220653D52352874293B66756E6374696F6E207428297B76617220723D617267756D656E74732E6C656E677468';
wwv_flow_imp.g_varchar2_table(4729) := '3E302626617267756D656E74735B305D213D3D766F696420303F617267756D656E74735B305D3A6E756C6C2C733D617267756D656E74732E6C656E6774683E312626617267756D656E74735B315D213D3D766F696420303F617267756D656E74735B315D';
wwv_flow_imp.g_varchar2_table(4730) := '3A7B7D3B72657475726E204F3528746869732C74292C733D746E28746E287B7D2C6968292C73292C652E63616C6C28746869732C722C73297D72657475726E206E28742C2255706C6F616422292C543528742C6E756C6C2C5B7B6B65793A227465726D69';
wwv_flow_imp.g_varchar2_table(4731) := '6E617465222C76616C75653A6E2866756E6374696F6E28732C6F2C61297B72657475726E206F3D746E28746E287B7D2C6968292C6F292C5A752E7465726D696E61746528732C6F2C61297D2C227465726D696E61746522297D5D292C747D285A75292C7A';
wwv_flow_imp.g_varchar2_table(4732) := '303D77696E646F772C4D353D7A302E584D4C48747470526571756573742C4C303D7A302E426C6F622C67493D4D3526264C302626747970656F66204C302E70726F746F747970652E736C6963653D3D2266756E6374696F6E223B66756E6374696F6E204E';
wwv_flow_imp.g_varchar2_table(4733) := '3528297B72657475726E20747970656F662077696E646F773C227522262628747970656F662077696E646F772E50686F6E654761703C2275227C7C747970656F662077696E646F772E436F72646F76613C2275227C7C747970656F662077696E646F772E';
wwv_flow_imp.g_varchar2_table(4734) := '636F72646F76613C227522297D6E284E352C226973436F72646F766122293B66756E6374696F6E204C3528297B72657475726E20747970656F66206E6176696761746F723C2275222626747970656F66206E6176696761746F722E70726F647563743D3D';
wwv_flow_imp.g_varchar2_table(4735) := '22737472696E672226266E6176696761746F722E70726F647563742E746F4C6F7765724361736528293D3D3D2272656163746E6174697665227D6E284C352C22697352656163744E617469766522293B66756E6374696F6E206C702869297B7265747572';
wwv_flow_imp.g_varchar2_table(4736) := '6E28652C74293D3E7B6966284E3528297C7C4C3528292972657475726E2069682E66696E6765727072696E7428652C74293B6C657420723D5B22747573222C692E69642C742E656E64706F696E745D2E6A6F696E28222D22293B72657475726E2050726F';
wwv_flow_imp.g_varchar2_table(4737) := '6D6973652E7265736F6C76652872297D7D6E286C702C2267657446696E6765727072696E7422293B66756E6374696F6E20616F28692C65297B696628214F626A6563742E70726F746F747970652E6861734F776E50726F70657274792E63616C6C28692C';
wwv_flow_imp.g_varchar2_table(4738) := '6529297468726F77206E657720547970654572726F722822617474656D7074656420746F207573652070726976617465206669656C64206F6E206E6F6E2D696E7374616E636522293B72657475726E20697D6E28616F2C225F636C617373507269766174';
wwv_flow_imp.g_varchar2_table(4739) := '654669656C644C6F6F73654261736522293B7661722042353D303B66756E6374696F6E204A612869297B72657475726E225F5F707269766174655F222B42352B2B2B225F222B697D6E284A612C225F636C617373507269766174654669656C644C6F6F73';
wwv_flow_imp.g_varchar2_table(4740) := '654B657922293B766172207A353D7B76657273696F6E3A22332E352E30227D2C48303D7B656E64706F696E743A22222C75706C6F616455726C3A6E756C6C2C6D657461646174613A7B7D2C75706C6F616453697A653A6E756C6C2C6F6E50726F67726573';
wwv_flow_imp.g_varchar2_table(4741) := '733A6E756C6C2C6F6E4368756E6B436F6D706C6574653A6E756C6C2C6F6E537563636573733A6E756C6C2C6F6E4572726F723A6E756C6C2C6F7665727269646550617463684D6574686F643A21312C686561646572733A7B7D2C61646452657175657374';
wwv_flow_imp.g_varchar2_table(4742) := '49643A21312C6368756E6B53697A653A312F302C726574727944656C6179733A5B3130302C3165332C3365332C3565335D2C706172616C6C656C55706C6F6164733A312C72656D6F766546696E6765727072696E744F6E537563636573733A21312C7570';
wwv_flow_imp.g_varchar2_table(4743) := '6C6F61644C656E67746844656665727265643A21312C75706C6F616444617461447572696E674372656174696F6E3A21317D2C51613D4A612822726574727944656C61794974657261746F7222292C68703D4A61282275706C6F61644C6F63616C46696C';
wwv_flow_imp.g_varchar2_table(4744) := '6522292C64703D4A612822676574436F6D70616E696F6E436C69656E744172677322292C75703D4A61282275706C6F616446696C657322292C59613D4A61282268616E646C6555706C6F616422292C6F723D636C61737320657874656E64732076657B63';
wwv_flow_imp.g_varchar2_table(4745) := '6F6E7374727563746F7228652C74297B76617220722C733B737570657228652C74292C4F626A6563742E646566696E6550726F706572747928746869732C75702C7B76616C75653A24357D292C4F626A6563742E646566696E6550726F70657274792874';
wwv_flow_imp.g_varchar2_table(4746) := '6869732C64702C7B76616C75653A48357D292C4F626A6563742E646566696E6550726F706572747928746869732C68702C7B76616C75653A6A357D292C4F626A6563742E646566696E6550726F706572747928746869732C51612C7B7772697461626C65';
wwv_flow_imp.g_varchar2_table(4747) := '3A21302C76616C75653A766F696420307D292C4F626A6563742E646566696E6550726F706572747928746869732C59612C7B7772697461626C653A21302C76616C75653A6173796E6320613D3E7B696628612E6C656E6774683D3D3D30297B746869732E';
wwv_flow_imp.g_varchar2_table(4748) := '757070792E6C6F6728225B5475735D204E6F2066696C657320746F2075706C6F616422293B72657475726E7D746869732E6F7074732E6C696D69743D3D3D302626746869732E757070792E6C6F6728225B5475735D205768656E2075706C6F6164696E67';
wwv_flow_imp.g_varchar2_table(4749) := '206D756C7469706C652066696C6573206174206F6E63652C20636F6E73696465722073657474696E672074686520606C696D697460206F7074696F6E2028746F206031306020666F72206578616D706C65292C20746F206C696D697420746865206E756D';
wwv_flow_imp.g_varchar2_table(4750) := '626572206F6620636F6E63757272656E742075706C6F6164732C2077686963682068656C70732070726576656E74206D656D6F727920616E64206E6574776F726B206973737565733A2068747470733A2F2F757070792E696F2F646F63732F7475732F23';
wwv_flow_imp.g_varchar2_table(4751) := '6C696D69742D30222C227761726E696E6722292C746869732E757070792E6C6F6728225B5475735D2055706C6F6164696E672E2E2E22293B6C6574206C3D746869732E757070792E67657446696C657342794964732861293B617761697420616F287468';
wwv_flow_imp.g_varchar2_table(4752) := '69732C7570295B75705D286C297D7D292C746869732E747970653D2275706C6F61646572222C746869732E69643D746869732E6F7074732E69647C7C22547573222C746869732E7469746C653D22547573223B6C6574206F3D7B6C696D69743A32302C72';
wwv_flow_imp.g_varchar2_table(4753) := '6574727944656C6179733A48302E726574727944656C6179732C7769746843726564656E7469616C733A21317D3B696628746869732E6F7074733D7B2E2E2E6F2C2E2E2E747D2C743F2E616C6C6F7765644D6574614669656C64733D3D3D766F69642030';
wwv_flow_imp.g_varchar2_table(4754) := '2626226D6574614669656C647322696E20746869732E6F707473297468726F77206E6577204572726F72282254686520606D6574614669656C647360206F7074696F6E20686173206265656E2072656E616D656420746F2060616C6C6F7765644D657461';
wwv_flow_imp.g_varchar2_table(4755) := '4669656C6473602E22293B696628226175746F526574727922696E2074297468726F77206E6577204572726F72282254686520606175746F526574727960206F7074696F6E20776173206465707265636174656420616E6420686173206265656E207265';
wwv_flow_imp.g_varchar2_table(4756) := '6D6F7665642E22293B746869732E72657175657374733D28723D746869732E6F7074732E726174654C696D69746564517565756529213D6E756C6C3F723A6E6577204E7428746869732E6F7074732E6C696D6974292C616F28746869732C5161295B5161';
wwv_flow_imp.g_varchar2_table(4757) := '5D3D28733D746869732E6F7074732E726574727944656C617973293D3D6E756C6C3F766F696420303A732E76616C75657328292C746869732E75706C6F61646572733D4F626A6563742E637265617465286E756C6C292C746869732E75706C6F61646572';
wwv_flow_imp.g_varchar2_table(4758) := '4576656E74733D4F626A6563742E637265617465286E756C6C292C746869732E68616E646C65526573657450726F67726573733D746869732E68616E646C65526573657450726F67726573732E62696E642874686973297D68616E646C65526573657450';
wwv_flow_imp.g_varchar2_table(4759) := '726F677265737328297B6C657420653D7B2E2E2E746869732E757070792E676574537461746528292E66696C65737D3B4F626A6563742E6B6579732865292E666F724561636828743D3E7B696628655B745D2E7475732626655B745D2E7475732E75706C';
wwv_flow_imp.g_varchar2_table(4760) := '6F616455726C297B6C657420723D7B2E2E2E655B745D2E7475737D3B64656C65746520722E75706C6F616455726C2C655B745D3D7B2E2E2E655B745D2C7475733A727D7D7D292C746869732E757070792E7365745374617465287B66696C65733A657D29';
wwv_flow_imp.g_varchar2_table(4761) := '7D726573657455706C6F616465725265666572656E63657328652C74297B696628743D3D3D766F69642030262628743D7B7D292C746869732E75706C6F61646572735B655D297B6C657420723D746869732E75706C6F61646572735B655D3B722E61626F';
wwv_flow_imp.g_varchar2_table(4762) := '727428292C742E61626F72742626722E61626F7274282130292C746869732E75706C6F61646572735B655D3D6E756C6C7D746869732E75706C6F616465724576656E74735B655D262628746869732E75706C6F616465724576656E74735B655D2E72656D';
wwv_flow_imp.g_varchar2_table(4763) := '6F766528292C746869732E75706C6F616465724576656E74735B655D3D6E756C6C297D6F6E5265636569766555706C6F616455726C28652C74297B6C657420723D746869732E757070792E67657446696C6528652E6964293B7226262821722E7475737C';
wwv_flow_imp.g_varchar2_table(4764) := '7C722E7475732E75706C6F616455726C213D3D7429262628746869732E757070792E6C6F6728225B5475735D2053746F72696E672075706C6F61642075726C22292C746869732E757070792E73657446696C65537461746528722E69642C7B7475733A7B';
wwv_flow_imp.g_varchar2_table(4765) := '2E2E2E722E7475732C75706C6F616455726C3A747D7D29297D696E7374616C6C28297B746869732E757070792E7365745374617465287B6361706162696C69746965733A7B2E2E2E746869732E757070792E676574537461746528292E6361706162696C';
wwv_flow_imp.g_varchar2_table(4766) := '69746965732C726573756D61626C6555706C6F6164733A21307D7D292C746869732E757070792E61646455706C6F6164657228616F28746869732C5961295B59615D292C746869732E757070792E6F6E282272657365742D70726F6772657373222C7468';
wwv_flow_imp.g_varchar2_table(4767) := '69732E68616E646C65526573657450726F6772657373297D756E696E7374616C6C28297B746869732E757070792E7365745374617465287B6361706162696C69746965733A7B2E2E2E746869732E757070792E676574537461746528292E636170616269';
wwv_flow_imp.g_varchar2_table(4768) := '6C69746965732C726573756D61626C6555706C6F6164733A21317D7D292C746869732E757070792E72656D6F766555706C6F6164657228616F28746869732C5961295B59615D297D7D3B6E286F722C2254757322293B66756E6374696F6E206A35286929';
wwv_flow_imp.g_varchar2_table(4769) := '7B76617220653D746869733B72657475726E20746869732E726573657455706C6F616465725265666572656E63657328692E6964292C6E65772050726F6D6973652828742C72293D3E7B6C657420732C6F2C612C6C3D7B2E2E2E746869732E6F7074732C';
wwv_flow_imp.g_varchar2_table(4770) := '2E2E2E692E7475737C7C7B7D7D3B747970656F66206C2E686561646572733D3D2266756E6374696F6E222626286C2E686561646572733D6C2E68656164657273286929293B6C657420683D7B2E2E2E48302C2E2E2E6C7D3B682E66696E6765727072696E';
wwv_flow_imp.g_varchar2_table(4771) := '743D6C702869292C682E6F6E4265666F7265526571756573743D533D3E7B6C657420453D532E676574556E6465726C79696E674F626A65637428293B452E7769746843726564656E7469616C733D21216C2E7769746843726564656E7469616C733B6C65';
wwv_flow_imp.g_varchar2_table(4772) := '7420463B696628747970656F66206C2E6F6E4265666F7265526571756573743D3D2266756E6374696F6E22262628463D6C2E6F6E4265666F72655265717565737428532C6929292C597428732C2273686F756C64426552657175657565642229297B6966';
wwv_flow_imp.g_varchar2_table(4773) := '2821732E73686F756C64426552657175657565642972657475726E2050726F6D6973652E72656A65637428293B6C657420782C553D6E65772050726F6D697365286A3D3E7B783D6A7D293B72657475726E20733D746869732E72657175657374732E7275';
wwv_flow_imp.g_varchar2_table(4774) := '6E2828293D3E28692E69735061757365642626732E61626F727428292C7828292C28293D3E7B7D29292C50726F6D6973652E616C6C285B552C465D297D72657475726E20467D2C682E6F6E4572726F723D533D3E7B76617220453B746869732E75707079';
wwv_flow_imp.g_varchar2_table(4775) := '2E6C6F672853293B6C657420463D532E6F726967696E616C526571756573743F532E6F726967696E616C526571756573742E676574556E6465726C79696E674F626A65637428293A6E756C6C3B736F284629262628533D6E6577205F6928532C4629292C';
wwv_flow_imp.g_varchar2_table(4776) := '746869732E726573657455706C6F616465725265666572656E63657328692E6964292C28453D73293D3D6E756C6C7C7C452E61626F727428292C746869732E757070792E656D6974282275706C6F61642D6572726F72222C692C53292C747970656F6620';
wwv_flow_imp.g_varchar2_table(4777) := '6C2E6F6E4572726F723D3D2266756E6374696F6E2226266C2E6F6E4572726F722853292C722853297D2C682E6F6E50726F67726573733D28532C45293D3E7B746869732E6F6E5265636569766555706C6F616455726C28692C612E75726C292C74797065';
wwv_flow_imp.g_varchar2_table(4778) := '6F66206C2E6F6E50726F67726573733D3D2266756E6374696F6E2226266C2E6F6E50726F677265737328532C45292C746869732E757070792E656D6974282275706C6F61642D70726F6772657373222C692C7B75706C6F616465723A746869732C627974';
wwv_flow_imp.g_varchar2_table(4779) := '657355706C6F616465643A532C6279746573546F74616C3A457D297D2C682E6F6E537563636573733D28293D3E7B6C657420533D7B75706C6F616455524C3A612E75726C7D3B746869732E726573657455706C6F616465725265666572656E6365732869';
wwv_flow_imp.g_varchar2_table(4780) := '2E6964292C732E646F6E6528292C746869732E757070792E656D6974282275706C6F61642D73756363657373222C692C53292C612E75726C2626746869732E757070792E6C6F672860446F776E6C6F616420247B612E66696C652E6E616D657D2066726F';
wwv_flow_imp.g_varchar2_table(4781) := '6D20247B612E75726C7D60292C747970656F66206C2E6F6E537563636573733D3D2266756E6374696F6E2226266C2E6F6E5375636365737328292C742861297D3B6C657420633D6E28533D3E7B76617220453B6C657420463D533D3D6E756C6C7C7C2845';
wwv_flow_imp.g_varchar2_table(4782) := '3D532E6F726967696E616C526573706F6E7365293D3D6E756C6C3F766F696420303A452E67657453746174757328293B696628463D3D3D343239297B69662821746869732E72657175657374732E6973506175736564297B76617220783B6C657420553D';
wwv_flow_imp.g_varchar2_table(4783) := '28783D616F28746869732C5161295B51615D293D3D6E756C6C3F766F696420303A782E6E65787428293B696628553D3D6E756C6C7C7C552E646F6E652972657475726E21313B746869732E72657175657374732E726174654C696D697428552E76616C75';
wwv_flow_imp.g_varchar2_table(4784) := '65297D7D656C73657B696628463E3430302626463C353030262646213D3D343039262646213D3D3432332972657475726E21313B747970656F66206E6176696761746F723C22752226266E6176696761746F722E6F6E4C696E653D3D3D21312626287468';
wwv_flow_imp.g_varchar2_table(4785) := '69732E72657175657374732E69735061757365647C7C28746869732E72657175657374732E706175736528292C77696E646F772E6164644576656E744C697374656E657228226F6E6C696E65222C28293D3E7B746869732E72657175657374732E726573';
wwv_flow_imp.g_varchar2_table(4786) := '756D6528297D2C7B6F6E63653A21307D2929297D72657475726E20732E61626F727428292C733D7B73686F756C64426552657175657565643A21302C61626F727428297B746869732E73686F756C64426552657175657565643D21317D2C646F6E652829';
wwv_flow_imp.g_varchar2_table(4787) := '7B7468726F77206E6577204572726F72282243616E6E6F74206D61726B206120717565756564207265717565737420617320646F6E653A207468697320696E6469636174657320612062756722297D2C666E28297B7468726F77206E6577204572726F72';
wwv_flow_imp.g_varchar2_table(4788) := '282243616E6E6F742072756E20612071756575656420726571756573743A207468697320696E6469636174657320612062756722297D7D2C21307D2C2264656661756C744F6E53686F756C64526574727922293B6C2E6F6E53686F756C64526574727921';
wwv_flow_imp.g_varchar2_table(4789) := '3D6E756C6C3F682E6F6E53686F756C6452657472793D66756E6374696F6E28297B666F722876617220533D617267756D656E74732E6C656E6774682C453D6E65772041727261792853292C463D303B463C533B462B2B29455B465D3D617267756D656E74';
wwv_flow_imp.g_varchar2_table(4790) := '735B465D3B72657475726E206C2E6F6E53686F756C645265747279282E2E2E452C63297D3A682E6F6E53686F756C6452657472793D633B6C657420643D6E2828532C452C46293D3E7B597428532C4529262621597428532C4629262628535B465D3D535B';
wwv_flow_imp.g_varchar2_table(4791) := '455D297D2C22636F707950726F7022292C663D7B7D3B2841727261792E69734172726179286C2E616C6C6F7765644D6574614669656C6473293F6C2E616C6C6F7765644D6574614669656C64733A4F626A6563742E6B65797328692E6D65746129292E66';
wwv_flow_imp.g_varchar2_table(4792) := '6F724561636828533D3E7B665B535D3D692E6D6574615B535D7D292C6428662C2274797065222C2266696C657479706522292C6428662C226E616D65222C2266696C656E616D6522292C682E6D657461646174613D662C613D6E657720423028692E6461';
wwv_flow_imp.g_varchar2_table(4793) := '74612C68292C746869732E75706C6F61646572735B692E69645D3D613B6C657420623D6E657720676928746869732E75707079293B746869732E75706C6F616465724576656E74735B692E69645D3D622C6F3D6E2828293D3E28692E6973506175736564';
wwv_flow_imp.g_varchar2_table(4794) := '7C7C612E737461727428292C28293D3E7B7D292C22715265717565737422292C612E66696E6450726576696F757355706C6F61647328292E7468656E28533D3E7B6C657420453D535B305D3B45262628746869732E757070792E6C6F6728605B5475735D';
wwv_flow_imp.g_varchar2_table(4795) := '20526573756D696E672075706C6F6164206F6620247B692E69647D207374617274656420617420247B452E6372656174696F6E54696D657D60292C612E726573756D6546726F6D50726576696F757355706C6F6164284529297D292C733D746869732E72';
wwv_flow_imp.g_varchar2_table(4796) := '657175657374732E72756E286F292C622E6F6E46696C6552656D6F766528692E69642C533D3E7B732E61626F727428292C746869732E726573657455706C6F616465725265666572656E63657328692E69642C7B61626F72743A2121612E75726C7D292C';
wwv_flow_imp.g_varchar2_table(4797) := '74286075706C6F616420247B537D207761732072656D6F76656460297D292C622E6F6E506175736528692E69642C533D3E7B732E61626F727428292C533F612E61626F727428293A733D746869732E72657175657374732E72756E286F297D292C622E6F';
wwv_flow_imp.g_varchar2_table(4798) := '6E5061757365416C6C28692E69642C28293D3E7B732E61626F727428292C612E61626F727428297D292C622E6F6E43616E63656C416C6C28692E69642C66756E6374696F6E2853297B6C65747B726561736F6E3A457D3D533D3D3D766F696420303F7B7D';
wwv_flow_imp.g_varchar2_table(4799) := '3A533B453D3D3D227573657222262628732E61626F727428292C652E726573657455706C6F616465725265666572656E63657328692E69642C7B61626F72743A2121612E75726C7D29292C74286075706C6F616420247B692E69647D207761732063616E';
wwv_flow_imp.g_varchar2_table(4800) := '63656C656460297D292C622E6F6E526573756D65416C6C28692E69642C28293D3E7B732E61626F727428292C692E6572726F722626612E61626F727428292C733D746869732E72657175657374732E72756E286F297D297D292E636174636828743D3E7B';
wwv_flow_imp.g_varchar2_table(4801) := '7468726F7720746869732E757070792E656D6974282275706C6F61642D6572726F72222C692C74292C747D297D6E286A352C225F75706C6F61644C6F63616C46696C653222293B66756E6374696F6E2048352869297B6C657420653D7B2E2E2E74686973';
wwv_flow_imp.g_varchar2_table(4802) := '2E6F7074737D3B72657475726E20692E74757326264F626A6563742E61737369676E28652C692E747573292C7B2E2E2E692E72656D6F74652E626F64792C656E64706F696E743A652E656E64706F696E742C75706C6F616455726C3A652E75706C6F6164';
wwv_flow_imp.g_varchar2_table(4803) := '55726C2C70726F746F636F6C3A22747573222C73697A653A692E646174612E73697A652C686561646572733A652E686561646572732C6D657461646174613A692E6D6574617D7D6E2848352C225F676574436F6D70616E696F6E436C69656E7441726773';
wwv_flow_imp.g_varchar2_table(4804) := '3222293B6173796E632066756E6374696F6E2024352869297B6C657420653D75732869292C743D68732865293B746869732E757070792E656D6974282275706C6F61642D7374617274222C74292C61776169742050726F6D6973652E616C6C536574746C';
wwv_flow_imp.g_varchar2_table(4805) := '656428652E6D61702828722C73293D3E7B6C6574206F3D732B312C613D692E6C656E6774683B696628722E697352656D6F7465297B6C6574206C3D6E2828293D3E746869732E72657175657374732C22676574517565756522292C683D6E65772041626F';
wwv_flow_imp.g_varchar2_table(4806) := '7274436F6E74726F6C6C65722C633D6E28663D3E7B662E69643D3D3D722E69642626682E61626F727428297D2C2272656D6F76656448616E646C657222293B746869732E757070792E6F6E282266696C652D72656D6F766564222C63293B6C657420643D';
wwv_flow_imp.g_varchar2_table(4807) := '746869732E757070792E67657452657175657374436C69656E74466F7246696C652872292E75706C6F616452656D6F746546696C6528722C616F28746869732C6470295B64705D2872292C7B7369676E616C3A682E7369676E616C2C6765745175657565';
wwv_flow_imp.g_varchar2_table(4808) := '3A6C7D293B72657475726E20746869732E72657175657374732E7772617053796E6346756E6374696F6E2828293D3E7B746869732E757070792E6F6666282266696C652D72656D6F766564222C63297D2C7B7072696F726974793A2D317D2928292C647D';
wwv_flow_imp.g_varchar2_table(4809) := '72657475726E20616F28746869732C6870295B68705D28722C6F2C61297D29297D6E2824352C225F75706C6F616446696C65733222293B6F722E56455253494F4E3D7A352E76657273696F6E3B7661722071303D646528707028292C31293B66756E6374';
wwv_flow_imp.g_varchar2_table(4810) := '696F6E20636528692C65297B696628214F626A6563742E70726F746F747970652E6861734F776E50726F70657274792E63616C6C28692C6529297468726F77206E657720547970654572726F722822617474656D7074656420746F207573652070726976';
wwv_flow_imp.g_varchar2_table(4811) := '617465206669656C64206F6E206E6F6E2D696E7374616E636522293B72657475726E20697D6E2863652C225F636C617373507269766174654669656C644C6F6F73654261736522293B7661722056353D303B66756E6374696F6E206E722869297B726574';
wwv_flow_imp.g_varchar2_table(4812) := '75726E225F5F707269766174655F222B56352B2B2B225F222B697D6E286E722C225F636C617373507269766174654669656C644C6F6F73654B657922293B7661722057353D22415353454D424C595F55504C4F4144494E47222C79703D22415353454D42';
wwv_flow_imp.g_varchar2_table(4813) := '4C595F455845435554494E47222C76703D22415353454D424C595F434F4D504C45544544222C24303D5B57352C79702C76705D3B66756E6374696F6E20726828692C65297B72657475726E2024302E696E6465784F662869293E3D24302E696E6465784F';
wwv_flow_imp.g_varchar2_table(4814) := '662865297D6E2872682C22697353746174757322293B76617220756F3D6E722822726174654C696D69746564517565756522292C5A613D6E7228226665746368576974684E6574776F726B4572726F7222292C6C6F3D6E72282270726576696F75734665';
wwv_flow_imp.g_varchar2_table(4815) := '7463685374617475735374696C6C50656E64696E6722292C56653D6E72282273736522292C62703D6E7228226F6E46696E697368656422292C66703D6E722822636F6E6E65637453657276657253656E744576656E747322292C6B693D6E7228226F6E45';
wwv_flow_imp.g_varchar2_table(4816) := '72726F7222292C6D703D6E722822626567696E506F6C6C696E6722292C42723D6E722822666574636853746174757322292C67703D6E7228226469666653746174757322292C73683D636C61737320657874656E64732071302E64656661756C747B636F';
wwv_flow_imp.g_varchar2_table(4817) := '6E7374727563746F7228652C74297B737570657228292C4F626A6563742E646566696E6550726F706572747928746869732C67702C7B76616C75653A4A357D292C4F626A6563742E646566696E6550726F706572747928746869732C42722C7B76616C75';
wwv_flow_imp.g_varchar2_table(4818) := '653A51357D292C4F626A6563742E646566696E6550726F706572747928746869732C6D702C7B76616C75653A59357D292C4F626A6563742E646566696E6550726F706572747928746869732C6B692C7B76616C75653A58357D292C4F626A6563742E6465';
wwv_flow_imp.g_varchar2_table(4819) := '66696E6550726F706572747928746869732C66702C7B76616C75653A4B357D292C4F626A6563742E646566696E6550726F706572747928746869732C62702C7B76616C75653A47357D292C4F626A6563742E646566696E6550726F706572747928746869';
wwv_flow_imp.g_varchar2_table(4820) := '732C756F2C7B7772697461626C653A21302C76616C75653A766F696420307D292C4F626A6563742E646566696E6550726F706572747928746869732C5A612C7B7772697461626C653A21302C76616C75653A766F696420307D292C4F626A6563742E6465';
wwv_flow_imp.g_varchar2_table(4821) := '66696E6550726F706572747928746869732C6C6F2C7B7772697461626C653A21302C76616C75653A21317D292C4F626A6563742E646566696E6550726F706572747928746869732C56652C7B7772697461626C653A21302C76616C75653A766F69642030';
wwv_flow_imp.g_varchar2_table(4822) := '7D292C746869732E7374617475733D652C746869732E706F6C6C496E74657276616C3D6E756C6C2C746869732E636C6F7365643D21312C636528746869732C756F295B756F5D3D742C636528746869732C5A61295B5A615D3D742E7772617050726F6D69';
wwv_flow_imp.g_varchar2_table(4823) := '736546756E6374696F6E285073297D636F6E6E65637428297B636528746869732C6670295B66705D28292C636528746869732C6D70295B6D705D28297D75706461746528297B72657475726E20636528746869732C4272295B42725D287B646966663A21';
wwv_flow_imp.g_varchar2_table(4824) := '307D297D7570646174655374617475732865297B636528746869732C6770295B67705D28746869732E7374617475732C65292C746869732E7374617475733D657D636C6F736528297B746869732E636C6F7365643D21302C636528746869732C5665295B';
wwv_flow_imp.g_varchar2_table(4825) := '56655D262628636528746869732C5665295B56655D2E636C6F736528292C636528746869732C5665295B56655D3D6E756C6C292C636C656172496E74657276616C28746869732E706F6C6C496E74657276616C292C746869732E706F6C6C496E74657276';
wwv_flow_imp.g_varchar2_table(4826) := '616C3D6E756C6C7D7D3B6E2873682C225472616E736C6F61646974417373656D626C7922293B66756E6374696F6E20473528297B746869732E656D6974282266696E697368656422292C746869732E636C6F736528297D6E2847352C225F6F6E46696E69';
wwv_flow_imp.g_varchar2_table(4827) := '736865643222293B66756E6374696F6E204B3528297B636528746869732C5665295B56655D3D6E6577204576656E74536F757263652860247B746869732E7374617475732E776562736F636B65745F75726C7D3F617373656D626C793D247B746869732E';
wwv_flow_imp.g_varchar2_table(4828) := '7374617475732E617373656D626C795F69647D60292C636528746869732C5665295B56655D2E6164644576656E744C697374656E657228226F70656E222C28293D3E7B746869732E736F636B6574262628746869732E736F636B65742E646973636F6E6E';
wwv_flow_imp.g_varchar2_table(4829) := '65637428292C746869732E736F636B65743D6E756C6C292C636C656172496E74657276616C28746869732E706F6C6C496E74657276616C292C746869732E706F6C6C496E74657276616C3D6E756C6C7D292C636528746869732C5665295B56655D2E6164';
wwv_flow_imp.g_varchar2_table(4830) := '644576656E744C697374656E657228226D657373616765222C693D3E7B692E646174613D3D3D22617373656D626C795F66696E6973686564222626636528746869732C6270295B62705D28292C692E646174613D3D3D22617373656D626C795F75706C6F';
wwv_flow_imp.g_varchar2_table(4831) := '6164696E675F66696E6973686564222626746869732E656D69742822657865637574696E6722292C692E646174613D3D3D22617373656D626C795F75706C6F61645F6D6574615F646174615F65787472616374656422262628746869732E656D69742822';
wwv_flow_imp.g_varchar2_table(4832) := '6D6574616461746122292C636528746869732C4272295B42725D287B646966663A21317D29297D292C636528746869732C5665295B56655D2E6164644576656E744C697374656E65722822617373656D626C795F75706C6F61645F66696E697368656422';
wwv_flow_imp.g_varchar2_table(4833) := '2C693D3E7B6C657420653D4A534F4E2E706172736528692E64617461293B746869732E656D6974282275706C6F6164222C65292C746869732E7374617475732E75706C6F6164732E707573682865297D292C636528746869732C5665295B56655D2E6164';
wwv_flow_imp.g_varchar2_table(4834) := '644576656E744C697374656E65722822617373656D626C795F726573756C745F66696E6973686564222C693D3E7B76617220652C743B6C65745B722C735D3D4A534F4E2E706172736528692E64617461293B746869732E656D69742822726573756C7422';
wwv_flow_imp.g_varchar2_table(4835) := '2C722C73292C2828743D28653D746869732E7374617475732E726573756C7473295B725D29213D6E756C6C3F743A655B725D3D5B5D292E707573682873297D292C636528746869732C5665295B56655D2E6164644576656E744C697374656E6572282261';
wwv_flow_imp.g_varchar2_table(4836) := '7373656D626C795F657865637574696F6E5F70726F6772657373222C693D3E7B6C657420653D4A534F4E2E706172736528692E64617461293B746869732E656D69742822657865637574696F6E2D70726F6772657373222C65297D292C63652874686973';
wwv_flow_imp.g_varchar2_table(4837) := '2C5665295B56655D2E6164644576656E744C697374656E65722822617373656D626C795F6572726F72222C693D3E7B7472797B636528746869732C6B69295B6B695D284A534F4E2E706172736528692E6461746129297D63617463687B63652874686973';
wwv_flow_imp.g_varchar2_table(4838) := '2C6B69295B6B695D287B6D73673A692E646174617D297D636528746869732C4272295B42725D287B646966663A21317D297D297D6E284B352C225F636F6E6E65637453657276657253656E744576656E74733222293B66756E6374696F6E205835286929';
wwv_flow_imp.g_varchar2_table(4839) := '7B746869732E656D697428226572726F72222C4F626A6563742E61737369676E286E6577204572726F7228692E6D7367292C6929292C746869732E636C6F736528297D6E2858352C225F6F6E4572726F723222293B66756E6374696F6E20593528297B74';
wwv_flow_imp.g_varchar2_table(4840) := '6869732E706F6C6C496E74657276616C3D736574496E74657276616C2828293D3E7B636528746869732C4272295B42725D28297D2C326533297D6E2859352C225F626567696E506F6C6C696E673222293B6173796E632066756E6374696F6E2051352869';
wwv_flow_imp.g_varchar2_table(4841) := '297B6C65747B646966663A653D21307D3D693D3D3D766F696420303F7B7D3A693B6966282128746869732E636C6F7365647C7C636528746869732C756F295B756F5D2E69735061757365647C7C636528746869732C6C6F295B6C6F5D29297472797B6365';
wwv_flow_imp.g_varchar2_table(4842) := '28746869732C6C6F295B6C6F5D3D21303B6C657420743D617761697420636528746869732C5A61295B5A615D28746869732E7374617475732E617373656D626C795F73736C5F75726C293B696628636528746869732C6C6F295B6C6F5D3D21312C746869';
wwv_flow_imp.g_varchar2_table(4843) := '732E636C6F7365642972657475726E3B696628742E7374617475733D3D3D343239297B636528746869732C756F295B756F5D2E726174654C696D697428326533293B72657475726E7D69662821742E6F6B297B636528746869732C6B69295B6B695D286E';
wwv_flow_imp.g_varchar2_table(4844) := '6577205F6928742E7374617475735465787429293B72657475726E7D6C657420723D617761697420742E6A736F6E28293B696628746869732E636C6F7365642972657475726E3B746869732E656D69742822737461747573222C72292C653F746869732E';
wwv_flow_imp.g_varchar2_table(4845) := '7570646174655374617475732872293A746869732E7374617475733D727D63617463682874297B636528746869732C6B69295B6B695D2874297D7D6E2851352C225F66657463685374617475733222293B66756E6374696F6E204A3528692C65297B6C65';
wwv_flow_imp.g_varchar2_table(4846) := '7420743D692E6F6B2C723D652E6F6B3B696628652E6572726F72262621692E6572726F722972657475726E20636528746869732C6B69295B6B695D2865293B6C657420733D726828722C797029262621726828742C7970293B732626746869732E656D69';
wwv_flow_imp.g_varchar2_table(4847) := '742822657865637574696E6722292C4F626A6563742E6B65797328652E75706C6F616473292E66696C746572286F3D3E21597428692E75706C6F6164732C6F29292E666F7245616368286F3D3E7B746869732E656D6974282275706C6F6164222C652E75';
wwv_flow_imp.g_varchar2_table(4848) := '706C6F6164735B6F5D297D292C732626746869732E656D697428226D6574616461746122292C4F626A6563742E6B65797328652E726573756C7473292E666F7245616368286F3D3E7B6C657420613D652E726573756C74735B6F5D2C6C3D692E72657375';
wwv_flow_imp.g_varchar2_table(4849) := '6C74735B6F5D3B612E66696C74657228683D3E216C7C7C216C2E736F6D6528633D3E632E69643D3D3D682E696429292E666F724561636828683D3E7B746869732E656D69742822726573756C74222C6F2C68297D297D292C726828722C76702926262172';
wwv_flow_imp.g_varchar2_table(4850) := '6828742C7670292626746869732E656D6974282266696E697368656422297D6E284A352C225F646966665374617475733222293B7661722077703D73683B66756E6374696F6E20496528692C65297B696628214F626A6563742E70726F746F747970652E';
wwv_flow_imp.g_varchar2_table(4851) := '6861734F776E50726F70657274792E63616C6C28692C6529297468726F77206E657720547970654572726F722822617474656D7074656420746F207573652070726976617465206669656C64206F6E206E6F6E2D696E7374616E636522293B7265747572';
wwv_flow_imp.g_varchar2_table(4852) := '6E20697D6E2849652C225F636C617373507269766174654669656C644C6F6F73654261736522293B766172205A353D303B66756E6374696F6E206F682869297B72657475726E225F5F707269766174655F222B5A352B2B2B225F222B697D6E286F682C22';
wwv_flow_imp.g_varchar2_table(4853) := '5F636C617373507269766174654669656C644C6F6F73654B657922293B7661722056303D222F617373656D626C696573222C42743D6F6828226865616465727322292C656C3D6F6828226665746368576974684E6574776F726B4572726F7222292C6274';
wwv_flow_imp.g_varchar2_table(4854) := '3D6F68282266657463684A534F4E22292C6C693D6F6828227265706F72744572726F7222292C726E3D636C6173737B636F6E7374727563746F722865297B653D3D3D766F69642030262628653D7B7D292C4F626A6563742E646566696E6550726F706572';
wwv_flow_imp.g_varchar2_table(4855) := '747928746869732C62742C7B76616C75653A65467D292C4F626A6563742E646566696E6550726F706572747928746869732C42742C7B7772697461626C653A21302C76616C75653A7B7D7D292C4F626A6563742E646566696E6550726F70657274792874';
wwv_flow_imp.g_varchar2_table(4856) := '6869732C656C2C7B7772697461626C653A21302C76616C75653A766F696420307D292C4F626A6563742E646566696E6550726F706572747928746869732C6C692C7B7772697461626C653A21302C76616C75653A28742C72293D3E7B696628746869732E';
wwv_flow_imp.g_varchar2_table(4857) := '6F7074732E6572726F725265706F7274696E673D3D3D2131297468726F7720743B6C657420733D7B747970653A722E747970657D3B7468726F7720722E617373656D626C79262628732E617373656D626C793D722E617373656D626C792E617373656D62';
wwv_flow_imp.g_varchar2_table(4858) := '6C795F69642C732E696E7374616E63653D722E617373656D626C792E696E7374616E6365292C722E75726C262628732E656E64706F696E743D722E75726C292C746869732E7375626D69744572726F7228742C73292E63617463682828293D3E7B7D292C';
wwv_flow_imp.g_varchar2_table(4859) := '747D7D292C746869732E6F7074733D652C746869732E6F7074732E636C69656E74213D6E756C6C262628496528746869732C4274295B42745D5B225472616E736C6F616469742D436C69656E74225D3D746869732E6F7074732E636C69656E74292C4965';
wwv_flow_imp.g_varchar2_table(4860) := '28746869732C656C295B656C5D3D746869732E6F7074732E726174654C696D6974656451756575652E7772617050726F6D69736546756E6374696F6E285073297D637265617465417373656D626C792865297B6C65747B706172616D733A742C6669656C';
wwv_flow_imp.g_varchar2_table(4861) := '64733A722C7369676E61747572653A732C657870656374656446696C65733A6F7D3D652C613D6E657720466F726D446174613B612E617070656E642822706172616D73222C747970656F6620743D3D22737472696E67223F743A4A534F4E2E737472696E';
wwv_flow_imp.g_varchar2_table(4862) := '67696679287429292C732626612E617070656E6428227369676E6174757265222C73292C4F626A6563742E6B6579732872292E666F724561636828683D3E7B612E617070656E6428682C725B685D297D292C612E617070656E6428226E756D5F65787065';
wwv_flow_imp.g_varchar2_table(4863) := '637465645F75706C6F61645F66696C6573222C6F293B6C6574206C3D6E65772055524C2856302C60247B746869732E6F7074732E736572766963657D60292E687265663B72657475726E20496528746869732C6274295B62745D286C2C7B6D6574686F64';
wwv_flow_imp.g_varchar2_table(4864) := '3A22504F5354222C686561646572733A496528746869732C4274295B42745D2C626F64793A617D292E636174636828683D3E496528746869732C6C69295B6C695D28682C7B75726C3A6C2C747970653A224150495F4552524F52227D29297D7265736572';
wwv_flow_imp.g_varchar2_table(4865) := '766546696C6528652C74297B6C657420723D656E636F6465555249436F6D706F6E656E7428742E73697A65292C733D60247B652E617373656D626C795F73736C5F75726C7D2F726573657276655F66696C653F73697A653D247B727D603B72657475726E';
wwv_flow_imp.g_varchar2_table(4866) := '20496528746869732C6274295B62745D28732C7B6D6574686F643A22504F5354222C686561646572733A496528746869732C4274295B42745D7D292E6361746368286F3D3E496528746869732C6C69295B6C695D286F2C7B617373656D626C793A652C66';
wwv_flow_imp.g_varchar2_table(4867) := '696C653A742C75726C3A732C747970653A224150495F4552524F52227D29297D61646446696C6528652C74297B69662821742E75706C6F616455524C2972657475726E2050726F6D6973652E72656A656374286E6577204572726F72282246696C652064';
wwv_flow_imp.g_varchar2_table(4868) := '6F6573206E6F74206861766520616E206075706C6F616455524C602E2229293B6C657420723D656E636F6465555249436F6D706F6E656E7428742E73697A65292C733D656E636F6465555249436F6D706F6E656E7428742E75706C6F616455524C292C6F';
wwv_flow_imp.g_varchar2_table(4869) := '3D656E636F6465555249436F6D706F6E656E7428742E6E616D65292C6C3D6073697A653D247B727D2666696C656E616D653D247B6F7D266669656C646E616D653D66696C6526733355726C3D247B737D602C683D60247B652E617373656D626C795F7373';
wwv_flow_imp.g_varchar2_table(4870) := '6C5F75726C7D2F6164645F66696C653F247B6C7D603B72657475726E20496528746869732C6274295B62745D28682C7B6D6574686F643A22504F5354222C686561646572733A496528746869732C4274295B42745D7D292E636174636828633D3E496528';
wwv_flow_imp.g_varchar2_table(4871) := '746869732C6C69295B6C695D28632C7B617373656D626C793A652C66696C653A742C75726C3A682C747970653A224150495F4552524F52227D29297D7570646174654E756D6265724F6646696C6573496E417373656D626C7928652C74297B6C65742072';
wwv_flow_imp.g_varchar2_table(4872) := '3D6E65772055524C28652E617373656D626C795F73736C5F75726C293B722E706174686E616D653D222F7570646174655F617373656D626C696573223B6C657420733D4A534F4E2E737472696E67696679287B617373656D626C795F757064617465733A';
wwv_flow_imp.g_varchar2_table(4873) := '5B7B617373656D626C795F69643A652E617373656D626C795F69642C6E756D5F65787065637465645F75706C6F61645F66696C65733A747D5D7D293B72657475726E20496528746869732C6274295B62745D28722C7B6D6574686F643A22504F5354222C';
wwv_flow_imp.g_varchar2_table(4874) := '686561646572733A496528746869732C4274295B42745D2C626F64793A737D292E6361746368286F3D3E496528746869732C6C69295B6C695D286F2C7B75726C3A722C747970653A224150495F4552524F52227D29297D63616E63656C417373656D626C';
wwv_flow_imp.g_varchar2_table(4875) := '792865297B6C657420743D652E617373656D626C795F73736C5F75726C3B72657475726E20496528746869732C6274295B62745D28742C7B6D6574686F643A2244454C455445222C686561646572733A496528746869732C4274295B42745D7D292E6361';
wwv_flow_imp.g_varchar2_table(4876) := '74636828723D3E496528746869732C6C69295B6C695D28722C7B75726C3A742C747970653A224150495F4552524F52227D29297D676574417373656D626C795374617475732865297B72657475726E20496528746869732C6274295B62745D28652C7B68';
wwv_flow_imp.g_varchar2_table(4877) := '6561646572733A496528746869732C4274295B42745D7D292E636174636828743D3E496528746869732C6C69295B6C695D28742C7B75726C3A652C747970653A225354415455535F4552524F52227D29297D7375626D69744572726F7228652C74297B6C';
wwv_flow_imp.g_varchar2_table(4878) := '65747B656E64706F696E743A722C696E7374616E63653A732C617373656D626C793A6F7D3D743D3D3D766F696420303F7B7D3A742C613D652E64657461696C733F60247B652E6D6573736167657D2028247B652E64657461696C737D29603A652E6D6573';
wwv_flow_imp.g_varchar2_table(4879) := '736167653B72657475726E20496528746869732C6274295B62745D282268747470733A2F2F7472616E736C6F616469747374617475732E636F6D2F636C69656E745F6572726F72222C7B6D6574686F643A22504F5354222C626F64793A4A534F4E2E7374';
wwv_flow_imp.g_varchar2_table(4880) := '72696E67696679287B656E64706F696E743A722C696E7374616E63653A732C617373656D626C795F69643A6F2C6167656E743A747970656F66206E6176696761746F723C2275223F6E6176696761746F722E757365724167656E743A22222C636C69656E';
wwv_flow_imp.g_varchar2_table(4881) := '743A746869732E6F7074732E636C69656E742C6572726F723A617D297D297D7D3B6E28726E2C22436C69656E7422293B66756E6374696F6E20654628297B666F722876617220693D617267756D656E74732E6C656E6774682C653D6E6577204172726179';
wwv_flow_imp.g_varchar2_table(4882) := '2869292C743D303B743C693B742B2B29655B745D3D617267756D656E74735B745D3B72657475726E20496528746869732C656C295B656C5D282E2E2E65292E7468656E28723D3E7B696628722E7374617475733D3D3D3432392972657475726E20746869';
wwv_flow_imp.g_varchar2_table(4883) := '732E6F7074732E726174654C696D6974656451756575652E726174654C696D697428326533292C496528746869732C6274295B62745D282E2E2E65293B69662821722E6F6B297B6C657420733D6E6577204572726F7228722E7374617475735465787429';
wwv_flow_imp.g_varchar2_table(4884) := '3B72657475726E20732E737461747573436F64653D722E7374617475732C60247B655B305D7D602E656E647357697468285630293F722E6A736F6E28292E7468656E286F3D3E7B696628216F2E6572726F72297468726F7720733B6C657420613D6E6577';
wwv_flow_imp.g_varchar2_table(4885) := '204572726F72286F2E6572726F72293B7468726F7720612E64657461696C733D6F2E6D6573736167652C612E617373656D626C793D6F2C6F2E617373656D626C795F6964262628612E64657461696C732B3D6020417373656D626C792049443A20247B6F';
wwv_flow_imp.g_varchar2_table(4886) := '2E617373656D626C795F69647D60292C617D2C6F3D3E7B7468726F77206F2E63617573653D732C6F7D293A50726F6D6973652E72656A6563742873297D72657475726E20722E6A736F6E28297D297D6E2865462C225F66657463684A534F4E3222293B66';
wwv_flow_imp.g_varchar2_table(4887) := '756E6374696F6E2053702869297B696628693D3D6E756C6C297468726F77206E6577204572726F7228225472616E736C6F616469743A205468652060706172616D7360206F7074696F6E2069732072657175697265642E22293B696628747970656F6620';
wwv_flow_imp.g_varchar2_table(4888) := '693D3D22737472696E6722297472797B693D4A534F4E2E70617273652869297D63617463682865297B7468726F77206E657720767228225472616E736C6F616469743A205468652060706172616D7360206F7074696F6E2069732061206D616C666F726D';
wwv_flow_imp.g_varchar2_table(4889) := '6564204A534F4E20737472696E672E222C7B63617573653A657D297D69662821692E617574687C7C21692E617574682E6B6579297468726F77206E6577204572726F7228225472616E736C6F616469743A205468652060706172616D732E617574682E6B';
wwv_flow_imp.g_varchar2_table(4890) := '657960206F7074696F6E2069732072657175697265642E20596F752063616E2066696E6420796F7572205472616E736C6F6164697420415049206B65792061742068747470733A2F2F7472616E736C6F616469742E636F6D2F632F74656D706C6174652D';
wwv_flow_imp.g_varchar2_table(4891) := '63726564656E7469616C7322297D6E2853702C2276616C6964617465506172616D7322293B66756E6374696F6E2074462869297B6C657420653D4F626A6563742E637265617465286E756C6C293B666F72286C65747B66696C654944733A742C6F707469';
wwv_flow_imp.g_varchar2_table(4892) := '6F6E733A727D6F6620692E66696C74657228426F6F6C65616E29297B6C657420733D4A534F4E2E737472696E676966792872293B7320696E20653F655B735D2E66696C6549444172726179732E707573682874293A655B735D3D7B6F7074696F6E733A72';
wwv_flow_imp.g_varchar2_table(4893) := '2C66696C6549444172726179733A5B745D7D7D72657475726E204F626A6563742E76616C7565732865292E6D617028743D3E7B6C65747B6F7074696F6E733A722C66696C6549444172726179733A737D3D743B72657475726E7B6F7074696F6E733A722C';
wwv_flow_imp.g_varchar2_table(4894) := '66696C654944733A732E666C61742831297D7D297D6E2874462C2264656475706522293B6173796E632066756E6374696F6E20573028692C65297B6C657420743D747970656F6620652E617373656D626C794F7074696F6E733D3D2266756E6374696F6E';
wwv_flow_imp.g_varchar2_table(4895) := '223F617761697420652E617373656D626C794F7074696F6E7328692C65293A652E617373656D626C794F7074696F6E733B537028742E706172616D73293B6C65747B6669656C64733A727D3D743B72657475726E2041727261792E697341727261792872';
wwv_flow_imp.g_varchar2_table(4896) := '293F742E6669656C64733D693D3D6E756C6C3F7B7D3A4F626A6563742E66726F6D456E747269657328722E6D617028733D3E5B732C692E6D6574615B735D5D29293A723D3D6E756C6C262628742E6669656C64733D7B7D292C747D6E2857302C22676574';
wwv_flow_imp.g_varchar2_table(4897) := '417373656D626C794F7074696F6E7322293B766172206E683D636C6173737B636F6E7374727563746F7228652C74297B746869732E66696C65733D652C746869732E6F7074733D747D6173796E63206275696C6428297B6C657420653D746869732E6F70';
wwv_flow_imp.g_varchar2_table(4898) := '74733B696628746869732E66696C65732E6C656E6774683E302972657475726E2050726F6D6973652E616C6C28746869732E66696C65732E6D6170286173796E6320743D3E7B696628743D3D6E756C6C2972657475726E3B6C657420723D617761697420';
wwv_flow_imp.g_varchar2_table(4899) := '573028742C65293B69662874213D6E756C6C2972657475726E7B66696C654944733A5B742E69645D2C6F7074696F6E733A727D7D29292E7468656E287446293B696628652E616C7761797352756E417373656D626C79297B6C657420743D617761697420';
wwv_flow_imp.g_varchar2_table(4900) := '5730286E756C6C2C65293B72657475726E5B7B66696C654944733A5B5D2C6F7074696F6E733A747D5D7D72657475726E5B5D7D7D3B6E286E682C22417373656D626C794F7074696F6E7322293B7661722047303D6E683B766172204B303D646528707028';
wwv_flow_imp.g_varchar2_table(4901) := '292C31293B66756E6374696F6E20736528692C65297B696628214F626A6563742E70726F746F747970652E6861734F776E50726F70657274792E63616C6C28692C6529297468726F77206E657720547970654572726F722822617474656D707465642074';
wwv_flow_imp.g_varchar2_table(4902) := '6F207573652070726976617465206669656C64206F6E206E6F6E2D696E7374616E636522293B72657475726E20697D6E2873652C225F636C617373507269766174654669656C644C6F6F73654261736522293B7661722069463D303B66756E6374696F6E';
wwv_flow_imp.g_varchar2_table(4903) := '2075692869297B72657475726E225F5F707269766174655F222B69462B2B2B225F222B697D6E2875692C225F636C617373507269766174654669656C644C6F6F73654B657922293B76617220746C3D75692822617373656D626C7949447322292C50703D';
wwv_flow_imp.g_varchar2_table(4904) := '7569282272656A65637422292C636F3D7569282272656D61696E696E6722292C696C3D756928227265736F6C766522292C43653D756928227570707922292C7A723D756928227761746368696E6722292C726C3D756928226F6E417373656D626C79436F';
wwv_flow_imp.g_varchar2_table(4905) := '6D706C65746522292C736C3D756928226F6E417373656D626C7943616E63656C22292C706F3D756928226F6E417373656D626C794572726F7222292C6F6C3D756928226F6E496D706F72744572726F7222292C686F3D75692822636865636B416C6C436F';
wwv_flow_imp.g_varchar2_table(4906) := '6D706C65746522292C46703D7569282272656D6F76654C697374656E65727322292C5F703D756928226164644C697374656E65727322292C61683D636C61737320657874656E6473204B302E64656661756C747B636F6E7374727563746F7228652C7429';
wwv_flow_imp.g_varchar2_table(4907) := '7B737570657228292C4F626A6563742E646566696E6550726F706572747928746869732C5F702C7B76616C75653A6E467D292C4F626A6563742E646566696E6550726F706572747928746869732C46702C7B76616C75653A6F467D292C4F626A6563742E';
wwv_flow_imp.g_varchar2_table(4908) := '646566696E6550726F706572747928746869732C686F2C7B76616C75653A73467D292C4F626A6563742E646566696E6550726F706572747928746869732C7A722C7B76616C75653A72467D292C4F626A6563742E646566696E6550726F70657274792874';
wwv_flow_imp.g_varchar2_table(4909) := '6869732C746C2C7B7772697461626C653A21302C76616C75653A766F696420307D292C4F626A6563742E646566696E6550726F706572747928746869732C50702C7B7772697461626C653A21302C76616C75653A766F696420307D292C4F626A6563742E';
wwv_flow_imp.g_varchar2_table(4910) := '646566696E6550726F706572747928746869732C636F2C7B7772697461626C653A21302C76616C75653A766F696420307D292C4F626A6563742E646566696E6550726F706572747928746869732C696C2C7B7772697461626C653A21302C76616C75653A';
wwv_flow_imp.g_varchar2_table(4911) := '766F696420307D292C4F626A6563742E646566696E6550726F706572747928746869732C43652C7B7772697461626C653A21302C76616C75653A766F696420307D292C4F626A6563742E646566696E6550726F706572747928746869732C726C2C7B7772';
wwv_flow_imp.g_varchar2_table(4912) := '697461626C653A21302C76616C75653A723D3E7B736528746869732C7A72295B7A725D28722E617373656D626C795F696429262628736528746869732C4365295B43655D2E6C6F6728605B5472616E736C6F616469745D20417373656D626C7957617463';
wwv_flow_imp.g_varchar2_table(4913) := '6865723A20476F7420417373656D626C792066696E69736820247B722E617373656D626C795F69647D60292C746869732E656D69742822617373656D626C792D636F6D706C657465222C722E617373656D626C795F6964292C736528746869732C686F29';
wwv_flow_imp.g_varchar2_table(4914) := '5B686F5D2829297D7D292C4F626A6563742E646566696E6550726F706572747928746869732C736C2C7B7772697461626C653A21302C76616C75653A723D3E7B736528746869732C7A72295B7A725D28722E617373656D626C795F696429262673652874';
wwv_flow_imp.g_varchar2_table(4915) := '6869732C686F295B686F5D28297D7D292C4F626A6563742E646566696E6550726F706572747928746869732C706F2C7B7772697461626C653A21302C76616C75653A28722C73293D3E7B736528746869732C7A72295B7A725D28722E617373656D626C79';
wwv_flow_imp.g_varchar2_table(4916) := '5F696429262628736528746869732C4365295B43655D2E6C6F6728605B5472616E736C6F616469745D20417373656D626C79576174636865723A20476F7420417373656D626C79206572726F7220247B722E617373656D626C795F69647D60292C736528';
wwv_flow_imp.g_varchar2_table(4917) := '746869732C4365295B43655D2E6C6F672873292C746869732E656D69742822617373656D626C792D6572726F72222C722E617373656D626C795F69642C73292C736528746869732C686F295B686F5D2829297D7D292C4F626A6563742E646566696E6550';
wwv_flow_imp.g_varchar2_table(4918) := '726F706572747928746869732C6F6C2C7B7772697461626C653A21302C76616C75653A28722C732C6F293D3E7B736528746869732C7A72295B7A725D28722E617373656D626C795F6964292626736528746869732C706F295B706F5D28722C6F297D7D29';
wwv_flow_imp.g_varchar2_table(4919) := '2C736528746869732C4365295B43655D3D652C736528746869732C746C295B746C5D3D742C736528746869732C636F295B636F5D3D742E6C656E6774682C746869732E70726F6D6973653D6E65772050726F6D6973652828722C73293D3E7B7365287468';
wwv_flow_imp.g_varchar2_table(4920) := '69732C696C295B696C5D3D722C736528746869732C5070295B50705D3D737D292C736528746869732C5F70295B5F705D28297D7D3B6E2861682C225472616E736C6F61646974417373656D626C795761746368657222293B66756E6374696F6E20724628';
wwv_flow_imp.g_varchar2_table(4921) := '69297B72657475726E20736528746869732C746C295B746C5D2E696E6465784F66286929213D3D2D317D6E2872462C225F7761746368696E673222293B66756E6374696F6E20734628297B736528746869732C636F295B636F5D2D3D312C736528746869';
wwv_flow_imp.g_varchar2_table(4922) := '732C636F295B636F5D3D3D3D30262628736528746869732C4670295B46705D28292C736528746869732C696C295B696C5D2829297D6E2873462C225F636865636B416C6C436F6D706C6574653222293B66756E6374696F6E206F4628297B736528746869';
wwv_flow_imp.g_varchar2_table(4923) := '732C4365295B43655D2E6F666628227472616E736C6F616469743A636F6D706C657465222C736528746869732C726C295B726C5D292C736528746869732C4365295B43655D2E6F666628227472616E736C6F616469743A617373656D626C792D63616E63';
wwv_flow_imp.g_varchar2_table(4924) := '656C222C736528746869732C736C295B736C5D292C736528746869732C4365295B43655D2E6F666628227472616E736C6F616469743A617373656D626C792D6572726F72222C736528746869732C706F295B706F5D292C736528746869732C4365295B43';
wwv_flow_imp.g_varchar2_table(4925) := '655D2E6F666628227472616E736C6F616469743A696D706F72742D6572726F72222C736528746869732C6F6C295B6F6C5D297D6E286F462C225F72656D6F76654C697374656E6572733222293B66756E6374696F6E206E4628297B736528746869732C43';
wwv_flow_imp.g_varchar2_table(4926) := '65295B43655D2E6F6E28227472616E736C6F616469743A636F6D706C657465222C736528746869732C726C295B726C5D292C736528746869732C4365295B43655D2E6F6E28227472616E736C6F616469743A617373656D626C792D63616E63656C222C73';
wwv_flow_imp.g_varchar2_table(4927) := '6528746869732C736C295B736C5D292C736528746869732C4365295B43655D2E6F6E28227472616E736C6F616469743A617373656D626C792D6572726F72222C736528746869732C706F295B706F5D292C736528746869732C4365295B43655D2E6F6E28';
wwv_flow_imp.g_varchar2_table(4928) := '227472616E736C6F616469743A696D706F72742D6572726F72222C736528746869732C6F6C295B6F6C5D297D6E286E462C225F6164644C697374656E6572733222293B7661722058303D61683B7661722059303D7B737472696E67733A7B637265617469';
wwv_flow_imp.g_varchar2_table(4929) := '6E67417373656D626C793A22507265706172696E672075706C6F61642E2E2E222C6372656174696E67417373656D626C794661696C65643A225472616E736C6F616469743A20436F756C64206E6F742063726561746520417373656D626C79222C656E63';
wwv_flow_imp.g_varchar2_table(4930) := '6F64696E673A22456E636F64696E672E2E2E227D7D3B66756E6374696F6E20616528692C65297B696628214F626A6563742E70726F746F747970652E6861734F776E50726F70657274792E63616C6C28692C6529297468726F77206E6577205479706545';
wwv_flow_imp.g_varchar2_table(4931) := '72726F722822617474656D7074656420746F207573652070726976617465206669656C64206F6E206E6F6E2D696E7374616E636522293B72657475726E20697D6E2861652C225F636C617373507269766174654669656C644C6F6F73654261736522293B';
wwv_flow_imp.g_varchar2_table(4932) := '7661722061463D303B66756E6374696F6E204C652869297B72657475726E225F5F707269766174655F222B61462B2B2B225F222B697D6E284C652C225F636C617373507269766174654669656C644C6F6F73654B657922293B766172206C463D7B766572';
wwv_flow_imp.g_varchar2_table(4933) := '73696F6E3A22332E342E30227D2C51303D6E28693D3E653D3E7B6C657420743D6E657720767228224661696C656420746F2073656E64206572726F7220746F2074686520636C69656E74222C7B63617573653A657D293B636F6E736F6C652E6572726F72';
wwv_flow_imp.g_varchar2_table(4934) := '28742C69297D2C2273656E644572726F72546F436F6E736F6C6522292C4D703D2268747470733A2F2F617069322E7472616E736C6F616469742E636F6D2F636F6D70616E696F6E222C4E703D2F5C2E7472616E736C6F616469745C2E636F6D242F2C7546';
wwv_flow_imp.g_varchar2_table(4935) := '3D2F68747470733F3A5C2F5C2F61706932283F3A2D5C772B293F5C2E7472616E736C6F616469745C2E636F6D5C2F636F6D70616E696F6E2F2C44693D4C652822726174654C696D69746564517565756522292C78703D4C652822676574436C69656E7456';
wwv_flow_imp.g_varchar2_table(4936) := '657273696F6E22292C6B703D4C652822617474616368417373656D626C794D6574616461746122292C45703D4C652822637265617465417373656D626C7922292C6E6C3D4C652822637265617465417373656D626C795761746368657222292C43703D4C';
wwv_flow_imp.g_varchar2_table(4937) := '65282273686F756C6457616974416674657255706C6F616422292C4F703D4C6528227265736572766546696C657322292C616C3D4C6528226F6E46696C6555706C6F616455524C417661696C61626C6522292C706C3D4C65282266696E6446696C652229';
wwv_flow_imp.g_varchar2_table(4938) := '2C44703D4C6528226F6E46696C6555706C6F6164436F6D706C65746522292C49703D4C6528226F6E526573756C7422292C636C3D4C6528226F6E417373656D626C7946696E697368656422292C666C3D4C65282263616E63656C417373656D626C792229';
wwv_flow_imp.g_varchar2_table(4939) := '2C54703D4C6528226F6E43616E63656C416C6C22292C41703D4C65282267657450657273697374656E744461746122292C52703D4C6528226F6E526573746F72656422292C6C6C3D4C652822636F6E6E656374417373656D626C7922292C756C3D4C6528';
wwv_flow_imp.g_varchar2_table(4940) := '227072657061726555706C6F616422292C666F3D4C652822616674657255706C6F616422292C686C3D4C652822636C6F7365417373656D626C79496645786973747322292C646C3D4C6528226F6E4572726F7222292C55703D4C6528226F6E5475734572';
wwv_flow_imp.g_varchar2_table(4941) := '726F7222292C76693D636C61737320657874656E64732076657B636F6E7374727563746F7228652C74297B76617220722C732C6F2C613B737570657228652C74292C723D746869732C4F626A6563742E646566696E6550726F706572747928746869732C';
wwv_flow_imp.g_varchar2_table(4942) := '6C6C2C7B76616C75653A53467D292C4F626A6563742E646566696E6550726F706572747928746869732C666C2C7B76616C75653A77467D292C4F626A6563742E646566696E6550726F706572747928746869732C636C2C7B76616C75653A62467D292C4F';
wwv_flow_imp.g_varchar2_table(4943) := '626A6563742E646566696E6550726F706572747928746869732C49702C7B76616C75653A76467D292C4F626A6563742E646566696E6550726F706572747928746869732C44702C7B76616C75653A79467D292C4F626A6563742E646566696E6550726F70';
wwv_flow_imp.g_varchar2_table(4944) := '6572747928746869732C706C2C7B76616C75653A67467D292C4F626A6563742E646566696E6550726F706572747928746869732C4F702C7B76616C75653A6D467D292C4F626A6563742E646566696E6550726F706572747928746869732C43702C7B7661';
wwv_flow_imp.g_varchar2_table(4945) := '6C75653A66467D292C4F626A6563742E646566696E6550726F706572747928746869732C6E6C2C7B76616C75653A70467D292C4F626A6563742E646566696E6550726F706572747928746869732C45702C7B76616C75653A63467D292C4F626A6563742E';
wwv_flow_imp.g_varchar2_table(4946) := '646566696E6550726F706572747928746869732C6B702C7B76616C75653A64467D292C4F626A6563742E646566696E6550726F706572747928746869732C78702C7B76616C75653A68467D292C4F626A6563742E646566696E6550726F70657274792874';
wwv_flow_imp.g_varchar2_table(4947) := '6869732C44692C7B7772697461626C653A21302C76616C75653A766F696420307D292C4F626A6563742E646566696E6550726F706572747928746869732C616C2C7B7772697461626C653A21302C76616C75653A683D3E7B76617220633B6C657420643D';
wwv_flow_imp.g_varchar2_table(4948) := '746869732E757070792E67657446696C6528682E6964293B696628212864213D6E756C6C262628633D642E7472616E736C6F6164697429213D6E756C6C2626632E617373656D626C79292972657475726E3B6C65747B617373656D626C6965733A667D3D';
wwv_flow_imp.g_varchar2_table(4949) := '746869732E676574506C7567696E537461746528292C793D665B642E7472616E736C6F616469742E617373656D626C795D3B746869732E636C69656E742E61646446696C6528792C64292E636174636828623D3E7B746869732E757070792E6C6F672862';
wwv_flow_imp.g_varchar2_table(4950) := '292C746869732E757070792E656D697428227472616E736C6F616469743A696D706F72742D6572726F72222C792C642E69642C62297D297D7D292C4F626A6563742E646566696E6550726F706572747928746869732C54702C7B7772697461626C653A21';
wwv_flow_imp.g_varchar2_table(4951) := '302C76616C75653A6173796E632066756E6374696F6E2868297B6C65747B726561736F6E3A637D3D683D3D3D766F696420303F7B7D3A683B7472797B69662863213D3D2275736572222972657475726E3B6C65747B75706C6F616473417373656D626C69';
wwv_flow_imp.g_varchar2_table(4952) := '65733A647D3D722E676574506C7567696E537461746528292C793D4F626A6563742E76616C7565732864292E666C61742831292E6D617028623D3E722E676574417373656D626C79286229293B61776169742050726F6D6973652E616C6C28792E6D6170';
wwv_flow_imp.g_varchar2_table(4953) := '28623D3E616528722C666C295B666C5D28622929297D63617463682864297B722E757070792E6C6F672864297D7D7D292C4F626A6563742E646566696E6550726F706572747928746869732C41702C7B7772697461626C653A21302C76616C75653A683D';
wwv_flow_imp.g_varchar2_table(4954) := '3E7B6C65747B617373656D626C6965733A632C75706C6F616473417373656D626C6965733A647D3D746869732E676574506C7567696E537461746528293B68287B5B746869732E69645D3A7B617373656D626C6965733A632C75706C6F61647341737365';
wwv_flow_imp.g_varchar2_table(4955) := '6D626C6965733A647D7D297D7D292C4F626A6563742E646566696E6550726F706572747928746869732C52702C7B7772697461626C653A21302C76616C75653A683D3E7B6C657420633D682626685B746869732E69645D3F685B746869732E69645D3A7B';
wwv_flow_imp.g_varchar2_table(4956) := '7D2C643D632E617373656D626C6965737C7C7B7D2C663D632E75706C6F616473417373656D626C6965737C7C7B7D3B6966284F626A6563742E6B6579732866292E6C656E6774683D3D3D302972657475726E3B6C657420793D6E28453D3E7B6C65742046';
wwv_flow_imp.g_varchar2_table(4957) := '3D7B7D2C783D5B5D3B666F72286C65745B552C6A5D6F66204F626A6563742E656E7472696573284529297B6A2E75706C6F6164732E666F7245616368284A3D3E7B6C657420423D616528746869732C706C295B706C5D284A293B465B4A2E69645D3D7B69';
wwv_flow_imp.g_varchar2_table(4958) := '643A422E69642C617373656D626C793A552C75706C6F6164656446696C653A4A7D7D293B6C657420473D746869732E676574506C7567696E537461746528293B4F626A6563742E6B657973286A2E726573756C7473292E666F7245616368284A3D3E7B66';
wwv_flow_imp.g_varchar2_table(4959) := '6F72286C65742042206F66206A2E726573756C74735B4A5D297B6C6574207A3D472E66696C65735B422E6F726967696E616C5F69645D3B422E6C6F63616C49643D7A3F7A2E69643A6E756C6C2C782E70757368287B69643A422E69642C726573756C743A';
wwv_flow_imp.g_varchar2_table(4960) := '422C737465704E616D653A4A2C617373656D626C793A557D297D7D297D746869732E736574506C7567696E5374617465287B617373656D626C6965733A452C66696C65733A462C726573756C74733A782C75706C6F616473417373656D626C6965733A66';
wwv_flow_imp.g_varchar2_table(4961) := '7D297D2C22726573746F7265537461746522292C623D6E2828293D3E7B6C65747B617373656D626C6965733A452C75706C6F616473417373656D626C6965733A467D3D746869732E676574506C7567696E537461746528293B4F626A6563742E6B657973';
wwv_flow_imp.g_varchar2_table(4962) := '2846292E666F724561636828553D3E7B6C6574206A3D465B555D3B616528746869732C6E6C295B6E6C5D286A2C55297D292C4F626A6563742E6B6579732845292E666F724561636828553D3E7B6C6574206A3D6E657720777028455B555D2C6165287468';
wwv_flow_imp.g_varchar2_table(4963) := '69732C4469295B44695D293B616528746869732C6C6C295B6C6C5D286A297D297D2C22726573746F7265417373656D626C69657322292C533D6E2828293D3E7B6C65747B617373656D626C6965733A457D3D746869732E676574506C7567696E53746174';
wwv_flow_imp.g_varchar2_table(4964) := '6528293B72657475726E2050726F6D6973652E616C6C284F626A6563742E6B6579732845292E6D617028463D3E746869732E616374697665417373656D626C6965735B465D2E757064617465282929297D2C22757064617465417373656D626C69657322';
wwv_flow_imp.g_varchar2_table(4965) := '293B746869732E726573746F7265643D50726F6D6973652E7265736F6C766528292E7468656E2828293D3E28792864292C6228292C53282929292C746869732E726573746F7265642E7468656E2828293D3E7B746869732E726573746F7265643D6E756C';
wwv_flow_imp.g_varchar2_table(4966) := '6C7D297D7D292C4F626A6563742E646566696E6550726F706572747928746869732C756C2C7B7772697461626C653A21302C76616C75653A28682C63293D3E7B6C657420663D682E6D617028453D3E746869732E757070792E67657446696C6528452929';
wwv_flow_imp.g_varchar2_table(4967) := '2E66696C74657228453D3E452E6572726F723F21313A28746869732E757070792E656D6974282270726570726F636573732D70726F6772657373222C452C7B6D6F64653A22696E64657465726D696E617465222C6D6573736167653A746869732E693138';
wwv_flow_imp.g_varchar2_table(4968) := '6E28226372656174696E67417373656D626C7922297D292C213029292C793D6E286173796E6320453D3E7B6C65747B66696C654944733A462C6F7074696F6E733A787D3D453B7472797B6C657420553D617761697420616528746869732C4570295B4570';
wwv_flow_imp.g_varchar2_table(4969) := '5D28462C632C78293B72657475726E20746869732E6F7074732E696D706F727446726F6D55706C6F616455524C732626617761697420616528746869732C4F70295B4F705D28552C46292C462E666F7245616368286A3D3E7B6C657420473D746869732E';
wwv_flow_imp.g_varchar2_table(4970) := '757070792E67657446696C65286A293B746869732E757070792E656D6974282270726570726F636573732D636F6D706C657465222C47297D292C557D63617463682855297B7468726F7720462E666F7245616368286A3D3E7B6C657420473D746869732E';
wwv_flow_imp.g_varchar2_table(4971) := '757070792E67657446696C65286A293B746869732E757070792E656D6974282270726570726F636573732D636F6D706C657465222C47292C746869732E757070792E656D6974282275706C6F61642D6572726F72222C472C55297D292C557D7D2C226372';
wwv_flow_imp.g_varchar2_table(4972) := '65617465417373656D626C7922292C7B75706C6F616473417373656D626C6965733A627D3D746869732E676574506C7567696E537461746528293B72657475726E20746869732E736574506C7567696E5374617465287B75706C6F616473417373656D62';
wwv_flow_imp.g_varchar2_table(4973) := '6C6965733A7B2E2E2E622C5B635D3A5B5D7D7D292C6E657720473028662C746869732E6F707473292E6275696C6428292E7468656E28453D3E50726F6D6973652E616C6C28452E6D617028792929292E7468656E28453D3E7B6C657420463D452E66696C';
wwv_flow_imp.g_varchar2_table(4974) := '74657228426F6F6C65616E292C783D462E6D617028553D3E552E7374617475732E617373656D626C795F6964293B72657475726E20616528746869732C6E6C295B6E6C5D28782C63292C50726F6D6973652E616C6C28462E6D617028553D3E6165287468';
wwv_flow_imp.g_varchar2_table(4975) := '69732C6C6C295B6C6C5D28552929297D292E636174636828453D3E7B7468726F7720662E666F724561636828463D3E7B746869732E757070792E656D6974282270726570726F636573732D636F6D706C657465222C46292C746869732E757070792E656D';
wwv_flow_imp.g_varchar2_table(4976) := '6974282275706C6F61642D6572726F72222C462C45297D292C457D297D7D292C4F626A6563742E646566696E6550726F706572747928746869732C666F2C7B7772697461626C653A21302C76616C75653A28682C63293D3E7B6C657420643D682E6D6170';
wwv_flow_imp.g_varchar2_table(4977) := '28783D3E746869732E757070792E67657446696C65287829292C663D642E66696C74657228783D3E21782E6572726F72292E6D617028783D3E782E6964292C793D746869732E676574506C7567696E537461746528293B696628746869732E726573746F';
wwv_flow_imp.g_varchar2_table(4978) := '7265642972657475726E20746869732E726573746F7265642E7468656E2828293D3E616528746869732C666F295B666F5D28662C6329293B6C657420623D792E75706C6F616473417373656D626C6965735B635D2C533D6E2828293D3E7B622E666F7245';
wwv_flow_imp.g_varchar2_table(4979) := '61636828783D3E7B746869732E616374697665417373656D626C6965735B785D2E636C6F736528292C64656C65746520746869732E616374697665417373656D626C6965735B785D7D297D2C22636C6F7365536F636B6574436F6E6E656374696F6E7322';
wwv_flow_imp.g_varchar2_table(4980) := '293B69662821616528746869732C4370295B43705D2829297B5328293B6C657420783D622E6D617028553D3E746869732E676574417373656D626C79285529293B72657475726E20746869732E757070792E616464526573756C744461746128632C7B74';
wwv_flow_imp.g_varchar2_table(4981) := '72616E736C6F616469743A787D292C50726F6D6973652E7265736F6C766528297D72657475726E20622E6C656E6774683D3D3D303F28746869732E757070792E616464526573756C744461746128632C7B7472616E736C6F616469743A5B5D7D292C5072';
wwv_flow_imp.g_varchar2_table(4982) := '6F6D6973652E7265736F6C76652829293A28642E66696C74657228783D3E21597428746869732E636F6D706C6574656446696C65732C782E696429292E666F724561636828783D3E7B746869732E757070792E656D69742822706F737470726F63657373';
wwv_flow_imp.g_varchar2_table(4983) := '2D70726F6772657373222C782C7B6D6F64653A22696E64657465726D696E617465222C6D6573736167653A746869732E6931386E2822656E636F64696E6722297D297D292C746869732E617373656D626C7957617463686572735B635D2E70726F6D6973';
wwv_flow_imp.g_varchar2_table(4984) := '652E7468656E2828293D3E7B5328293B6C657420783D622E6D6170286A3D3E746869732E676574417373656D626C79286A29292C553D7B2E2E2E746869732E676574506C7567696E537461746528292E75706C6F616473417373656D626C6965737D3B64';
wwv_flow_imp.g_varchar2_table(4985) := '656C65746520555B635D2C746869732E736574506C7567696E5374617465287B75706C6F616473417373656D626C6965733A557D292C746869732E757070792E616464526573756C744461746128632C7B7472616E736C6F616469743A787D297D29297D';
wwv_flow_imp.g_varchar2_table(4986) := '7D292C4F626A6563742E646566696E6550726F706572747928746869732C686C2C7B7772697461626C653A21302C76616C75653A683D3E7B76617220633B28633D746869732E616374697665417373656D626C6965735B685D293D3D6E756C6C7C7C632E';
wwv_flow_imp.g_varchar2_table(4987) := '636C6F736528297D7D292C4F626A6563742E646566696E6550726F706572747928746869732C646C2C7B7772697461626C653A21302C76616C75653A66756E6374696F6E28682C63297B683D3D3D766F69642030262628683D6E756C6C293B6C65742066';
wwv_flow_imp.g_varchar2_table(4988) := '3D722E676574506C7567696E537461746528292E75706C6F616473417373656D626C6965735B635D3B663F2E666F724561636828616528722C686C295B686C5D292C722E636C69656E742E7375626D69744572726F722868292E63617463682851302868';
wwv_flow_imp.g_varchar2_table(4989) := '29297D7D292C4F626A6563742E646566696E6550726F706572747928746869732C55702C7B7772697461626C653A21302C76616C75653A28682C63293D3E7B76617220642C663B696628616528746869732C686C295B686C5D28683D3D6E756C6C7C7C28';
wwv_flow_imp.g_varchar2_table(4990) := '643D682E7472616E736C6F61646974293D3D6E756C6C3F766F696420303A642E617373656D626C79292C63213D6E756C6C262628663D632E6D65737361676529213D6E756C6C2626662E7374617274735769746828227475733A202229297B7661722079';
wwv_flow_imp.g_varchar2_table(4991) := '3B6C657420623D28793D632E6F726967696E616C52657175657374293D3D6E756C6C7C7C28793D792E676574556E6465726C79696E674F626A6563742829293D3D6E756C6C3F766F696420303A792E726573706F6E736555524C3B746869732E636C6965';
wwv_flow_imp.g_varchar2_table(4992) := '6E742E7375626D69744572726F7228632C7B656E64706F696E743A622C747970653A225455535F4552524F52227D292E6361746368285130286329297D7D7D292C746869732E747970653D2275706C6F61646572222C746869732E69643D746869732E6F';
wwv_flow_imp.g_varchar2_table(4993) := '7074732E69647C7C225472616E736C6F61646974222C746869732E7469746C653D225472616E736C6F61646974222C746869732E64656661756C744C6F63616C653D59303B6C6574206C3D7B736572766963653A2268747470733A2F2F617069322E7472';
wwv_flow_imp.g_varchar2_table(4994) := '616E736C6F616469742E636F6D222C6572726F725265706F7274696E673A21302C77616974466F72456E636F64696E673A21312C77616974466F724D657461646174613A21312C616C7761797352756E417373656D626C793A21312C696D706F72744672';
wwv_flow_imp.g_varchar2_table(4995) := '6F6D55706C6F616455524C733A21312C7369676E61747572653A6E756C6C2C706172616D733A6E756C6C2C6669656C64733A6E756C6C2C676574417373656D626C794F7074696F6E733A6E756C6C2C6C696D69743A32302C726574727944656C6179733A';
wwv_flow_imp.g_varchar2_table(4996) := '5B3765332C3165342C313565332C3265345D7D3B746869732E6F7074733D7B2E2E2E6C2C2E2E2E747D2C286F3D28733D746869732E6F707473292E617373656D626C794F7074696F6E7329213D6E756C6C7C7C28732E617373656D626C794F7074696F6E';
wwv_flow_imp.g_varchar2_table(4997) := '733D28613D746869732E6F7074732E676574417373656D626C794F7074696F6E7329213D6E756C6C3F613A7B706172616D733A746869732E6F7074732E706172616D732C7369676E61747572653A746869732E6F7074732E7369676E61747572652C6669';
wwv_flow_imp.g_varchar2_table(4998) := '656C64733A746869732E6F7074732E6669656C64737D292C743F2E706172616D73213D6E756C6C2626742E676574417373656D626C794F7074696F6E733D3D6E756C6C2626742E617373656D626C794F7074696F6E733D3D6E756C6C2626537028746869';
wwv_flow_imp.g_varchar2_table(4999) := '732E6F7074732E617373656D626C794F7074696F6E732E706172616D73292C616528746869732C4469295B44695D3D6E6577204E7428746869732E6F7074732E6C696D6974292C746869732E6931386E496E697428292C746869732E636C69656E743D6E';
wwv_flow_imp.g_varchar2_table(5000) := '657720726E287B736572766963653A746869732E6F7074732E736572766963652C636C69656E743A616528746869732C7870295B78705D28292C6572726F725265706F7274696E673A746869732E6F7074732E6572726F725265706F7274696E672C7261';
wwv_flow_imp.g_varchar2_table(5001) := '74654C696D6974656451756575653A616528746869732C4469295B44695D7D292C746869732E616374697665417373656D626C6965733D7B7D2C746869732E617373656D626C7957617463686572733D7B7D2C746869732E636F6D706C6574656446696C';
wwv_flow_imp.g_varchar2_table(5002) := '65733D4F626A6563742E637265617465286E756C6C297D696E7374616C6C28297B746869732E757070792E61646450726550726F636573736F7228616528746869732C756C295B756C5D292C746869732E757070792E616464506F737450726F63657373';
wwv_flow_imp.g_varchar2_table(5003) := '6F7228616528746869732C666F295B666F5D292C746869732E757070792E6F6E28226572726F72222C616528746869732C646C295B646C5D292C746869732E757070792E6F6E282263616E63656C2D616C6C222C616528746869732C5470295B54705D29';
wwv_flow_imp.g_varchar2_table(5004) := '2C746869732E757070792E6F6E282275706C6F61642D6572726F72222C616528746869732C5570295B55705D292C746869732E6F7074732E696D706F727446726F6D55706C6F616455524C733F746869732E757070792E6F6E282275706C6F61642D7375';
wwv_flow_imp.g_varchar2_table(5005) := '6363657373222C616528746869732C616C295B616C5D293A746869732E757070792E757365286F722C7B73746F726546696E6765727072696E74466F72526573756D696E673A21312C616C6C6F7765644D6574614669656C64733A5B22617373656D626C';
wwv_flow_imp.g_varchar2_table(5006) := '795F75726C222C2266696C656E616D65222C226669656C646E616D65225D2C6C696D69743A746869732E6F7074732E6C696D69742C726174654C696D6974656451756575653A616528746869732C4469295B44695D2C726574727944656C6179733A7468';
wwv_flow_imp.g_varchar2_table(5007) := '69732E6F7074732E726574727944656C6179737D292C746869732E757070792E6F6E2822726573746F72653A6765742D64617461222C616528746869732C4170295B41705D292C746869732E757070792E6F6E2822726573746F726564222C6165287468';
wwv_flow_imp.g_varchar2_table(5008) := '69732C5270295B52705D292C746869732E736574506C7567696E5374617465287B617373656D626C6965733A7B7D2C75706C6F616473417373656D626C6965733A7B7D2C66696C65733A7B7D2C726573756C74733A5B5D7D293B6C65747B636170616269';
wwv_flow_imp.g_varchar2_table(5009) := '6C69746965733A657D3D746869732E757070792E676574537461746528293B746869732E757070792E7365745374617465287B6361706162696C69746965733A7B2E2E2E652C696E646976696475616C43616E63656C6C6174696F6E3A21317D7D297D75';
wwv_flow_imp.g_varchar2_table(5010) := '6E696E7374616C6C28297B746869732E757070792E72656D6F766550726550726F636573736F7228616528746869732C756C295B756C5D292C746869732E757070792E72656D6F7665506F737450726F636573736F7228616528746869732C666F295B66';
wwv_flow_imp.g_varchar2_table(5011) := '6F5D292C746869732E757070792E6F666628226572726F72222C616528746869732C646C295B646C5D292C746869732E6F7074732E696D706F727446726F6D55706C6F616455524C732626746869732E757070792E6F6666282275706C6F61642D737563';
wwv_flow_imp.g_varchar2_table(5012) := '63657373222C616528746869732C616C295B616C5D293B6C65747B6361706162696C69746965733A657D3D746869732E757070792E676574537461746528293B746869732E757070792E7365745374617465287B6361706162696C69746965733A7B2E2E';
wwv_flow_imp.g_varchar2_table(5013) := '2E652C696E646976696475616C43616E63656C6C6174696F6E3A21307D7D297D676574417373656D626C792865297B6C65747B617373656D626C6965733A747D3D746869732E676574506C7567696E537461746528293B72657475726E20745B655D7D67';
wwv_flow_imp.g_varchar2_table(5014) := '6574417373656D626C7946696C65732865297B72657475726E20746869732E757070792E67657446696C657328292E66696C74657228743D3E7B76617220723B72657475726E28743D3D6E756C6C7C7C28723D742E7472616E736C6F61646974293D3D6E';
wwv_flow_imp.g_varchar2_table(5015) := '756C6C3F766F696420303A722E617373656D626C79293D3D3D657D297D7D3B6E2876692C225472616E736C6F6164697422293B66756E6374696F6E20684628297B6C657420693D5B60757070792D636F72653A247B746869732E757070792E636F6E7374';
wwv_flow_imp.g_varchar2_table(5016) := '727563746F722E56455253494F4E7D602C60757070792D7472616E736C6F616469743A247B746869732E636F6E7374727563746F722E56455253494F4E7D602C60757070792D7475733A247B6F722E56455253494F4E7D605D2C653D6E2828742C72293D';
wwv_flow_imp.g_varchar2_table(5017) := '3E7B6C657420733D746869732E757070792E676574506C7567696E2874293B732626692E707573682860247B727D3A247B732E636F6E7374727563746F722E56455253494F4E7D60297D2C22616464506C7567696E56657273696F6E22293B7265747572';
wwv_flow_imp.g_varchar2_table(5018) := '6E20746869732E6F7074732E696D706F727446726F6D55706C6F616455524C7326262865282258485255706C6F6164222C22757070792D7868722D75706C6F616422292C6528224177735333222C22757070792D6177732D733322292C65282241777353';
wwv_flow_imp.g_varchar2_table(5019) := '334D756C746970617274222C22757070792D6177732D73332D6D756C7469706172742229292C65282244726F70626F78222C22757070792D64726F70626F7822292C652822426F78222C22757070792D626F7822292C65282246616365626F6F6B222C22';
wwv_flow_imp.g_varchar2_table(5020) := '757070792D66616365626F6F6B22292C652822476F6F676C654472697665222C22757070792D676F6F676C652D647269766522292C652822496E7374616772616D222C22757070792D696E7374616772616D22292C6528224F6E654472697665222C2275';
wwv_flow_imp.g_varchar2_table(5021) := '7070792D6F6E65647269766522292C6528225A6F6F6D222C22757070792D7A6F6F6D22292C65282255726C222C22757070792D75726C22292C692E6A6F696E28222C22297D6E2868462C225F676574436C69656E7456657273696F6E3222293B66756E63';
wwv_flow_imp.g_varchar2_table(5022) := '74696F6E20644628692C65297B6C657420743D7B2E2E2E692E6D6574612C617373656D626C795F75726C3A652E617373656D626C795F75726C2C66696C656E616D653A692E6E616D652C6669656C646E616D653A2266696C65227D2C723D7B2E2E2E692E';
wwv_flow_imp.g_varchar2_table(5023) := '7475732C656E64706F696E743A652E7475735F75726C2C6164645265717565737449643A21307D2C7B72656D6F74653A737D3D693B696628692E72656D6F7465262675462E7465737428692E72656D6F74652E636F6D70616E696F6E55726C29297B6C65';
wwv_flow_imp.g_varchar2_table(5024) := '7420613D652E636F6D70616E696F6E5F75726C2E7265706C616365282F5C2F242F2C2222292C6C3D692E72656D6F74652E75726C2E7265706C61636528692E72656D6F74652E636F6D70616E696F6E55726C2C2222292E7265706C616365282F5E5C2F2F';
wwv_flow_imp.g_varchar2_table(5025) := '2C2222293B733D7B2E2E2E692E72656D6F74652C636F6D70616E696F6E55726C3A612C75726C3A60247B617D2F247B6C7D607D7D6C6574206F3D7B2E2E2E692C7472616E736C6F616469743A7B617373656D626C793A652E617373656D626C795F69647D';
wwv_flow_imp.g_varchar2_table(5026) := '7D3B72657475726E20746869732E6F7074732E696D706F727446726F6D55706C6F616455524C737C7C4F626A6563742E61737369676E286F2C7B6D6574613A742C7475733A722C72656D6F74653A737D292C6F7D6E2864462C225F617474616368417373';
wwv_flow_imp.g_varchar2_table(5027) := '656D626C794D657461646174613222293B66756E6374696F6E20634628692C652C74297B72657475726E20746869732E757070792E6C6F6728225B5472616E736C6F616469745D2043726561746520417373656D626C7922292C746869732E636C69656E';
wwv_flow_imp.g_varchar2_table(5028) := '742E637265617465417373656D626C79287B2E2E2E742C657870656374656446696C65733A692E6C656E6774687D292E7468656E286173796E6320723D3E7B6C657420733D746869732E757070792E67657446696C657328292E66696C74657228793D3E';
wwv_flow_imp.g_varchar2_table(5029) := '7B6C65747B69643A627D3D793B72657475726E20692E696E636C756465732862297D293B696628732E6C656E677468213D3D692E6C656E677468297B696628732E6C656E6774683D3D3D302972657475726E20617761697420746869732E636C69656E74';
wwv_flow_imp.g_varchar2_table(5030) := '2E63616E63656C417373656D626C792872292C6E756C6C3B617761697420746869732E636C69656E742E7570646174654E756D6265724F6646696C6573496E417373656D626C7928722C732E6C656E677468297D6C6574206F3D6E657720777028722C61';
wwv_flow_imp.g_varchar2_table(5031) := '6528746869732C4469295B44695D292C7B7374617475733A617D3D6F2C6C3D612E617373656D626C795F69642C7B617373656D626C6965733A682C75706C6F616473417373656D626C6965733A637D3D746869732E676574506C7567696E537461746528';
wwv_flow_imp.g_varchar2_table(5032) := '293B746869732E736574506C7567696E5374617465287B617373656D626C6965733A7B2E2E2E682C5B6C5D3A617D2C75706C6F616473417373656D626C6965733A7B2E2E2E632C5B655D3A5B2E2E2E635B655D2C6C5D7D7D293B6C657420643D7B7D3B73';
wwv_flow_imp.g_varchar2_table(5033) := '2E666F724561636828793D3E7B645B792E69645D3D616528746869732C6B70295B6B705D28792C61297D292C746869732E757070792E7365745374617465287B66696C65733A7B2E2E2E746869732E757070792E676574537461746528292E66696C6573';
wwv_flow_imp.g_varchar2_table(5034) := '2C2E2E2E647D7D293B6C657420663D6E2828792C62293D3E7B76617220533B6966282828533D6F2E737461747573293D3D6E756C6C3F766F696420303A532E6F6B293D3D3D22415353454D424C595F434F4D504C4554454422297B746869732E75707079';
wwv_flow_imp.g_varchar2_table(5035) := '2E6F6666282266696C652D72656D6F766564222C66293B72657475726E7D696628623D3D3D2263616E63656C2D616C6C22296F2E636C6F736528292C746869732E757070792E6F6666282266696C652D72656D6F766564222C66293B656C736520696628';
wwv_flow_imp.g_varchar2_table(5036) := '792E696420696E2064297B64656C65746520645B792E69645D3B6C657420453D4F626A6563742E6B6579732864292E6C656E6774683B453D3D3D303F286F2E636C6F736528292C616528746869732C666C295B666C5D2872292E63617463682828293D3E';
wwv_flow_imp.g_varchar2_table(5037) := '7B7D292C746869732E757070792E6F6666282266696C652D72656D6F766564222C6629293A746869732E636C69656E742E7570646174654E756D6265724F6646696C6573496E417373656D626C7928722C45292E63617463682828293D3E7B7D297D7D2C';
wwv_flow_imp.g_varchar2_table(5038) := '2266696C6552656D6F76656448616E646C657222293B72657475726E20746869732E757070792E6F6E282266696C652D72656D6F766564222C66292C746869732E757070792E656D697428227472616E736C6F616469743A617373656D626C792D637265';
wwv_flow_imp.g_varchar2_table(5039) := '61746564222C612C69292C746869732E757070792E6C6F6728605B5472616E736C6F616469745D204372656174656420417373656D626C7920247B6C7D60292C6F7D292E636174636828723D3E7B6C657420733D6E65772076722860247B746869732E69';
wwv_flow_imp.g_varchar2_table(5040) := '31386E28226372656174696E67417373656D626C794661696C656422297D3A20247B722E6D6573736167657D602C7B63617573653A727D293B7468726F772264657461696C7322696E2072262628732E64657461696C733D722E64657461696C73292C22';
wwv_flow_imp.g_varchar2_table(5041) := '617373656D626C7922696E2072262628732E617373656D626C793D722E617373656D626C79292C737D297D6E2863462C225F637265617465417373656D626C793222293B66756E6374696F6E20704628692C65297B6C657420743D6E6577205830287468';
wwv_flow_imp.g_varchar2_table(5042) := '69732E757070792C69293B742E6F6E2822617373656D626C792D636F6D706C657465222C723D3E7B746869732E676574417373656D626C7946696C65732872292E666F7245616368286F3D3E7B746869732E636F6D706C6574656446696C65735B6F2E69';
wwv_flow_imp.g_varchar2_table(5043) := '645D3D21302C746869732E757070792E656D69742822706F737470726F636573732D636F6D706C657465222C6F297D297D292C742E6F6E2822617373656D626C792D6572726F72222C28722C73293D3E7B6C6574206F3D746869732E676574417373656D';
wwv_flow_imp.g_varchar2_table(5044) := '626C7946696C65732872293B6F2E666F7245616368286C3D3E7B746869732E757070792E656D6974282275706C6F61642D6572726F72222C6C2C73292C746869732E757070792E656D69742822706F737470726F636573732D636F6D706C657465222C6C';
wwv_flow_imp.g_varchar2_table(5045) := '297D293B6C657420613D7B2E2E2E746869732E757070792E676574537461746528292E66696C65737D3B6F2E666F7245616368286C3D3E64656C65746520615B6C2E69645D2E747573292C746869732E757070792E7365745374617465287B66696C6573';
wwv_flow_imp.g_varchar2_table(5046) := '3A617D292C746869732E757070792E656D697428226572726F72222C73297D292C746869732E617373656D626C7957617463686572735B655D3D747D6E2870462C225F637265617465417373656D626C79576174636865723222293B66756E6374696F6E';
wwv_flow_imp.g_varchar2_table(5047) := '20664628297B72657475726E20746869732E6F7074732E77616974466F72456E636F64696E677C7C746869732E6F7074732E77616974466F724D657461646174617D6E2866462C225F73686F756C6457616974416674657255706C6F61643222293B6675';
wwv_flow_imp.g_varchar2_table(5048) := '6E6374696F6E206D4628692C65297B72657475726E2050726F6D6973652E616C6C28652E6D617028743D3E7B6C657420723D746869732E757070792E67657446696C652874293B72657475726E20746869732E636C69656E742E7265736572766546696C';
wwv_flow_imp.g_varchar2_table(5049) := '6528692E7374617475732C72297D29297D6E286D462C225F7265736572766546696C65733222293B66756E6374696F6E2067462869297B6C657420653D746869732E757070792E67657446696C657328293B666F72286C657420743D303B743C652E6C65';
wwv_flow_imp.g_varchar2_table(5050) := '6E6774683B742B2B297B6C657420723D655B745D3B696628722E75706C6F616455524C3D3D3D692E7475735F75706C6F61645F75726C7C7C722E7475732626722E7475732E75706C6F616455726C3D3D3D692E7475735F75706C6F61645F75726C7C7C21';
wwv_flow_imp.g_varchar2_table(5051) := '692E69735F7475735F66696C652626722E6E616D653D3D3D692E6E616D652626722E73697A653D3D3D692E73697A652972657475726E20727D7D6E2867462C225F66696E6446696C653222293B66756E6374696F6E20794628692C65297B6C657420743D';
wwv_flow_imp.g_varchar2_table(5052) := '746869732E676574506C7567696E537461746528292C723D616528746869732C706C295B706C5D2865293B6966282172297B746869732E757070792E6C6F6728225B5472616E736C6F616469745D20436F756C646E5C7532303139742066696E64207468';
wwv_flow_imp.g_varchar2_table(5053) := '652066696C652C20697420776173206C696B656C792072656D6F76656420696E207468652070726F6365737322293B72657475726E7D746869732E736574506C7567696E5374617465287B66696C65733A7B2E2E2E742E66696C65732C5B652E69645D3A';
wwv_flow_imp.g_varchar2_table(5054) := '7B617373656D626C793A692C69643A722E69642C75706C6F6164656446696C653A657D7D7D292C746869732E757070792E656D697428227472616E736C6F616469743A75706C6F6164222C652C746869732E676574417373656D626C79286929297D6E28';
wwv_flow_imp.g_varchar2_table(5055) := '79462C225F6F6E46696C6555706C6F6164436F6D706C6574653222293B66756E6374696F6E20764628692C652C74297B6C657420723D746869732E676574506C7567696E537461746528292C733D722E66696C65735B742E6F726967696E616C5F69645D';
wwv_flow_imp.g_varchar2_table(5056) := '3B742E6C6F63616C49643D733F732E69643A6E756C6C3B6C6574206F3D7B726573756C743A742C737465704E616D653A652C69643A742E69642C617373656D626C793A697D3B746869732E736574506C7567696E5374617465287B726573756C74733A5B';
wwv_flow_imp.g_varchar2_table(5057) := '2E2E2E722E726573756C74732C6F5D7D292C746869732E757070792E656D697428227472616E736C6F616469743A726573756C74222C652C742C746869732E676574417373656D626C79286929297D6E2876462C225F6F6E526573756C743222293B6675';
wwv_flow_imp.g_varchar2_table(5058) := '6E6374696F6E2062462869297B6C657420653D692E617373656D626C795F73736C5F75726C3B746869732E636C69656E742E676574417373656D626C795374617475732865292E7468656E28743D3E7B6C657420723D742E617373656D626C795F69642C';
wwv_flow_imp.g_varchar2_table(5059) := '733D746869732E676574506C7567696E537461746528293B746869732E736574506C7567696E5374617465287B617373656D626C6965733A7B2E2E2E732E617373656D626C6965732C5B725D3A747D7D292C746869732E757070792E656D697428227472';
wwv_flow_imp.g_varchar2_table(5060) := '616E736C6F616469743A636F6D706C657465222C74297D297D6E2862462C225F6F6E417373656D626C7946696E69736865643222293B6173796E632066756E6374696F6E2077462869297B617761697420746869732E636C69656E742E63616E63656C41';
wwv_flow_imp.g_varchar2_table(5061) := '7373656D626C792869292C746869732E757070792E656D697428227472616E736C6F616469743A617373656D626C792D63616E63656C6C6564222C69297D6E2877462C225F63616E63656C417373656D626C793222293B66756E6374696F6E2053462869';
wwv_flow_imp.g_varchar2_table(5062) := '297B6C65747B7374617475733A657D3D692C743D652E617373656D626C795F69643B72657475726E20746869732E616374697665417373656D626C6965735B745D3D692C692E6F6E2822737461747573222C723D3E7B6C65747B617373656D626C696573';
wwv_flow_imp.g_varchar2_table(5063) := '3A737D3D746869732E676574506C7567696E537461746528293B746869732E736574506C7567696E5374617465287B617373656D626C6965733A7B2E2E2E732C5B745D3A727D7D297D292C692E6F6E282275706C6F6164222C723D3E7B61652874686973';
wwv_flow_imp.g_varchar2_table(5064) := '2C4470295B44705D28742C72297D292C692E6F6E28226572726F72222C723D3E7B722E617373656D626C793D692E7374617475732C746869732E757070792E656D697428227472616E736C6F616469743A617373656D626C792D6572726F72222C692E73';
wwv_flow_imp.g_varchar2_table(5065) := '74617475732C72297D292C692E6F6E2822657865637574696E67222C28293D3E7B746869732E757070792E656D697428227472616E736C6F616469743A617373656D626C792D657865637574696E67222C692E737461747573297D292C692E6F6E282265';
wwv_flow_imp.g_varchar2_table(5066) := '7865637574696F6E2D70726F6772657373222C723D3E7B696628746869732E757070792E656D697428227472616E736C6F616469743A657865637574696F6E2D70726F6772657373222C72292C722E70726F67726573735F636F6D62696E6564213D6E75';
wwv_flow_imp.g_varchar2_table(5067) := '6C6C29666F72286C65742073206F6620746869732E757070792E67657446696C6573282929746869732E757070792E656D69742822706F737470726F636573732D70726F6772657373222C732C7B6D6F64653A2264657465726D696E617465222C76616C';
wwv_flow_imp.g_varchar2_table(5068) := '75653A722E70726F67726573735F636F6D62696E65642F3130302C6D6573736167653A746869732E6931386E2822656E636F64696E6722297D297D292C746869732E6F7074732E77616974466F72456E636F64696E672626692E6F6E2822726573756C74';
wwv_flow_imp.g_varchar2_table(5069) := '222C28722C73293D3E7B616528746869732C4970295B49705D28742C722C73297D292C746869732E6F7074732E77616974466F72456E636F64696E673F692E6F6E282266696E6973686564222C28293D3E7B616528746869732C636C295B636C5D28692E';
wwv_flow_imp.g_varchar2_table(5070) := '737461747573297D293A746869732E6F7074732E77616974466F724D657461646174612626692E6F6E28226D65746164617461222C28293D3E7B616528746869732C636C295B636C5D28692E737461747573297D292C692E6F6B3D3D3D22415353454D42';
wwv_flow_imp.g_varchar2_table(5071) := '4C595F434F4D504C455445227C7C692E636F6E6E65637428292C697D6E2853462C225F636F6E6E656374417373656D626C793222293B76692E56455253494F4E3D6C462E76657273696F6E3B76692E434F4D50414E494F4E3D4D703B76692E434F4D5041';
wwv_flow_imp.g_varchar2_table(5072) := '4E494F4E5F5041545445524E3D4E703B766172204A303D7B737472696E67733A7B75706C6F61645374616C6C65643A2255706C6F616420686173206E6F74206D61646520616E792070726F677265737320666F7220257B7365636F6E64737D207365636F';
wwv_flow_imp.g_varchar2_table(5073) := '6E64732E20596F75206D61792077616E7420746F2072657472792069742E227D7D3B66756E6374696F6E20736E28692C65297B696628214F626A6563742E70726F746F747970652E6861734F776E50726F70657274792E63616C6C28692C652929746872';
wwv_flow_imp.g_varchar2_table(5074) := '6F77206E657720547970654572726F722822617474656D7074656420746F207573652070726976617465206669656C64206F6E206E6F6E2D696E7374616E636522293B72657475726E20697D6E28736E2C225F636C617373507269766174654669656C64';
wwv_flow_imp.g_varchar2_table(5075) := '4C6F6F73654261736522293B7661722050463D303B66756E6374696F6E20676C2869297B72657475726E225F5F707269766174655F222B50462B2B2B225F222B697D6E28676C2C225F636C617373507269766174654669656C644C6F6F73654B65792229';
wwv_flow_imp.g_varchar2_table(5076) := '3B766172205F463D7B76657273696F6E3A22332E362E30227D3B66756E6374696F6E205A3028692C65297B6C657420743D653B72657475726E20747C7C28743D6E6577204572726F72282255706C6F6164206572726F722229292C747970656F6620743D';
wwv_flow_imp.g_varchar2_table(5077) := '3D22737472696E6722262628743D6E6577204572726F72287429292C7420696E7374616E63656F66204572726F727C7C28743D4F626A6563742E61737369676E286E6577204572726F72282255706C6F6164206572726F7222292C7B646174613A747D29';
wwv_flow_imp.g_varchar2_table(5078) := '292C736F2869293F28743D6E6577205F6928742C69292C74293A28742E726571756573743D692C74297D6E285A302C226275696C64526573706F6E73654572726F7222293B66756E6374696F6E2065622869297B72657475726E20692E646174612E736C';
wwv_flow_imp.g_varchar2_table(5079) := '69636528302C692E646174612E73697A652C692E6D6574612E74797065297D6E2865622C2273657454797065496E426C6F6222293B766172207A703D676C282275706C6F61644C6F63616C46696C6522292C4C703D676C282275706C6F616442756E646C';
wwv_flow_imp.g_varchar2_table(5080) := '6522292C6A703D676C2822676574436F6D70616E696F6E436C69656E744172677322292C42703D676C282275706C6F616446696C657322292C6D6C3D676C282268616E646C6555706C6F616422292C6D6F3D636C61737320657874656E64732076657B63';
wwv_flow_imp.g_varchar2_table(5081) := '6F6E7374727563746F7228652C74297B737570657228652C74292C4F626A6563742E646566696E6550726F706572747928746869732C42702C7B76616C75653A43467D292C4F626A6563742E646566696E6550726F706572747928746869732C6A702C7B';
wwv_flow_imp.g_varchar2_table(5082) := '76616C75653A45467D292C4F626A6563742E646566696E6550726F706572747928746869732C4C702C7B76616C75653A78467D292C4F626A6563742E646566696E6550726F706572747928746869732C7A702C7B76616C75653A46467D292C4F626A6563';
wwv_flow_imp.g_varchar2_table(5083) := '742E646566696E6550726F706572747928746869732C6D6C2C7B7772697461626C653A21302C76616C75653A6173796E6320733D3E7B696628732E6C656E6774683D3D3D30297B746869732E757070792E6C6F6728225B58485255706C6F61645D204E6F';
wwv_flow_imp.g_varchar2_table(5084) := '2066696C657320746F2075706C6F61642122293B72657475726E7D746869732E6F7074732E6C696D69743D3D3D30262621746869732E6F7074735B6C735D2626746869732E757070792E6C6F6728225B58485255706C6F61645D205768656E2075706C6F';
wwv_flow_imp.g_varchar2_table(5085) := '6164696E67206D756C7469706C652066696C6573206174206F6E63652C20636F6E73696465722073657474696E672074686520606C696D697460206F7074696F6E2028746F206031306020666F72206578616D706C65292C20746F206C696D6974207468';
wwv_flow_imp.g_varchar2_table(5086) := '65206E756D626572206F6620636F6E63757272656E742075706C6F6164732C2077686963682068656C70732070726576656E74206D656D6F727920616E64206E6574776F726B206973737565733A2068747470733A2F2F757070792E696F2F646F63732F';
wwv_flow_imp.g_varchar2_table(5087) := '7868722D75706C6F61642F236C696D69742D30222C227761726E696E6722292C746869732E757070792E6C6F6728225B58485255706C6F61645D2055706C6F6164696E672E2E2E22293B6C6574206F3D746869732E757070792E67657446696C65734279';
wwv_flow_imp.g_varchar2_table(5088) := '4964732873292C613D7573286F292C6C3D68732861293B696628746869732E757070792E656D6974282275706C6F61642D7374617274222C6C292C746869732E6F7074732E62756E646C65297B696628612E736F6D6528633D3E632E697352656D6F7465';
wwv_flow_imp.g_varchar2_table(5089) := '29297468726F77206E6577204572726F72282243616E5C7532303139742075706C6F61642072656D6F74652066696C6573207768656E20746865206062756E646C653A207472756560206F7074696F6E2069732073657422293B696628747970656F6620';
wwv_flow_imp.g_varchar2_table(5090) := '746869732E6F7074732E686561646572733D3D2266756E6374696F6E22297468726F77206E657720547970654572726F722822606865616465727360206D6179206E6F7420626520612066756E6374696F6E207768656E20746865206062756E646C653A';
wwv_flow_imp.g_varchar2_table(5091) := '207472756560206F7074696F6E2069732073657422293B617761697420736E28746869732C4C70295B4C705D2861297D656C736520617761697420736E28746869732C4270295B42705D2861297D7D292C746869732E747970653D2275706C6F61646572';
wwv_flow_imp.g_varchar2_table(5092) := '222C746869732E69643D746869732E6F7074732E69647C7C2258485255706C6F6164222C746869732E7469746C653D2258485255706C6F6164222C746869732E64656661756C744C6F63616C653D4A303B6C657420723D7B666F726D446174613A21302C';
wwv_flow_imp.g_varchar2_table(5093) := '6669656C644E616D653A742E62756E646C653F2266696C65735B5D223A2266696C65222C6D6574686F643A22706F7374222C616C6C6F7765644D6574614669656C64733A6E756C6C2C726573706F6E736555726C4669656C644E616D653A2275726C222C';
wwv_flow_imp.g_varchar2_table(5094) := '62756E646C653A21312C686561646572733A7B7D2C74696D656F75743A33302A3165332C6C696D69743A352C7769746843726564656E7469616C733A21312C726573706F6E7365547970653A22222C676574526573706F6E7365446174612873297B6C65';
wwv_flow_imp.g_varchar2_table(5095) := '74206F3D7B7D3B7472797B6F3D4A534F4E2E70617273652873297D63617463682861297B652E6C6F672861297D72657475726E206F7D2C676574526573706F6E73654572726F7228732C6F297B6C657420613D6E6577204572726F72282255706C6F6164';
wwv_flow_imp.g_varchar2_table(5096) := '206572726F7222293B72657475726E20736F286F29262628613D6E6577205F6928612C6F29292C617D2C76616C69646174655374617475732873297B72657475726E20733E3D3230302626733C3330307D7D3B696628746869732E6F7074733D7B2E2E2E';
wwv_flow_imp.g_varchar2_table(5097) := '722C2E2E2E747D2C746869732E6931386E496E697428292C6C7320696E20746869732E6F7074733F746869732E72657175657374733D746869732E6F7074735B6C735D3A746869732E72657175657374733D6E6577204E7428746869732E6F7074732E6C';
wwv_flow_imp.g_varchar2_table(5098) := '696D6974292C746869732E6F7074732E62756E646C65262621746869732E6F7074732E666F726D44617461297468726F77206E6577204572726F722822606F7074732E666F726D4461746160206D7573742062652074727565207768656E20606F707473';
wwv_flow_imp.g_varchar2_table(5099) := '2E62756E646C656020697320656E61626C65642E22293B696628743F2E616C6C6F7765644D6574614669656C64733D3D3D766F696420302626226D6574614669656C647322696E20746869732E6F707473297468726F77206E6577204572726F72282254';
wwv_flow_imp.g_varchar2_table(5100) := '686520606D6574614669656C647360206F7074696F6E20686173206265656E2072656E616D656420746F2060616C6C6F7765644D6574614669656C6473602E22293B746869732E75706C6F616465724576656E74733D4F626A6563742E63726561746528';
wwv_flow_imp.g_varchar2_table(5101) := '6E756C6C297D6765744F7074696F6E732865297B6C657420743D746869732E757070792E676574537461746528292E78687255706C6F61642C7B686561646572733A727D3D746869732E6F7074732C733D7B2E2E2E746869732E6F7074732C2E2E2E747C';
wwv_flow_imp.g_varchar2_table(5102) := '7C7B7D2C2E2E2E652E78687255706C6F61647C7C7B7D2C686561646572733A7B7D7D3B72657475726E20747970656F6620723D3D2266756E6374696F6E223F732E686561646572733D722865293A4F626A6563742E61737369676E28732E686561646572';
wwv_flow_imp.g_varchar2_table(5103) := '732C746869732E6F7074732E68656164657273292C7426264F626A6563742E61737369676E28732E686561646572732C742E68656164657273292C652E78687255706C6F616426264F626A6563742E61737369676E28732E686561646572732C652E7868';
wwv_flow_imp.g_varchar2_table(5104) := '7255706C6F61642E68656164657273292C737D6164644D6574616461746128652C742C72297B2841727261792E6973417272617928722E616C6C6F7765644D6574614669656C6473293F722E616C6C6F7765644D6574614669656C64733A4F626A656374';
wwv_flow_imp.g_varchar2_table(5105) := '2E6B657973287429292E666F7245616368286F3D3E7B41727261792E6973417272617928745B6F5D293F745B6F5D2E666F724561636828613D3E652E617070656E64286F2C6129293A652E617070656E64286F2C745B6F5D297D297D637265617465466F';
wwv_flow_imp.g_varchar2_table(5106) := '726D4461746155706C6F616428652C74297B6C657420723D6E657720466F726D446174613B746869732E6164644D6574616461746128722C652E6D6574612C74293B6C657420733D65622865293B72657475726E20652E6E616D653F722E617070656E64';
wwv_flow_imp.g_varchar2_table(5107) := '28742E6669656C644E616D652C732C652E6D6574612E6E616D65293A722E617070656E6428742E6669656C644E616D652C73292C727D63726561746542756E646C656455706C6F616428652C74297B6C657420723D6E657720466F726D446174612C7B6D';
wwv_flow_imp.g_varchar2_table(5108) := '6574613A737D3D746869732E757070792E676574537461746528293B72657475726E20746869732E6164644D6574616461746128722C732C74292C652E666F7245616368286F3D3E7B6C657420613D746869732E6765744F7074696F6E73286F292C6C3D';
wwv_flow_imp.g_varchar2_table(5109) := '6562286F293B6F2E6E616D653F722E617070656E6428612E6669656C644E616D652C6C2C6F2E6E616D65293A722E617070656E6428612E6669656C644E616D652C6C297D292C727D696E7374616C6C28297B696628746869732E6F7074732E62756E646C';
wwv_flow_imp.g_varchar2_table(5110) := '65297B6C65747B6361706162696C69746965733A657D3D746869732E757070792E676574537461746528293B746869732E757070792E7365745374617465287B6361706162696C69746965733A7B2E2E2E652C696E646976696475616C43616E63656C6C';
wwv_flow_imp.g_varchar2_table(5111) := '6174696F6E3A21317D7D297D746869732E757070792E61646455706C6F6164657228736E28746869732C6D6C295B6D6C5D297D756E696E7374616C6C28297B696628746869732E6F7074732E62756E646C65297B6C65747B6361706162696C6974696573';
wwv_flow_imp.g_varchar2_table(5112) := '3A657D3D746869732E757070792E676574537461746528293B746869732E757070792E7365745374617465287B6361706162696C69746965733A7B2E2E2E652C696E646976696475616C43616E63656C6C6174696F6E3A21307D7D297D746869732E7570';
wwv_flow_imp.g_varchar2_table(5113) := '70792E72656D6F766555706C6F6164657228736E28746869732C6D6C295B6D6C5D297D7D3B6E286D6F2C2258485255706C6F616422293B6173796E632066756E6374696F6E20464628692C652C74297B6C657420723D746869732E6765744F7074696F6E';
wwv_flow_imp.g_varchar2_table(5114) := '732869293B72657475726E20746869732E757070792E6C6F67286075706C6F6164696E6720247B657D206F6620247B747D60292C6E65772050726F6D6973652828732C6F293D3E7B6C657420613D722E666F726D446174613F746869732E637265617465';
wwv_flow_imp.g_varchar2_table(5115) := '466F726D4461746155706C6F616428692C72293A692E646174612C6C3D6E657720584D4C48747470526571756573742C683D6E657720676928746869732E75707079293B746869732E75706C6F616465724576656E74735B692E69645D3D683B6C657420';
wwv_flow_imp.g_varchar2_table(5116) := '632C643D6E657720246128722E74696D656F75742C28293D3E7B6C657420793D6E6577204572726F7228746869732E6931386E282275706C6F61645374616C6C6564222C7B7365636F6E64733A4D6174682E6365696C28722E74696D656F75742F316533';
wwv_flow_imp.g_varchar2_table(5117) := '297D29293B746869732E757070792E656D6974282275706C6F61642D7374616C6C6564222C792C5B695D297D292C663D507428293B6C2E75706C6F61642E6164644576656E744C697374656E657228226C6F61647374617274222C28293D3E7B74686973';
wwv_flow_imp.g_varchar2_table(5118) := '2E757070792E6C6F6728605B58485255706C6F61645D20247B667D207374617274656460297D292C6C2E75706C6F61642E6164644576656E744C697374656E6572282270726F6772657373222C793D3E7B746869732E757070792E6C6F6728605B584852';
wwv_flow_imp.g_varchar2_table(5119) := '55706C6F61645D20247B667D2070726F67726573733A20247B792E6C6F616465647D202F20247B792E746F74616C7D60292C642E70726F677265737328292C792E6C656E677468436F6D70757461626C652626746869732E757070792E656D6974282275';
wwv_flow_imp.g_varchar2_table(5120) := '706C6F61642D70726F6772657373222C692C7B75706C6F616465723A746869732C627974657355706C6F616465643A792E6C6F616465642C6279746573546F74616C3A792E746F74616C7D297D292C6C2E6164644576656E744C697374656E657228226C';
wwv_flow_imp.g_varchar2_table(5121) := '6F6164222C28293D3E7B696628746869732E757070792E6C6F6728605B58485255706C6F61645D20247B667D2066696E697368656460292C642E646F6E6528292C632E646F6E6528292C746869732E75706C6F616465724576656E74735B692E69645D26';
wwv_flow_imp.g_varchar2_table(5122) := '2628746869732E75706C6F616465724576656E74735B692E69645D2E72656D6F766528292C746869732E75706C6F616465724576656E74735B692E69645D3D6E756C6C292C722E76616C6964617465537461747573286C2E7374617475732C6C2E726573';
wwv_flow_imp.g_varchar2_table(5123) := '706F6E7365546578742C6C29297B6C657420453D722E676574526573706F6E736544617461286C2E726573706F6E7365546578742C6C292C463D455B722E726573706F6E736555726C4669656C644E616D655D2C783D7B7374617475733A6C2E73746174';
wwv_flow_imp.g_varchar2_table(5124) := '75732C626F64793A452C75706C6F616455524C3A467D3B72657475726E20746869732E757070792E656D6974282275706C6F61642D73756363657373222C692C78292C462626746869732E757070792E6C6F672860446F776E6C6F616420247B692E6E61';
wwv_flow_imp.g_varchar2_table(5125) := '6D657D2066726F6D20247B467D60292C732869297D6C657420793D722E676574526573706F6E736544617461286C2E726573706F6E7365546578742C6C292C623D5A30286C2C722E676574526573706F6E73654572726F72286C2E726573706F6E736554';
wwv_flow_imp.g_varchar2_table(5126) := '6578742C6C29292C533D7B7374617475733A6C2E7374617475732C626F64793A797D3B72657475726E20746869732E757070792E656D6974282275706C6F61642D6572726F72222C692C622C53292C6F2862297D292C6C2E6164644576656E744C697374';
wwv_flow_imp.g_varchar2_table(5127) := '656E657228226572726F72222C28293D3E7B746869732E757070792E6C6F6728605B58485255706C6F61645D20247B667D206572726F72656460292C642E646F6E6528292C632E646F6E6528292C746869732E75706C6F616465724576656E74735B692E';
wwv_flow_imp.g_varchar2_table(5128) := '69645D262628746869732E75706C6F616465724576656E74735B692E69645D2E72656D6F766528292C746869732E75706C6F616465724576656E74735B692E69645D3D6E756C6C293B6C657420793D5A30286C2C722E676574526573706F6E7365457272';
wwv_flow_imp.g_varchar2_table(5129) := '6F72286C2E726573706F6E7365546578742C6C29293B72657475726E20746869732E757070792E656D6974282275706C6F61642D6572726F72222C692C79292C6F2879297D292C6C2E6F70656E28722E6D6574686F642E746F5570706572436173652829';
wwv_flow_imp.g_varchar2_table(5130) := '2C722E656E64706F696E742C2130292C6C2E7769746843726564656E7469616C733D722E7769746843726564656E7469616C732C722E726573706F6E736554797065213D3D22222626286C2E726573706F6E7365547970653D722E726573706F6E736554';
wwv_flow_imp.g_varchar2_table(5131) := '797065292C633D746869732E72657175657374732E72756E2828293D3E7B6C657420793D746869732E6765744F7074696F6E732869293B72657475726E204F626A6563742E6B65797328792E68656164657273292E666F724561636828623D3E7B6C2E73';
wwv_flow_imp.g_varchar2_table(5132) := '65745265717565737448656164657228622C792E686561646572735B625D297D292C6C2E73656E642861292C28293D3E7B642E646F6E6528292C6C2E61626F727428297D7D292C682E6F6E46696C6552656D6F766528692E69642C28293D3E7B632E6162';
wwv_flow_imp.g_varchar2_table(5133) := '6F727428292C6F286E6577204572726F72282246696C652072656D6F7665642229297D292C682E6F6E43616E63656C416C6C28692E69642C793D3E7B6C65747B726561736F6E3A627D3D793B623D3D3D2275736572222626632E61626F727428292C6F28';
wwv_flow_imp.g_varchar2_table(5134) := '6E6577204572726F72282255706C6F61642063616E63656C6C65642229297D297D297D6E2846462C225F75706C6F61644C6F63616C46696C653222293B66756E6374696F6E2078462869297B72657475726E206E65772050726F6D6973652828652C7429';
wwv_flow_imp.g_varchar2_table(5135) := '3D3E7B6C65747B656E64706F696E743A727D3D746869732E6F7074732C7B6D6574686F643A737D3D746869732E6F7074732C6F3D746869732E757070792E676574537461746528292E78687255706C6F61642C613D746869732E63726561746542756E64';
wwv_flow_imp.g_varchar2_table(5136) := '6C656455706C6F616428692C7B2E2E2E746869732E6F7074732C2E2E2E6F7C7C7B7D7D292C6C3D6E657720584D4C48747470526571756573742C683D6E28643D3E7B692E666F724561636828663D3E7B746869732E757070792E656D6974282275706C6F';
wwv_flow_imp.g_varchar2_table(5137) := '61642D6572726F72222C662C64297D297D2C22656D69744572726F7222292C633D6E657720246128746869732E6F7074732E74696D656F75742C28293D3E7B6C657420643D6E6577204572726F7228746869732E6931386E282275706C6F61645374616C';
wwv_flow_imp.g_varchar2_table(5138) := '6C6564222C7B7365636F6E64733A4D6174682E6365696C28746869732E6F7074732E74696D656F75742F316533297D29293B746869732E757070792E656D6974282275706C6F61642D7374616C6C6564222C642C69297D293B6C2E75706C6F61642E6164';
wwv_flow_imp.g_varchar2_table(5139) := '644576656E744C697374656E657228226C6F61647374617274222C28293D3E7B746869732E757070792E6C6F6728225B58485255706C6F61645D20737461727465642075706C6F6164696E672062756E646C6522292C632E70726F677265737328297D29';
wwv_flow_imp.g_varchar2_table(5140) := '2C6C2E75706C6F61642E6164644576656E744C697374656E6572282270726F6772657373222C643D3E7B632E70726F677265737328292C642E6C656E677468436F6D70757461626C652626692E666F724561636828663D3E7B746869732E757070792E65';
wwv_flow_imp.g_varchar2_table(5141) := '6D6974282275706C6F61642D70726F6772657373222C662C7B75706C6F616465723A746869732C627974657355706C6F616465643A642E6C6F616465642F642E746F74616C2A662E73697A652C6279746573546F74616C3A662E73697A657D297D297D29';
wwv_flow_imp.g_varchar2_table(5142) := '2C6C2E6164644576656E744C697374656E657228226C6F6164222C643D3E7B696628632E646F6E6528292C746869732E6F7074732E76616C696461746553746174757328642E7461726765742E7374617475732C6C2E726573706F6E7365546578742C6C';
wwv_flow_imp.g_varchar2_table(5143) := '29297B6C657420793D746869732E6F7074732E676574526573706F6E736544617461286C2E726573706F6E7365546578742C6C292C623D7B7374617475733A642E7461726765742E7374617475732C626F64793A797D3B72657475726E20692E666F7245';
wwv_flow_imp.g_varchar2_table(5144) := '61636828533D3E7B746869732E757070792E656D6974282275706C6F61642D73756363657373222C532C62297D292C6528297D6C657420663D746869732E6F7074732E676574526573706F6E73654572726F72286C2E726573706F6E7365546578742C6C';
wwv_flow_imp.g_varchar2_table(5145) := '297C7C6E6577204572726F72282255706C6F6164206572726F7222293B72657475726E20662E726571756573743D6C2C682866292C742866297D292C6C2E6164644576656E744C697374656E657228226572726F72222C28293D3E7B632E646F6E652829';
wwv_flow_imp.g_varchar2_table(5146) := '3B6C657420643D746869732E6F7074732E676574526573706F6E73654572726F72286C2E726573706F6E7365546578742C6C297C7C6E6577204572726F72282255706C6F6164206572726F7222293B72657475726E20682864292C742864297D292C7468';
wwv_flow_imp.g_varchar2_table(5147) := '69732E757070792E6F6E282263616E63656C2D616C6C222C66756E6374696F6E2864297B6C65747B726561736F6E3A667D3D643D3D3D766F696420303F7B7D3A643B663D3D3D227573657222262628632E646F6E6528292C6C2E61626F72742829297D29';
wwv_flow_imp.g_varchar2_table(5148) := '2C6C2E6F70656E28732E746F55707065724361736528292C722C2130292C6C2E7769746843726564656E7469616C733D746869732E6F7074732E7769746843726564656E7469616C732C746869732E6F7074732E726573706F6E736554797065213D3D22';
wwv_flow_imp.g_varchar2_table(5149) := '222626286C2E726573706F6E7365547970653D746869732E6F7074732E726573706F6E736554797065292C4F626A6563742E6B65797328746869732E6F7074732E68656164657273292E666F724561636828643D3E7B6C2E736574526571756573744865';
wwv_flow_imp.g_varchar2_table(5150) := '6164657228642C746869732E6F7074732E686561646572735B645D297D292C6C2E73656E642861297D297D6E2878462C225F75706C6F616442756E646C653222293B66756E6374696F6E2045462869297B6C657420653D746869732E6765744F7074696F';
wwv_flow_imp.g_varchar2_table(5151) := '6E732869292C743D41727261792E6973417272617928652E616C6C6F7765644D6574614669656C6473293F652E616C6C6F7765644D6574614669656C64733A4F626A6563742E6B65797328692E6D657461293B72657475726E7B2E2E2E692E72656D6F74';
wwv_flow_imp.g_varchar2_table(5152) := '652E626F64792C70726F746F636F6C3A226D756C746970617274222C656E64706F696E743A652E656E64706F696E742C73697A653A692E646174612E73697A652C6669656C646E616D653A652E6669656C644E616D652C6D657461646174613A4F626A65';
wwv_flow_imp.g_varchar2_table(5153) := '63742E66726F6D456E747269657328742E6D617028723D3E5B722C692E6D6574615B725D5D29292C687474704D6574686F643A652E6D6574686F642C757365466F726D446174613A652E666F726D446174612C686561646572733A652E68656164657273';
wwv_flow_imp.g_varchar2_table(5154) := '7D7D6E2845462C225F676574436F6D70616E696F6E436C69656E74417267733222293B6173796E632066756E6374696F6E2043462869297B61776169742050726F6D6973652E616C6C536574746C656428692E6D61702828652C74293D3E7B6C65742072';
wwv_flow_imp.g_varchar2_table(5155) := '3D7061727365496E7428742C3130292B312C733D692E6C656E6774683B696628652E697352656D6F7465297B6C6574206F3D6E2828293D3E746869732E72657175657374732C22676574517565756522292C613D6E65772041626F7274436F6E74726F6C';
wwv_flow_imp.g_varchar2_table(5156) := '6C65722C6C3D6E28633D3E7B632E69643D3D3D652E69642626612E61626F727428297D2C2272656D6F76656448616E646C657222293B746869732E757070792E6F6E282266696C652D72656D6F766564222C6C293B6C657420683D746869732E75707079';
wwv_flow_imp.g_varchar2_table(5157) := '2E67657452657175657374436C69656E74466F7246696C652865292E75706C6F616452656D6F746546696C6528652C736E28746869732C6A70295B6A705D2865292C7B7369676E616C3A612E7369676E616C2C67657451756575653A6F7D293B72657475';
wwv_flow_imp.g_varchar2_table(5158) := '726E20746869732E72657175657374732E7772617053796E6346756E6374696F6E2828293D3E7B746869732E757070792E6F6666282266696C652D72656D6F766564222C6C297D2C7B7072696F726974793A2D317D2928292C687D72657475726E20736E';
wwv_flow_imp.g_varchar2_table(5159) := '28746869732C7A70295B7A705D28652C722C73297D29297D6E2843462C225F75706C6F616446696C65733222293B6D6F2E56455253494F4E3D5F462E76657273696F6E3B7661722071703D646528496C28292C31292C73623D646528746228292C31293B';
wwv_flow_imp.g_varchar2_table(5160) := '7661722069623D7B737472696E67733A7B636F6D7072657373696E67496D616765733A22436F6D7072657373696E6720696D616765732E2E2E222C636F6D70726573736564583A22536176656420257B73697A657D20627920636F6D7072657373696E67';
wwv_flow_imp.g_varchar2_table(5161) := '20696D61676573227D7D3B66756E6374696F6E20726228692C65297B696628214F626A6563742E70726F746F747970652E6861734F776E50726F70657274792E63616C6C28692C6529297468726F77206E657720547970654572726F722822617474656D';
wwv_flow_imp.g_varchar2_table(5162) := '7074656420746F207573652070726976617465206669656C64206F6E206E6F6E2D696E7374616E636522293B72657475726E20697D6E2872622C225F636C617373507269766174654669656C644C6F6F73654261736522293B766172204F463D303B6675';
wwv_flow_imp.g_varchar2_table(5163) := '6E6374696F6E2054462869297B72657475726E225F5F707269766174655F222B4F462B2B2B225F222B697D6E2854462C225F636C617373507269766174654669656C644C6F6F73654B657922293B76617220796C3D54462822526174654C696D69746564';
wwv_flow_imp.g_varchar2_table(5164) := '517565756522292C6F6E3D636C61737320657874656E64732076657B636F6E7374727563746F7228652C74297B737570657228652C74292C4F626A6563742E646566696E6550726F706572747928746869732C796C2C7B7772697461626C653A21302C76';
wwv_flow_imp.g_varchar2_table(5165) := '616C75653A766F696420307D292C746869732E69643D746869732E6F7074732E69647C7C22436F6D70726573736F72222C746869732E747970653D226D6F646966696572222C746869732E64656661756C744C6F63616C653D69623B6C657420723D7B71';
wwv_flow_imp.g_varchar2_table(5166) := '75616C6974793A2E362C6C696D69743A31307D3B746869732E6F7074733D7B2E2E2E722C2E2E2E747D2C726228746869732C796C295B796C5D3D6E6577204E7428746869732E6F7074732E6C696D6974292C746869732E6931386E496E697428292C7468';
wwv_flow_imp.g_varchar2_table(5167) := '69732E7072657061726555706C6F61643D746869732E7072657061726555706C6F61642E62696E642874686973292C746869732E636F6D70726573733D746869732E636F6D70726573732E62696E642874686973297D636F6D70726573732865297B7265';
wwv_flow_imp.g_varchar2_table(5168) := '7475726E206E65772050726F6D6973652828742C72293D3E7B6E65772073622E64656661756C7428652C7B2E2E2E746869732E6F7074732C737563636573733A742C6572726F723A727D297D297D6173796E63207072657061726555706C6F6164286529';
wwv_flow_imp.g_varchar2_table(5169) := '7B6C657420743D302C723D5B5D2C733D726228746869732C796C295B796C5D2E7772617050726F6D69736546756E6374696F6E286173796E6320613D3E7B7472797B6C6574206C3D617761697420746869732E636F6D707265737328612E64617461292C';
wwv_flow_imp.g_varchar2_table(5170) := '683D612E646174612E73697A652D6C2E73697A653B746869732E757070792E6C6F6728605B496D61676520436F6D70726573736F725D20496D61676520247B612E69647D20636F6D7072657373656420627920247B28302C71702E64656661756C742928';
wwv_flow_imp.g_varchar2_table(5171) := '68297D60292C742B3D683B6C65747B6E616D653A632C747970653A642C73697A653A667D3D6C2C793D42692863292C533D60247B426928612E6D6574612E6E616D65292E6E616D657D2E247B792E657874656E73696F6E7D603B746869732E757070792E';
wwv_flow_imp.g_varchar2_table(5172) := '73657446696C65537461746528612E69642C7B2E2E2E6326267B6E616D653A637D2C2E2E2E792E657874656E73696F6E26267B657874656E73696F6E3A792E657874656E73696F6E7D2C2E2E2E6426267B747970653A647D2C2E2E2E6626267B73697A65';
wwv_flow_imp.g_varchar2_table(5173) := '3A667D2C646174613A6C2C6D6574613A7B2E2E2E612E6D6574612C747970653A642C6E616D653A537D7D292C722E707573682861297D6361746368286C297B746869732E757070792E6C6F6728605B496D61676520436F6D70726573736F725D20466169';
wwv_flow_imp.g_varchar2_table(5174) := '6C656420746F20636F6D707265737320247B612E69647D3A602C227761726E696E6722292C746869732E757070792E6C6F67286C2C227761726E696E6722297D7D292C6F3D652E6D617028613D3E7B6C6574206C3D746869732E757070792E6765744669';
wwv_flow_imp.g_varchar2_table(5175) := '6C652861293B72657475726E20746869732E757070792E656D6974282270726570726F636573732D70726F6772657373222C6C2C7B6D6F64653A22696E64657465726D696E617465222C6D6573736167653A746869732E6931386E2822636F6D70726573';
wwv_flow_imp.g_varchar2_table(5176) := '73696E67496D6167657322297D292C6C2E697352656D6F74657C7C286C2E646174612E747970657C7C286C2E646174613D6C2E646174612E736C69636528302C6C2E646174612E73697A652C6C2E7479706529292C216C2E747970652E73746172747357';
wwv_flow_imp.g_varchar2_table(5177) := '6974682822696D6167652F2229293F50726F6D6973652E7265736F6C766528293A73286C297D293B61776169742050726F6D6973652E616C6C286F292C746869732E757070792E656D69742822636F6D70726573736F723A636F6D706C657465222C7229';
wwv_flow_imp.g_varchar2_table(5178) := '2C743E313032342626746869732E757070792E696E666F28746869732E6931386E2822636F6D7072657373656458222C7B73697A653A28302C71702E64656661756C74292874297D292C22696E666F22293B666F72286C65742061206F662065297B6C65';
wwv_flow_imp.g_varchar2_table(5179) := '74206C3D746869732E757070792E67657446696C652861293B746869732E757070792E656D6974282270726570726F636573732D636F6D706C657465222C6C297D7D696E7374616C6C28297B746869732E757070792E61646450726550726F636573736F';
wwv_flow_imp.g_varchar2_table(5180) := '7228746869732E7072657061726555706C6F6164297D756E696E7374616C6C28297B746869732E757070792E72656D6F766550726550726F636573736F7228746869732E7072657061726555706C6F6164297D7D3B6E286F6E2C22436F6D70726573736F';
wwv_flow_imp.g_varchar2_table(5181) := '7222293B66756E6374696F6E206C6828297B72657475726E206C683D4F626A6563742E61737369676E7C7C66756E6374696F6E2869297B666F722876617220653D313B653C617267756D656E74732E6C656E6774683B652B2B297B76617220743D617267';
wwv_flow_imp.g_varchar2_table(5182) := '756D656E74735B655D3B666F7228766172207220696E2074294F626A6563742E70726F746F747970652E6861734F776E50726F70657274792E63616C6C28742C7229262628695B725D3D745B725D297D72657475726E20697D2C6C682E6170706C792874';
wwv_flow_imp.g_varchar2_table(5183) := '6869732C617267756D656E7473297D6E286C682C225F657874656E647322293B7661722041463D7B225B6F626A6563742048544D4C436F6C6C656374696F6E5D223A21302C225B6F626A656374204E6F64654C6973745D223A21302C225B6F626A656374';
wwv_flow_imp.g_varchar2_table(5184) := '20526164696F4E6F64654C6973745D223A21307D2C52463D7B627574746F6E3A21302C6669656C647365743A21302C72657365743A21302C7375626D69743A21307D2C55463D7B636865636B626F783A21302C726164696F3A21307D2C6B463D2F5E5C73';
wwv_flow_imp.g_varchar2_table(5185) := '2B7C5C732B242F672C44463D41727261792E70726F746F747970652E736C6963652C6F623D4F626A6563742E70726F746F747970652E746F537472696E673B66756E6374696F6E20756828692C65297B6966282169297468726F77206E6577204572726F';
wwv_flow_imp.g_varchar2_table(5186) := '7228224120666F726D20697320726571756972656420627920676574466F726D446174612C2077617320676976656E20666F726D3D222B69293B653D6C68287B696E636C75646544697361626C65643A21312C7472696D3A21317D2C65293B666F722876';
wwv_flow_imp.g_varchar2_table(5187) := '617220743D7B7D2C722C733D5B5D2C6F3D7B7D2C613D302C6C3D692E656C656D656E74732E6C656E6774683B613C6C3B612B2B297B76617220683D692E656C656D656E74735B615D3B52465B682E747970655D7C7C682E64697361626C6564262621652E';
wwv_flow_imp.g_varchar2_table(5188) := '696E636C75646544697361626C65647C7C28723D682E6E616D657C7C682E69642C722626216F5B725D262628732E707573682872292C6F5B725D3D213029297D666F722876617220633D302C643D732E6C656E6774683B633C643B632B2B297B723D735B';
wwv_flow_imp.g_varchar2_table(5189) := '635D3B76617220663D616228692C722C65293B66213D6E756C6C262628745B725D3D66297D72657475726E20747D6E2875682C22676574466F726D4461746122293B66756E6374696F6E20616228692C652C74297B6966282169297468726F77206E6577';
wwv_flow_imp.g_varchar2_table(5190) := '204572726F7228224120666F726D206973207265717569726564206279206765744669656C64446174612C2077617320676976656E20666F726D3D222B69293B696628216526266F622E63616C6C286529213D3D225B6F626A65637420537472696E675D';
wwv_flow_imp.g_varchar2_table(5191) := '22297468726F77206E6577204572726F72282241206669656C64206E616D65206973207265717569726564206279206765744669656C64446174612C2077617320676976656E206669656C644E616D653D222B65293B743D6C68287B696E636C75646544';
wwv_flow_imp.g_varchar2_table(5192) := '697361626C65643A21312C7472696D3A21317D2C74293B76617220723D692E656C656D656E74735B655D3B69662821727C7C722E64697361626C6564262621742E696E636C75646544697361626C65642972657475726E206E756C6C3B6966282141465B';
wwv_flow_imp.g_varchar2_table(5193) := '6F622E63616C6C2872295D2972657475726E206E6228722C742E7472696D293B666F722876617220733D5B5D2C6F3D21302C613D302C6C3D722E6C656E6774683B613C6C3B612B2B296966282128725B615D2E64697361626C6564262621742E696E636C';
wwv_flow_imp.g_varchar2_table(5194) := '75646544697361626C656429297B6F2626725B615D2E74797065213D3D22726164696F222626286F3D2131293B76617220683D6E6228725B615D2C742E7472696D293B68213D6E756C6C262628733D732E636F6E636174286829297D72657475726E206F';
wwv_flow_imp.g_varchar2_table(5195) := '2626732E6C656E6774683D3D3D313F735B305D3A732E6C656E6774683E303F733A6E756C6C7D6E2861622C226765744669656C644461746122293B66756E6374696F6E206E6228692C65297B76617220743D6E756C6C2C723D692E747970653B69662872';
wwv_flow_imp.g_varchar2_table(5196) := '3D3D3D2273656C6563742D6F6E65222972657475726E20692E6F7074696F6E732E6C656E677468262628743D692E6F7074696F6E735B692E73656C6563746564496E6465785D2E76616C7565292C743B696628723D3D3D2273656C6563742D6D756C7469';
wwv_flow_imp.g_varchar2_table(5197) := '706C6522297B743D5B5D3B666F722876617220733D302C6F3D692E6F7074696F6E732E6C656E6774683B733C6F3B732B2B29692E6F7074696F6E735B735D2E73656C65637465642626742E7075736828692E6F7074696F6E735B735D2E76616C7565293B';
wwv_flow_imp.g_varchar2_table(5198) := '72657475726E20742E6C656E6774683D3D3D30262628743D6E756C6C292C747D72657475726E20723D3D3D2266696C652226262266696C657322696E20693F28692E6D756C7469706C653F28743D44462E63616C6C28692E66696C6573292C742E6C656E';
wwv_flow_imp.g_varchar2_table(5199) := '6774683D3D3D30262628743D6E756C6C29293A743D692E66696C65735B305D2C74293A2855465B725D3F692E636865636B6564262628723D3D3D22636865636B626F7822262621692E686173417474726962757465282276616C756522293F743D21303A';
wwv_flow_imp.g_varchar2_table(5200) := '743D692E76616C7565293A743D653F692E76616C75652E7265706C616365286B462C2222293A692E76616C75652C74297D6E286E622C22676574466F726D456C656D656E7456616C756522293B75682E6765744669656C64446174613D61623B76617220';
wwv_flow_imp.g_varchar2_table(5201) := '49463D7B76657273696F6E3A22332E302E33227D2C676F3D636C61737320657874656E64732076657B636F6E7374727563746F7228652C74297B737570657228652C74292C746869732E747970653D226163717569726572222C746869732E69643D7468';
wwv_flow_imp.g_varchar2_table(5202) := '69732E6F7074732E69647C7C22466F726D222C746869732E7469746C653D22466F726D223B6C657420723D7B7461726765743A6E756C6C2C726573756C744E616D653A2275707079526573756C74222C6765744D65746146726F6D466F726D3A21302C61';
wwv_flow_imp.g_varchar2_table(5203) := '6464526573756C74546F466F726D3A21302C7375626D69744F6E537563636573733A21312C7472696767657255706C6F61644F6E5375626D69743A21317D3B746869732E6F7074733D7B2E2E2E722C2E2E2E747D2C746869732E68616E646C65466F726D';
wwv_flow_imp.g_varchar2_table(5204) := '5375626D69743D746869732E68616E646C65466F726D5375626D69742E62696E642874686973292C746869732E68616E646C6555706C6F616453746172743D746869732E68616E646C6555706C6F616453746172742E62696E642874686973292C746869';
wwv_flow_imp.g_varchar2_table(5205) := '732E68616E646C65537563636573733D746869732E68616E646C65537563636573732E62696E642874686973292C746869732E616464526573756C74546F466F726D3D746869732E616464526573756C74546F466F726D2E62696E642874686973292C74';
wwv_flow_imp.g_varchar2_table(5206) := '6869732E6765744D65746146726F6D466F726D3D746869732E6765744D65746146726F6D466F726D2E62696E642874686973297D68616E646C6555706C6F6164537461727428297B746869732E6F7074732E6765744D65746146726F6D466F726D262674';
wwv_flow_imp.g_varchar2_table(5207) := '6869732E6765744D65746146726F6D466F726D28297D68616E646C65537563636573732865297B746869732E6F7074732E616464526573756C74546F466F726D2626746869732E616464526573756C74546F466F726D2865292C746869732E6F7074732E';
wwv_flow_imp.g_varchar2_table(5208) := '7375626D69744F6E537563636573732626746869732E666F726D2E7375626D697428297D68616E646C65466F726D5375626D69742865297B696628746869732E6F7074732E7472696767657255706C6F61644F6E5375626D6974297B652E70726576656E';
wwv_flow_imp.g_varchar2_table(5209) := '7444656661756C7428293B6C657420743D516528652E7461726765742E656C656D656E7473292C723D5B5D3B742E666F724561636828733D3E7B28732E7461674E616D653D3D3D22425554544F4E227C7C732E7461674E616D653D3D3D22494E50555422';
wwv_flow_imp.g_varchar2_table(5210) := '2626732E747970653D3D3D227375626D69742229262621732E64697361626C6564262628732E64697361626C65643D21302C722E70757368287329297D292C746869732E757070792E75706C6F616428292E7468656E2828293D3E7B722E666F72456163';
wwv_flow_imp.g_varchar2_table(5211) := '6828733D3E7B732E64697361626C65643D21317D297D2C733D3E28722E666F7245616368286F3D3E7B6F2E64697361626C65643D21317D292C50726F6D6973652E72656A65637428732929292E636174636828733D3E7B746869732E757070792E6C6F67';
wwv_flow_imp.g_varchar2_table(5212) := '28732E737461636B7C7C732E6D6573736167657C7C73297D297D7D616464526573756C74546F466F726D2865297B746869732E757070792E6C6F6728225B466F726D5D20416464696E6720726573756C7420746F20746865206F726967696E616C20666F';
wwv_flow_imp.g_varchar2_table(5213) := '726D3A22292C746869732E757070792E6C6F672865293B6C657420743D746869732E666F726D2E717565727953656C6563746F7228605B6E616D653D22247B746869732E6F7074732E726573756C744E616D657D225D60293B69662874297B6C65742072';
wwv_flow_imp.g_varchar2_table(5214) := '3B7472797B723D4A534F4E2E706172736528742E76616C7565297D63617463687B7D41727261792E697341727261792872297C7C28723D5B5D292C722E707573682865292C742E76616C75653D4A534F4E2E737472696E676966792872293B7265747572';
wwv_flow_imp.g_varchar2_table(5215) := '6E7D743D646F63756D656E742E637265617465456C656D656E742822696E70757422292C742E6E616D653D746869732E6F7074732E726573756C744E616D652C742E747970653D2268696464656E222C742E76616C75653D4A534F4E2E737472696E6769';
wwv_flow_imp.g_varchar2_table(5216) := '6679285B655D292C746869732E666F726D2E617070656E644368696C642874297D6765744D65746146726F6D466F726D28297B6C657420653D756828746869732E666F726D293B64656C65746520655B746869732E6F7074732E726573756C744E616D65';
wwv_flow_imp.g_varchar2_table(5217) := '5D2C746869732E757070792E7365744D6574612865297D696E7374616C6C28297B696628746869732E666F726D3D546E28746869732E6F7074732E746172676574292C21746869732E666F726D7C7C746869732E666F726D2E6E6F64654E616D65213D3D';
wwv_flow_imp.g_varchar2_table(5218) := '22464F524D22297B746869732E757070792E6C6F672822466F726D20706C7567696E2072657175697265732061203C666F726D3E2074617267657420656C656D656E742070617373656420696E206F7074696F6E7320746F206F7065726174652C206E6F';
wwv_flow_imp.g_varchar2_table(5219) := '6E652077617320666F756E64222C226572726F7222293B72657475726E7D746869732E666F726D2E6164644576656E744C697374656E657228227375626D6974222C746869732E68616E646C65466F726D5375626D6974292C746869732E757070792E6F';
wwv_flow_imp.g_varchar2_table(5220) := '6E282275706C6F6164222C746869732E68616E646C6555706C6F61645374617274292C746869732E757070792E6F6E2822636F6D706C657465222C746869732E68616E646C6553756363657373297D756E696E7374616C6C28297B746869732E666F726D';
wwv_flow_imp.g_varchar2_table(5221) := '2E72656D6F76654576656E744C697374656E657228227375626D6974222C746869732E68616E646C65466F726D5375626D6974292C746869732E757070792E6F6666282275706C6F6164222C746869732E68616E646C6555706C6F61645374617274292C';
wwv_flow_imp.g_varchar2_table(5222) := '746869732E757070792E6F66662822636F6D706C657465222C746869732E68616E646C6553756363657373297D7D3B6E28676F2C22466F726D22293B676F2E56455253494F4E3D49462E76657273696F6E3B7661722062623D646528526C28292C31293B';
wwv_flow_imp.g_varchar2_table(5223) := '66756E6374696F6E20796F28692C65297B696628214F626A6563742E70726F746F747970652E6861734F776E50726F70657274792E63616C6C28692C6529297468726F77206E657720547970654572726F722822617474656D7074656420746F20757365';
wwv_flow_imp.g_varchar2_table(5224) := '2070726976617465206669656C64206F6E206E6F6E2D696E7374616E636522293B72657475726E20697D6E28796F2C225F636C617373507269766174654669656C644C6F6F73654261736522293B766172204D463D303B66756E6374696F6E204E462869';
wwv_flow_imp.g_varchar2_table(5225) := '297B72657475726E225F5F707269766174655F222B4D462B2B2B225F222B697D6E284E462C225F636C617373507269766174654669656C644C6F6F73654B657922293B766172206C623D747970656F66206E6176696761746F723C227522262622736572';
wwv_flow_imp.g_varchar2_table(5226) := '76696365576F726B657222696E206E6176696761746F723B66756E6374696F6E204C4628297B72657475726E206E65772050726F6D6973652828692C65293D3E7B6C623F6E6176696761746F722E73657276696365576F726B65722E636F6E74726F6C6C';
wwv_flow_imp.g_varchar2_table(5227) := '65723F6928293A6E6176696761746F722E73657276696365576F726B65722E6164644576656E744C697374656E65722822636F6E74726F6C6C65726368616E6765222C28293D3E7B6928297D293A65286E6577204572726F722822556E737570706F7274';
wwv_flow_imp.g_varchar2_table(5228) := '65642229297D297D6E284C462C2277616974466F7253657276696365576F726B657222293B766172207A743D4E462822726561647922292C766C3D636C6173737B636F6E7374727563746F722865297B4F626A6563742E646566696E6550726F70657274';
wwv_flow_imp.g_varchar2_table(5229) := '7928746869732C7A742C7B7772697461626C653A21302C76616C75653A766F696420307D292C796F28746869732C7A74295B7A745D3D4C4628292E7468656E28743D3E7B796F28746869732C7A74295B7A745D3D747D292C746869732E6E616D653D652E';
wwv_flow_imp.g_varchar2_table(5230) := '73746F72654E616D657D67657420726561647928297B72657475726E2050726F6D6973652E7265736F6C766528796F28746869732C7A74295B7A745D297D7365742072656164792865297B796F28746869732C7A74295B7A745D3D657D6173796E63206C';
wwv_flow_imp.g_varchar2_table(5231) := '69737428297B72657475726E20617761697420796F28746869732C7A74295B7A745D2C6E65772050726F6D6973652828652C74293D3E7B6C657420723D6E28733D3E7B696628732E646174612E73746F72653D3D3D746869732E6E616D65297377697463';
wwv_flow_imp.g_varchar2_table(5232) := '6828732E646174612E74797065297B6361736522757070792F414C4C5F46494C4553223A6528732E646174612E66696C6573292C6E6176696761746F722E73657276696365576F726B65722E72656D6F76654576656E744C697374656E657228226D6573';
wwv_flow_imp.g_varchar2_table(5233) := '73616765222C72293B627265616B3B64656661756C743A7428297D7D2C226F6E4D65737361676522293B6E6176696761746F722E73657276696365576F726B65722E6164644576656E744C697374656E657228226D657373616765222C72292C6E617669';
wwv_flow_imp.g_varchar2_table(5234) := '6761746F722E73657276696365576F726B65722E636F6E74726F6C6C65722E706F73744D657373616765287B747970653A22757070792F4745545F46494C4553222C73746F72653A746869732E6E616D657D297D297D6173796E63207075742865297B61';
wwv_flow_imp.g_varchar2_table(5235) := '7761697420796F28746869732C7A74295B7A745D2C6E6176696761746F722E73657276696365576F726B65722E636F6E74726F6C6C65722E706F73744D657373616765287B747970653A22757070792F4144445F46494C45222C73746F72653A74686973';
wwv_flow_imp.g_varchar2_table(5236) := '2E6E616D652C66696C653A657D297D6173796E632064656C6574652865297B617761697420796F28746869732C7A74295B7A745D2C6E6176696761746F722E73657276696365576F726B65722E636F6E74726F6C6C65722E706F73744D65737361676528';
wwv_flow_imp.g_varchar2_table(5237) := '7B747970653A22757070792F52454D4F56455F46494C45222C73746F72653A746869732E6E616D652C66696C6549443A657D297D7D3B6E28766C2C2253657276696365576F726B657253746F726522293B766C2E6973537570706F727465643D6C623B76';
wwv_flow_imp.g_varchar2_table(5238) := '61722075623D766C3B66756E6374696F6E20617228692C65297B696628214F626A6563742E70726F746F747970652E6861734F776E50726F70657274792E63616C6C28692C6529297468726F77206E657720547970654572726F722822617474656D7074';
wwv_flow_imp.g_varchar2_table(5239) := '656420746F207573652070726976617465206669656C64206F6E206E6F6E2D696E7374616E636522293B72657475726E20697D6E2861722C225F636C617373507269766174654669656C644C6F6F73654261736522293B7661722042463D303B66756E63';
wwv_flow_imp.g_varchar2_table(5240) := '74696F6E207A462869297B72657475726E225F5F707269766174655F222B42462B2B2B225F222B697D6E287A462C225F636C617373507269766174654669656C644C6F6F73654B657922293B7661722066623D747970656F662077696E646F773C227522';
wwv_flow_imp.g_varchar2_table(5241) := '26262877696E646F772E696E646578656444427C7C77696E646F772E7765626B6974496E646578656444427C7C77696E646F772E6D6F7A496E646578656444427C7C77696E646F772E4F496E646578656444427C7C77696E646F772E6D73496E64657865';
wwv_flow_imp.g_varchar2_table(5242) := '644442292C6A463D212166622C68623D22757070792D626C6F6273222C57743D2266696C6573222C6D623D32342A36302A36302A3165332C48463D332C64623D313034383537363B66756E6374696F6E2024462869297B6C657420653D692E6F70656E43';
wwv_flow_imp.g_varchar2_table(5243) := '7572736F7228293B652E6F6E737563636573733D743D3E7B6C657420723D742E7461726765742E726573756C743B69662821722972657475726E3B6C657420733D722E76616C75653B732E657870697265733D446174652E6E6F7728292B6D622C722E75';
wwv_flow_imp.g_varchar2_table(5244) := '70646174652873297D7D6E2824462C226D69677261746545787069726174696F6E22293B66756E6374696F6E2063622869297B6C657420653D66622E6F70656E28692C4846293B72657475726E206E65772050726F6D6973652828742C72293D3E7B652E';
wwv_flow_imp.g_varchar2_table(5245) := '6F6E757067726164656E65656465643D733D3E7B6C6574206F3D732E7461726765742E726573756C742C7B7472616E73616374696F6E3A617D3D732E63757272656E745461726765743B696628732E6F6C6456657273696F6E3C3226266F2E6372656174';
wwv_flow_imp.g_varchar2_table(5246) := '654F626A65637453746F72652857742C7B6B6579506174683A226964227D292E637265617465496E646578282273746F7265222C2273746F7265222C7B756E697175653A21317D292C732E6F6C6456657273696F6E3C33297B6C6574206C3D612E6F626A';
wwv_flow_imp.g_varchar2_table(5247) := '65637453746F7265285774293B6C2E637265617465496E646578282265787069726573222C2265787069726573222C7B756E697175653A21317D292C2446286C297D612E6F6E636F6D706C6574653D28293D3E7B74286F297D7D2C652E6F6E7375636365';
wwv_flow_imp.g_varchar2_table(5248) := '73733D733D3E7B7428732E7461726765742E726573756C74297D2C652E6F6E6572726F723D727D297D6E2863622C22636F6E6E65637422293B66756E6374696F6E2068682869297B72657475726E206E65772050726F6D6973652828652C74293D3E7B69';
wwv_flow_imp.g_varchar2_table(5249) := '2E6F6E737563636573733D723D3E7B6528722E7461726765742E726573756C74297D2C692E6F6E6572726F723D747D297D6E2868682C2277616974466F725265717565737422293B7661722070623D21312C57653D7A462822726561647922292C766F3D';
wwv_flow_imp.g_varchar2_table(5250) := '636C6173737B636F6E7374727563746F722865297B4F626A6563742E646566696E6550726F706572747928746869732C57652C7B7772697461626C653A21302C76616C75653A766F696420307D292C746869732E6F7074733D7B64624E616D653A68622C';
wwv_flow_imp.g_varchar2_table(5251) := '73746F72654E616D653A2264656661756C74222C657870697265733A6D622C6D617846696C6553697A653A31302A64622C6D6178546F74616C53697A653A3330302A64622C2E2E2E657D2C746869732E6E616D653D746869732E6F7074732E73746F7265';
wwv_flow_imp.g_varchar2_table(5252) := '4E616D653B6C657420743D6E286173796E6328293D3E7B6C657420723D617761697420636228746869732E6F7074732E64624E616D65293B72657475726E20617228746869732C5765295B57655D3D722C727D2C22637265617465436F6E6E656374696F';
wwv_flow_imp.g_varchar2_table(5253) := '6E22293B70623F617228746869732C5765295B57655D3D7428293A2870623D21302C617228746869732C5765295B57655D3D766F2E636C65616E757028292E7468656E28742C7429297D67657420726561647928297B72657475726E2050726F6D697365';
wwv_flow_imp.g_varchar2_table(5254) := '2E7265736F6C766528617228746869732C5765295B57655D297D7365742072656164792865297B617228746869732C5765295B57655D3D657D6B65792865297B72657475726E60247B746869732E6E616D657D21247B657D607D6173796E63206C697374';
wwv_flow_imp.g_varchar2_table(5255) := '28297B6C657420733D28617761697420617228746869732C5765295B57655D292E7472616E73616374696F6E285B57745D2C22726561646F6E6C7922292E6F626A65637453746F7265285774292E696E646578282273746F726522292E676574416C6C28';
wwv_flow_imp.g_varchar2_table(5256) := '4944424B657952616E67652E6F6E6C7928746869732E6E616D6529292C6F3D61776169742068682873293B72657475726E204F626A6563742E66726F6D456E7472696573286F2E6D617028613D3E5B612E66696C6549442C612E646174615D29297D6173';
wwv_flow_imp.g_varchar2_table(5257) := '796E63206765742865297B6C657420733D28617761697420617228746869732C5765295B57655D292E7472616E73616374696F6E285B57745D2C22726561646F6E6C7922292E6F626A65637453746F7265285774292E67657428746869732E6B65792865';
wwv_flow_imp.g_varchar2_table(5258) := '29292C7B646174613A6F7D3D61776169742068682873293B72657475726E7B69643A6F2E66696C6549442C646174613A6F2E646174617D7D6173796E632067657453697A6528297B6C657420733D28617761697420617228746869732C5765295B57655D';
wwv_flow_imp.g_varchar2_table(5259) := '292E7472616E73616374696F6E285B57745D2C22726561646F6E6C7922292E6F626A65637453746F7265285774292E696E646578282273746F726522292E6F70656E437572736F72284944424B657952616E67652E6F6E6C7928746869732E6E616D6529';
wwv_flow_imp.g_varchar2_table(5260) := '293B72657475726E206E65772050726F6D69736528286F2C61293D3E7B6C6574206C3D303B732E6F6E737563636573733D683D3E7B6C657420633D682E7461726765742E726573756C743B633F286C2B3D632E76616C75652E646174612E73697A652C63';
wwv_flow_imp.g_varchar2_table(5261) := '2E636F6E74696E75652829293A6F286C297D2C732E6F6E6572726F723D28293D3E7B61286E6577204572726F722822436F756C64206E6F742072657472696576652073746F72656420626C6F62732073697A652229297D7D297D6173796E632070757428';
wwv_flow_imp.g_varchar2_table(5262) := '65297B696628652E646174612E73697A653E746869732E6F7074732E6D617846696C6553697A65297468726F77206E6577204572726F72282246696C6520697320746F6F2062696720746F2073746F72652E22293B696628617761697420746869732E67';
wwv_flow_imp.g_varchar2_table(5263) := '657453697A6528293E746869732E6F7074732E6D6178546F74616C53697A65297468726F77206E6577204572726F7228224E6F207370616365206C65667422293B6C6574206F3D617228746869732C5765295B57655D2E7472616E73616374696F6E285B';
wwv_flow_imp.g_varchar2_table(5264) := '57745D2C2272656164777269746522292E6F626A65637453746F7265285774292E616464287B69643A746869732E6B657928652E6964292C66696C6549443A652E69642C73746F72653A746869732E6E616D652C657870697265733A446174652E6E6F77';
wwv_flow_imp.g_varchar2_table(5265) := '28292B746869732E6F7074732E657870697265732C646174613A652E646174617D293B72657475726E206868286F297D6173796E632064656C6574652865297B6C657420733D28617761697420617228746869732C5765295B57655D292E7472616E7361';
wwv_flow_imp.g_varchar2_table(5266) := '6374696F6E285B57745D2C2272656164777269746522292E6F626A65637453746F7265285774292E64656C65746528746869732E6B6579286529293B72657475726E2068682873297D737461746963206173796E6320636C65616E757028297B6C657420';
wwv_flow_imp.g_varchar2_table(5267) := '653D6177616974206362286862292C733D652E7472616E73616374696F6E285B57745D2C2272656164777269746522292E6F626A65637453746F7265285774292E696E64657828226578706972657322292E6F70656E437572736F72284944424B657952';
wwv_flow_imp.g_varchar2_table(5268) := '616E67652E7570706572426F756E6428446174652E6E6F77282929293B6177616974206E65772050726F6D69736528286F2C61293D3E7B732E6F6E737563636573733D6C3D3E7B6C657420683D6C2E7461726765742E726573756C743B683F28682E6465';
wwv_flow_imp.g_varchar2_table(5269) := '6C65746528292C682E636F6E74696E75652829293A6F28297D2C732E6F6E6572726F723D617D292C652E636C6F736528297D7D3B6E28766F2C22496E6465786564444253746F726522293B766F2E6973537570706F727465643D6A463B7661722067623D';
wwv_flow_imp.g_varchar2_table(5270) := '766F3B66756E6374696F6E20714628297B6C657420693D5B5D3B666F72286C657420653D303B653C6C6F63616C53746F726167652E6C656E6774683B652B2B297B6C657420743D6C6F63616C53746F726167652E6B65792865293B742E73746172747357';
wwv_flow_imp.g_varchar2_table(5271) := '69746828227570707953746174653A22292626692E7075736828742E736C69636528313029297D72657475726E20697D6E2871462C2266696E6455707079496E7374616E63657322293B66756E6374696F6E2079622869297B7472797B72657475726E20';
wwv_flow_imp.g_varchar2_table(5272) := '4A534F4E2E70617273652869297D63617463687B72657475726E206E756C6C7D7D6E2879622C226D61796265506172736522293B7661722076623D21312C49693D636C6173737B636F6E7374727563746F722865297B746869732E6F7074733D7B657870';
wwv_flow_imp.g_varchar2_table(5273) := '697265733A32342A36302A36302A3165332C2E2E2E657D2C746869732E6E616D653D607570707953746174653A247B652E73746F72654E616D657D602C76627C7C2876623D21302C49692E636C65616E75702829297D6C6F616428297B6C657420653D6C';
wwv_flow_imp.g_varchar2_table(5274) := '6F63616C53746F726167652E6765744974656D28746869732E6E616D65293B69662821652972657475726E206E756C6C3B6C657420743D79622865293B72657475726E20743F742E6D657461646174613F742E6D657461646174613A28746869732E7361';
wwv_flow_imp.g_varchar2_table(5275) := '76652874292C74293A6E756C6C7D736176652865297B6C657420743D446174652E6E6F7728292B746869732E6F7074732E657870697265732C723D4A534F4E2E737472696E67696679287B6D657461646174613A652C657870697265733A747D293B6C6F';
wwv_flow_imp.g_varchar2_table(5276) := '63616C53746F726167652E7365744974656D28746869732E6E616D652C72297D73746174696320636C65616E75702865297B69662865297B6C6F63616C53746F726167652E72656D6F76654974656D28607570707953746174653A247B657D60293B7265';
wwv_flow_imp.g_varchar2_table(5277) := '7475726E7D6C657420743D714628292C723D446174652E6E6F7728293B742E666F724561636828733D3E7B6C6574206F3D6C6F63616C53746F726167652E6765744974656D28607570707953746174653A247B737D60293B696628216F2972657475726E';
wwv_flow_imp.g_varchar2_table(5278) := '3B6C657420613D7962286F293B612626612E657870697265732626612E657870697265733C7226266C6F63616C53746F726167652E72656D6F76654974656D28607570707953746174653A247B737D60297D297D7D3B6E2849692C224D65746144617461';
wwv_flow_imp.g_varchar2_table(5279) := '53746F726522293B7661722056463D7B76657273696F6E3A22332E312E31227D2C626F3D636C61737320657874656E64732076657B636F6E7374727563746F7228652C74297B737570657228652C74292C746869732E616464426C6F62546F53746F7265';
wwv_flow_imp.g_varchar2_table(5280) := '733D733D3E7B732E697352656D6F74657C7C28746869732E53657276696365576F726B657253746F72652626746869732E53657276696365576F726B657253746F72652E7075742873292E6361746368286F3D3E7B746869732E757070792E6C6F672822';
wwv_flow_imp.g_varchar2_table(5281) := '5B476F6C64656E5265747269657665725D20436F756C64206E6F742073746F72652066696C65222C227761726E696E6722292C746869732E757070792E6C6F67286F297D292C746869732E496E6465786564444253746F72652E7075742873292E636174';
wwv_flow_imp.g_varchar2_table(5282) := '6368286F3D3E7B746869732E757070792E6C6F6728225B476F6C64656E5265747269657665725D20436F756C64206E6F742073746F72652066696C65222C227761726E696E6722292C746869732E757070792E6C6F67286F297D29297D2C746869732E72';
wwv_flow_imp.g_varchar2_table(5283) := '656D6F7665426C6F6246726F6D53746F7265733D733D3E7B746869732E53657276696365576F726B657253746F72652626746869732E53657276696365576F726B657253746F72652E64656C65746528732E6964292E6361746368286F3D3E7B74686973';
wwv_flow_imp.g_varchar2_table(5284) := '2E757070792E6C6F6728225B476F6C64656E5265747269657665725D204661696C656420746F2072656D6F76652066696C65222C227761726E696E6722292C746869732E757070792E6C6F67286F297D292C746869732E496E6465786564444253746F72';
wwv_flow_imp.g_varchar2_table(5285) := '652E64656C65746528732E6964292E6361746368286F3D3E7B746869732E757070792E6C6F6728225B476F6C64656E5265747269657665725D204661696C656420746F2072656D6F76652066696C65222C227761726E696E6722292C746869732E757070';
wwv_flow_imp.g_varchar2_table(5286) := '792E6C6F67286F297D297D2C746869732E7265706C616365426C6F62496E53746F7265733D733D3E7B746869732E72656D6F7665426C6F6246726F6D53746F7265732873292C746869732E616464426C6F62546F53746F7265732873297D2C746869732E';
wwv_flow_imp.g_varchar2_table(5287) := '68616E646C65526573746F7265436F6E6669726D65643D28293D3E7B746869732E757070792E6C6F6728225B476F6C64656E5265747269657665725D20526573746F726520636F6E6669726D65642C2070726F63656564696E672E2E2E22293B6C65747B';
wwv_flow_imp.g_varchar2_table(5288) := '63757272656E7455706C6F6164733A737D3D746869732E757070792E676574537461746528293B73262628746869732E757070792E726573756D65416C6C28292C4F626A6563742E6B6579732873292E666F7245616368286F3D3E7B746869732E757070';
wwv_flow_imp.g_varchar2_table(5289) := '792E726573746F7265286F2C735B6F5D297D29292C746869732E757070792E7365745374617465287B7265636F766572656453746174653A6E756C6C7D297D2C746869732E61626F7274526573746F72653D28293D3E7B746869732E757070792E6C6F67';
wwv_flow_imp.g_varchar2_table(5290) := '28225B476F6C64656E5265747269657665725D2041626F7274696E6720726573746F72652E2E2E22293B6C657420733D4F626A6563742E6B65797328746869732E757070792E676574537461746528292E66696C6573293B746869732E64656C65746542';
wwv_flow_imp.g_varchar2_table(5291) := '6C6F62732873292E7468656E2828293D3E7B746869732E757070792E6C6F6728605B476F6C64656E5265747269657665725D2052656D6F76656420247B732E6C656E6774687D2066696C657360297D292E6361746368286F3D3E7B746869732E75707079';
wwv_flow_imp.g_varchar2_table(5292) := '2E6C6F6728605B476F6C64656E5265747269657665725D20436F756C64206E6F742072656D6F766520247B732E6C656E6774687D2066696C6573602C227761726E696E6722292C746869732E757070792E6C6F67286F297D292C746869732E757070792E';
wwv_flow_imp.g_varchar2_table(5293) := '63616E63656C416C6C28292C746869732E757070792E7365745374617465287B7265636F766572656453746174653A6E756C6C7D292C49692E636C65616E757028746869732E757070792E6F7074732E6964297D2C746869732E68616E646C65436F6D70';
wwv_flow_imp.g_varchar2_table(5294) := '6C6574653D733D3E7B6C65747B7375636365737366756C3A6F7D3D732C613D6F2E6D6170286C3D3E6C2E6964293B746869732E64656C657465426C6F62732861292E7468656E2828293D3E7B746869732E757070792E6C6F6728605B476F6C64656E5265';
wwv_flow_imp.g_varchar2_table(5295) := '747269657665725D2052656D6F76656420247B6F2E6C656E6774687D2066696C657320746861742066696E69736865642075706C6F6164696E6760297D292E6361746368286C3D3E7B746869732E757070792E6C6F6728605B476F6C64656E5265747269';
wwv_flow_imp.g_varchar2_table(5296) := '657665725D20436F756C64206E6F742072656D6F766520247B6F2E6C656E6774687D2066696C657320746861742066696E69736865642075706C6F6164696E67602C227761726E696E6722292C746869732E757070792E6C6F67286C297D292C74686973';
wwv_flow_imp.g_varchar2_table(5297) := '2E757070792E7365745374617465287B7265636F766572656453746174653A6E756C6C7D292C49692E636C65616E757028746869732E757070792E6F7074732E6964297D2C746869732E726573746F7265426C6F62733D28293D3E7B746869732E757070';
wwv_flow_imp.g_varchar2_table(5298) := '792E67657446696C657328292E6C656E6774683E303F50726F6D6973652E616C6C285B746869732E6C6F616446696C65426C6F627346726F6D53657276696365576F726B657228292C746869732E6C6F616446696C65426C6F627346726F6D496E646578';
wwv_flow_imp.g_varchar2_table(5299) := '6564444228295D292E7468656E28733D3E7B6C6574206F3D7B2E2E2E735B305D2C2E2E2E735B315D7D3B746869732E6F6E426C6F62734C6F61646564286F297D293A746869732E757070792E6C6F6728225B476F6C64656E5265747269657665725D204E';
wwv_flow_imp.g_varchar2_table(5300) := '6F2066696C6573206E65656420746F206265206C6F616465642C206F6E6C7920726573746F72696E672070726F63657373696E672073746174652E2E2E22297D2C746869732E747970653D226465627567676572222C746869732E69643D746869732E6F';
wwv_flow_imp.g_varchar2_table(5301) := '7074732E69647C7C22476F6C64656E526574726965766572222C746869732E7469746C653D22476F6C64656E20526574726965766572223B6C657420723D7B657870697265733A32342A36302A36302A3165332C73657276696365576F726B65723A2131';
wwv_flow_imp.g_varchar2_table(5302) := '7D3B746869732E6F7074733D7B2E2E2E722C2E2E2E747D2C746869732E4D6574614461746153746F72653D6E6577204969287B657870697265733A746869732E6F7074732E657870697265732C73746F72654E616D653A652E676574494428297D292C74';
wwv_flow_imp.g_varchar2_table(5303) := '6869732E53657276696365576F726B657253746F72653D6E756C6C2C746869732E6F7074732E73657276696365576F726B6572262628746869732E53657276696365576F726B657253746F72653D6E6577207562287B73746F72654E616D653A652E6765';
wwv_flow_imp.g_varchar2_table(5304) := '74494428297D29292C746869732E496E6465786564444253746F72653D6E6577206762287B657870697265733A746869732E6F7074732E657870697265732C2E2E2E746869732E6F7074732E696E646578656444427C7C7B7D2C73746F72654E616D653A';
wwv_flow_imp.g_varchar2_table(5305) := '652E676574494428297D292C746869732E7361766546696C65735374617465546F4C6F63616C53746F726167653D28302C62622E64656661756C742928746869732E7361766546696C65735374617465546F4C6F63616C53746F726167652E62696E6428';
wwv_flow_imp.g_varchar2_table(5306) := '74686973292C3530302C7B6C656164696E673A21302C747261696C696E673A21307D292C746869732E726573746F726553746174653D746869732E726573746F726553746174652E62696E642874686973292C746869732E6C6F616446696C65426C6F62';
wwv_flow_imp.g_varchar2_table(5307) := '7346726F6D53657276696365576F726B65723D746869732E6C6F616446696C65426C6F627346726F6D53657276696365576F726B65722E62696E642874686973292C746869732E6C6F616446696C65426C6F627346726F6D496E646578656444423D7468';
wwv_flow_imp.g_varchar2_table(5308) := '69732E6C6F616446696C65426C6F627346726F6D496E646578656444422E62696E642874686973292C746869732E6F6E426C6F62734C6F616465643D746869732E6F6E426C6F62734C6F616465642E62696E642874686973297D726573746F7265537461';
wwv_flow_imp.g_varchar2_table(5309) := '746528297B6C657420653D746869732E4D6574614461746153746F72652E6C6F616428293B65262628746869732E757070792E6C6F6728225B476F6C64656E5265747269657665725D205265636F766572656420736F6D652073746174652066726F6D20';
wwv_flow_imp.g_varchar2_table(5310) := '4C6F63616C2053746F7261676522292C746869732E757070792E7365745374617465287B63757272656E7455706C6F6164733A652E63757272656E7455706C6F6164737C7C7B7D2C66696C65733A652E66696C65737C7C7B7D2C7265636F766572656453';
wwv_flow_imp.g_varchar2_table(5311) := '746174653A657D292C746869732E7361766564506C7567696E446174613D652E706C7567696E44617461297D67657457616974696E6746696C657328297B6C657420653D7B7D3B72657475726E20746869732E757070792E67657446696C657328292E66';
wwv_flow_imp.g_varchar2_table(5312) := '6F724561636828743D3E7B2821742E70726F67726573737C7C21742E70726F67726573732E75706C6F61645374617274656429262628655B742E69645D3D74297D292C657D67657455706C6F6164696E6746696C657328297B6C657420653D7B7D2C7B63';
wwv_flow_imp.g_varchar2_table(5313) := '757272656E7455706C6F6164733A747D3D746869732E757070792E676574537461746528293B72657475726E207426264F626A6563742E6B6579732874292E666F724561636828733D3E7B745B735D2E66696C654944732E666F724561636828613D3E7B';
wwv_flow_imp.g_varchar2_table(5314) := '655B615D3D746869732E757070792E67657446696C652861297D297D292C657D7361766546696C65735374617465546F4C6F63616C53746F7261676528297B6C657420653D7B2E2E2E746869732E67657457616974696E6746696C657328292C2E2E2E74';
wwv_flow_imp.g_varchar2_table(5315) := '6869732E67657455706C6F6164696E6746696C657328297D2C743D4F626A6563742E656E74726965732865293B696628742E6C656E6774683D3D3D30297B746869732E757070792E676574537461746528292E7265636F76657265645374617465213D3D';
wwv_flow_imp.g_varchar2_table(5316) := '6E756C6C2626746869732E757070792E7365745374617465287B7265636F766572656453746174653A6E756C6C7D292C49692E636C65616E757028746869732E757070792E6F7074732E6964293B72657475726E7D6C657420723D4F626A6563742E6672';
wwv_flow_imp.g_varchar2_table(5317) := '6F6D456E747269657328742E6D617028613D3E7B6C65745B6C2C685D3D613B72657475726E5B6C2C682E697352656D6F74653F7B2E2E2E682C6973526573746F7265643A21307D3A7B2E2E2E682C6973526573746F7265643A21302C646174613A6E756C';
wwv_flow_imp.g_varchar2_table(5318) := '6C2C707265766965773A6E756C6C7D5D7D29292C733D7B7D3B746869732E757070792E656D69742822726573746F72653A6765742D64617461222C613D3E7B4F626A6563742E61737369676E28732C61297D293B6C65747B63757272656E7455706C6F61';
wwv_flow_imp.g_varchar2_table(5319) := '64733A6F7D3D746869732E757070792E676574537461746528293B746869732E4D6574614461746153746F72652E73617665287B63757272656E7455706C6F6164733A6F2C66696C65733A722C706C7567696E446174613A737D297D6C6F616446696C65';
wwv_flow_imp.g_varchar2_table(5320) := '426C6F627346726F6D53657276696365576F726B657228297B72657475726E20746869732E53657276696365576F726B657253746F72653F746869732E53657276696365576F726B657253746F72652E6C69737428292E7468656E28653D3E7B6C657420';
wwv_flow_imp.g_varchar2_table(5321) := '743D4F626A6563742E6B6579732865292E6C656E6774683B72657475726E20743E303F28746869732E757070792E6C6F6728605B476F6C64656E5265747269657665725D205375636365737366756C6C79207265636F766572656420247B747D20626C6F';
wwv_flow_imp.g_varchar2_table(5322) := '62732066726F6D205365727669636520576F726B65722160292C65293A28746869732E757070792E6C6F6728225B476F6C64656E5265747269657665725D204E6F20626C6F627320666F756E6420696E205365727669636520576F726B65722C20747279';
wwv_flow_imp.g_varchar2_table(5323) := '696E6720496E64657865644442206E6F772E2E2E22292C7B7D297D292E636174636828653D3E28746869732E757070792E6C6F6728225B476F6C64656E5265747269657665725D204661696C656420746F207265636F76657220626C6F62732066726F6D';
wwv_flow_imp.g_varchar2_table(5324) := '205365727669636520576F726B6572222C227761726E696E6722292C746869732E757070792E6C6F672865292C7B7D29293A50726F6D6973652E7265736F6C7665287B7D297D6C6F616446696C65426C6F627346726F6D496E6465786564444228297B72';
wwv_flow_imp.g_varchar2_table(5325) := '657475726E20746869732E496E6465786564444253746F72652E6C69737428292E7468656E28653D3E7B6C657420743D4F626A6563742E6B6579732865292E6C656E6774683B72657475726E20743E303F28746869732E757070792E6C6F6728605B476F';
wwv_flow_imp.g_varchar2_table(5326) := '6C64656E5265747269657665725D205375636365737366756C6C79207265636F766572656420247B747D20626C6F62732066726F6D20496E646578656444422160292C65293A28746869732E757070792E6C6F6728225B476F6C64656E52657472696576';
wwv_flow_imp.g_varchar2_table(5327) := '65725D204E6F20626C6F627320666F756E6420696E20496E6465786564444222292C7B7D297D292E636174636828653D3E28746869732E757070792E6C6F6728225B476F6C64656E5265747269657665725D204661696C656420746F207265636F766572';
wwv_flow_imp.g_varchar2_table(5328) := '20626C6F62732066726F6D20496E64657865644442222C227761726E696E6722292C746869732E757070792E6C6F672865292C7B7D29297D6F6E426C6F62734C6F616465642865297B6C657420743D5B5D2C723D7B2E2E2E746869732E757070792E6765';
wwv_flow_imp.g_varchar2_table(5329) := '74537461746528292E66696C65737D3B4F626A6563742E6B6579732865292E666F724561636828733D3E7B6C6574206F3D746869732E757070792E67657446696C652873293B696628216F297B742E707573682873293B72657475726E7D6C6574206C3D';
wwv_flow_imp.g_varchar2_table(5330) := '7B646174613A655B735D2C6973526573746F7265643A21302C697347686F73743A21317D3B725B735D3D7B2E2E2E6F2C2E2E2E6C7D7D292C4F626A6563742E6B6579732872292E666F724561636828733D3E7B725B735D2E646174613D3D3D6E756C6C26';
wwv_flow_imp.g_varchar2_table(5331) := '2628725B735D3D7B2E2E2E725B735D2C697347686F73743A21307D297D292C746869732E757070792E7365745374617465287B66696C65733A727D292C746869732E757070792E656D69742822726573746F726564222C746869732E7361766564506C75';
wwv_flow_imp.g_varchar2_table(5332) := '67696E44617461292C742E6C656E6774682626746869732E64656C657465426C6F62732874292E7468656E2828293D3E7B746869732E757070792E6C6F6728605B476F6C64656E5265747269657665725D20436C65616E656420757020247B742E6C656E';
wwv_flow_imp.g_varchar2_table(5333) := '6774687D206F6C642066696C657360297D292E636174636828733D3E7B746869732E757070792E6C6F6728605B476F6C64656E5265747269657665725D20436F756C64206E6F7420636C65616E20757020247B742E6C656E6774687D206F6C642066696C';
wwv_flow_imp.g_varchar2_table(5334) := '6573602C227761726E696E6722292C746869732E757070792E6C6F672873297D297D64656C657465426C6F62732865297B72657475726E2050726F6D6973652E616C6C28652E6D617028743D3E7B76617220722C732C6F3B72657475726E28723D28733D';
wwv_flow_imp.g_varchar2_table(5335) := '746869732E53657276696365576F726B657253746F7265293D3D6E756C6C3F766F696420303A732E64656C65746528742929213D6E756C6C3F723A286F3D746869732E496E6465786564444253746F7265293D3D6E756C6C3F766F696420303A6F2E6465';
wwv_flow_imp.g_varchar2_table(5336) := '6C6574652874297D29297D696E7374616C6C28297B746869732E726573746F7265537461746528292C746869732E726573746F7265426C6F627328292C746869732E757070792E6F6E282266696C652D6164646564222C746869732E616464426C6F6254';
wwv_flow_imp.g_varchar2_table(5337) := '6F53746F726573292C746869732E757070792E6F6E282266696C652D656469746F723A636F6D706C657465222C746869732E7265706C616365426C6F62496E53746F726573292C746869732E757070792E6F6E282266696C652D72656D6F766564222C74';
wwv_flow_imp.g_varchar2_table(5338) := '6869732E72656D6F7665426C6F6246726F6D53746F726573292C746869732E757070792E6F6E282273746174652D757064617465222C746869732E7361766546696C65735374617465546F4C6F63616C53746F72616765292C746869732E757070792E6F';
wwv_flow_imp.g_varchar2_table(5339) := '6E2822726573746F72652D636F6E6669726D6564222C746869732E68616E646C65526573746F7265436F6E6669726D6564292C746869732E757070792E6F6E2822726573746F72652D63616E63656C6564222C746869732E61626F7274526573746F7265';
wwv_flow_imp.g_varchar2_table(5340) := '292C746869732E757070792E6F6E2822636F6D706C657465222C746869732E68616E646C65436F6D706C657465297D756E696E7374616C6C28297B746869732E757070792E6F6666282266696C652D6164646564222C746869732E616464426C6F62546F';
wwv_flow_imp.g_varchar2_table(5341) := '53746F726573292C746869732E757070792E6F6666282266696C652D656469746F723A636F6D706C657465222C746869732E7265706C616365426C6F62496E53746F726573292C746869732E757070792E6F6666282266696C652D72656D6F766564222C';
wwv_flow_imp.g_varchar2_table(5342) := '746869732E72656D6F7665426C6F6246726F6D53746F726573292C746869732E757070792E6F6666282273746174652D757064617465222C746869732E7361766546696C65735374617465546F4C6F63616C53746F72616765292C746869732E75707079';
wwv_flow_imp.g_varchar2_table(5343) := '2E6F66662822726573746F72652D636F6E6669726D6564222C746869732E68616E646C65526573746F7265436F6E6669726D6564292C746869732E757070792E6F66662822726573746F72652D63616E63656C6564222C746869732E61626F7274526573';
wwv_flow_imp.g_varchar2_table(5344) := '746F7265292C746869732E757070792E6F66662822636F6D706C657465222C746869732E68616E646C65436F6D706C657465297D7D3B6E28626F2C22476F6C64656E52657472696576657222293B626F2E56455253494F4E3D56462E76657273696F6E3B';
wwv_flow_imp.g_varchar2_table(5345) := '7661722057463D7B76657273696F6E3A22332E302E33227D2C776F3D636C61737320657874656E6473205A7B636F6E7374727563746F7228652C74297B737570657228652C74292C746869732E747970653D226465627567676572222C746869732E6964';
wwv_flow_imp.g_varchar2_table(5346) := '3D746869732E6F7074732E69647C7C225265647578446576546F6F6C73222C746869732E7469746C653D22526564757820446576546F6F6C73223B6C657420723D7B7D3B746869732E6F7074733D7B2E2E2E722C2E2E2E747D2C746869732E68616E646C';
wwv_flow_imp.g_varchar2_table(5347) := '6553746174654368616E67653D746869732E68616E646C6553746174654368616E67652E62696E642874686973292C746869732E696E6974446576546F6F6C733D746869732E696E6974446576546F6F6C732E62696E642874686973297D68616E646C65';
wwv_flow_imp.g_varchar2_table(5348) := '53746174654368616E676528652C74297B746869732E646576546F6F6C732E73656E642822555050595F53544154455F555044415445222C74297D696E6974446576546F6F6C7328297B746869732E646576546F6F6C733D77696E646F772E646576546F';
wwv_flow_imp.g_varchar2_table(5349) := '6F6C73457874656E73696F6E2E636F6E6E65637428292C746869732E646576546F6F6C73556E7375627363726962653D746869732E646576546F6F6C732E73756273637269626528653D3E7B696628652E747970653D3D3D224449535041544348222973';
wwv_flow_imp.g_varchar2_table(5350) := '776974636828652E7061796C6F61642E74797065297B63617365225245534554223A746869732E757070792E63616E63656C416C6C28293B72657475726E3B6361736522494D504F52545F5354415445223A7B6C65747B636F6D70757465645374617465';
wwv_flow_imp.g_varchar2_table(5351) := '733A747D3D652E7061796C6F61642E6E6578744C696674656453746174653B746869732E757070792E73746F72652E73746174653D7B2E2E2E746869732E757070792E676574537461746528292C2E2E2E745B742E6C656E6774682D315D2E7374617465';
wwv_flow_imp.g_varchar2_table(5352) := '7D2C746869732E757070792E757064617465416C6C28746869732E757070792E67657453746174652829293B72657475726E7D63617365224A554D505F544F5F5354415445223A63617365224A554D505F544F5F414354494F4E223A746869732E757070';
wwv_flow_imp.g_varchar2_table(5353) := '792E73746F72652E73746174653D7B2E2E2E746869732E757070792E676574537461746528292C2E2E2E4A534F4E2E706172736528652E7374617465297D2C746869732E757070792E757064617465416C6C28746869732E757070792E67657453746174';
wwv_flow_imp.g_varchar2_table(5354) := '652829293B627265616B3B64656661756C743A7D7D297D696E7374616C6C28297B746869732E77697468446576546F6F6C733D747970656F662077696E646F773C227522262677696E646F772E5F5F52454455585F444556544F4F4C535F455854454E53';
wwv_flow_imp.g_varchar2_table(5355) := '494F4E5F5F2C746869732E77697468446576546F6F6C73262628746869732E696E6974446576546F6F6C7328292C746869732E757070792E6F6E282273746174652D757064617465222C746869732E68616E646C6553746174654368616E676529297D75';
wwv_flow_imp.g_varchar2_table(5356) := '6E696E7374616C6C28297B746869732E77697468446576546F6F6C73262628746869732E646576546F6F6C73556E73756273637269626528292C746869732E757070792E6F6666282273746174652D757064617465222C746869732E68616E646C655374';
wwv_flow_imp.g_varchar2_table(5357) := '61746555706461746529297D7D3B6E28776F2C225265647578446576546F6F6C7322293B776F2E56455253494F4E3D57462E76657273696F6E3B66756E6374696F6E20474628297B7468726F77206E6577204572726F722822436F726520686173206265';
wwv_flow_imp.g_varchar2_table(5358) := '656E2072656E616D656420746F205570707922297D6E2847462C22436F726522293B766172204B463D7B50726F7669646572566965773A69647D3B76692E434F4D50414E494F4E5F55524C3D4D703B76692E434F4D50414E494F4E5F414C4C4F5745445F';
wwv_flow_imp.g_varchar2_table(5359) := '484F5354533D4E703B7661722058463D7B7D3B676C6F62616C546869732E557070793D56703B7D2928293B';
null;
end;
/
begin
wwv_flow_imp_shared.create_plugin_file(
 p_id=>wwv_flow_imp.id(740463060394162538)
,p_plugin_id=>wwv_flow_imp.id(739921988389392679)
,p_file_name=>'dist/uppy.min.js'
,p_mime_type=>'text/javascript'
,p_file_charset=>'utf-8'
,p_file_content=>wwv_flow_imp.varchar2_to_blob(wwv_flow_imp.g_varchar2_table)
);
end;
/
begin
wwv_flow_imp.g_varchar2_table := wwv_flow_imp.empty_varchar2_table;
wwv_flow_imp.g_varchar2_table(1) := '406368617273657420225554462D38223B2E757070792D526F6F747B2D7765626B69742D666F6E742D736D6F6F7468696E673A616E7469616C69617365643B2D6D6F7A2D6F73782D666F6E742D736D6F6F7468696E673A677261797363616C653B626F78';
wwv_flow_imp.g_varchar2_table(2) := '2D73697A696E673A626F726465722D626F783B636F6C6F723A233333333B666F6E742D66616D696C793A2D6170706C652D73797374656D2C73797374656D2D75692C426C696E6B4D616353797374656D466F6E742C5365676F652055492C5365676F6520';
wwv_flow_imp.g_varchar2_table(3) := '55492053796D626F6C2C5365676F6520554920456D6F6A692C4170706C6520436F6C6F7220456D6F6A692C526F626F746F2C48656C7665746963612C417269616C2C73616E732D73657269663B6C696E652D6865696768743A313B706F736974696F6E3A';
wwv_flow_imp.g_varchar2_table(4) := '72656C61746976653B746578742D616C69676E3A6C6566747D2E757070792D526F6F745B6469723D72746C5D2C5B6469723D72746C5D202E757070792D526F6F747B746578742D616C69676E3A72696768747D2E757070792D526F6F74202A2C2E757070';
wwv_flow_imp.g_varchar2_table(5) := '792D526F6F74203A61667465722C2E757070792D526F6F74203A6265666F72657B626F782D73697A696E673A696E68657269747D2E757070792D526F6F74205B68696464656E5D7B646973706C61793A6E6F6E657D2E757070792D752D72657365747B61';
wwv_flow_imp.g_varchar2_table(6) := '6C6C3A696E697469616C3B2D7765626B69742D617070656172616E63653A6E6F6E653B617070656172616E63653A6E6F6E653B626F782D73697A696E673A626F726465722D626F783B666F6E742D66616D696C793A2D6170706C652D73797374656D2C73';
wwv_flow_imp.g_varchar2_table(7) := '797374656D2D75692C426C696E6B4D616353797374656D466F6E742C5365676F652055492C5365676F652055492053796D626F6C2C5365676F6520554920456D6F6A692C4170706C6520436F6C6F7220456D6F6A692C526F626F746F2C48656C76657469';
wwv_flow_imp.g_varchar2_table(8) := '63612C417269616C2C73616E732D73657269663B6C696E652D6865696768743A317D5B6469723D72746C5D202E757070792D752D72657365747B746578742D616C69676E3A72696768747D2E757070792D632D74657874496E7075747B6261636B67726F';
wwv_flow_imp.g_varchar2_table(9) := '756E642D636F6C6F723A236666663B626F726465723A31707820736F6C696420236464643B626F726465722D7261646975733A3470783B666F6E742D66616D696C793A696E68657269743B666F6E742D73697A653A313470783B6C696E652D6865696768';
wwv_flow_imp.g_varchar2_table(10) := '743A312E353B70616464696E673A367078203870787D2E757070792D73697A652D2D6D64202E757070792D632D74657874496E7075747B70616464696E673A38707820313070787D2E757070792D632D74657874496E7075743A666F6375737B626F7264';
wwv_flow_imp.g_varchar2_table(11) := '65722D636F6C6F723A2331323639636639393B626F782D736861646F773A302030203020337078202331323639636632363B6F75746C696E653A6E6F6E657D5B646174612D757070792D7468656D653D6461726B5D202E757070792D632D74657874496E';
wwv_flow_imp.g_varchar2_table(12) := '7075747B6261636B67726F756E642D636F6C6F723A233333333B626F726465722D636F6C6F723A233333333B636F6C6F723A236561656165617D5B646174612D757070792D7468656D653D6461726B5D202E757070792D632D74657874496E7075743A66';
wwv_flow_imp.g_varchar2_table(13) := '6F6375737B626F726465722D636F6C6F723A233532353235323B626F782D736861646F773A6E6F6E657D2E757070792D632D69636F6E7B66696C6C3A63757272656E74436F6C6F723B646973706C61793A696E6C696E652D626C6F636B3B6D61782D6865';
wwv_flow_imp.g_varchar2_table(14) := '696768743A313030253B6D61782D77696474683A313030253B6F766572666C6F773A68696464656E7D2E757070792D632D62746E7B616C69676E2D6974656D733A63656E7465723B636F6C6F723A696E68657269743B646973706C61793A696E6C696E65';
wwv_flow_imp.g_varchar2_table(15) := '2D666C65783B666F6E742D66616D696C793A696E68657269743B666F6E742D73697A653A696E68657269743B666F6E742D7765696768743A3530303B6A7573746966792D636F6E74656E743A63656E7465723B6C696E652D6865696768743A313B747261';
wwv_flow_imp.g_varchar2_table(16) := '6E736974696F6E2D6475726174696F6E3A2E33733B7472616E736974696F6E2D70726F70657274793A6261636B67726F756E642D636F6C6F722C636F6C6F723B2D7765626B69742D757365722D73656C6563743A6E6F6E653B757365722D73656C656374';
wwv_flow_imp.g_varchar2_table(17) := '3A6E6F6E653B77686974652D73706163653A6E6F777261707D2E757070792D632D62746E2C5B6469723D72746C5D202E757070792D632D62746E7B746578742D616C69676E3A63656E7465727D2E757070792D632D62746E3A6E6F74283A64697361626C';
wwv_flow_imp.g_varchar2_table(18) := '6564293A6E6F74282E64697361626C6564297B637572736F723A706F696E7465727D2E757070792D632D62746E3A3A2D6D6F7A2D666F6375732D696E6E65727B626F726465723A307D2E757070792D632D62746E2D7072696D6172797B6261636B67726F';
wwv_flow_imp.g_varchar2_table(19) := '756E642D636F6C6F723A233132363963663B626F726465722D7261646975733A3470783B636F6C6F723A236666663B666F6E742D73697A653A313470783B70616464696E673A3130707820313870787D2E757070792D632D62746E2D7072696D6172793A';
wwv_flow_imp.g_varchar2_table(20) := '686F7665727B6261636B67726F756E642D636F6C6F723A233065353161307D2E757070792D632D62746E2D7072696D6172793A666F6375737B626F782D736861646F773A302030203020337078202331323639636636363B6F75746C696E653A6E6F6E65';
wwv_flow_imp.g_varchar2_table(21) := '7D2E757070792D73697A652D2D6D64202E757070792D632D62746E2D7072696D6172797B70616464696E673A3133707820323270787D5B646174612D757070792D7468656D653D6461726B5D202E757070792D632D62746E2D7072696D6172797B636F6C';
wwv_flow_imp.g_varchar2_table(22) := '6F723A236561656165617D5B646174612D757070792D7468656D653D6461726B5D202E757070792D632D62746E2D7072696D6172793A666F6375737B6F75746C696E653A6E6F6E657D5B646174612D757070792D7468656D653D6461726B5D202E757070';
wwv_flow_imp.g_varchar2_table(23) := '792D632D62746E2D7072696D6172793A3A2D6D6F7A2D666F6375732D696E6E65727B626F726465723A307D5B646174612D757070792D7468656D653D6461726B5D202E757070792D632D62746E2D7072696D6172793A666F6375737B626F782D73686164';
wwv_flow_imp.g_varchar2_table(24) := '6F773A302030203020327078202361616531666664397D2E757070792D632D62746E2D6C696E6B7B6261636B67726F756E642D636F6C6F723A696E697469616C3B626F726465722D7261646975733A3470783B636F6C6F723A233532353235323B666F6E';
wwv_flow_imp.g_varchar2_table(25) := '742D73697A653A313470783B6C696E652D6865696768743A313B70616464696E673A3130707820313570787D2E757070792D632D62746E2D6C696E6B3A686F7665727B636F6C6F723A233333337D2E757070792D632D62746E2D6C696E6B3A666F637573';
wwv_flow_imp.g_varchar2_table(26) := '7B626F782D736861646F773A302030203020337078202331323639636634303B6F75746C696E653A6E6F6E657D2E757070792D73697A652D2D6D64202E757070792D632D62746E2D6C696E6B7B70616464696E673A3133707820313870787D5B64617461';
wwv_flow_imp.g_varchar2_table(27) := '2D757070792D7468656D653D6461726B5D202E757070792D632D62746E2D6C696E6B7B636F6C6F723A236561656165617D5B646174612D757070792D7468656D653D6461726B5D202E757070792D632D62746E2D6C696E6B3A666F6375737B6F75746C69';
wwv_flow_imp.g_varchar2_table(28) := '6E653A6E6F6E657D5B646174612D757070792D7468656D653D6461726B5D202E757070792D632D62746E2D6C696E6B3A3A2D6D6F7A2D666F6375732D696E6E65727B626F726465723A307D5B646174612D757070792D7468656D653D6461726B5D202E75';
wwv_flow_imp.g_varchar2_table(29) := '7070792D632D62746E2D6C696E6B3A666F6375737B626F782D736861646F773A302030203020327078202361616531666664397D5B646174612D757070792D7468656D653D6461726B5D202E757070792D632D62746E2D6C696E6B3A686F7665727B636F';
wwv_flow_imp.g_varchar2_table(30) := '6C6F723A233933393339337D2E757070792D496E666F726D65727B626F74746F6D3A363070783B6C6566743A303B706F736974696F6E3A6162736F6C7574653B72696768743A303B746578742D616C69676E3A63656E7465723B7A2D696E6465783A3130';
wwv_flow_imp.g_varchar2_table(31) := '30357D2E757070792D496E666F726D6572207370616E3E6469767B6D617267696E2D626F74746F6D3A3670787D2E757070792D496E666F726D65722D616E696D617465647B6F7061636974793A303B7472616E73666F726D3A7472616E736C6174655928';
wwv_flow_imp.g_varchar2_table(32) := '33353025293B7472616E736974696F6E3A616C6C202E337320656173652D696E3B7A2D696E6465783A2D313030307D2E757070792D496E666F726D657220707B6261636B67726F756E642D636F6C6F723A233735373537353B626F726465722D72616469';
wwv_flow_imp.g_varchar2_table(33) := '75733A313870783B636F6C6F723A236666663B646973706C61793A696E6C696E652D626C6F636B3B666F6E742D73697A653A313270783B666F6E742D7765696768743A3430303B6C696E652D6865696768743A312E343B6D617267696E3A303B6D61782D';
wwv_flow_imp.g_varchar2_table(34) := '77696474683A3930253B70616464696E673A36707820313570787D2E757070792D73697A652D2D6D64202E757070792D496E666F726D657220707B666F6E742D73697A653A313470783B6C696E652D6865696768743A312E333B6D61782D77696474683A';
wwv_flow_imp.g_varchar2_table(35) := '35303070783B70616464696E673A3130707820323070787D5B646174612D757070792D7468656D653D6461726B5D202E757070792D496E666F726D657220707B6261636B67726F756E642D636F6C6F723A233333337D5B6469723D6C74725D202E757070';
wwv_flow_imp.g_varchar2_table(36) := '792D496E666F726D65722070207370616E7B6C6566743A3370787D5B6469723D72746C5D202E757070792D496E666F726D65722070207370616E7B72696768743A3370787D5B6469723D6C74725D202E757070792D496E666F726D65722070207370616E';
wwv_flow_imp.g_varchar2_table(37) := '7B6D617267696E2D6C6566743A2D3170787D5B6469723D72746C5D202E757070792D496E666F726D65722070207370616E7B6D617267696E2D72696768743A2D3170787D2E757070792D496E666F726D65722070207370616E7B6261636B67726F756E64';
wwv_flow_imp.g_varchar2_table(38) := '2D636F6C6F723A236666663B626F726465722D7261646975733A3530253B636F6C6F723A233532353235323B646973706C61793A696E6C696E652D626C6F636B3B666F6E742D73697A653A313070783B6865696768743A313370783B6C696E652D686569';
wwv_flow_imp.g_varchar2_table(39) := '6768743A313270783B706F736974696F6E3A72656C61746976653B746F703A2D3170783B766572746963616C2D616C69676E3A6D6964646C653B77696474683A313370787D2E757070792D496E666F726D65722070207370616E3A686F7665727B637572';
wwv_flow_imp.g_varchar2_table(40) := '736F723A68656C707D2E757070792D496E666F726D65722070207370616E3A61667465727B776F72642D777261703A627265616B2D776F72643B6C696E652D6865696768743A312E337D2E757070792D526F6F74205B617269612D6C6162656C5D5B726F';
wwv_flow_imp.g_varchar2_table(41) := '6C657E3D746F6F6C7469705D7B706F736974696F6E3A72656C61746976657D2E757070792D526F6F74205B617269612D6C6162656C5D5B726F6C657E3D746F6F6C7469705D3A61667465722C2E757070792D526F6F74205B617269612D6C6162656C5D5B';
wwv_flow_imp.g_varchar2_table(42) := '726F6C657E3D746F6F6C7469705D3A6265666F72657B2D7765626B69742D6261636B666163652D7669736962696C6974793A68696464656E3B6261636B666163652D7669736962696C6974793A68696464656E3B626F782D73697A696E673A626F726465';
wwv_flow_imp.g_varchar2_table(43) := '722D626F783B6F7061636974793A303B706F696E7465722D6576656E74733A6E6F6E653B706F736974696F6E3A6162736F6C7574653B7472616E73666F726D3A7472616E736C6174655A2830293B7472616E73666F726D2D6F726967696E3A746F703B74';
wwv_flow_imp.g_varchar2_table(44) := '72616E736974696F6E3A616C6C20766172282D2D6D6963726F7469702D7472616E736974696F6E2D6475726174696F6E2C2E3138732920766172282D2D6D6963726F7469702D7472616E736974696F6E2D656173696E672C656173652D696E2D6F757429';
wwv_flow_imp.g_varchar2_table(45) := '20766172282D2D6D6963726F7469702D7472616E736974696F6E2D64656C61792C3073293B77696C6C2D6368616E67653A7472616E73666F726D3B7A2D696E6465783A31307D2E757070792D526F6F74205B617269612D6C6162656C5D5B726F6C657E3D';
wwv_flow_imp.g_varchar2_table(46) := '746F6F6C7469705D3A6265666F72657B6261636B67726F756E642D73697A653A31303025206175746F21696D706F7274616E743B636F6E74656E743A22227D2E757070792D526F6F74205B617269612D6C6162656C5D5B726F6C657E3D746F6F6C746970';
wwv_flow_imp.g_varchar2_table(47) := '5D3A61667465727B6261636B67726F756E643A2331313131313165363B626F726465722D7261646975733A3470783B626F782D73697A696E673A696E697469616C3B636F6C6F723A236666663B636F6E74656E743A6174747228617269612D6C6162656C';
wwv_flow_imp.g_varchar2_table(48) := '293B666F6E742D73697A653A766172282D2D6D6963726F7469702D666F6E742D73697A652C31337078293B666F6E742D7765696768743A766172282D2D6D6963726F7469702D666F6E742D7765696768742C6E6F726D616C293B70616464696E673A2E35';
wwv_flow_imp.g_varchar2_table(49) := '656D2031656D3B746578742D7472616E73666F726D3A766172282D2D6D6963726F7469702D746578742D7472616E73666F726D2C6E6F6E65293B77686974652D73706163653A6E6F777261707D2E757070792D526F6F74205B617269612D6C6162656C5D';
wwv_flow_imp.g_varchar2_table(50) := '5B726F6C657E3D746F6F6C7469705D3A666F6375733A61667465722C2E757070792D526F6F74205B617269612D6C6162656C5D5B726F6C657E3D746F6F6C7469705D3A666F6375733A6265666F72652C2E757070792D526F6F74205B617269612D6C6162';
wwv_flow_imp.g_varchar2_table(51) := '656C5D5B726F6C657E3D746F6F6C7469705D3A686F7665723A61667465722C2E757070792D526F6F74205B617269612D6C6162656C5D5B726F6C657E3D746F6F6C7469705D3A686F7665723A6265666F72657B6F7061636974793A313B706F696E746572';
wwv_flow_imp.g_varchar2_table(52) := '2D6576656E74733A6175746F7D2E757070792D526F6F74205B726F6C657E3D746F6F6C7469705D5B646174612D6D6963726F7469702D706F736974696F6E7C3D746F705D3A6265666F72657B6261636B67726F756E643A75726C2822646174613A696D61';
wwv_flow_imp.g_varchar2_table(53) := '67652F7376672B786D6C3B636861727365743D7574662D382C25334373766720786D6C6E733D27687474703A2F2F7777772E77332E6F72672F323030302F737667272077696474683D27333627206865696768743D273132272533452533437061746820';
wwv_flow_imp.g_varchar2_table(54) := '66696C6C3D27726762612831372C2031372C2031372C20302E39292720643D274D322E36353820306833322E303034632D3620302D31312E3632372031322E3030322D31362E3030322031322E3030324331342E3238352031322E30303220382E353934';
wwv_flow_imp.g_varchar2_table(55) := '203020322E36353820305A272F2533452533432F7376672533452229206E6F2D7265706561743B626F74746F6D3A313030253B6865696768743A3670783B6C6566743A3530253B6D617267696E2D626F74746F6D3A3570783B7472616E73666F726D3A74';
wwv_flow_imp.g_varchar2_table(56) := '72616E736C6174653364282D3530252C302C30293B77696474683A313870787D2E757070792D526F6F74205B726F6C657E3D746F6F6C7469705D5B646174612D6D6963726F7469702D706F736974696F6E7C3D746F705D3A61667465727B626F74746F6D';
wwv_flow_imp.g_varchar2_table(57) := '3A313030253B6C6566743A3530253B6D617267696E2D626F74746F6D3A313170783B7472616E73666F726D3A7472616E736C6174653364282D3530252C302C30297D2E757070792D526F6F74205B726F6C657E3D746F6F6C7469705D5B646174612D6D69';
wwv_flow_imp.g_varchar2_table(58) := '63726F7469702D706F736974696F6E3D746F705D3A686F7665723A61667465722C2E757070792D526F6F74205B726F6C657E3D746F6F6C7469705D5B646174612D6D6963726F7469702D706F736974696F6E7C3D746F705D3A686F7665723A6265666F72';
wwv_flow_imp.g_varchar2_table(59) := '657B7472616E73666F726D3A7472616E736C6174653364282D3530252C2D3570782C30297D2E757070792D526F6F74205B726F6C657E3D746F6F6C7469705D5B646174612D6D6963726F7469702D706F736974696F6E3D746F702D6C6566745D3A616674';
wwv_flow_imp.g_varchar2_table(60) := '65727B626F74746F6D3A313030253B7472616E73666F726D3A7472616E736C61746533642863616C63282D31303025202B2031367078292C302C30297D2E757070792D526F6F74205B726F6C657E3D746F6F6C7469705D5B646174612D6D6963726F7469';
wwv_flow_imp.g_varchar2_table(61) := '702D706F736974696F6E3D746F702D6C6566745D3A686F7665723A61667465727B7472616E73666F726D3A7472616E736C61746533642863616C63282D31303025202B2031367078292C2D3570782C30297D2E757070792D526F6F74205B726F6C657E3D';
wwv_flow_imp.g_varchar2_table(62) := '746F6F6C7469705D5B646174612D6D6963726F7469702D706F736974696F6E3D746F702D72696768745D3A61667465727B626F74746F6D3A313030253B7472616E73666F726D3A7472616E736C6174653364282D313670782C302C30297D2E757070792D';
wwv_flow_imp.g_varchar2_table(63) := '526F6F74205B726F6C657E3D746F6F6C7469705D5B646174612D6D6963726F7469702D706F736974696F6E3D746F702D72696768745D3A686F7665723A61667465727B7472616E73666F726D3A7472616E736C6174653364282D313670782C2D3570782C';
wwv_flow_imp.g_varchar2_table(64) := '30297D2E757070792D526F6F74205B726F6C657E3D746F6F6C7469705D5B646174612D6D6963726F7469702D706F736974696F6E7C3D626F74746F6D5D3A6265666F72657B6261636B67726F756E643A75726C2822646174613A696D6167652F7376672B';
wwv_flow_imp.g_varchar2_table(65) := '786D6C3B636861727365743D7574662D382C25334373766720786D6C6E733D27687474703A2F2F7777772E77332E6F72672F323030302F737667272077696474683D27333627206865696768743D27313227253345253343706174682066696C6C3D2772';
wwv_flow_imp.g_varchar2_table(66) := '6762612831372C2031372C2031372C20302E39292720643D274D33332E33343220313248312E333338633620302031312E3632372D31322E3030322031362E3030322D31322E3030324332312E3731352D2E3030322032372E3430362031322033332E33';
wwv_flow_imp.g_varchar2_table(67) := '34322031325A272F2533452533432F7376672533452229206E6F2D7265706561743B626F74746F6D3A6175746F3B6865696768743A3670783B6C6566743A3530253B6D617267696E2D626F74746F6D3A303B6D617267696E2D746F703A3570783B746F70';
wwv_flow_imp.g_varchar2_table(68) := '3A313030253B7472616E73666F726D3A7472616E736C6174653364282D3530252C2D313070782C30293B77696474683A313870787D2E757070792D526F6F74205B726F6C657E3D746F6F6C7469705D5B646174612D6D6963726F7469702D706F73697469';
wwv_flow_imp.g_varchar2_table(69) := '6F6E7C3D626F74746F6D5D3A61667465727B6C6566743A3530253B6D617267696E2D746F703A313170783B746F703A313030253B7472616E73666F726D3A7472616E736C6174653364282D3530252C2D313070782C30297D2E757070792D526F6F74205B';
wwv_flow_imp.g_varchar2_table(70) := '726F6C657E3D746F6F6C7469705D5B646174612D6D6963726F7469702D706F736974696F6E3D626F74746F6D5D3A686F7665723A61667465722C2E757070792D526F6F74205B726F6C657E3D746F6F6C7469705D5B646174612D6D6963726F7469702D70';
wwv_flow_imp.g_varchar2_table(71) := '6F736974696F6E7C3D626F74746F6D5D3A686F7665723A6265666F72657B7472616E73666F726D3A7472616E736C6174653364282D3530252C302C30297D2E757070792D526F6F74205B726F6C657E3D746F6F6C7469705D5B646174612D6D6963726F74';
wwv_flow_imp.g_varchar2_table(72) := '69702D706F736974696F6E3D626F74746F6D2D6C6566745D3A61667465727B746F703A313030253B7472616E73666F726D3A7472616E736C61746533642863616C63282D31303025202B2031367078292C2D313070782C30297D2E757070792D526F6F74';
wwv_flow_imp.g_varchar2_table(73) := '205B726F6C657E3D746F6F6C7469705D5B646174612D6D6963726F7469702D706F736974696F6E3D626F74746F6D2D6C6566745D3A686F7665723A61667465727B7472616E73666F726D3A7472616E736C61746533642863616C63282D31303025202B20';
wwv_flow_imp.g_varchar2_table(74) := '31367078292C302C30297D2E757070792D526F6F74205B726F6C657E3D746F6F6C7469705D5B646174612D6D6963726F7469702D706F736974696F6E3D626F74746F6D2D72696768745D3A61667465727B746F703A313030253B7472616E73666F726D3A';
wwv_flow_imp.g_varchar2_table(75) := '7472616E736C6174653364282D313670782C2D313070782C30297D2E757070792D526F6F74205B726F6C657E3D746F6F6C7469705D5B646174612D6D6963726F7469702D706F736974696F6E3D626F74746F6D2D72696768745D3A686F7665723A616674';
wwv_flow_imp.g_varchar2_table(76) := '65727B7472616E73666F726D3A7472616E736C6174653364282D313670782C302C30297D2E757070792D526F6F74205B726F6C657E3D746F6F6C7469705D5B646174612D6D6963726F7469702D706F736974696F6E3D6C6566745D3A61667465722C2E75';
wwv_flow_imp.g_varchar2_table(77) := '7070792D526F6F74205B726F6C657E3D746F6F6C7469705D5B646174612D6D6963726F7469702D706F736974696F6E3D6C6566745D3A6265666F72657B626F74746F6D3A6175746F3B6C6566743A6175746F3B72696768743A313030253B746F703A3530';
wwv_flow_imp.g_varchar2_table(78) := '253B7472616E73666F726D3A7472616E736C617465336428313070782C2D3530252C30297D2E757070792D526F6F74205B726F6C657E3D746F6F6C7469705D5B646174612D6D6963726F7469702D706F736974696F6E3D6C6566745D3A6265666F72657B';
wwv_flow_imp.g_varchar2_table(79) := '6261636B67726F756E643A75726C2822646174613A696D6167652F7376672B786D6C3B636861727365743D7574662D382C25334373766720786D6C6E733D27687474703A2F2F7777772E77332E6F72672F323030302F737667272077696474683D273132';
wwv_flow_imp.g_varchar2_table(80) := '27206865696768743D27333627253345253343706174682066696C6C3D27726762612831372C2031372C2031372C20302E39292720643D274D302033332E33343256312E333338633020362031322E3030322031312E3632372031322E3030322031362E';
wwv_flow_imp.g_varchar2_table(81) := '3030324331322E3030322032312E37313520302032372E34303620302033332E3334325A272F2533452533432F7376672533452229206E6F2D7265706561743B6865696768743A313870783B6D617267696E2D626F74746F6D3A303B6D617267696E2D72';
wwv_flow_imp.g_varchar2_table(82) := '696768743A3570783B77696474683A3670787D2E757070792D526F6F74205B726F6C657E3D746F6F6C7469705D5B646174612D6D6963726F7469702D706F736974696F6E3D6C6566745D3A61667465727B6D617267696E2D72696768743A313170787D2E';
wwv_flow_imp.g_varchar2_table(83) := '757070792D526F6F74205B726F6C657E3D746F6F6C7469705D5B646174612D6D6963726F7469702D706F736974696F6E3D6C6566745D3A686F7665723A61667465722C2E757070792D526F6F74205B726F6C657E3D746F6F6C7469705D5B646174612D6D';
wwv_flow_imp.g_varchar2_table(84) := '6963726F7469702D706F736974696F6E3D6C6566745D3A686F7665723A6265666F72657B7472616E73666F726D3A7472616E736C617465336428302C2D3530252C30297D2E757070792D526F6F74205B726F6C657E3D746F6F6C7469705D5B646174612D';
wwv_flow_imp.g_varchar2_table(85) := '6D6963726F7469702D706F736974696F6E3D72696768745D3A61667465722C2E757070792D526F6F74205B726F6C657E3D746F6F6C7469705D5B646174612D6D6963726F7469702D706F736974696F6E3D72696768745D3A6265666F72657B626F74746F';
wwv_flow_imp.g_varchar2_table(86) := '6D3A6175746F3B6C6566743A313030253B746F703A3530253B7472616E73666F726D3A7472616E736C6174653364282D313070782C2D3530252C30297D2E757070792D526F6F74205B726F6C657E3D746F6F6C7469705D5B646174612D6D6963726F7469';
wwv_flow_imp.g_varchar2_table(87) := '702D706F736974696F6E3D72696768745D3A6265666F72657B6261636B67726F756E643A75726C2822646174613A696D6167652F7376672B786D6C3B636861727365743D7574662D382C25334373766720786D6C6E733D27687474703A2F2F7777772E77';
wwv_flow_imp.g_varchar2_table(88) := '332E6F72672F323030302F737667272077696474683D27313227206865696768743D27333627253345253343706174682066696C6C3D27726762612831372C2031372C2031372C20302E39292720643D274D313220322E3635387633322E30303463302D';
wwv_flow_imp.g_varchar2_table(89) := '362D31322E3030322D31312E3632372D31322E3030322D31362E303032432D2E3030322031342E32383520313220382E35393420313220322E3635385A272F2533452533432F7376672533452229206E6F2D7265706561743B6865696768743A31387078';
wwv_flow_imp.g_varchar2_table(90) := '3B6D617267696E2D626F74746F6D3A303B6D617267696E2D6C6566743A3570783B77696474683A3670787D2E757070792D526F6F74205B726F6C657E3D746F6F6C7469705D5B646174612D6D6963726F7469702D706F736974696F6E3D72696768745D3A';
wwv_flow_imp.g_varchar2_table(91) := '61667465727B6D617267696E2D6C6566743A313170787D2E757070792D526F6F74205B726F6C657E3D746F6F6C7469705D5B646174612D6D6963726F7469702D706F736974696F6E3D72696768745D3A686F7665723A61667465722C2E757070792D526F';
wwv_flow_imp.g_varchar2_table(92) := '6F74205B726F6C657E3D746F6F6C7469705D5B646174612D6D6963726F7469702D706F736974696F6E3D72696768745D3A686F7665723A6265666F72657B7472616E73666F726D3A7472616E736C617465336428302C2D3530252C30297D2E757070792D';
wwv_flow_imp.g_varchar2_table(93) := '526F6F74205B726F6C657E3D746F6F6C7469705D5B646174612D6D6963726F7469702D73697A653D736D616C6C5D3A61667465727B77686974652D73706163653A6E6F726D616C3B77696474683A383070787D2E757070792D526F6F74205B726F6C657E';
wwv_flow_imp.g_varchar2_table(94) := '3D746F6F6C7469705D5B646174612D6D6963726F7469702D73697A653D6D656469756D5D3A61667465727B77686974652D73706163653A6E6F726D616C3B77696474683A31353070787D2E757070792D526F6F74205B726F6C657E3D746F6F6C7469705D';
wwv_flow_imp.g_varchar2_table(95) := '5B646174612D6D6963726F7469702D73697A653D6C617267655D3A61667465727B77686974652D73706163653A6E6F726D616C3B77696474683A32363070787D2E757070792D5374617475734261727B6261636B67726F756E642D636F6C6F723A236666';
wwv_flow_imp.g_varchar2_table(96) := '663B636F6C6F723A236666663B646973706C61793A666C65783B666F6E742D73697A653A313270783B666F6E742D7765696768743A3430303B6865696768743A343670783B6C696E652D6865696768743A343070783B706F736974696F6E3A72656C6174';
wwv_flow_imp.g_varchar2_table(97) := '6976653B7472616E736974696F6E3A686569676874202E32733B7A2D696E6465783A313030317D5B646174612D757070792D7468656D653D6461726B5D202E757070792D5374617475734261727B6261636B67726F756E642D636F6C6F723A2331663166';
wwv_flow_imp.g_varchar2_table(98) := '31667D2E757070792D5374617475734261723A6265666F72657B6261636B67726F756E642D636F6C6F723A236561656165613B626F74746F6D3A303B636F6E74656E743A22223B6865696768743A3270783B6C6566743A303B706F736974696F6E3A6162';
wwv_flow_imp.g_varchar2_table(99) := '736F6C7574653B72696768743A303B746F703A303B77696474683A313030257D5B646174612D757070792D7468656D653D6461726B5D202E757070792D5374617475734261723A6265666F72657B6261636B67726F756E642D636F6C6F723A2337353735';
wwv_flow_imp.g_varchar2_table(100) := '37357D2E757070792D5374617475734261725B617269612D68696464656E3D747275655D7B6865696768743A303B6F766572666C6F772D793A68696464656E7D2E757070792D5374617475734261722E69732D636F6D706C657465202E757070792D5374';
wwv_flow_imp.g_varchar2_table(101) := '617475734261722D70726F67726573737B6261636B67726F756E642D636F6C6F723A233162623234307D2E757070792D5374617475734261722E69732D6572726F72202E757070792D5374617475734261722D70726F67726573737B6261636B67726F75';
wwv_flow_imp.g_varchar2_table(102) := '6E642D636F6C6F723A236533323433377D2E757070792D5374617475734261722E69732D636F6D706C657465202E757070792D5374617475734261722D737461747573496E64696361746F727B636F6C6F723A233162623234307D2E757070792D537461';
wwv_flow_imp.g_varchar2_table(103) := '7475734261722E69732D6572726F72202E757070792D5374617475734261722D737461747573496E64696361746F727B636F6C6F723A236533323433377D2E757070792D5374617475734261723A6E6F74285B617269612D68696464656E3D747275655D';
wwv_flow_imp.g_varchar2_table(104) := '292E69732D77616974696E677B6261636B67726F756E642D636F6C6F723A236666663B626F726465722D746F703A31707820736F6C696420236561656165613B6865696768743A363570787D5B646174612D757070792D7468656D653D6461726B5D202E';
wwv_flow_imp.g_varchar2_table(105) := '757070792D5374617475734261723A6E6F74285B617269612D68696464656E3D747275655D292E69732D77616974696E677B6261636B67726F756E642D636F6C6F723A233166316631663B626F726465722D746F703A31707820736F6C69642023333333';
wwv_flow_imp.g_varchar2_table(106) := '7D2E757070792D5374617475734261722D70726F67726573737B6261636B67726F756E642D636F6C6F723A233132363963663B6865696768743A3270783B706F736974696F6E3A6162736F6C7574653B7472616E736974696F6E3A6261636B67726F756E';
wwv_flow_imp.g_varchar2_table(107) := '642D636F6C6F722C7769647468202E337320656173652D6F75743B7A2D696E6465783A313030317D2E757070792D5374617475734261722D70726F67726573732E69732D696E64657465726D696E6174657B616E696D6174696F6E3A757070792D537461';
wwv_flow_imp.g_varchar2_table(108) := '7475734261722D50726F677265737353747269706573203173206C696E65617220696E66696E6974653B6261636B67726F756E642D696D6167653A6C696E6561722D6772616469656E742834356465672C233030303030303464203235252C2330303030';
wwv_flow_imp.g_varchar2_table(109) := '20302C2330303030203530252C23303030303030346420302C233030303030303464203735252C233030303020302C2330303030293B6261636B67726F756E642D73697A653A3634707820363470787D406B65796672616D657320757070792D53746174';
wwv_flow_imp.g_varchar2_table(110) := '75734261722D50726F6772657373537472697065737B30257B6261636B67726F756E642D706F736974696F6E3A3020307D746F7B6261636B67726F756E642D706F736974696F6E3A3634707820307D7D2E757070792D5374617475734261722E69732D70';
wwv_flow_imp.g_varchar2_table(111) := '6F737470726F63657373696E67202E757070792D5374617475734261722D70726F67726573732C2E757070792D5374617475734261722E69732D70726570726F63657373696E67202E757070792D5374617475734261722D70726F67726573737B626163';
wwv_flow_imp.g_varchar2_table(112) := '6B67726F756E642D636F6C6F723A236636613632337D2E757070792D5374617475734261722E69732D77616974696E67202E757070792D5374617475734261722D70726F67726573737B646973706C61793A6E6F6E657D5B6469723D6C74725D202E7570';
wwv_flow_imp.g_varchar2_table(113) := '70792D5374617475734261722D636F6E74656E747B70616464696E672D6C6566743A313070787D5B6469723D72746C5D202E757070792D5374617475734261722D636F6E74656E747B70616464696E672D72696768743A313070787D2E757070792D5374';
wwv_flow_imp.g_varchar2_table(114) := '617475734261722D636F6E74656E747B616C69676E2D6974656D733A63656E7465723B636F6C6F723A233333333B646973706C61793A666C65783B6865696768743A313030253B706F736974696F6E3A72656C61746976653B746578742D6F766572666C';
wwv_flow_imp.g_varchar2_table(115) := '6F773A656C6C69707369733B77686974652D73706163653A6E6F777261703B7A2D696E6465783A313030327D5B6469723D6C74725D202E757070792D73697A652D2D6D64202E757070792D5374617475734261722D636F6E74656E747B70616464696E67';
wwv_flow_imp.g_varchar2_table(116) := '2D6C6566743A313570787D5B6469723D72746C5D202E757070792D73697A652D2D6D64202E757070792D5374617475734261722D636F6E74656E747B70616464696E672D72696768743A313570787D5B646174612D757070792D7468656D653D6461726B';
wwv_flow_imp.g_varchar2_table(117) := '5D202E757070792D5374617475734261722D636F6E74656E747B636F6C6F723A236561656165617D5B6469723D6C74725D202E757070792D5374617475734261722D7374617475737B70616464696E672D72696768743A2E33656D7D5B6469723D72746C';
wwv_flow_imp.g_varchar2_table(118) := '5D202E757070792D5374617475734261722D7374617475737B70616464696E672D6C6566743A2E33656D7D2E757070792D5374617475734261722D7374617475737B646973706C61793A666C65783B666C65782D646972656374696F6E3A636F6C756D6E';
wwv_flow_imp.g_varchar2_table(119) := '3B666F6E742D7765696768743A3430303B6A7573746966792D636F6E74656E743A63656E7465723B6C696E652D6865696768743A312E347D2E757070792D5374617475734261722D7374617475735072696D6172797B646973706C61793A666C65783B66';
wwv_flow_imp.g_varchar2_table(120) := '6F6E742D7765696768743A3530303B6C696E652D6865696768743A317D2E757070792D5374617475734261722D7374617475735072696D61727920627574746F6E2E757070792D5374617475734261722D64657461696C737B6D617267696E2D6C656674';
wwv_flow_imp.g_varchar2_table(121) := '3A3570787D5B646174612D757070792D7468656D653D6461726B5D202E757070792D5374617475734261722D7374617475735072696D6172797B636F6C6F723A236561656165617D2E757070792D5374617475734261722D7374617475735365636F6E64';
wwv_flow_imp.g_varchar2_table(122) := '6172797B636F6C6F723A233735373537353B646973706C61793A696E6C696E652D626C6F636B3B666F6E742D73697A653A313170783B6C696E652D6865696768743A312E323B6D617267696E2D746F703A3170783B77686974652D73706163653A6E6F77';
wwv_flow_imp.g_varchar2_table(123) := '7261707D5B646174612D757070792D7468656D653D6461726B5D202E757070792D5374617475734261722D7374617475735365636F6E646172797B636F6C6F723A236262627D5B6469723D6C74725D202E757070792D5374617475734261722D73746174';
wwv_flow_imp.g_varchar2_table(124) := '75735365636F6E6461727948696E747B6D617267696E2D72696768743A3570787D5B6469723D72746C5D202E757070792D5374617475734261722D7374617475735365636F6E6461727948696E747B6D617267696E2D6C6566743A3570787D2E75707079';
wwv_flow_imp.g_varchar2_table(125) := '2D5374617475734261722D7374617475735365636F6E6461727948696E747B646973706C61793A696E6C696E652D626C6F636B3B6C696E652D6865696768743A313B766572746963616C2D616C69676E3A6D6964646C657D5B6469723D6C74725D202E75';
wwv_flow_imp.g_varchar2_table(126) := '7070792D73697A652D2D6D64202E757070792D5374617475734261722D7374617475735365636F6E6461727948696E747B6D617267696E2D72696768743A3870787D5B6469723D72746C5D202E757070792D73697A652D2D6D64202E757070792D537461';
wwv_flow_imp.g_varchar2_table(127) := '7475734261722D7374617475735365636F6E6461727948696E747B6D617267696E2D6C6566743A3870787D5B6469723D6C74725D202E757070792D5374617475734261722D737461747573496E64696361746F727B6D617267696E2D72696768743A3770';
wwv_flow_imp.g_varchar2_table(128) := '787D5B6469723D72746C5D202E757070792D5374617475734261722D737461747573496E64696361746F727B6D617267696E2D6C6566743A3770787D2E757070792D5374617475734261722D737461747573496E64696361746F727B636F6C6F723A2335';
wwv_flow_imp.g_varchar2_table(129) := '32353235323B706F736974696F6E3A72656C61746976653B746F703A3170787D2E757070792D5374617475734261722D737461747573496E64696361746F72207376677B766572746963616C2D616C69676E3A746578742D626F74746F6D7D5B6469723D';
wwv_flow_imp.g_varchar2_table(130) := '6C74725D202E757070792D5374617475734261722D616374696F6E737B72696768743A313070787D5B6469723D72746C5D202E757070792D5374617475734261722D616374696F6E737B6C6566743A313070787D2E757070792D5374617475734261722D';
wwv_flow_imp.g_varchar2_table(131) := '616374696F6E737B616C69676E2D6974656D733A63656E7465723B626F74746F6D3A303B646973706C61793A666C65783B706F736974696F6E3A6162736F6C7574653B746F703A303B7A2D696E6465783A313030347D2E757070792D5374617475734261';
wwv_flow_imp.g_varchar2_table(132) := '722E69732D77616974696E67202E757070792D5374617475734261722D616374696F6E737B6261636B67726F756E642D636F6C6F723A236661666166613B6865696768743A313030253B70616464696E673A3020313570783B706F736974696F6E3A7374';
wwv_flow_imp.g_varchar2_table(133) := '617469633B77696474683A313030257D5B646174612D757070792D7468656D653D6461726B5D202E757070792D5374617475734261722E69732D77616974696E67202E757070792D5374617475734261722D616374696F6E737B6261636B67726F756E64';
wwv_flow_imp.g_varchar2_table(134) := '2D636F6C6F723A233166316631667D2E757070792D5374617475734261723A6E6F74285B617269612D68696464656E3D747275655D292E69732D77616974696E672E6861732D67686F7374737B666C65782D646972656374696F6E3A636F6C756D6E3B68';
wwv_flow_imp.g_varchar2_table(135) := '65696768743A393070787D2E757070792D73697A652D2D6D64202E757070792D5374617475734261723A6E6F74285B617269612D68696464656E3D747275655D292E69732D77616974696E672E6861732D67686F7374737B666C65782D64697265637469';
wwv_flow_imp.g_varchar2_table(136) := '6F6E3A726F773B6865696768743A363570787D2E757070792D5374617475734261723A6E6F74285B617269612D68696464656E3D747275655D292E69732D77616974696E672E6861732D67686F737473202E757070792D5374617475734261722D616374';
wwv_flow_imp.g_varchar2_table(137) := '696F6E737B666C65782D646972656374696F6E3A636F6C756D6E3B6A7573746966792D636F6E74656E743A63656E7465727D2E757070792D73697A652D2D6D64202E757070792D5374617475734261723A6E6F74285B617269612D68696464656E3D7472';
wwv_flow_imp.g_varchar2_table(138) := '75655D292E69732D77616974696E672E6861732D67686F737473202E757070792D5374617475734261722D616374696F6E737B666C65782D646972656374696F6E3A726F773B6A7573746966792D636F6E74656E743A6E6F726D616C7D2E757070792D53';
wwv_flow_imp.g_varchar2_table(139) := '74617475734261722D616374696F6E436972636C6542746E7B637572736F723A706F696E7465723B6C696E652D6865696768743A313B6D617267696E3A3370783B6F7061636974793A2E397D2E757070792D5374617475734261722D616374696F6E4369';
wwv_flow_imp.g_varchar2_table(140) := '72636C6542746E3A666F6375737B6F75746C696E653A6E6F6E657D2E757070792D5374617475734261722D616374696F6E436972636C6542746E3A3A2D6D6F7A2D666F6375732D696E6E65727B626F726465723A307D2E757070792D5374617475734261';
wwv_flow_imp.g_varchar2_table(141) := '722D616374696F6E436972636C6542746E3A666F6375737B626F782D736861646F773A302030203020337078202331323639636638307D5B646174612D757070792D7468656D653D6461726B5D202E757070792D5374617475734261722D616374696F6E';
wwv_flow_imp.g_varchar2_table(142) := '436972636C6542746E3A666F6375737B6F75746C696E653A6E6F6E657D5B646174612D757070792D7468656D653D6461726B5D202E757070792D5374617475734261722D616374696F6E436972636C6542746E3A3A2D6D6F7A2D666F6375732D696E6E65';
wwv_flow_imp.g_varchar2_table(143) := '727B626F726465723A307D5B646174612D757070792D7468656D653D6461726B5D202E757070792D5374617475734261722D616374696F6E436972636C6542746E3A666F6375737B626F782D736861646F773A3020302030203270782023616165316666';
wwv_flow_imp.g_varchar2_table(144) := '64397D2E757070792D5374617475734261722D616374696F6E436972636C6542746E3A686F7665727B6F7061636974793A317D2E757070792D5374617475734261722D616374696F6E436972636C6542746E3A666F6375737B626F726465722D72616469';
wwv_flow_imp.g_varchar2_table(145) := '75733A3530257D2E757070792D5374617475734261722D616374696F6E436972636C6542746E207376677B766572746963616C2D616C69676E3A626F74746F6D7D2E757070792D5374617475734261722D616374696F6E42746E7B636F6C6F723A233132';
wwv_flow_imp.g_varchar2_table(146) := '363963663B646973706C61793A696E6C696E652D626C6F636B3B666F6E742D73697A653A313070783B6C696E652D6865696768743A696E68657269743B766572746963616C2D616C69676E3A6D6964646C657D2E757070792D73697A652D2D6D64202E75';
wwv_flow_imp.g_varchar2_table(147) := '7070792D5374617475734261722D616374696F6E42746E7B666F6E742D73697A653A313170787D2E757070792D5374617475734261722D616374696F6E42746E2D2D64697361626C65647B6F7061636974793A2E347D5B646174612D757070792D746865';
wwv_flow_imp.g_varchar2_table(148) := '6D653D6461726B5D202E757070792D5374617475734261722D616374696F6E42746E2D2D64697361626C65647B6F7061636974793A2E377D5B6469723D6C74725D202E757070792D5374617475734261722D616374696F6E42746E2D2D72657472797B6D';
wwv_flow_imp.g_varchar2_table(149) := '617267696E2D72696768743A3670787D5B6469723D72746C5D202E757070792D5374617475734261722D616374696F6E42746E2D2D72657472797B6D617267696E2D6C6566743A3670787D2E757070792D5374617475734261722D616374696F6E42746E';
wwv_flow_imp.g_varchar2_table(150) := '2D2D72657472797B6261636B67726F756E642D636F6C6F723A236666346232333B626F726465722D7261646975733A3870783B636F6C6F723A236666663B6865696768743A313670783B6C696E652D6865696768743A313B70616464696E673A31707820';
wwv_flow_imp.g_varchar2_table(151) := '3670782033707820313870783B706F736974696F6E3A72656C61746976657D2E757070792D5374617475734261722D616374696F6E42746E2D2D72657472793A666F6375737B6F75746C696E653A6E6F6E657D2E757070792D5374617475734261722D61';
wwv_flow_imp.g_varchar2_table(152) := '6374696F6E42746E2D2D72657472793A3A2D6D6F7A2D666F6375732D696E6E65727B626F726465723A307D2E757070792D5374617475734261722D616374696F6E42746E2D2D72657472793A666F6375737B626F782D736861646F773A30203020302033';
wwv_flow_imp.g_varchar2_table(153) := '7078202331323639636638307D5B646174612D757070792D7468656D653D6461726B5D202E757070792D5374617475734261722D616374696F6E42746E2D2D72657472793A666F6375737B6F75746C696E653A6E6F6E657D5B646174612D757070792D74';
wwv_flow_imp.g_varchar2_table(154) := '68656D653D6461726B5D202E757070792D5374617475734261722D616374696F6E42746E2D2D72657472793A3A2D6D6F7A2D666F6375732D696E6E65727B626F726465723A307D5B646174612D757070792D7468656D653D6461726B5D202E757070792D';
wwv_flow_imp.g_varchar2_table(155) := '5374617475734261722D616374696F6E42746E2D2D72657472793A666F6375737B626F782D736861646F773A302030203020327078202361616531666664397D2E757070792D5374617475734261722D616374696F6E42746E2D2D72657472793A686F76';
wwv_flow_imp.g_varchar2_table(156) := '65727B6261636B67726F756E642D636F6C6F723A236639326430307D5B6469723D6C74725D202E757070792D5374617475734261722D616374696F6E42746E2D2D7265747279207376677B6C6566743A3670787D5B6469723D72746C5D202E757070792D';
wwv_flow_imp.g_varchar2_table(157) := '5374617475734261722D616374696F6E42746E2D2D7265747279207376677B72696768743A3670787D2E757070792D5374617475734261722D616374696F6E42746E2D2D7265747279207376677B706F736974696F6E3A6162736F6C7574653B746F703A';
wwv_flow_imp.g_varchar2_table(158) := '3370787D2E757070792D5374617475734261722E69732D77616974696E67202E757070792D5374617475734261722D616374696F6E42746E2D2D75706C6F61647B6261636B67726F756E642D636F6C6F723A233162623234303B636F6C6F723A23666666';
wwv_flow_imp.g_varchar2_table(159) := '3B666F6E742D73697A653A313470783B6C696E652D6865696768743A313B70616464696E673A3135707820313070783B77696474683A313030257D2E757070792D5374617475734261722E69732D77616974696E67202E757070792D5374617475734261';
wwv_flow_imp.g_varchar2_table(160) := '722D616374696F6E42746E2D2D75706C6F61643A686F7665727B6261636B67726F756E642D636F6C6F723A233138396333387D5B646174612D757070792D7468656D653D6461726B5D202E757070792D5374617475734261722E69732D77616974696E67';
wwv_flow_imp.g_varchar2_table(161) := '202E757070792D5374617475734261722D616374696F6E42746E2D2D75706C6F61647B6261636B67726F756E642D636F6C6F723A233163386233377D5B646174612D757070792D7468656D653D6461726B5D202E757070792D5374617475734261722E69';
wwv_flow_imp.g_varchar2_table(162) := '732D77616974696E67202E757070792D5374617475734261722D616374696F6E42746E2D2D75706C6F61643A686F7665727B6261636B67726F756E642D636F6C6F723A233138373632667D2E757070792D73697A652D2D6D64202E757070792D53746174';
wwv_flow_imp.g_varchar2_table(163) := '75734261722E69732D77616974696E67202E757070792D5374617475734261722D616374696F6E42746E2D2D75706C6F61647B70616464696E673A3133707820323270783B77696474683A6175746F7D2E757070792D5374617475734261722E69732D77';
wwv_flow_imp.g_varchar2_table(164) := '616974696E67202E757070792D5374617475734261722D616374696F6E42746E2D2D75706C6F61642E757070792D5374617475734261722D616374696F6E42746E2D2D64697361626C65643A686F7665727B6261636B67726F756E642D636F6C6F723A23';
wwv_flow_imp.g_varchar2_table(165) := '3162623234303B637572736F723A6E6F742D616C6C6F7765647D5B646174612D757070792D7468656D653D6461726B5D202E757070792D5374617475734261722E69732D77616974696E67202E757070792D5374617475734261722D616374696F6E4274';
wwv_flow_imp.g_varchar2_table(166) := '6E2D2D75706C6F61642E757070792D5374617475734261722D616374696F6E42746E2D2D64697361626C65643A686F7665727B6261636B67726F756E642D636F6C6F723A233163386233377D2E757070792D5374617475734261723A6E6F74282E69732D';
wwv_flow_imp.g_varchar2_table(167) := '77616974696E6729202E757070792D5374617475734261722D616374696F6E42746E2D2D75706C6F61647B6261636B67726F756E642D636F6C6F723A696E697469616C3B636F6C6F723A233132363963667D5B6469723D6C74725D202E757070792D5374';
wwv_flow_imp.g_varchar2_table(168) := '617475734261722D616374696F6E42746E2D2D75706C6F61644E65776C7941646465647B70616464696E672D72696768743A3370787D5B6469723D6C74725D202E757070792D5374617475734261722D616374696F6E42746E2D2D75706C6F61644E6577';
wwv_flow_imp.g_varchar2_table(169) := '6C7941646465642C5B6469723D72746C5D202E757070792D5374617475734261722D616374696F6E42746E2D2D75706C6F61644E65776C7941646465647B70616464696E672D6C6566743A3370787D5B6469723D72746C5D202E757070792D5374617475';
wwv_flow_imp.g_varchar2_table(170) := '734261722D616374696F6E42746E2D2D75706C6F61644E65776C7941646465647B70616464696E672D72696768743A3370787D2E757070792D5374617475734261722D616374696F6E42746E2D2D75706C6F61644E65776C7941646465647B626F726465';
wwv_flow_imp.g_varchar2_table(171) := '722D7261646975733A3370783B70616464696E672D626F74746F6D3A3170787D2E757070792D5374617475734261722D616374696F6E42746E2D2D75706C6F61644E65776C7941646465643A666F6375737B6F75746C696E653A6E6F6E657D2E75707079';
wwv_flow_imp.g_varchar2_table(172) := '2D5374617475734261722D616374696F6E42746E2D2D75706C6F61644E65776C7941646465643A3A2D6D6F7A2D666F6375732D696E6E65727B626F726465723A307D2E757070792D5374617475734261722D616374696F6E42746E2D2D75706C6F61644E';
wwv_flow_imp.g_varchar2_table(173) := '65776C7941646465643A666F6375737B626F782D736861646F773A302030203020337078202331323639636638307D5B646174612D757070792D7468656D653D6461726B5D202E757070792D5374617475734261722D616374696F6E42746E2D2D75706C';
wwv_flow_imp.g_varchar2_table(174) := '6F61644E65776C7941646465643A666F6375737B6F75746C696E653A6E6F6E657D5B646174612D757070792D7468656D653D6461726B5D202E757070792D5374617475734261722D616374696F6E42746E2D2D75706C6F61644E65776C7941646465643A';
wwv_flow_imp.g_varchar2_table(175) := '3A2D6D6F7A2D666F6375732D696E6E65727B626F726465723A307D5B646174612D757070792D7468656D653D6461726B5D202E757070792D5374617475734261722D616374696F6E42746E2D2D75706C6F61644E65776C7941646465643A666F6375737B';
wwv_flow_imp.g_varchar2_table(176) := '626F782D736861646F773A302030203020327078202361616531666664397D2E757070792D5374617475734261722E69732D706F737470726F63657373696E67202E757070792D5374617475734261722D616374696F6E42746E2D2D75706C6F61644E65';
wwv_flow_imp.g_varchar2_table(177) := '776C7941646465642C2E757070792D5374617475734261722E69732D70726570726F63657373696E67202E757070792D5374617475734261722D616374696F6E42746E2D2D75706C6F61644E65776C7941646465647B646973706C61793A6E6F6E657D2E';
wwv_flow_imp.g_varchar2_table(178) := '757070792D5374617475734261722D616374696F6E42746E2D2D646F6E657B626F726465722D7261646975733A3370783B6C696E652D6865696768743A313B70616464696E673A377078203870787D2E757070792D5374617475734261722D616374696F';
wwv_flow_imp.g_varchar2_table(179) := '6E42746E2D2D646F6E653A666F6375737B6F75746C696E653A6E6F6E657D2E757070792D5374617475734261722D616374696F6E42746E2D2D646F6E653A3A2D6D6F7A2D666F6375732D696E6E65727B626F726465723A307D2E757070792D5374617475';
wwv_flow_imp.g_varchar2_table(180) := '734261722D616374696F6E42746E2D2D646F6E653A686F7665727B636F6C6F723A233065353161307D2E757070792D5374617475734261722D616374696F6E42746E2D2D646F6E653A666F6375737B6261636B67726F756E642D636F6C6F723A23646665';
wwv_flow_imp.g_varchar2_table(181) := '3666317D5B646174612D757070792D7468656D653D6461726B5D202E757070792D5374617475734261722D616374696F6E42746E2D2D646F6E653A666F6375737B6261636B67726F756E642D636F6C6F723A233333337D5B646174612D757070792D7468';
wwv_flow_imp.g_varchar2_table(182) := '656D653D6461726B5D202E757070792D5374617475734261722D616374696F6E42746E2D2D646F6E657B636F6C6F723A233032626166327D2E757070792D73697A652D2D6D64202E757070792D5374617475734261722D616374696F6E42746E2D2D646F';
wwv_flow_imp.g_varchar2_table(183) := '6E657B666F6E742D73697A653A313470787D2E757070792D5374617475734261722D736572766963654D73677B636F6C6F723A233030303B666F6E742D73697A653A313170783B6C696E652D6865696768743A312E313B70616464696E672D6C6566743A';
wwv_flow_imp.g_varchar2_table(184) := '313070787D2E757070792D73697A652D2D6D64202E757070792D5374617475734261722D736572766963654D73677B666F6E742D73697A653A313470783B70616464696E672D6C6566743A313570787D5B646174612D757070792D7468656D653D646172';
wwv_flow_imp.g_varchar2_table(185) := '6B5D202E757070792D5374617475734261722D736572766963654D73677B636F6C6F723A236561656165617D2E757070792D5374617475734261722D736572766963654D73672D67686F73747349636F6E7B6C6566743A3670783B6F7061636974793A2E';
wwv_flow_imp.g_varchar2_table(186) := '353B706F736974696F6E3A72656C61746976653B746F703A3270783B766572746963616C2D616C69676E3A746578742D626F74746F6D3B77696474683A313070787D2E757070792D73697A652D2D6D64202E757070792D5374617475734261722D736572';
wwv_flow_imp.g_varchar2_table(187) := '766963654D73672D67686F73747349636F6E7B6C6566743A313070783B746F703A3170783B77696474683A313570787D5B6469723D6C74725D202E757070792D5374617475734261722D64657461696C737B6C6566743A3270787D5B6469723D72746C5D';
wwv_flow_imp.g_varchar2_table(188) := '202E757070792D5374617475734261722D64657461696C737B72696768743A3270787D2E757070792D5374617475734261722D64657461696C737B2D7765626B69742D617070656172616E63653A6E6F6E653B617070656172616E63653A6E6F6E653B62';
wwv_flow_imp.g_varchar2_table(189) := '61636B67726F756E642D636F6C6F723A233933393339333B626F726465722D7261646975733A3530253B636F6C6F723A236666663B637572736F723A68656C703B646973706C61793A696E6C696E652D626C6F636B3B666F6E742D73697A653A31307078';
wwv_flow_imp.g_varchar2_table(190) := '3B666F6E742D7765696768743A3630303B6865696768743A313370783B6C696E652D6865696768743A313270783B706F736974696F6E3A72656C61746976653B746578742D616C69676E3A63656E7465723B746F703A303B766572746963616C2D616C69';
wwv_flow_imp.g_varchar2_table(191) := '676E3A6D6964646C653B77696474683A313370787D2E757070792D5374617475734261722D64657461696C733A61667465727B776F72642D777261703A627265616B2D776F72643B6C696E652D6865696768743A312E337D5B6469723D6C74725D202E75';
wwv_flow_imp.g_varchar2_table(192) := '7070792D5374617475734261722D7370696E6E65727B6D617267696E2D72696768743A313070787D5B6469723D72746C5D202E757070792D5374617475734261722D7370696E6E65727B6D617267696E2D6C6566743A313070787D2E757070792D537461';
wwv_flow_imp.g_varchar2_table(193) := '7475734261722D7370696E6E65727B66696C6C3A233132363963663B616E696D6174696F6E2D6475726174696F6E3A31733B616E696D6174696F6E2D697465726174696F6E2D636F756E743A696E66696E6974653B616E696D6174696F6E2D6E616D653A';
wwv_flow_imp.g_varchar2_table(194) := '757070792D5374617475734261722D7370696E6E6572416E696D6174696F6E3B616E696D6174696F6E2D74696D696E672D66756E6374696F6E3A6C696E6561727D2E757070792D5374617475734261722E69732D706F737470726F63657373696E67202E';
wwv_flow_imp.g_varchar2_table(195) := '757070792D5374617475734261722D7370696E6E65722C2E757070792D5374617475734261722E69732D70726570726F63657373696E67202E757070792D5374617475734261722D7370696E6E65727B66696C6C3A236636613632337D406B6579667261';
wwv_flow_imp.g_varchar2_table(196) := '6D657320757070792D5374617475734261722D7370696E6E6572416E696D6174696F6E7B30257B7472616E73666F726D3A726F746174652830646567297D746F7B7472616E73666F726D3A726F7461746528317475726E297D7D2E757070792D50726F76';
wwv_flow_imp.g_varchar2_table(197) := '6964657242726F777365722D76696577547970652D2D6772696420756C2E757070792D50726F766964657242726F777365722D6C6973742C2E757070792D50726F766964657242726F777365722D76696577547970652D2D756E73706C61736820756C2E';
wwv_flow_imp.g_varchar2_table(198) := '757070792D50726F766964657242726F777365722D6C6973747B616C69676E2D6974656D733A666C65782D73746172743B646973706C61793A666C65783B666C65782D646972656374696F6E3A726F773B666C65782D777261703A777261703B6A757374';
wwv_flow_imp.g_varchar2_table(199) := '6966792D636F6E74656E743A73706163652D6265747765656E3B70616464696E673A3670787D2E757070792D50726F766964657242726F777365722D76696577547970652D2D6772696420756C2E757070792D50726F766964657242726F777365722D6C';
wwv_flow_imp.g_varchar2_table(200) := '6973743A61667465722C2E757070792D50726F766964657242726F777365722D76696577547970652D2D756E73706C61736820756C2E757070792D50726F766964657242726F777365722D6C6973743A61667465727B636F6E74656E743A22223B666C65';
wwv_flow_imp.g_varchar2_table(201) := '783A6175746F7D2E757070792D50726F766964657242726F777365722D76696577547970652D2D67726964206C692E757070792D50726F766964657242726F777365724974656D2C2E757070792D50726F766964657242726F777365722D766965775479';
wwv_flow_imp.g_varchar2_table(202) := '70652D2D756E73706C617368206C692E757070792D50726F766964657242726F777365724974656D7B6D617267696E3A303B706F736974696F6E3A72656C61746976653B77696474683A3530257D2E757070792D73697A652D2D6D64202E757070792D50';
wwv_flow_imp.g_varchar2_table(203) := '726F766964657242726F777365722D76696577547970652D2D67726964206C692E757070792D50726F766964657242726F777365724974656D2C2E757070792D73697A652D2D6D64202E757070792D50726F766964657242726F777365722D7669657754';
wwv_flow_imp.g_varchar2_table(204) := '7970652D2D756E73706C617368206C692E757070792D50726F766964657242726F777365724974656D7B77696474683A33332E33333333257D2E757070792D73697A652D2D6C67202E757070792D50726F766964657242726F777365722D766965775479';
wwv_flow_imp.g_varchar2_table(205) := '70652D2D67726964206C692E757070792D50726F766964657242726F777365724974656D2C2E757070792D73697A652D2D6C67202E757070792D50726F766964657242726F777365722D76696577547970652D2D756E73706C617368206C692E75707079';
wwv_flow_imp.g_varchar2_table(206) := '2D50726F766964657242726F777365724974656D7B77696474683A3235257D2E757070792D50726F766964657242726F777365722D76696577547970652D2D67726964206C692E757070792D50726F766964657242726F777365724974656D3A6265666F';
wwv_flow_imp.g_varchar2_table(207) := '72652C2E757070792D50726F766964657242726F777365722D76696577547970652D2D756E73706C617368206C692E757070792D50726F766964657242726F777365724974656D3A6265666F72657B636F6E74656E743A22223B646973706C61793A626C';
wwv_flow_imp.g_varchar2_table(208) := '6F636B3B70616464696E672D746F703A313030257D2E757070792D50726F766964657242726F777365722D76696577547970652D2D67726964206C692E757070792D50726F766964657242726F777365724974656D2D2D73656C656374656420696D672C';
wwv_flow_imp.g_varchar2_table(209) := '2E757070792D50726F766964657242726F777365722D76696577547970652D2D67726964206C692E757070792D50726F766964657242726F777365724974656D2D2D73656C6563746564207376672C2E757070792D50726F766964657242726F77736572';
wwv_flow_imp.g_varchar2_table(210) := '2D76696577547970652D2D756E73706C617368206C692E757070792D50726F766964657242726F777365724974656D2D2D73656C656374656420696D672C2E757070792D50726F766964657242726F777365722D76696577547970652D2D756E73706C61';
wwv_flow_imp.g_varchar2_table(211) := '7368206C692E757070792D50726F766964657242726F777365724974656D2D2D73656C6563746564207376677B6F7061636974793A2E38357D2E757070792D50726F766964657242726F777365722D76696577547970652D2D67726964206C692E757070';
wwv_flow_imp.g_varchar2_table(212) := '792D50726F766964657242726F777365724974656D2D2D64697361626C65642C2E757070792D50726F766964657242726F777365722D76696577547970652D2D756E73706C617368206C692E757070792D50726F766964657242726F777365724974656D';
wwv_flow_imp.g_varchar2_table(213) := '2D2D64697361626C65647B6F7061636974793A2E357D2E757070792D50726F766964657242726F777365722D76696577547970652D2D67726964206C692E757070792D50726F766964657242726F777365724974656D2D2D6E6F50726576696577202E75';
wwv_flow_imp.g_varchar2_table(214) := '7070792D50726F766964657242726F777365724974656D2D696E6E65722C2E757070792D50726F766964657242726F777365722D76696577547970652D2D756E73706C617368206C692E757070792D50726F766964657242726F777365724974656D2D2D';
wwv_flow_imp.g_varchar2_table(215) := '6E6F50726576696577202E757070792D50726F766964657242726F777365724974656D2D696E6E65727B6261636B67726F756E642D636F6C6F723A2339333933393333337D5B646174612D757070792D7468656D653D6461726B5D202E757070792D5072';
wwv_flow_imp.g_varchar2_table(216) := '6F766964657242726F777365722D76696577547970652D2D67726964206C692E757070792D50726F766964657242726F777365724974656D2D2D6E6F50726576696577202E757070792D50726F766964657242726F777365724974656D2D696E6E65722C';
wwv_flow_imp.g_varchar2_table(217) := '5B646174612D757070792D7468656D653D6461726B5D202E757070792D50726F766964657242726F777365722D76696577547970652D2D756E73706C617368206C692E757070792D50726F766964657242726F777365724974656D2D2D6E6F5072657669';
wwv_flow_imp.g_varchar2_table(218) := '6577202E757070792D50726F766964657242726F777365724974656D2D696E6E65727B6261636B67726F756E642D636F6C6F723A2365616561656133337D2E757070792D50726F766964657242726F777365722D76696577547970652D2D67726964206C';
wwv_flow_imp.g_varchar2_table(219) := '692E757070792D50726F766964657242726F777365724974656D2D2D6E6F50726576696577207376672C2E757070792D50726F766964657242726F777365722D76696577547970652D2D756E73706C617368206C692E757070792D50726F766964657242';
wwv_flow_imp.g_varchar2_table(220) := '726F777365724974656D2D2D6E6F50726576696577207376677B66696C6C3A2330303030303062333B6865696768743A3330253B77696474683A3330257D5B646174612D757070792D7468656D653D6461726B5D202E757070792D50726F766964657242';
wwv_flow_imp.g_varchar2_table(221) := '726F777365722D76696577547970652D2D67726964206C692E757070792D50726F766964657242726F777365724974656D2D2D6E6F50726576696577207376672C5B646174612D757070792D7468656D653D6461726B5D202E757070792D50726F766964';
wwv_flow_imp.g_varchar2_table(222) := '657242726F777365722D76696577547970652D2D756E73706C617368206C692E757070792D50726F766964657242726F777365724974656D2D2D6E6F50726576696577207376677B66696C6C3A23666666637D2E757070792D50726F766964657242726F';
wwv_flow_imp.g_varchar2_table(223) := '777365722D76696577547970652D2D67726964202E757070792D50726F766964657242726F777365724974656D2D696E6E65722C2E757070792D50726F766964657242726F777365722D76696577547970652D2D756E73706C617368202E757070792D50';
wwv_flow_imp.g_varchar2_table(224) := '726F766964657242726F777365724974656D2D696E6E65727B626F726465722D7261646975733A3470783B626F74746F6D3A3770783B6865696768743A63616C632831303025202D2031347078293B6C6566743A3770783B6F766572666C6F773A686964';
wwv_flow_imp.g_varchar2_table(225) := '64656E3B706F736974696F6E3A6162736F6C7574653B72696768743A3770783B746578742D616C69676E3A63656E7465723B746F703A3770783B77696474683A63616C632831303025202D2031347078297D406D656469612028686F7665723A6E6F6E65';
wwv_flow_imp.g_varchar2_table(226) := '297B2E757070792D50726F766964657242726F777365722D76696577547970652D2D67726964202E757070792D50726F766964657242726F777365724974656D2D696E6E6572202E757070792D50726F766964657242726F777365724974656D2D617574';
wwv_flow_imp.g_varchar2_table(227) := '686F722C2E757070792D50726F766964657242726F777365722D76696577547970652D2D756E73706C617368202E757070792D50726F766964657242726F777365724974656D2D696E6E6572202E757070792D50726F766964657242726F777365724974';
wwv_flow_imp.g_varchar2_table(228) := '656D2D617574686F727B646973706C61793A626C6F636B7D7D5B646174612D757070792D7468656D653D6461726B5D202E757070792D50726F766964657242726F777365722D76696577547970652D2D67726964202E757070792D50726F766964657242';
wwv_flow_imp.g_varchar2_table(229) := '726F777365724974656D2D696E6E65722C5B646174612D757070792D7468656D653D6461726B5D202E757070792D50726F766964657242726F777365722D76696577547970652D2D756E73706C617368202E757070792D50726F766964657242726F7773';
wwv_flow_imp.g_varchar2_table(230) := '65724974656D2D696E6E65727B626F782D736861646F773A302030203020337078202361616531666662337D2E757070792D50726F766964657242726F777365722D76696577547970652D2D67726964202E757070792D50726F766964657242726F7773';
wwv_flow_imp.g_varchar2_table(231) := '65724974656D2D696E6E657220696D672C2E757070792D50726F766964657242726F777365722D76696577547970652D2D756E73706C617368202E757070792D50726F766964657242726F777365724974656D2D696E6E657220696D677B626F72646572';
wwv_flow_imp.g_varchar2_table(232) := '2D7261646975733A3470783B6865696768743A313030253B6F626A6563742D6669743A636F7665723B77696474683A313030257D2E757070792D50726F766964657242726F777365722D76696577547970652D2D67726964202E757070792D50726F7669';
wwv_flow_imp.g_varchar2_table(233) := '64657242726F777365724974656D2D617574686F722C2E757070792D50726F766964657242726F777365722D76696577547970652D2D756E73706C617368202E757070792D50726F766964657242726F777365724974656D2D617574686F727B6261636B';
wwv_flow_imp.g_varchar2_table(234) := '67726F756E643A2330303030303034643B626F74746F6D3A303B636F6C6F723A236666663B646973706C61793A6E6F6E653B666F6E742D73697A653A313270783B666F6E742D7765696768743A3530303B6C6566743A303B6D617267696E3A303B706164';
wwv_flow_imp.g_varchar2_table(235) := '64696E673A3570783B706F736974696F6E3A6162736F6C7574653B746578742D6465636F726174696F6E3A6E6F6E653B77696474683A313030257D2E757070792D50726F766964657242726F777365722D76696577547970652D2D67726964202E757070';
wwv_flow_imp.g_varchar2_table(236) := '792D50726F766964657242726F777365724974656D2D617574686F723A686F7665722C2E757070792D50726F766964657242726F777365722D76696577547970652D2D756E73706C617368202E757070792D50726F766964657242726F77736572497465';
wwv_flow_imp.g_varchar2_table(237) := '6D2D617574686F723A686F7665727B6261636B67726F756E643A23303030363B746578742D6465636F726174696F6E3A756E6465726C696E657D2E757070792D50726F766964657242726F777365722D76696577547970652D2D67726964202E75707079';
wwv_flow_imp.g_varchar2_table(238) := '2D50726F766964657242726F777365724974656D2D636865636B626F782C2E757070792D50726F766964657242726F777365722D76696577547970652D2D756E73706C617368202E757070792D50726F766964657242726F777365724974656D2D636865';
wwv_flow_imp.g_varchar2_table(239) := '636B626F787B6261636B67726F756E642D636F6C6F723A233132363963663B626F726465722D7261646975733A3530253B6865696768743A323670783B6F7061636974793A303B706F736974696F6E3A6162736F6C7574653B72696768743A313670783B';
wwv_flow_imp.g_varchar2_table(240) := '746F703A313670783B77696474683A323670783B7A2D696E6465783A313030327D5B6469723D6C74725D202E757070792D50726F766964657242726F777365722D76696577547970652D2D67726964202E757070792D50726F766964657242726F777365';
wwv_flow_imp.g_varchar2_table(241) := '724974656D2D636865636B626F783A61667465722C5B6469723D6C74725D202E757070792D50726F766964657242726F777365722D76696577547970652D2D756E73706C617368202E757070792D50726F766964657242726F777365724974656D2D6368';
wwv_flow_imp.g_varchar2_table(242) := '65636B626F783A61667465727B6C6566743A3770787D5B6469723D72746C5D202E757070792D50726F766964657242726F777365722D76696577547970652D2D67726964202E757070792D50726F766964657242726F777365724974656D2D636865636B';
wwv_flow_imp.g_varchar2_table(243) := '626F783A61667465722C5B6469723D72746C5D202E757070792D50726F766964657242726F777365722D76696577547970652D2D756E73706C617368202E757070792D50726F766964657242726F777365724974656D2D636865636B626F783A61667465';
wwv_flow_imp.g_varchar2_table(244) := '727B72696768743A3770787D2E757070792D50726F766964657242726F777365722D76696577547970652D2D67726964202E757070792D50726F766964657242726F777365724974656D2D636865636B626F783A61667465722C2E757070792D50726F76';
wwv_flow_imp.g_varchar2_table(245) := '6964657242726F777365722D76696577547970652D2D756E73706C617368202E757070792D50726F766964657242726F777365724974656D2D636865636B626F783A61667465727B6865696768743A3770783B746F703A3870783B77696474683A313270';
wwv_flow_imp.g_varchar2_table(246) := '787D2E757070792D50726F766964657242726F777365722D76696577547970652D2D67726964202E757070792D50726F766964657242726F777365724974656D2D636865636B626F782D2D69732D636865636B65642C2E757070792D50726F7669646572';
wwv_flow_imp.g_varchar2_table(247) := '42726F777365722D76696577547970652D2D756E73706C617368202E757070792D50726F766964657242726F777365724974656D2D636865636B626F782D2D69732D636865636B65647B6F7061636974793A317D2E757070792D50726F76696465724272';
wwv_flow_imp.g_varchar2_table(248) := '6F777365722D76696577547970652D2D67726964202E757070792D50726F766964657242726F777365724974656D2D636865636B626F782D2D677269643A666F6375732B6C6162656C202E757070792D50726F766964657242726F777365724974656D2D';
wwv_flow_imp.g_varchar2_table(249) := '617574686F722C2E757070792D50726F766964657242726F777365722D76696577547970652D2D67726964202E757070792D50726F766964657242726F777365724974656D2D636865636B626F782D2D677269643A686F7665722B6C6162656C202E7570';
wwv_flow_imp.g_varchar2_table(250) := '70792D50726F766964657242726F777365724974656D2D617574686F722C2E757070792D50726F766964657242726F777365722D76696577547970652D2D756E73706C617368202E757070792D50726F766964657242726F777365724974656D2D636865';
wwv_flow_imp.g_varchar2_table(251) := '636B626F782D2D677269643A666F6375732B6C6162656C202E757070792D50726F766964657242726F777365724974656D2D617574686F722C2E757070792D50726F766964657242726F777365722D76696577547970652D2D756E73706C617368202E75';
wwv_flow_imp.g_varchar2_table(252) := '7070792D50726F766964657242726F777365724974656D2D636865636B626F782D2D677269643A686F7665722B6C6162656C202E757070792D50726F766964657242726F777365724974656D2D617574686F727B646973706C61793A626C6F636B7D2E75';
wwv_flow_imp.g_varchar2_table(253) := '7070792D50726F766964657242726F777365722D76696577547970652D2D67726964202E757070792D50726F766964657242726F777365724974656D2D636865636B626F782D2D677269643A666F6375732B6C6162656C2C2E757070792D50726F766964';
wwv_flow_imp.g_varchar2_table(254) := '657242726F777365722D76696577547970652D2D756E73706C617368202E757070792D50726F766964657242726F777365724974656D2D636865636B626F782D2D677269643A666F6375732B6C6162656C7B626F782D736861646F773A30203020302033';
wwv_flow_imp.g_varchar2_table(255) := '7078202331323639636638307D2E757070792D50726F766964657242726F777365722D76696577547970652D2D67726964202E757070792D50726F766964657242726F777365724974656D2D636865636B626F782D2D677269643A666F6375732B6C6162';
wwv_flow_imp.g_varchar2_table(256) := '656C3A666F6375732C2E757070792D50726F766964657242726F777365722D76696577547970652D2D756E73706C617368202E757070792D50726F766964657242726F777365724974656D2D636865636B626F782D2D677269643A666F6375732B6C6162';
wwv_flow_imp.g_varchar2_table(257) := '656C3A666F6375737B6F75746C696E653A6E6F6E657D2E757070792D50726F766964657242726F777365722D76696577547970652D2D67726964202E757070792D50726F766964657242726F777365724974656D2D636865636B626F782D2D677269643A';
wwv_flow_imp.g_varchar2_table(258) := '666F6375732B6C6162656C3A3A2D6D6F7A2D666F6375732D696E6E65722C2E757070792D50726F766964657242726F777365722D76696577547970652D2D756E73706C617368202E757070792D50726F766964657242726F777365724974656D2D636865';
wwv_flow_imp.g_varchar2_table(259) := '636B626F782D2D677269643A666F6375732B6C6162656C3A3A2D6D6F7A2D666F6375732D696E6E65727B626F726465723A307D2E757070792D50726F766964657242726F777365722D76696577547970652D2D6C6973747B6261636B67726F756E642D63';
wwv_flow_imp.g_varchar2_table(260) := '6F6C6F723A236666667D5B646174612D757070792D7468656D653D6461726B5D202E757070792D50726F766964657242726F777365722D76696577547970652D2D6C6973747B6261636B67726F756E642D636F6C6F723A233166316631667D2E75707079';
wwv_flow_imp.g_varchar2_table(261) := '2D50726F766964657242726F777365722D76696577547970652D2D6C697374206C692E757070792D50726F766964657242726F777365724974656D7B616C69676E2D6974656D733A63656E7465723B646973706C61793A666C65783B6D617267696E3A30';
wwv_flow_imp.g_varchar2_table(262) := '3B70616464696E673A37707820313570787D5B646174612D757070792D7468656D653D6461726B5D202E757070792D50726F766964657242726F777365722D76696577547970652D2D6C697374206C692E757070792D50726F766964657242726F777365';
wwv_flow_imp.g_varchar2_table(263) := '724974656D7B636F6C6F723A236561656165617D2E757070792D50726F766964657242726F777365722D76696577547970652D2D6C697374206C692E757070792D50726F766964657242726F777365724974656D2D2D64697361626C65647B6F70616369';
wwv_flow_imp.g_varchar2_table(264) := '74793A2E367D5B6469723D6C74725D202E757070792D50726F766964657242726F777365722D76696577547970652D2D6C697374202E757070792D50726F766964657242726F777365724974656D2D636865636B626F787B6D617267696E2D7269676874';
wwv_flow_imp.g_varchar2_table(265) := '3A313570787D5B6469723D72746C5D202E757070792D50726F766964657242726F777365722D76696577547970652D2D6C697374202E757070792D50726F766964657242726F777365724974656D2D636865636B626F787B6D617267696E2D6C6566743A';
wwv_flow_imp.g_varchar2_table(266) := '313570787D2E757070792D50726F766964657242726F777365722D76696577547970652D2D6C697374202E757070792D50726F766964657242726F777365724974656D2D636865636B626F787B6261636B67726F756E642D636F6C6F723A236666663B62';
wwv_flow_imp.g_varchar2_table(267) := '6F726465723A31707820736F6C696420236366636663663B626F726465722D7261646975733A3370783B6865696768743A313770783B77696474683A313770787D2E757070792D50726F766964657242726F777365722D76696577547970652D2D6C6973';
wwv_flow_imp.g_varchar2_table(268) := '74202E757070792D50726F766964657242726F777365724974656D2D636865636B626F783A666F6375737B626F726465723A31707820736F6C696420233132363963663B626F782D736861646F773A302030203020337078202331323639636634303B6F';
wwv_flow_imp.g_varchar2_table(269) := '75746C696E653A6E6F6E657D5B6469723D6C74725D202E757070792D50726F766964657242726F777365722D76696577547970652D2D6C697374202E757070792D50726F766964657242726F777365724974656D2D636865636B626F783A61667465727B';
wwv_flow_imp.g_varchar2_table(270) := '6C6566743A3370787D5B6469723D72746C5D202E757070792D50726F766964657242726F777365722D76696577547970652D2D6C697374202E757070792D50726F766964657242726F777365724974656D2D636865636B626F783A61667465727B726967';
wwv_flow_imp.g_varchar2_table(271) := '68743A3370787D2E757070792D50726F766964657242726F777365722D76696577547970652D2D6C697374202E757070792D50726F766964657242726F777365724974656D2D636865636B626F783A61667465727B6865696768743A3570783B6F706163';
wwv_flow_imp.g_varchar2_table(272) := '6974793A303B746F703A3470783B77696474683A3970787D5B646174612D757070792D7468656D653D6461726B5D202E757070792D50726F766964657242726F777365722D76696577547970652D2D6C697374202E757070792D50726F76696465724272';
wwv_flow_imp.g_varchar2_table(273) := '6F777365724974656D2D636865636B626F783A666F6375737B626F726465722D636F6C6F723A2330326261663262333B626F782D736861646F773A302030203020337078202330326261663233337D2E757070792D50726F766964657242726F77736572';
wwv_flow_imp.g_varchar2_table(274) := '2D76696577547970652D2D6C697374202E757070792D50726F766964657242726F777365724974656D2D636865636B626F782D2D69732D636865636B65647B6261636B67726F756E642D636F6C6F723A233132363963663B626F726465722D636F6C6F72';
wwv_flow_imp.g_varchar2_table(275) := '3A233132363963667D2E757070792D50726F766964657242726F777365722D76696577547970652D2D6C697374202E757070792D50726F766964657242726F777365724974656D2D636865636B626F782D2D69732D636865636B65643A61667465727B6F';
wwv_flow_imp.g_varchar2_table(276) := '7061636974793A317D2E757070792D50726F766964657242726F777365722D76696577547970652D2D6C697374202E757070792D50726F766964657242726F777365724974656D2D696E6E65727B616C69676E2D6974656D733A63656E7465723B646973';
wwv_flow_imp.g_varchar2_table(277) := '706C61793A666C65783B6F766572666C6F773A68696464656E3B70616464696E673A3270783B746578742D6F766572666C6F773A656C6C69707369733B77686974652D73706163653A6E6F777261707D2E757070792D50726F766964657242726F777365';
wwv_flow_imp.g_varchar2_table(278) := '722D76696577547970652D2D6C697374202E757070792D50726F766964657242726F777365724974656D2D696E6E65723A666F6375737B6F75746C696E653A6E6F6E653B746578742D6465636F726174696F6E3A756E6465726C696E657D5B6469723D6C';
wwv_flow_imp.g_varchar2_table(279) := '74725D202E757070792D50726F766964657242726F777365722D76696577547970652D2D6C697374202E757070792D50726F766964657242726F777365724974656D2D696E6E657220696D672C5B6469723D6C74725D202E757070792D50726F76696465';
wwv_flow_imp.g_varchar2_table(280) := '7242726F777365722D76696577547970652D2D6C697374202E757070792D50726F766964657242726F777365724974656D2D696E6E6572207376677B6D617267696E2D72696768743A3870787D5B6469723D72746C5D202E757070792D50726F76696465';
wwv_flow_imp.g_varchar2_table(281) := '7242726F777365722D76696577547970652D2D6C697374202E757070792D50726F766964657242726F777365724974656D2D696E6E657220696D672C5B6469723D72746C5D202E757070792D50726F766964657242726F777365722D7669657754797065';
wwv_flow_imp.g_varchar2_table(282) := '2D2D6C697374202E757070792D50726F766964657242726F777365724974656D2D696E6E6572207376677B6D617267696E2D6C6566743A3870787D2E757070792D50726F766964657242726F777365722D76696577547970652D2D6C697374202E757070';
wwv_flow_imp.g_varchar2_table(283) := '792D50726F766964657242726F777365724974656D2D696E6E6572207370616E7B6C696E652D6865696768743A312E323B6F766572666C6F773A68696464656E3B746578742D6F766572666C6F773A656C6C69707369733B77686974652D73706163653A';
wwv_flow_imp.g_varchar2_table(284) := '6E6F777261707D2E757070792D50726F766964657242726F777365722D76696577547970652D2D6C697374202E757070792D50726F766964657242726F777365724974656D2D2D64697361626C6564202E757070792D50726F766964657242726F777365';
wwv_flow_imp.g_varchar2_table(285) := '724974656D2D696E6E65727B637572736F723A64656661756C747D5B6469723D6C74725D202E757070792D50726F766964657242726F777365722D76696577547970652D2D6C697374202E757070792D50726F766964657242726F777365724974656D2D';
wwv_flow_imp.g_varchar2_table(286) := '69636F6E577261707B6D617267696E2D72696768743A3770787D5B6469723D72746C5D202E757070792D50726F766964657242726F777365722D76696577547970652D2D6C697374202E757070792D50726F766964657242726F777365724974656D2D69';
wwv_flow_imp.g_varchar2_table(287) := '636F6E577261707B6D617267696E2D6C6566743A3770787D2E757070792D50726F766964657242726F777365722D76696577547970652D2D6C697374202E757070792D50726F766964657242726F777365724974656D2D69636F6E577261707B77696474';
wwv_flow_imp.g_varchar2_table(288) := '683A323070787D2E757070792D50726F766964657242726F777365724974656D2D636865636B626F787B637572736F723A706F696E7465723B666C65782D736872696E6B3A303B706F736974696F6E3A72656C61746976657D2E757070792D50726F7669';
wwv_flow_imp.g_varchar2_table(289) := '64657242726F777365724974656D2D636865636B626F783A64697361626C65647B637572736F723A64656661756C747D2E757070792D50726F766964657242726F777365724974656D2D636865636B626F783A61667465727B626F726465722D626F7474';
wwv_flow_imp.g_varchar2_table(290) := '6F6D3A32707820736F6C696420236561656165613B626F726465722D6C6566743A32707820736F6C696420236561656165613B636F6E74656E743A22223B637572736F723A706F696E7465723B706F736974696F6E3A6162736F6C7574653B7472616E73';
wwv_flow_imp.g_varchar2_table(291) := '666F726D3A726F74617465282D3435646567297D2E757070792D50726F766964657242726F777365724974656D2D636865636B626F783A64697361626C65643A61667465727B637572736F723A64656661756C747D5B646174612D757070792D7468656D';
wwv_flow_imp.g_varchar2_table(292) := '653D6461726B5D202E757070792D50726F766964657242726F777365724974656D2D636865636B626F787B6261636B67726F756E642D636F6C6F723A233166316631663B626F726465722D636F6C6F723A233933393339337D5B646174612D757070792D';
wwv_flow_imp.g_varchar2_table(293) := '7468656D653D6461726B5D202E757070792D50726F766964657242726F777365724974656D2D636865636B626F782D2D69732D636865636B65647B6261636B67726F756E642D636F6C6F723A233333337D2E757070792D53656172636850726F76696465';
wwv_flow_imp.g_varchar2_table(294) := '727B616C69676E2D6974656D733A63656E7465723B646973706C61793A666C65783B666C65783A313B666C65782D646972656374696F6E3A636F6C756D6E3B6865696768743A313030253B6A7573746966792D636F6E74656E743A63656E7465723B7769';
wwv_flow_imp.g_varchar2_table(295) := '6474683A313030257D5B646174612D757070792D7468656D653D6461726B5D202E757070792D53656172636850726F76696465727B6261636B67726F756E642D636F6C6F723A233166316631667D2E757070792D53656172636850726F76696465722D69';
wwv_flow_imp.g_varchar2_table(296) := '6E7075747B6D617267696E2D626F74746F6D3A313570783B6D61782D77696474683A36353070783B77696474683A3930257D2E757070792D73697A652D2D6D64202E757070792D53656172636850726F76696465722D696E7075747B6D617267696E2D62';
wwv_flow_imp.g_varchar2_table(297) := '6F74746F6D3A323070787D2E757070792D53656172636850726F76696465722D696E7075743A3A2D7765626B69742D7365617263682D63616E63656C2D627574746F6E7B646973706C61793A6E6F6E657D2E757070792D53656172636850726F76696465';
wwv_flow_imp.g_varchar2_table(298) := '722D736561726368427574746F6E7B70616464696E673A3133707820323570787D2E757070792D73697A652D2D6D64202E757070792D53656172636850726F76696465722D736561726368427574746F6E7B70616464696E673A3133707820333070787D';
wwv_flow_imp.g_varchar2_table(299) := '2E757070792D44617368626F617264436F6E74656E742D70616E656C426F64797B616C69676E2D6974656D733A63656E7465723B646973706C61793A666C65783B666C65783A313B6A7573746966792D636F6E74656E743A63656E7465727D5B64617461';
wwv_flow_imp.g_varchar2_table(300) := '2D757070792D7468656D653D6461726B5D202E757070792D44617368626F617264436F6E74656E742D70616E656C426F64797B6261636B67726F756E642D636F6C6F723A233166316631667D2E757070792D50726F76696465722D617574682C2E757070';
wwv_flow_imp.g_varchar2_table(301) := '792D50726F76696465722D656D7074792C2E757070792D50726F76696465722D6572726F722C2E757070792D50726F76696465722D6C6F6164696E677B616C69676E2D6974656D733A63656E7465723B636F6C6F723A233933393339333B646973706C61';
wwv_flow_imp.g_varchar2_table(302) := '793A666C65783B666C65783A313B666C65782D666C6F773A636F6C756D6E20777261703B6A7573746966792D636F6E74656E743A63656E7465727D2E757070792D50726F76696465722D656D7074797B636F6C6F723A233933393339337D2E757070792D';
wwv_flow_imp.g_varchar2_table(303) := '50726F76696465722D6175746849636F6E207376677B6865696768743A373570783B77696474683A31303070787D2E757070792D50726F76696465722D617574685469746C657B636F6C6F723A233735373537353B666F6E742D73697A653A313770783B';
wwv_flow_imp.g_varchar2_table(304) := '666F6E742D7765696768743A3430303B6C696E652D6865696768743A312E343B6D617267696E2D626F74746F6D3A333070783B6D61782D77696474683A35303070783B70616464696E673A3020313570783B746578742D616C69676E3A63656E7465727D';
wwv_flow_imp.g_varchar2_table(305) := '2E757070792D73697A652D2D6D64202E757070792D50726F76696465722D617574685469746C657B666F6E742D73697A653A323070787D5B646174612D757070792D7468656D653D6461726B5D202E757070792D50726F76696465722D61757468546974';
wwv_flow_imp.g_varchar2_table(306) := '6C657B636F6C6F723A236366636663667D2E757070792D50726F76696465722D62746E2D676F6F676C657B616C69676E2D6974656D733A63656E7465723B6261636B67726F756E643A233432383566343B646973706C61793A666C65783B70616464696E';
wwv_flow_imp.g_varchar2_table(307) := '673A387078203132707821696D706F7274616E747D2E757070792D50726F76696465722D62746E2D676F6F676C653A686F7665727B6261636B67726F756E642D636F6C6F723A233132363666317D2E757070792D50726F76696465722D62746E2D676F6F';
wwv_flow_imp.g_varchar2_table(308) := '676C653A666F6375737B626F782D736861646F773A302030203020337078202334323835663436363B6F75746C696E653A6E6F6E657D2E757070792D50726F76696465722D62746E2D676F6F676C65207376677B6D617267696E2D72696768743A387078';
wwv_flow_imp.g_varchar2_table(309) := '7D5B6469723D6C74725D202E757070792D50726F76696465722D62726561646372756D62737B746578742D616C69676E3A6C6566747D5B6469723D72746C5D202E757070792D50726F76696465722D62726561646372756D62737B746578742D616C6967';
wwv_flow_imp.g_varchar2_table(310) := '6E3A72696768747D2E757070792D50726F76696465722D62726561646372756D62737B636F6C6F723A233532353235323B666C65783A313B666F6E742D73697A653A313270783B6D617267696E2D626F74746F6D3A313070787D2E757070792D73697A65';
wwv_flow_imp.g_varchar2_table(311) := '2D2D6D64202E757070792D50726F76696465722D62726561646372756D62737B6D617267696E2D626F74746F6D3A307D5B646174612D757070792D7468656D653D6461726B5D202E757070792D50726F76696465722D62726561646372756D62737B636F';
wwv_flow_imp.g_varchar2_table(312) := '6C6F723A236561656165617D5B6469723D6C74725D202E757070792D50726F76696465722D62726561646372756D627349636F6E7B6D617267696E2D72696768743A3470787D5B6469723D72746C5D202E757070792D50726F76696465722D6272656164';
wwv_flow_imp.g_varchar2_table(313) := '6372756D627349636F6E7B6D617267696E2D6C6566743A3470787D2E757070792D50726F76696465722D62726561646372756D627349636F6E7B636F6C6F723A233532353235323B646973706C61793A696E6C696E652D626C6F636B3B6C696E652D6865';
wwv_flow_imp.g_varchar2_table(314) := '696768743A313B766572746963616C2D616C69676E3A6D6964646C657D2E757070792D50726F76696465722D62726561646372756D627349636F6E207376677B66696C6C3A233532353235323B6865696768743A313370783B77696474683A313370787D';
wwv_flow_imp.g_varchar2_table(315) := '2E757070792D50726F76696465722D62726561646372756D627320627574746F6E7B626F726465722D7261646975733A3370783B646973706C61793A696E6C696E652D626C6F636B3B6C696E652D6865696768743A696E68657269743B70616464696E67';
wwv_flow_imp.g_varchar2_table(316) := '3A3470787D2E757070792D50726F76696465722D62726561646372756D627320627574746F6E3A666F6375737B6F75746C696E653A6E6F6E657D2E757070792D50726F76696465722D62726561646372756D627320627574746F6E3A3A2D6D6F7A2D666F';
wwv_flow_imp.g_varchar2_table(317) := '6375732D696E6E65727B626F726465723A307D2E757070792D50726F76696465722D62726561646372756D627320627574746F6E3A686F7665727B636F6C6F723A233065353161307D2E757070792D50726F76696465722D62726561646372756D627320';
wwv_flow_imp.g_varchar2_table(318) := '627574746F6E3A666F6375737B6261636B67726F756E642D636F6C6F723A236466653666317D5B646174612D757070792D7468656D653D6461726B5D202E757070792D50726F76696465722D62726561646372756D627320627574746F6E3A666F637573';
wwv_flow_imp.g_varchar2_table(319) := '7B6261636B67726F756E642D636F6C6F723A233333337D2E757070792D50726F76696465722D62726561646372756D627320627574746F6E3A6E6F74283A6C6173742D6F662D74797065297B746578742D6465636F726174696F6E3A756E6465726C696E';
wwv_flow_imp.g_varchar2_table(320) := '657D2E757070792D50726F76696465722D62726561646372756D627320627574746F6E3A6C6173742D6F662D747970657B636F6C6F723A233333333B637572736F723A6E6F726D616C3B666F6E742D7765696768743A3530303B706F696E7465722D6576';
wwv_flow_imp.g_varchar2_table(321) := '656E74733A6E6F6E657D2E757070792D50726F76696465722D62726561646372756D627320627574746F6E3A686F7665727B637572736F723A706F696E7465727D5B646174612D757070792D7468656D653D6461726B5D202E757070792D50726F766964';
wwv_flow_imp.g_varchar2_table(322) := '65722D62726561646372756D627320627574746F6E7B636F6C6F723A236561656165617D2E757070792D50726F766964657242726F777365727B646973706C61793A666C65783B666C65783A313B666C65782D646972656374696F6E3A636F6C756D6E3B';
wwv_flow_imp.g_varchar2_table(323) := '666F6E742D73697A653A313470783B666F6E742D7765696768743A3430303B6865696768743A313030257D2E757070792D50726F766964657242726F777365722D757365727B636F6C6F723A233333333B666F6E742D7765696768743A3530303B6D6172';
wwv_flow_imp.g_varchar2_table(324) := '67696E3A3020387078203020307D5B646174612D757070792D7468656D653D6461726B5D202E757070792D50726F766964657242726F777365722D757365727B636F6C6F723A236561656165617D5B6469723D6C74725D202E757070792D50726F766964';
wwv_flow_imp.g_varchar2_table(325) := '657242726F777365722D757365723A61667465727B6C6566743A3470787D5B6469723D72746C5D202E757070792D50726F766964657242726F777365722D757365723A61667465727B72696768743A3470787D2E757070792D50726F766964657242726F';
wwv_flow_imp.g_varchar2_table(326) := '777365722D757365723A61667465727B636F6C6F723A233933393339333B636F6E74656E743A22C2B7223B666F6E742D7765696768743A3430303B706F736974696F6E3A72656C61746976657D2E757070792D50726F766964657242726F777365722D68';
wwv_flow_imp.g_varchar2_table(327) := '65616465727B626F726465722D626F74746F6D3A31707820736F6C696420236561656165613B706F736974696F6E3A72656C61746976653B7A2D696E6465783A313030317D5B646174612D757070792D7468656D653D6461726B5D202E757070792D5072';
wwv_flow_imp.g_varchar2_table(328) := '6F766964657242726F777365722D6865616465727B626F726465722D626F74746F6D3A31707820736F6C696420233333337D2E757070792D50726F766964657242726F777365722D6865616465724261727B6261636B67726F756E642D636F6C6F723A23';
wwv_flow_imp.g_varchar2_table(329) := '6661666166613B636F6C6F723A233735373537353B666F6E742D73697A653A313270783B6C696E652D6865696768743A312E343B70616464696E673A37707820313570783B7A2D696E6465783A313030317D2E757070792D73697A652D2D6D64202E7570';
wwv_flow_imp.g_varchar2_table(330) := '70792D50726F766964657242726F777365722D6865616465724261727B616C69676E2D6974656D733A63656E7465723B646973706C61793A666C65787D5B646174612D757070792D7468656D653D6461726B5D202E757070792D50726F76696465724272';
wwv_flow_imp.g_varchar2_table(331) := '6F777365722D6865616465724261727B6261636B67726F756E642D636F6C6F723A233166316631667D2E757070792D50726F766964657242726F777365722D6865616465724261722D2D73696D706C657B646973706C61793A626C6F636B3B6A75737469';
wwv_flow_imp.g_varchar2_table(332) := '66792D636F6E74656E743A63656E7465723B746578742D616C69676E3A63656E7465727D2E757070792D50726F766964657242726F777365722D6865616465724261722D2D73696D706C65202E757070792D50726F76696465722D62726561646372756D';
wwv_flow_imp.g_varchar2_table(333) := '6273577261707B646973706C61793A696E6C696E652D626C6F636B3B666C65783A6E6F6E653B766572746963616C2D616C69676E3A6D6964646C657D2E757070792D50726F766964657242726F777365722D73656172636846696C7465727B616C69676E';
wwv_flow_imp.g_varchar2_table(334) := '2D6974656D733A63656E7465723B646973706C61793A666C65783B6865696768743A333070783B6D617267696E2D626F74746F6D3A313570783B6D617267696E2D746F703A313570783B70616464696E672D6C6566743A3870783B70616464696E672D72';
wwv_flow_imp.g_varchar2_table(335) := '696768743A3870783B706F736974696F6E3A72656C61746976653B77696474683A313030257D5B6469723D6C74725D202E757070792D50726F766964657242726F777365722D73656172636846696C746572496E7075747B70616464696E672D6C656674';
wwv_flow_imp.g_varchar2_table(336) := '3A333070787D5B6469723D6C74725D202E757070792D50726F766964657242726F777365722D73656172636846696C746572496E7075742C5B6469723D72746C5D202E757070792D50726F766964657242726F777365722D73656172636846696C746572';
wwv_flow_imp.g_varchar2_table(337) := '496E7075747B70616464696E672D72696768743A333070787D5B6469723D72746C5D202E757070792D50726F766964657242726F777365722D73656172636846696C746572496E7075747B70616464696E672D6C6566743A333070787D2E757070792D50';
wwv_flow_imp.g_varchar2_table(338) := '726F766964657242726F777365722D73656172636846696C746572496E7075747B6261636B67726F756E642D636F6C6F723A236561656165613B626F726465723A303B626F726465722D7261646975733A3470783B636F6C6F723A233333333B666F6E74';
wwv_flow_imp.g_varchar2_table(339) := '2D66616D696C793A2D6170706C652D73797374656D2C73797374656D2D75692C426C696E6B4D616353797374656D466F6E742C5365676F652055492C5365676F652055492053796D626F6C2C5365676F6520554920456D6F6A692C4170706C6520436F6C';
wwv_flow_imp.g_varchar2_table(340) := '6F7220456D6F6A692C526F626F746F2C48656C7665746963612C417269616C2C73616E732D73657269663B666F6E742D73697A653A313370783B6865696768743A333070783B6C696E652D6865696768743A312E343B6F75746C696E653A303B77696474';
wwv_flow_imp.g_varchar2_table(341) := '683A313030253B7A2D696E6465783A313030317D2E757070792D50726F766964657242726F777365722D73656172636846696C746572496E7075743A3A2D7765626B69742D7365617263682D63616E63656C2D627574746F6E7B646973706C61793A6E6F';
wwv_flow_imp.g_varchar2_table(342) := '6E657D5B646174612D757070792D7468656D653D6461726B5D202E757070792D50726F766964657242726F777365722D73656172636846696C746572496E7075747B6261636B67726F756E642D636F6C6F723A233166316631663B636F6C6F723A236561';
wwv_flow_imp.g_varchar2_table(343) := '656165617D2E757070792D50726F766964657242726F777365722D73656172636846696C746572496E7075743A666F6375737B6261636B67726F756E642D636F6C6F723A236366636663663B626F726465723A307D5B646174612D757070792D7468656D';
wwv_flow_imp.g_varchar2_table(344) := '653D6461726B5D202E757070792D50726F766964657242726F777365722D73656172636846696C746572496E7075743A666F6375737B6261636B67726F756E642D636F6C6F723A233333337D5B6469723D6C74725D202E757070792D50726F7669646572';
wwv_flow_imp.g_varchar2_table(345) := '42726F777365722D73656172636846696C74657249636F6E7B6C6566743A313670787D5B6469723D72746C5D202E757070792D50726F766964657242726F777365722D73656172636846696C74657249636F6E7B72696768743A313670787D2E75707079';
wwv_flow_imp.g_varchar2_table(346) := '2D50726F766964657242726F777365722D73656172636846696C74657249636F6E7B636F6C6F723A233735373537353B6865696768743A313270783B706F736974696F6E3A6162736F6C7574653B77696474683A313270783B7A2D696E6465783A313030';
wwv_flow_imp.g_varchar2_table(347) := '327D2E757070792D50726F766964657242726F777365722D73656172636846696C746572496E7075743A3A706C616365686F6C6465727B636F6C6F723A233933393339333B6F7061636974793A317D5B6469723D6C74725D202E757070792D50726F7669';
wwv_flow_imp.g_varchar2_table(348) := '64657242726F777365722D73656172636846696C74657252657365747B72696768743A313670787D5B6469723D72746C5D202E757070792D50726F766964657242726F777365722D73656172636846696C74657252657365747B6C6566743A313670787D';
wwv_flow_imp.g_varchar2_table(349) := '2E757070792D50726F766964657242726F777365722D73656172636846696C74657252657365747B626F726465722D7261646975733A3370783B636F6C6F723A233933393339333B637572736F723A706F696E7465723B6865696768743A323270783B70';
wwv_flow_imp.g_varchar2_table(350) := '616464696E673A3670783B706F736974696F6E3A6162736F6C7574653B77696474683A323270783B7A2D696E6465783A313030327D2E757070792D50726F766964657242726F777365722D73656172636846696C74657252657365743A666F6375737B6F';
wwv_flow_imp.g_varchar2_table(351) := '75746C696E653A6E6F6E657D2E757070792D50726F766964657242726F777365722D73656172636846696C74657252657365743A3A2D6D6F7A2D666F6375732D696E6E65727B626F726465723A307D2E757070792D50726F766964657242726F77736572';
wwv_flow_imp.g_varchar2_table(352) := '2D73656172636846696C74657252657365743A666F6375737B626F782D736861646F773A302030203020337078202331323639636638307D2E757070792D50726F766964657242726F777365722D73656172636846696C74657252657365743A686F7665';
wwv_flow_imp.g_varchar2_table(353) := '727B636F6C6F723A233735373537357D2E757070792D50726F766964657242726F777365722D73656172636846696C7465725265736574207376677B766572746963616C2D616C69676E3A746578742D746F707D2E757070792D50726F76696465724272';
wwv_flow_imp.g_varchar2_table(354) := '6F777365722D757365724C6F676F75747B626F726465722D7261646975733A3370783B636F6C6F723A233132363963663B637572736F723A706F696E7465723B6C696E652D6865696768743A696E68657269743B70616464696E673A3470787D2E757070';
wwv_flow_imp.g_varchar2_table(355) := '792D50726F766964657242726F777365722D757365724C6F676F75743A666F6375737B6F75746C696E653A6E6F6E657D2E757070792D50726F766964657242726F777365722D757365724C6F676F75743A3A2D6D6F7A2D666F6375732D696E6E65727B62';
wwv_flow_imp.g_varchar2_table(356) := '6F726465723A307D2E757070792D50726F766964657242726F777365722D757365724C6F676F75743A686F7665727B636F6C6F723A233065353161307D2E757070792D50726F766964657242726F777365722D757365724C6F676F75743A666F6375737B';
wwv_flow_imp.g_varchar2_table(357) := '6261636B67726F756E642D636F6C6F723A236466653666317D5B646174612D757070792D7468656D653D6461726B5D202E757070792D50726F766964657242726F777365722D757365724C6F676F75743A666F6375737B6261636B67726F756E642D636F';
wwv_flow_imp.g_varchar2_table(358) := '6C6F723A233333337D2E757070792D50726F766964657242726F777365722D757365724C6F676F75743A686F7665727B746578742D6465636F726174696F6E3A756E6465726C696E657D5B646174612D757070792D7468656D653D6461726B5D202E7570';
wwv_flow_imp.g_varchar2_table(359) := '70792D50726F766964657242726F777365722D757365724C6F676F75747B636F6C6F723A236561656165617D2E757070792D50726F766964657242726F777365722D626F64797B666C65783A313B706F736974696F6E3A72656C61746976657D2E757070';
wwv_flow_imp.g_varchar2_table(360) := '792D50726F766964657242726F777365722D6C6973747B2D7765626B69742D6F766572666C6F772D7363726F6C6C696E673A746F7563683B6261636B67726F756E642D636F6C6F723A236666663B626F726465722D73706163696E673A303B626F74746F';
wwv_flow_imp.g_varchar2_table(361) := '6D3A303B646973706C61793A626C6F636B3B666C65783A313B6865696768743A313030253B6C6566743A303B6C6973742D7374796C653A6E6F6E653B6D617267696E3A303B6F766572666C6F772D783A68696464656E3B6F766572666C6F772D793A6175';
wwv_flow_imp.g_varchar2_table(362) := '746F3B70616464696E673A303B706F736974696F6E3A6162736F6C7574653B72696768743A303B746F703A303B77696474683A313030257D5B646174612D757070792D7468656D653D6461726B5D202E757070792D50726F766964657242726F77736572';
wwv_flow_imp.g_varchar2_table(363) := '2D6C6973747B6261636B67726F756E642D636F6C6F723A233166316631667D2E757070792D50726F766964657242726F777365722D6C6973743A666F6375737B6F75746C696E653A6E6F6E657D2E757070792D50726F766964657242726F777365724974';
wwv_flow_imp.g_varchar2_table(364) := '656D2D696E6E65727B637572736F723A706F696E7465723B666F6E742D73697A653A313370783B666F6E742D7765696768743A3530307D2E757070792D50726F766964657242726F777365722D666F6F7465727B616C69676E2D6974656D733A63656E74';
wwv_flow_imp.g_varchar2_table(365) := '65723B6261636B67726F756E642D636F6C6F723A236666663B626F726465722D746F703A31707820736F6C696420236561656165613B646973706C61793A666C65783B6865696768743A363570783B70616464696E673A3020313570787D5B6469723D6C';
wwv_flow_imp.g_varchar2_table(366) := '74725D202E757070792D50726F766964657242726F777365722D666F6F74657220627574746F6E7B6D617267696E2D72696768743A3870787D5B6469723D72746C5D202E757070792D50726F766964657242726F777365722D666F6F7465722062757474';
wwv_flow_imp.g_varchar2_table(367) := '6F6E7B6D617267696E2D6C6566743A3870787D5B646174612D757070792D7468656D653D6461726B5D202E757070792D50726F766964657242726F777365722D666F6F7465727B6261636B67726F756E642D636F6C6F723A233166316631663B626F7264';
wwv_flow_imp.g_varchar2_table(368) := '65722D746F703A31707820736F6C696420233333337D2E757070792D44617368626F6172642D4974656D2D70726576696577496E6E6572577261707B616C69676E2D6974656D733A63656E7465723B626F726465722D7261646975733A3370783B626F78';
wwv_flow_imp.g_varchar2_table(369) := '2D736861646F773A3020302032707820302023303030363B646973706C61793A666C65783B666C65782D646972656374696F6E3A636F6C756D6E3B6865696768743A313030253B6A7573746966792D636F6E74656E743A63656E7465723B6F766572666C';
wwv_flow_imp.g_varchar2_table(370) := '6F773A68696464656E3B706F736974696F6E3A72656C61746976653B77696474683A313030257D2E757070792D73697A652D2D6D64202E757070792D44617368626F6172642D4974656D2D70726576696577496E6E6572577261707B626F782D73686164';
wwv_flow_imp.g_varchar2_table(371) := '6F773A302031707820327078202330303030303032367D2E757070792D44617368626F6172642D2D73696E676C6546696C65202E757070792D44617368626F6172642D4974656D2D70726576696577496E6E6572577261707B626F782D736861646F773A';
wwv_flow_imp.g_varchar2_table(372) := '6E6F6E657D2E757070792D44617368626F6172642D4974656D2D70726576696577496E6E6572577261703A61667465727B6261636B67726F756E642D636F6C6F723A2330303030303061363B626F74746F6D3A303B636F6E74656E743A22223B64697370';
wwv_flow_imp.g_varchar2_table(373) := '6C61793A6E6F6E653B6C6566743A303B706F736974696F6E3A6162736F6C7574653B72696768743A303B746F703A303B7A2D696E6465783A313030317D2E757070792D44617368626F6172642D4974656D2D707265766965774C696E6B7B626F74746F6D';
wwv_flow_imp.g_varchar2_table(374) := '3A303B6C6566743A303B706F736974696F6E3A6162736F6C7574653B72696768743A303B746F703A303B7A2D696E6465783A313030327D2E757070792D44617368626F6172642D4974656D2D707265766965774C696E6B3A666F6375737B626F782D7368';
wwv_flow_imp.g_varchar2_table(375) := '61646F773A696E7365742030203020302033707820233537396466307D5B646174612D757070792D7468656D653D6461726B5D202E757070792D44617368626F6172642D4974656D2D707265766965774C696E6B3A666F6375737B626F782D736861646F';
wwv_flow_imp.g_varchar2_table(376) := '773A696E7365742030203020302033707820233031366338647D2E757070792D44617368626F6172642D4974656D2D7072657669657720696D672E757070792D44617368626F6172642D4974656D2D70726576696577496D677B626F726465722D726164';
wwv_flow_imp.g_varchar2_table(377) := '6975733A3370783B6865696768743A313030253B6F626A6563742D6669743A636F7665723B7472616E73666F726D3A7472616E736C6174655A2830293B77696474683A313030257D2E757070792D44617368626F6172642D2D73696E676C6546696C6520';
wwv_flow_imp.g_varchar2_table(378) := '2E757070792D44617368626F6172642D4974656D2D7072657669657720696D672E757070792D44617368626F6172642D4974656D2D70726576696577496D677B6865696768743A6175746F3B6D61782D6865696768743A313030253B6D61782D77696474';
wwv_flow_imp.g_varchar2_table(379) := '683A313030253B6F626A6563742D6669743A636F6E7461696E3B70616464696E673A313070783B77696474683A6175746F7D2E757070792D44617368626F6172642D4974656D2D70726F67726573737B636F6C6F723A236666663B6C6566743A3530253B';
wwv_flow_imp.g_varchar2_table(380) := '706F736974696F6E3A6162736F6C7574653B746578742D616C69676E3A63656E7465723B746F703A3530253B7472616E73666F726D3A7472616E736C617465282D3530252C2D353025293B7472616E736974696F6E3A616C6C202E333520656173653B77';
wwv_flow_imp.g_varchar2_table(381) := '696474683A31323070783B7A2D696E6465783A313030327D2E757070792D44617368626F6172642D4974656D2D70726F6772657373496E64696361746F727B636F6C6F723A236666663B646973706C61793A696E6C696E652D626C6F636B3B6865696768';
wwv_flow_imp.g_varchar2_table(382) := '743A333870783B6F7061636974793A2E393B77696474683A333870787D2E757070792D73697A652D2D6D64202E757070792D44617368626F6172642D4974656D2D70726F6772657373496E64696361746F727B6865696768743A353570783B7769647468';
wwv_flow_imp.g_varchar2_table(383) := '3A353570787D627574746F6E2E757070792D44617368626F6172642D4974656D2D70726F6772657373496E64696361746F727B637572736F723A706F696E7465727D627574746F6E2E757070792D44617368626F6172642D4974656D2D70726F67726573';
wwv_flow_imp.g_varchar2_table(384) := '73496E64696361746F723A666F6375737B6F75746C696E653A6E6F6E657D627574746F6E2E757070792D44617368626F6172642D4974656D2D70726F6772657373496E64696361746F723A3A2D6D6F7A2D666F6375732D696E6E65727B626F726465723A';
wwv_flow_imp.g_varchar2_table(385) := '307D627574746F6E2E757070792D44617368626F6172642D4974656D2D70726F6772657373496E64696361746F723A666F637573202E757070792D44617368626F6172642D4974656D2D70726F677265737349636F6E2D2D62672C627574746F6E2E7570';
wwv_flow_imp.g_varchar2_table(386) := '70792D44617368626F6172642D4974656D2D70726F6772657373496E64696361746F723A666F637573202E757070792D44617368626F6172642D4974656D2D70726F677265737349636F6E2D2D72657472797B66696C6C3A233537396466307D2E757070';
wwv_flow_imp.g_varchar2_table(387) := '792D44617368626F6172642D4974656D2D70726F677265737349636F6E2D2D636972636C657B6865696768743A313030253B77696474683A313030257D2E757070792D44617368626F6172642D4974656D2D70726F677265737349636F6E2D2D62677B73';
wwv_flow_imp.g_varchar2_table(388) := '74726F6B653A23666666367D2E757070792D44617368626F6172642D4974656D2D70726F677265737349636F6E2D2D70726F67726573737B7374726F6B653A236666663B7472616E736974696F6E3A7374726F6B652D646173686F6666736574202E3573';
wwv_flow_imp.g_varchar2_table(389) := '20656173652D6F75747D2E757070792D44617368626F6172642D4974656D2D70726F677265737349636F6E2D2D706C61797B66696C6C3A236666663B7374726F6B653A236666663B7472616E736974696F6E3A616C6C202E32737D2E757070792D446173';
wwv_flow_imp.g_varchar2_table(390) := '68626F6172642D4974656D2D70726F677265737349636F6E2D2D63616E63656C7B66696C6C3A236666663B7472616E736974696F6E3A616C6C202E32737D2E757070792D44617368626F6172642D4974656D2D70726F677265737349636F6E2D2D706175';
wwv_flow_imp.g_varchar2_table(391) := '73657B66696C6C3A236666663B7374726F6B653A236666663B7472616E736974696F6E3A616C6C202E32737D2E757070792D44617368626F6172642D4974656D2D70726F677265737349636F6E2D2D636865636B7B66696C6C3A236666663B7472616E73';
wwv_flow_imp.g_varchar2_table(392) := '6974696F6E3A616C6C202E32737D2E757070792D44617368626F6172642D4974656D2D70726F677265737349636F6E2D2D72657472797B66696C6C3A236666667D5B6469723D6C74725D202E757070792D44617368626F6172642D4974656D2E69732D63';
wwv_flow_imp.g_varchar2_table(393) := '6F6D706C657465202E757070792D44617368626F6172642D4974656D2D70726F67726573737B72696768743A2D3870787D5B6469723D72746C5D202E757070792D44617368626F6172642D4974656D2E69732D636F6D706C657465202E757070792D4461';
wwv_flow_imp.g_varchar2_table(394) := '7368626F6172642D4974656D2D70726F67726573737B6C6566743A2D3870787D5B6469723D6C74725D202E757070792D44617368626F6172642D4974656D2E69732D636F6D706C657465202E757070792D44617368626F6172642D4974656D2D70726F67';
wwv_flow_imp.g_varchar2_table(395) := '726573737B6C6566743A6175746F7D5B6469723D72746C5D202E757070792D44617368626F6172642D4974656D2E69732D636F6D706C657465202E757070792D44617368626F6172642D4974656D2D70726F67726573737B72696768743A6175746F7D2E';
wwv_flow_imp.g_varchar2_table(396) := '757070792D44617368626F6172642D4974656D2E69732D636F6D706C657465202E757070792D44617368626F6172642D4974656D2D70726F67726573737B746F703A2D3970783B7472616E73666F726D3A6E6F6E653B77696474683A6175746F7D2E7570';
wwv_flow_imp.g_varchar2_table(397) := '70792D44617368626F6172642D4974656D2E69732D6572726F72202E757070792D44617368626F6172642D4974656D2D70726F6772657373496E64696361746F727B6865696768743A313870783B77696474683A313870787D2E757070792D73697A652D';
wwv_flow_imp.g_varchar2_table(398) := '2D6D64202E757070792D44617368626F6172642D4974656D2E69732D6572726F72202E757070792D44617368626F6172642D4974656D2D70726F6772657373496E64696361746F727B6865696768743A323870783B77696474683A323870787D2E757070';
wwv_flow_imp.g_varchar2_table(399) := '792D44617368626F6172642D4974656D2E69732D636F6D706C657465202E757070792D44617368626F6172642D4974656D2D70726F6772657373496E64696361746F727B6865696768743A313870783B6F7061636974793A313B77696474683A31387078';
wwv_flow_imp.g_varchar2_table(400) := '7D2E757070792D73697A652D2D6D64202E757070792D44617368626F6172642D4974656D2E69732D636F6D706C657465202E757070792D44617368626F6172642D4974656D2D70726F6772657373496E64696361746F727B6865696768743A323270783B';
wwv_flow_imp.g_varchar2_table(401) := '77696474683A323270787D2E757070792D44617368626F6172642D4974656D2E69732D70726F63657373696E67202E757070792D44617368626F6172642D4974656D2D70726F67726573737B6F7061636974793A307D5B6469723D6C74725D202E757070';
wwv_flow_imp.g_varchar2_table(402) := '792D44617368626F6172642D4974656D2D66696C65496E666F7B70616464696E672D72696768743A3570787D5B6469723D72746C5D202E757070792D44617368626F6172642D4974656D2D66696C65496E666F7B70616464696E672D6C6566743A357078';
wwv_flow_imp.g_varchar2_table(403) := '7D5B6469723D6C74725D202E757070792D44617368626F6172642D2D73696E676C6546696C65202E757070792D44617368626F6172642D4974656D2D66696C65496E666F7B70616464696E672D72696768743A313070787D5B6469723D72746C5D202E75';
wwv_flow_imp.g_varchar2_table(404) := '7070792D44617368626F6172642D2D73696E676C6546696C65202E757070792D44617368626F6172642D4974656D2D66696C65496E666F7B70616464696E672D6C6566743A313070787D5B6469723D6C74725D202E757070792D73697A652D2D6D642E75';
wwv_flow_imp.g_varchar2_table(405) := '7070792D44617368626F6172642D2D73696E676C6546696C65202E757070792D44617368626F6172642D4974656D2D66696C65496E666F7B70616464696E672D72696768743A313570787D5B6469723D72746C5D202E757070792D73697A652D2D6D642E';
wwv_flow_imp.g_varchar2_table(406) := '757070792D44617368626F6172642D2D73696E676C6546696C65202E757070792D44617368626F6172642D4974656D2D66696C65496E666F7B70616464696E672D6C6566743A313570787D2E757070792D44617368626F6172642D4974656D2D6E616D65';
wwv_flow_imp.g_varchar2_table(407) := '7B776F72642D777261703A616E7977686572653B666F6E742D73697A653A313270783B666F6E742D7765696768743A3530303B6C696E652D6865696768743A312E333B6D617267696E2D626F74746F6D3A3570783B776F72642D627265616B3A62726561';
wwv_flow_imp.g_varchar2_table(408) := '6B2D616C6C7D5B646174612D757070792D7468656D653D6461726B5D202E757070792D44617368626F6172642D4974656D2D6E616D657B636F6C6F723A236561656165617D2E757070792D73697A652D2D6D642E757070792D44617368626F6172642D2D';
wwv_flow_imp.g_varchar2_table(409) := '73696E676C6546696C65202E757070792D44617368626F6172642D4974656D2D6E616D657B666F6E742D73697A653A313470783B6C696E652D6865696768743A312E347D2E757070792D44617368626F6172642D4974656D2D66696C654E616D657B616C';
wwv_flow_imp.g_varchar2_table(410) := '69676E2D6974656D733A626173656C696E653B646973706C61793A666C65787D2E757070792D44617368626F6172642D4974656D2D66696C654E616D6520627574746F6E7B6D617267696E2D6C6566743A3570787D2E757070792D44617368626F617264';
wwv_flow_imp.g_varchar2_table(411) := '2D4974656D2D617574686F727B636F6C6F723A233735373537353B646973706C61793A696E6C696E652D626C6F636B3B666F6E742D73697A653A313170783B666F6E742D7765696768743A3430303B6C696E652D6865696768743A313B6D617267696E2D';
wwv_flow_imp.g_varchar2_table(412) := '626F74746F6D3A3570783B766572746963616C2D616C69676E3A626F74746F6D7D2E757070792D44617368626F6172642D4974656D2D617574686F7220617B636F6C6F723A233735373537357D2E757070792D44617368626F6172642D4974656D2D7374';
wwv_flow_imp.g_varchar2_table(413) := '617475737B636F6C6F723A233735373537353B666F6E742D73697A653A313170783B666F6E742D7765696768743A3430303B6C696E652D6865696768743A317D5B646174612D757070792D7468656D653D6461726B5D202E757070792D44617368626F61';
wwv_flow_imp.g_varchar2_table(414) := '72642D4974656D2D7374617475737B636F6C6F723A236262627D2E757070792D44617368626F6172642D4974656D2D73746174757353697A657B646973706C61793A696E6C696E652D626C6F636B3B6D617267696E2D626F74746F6D3A3570783B746578';
wwv_flow_imp.g_varchar2_table(415) := '742D7472616E73666F726D3A7570706572636173653B766572746963616C2D616C69676E3A626F74746F6D7D2E757070792D44617368626F6172642D4974656D2D726553656C6563747B636F6C6F723A233132363963663B666F6E742D66616D696C793A';
wwv_flow_imp.g_varchar2_table(416) := '696E68657269743B666F6E742D73697A653A696E68657269743B666F6E742D7765696768743A3630307D2E757070792D44617368626F6172642D4974656D2D6572726F724D6573736167657B6261636B67726F756E642D636F6C6F723A23666465666631';
wwv_flow_imp.g_varchar2_table(417) := '3B636F6C6F723A236135313532333B666F6E742D73697A653A313170783B666F6E742D7765696768743A3530303B6C696E652D6865696768743A312E333B70616464696E673A357078203670787D2E757070792D44617368626F6172642D4974656D2D65';
wwv_flow_imp.g_varchar2_table(418) := '72726F724D65737361676542746E7B636F6C6F723A236135313532333B637572736F723A706F696E7465723B666F6E742D73697A653A313170783B666F6E742D7765696768743A3530303B746578742D6465636F726174696F6E3A756E6465726C696E65';
wwv_flow_imp.g_varchar2_table(419) := '7D2E757070792D44617368626F6172642D4974656D2D70726576696577202E757070792D44617368626F6172642D4974656D2D6572726F724D6573736167657B646973706C61793A6E6F6E657D2E757070792D73697A652D2D6D64202E757070792D4461';
wwv_flow_imp.g_varchar2_table(420) := '7368626F6172642D4974656D2D70726576696577202E757070792D44617368626F6172642D4974656D2D6572726F724D6573736167657B626F726465722D626F74746F6D2D6C6566742D7261646975733A3370783B626F726465722D626F74746F6D2D72';
wwv_flow_imp.g_varchar2_table(421) := '696768742D7261646975733A3370783B626F726465722D746F703A31707820736F6C696420236637633263383B626F74746F6D3A303B646973706C61793A626C6F636B3B6C6566743A303B6C696E652D6865696768743A312E343B70616464696E673A36';
wwv_flow_imp.g_varchar2_table(422) := '7078203870783B706F736974696F6E3A6162736F6C7574653B72696768743A307D2E757070792D44617368626F6172642D4974656D2D66696C65496E666F202E757070792D44617368626F6172642D4974656D2D6572726F724D6573736167657B626F72';
wwv_flow_imp.g_varchar2_table(423) := '6465723A31707820736F6C696420236637633263383B626F726465722D7261646975733A3370783B646973706C61793A696E6C696E652D626C6F636B3B706F736974696F6E3A7374617469637D2E757070792D73697A652D2D6D64202E757070792D4461';
wwv_flow_imp.g_varchar2_table(424) := '7368626F6172642D4974656D2D66696C65496E666F202E757070792D44617368626F6172642D4974656D2D6572726F724D6573736167657B646973706C61793A6E6F6E657D2E757070792D44617368626F6172642D4974656D2D616374696F6E7B636F6C';
wwv_flow_imp.g_varchar2_table(425) := '6F723A233933393339333B637572736F723A706F696E7465727D2E757070792D44617368626F6172642D4974656D2D616374696F6E3A666F6375737B6F75746C696E653A6E6F6E657D2E757070792D44617368626F6172642D4974656D2D616374696F6E';
wwv_flow_imp.g_varchar2_table(426) := '3A3A2D6D6F7A2D666F6375732D696E6E65727B626F726465723A307D2E757070792D44617368626F6172642D4974656D2D616374696F6E3A666F6375737B626F782D736861646F773A302030203020337078202331323639636638307D2E757070792D44';
wwv_flow_imp.g_varchar2_table(427) := '617368626F6172642D4974656D2D616374696F6E3A686F7665727B636F6C6F723A233166316631663B6F7061636974793A317D5B646174612D757070792D7468656D653D6461726B5D202E757070792D44617368626F6172642D4974656D2D616374696F';
wwv_flow_imp.g_varchar2_table(428) := '6E7B636F6C6F723A236366636663667D5B646174612D757070792D7468656D653D6461726B5D202E757070792D44617368626F6172642D4974656D2D616374696F6E3A666F6375737B6F75746C696E653A6E6F6E657D5B646174612D757070792D746865';
wwv_flow_imp.g_varchar2_table(429) := '6D653D6461726B5D202E757070792D44617368626F6172642D4974656D2D616374696F6E3A3A2D6D6F7A2D666F6375732D696E6E65727B626F726465723A307D5B646174612D757070792D7468656D653D6461726B5D202E757070792D44617368626F61';
wwv_flow_imp.g_varchar2_table(430) := '72642D4974656D2D616374696F6E3A666F6375737B626F782D736861646F773A302030203020327078202361616531666664397D5B646174612D757070792D7468656D653D6461726B5D202E757070792D44617368626F6172642D4974656D2D61637469';
wwv_flow_imp.g_varchar2_table(431) := '6F6E3A686F7665727B636F6C6F723A236561656165617D2E757070792D44617368626F6172642D4974656D2D616374696F6E2D2D72656D6F76657B636F6C6F723A233166316631663B6F7061636974793A2E39357D2E757070792D44617368626F617264';
wwv_flow_imp.g_varchar2_table(432) := '2D4974656D2D616374696F6E2D2D72656D6F76653A686F7665727B636F6C6F723A233030303B6F7061636974793A317D5B6469723D6C74725D202E757070792D73697A652D2D6D64202E757070792D44617368626F6172642D4974656D2D616374696F6E';
wwv_flow_imp.g_varchar2_table(433) := '2D2D72656D6F76657B72696768743A2D3870787D5B6469723D72746C5D202E757070792D73697A652D2D6D64202E757070792D44617368626F6172642D4974656D2D616374696F6E2D2D72656D6F76657B6C6566743A2D3870787D2E757070792D73697A';
wwv_flow_imp.g_varchar2_table(434) := '652D2D6D64202E757070792D44617368626F6172642D4974656D2D616374696F6E2D2D72656D6F76657B6865696768743A313870783B70616464696E673A303B706F736974696F6E3A6162736F6C7574653B746F703A2D3870783B77696474683A313870';
wwv_flow_imp.g_varchar2_table(435) := '783B7A2D696E6465783A313030327D2E757070792D73697A652D2D6D64202E757070792D44617368626F6172642D4974656D2D616374696F6E2D2D72656D6F76653A666F6375737B626F726465722D7261646975733A3530257D5B6469723D6C74725D20';
wwv_flow_imp.g_varchar2_table(436) := '2E757070792D44617368626F6172642D2D73696E676C6546696C652E757070792D73697A652D2D6865696768742D6D64202E757070792D44617368626F6172642D4974656D2D616374696F6E2D2D72656D6F76657B72696768743A3870787D5B6469723D';
wwv_flow_imp.g_varchar2_table(437) := '72746C5D202E757070792D44617368626F6172642D2D73696E676C6546696C652E757070792D73697A652D2D6865696768742D6D64202E757070792D44617368626F6172642D4974656D2D616374696F6E2D2D72656D6F76657B6C6566743A3870787D2E';
wwv_flow_imp.g_varchar2_table(438) := '757070792D44617368626F6172642D2D73696E676C6546696C652E757070792D73697A652D2D6865696768742D6D64202E757070792D44617368626F6172642D4974656D2D616374696F6E2D2D72656D6F76657B706F736974696F6E3A6162736F6C7574';
wwv_flow_imp.g_varchar2_table(439) := '653B746F703A3870787D5B646174612D757070792D7468656D653D6461726B5D202E757070792D44617368626F6172642D4974656D2D616374696F6E2D2D72656D6F76657B636F6C6F723A233532353235327D5B646174612D757070792D7468656D653D';
wwv_flow_imp.g_varchar2_table(440) := '6461726B5D202E757070792D44617368626F6172642D4974656D2D616374696F6E2D2D72656D6F76653A686F7665727B636F6C6F723A233333337D2E757070792D44617368626F6172643A6E6F74282E757070792D73697A652D2D6D64293A6E6F74282E';
wwv_flow_imp.g_varchar2_table(441) := '757070792D44617368626F6172642D2D73696E676C6546696C652E757070792D73697A652D2D6865696768742D6D6429202E757070792D44617368626F6172642D4974656D2D616374696F6E577261707065727B616C69676E2D6974656D733A63656E74';
wwv_flow_imp.g_varchar2_table(442) := '65723B646973706C61793A666C65787D2E757070792D44617368626F6172643A6E6F74282E757070792D73697A652D2D6D64293A6E6F74282E757070792D44617368626F6172642D2D73696E676C6546696C652E757070792D73697A652D2D6865696768';
wwv_flow_imp.g_varchar2_table(443) := '742D6D6429202E757070792D44617368626F6172642D4974656D2D616374696F6E7B6865696768743A323270783B6D617267696E2D6C6566743A3370783B70616464696E673A3370783B77696474683A323270787D2E757070792D44617368626F617264';
wwv_flow_imp.g_varchar2_table(444) := '3A6E6F74282E757070792D73697A652D2D6D64293A6E6F74282E757070792D44617368626F6172642D2D73696E676C6546696C652E757070792D73697A652D2D6865696768742D6D6429202E757070792D44617368626F6172642D4974656D2D61637469';
wwv_flow_imp.g_varchar2_table(445) := '6F6E3A666F6375737B626F726465722D7261646975733A3370787D2E757070792D73697A652D2D6D64202E757070792D44617368626F6172642D4974656D2D616374696F6E2D2D636F70794C696E6B2C2E757070792D73697A652D2D6D64202E75707079';
wwv_flow_imp.g_varchar2_table(446) := '2D44617368626F6172642D4974656D2D616374696F6E2D2D656469747B6865696768743A313670783B70616464696E673A303B77696474683A313670787D2E757070792D73697A652D2D6D64202E757070792D44617368626F6172642D4974656D2D6163';
wwv_flow_imp.g_varchar2_table(447) := '74696F6E2D2D636F70794C696E6B3A666F6375732C2E757070792D73697A652D2D6D64202E757070792D44617368626F6172642D4974656D2D616374696F6E2D2D656469743A666F6375737B626F726465722D7261646975733A3370787D2E757070792D';
wwv_flow_imp.g_varchar2_table(448) := '44617368626F6172642D4974656D7B616C69676E2D6974656D733A63656E7465723B626F726465722D626F74746F6D3A31707820736F6C696420236561656165613B646973706C61793A666C65783B70616464696E673A313070787D5B6469723D6C7472';
wwv_flow_imp.g_varchar2_table(449) := '5D202E757070792D44617368626F6172643A6E6F74282E757070792D44617368626F6172642D2D73696E676C6546696C6529202E757070792D44617368626F6172642D4974656D7B70616464696E672D72696768743A307D5B6469723D72746C5D202E75';
wwv_flow_imp.g_varchar2_table(450) := '7070792D44617368626F6172643A6E6F74282E757070792D44617368626F6172642D2D73696E676C6546696C6529202E757070792D44617368626F6172642D4974656D7B70616464696E672D6C6566743A307D5B646174612D757070792D7468656D653D';
wwv_flow_imp.g_varchar2_table(451) := '6461726B5D202E757070792D44617368626F6172642D4974656D7B626F726465722D626F74746F6D3A31707820736F6C696420233333337D5B6469723D6C74725D202E757070792D73697A652D2D6D64202E757070792D44617368626F6172642D497465';
wwv_flow_imp.g_varchar2_table(452) := '6D7B666C6F61743A6C6566747D5B6469723D72746C5D202E757070792D73697A652D2D6D64202E757070792D44617368626F6172642D4974656D7B666C6F61743A72696768747D2E757070792D73697A652D2D6D64202E757070792D44617368626F6172';
wwv_flow_imp.g_varchar2_table(453) := '642D4974656D7B626F726465722D626F74746F6D3A303B646973706C61793A626C6F636B3B6865696768743A32313570783B6D617267696E3A35707820313570783B70616464696E673A303B706F736974696F6E3A72656C61746976653B77696474683A';
wwv_flow_imp.g_varchar2_table(454) := '63616C632833332E33333325202D2033307078297D2E757070792D73697A652D2D6C67202E757070792D44617368626F6172642D4974656D7B6865696768743A31393070783B6D617267696E3A35707820313570783B70616464696E673A303B77696474';
wwv_flow_imp.g_varchar2_table(455) := '683A63616C6328323525202D2033307078297D2E757070792D73697A652D2D786C202E757070792D44617368626F6172642D4974656D7B6865696768743A32313070783B70616464696E673A303B77696474683A63616C6328323025202D203330707829';
wwv_flow_imp.g_varchar2_table(456) := '7D2E757070792D44617368626F6172642D2D73696E676C6546696C65202E757070792D44617368626F6172642D4974656D7B626F726465722D626F74746F6D3A303B646973706C61793A666C65783B666C65782D646972656374696F6E3A636F6C756D6E';
wwv_flow_imp.g_varchar2_table(457) := '3B6865696768743A313030253B6D61782D77696474683A34303070783B70616464696E673A313570783B706F736974696F6E3A72656C61746976653B77696474683A313030257D2E757070792D44617368626F6172642D4974656D2E69732D67686F7374';
wwv_flow_imp.g_varchar2_table(458) := '202E757070792D44617368626F6172642D4974656D2D70726576696577496E6E6572577261707B6F7061636974793A2E327D2E757070792D44617368626F6172642D4974656D2E69732D67686F7374202E757070792D44617368626F6172642D4974656D';
wwv_flow_imp.g_varchar2_table(459) := '2D6E616D657B6F7061636974793A2E377D2E757070792D44617368626F6172642D4974656D2E69732D67686F7374202E757070792D44617368626F6172642D4974656D2D707265766965773A6265666F72657B6261636B67726F756E642D696D6167653A';
wwv_flow_imp.g_varchar2_table(460) := '75726C2822646174613A696D6167652F7376672B786D6C3B636861727365743D7574662D382C25334373766720786D6C6E733D27687474703A2F2F7777772E77332E6F72672F323030302F737667272077696474683D27333527206865696768743D2733';
wwv_flow_imp.g_varchar2_table(461) := '39272533452533437061746820643D274D312E3730382033382E363663312E373039203020332E3431372D332E34313720362E3833342D332E34313720332E343136203020352E31323520332E34313720382E363120332E34313720332E333438203020';
wwv_flow_imp.g_varchar2_table(462) := '352E3035362D332E34313720382E3437332D332E34313720342E333035203020352E31323520332E34313720362E38333320332E3431372E383839203020312E3730392D2E38383920312E3730392D312E373039762D31392E36384333342E3136372D35';
wwv_flow_imp.g_varchar2_table(463) := '2E37353720302D352E37353720302031372E3237317631392E36386330202E38322E38383820312E37303920312E37303820312E3730397A6D382E3534322D31372E30383461332E33383320332E3338332030203020312D332E3431372D332E34313620';
wwv_flow_imp.g_varchar2_table(464) := '332E33383320332E33383320302030203120332E3431372D332E34313720332E33383320332E33383320302030203120332E34313720332E34313720332E33383320332E3338332030203020312D332E34313720332E3431367A6D31332E363637203041';
wwv_flow_imp.g_varchar2_table(465) := '332E33383320332E3338332030203020312032302E352031382E313661332E33383320332E33383320302030203120332E3431372D332E34313720332E33383320332E33383320302030203120332E34313620332E34313720332E33383320332E333833';
wwv_flow_imp.g_varchar2_table(466) := '2030203020312D332E34313620332E3431367A272066696C6C3D272532353233303030272F2533452533432F73766725334522293B6261636B67726F756E642D706F736974696F6E3A35302520313070783B6261636B67726F756E642D7265706561743A';
wwv_flow_imp.g_varchar2_table(467) := '6E6F2D7265706561743B6261636B67726F756E642D73697A653A323570783B626F74746F6D3A303B636F6E74656E743A22223B6C6566743A303B6F7061636974793A2E353B706F736974696F6E3A6162736F6C7574653B72696768743A303B746F703A30';
wwv_flow_imp.g_varchar2_table(468) := '3B7A2D696E6465783A313030357D2E757070792D73697A652D2D6D64202E757070792D44617368626F6172642D4974656D2E69732D67686F7374202E757070792D44617368626F6172642D4974656D2D707265766965773A6265666F72657B6261636B67';
wwv_flow_imp.g_varchar2_table(469) := '726F756E642D706F736974696F6E3A353025203530253B6261636B67726F756E642D73697A653A343070787D2E757070792D44617368626F6172642D2D73696E676C6546696C65202E757070792D44617368626F6172642D4974656D2E69732D67686F73';
wwv_flow_imp.g_varchar2_table(470) := '74202E757070792D44617368626F6172642D4974656D2D707265766965773A6265666F72657B6261636B67726F756E642D706F736974696F6E3A353025203530253B6261636B67726F756E642D73697A653A3330257D2E757070792D44617368626F6172';
wwv_flow_imp.g_varchar2_table(471) := '642D4974656D2D707265766965777B666C65782D67726F773A303B666C65782D736872696E6B3A303B6865696768743A353070783B706F736974696F6E3A72656C61746976653B77696474683A353070787D2E757070792D73697A652D2D6D64202E7570';
wwv_flow_imp.g_varchar2_table(472) := '70792D44617368626F6172642D4974656D2D707265766965777B6865696768743A31343070783B77696474683A313030257D2E757070792D73697A652D2D6C67202E757070792D44617368626F6172642D4974656D2D707265766965777B686569676874';
wwv_flow_imp.g_varchar2_table(473) := '3A31323070787D2E757070792D73697A652D2D786C202E757070792D44617368626F6172642D4974656D2D707265766965777B6865696768743A31343070787D2E757070792D44617368626F6172642D2D73696E676C6546696C65202E757070792D4461';
wwv_flow_imp.g_varchar2_table(474) := '7368626F6172642D4974656D2D707265766965777B666C65782D67726F773A313B6D61782D6865696768743A3735253B77696474683A313030257D2E757070792D44617368626F6172642D2D73696E676C6546696C652E757070792D73697A652D2D6D64';
wwv_flow_imp.g_varchar2_table(475) := '202E757070792D44617368626F6172642D4974656D2D707265766965777B6D61782D6865696768743A313030257D5B6469723D6C74725D202E757070792D44617368626F6172642D4974656D2D66696C65496E666F416E64427574746F6E737B70616464';
wwv_flow_imp.g_varchar2_table(476) := '696E672D72696768743A3870787D5B6469723D72746C5D202E757070792D44617368626F6172642D4974656D2D66696C65496E666F416E64427574746F6E737B70616464696E672D6C6566743A3870787D5B6469723D6C74725D202E757070792D446173';
wwv_flow_imp.g_varchar2_table(477) := '68626F6172642D4974656D2D66696C65496E666F416E64427574746F6E737B70616464696E672D6C6566743A313270787D5B6469723D72746C5D202E757070792D44617368626F6172642D4974656D2D66696C65496E666F416E64427574746F6E737B70';
wwv_flow_imp.g_varchar2_table(478) := '616464696E672D72696768743A313270787D2E757070792D44617368626F6172642D4974656D2D66696C65496E666F416E64427574746F6E737B616C69676E2D6974656D733A63656E7465723B646973706C61793A666C65783B666C65782D67726F773A';
wwv_flow_imp.g_varchar2_table(479) := '313B6A7573746966792D636F6E74656E743A73706163652D6265747765656E7D2E757070792D44617368626F6172642D2D73696E676C6546696C65202E757070792D44617368626F6172642D4974656D2D66696C65496E666F416E64427574746F6E732C';
wwv_flow_imp.g_varchar2_table(480) := '2E757070792D73697A652D2D6D64202E757070792D44617368626F6172642D4974656D2D66696C65496E666F416E64427574746F6E737B616C69676E2D6974656D733A666C65782D73746172743B70616464696E673A397078203020307D2E757070792D';
wwv_flow_imp.g_varchar2_table(481) := '44617368626F6172642D2D73696E676C6546696C65202E757070792D44617368626F6172642D4974656D2D66696C65496E666F416E64427574746F6E737B666C65782D67726F773A303B77696474683A313030257D2E757070792D44617368626F617264';
wwv_flow_imp.g_varchar2_table(482) := '2D4974656D2D66696C65496E666F7B666C65782D67726F773A313B666C65782D736872696E6B3A317D2E757070792D44617368626F6172642D4974656D2D616374696F6E577261707065727B666C65782D67726F773A303B666C65782D736872696E6B3A';
wwv_flow_imp.g_varchar2_table(483) := '307D2E757070792D44617368626F6172642D4974656D2E69732D6572726F72202E757070792D44617368626F6172642D4974656D2D70726576696577496E6E6572577261703A61667465722C2E757070792D44617368626F6172642D4974656D2E69732D';
wwv_flow_imp.g_varchar2_table(484) := '696E70726F6772657373202E757070792D44617368626F6172642D4974656D2D70726576696577496E6E6572577261703A61667465727B646973706C61793A626C6F636B7D2E757070792D44617368626F6172642D4974656D2E69732D696E70726F6772';
wwv_flow_imp.g_varchar2_table(485) := '6573733A6E6F74282E69732D726573756D61626C6529202E757070792D44617368626F6172642D4974656D2D616374696F6E2D2D72656D6F76657B646973706C61793A6E6F6E657D5B6469723D6C74725D202E757070792D44617368626F6172642D4974';
wwv_flow_imp.g_varchar2_table(486) := '656D2D6572726F7244657461696C737B6C6566743A3270787D5B6469723D72746C5D202E757070792D44617368626F6172642D4974656D2D6572726F7244657461696C737B72696768743A3270787D2E757070792D44617368626F6172642D4974656D2D';
wwv_flow_imp.g_varchar2_table(487) := '6572726F7244657461696C737B2D7765626B69742D617070656172616E63653A6E6F6E653B617070656172616E63653A6E6F6E653B6261636B67726F756E642D636F6C6F723A233933393339333B626F726465723A6E6F6E653B626F726465722D726164';
wwv_flow_imp.g_varchar2_table(488) := '6975733A3530253B636F6C6F723A236666663B637572736F723A68656C703B666C65782D736872696E6B3A303B666F6E742D73697A653A313070783B666F6E742D7765696768743A3630303B6865696768743A313370783B6C696E652D6865696768743A';
wwv_flow_imp.g_varchar2_table(489) := '313270783B706F736974696F6E3A72656C61746976653B746578742D616C69676E3A63656E7465723B746F703A303B77696474683A313370787D2E757070792D44617368626F6172642D4974656D2D6572726F7244657461696C733A61667465727B776F';
wwv_flow_imp.g_varchar2_table(490) := '72642D777261703A627265616B2D776F72643B6C696E652D6865696768743A312E337D2E757070792D44617368626F6172642D46696C65436172647B6261636B67726F756E642D636F6C6F723A236666663B626F726465722D7261646975733A3570783B';
wwv_flow_imp.g_varchar2_table(491) := '626F74746F6D3A303B626F782D736861646F773A302030203130707820347078202330303030303031613B646973706C61793A666C65783B666C65782D646972656374696F6E3A636F6C756D6E3B6865696768743A313030253B6C6566743A303B706F73';
wwv_flow_imp.g_varchar2_table(492) := '6974696F6E3A6162736F6C7574653B72696768743A303B746F703A303B77696474683A313030253B7A2D696E6465783A313030357D2E757070792D44617368626F6172642D46696C6543617264202E757070792D44617368626F617264436F6E74656E74';
wwv_flow_imp.g_varchar2_table(493) := '2D6261727B626F726465722D746F702D6C6566742D7261646975733A3570783B626F726465722D746F702D72696768742D7261646975733A3570787D2E757070792D44617368626F6172642D46696C6543617264202E757070792D44617368626F617264';
wwv_flow_imp.g_varchar2_table(494) := '2D46696C65436172642D616374696F6E737B626F726465722D626F74746F6D2D6C6566742D7261646975733A3570783B626F726465722D626F74746F6D2D72696768742D7261646975733A3570787D2E757070792D44617368626F6172642D46696C6543';
wwv_flow_imp.g_varchar2_table(495) := '6172642D696E6E65727B646973706C61793A666C65783B666C65782D646972656374696F6E3A636F6C756D6E3B666C65782D67726F773A313B666C65782D736872696E6B3A313B6865696768743A313030253B6D696E2D6865696768743A307D2E757070';
wwv_flow_imp.g_varchar2_table(496) := '792D44617368626F6172642D46696C65436172642D707265766965777B616C69676E2D6974656D733A63656E7465723B626F726465722D626F74746F6D3A31707820736F6C696420236561656165613B646973706C61793A666C65783B666C65782D6772';
wwv_flow_imp.g_varchar2_table(497) := '6F773A303B666C65782D736872696E6B3A313B6865696768743A3630253B6A7573746966792D636F6E74656E743A63656E7465723B6D696E2D6865696768743A303B706F736974696F6E3A72656C61746976657D5B646174612D757070792D7468656D65';
wwv_flow_imp.g_varchar2_table(498) := '3D6461726B5D202E757070792D44617368626F6172642D46696C65436172642D707265766965777B6261636B67726F756E642D636F6C6F723A233333333B626F726465722D626F74746F6D3A307D2E757070792D44617368626F6172642D46696C654361';
wwv_flow_imp.g_varchar2_table(499) := '72642D7072657669657720696D672E757070792D44617368626F6172642D4974656D2D70726576696577496D677B626F726465722D7261646975733A3370783B626F782D736861646F773A30203370782032307078202330303030303032363B666C6578';
wwv_flow_imp.g_varchar2_table(500) := '3A302030206175746F3B6D61782D6865696768743A3930253B6D61782D77696474683A3930253B6F626A6563742D6669743A636F7665727D5B6469723D6C74725D202E757070792D44617368626F6172642D46696C65436172642D656469747B72696768';
wwv_flow_imp.g_varchar2_table(501) := '743A313070787D5B6469723D72746C5D202E757070792D44617368626F6172642D46696C65436172642D656469747B6C6566743A313070787D2E757070792D44617368626F6172642D46696C65436172642D656469747B6261636B67726F756E642D636F';
wwv_flow_imp.g_varchar2_table(502) := '6C6F723A2330303030303038303B626F726465722D7261646975733A353070783B636F6C6F723A236666663B666F6E742D73697A653A313370783B70616464696E673A37707820313570783B706F736974696F6E3A6162736F6C7574653B746F703A3130';
wwv_flow_imp.g_varchar2_table(503) := '70787D2E757070792D44617368626F6172642D46696C65436172642D656469743A666F6375737B6F75746C696E653A6E6F6E657D2E757070792D44617368626F6172642D46696C65436172642D656469743A3A2D6D6F7A2D666F6375732D696E6E65727B';
wwv_flow_imp.g_varchar2_table(504) := '626F726465723A307D2E757070792D44617368626F6172642D46696C65436172642D656469743A666F6375737B626F782D736861646F773A302030203020337078202331323639636638307D2E757070792D44617368626F6172642D46696C6543617264';
wwv_flow_imp.g_varchar2_table(505) := '2D656469743A686F7665727B6261636B67726F756E642D636F6C6F723A23303030637D2E757070792D44617368626F6172642D46696C65436172642D696E666F7B2D7765626B69742D6F766572666C6F772D7363726F6C6C696E673A746F7563683B666C';
wwv_flow_imp.g_varchar2_table(506) := '65782D67726F773A303B666C65782D736872696E6B3A303B6865696768743A3430253B6F766572666C6F772D793A6175746F3B70616464696E673A33307078203230707820323070787D5B646174612D757070792D7468656D653D6461726B5D202E7570';
wwv_flow_imp.g_varchar2_table(507) := '70792D44617368626F6172642D46696C65436172642D696E666F7B6261636B67726F756E642D636F6C6F723A233166316631667D2E757070792D44617368626F6172642D46696C65436172642D6669656C647365747B626F726465723A303B666F6E742D';
wwv_flow_imp.g_varchar2_table(508) := '73697A653A303B6D617267696E3A6175746F206175746F20313270783B6D61782D77696474683A36343070783B70616464696E673A307D2E757070792D44617368626F6172642D46696C65436172642D6C6162656C7B636F6C6F723A233532353235323B';
wwv_flow_imp.g_varchar2_table(509) := '646973706C61793A696E6C696E652D626C6F636B3B666F6E742D73697A653A313270783B766572746963616C2D616C69676E3A6D6964646C653B77696474683A3232257D2E757070792D73697A652D2D6D64202E757070792D44617368626F6172642D46';
wwv_flow_imp.g_varchar2_table(510) := '696C65436172642D6C6162656C7B666F6E742D73697A653A313470787D5B646174612D757070792D7468656D653D6461726B5D202E757070792D44617368626F6172642D46696C65436172642D6C6162656C7B636F6C6F723A236561656165617D2E7570';
wwv_flow_imp.g_varchar2_table(511) := '70792D44617368626F6172642D46696C65436172642D696E7075747B646973706C61793A696E6C696E652D626C6F636B3B766572746963616C2D616C69676E3A6D6964646C653B77696474683A3738257D2E757070792D44617368626F6172642D46696C';
wwv_flow_imp.g_varchar2_table(512) := '65436172642D616374696F6E737B616C69676E2D6974656D733A63656E7465723B6261636B67726F756E642D636F6C6F723A236661666166613B626F726465722D746F703A31707820736F6C696420236561656165613B646973706C61793A666C65783B';
wwv_flow_imp.g_varchar2_table(513) := '666C65782D67726F773A303B666C65782D736872696E6B3A303B6865696768743A353570783B70616464696E673A3020313570787D2E757070792D73697A652D2D6D64202E757070792D44617368626F6172642D46696C65436172642D616374696F6E73';
wwv_flow_imp.g_varchar2_table(514) := '7B6865696768743A363570787D5B646174612D757070792D7468656D653D6461726B5D202E757070792D44617368626F6172642D46696C65436172642D616374696F6E737B6261636B67726F756E642D636F6C6F723A233166316631663B626F72646572';
wwv_flow_imp.g_varchar2_table(515) := '2D746F703A31707820736F6C696420233333337D5B6469723D6C74725D202E757070792D44617368626F6172642D46696C65436172642D616374696F6E7342746E7B6D617267696E2D72696768743A313070787D5B6469723D72746C5D202E757070792D';
wwv_flow_imp.g_varchar2_table(516) := '44617368626F6172642D46696C65436172642D616374696F6E7342746E7B6D617267696E2D6C6566743A313070787D2E757070792D7472616E736974696F6E2D736C696465446F776E55702D656E7465727B6F7061636974793A2E30313B7472616E7366';
wwv_flow_imp.g_varchar2_table(517) := '6F726D3A7472616E736C617465336428302C2D313035252C30293B7472616E736974696F6E3A7472616E73666F726D202E32357320656173652D696E2D6F75742C6F706163697479202E32357320656173652D696E2D6F75747D2E757070792D7472616E';
wwv_flow_imp.g_varchar2_table(518) := '736974696F6E2D736C696465446F776E55702D656E7465722E757070792D7472616E736974696F6E2D736C696465446F776E55702D656E7465722D6163746976657B6F7061636974793A313B7472616E73666F726D3A7472616E736C6174655A2830297D';
wwv_flow_imp.g_varchar2_table(519) := '2E757070792D7472616E736974696F6E2D736C696465446F776E55702D6C656176657B6F7061636974793A313B7472616E73666F726D3A7472616E736C6174655A2830293B7472616E736974696F6E3A7472616E73666F726D202E32357320656173652D';
wwv_flow_imp.g_varchar2_table(520) := '696E2D6F75742C6F706163697479202E32357320656173652D696E2D6F75747D2E757070792D7472616E736974696F6E2D736C696465446F776E55702D6C656176652E757070792D7472616E736974696F6E2D736C696465446F776E55702D6C65617665';
wwv_flow_imp.g_varchar2_table(521) := '2D6163746976657B6F7061636974793A2E30313B7472616E73666F726D3A7472616E736C617465336428302C2D313035252C30297D406B65796672616D657320757070792D44617368626F6172642D66616465496E7B30257B6F7061636974793A307D74';
wwv_flow_imp.g_varchar2_table(522) := '6F7B6F7061636974793A317D7D406B65796672616D657320757070792D44617368626F6172642D666164654F75747B30257B6F7061636974793A317D746F7B6F7061636974793A307D7D406B65796672616D657320757070792D44617368626F6172642D';
wwv_flow_imp.g_varchar2_table(523) := '736C696465446F776E416E6446616465496E7B30257B6F7061636974793A303B7472616E73666F726D3A7472616E736C6174653364282D3530252C2D3730252C30297D746F7B6F7061636974793A313B7472616E73666F726D3A7472616E736C61746533';
wwv_flow_imp.g_varchar2_table(524) := '64282D3530252C2D3530252C30297D7D406B65796672616D657320757070792D44617368626F6172642D736C696465446F776E416E6446616465496E2D2D736D616C6C7B30257B6F7061636974793A303B7472616E73666F726D3A7472616E736C617465';
wwv_flow_imp.g_varchar2_table(525) := '336428302C2D3230252C30297D746F7B6F7061636974793A313B7472616E73666F726D3A7472616E736C6174655A2830297D7D406B65796672616D657320757070792D44617368626F6172642D736C6964655570466164654F75747B30257B6F70616369';
wwv_flow_imp.g_varchar2_table(526) := '74793A313B7472616E73666F726D3A7472616E736C6174653364282D3530252C2D3530252C30297D746F7B6F7061636974793A303B7472616E73666F726D3A7472616E736C6174653364282D3530252C2D3730252C30297D7D406B65796672616D657320';
wwv_flow_imp.g_varchar2_table(527) := '757070792D44617368626F6172642D736C6964655570466164654F75742D2D736D616C6C7B30257B6F7061636974793A313B7472616E73666F726D3A7472616E736C6174655A2830297D746F7B6F7061636974793A303B7472616E73666F726D3A747261';
wwv_flow_imp.g_varchar2_table(528) := '6E736C617465336428302C2D3230252C30297D7D2E757070792D44617368626F6172642D2D6D6F64616C7B7A2D696E6465783A313030317D2E757070792D44617368626F6172642D2D6D6F64616C5B617269612D68696464656E3D747275655D7B646973';
wwv_flow_imp.g_varchar2_table(529) := '706C61793A6E6F6E657D2E757070792D44617368626F6172642D2D6D6F64616C2E757070792D44617368626F6172642D2D616E696D6174654F70656E436C6F73653E2E757070792D44617368626F6172642D696E6E65727B616E696D6174696F6E3A7570';
wwv_flow_imp.g_varchar2_table(530) := '70792D44617368626F6172642D736C696465446F776E416E6446616465496E2D2D736D616C6C202E33732063756269632D62657A69657228302C302C2E322C31297D406D65646961206F6E6C792073637265656E20616E6420286D696E2D77696474683A';
wwv_flow_imp.g_varchar2_table(531) := '3832307078297B2E757070792D44617368626F6172642D2D6D6F64616C2E757070792D44617368626F6172642D2D616E696D6174654F70656E436C6F73653E2E757070792D44617368626F6172642D696E6E65727B616E696D6174696F6E3A757070792D';
wwv_flow_imp.g_varchar2_table(532) := '44617368626F6172642D736C696465446F776E416E6446616465496E202E33732063756269632D62657A69657228302C302C2E322C31297D7D2E757070792D44617368626F6172642D2D6D6F64616C2E757070792D44617368626F6172642D2D616E696D';
wwv_flow_imp.g_varchar2_table(533) := '6174654F70656E436C6F73653E2E757070792D44617368626F6172642D6F7665726C61797B616E696D6174696F6E3A757070792D44617368626F6172642D66616465496E202E33732063756269632D62657A69657228302C302C2E322C31297D2E757070';
wwv_flow_imp.g_varchar2_table(534) := '792D44617368626F6172642D2D6D6F64616C2E757070792D44617368626F6172642D2D616E696D6174654F70656E436C6F73652E757070792D44617368626F6172642D2D6973436C6F73696E673E2E757070792D44617368626F6172642D696E6E65727B';
wwv_flow_imp.g_varchar2_table(535) := '616E696D6174696F6E3A757070792D44617368626F6172642D736C6964655570466164654F75742D2D736D616C6C202E33732063756269632D62657A69657228302C302C2E322C31297D406D65646961206F6E6C792073637265656E20616E6420286D69';
wwv_flow_imp.g_varchar2_table(536) := '6E2D77696474683A3832307078297B2E757070792D44617368626F6172642D2D6D6F64616C2E757070792D44617368626F6172642D2D616E696D6174654F70656E436C6F73652E757070792D44617368626F6172642D2D6973436C6F73696E673E2E7570';
wwv_flow_imp.g_varchar2_table(537) := '70792D44617368626F6172642D696E6E65727B616E696D6174696F6E3A757070792D44617368626F6172642D736C6964655570466164654F7574202E33732063756269632D62657A69657228302C302C2E322C31297D7D2E757070792D44617368626F61';
wwv_flow_imp.g_varchar2_table(538) := '72642D2D6D6F64616C2E757070792D44617368626F6172642D2D616E696D6174654F70656E436C6F73652E757070792D44617368626F6172642D2D6973436C6F73696E673E2E757070792D44617368626F6172642D6F7665726C61797B616E696D617469';
wwv_flow_imp.g_varchar2_table(539) := '6F6E3A757070792D44617368626F6172642D666164654F7574202E33732063756269632D62657A69657228302C302C2E322C31297D2E757070792D44617368626F6172642D697346697865647B6865696768743A31303076683B6F766572666C6F773A68';
wwv_flow_imp.g_varchar2_table(540) := '696464656E7D2E757070792D44617368626F6172642D2D6D6F64616C202E757070792D44617368626F6172642D6F7665726C61797B6261636B67726F756E642D636F6C6F723A2330303030303038303B626F74746F6D3A303B6C6566743A303B706F7369';
wwv_flow_imp.g_varchar2_table(541) := '74696F6E3A66697865643B72696768743A303B746F703A303B7A2D696E6465783A313030317D2E757070792D44617368626F6172642D696E6E65727B6261636B67726F756E642D636F6C6F723A236634663466343B626F726465723A31707820736F6C69';
wwv_flow_imp.g_varchar2_table(542) := '6420236561656165613B626F726465722D7261646975733A3570783B6D61782D6865696768743A313030253B6D61782D77696474683A313030253B6F75746C696E653A6E6F6E653B706F736974696F6E3A72656C61746976657D2E757070792D73697A65';
wwv_flow_imp.g_varchar2_table(543) := '2D2D6D64202E757070792D44617368626F6172642D696E6E65727B6D696E2D6865696768743A6175746F7D406D65646961206F6E6C792073637265656E20616E6420286D696E2D77696474683A3832307078297B2E757070792D44617368626F6172642D';
wwv_flow_imp.g_varchar2_table(544) := '696E6E65727B6865696768743A35303070783B77696474683A36353070787D7D2E757070792D44617368626F6172642D2D6D6F64616C202E757070792D44617368626F6172642D696E6E65727B7A2D696E6465783A313030327D5B646174612D75707079';
wwv_flow_imp.g_varchar2_table(545) := '2D7468656D653D6461726B5D202E757070792D44617368626F6172642D696E6E65727B6261636B67726F756E642D636F6C6F723A233166316631667D2E757070792D44617368626F6172642D2D697344697361626C6564202E757070792D44617368626F';
wwv_flow_imp.g_varchar2_table(546) := '6172642D696E6E65727B637572736F723A6E6F742D616C6C6F7765647D2E757070792D44617368626F6172642D696E6E6572577261707B626F726465722D7261646975733A3570783B646973706C61793A666C65783B666C65782D646972656374696F6E';
wwv_flow_imp.g_varchar2_table(547) := '3A636F6C756D6E3B6865696768743A313030253B6F7061636974793A303B6F766572666C6F773A68696464656E3B706F736974696F6E3A72656C61746976657D2E757070792D44617368626F6172642D2D6973496E6E65725772617056697369626C6520';
wwv_flow_imp.g_varchar2_table(548) := '2E757070792D44617368626F6172642D696E6E6572577261707B6F7061636974793A317D2E757070792D44617368626F6172642D2D697344697361626C6564202E757070792D44617368626F6172642D696E6E6572577261707B637572736F723A6E6F74';
wwv_flow_imp.g_varchar2_table(549) := '2D616C6C6F7765643B66696C7465723A677261797363616C652831303025293B6F7061636974793A2E363B2D7765626B69742D757365722D73656C6563743A6E6F6E653B757365722D73656C6563743A6E6F6E657D2E757070792D44617368626F617264';
wwv_flow_imp.g_varchar2_table(550) := '2D2D697344697361626C6564202E757070792D50726F766964657249636F6E42677B66696C6C3A233966396639667D2E757070792D44617368626F6172642D2D697344697361626C6564205B617269612D64697361626C65645D2C2E757070792D446173';
wwv_flow_imp.g_varchar2_table(551) := '68626F6172642D2D697344697361626C6564205B64697361626C65645D7B637572736F723A6E6F742D616C6C6F7765643B706F696E7465722D6576656E74733A6E6F6E657D2E757070792D44617368626F6172642D2D6D6F64616C202E757070792D4461';
wwv_flow_imp.g_varchar2_table(552) := '7368626F6172642D696E6E65727B626F726465723A6E6F6E653B626F74746F6D3A313570783B6C6566743A313570783B706F736974696F6E3A66697865643B72696768743A313570783B746F703A333570787D406D65646961206F6E6C79207363726565';
wwv_flow_imp.g_varchar2_table(553) := '6E20616E6420286D696E2D77696474683A3832307078297B2E757070792D44617368626F6172642D2D6D6F64616C202E757070792D44617368626F6172642D696E6E65727B626F782D736861646F773A3020357078203135707820347078202330303030';
wwv_flow_imp.g_varchar2_table(554) := '303032363B6C6566743A3530253B72696768743A6175746F3B746F703A3530253B7472616E73666F726D3A7472616E736C617465282D3530252C2D353025297D7D5B6469723D6C74725D202E757070792D44617368626F6172642D636C6F73657B726967';
wwv_flow_imp.g_varchar2_table(555) := '68743A2D3270787D5B6469723D72746C5D202E757070792D44617368626F6172642D636C6F73657B6C6566743A2D3270787D2E757070792D44617368626F6172642D636C6F73657B636F6C6F723A2366666666666665363B637572736F723A706F696E74';
wwv_flow_imp.g_varchar2_table(556) := '65723B646973706C61793A626C6F636B3B666F6E742D73697A653A323770783B706F736974696F6E3A6162736F6C7574653B746F703A2D333370783B7A2D696E6465783A313030357D2E757070792D44617368626F6172642D636C6F73653A666F637573';
wwv_flow_imp.g_varchar2_table(557) := '7B6F75746C696E653A6E6F6E657D2E757070792D44617368626F6172642D636C6F73653A3A2D6D6F7A2D666F6375732D696E6E65727B626F726465723A307D2E757070792D44617368626F6172642D636C6F73653A666F6375737B636F6C6F723A233665';
wwv_flow_imp.g_varchar2_table(558) := '616266327D406D65646961206F6E6C792073637265656E20616E6420286D696E2D77696474683A3832307078297B5B6469723D6C74725D202E757070792D44617368626F6172642D636C6F73657B72696768743A2D333570787D5B6469723D72746C5D20';
wwv_flow_imp.g_varchar2_table(559) := '2E757070792D44617368626F6172642D636C6F73657B6C6566743A2D333570787D2E757070792D44617368626F6172642D636C6F73657B666F6E742D73697A653A333570783B746F703A2D313070787D7D2E757070792D44617368626F6172642D736572';
wwv_flow_imp.g_varchar2_table(560) := '766963654D73677B6261636B67726F756E642D636F6C6F723A236666666266373B626F726465722D626F74746F6D3A31707820736F6C696420236564643462393B626F726465722D746F703A31707820736F6C696420236564643462393B666F6E742D73';
wwv_flow_imp.g_varchar2_table(561) := '697A653A313270783B666F6E742D7765696768743A3530303B6C696E652D6865696768743A312E333B70616464696E673A3132707820303B706F736974696F6E3A72656C61746976653B746F703A2D3170783B7A2D696E6465783A313030347D2E757070';
wwv_flow_imp.g_varchar2_table(562) := '792D73697A652D2D6D64202E757070792D44617368626F6172642D736572766963654D73677B666F6E742D73697A653A313470783B6C696E652D6865696768743A312E347D5B646174612D757070792D7468656D653D6461726B5D202E757070792D4461';
wwv_flow_imp.g_varchar2_table(563) := '7368626F6172642D736572766963654D73677B6261636B67726F756E642D636F6C6F723A233166316631663B626F726465722D626F74746F6D3A31707820736F6C696420233333333B626F726465722D746F703A31707820736F6C696420233333333B63';
wwv_flow_imp.g_varchar2_table(564) := '6F6C6F723A236561656165617D2E757070792D44617368626F6172642D736572766963654D73672D7469746C657B646973706C61793A626C6F636B3B6C696E652D6865696768743A313B6D617267696E2D626F74746F6D3A3470783B70616464696E672D';
wwv_flow_imp.g_varchar2_table(565) := '6C6566743A343270787D2E757070792D44617368626F6172642D736572766963654D73672D746578747B70616464696E673A3020313570787D2E757070792D44617368626F6172642D736572766963654D73672D616374696F6E42746E7B636F6C6F723A';
wwv_flow_imp.g_varchar2_table(566) := '233132363963663B666F6E742D73697A653A696E68657269743B666F6E742D7765696768743A696E68657269743B766572746963616C2D616C69676E3A696E697469616C7D5B646174612D757070792D7468656D653D6461726B5D202E757070792D4461';
wwv_flow_imp.g_varchar2_table(567) := '7368626F6172642D736572766963654D73672D616374696F6E42746E7B636F6C6F723A2330326261663265367D2E757070792D44617368626F6172642D736572766963654D73672D69636F6E7B6C6566743A313570783B706F736974696F6E3A6162736F';
wwv_flow_imp.g_varchar2_table(568) := '6C7574653B746F703A313070787D2E757070792D44617368626F6172642D41646446696C65737B616C69676E2D6974656D733A63656E7465723B646973706C61793A666C65783B666C65782D646972656374696F6E3A636F6C756D6E3B6865696768743A';
wwv_flow_imp.g_varchar2_table(569) := '313030253B6A7573746966792D636F6E74656E743A63656E7465723B706F736974696F6E3A72656C61746976653B746578742D616C69676E3A63656E7465727D5B646174612D757070792D647261672D64726F702D737570706F727465643D747275655D';
wwv_flow_imp.g_varchar2_table(570) := '202E757070792D44617368626F6172642D41646446696C65737B626F726465723A3170782064617368656420236466646664663B626F726465722D7261646975733A3370783B6865696768743A63616C632831303025202D2031347078293B6D61726769';
wwv_flow_imp.g_varchar2_table(571) := '6E3A3770787D2E757070792D44617368626F6172642D41646446696C657350616E656C202E757070792D44617368626F6172642D41646446696C65737B626F726465723A6E6F6E653B6865696768743A63616C632831303025202D2035347078297D2E75';
wwv_flow_imp.g_varchar2_table(572) := '7070792D44617368626F6172642D2D6D6F64616C202E757070792D44617368626F6172642D41646446696C65737B626F726465722D636F6C6F723A236366636663667D5B646174612D757070792D7468656D653D6461726B5D202E757070792D44617368';
wwv_flow_imp.g_varchar2_table(573) := '626F6172642D41646446696C65737B626F726465722D636F6C6F723A233735373537357D2E757070792D44617368626F6172642D41646446696C65732D696E666F7B646973706C61793A6E6F6E653B6D617267696E2D746F703A6175746F3B7061646469';
wwv_flow_imp.g_varchar2_table(574) := '6E672D626F74746F6D3A313570783B70616464696E672D746F703A313570787D2E757070792D73697A652D2D6865696768742D6D64202E757070792D44617368626F6172642D41646446696C65732D696E666F7B646973706C61793A626C6F636B7D2E75';
wwv_flow_imp.g_varchar2_table(575) := '7070792D73697A652D2D6D64202E757070792D44617368626F6172642D41646446696C65732D696E666F7B626F74746F6D3A323570783B6C6566743A303B70616464696E672D626F74746F6D3A303B70616464696E672D746F703A333070783B706F7369';
wwv_flow_imp.g_varchar2_table(576) := '74696F6E3A6162736F6C7574653B72696768743A307D5B646174612D757070792D6E756D2D6163717569726572733D2230225D202E757070792D44617368626F6172642D41646446696C65732D696E666F7B6D617267696E2D746F703A307D2E75707079';
wwv_flow_imp.g_varchar2_table(577) := '2D44617368626F6172642D62726F7773657B636F6C6F723A233132363963663B637572736F723A706F696E7465727D2E757070792D44617368626F6172642D62726F7773653A666F6375737B6F75746C696E653A6E6F6E657D2E757070792D4461736862';
wwv_flow_imp.g_varchar2_table(578) := '6F6172642D62726F7773653A3A2D6D6F7A2D666F6375732D696E6E65727B626F726465723A307D2E757070792D44617368626F6172642D62726F7773653A666F6375732C2E757070792D44617368626F6172642D62726F7773653A686F7665727B626F72';
wwv_flow_imp.g_varchar2_table(579) := '6465722D626F74746F6D3A31707820736F6C696420233132363963667D5B646174612D757070792D7468656D653D6461726B5D202E757070792D44617368626F6172642D62726F7773657B636F6C6F723A2330326261663265367D5B646174612D757070';
wwv_flow_imp.g_varchar2_table(580) := '792D7468656D653D6461726B5D202E757070792D44617368626F6172642D62726F7773653A666F6375732C5B646174612D757070792D7468656D653D6461726B5D202E757070792D44617368626F6172642D62726F7773653A686F7665727B626F726465';
wwv_flow_imp.g_varchar2_table(581) := '722D626F74746F6D3A31707820736F6C696420233032626166327D2E757070792D44617368626F6172642D62726F77736542746E7B646973706C61793A626C6F636B3B666F6E742D73697A653A313470783B666F6E742D7765696768743A3530303B6D61';
wwv_flow_imp.g_varchar2_table(582) := '7267696E2D626F74746F6D3A3570783B6D617267696E2D746F703A3870783B77696474683A313030257D2E757070792D73697A652D2D6D64202E757070792D44617368626F6172642D62726F77736542746E7B666F6E742D73697A653A313570783B6D61';
wwv_flow_imp.g_varchar2_table(583) := '7267696E3A31357078206175746F3B70616464696E673A3133707820343470783B77696474683A6175746F7D2E757070792D44617368626F6172642D41646446696C65732D6C6973747B2D7765626B69742D6F766572666C6F772D7363726F6C6C696E67';
wwv_flow_imp.g_varchar2_table(584) := '3A746F7563683B646973706C61793A666C65783B666C65783A313B666C65782D646972656374696F6E3A636F6C756D6E3B6D617267696E2D746F703A3270783B6F766572666C6F772D793A6175746F3B70616464696E673A32707820303B77696474683A';
wwv_flow_imp.g_varchar2_table(585) := '313030257D2E757070792D73697A652D2D6D64202E757070792D44617368626F6172642D41646446696C65732D6C6973747B666C65783A6E6F6E653B666C65782D646972656374696F6E3A726F773B666C65782D777261703A777261703B6A7573746966';
wwv_flow_imp.g_varchar2_table(586) := '792D636F6E74656E743A63656E7465723B6D617267696E2D746F703A313570783B6D61782D77696474683A36303070783B6F766572666C6F772D793A76697369626C653B70616464696E672D746F703A307D2E757070792D44617368626F617264546162';
wwv_flow_imp.g_varchar2_table(587) := '7B626F726465722D626F74746F6D3A31707820736F6C696420236561656165613B746578742D616C69676E3A63656E7465723B77696474683A313030257D5B646174612D757070792D7468656D653D6461726B5D202E757070792D44617368626F617264';
wwv_flow_imp.g_varchar2_table(588) := '5461627B626F726465722D626F74746F6D3A31707820736F6C696420233333337D2E757070792D73697A652D2D6D64202E757070792D44617368626F6172645461627B626F726465722D626F74746F6D3A6E6F6E653B646973706C61793A696E6C696E65';
wwv_flow_imp.g_varchar2_table(589) := '2D626C6F636B3B6D617267696E2D626F74746F6D3A313070783B77696474683A6175746F7D2E757070792D44617368626F6172645461622D62746E7B616C69676E2D6974656D733A63656E7465723B2D7765626B69742D617070656172616E63653A6E6F';
wwv_flow_imp.g_varchar2_table(590) := '6E653B617070656172616E63653A6E6F6E653B6261636B67726F756E642D636F6C6F723A696E697469616C3B636F6C6F723A233532353235323B637572736F723A706F696E7465723B666C65782D646972656374696F6E3A726F773B6865696768743A31';
wwv_flow_imp.g_varchar2_table(591) := '3030253B6A7573746966792D636F6E74656E743A6C6566743B70616464696E673A3132707820313570783B77696474683A313030257D2E757070792D44617368626F6172645461622D62746E3A666F6375737B6F75746C696E653A6E6F6E657D5B646972';
wwv_flow_imp.g_varchar2_table(592) := '3D6C74725D202E757070792D73697A652D2D6D64202E757070792D44617368626F6172645461622D62746E7B6D617267696E2D72696768743A3170787D5B6469723D72746C5D202E757070792D73697A652D2D6D64202E757070792D44617368626F6172';
wwv_flow_imp.g_varchar2_table(593) := '645461622D62746E7B6D617267696E2D6C6566743A3170787D2E757070792D73697A652D2D6D64202E757070792D44617368626F6172645461622D62746E7B626F726465722D7261646975733A3570783B666C65782D646972656374696F6E3A636F6C75';
wwv_flow_imp.g_varchar2_table(594) := '6D6E3B70616464696E673A31307078203370783B77696474683A383670787D5B646174612D757070792D7468656D653D6461726B5D202E757070792D44617368626F6172645461622D62746E7B636F6C6F723A236561656165617D2E757070792D446173';
wwv_flow_imp.g_varchar2_table(595) := '68626F6172645461622D62746E3A3A2D6D6F7A2D666F6375732D696E6E65727B626F726465723A307D2E757070792D44617368626F6172645461622D62746E3A686F7665727B6261636B67726F756E642D636F6C6F723A236539656365667D5B64617461';
wwv_flow_imp.g_varchar2_table(596) := '2D757070792D7468656D653D6461726B5D202E757070792D44617368626F6172645461622D62746E3A686F7665727B6261636B67726F756E642D636F6C6F723A233333337D2E757070792D44617368626F6172645461622D62746E3A6163746976652C2E';
wwv_flow_imp.g_varchar2_table(597) := '757070792D44617368626F6172645461622D62746E3A666F6375737B6261636B67726F756E642D636F6C6F723A236466653666317D5B646174612D757070792D7468656D653D6461726B5D202E757070792D44617368626F6172645461622D62746E3A61';
wwv_flow_imp.g_varchar2_table(598) := '63746976652C5B646174612D757070792D7468656D653D6461726B5D202E757070792D44617368626F6172645461622D62746E3A666F6375737B6261636B67726F756E642D636F6C6F723A233532353235327D2E757070792D44617368626F6172645461';
wwv_flow_imp.g_varchar2_table(599) := '622D62746E207376677B646973706C61793A696E6C696E652D626C6F636B3B6D61782D6865696768743A313030253B6D61782D77696474683A313030253B6F766572666C6F773A68696464656E3B7472616E736974696F6E3A7472616E73666F726D202E';
wwv_flow_imp.g_varchar2_table(600) := '31357320656173652D696E2D6F75743B766572746963616C2D616C69676E3A746578742D746F707D5B6469723D6C74725D202E757070792D44617368626F6172645461622D696E6E65727B6D617267696E2D72696768743A313070787D5B6469723D7274';
wwv_flow_imp.g_varchar2_table(601) := '6C5D202E757070792D44617368626F6172645461622D696E6E65727B6D617267696E2D6C6566743A313070787D2E757070792D44617368626F6172645461622D696E6E65727B616C69676E2D6974656D733A63656E7465723B6261636B67726F756E642D';
wwv_flow_imp.g_varchar2_table(602) := '636F6C6F723A236666663B626F726465722D7261646975733A3870783B626F782D736861646F773A3020317078203170782030202330303030303031612C3020317078203270782030202330303030303031612C30203270782033707820302023303030';
wwv_flow_imp.g_varchar2_table(603) := '30303030353B646973706C61793A666C65783B6865696768743A333270783B6A7573746966792D636F6E74656E743A63656E7465723B77696474683A333270787D5B6469723D6C74725D202E757070792D73697A652D2D6D64202E757070792D44617368';
wwv_flow_imp.g_varchar2_table(604) := '626F6172645461622D696E6E65727B6D617267696E2D72696768743A307D5B6469723D72746C5D202E757070792D73697A652D2D6D64202E757070792D44617368626F6172645461622D696E6E65727B6D617267696E2D6C6566743A307D5B646174612D';
wwv_flow_imp.g_varchar2_table(605) := '757070792D7468656D653D6461726B5D202E757070792D44617368626F6172645461622D696E6E65727B6261636B67726F756E642D636F6C6F723A233332333233323B626F782D736861646F773A30203170782031707820302023303030332C30203170';
wwv_flow_imp.g_varchar2_table(606) := '782032707820302023303030332C3020327078203370782030202330303030303031347D2E757070792D44617368626F6172645461622D6E616D657B666F6E742D73697A653A313470783B666F6E742D7765696768743A3430307D2E757070792D73697A';
wwv_flow_imp.g_varchar2_table(607) := '652D2D6D64202E757070792D44617368626F6172645461622D6E616D657B666F6E742D73697A653A313270783B6C696E652D6865696768743A313570783B6D617267696E2D626F74746F6D3A303B6D617267696E2D746F703A3870787D2E757070792D44';
wwv_flow_imp.g_varchar2_table(608) := '617368626F6172645461622D69636F6E4D794465766963657B636F6C6F723A233132363963667D5B646174612D757070792D7468656D653D6461726B5D202E757070792D44617368626F6172645461622D69636F6E4D794465766963657B636F6C6F723A';
wwv_flow_imp.g_varchar2_table(609) := '233032626166327D2E757070792D44617368626F6172645461622D69636F6E426F787B636F6C6F723A233030363164357D5B646174612D757070792D7468656D653D6461726B5D202E757070792D44617368626F6172645461622D69636F6E426F787B63';
wwv_flow_imp.g_varchar2_table(610) := '6F6C6F723A236561656165617D2E757070792D44617368626F6172645461622D69636F6E44726F70626F787B636F6C6F723A233030363166657D5B646174612D757070792D7468656D653D6461726B5D202E757070792D44617368626F6172645461622D';
wwv_flow_imp.g_varchar2_table(611) := '69636F6E44726F70626F787B636F6C6F723A236561656165617D2E757070792D44617368626F6172645461622D69636F6E556E73706C6173687B636F6C6F723A233131317D5B646174612D757070792D7468656D653D6461726B5D202E757070792D4461';
wwv_flow_imp.g_varchar2_table(612) := '7368626F6172645461622D69636F6E556E73706C6173687B636F6C6F723A236561656165617D2E757070792D44617368626F6172645461622D69636F6E53637265656E5265637B636F6C6F723A233263336535307D5B646174612D757070792D7468656D';
wwv_flow_imp.g_varchar2_table(613) := '653D6461726B5D202E757070792D44617368626F6172645461622D69636F6E53637265656E5265637B636F6C6F723A236561656165617D2E757070792D44617368626F6172645461622D69636F6E417564696F7B636F6C6F723A233830333061337D5B64';
wwv_flow_imp.g_varchar2_table(614) := '6174612D757070792D7468656D653D6461726B5D202E757070792D44617368626F6172645461622D69636F6E417564696F7B636F6C6F723A236266366565337D2E757070792D44617368626F6172642D696E7075747B6865696768743A2E3170783B6F70';
wwv_flow_imp.g_varchar2_table(615) := '61636974793A303B6F766572666C6F773A68696464656E3B706F736974696F6E3A6162736F6C7574653B77696474683A2E3170783B7A2D696E6465783A2D317D2E757070792D44617368626F617264436F6E74656E742D6261727B616C69676E2D697465';
wwv_flow_imp.g_varchar2_table(616) := '6D733A63656E7465723B6261636B67726F756E642D636F6C6F723A236661666166613B626F726465722D626F74746F6D3A31707820736F6C696420236561656165613B646973706C61793A666C65783B666C65782D736872696E6B3A303B686569676874';
wwv_flow_imp.g_varchar2_table(617) := '3A343070783B6A7573746966792D636F6E74656E743A73706163652D6265747765656E3B70616464696E673A3020313070783B706F736974696F6E3A72656C61746976653B77696474683A313030253B7A2D696E6465783A313030347D2E757070792D73';
wwv_flow_imp.g_varchar2_table(618) := '697A652D2D6D64202E757070792D44617368626F617264436F6E74656E742D6261727B6865696768743A353070783B70616464696E673A3020313570787D5B646174612D757070792D7468656D653D6461726B5D202E757070792D44617368626F617264';
wwv_flow_imp.g_varchar2_table(619) := '436F6E74656E742D6261727B6261636B67726F756E642D636F6C6F723A233166316631663B626F726465722D626F74746F6D3A31707820736F6C696420233333337D2E757070792D44617368626F617264436F6E74656E742D7469746C657B666F6E742D';
wwv_flow_imp.g_varchar2_table(620) := '73697A653A313270783B666F6E742D7765696768743A3530303B6C6566743A303B6C696E652D6865696768743A343070783B6D617267696E3A6175746F3B6D61782D77696474683A31373070783B6F766572666C6F772D783A68696464656E3B706F7369';
wwv_flow_imp.g_varchar2_table(621) := '74696F6E3A6162736F6C7574653B72696768743A303B746578742D616C69676E3A63656E7465723B746578742D6F766572666C6F773A656C6C69707369733B746F703A303B77686974652D73706163653A6E6F777261703B77696474683A313030257D2E';
wwv_flow_imp.g_varchar2_table(622) := '757070792D73697A652D2D6D64202E757070792D44617368626F617264436F6E74656E742D7469746C657B666F6E742D73697A653A313470783B6C696E652D6865696768743A353070783B6D61782D77696474683A33303070787D5B646174612D757070';
wwv_flow_imp.g_varchar2_table(623) := '792D7468656D653D6461726B5D202E757070792D44617368626F617264436F6E74656E742D7469746C657B636F6C6F723A236561656165617D5B6469723D6C74725D202E757070792D44617368626F617264436F6E74656E742D6261636B2C5B6469723D';
wwv_flow_imp.g_varchar2_table(624) := '6C74725D202E757070792D44617368626F617264436F6E74656E742D736176657B6D617267696E2D6C6566743A2D3670787D5B6469723D72746C5D202E757070792D44617368626F617264436F6E74656E742D6261636B2C5B6469723D72746C5D202E75';
wwv_flow_imp.g_varchar2_table(625) := '7070792D44617368626F617264436F6E74656E742D736176657B6D617267696E2D72696768743A2D3670787D2E757070792D44617368626F617264436F6E74656E742D6261636B2C2E757070792D44617368626F617264436F6E74656E742D736176657B';
wwv_flow_imp.g_varchar2_table(626) := '2D7765626B69742D617070656172616E63653A6E6F6E653B6261636B67726F756E643A6E6F6E653B626F726465723A303B626F726465722D7261646975733A3370783B636F6C6F723A696E68657269743B636F6C6F723A233132363963663B637572736F';
wwv_flow_imp.g_varchar2_table(627) := '723A706F696E7465723B666F6E742D66616D696C793A696E68657269743B666F6E742D73697A653A696E68657269743B666F6E742D73697A653A313270783B666F6E742D7765696768743A3430303B6C696E652D6865696768743A313B6D617267696E3A';
wwv_flow_imp.g_varchar2_table(628) := '303B70616464696E673A377078203670787D2E757070792D44617368626F617264436F6E74656E742D6261636B3A666F6375732C2E757070792D44617368626F617264436F6E74656E742D736176653A666F6375737B6F75746C696E653A6E6F6E657D2E';
wwv_flow_imp.g_varchar2_table(629) := '757070792D44617368626F617264436F6E74656E742D6261636B3A3A2D6D6F7A2D666F6375732D696E6E65722C2E757070792D44617368626F617264436F6E74656E742D736176653A3A2D6D6F7A2D666F6375732D696E6E65727B626F726465723A307D';
wwv_flow_imp.g_varchar2_table(630) := '2E757070792D44617368626F617264436F6E74656E742D6261636B3A686F7665722C2E757070792D44617368626F617264436F6E74656E742D736176653A686F7665727B636F6C6F723A233065353161307D2E757070792D44617368626F617264436F6E';
wwv_flow_imp.g_varchar2_table(631) := '74656E742D6261636B3A666F6375732C2E757070792D44617368626F617264436F6E74656E742D736176653A666F6375737B6261636B67726F756E642D636F6C6F723A236466653666317D5B646174612D757070792D7468656D653D6461726B5D202E75';
wwv_flow_imp.g_varchar2_table(632) := '7070792D44617368626F617264436F6E74656E742D6261636B3A666F6375732C5B646174612D757070792D7468656D653D6461726B5D202E757070792D44617368626F617264436F6E74656E742D736176653A666F6375737B6261636B67726F756E642D';
wwv_flow_imp.g_varchar2_table(633) := '636F6C6F723A233333337D2E757070792D73697A652D2D6D64202E757070792D44617368626F617264436F6E74656E742D6261636B2C2E757070792D73697A652D2D6D64202E757070792D44617368626F617264436F6E74656E742D736176657B666F6E';
wwv_flow_imp.g_varchar2_table(634) := '742D73697A653A313470787D5B646174612D757070792D7468656D653D6461726B5D202E757070792D44617368626F617264436F6E74656E742D6261636B2C5B646174612D757070792D7468656D653D6461726B5D202E757070792D44617368626F6172';
wwv_flow_imp.g_varchar2_table(635) := '64436F6E74656E742D736176657B636F6C6F723A233032626166327D5B6469723D6C74725D202E757070792D44617368626F617264436F6E74656E742D6164644D6F72657B6D617267696E2D72696768743A2D3570787D5B6469723D72746C5D202E7570';
wwv_flow_imp.g_varchar2_table(636) := '70792D44617368626F617264436F6E74656E742D6164644D6F72657B6D617267696E2D6C6566743A2D3570787D2E757070792D44617368626F617264436F6E74656E742D6164644D6F72657B2D7765626B69742D617070656172616E63653A6E6F6E653B';
wwv_flow_imp.g_varchar2_table(637) := '6261636B67726F756E643A6E6F6E653B626F726465723A303B626F726465722D7261646975733A3370783B636F6C6F723A696E68657269743B636F6C6F723A233132363963663B637572736F723A706F696E7465723B666F6E742D66616D696C793A696E';
wwv_flow_imp.g_varchar2_table(638) := '68657269743B666F6E742D73697A653A696E68657269743B666F6E742D7765696768743A3530303B6865696768743A323970783B6C696E652D6865696768743A313B6D617267696E3A303B70616464696E673A377078203870783B77696474683A323970';
wwv_flow_imp.g_varchar2_table(639) := '787D2E757070792D44617368626F617264436F6E74656E742D6164644D6F72653A666F6375737B6F75746C696E653A6E6F6E657D2E757070792D44617368626F617264436F6E74656E742D6164644D6F72653A3A2D6D6F7A2D666F6375732D696E6E6572';
wwv_flow_imp.g_varchar2_table(640) := '7B626F726465723A307D2E757070792D44617368626F617264436F6E74656E742D6164644D6F72653A686F7665727B636F6C6F723A233065353161307D2E757070792D44617368626F617264436F6E74656E742D6164644D6F72653A666F6375737B6261';
wwv_flow_imp.g_varchar2_table(641) := '636B67726F756E642D636F6C6F723A236466653666317D5B646174612D757070792D7468656D653D6461726B5D202E757070792D44617368626F617264436F6E74656E742D6164644D6F72653A666F6375737B6261636B67726F756E642D636F6C6F723A';
wwv_flow_imp.g_varchar2_table(642) := '233333337D5B6469723D6C74725D202E757070792D73697A652D2D6D64202E757070792D44617368626F617264436F6E74656E742D6164644D6F72657B6D617267696E2D72696768743A2D3870787D5B6469723D72746C5D202E757070792D73697A652D';
wwv_flow_imp.g_varchar2_table(643) := '2D6D64202E757070792D44617368626F617264436F6E74656E742D6164644D6F72657B6D617267696E2D6C6566743A2D3870787D2E757070792D73697A652D2D6D64202E757070792D44617368626F617264436F6E74656E742D6164644D6F72657B666F';
wwv_flow_imp.g_varchar2_table(644) := '6E742D73697A653A313470783B6865696768743A6175746F3B77696474683A6175746F7D5B646174612D757070792D7468656D653D6461726B5D202E757070792D44617368626F617264436F6E74656E742D6164644D6F72657B636F6C6F723A23303262';
wwv_flow_imp.g_varchar2_table(645) := '6166327D5B6469723D6C74725D202E757070792D44617368626F617264436F6E74656E742D6164644D6F7265207376677B6D617267696E2D72696768743A3470787D5B6469723D72746C5D202E757070792D44617368626F617264436F6E74656E742D61';
wwv_flow_imp.g_varchar2_table(646) := '64644D6F7265207376677B6D617267696E2D6C6566743A3470787D2E757070792D44617368626F617264436F6E74656E742D6164644D6F7265207376677B766572746963616C2D616C69676E3A696E697469616C7D2E757070792D73697A652D2D6D6420';
wwv_flow_imp.g_varchar2_table(647) := '2E757070792D44617368626F617264436F6E74656E742D6164644D6F7265207376677B6865696768743A313170783B77696474683A313170787D2E757070792D44617368626F617264436F6E74656E742D6164644D6F726543617074696F6E7B64697370';
wwv_flow_imp.g_varchar2_table(648) := '6C61793A6E6F6E657D2E757070792D73697A652D2D6D64202E757070792D44617368626F617264436F6E74656E742D6164644D6F726543617074696F6E7B646973706C61793A696E6C696E657D2E757070792D44617368626F617264436F6E74656E742D';
wwv_flow_imp.g_varchar2_table(649) := '70616E656C7B6261636B67726F756E642D636F6C6F723A236635663566353B666C65783A317D2E757070792D44617368626F6172642D41646446696C657350616E656C2C2E757070792D44617368626F617264436F6E74656E742D70616E656C7B626F72';
wwv_flow_imp.g_varchar2_table(650) := '6465722D7261646975733A3570783B626F74746F6D3A303B646973706C61793A666C65783B666C65782D646972656374696F6E3A636F6C756D6E3B6C6566743A303B6F766572666C6F773A68696464656E3B706F736974696F6E3A6162736F6C7574653B';
wwv_flow_imp.g_varchar2_table(651) := '72696768743A303B746F703A303B7A2D696E6465783A313030357D2E757070792D44617368626F6172642D41646446696C657350616E656C7B6261636B67726F756E643A236661666166613B6261636B67726F756E643A6C696E6561722D677261646965';
wwv_flow_imp.g_varchar2_table(652) := '6E7428306465672C23666166616661203335252C236661666166616439293B626F782D736861646F773A302030203130707820357078202330303030303032367D5B646174612D757070792D7468656D653D6461726B5D202E757070792D44617368626F';
wwv_flow_imp.g_varchar2_table(653) := '6172642D41646446696C657350616E656C7B6261636B67726F756E642D636F6C6F723A233333333B6261636B67726F756E642D696D6167653A6C696E6561722D6772616469656E7428306465672C23316631663166203335252C23316631663166643929';
wwv_flow_imp.g_varchar2_table(654) := '7D2E757070792D44617368626F6172642D2D697341646446696C657350616E656C56697369626C65202E757070792D44617368626F6172642D66696C65737B66696C7465723A626C757228327078297D2E757070792D44617368626F6172642D70726F67';
wwv_flow_imp.g_varchar2_table(655) := '726573737B626F74746F6D3A303B6865696768743A3132253B6C6566743A303B706F736974696F6E3A6162736F6C7574653B77696474683A313030257D2E757070792D44617368626F6172642D70726F6772657373426172436F6E7461696E65722E6973';
wwv_flow_imp.g_varchar2_table(656) := '2D6163746976657B6865696768743A313030253B6C6566743A303B706F736974696F6E3A6162736F6C7574653B746F703A303B77696474683A313030253B7A2D696E6465783A313030347D2E757070792D44617368626F6172642D66696C6573436F6E74';
wwv_flow_imp.g_varchar2_table(657) := '61696E65727B666C65783A313B6D617267696E3A303B6F766572666C6F772D793A68696464656E3B706F736974696F6E3A72656C61746976657D2E757070792D44617368626F6172642D66696C6573436F6E7461696E65723A61667465727B636C656172';
wwv_flow_imp.g_varchar2_table(658) := '3A626F74683B636F6E74656E743A22223B646973706C61793A7461626C657D2E757070792D44617368626F6172642D66696C65737B2D7765626B69742D6F766572666C6F772D7363726F6C6C696E673A746F7563683B666C65783A313B6D617267696E3A';
wwv_flow_imp.g_varchar2_table(659) := '303B6F766572666C6F772D793A6175746F3B70616464696E673A30203020313070787D2E757070792D73697A652D2D6D64202E757070792D44617368626F6172642D66696C65737B70616464696E672D746F703A313070787D2E757070792D4461736862';
wwv_flow_imp.g_varchar2_table(660) := '6F6172642D2D73696E676C6546696C65202E757070792D44617368626F6172642D66696C6573496E6E65727B616C69676E2D6974656D733A63656E7465723B646973706C61793A666C65783B6865696768743A313030253B6A7573746966792D636F6E74';
wwv_flow_imp.g_varchar2_table(661) := '656E743A63656E7465727D2E757070792D44617368626F6172642D64726F7046696C65734865726548696E747B616C69676E2D6974656D733A63656E7465723B6261636B67726F756E642D696D6167653A75726C2822646174613A696D6167652F737667';
wwv_flow_imp.g_varchar2_table(662) := '2B786D6C3B636861727365743D7574662D382C2533437376672077696474683D27343827206865696768743D2734382720786D6C6E733D27687474703A2F2F7777772E77332E6F72672F323030302F737667272533452533437061746820643D274D3234';
wwv_flow_imp.g_varchar2_table(663) := '203176314331312E3835203220322031312E3835203220323473392E38352032322032322032322032322D392E38352032322D32325333362E31352032203234203256317A6D30203056306331332E32353420302032342031302E373436203234203234';
wwv_flow_imp.g_varchar2_table(664) := '5333372E32353420343820323420343820302033372E32353420302032342031302E3734362030203234203076317A6D372E3730372031392E323933612E3939392E3939392030203120312D312E34313420312E3431344C32352031362E343134563334';
wwv_flow_imp.g_varchar2_table(665) := '613120312030203120312D3220305631362E3431346C2D352E32393320352E323933612E3939392E3939392030203120312D312E3431342D312E3431346C372D37612E3939392E39393920302030203120312E34313420306C3720377A272066696C6C3D';
wwv_flow_imp.g_varchar2_table(666) := '27253233313236394346272F2533452533432F73766725334522293B6261636B67726F756E642D706F736974696F6E3A353025203530253B6261636B67726F756E642D7265706561743A6E6F2D7265706561743B626F726465723A317078206461736865';
wwv_flow_imp.g_varchar2_table(667) := '6420233132363963663B626F726465722D7261646975733A3370783B626F74746F6D3A3770783B636F6C6F723A233735373537353B646973706C61793A666C65783B666F6E742D73697A653A313670783B6A7573746966792D636F6E74656E743A63656E';
wwv_flow_imp.g_varchar2_table(668) := '7465723B6C6566743A3770783B70616464696E672D746F703A393070783B706F736974696F6E3A6162736F6C7574653B72696768743A3770783B746578742D616C69676E3A63656E7465723B746F703A3770783B7669736962696C6974793A6869646465';
wwv_flow_imp.g_varchar2_table(669) := '6E3B7A2D696E6465783A323030307D5B646174612D757070792D7468656D653D6461726B5D202E757070792D44617368626F6172642D64726F7046696C65734865726548696E747B6261636B67726F756E642D696D6167653A75726C2822646174613A69';
wwv_flow_imp.g_varchar2_table(670) := '6D6167652F7376672B786D6C3B636861727365743D7574662D382C2533437376672077696474683D27343827206865696768743D2734382720786D6C6E733D27687474703A2F2F7777772E77332E6F72672F323030302F73766727253345253343706174';
wwv_flow_imp.g_varchar2_table(671) := '6820643D274D3234203176314331312E3835203220322031312E3835203220323473392E38352032322032322032322032322D392E38352032322D32325333362E31352032203234203256317A6D30203056306331332E32353420302032342031302E37';
wwv_flow_imp.g_varchar2_table(672) := '34362032342032345333372E32353420343820323420343820302033372E32353420302032342031302E3734362030203234203076317A6D372E3730372031392E323933612E3939392E3939392030203120312D312E34313420312E3431344C32352031';
wwv_flow_imp.g_varchar2_table(673) := '362E343134563334613120312030203120312D3220305631362E3431346C2D352E32393320352E323933612E3939392E3939392030203120312D312E3431342D312E3431346C372D37612E3939392E39393920302030203120312E34313420306C372037';
wwv_flow_imp.g_varchar2_table(674) := '7A272066696C6C3D27253233303242414632272F2533452533432F73766725334522293B626F726465722D636F6C6F723A233032626166323B636F6C6F723A236262627D2E757070792D44617368626F6172642E757070792D44617368626F6172642D2D';
wwv_flow_imp.g_varchar2_table(675) := '69734472616767696E674F766572202E757070792D44617368626F6172642D64726F7046696C65734865726548696E747B7669736962696C6974793A76697369626C657D2E757070792D44617368626F6172642E757070792D44617368626F6172642D2D';
wwv_flow_imp.g_varchar2_table(676) := '69734472616767696E674F766572202E757070792D44617368626F6172642D66696C65732C2E757070792D44617368626F6172642E757070792D44617368626F6172642D2D69734472616767696E674F766572202E757070792D44617368626F6172642D';
wwv_flow_imp.g_varchar2_table(677) := '70726F6772657373696E64696361746F72732C2E757070792D44617368626F6172642E757070792D44617368626F6172642D2D69734472616767696E674F766572202E757070792D44617368626F6172642D736572766963654D73672C2E757070792D44';
wwv_flow_imp.g_varchar2_table(678) := '617368626F6172642E757070792D44617368626F6172642D2D69734472616767696E674F766572202E757070792D44617368626F617264436F6E74656E742D6261727B6F7061636974793A2E31357D2E757070792D44617368626F6172642E757070792D';
wwv_flow_imp.g_varchar2_table(679) := '44617368626F6172642D2D69734472616767696E674F766572202E757070792D44617368626F6172642D41646446696C65737B6F7061636974793A2E30337D2E757070792D44617368626F6172642D41646446696C65732D7469746C657B636F6C6F723A';
wwv_flow_imp.g_varchar2_table(680) := '233030303B666F6E742D73697A653A313770783B666F6E742D7765696768743A3530303B6C696E652D6865696768743A312E33353B6D617267696E2D626F74746F6D3A3570783B6D617267696E2D746F703A313570783B70616464696E673A3020313570';
wwv_flow_imp.g_varchar2_table(681) := '783B746578742D616C69676E3A696E6C696E652D73746172743B77696474683A313030257D2E757070792D73697A652D2D6D64202E757070792D44617368626F6172642D41646446696C65732D7469746C657B666F6E742D73697A653A323170783B666F';
wwv_flow_imp.g_varchar2_table(682) := '6E742D7765696768743A3430303B6D617267696E2D746F703A3570783B6D61782D77696474683A34383070783B70616464696E673A3020333570783B746578742D616C69676E3A63656E7465727D5B646174612D757070792D6E756D2D61637175697265';
wwv_flow_imp.g_varchar2_table(683) := '72733D2230225D202E757070792D44617368626F6172642D41646446696C65732D7469746C657B746578742D616C69676E3A63656E7465727D5B646174612D757070792D7468656D653D6461726B5D202E757070792D44617368626F6172642D41646446';
wwv_flow_imp.g_varchar2_table(684) := '696C65732D7469746C657B636F6C6F723A236561656165617D2E757070792D44617368626F6172642D41646446696C65732D7469746C6520627574746F6E7B666F6E742D7765696768743A3530307D2E757070792D73697A652D2D6D64202E757070792D';
wwv_flow_imp.g_varchar2_table(685) := '44617368626F6172642D41646446696C65732D7469746C6520627574746F6E7B666F6E742D7765696768743A3430307D2E757070792D44617368626F6172642D6E6F74657B636F6C6F723A233735373537353B666F6E742D73697A653A313470783B6C69';
wwv_flow_imp.g_varchar2_table(686) := '6E652D6865696768743A312E32353B6D617267696E3A6175746F3B6D61782D77696474683A33353070783B70616464696E673A3020313570783B746578742D616C69676E3A63656E7465727D2E757070792D73697A652D2D6D64202E757070792D446173';
wwv_flow_imp.g_varchar2_table(687) := '68626F6172642D6E6F74657B6C696E652D6865696768743A312E33353B6D61782D77696474683A36303070787D5B646174612D757070792D7468656D653D6461726B5D202E757070792D44617368626F6172642D6E6F74657B636F6C6F723A2363666366';
wwv_flow_imp.g_varchar2_table(688) := '63667D612E757070792D44617368626F6172642D706F776572656442797B636F6C6F723A233933393339333B646973706C61793A696E6C696E652D626C6F636B3B666F6E742D73697A653A313170783B6D617267696E2D746F703A3870783B746578742D';
wwv_flow_imp.g_varchar2_table(689) := '616C69676E3A63656E7465723B746578742D6465636F726174696F6E3A6E6F6E657D2E757070792D44617368626F6172642D706F7765726564427949636F6E7B66696C6C3A6E6F6E653B7374726F6B653A233933393339333B6D617267696E2D6C656674';
wwv_flow_imp.g_varchar2_table(690) := '3A3170783B6D617267696E2D72696768743A3170783B6F7061636974793A2E393B706F736974696F6E3A72656C61746976653B746F703A3170783B766572746963616C2D616C69676E3A746578742D746F707D2E757070792D44617368626F6172642D49';
wwv_flow_imp.g_varchar2_table(691) := '74656D2D7072657669657749636F6E7B6865696768743A323570783B6C6566743A3530253B706F736974696F6E3A6162736F6C7574653B746F703A3530253B7472616E73666F726D3A7472616E736C617465282D3530252C2D353025293B77696474683A';
wwv_flow_imp.g_varchar2_table(692) := '323570783B7A2D696E6465783A3130307D2E757070792D73697A652D2D6D64202E757070792D44617368626F6172642D4974656D2D7072657669657749636F6E7B6865696768743A333870783B77696474683A333870787D2E757070792D44617368626F';
wwv_flow_imp.g_varchar2_table(693) := '6172642D4974656D2D7072657669657749636F6E207376677B6865696768743A313030253B77696474683A313030257D2E757070792D44617368626F6172642D2D73696E676C6546696C65202E757070792D44617368626F6172642D4974656D2D707265';
wwv_flow_imp.g_varchar2_table(694) := '7669657749636F6E7B6865696768743A313030253B6D61782D6865696768743A3630253B6D61782D77696474683A3630253B77696474683A313030257D2E757070792D44617368626F6172642D4974656D2D7072657669657749636F6E577261707B6865';
wwv_flow_imp.g_varchar2_table(695) := '696768743A373670783B6D61782D6865696768743A3735253B706F736974696F6E3A72656C61746976657D2E757070792D44617368626F6172642D2D73696E676C6546696C65202E757070792D44617368626F6172642D4974656D2D7072657669657749';
wwv_flow_imp.g_varchar2_table(696) := '636F6E577261707B6865696768743A313030253B77696474683A313030257D2E757070792D44617368626F6172642D4974656D2D7072657669657749636F6E42677B66696C7465723A64726F702D736861646F77287267626128302C302C302C2E312920';
wwv_flow_imp.g_varchar2_table(697) := '302031707820317078293B6865696768743A313030253B77696474683A313030257D2E757070792D44617368626F6172642D75706C6F61647B6865696768743A353070783B706F736974696F6E3A72656C61746976653B77696474683A353070787D2E75';
wwv_flow_imp.g_varchar2_table(698) := '7070792D73697A652D2D6D64202E757070792D44617368626F6172642D75706C6F61647B6865696768743A363070783B77696474683A363070787D2E757070792D44617368626F6172642D75706C6F6164202E757070792D632D69636F6E7B706F736974';
wwv_flow_imp.g_varchar2_table(699) := '696F6E3A72656C61746976653B746F703A3170783B77696474683A3530257D5B6469723D6C74725D202E757070792D44617368626F6172642D75706C6F6164436F756E747B72696768743A2D313270787D5B6469723D72746C5D202E757070792D446173';
wwv_flow_imp.g_varchar2_table(700) := '68626F6172642D75706C6F6164436F756E747B6C6566743A2D313270787D2E757070792D44617368626F6172642D75706C6F6164436F756E747B6261636B67726F756E642D636F6C6F723A233162623234303B626F726465722D7261646975733A353025';
wwv_flow_imp.g_varchar2_table(701) := '3B636F6C6F723A236666663B666F6E742D73697A653A3870783B6865696768743A313670783B6C696E652D6865696768743A313670783B706F736974696F6E3A6162736F6C7574653B746F703A2D313270783B77696474683A313670787D2E757070792D';
wwv_flow_imp.g_varchar2_table(702) := '73697A652D2D6D64202E757070792D44617368626F6172642D75706C6F6164436F756E747B666F6E742D73697A653A3970783B6865696768743A313870783B6C696E652D6865696768743A313870783B77696474683A313870787D2E757070792D447261';
wwv_flow_imp.g_varchar2_table(703) := '6744726F702D636F6E7461696E65727B616C69676E2D6974656D733A63656E7465723B6261636B67726F756E642D636F6C6F723A236666663B626F726465722D7261646975733A3770783B637572736F723A706F696E7465723B646973706C61793A666C';
wwv_flow_imp.g_varchar2_table(704) := '65783B666F6E742D66616D696C793A2D6170706C652D73797374656D2C73797374656D2D75692C426C696E6B4D616353797374656D466F6E742C5365676F652055492C5365676F652055492053796D626F6C2C5365676F6520554920456D6F6A692C4170';
wwv_flow_imp.g_varchar2_table(705) := '706C6520436F6C6F7220456D6F6A692C526F626F746F2C48656C7665746963612C417269616C2C73616E732D73657269663B6A7573746966792D636F6E74656E743A63656E7465723B6D61782D77696474683A313030257D2E757070792D447261674472';
wwv_flow_imp.g_varchar2_table(706) := '6F702D636F6E7461696E65723A3A2D6D6F7A2D666F6375732D696E6E65727B626F726465723A307D2E757070792D4472616744726F702D636F6E7461696E65723A666F6375737B626F782D736861646F773A302030203020337078202331323639636636';
wwv_flow_imp.g_varchar2_table(707) := '363B6F75746C696E653A6E6F6E657D2E757070792D4472616744726F702D696E6E65727B6C696E652D6865696768743A312E343B6D617267696E3A303B70616464696E673A3830707820323070783B746578742D616C69676E3A63656E7465727D2E7570';
wwv_flow_imp.g_varchar2_table(708) := '70792D4472616744726F702D6172726F777B66696C6C3A236530653065303B6865696768743A363070783B6D617267696E2D626F74746F6D3A313770783B77696474683A363070787D2E757070792D4472616744726F702D2D69734472616744726F7053';
wwv_flow_imp.g_varchar2_table(709) := '7570706F727465647B626F726465723A3270782064617368656420236164616461647D2E757070792D4472616744726F702D2D69734472616767696E674F7665727B6261636B67726F756E643A236561656165613B626F726465723A3270782064617368';
wwv_flow_imp.g_varchar2_table(710) := '656420233132363963667D2E757070792D4472616744726F702D2D69734472616767696E674F766572202E757070792D4472616744726F702D6172726F777B66696C6C3A233933393339337D2E757070792D4472616744726F702D6C6162656C7B646973';
wwv_flow_imp.g_varchar2_table(711) := '706C61793A626C6F636B3B666F6E742D73697A653A312E3135656D3B6D617267696E2D626F74746F6D3A3570787D2E757070792D4472616744726F702D62726F7773657B636F6C6F723A233132363963663B637572736F723A706F696E7465727D2E7570';
wwv_flow_imp.g_varchar2_table(712) := '70792D4472616744726F702D6E6F74657B636F6C6F723A236164616461643B666F6E742D73697A653A31656D7D2E757070792D46696C65496E7075742D636F6E7461696E65727B6D617267696E2D626F74746F6D3A313570787D2E757070792D46696C65';
wwv_flow_imp.g_varchar2_table(713) := '496E7075742D62746E7B2D7765626B69742D617070656172616E63653A6E6F6E653B6261636B67726F756E643A6E6F6E653B626F726465723A31707820736F6C696420233061333937313B626F726465722D7261646975733A3870783B636F6C6F723A69';
wwv_flow_imp.g_varchar2_table(714) := '6E68657269743B636F6C6F723A233061333937313B637572736F723A706F696E7465723B666F6E742D66616D696C793A696E68657269743B666F6E742D66616D696C793A73616E732D73657269663B666F6E742D73697A653A696E68657269743B666F6E';
wwv_flow_imp.g_varchar2_table(715) := '742D73697A653A2E3835656D3B6C696E652D6865696768743A313B6D617267696E3A303B70616464696E673A3130707820313570787D2E757070792D46696C65496E7075742D62746E3A686F7665727B6261636B67726F756E642D636F6C6F723A233061';
wwv_flow_imp.g_varchar2_table(716) := '333937313B636F6C6F723A236666667D2E757070792D50726F67726573734261727B6865696768743A3370783B6C6566743A303B706F736974696F6E3A6162736F6C7574653B746F703A303B7472616E736974696F6E3A686569676874202E32733B7769';
wwv_flow_imp.g_varchar2_table(717) := '6474683A313030253B7A2D696E6465783A31303030307D2E757070792D50726F67726573734261725B617269612D68696464656E3D747275655D7B6865696768743A307D2E757070792D50726F67726573734261722D696E6E65727B6261636B67726F75';
wwv_flow_imp.g_varchar2_table(718) := '6E642D636F6C6F723A233132363963663B626F782D736861646F773A3020302031307078202331323639636662333B6865696768743A313030253B7472616E736974696F6E3A7769647468202E347320656173653B77696474683A307D2E757070792D50';
wwv_flow_imp.g_varchar2_table(719) := '726F67726573734261722D70657263656E746167657B636F6C6F723A236666663B646973706C61793A6E6F6E653B6C6566743A3530253B706F736974696F6E3A6162736F6C7574653B746578742D616C69676E3A63656E7465723B746F703A3530253B74';
wwv_flow_imp.g_varchar2_table(720) := '72616E73666F726D3A7472616E736C617465282D3530252C2D353025297D2E757070792D55726C7B616C69676E2D6974656D733A63656E7465723B646973706C61793A666C65783B666C65783A313B666C65782D646972656374696F6E3A636F6C756D6E';
wwv_flow_imp.g_varchar2_table(721) := '3B6865696768743A313030253B6A7573746966792D636F6E74656E743A63656E7465723B77696474683A313030257D5B646174612D757070792D7468656D653D6461726B5D202E757070792D55726C7B6261636B67726F756E642D636F6C6F723A233166';
wwv_flow_imp.g_varchar2_table(722) := '316631667D2E757070792D55726C2D696E7075747B6D617267696E2D626F74746F6D3A313570783B6D61782D77696474683A36353070783B77696474683A3930257D2E757070792D73697A652D2D6D64202E757070792D55726C2D696E7075747B6D6172';
wwv_flow_imp.g_varchar2_table(723) := '67696E2D626F74746F6D3A323070787D2E757070792D55726C2D696D706F7274427574746F6E7B70616464696E673A3133707820323570787D2E757070792D73697A652D2D6D64202E757070792D55726C2D696D706F7274427574746F6E7B7061646469';
wwv_flow_imp.g_varchar2_table(724) := '6E673A3133707820333070787D2E757070792D57656263616D2D636F6E7461696E65727B616C69676E2D6974656D733A63656E7465723B646973706C61793A666C65783B666C65782D646972656374696F6E3A636F6C756D6E3B6865696768743A313030';
wwv_flow_imp.g_varchar2_table(725) := '253B6A7573746966792D636F6E74656E743A63656E7465723B77696474683A313030257D2E757070792D57656263616D2D766964656F436F6E7461696E65727B6261636B67726F756E642D636F6C6F723A233333333B666C65783A313B666C65782D6772';
wwv_flow_imp.g_varchar2_table(726) := '6F773A313B6F766572666C6F773A68696464656E3B706F736974696F6E3A72656C61746976653B746578742D616C69676E3A63656E7465723B77696474683A313030257D2E757070792D57656263616D2D766964656F7B626F74746F6D3A303B6C656674';
wwv_flow_imp.g_varchar2_table(727) := '3A303B6D617267696E3A6175746F3B6D61782D6865696768743A313030253B6D61782D77696474683A313030253B706F736974696F6E3A6162736F6C7574653B72696768743A303B746F703A307D2E757070792D57656263616D2D766964656F2D2D6D69';
wwv_flow_imp.g_varchar2_table(728) := '72726F7265647B7472616E73666F726D3A7363616C6558282D31297D2E757070792D57656263616D2D666F6F7465727B616C69676E2D6974656D733A63656E7465723B646973706C61793A666C65783B666C65782D777261703A777261703B6A75737469';
wwv_flow_imp.g_varchar2_table(729) := '66792D636F6E74656E743A73706163652D6265747765656E3B6D696E2D6865696768743A373570783B70616464696E673A323070783B77696474683A313030257D2E757070792D57656263616D2D766964656F536F75726365436F6E7461696E65727B66';
wwv_flow_imp.g_varchar2_table(730) := '6C65782D67726F773A303B77696474683A313030257D2E757070792D73697A652D2D6C67202E757070792D57656263616D2D766964656F536F75726365436F6E7461696E65727B6D617267696E3A303B77696474683A3333257D2E757070792D57656263';
wwv_flow_imp.g_varchar2_table(731) := '616D2D766964656F536F757263652D73656C6563747B6261636B67726F756E642D696D6167653A75726C2822646174613A696D6167652F7376672B786D6C3B636861727365743D55532D41534349492C253343737667253230786D6C6E73253344253232';
wwv_flow_imp.g_varchar2_table(732) := '687474702533412532462532467777772E77332E6F72672532463230303025324673766725323225323077696474682533442532323239322E342532322532306865696768742533442532323239322E342532322533452533437061746825323066696C';
wwv_flow_imp.g_varchar2_table(733) := '6C253344253232253233373537353735253232253230642533442532324D32383725323036392E346131372E3625323031372E362532303025323030253230302D31332D352E344831382E34632D35253230302D392E33253230312E382D31322E392532';
wwv_flow_imp.g_varchar2_table(734) := '30352E344131372E3625323031372E362532303025323030253230302532303025323038322E32633025323035253230312E38253230392E33253230352E3425323031322E396C3132382532303132372E3963332E36253230332E36253230372E382532';
wwv_flow_imp.g_varchar2_table(735) := '30352E3425323031322E38253230352E3473392E322D312E3825323031322E382D352E344C323837253230393563332E352D332E35253230352E342D372E38253230352E342D31322E38253230302D352D312E392D392E322D352E352D31322E387A2532';
wwv_flow_imp.g_varchar2_table(736) := '3225324625334525334325324673766725334522293B6261636B67726F756E642D706F736974696F6E3A7269676874202E34656D20746F70203530252C3020303B6261636B67726F756E642D7265706561743A6E6F2D7265706561743B6261636B67726F';
wwv_flow_imp.g_varchar2_table(737) := '756E642D73697A653A2E3635656D206175746F2C313030253B626F726465723A31707820736F6C696420233735373537353B646973706C61793A626C6F636B3B666F6E742D73697A653A313670783B6C696E652D6865696768743A312E323B6D61726769';
wwv_flow_imp.g_varchar2_table(738) := '6E3A6175746F206175746F20313070783B6D61782D77696474683A3930253B70616464696E673A2E34656D2031656D202E33656D202E34656D3B746578742D6F766572666C6F773A656C6C69707369733B77686974652D73706163653A6E6F777261703B';
wwv_flow_imp.g_varchar2_table(739) := '77696474683A313030257D2E757070792D73697A652D2D6C67202E757070792D57656263616D2D766964656F536F757263652D73656C6563747B666F6E742D73697A653A313470783B6D617267696E2D626F74746F6D3A307D2E757070792D5765626361';
wwv_flow_imp.g_varchar2_table(740) := '6D2D766964656F536F757263652D73656C6563743A3A2D6D732D657870616E647B646973706C61793A6E6F6E657D2E757070792D57656263616D2D627574746F6E436F6E7461696E65727B6D617267696E2D6C6566743A3235253B746578742D616C6967';
wwv_flow_imp.g_varchar2_table(741) := '6E3A63656E7465723B77696474683A3530257D2E757070792D73697A652D2D6C67202E757070792D57656263616D2D627574746F6E436F6E7461696E65727B6D617267696E2D6C6566743A303B77696474683A3334257D2E757070792D57656263616D2D';
wwv_flow_imp.g_varchar2_table(742) := '7265636F7264696E674C656E6774687B636F6C6F723A233735373537353B666C65782D67726F773A303B666F6E742D66616D696C793A53464D6F6E6F2D526567756C61722C4D656E6C6F2C4D6F6E61636F2C436F6E736F6C61732C4C696265726174696F';
wwv_flow_imp.g_varchar2_table(743) := '6E204D6F6E6F2C436F7572696572204E65772C6D6F6E6F73706163653B746578742D616C69676E3A72696768743B77696474683A3235257D2E757070792D73697A652D2D6C67202E757070792D57656263616D2D7265636F7264696E674C656E6774687B';
wwv_flow_imp.g_varchar2_table(744) := '77696474683A3333257D2E757070792D57656263616D2D627574746F6E7B6261636B67726F756E642D636F6C6F723A236533323433373B626F726465722D7261646975733A3530253B636F6C6F723A236666663B637572736F723A706F696E7465723B68';
wwv_flow_imp.g_varchar2_table(745) := '65696768743A343570783B7472616E736974696F6E3A616C6C202E33733B77696474683A343570787D2E757070792D57656263616D2D627574746F6E3A666F6375737B6F75746C696E653A6E6F6E657D2E757070792D57656263616D2D627574746F6E3A';
wwv_flow_imp.g_varchar2_table(746) := '3A2D6D6F7A2D666F6375732D696E6E65727B626F726465723A307D2E757070792D57656263616D2D627574746F6E3A666F6375737B626F782D736861646F773A302030203020337078202331323639636638307D2E757070792D57656263616D2D627574';
wwv_flow_imp.g_varchar2_table(747) := '746F6E3A686F7665727B6261636B67726F756E642D636F6C6F723A236433316232647D5B646174612D757070792D7468656D653D6461726B5D202E757070792D57656263616D2D627574746F6E3A666F6375737B6F75746C696E653A6E6F6E657D5B6461';
wwv_flow_imp.g_varchar2_table(748) := '74612D757070792D7468656D653D6461726B5D202E757070792D57656263616D2D627574746F6E3A3A2D6D6F7A2D666F6375732D696E6E65727B626F726465723A307D5B646174612D757070792D7468656D653D6461726B5D202E757070792D57656263';
wwv_flow_imp.g_varchar2_table(749) := '616D2D627574746F6E3A666F6375737B626F782D736861646F773A302030203020327078202361616531666664397D2E757070792D57656263616D2D627574746F6E2D2D7375626D69747B6261636B67726F756E642D636F6C6F723A233132363963663B';
wwv_flow_imp.g_varchar2_table(750) := '6D617267696E3A3020313270787D2E757070792D57656263616D2D627574746F6E2D2D7375626D69743A686F7665727B6261636B67726F756E642D636F6C6F723A233130356462387D2E757070792D57656263616D2D627574746F6E207376677B66696C';
wwv_flow_imp.g_varchar2_table(751) := '6C3A63757272656E74436F6C6F723B646973706C61793A696E6C696E652D626C6F636B3B6865696768743A333070783B6D61782D6865696768743A313030253B6D61782D77696474683A313030253B6F766572666C6F773A68696464656E3B7665727469';
wwv_flow_imp.g_varchar2_table(752) := '63616C2D616C69676E3A746578742D746F703B77696474683A333070787D2E757070792D73697A652D2D6D64202E757070792D57656263616D2D627574746F6E7B6865696768743A363070783B77696474683A363070787D2E757070792D57656263616D';
wwv_flow_imp.g_varchar2_table(753) := '2D627574746F6E2D2D706963747572657B6D617267696E2D72696768743A313270787D2E757070792D57656263616D2D7065726D6973736F6E737B616C69676E2D6974656D733A63656E7465723B646973706C61793A666C65783B666C65783A313B666C';
wwv_flow_imp.g_varchar2_table(754) := '65782D666C6F773A636F6C756D6E20777261703B6865696768743A313030253B6A7573746966792D636F6E74656E743A63656E7465723B70616464696E673A313570787D2E757070792D57656263616D2D7065726D6973736F6E7320707B636F6C6F723A';
wwv_flow_imp.g_varchar2_table(755) := '233933393339333B6C696E652D6865696768743A312E333B6C696E652D6865696768743A312E34353B6D617267696E3A303B6D61782D77696474683A34353070783B746578742D616C69676E3A63656E7465727D2E757070792D57656263616D2D706572';
wwv_flow_imp.g_varchar2_table(756) := '6D6973736F6E7349636F6E207376677B636F6C6F723A236262623B6865696768743A373570783B6D617267696E2D626F74746F6D3A333070783B77696474683A31303070787D2E757070792D57656263616D2D7469746C657B636F6C6F723A233333333B';
wwv_flow_imp.g_varchar2_table(757) := '666F6E742D73697A653A323270783B666F6E742D7765696768743A3430303B6C696E652D6865696768743A312E33353B6D617267696E3A302030203570783B6D61782D77696474683A35303070783B70616464696E673A3020313570783B746578742D61';
wwv_flow_imp.g_varchar2_table(758) := '6C69676E3A63656E7465727D5B646174612D757070792D7468656D653D6461726B5D202E757070792D57656263616D2D7469746C657B636F6C6F723A236561656165617D2E757070792D417564696F2D636F6E7461696E65727B666C65782D6469726563';
wwv_flow_imp.g_varchar2_table(759) := '74696F6E3A636F6C756D6E7D2E757070792D417564696F2D617564696F436F6E7461696E65722C2E757070792D417564696F2D636F6E7461696E65727B616C69676E2D6974656D733A63656E7465723B646973706C61793A666C65783B6865696768743A';
wwv_flow_imp.g_varchar2_table(760) := '313030253B6A7573746966792D636F6E74656E743A63656E7465723B77696474683A313030257D2E757070792D417564696F2D617564696F436F6E7461696E65727B6261636B67726F756E642D636F6C6F723A236366636663663B706F736974696F6E3A';
wwv_flow_imp.g_varchar2_table(761) := '72656C61746976657D2E757070792D417564696F2D706C617965727B626F726465722D7261646975733A313270783B77696474683A3835257D2E757070792D417564696F2D63616E7661737B626F74746F6D3A303B6865696768743A313030253B6C6566';
wwv_flow_imp.g_varchar2_table(762) := '743A303B706F736974696F6E3A6162736F6C7574653B72696768743A303B746F703A303B77696474683A313030257D2E757070792D417564696F2D666F6F7465727B616C69676E2D6974656D733A63656E7465723B646973706C61793A666C65783B666C';
wwv_flow_imp.g_varchar2_table(763) := '65782D777261703A777261703B6A7573746966792D636F6E74656E743A73706163652D6265747765656E3B70616464696E673A323070783B77696474683A313030257D2E757070792D417564696F2D617564696F536F75726365436F6E7461696E65727B';
wwv_flow_imp.g_varchar2_table(764) := '666C65782D67726F773A303B77696474683A313030257D2E757070792D73697A652D2D6C67202E757070792D417564696F2D617564696F536F75726365436F6E7461696E65727B6D617267696E3A303B77696474683A3333257D2E757070792D41756469';
wwv_flow_imp.g_varchar2_table(765) := '6F2D617564696F536F757263652D73656C6563747B6261636B67726F756E642D696D6167653A75726C2822646174613A696D6167652F7376672B786D6C3B636861727365743D55532D41534349492C253343737667253230786D6C6E7325334425323268';
wwv_flow_imp.g_varchar2_table(766) := '7474702533412532462532467777772E77332E6F72672532463230303025324673766725323225323077696474682533442532323239322E342532322532306865696768742533442532323239322E342532322533452533437061746825323066696C6C';
wwv_flow_imp.g_varchar2_table(767) := '253344253232253233373537353735253232253230642533442532324D32383725323036392E346131372E3625323031372E362532303025323030253230302D31332D352E344831382E34632D35253230302D392E33253230312E382D31322E39253230';
wwv_flow_imp.g_varchar2_table(768) := '352E344131372E3625323031372E362532303025323030253230302532303025323038322E32633025323035253230312E38253230392E33253230352E3425323031322E396C3132382532303132372E3963332E36253230332E36253230372E38253230';
wwv_flow_imp.g_varchar2_table(769) := '352E3425323031322E38253230352E3473392E322D312E3825323031322E382D352E344C323837253230393563332E352D332E35253230352E342D372E38253230352E342D31322E38253230302D352D312E392D392E322D352E352D31322E387A253232';
wwv_flow_imp.g_varchar2_table(770) := '25324625334525334325324673766725334522293B6261636B67726F756E642D706F736974696F6E3A7269676874202E34656D20746F70203530252C3020303B6261636B67726F756E642D7265706561743A6E6F2D7265706561743B6261636B67726F75';
wwv_flow_imp.g_varchar2_table(771) := '6E642D73697A653A2E3635656D206175746F2C313030253B626F726465723A31707820736F6C696420233735373537353B646973706C61793A626C6F636B3B666F6E742D73697A653A313670783B6C696E652D6865696768743A312E323B6D617267696E';
wwv_flow_imp.g_varchar2_table(772) := '3A6175746F206175746F20313070783B6D61782D77696474683A3930253B70616464696E673A2E34656D2031656D202E33656D202E34656D3B746578742D6F766572666C6F773A656C6C69707369733B77686974652D73706163653A6E6F777261703B77';
wwv_flow_imp.g_varchar2_table(773) := '696474683A313030257D2E757070792D73697A652D2D6C67202E757070792D417564696F2D617564696F536F757263652D73656C6563747B666F6E742D73697A653A313470783B6D617267696E2D626F74746F6D3A307D2E757070792D417564696F2D61';
wwv_flow_imp.g_varchar2_table(774) := '7564696F536F757263652D73656C6563743A3A2D6D732D657870616E647B646973706C61793A6E6F6E657D2E757070792D417564696F2D627574746F6E436F6E7461696E65727B666C65783A313B6D617267696E2D6C6566743A3235253B746578742D61';
wwv_flow_imp.g_varchar2_table(775) := '6C69676E3A63656E7465723B77696474683A3530257D2E757070792D73697A652D2D6C67202E757070792D417564696F2D627574746F6E436F6E7461696E65727B6D617267696E2D6C6566743A303B77696474683A3334257D2E757070792D417564696F';
wwv_flow_imp.g_varchar2_table(776) := '2D7265636F7264696E674C656E6774687B636F6C6F723A233735373537353B666C65782D67726F773A303B666F6E742D66616D696C793A53464D6F6E6F2D526567756C61722C4D656E6C6F2C4D6F6E61636F2C436F6E736F6C61732C4C69626572617469';
wwv_flow_imp.g_varchar2_table(777) := '6F6E204D6F6E6F2C436F7572696572204E65772C6D6F6E6F73706163653B746578742D616C69676E3A72696768743B77696474683A3235257D2E757070792D73697A652D2D6C67202E757070792D417564696F2D7265636F7264696E674C656E6774687B';
wwv_flow_imp.g_varchar2_table(778) := '77696474683A3333257D2E757070792D417564696F2D627574746F6E7B6261636B67726F756E642D636F6C6F723A236533323433373B626F726465722D7261646975733A3530253B636F6C6F723A236666663B637572736F723A706F696E7465723B6865';
wwv_flow_imp.g_varchar2_table(779) := '696768743A343570783B7472616E736974696F6E3A616C6C202E33733B77696474683A343570787D2E757070792D417564696F2D627574746F6E3A666F6375737B6F75746C696E653A6E6F6E657D2E757070792D417564696F2D627574746F6E3A3A2D6D';
wwv_flow_imp.g_varchar2_table(780) := '6F7A2D666F6375732D696E6E65727B626F726465723A307D2E757070792D417564696F2D627574746F6E3A666F6375737B626F782D736861646F773A302030203020337078202331323639636638307D2E757070792D417564696F2D627574746F6E3A68';
wwv_flow_imp.g_varchar2_table(781) := '6F7665727B6261636B67726F756E642D636F6C6F723A236433316232647D5B646174612D757070792D7468656D653D6461726B5D202E757070792D417564696F2D627574746F6E3A666F6375737B6F75746C696E653A6E6F6E657D5B646174612D757070';
wwv_flow_imp.g_varchar2_table(782) := '792D7468656D653D6461726B5D202E757070792D417564696F2D627574746F6E3A3A2D6D6F7A2D666F6375732D696E6E65727B626F726465723A307D5B646174612D757070792D7468656D653D6461726B5D202E757070792D417564696F2D627574746F';
wwv_flow_imp.g_varchar2_table(783) := '6E3A666F6375737B626F782D736861646F773A302030203020327078202361616531666664397D2E757070792D417564696F2D627574746F6E2D2D7375626D69747B6261636B67726F756E642D636F6C6F723A233132363963663B6D617267696E3A3020';
wwv_flow_imp.g_varchar2_table(784) := '313270787D2E757070792D417564696F2D627574746F6E2D2D7375626D69743A686F7665727B6261636B67726F756E642D636F6C6F723A233130356462387D2E757070792D417564696F2D627574746F6E207376677B66696C6C3A63757272656E74436F';
wwv_flow_imp.g_varchar2_table(785) := '6C6F723B646973706C61793A696E6C696E652D626C6F636B3B6865696768743A323670783B6D61782D6865696768743A313030253B6D61782D77696474683A313030253B6F766572666C6F773A68696464656E3B766572746963616C2D616C69676E3A74';
wwv_flow_imp.g_varchar2_table(786) := '6578742D746F703B77696474683A323670787D2E757070792D73697A652D2D6D64202E757070792D417564696F2D627574746F6E7B6865696768743A363070783B77696474683A363070787D2E757070792D417564696F2D7065726D6973736F6E737B61';
wwv_flow_imp.g_varchar2_table(787) := '6C69676E2D6974656D733A63656E7465723B646973706C61793A666C65783B666C65783A313B666C65782D666C6F773A636F6C756D6E20777261703B6865696768743A313030253B6A7573746966792D636F6E74656E743A63656E7465723B7061646469';
wwv_flow_imp.g_varchar2_table(788) := '6E673A313570787D2E757070792D417564696F2D7065726D6973736F6E7320707B636F6C6F723A233933393339333B6C696E652D6865696768743A312E333B6C696E652D6865696768743A312E34353B6D617267696E3A303B6D61782D77696474683A34';
wwv_flow_imp.g_varchar2_table(789) := '353070783B746578742D616C69676E3A63656E7465727D2E757070792D417564696F2D7065726D6973736F6E7349636F6E207376677B636F6C6F723A236262623B6865696768743A373570783B6D617267696E2D626F74746F6D3A333070783B77696474';
wwv_flow_imp.g_varchar2_table(790) := '683A31303070787D2E757070792D417564696F2D7469746C657B636F6C6F723A233333333B666F6E742D73697A653A323270783B666F6E742D7765696768743A3430303B6C696E652D6865696768743A312E33353B6D617267696E3A302030203570783B';
wwv_flow_imp.g_varchar2_table(791) := '6D61782D77696474683A35303070783B70616464696E673A3020313570783B746578742D616C69676E3A63656E7465727D5B646174612D757070792D7468656D653D6461726B5D202E757070792D417564696F2D7469746C657B636F6C6F723A23656165';
wwv_flow_imp.g_varchar2_table(792) := '6165617D2E757070792D53637265656E436170747572652D636F6E7461696E65727B616C69676E2D6974656D733A63656E7465723B646973706C61793A666C65783B666C65782D646972656374696F6E3A636F6C756D6E3B6865696768743A313030253B';
wwv_flow_imp.g_varchar2_table(793) := '6A7573746966792D636F6E74656E743A63656E7465723B77696474683A313030257D2E757070792D53637265656E436170747572652D766964656F436F6E7461696E65727B6261636B67726F756E642D636F6C6F723A233333333B666C65783A313B666C';
wwv_flow_imp.g_varchar2_table(794) := '65782D67726F773A313B6F766572666C6F773A68696464656E3B706F736974696F6E3A72656C61746976653B746578742D616C69676E3A63656E7465723B77696474683A313030257D2E757070792D73697A652D2D6D64202E757070792D53637265656E';
wwv_flow_imp.g_varchar2_table(795) := '436170747572652D766964656F436F6E7461696E65727B6D61782D77696474683A313030257D2E757070792D53637265656E436170747572652D766964656F7B626F74746F6D3A303B6C6566743A303B6D617267696E3A6175746F3B6D61782D68656967';
wwv_flow_imp.g_varchar2_table(796) := '68743A313030253B6D61782D77696474683A313030253B6F75746C696E653A303B706F736974696F6E3A6162736F6C7574653B72696768743A303B746F703A307D2E757070792D53637265656E436170747572652D627574746F6E436F6E7461696E6572';
wwv_flow_imp.g_varchar2_table(797) := '7B616C69676E2D6974656D733A63656E7465723B6261636B67726F756E642D636F6C6F723A236666663B626F726465722D746F703A31707820736F6C696420236561656165613B646973706C61793A666C65783B6865696768743A373570783B6A757374';
wwv_flow_imp.g_varchar2_table(798) := '6966792D636F6E74656E743A63656E7465723B70616464696E673A3020323070783B77696474683A313030257D5B646174612D757070792D7468656D653D6461726B5D202E757070792D53637265656E436170747572652D627574746F6E436F6E746169';
wwv_flow_imp.g_varchar2_table(799) := '6E65727B6261636B67726F756E642D636F6C6F723A233166316631663B626F726465722D746F703A31707820736F6C696420233333337D2E757070792D53637265656E436170747572652D627574746F6E7B626F726465722D7261646975733A3530253B';
wwv_flow_imp.g_varchar2_table(800) := '636F6C6F723A236666663B637572736F723A706F696E7465723B6865696768743A343570783B7472616E736974696F6E3A616C6C202E33733B77696474683A343570787D2E757070792D53637265656E436170747572652D627574746F6E3A666F637573';
wwv_flow_imp.g_varchar2_table(801) := '7B6F75746C696E653A6E6F6E657D2E757070792D53637265656E436170747572652D627574746F6E3A3A2D6D6F7A2D666F6375732D696E6E65727B626F726465723A307D2E757070792D53637265656E436170747572652D627574746F6E3A666F637573';
wwv_flow_imp.g_varchar2_table(802) := '7B626F782D736861646F773A302030203020337078202331323639636638307D5B646174612D757070792D7468656D653D6461726B5D202E757070792D53637265656E436170747572652D627574746F6E3A666F6375737B6F75746C696E653A6E6F6E65';
wwv_flow_imp.g_varchar2_table(803) := '7D5B646174612D757070792D7468656D653D6461726B5D202E757070792D53637265656E436170747572652D627574746F6E3A3A2D6D6F7A2D666F6375732D696E6E65727B626F726465723A307D5B646174612D757070792D7468656D653D6461726B5D';
wwv_flow_imp.g_varchar2_table(804) := '202E757070792D53637265656E436170747572652D627574746F6E3A666F6375737B626F782D736861646F773A302030203020327078202361616531666664397D2E757070792D73697A652D2D6D64202E757070792D53637265656E436170747572652D';
wwv_flow_imp.g_varchar2_table(805) := '627574746F6E7B6865696768743A363070783B77696474683A363070787D2E757070792D53637265656E436170747572652D627574746F6E3A686F7665727B6261636B67726F756E642D636F6C6F723A236433316232647D2E757070792D53637265656E';
wwv_flow_imp.g_varchar2_table(806) := '436170747572652D627574746F6E207376677B66696C6C3A63757272656E74436F6C6F723B646973706C61793A696E6C696E652D626C6F636B3B6865696768743A333070783B6D61782D6865696768743A313030253B6D61782D77696474683A31303025';
wwv_flow_imp.g_varchar2_table(807) := '3B6F766572666C6F773A68696464656E3B766572746963616C2D616C69676E3A746578742D746F703B77696474683A333070787D2E757070792D53637265656E436170747572652D627574746F6E2D2D7375626D69747B6261636B67726F756E642D636F';
wwv_flow_imp.g_varchar2_table(808) := '6C6F723A233132363963663B6D617267696E2D6C6566743A313270787D2E757070792D53637265656E436170747572652D627574746F6E2D2D7375626D69743A686F7665727B6261636B67726F756E642D636F6C6F723A233130356462387D2E75707079';
wwv_flow_imp.g_varchar2_table(809) := '2D53637265656E436170747572652D627574746F6E2D2D7375626D69743A64697361626C65647B6261636B67726F756E642D636F6C6F723A233933393339333B637572736F723A64656661756C747D2E757070792D53637265656E436170747572652D62';
wwv_flow_imp.g_varchar2_table(810) := '7574746F6E2D2D7375626D69743A64697361626C65643A686F7665727B6261636B67726F756E642D636F6C6F723A236561656165617D2E757070792D53637265656E436170747572652D7469746C657B636F6C6F723A233333333B666F6E742D73697A65';
wwv_flow_imp.g_varchar2_table(811) := '3A323270783B666F6E742D7765696768743A3430303B6C696E652D6865696768743A312E33353B6D617267696E3A302030203570783B6D61782D77696474683A35303070783B70616464696E673A3020313570783B746578742D616C69676E3A63656E74';
wwv_flow_imp.g_varchar2_table(812) := '65727D2E757070792D53637265656E436170747572652D69636F6E2D2D73747265616D7B6D617267696E3A3172656D3B706F736974696F6E3A6162736F6C7574653B72696768743A303B746F703A303B7A2D696E6465783A317D2E757070792D53637265';
wwv_flow_imp.g_varchar2_table(813) := '656E436170747572652D69636F6E2D2D73747265616D207376677B66696C6C3A233933393339337D2E757070792D53637265656E436170747572652D69636F6E2D2D73747265616D416374697665207376677B616E696D6174696F6E3A757070792D5363';
wwv_flow_imp.g_varchar2_table(814) := '7265656E436170747572652D69636F6E2D2D626C696E6B2031732063756269632D62657A696572282E34372C302C2E37352C2E37322920696E66696E6974657D406B65796672616D657320757070792D53637265656E436170747572652D69636F6E2D2D';
wwv_flow_imp.g_varchar2_table(815) := '626C696E6B7B30257B66696C6C3A233132363963667D3530257B66696C6C3A233933393339337D746F7B66696C6C3A233132363963667D7D2E757070792D53637265656E436170747572652D627574746F6E2D2D766964656F7B6261636B67726F756E64';
wwv_flow_imp.g_varchar2_table(816) := '3A236533323433373B636F6C6F723A236666667D2E757070792D53637265656E436170747572652D627574746F6E2D2D766964656F3A686F7665727B6261636B67726F756E642D636F6C6F723A236263313832387D2E757070792D496D61676543726F70';
wwv_flow_imp.g_varchar2_table(817) := '7065722D72616E67657B2D7765626B69742D617070656172616E63653A6E6F6E653B6261636B67726F756E643A23303030303B6D617267696E3A38707820303B77696474683A313030257D2E757070792D496D61676543726F707065722D72616E67653A';
wwv_flow_imp.g_varchar2_table(818) := '3A2D6D6F7A2D666F6375732D6F757465727B626F726465723A307D2E757070792D496D61676543726F707065722D72616E67653A666F6375737B6F75746C696E653A307D2E757070792D496D61676543726F707065722D72616E67653A666F6375733A3A';
wwv_flow_imp.g_varchar2_table(819) := '2D7765626B69742D736C696465722D72756E6E61626C652D747261636B7B6261636B67726F756E643A23666666337D2E757070792D496D61676543726F707065722D72616E67653A666F6375733A3A2D6D732D66696C6C2D6C6F7765722C2E757070792D';
wwv_flow_imp.g_varchar2_table(820) := '496D61676543726F707065722D72616E67653A666F6375733A3A2D6D732D66696C6C2D75707065727B6261636B67726F756E643A23666666337D2E757070792D496D61676543726F707065722D72616E67653A3A2D7765626B69742D736C696465722D72';
wwv_flow_imp.g_varchar2_table(821) := '756E6E61626C652D747261636B7B6261636B67726F756E643A23666666333B626F726465723A3020736F6C69642023303030303B626F726465722D7261646975733A3570783B626F782D736861646F773A30203020302023303030302C30203020302023';
wwv_flow_imp.g_varchar2_table(822) := '30643064306430303B637572736F723A64656661756C743B6865696768743A3470783B2D7765626B69742D7472616E736974696F6E3A616C6C202E327320656173653B7472616E736974696F6E3A616C6C202E327320656173653B77696474683A313030';
wwv_flow_imp.g_varchar2_table(823) := '257D2E757070792D496D61676543726F707065722D72616E67653A3A2D7765626B69742D736C696465722D7468756D627B2D7765626B69742D617070656172616E63653A6E6F6E653B6261636B67726F756E643A236666663B626F726465723A3020736F';
wwv_flow_imp.g_varchar2_table(824) := '6C69642023303030303B626F726465722D7261646975733A3970783B626F782D736861646F773A302030203470782023303030332C3020302030202330643064306433333B626F782D73697A696E673A626F726465722D626F783B637572736F723A6465';
wwv_flow_imp.g_varchar2_table(825) := '6661756C743B6865696768743A313670783B6D617267696E2D746F703A2D3670783B77696474683A313670787D2E757070792D496D61676543726F707065722D72616E67653A3A2D6D6F7A2D72616E67652D747261636B7B6261636B67726F756E643A23';
wwv_flow_imp.g_varchar2_table(826) := '666666333B626F726465723A3020736F6C69642023303030303B626F726465722D7261646975733A3570783B626F782D736861646F773A30203020302023303030302C3020302030202330643064306430303B637572736F723A64656661756C743B6865';
wwv_flow_imp.g_varchar2_table(827) := '696768743A3270783B2D6D6F7A2D7472616E736974696F6E3A616C6C202E327320656173653B7472616E736974696F6E3A616C6C202E327320656173653B77696474683A313030257D2E757070792D496D61676543726F707065722D72616E67653A3A2D';
wwv_flow_imp.g_varchar2_table(828) := '6D6F7A2D72616E67652D7468756D627B6261636B67726F756E643A236666663B626F726465723A3020736F6C69642023303030303B626F726465722D7261646975733A3970783B626F782D736861646F773A302030203470782023303030332C30203020';
wwv_flow_imp.g_varchar2_table(829) := '30202330643064306433333B626F782D73697A696E673A626F726465722D626F783B637572736F723A64656661756C743B6865696768743A313670783B77696474683A313670787D2E757070792D496D61676543726F707065722D72616E67653A3A2D6D';
wwv_flow_imp.g_varchar2_table(830) := '732D747261636B7B6261636B67726F756E643A23303030303B626F726465722D636F6C6F723A23303030303B626F726465722D77696474683A38707820303B636F6C6F723A23303030303B637572736F723A64656661756C743B6865696768743A347078';
wwv_flow_imp.g_varchar2_table(831) := '3B2D6D732D7472616E736974696F6E3A616C6C202E327320656173653B7472616E736974696F6E3A616C6C202E327320656173653B77696474683A313030257D2E757070792D496D61676543726F707065722D72616E67653A3A2D6D732D66696C6C2D6C';
wwv_flow_imp.g_varchar2_table(832) := '6F7765727B6261636B67726F756E643A2366326632663233333B626F726465723A3020736F6C69642023303030303B626F726465722D7261646975733A313070783B626F782D736861646F773A30203020302023303030302C3020302030202330643064';
wwv_flow_imp.g_varchar2_table(833) := '306430307D2E757070792D496D61676543726F707065722D72616E67653A3A2D6D732D66696C6C2D75707065727B6261636B67726F756E643A23666666333B626F726465723A3020736F6C69642023303030303B626F726465722D7261646975733A3130';
wwv_flow_imp.g_varchar2_table(834) := '70783B626F782D736861646F773A30203020302023303030302C3020302030202330643064306430307D2E757070792D496D61676543726F707065722D72616E67653A3A2D6D732D7468756D627B6261636B67726F756E643A236666663B626F72646572';
wwv_flow_imp.g_varchar2_table(835) := '3A3020736F6C69642023303030303B626F726465722D7261646975733A3970783B626F782D736861646F773A302030203470782023303030332C3020302030202330643064306433333B626F782D73697A696E673A626F726465722D626F783B63757273';
wwv_flow_imp.g_varchar2_table(836) := '6F723A64656661756C743B6865696768743A313670783B6D617267696E2D746F703A3170783B77696474683A313670787D2E757070792D496D61676543726F707065722D72616E67653A64697361626C65643A3A2D6D6F7A2D72616E67652D7468756D62';
wwv_flow_imp.g_varchar2_table(837) := '2C2E757070792D496D61676543726F707065722D72616E67653A64697361626C65643A3A2D6D732D66696C6C2D6C6F7765722C2E757070792D496D61676543726F707065722D72616E67653A64697361626C65643A3A2D6D732D66696C6C2D7570706572';
wwv_flow_imp.g_varchar2_table(838) := '2C2E757070792D496D61676543726F707065722D72616E67653A64697361626C65643A3A2D6D732D7468756D622C2E757070792D496D61676543726F707065722D72616E67653A64697361626C65643A3A2D7765626B69742D736C696465722D72756E6E';
wwv_flow_imp.g_varchar2_table(839) := '61626C652D747261636B2C2E757070792D496D61676543726F707065722D72616E67653A64697361626C65643A3A2D7765626B69742D736C696465722D7468756D627B637572736F723A6E6F742D616C6C6F7765647D0A0A2F2A210A202A2043726F7070';
wwv_flow_imp.g_varchar2_table(840) := '65722E6A732076312E352E360A202A2068747470733A2F2F66656E677975616E6368656E2E6769746875622E696F2F63726F707065726A730A202A0A202A20436F7079726967687420323031352D70726573656E74204368656E2046656E677975616E0A';
wwv_flow_imp.g_varchar2_table(841) := '202A2052656C656173656420756E64657220746865204D4954206C6963656E73650A202A0A202A20446174653A20323031392D31302D30345430343A33333A34342E3136345A0A202A2F2E63726F707065722D636F6E7461696E65727B64697265637469';
wwv_flow_imp.g_varchar2_table(842) := '6F6E3A6C74723B666F6E742D73697A653A303B6C696E652D6865696768743A303B706F736974696F6E3A72656C61746976653B746F7563682D616374696F6E3A6E6F6E653B2D7765626B69742D757365722D73656C6563743A6E6F6E653B757365722D73';
wwv_flow_imp.g_varchar2_table(843) := '656C6563743A6E6F6E657D2E63726F707065722D636F6E7461696E657220696D677B646973706C61793A626C6F636B3B6865696768743A313030253B696D6167652D6F7269656E746174696F6E3A306465673B6D61782D6865696768743A6E6F6E652169';
wwv_flow_imp.g_varchar2_table(844) := '6D706F7274616E743B6D61782D77696474683A6E6F6E6521696D706F7274616E743B6D696E2D6865696768743A3021696D706F7274616E743B6D696E2D77696474683A3021696D706F7274616E743B77696474683A313030257D2E63726F707065722D63';
wwv_flow_imp.g_varchar2_table(845) := '616E7661732C2E63726F707065722D63726F702D626F782C2E63726F707065722D647261672D626F782C2E63726F707065722D6D6F64616C2C2E63726F707065722D777261702D626F787B626F74746F6D3A303B6C6566743A303B706F736974696F6E3A';
wwv_flow_imp.g_varchar2_table(846) := '6162736F6C7574653B72696768743A303B746F703A307D2E63726F707065722D63616E7661732C2E63726F707065722D777261702D626F787B6F766572666C6F773A68696464656E7D2E63726F707065722D647261672D626F787B6261636B67726F756E';
wwv_flow_imp.g_varchar2_table(847) := '642D636F6C6F723A236666663B6F7061636974793A307D2E63726F707065722D6D6F64616C7B6261636B67726F756E642D636F6C6F723A233030303B6F7061636974793A2E357D2E63726F707065722D766965772D626F787B646973706C61793A626C6F';
wwv_flow_imp.g_varchar2_table(848) := '636B3B6865696768743A313030253B6F75746C696E653A31707820736F6C696420233339663B6F75746C696E652D636F6C6F723A2333333939666662663B6F766572666C6F773A68696464656E3B77696474683A313030257D2E63726F707065722D6461';
wwv_flow_imp.g_varchar2_table(849) := '736865647B626F726465723A302064617368656420236565653B646973706C61793A626C6F636B3B6F7061636974793A2E353B706F736974696F6E3A6162736F6C7574657D2E63726F707065722D6461736865642E6461736865642D687B626F72646572';
wwv_flow_imp.g_varchar2_table(850) := '2D626F74746F6D2D77696474683A3170783B626F726465722D746F702D77696474683A3170783B6865696768743A33332E33333333333333333333253B6C6566743A303B746F703A33332E33333333333333333333253B77696474683A313030257D2E63';
wwv_flow_imp.g_varchar2_table(851) := '726F707065722D6461736865642E6461736865642D767B626F726465722D6C6566742D77696474683A3170783B626F726465722D72696768742D77696474683A3170783B6865696768743A313030253B6C6566743A33332E33333333333333333333253B';
wwv_flow_imp.g_varchar2_table(852) := '746F703A303B77696474683A33332E33333333333333333333257D2E63726F707065722D63656E7465727B646973706C61793A626C6F636B3B6865696768743A303B6C6566743A3530253B6F7061636974793A2E37353B706F736974696F6E3A6162736F';
wwv_flow_imp.g_varchar2_table(853) := '6C7574653B746F703A3530253B77696474683A307D2E63726F707065722D63656E7465723A61667465722C2E63726F707065722D63656E7465723A6265666F72657B6261636B67726F756E642D636F6C6F723A236565653B636F6E74656E743A2220223B';
wwv_flow_imp.g_varchar2_table(854) := '646973706C61793A626C6F636B3B706F736974696F6E3A6162736F6C7574657D2E63726F707065722D63656E7465723A6265666F72657B6865696768743A3170783B6C6566743A2D3370783B746F703A303B77696474683A3770787D2E63726F70706572';
wwv_flow_imp.g_varchar2_table(855) := '2D63656E7465723A61667465727B6865696768743A3770783B6C6566743A303B746F703A2D3370783B77696474683A3170787D2E63726F707065722D666163652C2E63726F707065722D6C696E652C2E63726F707065722D706F696E747B646973706C61';
wwv_flow_imp.g_varchar2_table(856) := '793A626C6F636B3B6865696768743A313030253B6F7061636974793A2E313B706F736974696F6E3A6162736F6C7574653B77696474683A313030257D2E63726F707065722D666163657B6261636B67726F756E642D636F6C6F723A236666663B6C656674';
wwv_flow_imp.g_varchar2_table(857) := '3A303B746F703A307D2E63726F707065722D6C696E657B6261636B67726F756E642D636F6C6F723A233339667D2E63726F707065722D6C696E652E6C696E652D657B637572736F723A65772D726573697A653B72696768743A2D3370783B746F703A303B';
wwv_flow_imp.g_varchar2_table(858) := '77696474683A3570787D2E63726F707065722D6C696E652E6C696E652D6E7B637572736F723A6E732D726573697A653B6865696768743A3570783B6C6566743A303B746F703A2D3370787D2E63726F707065722D6C696E652E6C696E652D777B63757273';
wwv_flow_imp.g_varchar2_table(859) := '6F723A65772D726573697A653B6C6566743A2D3370783B746F703A303B77696474683A3570787D2E63726F707065722D6C696E652E6C696E652D737B626F74746F6D3A2D3370783B637572736F723A6E732D726573697A653B6865696768743A3570783B';
wwv_flow_imp.g_varchar2_table(860) := '6C6566743A307D2E63726F707065722D706F696E747B6261636B67726F756E642D636F6C6F723A233339663B6865696768743A3570783B6F7061636974793A2E37353B77696474683A3570787D2E63726F707065722D706F696E742E706F696E742D657B';
wwv_flow_imp.g_varchar2_table(861) := '637572736F723A65772D726573697A653B6D617267696E2D746F703A2D3370783B72696768743A2D3370783B746F703A3530257D2E63726F707065722D706F696E742E706F696E742D6E7B637572736F723A6E732D726573697A653B6C6566743A353025';
wwv_flow_imp.g_varchar2_table(862) := '3B6D617267696E2D6C6566743A2D3370783B746F703A2D3370787D2E63726F707065722D706F696E742E706F696E742D777B637572736F723A65772D726573697A653B6C6566743A2D3370783B6D617267696E2D746F703A2D3370783B746F703A353025';
wwv_flow_imp.g_varchar2_table(863) := '7D2E63726F707065722D706F696E742E706F696E742D737B626F74746F6D3A2D3370783B637572736F723A732D726573697A653B6C6566743A3530253B6D617267696E2D6C6566743A2D3370787D2E63726F707065722D706F696E742E706F696E742D6E';
wwv_flow_imp.g_varchar2_table(864) := '657B637572736F723A6E6573772D726573697A653B72696768743A2D3370783B746F703A2D3370787D2E63726F707065722D706F696E742E706F696E742D6E777B637572736F723A6E7773652D726573697A653B6C6566743A2D3370783B746F703A2D33';
wwv_flow_imp.g_varchar2_table(865) := '70787D2E63726F707065722D706F696E742E706F696E742D73777B626F74746F6D3A2D3370783B637572736F723A6E6573772D726573697A653B6C6566743A2D3370787D2E63726F707065722D706F696E742E706F696E742D73657B626F74746F6D3A2D';
wwv_flow_imp.g_varchar2_table(866) := '3370783B637572736F723A6E7773652D726573697A653B6865696768743A323070783B6F7061636974793A313B72696768743A2D3370783B77696474683A323070787D406D6564696120286D696E2D77696474683A3736387078297B2E63726F70706572';
wwv_flow_imp.g_varchar2_table(867) := '2D706F696E742E706F696E742D73657B6865696768743A313570783B77696474683A313570787D7D406D6564696120286D696E2D77696474683A3939327078297B2E63726F707065722D706F696E742E706F696E742D73657B6865696768743A31307078';
wwv_flow_imp.g_varchar2_table(868) := '3B77696474683A313070787D7D406D6564696120286D696E2D77696474683A313230307078297B2E63726F707065722D706F696E742E706F696E742D73657B6865696768743A3570783B6F7061636974793A2E37353B77696474683A3570787D7D2E6372';
wwv_flow_imp.g_varchar2_table(869) := '6F707065722D706F696E742E706F696E742D73653A6265666F72657B6261636B67726F756E642D636F6C6F723A233339663B626F74746F6D3A2D3530253B636F6E74656E743A2220223B646973706C61793A626C6F636B3B6865696768743A323030253B';
wwv_flow_imp.g_varchar2_table(870) := '6F7061636974793A303B706F736974696F6E3A6162736F6C7574653B72696768743A2D3530253B77696474683A323030257D2E63726F707065722D696E76697369626C657B6F7061636974793A307D2E63726F707065722D62677B6261636B67726F756E';
wwv_flow_imp.g_varchar2_table(871) := '642D696D6167653A75726C2822646174613A696D6167652F706E673B6261736536342C6956424F5277304B47676F414141414E5355684555674141414241414141415141514D414141416C505730694141414141334E435356514943416A6234552F6741';
wwv_flow_imp.g_varchar2_table(872) := '414141426C424D5645584D7A4D7A2F2F2F2F546A525632414141414358424957584D41414172724141414B367747436977316141414141484852465748525462325A30643246795A5142425A4739695A53424761584A6C6432397961334D6751314D3236';
wwv_flow_imp.g_varchar2_table(873) := '4C79796A4141414142464A52454655434A6C6A2B4D2F4167425668462F30504148362F442F486B44784F474141414141456C46546B5375516D434322297D2E63726F707065722D686964657B646973706C61793A626C6F636B3B6865696768743A303B70';
wwv_flow_imp.g_varchar2_table(874) := '6F736974696F6E3A6162736F6C7574653B77696474683A307D2E63726F707065722D68696464656E7B646973706C61793A6E6F6E6521696D706F7274616E747D2E63726F707065722D6D6F76657B637572736F723A6D6F76657D2E63726F707065722D63';
wwv_flow_imp.g_varchar2_table(875) := '726F707B637572736F723A63726F7373686169727D2E63726F707065722D64697361626C6564202E63726F707065722D647261672D626F782C2E63726F707065722D64697361626C6564202E63726F707065722D666163652C2E63726F707065722D6469';
wwv_flow_imp.g_varchar2_table(876) := '7361626C6564202E63726F707065722D6C696E652C2E63726F707065722D64697361626C6564202E63726F707065722D706F696E747B637572736F723A6E6F742D616C6C6F7765647D2E757070792D496D61676543726F707065727B646973706C61793A';
wwv_flow_imp.g_varchar2_table(877) := '666C65783B666C65782D646972656374696F6E3A636F6C756D6E3B6865696768743A313030253B77696474683A313030257D2E757070792D496D61676543726F707065722D636F6E7461696E65727B666C65782D67726F773A317D2E757070792D496D61';
wwv_flow_imp.g_varchar2_table(878) := '676543726F707065722D696D6167657B646973706C61793A626C6F636B3B6D61782D6865696768743A34303070783B6D61782D77696474683A313030257D2E757070792D496D61676543726F707065722D636F6E74726F6C737B616C69676E2D6974656D';
wwv_flow_imp.g_varchar2_table(879) := '733A63656E7465723B6261636B67726F756E642D636F6C6F723A23303030393B626F726465722D7261646975733A3570783B626F74746F6D3A313570783B636F6C6F723A236666663B646973706C61793A666C65783B6A7573746966792D636F6E74656E';
wwv_flow_imp.g_varchar2_table(880) := '743A63656E7465723B6C6566743A3530253B70616464696E672D746F703A333870783B706F736974696F6E3A6162736F6C7574653B7472616E73666F726D3A7472616E736C61746558282D353025297D2E757070792D73697A652D2D6D64202E75707079';
wwv_flow_imp.g_varchar2_table(881) := '2D496D61676543726F707065722D636F6E74726F6C737B70616464696E672D746F703A307D2E757070792D496D61676543726F707065722D636F6E74726F6C7320627574746F6E7B626F726465722D7261646975733A3570783B6865696768743A333570';
wwv_flow_imp.g_varchar2_table(882) := '783B77696474683A333570787D2E757070792D496D61676543726F707065722D636F6E74726F6C7320627574746F6E207376677B70616464696E673A3370787D2E757070792D73697A652D2D6D64202E757070792D496D61676543726F707065722D636F';
wwv_flow_imp.g_varchar2_table(883) := '6E74726F6C7320627574746F6E7B6865696768743A343070783B77696474683A343070787D2E757070792D73697A652D2D6D64202E757070792D496D61676543726F707065722D636F6E74726F6C7320627574746F6E207376677B70616464696E673A31';
wwv_flow_imp.g_varchar2_table(884) := '70787D2E757070792D496D61676543726F707065722D636F6E74726F6C7320627574746F6E3A686F7665727B6261636B67726F756E642D636F6C6F723A2366666666666638307D2E757070792D496D61676543726F707065722D636F6E74726F6C732062';
wwv_flow_imp.g_varchar2_table(885) := '7574746F6E3A666F6375737B6261636B67726F756E642D636F6C6F723A2366666666666638303B6F75746C696E653A6E6F6E657D2E757070792D44617368626F6172643A6E6F74282E757070792D73697A652D2D6D6429202E757070792D496D61676543';
wwv_flow_imp.g_varchar2_table(886) := '726F707065722D72616E6765577261707065727B6865696768743A333870783B6C6566743A313070783B706F736974696F6E3A6162736F6C75746521696D706F7274616E743B72696768743A313070783B746F703A307D2E757070792D73697A652D2D6D';
wwv_flow_imp.g_varchar2_table(887) := '64202E757070792D496D61676543726F707065722D72616E67657B6D617267696E2D6C6566743A3570783B6D617267696E2D72696768743A3570783B77696474683A31383070787D2E757070792D496D61676543726F70706572202E63726F707065722D';
wwv_flow_imp.g_varchar2_table(888) := '706F696E747B6865696768743A3870783B77696474683A3870787D2E757070792D496D61676543726F70706572202E63726F707065722D766965772D626F787B6261636B67726F756E643A726570656174696E672D636F6E69632D6772616469656E7428';
wwv_flow_imp.g_varchar2_table(889) := '2362646264626433332030203235252C2366666620302035302529203530252F3136707820313670783B6F75746C696E653A32707820736F6C696420233339667D5B646174612D757070792D7468656D653D6461726B5D202E757070792D496D61676543';
wwv_flow_imp.g_varchar2_table(890) := '726F70706572202E63726F707065722D766965772D626F787B6261636B67726F756E643A726570656174696E672D636F6E69632D6772616469656E7428233262326132612030203235252C2330303020302035302529203530252F313670782031367078';
wwv_flow_imp.g_varchar2_table(891) := '7D2E757070792D496D61676543726F70706572202E63726F707065722D6D6F64616C7B6261636B67726F756E642D636F6C6F723A236666663B6F7061636974793A2E397D5B646174612D757070792D7468656D653D6461726B5D202E757070792D496D61';
wwv_flow_imp.g_varchar2_table(892) := '676543726F70706572202E63726F707065722D6D6F64616C7B6261636B67726F756E642D636F6C6F723A233030303B6F7061636974793A2E377D2E757070792D496D61676543726F70706572202E63726F707065722D666163657B6F7061636974793A30';
wwv_flow_imp.g_varchar2_table(893) := '7D2E757070792D496D61676543726F707065722D72616E67653A3A2D6D6F7A2D72616E67652D747261636B7B6865696768743A3470787D2E757070792D496D61676543726F707065722D72616E67653A666F6375733A3A2D7765626B69742D736C696465';
wwv_flow_imp.g_varchar2_table(894) := '722D72756E6E61626C652D747261636B2C2E757070792D496D61676543726F707065722D72616E67653A686F7665723A3A2D7765626B69742D736C696465722D72756E6E61626C652D747261636B7B6261636B67726F756E643A2366666666666638307D';
wwv_flow_imp.g_varchar2_table(895) := '2E757070792D496D61676543726F707065722D72616E67653A666F6375733A3A2D6D732D66696C6C2D6C6F7765722C2E757070792D496D61676543726F707065722D72616E67653A666F6375733A3A2D6D732D66696C6C2D75707065722C2E757070792D';
wwv_flow_imp.g_varchar2_table(896) := '496D61676543726F707065722D72616E67653A686F7665723A3A2D6D732D66696C6C2D6C6F7765722C2E757070792D496D61676543726F707065722D72616E67653A686F7665723A3A2D6D732D66696C6C2D75707065727B6261636B67726F756E643A23';
wwv_flow_imp.g_varchar2_table(897) := '66666666666638307D2E757070792D496D61676543726F707065722D72616E67653A666F6375733A3A2D6D6F7A2D72616E67652D747261636B2C2E757070792D496D61676543726F707065722D72616E67653A686F7665723A3A2D6D6F7A2D72616E6765';
wwv_flow_imp.g_varchar2_table(898) := '2D747261636B7B6261636B67726F756E643A2366666666666638307D2E757070792D69732D647261672D6F7665723A61667465727B6261636B67726F756E642D636F6C6F723A2365616561656138303B626F726465723A35707820646173686564202362';
wwv_flow_imp.g_varchar2_table(899) := '62623B626F74746F6D3A3770783B636F6E74656E743A22223B6C6566743A3770783B706F736974696F6E3A66697865643B72696768743A3770783B746F703A3770783B7A2D696E6465783A31303030307D';
null;
end;
/
begin
wwv_flow_imp_shared.create_plugin_file(
 p_id=>wwv_flow_imp.id(740463456760162541)
,p_plugin_id=>wwv_flow_imp.id(739921988389392679)
,p_file_name=>'dist/uppy.min.css'
,p_mime_type=>'text/css'
,p_file_charset=>'utf-8'
,p_file_content=>wwv_flow_imp.varchar2_to_blob(wwv_flow_imp.g_varchar2_table)
);
end;
/
begin
wwv_flow_imp.g_varchar2_table := wwv_flow_imp.empty_varchar2_table;
wwv_flow_imp.g_varchar2_table(1) := '7B2276657273696F6E223A332C22736F7572636573223A5B226D61696E2E6A73225D2C226E616D6573223A5B22636F6D706F6E656E74222C22696E6974222C22616374696F6E222C2274686973222C22616A61784964656E746966696572222C22726573';
wwv_flow_imp.g_varchar2_table(2) := '7472696374696F6E73222C224A534F4E222C227061727365222C226174747269627574653031222C2264617368626F6172644F7074696F6E73222C226174747269627574653032222C22696D616765456469746F72222C22617474726962757465303322';
wwv_flow_imp.g_varchar2_table(3) := '2C22746172676574456C656D656E74222C226174747269627574653034222C226164646974696F6E616C4665617475726573222C226174747269627574653035222C227573655072657369676E55726C222C226174747269627574653037222C22746865';
wwv_flow_imp.g_varchar2_table(4) := '6D65222C226174747269627574653038222C226F6E436F6D706C65746543616C6C6261636B222C226174747269627574653039222C226C6F63616C655061636B222C226174747269627574653130222C2264657374696E6174696F6E222C226174747269';
wwv_flow_imp.g_varchar2_table(5) := '627574653131222C22757070794964222C226174747269627574653132222C2244617465222C226E6F77222C2275707079222C2255707079222C226175746F50726F63656564222C226C6F63616C65222C226C6F63616C6573222C226964222C22757365';
wwv_flow_imp.g_varchar2_table(6) := '222C2244617368626F617264222C2270726F75646C79446973706C6179506F7765726564427955707079222C22746172676574222C22616C6C6F774D756C7469706C6555706C6F616473222C22696E6C696E65222C227265706C61636554617267657443';
wwv_flow_imp.g_varchar2_table(7) := '6F6E74656E74222C2273686F7750726F677265737344657461696C73222C2262726F777365724261636B427574746F6E436C6F7365222C226869646555706C6F6164427574746F6E222C226869646550726F6772657373416674657246696E697368222C';
wwv_flow_imp.g_varchar2_table(8) := '22496D616765456469746F72222C22736561726368222C22417564696F222C2273686F77417564696F536F7572636544726F70646F776E222C2257656263616D222C2273686F77566964656F536F7572636544726F70646F776E222C2253637265656E43';
wwv_flow_imp.g_varchar2_table(9) := '617074757265222C226173796E63222C2266696C65222C2270757455726C222C2261706578222C22736572766572222C22706C7567696E222C22783031222C226E616D65222C22783032222C2274797065222C22783033222C22657874656E73696F6E22';
wwv_flow_imp.g_varchar2_table(10) := '2C22783034222C2273697A65222C226461746154797065222C2273756363657373222C2275706C6F61644C696E6B222C226D6574686F64222C2275726C222C226669656C6473222C2268656164657273222C226F6E222C226576616C225D2C226D617070';
wwv_flow_imp.g_varchar2_table(11) := '696E6773223A22414151412C4D41414D412C554141592C4341436842432C4B41414D2C5741454A2C4D41414D432C4F414153432C4B41414B442C4F414564452C6541416942462C4F41414F452C6541457842432C6141417142432C4B41414B432C4D4141';
wwv_flow_imp.g_varchar2_table(12) := '4D4C2C4F41414F4D2C6141437643432C694241417142482C4B41414B432C4D41414D4C2C4F41414F512C6141437643432C59414136432C4D41417642542C4F41414F552C5941433742432C6341417142582C4F41414F592C5941433542432C6D42414171';
wwv_flow_imp.g_varchar2_table(13) := '42622C4F41414F632C614141652C5141433343432C63414136432C4D41417642662C4F41414F67422C5941433742432C4D414171426A422C4F41414F6B422C5941433542432C6D42414171426E422C4F41414F6F422C5941433542432C57414171427242';
wwv_flow_imp.g_varchar2_table(14) := '2C4F41414F73422C5941433542432C594141714276422C4F41414F77422C5941433542432C4F414171427A422C4F41414F30422C61414165432C4B41414B432C4D41456844432C4B41414F2C49414149432C4B41414B412C4B41414B2C4341437A42432C';
wwv_flow_imp.g_varchar2_table(15) := '614141612C45414362432C4F414151462C4B41414B472C514141515A2C5941437242612C47414149542C4F41434A74422C61414141412C65413644462C4F4131444130422C4B41414B4D2C494141494C2C4B41414B4D2C554141572C4341437642432C36';
wwv_flow_imp.g_varchar2_table(16) := '42414136422C4541433742432C4F41415133422C6341435234422C7342414173422C4541437442432C514141512C45414352432C7342414173422C4541437442432C7142414171422C45414372427A422C4D414141412C4D41434130422C774241417742';
wwv_flow_imp.g_varchar2_table(17) := '2C4541437842432C6B4241416B422C4541436C42432C7942414179422C4B4143744274432C6D4241474C452C614143416F422C4B41414B4D2C494141494C2C4B41414B67422C594141612C43414145522C4F414151522C4B41414B4D2C59414531437642';
wwv_flow_imp.g_varchar2_table(18) := '2C6D4241416D426B432C4F41414F2C554141592C47414374436C422C4B41414B4D2C494141494C2C4B41414B6B422C4D41414F2C43414143562C4F414151522C4B41414B4D2C55414157612C7942414179422C494145764570432C6D4241416D426B432C';
wwv_flow_imp.g_varchar2_table(19) := '4F41414F2C574141612C47414376436C422C4B41414B4D2C494141494C2C4B41414B6F422C4F4141512C434141435A2C4F414151522C4B41414B4D2C55414157652C7942414179422C494145784574432C6D4241416D426B432C4F41414F2C6D42414171';
wwv_flow_imp.g_varchar2_table(20) := '422C4741432F436C422C4B41414B4D2C494141494C2C4B41414B73422C634141652C43414145642C4F414151522C4B41414B4D2C59414535422C5541416842622C614143414D2C4B41414B4D2C494141494C2C4B41414B502C614141632C434143314238';
wwv_flow_imp.g_varchar2_table(21) := '422C304241413242432C4741437A422C49414149432C45416B424A2C4F4168424978432C714241434979432C4B41414B432C4F41414F432C4F4143684278442C654143412C4341434579442C4941414B4C2C4541414B4D2C4B414356432C4941414B502C';
wwv_flow_imp.g_varchar2_table(22) := '4541414B512C4B414356432C4941414B542C4541414B552C55414356432C4941414B582C4541414B592C4D41455A2C43414345432C534141552C4F414356432C51414155432C47414165642C45414153632C49414B6A432C4341434C432C4F4141512C4D';
wwv_flow_imp.g_varchar2_table(23) := '414352432C4941414B68422C4541434C69422C4F4141512C4B414352432C514141532C434141432C65414167422C474141476E422C4541414B512C3242414B78436A432C4B41414B36432C474141472C57414159432C4B41414B78442C714241456C4255';
wwv_flow_imp.g_varchar2_table(24) := '222C2266696C65223A226D61696E2E6A73227D';
null;
end;
/
begin
wwv_flow_imp_shared.create_plugin_file(
 p_id=>wwv_flow_imp.id(740466693043181421)
,p_plugin_id=>wwv_flow_imp.id(739921988389392679)
,p_file_name=>'js/main.js.map'
,p_mime_type=>'application/octet-stream'
,p_file_charset=>'utf-8'
,p_file_content=>wwv_flow_imp.varchar2_to_blob(wwv_flow_imp.g_varchar2_table)
);
end;
/
begin
wwv_flow_imp.g_varchar2_table := wwv_flow_imp.empty_varchar2_table;
wwv_flow_imp.g_varchar2_table(1) := '2828293D3E7B76617220653D7B706C7572616C697A65286F297B72657475726E206F3D3D3D313F303A317D7D3B652E737472696E67733D7B61646442756C6B46696C65734661696C65643A7B303A224661696C656420746F2061646420257B736D617274';
wwv_flow_imp.g_varchar2_table(2) := '5F636F756E747D2066696C652064756520746F20616E20696E7465726E616C206572726F72222C313A224661696C656420746F2061646420257B736D6172745F636F756E747D2066696C65732064756520746F20696E7465726E616C206572726F727322';
wwv_flow_imp.g_varchar2_table(3) := '7D2C616464696E674D6F726546696C65733A22416464696E67206D6F72652066696C6573222C6164644D6F72653A22416464206D6F7265222C6164644D6F726546696C65733A22416464206D6F72652066696C6573222C616C6C46696C657346726F6D46';
wwv_flow_imp.g_varchar2_table(4) := '6F6C6465724E616D65643A22416C6C2066696C65732066726F6D20666F6C64657220257B6E616D657D222C616C6C6F774163636573734465736372697074696F6E3A22496E206F7264657220746F2074616B65207069637475726573206F72207265636F';
wwv_flow_imp.g_varchar2_table(5) := '726420766964656F207769746820796F75722063616D6572612C20706C6561736520616C6C6F772063616D6572612061636365737320666F72207468697320736974652E222C616C6C6F774163636573735469746C653A22506C6561736520616C6C6F77';
wwv_flow_imp.g_varchar2_table(6) := '2061636365737320746F20796F75722063616D657261222C616C6C6F77417564696F4163636573734465736372697074696F6E3A22496E206F7264657220746F207265636F726420617564696F2C20706C6561736520616C6C6F77206D6963726F70686F';
wwv_flow_imp.g_varchar2_table(7) := '6E652061636365737320666F72207468697320736974652E222C616C6C6F77417564696F4163636573735469746C653A22506C6561736520616C6C6F772061636365737320746F20796F7572206D6963726F70686F6E65222C617370656374526174696F';
wwv_flow_imp.g_varchar2_table(8) := '4C616E6473636170653A2243726F70206C616E647363617065202831363A3929222C617370656374526174696F506F7274726169743A2243726F7020706F7274726169742028393A313629222C617370656374526174696F5371756172653A2243726F70';
wwv_flow_imp.g_varchar2_table(9) := '20737175617265222C6175746841626F727465643A2241757468656E7469636174696F6E2061626F72746564222C61757468656E746963617465576974683A22436F6E6E65637420746F20257B706C7567696E4E616D657D222C61757468656E74696361';
wwv_flow_imp.g_varchar2_table(10) := '7465576974685469746C653A22506C656173652061757468656E746963617465207769746820257B706C7567696E4E616D657D20746F2073656C6563742066696C6573222C6261636B3A224261636B222C62726F7773653A2262726F777365222C62726F';
wwv_flow_imp.g_varchar2_table(11) := '77736546696C65733A2262726F7773652066696C6573222C62726F777365466F6C646572733A2262726F77736520666F6C64657273222C63616E63656C3A2243616E63656C222C63616E63656C55706C6F61643A2243616E63656C2075706C6F6164222C';
wwv_flow_imp.g_varchar2_table(12) := '63686F6F736546696C65733A2243686F6F73652066696C6573222C636C6F73654D6F64616C3A22436C6F7365204D6F64616C222C636F6D70616E696F6E4572726F723A22436F6E6E656374696F6E207769746820436F6D70616E696F6E206661696C6564';
wwv_flow_imp.g_varchar2_table(13) := '222C636F6D70616E696F6E556E617574686F72697A6548696E743A22546F20756E617574686F72697A6520746F20796F757220257B70726F76696465727D206163636F756E742C20706C6561736520676F20746F20257B75726C7D222C636F6D706C6574';
wwv_flow_imp.g_varchar2_table(14) := '653A22436F6D706C657465222C636F6D70726573736564583A22536176656420257B73697A657D20627920636F6D7072657373696E6720696D61676573222C636F6D7072657373696E67496D616765733A22436F6D7072657373696E6720696D61676573';
wwv_flow_imp.g_varchar2_table(15) := '2E2E2E222C636F6E6E6563746564546F496E7465726E65743A22436F6E6E656374656420746F2074686520496E7465726E6574222C636F70794C696E6B3A22436F7079206C696E6B222C636F70794C696E6B546F436C6970626F61726446616C6C626163';
wwv_flow_imp.g_varchar2_table(16) := '6B3A22436F7079207468652055524C2062656C6F77222C636F70794C696E6B546F436C6970626F617264537563636573733A224C696E6B20636F7069656420746F20636C6970626F6172642E222C6372656174696E67417373656D626C793A2250726570';
wwv_flow_imp.g_varchar2_table(17) := '6172696E672075706C6F61642E2E2E222C6372656174696E67417373656D626C794661696C65643A225472616E736C6F616469743A20436F756C64206E6F742063726561746520417373656D626C79222C64617368626F6172645469746C653A22557070';
wwv_flow_imp.g_varchar2_table(18) := '792044617368626F617264222C64617368626F61726457696E646F775469746C653A22557070792044617368626F6172642057696E646F77202850726573732065736361706520746F20636C6F736529222C6461746155706C6F616465644F66546F7461';
wwv_flow_imp.g_varchar2_table(19) := '6C3A22257B636F6D706C6574657D206F6620257B746F74616C7D222C646973636172645265636F7264656446696C653A2244697363617264207265636F726465642066696C65222C646F6E653A22446F6E65222C64726F70486572654F723A2244726F70';
wwv_flow_imp.g_varchar2_table(20) := '2068657265206F7220257B62726F7773657D222C64726F7048696E743A2244726F7020796F75722066696C65732068657265222C64726F705061737465426F74683A2244726F702066696C657320686572652C20257B62726F77736546696C65737D206F';
wwv_flow_imp.g_varchar2_table(21) := '7220257B62726F777365466F6C646572737D222C64726F70506173746546696C65733A2244726F702066696C65732068657265206F7220257B62726F77736546696C65737D222C64726F705061737465466F6C646572733A2244726F702066696C657320';
wwv_flow_imp.g_varchar2_table(22) := '68657265206F7220257B62726F777365466F6C646572737D222C64726F705061737465496D706F7274426F74683A2244726F702066696C657320686572652C20257B62726F77736546696C65737D2C20257B62726F777365466F6C646572737D206F7220';
wwv_flow_imp.g_varchar2_table(23) := '696D706F72742066726F6D3A222C64726F705061737465496D706F727446696C65733A2244726F702066696C657320686572652C20257B62726F77736546696C65737D206F7220696D706F72742066726F6D3A222C64726F705061737465496D706F7274';
wwv_flow_imp.g_varchar2_table(24) := '466F6C646572733A2244726F702066696C657320686572652C20257B62726F777365466F6C646572737D206F7220696D706F72742066726F6D3A222C6564697446696C653A22456469742066696C65222C6564697446696C655769746846696C656E616D';
wwv_flow_imp.g_varchar2_table(25) := '653A22456469742066696C6520257B66696C657D222C65646974696E673A2245646974696E6720257B66696C657D222C656D707479466F6C64657241646465643A224E6F2066696C657320776572652061646465642066726F6D20656D70747920666F6C';
wwv_flow_imp.g_varchar2_table(26) := '646572222C656E636F64696E673A22456E636F64696E672E2E2E222C656E746572436F727265637455726C3A22496E636F72726563742055524C3A20506C65617365206D616B65207375726520796F752061726520656E746572696E6720612064697265';
wwv_flow_imp.g_varchar2_table(27) := '6374206C696E6B20746F20612066696C65222C656E74657254657874546F5365617263683A22456E746572207465787420746F2073656172636820666F7220696D61676573222C656E74657255726C546F496D706F72743A22456E7465722055524C2074';
wwv_flow_imp.g_varchar2_table(28) := '6F20696D706F727420612066696C65222C6578636565647353697A653A22257B66696C657D2065786365656473206D6178696D756D20616C6C6F7765642073697A65206F6620257B73697A657D222C6661696C6564546F46657463683A22436F6D70616E';
wwv_flow_imp.g_varchar2_table(29) := '696F6E206661696C656420746F20666574636820746869732055524C2C20706C65617365206D616B6520737572652069745C75323031397320636F7272656374222C6661696C6564546F55706C6F61643A224661696C656420746F2075706C6F61642025';
wwv_flow_imp.g_varchar2_table(30) := '7B66696C657D222C66696C657355706C6F616465644F66546F74616C3A7B303A22257B636F6D706C6574657D206F6620257B736D6172745F636F756E747D2066696C652075706C6F61646564222C313A22257B636F6D706C6574657D206F6620257B736D';
wwv_flow_imp.g_varchar2_table(31) := '6172745F636F756E747D2066696C65732075706C6F61646564227D2C66696C7465723A2246696C746572222C66696E69736845646974696E6746696C653A2246696E6973682065646974696E672066696C65222C666C6970486F72697A6F6E74616C3A22';
wwv_flow_imp.g_varchar2_table(32) := '466C697020686F72697A6F6E74616C222C666F6C64657241646465643A7B303A22416464656420257B736D6172745F636F756E747D2066696C652066726F6D20257B666F6C6465727D222C313A22416464656420257B736D6172745F636F756E747D2066';
wwv_flow_imp.g_varchar2_table(33) := '696C65732066726F6D20257B666F6C6465727D227D2C666F6C646572416C726561647941646465643A2754686520666F6C6465722022257B666F6C6465727D222077617320616C7265616479206164646564272C67656E65726174696E675468756D626E';
wwv_flow_imp.g_varchar2_table(34) := '61696C733A2247656E65726174696E67207468756D626E61696C732E2E2E222C696D706F72743A22496D706F7274222C696D706F727446696C65733A22496D706F72742066696C65732066726F6D3A222C696D706F727446726F6D3A22496D706F727420';
wwv_flow_imp.g_varchar2_table(35) := '66726F6D20257B6E616D657D222C696E666572696F7253697A653A22546869732066696C6520697320736D616C6C6572207468616E2074686520616C6C6F7765642073697A65206F6620257B73697A657D222C6C6F6164696E673A224C6F6164696E672E';
wwv_flow_imp.g_varchar2_table(36) := '2E2E222C6C6F674F75743A224C6F67206F7574222C6D696344697361626C65643A224D6963726F70686F6E65206163636573732064656E6965642062792075736572222C6D697373696E6752657175697265644D6574614669656C643A224D697373696E';
wwv_flow_imp.g_varchar2_table(37) := '67207265717569726564206D657461206669656C6473222C6D697373696E6752657175697265644D6574614669656C644F6E46696C653A224D697373696E67207265717569726564206D657461206669656C647320696E20257B66696C654E616D657D22';
wwv_flow_imp.g_varchar2_table(38) := '2C6D697373696E6752657175697265644D6574614669656C64733A7B303A224D697373696E67207265717569726564206D657461206669656C643A20257B6669656C64737D2E222C313A224D697373696E67207265717569726564206D65746120666965';
wwv_flow_imp.g_varchar2_table(39) := '6C64733A20257B6669656C64737D2E227D2C6D794465766963653A224D7920446576696365222C6E6F417564696F4465736372697074696F6E3A22496E206F7264657220746F207265636F726420617564696F2C20706C6561736520636F6E6E65637420';
wwv_flow_imp.g_varchar2_table(40) := '61206D6963726F70686F6E65206F7220616E6F7468657220617564696F20696E70757420646576696365222C6E6F417564696F5469746C653A224D6963726F70686F6E65204E6F7420417661696C61626C65222C6E6F43616D6572614465736372697074';
wwv_flow_imp.g_varchar2_table(41) := '696F6E3A22496E206F7264657220746F2074616B65207069637475726573206F72207265636F726420766964656F2C20706C6561736520636F6E6E65637420612063616D65726120646576696365222C6E6F43616D6572615469746C653A2243616D6572';
wwv_flow_imp.g_varchar2_table(42) := '61204E6F7420417661696C61626C65222C6E6F4475706C6963617465733A2243616E6E6F742061646420746865206475706C69636174652066696C652027257B66696C654E616D657D272C20697420616C726561647920657869737473222C6E6F46696C';
wwv_flow_imp.g_varchar2_table(43) := '6573466F756E643A22596F752068617665206E6F2066696C6573206F7220666F6C646572732068657265222C6E6F496E7465726E6574436F6E6E656374696F6E3A224E6F20496E7465726E657420636F6E6E656374696F6E222C6E6F4D6F726546696C65';
wwv_flow_imp.g_varchar2_table(44) := '73416C6C6F7765643A2243616E6E6F7420616464206D6F72652066696C6573222C6F70656E466F6C6465724E616D65643A224F70656E20666F6C64657220257B6E616D657D222C70617573653A225061757365222C7061757365643A2250617573656422';
wwv_flow_imp.g_varchar2_table(45) := '2C706175736555706C6F61643A2250617573652075706C6F6164222C706C7567696E4E616D65417564696F3A22417564696F222C706C7567696E4E616D65426F783A22426F78222C706C7567696E4E616D6543616D6572613A2243616D657261222C706C';
wwv_flow_imp.g_varchar2_table(46) := '7567696E4E616D6544726F70626F783A2244726F70626F78222C706C7567696E4E616D6546616365626F6F6B3A2246616365626F6F6B222C706C7567696E4E616D65476F6F676C6544726976653A22476F6F676C65204472697665222C706C7567696E4E';
wwv_flow_imp.g_varchar2_table(47) := '616D65496E7374616772616D3A22496E7374616772616D222C706C7567696E4E616D654F6E6544726976653A224F6E654472697665222C706C7567696E4E616D655A6F6F6D3A225A6F6F6D222C706F776572656442793A22506F77657265642062792025';
wwv_flow_imp.g_varchar2_table(48) := '7B757070797D222C70726F63657373696E675846696C65733A7B303A2250726F63657373696E6720257B736D6172745F636F756E747D2066696C65222C313A2250726F63657373696E6720257B736D6172745F636F756E747D2066696C6573227D2C7265';
wwv_flow_imp.g_varchar2_table(49) := '636F7264696E673A225265636F7264696E67222C7265636F7264696E674C656E6774683A225265636F7264696E67206C656E67746820257B7265636F7264696E675F6C656E6774687D222C7265636F7264696E6753746F707065644D617853697A653A22';
wwv_flow_imp.g_varchar2_table(50) := '5265636F7264696E672073746F707065642062656361757365207468652066696C652073697A652069732061626F757420746F2065786365656420746865206C696D6974222C7265636F7264566964656F42746E3A225265636F726420566964656F222C';
wwv_flow_imp.g_varchar2_table(51) := '7265636F7665726564416C6C46696C65733A22576520726573746F72656420616C6C2066696C65732E20596F752063616E206E6F7720726573756D65207468652075706C6F61642E222C7265636F76657265645846696C65733A7B303A22576520636F75';
wwv_flow_imp.g_varchar2_table(52) := '6C64206E6F742066756C6C79207265636F76657220312066696C652E20506C656173652072652D73656C65637420697420616E6420726573756D65207468652075706C6F61642E222C313A22576520636F756C64206E6F742066756C6C79207265636F76';
wwv_flow_imp.g_varchar2_table(53) := '657220257B736D6172745F636F756E747D2066696C65732E20506C656173652072652D73656C656374207468656D20616E6420726573756D65207468652075706C6F61642E227D2C72656D6F766546696C653A2252656D6F76652066696C65222C726553';
wwv_flow_imp.g_varchar2_table(54) := '656C6563743A2252652D73656C656374222C726573657446696C7465723A2252657365742066696C746572222C726573756D653A22526573756D65222C726573756D6555706C6F61643A22526573756D652075706C6F6164222C72657472793A22526574';
wwv_flow_imp.g_varchar2_table(55) := '7279222C726574727955706C6F61643A2252657472792075706C6F6164222C7265766572743A22526576657274222C726F746174653A22526F74617465222C736176653A2253617665222C736176654368616E6765733A2253617665206368616E676573';
wwv_flow_imp.g_varchar2_table(56) := '222C7365617263683A22536561726368222C736561726368496D616765733A2253656172636820666F7220696D61676573222C73656C656374583A7B303A2253656C65637420257B736D6172745F636F756E747D222C313A2253656C65637420257B736D';
wwv_flow_imp.g_varchar2_table(57) := '6172745F636F756E747D227D2C73657373696F6E526573746F7265643A2253657373696F6E20726573746F726564222C73686F774572726F7244657461696C733A2253686F77206572726F722064657461696C73222C7369676E496E57697468476F6F67';
wwv_flow_imp.g_varchar2_table(58) := '6C653A225369676E20696E207769746820476F6F676C65222C736D696C653A22536D696C6521222C7374617274417564696F5265636F7264696E673A22426567696E20617564696F207265636F7264696E67222C7374617274436170747572696E673A22';
wwv_flow_imp.g_varchar2_table(59) := '426567696E2073637265656E20636170747572696E67222C73746172745265636F7264696E673A22426567696E20766964656F207265636F7264696E67222C73746F70417564696F5265636F7264696E673A2253746F7020617564696F207265636F7264';
wwv_flow_imp.g_varchar2_table(60) := '696E67222C73746F70436170747572696E673A2253746F702073637265656E20636170747572696E67222C73746F705265636F7264696E673A2253746F7020766964656F207265636F7264696E67222C73747265616D4163746976653A2253747265616D';
wwv_flow_imp.g_varchar2_table(61) := '20616374697665222C73747265616D506173736976653A2253747265616D2070617373697665222C7375626D69745265636F7264656446696C653A225375626D6974207265636F726465642066696C65222C74616B65506963747572653A2254616B6520';
wwv_flow_imp.g_varchar2_table(62) := '612070696374757265222C74616B655069637475726542746E3A2254616B652050696374757265222C74696D65644F75743A2255706C6F6164207374616C6C656420666F7220257B7365636F6E64737D207365636F6E64732C2061626F7274696E672E22';
wwv_flow_imp.g_varchar2_table(63) := '2C75706C6F61643A2255706C6F6164222C75706C6F6164436F6D706C6574653A2255706C6F616420636F6D706C657465222C75706C6F61644661696C65643A2255706C6F6164206661696C6564222C75706C6F6164696E673A2255706C6F6164696E6722';
wwv_flow_imp.g_varchar2_table(64) := '2C75706C6F6164696E675846696C65733A7B303A2255706C6F6164696E6720257B736D6172745F636F756E747D2066696C65222C313A2255706C6F6164696E6720257B736D6172745F636F756E747D2066696C6573227D2C75706C6F6164506175736564';
wwv_flow_imp.g_varchar2_table(65) := '3A2255706C6F616420706175736564222C75706C6F61645846696C65733A7B303A2255706C6F616420257B736D6172745F636F756E747D2066696C65222C313A2255706C6F616420257B736D6172745F636F756E747D2066696C6573227D2C75706C6F61';
wwv_flow_imp.g_varchar2_table(66) := '64584E657746696C65733A7B303A2255706C6F6164202B257B736D6172745F636F756E747D2066696C65222C313A2255706C6F6164202B257B736D6172745F636F756E747D2066696C6573227D2C7846696C657353656C65637465643A7B303A22257B73';
wwv_flow_imp.g_varchar2_table(67) := '6D6172745F636F756E747D2066696C652073656C6563746564222C313A22257B736D6172745F636F756E747D2066696C65732073656C6563746564227D2C784D6F726546696C657341646465643A7B303A22257B736D6172745F636F756E747D206D6F72';
wwv_flow_imp.g_varchar2_table(68) := '652066696C65206164646564222C313A22257B736D6172745F636F756E747D206D6F72652066696C6573206164646564227D2C7854696D654C6566743A22257B74696D657D206C656674222C796F7543616E4F6E6C7955706C6F616446696C6554797065';
wwv_flow_imp.g_varchar2_table(69) := '733A22596F752063616E206F6E6C792075706C6F61643A20257B74797065737D222C796F7543616E4F6E6C7955706C6F6164583A7B303A22596F752063616E206F6E6C792075706C6F616420257B736D6172745F636F756E747D2066696C65222C313A22';
wwv_flow_imp.g_varchar2_table(70) := '596F752063616E206F6E6C792075706C6F616420257B736D6172745F636F756E747D2066696C6573227D2C796F7548617665546F41744C6561737453656C656374583A7B303A22596F75206861766520746F2073656C656374206174206C656173742025';
wwv_flow_imp.g_varchar2_table(71) := '7B736D6172745F636F756E747D2066696C65222C313A22596F75206861766520746F2073656C656374206174206C6561737420257B736D6172745F636F756E747D2066696C6573227D2C7A6F6F6D496E3A225A6F6F6D20696E222C7A6F6F6D4F75743A22';
wwv_flow_imp.g_varchar2_table(72) := '5A6F6F6D206F7574227D3B747970656F6620557070793C227522262628676C6F62616C546869732E557070792E6C6F63616C65732E656E5F55533D65293B76617220723D653B7D2928293B0A2F2F2320736F757263654D617070696E6755524C3D656E5F';
wwv_flow_imp.g_varchar2_table(73) := '55532E6D696E2E6A732E6D61700A';
null;
end;
/
begin
wwv_flow_imp_shared.create_plugin_file(
 p_id=>wwv_flow_imp.id(740500482692667098)
,p_plugin_id=>wwv_flow_imp.id(739921988389392679)
,p_file_name=>'dist/en_US.min.js'
,p_mime_type=>'application/javascript'
,p_file_charset=>'utf-8'
,p_file_content=>wwv_flow_imp.varchar2_to_blob(wwv_flow_imp.g_varchar2_table)
);
end;
/
prompt --application/end_environment
begin
wwv_flow_imp.import_end(p_auto_install_sup_obj => nvl(wwv_flow_application_install.get_auto_install_sup_obj, false));
commit;
end;
/
set verify on feedback on define on
prompt  ...done
